/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/platform","vs/base/common/strings","vs/base/common/event","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/types","vs/base/common/uri","vs/base/common/errors","vs/base/common/cancellation","vs/base/common/arrays","vs/base/common/functional","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/extpath","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/process","vs/base/common/cache","vs/base/common/hash","vs/base/common/map","vs/base/common/objects","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/base/common/glob","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/diffComputer","vs/editor/common/languageSelector","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/languageFeatureRegistry","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/languages/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ae=function(W){for(var t=[],D=0,n=W.length;D<n;D++)t[D]=se[W[D]];return t},Fe=this,Se=typeof global=="object"?global:{},de;(function(W){W.global=Fe;var t=function(){function D(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(D.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),D.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=D._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},D._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},D}();W.Environment=t})(de||(de={}));var de;(function(W){var t=function(){function M(h,A,d){this.type=h,this.detail=A,this.timestamp=d}return M}();W.LoaderEvent=t;var D=function(){function M(h){this._events=[new t(1,"",h)]}return M.prototype.record=function(h,A){this._events.push(new t(h,A,W.Utilities.getHighPerformanceTimestamp()))},M.prototype.getEvents=function(){return this._events},M}();W.LoaderEventRecorder=D;var n=function(){function M(){}return M.prototype.record=function(h,A){},M.prototype.getEvents=function(){return[]},M.INSTANCE=new M,M}();W.NullLoaderEventRecorder=n})(de||(de={}));var de;(function(W){var t=function(){function D(){}return D.fileUriToFilePath=function(n,M){if(M=decodeURI(M).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M},D.startsWith=function(n,M){return n.length>=M.length&&n.substr(0,M.length)===M},D.endsWith=function(n,M){return n.length>=M.length&&n.substr(n.length-M.length)===M},D.containsQueryString=function(n){return/^[^\#]*\?/gi.test(n)},D.isAbsolutePath=function(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)},D.forEachProperty=function(n,M){if(n){var h=void 0;for(h in n)n.hasOwnProperty(h)&&M(h,n[h])}},D.isEmpty=function(n){var M=!0;return D.forEachProperty(n,function(){M=!1}),M},D.recursiveClone=function(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;var M=Array.isArray(n)?[]:{};return D.forEachProperty(n,function(h,A){A&&typeof A=="object"?M[h]=D.recursiveClone(A):M[h]=A}),M},D.generateAnonymousModule=function(){return"===anonymous"+D.NEXT_ANONYMOUS_ID+++"==="},D.isAnonymousModule=function(n){return D.startsWith(n,"===anonymous")},D.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()},D.NEXT_ANONYMOUS_ID=1,D.PERFORMANCE_NOW_PROBED=!1,D.HAS_PERFORMANCE_NOW=!1,D}();W.Utilities=t})(de||(de={}));var de;(function(W){function t(M){if(M instanceof Error)return M;var h=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(h.stack=M.stack),h}W.ensureError=t;var D=function(){function M(){}return M.validateConfigurationOptions=function(h){function A(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError=="undefined"&&(h.catchError=!1),typeof h.recordStats=="undefined"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=A),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(W.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags=="undefined"&&(h.preferScriptTags=!1),Array.isArray(h.nodeModules)||(h.nodeModules=[]),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){var d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",h.onError(d),h.nodeCachedData=void 0}return h},M.mergeConfigurationOptions=function(h,A){h===void 0&&(h=null),A===void 0&&(A=null);var d=W.Utilities.recursiveClone(A||{});return W.Utilities.forEachProperty(h,function(u,f){u==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules!="undefined"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(f):u==="paths"&&typeof d.paths!="undefined"?W.Utilities.forEachProperty(f,function(p,P){return d.paths[p]=P}):u==="config"&&typeof d.config!="undefined"?W.Utilities.forEachProperty(f,function(p,P){return d.config[p]=P}):d[u]=W.Utilities.recursiveClone(f)}),M.validateConfigurationOptions(d)},M}();W.ConfigurationOptionsUtil=D;var n=function(){function M(h,A){if(this._env=h,this.options=D.mergeConfigurationOptions(A),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var d=this.options.nodeRequire.main.filename,u=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var d=this.options.nodeMain,u=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,u+1)}}}return M.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0},M.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var h=0,A=this.options.nodeModules;h<A.length;h++){var d=A[h];this.nodeModulesMap[d]=!0}},M.prototype._createSortedPathsRules=function(){var h=this;this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,function(A,d){Array.isArray(d)?h.sortedPathsRules.push({from:A,to:d}):h.sortedPathsRules.push({from:A,to:[d]})}),this.sortedPathsRules.sort(function(A,d){return d.from.length-A.from.length})},M.prototype.cloneAndMerge=function(h){return new M(this._env,D.mergeConfigurationOptions(h,this.options))},M.prototype.getOptionsLiteral=function(){return this.options},M.prototype._applyPaths=function(h){for(var A,d=0,u=this.sortedPathsRules.length;d<u;d++)if(A=this.sortedPathsRules[d],W.Utilities.startsWith(h,A.from)){for(var f=[],p=0,P=A.to.length;p<P;p++)f.push(A.to[p]+h.substr(A.from.length));return f}return[h]},M.prototype._addUrlArgsToUrl=function(h){return W.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs},M.prototype._addUrlArgsIfNecessaryToUrl=function(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h},M.prototype._addUrlArgsIfNecessaryToUrls=function(h){if(this.options.urlArgs)for(var A=0,d=h.length;A<d;A++)h[A]=this._addUrlArgsToUrl(h[A]);return h},M.prototype.moduleIdToPaths=function(h){if(this._env.isNode){var A=this.nodeModulesMap[h]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h);if(A)return this.isBuild()?["empty:"]:["node|"+h]}var d=h,u;if(!W.Utilities.endsWith(d,".js")&&!W.Utilities.isAbsolutePath(d)){u=this._applyPaths(d);for(var f=0,p=u.length;f<p;f++)this.isBuild()&&u[f]==="empty:"||(W.Utilities.isAbsolutePath(u[f])||(u[f]=this.options.baseUrl+u[f]),!W.Utilities.endsWith(u[f],".js")&&!W.Utilities.containsQueryString(u[f])&&(u[f]=u[f]+".js"))}else!W.Utilities.endsWith(d,".js")&&!W.Utilities.containsQueryString(d)&&(d=d+".js"),u=[d];return this._addUrlArgsIfNecessaryToUrls(u)},M.prototype.requireToUrl=function(h){var A=h;return W.Utilities.isAbsolutePath(A)||(A=this._applyPaths(A)[0],W.Utilities.isAbsolutePath(A)||(A=this.options.baseUrl+A)),this._addUrlArgsIfNecessaryToUrl(A)},M.prototype.isBuild=function(){return this.options.isBuild},M.prototype.isDuplicateMessageIgnoredFor=function(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)},M.prototype.getConfigForModule=function(h){if(this.options.config)return this.options.config[h]},M.prototype.shouldCatchError=function(){return this.options.catchError},M.prototype.shouldRecordStats=function(){return this.options.recordStats},M.prototype.onError=function(h){this.options.onError(h)},M}();W.Configuration=n})(de||(de={}));var de;(function(W){var t=function(){function u(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(f,p,P,v){var b=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){var e=f.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new D:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new D;var w={callback:P,errorback:v};if(this._callbackMap.hasOwnProperty(p)){this._callbackMap[p].push(w);return}this._callbackMap[p]=[w],this._scriptLoader.load(f,p,function(){return b.triggerCallback(p)},function(y){return b.triggerErrorback(p,y)})},u.prototype.triggerCallback=function(f){var p=this._callbackMap[f];delete this._callbackMap[f];for(var P=0;P<p.length;P++)p[P].callback()},u.prototype.triggerErrorback=function(f,p){var P=this._callbackMap[f];delete this._callbackMap[f];for(var v=0;v<P.length;v++)P[v].errorback(p)},u}(),D=function(){function u(){}return u.prototype.attachListeners=function(f,p,P){var v=function(){f.removeEventListener("load",b),f.removeEventListener("error",e)},b=function(w){v(),p()},e=function(w){v(),P(w)};f.addEventListener("load",b),f.addEventListener("error",e)},u.prototype.load=function(f,p,P,v){if(/^node\|/.test(p)){var b=f.getConfig().getOptionsLiteral(),e=A(f.getRecorder(),b.nodeRequire||W.global.nodeRequire),w=p.split("|"),y=null;try{y=e(w[1])}catch(a){v(a);return}f.enqueueDefineAnonymousModule([],function(){return y}),P()}else{var E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,P,v);var m=f.getConfig().getOptionsLiteral().trustedTypesPolicy;m&&(p=m.createScriptURL(p)),E.setAttribute("src",p);var o=f.getConfig().getOptionsLiteral().cspNonce;o&&E.setAttribute("nonce",o),document.getElementsByTagName("head")[0].appendChild(E)}},u}();function n(u){var f=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var p=f?self.eval(f.createScript("","true")):new Function("true");return p.call(self),!0}catch{return!1}}var M=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(f)),this._cachedCanUseEval},u.prototype.load=function(f,p,P,v){if(/^node\|/.test(p)){var b=f.getConfig().getOptionsLiteral(),e=A(f.getRecorder(),b.nodeRequire||W.global.nodeRequire),w=p.split("|"),y=null;try{y=e(w[1])}catch(o){v(o);return}f.enqueueDefineAnonymousModule([],function(){return y}),P()}else{var E=f.getConfig().getOptionsLiteral().trustedTypesPolicy,m=/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin;if(!m&&this._canUseEval(f)){fetch(p).then(function(o){if(o.status!==200)throw new Error(o.statusText);return o.text()}).then(function(o){o=o+`
//# sourceURL=`+p;var a=E?self.eval(E.createScript("",o)):new Function(o);a.call(self),P()}).then(void 0,v);return}try{E&&(p=E.createScriptURL(p)),importScripts(p),P()}catch(o){v(o)}}},u}(),h=function(){function u(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},u.prototype._initNodeRequire=function(f,p){var P=p.getConfig().getOptionsLiteral().nodeCachedData;if(!P||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var v=this,b=f("module");function e(w){var y=w.constructor,E=function(o){try{return w.require(o)}finally{}};return E.resolve=function(o,a){return y._resolveFilename(o,w,!1,a)},E.resolve.paths=function(o){return y._resolveLookupPaths(o,w)},E.main=process.mainModule,E.extensions=y._extensions,E.cache=y._cache,E}b.prototype._compile=function(w,y){var E=b.wrap(w.replace(/^#!.*/,"")),m=p.getRecorder(),o=v._getCachedDataPath(P,y),a={filename:y},l;try{var g=v._fs.readFileSync(o);l=g.slice(0,16),a.cachedData=g.slice(16),m.record(60,o)}catch{m.record(61,o)}var L=new v._vm.Script(E,a),_=L.runInThisContext(a),i=v._path.dirname(y),s=e(this),c=[this.exports,s,this,y,i,process,Se,Buffer],C=_.apply(this.exports,c);return v._handleCachedData(L,E,o,!a.cachedData,p),v._verifyCachedData(L,E,o,l,p),C}},u.prototype.load=function(f,p,P,v){var b=this,e=f.getConfig().getOptionsLiteral(),w=A(f.getRecorder(),e.nodeRequire||W.global.nodeRequire),y=e.nodeInstrumenter||function(_){return _};this._init(w),this._initNodeRequire(w,f);var E=f.getRecorder();if(/^node\|/.test(p)){var m=p.split("|"),o=null;try{o=w(m[1])}catch(_){v(_);return}f.enqueueDefineAnonymousModule([],function(){return o}),P()}else{p=W.Utilities.fileUriToFilePath(this._env.isWindows,p);var a=this._path.normalize(p),l=this._getElectronRendererScriptPathOrUri(a),g=Boolean(e.nodeCachedData),L=g?this._getCachedDataPath(e.nodeCachedData,p):void 0;this._readSourceAndCachedData(a,L,E,function(_,i,s,c){if(_){v(_);return}var C;i.charCodeAt(0)===u._BOM?C=u._PREFIX+i.substring(1)+u._SUFFIX:C=u._PREFIX+i+u._SUFFIX,C=y(C,a);var S={filename:l,cachedData:s},I=b._createAndEvalScript(f,C,S,P,v);b._handleCachedData(I,C,L,g&&!s,f),b._verifyCachedData(I,C,L,c,f)})}},u.prototype._createAndEvalScript=function(f,p,P,v,b){var e=f.getRecorder();e.record(31,P.filename);var w=new this._vm.Script(p,P),y=w.runInThisContext(P),E=f.getGlobalAMDDefineFunc(),m=!1,o=function(){return m=!0,E.apply(null,arguments)};return o.amd=E.amd,y.call(W.global,f.getGlobalAMDRequireFunc(),o,P.filename,this._path.dirname(P.filename)),e.record(32,P.filename),m?v():b(new Error("Didn't receive define call in "+P.filename+"!")),w},u.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var p=f.match(/^([a-z])\:(.*)/i);return p?"file:///"+(p[1].toUpperCase()+":"+p[2]).replace(/\\/g,"/"):"file://"+f},u.prototype._getCachedDataPath=function(f,p){var P=this._crypto.createHash("md5").update(p,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),v=this._path.basename(p).replace(/\.js$/,"");return this._path.join(f.path,v+"-"+P+".code")},u.prototype._handleCachedData=function(f,p,P,v,b){var e=this;f.cachedDataRejected?this._fs.unlink(P,function(w){b.getRecorder().record(62,P),e._createAndWriteCachedData(f,p,P,b),w&&b.getConfig().onError(w)}):v&&this._createAndWriteCachedData(f,p,P,b)},u.prototype._createAndWriteCachedData=function(f,p,P,v){var b=this,e=Math.ceil(v.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),w=-1,y=0,E=void 0,m=function(){setTimeout(function(){E||(E=b._crypto.createHash("md5").update(p,"utf8").digest());var o=f.createCachedData();if(!(o.length===0||o.length===w||y>=5)){if(o.length<w){m();return}w=o.length,b._fs.writeFile(P,Buffer.concat([E,o]),function(a){a&&v.getConfig().onError(a),v.getRecorder().record(63,P),m()})}},e*Math.pow(4,y++))};m()},u.prototype._readSourceAndCachedData=function(f,p,P,v){if(!p)this._fs.readFile(f,{encoding:"utf8"},v);else{var b=void 0,e=void 0,w=void 0,y=2,E=function(m){m?v(m):--y==0&&v(void 0,b,e,w)};this._fs.readFile(f,{encoding:"utf8"},function(m,o){b=o,E(m)}),this._fs.readFile(p,function(m,o){!m&&o&&o.length>0?(w=o.slice(0,16),e=o.slice(16),P.record(60,p)):P.record(61,p),E()})}},u.prototype._verifyCachedData=function(f,p,P,v,b){var e=this;!v||f.cachedDataRejected||setTimeout(function(){var w=e._crypto.createHash("md5").update(p,"utf8").digest();v.equals(w)||(b.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+P+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(P,function(y){y&&b.getConfig().onError(y)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function A(u,f){if(f.__$__isRecorded)return f;var p=function(v){u.record(33,v);try{return f(v)}finally{u.record(34,v)}};return p.__$__isRecorded=!0,p}W.ensureRecordedNodeRequire=A;function d(u){return new t(u)}W.createScriptLoader=d})(de||(de={}));var de;(function(W){var t=function(){function d(u){var f=u.lastIndexOf("/");f!==-1?this.fromModulePath=u.substr(0,f+1):this.fromModulePath=""}return d._normalizeModuleId=function(u){var f=u,p;for(p=/\/\.\//;p.test(f);)f=f.replace(p,"/");for(f=f.replace(/^\.\//g,""),p=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;p.test(f);)f=f.replace(p,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},d.prototype.resolveModule=function(u){var f=u;return W.Utilities.isAbsolutePath(f)||(W.Utilities.startsWith(f,"./")||W.Utilities.startsWith(f,"../"))&&(f=d._normalizeModuleId(this.fromModulePath+f)),f},d.ROOT=new d(""),d}();W.ModuleIdResolver=t;var D=function(){function d(u,f,p,P,v,b){this.id=u,this.strId=f,this.dependencies=p,this._callback=P,this._errorback=v,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return d._safeInvokeFunction=function(u,f){try{return{returnedValue:u.apply(W.global,f),producedError:null}}catch(p){return{returnedValue:null,producedError:p}}},d._invokeFactory=function(u,f,p,P){return u.isBuild()&&!W.Utilities.isAnonymousModule(f)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(p,P):{returnedValue:p.apply(W.global,P),producedError:null}},d.prototype.complete=function(u,f,p){this._isComplete=!0;var P=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var v=d._invokeFactory(f,this.strId,this._callback,p);P=v.producedError,u.record(22,this.strId),!P&&typeof v.returnedValue!="undefined"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=v.returnedValue)}else this.exports=this._callback;if(P){var b=W.ensureError(P);b.phase="factory",b.moduleId=this.strId,this.error=b,f.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},d.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},d.prototype.isComplete=function(){return this._isComplete},d}();W.Module=D;var n=function(){function d(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return d.prototype.getMaxModuleId=function(){return this._nextId},d.prototype.getModuleId=function(u){var f=this._strModuleIdToIntModuleId.get(u);return typeof f=="undefined"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(u,f),this._intModuleIdToStrModuleId[f]=u),f},d.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},d}(),M=function(){function d(u){this.id=u}return d.EXPORTS=new d(0),d.MODULE=new d(1),d.REQUIRE=new d(2),d}();W.RegularDependency=M;var h=function(){function d(u,f,p){this.id=u,this.pluginId=f,this.pluginParam=p}return d}();W.PluginDependency=h;var A=function(){function d(u,f,p,P,v){v===void 0&&(v=0),this._env=u,this._scriptLoader=f,this._loaderAvailableTimestamp=v,this._defineFunc=p,this._requireFunc=P,this._moduleIdProvider=new n,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return d.prototype.reset=function(){return new d(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},d.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},d.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},d._findRelevantLocationInStack=function(u,f){for(var p=function(a){return a.replace(/\\/g,"/")},P=p(u),v=f.split(/\n/),b=0;b<v.length;b++){var e=v[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){var w=e[1],y=e[2],E=e[3],m=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(m),w=p(w),w===P){var o={line:parseInt(y,10),col:parseInt(E,10)};return o.line===1&&(o.col-="(function (require, define, __filename, __dirname) { ".length),o}}}throw new Error("Could not correlate define call site for needle "+u)},d.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],f=0,p=0,P=this._modules2.length;p<P;p++){var v=this._modules2[p];if(!!v){var b=this._buildInfoPath[v.id]||null,e=this._buildInfoDefineStack[v.id]||null,w=this._buildInfoDependencies[v.id];u[f++]={id:v.strId,path:b,defineLocation:b&&e?d._findRelevantLocationInStack(b,e):null,dependencies:w,shim:null,exports:v.exports}}}return u},d.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder},d.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},d.prototype.enqueueDefineAnonymousModule=function(u,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var p=null;this._config.isBuild()&&(p=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:p,dependencies:u,callback:f}},d.prototype.defineModule=function(u,f,p,P,v,b){var e=this;b===void 0&&(b=new t(u));var w=this._moduleIdProvider.getModuleId(u);if(this._modules2[w]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var y=new D(w,u,this._normalizeDependencies(f,b),p,P,b);this._modules2[w]=y,this._config.isBuild()&&(this._buildInfoDefineStack[w]=v,this._buildInfoDependencies[w]=(y.dependencies||[]).map(function(E){return e._moduleIdProvider.getStrModuleId(E.id)})),this._resolve(y)},d.prototype._normalizeDependency=function(u,f){if(u==="exports")return M.EXPORTS;if(u==="module")return M.MODULE;if(u==="require")return M.REQUIRE;var p=u.indexOf("!");if(p>=0){var P=f.resolveModule(u.substr(0,p)),v=f.resolveModule(u.substr(p+1)),b=this._moduleIdProvider.getModuleId(P+"!"+v),e=this._moduleIdProvider.getModuleId(P);return new h(b,e,v)}return new M(this._moduleIdProvider.getModuleId(f.resolveModule(u)))},d.prototype._normalizeDependencies=function(u,f){for(var p=[],P=0,v=0,b=u.length;v<b;v++)p[P++]=this._normalizeDependency(u[v],f);return p},d.prototype._relativeRequire=function(u,f,p,P){if(typeof f=="string")return this.synchronousRequire(f,u);this.defineModule(W.Utilities.generateAnonymousModule(),f,p,P,null,u)},d.prototype.synchronousRequire=function(u,f){f===void 0&&(f=new t(u));var p=this._normalizeDependency(u,f),P=this._modules2[p.id];if(!P)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!P.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(P.error)throw P.error;return P.exports},d.prototype.configure=function(u,f){var p=this._config.shouldRecordStats();f?this._config=new W.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!p&&(this._recorder=null)},d.prototype.getConfig=function(){return this._config},d.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),f.dependencies,f.callback,null,f.stack)}},d.prototype._createLoadError=function(u,f){var p=this,P=this._moduleIdProvider.getStrModuleId(u),v=(this._inverseDependencies2[u]||[]).map(function(e){return p._moduleIdProvider.getStrModuleId(e)}),b=W.ensureError(f);return b.phase="loading",b.moduleId=P,b.neededBy=v,b},d.prototype._onLoadError=function(u,f){var p=this._createLoadError(u,f);this._modules2[u]||(this._modules2[u]=new D(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},null,null));for(var P=[],v=0,b=this._moduleIdProvider.getMaxModuleId();v<b;v++)P[v]=!1;var e=!1,w=[];for(w.push(u),P[u]=!0;w.length>0;){var y=w.shift(),E=this._modules2[y];E&&(e=E.onDependencyError(p)||e);var m=this._inverseDependencies2[y];if(m)for(var v=0,b=m.length;v<b;v++){var o=m[v];P[o]||(w.push(o),P[o]=!0)}}e||this._config.onError(p)},d.prototype._hasDependencyPath=function(u,f){var p=this._modules2[u];if(!p)return!1;for(var P=[],v=0,b=this._moduleIdProvider.getMaxModuleId();v<b;v++)P[v]=!1;var e=[];for(e.push(p),P[u]=!0;e.length>0;){var w=e.shift(),y=w.dependencies;if(y)for(var v=0,b=y.length;v<b;v++){var E=y[v];if(E.id===f)return!0;var m=this._modules2[E.id];m&&!P[E.id]&&(P[E.id]=!0,e.push(m))}}return!1},d.prototype._findCyclePath=function(u,f,p){if(u===f||p===50)return[u];var P=this._modules2[u];if(!P)return null;var v=P.dependencies;if(v)for(var b=0,e=v.length;b<e;b++){var w=this._findCyclePath(v[b].id,f,p+1);if(w!==null)return w.push(u),w}return null},d.prototype._createRequire=function(u){var f=this,p=function(P,v,b){return f._relativeRequire(u,P,v,b)};return p.toUrl=function(P){return f._config.requireToUrl(u.resolveModule(P))},p.getStats=function(){return f.getLoaderEvents()},p.hasDependencyCycle=function(){return f._hasDependencyCycle},p.config=function(P,v){v===void 0&&(v=!1),f.configure(P,v)},p.__$__nodeRequire=W.global.nodeRequire,p},d.prototype._loadModule=function(u){var f=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var p=this._moduleIdProvider.getStrModuleId(u),P=this._config.moduleIdToPaths(p),v=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(p.indexOf("/")===-1||v.test(p))&&P.push("node|"+p);var b=-1,e=function(w){if(b++,b>=P.length)f._onLoadError(u,w);else{var y=P[b],E=f.getRecorder();if(f._config.isBuild()&&y==="empty:"){f._buildInfoPath[u]=y,f.defineModule(f._moduleIdProvider.getStrModuleId(u),[],null,null,null),f._onLoad(u);return}E.record(10,y),f._scriptLoader.load(f,y,function(){f._config.isBuild()&&(f._buildInfoPath[u]=y),E.record(11,y),f._onLoad(u)},function(m){E.record(12,y),e(m)})}};e(null)}},d.prototype._loadPluginDependency=function(u,f){var p=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var P=function(v){p.defineModule(p._moduleIdProvider.getStrModuleId(f.id),[],v,null,null)};P.error=function(v){p._config.onError(p._createLoadError(f.id,v))},u.load(f.pluginParam,this._createRequire(t.ROOT),P,this._config.getOptionsLiteral())}},d.prototype._resolve=function(u){var f=this,p=u.dependencies;if(p)for(var P=0,v=p.length;P<v;P++){var b=p[P];if(b===M.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(b===M.MODULE){u.unresolvedDependenciesCount--;continue}if(b===M.REQUIRE){u.unresolvedDependenciesCount--;continue}var e=this._modules2[b.id];if(e&&e.isComplete()){if(e.error){u.onDependencyError(e.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var w=this._findCyclePath(b.id,u.id,0)||[];w.reverse(),w.push(b.id),console.warn(w.map(function(m){return f._moduleIdProvider.getStrModuleId(m)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(u.id),b instanceof h){var y=this._modules2[b.pluginId];if(y&&y.isComplete()){this._loadPluginDependency(y.exports,b);continue}var E=this._inversePluginDependencies2.get(b.pluginId);E||(E=[],this._inversePluginDependencies2.set(b.pluginId,E)),E.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},d.prototype._onModuleComplete=function(u){var f=this,p=this.getRecorder();if(!u.isComplete()){var P=u.dependencies,v=[];if(P)for(var b=0,e=P.length;b<e;b++){var w=P[b];if(w===M.EXPORTS){v[b]=u.exports;continue}if(w===M.MODULE){v[b]={id:u.strId,config:function(){return f._config.getConfigForModule(u.strId)}};continue}if(w===M.REQUIRE){v[b]=this._createRequire(u.moduleIdResolver);continue}var y=this._modules2[w.id];if(y){v[b]=y.exports;continue}v[b]=null}u.complete(p,this._config,v);var E=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,E)for(var b=0,e=E.length;b<e;b++){var m=E[b],o=this._modules2[m];o.unresolvedDependenciesCount--,o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}var a=this._inversePluginDependencies2.get(u.id);if(a){this._inversePluginDependencies2.delete(u.id);for(var b=0,e=a.length;b<e;b++)this._loadPluginDependency(u.exports,a[b])}}},d}();W.ModuleManager=A})(de||(de={}));var ie,de;(function(W){var t=new W.Environment,D=null,n=function(d,u,f){typeof d!="string"&&(f=u,u=d,d=null),(typeof u!="object"||!Array.isArray(u))&&(f=u,u=null),u||(u=["require","exports","module"]),d?D.defineModule(d,u,f,null,null):D.enqueueDefineAnonymousModule(u,f)};n.amd={jQuery:!0};var M=function(d,u){u===void 0&&(u=!1),D.configure(d,u)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=M,h.getConfig=function(){return D.getConfig().getOptionsLiteral()},h.reset=function(){D=D.reset()},h.getBuildInfo=function(){return D.getBuildInfo()},h.getStats=function(){return D.getLoaderEvents()},h.define=n;function A(){if(typeof W.global.require!="undefined"||typeof require!="undefined"){var d=W.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){var u=W.ensureRecordedNodeRequire(D.getRecorder(),d);W.global.nodeRequire=u,h.nodeRequire=u,h.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?(module.exports=h,require=h):(t.isElectronRenderer||(W.global.define=n),W.global.require=h)}W.init=A,(typeof W.global.define!="function"||!W.global.define.amd)&&(D=new W.ModuleManager(t,W.createScriptLoader(t),n,h,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require!="undefined"&&typeof W.global.require!="function"&&h.config(W.global.require),ie=function(){return n.apply(null,arguments)},ie.amd=n.amd,typeof doNotInitLoader=="undefined"&&A())})(de||(de={}));var ke=this,Me;(function(W){var t=ke||{},D=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,n=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function M(f,p){var P;return p.length===0?P=f:P=f.replace(/\{(\d+)\}/g,function(v,b){var e=b[0];return typeof p[e]!="undefined"?p[e]:v}),n&&(P="\uFF3B"+P.replace(/[aouei]/g,"$&$&")+"\uFF3D"),P}function h(f,p){var P=f[p];return P||(P=f["*"],P)?P:null}function A(f,p){for(var P=[],v=0;v<arguments.length-2;v++)P[v]=arguments[v+2];return M(p,P)}function d(f){return function(p,P){var v=Array.prototype.slice.call(arguments,2);return M(f[p],v)}}var u=function(){function f(){this.localize=A}return f.prototype.setPseudoTranslation=function(p){n=p},f.prototype.create=function(p,P){return{localize:d(P[p])}},f.prototype.load=function(p,P,v,b){if(b=b||{},!p||p.length===0)v({localize:A});else{var e=void 0;if(D&&D.getString)e=".nls.keys",P([p+e],function(E){v({localize:function(m,o){if(!E[m])return"NLS error: unknown key "+m;var a=E[m].keys;if(o>=a.length)return"NLS error unknown index "+o;var l=a[o],g=[];g[0]=m+"_"+l;for(var L=0;L<arguments.length-2;L++)g[L+1]=arguments[L+2];return D.getString.apply(D,g)}})});else if(b.isBuild)P([p+".nls",p+".nls.keys"],function(E,m){f.BUILD_MAP[p]=E,f.BUILD_MAP_KEYS[p]=m,v(E)});else{var w=b["vs/nls"]||{},y=w.availableLanguages?h(w.availableLanguages,p):null;e=".nls",y!==null&&y!==f.DEFAULT_TAG&&(e=e+"."+y),P([p+e],function(E){Array.isArray(E)?E.localize=d(E):E.localize=d(E[p]),v(E)})}}},f.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},f.prototype.write=function(p,P,v){var b=v.getEntryPoint(),e=this._getEntryPointsMap();e[b]=e[b]||[],e[b].push(P),P!==b&&v.asModule(p+"!"+P,"define(['vs/nls', 'vs/nls!"+b+`'], function(nls, data) { return nls.create("`+P+'", data); });')},f.prototype.writeFile=function(p,P,v,b,e){var w=this._getEntryPointsMap();if(w.hasOwnProperty(P)){for(var y=v.toUrl(P+".nls.js"),E=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],m=w[P],o={},a=0;a<m.length;a++)o[m[a]]=f.BUILD_MAP[m[a]];E.push('define("'+P+'.nls", '+JSON.stringify(o,null,"	")+");"),b(y,E.join(`\r
`))}},f.prototype.finishBuild=function(p){p("nls.metadata.json",JSON.stringify({keys:f.BUILD_MAP_KEYS,messages:f.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},f.DEFAULT_TAG="i-default",f.BUILD_MAP={},f.BUILD_MAP_KEYS={},f}();W.NLSPlugin=u,function(){ie("vs/nls",new u)}()})(Me||(Me={})),ie(se[21],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(d,u)=>` ${u} `).trim():""}t.getCodiconAriaLabel=D;class n{constructor(d,u,f){this.id=d,this.definition=u,this.description=f,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}t.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function M(A,d){const u=["codicon","codicon-"+A];return d&&u.push("codicon-modifier-"+d),u}t.getClassNamesArray=M;var h;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function u(P){if(P instanceof n)return["codicon","codicon-"+P.id];const v=d.exec(P.id);if(!v)return u(n.error);let[,b,e]=v;const w=["codicon","codicon-"+b];return e&&w.push("codicon-modifier-"+e.substr(1)),w}A.asClassNameArray=u;function f(P){return u(P).join(" ")}A.asClassName=f;function p(P){return"."+u(P).join(".")}A.asCSSSelector=p})(h=t.CSSIcon||(t.CSSIcon={}))}),ie(se[22],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class D{constructor(M,h,A,d){this.originalStart=M,this.originalLength=h,this.modifiedStart=A,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=D}),ie(se[11],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(g){setTimeout(()=>{throw g.stack?new Error(g.message+`

`+g.stack):g},0)}}addListener(g){return this.listeners.push(g),()=>{this._removeListener(g)}}emit(g){this.listeners.forEach(L=>{L(g)})}_removeListener(g){this.listeners.splice(this.listeners.indexOf(g),1)}setUnexpectedErrorHandler(g){this.unexpectedErrorHandler=g}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(g){this.unexpectedErrorHandler(g),this.emit(g)}onUnexpectedExternalError(g){this.unexpectedErrorHandler(g)}}t.ErrorHandler=D,t.errorHandler=new D;function n(l){t.errorHandler.setUnexpectedErrorHandler(l)}t.setUnexpectedErrorHandler=n;function M(l){u(l)||t.errorHandler.onUnexpectedError(l)}t.onUnexpectedError=M;function h(l){u(l)||t.errorHandler.onUnexpectedExternalError(l)}t.onUnexpectedExternalError=h;function A(l){if(l instanceof Error){let{name:g,message:L}=l;const _=l.stacktrace||l.stack;return{$isError:!0,name:g,message:L,stack:_}}return l}t.transformErrorForSerialization=A;const d="Canceled";function u(l){return l instanceof f?!0:l instanceof Error&&l.name===d&&l.message===d}t.isCancellationError=u;class f extends Error{constructor(){super(d);this.name=this.message}}t.CancellationError=f;function p(){const l=new Error(d);return l.name=l.message,l}t.canceled=p;function P(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}t.illegalArgument=P;function v(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}t.illegalState=v;function b(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=b;function e(l){const g=new Error(`${l} has been disposed`);return g.name="DISPOSED",g}t.disposed=e;function w(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}t.getErrorMessage=w;class y extends Error{constructor(g){super("NotImplemented");g&&(this.message=g)}}t.NotImplementedError=y;class E extends Error{constructor(g){super("NotSupported");g&&(this.message=g)}}t.NotSupportedError=E;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=m;function o(l){const g=l;return g instanceof Error&&Array.isArray(g.actions)}t.isErrorWithActions=o;function a(l,g=Object.create(null)){const L=new Error(l);return g.actions&&(L.actions=g.actions),L}t.createErrorWithActions=a}),ie(se[13],ae([0,1,11]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.compareBy=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function n(T,N=0){return T[T.length-(1+N)]}t.tail=n;function M(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=M;function h(T,N,F=(O,U)=>O===U){if(T===N)return!0;if(!T||!N||T.length!==N.length)return!1;for(let O=0,U=T.length;O<U;O++)if(!F(T[O],N[O]))return!1;return!0}t.equals=h;function A(T,N,F){let O=0,U=T.length-1;for(;O<=U;){const Q=(O+U)/2|0,te=F(T[Q],N);if(te<0)O=Q+1;else if(te>0)U=Q-1;else return Q}return-(O+1)}t.binarySearch=A;function d(T,N){let F=0,O=T.length;if(O===0)return 0;for(;F<O;){const U=Math.floor((F+O)/2);N(T[U])?O=U:F=U+1}return F}t.findFirstInSorted=d;function u(T,N,F){if(T=T|0,T>=N.length)throw new TypeError("invalid index");let O=N[Math.floor(N.length*Math.random())],U=[],Q=[],te=[];for(let le of N){const ue=F(le,O);ue<0?U.push(le):ue>0?Q.push(le):te.push(le)}return T<U.length?u(T,U,F):T<U.length+te.length?te[0]:u(T-(U.length+te.length),Q,F)}t.quickSelect=u;function f(T,N){const F=[];let O;for(const U of T.slice(0).sort(N))!O||N(O[0],U)!==0?(O=[U],F.push(O)):O.push(U);return F}t.groupBy=f;function p(T,N,F){const O=[];function U(le,ue,me){if(ue===0&&me.length===0)return;const _e=O[O.length-1];_e&&_e.start+_e.deleteCount===le?(_e.deleteCount+=ue,_e.toInsert.push(...me)):O.push({start:le,deleteCount:ue,toInsert:me})}let Q=0,te=0;for(;;){if(Q===T.length){U(Q,0,N.slice(te));break}if(te===N.length){U(Q,T.length-Q,[]);break}const le=T[Q],ue=N[te],me=F(le,ue);me===0?(Q+=1,te+=1):me<0?(U(Q,1,[]),Q+=1):me>0&&(U(Q,0,[ue]),te+=1)}return O}t.sortedDiff=p;function P(T,N,F){const O=p(T,N,F),U=[],Q=[];for(const te of O)U.push(...T.slice(te.start,te.start+te.deleteCount)),Q.push(...te.toInsert);return{removed:U,added:Q}}t.delta=P;function v(T,N,F){if(F===0)return[];const O=T.slice(0,F).sort(N);return e(T,N,O,F,T.length),O}t.top=v;function b(T,N,F,O,U){return F===0?Promise.resolve([]):new Promise((Q,te)=>{(async()=>{const le=T.length,ue=T.slice(0,F).sort(N);for(let me=F,_e=Math.min(F+O,le);me<le;me=_e,_e=Math.min(_e+O,le)){if(me>F&&await new Promise(ye=>setTimeout(ye)),U&&U.isCancellationRequested)throw(0,D.canceled)();e(T,N,ue,me,_e)}return ue})().then(Q,te)})}t.topAsync=b;function e(T,N,F,O,U){for(const Q=F.length;O<U;O++){const te=T[O];if(N(te,F[Q-1])<0){F.pop();const le=d(F,ue=>N(te,ue)<0);F.splice(le,0,te)}}}function w(T){return T.filter(N=>!!N)}t.coalesce=w;function y(T){let N=0;for(let F=0;F<T.length;F++)T[F]&&(T[N]=T[F],N+=1);T.length=N}t.coalesceInPlace=y;function E(T,N,F){T.splice(F,0,T.splice(N,1)[0])}t.move=E;function m(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=m;function o(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=o;function a(T,N=F=>F){const F=new Set;return T.filter(O=>{const U=N(O);return F.has(U)?!1:(F.add(U),!0)})}t.distinct=a;function l(T){const N=new Set;return F=>{const O=T(F);return N.has(O)?!1:(N.add(O),!0)}}t.uniqueFilter=l;function g(T,N){const F=L(T,N);if(F!==-1)return T[F]}t.findLast=g;function L(T,N){for(let F=T.length-1;F>=0;F--){const O=T[F];if(N(O))return F}return-1}t.lastIndex=L;function _(T,N){return T.length>0?T[0]:N}t.firstOrDefault=_;function i(T,N,F=(O,U)=>O===U){let O=0;for(let U=0,Q=Math.min(T.length,N.length);U<Q&&F(T[U],N[U]);U++)O++;return O}t.commonPrefixLength=i;function s(T){return[].concat(...T)}t.flatten=s;function c(T,N){let F=typeof N=="number"?T:0;typeof N=="number"?F=T:(F=0,N=T);const O=[];if(F<=N)for(let U=F;U<N;U++)O.push(U);else for(let U=F;U>N;U--)O.push(U);return O}t.range=c;function C(T,N,F){return T.reduce((O,U)=>(O[N(U)]=F?F(U):U,O),Object.create(null))}t.index=C;function S(T,N){return T.push(N),()=>I(T,N)}t.insert=S;function I(T,N){const F=T.indexOf(N);if(F>-1)return T.splice(F,1),N}t.remove=I;function B(T,N,F){const O=T.slice(0,N),U=T.slice(N);return O.concat(F,U)}t.arrayInsert=B;function $(T,N){let F;if(typeof N=="number"){let O=N;F=()=>{const U=Math.sin(O++)*179426549;return U-Math.floor(U)}}else F=Math.random;for(let O=T.length-1;O>0;O-=1){const U=Math.floor(F()*(O+1)),Q=T[O];T[O]=T[U],T[U]=Q}}t.shuffle=$;function Z(T,N){const F=T.indexOf(N);F>-1&&(T.splice(F,1),T.unshift(N))}t.pushToStart=Z;function K(T,N){const F=T.indexOf(N);F>-1&&(T.splice(F,1),T.push(N))}t.pushToEnd=K;function R(T,N){return Array.isArray(T)?T.map(N):N(T)}t.mapArrayOrNot=R;function G(T){return Array.isArray(T)?T:[T]}t.asArray=G;function oe(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=oe;function r(T,N){for(const F of T){const O=N(F);if(O!==void 0)return O}}t.mapFind=r;function x(T,N,F){const O=ne(T,N),U=T.length,Q=F.length;T.length=U+Q;for(let te=U-1;te>=O;te--)T[te+Q]=T[te];for(let te=0;te<Q;te++)T[te+O]=F[te]}t.insertInto=x;function ce(T,N,F,O){const U=ne(T,N),Q=T.splice(U,F);return x(T,U,O),Q}t.splice=ce;function ne(T,N){return N<0?Math.max(N+T.length,0):Math.min(N,T.length)}function V(T,N){return(F,O)=>N(T(F),T(O))}t.compareBy=V;const j=(T,N)=>T-N;t.numberComparator=j;function H(T,N){if(T.length===0)return;let F=T[0];for(let O=1;O<T.length;O++){const U=T[O];N(U,F)>0&&(F=U)}return F}t.findMaxBy=H;function Y(T,N){if(T.length===0)return;let F=T[0];for(let O=1;O<T.length;O++){const U=T[O];N(U,F)>=0&&(F=U)}return F}t.findLastMaxBy=Y;function X(T,N){return H(T,(F,O)=>-N(F,O))}t.findMinBy=X;class ee{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let F=this.firstIdx;for(;F<this.items.length&&N(this.items[F]);)F++;const O=F===this.firstIdx?null:this.items.slice(this.firstIdx,F);return this.firstIdx=F,O}takeFromEndWhile(N){let F=this.lastIdx;for(;F>=0&&N(this.items[F]);)F--;const O=F===this.lastIdx?null:this.items.slice(F+1,this.lastIdx+1);return this.lastIdx=F,O}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const F=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,F}}t.ArrayQueue=ee}),ie(se[14],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function D(n){const M=this;let h=!1,A;return function(){return h||(h=!0,A=n.apply(M,arguments)),A}}t.once=D}),ie(se[23],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(n){function M(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=M;const h=Object.freeze([]);function A(){return h}n.empty=A;function*d(l){yield l}n.single=d;function u(l){return l||h}n.from=u;function f(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=f;function p(l){return l[Symbol.iterator]().next().value}n.first=p;function P(l,g){for(const L of l)if(g(L))return!0;return!1}n.some=P;function v(l,g){for(const L of l)if(g(L))return L}n.find=v;function*b(l,g){for(const L of l)g(L)&&(yield L)}n.filter=b;function*e(l,g){let L=0;for(const _ of l)yield g(_,L++)}n.map=e;function*w(...l){for(const g of l)for(const L of g)yield L}n.concat=w;function*y(l){for(const g of l)for(const L of g)yield L}n.concatNested=y;function E(l,g,L){let _=L;for(const i of l)_=g(_,i);return _}n.reduce=E;function*m(l,g,L=l.length){for(g<0&&(g+=l.length),L<0?L+=l.length:L>l.length&&(L=l.length);g<L;g++)yield l[g]}n.slice=m;function o(l,g=Number.POSITIVE_INFINITY){const L=[];if(g===0)return[L,l];const _=l[Symbol.iterator]();for(let i=0;i<g;i++){const s=_.next();if(s.done)return[L,n.empty()];L.push(s.value)}return[L,{[Symbol.iterator](){return _}}]}n.consume=o;function a(l,g,L=(_,i)=>_===i){const _=l[Symbol.iterator](),i=g[Symbol.iterator]();for(;;){const s=_.next(),c=i.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!L(s.value,c.value))return!1}}n.equals=a})(D=t.Iterable||(t.Iterable={}))}),ie(se[24],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.MAX_VALUE=126]="MAX_VALUE"})(D=t.KeyCode||(t.KeyCode={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n=t.ScanCode||(t.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,y){this._keyCodeToStr[w]=y,this._strToKeyCode[y.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const h=new M,A=new M,d=new M;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const u=[],f=Object.create(null),p=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>f[e]||0,toString:e=>u[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let y=[],E=[];for(const m of w){const[o,a,l,g,L,_,i,s,c,C]=m;if(E[l]||(E[l]=!0,u[l]=g,f[g]=l,p[g.toLowerCase()]=l,a&&(t.IMMUTABLE_CODE_TO_KEY_CODE[l]=L,L!==0&&L!==3&&L!==5&&L!==4&&L!==6&&L!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[L]=l))),!y[L]){if(y[L]=!0,!_)throw new Error(`String representation missing for key code ${L} around scan code ${g}`);h.define(L,_),A.define(L,c||_),d.define(L,C||c||_)}i&&(t.EVENT_KEY_CODE_MAP[i]=L),s&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=L)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function w(l){return h.keyCodeToStr(l)}e.toString=w;function y(l){return h.strToKeyCode(l)}e.fromString=y;function E(l){return A.keyCodeToStr(l)}e.toUserSettingsUS=E;function m(l){return d.keyCodeToStr(l)}e.toUserSettingsGeneral=m;function o(l){return A.strToKeyCode(l)||d.strToKeyCode(l)}e.fromUserSettings=o;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return h.keyCodeToStr(l)}e.toElectronAccelerator=a})(P=t.KeyCodeUtils||(t.KeyCodeUtils={}));var v;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(v=t.KeyMod||(t.KeyMod={}));function b(e,w){const y=(w&65535)<<16>>>0;return(e|y)>>>0}t.KeyChord=b}),ie(se[25],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class D{constructor(M){this.executor=M,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(M){return new D(()=>M(this.getValue()))}}t.Lazy=D}),ie(se[7],ae([0,1,14,23]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const M=!1;let h=null;function A(i){h=i}if(t.setDisposableTracker=A,M){const i="__is_disposable_tracked__";A(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==m.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==m.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function d(i){return h?.trackDisposable(i),i}function u(i){h?.markAsDisposed(i)}function f(i,s){h?.setParent(i,s)}function p(i,s){if(!!h)for(const c of i)h.setParent(c,s)}function P(i){return h?.markAsSingleton(i),i}t.markAsSingleton=P;class v extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}t.MultiDisposeError=v;function b(i){return typeof i.dispose=="function"&&i.dispose.length===0}t.isDisposable=b;function e(i){if(n.Iterable.is(i)){let s=[];for(const c of i)if(c)try{c.dispose()}catch(C){s.push(C)}if(s.length===1)throw s[0];if(s.length>1)throw new v(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}t.dispose=e;function w(...i){const s=y(()=>e(i));return p(i,s),s}t.combinedDisposable=w;function y(i){const s=d({dispose:(0,D.once)(()=>{u(s),i()})});return s}t.toDisposable=y;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,d(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return f(s,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}t.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new E,d(this),f(this._store,this)}dispose(){u(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}t.Disposable=m,m.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,d(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&f(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&f(s,null),s}}t.MutableDisposable=o;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(s,...c){let C=this.references.get(s);C||(C={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,C));const{object:S}=C,I=(0,D.once)(()=>{--C.counter==0&&(this.destroyReferencedObject(s,C.object),this.references.delete(s))});return C.counter++,{object:S,dispose:I}}}t.ReferenceCollection=l;class g{constructor(s){this.referenceCollection=s}async acquire(s,...c){const C=this.referenceCollection.acquire(s,...c);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(S){throw C.dispose(),S}}}t.AsyncReferenceCollection=g;class L{constructor(s){this.object=s}dispose(){}}t.ImmortalReference=L;function _(i){const s=new E;try{i(s)}finally{s.dispose()}}t.disposeOnReturn=_}),ie(se[26],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class D{constructor(h){this.element=h,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let h=this._first;for(;h!==D.Undefined;){const A=h.next;h.prev=D.Undefined,h.next=D.Undefined,h=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(h){return this._insert(h,!1)}push(h){return this._insert(h,!0)}_insert(h,A){const d=new D(h);if(this._first===D.Undefined)this._first=d,this._last=d;else if(A){const f=this._last;this._last=d,d.prev=f,f.next=d}else{const f=this._first;this._first=d,d.next=f,f.prev=d}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(d))}}shift(){if(this._first!==D.Undefined){const h=this._first.element;return this._remove(this._first),h}}pop(){if(this._last!==D.Undefined){const h=this._last.element;return this._remove(this._last),h}}_remove(h){if(h.prev!==D.Undefined&&h.next!==D.Undefined){const A=h.prev;A.next=h.next,h.next.prev=A}else h.prev===D.Undefined&&h.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):h.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):h.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let h=this._first;for(;h!==D.Undefined;)yield h.element,h=h.next}}t.LinkedList=n}),ie(se[2],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isElectronSandboxed=t.globals=void 0;const D="en";let n=!1,M=!1,h=!1,A=!1,d=!1,u=!1,f=!1,p=!1,P,v=D,b,e;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?w=t.globals.vscode.process:typeof process!="undefined"&&(w=process);const y=typeof w?.versions?.electron=="string",E=y&&w?.type==="renderer";if(t.isElectronSandboxed=E&&w?.sandboxed,typeof navigator=="object"&&!E)e=navigator.userAgent,n=e.indexOf("Windows")>=0,M=e.indexOf("Macintosh")>=0,p=(e.indexOf("Macintosh")>=0||e.indexOf("iPad")>=0||e.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=e.indexOf("Linux")>=0,u=!0,P=navigator.language,v=P;else if(typeof w=="object"){n=w.platform==="win32",M=w.platform==="darwin",h=w.platform==="linux",A=h&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,f=y,P=D,v=D;const s=w.env.VSCODE_NLS_CONFIG;if(s)try{const c=JSON.parse(s),C=c.availableLanguages["*"];P=c.locale,v=C||D,b=c._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var m;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(m=t.Platform||(t.Platform={}));function o(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=o;let a=0;M?a=1:n?a=3:h&&(a=2),t.isWindows=n,t.isMacintosh=M,t.isLinux=h,t.isLinuxSnap=A,t.isNative=d,t.isElectron=f,t.isWeb=u,t.isIOS=p,t.platform=a,t.userAgent=e,t.language=v;var l;(function(s){function c(){return t.language}s.value=c;function C(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}s.isDefaultVariant=C;function S(){return t.language==="en"}s.isDefault=S})(l=t.Language||(t.Language={})),t.locale=P,t.translationsConfigFile=b,t.setTimeout0=(()=>{if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let s=[];t.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let S=0,I=s.length;S<I;S++){const B=s[S];if(B.id===C.data.vscodeScheduleAsyncWork){s.splice(S,1),B.callback();return}}});let c=0;return C=>{const S=++c;s.push({id:S,callback:C}),t.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return s=>setTimeout(s)})();var g;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(g=t.OperatingSystem||(t.OperatingSystem={})),t.OS=M||p?2:n?1:3;let L=!0,_=!1;function i(){if(!_){_=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,L=new Uint16Array(s.buffer)[0]===(2<<8)+1}return L}t.isLittleEndian=i,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),ie(se[27],ae([0,1,2]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const M=D.globals.vscode.process;n={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.arch=n.arch}),ie(se[8],ae([0,1,27]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const n=65,M=97,h=90,A=122,d=46,u=47,f=92,p=58,P=63;class v extends Error{constructor(a,l,g){let L;typeof l=="string"&&l.indexOf("not ")===0?(L="must not be",l=l.replace(/^not /,"")):L="must be";const _=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${_} ${L} of type ${l}`;i+=`. Received type ${typeof g}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function b(o,a){if(typeof o!="string")throw new v(a,"string",o)}function e(o){return o===u||o===f}function w(o){return o===u}function y(o){return o>=n&&o<=h||o>=M&&o<=A}function E(o,a,l,g){let L="",_=0,i=-1,s=0,c=0;for(let C=0;C<=o.length;++C){if(C<o.length)c=o.charCodeAt(C);else{if(g(c))break;c=u}if(g(c)){if(!(i===C-1||s===1))if(s===2){if(L.length<2||_!==2||L.charCodeAt(L.length-1)!==d||L.charCodeAt(L.length-2)!==d){if(L.length>2){const S=L.lastIndexOf(l);S===-1?(L="",_=0):(L=L.slice(0,S),_=L.length-1-L.lastIndexOf(l)),i=C,s=0;continue}else if(L.length!==0){L="",_=0,i=C,s=0;continue}}a&&(L+=L.length>0?`${l}..`:"..",_=2)}else L.length>0?L+=`${l}${o.slice(i+1,C)}`:L=o.slice(i+1,C),_=C-i-1;i=C,s=0}else c===d&&s!==-1?++s:s=-1}return L}function m(o,a){if(a===null||typeof a!="object")throw new v("pathObject","Object",a);const l=a.dir||a.root,g=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${g}`:`${l}${o}${g}`:g}t.win32={resolve(...o){let a="",l="",g=!1;for(let L=o.length-1;L>=-1;L--){let _;if(L>=0){if(_=o[L],b(_,"path"),_.length===0)continue}else a.length===0?_=D.cwd():(_=D.env[`=${a}`]||D.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==a.toLowerCase()&&_.charCodeAt(2)===f)&&(_=`${a}\\`));const i=_.length;let s=0,c="",C=!1;const S=_.charCodeAt(0);if(i===1)e(S)&&(s=1,C=!0);else if(e(S))if(C=!0,e(_.charCodeAt(1))){let I=2,B=I;for(;I<i&&!e(_.charCodeAt(I));)I++;if(I<i&&I!==B){const $=_.slice(B,I);for(B=I;I<i&&e(_.charCodeAt(I));)I++;if(I<i&&I!==B){for(B=I;I<i&&!e(_.charCodeAt(I));)I++;(I===i||I!==B)&&(c=`\\\\${$}\\${_.slice(B,I)}`,s=I)}}}else s=1;else y(S)&&_.charCodeAt(1)===p&&(c=_.slice(0,2),s=2,i>2&&e(_.charCodeAt(2))&&(C=!0,s=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(g){if(a.length>0)break}else if(l=`${_.slice(s)}\\${l}`,g=C,C&&a.length>0)break}return l=E(l,!g,"\\",e),g?`${a}\\${l}`:`${a}${l}`||"."},normalize(o){b(o,"path");const a=o.length;if(a===0)return".";let l=0,g,L=!1;const _=o.charCodeAt(0);if(a===1)return w(_)?"\\":o;if(e(_))if(L=!0,e(o.charCodeAt(1))){let s=2,c=s;for(;s<a&&!e(o.charCodeAt(s));)s++;if(s<a&&s!==c){const C=o.slice(c,s);for(c=s;s<a&&e(o.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!e(o.charCodeAt(s));)s++;if(s===a)return`\\\\${C}\\${o.slice(c)}\\`;s!==c&&(g=`\\\\${C}\\${o.slice(c,s)}`,l=s)}}}else l=1;else y(_)&&o.charCodeAt(1)===p&&(g=o.slice(0,2),l=2,a>2&&e(o.charCodeAt(2))&&(L=!0,l=3));let i=l<a?E(o.slice(l),!L,"\\",e):"";return i.length===0&&!L&&(i="."),i.length>0&&e(o.charCodeAt(a-1))&&(i+="\\"),g===void 0?L?`\\${i}`:i:L?`${g}\\${i}`:`${g}${i}`},isAbsolute(o){b(o,"path");const a=o.length;if(a===0)return!1;const l=o.charCodeAt(0);return e(l)||a>2&&y(l)&&o.charCodeAt(1)===p&&e(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let a,l;for(let _=0;_<o.length;++_){const i=o[_];b(i,"path"),i.length>0&&(a===void 0?a=l=i:a+=`\\${i}`)}if(a===void 0)return".";let g=!0,L=0;if(typeof l=="string"&&e(l.charCodeAt(0))){++L;const _=l.length;_>1&&e(l.charCodeAt(1))&&(++L,_>2&&(e(l.charCodeAt(2))?++L:g=!1))}if(g){for(;L<a.length&&e(a.charCodeAt(L));)L++;L>=2&&(a=`\\${a.slice(L)}`)}return t.win32.normalize(a)},relative(o,a){if(b(o,"from"),b(a,"to"),o===a)return"";const l=t.win32.resolve(o),g=t.win32.resolve(a);if(l===g||(o=l.toLowerCase(),a=g.toLowerCase(),o===a))return"";let L=0;for(;L<o.length&&o.charCodeAt(L)===f;)L++;let _=o.length;for(;_-1>L&&o.charCodeAt(_-1)===f;)_--;const i=_-L;let s=0;for(;s<a.length&&a.charCodeAt(s)===f;)s++;let c=a.length;for(;c-1>s&&a.charCodeAt(c-1)===f;)c--;const C=c-s,S=i<C?i:C;let I=-1,B=0;for(;B<S;B++){const Z=o.charCodeAt(L+B);if(Z!==a.charCodeAt(s+B))break;Z===f&&(I=B)}if(B!==S){if(I===-1)return g}else{if(C>S){if(a.charCodeAt(s+B)===f)return g.slice(s+B+1);if(B===2)return g.slice(s+B)}i>S&&(o.charCodeAt(L+B)===f?I=B:B===2&&(I=3)),I===-1&&(I=0)}let $="";for(B=L+I+1;B<=_;++B)(B===_||o.charCodeAt(B)===f)&&($+=$.length===0?"..":"\\..");return s+=I,$.length>0?`${$}${g.slice(s,c)}`:(g.charCodeAt(s)===f&&++s,g.slice(s,c))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const a=t.win32.resolve(o);if(a.length<=2)return o;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const l=a.charCodeAt(2);if(l!==P&&l!==d)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(y(a.charCodeAt(0))&&a.charCodeAt(1)===p&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return o},dirname(o){b(o,"path");const a=o.length;if(a===0)return".";let l=-1,g=0;const L=o.charCodeAt(0);if(a===1)return e(L)?o:".";if(e(L)){if(l=g=1,e(o.charCodeAt(1))){let s=2,c=s;for(;s<a&&!e(o.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&e(o.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!e(o.charCodeAt(s));)s++;if(s===a)return o;s!==c&&(l=g=s+1)}}}}else y(L)&&o.charCodeAt(1)===p&&(l=a>2&&e(o.charCodeAt(2))?3:2,g=l);let _=-1,i=!0;for(let s=a-1;s>=g;--s)if(e(o.charCodeAt(s))){if(!i){_=s;break}}else i=!1;if(_===-1){if(l===-1)return".";_=l}return o.slice(0,_)},basename(o,a){a!==void 0&&b(a,"ext"),b(o,"path");let l=0,g=-1,L=!0,_;if(o.length>=2&&y(o.charCodeAt(0))&&o.charCodeAt(1)===p&&(l=2),a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let i=a.length-1,s=-1;for(_=o.length-1;_>=l;--_){const c=o.charCodeAt(_);if(e(c)){if(!L){l=_+1;break}}else s===-1&&(L=!1,s=_+1),i>=0&&(c===a.charCodeAt(i)?--i==-1&&(g=_):(i=-1,g=s))}return l===g?g=s:g===-1&&(g=o.length),o.slice(l,g)}for(_=o.length-1;_>=l;--_)if(e(o.charCodeAt(_))){if(!L){l=_+1;break}}else g===-1&&(L=!1,g=_+1);return g===-1?"":o.slice(l,g)},extname(o){b(o,"path");let a=0,l=-1,g=0,L=-1,_=!0,i=0;o.length>=2&&o.charCodeAt(1)===p&&y(o.charCodeAt(0))&&(a=g=2);for(let s=o.length-1;s>=a;--s){const c=o.charCodeAt(s);if(e(c)){if(!_){g=s+1;break}continue}L===-1&&(_=!1,L=s+1),c===d?l===-1?l=s:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||L===-1||i===0||i===1&&l===L-1&&l===g+1?"":o.slice(l,L)},format:m.bind(null,"\\"),parse(o){b(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const l=o.length;let g=0,L=o.charCodeAt(0);if(l===1)return e(L)?(a.root=a.dir=o,a):(a.base=a.name=o,a);if(e(L)){if(g=1,e(o.charCodeAt(1))){let I=2,B=I;for(;I<l&&!e(o.charCodeAt(I));)I++;if(I<l&&I!==B){for(B=I;I<l&&e(o.charCodeAt(I));)I++;if(I<l&&I!==B){for(B=I;I<l&&!e(o.charCodeAt(I));)I++;I===l?g=I:I!==B&&(g=I+1)}}}}else if(y(L)&&o.charCodeAt(1)===p){if(l<=2)return a.root=a.dir=o,a;if(g=2,e(o.charCodeAt(2))){if(l===3)return a.root=a.dir=o,a;g=3}}g>0&&(a.root=o.slice(0,g));let _=-1,i=g,s=-1,c=!0,C=o.length-1,S=0;for(;C>=g;--C){if(L=o.charCodeAt(C),e(L)){if(!c){i=C+1;break}continue}s===-1&&(c=!1,s=C+1),L===d?_===-1?_=C:S!==1&&(S=1):_!==-1&&(S=-1)}return s!==-1&&(_===-1||S===0||S===1&&_===s-1&&_===i+1?a.base=a.name=o.slice(i,s):(a.name=o.slice(i,_),a.base=o.slice(i,s),a.ext=o.slice(_,s))),i>0&&i!==g?a.dir=o.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...o){let a="",l=!1;for(let g=o.length-1;g>=-1&&!l;g--){const L=g>=0?o[g]:D.cwd();b(L,"path"),L.length!==0&&(a=`${L}/${a}`,l=L.charCodeAt(0)===u)}return a=E(a,!l,"/",w),l?`/${a}`:a.length>0?a:"."},normalize(o){if(b(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===u,l=o.charCodeAt(o.length-1)===u;return o=E(o,!a,"/",w),o.length===0?a?"/":l?"./":".":(l&&(o+="/"),a?`/${o}`:o)},isAbsolute(o){return b(o,"path"),o.length>0&&o.charCodeAt(0)===u},join(...o){if(o.length===0)return".";let a;for(let l=0;l<o.length;++l){const g=o[l];b(g,"path"),g.length>0&&(a===void 0?a=g:a+=`/${g}`)}return a===void 0?".":t.posix.normalize(a)},relative(o,a){if(b(o,"from"),b(a,"to"),o===a||(o=t.posix.resolve(o),a=t.posix.resolve(a),o===a))return"";const l=1,g=o.length,L=g-l,_=1,i=a.length-_,s=L<i?L:i;let c=-1,C=0;for(;C<s;C++){const I=o.charCodeAt(l+C);if(I!==a.charCodeAt(_+C))break;I===u&&(c=C)}if(C===s)if(i>s){if(a.charCodeAt(_+C)===u)return a.slice(_+C+1);if(C===0)return a.slice(_+C)}else L>s&&(o.charCodeAt(l+C)===u?c=C:C===0&&(c=0));let S="";for(C=l+c+1;C<=g;++C)(C===g||o.charCodeAt(C)===u)&&(S+=S.length===0?"..":"/..");return`${S}${a.slice(_+c)}`},toNamespacedPath(o){return o},dirname(o){if(b(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===u;let l=-1,g=!0;for(let L=o.length-1;L>=1;--L)if(o.charCodeAt(L)===u){if(!g){l=L;break}}else g=!1;return l===-1?a?"/":".":a&&l===1?"//":o.slice(0,l)},basename(o,a){a!==void 0&&b(a,"ext"),b(o,"path");let l=0,g=-1,L=!0,_;if(a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let i=a.length-1,s=-1;for(_=o.length-1;_>=0;--_){const c=o.charCodeAt(_);if(c===u){if(!L){l=_+1;break}}else s===-1&&(L=!1,s=_+1),i>=0&&(c===a.charCodeAt(i)?--i==-1&&(g=_):(i=-1,g=s))}return l===g?g=s:g===-1&&(g=o.length),o.slice(l,g)}for(_=o.length-1;_>=0;--_)if(o.charCodeAt(_)===u){if(!L){l=_+1;break}}else g===-1&&(L=!1,g=_+1);return g===-1?"":o.slice(l,g)},extname(o){b(o,"path");let a=-1,l=0,g=-1,L=!0,_=0;for(let i=o.length-1;i>=0;--i){const s=o.charCodeAt(i);if(s===u){if(!L){l=i+1;break}continue}g===-1&&(L=!1,g=i+1),s===d?a===-1?a=i:_!==1&&(_=1):a!==-1&&(_=-1)}return a===-1||g===-1||_===0||_===1&&a===g-1&&a===l+1?"":o.slice(a,g)},format:m.bind(null,"/"),parse(o){b(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const l=o.charCodeAt(0)===u;let g;l?(a.root="/",g=1):g=0;let L=-1,_=0,i=-1,s=!0,c=o.length-1,C=0;for(;c>=g;--c){const S=o.charCodeAt(c);if(S===u){if(!s){_=c+1;break}continue}i===-1&&(s=!1,i=c+1),S===d?L===-1?L=c:C!==1&&(C=1):L!==-1&&(C=-1)}if(i!==-1){const S=_===0&&l?1:_;L===-1||C===0||C===1&&L===i-1&&L===_+1?a.base=a.name=o.slice(S,i):(a.name=o.slice(S,L),a.base=o.slice(S,i),a.ext=o.slice(L,i))}return _>0?a.dir=o.slice(0,_-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=D.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=D.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=D.platform==="win32"?t.win32.join:t.posix.join,t.resolve=D.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=D.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=D.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=D.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=D.platform==="win32"?t.win32.extname:t.posix.extname,t.format=D.platform==="win32"?t.win32.format:t.posix.format,t.parse=D.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=D.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=D.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=D.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),ie(se[15],ae([0,1,2]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class M{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new M(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}t.StopWatch=M}),ie(se[4],ae([0,1,11,14,7,26,15]),function(W,t,D,n,M,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var d;(function(a){a.None=()=>M.Disposable.None;function l(ne){return(V,j=null,H)=>{let Y=!1,X;return X=ne(ee=>{if(!Y)return X?X.dispose():Y=!0,V.call(j,ee)},null,H),Y&&X.dispose(),X}}a.once=l;function g(ne,V){return C((j,H=null,Y)=>ne(X=>j.call(H,V(X)),null,Y))}a.map=g;function L(ne,V){return C((j,H=null,Y)=>ne(X=>{V(X),j.call(H,X)},null,Y))}a.forEach=L;function _(ne,V){return C((j,H=null,Y)=>ne(X=>V(X)&&j.call(H,X),null,Y))}a.filter=_;function i(ne){return ne}a.signal=i;function s(...ne){return(V,j=null,H)=>(0,M.combinedDisposable)(...ne.map(Y=>Y(X=>V.call(j,X),null,H)))}a.any=s;function c(ne,V,j){let H=j;return g(ne,Y=>(H=V(H,Y),H))}a.reduce=c;function C(ne){let V;const j=new v({onFirstListenerAdd(){V=ne(j.fire,j)},onLastListenerRemove(){V.dispose()}});return j.event}function S(ne,V,j,H=100,Y=!1){let X,ee,T=0;return ne(N=>{T++,X=j(X,N),Y&&!ee&&(V(X),X=void 0),clearTimeout(ee),ee=setTimeout(()=>{const F=X;X=void 0,ee=void 0,(!Y||T>1)&&V(F),T=0},H)})}a.debouncedListener=S;function I(ne,V,j=100,H=!1,Y){let X,ee,T,N=0;const F=new v({leakWarningThreshold:Y,onFirstListenerAdd(){X=ne(O=>{N++,ee=V(ee,O),H&&!T&&(F.fire(ee),ee=void 0),clearTimeout(T),T=setTimeout(()=>{const U=ee;ee=void 0,T=void 0,(!H||N>1)&&F.fire(U),N=0},j)})},onLastListenerRemove(){X.dispose()}});return F.event}a.debounce=I;function B(ne,V=(j,H)=>j===H){let j=!0,H;return _(ne,Y=>{const X=j||!V(Y,H);return j=!1,H=Y,X})}a.latch=B;function $(ne,V){return[a.filter(ne,V),a.filter(ne,j=>!V(j))]}a.split=$;function Z(ne,V=!1,j=[]){let H=j.slice(),Y=ne(T=>{H?H.push(T):ee.fire(T)});const X=()=>{H&&H.forEach(T=>ee.fire(T)),H=null},ee=new v({onFirstListenerAdd(){Y||(Y=ne(T=>ee.fire(T)))},onFirstListenerDidAdd(){H&&(V?setTimeout(X):X())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return ee.event}a.buffer=Z;class K{constructor(V){this.event=V}map(V){return new K(g(this.event,V))}forEach(V){return new K(L(this.event,V))}filter(V){return new K(_(this.event,V))}reduce(V,j){return new K(c(this.event,V,j))}latch(){return new K(B(this.event))}debounce(V,j=100,H=!1,Y){return new K(I(this.event,V,j,H,Y))}on(V,j,H){return this.event(V,j,H)}once(V,j,H){return l(this.event)(V,j,H)}}function R(ne){return new K(ne)}a.chain=R;function G(ne,V,j=H=>H){const H=(...T)=>ee.fire(j(...T)),Y=()=>ne.on(V,H),X=()=>ne.removeListener(V,H),ee=new v({onFirstListenerAdd:Y,onLastListenerRemove:X});return ee.event}a.fromNodeEventEmitter=G;function oe(ne,V,j=H=>H){const H=(...T)=>ee.fire(j(...T)),Y=()=>ne.addEventListener(V,H),X=()=>ne.removeEventListener(V,H),ee=new v({onFirstListenerAdd:Y,onLastListenerRemove:X});return ee.event}a.fromDOMEventEmitter=oe;function r(ne){return new Promise(V=>l(ne)(V))}a.toPromise=r;function x(ne,V){return V(void 0),ne(j=>V(j))}a.runAndSubscribe=x;function ce(ne,V){let j=null;function H(X){j?.dispose(),j=new M.DisposableStore,V(X,j)}H(void 0);const Y=ne(X=>H(X));return(0,M.toDisposable)(()=>{Y.dispose(),j?.dispose()})}a.runAndSubscribeWithStore=ce})(d=t.Event||(t.Event={}));class u{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${u._idPool++}`}start(l){this._stopWatch=new A.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let f=-1;function p(a){const l=f;return f=a,{dispose(){f=l}}}t.setGlobalLeakWarningThreshold=p;class P{constructor(l,g=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let g=f;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||l<g)return;this._stacks||(this._stacks=new Map);const L=new Error().stack.split(`
`).slice(3).join(`
`),_=this._stacks.get(L)||0;if(this._stacks.set(L,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let i,s=0;for(const[c,C]of this._stacks)(!i||s<C)&&(i=c,s=C);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(L)||0;this._stacks.set(L,i-1)}}}class v{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=f>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(l,g,L)=>{this._listeners||(this._listeners=new h.LinkedList);const _=this._listeners.isEmpty();_&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(g?[l,g]:l);_&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,g);const s=this._leakageMon?.check(this._listeners.size),c=(0,M.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return L instanceof M.DisposableStore?L.add(c):Array.isArray(L)&&L.push(c),c}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new h.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,L]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,L):g[0].call(g[1],L)}catch(_){(0,D.onUnexpectedError)(_)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}t.Emitter=v;class b extends v{async fireAsync(l,g,L){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new h.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,l]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[_,i]=this._asyncDeliveryQueue.shift(),s=[],c={...i,token:g,waitUntil:C=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");L&&(C=L(C,typeof _=="function"?_:_[0])),s.push(C)}};try{typeof _=="function"?_.call(void 0,c):_[0].call(_[1],c)}catch(C){(0,D.onUnexpectedError)(C);continue}Object.freeze(s),await Promise.allSettled(s).then(C=>{for(const S of C)S.status==="rejected"&&(0,D.onUnexpectedError)(S.reason)})}}}}t.AsyncEmitter=b;class e extends v{constructor(l){super(l);this._isPaused=0,this._eventQueue=new h.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}t.PauseableEmitter=e;class w extends e{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}t.DebounceEmitter=w;class y extends v{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]})}}t.MicrotaskEmitter=y;class E{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const g={event:l,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const L=()=>{this.hasListeners&&this.unhook(g);const _=this.events.indexOf(g);this.events.splice(_,1)};return(0,M.toDisposable)((0,n.once)(L))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(g=>this.emitter.fire(g))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=E;class m{constructor(){this.buffers=[]}wrapEvent(l){return(g,L,_)=>l(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>g.call(L,i)):g.call(L,i)},void 0,_)}bufferEvents(l){const g=[];this.buffers.push(g);const L=l();return this.buffers.pop(),g.forEach(_=>_()),L}}t.EventBufferer=m;class o{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=M.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=o}),ie(se[12],ae([0,1,4]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const n=Object.freeze(function(d,u){const f=setTimeout(d.bind(u),0);return{dispose(){clearTimeout(f)}}});var M;(function(d){function u(f){return f===d.None||f===d.Cancelled||f instanceof h?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}d.isCancellationToken=u,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(M=t.CancellationToken||(t.CancellationToken={}));class h{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new h),this._token}cancel(){this._token?this._token instanceof h&&this._token.cancel():this._token=M.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof h&&this._token.dispose():this._token=M.None}}t.CancellationTokenSource=A}),ie(se[28],ae([0,1,12]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCachedComputed=t.Cache=void 0;class n{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new D.CancellationTokenSource,d=this.task(A.token);return this.result={promise:d,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}t.Cache=n;class M{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const d=JSON.stringify(A);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.computeFn(A)),this.lastCache}}t.LRUCachedComputed=M}),ie(se[3],ae([0,1,28,25]),function(W,t,D,n){"use strict";var M;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function h(k){return!k||typeof k!="string"?!0:k.trim().length===0}t.isFalsyOrWhitespace=h;const A=/{(\d+)}/g;function d(k,...q){return q.length===0?k:k.replace(A,function(z,J){const re=parseInt(J,10);return isNaN(re)||re<0||re>=q.length?z:q[re]})}t.format=d;const u=/{([^}]+)}/g;function f(k,q){return k.replace(u,(z,J)=>q[J]??z)}t.format2=f;function p(k){return k.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}t.escape=p;function P(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=P;function v(k,q){let z=0;const J=q.charCodeAt(0);for(let re=k.length-1;re>=0;re--)k.charCodeAt(re)===J&&z++;return z}t.count=v;function b(k,q,z="\u2026"){return k.length<=q?k:`${k.substr(0,q)}${z}`}t.truncate=b;function e(k,q=" "){const z=w(k,q);return y(z,q)}t.trim=e;function w(k,q){if(!k||!q)return k;const z=q.length;if(z===0||k.length===0)return k;let J=0;for(;k.indexOf(q,J)===J;)J=J+z;return k.substring(J)}t.ltrim=w;function y(k,q){if(!k||!q)return k;const z=q.length,J=k.length;if(z===0||J===0)return k;let re=J,fe=-1;for(;fe=k.lastIndexOf(q,re-1),!(fe===-1||fe+z!==re);){if(fe===0)return"";re=fe}return k.substring(0,re)}t.rtrim=y;function E(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=E;function m(k){return k.replace(/\*/g,"")}t.stripWildcards=m;function o(k,q,z={}){if(!k)throw new Error("Cannot create regex from empty string");q||(k=P(k)),z.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let J="";return z.global&&(J+="g"),z.matchCase||(J+="i"),z.multiline&&(J+="m"),z.unicode&&(J+="u"),new RegExp(k,J)}t.createRegExp=o;function a(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}t.regExpLeadsToEndlessLoop=a;function l(k){return!!k.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=l;function g(k){return(k.global?"g":"")+(k.ignoreCase?"i":"")+(k.multiline?"m":"")+(k.unicode?"u":"")}t.regExpFlags=g;function L(k){return k.split(/\r\n|\r|\n/)}t.splitLines=L;function _(k){for(let q=0,z=k.length;q<z;q++){const J=k.charCodeAt(q);if(J!==32&&J!==9)return q}return-1}t.firstNonWhitespaceIndex=_;function i(k,q=0,z=k.length){for(let J=q;J<z;J++){const re=k.charCodeAt(J);if(re!==32&&re!==9)return k.substring(q,J)}return k.substring(q,z)}t.getLeadingWhitespace=i;function s(k,q=k.length-1){for(let z=q;z>=0;z--){const J=k.charCodeAt(z);if(J!==32&&J!==9)return z}return-1}t.lastNonWhitespaceIndex=s;function c(k,q){return k<q?-1:k>q?1:0}t.compare=c;function C(k,q,z=0,J=k.length,re=0,fe=q.length){for(;z<J&&re<fe;z++,re++){let ve=k.charCodeAt(z),he=q.charCodeAt(re);if(ve<he)return-1;if(ve>he)return 1}const ge=J-z,Ee=fe-re;return ge<Ee?-1:ge>Ee?1:0}t.compareSubstring=C;function S(k,q){return I(k,q,0,k.length,0,q.length)}t.compareIgnoreCase=S;function I(k,q,z=0,J=k.length,re=0,fe=q.length){for(;z<J&&re<fe;z++,re++){let ve=k.charCodeAt(z),he=q.charCodeAt(re);if(ve===he)continue;if(ve>=128||he>=128)return C(k.toLowerCase(),q.toLowerCase(),z,J,re,fe);B(ve)&&(ve-=32),B(he)&&(he-=32);const be=ve-he;if(be!==0)return be}const ge=J-z,Ee=fe-re;return ge<Ee?-1:ge>Ee?1:0}t.compareSubstringIgnoreCase=I;function B(k){return k>=97&&k<=122}t.isLowerAsciiLetter=B;function $(k){return k>=65&&k<=90}t.isUpperAsciiLetter=$;function Z(k,q){return k.length===q.length&&I(k,q)===0}t.equalsIgnoreCase=Z;function K(k,q){const z=q.length;return q.length>k.length?!1:I(k,q,0,z)===0}t.startsWithIgnoreCase=K;function R(k,q){let z,J=Math.min(k.length,q.length);for(z=0;z<J;z++)if(k.charCodeAt(z)!==q.charCodeAt(z))return z;return J}t.commonPrefixLength=R;function G(k,q){let z,J=Math.min(k.length,q.length);const re=k.length-1,fe=q.length-1;for(z=0;z<J;z++)if(k.charCodeAt(re-z)!==q.charCodeAt(fe-z))return z;return J}t.commonSuffixLength=G;function oe(k){return 55296<=k&&k<=56319}t.isHighSurrogate=oe;function r(k){return 56320<=k&&k<=57343}t.isLowSurrogate=r;function x(k,q){return(k-55296<<10)+(q-56320)+65536}t.computeCodePoint=x;function ce(k,q,z){const J=k.charCodeAt(z);if(oe(J)&&z+1<q){const re=k.charCodeAt(z+1);if(r(re))return x(J,re)}return J}t.getNextCodePoint=ce;function ne(k,q){const z=k.charCodeAt(q-1);if(r(z)&&q>1){const J=k.charCodeAt(q-2);if(oe(J))return x(J,z)}return z}class V{constructor(q,z=0){this._str=q,this._len=q.length,this._offset=z}get offset(){return this._offset}setOffset(q){this._offset=q}prevCodePoint(){const q=ne(this._str,this._offset);return this._offset-=q>=65536?2:1,q}nextCodePoint(){const q=ce(this._str,this._len,this._offset);return this._offset+=q>=65536?2:1,q}eol(){return this._offset>=this._len}}t.CodePointIterator=V;class j{constructor(q,z=0){this._iterator=new V(q,z)}get offset(){return this._iterator.offset}nextGraphemeLength(){const q=Le.getInstance(),z=this._iterator,J=z.offset;let re=q.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const fe=z.offset,ge=q.getGraphemeBreakType(z.nextCodePoint());if(Re(re,ge)){z.setOffset(fe);break}re=ge}return z.offset-J}prevGraphemeLength(){const q=Le.getInstance(),z=this._iterator,J=z.offset;let re=q.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const fe=z.offset,ge=q.getGraphemeBreakType(z.prevCodePoint());if(Re(ge,re)){z.setOffset(fe);break}re=ge}return J-z.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=j;function H(k,q){return new j(k,q).nextGraphemeLength()}t.nextCharLength=H;function Y(k,q){return new j(k,q).prevGraphemeLength()}t.prevCharLength=Y;function X(k,q){q>0&&r(k.charCodeAt(q))&&q--;const z=q+H(k,q);return[z-Y(k,z),z]}t.getCharContainingOffset=X;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(k){return ee.test(k)}t.containsRTL=T;const N=/^[\t\n\r\x20-\x7E]*$/;function F(k){return N.test(k)}t.isBasicASCII=F,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(k){return t.UNUSUAL_LINE_TERMINATORS.test(k)}t.containsUnusualLineTerminators=O;function U(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}t.isFullWidthCharacter=U;function Q(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}t.isEmojiImprecise=Q;function te(k,q){if(k.length<q)return k;const z=/\b/g;let J=0;for(;z.test(k)&&!(k.length-z.lastIndex<q);)J=z.lastIndex,z.lastIndex+=1;return k.substring(J).replace(/^\s/,"")}t.lcut=te;const le=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function _e(k){return k&&(k=k.replace(le,""),k=k.replace(ue,""),k=k.replace(me,"")),k}t.removeAnsiEscapeCodes=_e,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ye;function Ie(k){return ye(k)?k.substr(1):k}t.stripUTF8BOM=Ie;function Oe(k,q){if(!k||!q||k.length<q.length)return!1;const z=q.length,J=k.toLowerCase();let re=0,fe=-1;for(;re<z;){const ge=J.indexOf(q[re],fe+1);if(ge<0)return!1;fe=ge,re++}return!0}t.fuzzyContains=Oe;function Ue(k,q=!1){return k?(q&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}t.containsUppercaseCharacter=Ue;function Be(k){return k.charAt(0).toUpperCase()+k.slice(1)}t.uppercaseFirstLetter=Be;function qe(k,q=1){if(q===0)return"";let z=-1;do z=k.indexOf(`
`,z+1),q--;while(q>0&&z>=0);return z===-1?k:(k[z-1]==="\r"&&z--,k.substr(0,z))}t.getNLines=qe;function We(k){const q=90-65+1;return k=k%(2*q),k<q?String.fromCharCode(97+k):String.fromCharCode(65+k-q)}t.singleLetterHash=We;function Ve(k){return Le.getInstance().getGraphemeBreakType(k)}t.getGraphemeBreakType=Ve;function Re(k,q){return k===0?q!==5&&q!==7:k===2&&q===3?!1:k===4||k===2||k===3||q===4||q===2||q===3?!0:!(k===8&&(q===8||q===9||q===11||q===12)||(k===11||k===9)&&(q===9||q===10)||(k===12||k===10)&&q===10||q===5||q===13||q===7||k===1||k===13&&q===14||k===6&&q===6)}var He;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(He=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Le{constructor(){this._data=ze()}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const z=this._data,J=z.length/3;let re=1;for(;re<=J;)if(q<z[3*re])re=2*re;else if(q>z[3*re+1])re=2*re+1;else return z[3*re+2];return 0}}Le._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(k,q){if(k===0)return 0;const z=$e(k,q);if(z!==void 0)return z;const J=new V(q,k);return J.prevCodePoint(),J.offset}t.getLeftDeleteOffset=je;function $e(k,q){const z=new V(q,k);let J=z.prevCodePoint();for(;Ge(J)||J===65039||J===8419;){if(z.offset===0)return;J=z.prevCodePoint()}if(!Q(J))return;let re=z.offset;return re>0&&z.prevCodePoint()===8205&&(re=z.offset),re}function Ge(k){return 127995<=k&&k<=127999}var De;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={})),t.noBreakWhitespace="\xA0";class we{constructor(q){this.confusableDictionary=q}static getInstance(q){return we.cache.get(Array.from(q))}static getLocales(){return we._locales.getValue()}isAmbiguous(q){return this.confusableDictionary.has(q)}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=we,M=we,we.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),we.cache=new D.LRUCachedComputed(k=>{function q(he){const be=new Map;for(let pe=0;pe<he.length;pe+=2)be.set(he[pe],he[pe+1]);return be}function z(he,be){const pe=new Map(he);for(const[Ne,Pe]of be)pe.set(Ne,Pe);return pe}function J(he,be){if(!he)return be;const pe=new Map;for(const[Ne,Pe]of he)be.has(Ne)&&pe.set(Ne,Pe);return pe}const re=M.ambiguousCharacterData.getValue();let fe=k.filter(he=>!he.startsWith("_")&&he in re);fe.length===0&&(fe=["_default"]);let ge;for(const he of fe){const be=q(re[he]);ge=J(ge,be)}const Ee=q(re._common),ve=z(Ee,ge);return new we(ve)}),we._locales=new n.Lazy(()=>Object.keys(we.ambiguousCharacterData.getValue()).filter(k=>!k.startsWith("_")));class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(q){return Ae.getData().has(q)}static get codePoints(){return Ae.getData()}}t.InvisibleCharacters=Ae,Ae._data=void 0}),ie(se[29],ae([0,1,3]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function n(E){return M(E,0)}t.hash=n;function M(E,m){switch(typeof E){case"object":return E===null?h(349,m):Array.isArray(E)?u(E,m):f(E,m);case"string":return d(E,m);case"boolean":return A(E,m);case"number":return h(E,m);case"undefined":return h(937,m);default:return h(617,m)}}t.doHash=M;function h(E,m){return(m<<5)-m+E|0}t.numberHash=h;function A(E,m){return h(E?433:863,m)}function d(E,m){m=h(149417,m);for(let o=0,a=E.length;o<a;o++)m=h(E.charCodeAt(o),m);return m}t.stringHash=d;function u(E,m){return m=h(104579,m),E.reduce((o,a)=>M(a,o),m)}function f(E,m){return m=h(181387,m),Object.keys(E).sort().reduce((o,a)=>(o=d(a,o),M(E[a],o)),m)}class p{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=M(m,this._value),this._value}}t.Hasher=p;var P;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function v(E,m,o=32){const a=o-m,l=~((1<<a)-1);return(E<<m|(l&E)>>>a)>>>0}function b(E,m=0,o=E.byteLength,a=0){for(let l=0;l<o;l++)E[m+l]=a}function e(E,m,o="0"){for(;E.length<m;)E=o+E;return E}function w(E,m=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(o=>o.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),m/4)}t.toHexString=w;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const o=m.length;if(o===0)return;const a=this._buff;let l=this._buffLen,g=this._leftoverHighSurrogate,L,_;for(g!==0?(L=g,_=-1,g=0):(L=m.charCodeAt(0),_=0);;){let i=L;if(D.isHighSurrogate(L))if(_+1<o){const s=m.charCodeAt(_+1);D.isLowSurrogate(s)?(_++,i=D.computeCodePoint(L,s)):i=65533}else{g=L;break}else D.isLowSurrogate(L)&&(i=65533);if(l=this._push(a,l,i),_++,_<o)L=m.charCodeAt(_);else break}this._buffLen=l,this._leftoverHighSurrogate=g}_push(m,o,a){return a<128?m[o++]=a:a<2048?(m[o++]=192|(a&1984)>>>6,m[o++]=128|(a&63)>>>0):a<65536?(m[o++]=224|(a&61440)>>>12,m[o++]=128|(a&4032)>>>6,m[o++]=128|(a&63)>>>0):(m[o++]=240|(a&1835008)>>>18,m[o++]=128|(a&258048)>>>12,m[o++]=128|(a&4032)>>>6,m[o++]=128|(a&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=y._bigBlock32,o=this._buffDV;for(let C=0;C<64;C+=4)m.setUint32(C,o.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)m.setUint32(C,v(m.getUint32(C-12,!1)^m.getUint32(C-32,!1)^m.getUint32(C-56,!1)^m.getUint32(C-64,!1),1),!1);let a=this._h0,l=this._h1,g=this._h2,L=this._h3,_=this._h4,i,s,c;for(let C=0;C<80;C++)C<20?(i=l&g|~l&L,s=1518500249):C<40?(i=l^g^L,s=1859775393):C<60?(i=l&g|l&L|g&L,s=2400959708):(i=l^g^L,s=3395469782),c=v(a,5)+i+_+s+m.getUint32(C*4,!1)&4294967295,_=L,L=g,g=v(l,30),l=a,a=c;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+g&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+_&4294967295}}t.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),ie(se[16],ae([0,1,22,29]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class M{constructor(v){this.source=v}getElements(){const v=this.source,b=new Int32Array(v.length);for(let e=0,w=v.length;e<w;e++)b[e]=v.charCodeAt(e);return b}}t.StringDiffSequence=M;function h(P,v,b){return new p(new M(P),new M(v)).ComputeDiff(b).changes}t.stringDiff=h;class A{static Assert(v,b){if(!v)throw new Error(b)}}t.Debug=A;class d{static Copy(v,b,e,w,y){for(let E=0;E<y;E++)e[w+E]=v[b+E]}static Copy2(v,b,e,w,y){for(let E=0;E<y;E++)e[w+E]=v[b+E]}}t.MyArray=d;var u;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new D.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(v,b){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_originalCount++}AddModifiedElement(v,b){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class p{constructor(v,b,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=v,this._modifiedSequence=b;const[w,y,E]=p._getElements(v),[m,o,a]=p._getElements(b);this._hasStrings=E&&a,this._originalStringElements=w,this._originalElementsOrHash=y,this._modifiedStringElements=m,this._modifiedElementsOrHash=o,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(v){return v.length>0&&typeof v[0]=="string"}static _getElements(v){const b=v.getElements();if(p._isStringArray(b)){const e=new Int32Array(b.length);for(let w=0,y=b.length;w<y;w++)e[w]=(0,n.stringHash)(b[w],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}ElementsAreEqual(v,b){return this._originalElementsOrHash[v]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[v]===this._modifiedStringElements[b]:!0}ElementsAreStrictEqual(v,b){if(!this.ElementsAreEqual(v,b))return!1;const e=p._getStrictElement(this._originalSequence,v),w=p._getStrictElement(this._modifiedSequence,b);return e===w}static _getStrictElement(v,b){return typeof v.getStrictElement=="function"?v.getStrictElement(b):null}OriginalElementsAreEqual(v,b){return this._originalElementsOrHash[v]!==this._originalElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[v]===this._originalStringElements[b]:!0}ModifiedElementsAreEqual(v,b){return this._modifiedElementsOrHash[v]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._modifiedStringElements[v]===this._modifiedStringElements[b]:!0}ComputeDiff(v){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,v)}_ComputeDiff(v,b,e,w,y){const E=[!1];let m=this.ComputeDiffRecursive(v,b,e,w,E);return y&&(m=this.PrettifyChanges(m)),{quitEarly:E[0],changes:m}}ComputeDiffRecursive(v,b,e,w,y){for(y[0]=!1;v<=b&&e<=w&&this.ElementsAreEqual(v,e);)v++,e++;for(;b>=v&&w>=e&&this.ElementsAreEqual(b,w);)b--,w--;if(v>b||e>w){let g;return e<=w?(A.Assert(v===b+1,"originalStart should only be one more than originalEnd"),g=[new D.DiffChange(v,0,e,w-e+1)]):v<=b?(A.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),g=[new D.DiffChange(v,b-v+1,e,0)]):(A.Assert(v===b+1,"originalStart should only be one more than originalEnd"),A.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),g=[]),g}const E=[0],m=[0],o=this.ComputeRecursionPoint(v,b,e,w,E,m,y),a=E[0],l=m[0];if(o!==null)return o;if(!y[0]){const g=this.ComputeDiffRecursive(v,a,e,l,y);let L=[];return y[0]?L=[new D.DiffChange(a+1,b-(a+1)+1,l+1,w-(l+1)+1)]:L=this.ComputeDiffRecursive(a+1,b,l+1,w,y),this.ConcatenateChanges(g,L)}return[new D.DiffChange(v,b-v+1,e,w-e+1)]}WALKTRACE(v,b,e,w,y,E,m,o,a,l,g,L,_,i,s,c,C,S){let I=null,B=null,$=new f,Z=b,K=e,R=_[0]-c[0]-w,G=-1073741824,oe=this.m_forwardHistory.length-1;do{const r=R+v;r===Z||r<K&&a[r-1]<a[r+1]?(g=a[r+1],i=g-R-w,g<G&&$.MarkNextChange(),G=g,$.AddModifiedElement(g+1,i),R=r+1-v):(g=a[r-1]+1,i=g-R-w,g<G&&$.MarkNextChange(),G=g-1,$.AddOriginalElement(g,i+1),R=r-1-v),oe>=0&&(a=this.m_forwardHistory[oe],v=a[0],Z=1,K=a.length-1)}while(--oe>=-1);if(I=$.getReverseChanges(),S[0]){let r=_[0]+1,x=c[0]+1;if(I!==null&&I.length>0){const ce=I[I.length-1];r=Math.max(r,ce.getOriginalEnd()),x=Math.max(x,ce.getModifiedEnd())}B=[new D.DiffChange(r,L-r+1,x,s-x+1)]}else{$=new f,Z=E,K=m,R=_[0]-c[0]-o,G=1073741824,oe=C?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const r=R+y;r===Z||r<K&&l[r-1]>=l[r+1]?(g=l[r+1]-1,i=g-R-o,g>G&&$.MarkNextChange(),G=g+1,$.AddOriginalElement(g+1,i+1),R=r+1-y):(g=l[r-1],i=g-R-o,g>G&&$.MarkNextChange(),G=g,$.AddModifiedElement(g+1,i+1),R=r-1-y),oe>=0&&(l=this.m_reverseHistory[oe],y=l[0],Z=1,K=l.length-1)}while(--oe>=-1);B=$.getChanges()}return this.ConcatenateChanges(I,B)}ComputeRecursionPoint(v,b,e,w,y,E,m){let o=0,a=0,l=0,g=0,L=0,_=0;v--,e--,y[0]=0,E[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const i=b-v+(w-e),s=i+1,c=new Int32Array(s),C=new Int32Array(s),S=w-e,I=b-v,B=v-e,$=b-w,K=(I-S)%2==0;c[S]=v,C[I]=b,m[0]=!1;for(let R=1;R<=i/2+1;R++){let G=0,oe=0;l=this.ClipDiagonalBound(S-R,R,S,s),g=this.ClipDiagonalBound(S+R,R,S,s);for(let x=l;x<=g;x+=2){x===l||x<g&&c[x-1]<c[x+1]?o=c[x+1]:o=c[x-1]+1,a=o-(x-S)-B;const ce=o;for(;o<b&&a<w&&this.ElementsAreEqual(o+1,a+1);)o++,a++;if(c[x]=o,o+a>G+oe&&(G=o,oe=a),!K&&Math.abs(x-I)<=R-1&&o>=C[x])return y[0]=o,E[0]=a,ce<=C[x]&&1447>0&&R<=1447+1?this.WALKTRACE(S,l,g,B,I,L,_,$,c,C,o,b,y,a,w,E,K,m):null}const r=(G-v+(oe-e)-R)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(G,r))return m[0]=!0,y[0]=G,E[0]=oe,r>0&&1447>0&&R<=1447+1?this.WALKTRACE(S,l,g,B,I,L,_,$,c,C,o,b,y,a,w,E,K,m):(v++,e++,[new D.DiffChange(v,b-v+1,e,w-e+1)]);L=this.ClipDiagonalBound(I-R,R,I,s),_=this.ClipDiagonalBound(I+R,R,I,s);for(let x=L;x<=_;x+=2){x===L||x<_&&C[x-1]>=C[x+1]?o=C[x+1]-1:o=C[x-1],a=o-(x-I)-$;const ce=o;for(;o>v&&a>e&&this.ElementsAreEqual(o,a);)o--,a--;if(C[x]=o,K&&Math.abs(x-S)<=R&&o<=c[x])return y[0]=o,E[0]=a,ce>=c[x]&&1447>0&&R<=1447+1?this.WALKTRACE(S,l,g,B,I,L,_,$,c,C,o,b,y,a,w,E,K,m):null}if(R<=1447){let x=new Int32Array(g-l+2);x[0]=S-l+1,d.Copy2(c,l,x,1,g-l+1),this.m_forwardHistory.push(x),x=new Int32Array(_-L+2),x[0]=I-L+1,d.Copy2(C,L,x,1,_-L+1),this.m_reverseHistory.push(x)}}return this.WALKTRACE(S,l,g,B,I,L,_,$,c,C,o,b,y,a,w,E,K,m)}PrettifyChanges(v){for(let b=0;b<v.length;b++){const e=v[b],w=b<v.length-1?v[b+1].originalStart:this._originalElementsOrHash.length,y=b<v.length-1?v[b+1].modifiedStart:this._modifiedElementsOrHash.length,E=e.originalLength>0,m=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<y&&(!E||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!m||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}let o=[null];if(b<v.length-1&&this.ChangesOverlap(v[b],v[b+1],o)){v[b]=o[0],v.splice(b+1,1),b--;continue}}for(let b=v.length-1;b>=0;b--){const e=v[b];let w=0,y=0;if(b>0){const g=v[b-1];w=g.originalStart+g.originalLength,y=g.modifiedStart+g.modifiedLength}const E=e.originalLength>0,m=e.modifiedLength>0;let o=0,a=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let g=1;;g++){const L=e.originalStart-g,_=e.modifiedStart-g;if(L<w||_<y||E&&!this.OriginalElementsAreEqual(L,L+e.originalLength)||m&&!this.ModifiedElementsAreEqual(_,_+e.modifiedLength))break;const s=(L===w&&_===y?5:0)+this._boundaryScore(L,e.originalLength,_,e.modifiedLength);s>a&&(a=s,o=g)}e.originalStart-=o,e.modifiedStart-=o;const l=[null];if(b>0&&this.ChangesOverlap(v[b-1],v[b],l)){v[b-1]=l[0],v.splice(b,1),b++;continue}}if(this._hasStrings)for(let b=1,e=v.length;b<e;b++){const w=v[b-1],y=v[b],E=y.originalStart-w.originalStart-w.originalLength,m=w.originalStart,o=y.originalStart+y.originalLength,a=o-m,l=w.modifiedStart,g=y.modifiedStart+y.modifiedLength,L=g-l;if(E<5&&a<20&&L<20){const _=this._findBetterContiguousSequence(m,a,l,L,E);if(_){const[i,s]=_;(i!==w.originalStart+w.originalLength||s!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=i-w.originalStart,w.modifiedLength=s-w.modifiedStart,y.originalStart=i+E,y.modifiedStart=s+E,y.originalLength=o-y.originalStart,y.modifiedLength=g-y.modifiedStart)}}}return v}_findBetterContiguousSequence(v,b,e,w,y){if(b<y||w<y)return null;const E=v+b-y+1,m=e+w-y+1;let o=0,a=0,l=0;for(let g=v;g<E;g++)for(let L=e;L<m;L++){const _=this._contiguousSequenceScore(g,L,y);_>0&&_>o&&(o=_,a=g,l=L)}return o>0?[a,l]:null}_contiguousSequenceScore(v,b,e){let w=0;for(let y=0;y<e;y++){if(!this.ElementsAreEqual(v+y,b+y))return 0;w+=this._originalStringElements[v+y].length}return w}_OriginalIsBoundary(v){return v<=0||v>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[v])}_OriginalRegionIsBoundary(v,b){if(this._OriginalIsBoundary(v)||this._OriginalIsBoundary(v-1))return!0;if(b>0){const e=v+b;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(v){return v<=0||v>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[v])}_ModifiedRegionIsBoundary(v,b){if(this._ModifiedIsBoundary(v)||this._ModifiedIsBoundary(v-1))return!0;if(b>0){const e=v+b;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(v,b,e,w){const y=this._OriginalRegionIsBoundary(v,b)?1:0,E=this._ModifiedRegionIsBoundary(e,w)?1:0;return y+E}ConcatenateChanges(v,b){let e=[];if(v.length===0||b.length===0)return b.length>0?b:v;if(this.ChangesOverlap(v[v.length-1],b[0],e)){const w=new Array(v.length+b.length-1);return d.Copy(v,0,w,0,v.length-1),w[v.length-1]=e[0],d.Copy(b,1,w,v.length,b.length-1),w}else{const w=new Array(v.length+b.length);return d.Copy(v,0,w,0,v.length),d.Copy(b,0,w,v.length,b.length),w}}ChangesOverlap(v,b,e){if(A.Assert(v.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),A.Assert(v.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),v.originalStart+v.originalLength>=b.originalStart||v.modifiedStart+v.modifiedLength>=b.modifiedStart){const w=v.originalStart;let y=v.originalLength;const E=v.modifiedStart;let m=v.modifiedLength;return v.originalStart+v.originalLength>=b.originalStart&&(y=b.originalStart+b.originalLength-v.originalStart),v.modifiedStart+v.modifiedLength>=b.modifiedStart&&(m=b.modifiedStart+b.modifiedLength-v.modifiedStart),e[0]=new D.DiffChange(w,y,E,m),!0}else return e[0]=null,!1}ClipDiagonalBound(v,b,e,w){if(v>=0&&v<w)return v;const y=e,E=w-e-1,m=b%2==0;if(v<0){const o=y%2==0;return m===o?0:1}else{const o=E%2==0;return m===o?w-1:w-2}}}t.LcsDiff=p});var Te=this&&this.__classPrivateFieldSet||function(W,t,D,n,M){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof t=="function"?W!==t||!M:!t.has(W))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?M.call(W,D):M?M.value=D:t.set(W,D),D},Ce=this&&this.__classPrivateFieldGet||function(W,t,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof t=="function"?W!==t||!n:!t.has(W))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(W):n?n.value:t.get(W)};ie(se[30],ae([0,1,13,3]),function(W,t,D,n){"use strict";var M,h,A;Object.defineProperty(t,"__esModule",{value:!0}),t.ReadonlyMapView=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function d(_,i,s){let c=_.get(i);return c===void 0&&(c=s,_.set(i,c)),c}t.getOrSet=d;function u(_){const i=[];return _.forEach((s,c)=>{i.push(`${c} => ${s}`)}),`Map(${_.size}) {${i.join(", ")}}`}t.mapToString=u;function f(_){const i=[];return _.forEach(s=>{i.push(s)}),`Set(${_.size}) {${i.join(", ")}}`}t.setToString=f;class p{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}t.StringIterator=p;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=P;class v{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=v;var b;(function(_){_[_.Scheme=1]="Scheme",_[_.Authority=2]="Authority",_[_.Path=3]="Path",_[_.Query=4]="Query",_[_.Fragment=5]="Fragment"})(b||(b={}));class e{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=e;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(_){_[_.Left=-1]="Left",_[_.Mid=0]="Mid",_[_.Right=1]="Right"})(y||(y={}));class E{constructor(i){this._iter=i}static forUris(i=()=>!1){return new E(new e(i))}static forPaths(i=!1){return new E(new v(void 0,!i))}static forStrings(){return new E(new p)}static forConfigKeys(){return new E(new P)}clear(){this._root=void 0}fill(i,s){if(s){const c=s.slice(0);(0,D.shuffle)(c);for(let C of c)this.set(C,i)}else{const c=i.slice(0);(0,D.shuffle)(c);for(let C of c)this.set(C[0],C[1])}}set(i,s){const c=this._iter.reset(i);let C;this._root||(this._root=new w,this._root.segment=c.value());const S=[];for(C=this._root;;){const B=c.cmp(C.segment);if(B>0)C.left||(C.left=new w,C.left.segment=c.value()),S.push([-1,C]),C=C.left;else if(B<0)C.right||(C.right=new w,C.right.segment=c.value()),S.push([1,C]),C=C.right;else if(c.hasNext())c.next(),C.mid||(C.mid=new w,C.mid.segment=c.value()),S.push([0,C]),C=C.mid;else break}const I=C.value;C.value=s,C.key=i;for(let B=S.length-1;B>=0;B--){const $=S[B][1];$.updateHeight();const Z=$.balanceFactor();if(Z<-1||Z>1){const K=S[B][0],R=S[B+1][0];if(K===1&&R===1)S[B][1]=$.rotateLeft();else if(K===-1&&R===-1)S[B][1]=$.rotateRight();else if(K===1&&R===-1)$.right=S[B+1][1]=S[B+1][1].rotateRight(),S[B][1]=$.rotateLeft();else if(K===-1&&R===1)$.left=S[B+1][1]=S[B+1][1].rotateLeft(),S[B][1]=$.rotateRight();else throw new Error;if(B>0)switch(S[B-1][0]){case-1:S[B-1][1].left=S[B][1];break;case 1:S[B-1][1].right=S[B][1];break;case 0:S[B-1][1].mid=S[B][1];break}else this._root=S[0][1]}}return I}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let c=this._root;for(;c;){const C=s.cmp(c.segment);if(C>0)c=c.left;else if(C<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const c=this._iter.reset(i),C=[];let S=this._root;for(;S;){const I=c.cmp(S.segment);if(I>0)C.push([-1,S]),S=S.left;else if(I<0)C.push([1,S]),S=S.right;else if(c.hasNext())c.next(),C.push([0,S]),S=S.mid;else break}if(!!S){if(s?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const I=this._min(S.right),{key:B,value:$,segment:Z}=I;this._delete(I.key,!1),S.key=B,S.value=$,S.segment=Z}else{const I=S.left??S.right;if(C.length>0){const[B,$]=C[C.length-1];switch(B){case-1:$.left=I;break;case 0:$.mid=I;break;case 1:$.right=I;break}}else this._root=I}for(let I=C.length-1;I>=0;I--){const B=C[I][1];B.updateHeight();const $=B.balanceFactor();if($>1?(B.right.balanceFactor()>=0||(B.right=B.right.rotateRight()),C[I][1]=B.rotateLeft()):$<-1&&(B.left.balanceFactor()<=0||(B.left=B.left.rotateLeft()),C[I][1]=B.rotateRight()),I>0)switch(C[I-1][0]){case-1:C[I-1][1].left=C[I][1];break;case 1:C[I-1][1].right=C[I][1];break;case 0:C[I-1][1].mid=C[I][1];break}else this._root=C[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let c=this._root,C;for(;c;){const S=s.cmp(c.segment);if(S>0)c=c.left;else if(S<0)c=c.right;else if(s.hasNext())s.next(),C=c.value||C,c=c.mid;else break}return c&&c.value||C}findSuperstr(i){const s=this._iter.reset(i);let c=this._root;for(;c;){const C=s.cmp(c.segment);if(C>0)c=c.left;else if(C<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[s,c]of this)i(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}t.TernarySearchTree=E;class m{constructor(i,s){this.uri=i,this.value=s}}class o{constructor(i,s){this[M]="ResourceMap",i instanceof o?(this.map=new Map(i.map),this.toKey=s??o.defaultToKey):(this.map=new Map,this.toKey=i??o.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new m(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[c,C]of this.map)i(C.value,C.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}t.ResourceMap=o,o.defaultToKey=_=>_.toString();var a;(function(_){_[_.None=0]="None",_[_.AsOld=1]="AsOld",_[_.AsNew=2]="AsNew"})(a=t.Touch||(t.Touch={}));class l{constructor(){this[h]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const c=this._map.get(i);if(!!c)return s!==0&&this.touch(c,s),c.value}set(i,s,c=0){let C=this._map.get(i);if(C)C.value=s,c!==0&&this.touch(C,c);else{switch(C={key:i,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(C);break;case 1:this.addItemFirst(C);break;case 2:this.addItemLast(C);break;default:this.addItemLast(C);break}this._map.set(i,C),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const c=this._state;let C=this._head;for(;C;){if(s?i.bind(s)(C.value,C.key,this):i(C.value,C.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");C=C.next}}keys(){const i=this,s=this._state;let c=this._head;const C={[Symbol.iterator](){return C},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.key,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return C}values(){const i=this,s=this._state;let c=this._head;const C={[Symbol.iterator](){return C},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.value,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return C}entries(){const i=this,s=this._state;let c=this._head;const C={[Symbol.iterator](){return C},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:[c.key,c.value],done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return C}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>i;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,c=i.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const c=i.next,C=i.previous;i===this._tail?(C.next=void 0,this._tail=C):(c.previous=C,C.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const c=i.next,C=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=C,C.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,c)=>{i.push([c,s])}),i}fromJSON(i){this.clear();for(const[s,c]of i)this.set(s,c)}}t.LinkedMap=l;class g extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=g;class L{constructor(i){A.set(this,void 0),Te(this,A,i,"f")}get size(){return Ce(this,A,"f").size}forEach(i,s){Ce(this,A,"f").forEach(i,s)}get(i){return Ce(this,A,"f").get(i)}has(i){return Ce(this,A,"f").has(i)}entries(){return Ce(this,A,"f").entries()}keys(){return Ce(this,A,"f").keys()}values(){return Ce(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ce(this,A,"f").entries()}}t.ReadonlyMapView=L}),ie(se[9],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function D(c){return Array.isArray(c)}t.isArray=D;function n(c){return typeof c=="string"}t.isString=n;function M(c){return Array.isArray(c)&&c.every(C=>n(C))}t.isStringArray=M;function h(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.isObject=h;function A(c){return typeof c=="number"&&!isNaN(c)}t.isNumber=A;function d(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.isIterable=d;function u(c){return c===!0||c===!1}t.isBoolean=u;function f(c){return typeof c=="undefined"}t.isUndefined=f;function p(c){return!P(c)}t.isDefined=p;function P(c){return f(c)||c===null}t.isUndefinedOrNull=P;function v(c,C){if(!c)throw new Error(C?`Unexpected type, expected '${C}'`:"Unexpected type")}t.assertType=v;function b(c){if(P(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.assertIsDefined=b;function e(...c){const C=[];for(let S=0;S<c.length;S++){const I=c[S];if(P(I))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);C.push(I)}return C}t.assertAllDefined=e;const w=Object.prototype.hasOwnProperty;function y(c){if(!h(c))return!1;for(let C in c)if(w.call(c,C))return!1;return!0}t.isEmptyObject=y;function E(c){return typeof c=="function"}t.isFunction=E;function m(...c){return c.length>0&&c.every(E)}t.areFunctions=m;function o(c,C){const S=Math.min(c.length,C.length);for(let I=0;I<S;I++)a(c[I],C[I])}t.validateConstraints=o;function a(c,C){if(n(C)){if(typeof c!==C)throw new Error(`argument does not match constraint: typeof ${C}`)}else if(E(C)){try{if(c instanceof C)return}catch{}if(!P(c)&&c.constructor===C||C.length===1&&C.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=a;function l(c){let C=[],S=Object.getPrototypeOf(c);for(;Object.prototype!==S;)C=C.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return C}t.getAllPropertyNames=l;function g(c){const C=[];for(const S of l(c))typeof c[S]=="function"&&C.push(S);return C}t.getAllMethodNames=g;function L(c,C){const S=B=>function(){const $=Array.prototype.slice.call(arguments,0);return C(B,$)};let I={};for(const B of c)I[B]=S(B);return I}t.createProxyObject=L;function _(c){return c===null?void 0:c}t.withNullAsUndefined=_;function i(c){return typeof c=="undefined"?null:c}t.withUndefinedAsNull=i;function s(c,C="Unreachable"){throw new Error(C)}t.assertNever=s}),ie(se[17],ae([0,1,8,2,3,9]),function(W,t,D,n,M,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function A(s){return s===47||s===92}t.isPathSeparator=A;function d(s){return s.replace(/[\\/]/g,D.posix.sep)}t.toSlashes=d;function u(s){return s.indexOf("/")===-1&&(s=d(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}t.toPosixPath=u;function f(s,c=D.posix.sep){if(!s)return"";const C=s.length,S=s.charCodeAt(0);if(A(S)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let B=3;const $=B;for(;B<C&&!A(s.charCodeAt(B));B++);if($!==B&&!A(s.charCodeAt(B+1))){for(B+=1;B<C;B++)if(A(s.charCodeAt(B)))return s.slice(0,B+1).replace(/[\\/]/g,c)}}return c}else if(E(S)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let I=s.indexOf("://");if(I!==-1){for(I+=3;I<C;I++)if(A(s.charCodeAt(I)))return s.slice(0,I+1)}return""}t.getRoot=f;function p(s){if(!n.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let C=2;const S=C;for(;C<s.length&&(c=s.charCodeAt(C),c!==92);C++);return!(S===C||(c=s.charCodeAt(C+1),isNaN(c)||c===92))}t.isUNC=p;const P=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(s,c=n.isWindows){const C=c?P:v;return!(!s||s.length===0||/^\s+$/.test(s)||(C.lastIndex=0,C.test(s))||c&&b.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}t.isValidBasename=e;function w(s,c,C){const S=s===c;return!C||S?S:!s||!c?!1:(0,M.equalsIgnoreCase)(s,c)}t.isEqual=w;function y(s,c,C,S=D.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(C){if(!(0,M.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let B=c.length;return c.charAt(c.length-1)===S&&B--,s.charAt(B)===S}return c.charAt(c.length-1)!==S&&(c+=S),s.indexOf(c)===0}t.isEqualOrParent=y;function E(s){return s>=65&&s<=90||s>=97&&s<=122}t.isWindowsDriveLetter=E;function m(s,c){return n.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(c,s)),s=(0,D.normalize)(s),n.isWindows?(s=(0,M.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,M.rtrim)(s,D.sep),s||(s=D.sep)),s}t.sanitizeFilePath=m;function o(s){const c=(0,D.normalize)(s);return n.isWindows?s.length>3?!1:a(c)&&(s.length===2||c.charCodeAt(2)===92):c===D.posix.sep}t.isRootOrDriveLetter=o;function a(s,c){return(c!==void 0?c:n.isWindows)?E(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}t.hasDriveLetter=a;function l(s){return a(s)?s[0]:void 0}t.getDriveLetter=l;function g(s,c,C){return c.length>s.length?-1:s===c?0:(C&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}t.indexOfPath=g;function L(s){const c=s.split(":");let C,S,I;for(const B of c){const $=Number(B);(0,h.isNumber)($)?S===void 0?S=$:I===void 0&&(I=$):C=C?[C,B].join(":"):B}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:S!==void 0?S:void 0,column:I!==void 0?I:S!==void 0?1:void 0}}t.parseLineAndColumnAware=L;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,c,C=8){let S="";for(let B=0;B<C;B++)S+=_.charAt(Math.floor(Math.random()*_.length));let I;return c?I=`${c}-${S}`:I=S,s?(0,D.join)(s,I):I}t.randomPath=i}),ie(se[31],ae([0,1,9]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function n(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const y=Array.isArray(w)?[]:{};return Object.keys(w).forEach(E=>{w[E]&&typeof w[E]=="object"?y[E]=n(w[E]):y[E]=w[E]}),y}t.deepClone=n;function M(w){if(!w||typeof w!="object")return w;const y=[w];for(;y.length>0;){const E=y.shift();Object.freeze(E);for(const m in E)if(h.call(E,m)){const o=E[m];typeof o=="object"&&!Object.isFrozen(o)&&y.push(o)}}return w}t.deepFreeze=M;const h=Object.prototype.hasOwnProperty;function A(w,y){return d(w,y,new Set)}t.cloneAndChange=A;function d(w,y,E){if((0,D.isUndefinedOrNull)(w))return w;const m=y(w);if(typeof m!="undefined")return m;if((0,D.isArray)(w)){const o=[];for(const a of w)o.push(d(a,y,E));return o}if((0,D.isObject)(w)){if(E.has(w))throw new Error("Cannot clone recursive data-structure");E.add(w);const o={};for(let a in w)h.call(w,a)&&(o[a]=d(w[a],y,E));return E.delete(w),o}return w}function u(w,y,E=!0){return(0,D.isObject)(w)?((0,D.isObject)(y)&&Object.keys(y).forEach(m=>{m in w?E&&((0,D.isObject)(w[m])&&(0,D.isObject)(y[m])?u(w[m],y[m],E):w[m]=y[m]):w[m]=y[m]}),w):y}t.mixin=u;function f(w,y){if(w===y)return!0;if(w==null||y===null||y===void 0||typeof w!=typeof y||typeof w!="object"||Array.isArray(w)!==Array.isArray(y))return!1;let E,m;if(Array.isArray(w)){if(w.length!==y.length)return!1;for(E=0;E<w.length;E++)if(!f(w[E],y[E]))return!1}else{const o=[];for(m in w)o.push(m);o.sort();const a=[];for(m in y)a.push(m);if(a.sort(),!f(o,a))return!1;for(E=0;E<o.length;E++)if(!f(w[o[E]],y[o[E]]))return!1}return!0}t.equals=f;function p(w){const y=new Set;return JSON.stringify(w,(E,m)=>{if((0,D.isObject)(m)||Array.isArray(m)){if(y.has(m))return"[Circular]";y.add(m)}return m})}t.safeStringify=p;function P(w,y,E){const m=y(w);return typeof m=="undefined"?E:m}t.getOrDefault=P;function v(w,y){const E=Object.create(null);return!w||!y||Object.keys(y).forEach(o=>{const a=w[o],l=y[o];f(a,l)||(E[o]=l)}),E}t.distinct=v;function b(w,y){const E=y.toLowerCase(),m=Object.keys(w).find(o=>o.toLowerCase()===E);return m?w[m]:w[y]}t.getCaseInsensitive=b;function e(w,y){const E=Object.create(null);for(const[m,o]of Object.entries(w))y(m,o)&&(E[m]=o);return E}t.filter=e}),ie(se[18],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var D;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D=t.Constants||(t.Constants={}));function n(h){return h<0?0:h>255?255:h|0}t.toUint8=n;function M(h){return h<0?0:h>4294967295?4294967295:h|0}t.toUint32=M}),ie(se[10],ae([0,1,8,2]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const M=/^\w[\w\d+.-]*$/,h=/^\//,A=/^\/\//;function d(_,i){if(!_.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!M.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!h.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(_,i){return!_&&!i?"file":_}function f(_,i){switch(_){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const p="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(i,s,c,C,S,I=!1){typeof i=="object"?(this.scheme=i.scheme||p,this.authority=i.authority||p,this.path=i.path||p,this.query=i.query||p,this.fragment=i.fragment||p):(this.scheme=u(i,I),this.authority=s||p,this.path=f(this.scheme,c||p),this.query=C||p,this.fragment=S||p,d(this,I))}static isUri(i){return i instanceof b?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return o(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:c,path:C,query:S,fragment:I}=i;return s===void 0?s=this.scheme:s===null&&(s=p),c===void 0?c=this.authority:c===null&&(c=p),C===void 0?C=this.path:C===null&&(C=p),S===void 0?S=this.query:S===null&&(S=p),I===void 0?I=this.fragment:I===null&&(I=p),s===this.scheme&&c===this.authority&&C===this.path&&S===this.query&&I===this.fragment?this:new w(s,c,C,S,I)}static parse(i,s=!1){const c=v.exec(i);return c?new w(c[2]||p,L(c[4]||p),L(c[5]||p),L(c[7]||p),L(c[9]||p),s):new w(p,p,p,p,p)}static file(i){let s=p;if(n.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const c=i.indexOf(P,2);c===-1?(s=i.substring(2),i=P):(s=i.substring(2,c),i=i.substring(c)||P)}return new w("file",s,i,p,p)}static from(i){const s=new w(i.scheme,i.authority,i.path,i.query,i.fragment);return d(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return n.isWindows&&i.scheme==="file"?c=b.file(D.win32.join(o(i,!0),...s)).path:c=D.posix.join(i.path,...s),i.with({path:c})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof b)return i;{const s=new w(i);return s._formatted=i.external,s._fsPath=i._sep===e?i.fsPath:null,s}}else return i}}t.URI=b;const e=n.isWindows?1:void 0;class w extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=e),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(_,i){let s,c=-1;for(let C=0;C<_.length;C++){const S=_.charCodeAt(C);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||i&&S===47)c!==-1&&(s+=encodeURIComponent(_.substring(c,C)),c=-1),s!==void 0&&(s+=_.charAt(C));else{s===void 0&&(s=_.substr(0,C));const I=y[S];I!==void 0?(c!==-1&&(s+=encodeURIComponent(_.substring(c,C)),c=-1),s+=I):c===-1&&(c=C)}}return c!==-1&&(s+=encodeURIComponent(_.substring(c))),s!==void 0?s:_}function m(_){let i;for(let s=0;s<_.length;s++){const c=_.charCodeAt(s);c===35||c===63?(i===void 0&&(i=_.substr(0,s)),i+=y[c]):i!==void 0&&(i+=_[s])}return i!==void 0?i:_}function o(_,i){let s;return _.authority&&_.path.length>1&&_.scheme==="file"?s=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===47&&(_.path.charCodeAt(1)>=65&&_.path.charCodeAt(1)<=90||_.path.charCodeAt(1)>=97&&_.path.charCodeAt(1)<=122)&&_.path.charCodeAt(2)===58?i?s=_.path.substr(1):s=_.path[1].toLowerCase()+_.path.substr(2):s=_.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}t.uriToFsPath=o;function a(_,i){const s=i?m:E;let c="",{scheme:C,authority:S,path:I,query:B,fragment:$}=_;if(C&&(c+=C,c+=":"),(S||C==="file")&&(c+=P,c+=P),S){let Z=S.indexOf("@");if(Z!==-1){const K=S.substr(0,Z);S=S.substr(Z+1),Z=K.indexOf(":"),Z===-1?c+=s(K,!1):(c+=s(K.substr(0,Z),!1),c+=":",c+=s(K.substr(Z+1),!1)),c+="@"}S=S.toLowerCase(),Z=S.indexOf(":"),Z===-1?c+=s(S,!1):(c+=s(S.substr(0,Z),!1),c+=S.substr(Z))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const Z=I.charCodeAt(1);Z>=65&&Z<=90&&(I=`/${String.fromCharCode(Z+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const Z=I.charCodeAt(0);Z>=65&&Z<=90&&(I=`${String.fromCharCode(Z+32)}:${I.substr(2)}`)}c+=s(I,!0)}return B&&(c+="?",c+=s(B,!1)),$&&(c+="#",c+=i?$:E($,!1)),c}function l(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+l(_.substr(3)):_}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(_){return _.match(g)?_.replace(g,i=>l(i)):_}}),ie(se[32],ae([0,1,2,10]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.Schemas=void 0;var M;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.userData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebook="vscode-notebook",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls"})(M=t.Schemas||(t.Schemas={}));class h{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}set(u,f,p){this._hosts[u]=f,this._ports[u]=p}setConnectionToken(u,f){this._connectionTokens[u]=f}rewrite(u){if(this._delegate)return this._delegate(u);const f=u.authority;let p=this._hosts[f];p&&p.indexOf(":")!==-1&&(p=`[${p}]`);const P=this._ports[f],v=this._connectionTokens[f];let b=`path=${encodeURIComponent(u.path)}`;return typeof v=="string"&&(b+=`&tkn=${encodeURIComponent(v)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${p}:${P}`,path:"/vscode-remote-resource",query:b})}}t.RemoteAuthorities=new h;class A{asBrowserUri(u,f){const p=this.toUri(u,f);return p.scheme===M.vscodeRemote?t.RemoteAuthorities.rewrite(p):p.scheme===M.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${M.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?p.with({scheme:M.vscodeFileResource,authority:p.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(u,f){const p=this.toUri(u,f);return p.scheme===M.vscodeFileResource?p.with({scheme:M.file,authority:p.authority!==A.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(u,f){return n.URI.isUri(u)?u:n.URI.parse(f.toUrl(u))}}A.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new A}),ie(se[33],ae([0,1,17,32,8,2,3,10]),function(W,t,D,n,M,h,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function u(b){return(0,d.uriToFsPath)(b,!0)}t.originalFSPath=u;class f{constructor(e){this._ignorePathCasing=e}compare(e,w,y=!1){return e===w?0:(0,A.compare)(this.getComparisonKey(e,y),this.getComparisonKey(w,y))}isEqual(e,w,y=!1){return e===w?!0:!e||!w?!1:this.getComparisonKey(e,y)===this.getComparisonKey(w,y)}getComparisonKey(e,w=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,w,y=!1){if(e.scheme===w.scheme){if(e.scheme===n.Schemas.file)return D.isEqualOrParent(u(e),u(w),this._ignorePathCasing(e))&&e.query===w.query&&(y||e.fragment===w.fragment);if((0,t.isEqualAuthority)(e.authority,w.authority))return D.isEqualOrParent(e.path,w.path,this._ignorePathCasing(e),"/")&&e.query===w.query&&(y||e.fragment===w.fragment)}return!1}joinPath(e,...w){return d.URI.joinPath(e,...w)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return M.posix.basename(e.path)}extname(e){return M.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let w;return e.scheme===n.Schemas.file?w=d.URI.file(M.dirname(u(e))).path:(w=M.posix.dirname(e.path),e.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),w="/")),e.with({path:w})}normalizePath(e){if(!e.path.length)return e;let w;return e.scheme===n.Schemas.file?w=d.URI.file(M.normalize(u(e))).path:w=M.posix.normalize(e.path),e.with({path:w})}relativePath(e,w){if(e.scheme!==w.scheme||!(0,t.isEqualAuthority)(e.authority,w.authority))return;if(e.scheme===n.Schemas.file){const m=M.relative(u(e),u(w));return h.isWindows?D.toSlashes(m):m}let y=e.path||"/",E=w.path||"/";if(this._ignorePathCasing(e)){let m=0;for(const o=Math.min(y.length,E.length);m<o&&!(y.charCodeAt(m)!==E.charCodeAt(m)&&y.charAt(m).toLowerCase()!==E.charAt(m).toLowerCase());m++);y=E.substr(0,m)+y.substr(m)}return M.posix.relative(y,E)}resolvePath(e,w){if(e.scheme===n.Schemas.file){const y=d.URI.file(M.resolve(u(e),w));return e.with({authority:y.authority,path:y.path})}return w=D.toPosixPath(w),e.with({path:M.posix.resolve(e.path,w)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,w){return e===w||e!==void 0&&w!==void 0&&(0,A.equalsIgnoreCase)(e,w)}hasTrailingPathSeparator(e,w=M.sep){if(e.scheme===n.Schemas.file){const y=u(e);return y.length>D.getRoot(y).length&&y[y.length-1]===w}else{const y=e.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,w=M.sep){return(0,t.hasTrailingPathSeparator)(e,w)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,w=M.sep){let y=!1;if(e.scheme===n.Schemas.file){const E=u(e);y=E!==void 0&&E.length===D.getRoot(E).length&&E[E.length-1]===w}else{w="/";const E=e.path;y=E.length===1&&E.charCodeAt(E.length-1)===47}return!y&&!(0,t.hasTrailingPathSeparator)(e,w)?e.with({path:e.path+"/"}):e}}t.ExtUri=f,t.extUri=new f(()=>!1),t.extUriBiasedIgnorePathCase=new f(b=>b.scheme===n.Schemas.file?!h.isLinux:!0),t.extUriIgnorePathCase=new f(b=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function p(b,e){const w=[];for(let y=0;y<b.length;y++){const E=e(b[y]);b.some((m,o)=>o===y?!1:(0,t.isEqualOrParent)(E,e(m)))||w.push(b[y])}return w}t.distinctParents=p;var P;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function e(w){const y=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(o=>{const[a,l]=o.split(":");a&&l&&y.set(a,l)});const m=w.path.substring(0,w.path.indexOf(";"));return m&&y.set(b.META_DATA_MIME,m),y}b.parseMetaData=e})(P=t.DataUri||(t.DataUri={}));function v(b,e,w){if(e){let y=b.path;return y&&y[0]!==M.posix.sep&&(y=M.posix.sep+y),b.with({scheme:w,authority:e,path:y})}return b.with({scheme:w})}t.toLocalResource=v}),ie(se[34],ae([0,1,12,11,4,7,33,2]),function(W,t,D,n,M,h,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function u(T){return!!T&&typeof T.then=="function"}t.isThenable=u;function f(T){const N=new D.CancellationTokenSource,F=T(N.token),O=new Promise((U,Q)=>{const te=N.token.onCancellationRequested(()=>{te.dispose(),N.dispose(),Q(new n.CancellationError)});Promise.resolve(F).then(le=>{te.dispose(),N.dispose(),U(le)},le=>{te.dispose(),N.dispose(),Q(le)})});return new class{cancel(){N.cancel()}then(U,Q){return O.then(U,Q)}catch(U){return this.then(void 0,U)}finally(U){return O.finally(U)}}}t.createCancelablePromise=f;function p(T,N,F){return new Promise((O,U)=>{const Q=N.onCancellationRequested(()=>{Q.dispose(),O(F)});T.then(O,U).finally(()=>Q.dispose())})}t.raceCancellation=p;function P(T,N){return new Promise((F,O)=>{const U=N.onCancellationRequested(()=>{U.dispose(),O(new n.CancellationError)});T.then(F,O).finally(()=>U.dispose())})}t.raceCancellationError=P;async function v(T){let N=-1;const F=T.map((U,Q)=>U.then(te=>(N=Q,te))),O=await Promise.race(F);return T.forEach((U,Q)=>{Q!==N&&U.cancel()}),O}t.raceCancellablePromises=v;function b(T,N,F){let O;const U=setTimeout(()=>{O?.(void 0),F?.()},N);return Promise.race([T.finally(()=>clearTimeout(U)),new Promise(Q=>O=Q)])}t.raceTimeout=b;function e(T){return new Promise((N,F)=>{const O=T();u(O)?O.then(N,F):N(O)})}t.asPromise=e;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(F,F).then(O)})}return new Promise((F,O)=>{this.queuedPromise.then(F,O)})}return this.activePromise=N(),new Promise((F,O)=>{this.activePromise.then(U=>{this.activePromise=null,F(U)},U=>{this.activePromise=null,O(U)})})}}t.Throttler=w;class y{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}t.Sequencer=y;class E{constructor(){this.promiseMap=new Map}queue(N,F){const U=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(N)===U&&this.promiseMap.delete(N)});return this.promiseMap.set(N,U),U}}t.SequencerByKey=E;const m=(T,N)=>{let F=!0;const O=setTimeout(()=>{F=!1,N()},T);return{isTriggered:()=>F,dispose:()=>{clearTimeout(O),F=!1}}},o=T=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,T())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,F=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,Q)=>{this.doResolve=U,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===t.MicrotaskDelay?o(O):m(F,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=a;class l{constructor(N){this.delayer=new a(N),this.throttler=new w}trigger(N,F){return this.delayer.trigger(()=>this.throttler.queue(N),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=l;class g{constructor(){this._isOpen=!1,this._promise=new Promise((N,F)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=g;class L extends g{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=L;function _(T,N){return N?new Promise((F,O)=>{const U=setTimeout(()=>{Q.dispose(),F()},T),Q=N.onCancellationRequested(()=>{clearTimeout(U),Q.dispose(),O(new n.CancellationError)})}):f(F=>_(T,F))}t.timeout=_;function i(T,N=0){const F=setTimeout(T,N);return(0,h.toDisposable)(()=>clearTimeout(F))}t.disposableTimeout=i;function s(T){const N=[];let F=0;const O=T.length;function U(){return F<O?T[F++]():null}function Q(te){te!=null&&N.push(te);const le=U();return le?le.then(Q):Promise.resolve(N)}return Promise.resolve(null).then(Q)}t.sequence=s;function c(T,N=O=>!!O,F=null){let O=0;const U=T.length,Q=()=>{if(O>=U)return Promise.resolve(F);const te=T[O++];return Promise.resolve(te()).then(ue=>N(ue)?Promise.resolve(ue):Q())};return Q()}t.first=c;function C(T,N=O=>!!O,F=null){if(T.length===0)return Promise.resolve(F);let O=T.length;const U=()=>{O=-1;for(const Q of T)Q.cancel?.()};return new Promise((Q,te)=>{for(const le of T)le.then(ue=>{--O>=0&&N(ue)?(U(),Q(ue)):O===0&&Q(F)}).catch(ue=>{--O>=0&&(U(),te(ue))})})}t.firstParallel=C;class S{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((F,O)=>{this.outstandingPromises.push({factory:N,c:F,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const F=N.factory();F.then(N.c,N.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=S;class I extends S{constructor(){super(1)}}t.Queue=I;class B{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new V;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,F=A.extUri){const O=F.getComparisonKey(N);let U=this.queues.get(O);return U||(U=new I,M.Event.once(U.onFinished)(()=>{U?.dispose(),this.queues.delete(O),this.onDidQueueFinish()}),this.queues.set(O,U)),U}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=B;class ${constructor(N,F){this._token=-1,typeof N=="function"&&typeof F=="number"&&this.setIfNotSet(N,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},F)}setIfNotSet(N,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},F))}}t.TimeoutTimer=$;class Z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,F){this.cancel(),this._token=setInterval(()=>{N()},F)}}t.IntervalTimer=Z;class K{constructor(N,F){this.timeoutToken=-1,this.runner=N,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=K;class R{constructor(N,F){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}t.ProcessTimeRunOnceScheduler=R;class G extends K{constructor(N,F){super(N,F);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=G;class oe extends h.Disposable{constructor(N,F){super();this.options=N,this.handler=F,this.pendingWork=[],this.throttler=this._register(new h.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=T=>{(0,d.setTimeout0)(()=>{if(N)return;const F=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:t.runWhenIdle=(T,N)=>{const F=requestIdleCallback(T,typeof N=="number"?{timeout:N}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(F))}}}}();class r{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=r;async function x(T,N,F){let O;for(let U=0;U<F;U++)try{return await T()}catch(Q){O=Q,await _(N)}throw O}t.retry=x;class ce{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,F,O){return this._pending={taskId:N,cancel:()=>O?.(),promise:F},F.then(()=>this.donePending(N),()=>this.donePending(N)),F}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let F,O;const U=new Promise((Q,te)=>{F=Q,O=te});this._next={run:N,promise:U,promiseResolve:F,promiseReject:O}}return this._next.promise}}t.TaskSequentializer=ce;class ne{constructor(N,F=()=>Date.now()){this.interval=N,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}t.IntervalCounter=ne;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,F)=>{this.completeCallback=N,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(F=>{this.completeCallback(N),this.resolved=!0,F()})}error(N){return new Promise(F=>{this.errorCallback(N),this.rejected=!0,F()})}cancel(){new Promise(N=>{this.errorCallback(new n.CancellationError),this.rejected=!0,N()})}}t.DeferredPromise=V;var j;(function(T){async function N(O){let U;const Q=await Promise.all(O.map(te=>te.then(le=>le,le=>{U||(U=le)})));if(typeof U!="undefined")throw U;return Q}T.settled=N;function F(O){return new Promise(async(U,Q)=>{try{await O(U,Q)}catch(te){Q(te)}})}T.withAsyncBody=F})(j=t.Promises||(t.Promises={}));var H;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(H||(H={}));class Y{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new M.Emitter,queueMicrotask(async()=>{const F={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(N(F)),this.resolve()}catch(O){this.reject(O)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}static fromArray(N){return new Y(F=>{F.emitMany(N)})}static fromPromise(N){return new Y(async F=>{F.emitMany(await N)})}static fromPromises(N){return new Y(async F=>{await Promise.all(N.map(async O=>F.emitOne(await O)))})}static merge(N){return new Y(async F=>{await Promise.all(N.map(async O=>{for await(const U of O)F.emitOne(U)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await M.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,F){return new Y(async O=>{for await(const U of N)O.emitOne(F(U))})}map(N){return Y.map(this,N)}static filter(N,F){return new Y(async O=>{for await(const U of N)F(U)&&O.emitOne(U)})}filter(N){return Y.filter(this,N)}static coalesce(N){return Y.filter(N,F=>!!F)}coalesce(){return Y.coalesce(this)}static async toPromise(N){const F=[];for await(const O of N)F.push(O);return F}toPromise(){return Y.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}t.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class X extends Y{constructor(N,F){super(F);this._source=N}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=X;function ee(T){const N=new D.CancellationTokenSource,F=T(N.token);return new X(N,async O=>{const U=N.token.onCancellationRequested(()=>{U.dispose(),N.dispose(),O.reject(new n.CancellationError)});try{for await(const Q of F){if(N.token.isCancellationRequested)return;O.emitOne(Q)}U.dispose(),N.dispose()}catch(Q){U.dispose(),N.dispose(),O.reject(Q)}})}t.createCancelableAsyncIterable=ee}),ie(se[35],ae([0,1,34,17,30,8,2,3]),function(W,t,D,n,M,h,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.GLOB_SPLIT=t.GLOBSTAR=t.getEmptyExpression=void 0;function u(){return Object.create(null)}t.getEmptyExpression=u,t.GLOBSTAR="**",t.GLOB_SPLIT="/";const f="[/\\\\]",p="[^/\\\\]",P=/\//g;function v(V){switch(V){case 0:return"";case 1:return`${p}*?`;default:return`(?:${f}|${p}+${f}|${f}${p}+)*?`}}function b(V,j){if(!V)return[];const H=[];let Y=!1,X=!1,ee="";for(const T of V){switch(T){case j:if(!Y&&!X){H.push(ee),ee="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":X=!0;break;case"]":X=!1;break}ee+=T}return ee&&H.push(ee),H}t.splitGlobAware=b;function e(V){if(!V)return"";let j="";const H=b(V,t.GLOB_SPLIT);if(H.every(Y=>Y===t.GLOBSTAR))j=".*";else{let Y=!1;H.forEach((X,ee)=>{if(X===t.GLOBSTAR){Y||(j+=v(2),Y=!0);return}let T=!1,N="",F=!1,O="";for(const U of X){if(U!=="}"&&T){N+=U;continue}if(F&&(U!=="]"||!O)){let Q;U==="-"?Q=U:(U==="^"||U==="!")&&!O?Q="^":U===t.GLOB_SPLIT?Q="":Q=(0,d.escapeRegExpCharacters)(U),O+=Q;continue}switch(U){case"{":T=!0;continue;case"[":F=!0;continue;case"}":{j+=`(?:${b(N,",").map(le=>e(le)).join("|")})`,T=!1,N="";break}case"]":j+="["+O+"]",F=!1,O="";break;case"?":j+=p;continue;case"*":j+=v(1);continue;default:j+=(0,d.escapeRegExpCharacters)(U)}}ee<H.length-1&&(H[ee+1]!==t.GLOBSTAR||ee+2<H.length)&&(j+=f),Y=!1})}return j}const w=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new M.LRUCache(1e4),g=function(){return!1},L=function(){return null};function _(V,j){if(!V)return L;let H;typeof V!="string"?H=V.pattern:H=V,H=H.trim();const Y=`${H}_${!!j.trimForExclusions}`;let X=l.get(Y);if(X)return i(X,V);let ee;if(w.test(H)){const T=H.substr(4);X=function(N,F){return typeof N=="string"&&N.endsWith(T)?H:null}}else(ee=y.exec(s(H,j)))?X=c(ee[1],H):(j.trimForExclusions?m:E).test(H)?X=C(H,j):(ee=o.exec(s(H,j)))?X=S(ee[1].substr(1),H,!0):(ee=a.exec(s(H,j)))?X=S(ee[1],H,!1):X=I(H);return l.set(Y,X),i(X,V)}function i(V,j){return typeof j=="string"?V:function(H,Y){return(0,n.isEqualOrParent)(H,j.base,!A.isLinux)?V(H.substr(j.base.length+1),Y):null}}function s(V,j){return j.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function c(V,j){const H=`/${V}`,Y=`\\${V}`,X=function(T,N){return typeof T!="string"?null:N?N===V?j:null:T===V||T.endsWith(H)||T.endsWith(Y)?j:null},ee=[V];return X.basenames=ee,X.patterns=[j],X.allBasenames=ee,X}function C(V,j){const H=ne(V.slice(1,-1).split(",").map(N=>_(N,j)).filter(N=>N!==L),V),Y=H.length;if(!Y)return L;if(Y===1)return H[0];const X=function(N,F){for(let O=0,U=H.length;O<U;O++)if(H[O](N,F))return V;return null},ee=H.find(N=>!!N.allBasenames);ee&&(X.allBasenames=ee.allBasenames);const T=H.reduce((N,F)=>F.allPaths?N.concat(F.allPaths):N,[]);return T.length&&(X.allPaths=T),X}function S(V,j,H){const Y=h.sep===h.posix.sep,X=Y?V:V.replace(P,h.sep),ee=h.sep+X,T=h.posix.sep+V,N=H?function(F,O){return typeof F=="string"&&(F===X||F.endsWith(ee)||!Y&&(F===V||F.endsWith(T)))?j:null}:function(F,O){return typeof F=="string"&&(F===X||!Y&&F===V)?j:null};return N.allPaths=[(H?"*/":"./")+V],N}function I(V){try{const j=new RegExp(`^${e(V)}$`);return function(H){return j.lastIndex=0,typeof H=="string"&&j.test(H)?V:null}}catch{return L}}function B(V,j,H){return!V||typeof j!="string"?!1:$(V)(j,void 0,H)}t.match=B;function $(V,j={}){if(!V)return g;if(typeof V=="string"||G(V)){const H=_(V,j);if(H===L)return g;const Y=function(X,ee){return!!H(X,ee)};return H.allBasenames&&(Y.allBasenames=H.allBasenames),H.allPaths&&(Y.allPaths=H.allPaths),Y}return x(V,j)}t.parse=$;function Z(V){if(!V)return;let j;return H=>(j||(j=(V()||Promise.resolve([])).then(Y=>Y?R(Y):{})),j.then(Y=>!!Y[H]))}t.hasSiblingPromiseFn=Z;function K(V){if(!V)return;let j;return H=>{if(!j){const Y=V();j=Y?R(Y):{}}return!!j[H]}}t.hasSiblingFn=K;function R(V){const j={};for(const H of V)j[H]=!0;return j}function G(V){const j=V;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}t.isRelativePattern=G;function oe(V){return V.allBasenames||[]}t.getBasenameTerms=oe;function r(V){return V.allPaths||[]}t.getPathTerms=r;function x(V,j){const H=ne(Object.getOwnPropertyNames(V).map(N=>ce(N,V[N],j)).filter(N=>N!==L)),Y=H.length;if(!Y)return L;if(!H.some(N=>!!N.requiresSiblings)){if(Y===1)return H[0];const N=function(U,Q){for(let te=0,le=H.length;te<le;te++){const ue=H[te](U,Q);if(ue)return ue}return null},F=H.find(U=>!!U.allBasenames);F&&(N.allBasenames=F.allBasenames);const O=H.reduce((U,Q)=>Q.allPaths?U.concat(Q.allPaths):U,[]);return O.length&&(N.allPaths=O),N}const X=function(N,F,O){let U;for(let Q=0,te=H.length;Q<te;Q++){const le=H[Q];le.requiresSiblings&&O&&(F||(F=(0,h.basename)(N)),U||(U=F.substr(0,F.length-(0,h.extname)(N).length)));const ue=le(N,F,U,O);if(ue)return ue}return null},ee=H.find(N=>!!N.allBasenames);ee&&(X.allBasenames=ee.allBasenames);const T=H.reduce((N,F)=>F.allPaths?N.concat(F.allPaths):N,[]);return T.length&&(X.allPaths=T),X}function ce(V,j,H){if(j===!1)return L;const Y=_(V,H);if(Y===L)return L;if(typeof j=="boolean")return Y;if(j){const X=j.when;if(typeof X=="string"){const ee=(T,N,F,O)=>{if(!O||!Y(T,N))return null;const U=X.replace("$(basename)",F),Q=O(U);return(0,D.isThenable)(Q)?Q.then(te=>te?V:null):Q?V:null};return ee.requiresSiblings=!0,ee}}return Y}function ne(V,j){const H=V.filter(N=>!!N.basenames);if(H.length<2)return V;const Y=H.reduce((N,F)=>{const O=F.basenames;return O?N.concat(O):N},[]);let X;if(j){X=[];for(let N=0,F=Y.length;N<F;N++)X.push(j)}else X=H.reduce((N,F)=>{const O=F.patterns;return O?N.concat(O):N},[]);const ee=function(N,F){if(typeof N!="string")return null;if(!F){let U;for(U=N.length;U>0;U--){const Q=N.charCodeAt(U-1);if(Q===47||Q===92)break}F=N.substr(U)}const O=Y.indexOf(F);return O!==-1?X[O]:null};ee.basenames=Y,ee.patterns=X,ee.allBasenames=Y;const T=V.filter(N=>!N.basenames);return T.push(ee),T}}),ie(se[52],ae([0,1,11,4,7,2,9,3]),function(W,t,D,n,M,h,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const u="$initialize";let f=!1;function p(_){!h.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(_.message))}t.logOnceWebWorkerWarning=p;var P;(function(_){_[_.Request=0]="Request",_[_.Reply=1]="Reply",_[_.SubscribeEvent=2]="SubscribeEvent",_[_.Event=3]="Event",_[_.UnsubscribeEvent=4]="UnsubscribeEvent"})(P||(P={}));class v{constructor(i,s,c,C){this.vsWorker=i,this.req=s,this.method=c,this.args=C,this.type=0}}class b{constructor(i,s,c,C){this.vsWorker=i,this.seq=s,this.res=c,this.err=C,this.type=1}}class e{constructor(i,s,c,C){this.vsWorker=i,this.req=s,this.eventName=c,this.arg=C,this.type=2}}class w{constructor(i,s,c){this.vsWorker=i,this.req=s,this.event=c,this.type=3}}class y{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class E{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const c=String(++this._lastSentReq);return new Promise((C,S)=>{this._pendingReplies[c]={resolve:C,reject:S},this._send(new v(this._workerId,c,i,s))})}listen(i,s){let c=null;const C=new n.Emitter({onFirstListenerAdd:()=>{c=String(++this._lastSentReq),this._pendingEmitters.set(c,C),this._send(new e(this._workerId,c,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(c),this._send(new y(this._workerId,c)),c=null}});return C.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let c=i.err;i.err.$isError&&(c=new Error,c.name=i.err.name,c.message=i.err.message,c.stack=i.err.stack),s.reject(c);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(C=>{this._send(new b(this._workerId,s,C,void 0))},C=>{C.detail instanceof Error&&(C.detail=(0,D.transformErrorForSerialization)(C.detail)),this._send(new b(this._workerId,s,void 0,(0,D.transformErrorForSerialization)(C)))})}_handleSubscribeEventMessage(i){const s=i.req,c=this._handler.handleEvent(i.eventName,i.arg)(C=>{this._send(new w(this._workerId,s,C))});this._pendingEvents.set(s,c)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let c=0;c<i.args.length;c++)i.args[c]instanceof ArrayBuffer&&s.push(i.args[c]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class m extends M.Disposable{constructor(i,s,c){super();let C=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",Z=>{this._protocol.handleMessage(Z)},Z=>{C&&C(Z)})),this._protocol=new E({sendMessage:(Z,K)=>{this._worker.postMessage(Z,K)},handleMessage:(Z,K)=>{if(typeof c[Z]!="function")return Promise.reject(new Error("Missing method "+Z+" on main thread host."));try{return Promise.resolve(c[Z].apply(c,K))}catch(R){return Promise.reject(R)}},handleEvent:(Z,K)=>{if(a(Z)){const R=c[Z].call(c,K);if(typeof R!="function")throw new Error(`Missing dynamic event ${Z} on main thread host.`);return R}if(o(Z)){const R=c[Z];if(typeof R!="function")throw new Error(`Missing event ${Z} on main thread host.`);return R}throw new Error(`Malformed event name ${Z}`)}}),this._protocol.setWorkerId(this._worker.getId());let S=null;typeof h.globals.require!="undefined"&&typeof h.globals.require.getConfig=="function"?S=h.globals.require.getConfig():typeof h.globals.requirejs!="undefined"&&(S=h.globals.requirejs.s.contexts._.config);const I=A.getAllMethodNames(c);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(S)),s,I]);const B=(Z,K)=>this._request(Z,K),$=(Z,K)=>this._protocol.listen(Z,K);this._lazyProxy=new Promise((Z,K)=>{C=K,this._onModuleLoaded.then(R=>{Z(l(R,B,$))},R=>{K(R),this._onError("Worker failed to load "+s,R)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((c,C)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(c,C)},C)})}_onError(i,s){console.error(i),console.info(s)}}t.SimpleWorkerClient=m;function o(_){return _[0]==="o"&&_[1]==="n"&&d.isUpperAsciiLetter(_.charCodeAt(2))}function a(_){return/^onDynamic/.test(_)&&d.isUpperAsciiLetter(_.charCodeAt(9))}function l(_,i,s){const c=I=>function(){const B=Array.prototype.slice.call(arguments,0);return i(I,B)},C=I=>function(B){return s(I,B)};let S={};for(const I of _){if(a(I)){S[I]=C(I);continue}if(o(I)){S[I]=s(I,void 0);continue}S[I]=c(I)}return S}class g{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new E({sendMessage:(c,C)=>{i(c,C)},handleMessage:(c,C)=>this._handleMessage(c,C),handleEvent:(c,C)=>this._handleEvent(c,C)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===u)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(c){return Promise.reject(c)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const c=this._requestHandler[i].call(this._requestHandler,s);if(typeof c!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return c}if(o(i)){const c=this._requestHandler[i];if(typeof c!="function")throw new Error(`Missing event ${i} on request handler.`);return c}throw new Error(`Malformed event name ${i}`)}initialize(i,s,c,C){this._protocol.setWorkerId(i);const B=l(C,($,Z)=>this._protocol.sendMessage($,Z),($,Z)=>this._protocol.listen($,Z));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(B),Promise.resolve(A.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,h.globals.require.config(s)),new Promise(($,Z)=>{(h.globals.require||W)([c],R=>{if(this._requestHandler=R.create(B),!this._requestHandler){Z(new Error("No RequestHandler!"));return}$(A.getAllMethodNames(this._requestHandler))},Z)}))}}t.SimpleWorkerServer=g;function L(_){return new g(_,null)}t.create=L}),ie(se[19],ae([0,1,18]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class n{constructor(d){const u=(0,D.toUint8)(d);this._defaultValue=u,this._asciiMap=n._createAsciiMap(u),this._map=new Map}static _createAsciiMap(d){const u=new Uint8Array(256);for(let f=0;f<256;f++)u[f]=d;return u}set(d,u){const f=(0,D.toUint8)(u);d>=0&&d<256?this._asciiMap[d]=f:this._map.set(d,f)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}}t.CharacterClassifier=n;var M;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(M||(M={}));class h{constructor(){this._actual=new n(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}}t.CharacterSet=h}),ie(se[5],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class D{constructor(M,h){this.lineNumber=M,this.column=h}with(M=this.lineNumber,h=this.column){return M===this.lineNumber&&h===this.column?this:new D(M,h)}delta(M=0,h=0){return this.with(this.lineNumber+M,this.column+h)}equals(M){return D.equals(this,M)}static equals(M,h){return!M&&!h?!0:!!M&&!!h&&M.lineNumber===h.lineNumber&&M.column===h.column}isBefore(M){return D.isBefore(this,M)}static isBefore(M,h){return M.lineNumber<h.lineNumber?!0:h.lineNumber<M.lineNumber?!1:M.column<h.column}isBeforeOrEqual(M){return D.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,h){return M.lineNumber<h.lineNumber?!0:h.lineNumber<M.lineNumber?!1:M.column<=h.column}static compare(M,h){const A=M.lineNumber|0,d=h.lineNumber|0;if(A===d){const u=M.column|0,f=h.column|0;return u-f}return A-d}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new D(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}}t.Position=D}),ie(se[6],ae([0,1,5]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class n{constructor(h,A,d,u){h>d||h===d&&A>u?(this.startLineNumber=d,this.startColumn=u,this.endLineNumber=h,this.endColumn=A):(this.startLineNumber=h,this.startColumn=A,this.endLineNumber=d,this.endColumn=u)}isEmpty(){return n.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return n.containsPosition(this,h)}static containsPosition(h,A){return!(A.lineNumber<h.startLineNumber||A.lineNumber>h.endLineNumber||A.lineNumber===h.startLineNumber&&A.column<h.startColumn||A.lineNumber===h.endLineNumber&&A.column>h.endColumn)}static strictContainsPosition(h,A){return!(A.lineNumber<h.startLineNumber||A.lineNumber>h.endLineNumber||A.lineNumber===h.startLineNumber&&A.column<=h.startColumn||A.lineNumber===h.endLineNumber&&A.column>=h.endColumn)}containsRange(h){return n.containsRange(this,h)}static containsRange(h,A){return!(A.startLineNumber<h.startLineNumber||A.endLineNumber<h.startLineNumber||A.startLineNumber>h.endLineNumber||A.endLineNumber>h.endLineNumber||A.startLineNumber===h.startLineNumber&&A.startColumn<h.startColumn||A.endLineNumber===h.endLineNumber&&A.endColumn>h.endColumn)}strictContainsRange(h){return n.strictContainsRange(this,h)}static strictContainsRange(h,A){return!(A.startLineNumber<h.startLineNumber||A.endLineNumber<h.startLineNumber||A.startLineNumber>h.endLineNumber||A.endLineNumber>h.endLineNumber||A.startLineNumber===h.startLineNumber&&A.startColumn<=h.startColumn||A.endLineNumber===h.endLineNumber&&A.endColumn>=h.endColumn)}plusRange(h){return n.plusRange(this,h)}static plusRange(h,A){let d,u,f,p;return A.startLineNumber<h.startLineNumber?(d=A.startLineNumber,u=A.startColumn):A.startLineNumber===h.startLineNumber?(d=A.startLineNumber,u=Math.min(A.startColumn,h.startColumn)):(d=h.startLineNumber,u=h.startColumn),A.endLineNumber>h.endLineNumber?(f=A.endLineNumber,p=A.endColumn):A.endLineNumber===h.endLineNumber?(f=A.endLineNumber,p=Math.max(A.endColumn,h.endColumn)):(f=h.endLineNumber,p=h.endColumn),new n(d,u,f,p)}intersectRanges(h){return n.intersectRanges(this,h)}static intersectRanges(h,A){let d=h.startLineNumber,u=h.startColumn,f=h.endLineNumber,p=h.endColumn,P=A.startLineNumber,v=A.startColumn,b=A.endLineNumber,e=A.endColumn;return d<P?(d=P,u=v):d===P&&(u=Math.max(u,v)),f>b?(f=b,p=e):f===b&&(p=Math.min(p,e)),d>f||d===f&&u>p?null:new n(d,u,f,p)}equalsRange(h){return n.equalsRange(this,h)}static equalsRange(h,A){return!!h&&!!A&&h.startLineNumber===A.startLineNumber&&h.startColumn===A.startColumn&&h.endLineNumber===A.endLineNumber&&h.endColumn===A.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(h){return new D.Position(h.endLineNumber,h.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(h){return new D.Position(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,A){return new n(this.startLineNumber,this.startColumn,h,A)}setStartPosition(h,A){return new n(h,A,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(h){return new n(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}static fromPositions(h,A=h){return new n(h.lineNumber,h.column,A.lineNumber,A.column)}static lift(h){return h?new n(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,A){return!(h.endLineNumber<A.startLineNumber||h.endLineNumber===A.startLineNumber&&h.endColumn<A.startColumn||A.endLineNumber<h.startLineNumber||A.endLineNumber===h.startLineNumber&&A.endColumn<h.startColumn)}static areIntersecting(h,A){return!(h.endLineNumber<A.startLineNumber||h.endLineNumber===A.startLineNumber&&h.endColumn<=A.startColumn||A.endLineNumber<h.startLineNumber||A.endLineNumber===h.startLineNumber&&A.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,A){if(h&&A){const f=h.startLineNumber|0,p=A.startLineNumber|0;if(f===p){const P=h.startColumn|0,v=A.startColumn|0;if(P===v){const b=h.endLineNumber|0,e=A.endLineNumber|0;if(b===e){const w=h.endColumn|0,y=A.endColumn|0;return w-y}return b-e}return P-v}return f-p}return(h?1:0)-(A?1:0)}static compareRangesUsingEnds(h,A){return h.endLineNumber===A.endLineNumber?h.endColumn===A.endColumn?h.startLineNumber===A.startLineNumber?h.startColumn-A.startColumn:h.startLineNumber-A.startLineNumber:h.endColumn-A.endColumn:h.endLineNumber-A.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}}t.Range=n}),ie(se[36],ae([0,1,5,6]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var M;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(M=t.SelectionDirection||(t.SelectionDirection={}));class h extends n.Range{constructor(d,u,f,p){super(d,u,f,p);this.selectionStartLineNumber=d,this.selectionStartColumn=u,this.positionLineNumber=f,this.positionColumn=p}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return h.selectionsEqual(this,d)}static selectionsEqual(d,u){return d.selectionStartLineNumber===u.selectionStartLineNumber&&d.selectionStartColumn===u.selectionStartColumn&&d.positionLineNumber===u.positionLineNumber&&d.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,u){return this.getDirection()===0?new h(this.startLineNumber,this.startColumn,d,u):new h(d,u,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,u){return this.getDirection()===0?new h(d,u,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,d,u)}static fromPositions(d,u=d){return new h(d.lineNumber,d.column,u.lineNumber,u.column)}static fromRange(d,u){return u===0?new h(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new h(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new h(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,u){if(d&&!u||!d&&u)return!1;if(!d&&!u)return!0;if(d.length!==u.length)return!1;for(let f=0,p=d.length;f<p;f++)if(!this.selectionsEqual(d[f],u[f]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,u,f,p,P){return P===0?new h(d,u,f,p):new h(f,p,d,u)}}t.Selection=h}),ie(se[37],ae([0,1,19]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var n;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(n=t.WordCharacterClass||(t.WordCharacterClass={}));class M extends D.CharacterClassifier{constructor(d){super(0);for(let u=0,f=d.length;u<f;u++)this.set(d.charCodeAt(u),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=M;function h(A){const d={};return u=>(d.hasOwnProperty(u)||(d[u]=A(u)),d[u])}t.getMapForWordSeparators=h(A=>new M(A))}),ie(se[38],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function D(d=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const f of t.USUAL_WORD_SEPARATORS)d.indexOf(f)>=0||(u+="\\"+f);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=D();function n(d){let u=t.DEFAULT_WORD_REGEXP;if(d&&d instanceof RegExp)if(d.global)u=d;else{let f="g";d.ignoreCase&&(f+="i"),d.multiline&&(f+="m"),d.unicode&&(f+="u"),u=new RegExp(d.source,f)}return u.lastIndex=0,u}t.ensureValidWordDefinition=n;const M={maxLen:1e3,windowSize:15,timeBudget:150};function h(d,u,f,p,P=M){if(f.length>P.maxLen){let y=d-P.maxLen/2;return y<0?y=0:p+=y,f=f.substring(y,d+P.maxLen/2),h(d,u,f,p,P)}const v=Date.now(),b=d-1-p;let e=-1,w=null;for(let y=1;!(Date.now()-v>=P.timeBudget);y++){const E=b-P.windowSize*y;u.lastIndex=Math.max(0,E);const m=A(u,f,b,e);if(!m&&w||(w=m,E<=0))break;e=E}if(w){const y={word:w[0],startColumn:p+1+w.index,endColumn:p+1+w.index+w[0].length};return u.lastIndex=0,y}return null}t.getWordAtText=h;function A(d,u,f,p){let P;for(;P=d.exec(u);){const v=P.index||0;if(v<=f&&d.lastIndex>=f)return P;if(p>0&&v>p)return null}return null}}),ie(se[39],ae([0,1,16,3]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const M=3;function h(w,y,E,m){return new D.LcsDiff(w,y,E).ComputeDiff(m)}class A{constructor(y){const E=[],m=[];for(let o=0,a=y.length;o<a;o++)E[o]=v(y[o],1),m[o]=b(y[o],1);this.lines=y,this._startColumns=E,this._endColumns=m}getElements(){const y=[];for(let E=0,m=this.lines.length;E<m;E++)y[E]=this.lines[E].substring(this._startColumns[E]-1,this._endColumns[E]-1);return y}getStrictElement(y){return this.lines[y]}getStartLineNumber(y){return y+1}getEndLineNumber(y){return y+1}createCharSequence(y,E,m){const o=[],a=[],l=[];let g=0;for(let L=E;L<=m;L++){const _=this.lines[L],i=y?this._startColumns[L]:1,s=y?this._endColumns[L]:_.length+1;for(let c=i;c<s;c++)o[g]=_.charCodeAt(c-1),a[g]=L+1,l[g]=c,g++}return new d(o,a,l)}}class d{constructor(y,E,m){this._charCodes=y,this._lineNumbers=E,this._columns=m}getElements(){return this._charCodes}getStartLineNumber(y){return this._lineNumbers[y]}getStartColumn(y){return this._columns[y]}getEndLineNumber(y){return this._lineNumbers[y]}getEndColumn(y){return this._columns[y]+1}}class u{constructor(y,E,m,o,a,l,g,L){this.originalStartLineNumber=y,this.originalStartColumn=E,this.originalEndLineNumber=m,this.originalEndColumn=o,this.modifiedStartLineNumber=a,this.modifiedStartColumn=l,this.modifiedEndLineNumber=g,this.modifiedEndColumn=L}static createFromDiffChange(y,E,m){let o,a,l,g,L,_,i,s;return y.originalLength===0?(o=0,a=0,l=0,g=0):(o=E.getStartLineNumber(y.originalStart),a=E.getStartColumn(y.originalStart),l=E.getEndLineNumber(y.originalStart+y.originalLength-1),g=E.getEndColumn(y.originalStart+y.originalLength-1)),y.modifiedLength===0?(L=0,_=0,i=0,s=0):(L=m.getStartLineNumber(y.modifiedStart),_=m.getStartColumn(y.modifiedStart),i=m.getEndLineNumber(y.modifiedStart+y.modifiedLength-1),s=m.getEndColumn(y.modifiedStart+y.modifiedLength-1)),new u(o,a,l,g,L,_,i,s)}}function f(w){if(w.length<=1)return w;const y=[w[0]];let E=y[0];for(let m=1,o=w.length;m<o;m++){const a=w[m],l=a.originalStart-(E.originalStart+E.originalLength),g=a.modifiedStart-(E.modifiedStart+E.modifiedLength);Math.min(l,g)<M?(E.originalLength=a.originalStart+a.originalLength-E.originalStart,E.modifiedLength=a.modifiedStart+a.modifiedLength-E.modifiedStart):(y.push(a),E=a)}return y}class p{constructor(y,E,m,o,a){this.originalStartLineNumber=y,this.originalEndLineNumber=E,this.modifiedStartLineNumber=m,this.modifiedEndLineNumber=o,this.charChanges=a}static createFromDiffResult(y,E,m,o,a,l,g){let L,_,i,s,c;if(E.originalLength===0?(L=m.getStartLineNumber(E.originalStart)-1,_=0):(L=m.getStartLineNumber(E.originalStart),_=m.getEndLineNumber(E.originalStart+E.originalLength-1)),E.modifiedLength===0?(i=o.getStartLineNumber(E.modifiedStart)-1,s=0):(i=o.getStartLineNumber(E.modifiedStart),s=o.getEndLineNumber(E.modifiedStart+E.modifiedLength-1)),l&&E.originalLength>0&&E.originalLength<20&&E.modifiedLength>0&&E.modifiedLength<20&&a()){const C=m.createCharSequence(y,E.originalStart,E.originalStart+E.originalLength-1),S=o.createCharSequence(y,E.modifiedStart,E.modifiedStart+E.modifiedLength-1);let I=h(C,S,a,!0).changes;g&&(I=f(I)),c=[];for(let B=0,$=I.length;B<$;B++)c.push(u.createFromDiffChange(I[B],C,S))}return new p(L,_,i,s,c)}}class P{constructor(y,E,m){this.shouldComputeCharChanges=m.shouldComputeCharChanges,this.shouldPostProcessCharChanges=m.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=m.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=m.shouldMakePrettyDiff,this.originalLines=y,this.modifiedLines=E,this.original=new A(y),this.modified=new A(E),this.continueLineDiff=e(m.maxComputationTime),this.continueCharDiff=e(m.maxComputationTime===0?0:Math.min(m.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const y=h(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),E=y.changes,m=y.quitEarly;if(this.shouldIgnoreTrimWhitespace){const g=[];for(let L=0,_=E.length;L<_;L++)g.push(p.createFromDiffResult(this.shouldIgnoreTrimWhitespace,E[L],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:m,changes:g}}const o=[];let a=0,l=0;for(let g=-1,L=E.length;g<L;g++){const _=g+1<L?E[g+1]:null,i=_?_.originalStart:this.originalLines.length,s=_?_.modifiedStart:this.modifiedLines.length;for(;a<i&&l<s;){const c=this.originalLines[a],C=this.modifiedLines[l];if(c!==C){{let S=v(c,1),I=v(C,1);for(;S>1&&I>1;){const B=c.charCodeAt(S-2),$=C.charCodeAt(I-2);if(B!==$)break;S--,I--}(S>1||I>1)&&this._pushTrimWhitespaceCharChange(o,a+1,1,S,l+1,1,I)}{let S=b(c,1),I=b(C,1);const B=c.length+1,$=C.length+1;for(;S<B&&I<$;){const Z=c.charCodeAt(S-1),K=c.charCodeAt(I-1);if(Z!==K)break;S++,I++}(S<B||I<$)&&this._pushTrimWhitespaceCharChange(o,a+1,S,B,l+1,I,$)}}a++,l++}_&&(o.push(p.createFromDiffResult(this.shouldIgnoreTrimWhitespace,_,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=_.originalLength,l+=_.modifiedLength)}return{quitEarly:m,changes:o}}_pushTrimWhitespaceCharChange(y,E,m,o,a,l,g){if(this._mergeTrimWhitespaceCharChange(y,E,m,o,a,l,g))return;let L;this.shouldComputeCharChanges&&(L=[new u(E,m,E,o,a,l,a,g)]),y.push(new p(E,E,a,a,L))}_mergeTrimWhitespaceCharChange(y,E,m,o,a,l,g){const L=y.length;if(L===0)return!1;const _=y[L-1];return _.originalEndLineNumber===0||_.modifiedEndLineNumber===0?!1:_.originalEndLineNumber+1===E&&_.modifiedEndLineNumber+1===a?(_.originalEndLineNumber=E,_.modifiedEndLineNumber=a,this.shouldComputeCharChanges&&_.charChanges&&_.charChanges.push(new u(E,m,E,o,a,l,a,g)),!0):!1}}t.DiffComputer=P;function v(w,y){const E=n.firstNonWhitespaceIndex(w);return E===-1?y:E+1}function b(w,y){const E=n.lastNonWhitespaceIndex(w);return E===-1?y:E+2}function e(w){if(w===0)return()=>!0;const y=Date.now();return()=>Date.now()-y<w}}),ie(se[40],ae([0,1,35,8]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.score=void 0;function M(h,A,d,u){if(Array.isArray(h)){let f=0;for(const p of h){const P=M(p,A,d,u);if(P===10)return P;P>f&&(f=P)}return f}else{if(typeof h=="string")return u?h==="*"?5:h===d?10:0:0;if(h){const{language:f,pattern:p,scheme:P,hasAccessToAllModels:v}=h;if(!u&&!v)return 0;let b=0;if(P)if(P===A.scheme)b=10;else if(P==="*")b=5;else return 0;if(f)if(f===d)b=10;else if(f==="*")b=Math.max(b,5);else return 0;if(p){let e;if(typeof p=="string"?e=p:e={...p,base:(0,n.normalize)(p.base)},e===A.fsPath||(0,D.match)(e,A.fsPath))b=10;else return 0}return b}else return 0}}t.score=M}),ie(se[41],ae([0,1,19]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var n;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(n=t.State||(t.State={}));class M{constructor(e,w,y){const E=new Uint8Array(e*w);for(let m=0,o=e*w;m<o;m++)E[m]=y;this._data=E,this.rows=e,this.cols=w}get(e,w){return this._data[e*this.cols+w]}set(e,w,y){this._data[e*this.cols+w]=y}}t.Uint8Matrix=M;class h{constructor(e){let w=0,y=0;for(let m=0,o=e.length;m<o;m++){const[a,l,g]=e[m];l>w&&(w=l),a>y&&(y=a),g>y&&(y=g)}w++,y++;const E=new M(y,w,0);for(let m=0,o=e.length;m<o;m++){const[a,l,g]=e[m];E.set(a,l,g)}this._states=E,this._maxCharCode=w}nextState(e,w){return w<0||w>=this._maxCharCode?0:this._states.get(e,w)}}t.StateMachine=h;let A=null;function d(){return A===null&&(A=new h([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var u;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let f=null;function p(){if(f===null){f=new D.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<b.length;w++)f.set(b.charCodeAt(w),1);const e=".,;";for(let w=0;w<e.length;w++)f.set(e.charCodeAt(w),2)}return f}class P{static _createLink(e,w,y,E,m){let o=m-1;do{const a=w.charCodeAt(o);if(e.get(a)!==2)break;o--}while(o>E);if(E>0){const a=w.charCodeAt(E-1),l=w.charCodeAt(o);(a===40&&l===41||a===91&&l===93||a===123&&l===125)&&o--}return{range:{startLineNumber:y,startColumn:E+1,endLineNumber:y,endColumn:o+2},url:w.substring(E,o+1)}}static computeLinks(e,w=d()){const y=p(),E=[];for(let m=1,o=e.getLineCount();m<=o;m++){const a=e.getLineContent(m),l=a.length;let g=0,L=0,_=0,i=1,s=!1,c=!1,C=!1,S=!1;for(;g<l;){let I=!1;const B=a.charCodeAt(g);if(i===13){let $;switch(B){case 40:s=!0,$=0;break;case 41:$=s?0:1;break;case 91:C=!0,c=!0,$=0;break;case 93:C=!1,$=c?0:1;break;case 123:S=!0,$=0;break;case 125:$=S?0:1;break;case 39:$=_===34||_===96?0:1;break;case 34:$=_===39||_===96?0:1;break;case 96:$=_===39||_===34?0:1;break;case 42:$=_===42?1:0;break;case 124:$=_===124?1:0;break;case 32:$=C?0:1;break;default:$=y.get(B)}$===1&&(E.push(P._createLink(y,a,m,L,g)),I=!0)}else if(i===12){let $;B===91?(c=!0,$=0):$=y.get(B),$===1?I=!0:i=13}else i=w.nextState(i,B),i===0&&(I=!0);I&&(i=1,s=!1,c=!1,S=!1,L=g+1,_=B),g++}i===13&&E.push(P._createLink(y,a,m,L,l))}return E}}t.LinkComputer=P;function v(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:P.computeLinks(b)}t.computeLinks=v}),ie(se[42],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class D{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(M,h,A,d,u){if(M&&h){const f=this.doNavigateValueSet(h,u);if(f)return{range:M,value:f}}if(A&&d){const f=this.doNavigateValueSet(d,u);if(f)return{range:A,value:f}}return null}doNavigateValueSet(M,h){const A=this.numberReplace(M,h);return A!==null?A:this.textReplace(M,h)}numberReplace(M,h){const A=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let d=Number(M),u=parseFloat(M);return!isNaN(d)&&!isNaN(u)&&d===u?d===0&&!h?null:(d=Math.floor(d*A),d+=h?A:-A,String(d/A)):null}textReplace(M,h){return this.valueSetsReplace(this._defaultValueSet,M,h)}valueSetsReplace(M,h,A){let d=null;for(let u=0,f=M.length;d===null&&u<f;u++)d=this.valueSetReplace(M[u],h,A);return d}valueSetReplace(M,h,A){let d=M.indexOf(h);return d>=0?(d+=A?1:-1,d<0?d=M.length-1:d%=M.length,M[d]):null}}t.BasicInplaceReplace=D,D.INSTANCE=new D}),ie(se[20],ae([0,1,31]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0;var n;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(n=t.OverviewRulerLane||(t.OverviewRulerLane={}));var M;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(M=t.MinimapPosition||(t.MinimapPosition={}));var h;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(h=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var A;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=t.EndOfLinePreference||(t.EndOfLinePreference={}));var d;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(d=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var u;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(u=t.EndOfLineSequence||(t.EndOfLineSequence={}));class f{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,D.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}t.TextModelResolvedOptions=f;class p{constructor(o,a){this._findMatchBrand=void 0,this.range=o,this.matches=a}}t.FindMatch=p;var P;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var v;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None"})(v=t.PositionAffinity||(t.PositionAffinity={}));var b;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=t.ModelConstants||(t.ModelConstants={}));class e{constructor(o,a,l,g,L,_){this.identifier=o,this.range=a,this.text=l,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=L,this._isTracked=_}}t.ValidAnnotatedEditOperation=e;class w{constructor(o,a,l){this.regex=o,this.wordSeparators=a,this.simpleSearch=l}}t.SearchData=w;class y{constructor(o,a,l){this.reverseEdits=o,this.changes=a,this.trimAutoWhitespaceLineNumbers=l}}t.ApplyEditsResult=y;function E(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}t.shouldSynchronizeModel=E}),ie(se[43],ae([0,1,4,7,20,40]),function(W,t,D,n,M,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguageFeatureRegistry=void 0;function A(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(A):!!u.exclusive}class d{constructor(){this._clock=0,this._entries=[],this._onDidChange=new D.Emitter}get onDidChange(){return this._onDidChange.event}register(f,p){let P={selector:f,provider:p,_score:-1,_time:this._clock++};return this._entries.push(P),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,n.toDisposable)(()=>{if(P){const v=this._entries.indexOf(P);v>=0&&(this._entries.splice(v,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),P=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const p=[];for(let P of this._entries)P._score>0&&p.push(P.provider);return p}ordered(f){const p=[];return this._orderedForEach(f,P=>p.push(P.provider)),p}orderedGroups(f){const p=[];let P,v;return this._orderedForEach(f,b=>{P&&v===b._score?P.push(b.provider):(v=b._score,P=[b.provider],p.push(P))}),p}_orderedForEach(f,p){if(!!f){this._updateScores(f);for(const P of this._entries)P._score>0&&p(P)}}_updateScores(f){const p={uri:f.uri.toString(),language:f.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===p.language&&this._lastCandidate.uri===p.uri)){this._lastCandidate=p;for(let P of this._entries)if(P._score=(0,h.score)(P.selector,f.uri,f.getLanguageId(),(0,M.shouldSynchronizeModel)(f)),A(P.selector)&&P._score>0){for(let v of this._entries)v._score=0;P._score=1e3;break}this._entries.sort(d._compareByScoreAndTime)}}static _compareByScoreAndTime(f,p){return f._score<p._score?1:f._score>p._score?-1:f._time<p._time?1:f._time>p._time?-1:0}}t.LanguageFeatureRegistry=d}),ie(se[44],ae([0,1,13,18]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class M{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(u,f){u=(0,n.toUint32)(u);const p=this.values,P=this.prefixSum,v=f.length;return v===0?!1:(this.values=new Uint32Array(p.length+v),this.values.set(p.subarray(0,u),0),this.values.set(p.subarray(u),u+v),this.values.set(f,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,f){return u=(0,n.toUint32)(u),f=(0,n.toUint32)(f),this.values[u]===f?!1:(this.values[u]=f,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,f){u=(0,n.toUint32)(u),f=(0,n.toUint32)(f);const p=this.values,P=this.prefixSum;if(u>=p.length)return!1;const v=p.length-u;return f>=v&&(f=v),f===0?!1:(this.values=new Uint32Array(p.length-f),this.values.set(p.subarray(0,u),0),this.values.set(p.subarray(u+f),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,n.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let f=this.prefixSumValidIndex[0]+1;f===0&&(this.prefixSum[0]=this.values[0],f++),u>=this.values.length&&(u=this.values.length-1);for(let p=f;p<=u;p++)this.prefixSum[p]=this.prefixSum[p-1]+this.values[p];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let f=0,p=this.values.length-1,P=0,v=0,b=0;for(;f<=p;)if(P=f+(p-f)/2|0,v=this.prefixSum[P],b=v-this.values[P],u<b)p=P-1;else if(u>=v)f=P+1;else break;return new A(P,u-b)}}t.PrefixSumComputer=M;class h{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const f=this._indexBySum[u],p=f>0?this._prefixSum[f-1]:0;return new A(f,u-p)}removeValues(u,f){this._values.splice(u,f),this._invalidate(u)}insertValues(u,f){this._values=(0,D.arrayInsert)(this._values,u,f),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,f=this._values.length;u<f;u++){const p=this._values[u],P=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=P+p;for(let v=0;v<p;v++)this._indexBySum[P+v]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,f){this._values[u]!==f&&(this._values[u]=f,this._invalidate(u))}}t.ConstantTimePrefixSumComputer=h;class A{constructor(u,f){this.index=u,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=f}}t.PrefixSumIndexOfResult=A}),ie(se[45],ae([0,1,3,5,44]),function(W,t,D,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class h{constructor(d,u,f,p){this._uri=d,this._lines=u,this._eol=f,this._versionId=p,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(d){d.eol&&d.eol!==this._eol&&(this._eol=d.eol,this._lineStarts=null);const u=d.changes;for(const f of u)this._acceptDeleteRange(f.range),this._acceptInsertText(new n.Position(f.range.startLineNumber,f.range.startColumn),f.text);this._versionId=d.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const d=this._eol.length,u=this._lines.length,f=new Uint32Array(u);for(let p=0;p<u;p++)f[p]=this._lines[p].length+d;this._lineStarts=new M.PrefixSumComputer(f)}}_setLineText(d,u){this._lines[d]=u,this._lineStarts&&this._lineStarts.setValue(d,this._lines[d].length+this._eol.length)}_acceptDeleteRange(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.startLineNumber-1].substring(d.endColumn-1));return}this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.endLineNumber-1].substring(d.endColumn-1)),this._lines.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}_acceptInsertText(d,u){if(u.length===0)return;const f=(0,D.splitLines)(u);if(f.length===1){this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+f[0]+this._lines[d.lineNumber-1].substring(d.column-1));return}f[f.length-1]+=this._lines[d.lineNumber-1].substring(d.column-1),this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+f[0]);const p=new Uint32Array(f.length-1);for(let P=1;P<f.length;P++)this._lines.splice(d.lineNumber+P-1,0,f[P]),p[P-1]=f[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(d.lineNumber,p)}}t.MirrorTextModel=h}),ie(se[46],ae([0,1,3,37,5,6,20]),function(W,t,D,n,M,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const d=999;class u{constructor(m,o,a,l){this.searchString=m,this.isRegex=o,this.matchCase=a,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=f(this.searchString):m=this.searchString.indexOf(`
`)>=0;let o=null;try{o=D.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch{return null}if(!o)return null;let a=!this.isRegex&&!m;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new A.SearchData(o,this.wordSeparators?(0,n.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}t.SearchParams=u;function f(E){if(!E||E.length===0)return!1;for(let m=0,o=E.length;m<o;m++)if(E.charCodeAt(m)===92){if(m++,m>=o)break;const l=E.charCodeAt(m);if(l===110||l===114||l===87)return!0}return!1}t.isMultilineRegexSource=f;function p(E,m,o){if(!o)return new A.FindMatch(E,null);const a=[];for(let l=0,g=m.length;l<g;l++)a[l]=m[l];return new A.FindMatch(E,a)}t.createFindMatch=p;class P{constructor(m){const o=[];let a=0;for(let l=0,g=m.length;l<g;l++)m.charCodeAt(l)===10&&(o[a++]=l);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(m){const o=this._lineFeedsOffsets;let a=0,l=o.length-1;if(l===-1||m<=o[0])return 0;for(;a<l;){const g=a+((l-a)/2>>0);o[g]>=m?l=g-1:o[g+1]>=m?(a=g,l=g):a=g+1}return a+1}}class v{static findMatches(m,o,a,l,g){const L=o.parseSearchRequest();return L?L.regex.multiline?this._doFindMatchesMultiline(m,a,new y(L.wordSeparators,L.regex),l,g):this._doFindMatchesLineByLine(m,a,L,l,g):[]}static _getMultilineMatchRange(m,o,a,l,g,L){let _,i=0;l?(i=l.findLineFeedCountBeforeOffset(g),_=o+g+i):_=o+g;let s;if(l){const I=l.findLineFeedCountBeforeOffset(g+L.length)-i;s=_+L.length+I}else s=_+L.length;const c=m.getPositionAt(_),C=m.getPositionAt(s);return new h.Range(c.lineNumber,c.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(m,o,a,l,g){const L=m.getOffsetAt(o.getStartPosition()),_=m.getValueInRange(o,1),i=m.getEOL()===`\r
`?new P(_):null,s=[];let c=0,C;for(a.reset(0);C=a.next(_);)if(s[c++]=p(this._getMultilineMatchRange(m,L,_,i,C.index,C[0]),C,l),c>=g)return s;return s}static _doFindMatchesLineByLine(m,o,a,l,g){const L=[];let _=0;if(o.startLineNumber===o.endLineNumber){const s=m.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return _=this._findMatchesInLine(a,s,o.startLineNumber,o.startColumn-1,_,L,l,g),L}const i=m.getLineContent(o.startLineNumber).substring(o.startColumn-1);_=this._findMatchesInLine(a,i,o.startLineNumber,o.startColumn-1,_,L,l,g);for(let s=o.startLineNumber+1;s<o.endLineNumber&&_<g;s++)_=this._findMatchesInLine(a,m.getLineContent(s),s,0,_,L,l,g);if(_<g){const s=m.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);_=this._findMatchesInLine(a,s,o.endLineNumber,0,_,L,l,g)}return L}static _findMatchesInLine(m,o,a,l,g,L,_,i){const s=m.wordSeparators;if(!_&&m.simpleSearch){const S=m.simpleSearch,I=S.length,B=o.length;let $=-I;for(;($=o.indexOf(S,$+I))!==-1;)if((!s||w(s,o,B,$,I))&&(L[g++]=new A.FindMatch(new h.Range(a,$+1+l,a,$+1+I+l),null),g>=i))return g;return g}const c=new y(m.wordSeparators,m.regex);let C;c.reset(0);do if(C=c.next(o),C&&(L[g++]=p(new h.Range(a,C.index+1+l,a,C.index+1+C[0].length+l),C,_),g>=i))return g;while(C);return g}static findNextMatch(m,o,a,l){const g=o.parseSearchRequest();if(!g)return null;const L=new y(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(m,a,L,l):this._doFindNextMatchLineByLine(m,a,L,l)}static _doFindNextMatchMultiline(m,o,a,l){const g=new M.Position(o.lineNumber,1),L=m.getOffsetAt(g),_=m.getLineCount(),i=m.getValueInRange(new h.Range(g.lineNumber,g.column,_,m.getLineMaxColumn(_)),1),s=m.getEOL()===`\r
`?new P(i):null;a.reset(o.column-1);let c=a.next(i);return c?p(this._getMultilineMatchRange(m,L,i,s,c.index,c[0]),c,l):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(m,new M.Position(1,1),a,l):null}static _doFindNextMatchLineByLine(m,o,a,l){const g=m.getLineCount(),L=o.lineNumber,_=m.getLineContent(L),i=this._findFirstMatchInLine(a,_,L,o.column,l);if(i)return i;for(let s=1;s<=g;s++){const c=(L+s-1)%g,C=m.getLineContent(c+1),S=this._findFirstMatchInLine(a,C,c+1,1,l);if(S)return S}return null}static _findFirstMatchInLine(m,o,a,l,g){m.reset(l-1);const L=m.next(o);return L?p(new h.Range(a,L.index+1,a,L.index+1+L[0].length),L,g):null}static findPreviousMatch(m,o,a,l){const g=o.parseSearchRequest();if(!g)return null;const L=new y(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(m,a,L,l):this._doFindPreviousMatchLineByLine(m,a,L,l)}static _doFindPreviousMatchMultiline(m,o,a,l){const g=this._doFindMatchesMultiline(m,new h.Range(1,1,o.lineNumber,o.column),a,l,10*d);if(g.length>0)return g[g.length-1];const L=m.getLineCount();return o.lineNumber!==L||o.column!==m.getLineMaxColumn(L)?this._doFindPreviousMatchMultiline(m,new M.Position(L,m.getLineMaxColumn(L)),a,l):null}static _doFindPreviousMatchLineByLine(m,o,a,l){const g=m.getLineCount(),L=o.lineNumber,_=m.getLineContent(L).substring(0,o.column-1),i=this._findLastMatchInLine(a,_,L,l);if(i)return i;for(let s=1;s<=g;s++){const c=(g+L-s-1)%g,C=m.getLineContent(c+1),S=this._findLastMatchInLine(a,C,c+1,l);if(S)return S}return null}static _findLastMatchInLine(m,o,a,l){let g=null,L;for(m.reset(0);L=m.next(o);)g=p(new h.Range(a,L.index+1,a,L.index+1+L[0].length),L,l);return g}}t.TextModelSearch=v;function b(E,m,o,a,l){if(a===0)return!0;const g=m.charCodeAt(a-1);if(E.get(g)!==0||g===13||g===10)return!0;if(l>0){const L=m.charCodeAt(a);if(E.get(L)!==0)return!0}return!1}function e(E,m,o,a,l){if(a+l===o)return!0;const g=m.charCodeAt(a+l);if(E.get(g)!==0||g===13||g===10)return!0;if(l>0){const L=m.charCodeAt(a+l-1);if(E.get(L)!==0)return!0}return!1}function w(E,m,o,a,l){return b(E,m,o,a,l)&&e(E,m,o,a,l)}t.isValidMatch=w;class y{constructor(m,o){this._wordSeparators=m,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(m){this._searchRegex.lastIndex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(m){const o=m.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(a=this._searchRegex.exec(m),!a))return null;const l=a.index,g=a[0].length;if(l===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){D.getNextCodePoint(m,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=g,!this._wordSeparators||w(this._wordSeparators,m,o,l,g))return a}while(a);return null}}t.Searcher=y}),ie(se[47],ae([0,1,6,46,3,9]),function(W,t,D,n,M,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class A{static computeUnicodeHighlights(v,b,e){const w=e?e.startLineNumber:1,y=e?e.endLineNumber:v.getLineCount(),E=new f(b),m=E.getCandidateCodePoints();let o;m==="allNonBasicAscii"?o=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):o=new RegExp(`${d(Array.from(m))}`,"g");const a=new n.Searcher(null,o),l=[];let g=!1,L,_=0,i=0,s=0;e:for(let c=w,C=y;c<=C;c++){const S=v.getLineContent(c),I=S.length;a.reset(0);do if(L=a.next(S),L){let B=L.index,$=L.index+L[0].length;if(B>0){const R=S.charCodeAt(B-1);M.isHighSurrogate(R)&&B--}if($+1<I){const R=S.charCodeAt($-1);M.isHighSurrogate(R)&&$++}const Z=S.substring(B,$),K=E.shouldHighlightNonBasicASCII(Z);if(K!==0){K===3?_++:K===2?i++:K===1?s++:(0,h.assertNever)(K);const R=1e3;if(l.length>=R){g=!0;break e}l.push(new D.Range(c,B+1,c,$+1))}}while(L)}return{ranges:l,hasMore:g,ambiguousCharacterCount:_,invisibleCharacterCount:i,nonBasicAsciiCharacterCount:s}}static computeUnicodeHighlightReason(v,b){const e=new f(b);switch(e.shouldHighlightNonBasicASCII(v)){case 0:return null;case 2:return{kind:1};case 3:{const y=v.codePointAt(0),E=e.ambiguousCharacters.getPrimaryConfusable(y),m=M.AmbiguousCharacters.getLocales().filter(o=>!M.AmbiguousCharacters.getInstance(new Set([...b.allowedLocales,o])).isAmbiguous(y));return{kind:0,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:m}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=A;function d(P,v){return`[${M.escapeRegExpCharacters(P.map(e=>String.fromCodePoint(e)).join(""))}]`}var u;(function(P){P[P.Ambiguous=0]="Ambiguous",P[P.Invisible=1]="Invisible",P[P.NonBasicAscii=2]="NonBasicAscii"})(u=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class f{constructor(v){this.options=v,this.allowedCodePoints=new Set(v.allowedCodePoints),this.ambiguousCharacters=M.AmbiguousCharacters.getInstance(new Set(v.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const v=new Set;if(this.options.invisibleCharacters)for(const b of M.InvisibleCharacters.codePoints)v.add(b);if(this.options.ambiguousCharacters)for(const b of this.ambiguousCharacters.getConfusableCodePoints())v.add(b);for(const b of this.allowedCodePoints)v.delete(b);return v}shouldHighlightNonBasicASCII(v){const b=v.codePointAt(0);return this.allowedCodePoints.has(b)?0:this.options.nonBasicASCII?1:this.options.invisibleCharacters&&!(v===" "||v===`
`||v==="	")&&M.InvisibleCharacters.isInvisibleCharacter(b)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(b)?3:0}}var p;(function(P){P[P.None=0]="None",P[P.NonBasicASCII=1]="NonBasicASCII",P[P.Invisible=2]="Invisible",P[P.Ambiguous=3]="Ambiguous"})(p||(p={}))}),ie(se[48],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var D;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(D=t.AccessibilitySupport||(t.AccessibilitySupport={}));var n;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(n=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var M;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(M=t.CompletionItemKind||(t.CompletionItemKind={}));var h;(function(r){r[r.Deprecated=1]="Deprecated"})(h=t.CompletionItemTag||(t.CompletionItemTag={}));var A;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var d;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(d=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var f;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(f=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var p;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(p=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var P;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(P=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var v;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.emptySelectionClipboard=32]="emptySelectionClipboard",r[r.extraEditorClassName=33]="extraEditorClassName",r[r.fastScrollSensitivity=34]="fastScrollSensitivity",r[r.find=35]="find",r[r.fixedOverflowWidgets=36]="fixedOverflowWidgets",r[r.folding=37]="folding",r[r.foldingStrategy=38]="foldingStrategy",r[r.foldingHighlight=39]="foldingHighlight",r[r.foldingImportsByDefault=40]="foldingImportsByDefault",r[r.foldingMaximumRegions=41]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=43]="fontFamily",r[r.fontInfo=44]="fontInfo",r[r.fontLigatures=45]="fontLigatures",r[r.fontSize=46]="fontSize",r[r.fontWeight=47]="fontWeight",r[r.formatOnPaste=48]="formatOnPaste",r[r.formatOnType=49]="formatOnType",r[r.glyphMargin=50]="glyphMargin",r[r.gotoLocation=51]="gotoLocation",r[r.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",r[r.hover=53]="hover",r[r.inDiffEditor=54]="inDiffEditor",r[r.inlineSuggest=55]="inlineSuggest",r[r.letterSpacing=56]="letterSpacing",r[r.lightbulb=57]="lightbulb",r[r.lineDecorationsWidth=58]="lineDecorationsWidth",r[r.lineHeight=59]="lineHeight",r[r.lineNumbers=60]="lineNumbers",r[r.lineNumbersMinChars=61]="lineNumbersMinChars",r[r.linkedEditing=62]="linkedEditing",r[r.links=63]="links",r[r.matchBrackets=64]="matchBrackets",r[r.minimap=65]="minimap",r[r.mouseStyle=66]="mouseStyle",r[r.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=68]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",r[r.multiCursorModifier=70]="multiCursorModifier",r[r.multiCursorPaste=71]="multiCursorPaste",r[r.occurrencesHighlight=72]="occurrencesHighlight",r[r.overviewRulerBorder=73]="overviewRulerBorder",r[r.overviewRulerLanes=74]="overviewRulerLanes",r[r.padding=75]="padding",r[r.parameterHints=76]="parameterHints",r[r.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",r[r.quickSuggestions=79]="quickSuggestions",r[r.quickSuggestionsDelay=80]="quickSuggestionsDelay",r[r.readOnly=81]="readOnly",r[r.renameOnType=82]="renameOnType",r[r.renderControlCharacters=83]="renderControlCharacters",r[r.renderFinalNewline=84]="renderFinalNewline",r[r.renderLineHighlight=85]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=87]="renderValidationDecorations",r[r.renderWhitespace=88]="renderWhitespace",r[r.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",r[r.roundedSelection=90]="roundedSelection",r[r.rulers=91]="rulers",r[r.scrollbar=92]="scrollbar",r[r.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=94]="scrollBeyondLastLine",r[r.scrollPredominantAxis=95]="scrollPredominantAxis",r[r.selectionClipboard=96]="selectionClipboard",r[r.selectionHighlight=97]="selectionHighlight",r[r.selectOnLineNumbers=98]="selectOnLineNumbers",r[r.showFoldingControls=99]="showFoldingControls",r[r.showUnused=100]="showUnused",r[r.snippetSuggestions=101]="snippetSuggestions",r[r.smartSelect=102]="smartSelect",r[r.smoothScrolling=103]="smoothScrolling",r[r.stickyTabStops=104]="stickyTabStops",r[r.stopRenderingLineAfter=105]="stopRenderingLineAfter",r[r.suggest=106]="suggest",r[r.suggestFontSize=107]="suggestFontSize",r[r.suggestLineHeight=108]="suggestLineHeight",r[r.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",r[r.suggestSelection=110]="suggestSelection",r[r.tabCompletion=111]="tabCompletion",r[r.tabIndex=112]="tabIndex",r[r.unicodeHighlighting=113]="unicodeHighlighting",r[r.unusualLineTerminators=114]="unusualLineTerminators",r[r.useShadowDOM=115]="useShadowDOM",r[r.useTabStops=116]="useTabStops",r[r.wordSeparators=117]="wordSeparators",r[r.wordWrap=118]="wordWrap",r[r.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=121]="wordWrapColumn",r[r.wordWrapOverride1=122]="wordWrapOverride1",r[r.wordWrapOverride2=123]="wordWrapOverride2",r[r.wrappingIndent=124]="wrappingIndent",r[r.wrappingStrategy=125]="wrappingStrategy",r[r.showDeprecated=126]="showDeprecated",r[r.inlayHints=127]="inlayHints",r[r.editorClassName=128]="editorClassName",r[r.pixelRatio=129]="pixelRatio",r[r.tabFocusMode=130]="tabFocusMode",r[r.layoutInfo=131]="layoutInfo",r[r.wrappingInfo=132]="wrappingInfo"})(v=t.EditorOption||(t.EditorOption={}));var b;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(b=t.EndOfLinePreference||(t.EndOfLinePreference={}));var e;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(e=t.EndOfLineSequence||(t.EndOfLineSequence={}));var w;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(w=t.IndentAction||(t.IndentAction={}));var y;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(y=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var E;(function(r){r[r.Other=0]="Other",r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(E=t.InlayHintKind||(t.InlayHintKind={}));var m;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(m=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var o;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.MAX_VALUE=126]="MAX_VALUE"})(o=t.KeyCode||(t.KeyCode={}));var a;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(a=t.MarkerSeverity||(t.MarkerSeverity={}));var l;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(l=t.MarkerTag||(t.MarkerTag={}));var g;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(g=t.MinimapPosition||(t.MinimapPosition={}));var L;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(L=t.MouseTargetType||(t.MouseTargetType={}));var _;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(_=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var i;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(i=t.OverviewRulerLane||(t.OverviewRulerLane={}));var s;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(s=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var c;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(c=t.RenderMinimap||(t.RenderMinimap={}));var C;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(C=t.ScrollType||(t.ScrollType={}));var S;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(S=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var I;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(I=t.SelectionDirection||(t.SelectionDirection={}));var B;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(B=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var $;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})($=t.SymbolKind||(t.SymbolKind={}));var Z;(function(r){r[r.Deprecated=1]="Deprecated"})(Z=t.SymbolTag||(t.SymbolTag={}));var K;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(K=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var R;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(R=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var G;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var oe;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(oe=t.WrappingIndent||(t.WrappingIndent={}))}),ie(se[49],ae([0,1,4,7]),function(W,t,D,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class M{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(d){this._onDidChange.fire({changedLanguages:d,changedColorMap:!1})}register(d,u){return this._map.set(d,u),this.fire([d]),(0,n.toDisposable)(()=>{this._map.get(d)===u&&(this._map.delete(d),this.fire([d]))})}registerFactory(d,u){this._factories.get(d)?.dispose();const f=new h(this,d,u);return this._factories.set(d,f),(0,n.toDisposable)(()=>{const p=this._factories.get(d);!p||p!==f||(this._factories.delete(d),p.dispose())})}async getOrCreate(d){const u=this.get(d);if(u)return u;const f=this._factories.get(d);return!f||f.isResolved?null:(await f.resolve(),this.get(d))}get(d){return this._map.get(d)||null}isResolved(d){if(this.get(d))return!0;const f=this._factories.get(d);return!!(!f||f.isResolved)}setColorMap(d){this._colorMap=d,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=M;class h extends n.Disposable{constructor(d,u,f){super();this._registry=d,this._languageId=u,this._factory=f,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const d=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,d&&!this._isDisposed&&this._register(this._registry.register(this._languageId,d))}}}),ie(se[50],ae([0,1,10,6,43,49,21]),function(W,t,D,n,M,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.DocumentRangeSemanticTokensProviderRegistry=t.DocumentSemanticTokensProviderRegistry=t.FoldingRangeProviderRegistry=t.SelectionRangeRegistry=t.ColorProviderRegistry=t.LinkProviderRegistry=t.OnTypeFormattingEditProviderRegistry=t.DocumentRangeFormattingEditProviderRegistry=t.DocumentFormattingEditProviderRegistry=t.CodeActionProviderRegistry=t.InlayHintsProviderRegistry=t.CodeLensProviderRegistry=t.TypeDefinitionProviderRegistry=t.ImplementationProviderRegistry=t.DeclarationProviderRegistry=t.DefinitionProviderRegistry=t.LinkedEditingRangeProviderRegistry=t.DocumentHighlightProviderRegistry=t.DocumentSymbolProviderRegistry=t.InlineValuesProviderRegistry=t.EvaluatableExpressionProviderRegistry=t.HoverProviderRegistry=t.SignatureHelpProviderRegistry=t.InlineCompletionsProviderRegistry=t.CompletionProviderRegistry=t.RenameProviderRegistry=t.ReferenceProviderRegistry=t.InlayHintKind=t.CommentMode=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=t.TokenMetadata=t.MetadataConsts=t.StandardTokenType=t.ColorId=t.FontStyle=t.LanguageId=void 0;var d;(function(R){R[R.Null=0]="Null",R[R.PlainText=1]="PlainText"})(d=t.LanguageId||(t.LanguageId={}));var u;(function(R){R[R.NotSet=-1]="NotSet",R[R.None=0]="None",R[R.Italic=1]="Italic",R[R.Bold=2]="Bold",R[R.Underline=4]="Underline",R[R.Strikethrough=8]="Strikethrough"})(u=t.FontStyle||(t.FontStyle={}));var f;(function(R){R[R.None=0]="None",R[R.DefaultForeground=1]="DefaultForeground",R[R.DefaultBackground=2]="DefaultBackground"})(f=t.ColorId||(t.ColorId={}));var p;(function(R){R[R.Other=0]="Other",R[R.Comment=1]="Comment",R[R.String=2]="String",R[R.RegEx=3]="RegEx"})(p=t.StandardTokenType||(t.StandardTokenType={}));var P;(function(R){R[R.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",R[R.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",R[R.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",R[R.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",R[R.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",R[R.ITALIC_MASK=1024]="ITALIC_MASK",R[R.BOLD_MASK=2048]="BOLD_MASK",R[R.UNDERLINE_MASK=4096]="UNDERLINE_MASK",R[R.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",R[R.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",R[R.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",R[R.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",R[R.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",R[R.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",R[R.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",R[R.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",R[R.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",R[R.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",R[R.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",R[R.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(P=t.MetadataConsts||(t.MetadataConsts={}));class v{static getLanguageId(G){return(G&255)>>>0}static getTokenType(G){return(G&768)>>>8}static getFontStyle(G){return(G&15360)>>>10}static getForeground(G){return(G&8372224)>>>14}static getBackground(G){return(G&4286578688)>>>23}static getClassNameFromMetadata(G){const oe=this.getForeground(G);let r="mtk"+oe;const x=this.getFontStyle(G);return x&1&&(r+=" mtki"),x&2&&(r+=" mtkb"),x&4&&(r+=" mtku"),x&8&&(r+=" mtks"),r}static getInlineStyleFromMetadata(G,oe){const r=this.getForeground(G),x=this.getFontStyle(G);let ce=`color: ${oe[r]};`;x&1&&(ce+="font-style: italic;"),x&2&&(ce+="font-weight: bold;");let ne="";return x&4&&(ne+=" underline"),x&8&&(ne+=" line-through"),ne&&(ce+=`text-decoration:${ne};`),ce}static getPresentationFromMetadata(G){const oe=this.getForeground(G),r=this.getFontStyle(G);return{foreground:oe,italic:Boolean(r&1),bold:Boolean(r&2),underline:Boolean(r&4),strikethrough:Boolean(r&8)}}}t.TokenMetadata=v;class b{constructor(G,oe,r){this._tokenBrand=void 0,this.offset=G,this.type=oe,this.language=r}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=b;class e{constructor(G,oe){this._tokenizationResultBrand=void 0,this.tokens=G,this.endState=oe}}t.TokenizationResult=e;class w{constructor(G,oe){this._encodedTokenizationResultBrand=void 0,this.tokens=G,this.endState=oe}}t.EncodedTokenizationResult=w;var y;(function(R){R[R.Method=0]="Method",R[R.Function=1]="Function",R[R.Constructor=2]="Constructor",R[R.Field=3]="Field",R[R.Variable=4]="Variable",R[R.Class=5]="Class",R[R.Struct=6]="Struct",R[R.Interface=7]="Interface",R[R.Module=8]="Module",R[R.Property=9]="Property",R[R.Event=10]="Event",R[R.Operator=11]="Operator",R[R.Unit=12]="Unit",R[R.Value=13]="Value",R[R.Constant=14]="Constant",R[R.Enum=15]="Enum",R[R.EnumMember=16]="EnumMember",R[R.Keyword=17]="Keyword",R[R.Text=18]="Text",R[R.Color=19]="Color",R[R.File=20]="File",R[R.Reference=21]="Reference",R[R.Customcolor=22]="Customcolor",R[R.Folder=23]="Folder",R[R.TypeParameter=24]="TypeParameter",R[R.User=25]="User",R[R.Issue=26]="Issue",R[R.Snippet=27]="Snippet"})(y=t.CompletionItemKind||(t.CompletionItemKind={}));var E;(function(R){const G=new Map;G.set(0,A.Codicon.symbolMethod),G.set(1,A.Codicon.symbolFunction),G.set(2,A.Codicon.symbolConstructor),G.set(3,A.Codicon.symbolField),G.set(4,A.Codicon.symbolVariable),G.set(5,A.Codicon.symbolClass),G.set(6,A.Codicon.symbolStruct),G.set(7,A.Codicon.symbolInterface),G.set(8,A.Codicon.symbolModule),G.set(9,A.Codicon.symbolProperty),G.set(10,A.Codicon.symbolEvent),G.set(11,A.Codicon.symbolOperator),G.set(12,A.Codicon.symbolUnit),G.set(13,A.Codicon.symbolValue),G.set(15,A.Codicon.symbolEnum),G.set(14,A.Codicon.symbolConstant),G.set(15,A.Codicon.symbolEnum),G.set(16,A.Codicon.symbolEnumMember),G.set(17,A.Codicon.symbolKeyword),G.set(27,A.Codicon.symbolSnippet),G.set(18,A.Codicon.symbolText),G.set(19,A.Codicon.symbolColor),G.set(20,A.Codicon.symbolFile),G.set(21,A.Codicon.symbolReference),G.set(22,A.Codicon.symbolCustomColor),G.set(23,A.Codicon.symbolFolder),G.set(24,A.Codicon.symbolTypeParameter),G.set(25,A.Codicon.account),G.set(26,A.Codicon.issues);function oe(ce){let ne=G.get(ce);return ne||(console.info("No codicon found for CompletionItemKind "+ce),ne=A.Codicon.symbolProperty),ne}R.toIcon=oe;const r=new Map;r.set("method",0),r.set("function",1),r.set("constructor",2),r.set("field",3),r.set("variable",4),r.set("class",5),r.set("struct",6),r.set("interface",7),r.set("module",8),r.set("property",9),r.set("event",10),r.set("operator",11),r.set("unit",12),r.set("value",13),r.set("constant",14),r.set("enum",15),r.set("enum-member",16),r.set("enumMember",16),r.set("keyword",17),r.set("snippet",27),r.set("text",18),r.set("color",19),r.set("file",20),r.set("reference",21),r.set("customcolor",22),r.set("folder",23),r.set("type-parameter",24),r.set("typeParameter",24),r.set("account",25),r.set("issue",26);function x(ce,ne){let V=r.get(ce);return typeof V=="undefined"&&!ne&&(V=9),V}R.fromString=x})(E=t.CompletionItemKinds||(t.CompletionItemKinds={}));var m;(function(R){R[R.Deprecated=1]="Deprecated"})(m=t.CompletionItemTag||(t.CompletionItemTag={}));var o;(function(R){R[R.KeepWhitespace=1]="KeepWhitespace",R[R.InsertAsSnippet=4]="InsertAsSnippet"})(o=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var a;(function(R){R[R.Invoke=0]="Invoke",R[R.TriggerCharacter=1]="TriggerCharacter",R[R.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var l;(function(R){R[R.Automatic=0]="Automatic",R[R.Explicit=1]="Explicit"})(l=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var g;(function(R){R[R.Invoke=1]="Invoke",R[R.Auto=2]="Auto"})(g=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var L;(function(R){R[R.Invoke=1]="Invoke",R[R.TriggerCharacter=2]="TriggerCharacter",R[R.ContentChange=3]="ContentChange"})(L=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var _;(function(R){R[R.Text=0]="Text",R[R.Read=1]="Read",R[R.Write=2]="Write"})(_=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));function i(R){return R&&D.URI.isUri(R.uri)&&n.Range.isIRange(R.range)&&(n.Range.isIRange(R.originSelectionRange)||n.Range.isIRange(R.targetSelectionRange))}t.isLocationLink=i;var s;(function(R){R[R.File=0]="File",R[R.Module=1]="Module",R[R.Namespace=2]="Namespace",R[R.Package=3]="Package",R[R.Class=4]="Class",R[R.Method=5]="Method",R[R.Property=6]="Property",R[R.Field=7]="Field",R[R.Constructor=8]="Constructor",R[R.Enum=9]="Enum",R[R.Interface=10]="Interface",R[R.Function=11]="Function",R[R.Variable=12]="Variable",R[R.Constant=13]="Constant",R[R.String=14]="String",R[R.Number=15]="Number",R[R.Boolean=16]="Boolean",R[R.Array=17]="Array",R[R.Object=18]="Object",R[R.Key=19]="Key",R[R.Null=20]="Null",R[R.EnumMember=21]="EnumMember",R[R.Struct=22]="Struct",R[R.Event=23]="Event",R[R.Operator=24]="Operator",R[R.TypeParameter=25]="TypeParameter"})(s=t.SymbolKind||(t.SymbolKind={}));var c;(function(R){R[R.Deprecated=1]="Deprecated"})(c=t.SymbolTag||(t.SymbolTag={}));var C;(function(R){const G=new Map;G.set(0,A.Codicon.symbolFile),G.set(1,A.Codicon.symbolModule),G.set(2,A.Codicon.symbolNamespace),G.set(3,A.Codicon.symbolPackage),G.set(4,A.Codicon.symbolClass),G.set(5,A.Codicon.symbolMethod),G.set(6,A.Codicon.symbolProperty),G.set(7,A.Codicon.symbolField),G.set(8,A.Codicon.symbolConstructor),G.set(9,A.Codicon.symbolEnum),G.set(10,A.Codicon.symbolInterface),G.set(11,A.Codicon.symbolFunction),G.set(12,A.Codicon.symbolVariable),G.set(13,A.Codicon.symbolConstant),G.set(14,A.Codicon.symbolString),G.set(15,A.Codicon.symbolNumber),G.set(16,A.Codicon.symbolBoolean),G.set(17,A.Codicon.symbolArray),G.set(18,A.Codicon.symbolObject),G.set(19,A.Codicon.symbolKey),G.set(20,A.Codicon.symbolNull),G.set(21,A.Codicon.symbolEnumMember),G.set(22,A.Codicon.symbolStruct),G.set(23,A.Codicon.symbolEvent),G.set(24,A.Codicon.symbolOperator),G.set(25,A.Codicon.symbolTypeParameter);function oe(r){let x=G.get(r);return x||(console.info("No codicon found for SymbolKind "+r),x=A.Codicon.symbolProperty),x}R.toIcon=oe})(C=t.SymbolKinds||(t.SymbolKinds={}));class S{constructor(G){this.value=G}}t.FoldingRangeKind=S,S.Comment=new S("comment"),S.Imports=new S("imports"),S.Region=new S("region");var I;(function(R){function G(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}R.is=G})(I=t.Command||(t.Command={}));var B;(function(R){R[R.Collapsed=0]="Collapsed",R[R.Expanded=1]="Expanded"})(B=t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={}));var $;(function(R){R[R.Editing=0]="Editing",R[R.Preview=1]="Preview"})($=t.CommentMode||(t.CommentMode={}));var Z;(function(R){R[R.Other=0]="Other",R[R.Type=1]="Type",R[R.Parameter=2]="Parameter"})(Z=t.InlayHintKind||(t.InlayHintKind={})),t.ReferenceProviderRegistry=new M.LanguageFeatureRegistry,t.RenameProviderRegistry=new M.LanguageFeatureRegistry,t.CompletionProviderRegistry=new M.LanguageFeatureRegistry,t.InlineCompletionsProviderRegistry=new M.LanguageFeatureRegistry,t.SignatureHelpProviderRegistry=new M.LanguageFeatureRegistry,t.HoverProviderRegistry=new M.LanguageFeatureRegistry,t.EvaluatableExpressionProviderRegistry=new M.LanguageFeatureRegistry,t.InlineValuesProviderRegistry=new M.LanguageFeatureRegistry,t.DocumentSymbolProviderRegistry=new M.LanguageFeatureRegistry,t.DocumentHighlightProviderRegistry=new M.LanguageFeatureRegistry,t.LinkedEditingRangeProviderRegistry=new M.LanguageFeatureRegistry,t.DefinitionProviderRegistry=new M.LanguageFeatureRegistry,t.DeclarationProviderRegistry=new M.LanguageFeatureRegistry,t.ImplementationProviderRegistry=new M.LanguageFeatureRegistry,t.TypeDefinitionProviderRegistry=new M.LanguageFeatureRegistry,t.CodeLensProviderRegistry=new M.LanguageFeatureRegistry,t.InlayHintsProviderRegistry=new M.LanguageFeatureRegistry,t.CodeActionProviderRegistry=new M.LanguageFeatureRegistry,t.DocumentFormattingEditProviderRegistry=new M.LanguageFeatureRegistry,t.DocumentRangeFormattingEditProviderRegistry=new M.LanguageFeatureRegistry,t.OnTypeFormattingEditProviderRegistry=new M.LanguageFeatureRegistry,t.LinkProviderRegistry=new M.LanguageFeatureRegistry,t.ColorProviderRegistry=new M.LanguageFeatureRegistry,t.SelectionRangeRegistry=new M.LanguageFeatureRegistry,t.FoldingRangeProviderRegistry=new M.LanguageFeatureRegistry,t.DocumentSemanticTokensProviderRegistry=new M.LanguageFeatureRegistry,t.DocumentRangeSemanticTokensProviderRegistry=new M.LanguageFeatureRegistry,t.TokenizationRegistry=new h.TokenizationRegistry;var K;(function(R){R[R.None=0]="None",R[R.Option=1]="Option",R[R.Default=2]="Default",R[R.Preferred=3]="Preferred"})(K=t.ExternalUriOpenerPriority||(t.ExternalUriOpenerPriority={}))}),ie(se[51],ae([0,1,12,4,24,10,5,6,36,50,48]),function(W,t,D,n,M,h,A,d,u,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class P{static chord(e,w){return(0,M.KeyChord)(e,w)}}t.KeyMod=P,P.CtrlCmd=2048,P.Shift=1024,P.Alt=512,P.WinCtrl=256;function v(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.CancellationTokenSource,Emitter:n.Emitter,KeyCode:p.KeyCode,KeyMod:P,Position:A.Position,Range:d.Range,Selection:u.Selection,SelectionDirection:p.SelectionDirection,MarkerSeverity:p.MarkerSeverity,MarkerTag:p.MarkerTag,Uri:h.URI,Token:f.Token}}t.createMonacoBaseAPI=v}),ie(se[53],ae([0,1,16,2,10,5,6,39,45,38,41,42,51,9,15,47]),function(W,t,D,n,M,h,A,d,u,f,p,P,v,b,e,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=t.MirrorModel=void 0;class y extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(a){return this._lines[a-1]}getWordAtPosition(a,l){const g=(0,f.getWordAtText)(a.column,(0,f.ensureValidWordDefinition)(l),this._lines[a.lineNumber-1],0);return g?new A.Range(a.lineNumber,g.startColumn,a.lineNumber,g.endColumn):null}getWordUntilPosition(a,l){const g=this.getWordAtPosition(a,l);return g?{word:this._lines[a.lineNumber-1].substring(g.startColumn-1,a.column-1),startColumn:g.startColumn,endColumn:a.column}:{word:"",startColumn:a.column,endColumn:a.column}}words(a){const l=this._lines,g=this._wordenize.bind(this);let L=0,_="",i=0,s=[];return{*[Symbol.iterator](){for(;;)if(i<s.length){const c=_.substring(s[i].start,s[i].end);i+=1,yield c}else if(L<l.length)_=l[L],s=g(_,a),i=0,L+=1;else break}}}getLineWords(a,l){const g=this._lines[a-1],L=this._wordenize(g,l),_=[];for(const i of L)_.push({word:g.substring(i.start,i.end),startColumn:i.start+1,endColumn:i.end+1});return _}_wordenize(a,l){const g=[];let L;for(l.lastIndex=0;(L=l.exec(a))&&L[0].length!==0;)g.push({start:L.index,end:L.index+L[0].length});return g}getValueInRange(a){if(a=this._validateRange(a),a.startLineNumber===a.endLineNumber)return this._lines[a.startLineNumber-1].substring(a.startColumn-1,a.endColumn-1);const l=this._eol,g=a.startLineNumber-1,L=a.endLineNumber-1,_=[];_.push(this._lines[g].substring(a.startColumn-1));for(let i=g+1;i<L;i++)_.push(this._lines[i]);return _.push(this._lines[L].substring(0,a.endColumn-1)),_.join(l)}offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.lineNumber-2)+(a.column-1)}positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(a),g=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,g)}}_validateRange(a){const l=this._validatePosition({lineNumber:a.startLineNumber,column:a.startColumn}),g=this._validatePosition({lineNumber:a.endLineNumber,column:a.endColumn});return l.lineNumber!==a.startLineNumber||l.column!==a.startColumn||g.lineNumber!==a.endLineNumber||g.column!==a.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:g.lineNumber,endColumn:g.column}:a}_validatePosition(a){if(!h.Position.isIPosition(a))throw new Error("bad position");let{lineNumber:l,column:g}=a,L=!1;if(l<1)l=1,g=1,L=!0;else if(l>this._lines.length)l=this._lines.length,g=this._lines[l-1].length+1,L=!0;else{const _=this._lines[l-1].length+1;g<1?(g=1,L=!0):g>_&&(g=_,L=!0)}return L?{lineNumber:l,column:g}:a}}t.MirrorModel=y;class E{constructor(a,l){this._host=a,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(a){return this._models[a]}_getModels(){const a=[];return Object.keys(this._models).forEach(l=>a.push(this._models[l])),a}acceptNewModel(a){this._models[a.url]=new y(M.URI.parse(a.url),a.lines,a.EOL,a.versionId)}acceptModelChanged(a,l){if(!this._models[a])return;this._models[a].onEvents(l)}acceptRemovedModel(a){!this._models[a]||delete this._models[a]}async computeUnicodeHighlights(a,l,g){const L=this._getModel(a);return L?w.UnicodeTextModelHighlighter.computeUnicodeHighlights(L,l,g):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(a,l,g,L){const _=this._getModel(a),i=this._getModel(l);if(!_||!i)return null;const s=_.getLinesContent(),c=i.getLinesContent(),S=new d.DiffComputer(s,c,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:g,shouldMakePrettyDiff:!0,maxComputationTime:L}).computeDiff(),I=S.changes.length>0?!1:this._modelsAreIdentical(_,i);return{quitEarly:S.quitEarly,identical:I,changes:S.changes}}_modelsAreIdentical(a,l){const g=a.getLineCount(),L=l.getLineCount();if(g!==L)return!1;for(let _=1;_<=g;_++){const i=a.getLineContent(_),s=l.getLineContent(_);if(i!==s)return!1}return!0}async computeDirtyDiff(a,l,g){const L=this._getModel(a),_=this._getModel(l);if(!L||!_)return null;const i=L.getLinesContent(),s=_.getLinesContent();return new d.DiffComputer(i,s,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:g,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(a,l){const g=this._getModel(a);if(!g)return l;const L=[];let _;l=l.slice(0).sort((i,s)=>{if(i.range&&s.range)return A.Range.compareRangesUsingStarts(i.range,s.range);const c=i.range?0:1,C=s.range?0:1;return c-C});for(let{range:i,text:s,eol:c}of l){if(typeof c=="number"&&(_=c),A.Range.isEmpty(i)&&!s)continue;const C=g.getValueInRange(i);if(s=s.replace(/\r\n|\n|\r/g,g.eol),C===s)continue;if(Math.max(s.length,C.length)>E._diffLimit){L.push({range:i,text:s});continue}const S=(0,D.stringDiff)(C,s,!1),I=g.offsetAt(A.Range.lift(i).getStartPosition());for(const B of S){const $=g.positionAt(I+B.originalStart),Z=g.positionAt(I+B.originalStart+B.originalLength),K={text:s.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:$.lineNumber,startColumn:$.column,endLineNumber:Z.lineNumber,endColumn:Z.column}};g.getValueInRange(K.range)!==K.text&&L.push(K)}}return typeof _=="number"&&L.push({eol:_,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(a){const l=this._getModel(a);return l?(0,p.computeLinks)(l):null}async textualSuggest(a,l,g,L){const _=new e.StopWatch(!0),i=new RegExp(g,L),s=new Set;e:for(let c of a){const C=this._getModel(c);if(!!C){for(let S of C.words(i))if(!(S===l||!isNaN(Number(S)))&&(s.add(S),s.size>E._suggestionsLimit))break e}}return{words:Array.from(s),duration:_.elapsed()}}async computeWordRanges(a,l,g,L){const _=this._getModel(a);if(!_)return Object.create(null);const i=new RegExp(g,L),s=Object.create(null);for(let c=l.startLineNumber;c<l.endLineNumber;c++){const C=_.getLineWords(c,i);for(const S of C){if(!isNaN(Number(S.word)))continue;let I=s[S.word];I||(I=[],s[S.word]=I),I.push({startLineNumber:c,startColumn:S.startColumn,endLineNumber:c,endColumn:S.endColumn})}}return s}async navigateValueSet(a,l,g,L,_){const i=this._getModel(a);if(!i)return null;const s=new RegExp(L,_);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const c=i.getValueInRange(l),C=i.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},s);if(!C)return null;const S=i.getValueInRange(C);return P.BasicInplaceReplace.INSTANCE.navigateValueSet(l,c,C,S,g)}loadForeignModule(a,l,g){const L=(s,c)=>this._host.fhr(s,c),i={host:b.createProxyObject(g,L),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(i,l),Promise.resolve(b.getAllMethodNames(this._foreignModule))):new Promise((s,c)=>{W([a],C=>{this._foreignModule=C.create(i,l),s(b.getAllMethodNames(this._foreignModule))},c)})}fmr(a,l){if(!this._foreignModule||typeof this._foreignModule[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._foreignModule[a].apply(this._foreignModule,l))}catch(g){return Promise.reject(g)}}}t.EditorSimpleWorker=E,E._diffLimit=1e5,E._suggestionsLimit=1e4;function m(o){return new E(o,null)}t.create=m,typeof importScripts=="function"&&(n.globals.monaco=(0,v.createMonacoBaseAPI)())}),function(){const W=self.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../",D=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:u=>u,createScript:(u,...f)=>{const p=f.slice(0,-1).join(","),P=f.pop().toString();return`(function anonymous(${p}) {
${P}
})`}}):void 0;function n(){try{return(D?self.eval(D.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function M(){return new Promise((u,f)=>{if(typeof self.define=="function"&&self.define.amd)return u();const p=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin)&&n()){fetch(p).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${p}`,(D?self.eval(D.createScript("",v)):new Function(v)).call(self),u()}).then(void 0,f);return}D?importScripts(D.createScriptURL(p)):importScripts(p),u()})}const h=function(u){M().then(()=>{require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//}),require([u],function(f){setTimeout(function(){let p=f.create((P,v)=>{self.postMessage(P,v)},null);for(self.onmessage=P=>p.onmessage(P.data,P.ports);d.length>0;)self.onmessage(d.shift())},0)})})};let A=!0,d=[];self.onmessage=u=>{if(!A){d.push(u);return}A=!1,h(u.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36c1f3bd16fce1c215b23e577a080f7f63755fcc/core/vs/base/worker/workerMain.js.map
