/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","os","vs/platform/workspaces/common/workspaces","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/credentials/node/credentialsMainService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],x=function(V){for(var e=[],p=0,n=V.length;p<n;p++)e[p]=Z[V[p]];return e};define(Z[104],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(Z[105],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function p(M){return M?M.replace(/\$\((.*?)\)/g,(E,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=p;class n{constructor(E,g,y){this.id=E,this.definition=g,this.description=y,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(M,E){const g=["codicon","codicon-"+M];return E&&g.push("codicon-modifier-"+E),g}e.getClassNamesArray=D;var C;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(P){if(P instanceof n)return["codicon","codicon-"+P.id];const S=E.exec(P.id);if(!S)return g(n.error);let[,w,t]=S;const d=["codicon","codicon-"+w];return t&&d.push("codicon-modifier-"+t.substr(1)),d}M.asClassNameArray=g;function y(P){return g(P).join(" ")}M.asClassName=y;function b(P){return"."+g(P).join(".")}M.asCSSSelector=b})(C=e.CSSIcon||(e.CSSIcon={}))}),define(Z[46],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(M){return(E,g,y)=>{let b=null,P=null;if(typeof y.value=="function"?(b="value",P=y.value):typeof y.get=="function"&&(b="get",P=y.get),!P)throw new Error("not supported");y[b]=M(P,g)}}e.createDecorator=p;function n(M,E,g){let y=null,b=null;if(typeof g.value=="function"?(y="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(y="get",b=g.get),!b)throw new Error("not supported");const P=`$memoize$${E}`;g[y]=function(...S){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,S)}),this[P]}}e.memoize=n;function D(M,E,g){return p((y,b)=>{const P=`$debounce$${b}`,S=`$debounce$result$${b}`;return function(...w){this[S]||(this[S]=g?g():void 0),clearTimeout(this[P]),E&&(this[S]=E(this[S],...w),w=[this[S]]),this[P]=setTimeout(()=>{y.apply(this,w),this[S]=g?g():void 0},M)}})}e.debounce=D;function C(M,E,g){return p((y,b)=>{const P=`$throttle$timer$${b}`,S=`$throttle$result$${b}`,w=`$throttle$lastRun$${b}`,t=`$throttle$pending$${b}`;return function(...d){if(this[S]||(this[S]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),E&&(this[S]=E(this[S],...d)),this[t])return;const m=this[w]+M;m<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[S]]),this[S]=g?g():void 0):(this[t]=!0,this[P]=setTimeout(()=>{this[t]=!1,this[w]=Date.now(),y.apply(this,[this[S]]),this[S]=g?g():void 0},m-Date.now()))}})}e.throttle=C}),define(Z[15],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(u=>{u(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=p,e.errorHandler=new p;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function D(c){g(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function C(c){g(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=C;function M(c){if(c instanceof Error){let{name:o,message:u}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:o,message:u,stack:s}}return c}e.transformErrorForSerialization=M;const E="Canceled";function g(c){return c instanceof y?!0:c instanceof Error&&c.name===E&&c.message===E}e.isCancellationError=g;class y extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=y;function b(){const c=new Error(E);return c.name=c.message,c}e.canceled=b;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function w(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function t(c){const o=new Error(`${c} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class m extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=m;class v extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=v;class k extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=k;function l(c){const o=c;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=l;function f(c,o=Object.create(null)){const u=new Error(c);return o.actions&&(u.actions=o.actions),u}e.createErrorWithActions=f}),define(Z[30],x([0,1,15]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(T,A=0){return T[T.length-(1+A)]}e.tail=n;function D(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=D;function C(T,A,O=(N,G)=>N===G){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let N=0,G=T.length;N<G;N++)if(!O(T[N],A[N]))return!1;return!0}e.equals=C;function M(T,A,O){let N=0,G=T.length-1;for(;N<=G;){const ne=(N+G)/2|0,ce=O(T[ne],A);if(ce<0)N=ne+1;else if(ce>0)G=ne-1;else return ne}return-(N+1)}e.binarySearch=M;function E(T,A){let O=0,N=T.length;if(N===0)return 0;for(;O<N;){const G=Math.floor((O+N)/2);A(T[G])?N=G:O=G+1}return O}e.findFirstInSorted=E;function g(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let N=A[Math.floor(A.length*Math.random())],G=[],ne=[],ce=[];for(let ae of A){const re=O(ae,N);re<0?G.push(ae):re>0?ne.push(ae):ce.push(ae)}return T<G.length?g(T,G,O):T<G.length+ce.length?ce[0]:g(T-(G.length+ce.length),ne,O)}e.quickSelect=g;function y(T,A){const O=[];let N;for(const G of T.slice(0).sort(A))!N||A(N[0],G)!==0?(N=[G],O.push(N)):N.push(G);return O}e.groupBy=y;function b(T,A,O){const N=[];function G(ae,re,le){if(re===0&&le.length===0)return;const he=N[N.length-1];he&&he.start+he.deleteCount===ae?(he.deleteCount+=re,he.toInsert.push(...le)):N.push({start:ae,deleteCount:re,toInsert:le})}let ne=0,ce=0;for(;;){if(ne===T.length){G(ne,0,A.slice(ce));break}if(ce===A.length){G(ne,T.length-ne,[]);break}const ae=T[ne],re=A[ce],le=O(ae,re);le===0?(ne+=1,ce+=1):le<0?(G(ne,1,[]),ne+=1):le>0&&(G(ne,0,[re]),ce+=1)}return N}e.sortedDiff=b;function P(T,A,O){const N=b(T,A,O),G=[],ne=[];for(const ce of N)G.push(...T.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:G,added:ne}}e.delta=P;function S(T,A,O){if(O===0)return[];const N=T.slice(0,O).sort(A);return t(T,A,N,O,T.length),N}e.top=S;function w(T,A,O,N,G){return O===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const ae=T.length,re=T.slice(0,O).sort(A);for(let le=O,he=Math.min(O+N,ae);le<ae;le=he,he=Math.min(he+N,ae)){if(le>O&&await new Promise(me=>setTimeout(me)),G&&G.isCancellationRequested)throw(0,p.canceled)();t(T,A,re,le,he)}return re})().then(ne,ce)})}e.topAsync=w;function t(T,A,O,N,G){for(const ne=O.length;N<G;N++){const ce=T[N];if(A(ce,O[ne-1])<0){O.pop();const ae=E(O,re=>A(ce,re)<0);O.splice(ae,0,ce)}}}function d(T){return T.filter(A=>!!A)}e.coalesce=d;function m(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=m;function v(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=v;function k(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=k;function l(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=l;function f(T,A=O=>O){const O=new Set;return T.filter(N=>{const G=A(N);return O.has(G)?!1:(O.add(G),!0)})}e.distinct=f;function c(T){const A=new Set;return O=>{const N=T(O);return A.has(N)?!1:(A.add(N),!0)}}e.uniqueFilter=c;function o(T,A){const O=u(T,A);if(O!==-1)return T[O]}e.findLast=o;function u(T,A){for(let O=T.length-1;O>=0;O--){const N=T[O];if(A(N))return O}return-1}e.lastIndex=u;function s(T,A){return T.length>0?T[0]:A}e.firstOrDefault=s;function i(T,A,O=(N,G)=>N===G){let N=0;for(let G=0,ne=Math.min(T.length,A.length);G<ne&&O(T[G],A[G]);G++)N++;return N}e.commonPrefixLength=i;function r(T){return[].concat(...T)}e.flatten=r;function a(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const N=[];if(O<=A)for(let G=O;G<A;G++)N.push(G);else for(let G=O;G>A;G--)N.push(G);return N}e.range=a;function h(T,A,O){return T.reduce((N,G)=>(N[A(G)]=O?O(G):G,N),Object.create(null))}e.index=h;function I(T,A){return T.push(A),()=>R(T,A)}e.insert=I;function R(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=R;function L(T,A,O){const N=T.slice(0,A),G=T.slice(A);return N.concat(O,G)}e.arrayInsert=L;function W(T,A){let O;if(typeof A=="number"){let N=A;O=()=>{const G=Math.sin(N++)*179426549;return G-Math.floor(G)}}else O=Math.random;for(let N=T.length-1;N>0;N-=1){const G=Math.floor(O()*(N+1)),ne=T[N];T[N]=T[G],T[G]=ne}}e.shuffle=W;function z(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=z;function Q(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=Q;function ie(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ie;function ee(T){return Array.isArray(T)?T:[T]}e.asArray=ee;function q(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=q;function X(T,A){for(const O of T){const N=A(O);if(N!==void 0)return N}}e.mapFind=X;function H(T,A,O){const N=J(T,A),G=T.length,ne=O.length;T.length=G+ne;for(let ce=G-1;ce>=N;ce--)T[ce+ne]=T[ce];for(let ce=0;ce<ne;ce++)T[ce+N]=O[ce]}e.insertInto=H;function j(T,A,O,N){const G=J(T,A),ne=T.splice(G,O);return H(T,G,N),ne}e.splice=j;function J(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function U(T,A){return(O,N)=>A(T(O),T(N))}e.compareBy=U;const B=(T,A)=>T-A;e.numberComparator=B;function K(T,A){if(T.length===0)return;let O=T[0];for(let N=1;N<T.length;N++){const G=T[N];A(G,O)>0&&(O=G)}return O}e.findMaxBy=K;function $(T,A){if(T.length===0)return;let O=T[0];for(let N=1;N<T.length;N++){const G=T[N];A(G,O)>=0&&(O=G)}return O}e.findLastMaxBy=$;function F(T,A){return K(T,(O,N)=>-A(O,N))}e.findMinBy=F;class _{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const N=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,N}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const N=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,N}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=_}),define(Z[43],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(n){const D=this;let C=!1,M;return function(){return C||(C=!0,M=n.apply(D,arguments)),M}}e.once=p}),define(Z[68],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(n){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=D;const C=Object.freeze([]);function M(){return C}n.empty=M;function*E(c){yield c}n.single=E;function g(c){return c||C}n.from=g;function y(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=y;function b(c){return c[Symbol.iterator]().next().value}n.first=b;function P(c,o){for(const u of c)if(o(u))return!0;return!1}n.some=P;function S(c,o){for(const u of c)if(o(u))return u}n.find=S;function*w(c,o){for(const u of c)o(u)&&(yield u)}n.filter=w;function*t(c,o){let u=0;for(const s of c)yield o(s,u++)}n.map=t;function*d(...c){for(const o of c)for(const u of o)yield u}n.concat=d;function*m(c){for(const o of c)for(const u of o)yield u}n.concatNested=m;function v(c,o,u){let s=u;for(const i of c)s=o(s,i);return s}n.reduce=v;function*k(c,o,u=c.length){for(o<0&&(o+=c.length),u<0?u+=c.length:u>c.length&&(u=c.length);o<u;o++)yield c[o]}n.slice=k;function l(c,o=Number.POSITIVE_INFINITY){const u=[];if(o===0)return[u,c];const s=c[Symbol.iterator]();for(let i=0;i<o;i++){const r=s.next();if(r.done)return[u,n.empty()];u.push(r.value)}return[u,{[Symbol.iterator](){return s}}]}n.consume=l;function f(c,o,u=(s,i)=>s===i){const s=c[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const r=s.next(),a=i.next();if(r.done!==a.done)return!1;if(r.done)return!0;if(!u(r.value,a.value))return!1}}n.equals=f})(p=e.Iterable||(e.Iterable={}))}),define(Z[44],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function M(o,u=!1){let s=0,i=o.length,r="",a=0,h=16,I=0;function R(q){let X=0,H=0;for(;X<q;){const j=o.charCodeAt(s);if(j>=48&&j<=57)H=H*16+j-48;else if(j>=65&&j<=70)H=H*16+j-65+10;else if(j>=97&&j<=102)H=H*16+j-97+10;else break;s++,X++}return X<q&&(H=-1),H}function L(q){s=q,r="",a=0,h=16,I=0}function W(){const q=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&y(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&y(o.charCodeAt(s)))for(s++;s<o.length&&y(o.charCodeAt(s));)s++;else return I=3,o.substring(q,s);let X=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&y(o.charCodeAt(s))){for(s++;s<o.length&&y(o.charCodeAt(s));)s++;X=s}else I=3;return o.substring(q,X)}function z(){let q="",X=s;for(;;){if(s>=i){q+=o.substring(X,s),I=2;break}const H=o.charCodeAt(s);if(H===34){q+=o.substring(X,s),s++;break}if(H===92){if(q+=o.substring(X,s),s++,s>=i){I=2;break}switch(o.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const J=R(4);J>=0?q+=String.fromCharCode(J):I=4;break}default:I=5}X=s;continue}if(H>=0&&H<=31)if(g(H)){q+=o.substring(X,s),I=2;break}else I=6;s++}return q}function Q(){if(r="",I=0,a=s,s>=i)return a=i,h=17;let q=o.charCodeAt(s);if(E(q)){do s++,r+=String.fromCharCode(q),q=o.charCodeAt(s);while(E(q));return h=15}if(g(q))return s++,r+=String.fromCharCode(q),q===13&&o.charCodeAt(s)===10&&(s++,r+=`
`),h=14;switch(q){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,r=z(),h=10;case 47:{const X=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<i&&!g(o.charCodeAt(s));)s++;return r=o.substring(X,s),h=12}if(o.charCodeAt(s+1)===42){s+=2;const H=i-1;let j=!1;for(;s<H;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,j=!0;break}s++}return j||(s++,I=1),r=o.substring(X,s),h=13}return r+=String.fromCharCode(q),s++,h=16}case 45:if(r+=String.fromCharCode(q),s++,s===i||!y(o.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=W(),h=11;default:for(;s<i&&ie(q);)s++,q=o.charCodeAt(s);if(a!==s){switch(r=o.substring(a,s),r){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return r+=String.fromCharCode(q),s++,h=16}}function ie(q){if(E(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let q;do q=Q();while(q>=12&&q<=15);return q}return{setPosition:L,getPosition:()=>s,scan:u?ee:Q,getToken:()=>h,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>I}}e.createScanner=M;function E(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function g(o){return o===10||o===13||o===8232||o===8233}function y(o){return o>=48&&o<=57}var b;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(b||(b={}));function P(o,u){const s=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function I(R,L,W,z){a.value=R,a.offset=L,a.length=W,a.type=z,a.colonOffset=void 0,r=a}try{l(o,{onObjectBegin:(R,L)=>{if(u<=R)throw i;r=void 0,h=u>R,s.push("")},onObjectProperty:(R,L,W)=>{if(u<L||(I(R,L,W,"property"),s[s.length-1]=R,u<=L+W))throw i},onObjectEnd:(R,L)=>{if(u<=R)throw i;r=void 0,s.pop()},onArrayBegin:(R,L)=>{if(u<=R)throw i;r=void 0,s.push(0)},onArrayEnd:(R,L)=>{if(u<=R)throw i;r=void 0,s.pop()},onLiteralValue:(R,L,W)=>{if(u<L||(I(R,L,W,c(R)),u<=L+W))throw i},onSeparator:(R,L,W)=>{if(u<=L)throw i;if(R===":"&&r&&r.type==="property")r.colonOffset=L,h=!1,r=void 0;else if(R===","){const z=s[s.length-1];typeof z=="number"?s[s.length-1]=z+1:(h=!0,s[s.length-1]=""),r=void 0}}})}catch(R){if(R!==i)throw R}return{path:s,previousNode:r,isAtPropertyKey:h,matches:R=>{let L=0;for(let W=0;L<R.length&&W<s.length;W++)if(R[L]===s[W]||R[L]==="*")L++;else if(R[L]!=="**")return!1;return L===R.length}}}e.getLocation=P;function S(o,u=[],s=C.DEFAULT){let i=null,r=[];const a=[];function h(R){Array.isArray(r)?r.push(R):i!==null&&(r[i]=R)}return l(o,{onObjectBegin:()=>{const R={};h(R),a.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const R=[];h(R),a.push(r),r=R,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:h,onError:(R,L,W)=>{u.push({error:R,offset:L,length:W})}},s),r[0]}e.parse=S;function w(o,u=[],s=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function a(R){return i.children.push(R),R}l(o,{onObjectBegin:R=>{i=a({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,L,W)=>{i=a({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:L,length:W,parent:i})},onObjectEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onArrayBegin:(R,L)=>{i=a({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onLiteralValue:(R,L,W)=>{a({type:c(R),offset:L,length:W,parent:i,value:R}),r(L+W)},onSeparator:(R,L,W)=>{i.type==="property"&&(R===":"?i.colonOffset=L:R===","&&r(L))},onError:(R,L,W)=>{u.push({error:R,offset:L,length:W})}},s);const I=i.children[0];return I&&delete I.parent,I}e.parseTree=w;function t(o,u){if(!o)return;let s=o;for(let i of u)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===i){s=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function d(o){if(!o.parent||!o.parent.children)return[];const u=d(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;u.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&u.push(s)}return u}e.getNodePath=d;function m(o){switch(o.type){case"array":return o.children.map(m);case"object":{const u=Object.create(null);for(let s of o.children){const i=s.children[1];i&&(u[s.children[0].value]=m(i))}return u}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=m;function v(o,u,s=!1){return u>=o.offset&&u<o.offset+o.length||s&&u===o.offset+o.length}e.contains=v;function k(o,u,s=!1){if(v(o,u,s)){const i=o.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=u;r++){const a=k(i[r],u,s);if(a)return a}return o}}e.findNodeAtOffset=k;function l(o,u,s=C.DEFAULT){const i=M(o,!1);function r(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(_){return _?T=>_(T,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=r(u.onObjectBegin),I=a(u.onObjectProperty),R=r(u.onObjectEnd),L=r(u.onArrayBegin),W=r(u.onArrayEnd),z=a(u.onLiteralValue),Q=a(u.onSeparator),ie=r(u.onComment),ee=a(u.onError),q=s&&s.disallowComments,X=s&&s.allowTrailingComma;function H(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:q||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(_){case 12:case 13:q?j(10):ie();break;case 16:j(1);break;case 15:case 14:break;default:return _}}}function j(_,T=[],A=[]){if(ee(_),T.length+A.length>0){let O=i.getToken();for(;O!==17;){if(T.indexOf(O)!==-1){H();break}else if(A.indexOf(O)!==-1)break;O=H()}}}function J(_){const T=i.getTokenValue();return _?z(T):I(T),H(),!0}function U(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(j(2),_=0)}catch{j(2)}z(_);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return H(),!0}function B(){return i.getToken()!==10?(j(3,[],[2,5]),!1):(J(!1),i.getToken()===6?(Q(":"),H(),F()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function K(){h(),H();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||j(4,[],[]),Q(","),H(),i.getToken()===2&&X)break}else _&&j(6,[],[]);B()||j(4,[],[2,5]),_=!0}return R(),i.getToken()!==2?j(7,[2],[]):H(),!0}function $(){L(),H();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||j(4,[],[]),Q(","),H(),i.getToken()===4&&X)break}else _&&j(6,[],[]);F()||j(4,[],[4,5]),_=!0}return W(),i.getToken()!==4?j(8,[4],[]):H(),!0}function F(){switch(i.getToken()){case 3:return $();case 1:return K();case 10:return J(!0);default:return U()}}return H(),i.getToken()===17?s.allowEmptyContent?!0:(j(4,[],[]),!1):F()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=l;function f(o,u){let s=M(o),i=[],r,a=0,h;do switch(h=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:a!==h&&i.push(o.substring(a,h)),u!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,u)),a=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=f;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[106],x([0,1,44]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(y,b,P){let S,w,t,d,m;if(b){for(d=b.offset,m=d+b.length,t=d;t>0&&!g(y,t-1);)t--;let h=m;for(;h<y.length&&!g(y,h);)h++;w=y.substring(t,h),S=M(w,P)}else w=y,S=0,t=0,d=0,m=y.length;const v=E(P,y);let k=!1,l=0,f;P.insertSpaces?f=C(" ",P.tabSize||4):f="	";const c=(0,p.createScanner)(w,!1);let o=!1;function u(){return v+C(f,S+l)}function s(){let h=c.scan();for(k=!1;h===15||h===14;)k=k||h===14,h=c.scan();return o=h===16||c.getTokenError()!==0,h}const i=[];function r(h,I,R){!o&&I<m&&R>d&&y.substring(I,R)!==h&&i.push({offset:I,length:R-I,content:h})}let a=s();if(a!==17){const h=c.getTokenOffset()+t,I=C(f,S);r(I,t,h)}for(;a!==17;){let h=c.getTokenOffset()+c.getTokenLength()+t,I=s(),R="";for(;!k&&(I===12||I===13);){const W=c.getTokenOffset()+t;r(" ",h,W),h=c.getTokenOffset()+c.getTokenLength()+t,R=I===12?u():"",I=s()}if(I===2)a!==1&&(l--,R=u());else if(I===4)a!==3&&(l--,R=u());else{switch(a){case 3:case 1:l++,R=u();break;case 5:case 12:R=u();break;case 13:k?R=u():R=" ";break;case 6:R=" ";break;case 10:if(I===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?R=" ":I!==5&&I!==17&&(o=!0);break;case 16:o=!0;break}k&&(I===12||I===13)&&(R=u())}const L=c.getTokenOffset()+t;r(R,h,L),a=I}return i}e.format=n;function D(y,b){const P=JSON.stringify(y,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?P.replace(/\r\n|\r|\n/g,b.eol):P}e.toFormattedString=D;function C(y,b){let P="";for(let S=0;S<b;S++)P+=y;return P}function M(y,b){let P=0,S=0;const w=b.tabSize||4;for(;P<y.length;){const t=y.charAt(P);if(t===" ")S++;else if(t==="	")S+=w;else break;P++}return Math.floor(S/w)}function E(y,b){for(let P=0;P<b.length;P++){const S=b.charAt(P);if(S==="\r")return P+1<b.length&&b.charAt(P+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=E;function g(y,b){return`\r
`.indexOf(y.charAt(b))!==-1}e.isEOL=g}),define(Z[107],x([0,1,44,106]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(y,b,P){return C(y,b,void 0,P)}e.removeProperty=D;function C(y,b,P,S,w){const t=b.slice(),d=[],m=(0,p.parseTree)(y,d);let v,k;for(;t.length>0&&(k=t.pop(),v=(0,p.findNodeAtLocation)(m,t),v===void 0&&P!==void 0);)typeof k=="string"?P={[k]:P}:P=[P];if(v)if(v.type==="object"&&typeof k=="string"&&Array.isArray(v.children)){const l=(0,p.findNodeAtLocation)(v,[k]);if(l!==void 0)if(P===void 0){if(!l.parent)throw new Error("Malformed AST");const f=v.children.indexOf(l.parent);let c,o=l.parent.offset+l.parent.length;if(f>0){const u=v.children[f-1];c=u.offset+u.length}else c=v.offset+1,v.children.length>1&&(o=v.children[1].offset);return M(y,{offset:c,length:o-c,content:""},S)}else return M(y,{offset:l.offset,length:l.length,content:JSON.stringify(P)},S);else{if(P===void 0)return[];const f=`${JSON.stringify(k)}: ${JSON.stringify(P)}`,c=w?w(v.children.map(u=>u.children[0].value)):v.children.length;let o;if(c>0){const u=v.children[c-1];o={offset:u.offset+u.length,length:0,content:","+f}}else v.children.length===0?o={offset:v.offset+1,length:0,content:f}:o={offset:v.offset+1,length:0,content:f+","};return M(y,o,S)}}else if(v.type==="array"&&typeof k=="number"&&Array.isArray(v.children))if(P!==void 0){const l=`${JSON.stringify(P)}`;let f;if(v.children.length===0||k===0)f={offset:v.offset+1,length:0,content:v.children.length===0?l:l+","};else{const c=k===-1||k>v.children.length?v.children.length:k,o=v.children[c-1];f={offset:o.offset+o.length,length:0,content:","+l}}return M(y,f,S)}else{const l=k,f=v.children[l];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===l){const o=v.children[l-1],u=o.offset+o.length,s=v.offset+v.length;c={offset:u,length:s-2-u,content:""}}else c={offset:f.offset,length:v.children[l+1].offset-f.offset,content:""};return M(y,c,S)}else throw new Error(`Can not add ${typeof k!="number"?"index":"property"} to parent of type ${v.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return M(y,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(P)},S)}}e.setProperty=C;function M(y,b,P){let S=E(y,b),w=b.offset,t=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;w>0&&!(0,n.isEOL)(S,w-1);)w--;for(;t<S.length&&!(0,n.isEOL)(S,t);)t++}const d=(0,n.format)(S,{offset:w,length:t-w},P);for(let v=d.length-1;v>=0;v--){const k=d[v];S=E(S,k),w=Math.min(w,k.offset),t=Math.max(t,k.offset+k.length),t+=k.content.length-k.length}const m=y.length-(S.length-t)-w;return[{offset:w,length:m,content:S.substring(w,t)}]}e.withFormatting=M;function E(y,b){return y.substring(0,b.offset)+b.content+y.substring(b.offset+b.length)}e.applyEdit=E;function g(y,b){let P=b.slice(0).sort((w,t)=>{const d=w.offset-t.offset;return d===0?w.length-t.length:d}),S=y.length;for(let w=P.length-1;w>=0;w--){let t=P[w];if(t.offset+t.length<=S)y=E(y,t);else throw new Error("Overlapping edit");S=t.offset}return y}e.applyEdits=g}),define(Z[82],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,m){this._keyCodeToStr[d]=m,this._strToKeyCode[m.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const C=new D,M=new D,E=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],y=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>b[t]||0,toEnum:t=>y[t]||0,toString:t=>g[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let m=[],v=[];for(const k of d){const[l,f,c,o,u,s,i,r,a,h]=k;if(v[c]||(v[c]=!0,g[c]=o,y[o]=c,b[o.toLowerCase()]=c,f&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[u]=c))),!m[u]){if(m[u]=!0,!s)throw new Error(`String representation missing for key code ${u} around scan code ${o}`);C.define(u,s),M.define(u,a||s),E.define(u,h||a||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=u),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=u)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(t){function d(c){return C.keyCodeToStr(c)}t.toString=d;function m(c){return C.strToKeyCode(c)}t.fromString=m;function v(c){return M.keyCodeToStr(c)}t.toUserSettingsUS=v;function k(c){return E.keyCodeToStr(c)}t.toUserSettingsGeneral=k;function l(c){return M.strToKeyCode(c)||E.strToKeyCode(c)}t.fromUserSettings=l;function f(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(c)}t.toElectronAccelerator=f})(P=e.KeyCodeUtils||(e.KeyCodeUtils={}));var S;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(S=e.KeyMod||(e.KeyMod={}));function w(t,d){const m=(d&65535)<<16>>>0;return(t|m)>>>0}e.KeyChord=w}),define(Z[59],x([0,1,15]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(n||(n={}));function D(P,S){if(P===0)return null;const w=(P&65535)>>>0,t=(P&4294901760)>>>16;return t!==0?new E([C(w,S),C(t,S)]):new E([C(w,S)])}e.createKeybinding=D;function C(P,S){const w=!!(P&2048),t=!!(P&256),d=S===2?t:w,m=!!(P&1024),v=!!(P&512),k=S===2?w:t,l=P&255;return new M(d,m,v,k,l)}e.createSimpleKeybinding=C;class M{constructor(S,w,t,d,m){this.ctrlKey=S,this.shiftKey=w,this.altKey=t,this.metaKey=d,this.keyCode=m}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.keyCode===S.keyCode}getHashCode(){const S=this.ctrlKey?"1":"0",w=this.shiftKey?"1":"0",t=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${S}${w}${t}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new E([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=M;class E{constructor(S){if(S.length===0)throw(0,p.illegalArgument)("parts");this.parts=S}getHashCode(){let S="";for(let w=0,t=this.parts.length;w<t;w++)w!==0&&(S+=";"),S+=this.parts[w].getHashCode();return S}equals(S){if(S===null||this.parts.length!==S.parts.length)return!1;for(let w=0;w<this.parts.length;w++)if(!this.parts[w].equals(S.parts[w]))return!1;return!0}}e.ChordKeybinding=E;class g{constructor(S,w,t,d,m){this.ctrlKey=S,this.shiftKey=w,this.altKey=t,this.metaKey=d,this.scanCode=m}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=g;class y{constructor(S,w,t,d,m,v){this.ctrlKey=S,this.shiftKey=w,this.altKey=t,this.metaKey=d,this.keyLabel=m,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=y;class b{}e.ResolvedKeybinding=b}),define(Z[108],x([0,1,82,59]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(M){M=M.toLowerCase().trim();let E=!1,g=!1,y=!1,b=!1,P;do P=!1,/^ctrl(\+|\-)/.test(M)&&(E=!0,M=M.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(M)&&(g=!0,M=M.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(M)&&(y=!0,M=M.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(M)&&(b=!0,M=M.substr("meta-".length),P=!0),/^win(\+|\-)/.test(M)&&(b=!0,M=M.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(M)&&(b=!0,M=M.substr("cmd-".length),P=!0);while(P);let S;const w=M.indexOf(" ");return w>0?(S=M.substring(0,w),M=M.substring(w)):(S=M,M=""),{remains:M,ctrl:E,shift:g,alt:y,meta:b,key:S}}static parseSimpleKeybinding(M){const E=this._readModifiers(M),g=p.KeyCodeUtils.fromUserSettings(E.key);return[new n.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,g),E.remains]}static parseKeybinding(M,E){if(!M)return null;const g=[];let y;do[y,M]=this.parseSimpleKeybinding(M),g.push(y);while(M.length>0);return new n.ChordKeybinding(g)}static parseSimpleUserBinding(M){const E=this._readModifiers(M),g=E.key.match(/^\[([^\]]+)\]$/);if(g){const b=g[1],P=p.ScanCodeUtils.lowerCaseToEnum(b);return[new n.ScanCodeBinding(E.ctrl,E.shift,E.alt,E.meta,P),E.remains]}const y=p.KeyCodeUtils.fromUserSettings(E.key);return[new n.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,y),E.remains]}static parseUserBinding(M){if(!M)return[];const E=[];let g;for(;M.length>0;)[g,M]=this.parseSimpleUserBinding(M),E.push(g);return E}}e.KeybindingParser=D}),define(Z[109],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new p(()=>D(this.getValue()))}}e.Lazy=p}),define(Z[2],x([0,1,43,68]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function M(i){C=i}if(e.setDisposableTracker=M,D){const i="__is_disposable_tracked__";M(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==k.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==k.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function E(i){return C?.trackDisposable(i),i}function g(i){C?.markAsDisposed(i)}function y(i,r){C?.setParent(i,r)}function b(i,r){if(!!C)for(const a of i)C.setParent(a,r)}function P(i){return C?.markAsSingleton(i),i}e.markAsSingleton=P;class S extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=S;function w(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=w;function t(i){if(n.Iterable.is(i)){let r=[];for(const a of i)if(a)try{a.dispose()}catch(h){r.push(h)}if(r.length===1)throw r[0];if(r.length>1)throw new S(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function d(...i){const r=m(()=>t(i));return b(i,r),r}e.combinedDisposable=d;function m(i){const r=E({dispose:(0,p.once)(()=>{g(r),i()})});return r}e.toDisposable=m;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return y(r,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class k{constructor(){this._store=new v,E(this),y(this._store,this)}dispose(){g(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=k,k.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&y(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&y(r,null),r}}e.MutableDisposable=l;class f{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.references=new Map}acquire(r,...a){let h=this.references.get(r);h||(h={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,h));const{object:I}=h,R=(0,p.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(r,h.object),this.references.delete(r))});return h.counter++,{object:I,dispose:R}}}e.ReferenceCollection=c;class o{constructor(r){this.referenceCollection=r}async acquire(r,...a){const h=this.referenceCollection.acquire(r,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(I){throw h.dispose(),I}}}e.AsyncReferenceCollection=o;class u{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=u;function s(i){const r=new v;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=s}),define(Z[110],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(C){this.element=C,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class n{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let C=this._first;for(;C!==p.Undefined;){const M=C.next;C.prev=p.Undefined,C.next=p.Undefined,C=M}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,M){const E=new p(C);if(this._first===p.Undefined)this._first=E,this._last=E;else if(M){const y=this._last;this._last=E,E.prev=y,y.next=E}else{const y=this._first;this._first=E,E.next=y,y.prev=E}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(E))}}shift(){if(this._first!==p.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==p.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==p.Undefined&&C.next!==p.Undefined){const M=C.prev;M.next=C.next,C.next.prev=M}else C.prev===p.Undefined&&C.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):C.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):C.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==p.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(){function V(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function M(g){C.push(g,Date.now())}function E(){const g=[];for(let y=0;y<C.length;y+=2)g.push({name:C[y],startTime:C[y+1]});return g}return{mark:M,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const M of performance.getEntriesByType("mark"))C.push({name:M.name,startTime:Math.round(D+M.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=p(n))}(),define(Z[3],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let n=!1,D=!1,C=!1,M=!1,E=!1,g=!1,y=!1,b=!1,P,S=p,w,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string",v=m&&d?.type==="renderer";if(e.isElectronSandboxed=v&&d?.sandboxed,typeof navigator=="object"&&!v)t=navigator.userAgent,n=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,b=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=t.indexOf("Linux")>=0,g=!0,P=navigator.language,S=P;else if(typeof d=="object"){n=d.platform==="win32",D=d.platform==="darwin",C=d.platform==="linux",M=C&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,y=m,P=p,S=p;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),h=a.availableLanguages["*"];P=a.locale,S=h||p,w=a._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var k;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(k=e.Platform||(e.Platform={}));function l(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let f=0;D?f=1:n?f=3:C&&(f=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=M,e.isNative=E,e.isElectron=y,e.isWeb=g,e.isIOS=b,e.platform=f,e.userAgent=t,e.language=S;var c;(function(r){function a(){return e.language}r.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function I(){return e.language==="en"}r.isDefault=I})(c=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=w,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let I=0,R=r.length;I<R;I++){const L=r[I];if(L.id===h.data.vscodeScheduleAsyncWork){r.splice(I,1),L.callback();return}}});let a=0;return h=>{const I=++a;r.push({id:I,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return r=>setTimeout(r)})();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:n?1:3;let u=!0,s=!1;function i(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,u=new Uint16Array(r.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(Z[9],x([0,1,36]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,C=90,M=122,E=46,g=47,y=92,b=58,P=63;class S extends Error{constructor(f,c,o){let u;typeof c=="string"&&c.indexOf("not ")===0?(u="must not be",c=c.replace(/^not /,"")):u="must be";const s=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${s} ${u} of type ${c}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function w(l,f){if(typeof l!="string")throw new S(f,"string",l)}function t(l){return l===g||l===y}function d(l){return l===g}function m(l){return l>=n&&l<=C||l>=D&&l<=M}function v(l,f,c,o){let u="",s=0,i=-1,r=0,a=0;for(let h=0;h<=l.length;++h){if(h<l.length)a=l.charCodeAt(h);else{if(o(a))break;a=g}if(o(a)){if(!(i===h-1||r===1))if(r===2){if(u.length<2||s!==2||u.charCodeAt(u.length-1)!==E||u.charCodeAt(u.length-2)!==E){if(u.length>2){const I=u.lastIndexOf(c);I===-1?(u="",s=0):(u=u.slice(0,I),s=u.length-1-u.lastIndexOf(c)),i=h,r=0;continue}else if(u.length!==0){u="",s=0,i=h,r=0;continue}}f&&(u+=u.length>0?`${c}..`:"..",s=2)}else u.length>0?u+=`${c}${l.slice(i+1,h)}`:u=l.slice(i+1,h),s=h-i-1;i=h,r=0}else a===E&&r!==-1?++r:r=-1}return u}function k(l,f){if(f===null||typeof f!="object")throw new S("pathObject","Object",f);const c=f.dir||f.root,o=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${o}`:`${c}${l}${o}`:o}e.win32={resolve(...l){let f="",c="",o=!1;for(let u=l.length-1;u>=-1;u--){let s;if(u>=0){if(s=l[u],w(s,"path"),s.length===0)continue}else f.length===0?s=p.cwd():(s=p.env[`=${f}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${f}\\`));const i=s.length;let r=0,a="",h=!1;const I=s.charCodeAt(0);if(i===1)t(I)&&(r=1,h=!0);else if(t(I))if(h=!0,t(s.charCodeAt(1))){let R=2,L=R;for(;R<i&&!t(s.charCodeAt(R));)R++;if(R<i&&R!==L){const W=s.slice(L,R);for(L=R;R<i&&t(s.charCodeAt(R));)R++;if(R<i&&R!==L){for(L=R;R<i&&!t(s.charCodeAt(R));)R++;(R===i||R!==L)&&(a=`\\\\${W}\\${s.slice(L,R)}`,r=R)}}}else r=1;else m(I)&&s.charCodeAt(1)===b&&(a=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(h=!0,r=3));if(a.length>0)if(f.length>0){if(a.toLowerCase()!==f.toLowerCase())continue}else f=a;if(o){if(f.length>0)break}else if(c=`${s.slice(r)}\\${c}`,o=h,h&&f.length>0)break}return c=v(c,!o,"\\",t),o?`${f}\\${c}`:`${f}${c}`||"."},normalize(l){w(l,"path");const f=l.length;if(f===0)return".";let c=0,o,u=!1;const s=l.charCodeAt(0);if(f===1)return d(s)?"\\":l;if(t(s))if(u=!0,t(l.charCodeAt(1))){let r=2,a=r;for(;r<f&&!t(l.charCodeAt(r));)r++;if(r<f&&r!==a){const h=l.slice(a,r);for(a=r;r<f&&t(l.charCodeAt(r));)r++;if(r<f&&r!==a){for(a=r;r<f&&!t(l.charCodeAt(r));)r++;if(r===f)return`\\\\${h}\\${l.slice(a)}\\`;r!==a&&(o=`\\\\${h}\\${l.slice(a,r)}`,c=r)}}}else c=1;else m(s)&&l.charCodeAt(1)===b&&(o=l.slice(0,2),c=2,f>2&&t(l.charCodeAt(2))&&(u=!0,c=3));let i=c<f?v(l.slice(c),!u,"\\",t):"";return i.length===0&&!u&&(i="."),i.length>0&&t(l.charCodeAt(f-1))&&(i+="\\"),o===void 0?u?`\\${i}`:i:u?`${o}\\${i}`:`${o}${i}`},isAbsolute(l){w(l,"path");const f=l.length;if(f===0)return!1;const c=l.charCodeAt(0);return t(c)||f>2&&m(c)&&l.charCodeAt(1)===b&&t(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let f,c;for(let s=0;s<l.length;++s){const i=l[s];w(i,"path"),i.length>0&&(f===void 0?f=c=i:f+=`\\${i}`)}if(f===void 0)return".";let o=!0,u=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++u;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++u,s>2&&(t(c.charCodeAt(2))?++u:o=!1))}if(o){for(;u<f.length&&t(f.charCodeAt(u));)u++;u>=2&&(f=`\\${f.slice(u)}`)}return e.win32.normalize(f)},relative(l,f){if(w(l,"from"),w(f,"to"),l===f)return"";const c=e.win32.resolve(l),o=e.win32.resolve(f);if(c===o||(l=c.toLowerCase(),f=o.toLowerCase(),l===f))return"";let u=0;for(;u<l.length&&l.charCodeAt(u)===y;)u++;let s=l.length;for(;s-1>u&&l.charCodeAt(s-1)===y;)s--;const i=s-u;let r=0;for(;r<f.length&&f.charCodeAt(r)===y;)r++;let a=f.length;for(;a-1>r&&f.charCodeAt(a-1)===y;)a--;const h=a-r,I=i<h?i:h;let R=-1,L=0;for(;L<I;L++){const z=l.charCodeAt(u+L);if(z!==f.charCodeAt(r+L))break;z===y&&(R=L)}if(L!==I){if(R===-1)return o}else{if(h>I){if(f.charCodeAt(r+L)===y)return o.slice(r+L+1);if(L===2)return o.slice(r+L)}i>I&&(l.charCodeAt(u+L)===y?R=L:L===2&&(R=3)),R===-1&&(R=0)}let W="";for(L=u+R+1;L<=s;++L)(L===s||l.charCodeAt(L)===y)&&(W+=W.length===0?"..":"\\..");return r+=R,W.length>0?`${W}${o.slice(r,a)}`:(o.charCodeAt(r)===y&&++r,o.slice(r,a))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const f=e.win32.resolve(l);if(f.length<=2)return l;if(f.charCodeAt(0)===y){if(f.charCodeAt(1)===y){const c=f.charCodeAt(2);if(c!==P&&c!==E)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(m(f.charCodeAt(0))&&f.charCodeAt(1)===b&&f.charCodeAt(2)===y)return`\\\\?\\${f}`;return l},dirname(l){w(l,"path");const f=l.length;if(f===0)return".";let c=-1,o=0;const u=l.charCodeAt(0);if(f===1)return t(u)?l:".";if(t(u)){if(c=o=1,t(l.charCodeAt(1))){let r=2,a=r;for(;r<f&&!t(l.charCodeAt(r));)r++;if(r<f&&r!==a){for(a=r;r<f&&t(l.charCodeAt(r));)r++;if(r<f&&r!==a){for(a=r;r<f&&!t(l.charCodeAt(r));)r++;if(r===f)return l;r!==a&&(c=o=r+1)}}}}else m(u)&&l.charCodeAt(1)===b&&(c=f>2&&t(l.charCodeAt(2))?3:2,o=c);let s=-1,i=!0;for(let r=f-1;r>=o;--r)if(t(l.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return l.slice(0,s)},basename(l,f){f!==void 0&&w(f,"ext"),w(l,"path");let c=0,o=-1,u=!0,s;if(l.length>=2&&m(l.charCodeAt(0))&&l.charCodeAt(1)===b&&(c=2),f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,r=-1;for(s=l.length-1;s>=c;--s){const a=l.charCodeAt(s);if(t(a)){if(!u){c=s+1;break}}else r===-1&&(u=!1,r=s+1),i>=0&&(a===f.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=l.length),l.slice(c,o)}for(s=l.length-1;s>=c;--s)if(t(l.charCodeAt(s))){if(!u){c=s+1;break}}else o===-1&&(u=!1,o=s+1);return o===-1?"":l.slice(c,o)},extname(l){w(l,"path");let f=0,c=-1,o=0,u=-1,s=!0,i=0;l.length>=2&&l.charCodeAt(1)===b&&m(l.charCodeAt(0))&&(f=o=2);for(let r=l.length-1;r>=f;--r){const a=l.charCodeAt(r);if(t(a)){if(!s){o=r+1;break}continue}u===-1&&(s=!1,u=r+1),a===E?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||u===-1||i===0||i===1&&c===u-1&&c===o+1?"":l.slice(c,u)},format:k.bind(null,"\\"),parse(l){w(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const c=l.length;let o=0,u=l.charCodeAt(0);if(c===1)return t(u)?(f.root=f.dir=l,f):(f.base=f.name=l,f);if(t(u)){if(o=1,t(l.charCodeAt(1))){let R=2,L=R;for(;R<c&&!t(l.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&t(l.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&!t(l.charCodeAt(R));)R++;R===c?o=R:R!==L&&(o=R+1)}}}}else if(m(u)&&l.charCodeAt(1)===b){if(c<=2)return f.root=f.dir=l,f;if(o=2,t(l.charCodeAt(2))){if(c===3)return f.root=f.dir=l,f;o=3}}o>0&&(f.root=l.slice(0,o));let s=-1,i=o,r=-1,a=!0,h=l.length-1,I=0;for(;h>=o;--h){if(u=l.charCodeAt(h),t(u)){if(!a){i=h+1;break}continue}r===-1&&(a=!1,r=h+1),u===E?s===-1?s=h:I!==1&&(I=1):s!==-1&&(I=-1)}return r!==-1&&(s===-1||I===0||I===1&&s===r-1&&s===i+1?f.base=f.name=l.slice(i,r):(f.name=l.slice(i,s),f.base=l.slice(i,r),f.ext=l.slice(s,r))),i>0&&i!==o?f.dir=l.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let f="",c=!1;for(let o=l.length-1;o>=-1&&!c;o--){const u=o>=0?l[o]:p.cwd();w(u,"path"),u.length!==0&&(f=`${u}/${f}`,c=u.charCodeAt(0)===g)}return f=v(f,!c,"/",d),c?`/${f}`:f.length>0?f:"."},normalize(l){if(w(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===g,c=l.charCodeAt(l.length-1)===g;return l=v(l,!f,"/",d),l.length===0?f?"/":c?"./":".":(c&&(l+="/"),f?`/${l}`:l)},isAbsolute(l){return w(l,"path"),l.length>0&&l.charCodeAt(0)===g},join(...l){if(l.length===0)return".";let f;for(let c=0;c<l.length;++c){const o=l[c];w(o,"path"),o.length>0&&(f===void 0?f=o:f+=`/${o}`)}return f===void 0?".":e.posix.normalize(f)},relative(l,f){if(w(l,"from"),w(f,"to"),l===f||(l=e.posix.resolve(l),f=e.posix.resolve(f),l===f))return"";const c=1,o=l.length,u=o-c,s=1,i=f.length-s,r=u<i?u:i;let a=-1,h=0;for(;h<r;h++){const R=l.charCodeAt(c+h);if(R!==f.charCodeAt(s+h))break;R===g&&(a=h)}if(h===r)if(i>r){if(f.charCodeAt(s+h)===g)return f.slice(s+h+1);if(h===0)return f.slice(s+h)}else u>r&&(l.charCodeAt(c+h)===g?a=h:h===0&&(a=0));let I="";for(h=c+a+1;h<=o;++h)(h===o||l.charCodeAt(h)===g)&&(I+=I.length===0?"..":"/..");return`${I}${f.slice(s+a)}`},toNamespacedPath(l){return l},dirname(l){if(w(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===g;let c=-1,o=!0;for(let u=l.length-1;u>=1;--u)if(l.charCodeAt(u)===g){if(!o){c=u;break}}else o=!1;return c===-1?f?"/":".":f&&c===1?"//":l.slice(0,c)},basename(l,f){f!==void 0&&w(f,"ext"),w(l,"path");let c=0,o=-1,u=!0,s;if(f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,r=-1;for(s=l.length-1;s>=0;--s){const a=l.charCodeAt(s);if(a===g){if(!u){c=s+1;break}}else r===-1&&(u=!1,r=s+1),i>=0&&(a===f.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=l.length),l.slice(c,o)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===g){if(!u){c=s+1;break}}else o===-1&&(u=!1,o=s+1);return o===-1?"":l.slice(c,o)},extname(l){w(l,"path");let f=-1,c=0,o=-1,u=!0,s=0;for(let i=l.length-1;i>=0;--i){const r=l.charCodeAt(i);if(r===g){if(!u){c=i+1;break}continue}o===-1&&(u=!1,o=i+1),r===E?f===-1?f=i:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||o===-1||s===0||s===1&&f===o-1&&f===c+1?"":l.slice(f,o)},format:k.bind(null,"/"),parse(l){w(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const c=l.charCodeAt(0)===g;let o;c?(f.root="/",o=1):o=0;let u=-1,s=0,i=-1,r=!0,a=l.length-1,h=0;for(;a>=o;--a){const I=l.charCodeAt(a);if(I===g){if(!r){s=a+1;break}continue}i===-1&&(r=!1,i=a+1),I===E?u===-1?u=a:h!==1&&(h=1):u!==-1&&(h=-1)}if(i!==-1){const I=s===0&&c?1:s;u===-1||h===0||h===1&&u===i-1&&u===s+1?f.base=f.name=l.slice(I,i):(f.name=l.slice(I,u),f.base=l.slice(I,i),f.ext=l.slice(u,i))}return s>0?f.dir=l.slice(0,s-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[83],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...M){const E=M.reduce((b,P)=>(b[P]=!0,b),{}),g=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(b=>!E[b]).forEach(b=>{for(let P=0;P<g.length;P++)if(b.search(g[P])!==-1){delete C[b];break}})}e.sanitizeProcessEnvironment=D}),define(Z[84],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(M){this._highResolution=n&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new D(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Z[4],x([0,1,15,43,2,110,84]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(f){f.None=()=>D.Disposable.None;function c(J){return(U,B=null,K)=>{let $=!1,F;return F=J(_=>{if(!$)return F?F.dispose():$=!0,U.call(B,_)},null,K),$&&F.dispose(),F}}f.once=c;function o(J,U){return h((B,K=null,$)=>J(F=>B.call(K,U(F)),null,$))}f.map=o;function u(J,U){return h((B,K=null,$)=>J(F=>{U(F),B.call(K,F)},null,$))}f.forEach=u;function s(J,U){return h((B,K=null,$)=>J(F=>U(F)&&B.call(K,F),null,$))}f.filter=s;function i(J){return J}f.signal=i;function r(...J){return(U,B=null,K)=>(0,D.combinedDisposable)(...J.map($=>$(F=>U.call(B,F),null,K)))}f.any=r;function a(J,U,B){let K=B;return o(J,$=>(K=U(K,$),K))}f.reduce=a;function h(J){let U;const B=new S({onFirstListenerAdd(){U=J(B.fire,B)},onLastListenerRemove(){U.dispose()}});return B.event}function I(J,U,B,K=100,$=!1){let F,_,T=0;return J(A=>{T++,F=B(F,A),$&&!_&&(U(F),F=void 0),clearTimeout(_),_=setTimeout(()=>{const O=F;F=void 0,_=void 0,(!$||T>1)&&U(O),T=0},K)})}f.debouncedListener=I;function R(J,U,B=100,K=!1,$){let F,_,T,A=0;const O=new S({leakWarningThreshold:$,onFirstListenerAdd(){F=J(N=>{A++,_=U(_,N),K&&!T&&(O.fire(_),_=void 0),clearTimeout(T),T=setTimeout(()=>{const G=_;_=void 0,T=void 0,(!K||A>1)&&O.fire(G),A=0},B)})},onLastListenerRemove(){F.dispose()}});return O.event}f.debounce=R;function L(J,U=(B,K)=>B===K){let B=!0,K;return s(J,$=>{const F=B||!U($,K);return B=!1,K=$,F})}f.latch=L;function W(J,U){return[f.filter(J,U),f.filter(J,B=>!U(B))]}f.split=W;function z(J,U=!1,B=[]){let K=B.slice(),$=J(T=>{K?K.push(T):_.fire(T)});const F=()=>{K&&K.forEach(T=>_.fire(T)),K=null},_=new S({onFirstListenerAdd(){$||($=J(T=>_.fire(T)))},onFirstListenerDidAdd(){K&&(U?setTimeout(F):F())},onLastListenerRemove(){$&&$.dispose(),$=null}});return _.event}f.buffer=z;class Q{constructor(U){this.event=U}map(U){return new Q(o(this.event,U))}forEach(U){return new Q(u(this.event,U))}filter(U){return new Q(s(this.event,U))}reduce(U,B){return new Q(a(this.event,U,B))}latch(){return new Q(L(this.event))}debounce(U,B=100,K=!1,$){return new Q(R(this.event,U,B,K,$))}on(U,B,K){return this.event(U,B,K)}once(U,B,K){return c(this.event)(U,B,K)}}function ie(J){return new Q(J)}f.chain=ie;function ee(J,U,B=K=>K){const K=(...T)=>_.fire(B(...T)),$=()=>J.on(U,K),F=()=>J.removeListener(U,K),_=new S({onFirstListenerAdd:$,onLastListenerRemove:F});return _.event}f.fromNodeEventEmitter=ee;function q(J,U,B=K=>K){const K=(...T)=>_.fire(B(...T)),$=()=>J.addEventListener(U,K),F=()=>J.removeEventListener(U,K),_=new S({onFirstListenerAdd:$,onLastListenerRemove:F});return _.event}f.fromDOMEventEmitter=q;function X(J){return new Promise(U=>c(J)(U))}f.toPromise=X;function H(J,U){return U(void 0),J(B=>U(B))}f.runAndSubscribe=H;function j(J,U){let B=null;function K(F){B?.dispose(),B=new D.DisposableStore,U(F,B)}K(void 0);const $=J(F=>K(F));return(0,D.toDisposable)(()=>{$.dispose(),B?.dispose()})}f.runAndSubscribeWithStore=j})(E=e.Event||(e.Event={}));class g{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${g._idPool++}`}start(c){this._stopWatch=new M.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let y=-1;function b(f){const c=y;return y=f,{dispose(){y=c}}}e.setGlobalLeakWarningThreshold=b;class P{constructor(c,o=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let o=y;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||c<o)return;this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(u)||0;if(this._stacks.set(u,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,r=0;for(const[a,h]of this._stacks)(!i||r<h)&&(i=a,r=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(u)||0;this._stacks.set(u,i-1)}}}class S{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=y>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(c,o,u)=>{this._listeners||(this._listeners=new C.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[c,o]:c);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,o);const r=this._leakageMon?.check(this._listeners.size),a=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof D.DisposableStore?u.add(a):Array.isArray(u)&&u.push(a),a}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,u]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,u):o[0].call(o[1],u)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=S;class w extends S{async fireAsync(c,o,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,c]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),r=[],a={...i,token:o,waitUntil:h=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");u&&(h=u(h,typeof s=="function"?s:s[0])),r.push(h)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(h){(0,p.onUnexpectedError)(h);continue}Object.freeze(r),await Promise.allSettled(r).then(h=>{for(const I of h)I.status==="rejected"&&(0,p.onUnexpectedError)(I.reason)})}}}}e.AsyncEmitter=w;class t extends S{constructor(c){super(c);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=t;class d extends t{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=d;class m extends S{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=m;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const o={event:c,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const u=()=>{this.hasListeners&&this.unhook(o);const s=this.events.indexOf(o);this.events.splice(s,1)};return(0,D.toDisposable)((0,n.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(o=>this.emitter.fire(o))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class k{constructor(){this.buffers=[]}wrapEvent(c){return(o,u,s)=>c(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>o.call(u,i)):o.call(u,i)},void 0,s)}bufferEvents(c){const o=[];this.buffers.push(o);const u=c();return this.buffers.pop(),o.forEach(s=>s()),u}}e.EventBufferer=k;class l{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=D.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(Z[23],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(E,g){const y=setTimeout(E.bind(g),0);return{dispose(){clearTimeout(y)}}});var D;(function(E){function g(y){return y===E.None||y===E.Cancelled||y instanceof C?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}E.isCancellationToken=g,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=M}),define(Z[111],x([0,1,23]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(M){this.task=M,this.result=null}get(){if(this.result)return this.result;const M=new p.CancellationTokenSource,E=this.task(M.token);return this.result={promise:E,dispose:()=>{this.result=null,M.cancel(),M.dispose()}},this.result}}e.Cache=n;class D{constructor(M){this.computeFn=M,this.lastCache=void 0,this.lastArgKey=void 0}get(M){const E=JSON.stringify(M);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.computeFn(M)),this.lastCache}}e.LRUCachedComputed=D}),define(Z[48],x([0,1,15,2]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function C(l){const f=l;return f?D(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=C;function M(l,f){return new E(l,f)}e.newWriteableStream=M;class E{constructor(f,c){this.reducer=f,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(c=>c(f))}emitError(f){this.listeners.error.length===0?(0,p.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(c=>c(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,c){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(f,c){if(this.state.destroyed)return;let o;switch(f){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const u=o.indexOf(c);u>=0&&o.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(l,f){const c=[];let o;for(;(o=l.read())!==null;)c.push(o);return f(c)}e.consumeReadable=g;function y(l,f,c){const o=[];let u;for(;(u=l.read())!==null&&o.length<c;)o.push(u);return u===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof u!="undefined"){const s=u;return u=void 0,s}return l.read()}}}e.peekReadable=y;function b(l,f){return new Promise((c,o)=>{const u=[];P(l,{onData:s=>{f&&u.push(s)},onError:s=>{f?o(s):c(void 0)},onEnd:()=>{c(f?f(u):void 0)}})})}e.consumeStream=b;function P(l,f){let c=!1;return l.on("error",o=>{c||f.onError(o)}),l.on("end",()=>{c||f.onEnd()}),l.on("data",o=>{c||f.onData(o)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=P;function S(l,f){return new Promise((c,o)=>{const u=new n.DisposableStore,s=[],i=h=>{if(s.push(h),s.length>f)return u.dispose(),l.pause(),c({stream:l,buffer:s,ended:!1})},r=h=>o(h),a=()=>c({stream:l,buffer:s,ended:!0});u.add((0,n.toDisposable)(()=>l.removeListener("error",r))),l.on("error",r),u.add((0,n.toDisposable)(()=>l.removeListener("end",a))),l.on("end",a),u.add((0,n.toDisposable)(()=>l.removeListener("data",i))),l.on("data",i)})}e.peekStream=S;function w(l,f){const c=M(f);return c.end(l),c}e.toStream=w;function t(){const l=M(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=t;function d(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=d;function m(l,f,c){const o=M(c);return P(l,{onData:u=>o.write(f.data(u)),onError:u=>o.error(f.error?f.error(u):u),onEnd:()=>o.end()}),o}e.transform=m;function v(l,f,c){let o=!1;return{read:()=>{const u=f.read();return o?u:(o=!0,u!==null?c([l,u]):l)}}}e.prefixedReadable=v;function k(l,f,c){let o=!1;const u=M(c);return P(f,{onData:s=>o?u.write(s):(o=!0,u.write(c([l,s]))),onError:s=>u.error(s),onEnd:()=>{o||(o=!0,u.write(l)),u.end()}}),u}e.prefixedStream=k}),define(Z[17],x([0,1,48]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,C;class M{constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}static alloc(I){return n?new M(Buffer.allocUnsafe(I)):new M(new Uint8Array(I))}static wrap(I){return n&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new M(I)}static fromString(I,R){return!(R?.dontUseNodeBuffer||!1)&&n?new M(Buffer.from(I)):(D||(D=new TextEncoder),new M(D.encode(I)))}static fromByteArray(I){const R=M.alloc(I.length);for(let L=0,W=I.length;L<W;L++)R.buffer[L]=I[L];return R}static concat(I,R){if(typeof R=="undefined"){R=0;for(let z=0,Q=I.length;z<Q;z++)R+=I[z].byteLength}const L=M.alloc(R);let W=0;for(let z=0,Q=I.length;z<Q;z++){const ie=I[z];L.set(ie,W),W+=ie.byteLength}return L}clone(){const I=M.alloc(this.byteLength);return I.set(this),I}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(I,R){return new M(this.buffer.subarray(I,R))}set(I,R){if(I instanceof M)this.buffer.set(I.buffer,R);else if(I instanceof Uint8Array)this.buffer.set(I,R);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),R);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),R);else throw new Error("Unkown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,R){b(this.buffer,I,R)}readUInt32LE(I){return P(this.buffer,I)}writeUInt32LE(I,R){S(this.buffer,I,R)}readUInt8(I){return w(this.buffer,I)}writeUInt8(I,R){t(this.buffer,I,R)}}e.VSBuffer=M;function E(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0}e.readUInt16LE=E;function g(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255}e.writeUInt16LE=g;function y(h,I){return h[I]*2**24+h[I+1]*2**16+h[I+2]*2**8+h[I+3]}e.readUInt32BE=y;function b(h,I,R){h[R+3]=I,I=I>>>8,h[R+2]=I,I=I>>>8,h[R+1]=I,I=I>>>8,h[R]=I}e.writeUInt32BE=b;function P(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0|h[I+2]<<16>>>0|h[I+3]<<24>>>0}e.readUInt32LE=P;function S(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255,I=I>>>8,h[R+2]=I&255,I=I>>>8,h[R+3]=I&255}e.writeUInt32LE=S;function w(h,I){return h[I]}e.readUInt8=w;function t(h,I,R){h[R]=I}e.writeUInt8=t;function d(h){return p.consumeReadable(h,I=>M.concat(I))}e.readableToBuffer=d;function m(h){return p.toReadable(h)}e.bufferToReadable=m;function v(h){return p.consumeStream(h,I=>M.concat(I))}e.streamToBuffer=v;async function k(h){return h.ended?M.concat(h.buffer):M.concat([...h.buffer,await v(h.stream)])}e.bufferedStreamToBuffer=k;function l(h){return p.toStream(h,I=>M.concat(I))}e.bufferToStream=l;function f(h){return p.transform(h,{data:I=>typeof I=="string"?M.fromString(I):M.wrap(I)},I=>M.concat(I))}e.streamToBufferReadableStream=f;function c(h){return p.newWriteableStream(I=>M.concat(I),h)}e.newWriteableBufferStream=c;function o(h,I){return p.prefixedReadable(h,I,R=>M.concat(R))}e.prefixedBufferReadable=o;function u(h,I){return p.prefixedStream(h,I,R=>M.concat(R))}e.prefixedBufferStream=u;function s(h){let I=0,R=0,L=0;const W=new Uint8Array(Math.floor(h.length/4*3)),z=ie=>{switch(R){case 3:W[L++]=I|ie,R=0;break;case 2:W[L++]=I|ie>>>2,I=ie<<6,R=3;break;case 1:W[L++]=I|ie>>>4,I=ie<<4,R=2;break;default:I=ie<<2,R=1}};for(let ie=0;ie<h.length;ie++){const ee=h.charCodeAt(ie);if(ee>=65&&ee<=90)z(ee-65);else if(ee>=97&&ee<=122)z(ee-97+26);else if(ee>=48&&ee<=57)z(ee-48+52);else if(ee===43||ee===45)z(62);else if(ee===47||ee===95)z(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${h[ie]}`)}}const Q=L;for(;R>0;)z(0);return M.wrap(W).slice(0,Q)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:h},I=!0,R=!1){const L=R?r:i;let W="";const z=h.byteLength%3;let Q=0;for(;Q<h.byteLength-z;Q+=3){const ie=h[Q+0],ee=h[Q+1],q=h[Q+2];W+=L[ie>>>2],W+=L[(ie<<4|ee>>>4)&63],W+=L[(ee<<2|q>>>6)&63],W+=L[q&63]}if(z===1){const ie=h[Q+0];W+=L[ie>>>2],W+=L[ie<<4&63],I&&(W+="==")}else if(z===2){const ie=h[Q+0],ee=h[Q+1];W+=L[ie>>>2],W+=L[(ie<<4|ee>>>4)&63],W+=L[ee<<2&63],I&&(W+="=")}return W}e.encodeBase64=a}),define(Z[27],x([0,1,111,109]),function(V,e,p,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=C;const M=/{(\d+)}/g;function E(Y,...se){return se.length===0?Y:Y.replace(M,function(oe,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=se.length?oe:se[ye]})}e.format=E;const g=/{([^}]+)}/g;function y(Y,se){return Y.replace(g,(oe,fe)=>se[fe]??oe)}e.format2=y;function b(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=b;function P(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function S(Y,se){let oe=0;const fe=se.charCodeAt(0);for(let ye=Y.length-1;ye>=0;ye--)Y.charCodeAt(ye)===fe&&oe++;return oe}e.count=S;function w(Y,se,oe="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${oe}`}e.truncate=w;function t(Y,se=" "){const oe=d(Y,se);return m(oe,se)}e.trim=t;function d(Y,se){if(!Y||!se)return Y;const oe=se.length;if(oe===0||Y.length===0)return Y;let fe=0;for(;Y.indexOf(se,fe)===fe;)fe=fe+oe;return Y.substring(fe)}e.ltrim=d;function m(Y,se){if(!Y||!se)return Y;const oe=se.length,fe=Y.length;if(oe===0||fe===0)return Y;let ye=fe,Le=-1;for(;Le=Y.lastIndexOf(se,ye-1),!(Le===-1||Le+oe!==ye);){if(Le===0)return"";ye=Le}return Y.substring(0,ye)}e.rtrim=m;function v(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function k(Y){return Y.replace(/\*/g,"")}e.stripWildcards=k;function l(Y,se,oe={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=P(Y)),oe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let fe="";return oe.global&&(fe+="g"),oe.matchCase||(fe+="i"),oe.multiline&&(fe+="m"),oe.unicode&&(fe+="u"),new RegExp(Y,fe)}e.createRegExp=l;function f(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=o;function u(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=u;function s(Y){for(let se=0,oe=Y.length;se<oe;se++){const fe=Y.charCodeAt(se);if(fe!==32&&fe!==9)return se}return-1}e.firstNonWhitespaceIndex=s;function i(Y,se=0,oe=Y.length){for(let fe=se;fe<oe;fe++){const ye=Y.charCodeAt(fe);if(ye!==32&&ye!==9)return Y.substring(se,fe)}return Y.substring(se,oe)}e.getLeadingWhitespace=i;function r(Y,se=Y.length-1){for(let oe=se;oe>=0;oe--){const fe=Y.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function a(Y,se){return Y<se?-1:Y>se?1:0}e.compare=a;function h(Y,se,oe=0,fe=Y.length,ye=0,Le=se.length){for(;oe<fe&&ye<Le;oe++,ye++){let He=Y.charCodeAt(oe),Ae=se.charCodeAt(ye);if(He<Ae)return-1;if(He>Ae)return 1}const Oe=fe-oe,Ke=Le-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstring=h;function I(Y,se){return R(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=I;function R(Y,se,oe=0,fe=Y.length,ye=0,Le=se.length){for(;oe<fe&&ye<Le;oe++,ye++){let He=Y.charCodeAt(oe),Ae=se.charCodeAt(ye);if(He===Ae)continue;if(He>=128||Ae>=128)return h(Y.toLowerCase(),se.toLowerCase(),oe,fe,ye,Le);L(He)&&(He-=32),L(Ae)&&(Ae-=32);const $e=He-Ae;if($e!==0)return $e}const Oe=fe-oe,Ke=Le-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstringIgnoreCase=R;function L(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=L;function W(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=W;function z(Y,se){return Y.length===se.length&&R(Y,se)===0}e.equalsIgnoreCase=z;function Q(Y,se){const oe=se.length;return se.length>Y.length?!1:R(Y,se,0,oe)===0}e.startsWithIgnoreCase=Q;function ie(Y,se){let oe,fe=Math.min(Y.length,se.length);for(oe=0;oe<fe;oe++)if(Y.charCodeAt(oe)!==se.charCodeAt(oe))return oe;return fe}e.commonPrefixLength=ie;function ee(Y,se){let oe,fe=Math.min(Y.length,se.length);const ye=Y.length-1,Le=se.length-1;for(oe=0;oe<fe;oe++)if(Y.charCodeAt(ye-oe)!==se.charCodeAt(Le-oe))return oe;return fe}e.commonSuffixLength=ee;function q(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=q;function X(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=X;function H(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=H;function j(Y,se,oe){const fe=Y.charCodeAt(oe);if(q(fe)&&oe+1<se){const ye=Y.charCodeAt(oe+1);if(X(ye))return H(fe,ye)}return fe}e.getNextCodePoint=j;function J(Y,se){const oe=Y.charCodeAt(se-1);if(X(oe)&&se>1){const fe=Y.charCodeAt(se-2);if(q(fe))return H(fe,oe)}return oe}class U{constructor(se,oe=0){this._str=se,this._len=se.length,this._offset=oe}get offset(){return this._offset}setOffset(se){this._offset=se}prevCodePoint(){const se=J(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=j(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}e.CodePointIterator=U;class B{constructor(se,oe=0){this._iterator=new U(se,oe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const se=Be.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Le=oe.offset,Oe=se.getGraphemeBreakType(oe.nextCodePoint());if(xe(ye,Oe)){oe.setOffset(Le);break}ye=Oe}return oe.offset-fe}prevGraphemeLength(){const se=Be.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Le=oe.offset,Oe=se.getGraphemeBreakType(oe.prevCodePoint());if(xe(Oe,ye)){oe.setOffset(Le);break}ye=Oe}return fe-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=B;function K(Y,se){return new B(Y,se).nextGraphemeLength()}e.nextCharLength=K;function $(Y,se){return new B(Y,se).prevGraphemeLength()}e.prevCharLength=$;function F(Y,se){se>0&&X(Y.charCodeAt(se))&&se--;const oe=se+K(Y,se);return[oe-$(Y,oe),oe]}e.getCharContainingOffset=F;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(Y){return _.test(Y)}e.containsRTL=T;const A=/^[\t\n\r\x20-\x7E]*$/;function O(Y){return A.test(Y)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=N;function G(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=G;function ne(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=ne;function ce(Y,se){if(Y.length<se)return Y;const oe=/\b/g;let fe=0;for(;oe.test(Y)&&!(Y.length-oe.lastIndex<se);)fe=oe.lastIndex,oe.lastIndex+=1;return Y.substring(fe).replace(/^\s/,"")}e.lcut=ce;const ae=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function he(Y){return Y&&(Y=Y.replace(ae,""),Y=Y.replace(re,""),Y=Y.replace(le,"")),Y}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function me(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=me;function ke(Y){return me(Y)?Y.substr(1):Y}e.stripUTF8BOM=ke;function Ce(Y,se){if(!Y||!se||Y.length<se.length)return!1;const oe=se.length,fe=Y.toLowerCase();let ye=0,Le=-1;for(;ye<oe;){const Oe=fe.indexOf(se[ye],Le+1);if(Oe<0)return!1;Le=Oe,ye++}return!0}e.fuzzyContains=Ce;function Se(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Se;function pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=pe;function be(Y,se=1){if(se===0)return"";let oe=-1;do oe=Y.indexOf(`
`,oe+1),se--;while(se>0&&oe>=0);return oe===-1?Y:(Y[oe-1]==="\r"&&oe--,Y.substr(0,oe))}e.getNLines=be;function Re(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Re;function Ue(Y){return Be.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ue;function xe(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}var Te;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Ye()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const oe=this._data,fe=oe.length/3;let ye=1;for(;ye<=fe;)if(se<oe[3*ye])ye=2*ye;else if(se>oe[3*ye+1])ye=2*ye+1;else return oe[3*ye+2];return 0}}Be._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Y,se){if(Y===0)return 0;const oe=pt(Y,se);if(oe!==void 0)return oe;const fe=new U(se,Y);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=st;function pt(Y,se){const oe=new U(se,Y);let fe=oe.prevCodePoint();for(;ot(fe)||fe===65039||fe===8419;){if(oe.offset===0)return;fe=oe.prevCodePoint()}if(!ne(fe))return;let ye=oe.offset;return ye>0&&oe.prevCodePoint()===8205&&(ye=oe.offset),ye}function ot(Y){return 127995<=Y&&Y<=127999}var Qe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class qe{constructor(se){this.confusableDictionary=se}static getInstance(se){return qe.cache.get(Array.from(se))}static getLocales(){return qe._locales.getValue()}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe,D=qe,qe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new p.LRUCachedComputed(Y=>{function se(Ae){const $e=new Map;for(let Ve=0;Ve<Ae.length;Ve+=2)$e.set(Ae[Ve],Ae[Ve+1]);return $e}function oe(Ae,$e){const Ve=new Map(Ae);for(const[Ge,it]of $e)Ve.set(Ge,it);return Ve}function fe(Ae,$e){if(!Ae)return $e;const Ve=new Map;for(const[Ge,it]of Ae)$e.has(Ge)&&Ve.set(Ge,it);return Ve}const ye=D.ambiguousCharacterData.getValue();let Le=Y.filter(Ae=>!Ae.startsWith("_")&&Ae in ye);Le.length===0&&(Le=["_default"]);let Oe;for(const Ae of Le){const $e=se(ye[Ae]);Oe=fe(Oe,$e)}const Ke=se(ye._common),He=oe(Ke,Oe);return new qe(He)}),qe._locales=new n.Lazy(()=>Object.keys(qe.ambiguousCharacterData.getValue()).filter(Y=>!Y.startsWith("_")));class Xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Xe.getRawData())),this._data}static isInvisibleCharacter(se){return Xe.getData().has(se)}static get codePoints(){return Xe.getData()}}e.InvisibleCharacters=Xe,Xe._data=void 0}),define(Z[69],x([0,1,27]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return D(v,0)}e.hash=n;function D(v,k){switch(typeof v){case"object":return v===null?C(349,k):Array.isArray(v)?g(v,k):y(v,k);case"string":return E(v,k);case"boolean":return M(v,k);case"number":return C(v,k);case"undefined":return C(937,k);default:return C(617,k)}}e.doHash=D;function C(v,k){return(k<<5)-k+v|0}e.numberHash=C;function M(v,k){return C(v?433:863,k)}function E(v,k){k=C(149417,k);for(let l=0,f=v.length;l<f;l++)k=C(v.charCodeAt(l),k);return k}e.stringHash=E;function g(v,k){return k=C(104579,k),v.reduce((l,f)=>D(f,l),k)}function y(v,k){return k=C(181387,k),Object.keys(v).sort().reduce((l,f)=>(l=E(f,l),D(v[f],l)),k)}class b{constructor(){this._value=0}get value(){return this._value}hash(k){return this._value=D(k,this._value),this._value}}e.Hasher=b;var P;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function S(v,k,l=32){const f=l-k,c=~((1<<f)-1);return(v<<k|(c&v)>>>f)>>>0}function w(v,k=0,l=v.byteLength,f=0){for(let c=0;c<l;c++)v[k+c]=f}function t(v,k,l="0"){for(;v.length<k;)v=l+v;return v}function d(v,k=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(l=>l.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),k/4)}e.toHexString=d;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(k){const l=k.length;if(l===0)return;const f=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,u,s;for(o!==0?(u=o,s=-1,o=0):(u=k.charCodeAt(0),s=0);;){let i=u;if(p.isHighSurrogate(u))if(s+1<l){const r=k.charCodeAt(s+1);p.isLowSurrogate(r)?(s++,i=p.computeCodePoint(u,r)):i=65533}else{o=u;break}else p.isLowSurrogate(u)&&(i=65533);if(c=this._push(f,c,i),s++,s<l)u=k.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(k,l,f){return f<128?k[l++]=f:f<2048?(k[l++]=192|(f&1984)>>>6,k[l++]=128|(f&63)>>>0):f<65536?(k[l++]=224|(f&61440)>>>12,k[l++]=128|(f&4032)>>>6,k[l++]=128|(f&63)>>>0):(k[l++]=240|(f&1835008)>>>18,k[l++]=128|(f&258048)>>>12,k[l++]=128|(f&4032)>>>6,k[l++]=128|(f&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,k[0]=k[64+0],k[1]=k[64+1],k[2]=k[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const k=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(k/4294967296),!1),this._buffDV.setUint32(60,k%4294967296,!1),this._step()}_step(){const k=m._bigBlock32,l=this._buffDV;for(let h=0;h<64;h+=4)k.setUint32(h,l.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)k.setUint32(h,S(k.getUint32(h-12,!1)^k.getUint32(h-32,!1)^k.getUint32(h-56,!1)^k.getUint32(h-64,!1),1),!1);let f=this._h0,c=this._h1,o=this._h2,u=this._h3,s=this._h4,i,r,a;for(let h=0;h<80;h++)h<20?(i=c&o|~c&u,r=1518500249):h<40?(i=c^o^u,r=1859775393):h<60?(i=c&o|c&u|o&u,r=2400959708):(i=c^o^u,r=3395469782),a=S(f,5)+i+s+r+k.getUint32(h*4,!1)&4294967295,s=u,u=o,o=S(c,30),c=f,f=a;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var Mt=this&&this.__classPrivateFieldSet||function(V,e,p,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!D:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(V,p):D?D.value=p:e.set(V,p),p},Ze=this&&this.__classPrivateFieldGet||function(V,e,p,n){if(p==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!n:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?n:p==="a"?n.call(V):n?n.value:e.get(V)};define(Z[35],x([0,1,30,27]),function(V,e,p,n){"use strict";var D,C,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(s,i,r){let a=s.get(i);return a===void 0&&(a=r,s.set(i,a)),a}e.getOrSet=E;function g(s){const i=[];return s.forEach((r,a)=>{i.push(`${a} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=g;function y(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=y;class b{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=b;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class S{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const a=this._value.charCodeAt(r);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var w;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(w||(w={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(m||(m={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new S(void 0,!i))}static forStrings(){return new v(new b)}static forConfigKeys(){return new v(new P)}clear(){this._root=void 0}fill(i,r){if(r){const a=r.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h,i)}else{const a=i.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h[0],h[1])}}set(i,r){const a=this._iter.reset(i);let h;this._root||(this._root=new d,this._root.segment=a.value());const I=[];for(h=this._root;;){const L=a.cmp(h.segment);if(L>0)h.left||(h.left=new d,h.left.segment=a.value()),I.push([-1,h]),h=h.left;else if(L<0)h.right||(h.right=new d,h.right.segment=a.value()),I.push([1,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new d,h.mid.segment=a.value()),I.push([0,h]),h=h.mid;else break}const R=h.value;h.value=r,h.key=i;for(let L=I.length-1;L>=0;L--){const W=I[L][1];W.updateHeight();const z=W.balanceFactor();if(z<-1||z>1){const Q=I[L][0],ie=I[L+1][0];if(Q===1&&ie===1)I[L][1]=W.rotateLeft();else if(Q===-1&&ie===-1)I[L][1]=W.rotateRight();else if(Q===1&&ie===-1)W.right=I[L+1][1]=I[L+1][1].rotateRight(),I[L][1]=W.rotateLeft();else if(Q===-1&&ie===1)W.left=I[L+1][1]=I[L+1][1].rotateLeft(),I[L][1]=W.rotateRight();else throw new Error;if(L>0)switch(I[L-1][0]){case-1:I[L-1][1].left=I[L][1];break;case 1:I[L-1][1].right=I[L][1];break;case 0:I[L-1][1].mid=I[L][1];break}else this._root=I[0][1]}}return R}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const a=this._iter.reset(i),h=[];let I=this._root;for(;I;){const R=a.cmp(I.segment);if(R>0)h.push([-1,I]),I=I.left;else if(R<0)h.push([1,I]),I=I.right;else if(a.hasNext())a.next(),h.push([0,I]),I=I.mid;else break}if(!!I){if(r?(I.left=void 0,I.mid=void 0,I.right=void 0,I.height=1):(I.key=void 0,I.value=void 0),!I.mid&&!I.value)if(I.left&&I.right){const R=this._min(I.right),{key:L,value:W,segment:z}=R;this._delete(R.key,!1),I.key=L,I.value=W,I.segment=z}else{const R=I.left??I.right;if(h.length>0){const[L,W]=h[h.length-1];switch(L){case-1:W.left=R;break;case 0:W.mid=R;break;case 1:W.right=R;break}}else this._root=R}for(let R=h.length-1;R>=0;R--){const L=h[R][1];L.updateHeight();const W=L.balanceFactor();if(W>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),h[R][1]=L.rotateLeft()):W<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),h[R][1]=L.rotateRight()),R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let a=this._root,h;for(;a;){const I=r.cmp(a.segment);if(I>0)a=a.left;else if(I<0)a=a.right;else if(r.hasNext())r.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[r,a]of this)i(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=v;class k{constructor(i,r){this.uri=i,this.value=r}}class l{constructor(i,r){this[D]="ResourceMap",i instanceof l?(this.map=new Map(i.map),this.toKey=r??l.defaultToKey):(this.map=new Map,this.toKey=i??l.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new k(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[a,h]of this.map)i(h.value,h.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=l,l.defaultToKey=s=>s.toString();var f;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class c{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const a=this._map.get(i);if(!!a)return r!==0&&this.touch(a,r),a.value}set(i,r,a=0){let h=this._map.get(i);if(h)h.value=r,a!==0&&this.touch(h,a);else{switch(h={key:i,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const a=this._state;let h=this._head;for(;h;){if(r?i.bind(r)(h.value,h.key,this):i(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.key,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}values(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.value,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}entries(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:[a.key,a.value],done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>i;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,a=i.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const a=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const a=i.next,h=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,a)=>{i.push([a,r])}),i}fromJSON(i){this.clear();for(const[r,a]of i)this.set(r,a)}}e.LinkedMap=c;class o extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class u{constructor(i){M.set(this,void 0),Mt(this,M,i,"f")}get size(){return Ze(this,M,"f").size}forEach(i,r){Ze(this,M,"f").forEach(i,r)}get(i){return Ze(this,M,"f").get(i)}has(i){return Ze(this,M,"f").has(i)}entries(){return Ze(this,M,"f").entries()}keys(){return Ze(this,M,"f").keys()}values(){return Ze(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Ze(this,M,"f").entries()}}e.ReadonlyMapView=u}),define(Z[70],x([0,1,35]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new p.LRUCache(1e4);function D(y){return g(y,"NFC",n)}e.normalizeNFC=D;const C=new p.LRUCache(1e4);function M(y){return g(y,"NFD",C)}e.normalizeNFD=M;const E=/[^\u0000-\u0080]/;function g(y,b,P){if(!y)return y;const S=P.get(y);if(S)return S;let w;return E.test(y)?w=y.normalize(b):w=y,P.set(y,w),w}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(b){return M(b).replace(y,"")}}()}),define(Z[14],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(a){return Array.isArray(a)}e.isArray=p;function n(a){return typeof a=="string"}e.isString=n;function D(a){return Array.isArray(a)&&a.every(h=>n(h))}e.isStringArray=D;function C(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=C;function M(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=M;function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=E;function g(a){return a===!0||a===!1}e.isBoolean=g;function y(a){return typeof a=="undefined"}e.isUndefined=y;function b(a){return!P(a)}e.isDefined=b;function P(a){return y(a)||a===null}e.isUndefinedOrNull=P;function S(a,h){if(!a)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=S;function w(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=w;function t(...a){const h=[];for(let I=0;I<a.length;I++){const R=a[I];if(P(R))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);h.push(R)}return h}e.assertAllDefined=t;const d=Object.prototype.hasOwnProperty;function m(a){if(!C(a))return!1;for(let h in a)if(d.call(a,h))return!1;return!0}e.isEmptyObject=m;function v(a){return typeof a=="function"}e.isFunction=v;function k(...a){return a.length>0&&a.every(v)}e.areFunctions=k;function l(a,h){const I=Math.min(a.length,h.length);for(let R=0;R<I;R++)f(a[R],h[R])}e.validateConstraints=l;function f(a,h){if(n(h)){if(typeof a!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(v(h)){try{if(a instanceof h)return}catch{}if(!P(a)&&a.constructor===h||h.length===1&&h.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(a){let h=[],I=Object.getPrototypeOf(a);for(;Object.prototype!==I;)h=h.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return h}e.getAllPropertyNames=c;function o(a){const h=[];for(const I of c(a))typeof a[I]=="function"&&h.push(I);return h}e.getAllMethodNames=o;function u(a,h){const I=L=>function(){const W=Array.prototype.slice.call(arguments,0);return h(L,W)};let R={};for(const L of a)R[L]=I(L);return R}e.createProxyObject=u;function s(a){return a===null?void 0:a}e.withNullAsUndefined=s;function i(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=i;function r(a,h="Unreachable"){throw new Error(h)}e.assertNever=r}),define(Z[28],x([0,1,9,3,27,14]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(r){return r===47||r===92}e.isPathSeparator=M;function E(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=E;function g(r){return r.indexOf("/")===-1&&(r=E(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=g;function y(r,a=p.posix.sep){if(!r)return"";const h=r.length,I=r.charCodeAt(0);if(M(I)){if(M(r.charCodeAt(1))&&!M(r.charCodeAt(2))){let L=3;const W=L;for(;L<h&&!M(r.charCodeAt(L));L++);if(W!==L&&!M(r.charCodeAt(L+1))){for(L+=1;L<h;L++)if(M(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(v(I)&&r.charCodeAt(1)===58)return M(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let R=r.indexOf("://");if(R!==-1){for(R+=3;R<h;R++)if(M(r.charCodeAt(R)))return r.slice(0,R+1)}return""}e.getRoot=y;function b(r){if(!n.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let h=2;const I=h;for(;h<r.length&&(a=r.charCodeAt(h),a!==92);h++);return!(I===h||(a=r.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=b;const P=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,a=n.isWindows){const h=a?P:S;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||a&&w.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function d(r,a,h){const I=r===a;return!h||I?I:!r||!a?!1:(0,D.equalsIgnoreCase)(r,a)}e.isEqual=d;function m(r,a,h,I=p.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(h){if(!(0,D.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let L=a.length;return a.charAt(a.length-1)===I&&L--,r.charAt(L)===I}return a.charAt(a.length-1)!==I&&(a+=I),r.indexOf(a)===0}e.isEqualOrParent=m;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function k(r,a){return n.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(a,r)),r=(0,p.normalize)(r),n.isWindows?(r=(0,D.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,D.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=k;function l(r){const a=(0,p.normalize)(r);return n.isWindows?r.length>3?!1:f(a)&&(r.length===2||a.charCodeAt(2)===92):a===p.posix.sep}e.isRootOrDriveLetter=l;function f(r,a){return(a!==void 0?a:n.isWindows)?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(r){return f(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,a,h){return a.length>r.length?-1:r===a?0:(h&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=o;function u(r){const a=r.split(":");let h,I,R;for(const L of a){const W=Number(L);(0,C.isNumber)(W)?I===void 0?I=W:R===void 0&&(R=W):h=h?[h,L].join(":"):L}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:I!==void 0?I:void 0,column:R!==void 0?R:I!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,a,h=8){let I="";for(let L=0;L<h;L++)I+=s.charAt(Math.floor(Math.random()*s.length));let R;return a?R=`${a}-${I}`:R=I,r?(0,p.join)(r,R):R}e.randomPath=i}),define(Z[49],x([0,1,14]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?m[v]=n(d[v]):m[v]=d[v]}),m}e.deepClone=n;function D(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const v=m.shift();Object.freeze(v);for(const k in v)if(C.call(v,k)){const l=v[k];typeof l=="object"&&!Object.isFrozen(l)&&m.push(l)}}return d}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function M(d,m){return E(d,m,new Set)}e.cloneAndChange=M;function E(d,m,v){if((0,p.isUndefinedOrNull)(d))return d;const k=m(d);if(typeof k!="undefined")return k;if((0,p.isArray)(d)){const l=[];for(const f of d)l.push(E(f,m,v));return l}if((0,p.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const l={};for(let f in d)C.call(d,f)&&(l[f]=E(d[f],m,v));return v.delete(d),l}return d}function g(d,m,v=!0){return(0,p.isObject)(d)?((0,p.isObject)(m)&&Object.keys(m).forEach(k=>{k in d?v&&((0,p.isObject)(d[k])&&(0,p.isObject)(m[k])?g(d[k],m[k],v):d[k]=m[k]):d[k]=m[k]}),d):m}e.mixin=g;function y(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let v,k;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(v=0;v<d.length;v++)if(!y(d[v],m[v]))return!1}else{const l=[];for(k in d)l.push(k);l.sort();const f=[];for(k in m)f.push(k);if(f.sort(),!y(l,f))return!1;for(v=0;v<l.length;v++)if(!y(d[l[v]],m[l[v]]))return!1}return!0}e.equals=y;function b(d){const m=new Set;return JSON.stringify(d,(v,k)=>{if((0,p.isObject)(k)||Array.isArray(k)){if(m.has(k))return"[Circular]";m.add(k)}return k})}e.safeStringify=b;function P(d,m,v){const k=m(d);return typeof k=="undefined"?v:k}e.getOrDefault=P;function S(d,m){const v=Object.create(null);return!d||!m||Object.keys(m).forEach(l=>{const f=d[l],c=m[l];y(f,c)||(v[l]=c)}),v}e.distinct=S;function w(d,m){const v=m.toLowerCase(),k=Object.keys(d).find(l=>l.toLowerCase()===v);return k?d[k]:d[m]}e.getCaseInsensitive=w;function t(d,m){const v=Object.create(null);for(const[k,l]of Object.entries(d))m(k,l)&&(v[k]=l);return v}e.filter=t}),define(Z[7],x([0,1,9,3]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,M=/^\/\//;function E(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(s,i){return!s&&!i?"file":s}function y(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const b="",P="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(i,r,a,h,I,R=!1){typeof i=="object"?(this.scheme=i.scheme||b,this.authority=i.authority||b,this.path=i.path||b,this.query=i.query||b,this.fragment=i.fragment||b):(this.scheme=g(i,R),this.authority=r||b,this.path=y(this.scheme,a||b),this.query=h||b,this.fragment=I||b,E(this,R))}static isUri(i){return i instanceof w?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:h,query:I,fragment:R}=i;return r===void 0?r=this.scheme:r===null&&(r=b),a===void 0?a=this.authority:a===null&&(a=b),h===void 0?h=this.path:h===null&&(h=b),I===void 0?I=this.query:I===null&&(I=b),R===void 0?R=this.fragment:R===null&&(R=b),r===this.scheme&&a===this.authority&&h===this.path&&I===this.query&&R===this.fragment?this:new d(r,a,h,I,R)}static parse(i,r=!1){const a=S.exec(i);return a?new d(a[2]||b,u(a[4]||b),u(a[5]||b),u(a[7]||b),u(a[9]||b),r):new d(b,b,b,b,b)}static file(i){let r=b;if(n.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const a=i.indexOf(P,2);a===-1?(r=i.substring(2),i=P):(r=i.substring(2,a),i=i.substring(a)||P)}return new d("file",r,i,b,b)}static from(i){const r=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return E(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return n.isWindows&&i.scheme==="file"?a=w.file(p.win32.join(l(i,!0),...r)).path:a=p.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof w)return i;{const r=new d(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=w;const t=n.isWindows?1:void 0;class d extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,i){let r,a=-1;for(let h=0;h<s.length;h++){const I=s.charCodeAt(h);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||i&&I===47)a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r!==void 0&&(r+=s.charAt(h));else{r===void 0&&(r=s.substr(0,h));const R=m[I];R!==void 0?(a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r+=R):a===-1&&(a=h)}}return a!==-1&&(r+=encodeURIComponent(s.substring(a))),r!==void 0?r:s}function k(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=m[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function l(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=l;function f(s,i){const r=i?k:v;let a="",{scheme:h,authority:I,path:R,query:L,fragment:W}=s;if(h&&(a+=h,a+=":"),(I||h==="file")&&(a+=P,a+=P),I){let z=I.indexOf("@");if(z!==-1){const Q=I.substr(0,z);I=I.substr(z+1),z=Q.indexOf(":"),z===-1?a+=r(Q,!1):(a+=r(Q.substr(0,z),!1),a+=":",a+=r(Q.substr(z+1),!1)),a+="@"}I=I.toLowerCase(),z=I.indexOf(":"),z===-1?a+=r(I,!1):(a+=r(I.substr(0,z),!1),a+=I.substr(z))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const z=R.charCodeAt(1);z>=65&&z<=90&&(R=`/${String.fromCharCode(z+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const z=R.charCodeAt(0);z>=65&&z<=90&&(R=`${String.fromCharCode(z+32)}:${R.substr(2)}`)}a+=r(R,!0)}return L&&(a+="?",a+=r(L,!1)),W&&(a+="#",a+=i?W:v(W,!1)),a}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(s){return s.match(o)?s.replace(o,i=>c(i)):s}}),define(Z[112],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(y){const b=y;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=n;function D(y){const b=[];let P;try{const S=JSON.parse(y.arguments),w=S[S.length-1];w&&w.__$stack&&(S.pop(),P=w.__$stack),b.push(...S)}catch{b.push("Unable to log remote console arguments",y.arguments)}return{args:b,stack:P}}e.parse=D;function C(y){if(typeof y!="string")return C(D(y).stack);const b=y;if(b){const P=M(b),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(S&&S.length===4)return{uri:p.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=C;function M(y){if(!y)return y;const b=y.indexOf(`
`);return b===-1?y:y.substring(0,b)}function E(y,b){const{args:P,stack:S}=D(y),w=typeof P[0]=="string"&&P.length===1;let t=M(S);t&&(t=`(${t.trim()})`);let d=[];if(typeof P[0]=="string"?t&&w?d=[`%c[${b}] %c${P[0]} %c${t}`,g("blue"),g(""),g("grey")]:d=[`%c[${b}] %c${P[0]}`,g("blue"),g(""),...P.slice(1)]:d=[`%c[${b}]%`,g("blue"),...P],t&&!w&&d.push(t),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,d)}e.log=E;function g(y){return`color: ${y}`}}),define(Z[113],x([0,1,17,27,7]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(b){return JSON.stringify(b,g)}e.stringify=C;function M(b){let P=JSON.parse(b);return P=y(P),P}e.parse=M;var E;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext",b[b.Date=14]="Date"})(E=e.MarshalledId||(e.MarshalledId={}));function g(b,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,n.regExpFlags)(P)}:P}function y(b,P=0){if(!b||P>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof p.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let S=0;S<b.length;++S)b[S]=y(b[S],P+1);else for(const S in b)Object.hasOwnProperty.call(b,S)&&(b[S]=y(b[S],P+1))}return b}e.revive=y}),define(Z[10],x([0,1,3,7]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,y,b){this._hosts[g]=y,this._ports[g]=b}setConnectionToken(g,y){this._connectionTokens[g]=y}rewrite(g){if(this._delegate)return this._delegate(g);const y=g.authority;let b=this._hosts[y];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const P=this._ports[y],S=this._connectionTokens[y];let w=`path=${encodeURIComponent(g.path)}`;return typeof S=="string"&&(w+=`&tkn=${encodeURIComponent(S)}`),n.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${b}:${P}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new C;class M{asBrowserUri(g,y){const b=this.toUri(g,y);return b.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?b.with({scheme:D.vscodeFileResource,authority:b.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(g,y){const b=this.toUri(g,y);return b.scheme===D.vscodeFileResource?b.with({scheme:D.file,authority:b.authority!==M.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(g,y){return n.URI.isUri(g)?g:n.URI.parse(y.toUrl(g))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(Z[16],x([0,1,28,10,9,3,27,7]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(w){return(0,E.uriToFsPath)(w,!0)}e.originalFSPath=g;class y{constructor(t){this._ignorePathCasing=t}compare(t,d,m=!1){return t===d?0:(0,M.compare)(this.getComparisonKey(t,m),this.getComparisonKey(d,m))}isEqual(t,d,m=!1){return t===d?!0:!t||!d?!1:this.getComparisonKey(t,m)===this.getComparisonKey(d,m)}getComparisonKey(t,d=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,d,m=!1){if(t.scheme===d.scheme){if(t.scheme===n.Schemas.file)return p.isEqualOrParent(g(t),g(d),this._ignorePathCasing(t))&&t.query===d.query&&(m||t.fragment===d.fragment);if((0,e.isEqualAuthority)(t.authority,d.authority))return p.isEqualOrParent(t.path,d.path,this._ignorePathCasing(t),"/")&&t.query===d.query&&(m||t.fragment===d.fragment)}return!1}joinPath(t,...d){return E.URI.joinPath(t,...d)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let d;return t.scheme===n.Schemas.file?d=E.URI.file(D.dirname(g(t))).path:(d=D.posix.dirname(t.path),t.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),d="/")),t.with({path:d})}normalizePath(t){if(!t.path.length)return t;let d;return t.scheme===n.Schemas.file?d=E.URI.file(D.normalize(g(t))).path:d=D.posix.normalize(t.path),t.with({path:d})}relativePath(t,d){if(t.scheme!==d.scheme||!(0,e.isEqualAuthority)(t.authority,d.authority))return;if(t.scheme===n.Schemas.file){const k=D.relative(g(t),g(d));return C.isWindows?p.toSlashes(k):k}let m=t.path||"/",v=d.path||"/";if(this._ignorePathCasing(t)){let k=0;for(const l=Math.min(m.length,v.length);k<l&&!(m.charCodeAt(k)!==v.charCodeAt(k)&&m.charAt(k).toLowerCase()!==v.charAt(k).toLowerCase());k++);m=v.substr(0,k)+m.substr(k)}return D.posix.relative(m,v)}resolvePath(t,d){if(t.scheme===n.Schemas.file){const m=E.URI.file(D.resolve(g(t),d));return t.with({authority:m.authority,path:m.path})}return d=p.toPosixPath(d),t.with({path:D.posix.resolve(t.path,d)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,d){return t===d||t!==void 0&&d!==void 0&&(0,M.equalsIgnoreCase)(t,d)}hasTrailingPathSeparator(t,d=D.sep){if(t.scheme===n.Schemas.file){const m=g(t);return m.length>p.getRoot(m).length&&m[m.length-1]===d}else{const m=t.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,d=D.sep){return(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,d=D.sep){let m=!1;if(t.scheme===n.Schemas.file){const v=g(t);m=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=t.path;m=v.length===1&&v.charCodeAt(v.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path+"/"}):t}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(w=>w.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new y(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(w,t){const d=[];for(let m=0;m<w.length;m++){const v=t(w[m]);w.some((k,l)=>l===m?!1:(0,e.isEqualOrParent)(v,t(k)))||d.push(w[m])}return d}e.distinctParents=b;var P;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function t(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(l=>{const[f,c]=l.split(":");f&&c&&m.set(f,c)});const k=d.path.substring(0,d.path.indexOf(";"));return k&&m.set(w.META_DATA_MIME,k),m}w.parseMetaData=t})(P=e.DataUri||(e.DataUri={}));function S(w,t,d){if(t){let m=w.path;return m&&m[0]!==D.posix.sep&&(m=D.posix.sep+m),w.with({scheme:d,authority:t,path:m})}return w.with({scheme:d})}e.toLocalResource=S}),define(Z[8],x([0,1,23,15,4,2,16,3]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(T){return!!T&&typeof T.then=="function"}e.isThenable=g;function y(T){const A=new p.CancellationTokenSource,O=T(A.token),N=new Promise((G,ne)=>{const ce=A.token.onCancellationRequested(()=>{ce.dispose(),A.dispose(),ne(new n.CancellationError)});Promise.resolve(O).then(ae=>{ce.dispose(),A.dispose(),G(ae)},ae=>{ce.dispose(),A.dispose(),ne(ae)})});return new class{cancel(){A.cancel()}then(G,ne){return N.then(G,ne)}catch(G){return this.then(void 0,G)}finally(G){return N.finally(G)}}}e.createCancelablePromise=y;function b(T,A,O){return new Promise((N,G)=>{const ne=A.onCancellationRequested(()=>{ne.dispose(),N(O)});T.then(N,G).finally(()=>ne.dispose())})}e.raceCancellation=b;function P(T,A){return new Promise((O,N)=>{const G=A.onCancellationRequested(()=>{G.dispose(),N(new n.CancellationError)});T.then(O,N).finally(()=>G.dispose())})}e.raceCancellationError=P;async function S(T){let A=-1;const O=T.map((G,ne)=>G.then(ce=>(A=ne,ce))),N=await Promise.race(O);return T.forEach((G,ne)=>{ne!==A&&G.cancel()}),N}e.raceCancellablePromises=S;function w(T,A,O){let N;const G=setTimeout(()=>{N?.(void 0),O?.()},A);return Promise.race([T.finally(()=>clearTimeout(G)),new Promise(ne=>N=ne)])}e.raceTimeout=w;function t(T){return new Promise((A,O)=>{const N=T();g(N)?N.then(A,O):A(N)})}e.asPromise=t;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(O,O).then(N)})}return new Promise((O,N)=>{this.queuedPromise.then(O,N)})}return this.activePromise=A(),new Promise((O,N)=>{this.activePromise.then(G=>{this.activePromise=null,O(G)},G=>{this.activePromise=null,N(G)})})}}e.Throttler=d;class m{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=m;class v{constructor(){this.promiseMap=new Map}queue(A,O){const G=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===G&&this.promiseMap.delete(A)});return this.promiseMap.set(A,G),G}}e.SequencerByKey=v;const k=(T,A)=>{let O=!0;const N=setTimeout(()=>{O=!1,A()},T);return{isTriggered:()=>O,dispose:()=>{clearTimeout(N),O=!1}}},l=T=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,T())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,ne)=>{this.doResolve=G,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?l(N):k(O,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(A){this.delayer=new f(A),this.throttler=new d}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class u extends o{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function s(T,A){return A?new Promise((O,N)=>{const G=setTimeout(()=>{ne.dispose(),O()},T),ne=A.onCancellationRequested(()=>{clearTimeout(G),ne.dispose(),N(new n.CancellationError)})}):y(O=>s(T,O))}e.timeout=s;function i(T,A=0){const O=setTimeout(T,A);return(0,C.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function r(T){const A=[];let O=0;const N=T.length;function G(){return O<N?T[O++]():null}function ne(ce){ce!=null&&A.push(ce);const ae=G();return ae?ae.then(ne):Promise.resolve(A)}return Promise.resolve(null).then(ne)}e.sequence=r;function a(T,A=N=>!!N,O=null){let N=0;const G=T.length,ne=()=>{if(N>=G)return Promise.resolve(O);const ce=T[N++];return Promise.resolve(ce()).then(re=>A(re)?Promise.resolve(re):ne())};return ne()}e.first=a;function h(T,A=N=>!!N,O=null){if(T.length===0)return Promise.resolve(O);let N=T.length;const G=()=>{N=-1;for(const ne of T)ne.cancel?.()};return new Promise((ne,ce)=>{for(const ae of T)ae.then(re=>{--N>=0&&A(re)?(G(),ne(re)):N===0&&ne(O)}).catch(re=>{--N>=0&&(G(),ce(re))})})}e.firstParallel=h;class I{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,N)=>{this.outstandingPromises.push({factory:A,c:O,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=I;class R extends I{constructor(){super(1)}}e.Queue=R;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new U;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=M.extUri){const N=O.getComparisonKey(A);let G=this.queues.get(N);return G||(G=new R,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(N),this.onDidQueueFinish()}),this.queues.set(N,G)),G}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class W{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=W;class z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=z;class Q{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Q;class ie{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=ie;class ee extends Q{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ee;class q extends C.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,E.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(T,A)=>{const O=requestIdleCallback(T,typeof A=="number"?{timeout:A}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(O))}}}}();class X{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=X;async function H(T,A,O){let N;for(let G=0;G<O;G++)try{return await T()}catch(ne){N=ne,await s(A)}throw N}e.retry=H;class j{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,N){return this._pending={taskId:A,cancel:()=>N?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,N;const G=new Promise((ne,ce)=>{O=ne,N=ce});this._next={run:A,promise:G,promiseResolve:O,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=j;class J{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=U;var B;(function(T){async function A(N){let G;const ne=await Promise.all(N.map(ce=>ce.then(ae=>ae,ae=>{G||(G=ae)})));if(typeof G!="undefined")throw G;return ne}T.settled=A;function O(N){return new Promise(async(G,ne)=>{try{await N(G,ne)}catch(ce){ne(ce)}})}T.withAsyncBody=O})(B=e.Promises||(e.Promises={}));var K;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(K||(K={}));class ${constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const O={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(A(O)),this.resolve()}catch(N){this.reject(N)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new $(O=>{O.emitMany(A)})}static fromPromise(A){return new $(async O=>{O.emitMany(await A)})}static fromPromises(A){return new $(async O=>{await Promise.all(A.map(async N=>O.emitOne(await N)))})}static merge(A){return new $(async O=>{await Promise.all(A.map(async N=>{for await(const G of N)O.emitOne(G)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new $(async N=>{for await(const G of A)N.emitOne(O(G))})}map(A){return $.map(this,A)}static filter(A,O){return new $(async N=>{for await(const G of A)O(G)&&N.emitOne(G)})}filter(A){return $.filter(this,A)}static coalesce(A){return $.filter(A,O=>!!O)}coalesce(){return $.coalesce(this)}static async toPromise(A){const O=[];for await(const N of A)O.push(N);return O}toPromise(){return $.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class F extends ${constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=F;function _(T){const A=new p.CancellationTokenSource,O=T(A.token);return new F(A,async N=>{const G=A.token.onCancellationRequested(()=>{G.dispose(),A.dispose(),N.reject(new n.CancellationError)});try{for await(const ne of O){if(A.token.isCancellationRequested)return;N.emitOne(ne)}G.dispose(),A.dispose()}catch(ne){G.dispose(),A.dispose(),N.reject(ne)}})}e.createCancelableAsyncIterable=_}),define(Z[114],x([0,1,8,28,35,9,3,27]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",b="[^/\\\\]",P=/\//g;function S(U){switch(U){case 0:return"";case 1:return`${b}*?`;default:return`(?:${y}|${b}+${y}|${y}${b}+)*?`}}function w(U,B){if(!U)return[];const K=[];let $=!1,F=!1,_="";for(const T of U){switch(T){case B:if(!$&&!F){K.push(_),_="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":F=!0;break;case"]":F=!1;break}_+=T}return _&&K.push(_),K}e.splitGlobAware=w;function t(U){if(!U)return"";let B="";const K=w(U,e.GLOB_SPLIT);if(K.every($=>$===e.GLOBSTAR))B=".*";else{let $=!1;K.forEach((F,_)=>{if(F===e.GLOBSTAR){$||(B+=S(2),$=!0);return}let T=!1,A="",O=!1,N="";for(const G of F){if(G!=="}"&&T){A+=G;continue}if(O&&(G!=="]"||!N)){let ne;G==="-"?ne=G:(G==="^"||G==="!")&&!N?ne="^":G===e.GLOB_SPLIT?ne="":ne=(0,E.escapeRegExpCharacters)(G),N+=ne;continue}switch(G){case"{":T=!0;continue;case"[":O=!0;continue;case"}":{B+=`(?:${w(A,",").map(ae=>t(ae)).join("|")})`,T=!1,A="";break}case"]":B+="["+N+"]",O=!1,N="";break;case"?":B+=b;continue;case"*":B+=S(1);continue;default:B+=(0,E.escapeRegExpCharacters)(G)}}_<K.length-1&&(K[_+1]!==e.GLOBSTAR||_+2<K.length)&&(B+=y),$=!1})}return B}const d=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,k=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new D.LRUCache(1e4),o=function(){return!1},u=function(){return null};function s(U,B){if(!U)return u;let K;typeof U!="string"?K=U.pattern:K=U,K=K.trim();const $=`${K}_${!!B.trimForExclusions}`;let F=c.get($);if(F)return i(F,U);let _;if(d.test(K)){const T=K.substr(4);F=function(A,O){return typeof A=="string"&&A.endsWith(T)?K:null}}else(_=m.exec(r(K,B)))?F=a(_[1],K):(B.trimForExclusions?k:v).test(K)?F=h(K,B):(_=l.exec(r(K,B)))?F=I(_[1].substr(1),K,!0):(_=f.exec(r(K,B)))?F=I(_[1],K,!1):F=R(K);return c.set($,F),i(F,U)}function i(U,B){return typeof B=="string"?U:function(K,$){return(0,n.isEqualOrParent)(K,B.base,!M.isLinux)?U(K.substr(B.base.length+1),$):null}}function r(U,B){return B.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function a(U,B){const K=`/${U}`,$=`\\${U}`,F=function(T,A){return typeof T!="string"?null:A?A===U?B:null:T===U||T.endsWith(K)||T.endsWith($)?B:null},_=[U];return F.basenames=_,F.patterns=[B],F.allBasenames=_,F}function h(U,B){const K=J(U.slice(1,-1).split(",").map(A=>s(A,B)).filter(A=>A!==u),U),$=K.length;if(!$)return u;if($===1)return K[0];const F=function(A,O){for(let N=0,G=K.length;N<G;N++)if(K[N](A,O))return U;return null},_=K.find(A=>!!A.allBasenames);_&&(F.allBasenames=_.allBasenames);const T=K.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function I(U,B,K){const $=C.sep===C.posix.sep,F=$?U:U.replace(P,C.sep),_=C.sep+F,T=C.posix.sep+U,A=K?function(O,N){return typeof O=="string"&&(O===F||O.endsWith(_)||!$&&(O===U||O.endsWith(T)))?B:null}:function(O,N){return typeof O=="string"&&(O===F||!$&&O===U)?B:null};return A.allPaths=[(K?"*/":"./")+U],A}function R(U){try{const B=new RegExp(`^${t(U)}$`);return function(K){return B.lastIndex=0,typeof K=="string"&&B.test(K)?U:null}}catch{return u}}function L(U,B,K){return!U||typeof B!="string"?!1:W(U)(B,void 0,K)}e.match=L;function W(U,B={}){if(!U)return o;if(typeof U=="string"||ee(U)){const K=s(U,B);if(K===u)return o;const $=function(F,_){return!!K(F,_)};return K.allBasenames&&($.allBasenames=K.allBasenames),K.allPaths&&($.allPaths=K.allPaths),$}return H(U,B)}e.parse=W;function z(U){if(!U)return;let B;return K=>(B||(B=(U()||Promise.resolve([])).then($=>$?ie($):{})),B.then($=>!!$[K]))}e.hasSiblingPromiseFn=z;function Q(U){if(!U)return;let B;return K=>{if(!B){const $=U();B=$?ie($):{}}return!!B[K]}}e.hasSiblingFn=Q;function ie(U){const B={};for(const K of U)B[K]=!0;return B}function ee(U){const B=U;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=ee;function q(U){return U.allBasenames||[]}e.getBasenameTerms=q;function X(U){return U.allPaths||[]}e.getPathTerms=X;function H(U,B){const K=J(Object.getOwnPropertyNames(U).map(A=>j(A,U[A],B)).filter(A=>A!==u)),$=K.length;if(!$)return u;if(!K.some(A=>!!A.requiresSiblings)){if($===1)return K[0];const A=function(G,ne){for(let ce=0,ae=K.length;ce<ae;ce++){const re=K[ce](G,ne);if(re)return re}return null},O=K.find(G=>!!G.allBasenames);O&&(A.allBasenames=O.allBasenames);const N=K.reduce((G,ne)=>ne.allPaths?G.concat(ne.allPaths):G,[]);return N.length&&(A.allPaths=N),A}const F=function(A,O,N){let G;for(let ne=0,ce=K.length;ne<ce;ne++){const ae=K[ne];ae.requiresSiblings&&N&&(O||(O=(0,C.basename)(A)),G||(G=O.substr(0,O.length-(0,C.extname)(A).length)));const re=ae(A,O,G,N);if(re)return re}return null},_=K.find(A=>!!A.allBasenames);_&&(F.allBasenames=_.allBasenames);const T=K.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function j(U,B,K){if(B===!1)return u;const $=s(U,K);if($===u)return u;if(typeof B=="boolean")return $;if(B){const F=B.when;if(typeof F=="string"){const _=(T,A,O,N)=>{if(!N||!$(T,A))return null;const G=F.replace("$(basename)",O),ne=N(G);return(0,p.isThenable)(ne)?ne.then(ce=>ce?U:null):ne?U:null};return _.requiresSiblings=!0,_}}return $}function J(U,B){const K=U.filter(A=>!!A.basenames);if(K.length<2)return U;const $=K.reduce((A,O)=>{const N=O.basenames;return N?A.concat(N):A},[]);let F;if(B){F=[];for(let A=0,O=$.length;A<O;A++)F.push(B)}else F=K.reduce((A,O)=>{const N=O.patterns;return N?A.concat(N):A},[]);const _=function(A,O){if(typeof A!="string")return null;if(!O){let G;for(G=A.length;G>0;G--){const ne=A.charCodeAt(G-1);if(ne===47||ne===92)break}O=A.substr(G)}const N=$.indexOf(O);return N!==-1?F[N]:null};_.basenames=$,_.patterns=F,_.allBasenames=$;const T=U.filter(A=>!A.basenames);return T.push(_),T}}),define(Z[33],x([0,1,28,10,9,3,16,27,7]),function(V,e,p,n,D,C,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(i,r,a){if(typeof i=="string"&&(i=g.URI.file(i)),a){const I=a.getWorkspaceFolder(i);if(I){const R=a.getWorkspace().folders.length>1;let L;if((0,M.isEqual)(I.uri,i)?L="":L=(0,M.relativePath)(I.uri,i),R){const W=I.name?I.name:(0,M.basename)(I.uri);L=L?W+" \u2022 "+L:W}return L}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,D.normalize)(P(i.fsPath));let h=(0,D.normalize)(i.fsPath);return!C.isWindows&&r?.userHome&&(h=w(h,r.userHome.fsPath)),h}e.getPathLabel=y;function b(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const r=(0,M.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,p.isRootOrDriveLetter)(r)?P(r):r}e.getBaseLabel=b;function P(i,r){return(0,p.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let S=Object.create(null);function w(i,r){if(C.isWindows||!i||!r)return i;let a=S.original===r?S.normalized:void 0;return a||(a=`${(0,E.rtrim)(r,D.posix.sep)}${D.posix.sep}`,S={original:r,normalized:a}),(C.isLinux?i.startsWith(a):(0,E.startsWithIgnoreCase)(i,a))&&(i=`~/${i.substr(a.length)}`),i}e.tildify=w;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const d="\u2026",m="\\\\",v="~";function k(i,r=D.sep){const a=new Array(i.length);let h=!1;for(let I=0;I<i.length;I++){let R=i[I];if(R===""){a[I]=`.${r}`;continue}if(!R){a[I]=R;continue}h=!0;let L="";R.indexOf(m)===0?(L=R.substr(0,R.indexOf(m)+m.length),R=R.substr(R.indexOf(m)+m.length)):R.indexOf(r)===0?(L=R.substr(0,R.indexOf(r)+r.length),R=R.substr(R.indexOf(r)+r.length)):R.indexOf(v)===0&&(L=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const W=R.split(r);for(let z=1;h&&z<=W.length;z++)for(let Q=W.length-z;h&&Q>=0;Q--){h=!1;let ie=W.slice(Q,Q+z).join(r);for(let ee=0;!h&&ee<i.length;ee++)if(ee!==I&&i[ee]&&i[ee].indexOf(ie)>-1){const q=Q+z===W.length,X=Q>0&&i[ee].indexOf(r)>-1?r+ie:ie,H=i[ee].endsWith(X);h=!q||H}if(!h){let ee="";(W[0].endsWith(":")||L!=="")&&(Q===1&&(Q=0,z++,ie=W[0]+r+ie),Q>0&&(ee=W[0]+r),ee=L+ee),Q>0&&(ee=ee+d+r),ee=ee+ie,Q+z<W.length&&(ee=ee+r+d),a[I]=ee}}h&&(a[I]=R)}return a}e.shorten=k;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function f(i,r=Object.create(null)){const a=[];let h=!1,I="";for(const R of i)if(R==="$"||h&&R==="{")I&&a.push({value:I,type:l.TEXT}),I="",h=!0;else if(R==="}"&&h){const L=r[I];if(typeof L=="string")L.length&&a.push({value:L,type:l.VARIABLE});else if(L){const W=a[a.length-1];(!W||W.type!==l.SEPARATOR)&&a.push({value:L.label,type:l.SEPARATOR})}I="",h=!1}else I+=R;return I&&!h&&a.push({value:I,type:l.TEXT}),a.filter((R,L)=>{if(R.type===l.SEPARATOR){const W=a[L-1],z=a[L+1];return[W,z].every(Q=>Q&&(Q.type===l.VARIABLE||Q.type===l.TEXT)&&Q.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=f;function c(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function s(i){const r=i.indexOf("/")!==-1?D.posix:D.win32,a=r.basename(i),h=r.dirname(i);return a.length?{name:a,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(Z[115],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(b){return b.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const S=this._uriTransformer.transformIncoming(P);return S===P?P:n(p.URI.from(S))}transformOutgoing(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:n(p.URI.from(S))}transformOutgoingURI(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:p.URI.from(S)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,P,S){if(!b||S>200)return null;if(typeof b=="object"){if(b instanceof p.URI)return P.transformOutgoing(b);for(let w in b)if(Object.hasOwnProperty.call(b,w)){const t=C(b[w],P,S+1);t!==null&&(b[w]=t)}}return null}function M(b,P){const S=C(b,P,0);return S===null?b:S}e.transformOutgoingURIs=M;function E(b,P,S,w){if(!b||w>200)return null;if(typeof b=="object"){if(b.$mid===1)return S?p.URI.revive(P.transformIncoming(b)):P.transformIncoming(b);for(let t in b)if(Object.hasOwnProperty.call(b,t)){const d=E(b[t],P,S,w+1);d!==null&&(b[t]=d)}}return null}function g(b,P){const S=E(b,P,!1,0);return S===null?b:S}e.transformIncomingURIs=g;function y(b,P){const S=E(b,P,!0,0);return S===null?b:S}e.transformAndReviveIncomingURIs=y}),define(Z[31],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(g){return p.test(g)}e.isUUID=n;const D=new Uint8Array(16),C=[];for(let g=0;g<256;g++)C.push(g.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(g){for(let y=0;y<g.length;y++)g[y]=Math.floor(Math.random()*256);return g};function E(){M(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let g=0,y="";return y+=C[D[g++]],y+=C[D[g++]],y+=C[D[g++]],y+=C[D[g++]],y+="-",y+=C[D[g++]],y+=C[D[g++]],y+="-",y+=C[D[g++]],y+=C[D[g++]],y+="-",y+=C[D[g++]],y+=C[D[g++]],y+="-",y+=C[D[g++]],y+=C[D[g++]],y+=C[D[g++]],y+=C[D[g++]],y+=C[D[g++]],y+=C[D[g++]],y}e.generateUuid=E}),define(Z[116],x([0,1,15,4,2,3,14,27]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const g="$initialize";let y=!1;function b(s){!C.isWeb||(y||(y=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=b;var P;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(P||(P={}));class S{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.method=a,this.args=h,this.type=0}}class w{constructor(i,r,a,h){this.vsWorker=i,this.seq=r,this.res=a,this.err=h,this.type=1}}class t{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.eventName=a,this.arg=h,this.type=2}}class d{constructor(i,r,a){this.vsWorker=i,this.req=r,this.event=a,this.type=3}}class m{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const a=String(++this._lastSentReq);return new Promise((h,I)=>{this._pendingReplies[a]={resolve:h,reject:I},this._send(new S(this._workerId,a,i,r))})}listen(i,r){let a=null;const h=new n.Emitter({onFirstListenerAdd:()=>{a=String(++this._lastSentReq),this._pendingEmitters.set(a,h),this._send(new t(this._workerId,a,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(a),this._send(new m(this._workerId,a)),a=null}});return h.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let a=i.err;i.err.$isError&&(a=new Error,a.name=i.err.name,a.message=i.err.message,a.stack=i.err.stack),r.reject(a);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(h=>{this._send(new w(this._workerId,r,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,p.transformErrorForSerialization)(h.detail)),this._send(new w(this._workerId,r,void 0,(0,p.transformErrorForSerialization)(h)))})}_handleSubscribeEventMessage(i){const r=i.req,a=this._handler.handleEvent(i.eventName,i.arg)(h=>{this._send(new d(this._workerId,r,h))});this._pendingEvents.set(r,a)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let a=0;a<i.args.length;a++)i.args[a]instanceof ArrayBuffer&&r.push(i.args[a]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class k extends D.Disposable{constructor(i,r,a){super();let h=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",z=>{this._protocol.handleMessage(z)},z=>{h&&h(z)})),this._protocol=new v({sendMessage:(z,Q)=>{this._worker.postMessage(z,Q)},handleMessage:(z,Q)=>{if(typeof a[z]!="function")return Promise.reject(new Error("Missing method "+z+" on main thread host."));try{return Promise.resolve(a[z].apply(a,Q))}catch(ie){return Promise.reject(ie)}},handleEvent:(z,Q)=>{if(f(z)){const ie=a[z].call(a,Q);if(typeof ie!="function")throw new Error(`Missing dynamic event ${z} on main thread host.`);return ie}if(l(z)){const ie=a[z];if(typeof ie!="function")throw new Error(`Missing event ${z} on main thread host.`);return ie}throw new Error(`Malformed event name ${z}`)}}),this._protocol.setWorkerId(this._worker.getId());let I=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?I=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(I=C.globals.requirejs.s.contexts._.config);const R=M.getAllMethodNames(a);this._onModuleLoaded=this._protocol.sendMessage(g,[this._worker.getId(),JSON.parse(JSON.stringify(I)),r,R]);const L=(z,Q)=>this._request(z,Q),W=(z,Q)=>this._protocol.listen(z,Q);this._lazyProxy=new Promise((z,Q)=>{h=Q,this._onModuleLoaded.then(ie=>{z(c(ie,L,W))},ie=>{Q(ie),this._onError("Worker failed to load "+r,ie)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((a,h)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(a,h)},h)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=k;function l(s){return s[0]==="o"&&s[1]==="n"&&E.isUpperAsciiLetter(s.charCodeAt(2))}function f(s){return/^onDynamic/.test(s)&&E.isUpperAsciiLetter(s.charCodeAt(9))}function c(s,i,r){const a=R=>function(){const L=Array.prototype.slice.call(arguments,0);return i(R,L)},h=R=>function(L){return r(R,L)};let I={};for(const R of s){if(f(R)){I[R]=h(R);continue}if(l(R)){I[R]=r(R,void 0);continue}I[R]=a(R)}return I}class o{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new v({sendMessage:(a,h)=>{i(a,h)},handleMessage:(a,h)=>this._handleMessage(a,h),handleEvent:(a,h)=>this._handleEvent(a,h)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===g)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(a){return Promise.reject(a)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(f(i)){const a=this._requestHandler[i].call(this._requestHandler,r);if(typeof a!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return a}if(l(i)){const a=this._requestHandler[i];if(typeof a!="function")throw new Error(`Missing event ${i} on request handler.`);return a}throw new Error(`Malformed event name ${i}`)}initialize(i,r,a,h){this._protocol.setWorkerId(i);const L=c(h,(W,z)=>this._protocol.sendMessage(W,z),(W,z)=>this._protocol.listen(W,z));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(M.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,C.globals.require.config(r)),new Promise((W,z)=>{(C.globals.require||V)([a],ie=>{if(this._requestHandler=ie.create(L),!this._requestHandler){z(new Error("No RequestHandler!"));return}W(M.getAllMethodNames(this._requestHandler))},z)}))}}e.SimpleWorkerServer=o;function u(s){return new o(s,null)}e.create=u}),define(Z[117],x([0,1,60,29,43]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(M,E){if(await new Promise((b,P)=>{const S=n.createReadStream(M),w=p.createHash("sha1");S.pipe(w);const t=(0,D.once)((d,m)=>{S.removeAllListeners(),w.removeAllListeners(),d?P(d):b(m)});S.once("error",t),S.once("end",t),w.once("error",t),w.once("data",d=>t(void 0,d.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=C}),define(Z[118],x([0,1,247]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new p.StringDecoder(C),this.remaining=null}write(C){const M=[],E=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(E.length<1)return M;let g=0,y,b=g;for(;b<E.length;)if(y=E.charCodeAt(b),y===13||y===10){if(M.push(E.substring(g,b)),b++,b<E.length){const P=y;y=E.charCodeAt(b),(P===13&&y===10||P===10&&y===13)&&b++}g=b}else b++;return this.remaining=g<E.length?E.substr(g):null,M}end(){return this.remaining}}e.LineDecoder=n}),define(Z[119],x([0,1,25]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(M){const E=M.replace(/\-/g,":").toLowerCase();return!n.has(E)}function C(){const M=(0,p.networkInterfaces)();for(let E in M){const g=M[E];if(g){for(const{mac:y}of g)if(D(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(Z[71],x([0,1,25,15,35,31,119]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,P=0;const S=(0,p.networkInterfaces)();for(let w in S){const t=S[w];if(t)for(const{mac:d,internal:m}of t)m||(P+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(b+=1))}this._value=P>0?b/P:0}return this._value}};let E;async function g(){return E||(E=(async()=>await y()||C.generateUuid())()),E}e.getMachineId=g;async function y(){try{const b=await new Promise((S,w)=>{V(["crypto"],S,w)}),P=(0,M.getMac)();return b.createHash("sha256").update(P,"utf8").digest("hex")}catch(b){n.onUnexpectedError(b);return}}}),define(Z[24],x([0,1,29,25,120,8,28,70,9,3,16,7]),function(V,e,p,n,D,C,M,E,g,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function w(q,X=S.UNLINK){if((0,M.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return X===S.UNLINK?d(q):t(q)}async function t(q){try{const X=(0,M.randomPath)((0,n.tmpdir)());try{await p.promises.rename(q,X)}catch{return d(q)}d(X).catch(H=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function d(q){return(0,D.promisify)(p.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function m(q){if((0,M.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");p.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function v(q,X){return f(await(X?k(q):(0,D.promisify)(p.readdir)(q)))}async function k(q){try{return await(0,D.promisify)(p.readdir)(q,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const X=[],H=await v(q);for(const j of H){let J=!1,U=!1,B=!1;try{const K=await e.Promises.lstat((0,g.join)(q,j));J=K.isFile(),U=K.isDirectory(),B=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}X.push({name:j,isFile:()=>J,isDirectory:()=>U,isSymbolicLink:()=>B})}return X}function l(q){return f(p.readdirSync(q))}e.readdirSync=l;function f(q){return q.map(X=>typeof X=="string"?y.isMacintosh?(0,E.normalizeNFC)(X):X:(X.name=y.isMacintosh?(0,E.normalizeNFC)(X.name):X.name,X))}async function c(q){const X=await v(q),H=[];for(const j of X)await u.existsDirectory((0,g.join)(q,j))&&H.push(j);return H}function o(q,X=1e3){return new Promise(H=>{let j=!1;const J=setInterval(()=>{j||(j=!0,p.access(q,U=>{j=!1,U&&(clearInterval(J),H(void 0))}))},X)})}e.whenDeleted=o;var u;(function(q){async function X(J){let U;try{if(U=await e.Promises.lstat(J),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(y.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw K}throw B}}q.stat=X;async function H(J){try{const{stat:U,symbolicLink:B}=await q.stat(J);return U.isFile()&&B?.dangling!==!0}catch{}return!1}q.existsFile=H;async function j(J){try{const{stat:U,symbolicLink:B}=await q.stat(J);return U.isDirectory()&&B?.dangling!==!0}catch{}return!1}q.existsDirectory=j})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new C.ResourceQueue;function i(q,X,H){return s.queueFor(P.URI.file(q),b.extUriBiasedIgnorePathCase).queue(()=>{const j=I(H);return new Promise((J,U)=>a(q,X,j,B=>B?U(B):J()))})}let r=!0;function a(q,X,H,j){if(!r)return p.writeFile(q,X,{mode:H.mode,flag:H.flag},j);p.open(q,H.flag,H.mode,(J,U)=>{if(J)return j(J);p.writeFile(U,X,B=>{if(B)return p.close(U,()=>j(B));p.fdatasync(U,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),r=!1),p.close(U,$=>j($))))})})}function h(q,X,H){const j=I(H);if(!r)return p.writeFileSync(q,X,{mode:j.mode,flag:j.flag});const J=p.openSync(q,j.flag,j.mode);try{p.writeFileSync(J,X);try{p.fdatasyncSync(J)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),r=!1}}finally{p.closeSync(J)}}e.writeFileSync=h;function I(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function R(q,X){if(q===X)return;async function H(j){try{const J=await e.Promises.lstat(j);if(J.isDirectory()||J.isSymbolicLink())return;await e.Promises.utimes(j,J.atime,new Date)}catch{}}try{await e.Promises.rename(q,X),await H(X)}catch(j){if(q.toLowerCase()!==X.toLowerCase()&&j.code==="EXDEV"||q.endsWith("."))await L(q,X,{preserveSymlinks:!1}),await w(q,S.MOVE),await H(X);else throw j}}async function L(q,X,H){return z(q,X,{root:{source:q,target:X},options:H,handledSourcePaths:new Set})}const W=511;async function z(q,X,H){if(H.handledSourcePaths.has(q))return;H.handledSourcePaths.add(q);const{stat:j,symbolicLink:J}=await u.stat(q);if(J){if(H.options.preserveSymlinks)try{return await ee(q,X,H)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(J.dangling)return}return j.isDirectory()?Q(q,X,j.mode&W,H):ie(q,X,j.mode&W)}async function Q(q,X,H,j){await e.Promises.mkdir(X,{recursive:!0,mode:H});const J=await v(q);for(const U of J)await z((0,g.join)(q,U),(0,g.join)(X,U),j)}async function ie(q,X,H){await e.Promises.copyFile(q,X),await e.Promises.chmod(X,H)}async function ee(q,X,H){let j=await e.Promises.readlink(q);(0,M.isEqualOrParent)(j,H.root.source,!y.isLinux)&&(j=(0,g.join)(H.root.target,j.substr(H.root.source.length+1))),await e.Promises.symlink(j,X)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(q,X,H,j,J)=>new Promise((U,B)=>{p.read(q,X,H,j,J,(K,$,F)=>K?B(K):U({bytesRead:$,buffer:F}))})}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(q,X,H,j,J)=>new Promise((U,B)=>{p.write(q,X,H,j,J,(K,$,F)=>K?B(K):U({bytesWritten:$,buffer:F}))})}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return w}get move(){return R}get copy(){return L}}}),define(Z[85],x([0,1,29,9,3,27,24]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(S){if(D.isLinux)return S;const w=(0,n.dirname)(S);if(S===w)return S;const t=((0,n.basename)(S)||S).toLowerCase();try{const m=(0,M.readdirSync)(w).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=E(w);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const k=E(w);if(k)return(0,n.join)(k,m[v])}}}catch{}return null}e.realcaseSync=E;async function g(S){if(D.isLinux)return S;const w=(0,n.dirname)(S);if(S===w)return S;const t=((0,n.basename)(S)||S).toLowerCase();try{const m=(await M.Promises.readdir(w)).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=await g(w);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const k=await g(w);if(k)return(0,n.join)(k,m[v])}}}catch{}return null}e.realcase=g;async function y(S){try{return await M.Promises.realpath(S)}catch{const t=P(S);return await M.Promises.access(t,p.constants.R_OK),t}}e.realpath=y;function b(S){try{return p.realpathSync(S)}catch{const t=P(S);return p.accessSync(t,p.constants.R_OK),t}}e.realpathSync=b;function P(S){return(0,C.rtrim)((0,n.normalize)(S),n.sep)}}),define(Z[121],x([0,1,61]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(E,g,y,b=1){let P=!1;return new Promise(S=>{const w=setTimeout(()=>{if(!P)return P=!0,S(0)},y);D(E,g,b,t=>{if(!P)return P=!0,clearTimeout(w),S(t)})})}e.findFreePort=n;function D(E,g,y,b){if(g===0)return b(0);const P=new p.Socket;P.once("connect",()=>(M(P),D(E+y,g-1,y,b))),P.once("data",()=>{}),P.once("error",S=>(M(P),S.code!=="ECONNREFUSED"?D(E+y,g-1,y,b):b(E))),P.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(E,g,y){let b=!1,P,S=1;const w=p.createServer({pauseOnConnect:!0});function t(d,m){b||(b=!0,w.removeAllListeners(),w.close(),P&&clearTimeout(P),m(d))}return new Promise(d=>{P=setTimeout(()=>{t(0,d)},y),w.on("listening",()=>{t(E,d)}),w.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&S<g?(E++,S++,w.listen(E,"127.0.0.1")):t(0,d)}),w.on("close",()=>{t(0,d)}),w.listen(E,"127.0.0.1")})}e.findFreePortFaster=C;function M(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(g){console.error(g)}}}),define(Z[122],x([0,1,25,9,24]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,M=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var g;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(g||(g={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class P{constructor(c,o,u){this.exePath=c,this.displayName=o,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:f=!1}={}){return f?y===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:f=!1,findPreview:c=!1}={}){const o=S({useAlternateBitness:f});if(!o)return null;const u=n.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(u))return null;let s=-1,i=null;for(const h of await D.Promises.readdir(u)){let I=-1;if(c){const L=h.indexOf("-");if(L<0)continue;const W=h.substring(0,L);if(!C.test(W)||h.substring(L+1)!=="preview")continue;I=parseInt(W,10)}else{if(!C.test(h))continue;I=parseInt(h,10)}if(I<=s)continue;const R=n.join(u,h,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(i=R,s=I)}if(!i)return null;const r=o.includes("x86")?" (x86)":"",a=c?" Preview":"";return new P(i,`PowerShell${a}${r}`,!0)}async function t({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:u}=f?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(c))if(o.test(s)){const i=n.join(c,s,"pwsh.exe");return new P(i,u)}return null}function d(){const f=n.join(p.homedir(),".dotnet","tools","pwsh.exe");return new P(f,".NET Core PowerShell Global Tool")}function m(){const f=n.join(process.env.windir,y===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(f,"Windows PowerShell",!0)}async function*v(){let f=await w();f&&(yield f),f=await w({useAlternateBitness:!0}),f&&(yield f),f=await t(),f&&(yield f),f=d(),f&&(yield f),f=await w({findPreview:!0}),f&&(yield f),f=await t({findPreview:!0}),f&&(yield f),f=await w({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=m(),f&&(yield f)}async function*k(){for await(const f of v())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=k;async function l(){for await(const f of k())return f;return null}e.getFirstAvailablePowerShellInstallation=l}),define(Z[86],x([0,1,45,10]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(M){return new Promise((E,g)=>{let y;const b=new Map;function P(w,t,d,m,v){const k=b.get(t);if(w===M||k){const l={name:S(d),cmd:d,pid:w,ppid:t,load:m,mem:v};b.set(w,l),w===M&&(y=l),k&&(k.children||(k.children=[]),k.children.push(l),k.children.length>1&&(k.children=k.children.sort((f,c)=>f.pid-c.pid)))}}function S(w){const t=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,k=/--crashes-directory/,l=/\\pipe\\winpty-control/,f=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(k.exec(w))return"electron-crash-reporter";if(l.exec(w))return"winpty-process";if(f.exec(w))return"console-window-host (Windows internal process)";let o=c.exec(w);if(o&&o.length===2)return o[1]==="renderer"?t.exec(w)?"shared-process":d.exec(w)?"issue-reporter":m.exec(w)?"process-explorer":"window":o[1]==="utility"&&v.exec(w)?"utility-network-service":o[1];const u=/[a-zA-Z-]+\.js/g;let s="";do o=u.exec(w),o&&(s+=o+" ");while(o);return s&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${s}`:w}if(process.platform==="win32"){const w=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,d)=>{V(["windows-process-tree"],t,d)}).then(t=>{t.getProcessList(M,d=>{t.getProcessCpuUsage(d,m=>{const v=new Map;m.forEach(k=>{const l=w(k.commandLine||"");v.set(k.pid,{name:S(l),cmd:l,pid:k.pid,ppid:k.ppid,load:k.cpu||0,mem:k.memory||0})}),y=v.get(M),y?(v.forEach(k=>{const l=v.get(k.ppid);l&&(l.children||(l.children=[]),l.children.push(k))}),v.forEach(k=>{k.children&&(k.children=k.children.sort((l,f)=>l.pid-f.pid))}),E(y)):g(new Error(`Root process ${M} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let w=function(){let t=[y];const d=[];for(;t.length;){const v=t.shift();v&&(d.push(v.pid),v.children&&(t=t.concat(v.children)))}let m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);m+=" "+d.join(" "),(0,p.exec)(m,{},(v,k,l)=>{if(v||l)g(v||new Error(l.toString()));else{const f=k.toString().split(`
`);for(let c=0;c<d.length;c++){const o=b.get(d[c]);o.load=parseFloat(f[c])}if(!y){g(new Error(`Root process ${M} not found`));return}E(y)}})};(0,p.exec)("which ps",{},(t,d,m)=>{if(t||m)if(process.platform!=="linux")g(t||new Error(m.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,p.exec)(v,{},(k,l,f)=>{k||f?g(k||new Error(f.toString())):(C(l,P),w())})}else{const v=d.toString().trim(),k="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${k}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,f,c)=>{l||c&&!c.includes("screen size is bogus")?g(l||new Error(c.toString())):(C(f,P),process.platform==="linux"?w():y?E(y):g(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=D;function C(M,E){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=M.toString().split(`
`);for(const b of y){const P=g.exec(b.trim());P&&P.length===6&&E(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(Z[123],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[124],x([0,1,12,14,123]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(E,g,y,b,P)=>{const S=M(E,b,y);S.popup({window:(0,n.withNullAsUndefined)(p.BrowserWindow.fromWebContents(E.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{S&&E.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=C;function M(E,g,y){const b=new p.Menu;return y.forEach(P=>{let S;P.type==="separator"?S=new p.MenuItem({type:P.type}):Array.isArray(P.submenu)?S=new p.MenuItem({submenu:M(E,g,P.submenu),label:P.label}):S=new p.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(w,t,d)=>E.sender.send(g,P.id,d)}),b.append(S)}),b}});var ue=this&&this.__decorate||function(V,e,p,n){var D=arguments.length,C=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,p):n,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(V,e,p,n);else for(var E=V.length-1;E>=0;E--)(M=V[E])&&(C=(D<3?M(C):D>3?M(e,p,C):M(e,p))||C);return D>3&&C&&Object.defineProperty(e,p,C),C};define(Z[37],x([0,1,30,8,17,23,46,15,4,2,113,27,14]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function t(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function m(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(v||(v={}));class k{constructor(B){this.buffer=B,this.pos=0}read(B){const K=this.buffer.slice(this.pos,this.pos+B);return this.pos+=K.byteLength,K}}class l{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var f;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(f||(f={}));function c(U){const B=D.VSBuffer.alloc(4);return B.writeUInt32BE(U,0),B}function o(U){return U.read(4).readUInt32BE(0)}function u(U){const B=D.VSBuffer.alloc(1);return B.writeUInt8(U,0),B}const s={Undefined:u(f.Undefined),String:u(f.String),Buffer:u(f.Buffer),VSBuffer:u(f.VSBuffer),Array:u(f.Array),Object:u(f.Object)},i=typeof Buffer!="undefined";function r(U,B){if(typeof B=="undefined")U.write(s.Undefined);else if(typeof B=="string"){const K=D.VSBuffer.fromString(B);U.write(s.String),U.write(c(K.byteLength)),U.write(K)}else if(i&&Buffer.isBuffer(B)){const K=D.VSBuffer.wrap(B);U.write(s.Buffer),U.write(c(K.byteLength)),U.write(K)}else if(B instanceof D.VSBuffer)U.write(s.VSBuffer),U.write(c(B.byteLength)),U.write(B);else if(Array.isArray(B)){U.write(s.Array),U.write(c(B.length));for(const K of B)r(U,K)}else{const K=D.VSBuffer.fromString(JSON.stringify(B));U.write(s.Object),U.write(c(K.byteLength)),U.write(K)}}function a(U){switch(U.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return U.read(o(U)).toString();case f.Buffer:return U.read(o(U)).buffer;case f.VSBuffer:return U.read(o(U));case f.Array:{const K=o(U),$=[];for(let F=0;F<K;F++)$.push(a(U));return $}case f.Object:return JSON.parse(U.read(o(U)).toString())}}class h{constructor(B,K,$=null,F=1e3){this.protocol=B,this.ctx=K,this.logger=$,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(B,K){this.channels.set(B,K),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const K=this.send([B.type]);this.logger&&this.logger.logOutgoing(K,0,1,m(B.type));return}case 201:case 202:case 204:case 203:{const K=this.send([B.type,B.id],B.data);this.logger&&this.logger.logOutgoing(K,B.id,1,m(B.type),B.data);return}}}send(B,K=void 0){const $=new l;return r($,B),r($,K),this.sendBuffer($.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const K=new k(B),$=a(K),F=a(K),_=$[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${t(_)}: ${$[2]}.${$[3]}`,F),this.onPromise({type:_,id:$[1],channelName:$[2],name:$[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${t(_)}: ${$[2]}.${$[3]}`,F),this.onEventListen({type:_,id:$[1],channelName:$[2],name:$[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${t(_)}`),this.disposeActiveRequest({type:_,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${t(_)}`),this.disposeActiveRequest({type:_,id:$[1]})}}onPromise(B){const K=this.channels.get(B.channelName);if(!K){this.collectPendingRequest(B);return}const $=new C.CancellationTokenSource;let F;try{F=K.call(this.ctx,B.name,B.arg,$.token)}catch(A){F=Promise.reject(A)}const _=B.id;F.then(A=>{this.sendResponse({id:_,data:A,type:201}),this.activeRequests.delete(B.id)},A=>{A instanceof Error?this.sendResponse({id:_,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:_,data:A,type:203}),this.activeRequests.delete(B.id)});const T=(0,y.toDisposable)(()=>$.cancel());this.activeRequests.set(B.id,T)}onEventListen(B){const K=this.channels.get(B.channelName);if(!K){this.collectPendingRequest(B);return}const $=B.id,_=K.listen(this.ctx,B.name,B.arg)(T=>this.sendResponse({id:$,data:T,type:204}));this.activeRequests.set(B.id,_)}disposeActiveRequest(B){const K=this.activeRequests.get(B.id);K&&(K.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let K=this.pendingRequests.get(B.channelName);K||(K=[],this.pendingRequests.set(B.channelName,K));const $=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:B,timeoutTimer:$})}flushPendingRequests(B){const K=this.pendingRequests.get(B);if(K){for(const $ of K)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var I;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(B,K=null){this.protocol=B,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=K}getChannel(B){const K=this;return{call($,F,_){return K.isDisposed?Promise.reject(E.canceled()):K.requestPromise(B,$,F,_)},listen($,F){return K.isDisposed?Promise.reject(E.canceled()):K.requestEvent(B,$,F)}}}requestPromise(B,K,$,F=C.CancellationToken.None){const _=this.lastRequestId++,A={id:_,type:100,channelName:B,name:K,arg:$};if(F.isCancellationRequested)return Promise.reject(E.canceled());let O;return new Promise((G,ne)=>{if(F.isCancellationRequested)return ne(E.canceled());const ce=()=>{const he=me=>{switch(me.type){case 201:this.handlers.delete(_),G(me.data);break;case 202:{this.handlers.delete(_);const ke=new Error(me.data.message);ke.stack=me.data.stack,ke.name=me.data.name,ne(ke);break}case 203:this.handlers.delete(_),ne(me.data);break}};this.handlers.set(_,he),this.sendRequest(A)};let ae=null;this.state===v.Idle?ce():(ae=(0,n.createCancelablePromise)(he=>this.whenInitialized()),ae.then(()=>{ae=null,ce()}));const re=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:_,type:101}),ne(E.canceled())},le=F.onCancellationRequested(re);O=(0,y.combinedDisposable)((0,y.toDisposable)(re),le),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(B,K,$){const F=this.lastRequestId++,T={id:F,type:102,channelName:B,name:K,arg:$};let A=null;const O=new g.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(G=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(T)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:F,type:103}))}}),N=G=>O.fire(G.data);return this.handlers.set(F,N),O.event}sendRequest(B){switch(B.type){case 100:case 102:{const K=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger&&this.logger.logOutgoing(K,B.id,0,`${t(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const K=this.send([B.type,B.id]);this.logger&&this.logger.logOutgoing(K,B.id,0,t(B.type));return}}}send(B,K=void 0){const $=new l;return r($,B),r($,K),this.sendBuffer($.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const K=new k(B),$=a(K),F=a(K),_=$[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(B.byteLength,0,0,m(_)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],0,m(_),F),this.onResponse({type:$[0],id:$[1],data:F})}}onResponse(B){if(B.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(B.id);K&&K(B)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}ue([M.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class L{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:K,onDidClientDisconnect:$})=>{g.Event.once(K.onMessage)(_=>{const T=new k(_),A=a(T),O=new h(K,A),N=new R(K);this.channels.forEach((ne,ce)=>O.registerChannel(ce,ne));const G={channelServer:O,channelClient:N,ctx:A};this._connections.add(G),this._onDidAddConnection.fire(G),$(()=>{O.dispose(),N.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)})})})}get connections(){const B=[];return this._connections.forEach(K=>B.push(K)),B}getChannel(B,K){const $=this;return{call(F,_,T){let A;if((0,S.isFunction)(K)){let N=(0,p.getRandomElement)($.connections.filter(K));A=N?Promise.resolve(N):g.Event.toPromise(g.Event.filter($.onDidAddConnection,K))}else A=K.routeCall($,F,_);const O=A.then(N=>N.channelClient.getChannel(B));return z(O).call(F,_,T)},listen(F,_){if((0,S.isFunction)(K))return $.getMulticastEvent(B,K,F,_);const T=K.routeEvent($,F,_).then(A=>A.channelClient.getChannel(B));return z(T).listen(F,_)}}}getMulticastEvent(B,K,$,F){const _=this;let T=new y.DisposableStore;const A=new g.Emitter({onFirstListenerAdd:()=>{T=new y.DisposableStore;const O=new g.EventMultiplexer,N=new Map,G=ce=>{const re=ce.channelClient.getChannel(B).listen($,F),le=O.add(re);N.set(ce,le)},ne=ce=>{const ae=N.get(ce);!ae||(ae.dispose(),N.delete(ce))};_.connections.filter(K).forEach(G),g.Event.filter(_.onDidAddConnection,K)(G,void 0,T),_.onDidRemoveConnection(ne,void 0,T),O.event(A.fire,A,T),T.add(O)},onLastListenerRemove:()=>{T.dispose()}});return A.event}registerChannel(B,K){this.channels.set(B,K),this._connections.forEach($=>{$.channelServer.registerChannel(B,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class W{constructor(B,K,$=null){const F=new l;r(F,K),B.send(F.buffer),this.channelClient=new R(B,$),this.channelServer=new h(B,K,$)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,K){this.channelServer.registerChannel(B,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function z(U){return{call(B,K,$){return U.then(F=>F.call(B,K,$))},listen(B,K){const $=new g.Relay;return U.then(F=>$.input=F.listen(B,K)),$.event}}}e.getDelayedChannel=z;function Q(U){let B=!1;return{call(K,$,F){return B?U.call(K,$,F):(0,n.timeout)(0).then(()=>B=!0).then(()=>U.call(K,$,F))},listen(K,$){if(B)return U.listen(K,$);const F=new g.Relay;return(0,n.timeout)(0).then(()=>B=!0).then(()=>F.input=U.listen(K,$)),F.event}}}e.getNextTickChannel=Q;class ie{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const K of B.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await g.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=ie;var ee;(function(U){function B(_,T){const A=_,O=T&&T.disableMarshalling,N=new Map;for(const G in A)$(G)&&N.set(G,g.Event.buffer(A[G],!0));return new class{listen(G,ne,ce){const ae=N.get(ne);if(ae)return ae;if(F(ne)){const re=A[ne];if(typeof re=="function")return re.call(A,ce)}throw new Error(`Event not found: ${ne}`)}call(G,ne,ce){const ae=A[ne];if(typeof ae=="function"){if(!O&&Array.isArray(ce))for(let re=0;re<ce.length;re++)ce[re]=(0,b.revive)(ce[re]);return ae.apply(A,ce)}throw new Error(`Method not found: ${ne}`)}}}U.fromService=B;function K(_,T){const A=T&&T.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return T?.properties?.has(N)?T.properties.get(N):F(N)?function(G){return _.listen(N,G)}:$(N)?_.listen(N):async function(...G){let ne;T&&!(0,S.isUndefinedOrNull)(T.context)?ne=[T.context,...G]:ne=G;const ce=await _.call(N,ne);return A?ce:(0,b.revive)(ce)};throw new Error(`Property not found: ${String(N)}`)}})}U.toService=K;function $(_){return _[0]==="o"&&_[1]==="n"&&P.isUpperAsciiLetter(_.charCodeAt(2))}function F(_){return/^onDynamic/.test(_)&&P.isUpperAsciiLetter(_.charCodeAt(9))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let B=U.toString();if(B!=="[object Object]")return B}return U}function H(U){return Array.isArray(U)?U.map(X):X(U)}function j(U,B,K,$,F,_,T){T=H(T);const A=q[F],O=A[$%A.length];let N=[`%c[${U}]%c[${String(B).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String($).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(_)?(N=N.concat(T),N.push(")")):N.push(T),console.log.apply(console,N)}e.logWithColors=j;class J{constructor(B,K){this._outgoingPrefix=B,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,K,$,F,_){this._totalOutgoing+=B,j(this._outgoingPrefix,this._totalOutgoing,B,K,$,F,_)}logIncoming(B,K,$,F,_){this._totalIncoming+=B,j(this._incomingPrefix,this._totalIncoming,B,K,$,F,_)}}e.IPCLogger=J}),define(Z[125],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[126],x([0,1,17,4,37]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(g){this.port=g,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",y=>p.VSBuffer.wrap(y.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class M extends D.IPCClient{constructor(g,y){const b=new C(g);super(b,y);this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Z[87],x([0,1,17,4,2,37]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let a=0;function h(R,L){if(!r.has(R)){const W=String(++a);r.set(R,W)}return r.get(R)}function I(R,L,W,z){if(!i.enableDiagnostics)return;const Q=h(R,L);if(z instanceof p.VSBuffer||z instanceof Uint8Array||z instanceof ArrayBuffer||ArrayBuffer.isView(z)){const ie=p.VSBuffer.alloc(z.byteLength);ie.set(z),i.records.push({timestamp:Date.now(),id:Q,label:L,type:W,buff:ie})}else i.records.push({timestamp:Date.now(),id:Q,label:L,type:W,data:z})}i.traceSocketEvent=I})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function b(){return y||(y=p.VSBuffer.alloc(0)),y}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return b();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),L}if(this._chunks[0].byteLength>r){const L=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),L}let h=p.VSBuffer.alloc(r),I=0,R=0;for(;r>0;){const L=this._chunks[R];if(L.byteLength>r){const W=L.slice(0,r);h.set(W,I),I+=r,a&&(this._chunks[R]=L.slice(r),this._totalLength-=r),r-=r}else h.set(L,I),I+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):R++,r-=L.byteLength}return h}}e.ChunkStream=P;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(S||(S={}));function w(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,a,h,I){this.type=r,this.id=a,this.ack=h,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const h=this._state.messageType,I=this._state.id,R=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new d(h,I,R,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=p.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(a,r.data)}_bufferAdd(r,a){const h=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,h}_bufferTake(){const r=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class k extends D.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=k;class l extends C.IPCClient{constructor(r,a,h=null){super(r,a,h);this.protocol=r}static fromSocket(r,a){return new l(new k(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=l;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,h=this._first;for(;h;)r[a++]=h.data,h=h.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new c(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class u{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<u._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=u._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const r=Date.now(),a=(1+u._HISTORY_LENGTH)*1e3;let h=0;for(let I=0;I<u._HISTORY_LENGTH;I++)r-this.lastRuns[I]<=a&&h++;return 1-h/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class s{constructor(r,a=null,h=u.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=h,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.push(this._socket.onClose(I=>this._onSocketClose.fire(I))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,b());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,b());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,b());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r);const a=this._outgoingUnackMsg.toArray();for(let h=0,I=a.length;h<I;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new d(6,0,0,b())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let h=0,I=a.length;h<I;h++)this._socketWriter.write(a[h]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new d(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(r){const a=new d(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime,h=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&h>=2e4&&I>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const R=Math.max(2e4-a,2e4-h,2e4-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},R)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(Z[127],x([0,1,12,17,4,2,37,125]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(b,P){const S=D.Event.fromNodeEventEmitter(p.ipcMain,P,(t,d)=>({event:t,message:d})),w=D.Event.filter(S,({event:t})=>t.sender.id===b);return D.Event.map(w,({message:t})=>t&&n.VSBuffer.wrap(t))}class y extends M.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const P=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:S})=>S);return D.Event.map(P,S=>{const w=S.id,t=y.Clients.get(w);t&&t.dispose();const d=new D.Emitter;y.Clients.set(w,(0,C.toDisposable)(()=>d.fire()));const m=g(w,"vscode:message"),v=D.Event.any(D.Event.signal(g(w,"vscode:disconnect")),d.event);return{protocol:new E.Protocol(S,m),onDidClientDisconnect:v}})}}e.Server=y,y.Clients=new Map}),define(Z[88],x([0,1,12,4,31,126]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends C.Client{constructor(y,b){super({addEventListener:(P,S)=>y.addListener(P,S),removeEventListener:(P,S)=>y.removeListener(P,S),postMessage:P=>y.postMessage(P),start:()=>y.start(),close:()=>y.close()},b)}}e.Client=M;async function E(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=(0,D.generateUuid)();g.webContents.send("vscode:createMessageChannel",y);const b=n.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(S,w)=>({nonce:w,port:S.ports[0]})),{port:P}=await n.Event.toPromise(n.Event.once(n.Event.filter(b,S=>S.nonce===y)));return P}e.connect=E}),define(Z[89],x([0,1,8,4,2,14]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function E(P){const S=P;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var g;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(g||(g={}));class y extends D.Disposable{constructor(S,w=Object.create(null)){super();this.database=S,this.options=w,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((w,t)=>this.accept(t,w)),S.deleted?.forEach(w=>this.accept(w,void 0))}accept(S,w){if(this.state===g.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(w)?t=this.cache.delete(S):this.cache.get(S)!==w&&(this.cache.set(S,w),t=!0),t&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,w){const t=this.cache.get(S);return(0,C.isUndefinedOrNull)(t)?w:t}getBoolean(S,w){const t=this.get(S);return(0,C.isUndefinedOrNull)(t)?w:t==="true"}getNumber(S,w){const t=this.get(S);return(0,C.isUndefinedOrNull)(t)?w:parseInt(t,10)}async set(S,w){if(this.state===g.Closed)return;if((0,C.isUndefinedOrNull)(w))return this.delete(S);const t=String(w);if(this.cache.get(S)!==t)return this.cache.set(S,t),this.pendingInserts.set(S,t),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===g.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert&&S.insert.forEach((w,t)=>this.items.set(t,w)),S.delete&&S.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=b}),define(Z[128],x([0,1,8,4,35,9,24]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(b,P=Object.create(null)){this.path=b,this.options=P,this.name=(0,C.basename)(this.path),this.logger=new g(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const b=await this.whenConnected,P=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(w=>P.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(b){const P=await this.whenConnected;return this.doUpdateItems(P,b)}doUpdateItems(b,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,D.mapToString)(P.insert):"0"}), delete(${P.delete?(0,D.setToString)(P.delete):"0"})`),this.transaction(b,()=>{const S=P.insert,w=P.delete;if(S&&S.size>0){const t=[];t.push([]);let d=0;S.forEach((m,v)=>{let k=t[d];k.length>E.MAX_HOST_PARAMETERS&&(d++,k=[],t.push(k)),k.push(v,m)}),t.forEach(m=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,v=>v.run(m),()=>{const v=[];let k=0;return S.forEach((l,f)=>{v.push(f),k+=l.length}),`Keys: ${v.join(", ")} Length: ${k}`})})}if(w&&w.size){const t=[];t.push([]);let d=0;w.forEach(m=>{let v=t[d];v.length>E.MAX_HOST_PARAMETERS&&(d++,v=[],t.push(v)),v.push(m)}),t.forEach(m=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,v=>v.run(m),()=>{const v=[];return w.forEach(k=>{v.push(k)}),`Keys: ${v.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,b)}doClose(b,P){return new Promise((S,w)=>{b.db.close(t=>(t&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${t}`),this.path===E.IN_MEMORY_PATH?S():!b.isErroneous&&!b.isInMemory?this.backup().then(S,d=>(this.logger.error(`[storage ${this.name}] backup(): ${d}`),S())):typeof P=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(d=>{const m=()=>this.doClose(d,void 0);return this.doUpdateItems(d,{insert:P()}).then(()=>m(),v=>(m(),Promise.reject(v)))})).then(S,w):w(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return M.Promises.copy(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const P=await this.whenConnected,S=await this.get(P,b?"PRAGMA integrity_check":"PRAGMA quick_check"),w=b?S.integrity_check:S.quick_check;return P.isErroneous?`${w} (last error: ${P.lastError})`:P.isInMemory?`${w} (in-memory!)`:w}async connect(b,P=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${P})`);try{return await this.doConnect(b)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&P)return await(0,p.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await M.Promises.unlink(b);try{await M.Promises.rename(this.toBackupPath(b),b)}catch{}return await this.doConnect(b)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(b,P){b.isErroneous=!0,b.lastError=P,this.logger.error(P)}doConnect(b){return new Promise((P,S)=>{new Promise((w,t)=>{V(["@vscode/sqlite3"],w,t)}).then(w=>{const t={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(b,d=>d?t.db?t.db.close(()=>S(d)):S(d):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(t),m=>t.db.close(()=>S(m)))),isInMemory:b===E.IN_MEMORY_PATH};t.db.on("error",d=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${d}`)),this.logger.isTracing&&t.db.on("trace",d=>this.logger.trace(`[storage ${this.name}] Trace (event): ${d}`))},S)})}exec(b,P){return new Promise((S,w)=>{b.db.exec(P,t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${t}`),w(t)):S())})}get(b,P){return new Promise((S,w)=>{b.db.get(P,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${t}`),w(t)):S(d))})}all(b,P){return new Promise((S,w)=>{b.db.all(P,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${t}`),w(t)):S(d))})}transaction(b,P){return new Promise((S,w)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),P(),b.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${t}`),w(t)):S())})})}prepare(b,P,S,w){const t=b.db.prepare(P),d=m=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${m} (${P}). Details: ${w()}`)};t.on("error",d),S(t),t.finalize(m=>{m&&d(m),t.removeListener("error",d)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class g{constructor(b){b&&typeof b.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace&&this.logTrace(b)}error(b){this.logError&&this.logError(b)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[129],x([13,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Z[130],x([0,1,129]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,C=D*24,M=C*7,E=C*30,g=C*365;function y(P,S,w){typeof P!="number"&&(P=P.getTime());const t=Math.round((new Date().getTime()-P)/1e3);if(t<-30)return(0,p.localize)(0,null,y(new Date().getTime()+t*1e3,!1));if(t<30)return(0,p.localize)(1,null);let d;return t<n?(d=t,S?d===1?w?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):w?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d):d===1?w?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):w?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):t<D?(d=Math.floor(t/n),S?d===1?w?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):w?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d):d===1?w?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):w?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):t<C?(d=Math.floor(t/D),S?d===1?w?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):w?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d):d===1?w?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):w?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):t<M?(d=Math.floor(t/C),S?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d)):t<E?(d=Math.floor(t/M),S?d===1?w?(0,p.localize)(30,null,d):(0,p.localize)(31,null,d):w?(0,p.localize)(32,null,d):(0,p.localize)(33,null,d):d===1?w?(0,p.localize)(34,null,d):(0,p.localize)(35,null,d):w?(0,p.localize)(36,null,d):(0,p.localize)(37,null,d)):t<g?(d=Math.floor(t/E),S?d===1?w?(0,p.localize)(38,null,d):(0,p.localize)(39,null,d):w?(0,p.localize)(40,null,d):(0,p.localize)(41,null,d):d===1?w?(0,p.localize)(42,null,d):(0,p.localize)(43,null,d):w?(0,p.localize)(44,null,d):(0,p.localize)(45,null,d)):(d=Math.floor(t/g),S?d===1?w?(0,p.localize)(46,null,d):(0,p.localize)(47,null,d):w?(0,p.localize)(48,null,d):(0,p.localize)(49,null,d):d===1?w?(0,p.localize)(50,null,d):(0,p.localize)(51,null,d):w?(0,p.localize)(52,null,d):(0,p.localize)(53,null,d))}e.fromNow=y;function b(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(Z[131],x([13,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Z[39],x([0,1,30,14,131]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(y,b){return b&&(y.stack||y.stacktrace)?D.localize(0,null,E(y),M(y.stack)||M(y.stacktrace)):E(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function g(y=null,b=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const P=p.coalesce(y),S=g(P[0],b);return P.length>1?D.localize(4,null,S,P.length):S}if(n.isString(y))return y;if(y.detail){const P=y.detail;if(P.error)return C(P.error,b);if(P.exception)return C(P.exception,b)}return y.stack?C(y,b):y.message?y.message:D.localize(5,null)}e.toErrorMessage=g}),define(Z[132],x([13,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Z[133],x([0,1,132]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(M,E,g=E){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=E,this.modifierLabels[3]=g}toLabel(M,E,g){if(E.length===0)return null;const y=[];for(let b=0,P=E.length;b<P;b++){const S=E[b],w=g(S);if(w===null)return null;y[b]=D(S,w,this.modifierLabels[M])}return y.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,M,E){if(M===null)return"";const g=[];return C.ctrlKey&&g.push(E.ctrlKey),C.shiftKey&&g.push(E.shiftKey),C.altKey&&g.push(E.altKey),C.metaKey&&g.push(E.metaKey),M!==""&&g.push(M),g.join(E.separator)}}),define(Z[134],x([13,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Z[72],x([0,1,45,28,10,49,9,3,36,83,14,118,24,134]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,u){if(E.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};u&&(s.cwd=u);const i=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",a=>{r({success:!1,error:a})}),i.once("exit",(a,h)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(E.isLinux||E.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(i=>{p.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,h)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o){!o||(delete o.DEBUG,E.isMacintosh&&delete o.DYLD_LIBRARY_PATH,E.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=m;function v(o=g.env){return o.comspec||"cmd.exe"}e.getWindowsShell=v;class k{constructor(u,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=u,this.args=s,this.shell=i,this.options=r;else{const a=u;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(g.env).forEach(h=>{a[h]=g.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const s=u.lastIndexOf(M.sep);return s!==-1&&(u=u.substring(s+1)),k.WellKnowCommands[u]?u:"other"}start(u){return E.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(g.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(s=>{let i,r;const a=new Promise((h,I)=>{i=h,r=I});if(s){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=p.exec(h,this.options,(I,R,L)=>{this.childProcess=null;const W=I;W&&W.killed?r({killed:this.terminateRequested,stdout:R.toString(),stderr:L.toString()}):this.handleExec(i,u,I,R,L)})}else{let h=null;const I=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,i,u,r);const L={terminated:this.terminateRequested};b.isNumber(R)&&(L.cmdCode=R),i(L)};if(this.shell&&E.isWindows){const R=C.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let L=!1,W=!1;const z=[];let Q=this.ensureQuotes(this.cmd);z.push(Q.value),L=Q.quoted,this.args&&this.args.forEach(ee=>{Q=this.ensureQuotes(ee),z.push(Q.value),W=W&&Q.quoted});const ie=["/s","/c"];L?W?ie.push('"'+z.join(" ")+'"'):z.length>1?ie.push('"'+z[0]+'" '+z.slice(1).join(" ")):ie.push('"'+z[0]+'"'):ie.push(z.join(" ")),h=p.spawn(v(),ie,R)}else this.cmd&&(h=p.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(b.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",R=>{this.childProcess=null,r({terminated:this.terminateRequested,error:R})}),h.pid&&(this.childProcess.on("close",I),this.handleSpawn(h,i,u,r,!0)))}return a})}handleClose(u,s,i,r){}ensureQuotes(u){return k.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,d(u,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!E.isWindows)return u(!1);const s=p.spawn(v(),["/s","/c"]);s.on("error",i=>u(!0)),s.on("exit",i=>u(!1))})}}e.AbstractProcess=k,k.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},k.regexp=/^[^"].* .*[^"]/;class l extends k{constructor(u,s,i,r){super(u,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,s,i,r,a){[r,a].forEach((h,I)=>{const R=new P.LineDecoder;R.write(h).forEach(z=>{s({line:z,source:I===0?0:1})});const W=R.end();W&&s({line:W,source:I===0?0:1})}),u({terminated:this.terminateRequested,error:i})}handleSpawn(u,s,i,r,a){const h=new P.LineDecoder,I=new P.LineDecoder;u.stdout.on("data",R=>{h.write(R).forEach(W=>i({line:W,source:0}))}),u.stderr.on("data",R=>{I.write(R).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=I}handleClose(u,s,i,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&i({line:h,source:1})}}e.LineProcess=l;function f(o){let u=[],s=!1;const i=function(r){if(s){u.push(r);return}(!o.send(r,h=>{if(h&&console.error(h),s=!1,u.length>0){const I=u.slice(0);u=[],I.forEach(R=>i(R))}})||E.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=f;var c;(function(o){async function u(s,i,r){if(M.isAbsolute(s))return s;if(i===void 0&&(i=g.cwd()),M.dirname(s)!=="."||(r===void 0&&b.isString(g.env.PATH)&&(r=g.env.PATH.split(M.delimiter)),r===void 0||r.length===0))return M.join(i,s);async function h(I){if(await S.Promises.exists(I)){let R;try{R=await S.Promises.stat(I)}catch(L){L.message.startsWith("EACCES")&&(R=await S.Promises.lstat(I))}return R?!R.isDirectory():!1}return!1}for(let I of r){let R;if(M.isAbsolute(I)?R=M.join(I,s):R=M.join(i,I,s),await h(R))return R;let L=R+".com";if(await h(L)||(L=R+".exe",await h(L)))return L}return M.join(i,s)}o.findExecutable=u})(c=e.win32||(e.win32={}))}),define(Z[135],x([0,1,25,3,122,72]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(w,t){return w===1?n.isWindows?P():C.getWindowsShell(t):y(w,t)}e.getSystemShell=M;function E(w,t){return w===1?n.isWindows?S(t):C.getWindowsShell(t):y(w,t)}e.getSystemShellSync=E;let g=null;function y(w,t){if(n.isLinux&&w===2||n.isMacintosh&&w===3)return"/bin/bash";if(!g){let d;if(n.isWindows)d="/bin/bash";else{if(d=t.SHELL,!d)try{d=(0,p.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}g=d}return g}let b=null;async function P(){return b||(b=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),b}function S(w){if(b)return b;const t=n.isWindows&&parseFloat((0,p.release)())>=10,d=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${w.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?m:C.getWindowsShell(w)}}),define(Z[136],x([0,1,45,8,17,23,112,15,4,2,49,72,37]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends S.ChannelServer{constructor(m){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=w;class t{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const k=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(k),this.child=null,this._client=null}getChannel(m){const v=this;return{call(k,l,f){return v.requestPromise(m,k,l,f)},listen(k,l){return v.requestEvent(m,k,l)}}}requestPromise(m,v,k,l=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const f=this.getCachedChannel(m),c=(0,n.createCancelablePromise)(s=>f.call(v,k,s)),o=l.onCancellationRequested(()=>c.cancel()),u=(0,y.toDisposable)(()=>c.cancel());return this.activeRequests.add(u),c.finally(()=>{o.dispose(),this.activeRequests.delete(u),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(m,v,k){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let l;const f=new g.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(m).listen(v,k)(f.fire,f),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return f.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,P.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,m,v);const k=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,M.isRemoteConsoleLog)(i)){(0,M.log)(i,`IPC Library: ${this.options.serverName}`);return}k.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const f=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&f.send(i.buffer.toString("base64")),o=k.event,u={send:c,onMessage:o};this._client=new S.ChannelClient(u);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,y.dispose)(a)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[137],x([13,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Z[138],x([13,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[139],x([13,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[140],x([13,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Z[141],x([13,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Z[142],x([13,11]),function(V,e){return V.create("vs/platform/environment/node/shellEnv",e)}),define(Z[143],x([13,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[144],x([13,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Z[145],x([13,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Z[146],x([13,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Z[147],x([13,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[148],x([13,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[149],x([13,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[150],x([13,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[151],x([13,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[152],x([13,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Z[153],x([13,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[154],x([13,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[155],x([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Z[156],x([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[157],x([13,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[158],x([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[159],x([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[160],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function p(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=p}),define(Z[161],x([0,1,4,2]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(E,g,y){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(E,g,y){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,g,y){this.channel.call("attach",[E,g,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,g){this.channel.call("terminate",[E,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,g){return this.channel.call("openExtensionDevelopmentHostWindow",[E,g])}}e.ExtensionHostDebugChannelClient=C}),define(Z[162],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(M){this.driver=M}listen(M,E){throw new Error(`No event found: ${E}`)}call(M,E,g){switch(E){case"click":return this.driver.click(g[0],g[1],g[2]);case"doubleClick":return this.driver.doubleClick(g);case"setValue":return this.driver.setValue(g[0],g[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(g);case"getElements":return this.driver.getElements(g[0],g[1]);case"getElementXY":return this.driver.getElementXY(g[0],g[1],g[2]);case"typeInEditor":return this.driver.typeInEditor(g[0],g[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(g);case"writeInTerminal":return this.driver.writeInTerminal(g[0],g[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=p;class n{constructor(M){this.channel=M}click(M,E,g){return this.channel.call("click",[M,E,g])}doubleClick(M){return this.channel.call("doubleClick",M)}setValue(M,E){return this.channel.call("setValue",[M,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(M){return this.channel.call("isActiveElement",M)}getElements(M,E){return this.channel.call("getElements",[M,E])}getElementXY(M,E,g){return this.channel.call("getElementXY",[M,E,g])}typeInEditor(M,E){return this.channel.call("typeInEditor",[M,E])}getTerminalBuffer(M){return this.channel.call("getTerminalBuffer",M)}writeInTerminal(M,E){return this.channel.call("writeInTerminal",[M,E])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class D{constructor(M){this.channel=M}registerWindowDriver(M){return this.channel.call("registerWindowDriver",M)}reloadWindowDriver(M){return this.channel.call("reloadWindowDriver",M)}}e.WindowDriverRegistryChannelClient=D}),define(Z[163],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class p{constructor(D){this.machineId=D}encryption(){return new Promise((D,C)=>V(["vscode-encrypt"],D,C))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=p}),define(Z[164],x([0,1,130,46,10,9,36,16,7]),function(V,e,p,n,D,C,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(d,m,v){this._args=d,this.paths=m,this.productService=v}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",V).fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(g.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return g.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return g.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=M.env.VSCODE_PORTABLE;return d?g.URI.file((0,C.join)(d,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,C.resolve)(d):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,C.resolve)(d):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,C.resolve)(d);const m=M.env.VSCODE_EXTENSIONS;if(m)return m;const v=M.env.VSCODE_PORTABLE;return v?(0,C.join)(v,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,C.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?g.URI.parse(d):g.URI.file((0,C.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return g.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],y.prototype,"appRoot",null),ue([n.memoize],y.prototype,"userHome",null),ue([n.memoize],y.prototype,"userDataPath",null),ue([n.memoize],y.prototype,"appSettingsHome",null),ue([n.memoize],y.prototype,"tmpDir",null),ue([n.memoize],y.prototype,"cacheHome",null),ue([n.memoize],y.prototype,"userRoamingDataHome",null),ue([n.memoize],y.prototype,"settingsResource",null),ue([n.memoize],y.prototype,"userDataSyncHome",null),ue([n.memoize],y.prototype,"userDataSyncLogResource",null),ue([n.memoize],y.prototype,"sync",null),ue([n.memoize],y.prototype,"machineSettingsResource",null),ue([n.memoize],y.prototype,"globalStorageHome",null),ue([n.memoize],y.prototype,"workspaceStorageHome",null),ue([n.memoize],y.prototype,"keybindingsResource",null),ue([n.memoize],y.prototype,"keyboardLayoutResource",null),ue([n.memoize],y.prototype,"argvResource",null),ue([n.memoize],y.prototype,"snippetsHome",null),ue([n.memoize],y.prototype,"isExtensionDevelopment",null),ue([n.memoize],y.prototype,"untitledWorkspacesHome",null),ue([n.memoize],y.prototype,"installSourcePath",null),ue([n.memoize],y.prototype,"builtinExtensionsPath",null),ue([n.memoize],y.prototype,"extensionsPath",null),ue([n.memoize],y.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],y.prototype,"extensionDevelopmentKind",null),ue([n.memoize],y.prototype,"extensionTestsLocationURI",null),ue([n.memoize],y.prototype,"debugExtensionHost",null),ue([n.memoize],y.prototype,"serviceMachineIdResource",null),ue([n.memoize],y.prototype,"telemetryLogResource",null),ue([n.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function b(t,d){return w(t["inspect-extensions"],t["inspect-brk-extensions"],5870,d,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=b;function P(t,d){return w(t["inspect-search"],t["inspect-brk-search"],5876,d,t.extensionEnvironment)}e.parseSearchPort=P;function S(t,d){return w(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,d,t.extensionEnvironment)}e.parsePtyHostPort=S;function w(t,d,m,v,k,l){const c=Number(d||t)||(v?null:m),o=c?Boolean(!!d):!1;let u;if(l)try{u=JSON.parse(l)}catch{}return{port:c,break:o,debugId:k,env:u}}}),define(Z[90],x([0,1,248,3,140]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function E(t,d,m=M){const v={},k=[],l=[];for(let u in d){const s=d[u];s.alias&&(v[u]=s.alias),s.type==="string"||s.type==="string[]"?(k.push(u),s.deprecates&&k.push(...s.deprecates)):s.type==="boolean"&&(l.push(u),s.deprecates&&l.push(...s.deprecates))}const f=p(t,{string:k,boolean:l,alias:v}),c={},o=f;c._=f._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(let u in d){const s=d[u];s.alias&&delete o[s.alias];let i=o[u];if(s.deprecates)for(const r of s.deprecates)o.hasOwnProperty(r)&&(i||(i=o[r],i&&m.onDeprecatedOption(r,s.deprecationMessage||(0,D.localize)(33,null))),delete o[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),m.onMultipleValues(u,i)),c[u]=i,s.deprecationMessage&&m.onDeprecatedOption(u,s.deprecationMessage)),delete o[u]}for(let u in o)m.onUnknownOption(u);return c}e.parseArgs=E;function g(t,d){let m="";return d.args&&(Array.isArray(d.args)?m=` <${d.args.join("> <")}>`:m=` <${d.args}>`),d.alias?`-${d.alias} --${t}${m}`:`--${t}${m}`}function y(t,d){let m=0,v=[];for(const c in t){const o=t[c],u=g(c,o);m=Math.max(m,u.length),v.push([u,o.description])}let k=m+2+1;if(d-k<25)return v.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let l=d-k-1,f=[];for(const c of v){let o=c[0],u=P(c[1],l),s=b(k-o.length-2);f.push("  "+o+s+u[0]);for(let i=1;i<u.length;i++)f.push(b(k)+u[i])}return f}e.formatOptions=y;function b(t){return" ".repeat(t)}function P(t,d){let m=[];for(;t.length;){let v=t.length<d?t.length:t.lastIndexOf(" ",d),k=t.slice(0,v).trim();t=t.slice(v),m.push(k)}return m}function S(t,d,m,v,k){const l=process.stdout.isTTY&&process.stdout.columns||80,f=k?.noInputFiles!==!0?`[${(0,D.localize)(34,null)}...]`:"",c=[`${t} ${m}`];c.push(""),c.push(`${(0,D.localize)(35,null)}: ${d} [${(0,D.localize)(36,null)}]${f}`),c.push(""),k?.noPipe!==!0&&(n.isWindows?c.push((0,D.localize)(37,null,d)):c.push((0,D.localize)(38,null,d)),c.push(""));const o={};for(const u in v){const s=v[u];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[u]=s}}for(let u in o){const s=u;let i=o[s];i&&(c.push(C[s]),c.push(...y(i,l)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=S;function w(t,d){return`${t||(0,D.localize)(39,null)}
${d||(0,D.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=w}),define(Z[165],x([0,1,61,161,90]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends n.ExtensionHostDebugBroadcastChannel{constructor(E){super();this.windowsMainService=E}call(E,g,y){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1]):super.call(E,g,y)}async openExtensionDevelopmentHostWindow(E,g){const y=(0,D.parseArgs)(E,D.OPTIONS);y.debugRenderer=g;const b=y.extensionDevelopmentPath;if(!b)return{success:!1};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:y});if(!g)return{success:!0};const S=P.win;if(!S)return{success:!0};const w=S.webContents.debugger;let t=w.isAttached()?1/0:0;const d=(0,p.createServer)(m=>{t++==0&&w.attach();let v=!1;const k=c=>{v||m.write(JSON.stringify(c)+"\0")},l=(c,o,u,s)=>k({method:o,params:u,sessionId:s});S.on("close",()=>{w.removeListener("message",l),m.end(),v=!0}),w.addListener("message",l);let f=Buffer.alloc(0);m.on("data",c=>{f=Buffer.concat([f,c]);for(let o=f.indexOf(0);o!==-1;o=f.indexOf(0)){let u;try{const s=f.slice(0,o).toString("utf8");f=f.slice(o+1),u=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}w.sendCommand(u.method,u.params,u.sessionId).then(s=>k({id:u.id,sessionId:u.sessionId,result:s})).catch(s=>k({id:u.id,sessionId:u.sessionId,error:{code:0,message:s.message}}))}}),m.on("error",c=>{console.error("error on cdp pipe:",c)}),m.on("close",()=>{v=!0,--t==0&&w.detach()})});return await new Promise(m=>d.listen(0,m)),S.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function V(e,p,n,D){function C(E){const g=M(E),y=[g];return e.isAbsolute(g)||y.unshift(D),e.resolve(...y)}function M(E){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,n);const b=E["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(P,"AppData","Roaming")}break;case"darwin":y=e.join(p.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,n)}return{getUserDataPath:C}}if(typeof define=="function")define(Z[166],x([0,249,25,10,16,36]),function(e,p,n,D,C,M){const E=C.dirname(D.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(C.joinPath(E,"package.json").fsPath);return V(p,n,g.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),n=require("os");module.exports=V(p,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[167],x([0,1,25,164,166]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(E,g){super(E,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E)},g)}}e.NativeEnvironmentService=C}),define(Z[168],x([0,1,29,25,28]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(M){const E=(0,D.randomPath)((0,n.tmpdir)());try{return(0,p.writeFileSync)(E,""),M&&console.log(`Marker file for --wait created: ${E}`),E}catch(g){M&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFile=C}),define(Z[169],x([0,1,17,31]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,M,E){let g=E&&E.get("storage.serviceMachineId",0)||null;if(g)return g;try{const b=(await M.readFile(C.serviceMachineIdResource)).value.toString();g=(0,n.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,n.generateUuid)();try{await M.writeFile(C.serviceMachineIdResource,p.VSBuffer.fromString(g))}catch{}}return E&&E.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=D}),define(Z[73],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,C=[],M=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=p}),define(Z[170],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=p;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let M of this._nodes.values())M.outgoing.size===0&&C.push(M);return C}insertEdge(C,M){const E=this.lookupOrInsertNode(C),g=this.lookupOrInsertNode(M);E.outgoing.set(this._hashFn(M),g),g.incoming.set(this._hashFn(C),E)}removeNode(C){const M=this._hashFn(C);this._nodes.delete(M);for(let E of this._nodes.values())E.outgoing.delete(M),E.incoming.delete(M)}lookupOrInsertNode(C){const M=this._hashFn(C);let E=this._nodes.get(M);return E||(E=new p(C),this._nodes.set(M,E)),E}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[M,E]of this._nodes)C.push(`${M}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,M]of this._nodes){const E=new Set([C]),g=this._findCycle(M,E);if(g)return g}}_findCycle(C,M){for(let[E,g]of C.outgoing){if(M.has(E))return[...M,E].join(" -> ");M.add(E);const y=this._findCycle(g,M);if(y)return y;M.delete(E)}}}e.Graph=n}),define(Z[5],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function E(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(M,E,g,y){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:M,index:g,optional:y}):(E[p.DI_DEPENDENCIES]=[{id:M,index:g,optional:y}],E[p.DI_TARGET]=E)}function D(M){if(p.serviceIds.has(M))return p.serviceIds.get(M);const E=function(g,y,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(E,g,b,!1)};return E.toString=()=>M,p.serviceIds.set(M,E),E}e.createDecorator=D;function C(M){return M}e.refineServiceDecorator=C}),define(Z[50],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService")}),define(Z[20],x([0,1,14,7,5]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationOverrides=C;function M(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||p.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=M;var E;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=g;function y(m,v){const k=Object.create(null);for(let l in m)b(k,l,m[l],v);return k}e.toValuesTree=y;function b(m,v,k,l){const f=v.split("."),c=f.pop();let o=m;for(let u=0;u<f.length;u++){let s=f[u],i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${v} as ${f.slice(0,u+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[c]=k}catch{l(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(o)}`)}else l(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function P(m,v){const k=v.split(".");S(m,k)}e.removeFromValueTree=P;function S(m,v){const k=v.shift();if(v.length===0){delete m[k];return}if(Object.keys(m).indexOf(k)!==-1){const l=m[k];typeof l=="object"&&!Array.isArray(l)&&(S(l,v),Object.keys(l).length===0&&delete m[k])}}function w(m,v,k){function l(o,u){let s=o;for(const i of u){if(typeof s!="object"||s===null)return;s=s[i]}return s}const f=v.split("."),c=l(m,f);return typeof c=="undefined"?k:c}e.getConfigurationValue=w;function t(m,v,k){Object.keys(v).forEach(l=>{l!=="__proto__"&&(l in m?p.isObject(m[l])&&p.isObject(v[l])?t(m[l],v[l],k):k&&(m[l]=v[l]):m[l]=v[l])})}e.merge=t;function d(m,v,k){const l=m.inspect(v),f=m.inspect(k);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=d}),define(Z[74],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,p.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,p.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(C,M){return this.secretVault[C]?.[M]??null}async setPassword(C,M,E){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][M]=E}async deletePassword(C,M){return this.secretVault[C]?.[M]?(delete this.secretVault[C][M],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const M=[];for(const E of Object.keys(this.secretVault[C]||{}))M.push({account:E,password:this.secretVault[C][E]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(Z[75],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n}),define(Z[91],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService")}),define(Z[51],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[171],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[172],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[92],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[173],x([0,1,45,10,9,3,83,24,72,143,92]),function(V,e,p,n,D,C,M,E,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends S{openTerminal(f,c){return this.spawnTerminal(p,f,g.getWindowsShell(),c)}spawnTerminal(f,c,o,u){const s=c.windowsExec||w.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return f.spawn(s,u?[u]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((a,h)=>{const I=m(process),R=f.spawn(o,r,{cwd:u,env:I});R.on("error",h),R.on("exit",()=>a())})}runInTerminal(f,c,o,u,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:w.getDefaultTerminalWindows();return new Promise((r,a)=>{const h=`"${c} - ${P}"`,I=`""${o.join('" "')}" & pause"`,R=["/c","start",h,"/wait",i,"/c",I],L=Object.assign({},m(process),u);Object.keys(L).filter(Q=>L[Q]===null).forEach(Q=>delete L[Q]);const W={cwd:c,env:L,windowsVerbatimArguments:!0};p.spawn(w.CMD,R,W).on("error",Q=>{a(v(Q))}),r(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class t extends S{openTerminal(f,c){return this.spawnTerminal(p,f,c)}runInTerminal(f,c,o,u,s){const i=s.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(i===b.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,V).fsPath,"-t",f||P,"-w",c];for(let z of o)R.push("-a"),R.push(z);if(u){const z=Object.assign({},m(process),u);for(let Q in z){const ie=z[Q];ie===null?(R.push("-u"),R.push(Q)):(R.push("-e"),R.push(`${Q}=${ie}`))}}let L="";const W=p.spawn(t.OSASCRIPT,R);W.on("error",z=>{a(v(z))}),W.stderr.on("data",z=>{L+=z.toString()}),W.on("exit",z=>{if(z===0)r(void 0);else if(L){const Q=L.split(`
`,1);a(new Error(Q[0]))}else a(new Error(y.localize(1,null,h,z)))})}else a(new Error(y.localize(2,null,i)))})}spawnTerminal(f,c,o){const u=c.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",u];o&&r.push(o);const a=m(process),h=f.spawn("/usr/bin/open",r,{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class d extends S{openTerminal(f,c){return this.spawnTerminal(p,f,c)}runInTerminal(f,c,o,u,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{let h=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const R=`${k(o)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;h.push(`''${R}''`);const L=Object.assign({},m(process),u);Object.keys(L).filter(ie=>L[ie]===null).forEach(ie=>delete L[ie]);const W={cwd:c,env:L};let z="";const Q=p.spawn(I,h,W);Q.on("error",ie=>{a(v(ie))}),Q.stderr.on("data",ie=>{z+=ie.toString()}),Q.on("exit",ie=>{if(ie===0)r(void 0);else if(z){const ee=z.split(`
`,1);a(new Error(ee[0]))}else a(new Error(y.localize(4,null,I,ie)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const f=await E.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{f?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,c,o){const u=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{u.then(r=>{const a=m(process),h=f.spawn(r,[],{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=y.localize(3,null);function m(l){const f={...l.env};return(0,M.sanitizeProcessEnvironment)(f),f}function v(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(y.localize(5,null,l.path)):l}function k(l){let f="";for(let c of l)c.indexOf(" ")>=0?f+='"'+c+'"':f+=c,f+=" ";return f}}),define(Z[18],x([0,1,35,9,27,14,7,145,5]),function(V,e,p,n,D,C,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function y(H){return H.create===!0}e.isFileOpenForWriteOptions=y;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var P;(function(H){H[H.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var S;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=w;function t(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=t;function d(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function v(H){return w(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var k;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(j,J){super(j);this.code=J}}e.FileSystemProviderError=l;function f(H,j){const J=new l(H.toString(),j);return o(J,j),J}e.createFileSystemProviderError=f;function c(H){return H||f((0,E.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=c;function o(H,j){return H.name=j?`${j} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function u(H){if(!H)return k.Unknown;if(H instanceof l)return H.code;const j=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!j)return k.Unknown;switch(j[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=u;function s(H){if(H instanceof R)return H.fileOperationResult;switch(u(H)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(j,J,U){this.resource=j,this.operation=J,this.target=U}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var a;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(j,J){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const U=new Map;for(const B of j){const K=U.get(B.type);switch(K?K.push([B.resource,B]):U.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,K]of U)switch(B){case 1:this.added=p.TernarySearchTree.forUris(()=>J),this.added.fill(K);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>J),this.updated.fill(K);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>J),this.deleted.fill(K);break}}contains(j,...J){return this.doContains(j,{includeChildren:!1},...J)}affects(j,...J){return this.doContains(j,{includeChildren:!0},...J)}doContains(j,J,...U){if(!j)return!1;const B=U.length>0;return!!((!B||U.includes(1))&&(this.added?.get(j)||J.includeChildren&&this.added?.findSuperstr(j))||(!B||U.includes(0))&&(this.updated?.get(j)||J.includeChildren&&this.updated?.findSuperstr(j))||(!B||U.includes(2))&&(this.deleted?.findSubstr(j)||J.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function I(H,j,J){return!H||!j||H===j||j.length>H.length?!1:(j.charAt(j.length-1)!==n.sep&&(j+=n.sep),J?(0,D.startsWithIgnoreCase)(H,j):H.indexOf(j)===0)}e.isParent=I;class R extends Error{constructor(j,J,U){super(j);this.fileOperationResult=J,this.options=U}}e.FileOperationError=R;class L extends R{constructor(j,J,U){super(j,2,U);this.stat=J}}e.NotModifiedSinceFileOperationError=L;var W;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var z;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=Q;async function ie(H,j){if(!j.hasProvider(M.URI.from({scheme:H.scheme})))return new Promise(J=>{const U=j.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===H.scheme&&B.added&&(U.dispose(),J())})})}e.whenProviderRegistered=ie,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ee{static formatSize(j){return(0,C.isNumber)(j)||(j=0),j<ee.KB?(0,E.localize)(1,null,j.toFixed(0)):j<ee.MB?(0,E.localize)(2,null,(j/ee.KB).toFixed(2)):j<ee.GB?(0,E.localize)(3,null,(j/ee.MB).toFixed(2)):j<ee.TB?(0,E.localize)(4,null,(j/ee.GB).toFixed(2)):(0,E.localize)(5,null,(j/ee.TB).toFixed(2))}}e.ByteSize=ee,ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB;var q;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function X(H){return{maxFileSize:H===0?300*ee.MB:16*ee.GB,maxHeapSize:H===0?700*ee.MB:2*700*ee.MB}}e.getPlatformLimits=X}),define(Z[52],x([0,1,250,141,90,18]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function M(S,w){const t={onUnknownOption:m=>{console.warn((0,n.localize)(0,null,m))},onMultipleValues:(m,v)=>{console.warn((0,n.localize)(1,null,m,v))},onDeprecatedOption:(m,v)=>{console.warn((0,n.localize)(2,null,m,v))}},d=(0,D.parseArgs)(S,D.OPTIONS,w?t:void 0);return d.goto&&d._.forEach(m=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,n.localize)(3,null))),d["max-memory"]&&p(parseInt(d["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function E(S){const w=S.findIndex(t=>!/^-/.test(t));if(w>-1)return[...S.slice(0,w),...S.slice(w+1)]}function g(S){let[,...w]=S;process.env.VSCODE_DEV&&(w=E(w)||[]);const t=!P(process.env);return M(w,t)}e.parseMainProcessArgv=g;function y(S){const[,,...w]=S;return M(w,!0)}e.parseCLIProcessArgv=y;function b(S,...w){const t=S.indexOf("--");return t===-1?S.push(...w):S.splice(t,0,...w),S}e.addArg=b;function P(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(Z[93],x([0,1,45,9,142,23,39,15,3,31,135,52,8]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let t;async function d(v,k,l){return k["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(l)&&!k["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(l)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=S.Promises.withAsyncBody(async(f,c)=>{const o=new C.CancellationTokenSource,u=setTimeout(()=>{o.dispose(!0),c(new Error((0,D.localize)(0,null)))},w);try{f(await m(v,o.token))}catch(s){!(0,E.isCancellationError)(s)&&!o.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,M.toErrorMessage)(s)))):f({})}finally{clearTimeout(u),o.dispose()}})),t)}e.getResolvedShellEnv=d;async function m(v,k){const l=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",l);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",f);const c=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",u);const s=await(0,b.getSystemShell)(g.OS,u);return v.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(k.isCancellationRequested)return r((0,E.canceled)());const a=(0,n.basename)(s);let h,I;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(h=`& '${process.execPath}' ${R} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,I=["-Login","-Command"]):(h=`'${process.execPath}' ${R} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?I=["-ic"]:I=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),h);const L=(0,p.spawn)(s,[...I,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});k.onCancellationRequested(()=>(L.kill(),r((0,E.canceled)()))),L.on("error",Q=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(Q)),r(Q)});const W=[];L.stdout.on("data",Q=>W.push(Q));const z=[];L.stderr.on("data",Q=>z.push(Q)),L.on("close",(Q,ie)=>{const ee=Buffer.concat(W).toString("utf8");v.trace("getUnixShellEnvironment#raw",ee);const q=Buffer.concat(z).toString("utf8");if(q.trim()&&v.trace("getUnixShellEnvironment#stderr",q),Q||ie)return r(new Error((0,D.localize)(2,null,Q,ie)));const X=o.exec(ee),H=X?X[1]:"{}";try{const j=JSON.parse(H);l?j.ELECTRON_RUN_AS_NODE=l:delete j.ELECTRON_RUN_AS_NODE,f?j.ELECTRON_NO_ATTACH_CONSOLE=f:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",j),i(j)}catch(j){v.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(j)),r(j)}})})}}),define(Z[174],x([0,1,17,39,15,4,2,48,7,31,18]),function(V,e,p,n,D,C,M,E,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends M.Disposable{constructor(w,t){super();this.channel=w,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,y.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,t){const{buffer:d}=await this.channel.call("readFile",[w,t]);return d}readFileStream(w,t,d){const m=(0,E.newWriteableStream)(k=>p.VSBuffer.concat(k.map(l=>p.VSBuffer.wrap(l))).buffer),v=this.channel.listen("readFileStream",[w,t])(k=>{if(k instanceof p.VSBuffer)m.write(k.buffer);else{if(k==="end")m.end();else{let l=k;l instanceof Error||(l=(0,b.createFileSystemProviderError)((0,n.toErrorMessage)(l),b.FileSystemProviderErrorCode.Unknown)),m.error(l),m.end()}v.dispose()}});return d.onCancellationRequested(()=>{m.error((0,D.canceled)()),m.end(),v.dispose()}),m}writeFile(w,t,d){return this.channel.call("writeFile",[w,p.VSBuffer.wrap(t),d])}open(w,t){return this.channel.call("open",[w,t])}close(w){return this.channel.call("close",[w])}async read(w,t,d,m,v){const[k,l]=await this.channel.call("read",[w,t,v]);return d.set(k.buffer.slice(0,l),m),l}write(w,t,d,m,v){return this.channel.call("write",[w,t,p.VSBuffer.wrap(d),m,v])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,t){return this.channel.call("delete",[w,t])}rename(w,t,d){return this.channel.call("rename",[w,t,d])}copy(w,t,d){return this.channel.call("copy",[w,t,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const t=w;this._onDidChange.fire(t.map(d=>({resource:g.URI.revive(d.resource),type:d.type})))}else{const t=w;this._onDidWatchError.fire(t)}}))}watch(w,t){const d=(0,y.generateUuid)();return this.channel.call("watch",[this.sessionId,d,w,t]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=P}),define(Z[94],x([0,1,17,15,146,18]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(b,P,S,w,t,d){let m;try{await E(b,P,S,w,t,d)}catch(v){m=v}finally{m&&t.errorTransformer&&(m=t.errorTransformer(m)),typeof m!="undefined"&&S.error(m),S.end()}}e.readFileIntoStream=M;async function E(b,P,S,w,t,d){g(d);const m=await b.open(P,{create:!1});try{g(d);let v=0,k=0,l=t&&typeof t.length=="number"?t.length:void 0,f=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof l=="number"?l:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,o=0;do k=await b.read(m,c,f.buffer,o,f.byteLength-o),c+=k,o+=k,v+=k,typeof l=="number"&&(l-=k),o===f.byteLength&&(await S.write(w(f)),f=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof l=="number"?l:t.bufferSize)),o=0);while(k>0&&(typeof l!="number"||l>0)&&g(d)&&y(v,t));if(o>0){let u=o;typeof l=="number"&&(u=Math.min(o,l)),S.write(w(f.slice(0,u)))}}catch(v){throw(0,C.ensureFileSystemProviderError)(v)}finally{await b.close(m)}}function g(b){if(b.isCancellationRequested)throw(0,n.canceled)();return!0}function y(b,P){if(P?.limits){if(typeof P.limits.memory=="number"&&b>P.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&b>P.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[62],x([0,1,2,3,7,18]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function M(w){return w.recursive===!0}e.isRecursiveWatchRequest=M;class E extends p.Disposable{constructor(t,d,m,v){super();this.onFileChanges=t,this.onLogMessage=d,this.verboseLogging=m,this.options=v,this.watcherDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new p.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),t.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),t.add(this.watcher.onDidError(d=>this.onError(d)))}onError(t){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class g extends E{constructor(t,d,m){super(t,d,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=g;class y extends E{constructor(t,d,m){super(t,d,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function b(w){return w.map(t=>({type:t.type,resource:D.URI.file(t.path)}))}e.toFileChanges=b;function P(w){const t=new S;for(const d of w)t.processEvent(d);return t.coalesce()}e.coalesceEvents=P;class S{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const d=this.mapPathToChange.get(this.toKey(t));let m=!1;if(d){const v=d.type,k=t.type;d.path!==t.path&&(t.type===2||t.type===1)?m=!0:v===1&&k===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(d)):v===2&&k===1?d.type=0:v===1&&k===0||(d.type=k)}else m=!0;m&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],d=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(t.push(m),!1):!0).sort((m,v)=>m.path.length-v.path.length).filter(m=>d.some(v=>(0,C.isParent)(m.path,v,!n.isLinux))?!1:(d.push(m.path),!0)).concat(t)}}}),define(Z[175],x([0,1,29,8,23,28,114,2,70,9,3,85,24,62]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends E.Disposable{constructor(v,k,l,f){super();this.request=v,this.onDidFilesChange=k,this.onLogMessage=l,this.verboseLogging=f,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,M.parse)(c)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const k=await S.Promises.stat(v);this._register(await this.doWatch(v,k.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let k=v.path;try{k=await S.Promises.realpath(v.path),v.path===k&&(k=await(0,P.realcase)(v.path)??v.path),v.path!==k&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${k})`)}catch{}return k}async doWatch(v,k){if(b.isMacintosh&&(0,C.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),E.Disposable.None;const l=new D.CancellationTokenSource(this.cts.token);let f=new E.DisposableStore;try{const c=(0,y.basename)(v),o=(0,p.watch)(v);f.add((0,E.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${v}'`);const u=new Set;if(k)try{for(const i of await S.Promises.readdir(v))u.add(i)}catch(i){this.error(i)}const s=new Map;f.add((0,E.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),o.on("error",(i,r)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),o.on("change",(i,r)=>{if(l.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let a="";if(r&&(a=r.toString(),b.isMacintosh&&(a=(0,g.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(k)if(i==="rename"){s.get(a)?.dispose();const h=setTimeout(async()=>{if(s.delete(a),a===c&&!await S.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const I=await this.existsChildStrictCase((0,y.join)(v,a));if(l.token.isCancellationRequested)return;let R;I?u.has(a)?R=0:(R=1,u.add(a)):(u.delete(a),R=2),this.onFileChange({path:(0,y.join)(this.request.path,a),type:R})},t.FILE_DELETE_HANDLER_DELAY);s.set(a,(0,E.toDisposable)(()=>clearTimeout(h)))}else{let h;u.has(a)?h=0:(h=1,u.add(a)),this.onFileChange({path:(0,y.join)(this.request.path,a),type:h})}else if(i==="rename"||a!==c){const h=setTimeout(async()=>{const I=await S.Promises.exists(v);l.token.isCancellationRequested||(I?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,E.toDisposable)(()=>clearTimeout(h)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await S.Promises.exists(v)&&!l.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,E.toDisposable)(()=>{l.dispose(!0),f.dispose()})}async onFileChange(v,k=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!k&&this.excludes.some(l=>l(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const l=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,w.coalesceEvents)(l);if(f.length>0){if(this.verboseLogging)for(const o of f)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(b.isLinux)return S.Promises.exists(v);try{const k=(0,y.basename)(v);return(await S.Promises.readdir((0,y.dirname)(v))).some(f=>f===k)}catch(k){return this.trace(k),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function d(m,v,k,l,f=512){const c=await S.Promises.open(m,"r"),o=Buffer.allocUnsafe(f),u=new D.CancellationTokenSource(l);let s,i=!1;const r={path:m,excludes:[],recursive:!1},a=new t(r,h=>{(async()=>{for(const{type:I}of h)if(I===0){if(i)return;i=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:R}=await S.Promises.read(c,o,0,f,null);if(!R||u.token.isCancellationRequested)break;v(o.slice(0,R))}}catch(R){s=new Error(R),u.dispose(!0)}finally{i=!1}}})()});return await a.ready,k(),new Promise((h,I)=>{u.token.onCancellationRequested(async()=>{a.dispose();try{await S.Promises.close(c)}catch(R){s=new Error(R)}s?I(s):h()})})}e.watchFileContents=d}),define(Z[176],x([0,1,30,4,2,3,175]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(y){const b=this.normalizeRequests(y),P=b.filter(w=>{const t=this.watchers.get(w.path);return t?!(0,p.equals)(t.request.excludes,w.excludes):!0}),S=Array.from(this.watchers.values()).filter(({request:w})=>!b.find(t=>t.path===w.path&&(0,p.equals)(t.excludes,w.excludes))).map(({request:w})=>w.path);P.length&&this.trace(`Request to start watching: ${P.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const w of S)this.stopWatching(w);for(const w of P)this.startWatching(w)}startWatching(y){const b=new M.NodeJSFileWatcherLibrary(y,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),P={request:y,instance:b};this.watchers.set(y.path,P)}async stop(){for(const[y]of this.watchers)this.stopWatching(y);this.watchers.clear()}stopWatching(y){const b=this.watchers.get(y);b&&(this.watchers.delete(y),b.instance.dispose())}normalizeRequests(y){const b=new Map;for(const P of y){const S=C.isLinux?P.path:P.path.toLowerCase();b.set(S,P)}return Array.from(b.values())}async setVerboseLogging(y){this.verboseLogging=y;for(const[,b]of this.watchers)b.instance.setVerboseLogging(y)}trace(y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(y)})}toMessage(y,b){return b?`[File Watcher (node.js)] ${y} (path: ${b.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=E}),define(Z[177],x([0,1,62,176]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends p.AbstractNonRecursiveWatcherClient{constructor(M,E,g){super(M,E,g);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(Z[178],x([0,1,10,37,136,62]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends C.AbstractUniversalWatcherClient{constructor(g,y,b){super(g,y,b);this.init()}createWatcher(g){const y=g.add(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(y.onDidProcessExit(({code:b,signal:P})=>this.onError(`terminated by itself with code ${b}, signal: ${P}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(Z[76],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[C,M]of D)this.set(C,M)}set(D,C){const M=this._entries.get(D);return this._entries.set(D,C),M}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(Z[179],x([0,1,8,15,73,170,5,76]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const g=!1;class y extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class b{constructor(t=new E.ServiceCollection,d=!1,m){this._activeInstantiations=new Set,this._services=t,this._strict=d,this._parent=m,this._services.set(M.IInstantiationService,this)}createChild(t){return new b(t,this._strict,this)}invokeFunction(t,...d){let m=S.traceInvocation(t),v=!1;try{return t({get:l=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(l,m);if(!f)throw new Error(`[invokeFunction] unknown service '${l}'`);return f}},...d)}finally{v=!0,m.stop()}}createInstance(t,...d){let m,v;return t instanceof D.SyncDescriptor?(m=S.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(d),m)):(m=S.traceCreation(t),v=this._createInstance(t,d,m)),m.stop(),v}_createInstance(t,d=[],m){let v=M._util.getServiceDependencies(t).sort((f,c)=>f.index-c.index),k=[];for(const f of v){let c=this._getOrCreateServiceInstance(f.id,m);if(!c&&this._strict&&!f.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${f.id}.`);k.push(c)}let l=v.length>0?v[0].index:d.length;if(d.length!==l){console.warn(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${d.length} static arguments`);let f=l-d.length;f>0?d=d.concat(new Array(f)):d=d.slice(0,l)}return new t(...[...d,...k])}_setServiceInstance(t,d){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,d);else if(this._parent)this._parent._setServiceInstance(t,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let d=this._services.get(t);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):d}_getOrCreateServiceInstance(t,d){let m=this._getServiceInstanceOrDescriptor(t);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,m,d.branch(t,!0)):(d.branch(t,!1),m)}_safeCreateAndCacheServiceInstance(t,d,m){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,d,m)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,d,m){const v=new C.Graph(f=>f.id.toString());let k=0;const l=[{id:t,desc:d,_trace:m}];for(;l.length;){const f=l.pop();if(v.lookupOrInsertNode(f),k++>1e3)throw new y(v);for(let c of M._util.getServiceDependencies(f.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(!o&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const u={id:c.id,desc:o,_trace:f._trace.branch(c.id,!0)};v.insertEdge(f,u),l.push(u)}}}for(;;){const f=v.roots();if(f.length===0){if(!v.isEmpty())throw new y(v);break}for(const{data:c}of f){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const u=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,u)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,d,m=[],v,k){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(d,m,v,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,d,m,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(t,d=[],m,v){if(m){const k=new p.IdleValue(()=>this._createInstance(t,d,v));return new Proxy(Object.create(null),{get(l,f){if(f in l)return l[f];let c=k.value,o=c[f];return typeof o!="function"||(o=o.bind(c),l[f]=o),o},set(l,f,c){return k.value[f]=c,!0}})}else return this._createInstance(t,d,v)}}e.InstantiationService=b;var P;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(P||(P={}));class S{constructor(t,d){this.type=t,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return g?new S(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(t){return g?new S(0,t.name):S._None}branch(t,d){let m=new S(2,t.toString());return this._dep.push([t,d,m]),m}stop(){let t=Date.now()-this._start;S._totals+=t;let d=!1;function m(k,l){let f=[],c=new Array(k+1).join("	");for(const[o,u,s]of l._dep)if(u&&s){d=!0,f.push(`${c}CREATES -> ${o}`);let i=m(k+1,s);i&&f.push(i)}else f.push(`${c}uses -> ${o}`);return f.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(t>2||d)&&console.log(v.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Z[180],x([0,1,15,133,59]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(E,g){super();if(g.length===0)throw(0,p.illegalArgument)("parts");this._os=E,this._parts=g}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,E=>this._getLabel(E))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,E=>this._getAriaLabel(E))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,E=>this._getElectronAccelerator(E))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,E=>this._getUserSettingsLabel(E))}isWYSIWYG(){return this._parts.every(E=>this._isWYSIWYG(E))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(E=>this._getPart(E))}_getPart(E){return new D.ResolvedKeybindingPart(E.ctrlKey,E.shiftKey,E.altKey,E.metaKey,this._getLabel(E),this._getAriaLabel(E))}getDispatchParts(){return this._parts.map(E=>this._getDispatchPart(E))}getSingleModifierDispatchParts(){return this._parts.map(E=>this._getSingleModifierDispatchPart(E))}}e.BaseResolvedKeybinding=C}),define(Z[181],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(C,M,E,g,y,b,P){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?n(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=n(C.getSingleModifierDispatchParts())),this.bubble=M?M.charCodeAt(0)===94:!1,this.command=this.bubble?M.substr(1):M,this.commandArgs=E,this.when=g,this.isDefault=y,this.extensionId=b,this.isBuiltinExtension=P}}e.ResolvedKeybindingItem=p;function n(D){let C=[];for(let M=0,E=D.length;M<E;M++){const g=D[M];if(!g)return C;C.push(g)}return C}e.removeElementsAfterNulls=n}),define(Z[182],x([0,1,82,59,180,181]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends D.BaseResolvedKeybinding{constructor(g,y){super(y,g.parts)}_keyCodeToUILabel(g){if(this._os===2)switch(g){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(g)}_getLabel(g){return g.isDuplicateModifierCase()?"":this._keyCodeToUILabel(g.keyCode)}_getAriaLabel(g){return g.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(g.keyCode)}_getElectronAccelerator(g){return p.KeyCodeUtils.toElectronAccelerator(g.keyCode)}_getUserSettingsLabel(g){if(g.isDuplicateModifierCase())return"";const y=p.KeyCodeUtils.toUserSettingsUS(g.keyCode);return y&&y.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(g){return M.getDispatchStr(g)}static getDispatchStr(g){if(g.isModifierKey())return null;let y="";return g.ctrlKey&&(y+="ctrl+"),g.shiftKey&&(y+="shift+"),g.altKey&&(y+="alt+"),g.metaKey&&(y+="meta+"),y+=p.KeyCodeUtils.toString(g.keyCode),y}_getSingleModifierDispatchPart(g){return g.keyCode===5&&!g.shiftKey&&!g.altKey&&!g.metaKey?"ctrl":g.keyCode===4&&!g.ctrlKey&&!g.altKey&&!g.metaKey?"shift":g.keyCode===6&&!g.ctrlKey&&!g.shiftKey&&!g.metaKey?"alt":g.keyCode===57&&!g.ctrlKey&&!g.shiftKey&&!g.altKey?"meta":null}static _scanCodeToKeyCode(g){const y=p.IMMUTABLE_CODE_TO_KEY_CODE[g];if(y!==-1)return y;switch(g){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(g){if(!g)return null;if(g instanceof n.SimpleKeybinding)return g;const y=this._scanCodeToKeyCode(g.scanCode);return y===0?null:new n.SimpleKeybinding(g.ctrlKey,g.shiftKey,g.altKey,g.metaKey,y)}static resolveUserBinding(g,y){const b=(0,C.removeElementsAfterNulls)(g.map(P=>this._resolveSimpleUserBinding(P)));return b.length>0?[new M(new n.ChordKeybinding(b),y)]:[]}}e.USLayoutResolvedKeybinding=M}),define(Z[183],x([0,1,8]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(D,C){if(D.length===0)return Promise.resolve(!1);const M=[];let E=!1;for(let g of D){if(g===!0)return Promise.resolve(!0);(0,p.isThenable)(g)&&M.push(g.then(y=>{y&&(E=!0)},y=>{C(y),E=!0}))}return p.Promises.settled(M).then(()=>E)}e.handleVetos=n}),define(Z[6],x([0,1,39,4,2,3,5]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function E(){return new Date().toISOString()}var g;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function y(u,s,i){switch(s){case g.Trace:u.trace(i);break;case g.Debug:u.debug(i);break;case g.Info:u.info(i);break;case g.Warning:u.warn(i);break;case g.Error:u.error(i);break;case g.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=y;function b(u){let s="";for(let i=0;i<u.length;i++){let r=u[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=b;class P extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class S extends P{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(g.Trace)&&this.log(g.Trace,b([s,...i]))}debug(s,...i){this.checkLogLevel(g.Debug)&&this.log(g.Debug,b([s,...i]))}info(s,...i){this.checkLogLevel(g.Info)&&this.log(g.Info,b([s,...i]))}warn(s,...i){this.checkLogLevel(g.Warning)&&this.log(g.Warning,b([s,...i]))}error(s,...i){if(this.checkLogLevel(g.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(g.Error,b(r))}else this.log(g.Error,b([s,...i]))}critical(s,...i){this.checkLogLevel(g.Critical)&&this.log(g.Critical,b([s,...i]))}flush(){}}e.AbstractMessageLogger=S;class w extends P{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!C.isWindows}trace(s,...i){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}debug(s,...i){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}info(s,...i){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}warn(s,...i){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,s,...i):console.warn(`[main ${E()}]`,s,...i))}error(s,...i){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,s,...i):console.error(`[main ${E()}]`,s,...i))}critical(s,...i){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,s,...i):console.error(`[main ${E()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class t extends P{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class d extends P{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,p.toErrorMessage)(s,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class m extends P{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=m;class v extends D.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=v;class k extends D.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?g.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class l{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(s){}getLevel(){return g.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=l;function f(u){if(u.verbose)return g.Trace;if(typeof u.logLevel=="string"){const s=c(u.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function c(u){switch(u){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=c;function o(u){switch(u){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=o}),define(Z[184],x([0,1,30,8,15,4,2,9,62,6]),function(V,e,p,n,D,C,M,E,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends M.Disposable{constructor(S,w){super();this.logService=S,this.options=w,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(S,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,w):this.watchNonRecursive(S,w)}watchUniversal(S,w){const t={path:this.toFilePath(S),excludes:w.excludes,recursive:w.recursive},d=(0,p.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,g.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const w of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const w of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(w)&&S.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,w){const t={path:this.toFilePath(S),excludes:w.excludes,recursive:!1},d=(0,p.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,g.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,E.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=b});var te=this&&this.__param||function(V,e){return function(p,n){e(p,n,V)}};define(Z[185],x([0,1,30,8,17,23,4,69,68,2,35,10,63,16,48,144,18,94,6]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends y.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${c}`);const u=new y.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),u.add(o.onDidChangeFile(s=>this._onDidFilesChange.fire(new m.FileChangesEvent(s,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&u.add(o.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),u.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,y.dispose)(u)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(u){o.push(u)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const u=this.provider.get(c.scheme);return!!(u&&u.capabilities&o)}listCapabilities(){return g.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,w.isAbsolutePath)(c))throw new m.FileOperationError((0,d.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const u=new Error;throw u.name="ENOPRO",u.message=(0,d.localize)(1,null,c.toString()),u}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o)||(0,m.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(u){throw(0,m.toFileSystemProviderErrorCode)(u)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,d.localize)(2,null,this.resourceForError(c)),1):(0,m.ensureFileSystemProviderError)(u)}}async doResolveFile(c,o){const u=await this.withProvider(c),s=this.isPathCaseSensitive(u),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,h=await u.stat(c);let I;return this.toFileStat(u,c,h,void 0,!!a,(R,L)=>(I||(I=b.TernarySearchTree.forUris(()=>!s),I.set(c,!0),i&&I.fill(!0,i)),I.get(R.resource)||I.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&r?L===1:!1))}async toFileStat(c,o,u,s,i,r){const{providerExtUri:a}=this.getExtUri(c),h={resource:o,name:a.basename(o),isFile:(u.type&m.FileType.File)!=0,isDirectory:(u.type&m.FileType.Directory)!=0,isSymbolicLink:(u.type&m.FileType.SymbolicLink)!=0,mtime:u.mtime,ctime:u.ctime,size:u.size,readonly:Boolean((u.permissions??0)&m.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,m.etag)({mtime:u.mtime,size:u.size})};if(h.isDirectory&&r(h,s)){try{const I=await c.readdir(o),R=await n.Promises.settled(I.map(async([L,W])=>{try{const z=a.joinPath(o,L),Q=i?await c.stat(z):{type:W};return await this.toFileStat(c,z,Q,I.length,i,r)}catch(z){return this.logService.trace(z),null}}));h.children=(0,p.coalesce)(R)}catch(I){this.logService.trace(I),h.children=[]}return h}return h}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(u){return this.logService.trace(u),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(u){return u}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new m.FileOperationError((0,d.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=D.VSBuffer.fromString(""),u){await this.doValidateCreateFile(c,u);const s=await this.writeFile(c,o);return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,s)),s}async writeFile(c,o,u){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,u)||await this.mkdirp(s,i.dirname(c));let a;if((0,m.hasReadWriteCapability)(s)&&!(o instanceof D.VSBuffer))if((0,t.isReadableStream)(o)){const h=await(0,t.peekStream)(o,3);h.ended?a=D.VSBuffer.concat(h.buffer):a=h}else a=(0,t.peekReadable)(o,h=>D.VSBuffer.concat(h),3);else a=o;!(0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,u,a):await this.doWriteBuffered(s,c,u,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new m.FileOperationError((0,d.localize)(4,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),u)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,u){if(!!u?.unlock&&!(c.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch{return}if((i.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,d.localize)(6,null,this.resourceForError(o)),0,u);if(this.throwIfFileIsReadonly(o,i),typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==m.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&u.mtime<i.mtime&&u.etag!==(0,m.etag)({mtime:u.mtime,size:i.size}))throw new m.FileOperationError((0,d.localize)(7,null),3,u);return i}async readFile(c,o,u){const s=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(s,c,o,u):this.doReadFile(s,c,o,u)}async doReadFileAtomic(c,o,u,s){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,o,u,s);i(a)}catch(a){r(a)}})})}async doReadFile(c,o,u,s){const i=await this.doReadFileStream(c,o,{...u,preferUnbuffered:!0},s);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(c,o,u){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,o,u)}async doReadFileStream(c,o,u,s){const i=new C.CancellationTokenSource(s),r=this.validateReadFile(o,u).then(h=>h,h=>{throw i.cancel(),h});let a;try{return typeof u?.etag=="string"&&u.etag!==m.ETAG_DISABLED&&await r,u?.atomic&&(0,m.hasFileAtomicReadCapability)(c)||!((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasFileReadStreamCapability)(c))||(0,m.hasReadWriteCapability)(c)&&u?.preferUnbuffered?a=this.readFileUnbuffered(c,o,u):(0,m.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,o,i.token,u):a=this.readFileBuffered(c,o,i.token,u),{...await r,value:a}}catch(h){a&&await(0,t.consumeStream)(a);const I=(0,d.localize)(8,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(h).toString());throw h instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(I,h.stat,u):new m.FileOperationError(I,(0,m.toFileOperationResult)(h),u)}}readFileStreamed(c,o,u,s=Object.create(null)){const i=c.readFileStream(o,s,u);return(0,t.transform)(i,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,d.localize)(9,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,o,u,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,d.localize)(10,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},u),i}readFileUnbuffered(c,o,u){const s=(0,t.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;u?.atomic&&(0,m.hasFileAtomicReadCapability)(c)?i=await c.readFile(o,{atomic:!0}):i=await c.readFile(o),typeof u?.position=="number"&&(i=i.slice(u.position)),typeof u?.length=="number"&&(i=i.slice(0,u.length)),this.validateReadFileLimits(o,i.byteLength,u),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,o){const u=await this.resolve(c,{resolveMetadata:!0});if(u.isDirectory)throw new m.FileOperationError((0,d.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.ETAG_DISABLED&&o.etag===u.etag)throw new m.NotModifiedSinceFileOperationError((0,d.localize)(12,null),u,o);return this.validateReadFileLimits(c,u.size,o),u}validateReadFileLimits(c,o,u){if(u?.limits){let s;if(typeof u.limits.memory=="number"&&o>u.limits.memory&&(s=9),typeof u.limits.size=="number"&&o>u.limits.size&&(s=7),typeof s=="number")throw new m.FileOperationError((0,d.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,o,u){return this.doCanMoveCopy(c,o,"move",u)}async canCopy(c,o,u){return this.doCanMoveCopy(c,o,"copy",u)}async doCanMoveCopy(c,o,u,s){if(c.toString()!==o.toString())try{const i=u==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,r,o,u,s)}catch(i){return i}return!0}async move(c,o,u){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"move",!!u),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="move"?2:3,a)),a}async copy(c,o,u){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"copy",!!u),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="copy"?3:2,a)),a}async doMoveCopy(c,o,u,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(c,o,u,s,i,r);if(a&&!h&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(u,this.getExtUri(u).providerExtUri.dirname(s)),i==="copy"){if(c===u&&(0,m.hasFileFolderCopyCapability)(c))await c.copy(o,s,{overwrite:r});else{const I=await this.resolve(o);I.isDirectory?await this.doCopyFolder(c,I,u,s):await this.doCopyFile(c,o,u,s)}return i}else return c===u?(await c.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(c,o,u,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,u,s){if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(u))return this.doPipeBuffered(c,o,u,s);if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasReadWriteCapability)(u))return this.doPipeBufferedToUnbuffered(c,o,u,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(u))return this.doPipeUnbufferedToBuffered(c,o,u,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasReadWriteCapability)(u))return this.doPipeUnbuffered(c,o,u,s)}async doCopyFolder(c,o,u,s){await u.mkdir(s),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(u).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),u,r):this.doCopyFile(c,i.resource,u,r)}))}async doValidateMoveCopy(c,o,u,s,i,r){let a=!1;if(c===u){const{providerExtUri:I,isPathCaseSensitive:R}=this.getExtUri(c);if(R||(a=I.isEqual(o,s)),a&&i==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!a&&I.isEqualOrParent(s,o))throw new Error((0,d.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const h=await this.exists(s);if(h&&!a){if(!r)throw new m.FileOperationError((0,d.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(c===u){const{providerExtUri:I}=this.getExtUri(c);if(I.isEqualOrParent(o,s))throw new Error((0,d.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,u)),u}async mkdirp(c,o){const u=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(o,s.dirname(o));)try{if(((await c.stat(o)).type&m.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;u.push(s.basename(o)),o=s.dirname(o)}for(let i=u.length-1;i>=0;i--){o=s.joinPath(o,u[i]);try{await c.mkdir(o)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(u){return u}return!0}async doValidateDelete(c,o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(u.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(c)));let i;try{i=await u.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new m.FileOperationError((0,d.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(c)))}return u}async del(c,o){const u=await this.doValidateDelete(c,o),s=!!o?.useTrash,i=!!o?.recursive;await u.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new m.FileOperationEvent(c,1))}watch(c,o={recursive:!1,excludes:[]}){const u=new y.DisposableStore;let s=!1,i=()=>{s=!0};return u.add((0,y.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(c,o);s?(0,y.dispose)(r):i=()=>(0,y.dispose)(r)}catch(r){this.logService.error(r)}})(),u}async doWatch(c,o){const u=await this.withProvider(c),s=(0,E.hash)([this.getExtUri(u).providerExtUri.getComparisonKey(c),o]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:u.watch(c,o)},this.activeWatchers.set(s,i)),i.count+=1,(0,y.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,y.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,y.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,u,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:u?.unlock??!1});try{(0,t.isReadableStream)(s)||(0,t.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,u){let s=0,i;if((0,t.isReadableBufferedStream)(u)){if(u.buffer.length>0){const r=D.VSBuffer.concat(u.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,s,0),s+=r.byteLength}if(u.ended)return;i=u.stream}else i=u;return new Promise((r,a)=>{(0,t.listenStream)(i,{onData:async h=>{i.pause();try{await this.doWriteBuffer(c,o,h,h.byteLength,s,0)}catch(I){return a(I)}s+=h.byteLength,setTimeout(()=>i.resume())},onError:h=>a(h),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,u){let s=0,i;for(;(i=u.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,o,u,s,i,r){let a=0;for(;a<s;)a+=await c.write(o,i+a,u.buffer,r+a,s-a)}async doWriteUnbuffered(c,o,u,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,u,s))}async doWriteUnbufferedQueued(c,o,u,s){let i;s instanceof D.VSBuffer?i=s:(0,t.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,t.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:u?.unlock??!1})}async doPipeBuffered(c,o,u,s){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,u,s))}async doPipeBufferedQueued(c,o,u,s){let i,r;try{i=await c.open(o,{create:!1}),r=await u.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,I=0,R=0;do R=await c.read(i,h,a.buffer,I,a.byteLength-I),await this.doWriteBuffer(u,r,a,R,h,I),h+=R,I+=R,I===a.byteLength&&(I=0);while(R>0)}catch(a){throw(0,m.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?u.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,u,s){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,u,s))}async doPipeUnbufferedQueued(c,o,u,s){return u.writeFile(s,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,u,s){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,u,s))}async doPipeUnbufferedToBufferedQueued(c,o,u,s){const i=await u.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(u,i,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await u.close(i)}}async doPipeBufferedToUnbuffered(c,o,u,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,o,C.CancellationToken.None));await this.doWriteUnbuffered(u,s,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new m.FileOperationError((0,d.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,d.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};l=ue([te(0,k.ILogService)],l),e.FileService=l}),define(Z[77],x([0,1,29,251,8,35,17,4,28,2,9,3,16,48,24,148,18,94,184,39,178,177]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(p)}catch(u){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(u)}`)}})();class o extends k.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i);this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new C.ResourceMap(r=>S.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async a=>{try{let h;a.isSymbolicLink()?h=(await this.stat((0,S.joinPath)(s,a.name))).type:h=this.toType(a),r.push([a.name,h])}catch(h){this.logService.trace(h)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=m.FileType.Unknown:s.isFile()?r=m.FileType.File:s.isDirectory()?r=m.FileType.Directory:r=m.FileType.Unknown,i&&(r|=m.FileType.SymbolicLink),r}async createResourceLock(s){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(s)})`);let i;for(;i=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(s)})`),await i.wait();const r=new D.Barrier;return this.resourceLocks.set(s,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(s)})`),(0,y.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(s)})`),this.resourceLocks.delete(s),r.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const a=this.toFilePath(s);return await t.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}readFileStream(s,i,r){const a=(0,w.newWriteableStream)(h=>M.VSBuffer.concat(h.map(I=>M.VSBuffer.wrap(I))).buffer);return(0,v.readFileIntoStream)(this,s,a,h=>h.buffer,{...i,bufferSize:256*1024},r),a}async writeFile(s,i,r){let a;try{const h=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(h)){if(!r.overwrite)throw(0,m.createFileSystemProviderError)((0,d.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,m.createFileSystemProviderError)((0,d.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof a=="number"&&await this.close(a)}}async open(s,i){let r;(0,m.isFileOpenForWriteOptions)(i)&&(r=await this.createResourceLock(s));let a;try{const h=this.toFilePath(s);if((0,m.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:R}=await t.SymlinkSupport.stat(h);R.mode&128||await t.Promises.chmod(h,R.mode|128)}catch(R){this.logService.trace(R)}let I;if((0,m.isFileOpenForWriteOptions)(i)){if(P.isWindows)try{await t.Promises.truncate(h,0),I="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}I||(I="w")}else I="r";a=await t.Promises.open(h,I)}catch(h){throw r?.dispose(),(0,m.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}return this.mapHandleToPos.set(a,0),(0,m.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,s),r&&this.mapHandleToLock.set(a,r),a}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(s);i&&(this.mapHandleToLock.delete(s),i.dispose())}}async read(s,i,r,a,h){const I=this.normalizePos(s,i);let R=null;try{const{bytesRead:L}=await t.Promises.read(s,r,a,h,I);return L}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(s,I,R)}}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const a=this.mapHandleToPos.get(s);typeof a=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,a+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,a,h){return(0,D.retry)(()=>this.doWrite(s,i,r,a,h),100,3)}async doWrite(s,i,r,a,h){const I=this.normalizePos(s,i);let R=null;try{const{bytesWritten:L}=await t.Promises.write(s,r,a,h,I);return L}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),L)}finally{this.updatePos(s,I,R)}}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(a,h)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,d.localize)(2,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(a,h,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,d.localize)(3,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(s,i,r,a){const h=this.toFilePath(s),I=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,g.isEqual)(h,I,!0)),R&&r==="copy")throw(0,m.createFileSystemProviderError)((0,d.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!R&&await t.Promises.exists(I)){if(!a)throw(0,m.createFileSystemProviderError)((0,d.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(s,i,r){return new f.UniversalWatcherClient(a=>s(a),a=>i(a),r)}createNonRecursiveWatcher(s,i,r){return new c.NodeJSWatcherClient(a=>s(a),a=>i(a),r)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await t.SymlinkSupport.stat(this.toFilePath(s));a.mode&128||(r=(0,m.createFileSystemProviderError)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}e.DiskFileSystemProvider=o}),define(Z[186],x([0,1,4,77,2,17,48,23]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends D.Disposable{constructor(P,S){super();this.provider=P,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(P,S,w){const t=this.getUriTransformer(P);switch(S){case"stat":return this.stat(t,w[0]);case"readdir":return this.readdir(t,w[0]);case"open":return this.open(t,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(t,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(t,w[0],w[1],w[2]);case"rename":return this.rename(t,w[0],w[1],w[2]);case"copy":return this.copy(t,w[0],w[1],w[2]);case"mkdir":return this.mkdir(t,w[0]);case"delete":return this.delete(t,w[0],w[1]);case"watch":return this.watch(t,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${S} not found`)}listen(P,S,w){const t=this.getUriTransformer(P);switch(S){case"fileChange":return this.onFileChange(t,w[0]);case"readFileStream":return this.onReadFileStream(t,w[0],w[1])}throw new Error(`Unknown event ${S}`)}stat(P,S){const w=this.transformIncoming(P,S,!0);return this.provider.stat(w)}readdir(P,S){const w=this.transformIncoming(P,S);return this.provider.readdir(w)}async readFile(P,S,w){const t=this.transformIncoming(P,S,!0),d=await this.provider.readFile(t,w);return C.VSBuffer.wrap(d)}onReadFileStream(P,S,w){const t=this.transformIncoming(P,S,!0),d=new E.CancellationTokenSource,m=new p.Emitter({onLastListenerRemove:()=>{d.cancel()}}),v=this.provider.readFileStream(t,w,d.token);return(0,M.listenStream)(v,{onData:k=>m.fire(C.VSBuffer.wrap(k)),onError:k=>m.fire(k),onEnd:()=>{m.fire("end"),m.dispose(),d.dispose()}}),m.event}writeFile(P,S,w,t){const d=this.transformIncoming(P,S);return this.provider.writeFile(d,w.buffer,t)}open(P,S,w){const t=this.transformIncoming(P,S,!0);return this.provider.open(t,w)}close(P){return this.provider.close(P)}async read(P,S,w){const t=C.VSBuffer.alloc(w),d=0,m=await this.provider.read(P,S,t.buffer,d,w);return[t,m]}write(P,S,w,t,d){return this.provider.write(P,S,w.buffer,t,d)}mkdir(P,S){const w=this.transformIncoming(P,S);return this.provider.mkdir(w)}delete(P,S,w){const t=this.transformIncoming(P,S);return this.provider.delete(t,w)}rename(P,S,w,t){const d=this.transformIncoming(P,S),m=this.transformIncoming(P,w);return this.provider.rename(d,m,t)}copy(P,S,w,t){const d=this.transformIncoming(P,S),m=this.transformIncoming(P,w);return this.provider.copy(d,m,t)}onFileChange(P,S){const w=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(P,w))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return w.event}async watch(P,S,w,t,d){const m=this.sessionToWatcher.get(S);if(m){const v=this.transformIncoming(P,t),k=m.watch(w,v,d);this.watchRequests.set(S+w,k)}}async unwatch(P,S){const w=P+S,t=this.watchRequests.get(w);t&&((0,D.dispose)(t),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,P]of this.watchRequests)P.dispose();this.watchRequests.clear();for(const[,P]of this.sessionToWatcher)P.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class y extends D.Disposable{constructor(P,S,w,t){super();this.uriTransformer=P,this.logService=w,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(P){const S=this._register(new p.Emitter);this._register(S.event(w=>{P.fire(w.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>S.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>P.fire(w)))}getRecursiveWatcherOptions(P){}getExtraExcludes(P){}watch(P,S,w){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(w.excludes=[...w.excludes,...t]),this.watcherRequests.set(P,this.fileWatcher.watch(S,w)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(P)),this.watcherRequests.delete(P)})}dispose(){super.dispose();for(const[,P]of this.watcherRequests)P.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=y}),define(Z[187],x([0,1,12,147,3,7,18,9,186,115]),function(V,e,p,n,D,C,M,E,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends g.AbstractDiskFileSystemProviderChannel{constructor(w,t,d){super(w,t);this.environmentService=d}getUriTransformer(w){return y.DefaultURITransformer}transformIncoming(w,t){return C.URI.revive(t)}async delete(w,t,d){if(!d.useTrash)return super.delete(w,t,d);const m=this.transformIncoming(w,t),v=(0,E.normalize)(m.fsPath);try{await p.shell.trashItem(v)}catch{throw(0,M.createFileSystemProviderError)(D.isWindows?(0,n.localize)(0,null,(0,E.basename)(v)):(0,n.localize)(1,null,(0,E.basename)(v)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(w,t){return new P(w,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=b;class P extends g.AbstractSessionFileWatcher{watch(w,t,d){if(d.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(w,t,d)}}}),define(Z[95],x([0,1,6]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(C,M){switch(M){case p.LogLevel.Trace:return C.trace;case p.LogLevel.Debug:return C.debug;case p.LogLevel.Info:return C.info;case p.LogLevel.Warning:return C.warn;case p.LogLevel.Error:return C.error;case p.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(M=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}set logger(M){this._logger=M;for(const{level:E,args:g}of this.buffer)n(M,E).apply(M,g);this.buffer=[]}_log(M,...E){this._logger?n(this._logger,M).apply(this._logger,E):this.getLevel()<=M&&this.buffer.push({level:M,args:E})}trace(M,...E){this._log(p.LogLevel.Trace,M,...E)}debug(M,...E){this._log(p.LogLevel.Debug,M,...E)}info(M,...E){this._log(p.LogLevel.Info,M,...E)}warn(M,...E){this._log(p.LogLevel.Warning,M,...E)}error(M,...E){this._log(p.LogLevel.Error,M,...E)}critical(M,...E){this._log(p.LogLevel.Critical,M,...E)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Z[188],x([0,1,8,17,16,18,5,95,6]),function(V,e,p,n,D,C,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*C.ByteSize.MB;let b=class extends g.AbstractLogger{constructor(w,t,d,m,v){super();this.name=w,this.resource=t,this.donotUseFormatters=m,this.fileService=v,this.backupIndex=1,this.setLevel(d),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=g.LogLevel.Trace&&this._log(g.LogLevel.Trace,(0,g.format)(arguments))}debug(){this.getLevel()<=g.LogLevel.Debug&&this._log(g.LogLevel.Debug,(0,g.format)(arguments))}info(){this.getLevel()<=g.LogLevel.Info&&this._log(g.LogLevel.Info,(0,g.format)(arguments))}warn(){this.getLevel()<=g.LogLevel.Warning&&this._log(g.LogLevel.Warning,(0,g.format)(arguments))}error(){if(this.getLevel()<=g.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=w.stack,this._log(g.LogLevel.Error,(0,g.format)(t))}else this._log(g.LogLevel.Error,(0,g.format)(arguments))}}critical(){this.getLevel()<=g.LogLevel.Critical&&this._log(g.LogLevel.Critical,(0,g.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,t){this.queue.queue(async()=>{await this.initializePromise;let d=await this.loadContent();d.length>y&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(d)),d=""),this.donotUseFormatters?d+=t:d+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(d))})}getCurrentTimestamp(){const w=m=>m<10?`0${m}`:m,t=m=>m<10?`00${m}`:m<100?`0${m}`:m,d=new Date;return`${d.getFullYear()}-${w(d.getMonth()+1)}-${w(d.getDate())} ${w(d.getHours())}:${w(d.getMinutes())}:${w(d.getSeconds())}.${t(d.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(w){switch(w){case g.LogLevel.Critical:return"critical";case g.LogLevel.Debug:return"debug";case g.LogLevel.Error:return"error";case g.LogLevel.Info:return"info";case g.LogLevel.Trace:return"trace";case g.LogLevel.Warning:return"warning"}return""}};b=ue([te(4,C.IFileService)],b),e.FileLogger=b;let P=class extends g.AbstractLoggerService{constructor(w,t,d){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=t,this.fileService=d}doCreateLogger(w,t,d){const m=new E.BufferLogService(t);return(0,C.whenProviderRegistered)(w,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(b,d?.name||(0,D.basename)(w),w,m.getLevel(),!!d?.donotUseFormatters)),m}};P=ue([te(0,g.ILogService),te(1,M.IInstantiationService),te(2,C.IFileService)],P),e.FileLoggerService=P}),define(Z[189],x([0,1,4,7,6]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(S){this.service=S,this.onDidChangeLogLevel=p.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(S,w,t){switch(w){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=C;class M{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){M.setLevel(this.channel,S)}static setLevel(S,w){return S.call("setLevel",w)}}e.LogLevelChannelClient=M;class E{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,w){throw new Error(`Event not found: ${w}`)}async call(S,w,t){switch(w){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${w}`)}createLogger(S,w){this.loggers.set(S.toString(),this.loggerService.createLogger(S,w))}consoleLog(S,w){let t=console.log;switch(S){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...w)}log(S,w){const t=this.loggers.get(S.toString());if(!t)throw new Error("Create the logger before logging");for(const[d,m]of w)(0,D.log)(t,d,m)}}e.LoggerChannel=E;class g extends D.AbstractLoggerService{constructor(S,w,t){super(S,w);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,w)=>{this.channel.call("consoleLog",[S,w])}})}doCreateLogger(S,w,t){return new y(this.channel,S,w,t)}}e.LoggerChannelClient=g;class y extends D.AbstractMessageLogger{constructor(S,w,t,d){super(d?.always);this.channel=S,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[w,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,w){const t=[[S,w]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(S){this.channel.call("log",[this.file,S])}}class b extends D.LogService{constructor(S,w){super(w);this.parent=S,this._register(S.onDidChangeLogLevel(t=>w.setLevel(t)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=b}),define(Z[96],x([0,1,18,6]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(E,g,y,b,P){try{const S=await new Promise((t,d)=>{V(["spdlog"],t,d)});S.setFlushOn(n.LogLevel.Trace);const w=await S.createAsyncRotatingLogger(E,g,y,b);return P&&w.clearFormatters(),w}catch(S){console.error(S)}return null}function C(E,g,y){switch(g){case n.LogLevel.Trace:E.trace(y);break;case n.LogLevel.Debug:E.debug(y);break;case n.LogLevel.Info:E.info(y);break;case n.LogLevel.Warning:E.warn(y);break;case n.LogLevel.Error:E.error(y);break;case n.LogLevel.Critical:E.critical(y);break;default:throw new Error("Invalid log level")}}class M extends n.AbstractMessageLogger{constructor(g,y,b,P,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(g,y,b,P),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(g,y,b,P){const S=b?6:1,w=30/S*p.ByteSize.MB,t=await D(g,y,w,S,P);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:d,message:m}of this.buffer)C(this._logger,d,m);this.buffer=[]}}log(g,y){this._logger?C(this._logger,g,y):this.getLevel()<=g&&this.buffer.push({level:g,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(Z[190],x([0,1,10,16,31,18,188,6,96]),function(V,e,p,n,D,C,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends E.AbstractLoggerService{constructor(P,S){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=S}doCreateLogger(P,S,w){return P.scheme===p.Schemas.file?new g.SpdLogLogger(w?.name||(0,D.generateUuid)(),P.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,S):new M.FileLogger(w?.name??(0,n.basename)(P),P,S,!!w?.donotUseFormatters,this.fileService)}};y=ue([te(0,E.ILogService),te(1,C.IFileService)],y),e.LoggerService=y}),define(Z[191],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function n(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function D(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(M){return!p(M)&&!n(M)&&!D(M)}e.isMenubarMenuItemAction=C}),define(Z[53],x([0,1,10,3,36,16]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const E=n.globals.vscode.context.configuration();if(E)M=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const E=(0,C.dirname)(p.FileAccess.asFileUri("",V));M=V.__$__nodeRequire((0,C.joinPath)(E,"product.json").fsPath);const g=V.__$__nodeRequire((0,C.joinPath)(E,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:g.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=M}),define(Z[21],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[192],x([0,1,74,4,2,6,3,51,21]),function(V,e,p,n,D,C,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let y=class mt extends D.Disposable{constructor(P,S,w,t){super();this.isRunningOnServer=P,this.logService=S,this.environmentMainService=w,this.productService=t,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(P,S){const w=await this.withKeytar(),t=await w.getPassword(P,S);if(t)try{let{content:d,hasNextChunk:m}=JSON.parse(t);if(!d||!m)return t;let v=1;for(;m;){const k=await w.getPassword(P,`${S}-${v}`),l=JSON.parse(k);d+=l.content,m=l.hasNextChunk,v++}return d}catch{return t}return t}async setPassword(P,S,w){const t=await this.withKeytar(),d=3,m=async(v,k,l)=>{let f=0,c;for(;f<d;)try{await t.setPassword(v,k,l);return}catch(o){c=o,this.logService.warn("Error attempting to set a password: ",o),f++,await new Promise(u=>setTimeout(u,200))}throw c};if(M.isWindows&&w.length>mt.MAX_PASSWORD_LENGTH){let v=0,k=0,l=!0;for(;l;){const f=w.substring(v,v+mt.PASSWORD_CHUNK_SIZE);v+=mt.PASSWORD_CHUNK_SIZE,l=w.length-v>0;const c={content:f,hasNextChunk:l};await m(P,k?`${S}-${k}`:S,JSON.stringify(c)),k++}}else await m(P,S,w);this._onDidChangePassword.fire({service:P,account:S})}async deletePassword(P,S){const t=await(await this.withKeytar()).deletePassword(P,S);return t&&this._onDidChangePassword.fire({service:P,account:S}),t}async findPassword(P){return(await this.withKeytar()).findPassword(P)}async findCredentials(P){return(await this.withKeytar()).findCredentials(P)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new p.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((P,S)=>{V(["keytar"],P,S)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(P){this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${P.message}`),this._keytarCache=new p.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof p.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=ue([te(1,C.ILogService),te(2,E.INativeEnvironmentService),te(3,g.IProductService)],y),e.CredentialsMainService=y}),define(Z[193],x([0,1,60,6,21]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(E,g){this.productService=E,this.logService=g,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,g){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(g);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,b,P]=y;let S=this.trustedExtensionUrlPublicKeys.get(E);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[E],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...S])}const w=Buffer.from(decodeURIComponent(P),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const t=w.slice(0,6),d=w.readUIntBE(0,6),m=Date.now()-d;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const v=w.slice(6),k=p.createVerify("SHA256");k.write(t),k.write(Buffer.from(b)),k.end();for(let l=0;l<S.length;l++){let f=S[l];if(f!==null){if(typeof f=="string")try{f=p.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),S[l]=f}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${l+1} for ${E}:`,c),S[l]=null;continue}if(k.verify(f,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};C=ue([te(0,D.IProductService),te(1,n.ILogService)],C),e.ExtensionUrlTrustService=C}),define(Z[54],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[194],x([0,1,12,2,35,10,3,16,7,31,51,6]),function(V,e,p,n,D,C,M,E,g,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends n.Disposable{constructor(t,d){super();this.logService=d,this.validRoots=D.TernarySearchTree.forUris(()=>!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(g.URI.file(t.appRoot)),this.addValidFileRoot(g.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(d,m)=>this.handleResourceRequest(d,m)),t.protocol.interceptFileProtocol(C.Schemas.file,(d,m)=>this.handleFileRequest(d,m)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,d){const m=g.URI.parse(t.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),d({error:-3})}handleResourceRequest(t,d){const m=g.URI.parse(t.url),v=C.FileAccess.asFileUri(m);return this.validRoots.findSubstr(v)?d({path:v.fsPath}):this.validExtensions.has((0,E.extname)(v))?d({path:v.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),d({error:-3}))}createIPCObjectUrl(){let t;const d=g.URI.from({scheme:"vscode",path:(0,y.generateUuid)()}),m=d.toString(),v=async()=>t;return p.ipcMain.handle(m,v),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:d,update:k=>t=k,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),p.ipcMain.removeHandler(m)}}}};S=ue([te(0,b.INativeEnvironmentService),te(1,P.ILogService)],S),e.ProtocolMainService=S}),define(Z[40],x([0,1,104,14]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(M,E){p.ok(n.isString(M)),p.ok(n.isObject(E)),p.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,E)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new D}),define(Z[195],x([0,1,4,40]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class C{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,y){this.schemasById[D(g)]=y,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new C;n.Registry.add(e.Extensions.JSONContribution,M)}),define(Z[55],x([0,1,30,4,14,138,195,40]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=E.Registry.as(M.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const u=this.doRegisterConfigurations(c,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:c,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(c,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(u)})}registerDefaultConfigurations(c){const o=[],u=[];for(const{overrides:s,source:i}of c)for(const r in s)if(o.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:a});const h={type:"object",default:a,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:D.isString(i)?void 0:i};u.push(...t(r)),this.configurationProperties[r]=h,this.defaultLanguageConfigurationOverridesNode.properties[r]=h}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const o=[];for(const{overrides:u,source:s}of c)for(const i in u){const r=this.configurationDefaultsOverrides.get(i),a=D.isString(s)?s:s?.id,h=D.isString(r?.source)?r?.source:r?.source?.id;if(a===h)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const I=this.configurationProperties[i];I&&(this.updatePropertyDefaultValue(i,I),this.updateSchema(i,I))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const u=[];return c.forEach(s=>{u.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),u}doDeregisterConfigurations(c){const o=[],u=s=>{if(s.properties)for(const i in s.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>u(i))};for(const s of c){u(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(c,o=!0,u,s,i=3){i=D.isUndefinedOrNull(c.scope)?i:c.scope;let r=[],a=c.properties;if(a)for(let I in a){if(o&&k(I)){delete a[I];continue}const R=a[I];if(R.source=u,R.defaultDefaultValue=a[I].default,this.updatePropertyDefaultValue(I,R),e.OVERRIDE_PROPERTY_REGEX.test(I)?R.scope=void 0:(R.scope=D.isUndefinedOrNull(R.scope)?i:R.scope,R.restricted=D.isUndefinedOrNull(R.restricted)?!!s?.includes(I):R.restricted),a[I].hasOwnProperty("included")&&!a[I].included){this.excludedConfigurationProperties[I]=a[I],delete a[I];continue}else this.configurationProperties[I]=a[I];!a[I].deprecationMessage&&a[I].markdownDeprecationMessage&&(a[I].deprecationMessage=a[I].markdownDeprecationMessage),r.push(I)}let h=c.allOf;if(h)for(let I of h)r.push(...this.validateAndRegisterProperties(I,o,u,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const o=u=>{let s=u.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=u.allOf;i&&i.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,u={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){const u=this.configurationDefaultsOverrides.get(c);let s=u?.value,i=u?.source;D.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),D.isUndefined(s)&&(s=m(o.type)),o.default=s,o.defaultValueSource=i}}const S="\\[([^\\]]+)\\]",w=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(f){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let o=w.exec(f);for(;o?.length;){const u=o[1].trim();u&&c.push(u),o=w.exec(f)}}return(0,p.distinct)(c)}e.overrideIdentifiersFromKey=t;function d(f){return f.reduce((c,o)=>`${c}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function m(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new P;E.Registry.add(e.Extensions.Configuration,v);function k(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?C.localize(7,null,f):v.getConfigurationProperties()[f]!==void 0?C.localize(8,null,f):null:C.localize(6,null)}e.validateProperty=k;function l(){const f=[],c=v.getConfigurationProperties();for(const o of Object.keys(c))f.push([o,c[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=l}),define(Z[196],x([0,1,30,4,44,2,35,49,14,7,20,55,40]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,b.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,b.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return p.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=E.deepClone(this.contents),r=E.deepClone(this.overrides),a=[...this.keys];for(const h of s){this.mergeContents(i,h.contents);for(const I of h.overrides){const[R]=r.filter(L=>p.equals(L.identifiers,I.identifiers));R?(this.mergeContents(R.contents,I.contents),R.keys.push(...I.keys),R.keys=p.distinct(R.keys)):r.push(E.deepClone(I))}for(const I of h.keys)a.indexOf(I)===-1&&a.push(I)}return new w(i,a,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const a of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[a],I=i[a];I&&(typeof h=="object"&&typeof I=="object"?(h=E.deepClone(h),this.mergeContents(h,I)):h=I),r[a]=h}return new w(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&g.isObject(s[r])&&g.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=E.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?E.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const a=h=>{h&&(r?this.mergeContents(r,h):r=E.deepClone(h))};for(const h of this.overrides)p.equals(h.identifiers,[s])?i=h.contents:h.identifiers.includes(s)&&a(h.contents);return a(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,b.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,b.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=w;class t extends w{constructor(s={}){const i=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),a=Object.create(null),h=[];for(const I in i){const R=s[I],L=R!==void 0?R:i[I].default;(0,b.addToValueTree)(a,I,L,W=>console.error(`Conflict in default settings: ${W}`))}for(const I of Object.keys(a))P.OVERRIDE_PROPERTY_REGEX.test(I)&&h.push({identifiers:(0,P.overrideIdentifiersFromKey)(I),keys:Object.keys(a[I]),contents:(0,b.toValuesTree)(a[I],R=>console.error(`Conflict in default settings file: ${R}`))});super(a,r,h)}}e.DefaultConfigurationModel=t;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!g.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:a,overrides:h,restricted:I}=this.doParseRaw(s,i);this._configurationModel=new w(r,a,h),this._restrictedConfigurations=I||[]}doParseContent(s){let i={},r=null,a=[],h=[],I=[];function R(W){Array.isArray(a)?a.push(W):r!==null&&(a[r]=W)}let L={onObjectBegin:()=>{let W={};R(W),h.push(a),a=W,r=null},onObjectProperty:W=>{r=W},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let W=[];R(W),h.push(a),a=W,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:R,onError:(W,z,Q)=>{I.push({error:W,offset:z,length:Q})}};if(s)try{D.visit(s,L),i=a[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(s,i){const r=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),a=this.filter(s,r,!0,i);s=a.raw;const h=(0,b.toValuesTree)(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),I=Object.keys(s),R=this.toOverrides(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:h,keys:I,overrides:R,restricted:a.restricted}}filter(s,i,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:s,restricted:[]};const h={},I=[];for(let R in s)if(P.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const L=this.filter(s[R],i,!1,a);h[R]=L.raw,I.push(...L.restricted)}else{const L=i[R],W=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&I.push(R),(W===void 0||a.scopes===void 0||a.scopes.includes(W))&&(a.skipRestricted&&L?.restricted||(h[R]=s[R]))}return{raw:h,restricted:I}}toOverrides(s,i){const r=[];for(const a of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(a)){const h={};for(const I in s[a])h[I]=s[a][I];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(a),keys:Object.keys(h),contents:(0,b.toValuesTree)(h,i)})}return r}}e.ConfigurationModelParser=d;class m extends C.Disposable{constructor(s,i,r,a){super();this.userSettingsResource=s,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class v{constructor(s,i,r=new w,a=new w,h=new M.ResourceMap,I=new w,R=new M.ResourceMap,L=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=I,this._memoryConfigurationByResource=R,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new w,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(s):a.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const a=this.getConsolidateConfigurationModel(i,r),h=this.getFolderConfigurationModelForResource(i.resource,r),I=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),z=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),Q=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,ie=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(s):h.freeze().getValue(s):void 0,ee=i.overrideIdentifier?I.override(i.overrideIdentifier).getValue(s):I.getValue(s),q=a.getValue(s),X=p.distinct(p.flatten(a.overrides.map(H=>H.identifiers))).filter(H=>a.getOverrideValue(s,H)!==void 0);return{defaultValue:R,userValue:L,userLocalValue:W,userRemoteValue:z,workspaceValue:Q,workspaceFolderValue:ie,memoryValue:ee,value:q,default:R!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:z!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ie!==void 0?{value:h?.freeze().getValue(s),override:i.overrideIdentifier?h?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:I.getValue(s),override:i.overrideIdentifier?I.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:X.length?X:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:a,updated:h,removed:I}=c(this._defaultConfiguration,s);i=[...a,...h,...I]}for(const a of i)for(const h of(0,P.overrideIdentifiersFromKey)(a)){const I=this._defaultConfiguration.getKeysForOverrideIdentifier(h),R=s.getKeysForOverrideIdentifier(h),L=[...R.filter(W=>I.indexOf(W)===-1),...I.filter(W=>R.indexOf(W)===-1),...I.filter(W=>!E.equals(this._defaultConfiguration.override(h).getValue(W),s.override(h).getValue(W)))];r.push([h,L])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.localUserConfiguration,s),I=[...i,...r,...a];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.remoteUserConfiguration,s);let I=[...i,...r,...a];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.workspaceConfiguration,s);let I=[...i,...r,...a];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:h}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:a,updated:h,removed:I,overrides:R}=c(r,i);let L=[...a,...h,...I];return(L.length||!r)&&this.updateFolderConfiguration(s,i),{keys:L,overrides:R}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:a,removed:h,overrides:I}=c(i,void 0);return{keys:[...r,...a,...h],overrides:I}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const a=i.getFolder(s);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const h=this._memoryConfigurationByResource.get(s);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(s);a?(i=r.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:a,keys:h}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:a,keys:h}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),a=this.parseConfigurationModel(s.workspace),h=s.folders.reduce((I,R)=>(I.set(y.URI.revive(R[0]),this.parseConfigurationModel(R[1])),I),new M.ResourceMap);return new v(i,r,new w,a,h,new w,new M.ResourceMap,!1)}static parseConfigurationModel(s){return new w(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=v;function k(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,i=new Map;for(const a of u)a.keys.forEach(h=>s.add(h)),a.overrides.forEach(([h,I])=>{const R=(0,M.getOrSet)(i,h,new Set);I.forEach(L=>R.add(L))});const r=[];return i.forEach((a,h)=>r.push([h,[...a.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=k;class l{constructor(s,i,r,a){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;s.keys.forEach(R=>h.add(R)),s.overrides.forEach(([,R])=>R.forEach(L=>h.add(L))),this.affectedKeys=[...h.values()];const I=new w;this.affectedKeys.forEach(R=>I.setValue(R,{})),this.affectedKeysTree=I.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!E.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,b.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(s=s[a],!s)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=l;class f extends l{constructor(s,i,r,a){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=f;function c(u,s){const{added:i,removed:r,updated:a}=o(s,u),h=[],I=u?.getAllOverrideIdentifiers()||[],R=s?.getAllOverrideIdentifiers()||[];if(s){const L=R.filter(W=>!I.includes(W));for(const W of L)h.push([W,s.getKeysForOverrideIdentifier(W)])}if(u){const L=I.filter(W=>!R.includes(W));for(const W of L)h.push([W,u.getKeysForOverrideIdentifier(W)])}if(s&&u){for(const L of I)if(R.includes(L)){const W=o({contents:u.getOverrideValue(void 0,L)||{},keys:u.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});h.push([L,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:r,updated:a,overrides:h}}function o(u,s){const i=u?s?u.keys.filter(h=>s.keys.indexOf(h)===-1):[...u.keys]:[],r=s?u?s.keys.filter(h=>u.keys.indexOf(h)===-1):[...s.keys]:[],a=[];if(u&&s){for(const h of s.keys)if(u.keys.indexOf(h)!==-1){const I=(0,b.getConfigurationValue)(s.contents,h),R=(0,b.getConfigurationValue)(u.contents,h);E.equals(I,R)||a.push(h)}}return{added:i,removed:r,updated:a}}}),define(Z[197],x([0,1,8,4,2,16,20,196,55,40]),function(V,e,p,n,D,C,M,E,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends D.Disposable{constructor(S,w){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,w)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const S=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(S,w){const t=typeof S=="string"?S:void 0,d=(0,M.isConfigurationOverrides)(S)?S:(0,M.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(t,d,void 0)}updateValue(S,w,t,d){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(t,w,1)}onDidDefaultConfigurationChange(S){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,S);this.trigger(t,w,6)}trigger(S,w,t){const d=new E.ConfigurationChangeEvent(S,{data:w},this.configuration);d.source=t,d.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(S){switch(S){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(Z[198],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var n;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(M,E=n.Unknown,g){super(M);this._message=M,this._code=E,this._detail=g,this.isHandled=E===n.NotAvailable&&g===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(M){return M instanceof D&&M._code===n.TemporarilyNotAvailable}static isNoResolverFound(M){return M instanceof D&&M._code===n.NoResolverFound}static isHandled(M){return M instanceof D&&M.isHandled}}e.RemoteAuthorityResolverError=D}),define(Z[199],x([0,1,8,17,23,15,4,2,31,87,198]),function(V,e,p,n,D,C,M,E,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var S;(function($){$[$.Management=1]="Management",$[$.ExtensionHost=2]="ExtensionHost",$[$.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function w($){switch($){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t($){const F=new D.CancellationTokenSource;return setTimeout(()=>F.cancel(),$),F.token}function d($,F){if($.isCancellationRequested||F.isCancellationRequested)return D.CancellationToken.Cancelled;const _=new D.CancellationTokenSource;return $.onCancellationRequested(()=>_.cancel()),F.onCancellationRequested(()=>_.cancel()),_.token}class m{constructor(F){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((_,T)=>{this._resolvePromise=_,this._rejectPromise=T}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function v($,F){const _=new m(F);return _.registerDisposable($.onControlMessage(T=>{const A=JSON.parse(T.toString()),O=j(A);O?_.reject(O):_.resolve(A)})),_.promise}function k($,F,_,T,A,O,N){const G=new m(N);return F.connect(_,T,A,O,(ne,ce)=>{G.didTimeout?(ne&&$.error(ne),ce?.dispose()):ne||!ce?G.reject(ne):G.resolve(ce)}),G.promise}function l($,F){const _=new m(F);return $.then(T=>{_.didTimeout||_.resolve(T)},T=>{_.didTimeout||_.reject(T)}),_.promise}async function f($,F,_,T){const A=B($,F);$.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let O;try{O=await k($.logService,$.socketFactory,$.host,$.port,`reconnectionToken=${$.reconnectionToken}&reconnection=${$.reconnectionProtocol?"true":"false"}`,`renderer-${w(F)}-${$.reconnectionToken}`,T)}catch(ae){throw $.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),$.logService.error(ae),ae}$.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let N,G;$.reconnectionProtocol?($.reconnectionProtocol.beginAcceptReconnection(O,null),N=$.reconnectionProtocol,G=!1):(N=new y.PersistentProtocol(O,null),G=!0),$.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const ne=await l($.signService.createNewMessage((0,g.generateUuid)()),T),ce={type:"auth",auth:$.connectionToken||"00000000000000000000",data:ne.data};N.sendControl(n.VSBuffer.fromString(JSON.stringify(ce)));try{const ae=await v(N,d(T,t(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if($.logService.trace(`${A} 4/6. received SignRequest control message.`),!await l($.signService.validate(ne,ae.signedData),T)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const le=await l($.signService.sign(ae.data),T),he={type:"connectionType",commit:$.commit,signedData:le,desiredConnectionType:F};return _&&(he.args=_),$.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(n.VSBuffer.fromString(JSON.stringify(he))),{protocol:N,ownsProtocol:G}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&($.logService.error(`${A} the handshake timed out. Error:`),$.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&($.logService.error(`${A} received error control message when negotiating connection. Error:`),$.logService.error(ae)),G&&H(N),ae}}async function c($,F,_,T){const A=Date.now(),O=B($,F),{protocol:N,ownsProtocol:G}=await f($,F,_,T),ne=new m(T);return ne.registerDisposable(N.onControlMessage(ce=>{const ae=JSON.parse(ce.toString()),re=j(ae);re?($.logService.error(`${O} received error control message when negotiating connection. Error:`),$.logService.error(re),G&&H(N),ne.reject(re)):($.reconnectionProtocol&&$.reconnectionProtocol.endAcceptReconnection(),$.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${K(A)}!`),ne.resolve({protocol:N,firstMessage:ae}))})),ne.promise}async function o($,F){const{protocol:_}=await c($,1,void 0,F);return{protocol:_}}async function u($,F,_){const{protocol:T,firstMessage:A}=await c($,2,F,_),O=A&&A.debugPort;return{protocol:T,debugPort:O}}async function s($,F,_){const T=Date.now(),A=B($,3),{protocol:O}=await f($,3,F,_);return $.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${K(T)}!`),O}async function i($,F,_){const{host:T,port:A,connectionToken:O}=await $.addressProvider.getAddress();return{commit:$.commit,host:T,port:A,connectionToken:O,reconnectionToken:F,reconnectionProtocol:_,socketFactory:$.socketFactory,signService:$.signService,logService:$.logService}}async function r($,F,_){try{const T=(0,g.generateUuid)(),A=await i($,T,null),{protocol:O}=await o(A,D.CancellationToken.None);return new q($,F,_,T,O)}catch(T){throw $.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),$.logService.error(T),ee.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentManagement=r;async function a($,F){try{const _=(0,g.generateUuid)(),T=await i($,_,null),{protocol:A,debugPort:O}=await u(T,F,D.CancellationToken.None);return new X($,F,_,A,O)}catch(_){throw $.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),$.logService.error(_),ee.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=a;async function h($,F,_){const T=await i($,(0,g.generateUuid)(),null);return await s(T,{host:F,port:_},D.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function I($){return(0,p.createCancelablePromise)(F=>new Promise((_,T)=>{const A=setTimeout(_,$*1e3);F.onCancellationRequested(()=>{clearTimeout(A),_()})}))}var R;(function($){$[$.ConnectionLost=0]="ConnectionLost",$[$.ReconnectionWait=1]="ReconnectionWait",$[$.ReconnectionRunning=2]="ReconnectionRunning",$[$.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$[$.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(F,_){this.reconnectionToken=F,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=L;class W{constructor(F,_,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=_,this.durationSeconds=T,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class z{constructor(F,_,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=_,this.attempt=T,this.type=2}}e.ReconnectionRunningEvent=z;class Q{constructor(F,_,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=_,this.attempt=T,this.type=4}}e.ConnectionGainEvent=Q;class ie{constructor(F,_,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=_,this.attempt=T,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=ie;class ee extends E.Disposable{constructor(F,_,T,A){super();this._connectionType=F,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=T,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(A.onSocketClose(O=>{const N=U(this._connectionType,this.reconnectionToken,!0);O?O.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${O.hadError}).`),O.error&&this._options.logService.error(O.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${O.wasClean}, code: ${O.code}, reason: ${O.reason}).`),O.event&&this._options.logService.error(O.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const O=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} received socket timeout event.`),this._beginReconnecting()})),ee._instances.push(this),ee._permanentFailure&&this._gotoPermanentFailure(ee._permanentFailureMillisSinceLastIncomingData,ee._permanentFailureAttempt,ee._permanentFailureHandled)}static triggerPermanentFailure(F,_,T){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=_,this._permanentFailureHandled=T,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(ee._permanentFailure)return;const F=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const A=T<_.length?_[T]:_[_.length-1];try{if(A>0){const N=I(A);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,N)),this._options.logService.info(`${F} waiting for ${A} seconds before reconnecting...`);try{await N}catch{}}if(ee._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this._options.logService.info(`${F} resolving connection...`);const O=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${O.host}:${O.port}...`),await this._reconnect(O,t(P)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(O){if(O.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(O)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((O.code==="ETIMEDOUT"||O.code==="ENETUNREACH"||O.code==="ECONNREFUSED"||O.code==="ECONNRESET")&&O.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((0,C.isCancellationError)(O)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if(O instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,b.RemoteAuthorityResolverError.isHandled(O));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!ee._permanentFailure)}_gotoPermanentFailure(F,_,T){this._onDidStateChange.fire(new ie(this.reconnectionToken,F,_,T)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ee,ee._permanentFailure=!1,ee._permanentFailureMillisSinceLastIncomingData=0,ee._permanentFailureAttempt=0,ee._permanentFailureHandled=!1,ee._instances=[];class q extends ee{constructor(F,_,T,A,O){super(1,F,A,O);this.client=this._register(new y.Client(O,{remoteAuthority:_,clientId:T},F.ipcLogger))}async _reconnect(F,_){await o(F,_)}}e.ManagementPersistentConnection=q;class X extends ee{constructor(F,_,T,A,O){super(2,F,T,A);this._startArguments=_,this.debugPort=O}async _reconnect(F,_){await u(F,this._startArguments,_)}}e.ExtensionHostPersistentConnection=X;function H($){try{$.acceptDisconnect();const F=$.getSocket();$.dispose(),F.dispose()}catch(F){(0,C.onUnexpectedError)(F)}}function j($){if($&&$.type==="error"){const F=new Error(`Connection error: ${$.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function J($,F){for(;$.length<F;)$+=" ";return $}function U($,F,_){return`[remote-connection][${J(w($),13)}][${F.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function B($,F){return`${U(F,$.reconnectionToken,!!$.reconnectionProtocol)}[${$.host}:${$.port}]`}function K($){return`${Date.now()-$} ms`}}),define(Z[78],x([0,1,10]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(C){return C.scheme===p.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=n;function D(C){if(!C)return;const M=C.indexOf("+");return M<0?C:C.substr(0,M)}e.getRemoteName=D}),define(Z[56],x([0,1,17,152,55,5,40]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function E(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=E;function g(t){return t.res.statusCode===204}async function y(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);return g(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=y;async function b(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);if(g(t))return null;const m=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=b;function P(t){w(t)}e.updateProxyConfigurationsScope=P;let S;function w(t){const d=M.Registry.as(D.Extensions.Configuration),m=S;S={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[S],remove:m?[m]:[]})}w(2)}),define(Z[200],x([0,1,201,14]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(M,E){return M.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:M.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function C(M,E,g={}){const y=(0,p.parse)(M),b=g.proxyUrl||D(y,E);if(!b)return null;const P=(0,p.parse)(b);if(!/^https?:$/.test(P.protocol||""))return null;const S={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,n.isBoolean)(g.strictSSL)?g.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((w,t)=>{V(["http-proxy-agent"],w,t)}))(S):new(await new Promise((w,t)=>{V(["https-proxy-agent"],w,t)}))(S)}e.getProxyAgent=C}),define(Z[79],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[202],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>V(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),M=new C.validator;if(M){const E=String(p._nextId++);return this.validators.set(E,M),{id:E,data:M.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const M=this.validators.get(D.id);if(!M)return!1;this.validators.delete(D.id);try{return M.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),M=new C.signer;if(M)return M.sign(D)}catch{}return D}}e.SignService=p,p._nextId=1}),define(Z[38],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[19],x([0,1,12,8,4,2,3,36,14,5,183,6,38]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var w;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class wt extends C.Disposable{constructor(m,v){super();this.logService=m,this.stateMainService=v,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(wt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(wt.QUIT_AND_RESTART_KEY)}registerListeners(){const m=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),M.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",m);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!M.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",k=>{this.logService.trace("Lifecycle#app.on(will-quit)"),k.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",m),p.app.removeListener("window-all-closed",v),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const m=[];return this._onWillShutdown.fire({join(v){m.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(m)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===m)return;this.logService.trace(`lifecycle (main): phase changed (value: ${m})`),this._phase=m;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(m){if(m<=this._phase)return;let v=this.phaseWhen.get(m);v||(v=new n.Barrier,this.phaseWhen.set(m,v)),await v.wait()}registerWindow(m){const v=new C.DisposableStore;this.windowCounter++,v.add(m.onWillLoad(l=>this._onWillLoadWindow.fire({window:m,workspace:l.workspace,reason:l.reason})));const k=(0,g.assertIsDefined)(m.win);k.on("close",l=>{const f=m.id;if(this.windowToCloseRequest.has(f)){this.windowToCloseRequest.delete(f);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${m.id}`),l.preventDefault(),this.unload(m,1).then(c=>{if(c){this.windowToCloseRequest.delete(f);return}this.windowToCloseRequest.add(f),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${f}`),this._onBeforeCloseWindow.fire(m),m.close()})}),k.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!M.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(m,v){await this.unload(m,3)||m.reload(v)}async unload(m,v){if(!m.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${m.id}`);const k=this._quitRequested?2:v;let l=await this.onBeforeUnloadWindowInRenderer(m,k);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(m,k),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${m.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${m.id})`),await this.onWillUnloadWindowInRenderer(m,k),!1))}handleWindowUnloadVeto(m){return m?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(m){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(m),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(m,v){return new Promise(k=>{const l=this.oneTimeListenerTokenGenerator++,f=`vscode:ok${l}`,c=`vscode:cancel${l}`;p.ipcMain.once(f,()=>{k(!1)}),p.ipcMain.once(c,()=>{k(!0)}),m.send("vscode:onBeforeUnload",{okChannel:f,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(m,v){const k=[];return this._onBeforeUnloadWindow.fire({reason:v,window:m,veto(l){k.push(l)}}),(0,b.handleVetos)(k,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(m,v){return new Promise(k=>{const f=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(f,()=>k()),m.send("vscode:onWillUnload",{replyChannel:f,reason:v})})}quit(m){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${m}`),m&&this.stateMainService.setItem(wt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(m){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(m?.addArgs&&v.push(...m.addArgs),m?.removeArgs)for(const f of m.removeArgs){const c=v.indexOf(f);c>=0&&v.splice(c,1)}const k=()=>{try{if(M.isWindows){const f=(0,E.cwd)();f!==process.cwd()&&process.chdir(f)}}catch(f){this.logService.error(f)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",k),await this.quit(!0)&&p.app.removeListener("quit",k)}async kill(m){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let k;v.webContents&&!v.webContents.isDestroyed()?k=new Promise(l=>v.once("closed",l)):k=Promise.resolve(),v.destroy(),await k}})()]),p.app.exit(m)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ue([te(0,P.ILogService),te(1,S.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[203],x([0,1,4,2,5,19]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let M=class extends n.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((b,P)=>{V(["native-keymap"],b,P)});this._keyboardLayoutData=E(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=E(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ue([te(0,C.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function E(g){const y=g.getKeyMap(),b=g.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:b}}}),define(Z[97],x([0,1,8,4,2,63,14,89,5]),function(V,e,p,n,D,C,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var S;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));class w extends D.Disposable{constructor(v={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,k){k===y?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:k,target:this.getKeyTargets(v)[k]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,k,l){return this.getStorage(k)?.get(v,l)}getBoolean(v,k,l){return this.getStorage(k)?.getBoolean(v,l)}getNumber(v,k,l){return this.getStorage(k)?.getNumber(v,l)}store(v,k,l,f){if((0,M.isUndefinedOrNull)(k)){this.remove(v,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,l,f),this.getStorage(l)?.set(v,k)})}remove(v,k){this.withPausedEmitters(()=>{this.updateKeyTarget(v,k,void 0),this.getStorage(k)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,k){const l=[],f=this.getKeyTargets(v);for(const c of Object.keys(f))f[c]===k&&l.push(c);return l}updateKeyTarget(v,k,l){const f=this.getKeyTargets(k);typeof l=="number"?f[v]!==l&&(f[v]=l,this.getStorage(k)?.set(y,JSON.stringify(f))):typeof f[v]=="number"&&(delete f[v],this.getStorage(k)?.set(y,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const k=this.get(y,v);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=b.NONE){this._onWillSaveState.fire({reason:v});const k=this.getStorage(0),l=this.getStorage(1);switch(v){case b.NONE:await p.Promises.settled([k?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await p.Promises.settled([k?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return d(v,k,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends w{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function d(m,v,k,l){const f=a=>{try{return JSON.parse(a)}catch{return a}},c=new Map,o=new Map;m.forEach((a,h)=>{c.set(h,a),o.set(h,f(a))});const u=new Map,s=new Map;v.forEach((a,h)=>{u.set(h,a),s.set(h,f(a))}),console.group(`Storage: Global (path: ${k})`);let i=[];c.forEach((a,h)=>{i.push({key:h,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${l})`);let r=[];u.forEach((a,h)=>{r.push({key:h,value:a})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=d}),define(Z[204],x([0,1,3,36,7,31]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(y){if(p.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function E(y,b,P,S,w,t,d,m,v,k){const l=Object.create(null);l["common.machineId"]=d,l.sessionID=(0,C.generateUuid)()+Date.now(),l.commitHash=w,l.version=t,l["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,p.PlatformToString)(p.platform),l["common.nodePlatform"]=n.platform,l["common.nodeArch"]=S,l["common.product"]=k||"desktop";const f=g(m||[]);f&&(l["common.msftInternal"]=f);let c=0;const o=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(l["common.snap"]="true");const u=M(P);u&&(l["common.platformDetail"]=u);try{const s=await y.readFile(D.URI.file(v));l["common.source"]=s.value.toString().slice(0,30)}catch{}return l}e.resolveCommonProperties=E;function g(y){const b=n.env.USERDNSDOMAIN;if(!b)return!1;const P=b.toLowerCase();return y.some(S=>P===S)}e.verifyMicrosoftInternalDomain=g}),define(Z[32],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[205],x([0,1,25,68,8,44,10,9,3,7,71,24,86,75,18,21,32]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(o,u){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,r=new Map,a=2e4;function h(L,W,z,Q){const ie=W.substring(L.length+1);return D.Promises.withAsyncBody(async ee=>{let q;try{q=await P.Promises.readdir(W,{withFileTypes:!0})}catch{ee();return}if(Q.count>=a){Q.count+=q.length,Q.maxReached=!0,ee();return}let X=q.length;if(X===0){ee();return}let H=q;Q.count+q.length>a&&(Q.maxReached=!0,X=a-Q.count,H=q.slice(0,X)),Q.count+=q.length;for(const j of H)if(j.isDirectory()){if(z.includes(j.name)||await h(L,(0,E.join)(W,j.name),z,Q),--X==0){ee();return}}else{const J=j.name.lastIndexOf(".");if(J>=0){const U=j.name.substring(J+1);U&&i.set(U,(i.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(ie)!==!1&&U.filePattern.test(j.name)&&r.set(U.tag,(r.get(U.tag)??0)+1);if(--X==0){ee();return}}})}const I={count:0,maxReached:!1};await h(o,o,u,I);const R=await f(o);return{configFiles:k(r),fileTypes:k(i),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=v;function k(o){return[...n.Iterable.map(o.entries(),([u,s])=>({name:u,count:s}))].sort((u,s)=>s.count-u.count)}function l(){const o={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},u=p.cpus();return u&&u.length>0&&(o.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),o}e.getMachineInfo=l;async function f(o){try{const u=new Map,s=(0,E.join)(o,".vscode","launch.json"),i=await P.Promises.readFile(s),r=[],a=(0,C.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,C.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const I=h.type;I&&(u.has(I)?u.set(I,u.get(I)+1):u.set(I,1))}return k(u)}catch{return[]}}e.collectLaunchConfigs=f;let c=class{constructor(u,s){this.telemetryService=u,this.productService=s}formatMachineInfo(u){const s=[];return s.push(`OS Version:       ${u.os}`),s.push(`CPUs:             ${u.cpus}`),s.push(`Memory (System):  ${u.memory}`),s.push(`VM:               ${u.vmHint}`),s.join(`
`)}formatEnvironment(u){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),g.isWindows||s.push(`Load (avg):       ${p.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${u.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(u,s){return Promise.all([(0,S.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async i=>{let[r,a]=i,h=this.formatProcessList(u,r);return s.forEach(I=>{if((0,w.isRemoteDiagnosticError)(I))h+=`
${I.errorMessage}`,a+=`
${I.errorMessage}`;else if(h+=`

Remote: ${I.hostName}`,I.processes&&(h+=`
${this.formatProcessList(u,I.processes)}`),I.workspaceMetadata){a+=`
|  Remote: ${I.hostName}`;for(const R of Object.keys(I.workspaceMetadata)){const L=I.workspaceMetadata[R];let W=`${L.fileCount} files`;L.maxFilesReached&&(W=`more than ${W}`),a+=`|    Folder (${R}): ${W}`,a+=this.formatWorkspaceStats(L)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(u,s){const{memory:i,vmHint:r,os:a,cpus:h}=l(),I={os:a,memory:i,cpus:h,vmHint:r,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:s};return g.isWindows||(I.load=`${p.loadavg().map(R=>Math.round(R)).join(", ")}`),g.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(u,s){const i=[];return(0,S.listProcesses)(u.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(u)),i.push(""),i.push(this.formatProcessList(u,r)),u.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(u))),s.forEach(a=>{if((0,w.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(u,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const I=a.workspaceMetadata[h];let R=`${I.fileCount} files`;I.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${h}): ${R}`),i.push(this.formatWorkspaceStats(I))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(u){const s=[],i=60;let r=0;const a=(L,W)=>{const z=` ${L}(${W})`;r+z.length>i?(s.push(h),h="|                 ",r=h.length):r+=z.length,h+=z};let h="|      File types:";const I=10;let R=u.fileTypes.length>I?I:u.fileTypes.length;for(let L=0;L<R;L++){const W=u.fileTypes[L];a(W.name,W.count)}if(s.push(h),u.configFiles.length>=0&&(h="|      Conf files:",r=0,u.configFiles.forEach(L=>{a(L.name,L.count)}),s.push(h)),u.launchConfigFiles.length>0){let L="|      Launch Configs:";u.launchConfigFiles.forEach(W=>{L+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(L)}return s.join(`
`)}expandGPUFeatures(u){const s=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${u[i]}`).join(`
                  `)}formatWorkspaceMetadata(u){const s=[],i=[];return u.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const h=y.URI.revive(a);if(h.scheme===M.Schemas.file){const I=h.fsPath;i.push(v(I,["node_modules",".git"]).then(R=>{let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,E.basename)(I)}): ${L}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${I} (${R.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(u,s){const i=new Map;u.windows.forEach(a=>i.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(u.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(u,s,i,r,a){const h=a===0;let I;h?I=r.pid===u?`${this.productService.applicationName} main`:"remote agent":(I=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(I=`${I} (${s.get(r.pid)})`));const R=process.platform==="win32"?r.mem:p.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(r.children)&&r.children.forEach(L=>this.formatProcessItem(u,s,i,L,a+1))}async reportWorkspaceStats(u){for(const{uri:s}of u.folders){const i=y.URI.revive(s);if(i.scheme!==M.Schemas.file)continue;const r=i.fsPath;try{const a=await v(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};c=ue([te(0,m.ITelemetryService),te(1,d.IProductService)],c),e.DiagnosticsService=c}),define(Z[206],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(C){this.appenders=C}listen(C,M){throw new Error(`Event not found: ${M}`)}call(C,M,{eventName:E,data:g}){return this.appenders.forEach(y=>y.log(E,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class n{constructor(C){this.channel=C}log(C,M){return this.channel.call("log",{eventName:C,data:M}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(Z[64],x([0,1,49,14,20,32]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,k){return Promise.resolve(void 0)}publicLog2(v,k){return this.publicLog(v,k)}publicLogError(v,k){return Promise.resolve(void 0)}publicLogError2(v,k){return this.publicLogError(v,k)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class E{async publicLog(v,k,l){}async publicLogError(v,k,l){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(m,v){return v.onDidChangeConfiguration(k=>{k.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(k.source),configurationKeys:t(k.sourceConfig)})})}e.configurationTelemetry=g;function y(m,v){return!(v.disableTelemetry||!m.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=y;function b(m){const v=m.getValue(C.TELEMETRY_SETTING_ID),k=m.getValue("telemetry.enableCrashReporter");if(m.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||k===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function P(m){const v=Object.create(null),k=Object.create(null),l=Object.create(null);w(m,l);for(let f in l){f=f.length>150?f.substr(f.length-149):f;const c=l[f];typeof c=="number"?k[f]=c:typeof c=="boolean"?k[f]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${c.length}`),v[f]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(v[f]=c)}return{properties:v,measurements:k}}e.validateTelemetryData=P;function S(m){if(!m)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(l=>{m.indexOf(`${l}+`)===0&&(v=l)}),v}e.cleanRemoteAuthority=S;function w(m,v,k=0,l){if(!!m)for(let f of Object.getOwnPropertyNames(m)){const c=m[f],o=l?l+f:f;Array.isArray(c)?v[o]=(0,p.safeStringify)(c):c instanceof Date?v[o]=c.toISOString():(0,n.isObject)(c)?k<2?w(c,v,k+1,o+"."):v[o]=(0,p.safeStringify)(c):v[o]=c}}function t(m){if(!m)return[];const v=[];return d(v,"",m),v}function d(m,v,k){k&&typeof k=="object"&&!Array.isArray(k)?Object.keys(k).forEach(l=>d(m,v?`${v}.${l}`:l,k[l])):m.push(v)}}),define(Z[207],x([0,1,169,64]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(C,M,E,g,y,b){const P={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${M.nameShort})`},S=await(0,p.getServiceMachineId)(E,y,b);return(0,n.supportsTelemetry)(M,E)&&(0,n.getTelemetryLevel)(g)===3&&(P["X-Market-User-Id"]=S),P}e.resolveMarketplaceHeaders=D}),define(Z[208],x([0,1,2,49,3,27,153,20,55,53,40,32,64]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(m,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let k of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(k),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(k=>{const l=/^[a-f0-9]+$/i.test(k["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!l})})}setExperimentProperty(m,v){this._experimentProperties[m]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,S.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let v=m.sessionID,k=m["common.machineId"],l=m["common.firstSessionDate"],f=m["common.msftInternal"];return{sessionId:v,machineId:k,firstSessionDate:l,msftInternal:f}}dispose(){this._disposables.dispose()}_log(m,v,k,l){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(f=>{k=(0,n.mixin)(k,f),k=(0,n.mixin)(k,this._experimentProperties),k=(0,n.cloneAndChange)(k,c=>{if(typeof c=="string")return this._cleanupInfo(c,l)}),this._appenders.forEach(c=>c.log(m,k))},f=>{console.error(f)})}publicLog(m,v,k){return this._log(m,3,v,k)}publicLog2(m,v,k){return this.publicLog(m,v,k)}publicLogError(m,v){return this.sendErrorTelemetry?this._log(m,2,v,!0):Promise.resolve(void 0)}publicLogError2(m,v){return this.publicLogError(m,v)}_anonymizeFilePaths(m){let v=m;const k=[];for(let o of this._cleanupPatterns)for(;;){const u=o.exec(m);if(!u)break;k.push([u.index,o.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const o=f.exec(m);if(!o)break;!l.test(o[0])&&k.every(([u,s])=>o.index<u||o.index>=s)&&(v+=m.substring(c,o.index)+"<REDACTED: user-file-path>",c=f.lastIndex)}return c<m.length&&(v+=m.substr(c)),v}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const v=m.toLowerCase(),k=/@[a-zA-Z0-9-.]+/,l=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,f=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return l.test(v)?"<REDACTED: secret>":k.test(v)?"<REDACTED: email>":f.test(v)?"<REDACTED: token>":m}_cleanupInfo(m,v){let k=m;v&&(k=this._anonymizeFilePaths(k));for(let l of this._cleanupPatterns)k=k.replace(l,"");return k=this._removePropertiesWithPossibleUserInfo(k),k}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=ue([te(1,E.IConfigurationService)],w),e.TelemetryService=w;function t(){const d=(0,M.localize)(0,null,y.default.nameLong),m=y.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,M.localize)(3,null),k=(0,M.localize)(4,null),l=(0,M.localize)(5,null),f=(0,M.localize)(6,null),c=(0,M.localize)(7,null),o=`
|       | ${k} | ${l} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,M.localize)(8,null);return`
${d} ${m} ${v}

&nbsp;

${c}
${o}

&nbsp;

${u}
`}b.Registry.as(g.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(9,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(g.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,M.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,M.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[209],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[210],x([0,1,105,4,2,5,40,209]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var g;(function(m){function v(k){return k&&typeof k=="object"&&typeof k.id=="string"}m.isThemeColor=v})(g=e.ThemeColor||(e.ThemeColor={}));function y(m){return{id:m}}e.themeColorFromId=y;var b;(function(m){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||g.isThemeColor(i.color))}m.isThemeIcon=v;const k=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const r=k.exec(i);if(!r)return;let[,a]=r;return{id:a}}m.fromString=l;function f(i){return{id:i}}m.fromId=f;function c(i,r){let a=i.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),r&&(a=`${a}~${r}`),{id:a}}m.modify=c;function o(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}m.getModifier=o;function u(i,r){return i.id===r.id&&i.color?.id===r.color?.id}m.isEqual=u;function s(i,r){return{id:i.id,color:r?y(r):void 0}}m.asThemeIcon=s,m.asClassNameArray=p.CSSIcon.asClassNameArray,m.asClassName=p.CSSIcon.asClassName,m.asCSSSelector=p.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function P(m){switch(m){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const k=this.themingParticipants.indexOf(v);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new S;M.Registry.add(e.Extensions.ThemingContribution,w);function t(m){return w.onColorThemeChange(m)}e.registerThemingParticipant=t;class d extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,k){let l=this.theme.getColor(v);return l&&k&&(l=k(l,this.theme)),l?l.toString():null}}e.Themable=d}),define(Z[65],x([0,1,12,3,5,38]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",E="#1E1E1E",g="#000000",y="theme",b="themeBackground",P="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let S=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return g;let t=this.stateMainService.getItem(b,null);if(!t){let d;(n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],t=d==="hc-black"?g:d==="vs"?M:E}return n.isMacintosh&&t.toUpperCase()===E&&(t="#171717"),t}saveWindowSplash(t,d){this.stateMainService.setItems([{key:y,data:d.baseTheme},{key:b,data:d.colorInfo.background},{key:P,data:d}]),typeof t=="number"&&this.updateBackgroundColor(t,d)}updateBackgroundColor(t,d){for(const m of p.BrowserWindow.getAllWindows())if(m.id===t){m.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};S=ue([te(0,C.IStateMainService)],S),e.ThemeMainService=S}),define(Z[98],x([0,1,4,3,5,6]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var M;(function(t){t.Http="http",t.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=P;function S(t,d){return d?d!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=S;let w=class{constructor(d){this.logService=d,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],m=Array.from(this._tunnels.values());for(let v of m){const k=Array.from(v.values());for(let l of k){const f=await l.value;f&&d.push(f)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:m}of d.values())await m.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,m,v,k,l=!1,f=E.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${k}.`),!d)return;m||(m="localhost");const o=this.retainOrCreateTunnel(d,m,v,k,l,f,c);return o?o.then(u=>{if(!u){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(u);return(u.tunnelRemoteHost!==m||u.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const m=this._tunnels.get(d.tunnelRemoteHost);if(m){const v=m.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${m}.`);const k=v.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(m),k}}async closeTunnel(d,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${m} `);const v=this._tunnels.get(d);if(v&&v.has(m)){const k=v.get(m);k.refcount=0,await this.tryDisposeTunnel(d,m,k)}}addTunnelToMap(d,m,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,m){const v=this._tunnels.get(d);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,m){let v=[d];b(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):P(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const k=v.map(l=>this._tunnels.get(l));for(const l of k){const f=l?.get(m);if(f)return f}}canTunnel(d){return!!y(d)}createWithProvider(d,m,v,k,l,f,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${k}.`);const u={elevationRequired:l?S(k===void 0?v:k):!1},s={remoteAddress:{host:m,port:v},localAddressPort:k,privacy:f,public:f!==E.Private,protocol:c},i=d.forwardPort(s,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(m,v,i),i}};w=ue([te(0,C.ILogService)],w),e.AbstractTunnelService=w}),define(Z[41],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(n=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,M)=>({type:"idle",updateType:C,error:M}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[211],x([0,1,3,154,55,40]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[212],x([0,1,4,41]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(E){this.service=E}listen(E,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(E,g,y){switch(g){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=D;class C{constructor(E){this.channel=E,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(Z[99],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[213],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(E){this.handler=E}listen(E,g){throw new Error(`Event not found: ${g}`)}call(E,g,y){switch(g){case"handleURL":return this.handler.handleURL(p.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=n;class D{constructor(E){this.channel=E}handleURL(E,g){return this.channel.call("handleURL",[E.toJSON(),g])}}e.URLHandlerChannelClient=D;class C{constructor(E){this.next=E}async routeCall(E,g,y,b){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(y){const P=p.URI.revive(y);if(P&&P.query){const S=/\bwindowId=(\d+)/.exec(P.query);if(S){const w=S[1],t=new RegExp(`window:${w}`),d=E.connections.find(m=>t.test(m.ctx));if(d)return d}}}return this.next.routeCall(E,g,y,b)}routeEvent(E,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=C}),define(Z[214],x([0,1,8,2,7,21]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,b){const P=[...this.handlers.values()];return(0,p.first)(P.map(S=>()=>S.handleURL(y,b)),void 0,!1).then(S=>S||!1)}registerHandler(y){return this.handlers.add(y),(0,n.toDisposable)(()=>this.handlers.delete(y))}}e.AbstractURLService=M;let E=class extends M{constructor(y){super();this.productService=y}create(y){let{authority:b,path:P,query:S,fragment:w}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&P&&P.indexOf("/")!==0&&(P=`/${P}`),D.URI.from({scheme:this.productService.urlProtocol,authority:b,path:P,query:S,fragment:w})}};E=ue([te(0,C.IProductService)],E),e.NativeURLService=E}),define(Z[215],x([0,1,12,8,4,2,3,7]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function g(b){try{return E.URI.parse(b)}catch{return null}}class y{constructor(P,S,w,t,d){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=P,M.isWindows){const k=t.isBuilt?[]:[`"${t.appRoot}"`];k.push("--open-url","--"),p.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,k)}const m=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(k,l)=>({event:k,url:l})),({event:k,url:l})=>(k.preventDefault(),l));this.disposables.add(m(k=>{const l=g(k);!l||this.urlService.open(l,{originalUrl:k})})),w.getWindows().filter(k=>k.isReady).length>0?this.flush():D.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||P.push(S);P.length!==0&&(this.uris=P,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(Z[216],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[217],x([0,1,12,2,10,7]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends n.Disposable{constructor(){super();const g=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,g)}handleWebviewRequest(g,y){try{const b=C.URI.parse(g.url),P=M.validWebviewFilePaths.get(b.path);if(typeof P=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${P}`,w=D.FileAccess.asFileUri(S,V);return y(decodeURIComponent(w.fsPath))}else return y({error:-10})}catch{}return y({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[66],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(y){return!!y.workspaceUri}e.isWorkspaceToOpen=n;function D(y){return!!y.folderUri}e.isFolderToOpen=D;function C(y){return!!y.fileUri}e.isFileToOpen=C;function M(y){const b=E(y),P=y.getValue("window.menuBarVisibility");return P==="default"||b==="native"&&P==="compact"||p.isMacintosh&&p.isNative?"classic":P}e.getMenuBarVisibility=M;function E(y){if(p.isWeb)return"custom";const b=y.getValue("window");if(b){if(p.isMacintosh&&b.nativeTabs===!0||p.isMacintosh&&b.nativeFullScreen===!1)return"native";const w=y.getValue("workbench.colorCustomizations");if(w?.["window.activeBorder"]||w?.["window.inactiveBorder"])return"custom";const t=b.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=E;function g(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=g}),define(Z[34],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var D;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(y){y[y.CLI=0]="CLI",y[y.DOCK=1]="DOCK",y[y.MENU=2]="MENU",y[y.DIALOG=3]="DIALOG",y[y.DESKTOP=4]="DESKTOP",y[y.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const M=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=M;var E;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(E=e.WindowMode||(e.WindowMode={}));var g;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(g=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[218],x([0,1,12,23,4,69,2,31,74,91,6,21,34]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let t=class extends M.Disposable{constructor(m,v,k,l,f){super();this.logService=m,this.windowsMainService=v,this.credentialsService=k,this.encryptionMainService=l,this.productService=f,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=D.Event.fromNodeEventEmitter(p.app,"login",(v,k,l,f,c)=>({event:v,webContents:k,req:l,authInfo:f,callback:c}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:v,req:k,callback:l}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&k.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let f;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{f=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}l(f?.username,f?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(m);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const v=String((0,C.hash)({scheme:m.scheme,host:m.host,port:m.port}));let k,l;try{const u=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(u){const s=JSON.parse(await this.encryptionMainService.decrypt(u));k=s.username,l=s.password}}catch(u){this.logService.error(u)}if(this.state!==w.StoredCredentialsUsed&&typeof k=="string"&&typeof l=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:k,password:l};const f=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!f){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const c={authInfo:m,username:this.sessionCredentials?.username??k,password:this.sessionCredentials?.password??l,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=w.LoginDialogShown;const o=await new Promise(u=>{const s=async(i,r,a)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",s),a){const h={username:a.username,password:a.password};try{if(a.remember){const I=await this.encryptionMainService.encrypt(JSON.stringify(h));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,I)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(I){this.logService.error(I)}u({username:h.username,password:h.password})}else u(void 0)};f.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=o,o}};t=ue([te(0,b.ILogService),te(1,S.IWindowsMainService),te(2,g.ICredentialsMainService),te(3,y.IEncryptionMainService),te(4,P.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[219],x([0,1,12,4,2,217,34]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends D.Disposable{constructor(y){super();this.windowsMainService=y,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(y,b){let P;if(typeof y.windowId=="number"){const{windowId:S}=y,w=this.windowsMainService.getWindowById(S);if(!w?.win)throw new Error(`Invalid windowId: ${S}`);P=w.win.webContents}else{const{webContentsId:S}=y;if(P=p.webContents.fromId(S),!P)throw new Error(`Invalid webContentsId: ${S}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(b)}async findInFrame(y,b,P,S){const t=this.getFrameByName(y,b);if(typeof t.findInFrame=="function"){t.findInFrame(P,{findNext:S.findNext,forward:S.forward});const d=(m,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),t.removeListener("found-in-frame",d))};t.on("found-in-frame",d)}}async stopFindInFrame(y,b,P){const w=this.getFrameByName(y,b);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(y,b){const P=this.windowsMainService.getWindowById(y.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${y}`);const S=P.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===b);if(!S)throw new Error(`Unknown frame: ${b}`);return S}};E=ue([te(0,M.IWindowsMainService)],E),e.WebviewMainService=E}),define(Z[220],x([0,1,8,4,2]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:g,getActiveWindowId:y}){super();this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(E,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>y()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(Z[221],x([0,1,35,16,7,5]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var M;(function(S){S[S.EMPTY=1]="EMPTY",S[S.FOLDER=2]="FOLDER",S[S.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function E(S){const w=S;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=E;function g(S){const w=S;return!!(w&&typeof w=="object"&&D.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=g;class y{constructor(w,t,d,m,v){this._id=w,this._transient=d,this._configuration=m,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(w){this._id=w.id,this._configuration=w.configuration,this._transient=w.transient,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class b{constructor(w,t){this.raw=t,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,n.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function P(S){return new b({uri:S,index:0,name:(0,n.basenameOrAuthority)(S)},{uri:S.toString()})}e.toWorkspaceFolder=P}),define(Z[26],x([0,1,28,44,107,33,10,9,3,16,7,157,5,78,221]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(j){return(typeof j=="string"?(0,E.extname)(j):(0,y.extname)(j))===d}e.hasWorkspaceFileExtension=m,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function v(j){return j.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function k(j){return j.hasOwnProperty("folderUri")}e.isRecentFolder=k;function l(j){return j.hasOwnProperty("fileUri")}e.isRecentFile=l;function f(j){return j&&j.hasOwnProperty("folderUri")}e.isFolderBackupInfo=f;function c(j){return j&&j.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=c;function o(j){const J=j;return typeof J?.id=="string"&&b.URI.isUri(J.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(j){if(j.configuration)return{id:j.id,configPath:j.configuration};if(j.folders.length===1)return{id:j.id,uri:j.folders[0].uri}}e.toWorkspaceIdentifier=u;function s(j){const J=j;return typeof J?.id=="string"&&b.URI.isUri(J.configPath)}e.isWorkspaceIdentifier=s;function i(j){const J=j;if(J?.uri)return{id:J.id,uri:b.URI.revive(J.uri)};const U=j;if(U?.configPath)return{id:U.id,configPath:b.URI.revive(U.configPath)};if(j?.id)return{id:j.id}}e.reviveIdentifier=i;function r(j,J){return y.extUriBiasedIgnorePathCase.isEqualOrParent(j,J.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(j){return h(j)||I(j)}e.isStoredWorkspaceFolder=a;function h(j){const J=j;return typeof J?.path=="string"&&(!J.name||typeof J.name=="string")}e.isRawFileWorkspaceFolder=h;function I(j){const J=j;return typeof J?.uri=="string"&&(!J.name||typeof J.name=="string")}e.isRawUriWorkspaceFolder=I;function R(j,J,U,B,K=!g.isWindows,$){if(j.scheme!==B.scheme)return{name:U,uri:j.toString(!0)};let F=J?void 0:$.relativePath(B,j);if(F!==void 0)F.length===0?F=".":g.isWindows&&j.scheme===M.Schemas.file&&!K&&(F=F.replace(/\//g,"\\"));else if(j.scheme===M.Schemas.file)F=j.fsPath,g.isWindows&&(F=(0,C.normalizeDriveLetter)(F),K&&(F=(0,p.toSlashes)(F)));else{if(!$.isEqualAuthority(j.authority,B.authority))return{name:U,uri:j.toString(!0)};F=j.path}return{name:U,path:F}}e.getStoredWorkspaceFolder=R;function L(j,J,U){let B=[],K=new Set;const $=U.dirname(J);for(let F of j){let _;if(h(F))F.path&&(_=U.resolvePath($,F.path));else if(I(F))try{_=b.URI.parse(F.uri),_.path[0]!=="/"&&(_=_.with({path:"/"+_.path}))}catch(T){console.warn(T)}if(_){let T=U.getComparisonKey(_);if(!K.has(T)){K.add(T);const A=F.name||U.basenameOrAuthority(_);B.push(new t.WorkspaceFolder({uri:_,name:A,index:B.length},F))}}}return B}e.toWorkspaceFolders=L;function W(j,J,U,B,K){let $=z(J,j);const F=K.dirname(J),_=K.dirname(B),T=[],A=Q($.folders);for(const ne of $.folders){const ce=h(ne)?K.resolvePath(F,ne.path):b.URI.parse(ne.uri);let ae;U?ae=!1:ae=!h(ne)||(0,E.isAbsolute)(ne.path),T.push(R(ce,ae,ne.name,_,A,K))}const O={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},N=D.setProperty(j,["folders"],T,O);let G=D.applyEdits(j,N);return(0,y.isEqualAuthority)($.remoteAuthority,(0,w.getRemoteAuthority)(B))&&(G=D.applyEdits(G,D.removeProperty(G,["remoteAuthority"],O))),G}e.rewriteWorkspaceFileForNewLocation=W;function z(j,J){let U=n.parse(J);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(B=>a(B));else throw new Error(`${j} looks like an invalid workspace file.`);return U}function Q(j){return g.isWindows?j.some(J=>h(J)&&J.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function ie(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function ee(j){return typeof j.folderUri=="string"}function q(j){return typeof j.fileUri=="string"}function X(j,J){const U={workspaces:[],files:[]};if(j){const B=function($,F){for(let _=0;_<$.length;_++)try{F($[_],_)}catch(T){J.warn(`Error restoring recent entry ${JSON.stringify($[_])}: ${T.toString()}. Skip entry.`)}},K=j;if(Array.isArray(K.entries))B(K.entries,$=>{const F=$.label,_=$.remoteAuthority;ie($)?U.workspaces.push({label:F,remoteAuthority:_,workspace:{id:$.workspace.id,configPath:b.URI.parse($.workspace.configPath)}}):ee($)?U.workspaces.push({label:F,remoteAuthority:_,folderUri:b.URI.parse($.folderUri)}):q($)&&U.files.push({label:F,remoteAuthority:_,fileUri:b.URI.parse($.fileUri)})});else{const $=j;Array.isArray($.workspaces3)&&B($.workspaces3,(F,_)=>{const T=Array.isArray($.workspaceLabels)&&$.workspaceLabels[_]||void 0;typeof F=="object"&&typeof F.id=="string"&&typeof F.configURIPath=="string"?U.workspaces.push({label:T,workspace:{id:F.id,configPath:b.URI.parse(F.configURIPath)}}):typeof F=="string"&&U.workspaces.push({label:T,folderUri:b.URI.parse(F)})}),Array.isArray($.files2)&&B($.files2,(F,_)=>{const T=Array.isArray($.fileLabels)&&$.fileLabels[_]||void 0;typeof F=="string"&&U.files.push({label:T,fileUri:b.URI.parse(F)})})}}return U}e.restoreRecentlyOpened=X;function H(j){const J={entries:[]};for(const U of j.workspaces)k(U)?J.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):J.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of j.files)J.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return J}e.toStoreData=H}),define(Z[47],x([0,1,12,8,69,33,2,70,9,3,14,24,139,5,6,38,26]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let v=class St{constructor(l,f){this.stateMainService=l,this.logService=f,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(l,f){return this.doPick({...l,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},f)}pickFolder(l,f){return this.doPick({...l,pickFolders:!0,title:(0,S.localize)(1,null)},f)}pickFile(l,f){return this.doPick({...l,pickFiles:!0,title:(0,S.localize)(2,null)},f)}pickWorkspace(l,f){const c=(0,S.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,S.localize)(4,null)),u=m.WORKSPACE_FILTER;return this.doPick({...l,pickFiles:!0,title:c,filters:u,buttonLabel:o},f)}async doPick(l,f){const c={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters};c.defaultPath=l.defaultPath||this.stateMainService.getItem(St.workingDirPickerStorageKey),(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(c.properties=void 0,l.pickFiles&&l.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),y.isMacintosh&&c.properties.push("treatPackageAsDirectory");const o=f||p.BrowserWindow.getFocusedWindow(),u=await this.showOpenDialog(c,(0,b.withNullAsUndefined)(o));if(u&&u.filePaths&&u.filePaths.length>0)return this.stateMainService.setItem(St.workingDirPickerStorageKey,(0,g.dirname)(u.filePaths[0])),u.filePaths}getWindowDialogQueue(l){if(l){let f=this.windowDialogQueues.get(l.id);return f||(f=new n.Queue,this.windowDialogQueues.set(l.id,f)),f}else return this.noWindowDialogueQueue}showMessageBox(l,f){return this.getWindowDialogQueue(f).queue(async()=>f?p.dialog.showMessageBox(f,l):p.dialog.showMessageBox(l))}async showSaveDialog(l,f){const c=this.acquireFileDialogLock(l,f);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(f).queue(async()=>{let o;return f?o=await p.dialog.showSaveDialog(f,l):o=await p.dialog.showSaveDialog(l),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,M.dispose)(c)}}normalizePath(l){return l&&y.isMacintosh&&(l=(0,E.normalizeNFC)(l)),l}normalizePaths(l){return l.map(f=>this.normalizePath(f))}async showOpenDialog(l,f){l.defaultPath&&(await P.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const c=this.acquireFileDialogLock(l,f);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(f).queue(async()=>{let o;return f?o=await p.dialog.showOpenDialog(f,l):o=await p.dialog.showOpenDialog(l),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,M.dispose)(c)}}acquireFileDialogLock(l,f){if(!f)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",l);let c=this.windowFileDialogLocks.get(f.id);c||(c=new Set,this.windowFileDialogLocks.set(f.id,c));const o=(0,D.hash)(l);if(!c.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",l),c.add(o),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",l),c?.delete(o),c?.size===0&&this.windowFileDialogLocks.delete(f.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([te(0,d.IStateMainService),te(1,t.ILogService)],v),e.DialogMainService=v}),define(Z[222],x([0,1,4,2,26]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends n.Disposable{constructor(E,g){super();this.logService=E,this.storageMainService=g,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(E,g)=>(E?E.push(g):E=[g],E),C.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(E))}))}serializeGlobalStorageEvents(E){const g=new Map,y=new Set;return E.forEach(b=>{const P=this.storageMainService.globalStorage.get(b.key);typeof P=="string"?g.set(b.key,P):y.add(b.key)}),{changed:Array.from(g.entries()),deleted:Array.from(y.values())}}listen(E,g){switch(g){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${g}`)}async call(E,g,y){const b=(0,D.reviveIdentifier)(y.workspace),P=await this.withStorageInitialized(b);switch(g){case"getItems":return Array.from(P.items.entries());case"updateItems":{const S=y;if(S.insert)for(const[w,t]of S.insert)P.set(w,t);S.delete&&S.delete.forEach(w=>P.delete(w));break}case"close":{if(b)return P.close();break}default:throw new Error(`Call not found: ${g}`)}}async withStorageInitialized(E){const g=E?this.storageMainService.workspaceStorage(E):this.storageMainService.globalStorage;try{await g.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${E?"workspace":"global"} storage due to ${y}`)}return g}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[223],x([0,1,8,4,2,9,24,89,128,6,97,32,26]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class w extends D.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this._storage.dispose(),this._storage=v,this._register(v.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(v);const k=v.getBoolean(b.IS_NEW_KEY);k===void 0?v.set(b.IS_NEW_KEY,!0):k&&v.set(b.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this._storage.items}get(v,k){return this._storage.get(v,k)}set(v,k){return this._storage.set(v,k)}delete(v){return this._storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends w{constructor(v,k,l){super(k);this.options=v,this.environmentService=l}async doCreate(){let v;return this.options.useInMemoryStorage?v=g.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new E.Storage(new g.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(P.firstSessionDateStorageKey,void 0)===void 0&&v.set(P.firstSessionDateStorageKey,new Date().toUTCString());const l=v.get(P.currentSessionDateStorageKey,void 0),f=new Date().toUTCString();v.set(P.lastSessionDateStorageKey,typeof l=="undefined"?null:l),v.set(P.currentSessionDateStorageKey,f)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class d extends w{constructor(v,k,l,f){super(l);this.workspace=v,this.options=k,this.environmentService=f}async doCreate(){const{storageFilePath:v,wasCreated:k}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new g.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:k?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:g.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),k=(0,C.join)(v,d.WORKSPACE_STORAGE_NAME);return await M.Promises.exists(v)?{storageFilePath:k,wasCreated:!1}:(await M.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:k,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let k;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?k={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(k={workspace:this.workspace.configPath.toString()}),k)try{const l=(0,C.join)(v,d.WORKSPACE_META_NAME);await M.Promises.exists(l)||await M.Promises.writeFile(l,JSON.stringify(k,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=d,d.WORKSPACE_STORAGE_NAME="state.vscdb",d.WORKSPACE_META_NAME="workspace.json"}),define(Z[100],x([0,1,16,7,26]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(g,y,b){for(const S of g){const w=S.openedWorkspace;if((0,D.isWorkspaceIdentifier)(w)){const t=b(w);if(t){if(t.folders.some(d=>p.extUriBiasedIgnorePathCase.isEqualOrParent(y,d.uri)))return S}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(y,w.configPath))return S}}const P=g.filter(S=>(0,D.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(y,S.openedWorkspace.uri));if(P.length)return P.sort((S,w)=>-(S.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function M(g,y){for(const b of g)if((0,D.isWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,y)||(0,D.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,y))return b}e.findWindowOnWorkspaceOrFolder=M;function E(g,y){const b=P=>y.some(S=>p.extUriBiasedIgnorePathCase.isEqual(n.URI.file(S),n.URI.file(P)));for(const P of g)if(P.config?.extensionDevelopmentPath?.some(S=>b(S)))return P}e.findWindowOnExtensionDevelopmentPath=E}),define(Z[224],x([0,1,12,2,3,16,7,20,19,6,38,34,26]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class bt extends n.Disposable{constructor(l,f,c,o,u){super();this.windowsMainService=l,this.stateMainService=f,this.lifecycleMainService=c,this.logService=o,this.configurationService=u,this._state=t(this.stateMainService.getItem(bt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(u=>!u.isExtensionDevelopmentHost)),o&&(l.lastActiveWindow=this.toWindowState(o))}const f=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);f&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(f)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const c=m(l);this.stateMainService.setItem(bt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(l){if(this.lifecycleMainService.quitRequested)return;const f=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=f:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(c=>{const o=(0,S.isWorkspaceIdentifier)(l.openedWorkspace)&&c.workspace?.id===l.openedWorkspace.id,u=(0,S.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&c.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(c.folderUri,l.openedWorkspace.uri);(o||u)&&(c.uiState=f.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=f)}toWindowState(l){return{workspace:(0,S.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,S.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const f=this.doGetNewWindowState(l),c=this.configurationService.getValue("window");let o;return f.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(u=>u.isFullScreen)&&(o=!1)),f.mode===3&&!o&&(f.mode=1),f}doGetNewWindowState(l){const f=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=l.workspace;if((0,S.isWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===r.id).map(I=>I.uiState);if(h.length)return h[0]}if((0,S.isSingleFolderWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(I=>I.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(I.folderUri,r.uri)).map(I=>I.uiState);if(h.length)return h[0]}else if(l.backupPath){const h=this.state.openedWindows.filter(I=>I.backupPath===l.backupPath).map(I=>I.uiState);if(h.length)return h[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!f&&a)return a.uiState}let c;const o=p.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(D.isMacintosh){const r=p.screen.getCursorScreenPoint();c=p.screen.getDisplayNearestPoint(r)}!c&&f&&(c=p.screen.getDisplayMatching(f.getBounds())),c||(c=p.screen.getPrimaryDisplay()||o[0])}let u=(0,P.defaultWindowState)();u.x=Math.round(c.bounds.x+c.bounds.width/2-u.width/2),u.y=Math.round(c.bounds.y+c.bounds.height/2-u.height/2);const s=this.configurationService.getValue("window");let i=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")u.mode=0,i=!1;else if(s.newWindowDimensions==="fullscreen")u.mode=3,i=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&f){const r=f.serializeWindowState();r.mode===3?u.mode=3:u=r,i=u.mode!==3&&s.newWindowDimensions==="offset"}}return i&&(u=this.ensureNoOverlap(u)),u.hasDefaultState=!0,u}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const f=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;f.some(c=>c.x===l.x||c.y===l.y);)l.x+=30,l.y+=30;return l}};w.windowsStateStorageKey="windowsState",w=ue([te(0,P.IWindowsMainService),te(1,b.IStateMainService),te(2,g.ILifecycleMainService),te(3,y.ILogService),te(4,E.IConfigurationService)],w),e.WindowsStateHandler=w;function t(k){const l={openedWindows:[]},f=k||{openedWindows:[]};return f.lastActiveWindow&&(l.lastActiveWindow=d(f.lastActiveWindow)),f.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=d(f.lastPluginDevelopmentHostWindow)),Array.isArray(f.openedWindows)&&(l.openedWindows=f.openedWindows.map(c=>d(c))),l}e.restoreWindowsState=t;function d(k){const l={uiState:k.uiState};return k.backupPath&&(l.backupPath=k.backupPath),k.remoteAuthority&&(l.remoteAuthority=k.remoteAuthority),k.folder&&(l.folderUri=M.URI.parse(k.folder)),k.workspaceIdentifier&&(l.workspace={id:k.workspaceIdentifier.id,configPath:M.URI.parse(k.workspaceIdentifier.configURIPath)}),l}function m(k){return{lastActiveWindow:k.lastActiveWindow&&v(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&v(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(l=>v(l))}}e.getWindowsStateStoreData=m;function v(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(Z[101],x([0,1,60,29,10,3,16]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function E(y){function b(){let P=y.scheme===D.Schemas.file?(0,M.originalFSPath)(y):y.toString();return C.isLinux||(P=P.toLowerCase()),(0,p.createHash)("md5").update(P).digest("hex")}return{id:b(),configPath:y}}e.getWorkspaceIdentifier=E;function g(y,b){function P(){if(y.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(y.toString()).digest("hex");if(!b)try{b=(0,n.statSync)(y.fsPath)}catch{return}let w;return C.isLinux?w=b.ino:C.isMacintosh?w=b.birthtime.getTime():C.isWindows&&(typeof b.birthtimeMs=="number"?w=Math.floor(b.birthtimeMs):w=b.birthtime.getTime()),(0,p.createHash)("md5").update(y.fsPath).update(w?String(w):"").digest("hex")}const S=P();if(typeof S=="string")return{id:S,uri:y}}e.getSingleFolderWorkspaceIdentifier=g}),define(Z[225],x([0,1,15,4,10,6,252,116,19,84]),function(V,e,p,n,D,C,M,E,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class b{constructor(t,d){this._worker=new M.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",V).fsPath),this._worker.on("message",t),this._worker.on("error",d),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,d){this._worker.postMessage(t,d)}dispose(){this._worker.terminate()}}let P=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};P=ue([te(0,C.ILogService)],P);let S=class{constructor(t,d){this._logService=t,this._shutdown=!1,this._proxy=null;const m={create:(v,k,l)=>{const f=new b(k,l);return f.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),f.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),f.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),f.postMessage(v,[]),f}};this._worker=new E.SimpleWorkerClient(m,"vs/platform/extensions/node/extensionHostStarterWorker",new P(this._logService)),this._initialize(),d.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.createExtensionHost()}async start(t,d){const m=y.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();const k=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),l=await v.start(t,d),f=m.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${f} ms.`),clearTimeout(k),l}async enableInspectPort(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.enableInspectPort(t)}async kill(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.kill(t)}};S=ue([te(0,C.ILogService),te(1,g.ILifecycleMainService)],S),e.WorkerMainProcessExtensionHostStarter=S}),define(Z[57],x([0,1,60,61,25,17,15,4,2,9,3,31,37,87,226]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(L,W=""){this.debugLabel=W,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=z=>{if(this.traceSocketEvent("error",{code:z?.code,message:z?.message}),z){if(z.code==="EPIPE")return;(0,M.onUnexpectedError)(z)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,W){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const W=z=>{this.traceSocketEvent("read",z),L(C.VSBuffer.wrap(z))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(L){const W=z=>{this.traceSocketEvent("close",{hadError:z}),L({type:0,hadError:z,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(L){const W=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const z=()=>{this.socket.off("close",z),this.socket.off("end",z),this.socket.off("error",z),this.socket.off("timeout",z),this.socket.off("drain",z),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",z),this.socket.on("end",z),this.socket.on("error",z),this.socket.on("timeout",z),this.socket.on("drain",z)})}}e.NodeSocket=d;var m;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var v;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(v||(v={}));class k extends g.Disposable{constructor(L,W,z,Q){super();this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:z?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new l(this,W,z,Q,this._onData,(ie,ee)=>this._write(ie,ee))),this._register(this._flowManager.onError(ie=>{console.error(ie),(0,M.onUnexpectedError)(ie),this._onClose.fire({type:0,hadError:!0,error:ie})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(ie=>this._acceptChunk(ie))),this._register(this.socket.onClose(ie=>this._onClose.fire(ie)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,W){this.socket.traceSocketEvent(L,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let z=2;L.byteLength<126?z+=0:L.byteLength<2**16?z+=2:z+=8;const Q=C.VSBuffer.alloc(z);if(W?Q.writeUInt8(194,0):Q.writeUInt8(130,0),L.byteLength<126)Q.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Q.writeUInt8(126,1);let ie=1;Q.writeUInt8(L.byteLength>>>8&255,++ie),Q.writeUInt8(L.byteLength>>>0&255,++ie)}else{Q.writeUInt8(127,1);let ie=1;Q.writeUInt8(0,++ie),Q.writeUInt8(0,++ie),Q.writeUInt8(0,++ie),Q.writeUInt8(0,++ie),Q.writeUInt8(L.byteLength>>>24&255,++ie),Q.writeUInt8(L.byteLength>>>16&255,++ie),Q.writeUInt8(L.byteLength>>>8&255,++ie),Q.writeUInt8(L.byteLength>>>0&255,++ie)}this.socket.write(C.VSBuffer.concat([Q,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),z=W.readUInt8(0),Q=(z&128)>>>7,ie=(z&64)>>>6,ee=W.readUInt8(1),q=(ee&128)>>>7,X=ee&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ie)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),z=W.readUInt8(1),Q=(z&128)>>>7;let ie=z&127,ee=1;ie===126?ie=W.readUInt8(++ee)*2**8+W.readUInt8(++ee):ie===127&&(ie=W.readUInt8(++ee)*0+W.readUInt8(++ee)*0+W.readUInt8(++ee)*0+W.readUInt8(++ee)*0+W.readUInt8(++ee)*2**24+W.readUInt8(++ee)*2**16+W.readUInt8(++ee)*2**8+W.readUInt8(++ee));let q=0;Q&&(q=W.readUInt8(++ee)*2**24+W.readUInt8(++ee)*2**16+W.readUInt8(++ee)*2**8+W.readUInt8(++ee)),this._state.state=3,this._state.readLen=ie,this._state.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),o(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=k;class l extends g.Disposable{constructor(L,W,z,Q,ie,ee){super();this._tracer=L,this._onData=ie,this._writeFn=ee,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new E.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new f(this._tracer,Q,z,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(q=>this._onError.fire(q))),this._register(this._zlibDeflateStream.onError(q=>this._onError.fire(q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(W,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,W){return new Promise((z,Q)=>{L.write(W),L.flush(ie=>z(ie))})}acceptFrame(L,W,z){this._readQueue.push({data:L,isCompressed:W,isLastFrameOfMessage:z}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,W,z){return new Promise((Q,ie)=>{L.write(W),z&&L.write(C.VSBuffer.fromByteArray([0,0,255,255])),L.flush(ee=>Q(ee))})}}class f extends g.Disposable{constructor(L,W,z,Q){super();this._tracer=L,this._recordInflateBytes=W,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",ie=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ie?.message,code:ie?.code}),this._onError.fire(ie)}),this._zlibInflate.on("data",ie=>{this._tracer.traceSocketEvent("zlibInflateData",ie),this._pendingInflateData.push(C.VSBuffer.wrap(ie))}),z&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",z.buffer),this._zlibInflate.write(z.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(W)})}}class c extends g.Disposable{constructor(L,W){super();this._tracer=L,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",z=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibDeflate.on("data",z=>{this._tracer.traceSocketEvent("zlibDeflateData",z),this._pendingDeflateData.push(C.VSBuffer.wrap(z))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),L(W)})}}function o(R,L){if(L===0)return;let W=R.byteLength>>>2;for(let X=0;X<W;X++){const H=R.readUInt32BE(X*4);R.writeUInt32BE(H^L,X*4)}let z=W*4,Q=R.byteLength-z;const ie=L>>>24&255,ee=L>>>16&255,q=L>>>8&255;Q>=1&&R.writeUInt8(R.readUInt8(z)^ie,z),Q>=2&&R.writeUInt8(R.readUInt8(z+1)^ee,z+1),Q>=3&&R.writeUInt8(R.readUInt8(z+2)^q,z+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const R=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${R}.sock`):L=(0,y.join)((0,D.tmpdir)(),`vscode-ipc-${R}.sock`),r(L),L}e.createRandomIPCHandle=s;function i(R,L,W){const z=(0,p.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${z}-${W}-${L}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${z.substr(0,8)}-${W}-${L}.sock`):Q=(0,y.join)(R,`${W}-${L}.sock`),r(Q),Q}e.createStaticIPCHandle=i;function r(R){const L=u[b.platform];typeof L=="number"&&R.length>=L&&console.warn(`WARNING: IPC handle "${R}" is longer than ${L} chars, try a shorter --user-data-dir`)}class a extends S.IPCServer{constructor(L){super(a.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const W=E.Event.fromNodeEventEmitter(L,"connection");return E.Event.map(W,z=>({protocol:new w.Protocol(new d(z,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(z,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function h(R){return new Promise((L,W)=>{const z=(0,n.createServer)();z.on("error",W),z.listen(R,()=>{z.removeListener("error",W),L(new a(z))})})}e.serve=h;function I(R,L){return new Promise((W,z)=>{const Q=(0,n.createConnection)(R,()=>{Q.removeListener("error",z),W(w.Client.fromSocket(new d(Q,`ipc-client${L}`),L))});Q.once("error",z)})}e.connect=I}),define(Z[227],x([0,1,57]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(g){this.driver=g}listen(g,y){throw new Error("No event found")}call(g,y,b){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(b);case"startTracing":return this.driver.startTracing(b[0],b[1]);case"stopTracing":return this.driver.stopTracing(b[0],b[1],b[2]);case"reloadWindow":return this.driver.reloadWindow(b);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(b[0],b[1]);case"click":return this.driver.click(b[0],b[1],b[2],b[3]);case"doubleClick":return this.driver.doubleClick(b[0],b[1]);case"setValue":return this.driver.setValue(b[0],b[1],b[2]);case"getTitle":return this.driver.getTitle(b[0]);case"isActiveElement":return this.driver.isActiveElement(b[0],b[1]);case"getElements":return this.driver.getElements(b[0],b[1],b[2]);case"getElementXY":return this.driver.getElementXY(b[0],b[1],b[2]);case"typeInEditor":return this.driver.typeInEditor(b[0],b[1],b[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(b[0],b[1]);case"writeInTerminal":return this.driver.writeInTerminal(b[0],b[1],b[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(b);case"getLocalizedStrings":return this.driver.getLocalizedStrings(b)}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=n;class D{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}startTracing(g,y){return this.channel.call("startTracing",[g,y])}stopTracing(g,y,b){return this.channel.call("stopTracing",[g,y,b])}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,y){return this.channel.call("dispatchKeybinding",[g,y])}click(g,y,b,P){return this.channel.call("click",[g,y,b,P])}doubleClick(g,y){return this.channel.call("doubleClick",[g,y])}setValue(g,y,b){return this.channel.call("setValue",[g,y,b])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,y){return this.channel.call("isActiveElement",[g,y])}getElements(g,y,b){return this.channel.call("getElements",[g,y,b])}getElementXY(g,y,b,P){return this.channel.call("getElementXY",[g,y,b,P])}typeInEditor(g,y,b){return this.channel.call("typeInEditor",[g,y,b])}getTerminalBuffer(g,y){return this.channel.call("getTerminalBuffer",[g,y])}writeInTerminal(g,y,b){return this.channel.call("writeInTerminal",[g,y,b])}getLocaleInfo(g){return this.channel.call("getLocaleInfo",g)}getLocalizedStrings(g){return this.channel.call("getLocalizedStrings",g)}}e.DriverChannelClient=D;class C{constructor(g){this.registry=g}listen(g,y){throw new Error(`Event not found: ${y}`)}call(g,y,b){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(b);case"reloadWindowDriver":return this.registry.reloadWindowDriver(b)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=C;async function M(E){const g=await(0,p.connect)(E,"driverClient"),y=g.getChannel("driver"),b=new D(y);return{client:g,driver:b}}e.connect=M}),define(Z[22],x([0,1,46,9,57,51,167,5]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(C.IEnvironmentService);class g extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([p.memoize],g.prototype,"cachedLanguagesPath",null),ue([p.memoize],g.prototype,"backupHome",null),ue([p.memoize],g.prototype,"backupWorkspacesPath",null),ue([p.memoize],g.prototype,"mainIPCHandle",null),ue([p.memoize],g.prototype,"mainLockfile",null),ue([p.memoize],g.prototype,"sandbox",null),ue([p.memoize],g.prototype,"driverVerbose",null),ue([p.memoize],g.prototype,"disableUpdates",null),ue([p.memoize],g.prototype,"disableKeytar",null),ue([p.memoize],g.prototype,"codeCachePath",null),ue([p.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(Z[228],x([0,1,60,29,28,10,9,3,16,7,24,160,20,22,18,6,26]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(l,f,c){this.configurationService=f,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=g.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,u)=>(0,D.isEqual)(o,u,!E.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await b.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{l=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos);let f=[];try{Array.isArray(l.rootURIWorkspaces)&&(f=l.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:y.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(f);let c=[];try{Array.isArray(l.folderWorkspaceInfos)?c=l.folderWorkspaceInfos.map(o=>({folderUri:y.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(l.folderURIWorkspaces)&&(c=l.folderURIWorkspaces.map(o=>({folderUri:y.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,f){this.workspaces.some(o=>l.workspace.id===o.workspace.id)||(this.workspaces.push(l),this.saveSync());const c=this.getBackupPath(l.workspace.id);return f&&this.moveBackupFolderSync(c,f),c}moveBackupFolderSync(l,f){if(n.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),n.existsSync(f))try{n.renameSync(f,l)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(l){const f=l.id,c=this.workspaces.findIndex(o=>o.workspace.id===f);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(f=>this.backupUriComparer.isEqual(l.folderUri,f.folderUri))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const f=this.folders.findIndex(c=>this.backupUriComparer.isEqual(l,c.folderUri));f!==-1&&(this.folders.splice(f,1),this.saveSync())}registerEmptyWindowBackupSync(l,f){const c=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:f}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(l){const f=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,l));f!==-1&&(this.emptyWindows.splice(f,1),this.saveSync())}getBackupPath(l){return(0,M.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const f=new Set,c=[];for(let o of l){const u=o.workspace;if(!(0,m.isWorkspaceIdentifier)(u))return[];if(!f.has(u.id)){f.add(u.id);const s=this.getBackupPath(u.id);await this.doHasBackups(s)?u.configPath.scheme!==C.Schemas.file||await b.Promises.exists(u.configPath.fsPath)?c.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(l){if(!Array.isArray(l))return[];const f=[],c=new Set;for(let o of l){const u=o.folderUri,s=this.backupUriComparer.getComparisonKey(u);if(!c.has(s)){c.add(s);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?u.scheme!==C.Schemas.file||await b.Promises.exists(u.fsPath)?f.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return f}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const f=[],c=new Set;for(let o of l){const u=o.backupFolder;if(typeof u!="string")return[];if(!c.has(u)){c.add(u);const s=this.getBackupPath(u);await this.doHasBackups(s)?f.push(o):await this.deleteStaleBackup(s)}}return f}async deleteStaleBackup(l){try{await b.Promises.exists(l)&&await b.Promises.rm(l,b.RimRafMode.MOVE)}catch(f){this.logService.error(`Backup: Could not delete stale backup: ${f.toString()}`)}}async convertToEmptyWindowBackup(l){let f=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,f));)f=this.getRandomEmptyWindowId();const c=this.getBackupPath(f);try{await b.Promises.rename(l,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:f}),!0}convertToEmptyWindowBackupSync(l){let f=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,f));)f=this.getRandomEmptyWindowId();const c=this.getBackupPath(f);try{n.renameSync(l,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:f}),!0}async getDirtyWorkspaces(){const l=[];for(const f of this.workspaces)await this.hasBackups(f)&&l.push(f);for(const f of this.folders)await this.hasBackups(f)&&l.push(f);return l}hasBackups(l){let f;return(0,P.isEmptyWindowBackupInfo)(l)?f=l.backupFolder:(0,m.isFolderBackupInfo)(l)?f=this.getBackupPath(this.getFolderHash(l)):f=this.getBackupPath(l.workspace.id),this.doHasBackups(f)}async doHasBackups(l){try{const f=await b.Promises.readdir(l);for(const c of f)try{if((await b.Promises.readdir((0,M.join)(l,c))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,b.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await b.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderWorkspaceInfos:this.folders.map(l=>({folderUri:l.folderUri.toString(),remoteAuthority:l.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){const f=l.folderUri;let c;return f.scheme===C.Schemas.file?c=E.isLinux?f.fsPath:f.fsPath.toLowerCase():c=f.toString().toLowerCase(),(0,p.createHash)("md5").update(c).digest("hex")}};v=ue([te(0,w.IEnvironmentMainService),te(1,S.IConfigurationService),te(2,d.ILogService)],v),e.BackupMainService=v}),define(Z[229],x([0,1,8,4,108,59,2,3,37,57,162,227,22,182,19,34,18,7,9,17,6]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(s){return s<21}let o=class{constructor(i,r,a,h,I,R,L){this.windowServer=i,this.options=r,this.windowsMainService=a,this.lifecycleMainService=h,this.fileService=I,this.environmentMainService=R,this.logService=L,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,a){if(!a)return;const h=await this.capturePage(i),I=Buffer.from(h,"base64");await this.fileService.writeFile(v.URI.file((0,k.join)(this.environmentMainService.logsPath,`${r}.png`)),l.VSBuffer.wrap(I))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const a=D.KeybindingParser.parseUserBinding(r);for(let h of a)await this._dispatchKeybinding(i,h)}async _dispatchKeybinding(i,r){if(r instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const a=this.windowsMainService.getWindowById(i);if(!a?.win)throw new Error("Invalid window");const h=a.win.webContents,I=new C.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),L=new w.USLayoutResolvedKeybinding(I.toChord(),E.OS).getElectronAccelerator(),W=[];r.ctrlKey&&W.push("ctrl"),r.metaKey&&W.push("meta"),r.shiftKey&&W.push("shift"),r.altKey&&W.push("alt"),h.sendInputEvent({type:"keyDown",keyCode:L,modifiers:W}),c(r.keyCode)||h.sendInputEvent({type:"char",keyCode:L,modifiers:W}),h.sendInputEvent({type:"keyUp",keyCode:L,modifiers:W}),await(0,p.timeout)(100)}async click(i,r,a,h){await(await this.getWindowDriver(i)).click(r,a,h)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,a){await(await this.getWindowDriver(i)).setValue(r,a)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,a){return await(await this.getWindowDriver(i)).getElements(r,a)}async getElementXY(i,r,a,h){return await(await this.getWindowDriver(i)).getElementXY(r,a,h)}async typeInEditor(i,r,a){await(await this.getWindowDriver(i)).typeInEditor(r,a)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,a){await(await this.getWindowDriver(i)).writeInTerminal(r,a)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const r=`window:${i}`,a=new g.StaticRouter(I=>I===r),h=this.windowServer.getChannel("windowDriver",a);return new b.WindowDriverChannelClient(h)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};o=ue([te(2,d.IWindowsMainService),te(3,t.ILifecycleMainService),te(4,m.IFileService),te(5,S.IEnvironmentMainService),te(6,f.ILogService)],o),e.Driver=o;async function u(s,i,r,a){const h=r.driverVerbose,I=a.createInstance(o,s,{verbose:h}),R=new P.WindowDriverRegistryChannel(I);s.registerChannel("windowDriverRegistry",R);const L=await(0,y.serve)(i),W=new P.DriverChannel(I);return L.registerChannel("driver",W),(0,M.combinedDisposable)(L,s)}e.serve=u}),define(Z[230],x([0,1,61,57]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,M,E,g){const y=P=>g(P,void 0),b=p.createConnection({host:D,port:C},()=>{b.removeListener("error",y);const P=Buffer.alloc(16);for(let d=0;d<16;d++)P[d]=Math.round(Math.random()*256);const S=P.toString("base64"),w=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];b.write(w.join(`\r
`)+`\r
\r
`);const t=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",t),g(void 0,new n.NodeSocket(b,E)))};b.on("data",t)});b.setNoDelay(!0),b.once("error",y)}}}),define(Z[231],x([0,1,201,8,17,15,2,14,20,51,93,6,200,226]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends M.Disposable{constructor(m,v,k){super();this.environmentService=v,this.logService=k,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,v){this.logService.trace("RequestService#request",m.url);const{proxyUrl:k,strictSSL:l}=this;let f;try{f=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(u){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",u))}const c={...process.env,...f},o=m.agent?m.agent:await(0,S.getProxyAgent)(m.url||"",c,{proxyUrl:k,strictSSL:l});return m.agent=o,m.strictSSL=l,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,v)}async getNodeRequest(m){return((0,p.parse)(m.url).protocol==="https:"?await new Promise((l,f)=>{V(["https"],l,f)}):await new Promise((l,f)=>{V(["http"],l,f)})).request}_request(m,v){return n.Promises.withAsyncBody(async(k,l)=>{let f;const c=(0,p.parse)(m.url),o=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),u={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,E.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(u.auth=m.user+":"+m.password),f=o(u,s=>{const i=(0,E.isNumber)(m.followRedirects)?m.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...m,url:s.headers.location,followRedirects:i-1},v).then(k,l);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,w.createGunzip)())),k({res:s,stream:(0,D.streamToBufferReadableStream)(r)})}}),f.on("error",l),m.timeout&&f.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&f.write(m.data),f.end(),v.onCancellationRequested(()=>{f.abort(),l((0,C.canceled)())})})}async resolveProxy(m){}};t=ue([te(0,g.IConfigurationService),te(1,y.INativeEnvironmentService),te(2,P.ILogService)],t),e.RequestService=t}),define(Z[232],x([0,1,12,231]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(M){return p.net.request}class C extends n.RequestService{request(E,g){return super.request({...E||{},getRawRequest:D},g)}}e.RequestMainService=C}),define(Z[233],x([0,1,12,8,4,2,10,14,88,22,19,6,53,54,65,39]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends C.Disposable{constructor(k,l,f,c,o,u,s){super();this.machineId=k,this.userEnv=l,this.environmentMainService=f,this.lifecycleMainService=c,this.logService=o,this.themeMainService=u,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(k,l)=>this.onWindowConnection(k,l)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(k,l)=>this.onWorkerConnection(k,l)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(k,l){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const f=await this.connect();if(k.sender.isDestroyed())return f.close();k.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[f])}onWorkerConnection(k,l){this.logService.trace("SharedProcess: onWorkerConnection",l);const f=new C.DisposableStore,c=u=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${u}')`,l),f.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",l))},o=p.BrowserWindow.fromId(l.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!l.reply.channel){c("unavailable");return}f.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===o)(()=>c("load"))),f.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>c("closed"))),o.webContents.postMessage(l.reply.channel,l.reply.nonce,k.ports)}onWillShutdown(){const k=this.window;!k||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(k.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{k.close()}catch{}this.window=void 0},0))}send(k,...l){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${k}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(k,...l)}catch(f){this.logService.warn(`Error sending IPC message to channel '${k}' of shared process: ${(0,d.toErrorMessage)(f)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(k=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),k()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(k=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),k()}))})()),this._whenIpcReady}createWindow(){const k=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${k.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),k.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:S.default}),this.window.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=k=>{this.logService.trace("SharedProcess#close prevented"),k.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(k,l)=>this._onDidError.fire({type:2,details:l})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(k,l,f)=>this._onDidError.fire({type:3,details:{reason:f,exitCode:l}})))}async connect(){await this.whenIpcReady;const k=(0,E.assertIsDefined)(this.window);return(0,g.connect)(k)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const k=this.window;return k?!k.isDestroyed()&&!k.webContents.isDestroyed():!1}};m=ue([te(2,y.IEnvironmentMainService),te(3,b.ILifecycleMainService),te(4,P.ILogService),te(5,t.IThemeMainService),te(6,w.IProtocolMainService)],m),e.SharedProcess=m}),define(Z[234],x([0,1,8,17,9,14,7,22,18,6]),function(V,e,p,n,D,C,M,E,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class b{constructor(w,t,d){this.storagePath=w,this.logService=t,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,t){const d=this.storage[w];return(0,C.isUndefinedOrNull)(d)?t:d}setItem(w,t){this.setItems([{key:w,data:t}])}setItems(w){let t=!1;for(const{key:d,data:m}of w)this.storage[d]!==m&&((0,C.isUndefinedOrNull)(m)?(0,C.isUndefined)(this.storage[d])||(this.storage[d]=void 0,t=!0):(this.storage[d]=m,t=!0));t&&this.save()}removeItem(w){(0,C.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(w){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),w)}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=b;let P=class Pt{constructor(w,t,d){this.fileStorage=new b(M.URI.file((0,D.join)(w.userDataPath,Pt.STATE_FILE)),t,d)}async init(){return this.fileStorage.init()}getItem(w,t){return this.fileStorage.getItem(w,t)}setItem(w,t){this.fileStorage.setItem(w,t)}setItems(w){this.fileStorage.setItems(w)}removeItem(w){this.fileStorage.removeItem(w)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=ue([te(0,E.IEnvironmentMainService),te(1,y.ILogService),te(2,g.IFileService)],P),e.StateMainService=P}),define(Z[80],x([0,1,43,2,51,22,5,19,6,97,223]),function(V,e,p,n,D,C,M,E,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let P=class extends n.Disposable{constructor(t,d,m){super();this.logService=t,this.environmentService=d,this.lifecycleMainService=m,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,d]of this.mapWorkspaceToStorage)t.join(d.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new b.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new b.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let d=this.mapWorkspaceToStorage.get(t.id);return d||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),d=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,d),(0,p.once)(d.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),d}};P=ue([te(0,g.ILogService),te(1,D.IEnvironmentService),te(2,E.ILifecycleMainService)],P),e.StorageMainService=P,e.IGlobalStorageMainService=(0,M.createDecorator)("globalStorageMainService");let S=class extends y.AbstractStorageService{constructor(t,d){super();this.environmentMainService=t,this.storageMainService=d,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};S=ue([te(0,C.IEnvironmentMainService),te(1,e.IStorageMainService)],S),e.GlobalStorageMainService=S}),define(Z[235],x([0,1,61,121,230,8,2,20,6,21,199,98,79]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(k,l,f,c,o){let u;for(let s=3;s&&(u&&u.dispose(),u=await new t(k,l,f,c,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));s--);return u}class t extends M.Disposable{constructor(l,f,c,o,u){super();this.defaultTunnelHost=f,this.suggestedLocalPort=u,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=p.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let l=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(l){l.pause();const f=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),o=c.getSocket().socket,u=c.readEntireBuffer();c.dispose(),u.byteLength>0&&l.write(u.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),o.end()}),l.on("close",()=>o.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),o.destroy()}),o.on("end",()=>l.end()),o.on("close",()=>l.end()),o.on("error",()=>{l.destroy()}),l.pipe(o),o.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),o.end()})}}let d=class extends P.AbstractTunnelService{constructor(l,f,c,o,u){super(f);this.socketFactory=l,this.signService=c,this.productService=o,this.configurationService=u}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(l,f,c,o,u,s,i){const r=this.getTunnelFromMap(f,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,c,o,u,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},h=w(a,this.defaultTunnelHost,f,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,c,h),h}}};d=ue([te(1,g.ILogService),te(2,S.ISignService),te(3,y.IProductService),te(4,E.IConfigurationService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(l,f,c,o){super(D.nodeSocketFactory,l,f,c,o)}};m=ue([te(0,g.ILogService),te(1,S.ISignService),te(2,y.IProductService),te(3,E.IConfigurationService)],m),e.TunnelService=m;let v=class extends M.Disposable{constructor(l,f,c,o){super();this.logService=l,this.productService=f,this.signService=c,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(l,f,c,o,u,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${o} on local port ${u}.`),!this._tunnelServices.has(l)){const a=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(l,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(f,c,o,u,s,i,r)}};v=ue([te(0,g.ILogService),te(1,y.IProductService),te(2,S.ISignService),te(3,E.IConfigurationService)],v),e.SharedTunnelsService=v}),define(Z[81],x([0,1,8,23,4,20,22,19,6,21,56,41]),function(V,e,p,n,D,C,M,E,g,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(t,d,m){return`${m.updateUrl}/api/update/${t}/${d}/${m.commit}`}e.createUpdateURL=S;let w=class{constructor(d,m,v,k,l,f){this.lifecycleMainService=d,this.configurationService=m,this.environmentMainService=v,this.requestService=k,this.logService=l,this.productService=f,this._state=P.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.getUpdateMode(),m=this.getProductQuality(d);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),d==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(d){return d==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(d=60*60*1e3){return(0,p.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(d){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};w=ue([te(0,E.ILifecycleMainService),te(1,C.IConfigurationService),te(2,M.IEnvironmentMainService),te(3,b.IRequestService),te(4,g.ILogService),te(5,y.IProductService)],w),e.AbstractUpdateService=w}),define(Z[236],x([0,1,12,46,4,2,20,22,19,6,21,56,32,41,81]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends t.AbstractUpdateService{constructor(v,k,l,f,c,o,u){super(v,k,f,c,o,u);this.telemetryService=l,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,k)=>k)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,k,l)=>({url:k,version:l,productVersion:l}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,k,l,f)=>({releaseNotes:k,version:l,productVersion:l,date:f}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const l=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(w.State.Idle(1,l))}buildUpdateFeedUrl(v){let k;this.productService.darwinUniversalAssetId?k=this.productService.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,t.createUpdateURL)(k,v,this.productService);try{p.autoUpdater.setFeedURL({url:l})}catch(f){this.logService.error("Failed to set update feed URL",f);return}return l}doCheckForUpdates(v){this.setState(w.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(w.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],d.prototype,"onRawError",null),ue([n.memoize],d.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateDownloaded",null),d=ue([te(0,g.ILifecycleMainService),te(1,M.IConfigurationService),te(2,S.ITelemetryService),te(3,E.IEnvironmentMainService),te(4,P.IRequestService),te(5,y.ILogService),te(6,b.IProductService)],d),e.DarwinUpdateService=d}),define(Z[237],x([0,1,45,29,8,4,9,22,19,6,32,41]),function(V,e,p,n,D,C,M,E,g,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(d,m,v){if(this.lifecycleMainService=d,this.logService=v,this._state=P.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,k=>this.logService.error(k))}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}scheduleCheckForUpdates(d=60*60*1e3){return(0,D.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(d){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};S=ue([te(0,g.ILifecycleMainService),te(1,E.IEnvironmentMainService),te(2,y.ILogService)],S);let w=class extends S{constructor(d,m,v,k,l,f){super(v,k,l);this.snap=d,this.snapRevision=m,this.telemetryService=f;const c=(0,n.watch)(M.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(c,"change",(r,a)=>a),u=C.Event.filter(o,r=>r==="current"),i=C.Event.debounce(u,(r,a)=>a,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(d=>{d?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,d.message||d))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const d=await new Promise((v,k)=>(0,n.realpath)(`${M.dirname(this.snap)}/current`,(l,f)=>l?k(l):v(f))),m=M.basename(d);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,d=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=ue([te(2,g.ILifecycleMainService),te(3,E.IEnvironmentMainService),te(4,y.ILogService),te(5,b.ITelemetryService)],w),e.SnapUpdateService=w}),define(Z[42],x([0,1,12,29,4,44,33,2,10,9,3,16,14,24,159,50,47,22,5,6,21,100,26,101]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,k.createDecorator)("workspacesManagementMainService");let s=class extends E.Disposable{constructor(r,a,h,I,R){super();this.environmentMainService=r,this.logService=a,this.backupMainService=h,this.dialogMainService=I,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,a=>(0,n.readFileSync)(a,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,a=>w.Promises.readFile(a,"utf8"))}doResolveLocalWorkspace(r,a){if(!!this.isWorkspacePath(r)&&r.scheme===g.Schemas.file)try{const h=a(r.fsPath);return h instanceof Promise?h.then(I=>this.doResolveWorkspace(r,I),I=>{}):this.doResolveWorkspace(r,h)}catch{return}}isWorkspacePath(r){return(0,o.isUntitledWorkspace)(r,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,a){try{const h=this.doParseStoredWorkspace(r,a),I=(0,u.getWorkspaceIdentifier)(r);return{id:I.id,configPath:I.configPath,folders:(0,o.toWorkspaceFolders)(h.folders,I.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:h.remoteAuthority,transient:h.transient}}catch(h){this.logService.warn(h.toString())}}doParseStoredWorkspace(r,a){const h=(0,C.parse)(a);if(h&&Array.isArray(h.folders))h.folders=h.folders.filter(I=>(0,o.isStoredWorkspaceFolder)(I));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return h}async createUntitledWorkspace(r,a){const{workspace:h,storedWorkspace:I}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return await w.Promises.mkdir((0,y.dirname)(R),{recursive:!0}),await w.Promises.writeFile(R,JSON.stringify(I,null,"	")),h}createUntitledWorkspaceSync(r,a){const{workspace:h,storedWorkspace:I}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return(0,n.mkdirSync)((0,y.dirname)(R),{recursive:!0}),(0,w.writeFileSync)(R,JSON.stringify(I,null,"	")),h}newUntitledWorkspace(r=[],a){const h=(Date.now()+Math.round(Math.random()*1e3)).toString(),I=(0,P.joinPath)(this.untitledWorkspacesHome,h),R=(0,P.joinPath)(I,o.UNTITLED_WORKSPACE_NAME),L=[];for(const W of r)L.push((0,o.getStoredWorkspaceFolder)(W.uri,!0,W.name,I,!b.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,u.getWorkspaceIdentifier)(R),storedWorkspace:{folders:L,remoteAuthority:a}}}async getWorkspaceIdentifier(r){return(0,u.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,o.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const a=(0,P.originalFSPath)(r.configPath);try{(0,w.rimrafSync)((0,y.dirname)(a));const h=(0,y.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,n.existsSync)(h)&&(0,w.writeFileSync)((0,y.join)(h,"obsolete"),"")}catch(h){this.logService.warn(`Unable to delete untitled workspace ${a} (${h}).`)}}getUntitledWorkspacesSync(){const r=[];try{const a=(0,w.readdirSync)(this.untitledWorkspacesHome.fsPath).map(h=>(0,P.joinPath)(this.untitledWorkspacesHome,h,o.UNTITLED_WORKSPACE_NAME));for(const h of a){const I=(0,u.getWorkspaceIdentifier)(h),R=this.resolveLocalWorkspaceSync(h);R?r.push({workspace:I,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(I)}}catch(a){a.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${a}).`)}return r}async enterWorkspace(r,a,h){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,a,h))return;const R=this.doEnterWorkspace(r,(0,u.getWorkspaceIdentifier)(h));if(!!R)return this._onDidEnterWorkspace.fire({window:r,workspace:R.workspace}),R}async isValidTargetWorkspacePath(r,a,h){if(!h)return!0;if((0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,h))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(a,h)){const I={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,P.basename)(h)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(I,(0,S.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,a){if(!r.config)return;r.focus();let h;return r.config.extensionDevelopmentPath||(h=this.backupMainService.registerWorkspaceBackupSync({workspace:a,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=a,r.config.backupPath=h,{workspace:a,backupPath:h}}};s=ue([te(0,v.IEnvironmentMainService),te(1,l.ILogService),te(2,d.IBackupMainService),te(3,m.IDialogMainService),te(4,f.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Z[102],x([0,1,12,23,5,34,26,42]),function(V,e,p,n,D,C,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let g=class{constructor(b,P){this.windowsMainService=b,this.workspacesManagementMainService=P}async getRemoteDiagnostics(b){const P=this.windowsMainService.getWindows();return(await Promise.all(P.map(w=>new Promise(t=>{const d=w.remoteAuthority;if(d){const m=`vscode:getDiagnosticInfoResponse${w.id}`,v={includeProcesses:b.includeProcesses,folders:b.includeWorkspaceMetadata?this.getFolderURIs(w):void 0};w.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:m,args:v}),p.ipcMain.once(m,(k,l)=>{l||t({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),t(l)}),setTimeout(()=>{t({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)}else t(void 0)})))).filter(w=>!!w)}getFolderURIs(b){const P=[],S=b.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(S))P.push(S.uri);else if((0,M.isWorkspaceIdentifier)(S)){const w=this.workspacesManagementMainService.resolveLocalWorkspaceSync(S.configPath);w&&w.folders.forEach(d=>{P.push(d.uri)})}return P}};g=ue([te(0,C.IWindowsMainService),te(1,E.IWorkspacesManagementMainService)],g),e.DiagnosticsMainService=g}),define(Z[103],x([0,1,12,30,3,14,7,24,20,52,5,6,99,34,26,42]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let m=class{constructor(k,l,f,c,o){this.logService=k,this.windowsMainService=l,this.urlService=f,this.workspacesManagementMainService=c,this.configurationService=o}async start(k,l){this.logService.trace("Received data from other instance: ",k,l),D.isMacintosh&&p.app.focus({steal:!0});const f=this.parseOpenUrl(k);if(f.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:o,url:u}of f)this.urlService.open(o,{originalUrl:u})})}else return this.startOpenWindow(k,l)}parseOpenUrl(k){return k["open-url"]&&k._urls&&k._urls.length>0?(0,n.coalesce)(k._urls.map(l=>{try{return{uri:M.URI.parse(l),url:l}}catch{return null}})):[]}async startOpenWindow(k,l){const f=(0,y.isLaunchedFromCli)(l)?0:4;let c=[];const o=k.wait&&k.waitMarkerFilePath?M.URI.file(k.waitMarkerFilePath):void 0,u=k.remote||void 0,s={context:f,cli:k,userEnv:l,waitMarkerFileURI:o,remoteAuthority:u};if(k.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(k.extensionDevelopmentPath,s);else if(!k._.length&&!k["folder-uri"]&&!k["file-uri"]){let i=!1;if(k["new-window"]||k["unity-launch"])i=!0;else if(k["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!D.isMacintosh}if(i)c=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,s),c=[r]):c=this.windowsMainService.open({...s,forceEmpty:!0})}}else c=this.windowsMainService.open({...s,forceNewWindow:k["new-window"],preferNewWindow:!k["reuse-window"]&&!k.wait,forceReuseWindow:k["reuse-window"],diffMode:k.diff,addMode:k.add,noRecentEntry:!!k["skip-add-to-recently-opened"],gotoLineMode:k.goto});if(o&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,E.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const k=[];return p.BrowserWindow.getAllWindows().forEach(l=>{const f=this.windowsMainService.getWindowById(l.id);f?k.push(this.codeWindowToInfo(f)):k.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:k,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}getFolderURIs(k){const l=[],f=k.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(f))l.push(f.uri);else if((0,t.isWorkspaceIdentifier)(f)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(f.configPath);c&&c.folders.forEach(u=>{l.push(u.uri)})}return l}codeWindowToInfo(k){const l=this.getFolderURIs(k),f=(0,C.assertIsDefined)(k.win);return this.browserWindowToInfo(f,l,k.remoteAuthority)}browserWindowToInfo(k,l=[],f){return{pid:k.webContents.getOSProcessId(),title:k.getTitle(),folderURIs:l,remoteAuthority:f}}};m=ue([te(0,P.ILogService),te(1,w.IWindowsMainService),te(2,S.IURLService),te(3,d.IWorkspacesManagementMainService),te(4,g.IConfigurationService)],m),e.LaunchMainService=m}),define(Z[58],x([0,1,45,12,25,120,46,4,33,2,10,9,3,7,85,71,24,151,47,22,5,19,6,21,32,65,34,26,42]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c,o,u,s,i,r,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,f.createDecorator)("nativeHostMainService");let I=class extends y.Disposable{constructor(L,W,z,Q,ie,ee,q,X,H,j){super();this.sharedProcess=L,this.windowsMainService=W,this.dialogMainService=z,this.lifecycleMainService=Q,this.environmentMainService=ie,this.telemetryService=ee,this.logService=q,this.productService=X,this.themeMainService=H,this.workspacesManagementMainService=j,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,J=>J.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(J,U)=>U.id),J=>!!this.windowsMainService.getWindowById(J)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(J,U)=>U.id),J=>!!this.windowsMainService.getWindowById(J)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(J,U)=>U.id),J=>!!this.windowsMainService.getWindowById(J)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),J=>!!J),J=>J.id),E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(J,U)=>U.id),J=>!!this.windowsMainService.getWindowById(J))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(J,U,B)=>B),J=>!(Array.isArray(J)&&J.length===1&&J[0]==="workArea")),E.Event.fromNodeEventEmitter(n.screen,"display-added"),E.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const W=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(L,W,z){return Array.isArray(W)?this.doOpenWindow(L,W,z):this.doOpenEmptyWindow(L,W)}async doOpenWindow(L,W,z=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0})}async doOpenEmptyWindow(L,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},W)}async toggleFullScreen(L){const W=this.windowById(L);W&&W.toggleFullScreen()}async handleTitleDoubleClick(L){const W=this.windowById(L);W&&W.handleTitleDoubleClick()}async isMaximized(L){const W=this.windowById(L);return W?.win?W.win.isMaximized():!1}async maximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.maximize()}async unmaximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.unmaximize()}async minimizeWindow(L){const W=this.windowById(L);W?.win&&W.win.minimize()}async focusWindow(L,W){W&&typeof W.windowId=="number"&&(L=W.windowId);const z=this.windowById(L);z&&z.focus({force:W?.force??!1})}async setMinimumSize(L,W,z){const Q=this.windowById(L);if(Q?.win){const[ie,ee]=Q.win.getSize(),[q,X]=Q.win.getMinimumSize(),[H,j]=[W??q,z??X],[J,U]=[Math.max(ie,H),Math.max(ee,j)];(q!==H||X!==j)&&Q.win.setMinimumSize(H,j),(ie!==J||ee!==U)&&Q.win.setSize(J,U)}}async saveWindowSplash(L,W){this.themeMainService.saveWindowSplash(L,W)}async installShellCommand(L){const{source:W,target:z}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await m.SymlinkSupport.stat(W);if(Q&&!Q.dangling){const ie=await(0,t.realpath)(W);if(z===ie)return}await m.Promises.unlink(W)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await m.Promises.symlink(z,W)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:ie}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,g.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ie===0)try{const ee=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${W}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(ee)}catch{throw new Error((0,v.localize)(3,null,W))}}}async uninstallShellCommand(L){const{source:W}=await this.getShellCommandLink();try{await m.Promises.unlink(W)}catch(z){switch(z.code){case"EACCES":{const{response:Q}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,g.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const ie=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(ie)}catch{throw new Error((0,v.localize)(7,null,W))}break}case"ENOENT":break;default:throw z}}}async getShellCommandLink(){const L=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(L))throw new Error((0,v.localize)(8,null,L));return{source:W,target:L}}async showMessageBox(L,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(L))}async showSaveDialog(L,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(L))}async showOpenDialog(L,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(L))}toBrowserWindow(L){const W=this.windowById(L);if(W?.win)return W.win}async pickFileFolderAndOpen(L,W){const z=await this.dialogMainService.pickFileFolder(W);z&&(this.sendPickerTelemetry(z,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(z.map(async Q=>await m.SymlinkSupport.existsDirectory(Q)?{folderUri:w.URI.file(Q)}:{fileUri:w.URI.file(Q)})),W,L))}async pickFolderAndOpen(L,W){const z=await this.dialogMainService.pickFolder(W);z&&(this.sendPickerTelemetry(z,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(z.map(Q=>({folderUri:w.URI.file(Q)})),W,L))}async pickFileAndOpen(L,W){const z=await this.dialogMainService.pickFile(W);z&&(this.sendPickerTelemetry(z,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(z.map(Q=>({fileUri:w.URI.file(Q)})),W,L))}async pickWorkspaceAndOpen(L,W){const z=await this.dialogMainService.pickWorkspace(W);z&&(this.sendPickerTelemetry(z,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(z.map(Q=>({workspaceUri:w.URI.file(Q)})),W,L))}doOpenPicked(L,W,z){this.windowsMainService.open({context:3,contextWindowId:z,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(L,W,z){const Q=L?L.length:0;this.telemetryService.publicLog(W,{...z,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(L,W){n.shell.showItemInFolder(W)}async setRepresentedFilename(L,W){const z=this.windowById(L);z&&z.setRepresentedFilename(W)}async setDocumentEdited(L,W){const z=this.windowById(L);z&&z.setDocumentEdited(W)}async openExternal(L,W){return S.isLinuxSnap?this.safeSnapOpenExternal(W):n.shell.openExternal(W),!0}safeSnapOpenExternal(L){const W=process.env.GDK_PIXBUF_MODULE_FILE,z=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=z}moveItemToTrash(L,W){return n.shell.trashItem(W)}async isAdmin(){let L;return S.isWindows?L=(await new Promise((W,z)=>{V(["native-is-elevated"],W,z)}))():L=process.getuid()===0,L}async writeElevated(L,W,z,Q){const ie=await new Promise((ee,q)=>{V(["@vscode/sudo-prompt"],ee,q)});return new Promise((ee,q)=>{const X=[`"${this.cliPath}"`];Q?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${W.fsPath}"`,`"${z.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(X.join(" "),H,(j,J,U)=>{J&&this.logService.trace(`[sudo-prompt] received stdout: ${J}`),U&&this.logService.trace(`[sudo-prompt] received stderr: ${U}`),j?q(j):ee(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,W,z){process.kill(W,z)}async readClipboardText(L,W){return n.clipboard.readText(W)}async writeClipboardText(L,W,z){return n.clipboard.writeText(W,z)}async readClipboardFindText(L){return n.clipboard.readFindText()}async writeClipboardFindText(L,W){return n.clipboard.writeFindText(W)}async writeClipboardBuffer(L,W,z,Q){return n.clipboard.writeBuffer(W,Buffer.from(z),Q)}async readClipboardBuffer(L,W){return n.clipboard.readBuffer(W)}async hasClipboard(L,W,z){return n.clipboard.has(W,z)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,W){const z=this.windowById(L);z&&z.updateTouchBar(W)}async notifyReady(L){const W=this.windowById(L);W&&W.setReady()}async relaunch(L,W){return this.lifecycleMainService.relaunch(W)}async reload(L,W){const z=this.windowById(L);if(z){if((0,a.isWorkspaceIdentifier)(z.openedWorkspace)){const Q=z.openedWorkspace.configPath;if(Q.scheme===b.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(z,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,W){const z=this.windowById(W);if(z?.win)return z.win.close()}async quit(L){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(L,W){await this.lifecycleMainService.kill(W)}async resolveProxy(L,W){const Q=this.windowById(L)?.win?.webContents?.session;if(Q)return Q.resolveProxy(W)}async openDevTools(L,W){const z=this.windowById(L);z?.win&&z.win.webContents.openDevTools(W)}async toggleDevTools(L){const W=this.windowById(L);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(L,W){const z=this.windowById(L);z?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&z.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,W,z,Q){if(!S.isWindows)return;const ie=await new Promise((ee,q)=>{V(["@vscode/windows-registry"],ee,q)});try{return ie.GetStringRegKey(W,z,Q)}catch{return}}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};ue([M.memoize],I.prototype,"cliPath",null),I=ue([te(1,r.IWindowsMainService),te(2,k.IDialogMainService),te(3,c.ILifecycleMainService),te(4,l.IEnvironmentMainService),te(5,s.ITelemetryService),te(6,o.ILogService),te(7,u.IProductService),te(8,i.IThemeMainService),te(9,h.IWorkspacesManagementMainService)],I),e.NativeHostMainService=I}),define(Z[238],x([0,1,12,25,33,2,10,3,86,149,75,102,47,22,5,103,6,58,53,21,54,66]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let o=class kt{constructor(s,i,r,a,h,I,R,L,W,z){this.userEnv=s,this.environmentMainService=i,this.launchMainService=r,this.logService=a,this.diagnosticsService=h,this.diagnosticsMainService=I,this.dialogMainService=R,this.nativeHostMainService=L,this.protocolMainService=W,this.productService=z,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[i,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(i,r);this.safeSend(s,"vscode:issueSystemInfoResponse",a)}),p.ipcMain.on("vscode:listProcesses",async s=>{const i=[];try{const r=await this.launchMainService.getMainProcessId();i.push({name:(0,y.localize)(0,null),rootProcess:await(0,g.listProcesses)(r)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,b.isRemoteDiagnosticError)(h)?i.push({name:h.hostName,rootProcess:h}):h.processes&&i.push({name:h.hostName,rootProcess:h.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(s,"vscode:listProcessesResponse",i)}),p.ipcMain.on("vscode:issueReporterClipboard",async s=>{const i={title:this.productService.nameLong,message:(0,y.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,y.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,y.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",r.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const i=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",i)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,y.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,y.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(s,i)=>{const{id:r,from:a,args:h}=i;let I;switch(a){case"issueReporter":I=this.issueReporterParentWindow;break;case"processExplorer":I=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}I&&I.webContents.send("vscode:runAction",{id:r,from:a,args:h})}),p.ipcMain.on("vscode:openExternal",(s,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),p.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async s=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",i.windows)})}safeSend(s,i,...r){s.sender.isDestroyed()||s.sender.send(i,...r)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:s.styles.backgroundColor,title:(0,y.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:k.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:s.styles.backgroundColor,title:(0,y.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:k.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,i,r,a){const h=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:r.title,backgroundColor:r.backgroundColor||kt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop,experimentalDarkMode:!0});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,i)}getWindowPosition(s,i,r){let a;const h=p.screen.getAllDisplays();if(h.length===1)a=h[0];else{if(E.isMacintosh){const L=p.screen.getCursorScreenPoint();a=p.screen.getDisplayNearestPoint(L)}!a&&s&&(a=p.screen.getDisplayMatching(s.getBounds())),a||(a=p.screen.getPrimaryDisplay()||h[0])}const I={width:i,height:r},R=a.bounds;return I.x=R.x+R.width/2-I.width/2,I.y=R.y+R.height/2-I.height/2,R.width>0&&R.height>0&&(I.x<R.x&&(I.x=R.x),I.y<R.y&&(I.y=R.y),I.x>R.x+R.width&&(I.x=R.x),I.y>R.y+R.height&&(I.y=R.y),I.width>R.width&&(I.width=R.width),I.height>R.height&&(I.height=R.height)),I}async getPerformanceInfo(){try{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,i)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};o.DEFAULT_BACKGROUND_COLOR="#1E1E1E",o=ue([te(1,w.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,m.ILogService),te(4,b.IDiagnosticsService),te(5,P.IDiagnosticsMainService),te(6,S.IDialogMainService),te(7,v.INativeHostMainService),te(8,f.IProtocolMainService),te(9,l.IProductService)],o),e.IssueMainService=o}),define(Z[239],x([0,1,23,20,22,19,6,58,21,56,32,41,81]),function(V,e,p,n,D,C,M,E,g,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends S.AbstractUpdateService{constructor(d,m,v,k,l,f,c,o){super(d,m,k,l,f,o);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(d){return(0,S.createUpdateURL)(`linux-${process.arch}`,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(P.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},p.CancellationToken.None).then(y.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const v=d?m.message||m:void 0;this.setState(P.State.Idle(1,v))}))}async doDownloadUpdate(d){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(P.State.Idle(1))}};w=ue([te(0,C.ILifecycleMainService),te(1,n.IConfigurationService),te(2,b.ITelemetryService),te(3,D.IEnvironmentMainService),te(4,y.IRequestService),te(5,M.ILogService),te(6,E.INativeHostMainService),te(7,g.IProductService)],w),e.LinuxUpdateService=w}),define(Z[240],x([0,1,45,29,25,8,23,46,9,7,117,24,20,22,18,19,6,58,21,56,32,41,81]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(a,h=1e3){for(;!a();)await(0,C.timeout)(h)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends o.AbstractUpdateService{constructor(h,I,R,L,W,z,Q,ie,ee){super(h,I,L,W,z,ee);this.telemetryService=R,this.fileService=Q,this.nativeHostMainService=ie}get cachePath(){const h=g.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(h,{recursive:!0}).then(()=>h)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(h){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.productService.target==="user"&&(I+="-user"),(0,o.createUpdateURL)(I,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(c.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},M.CancellationToken.None).then(l.asJson).then(I=>{const R=i();return!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(I)),Promise.resolve(null)):(this.setState(c.State.Downloading(I)),this.cleanup(I.version).then(()=>this.getUpdatePackagePath(I.version).then(L=>P.Promises.exists(L).then(W=>{if(W)return Promise.resolve(L);const z=I.url,Q=I.hash,ie=`${L}.tmp`;return this.requestService.request({url:z},M.CancellationToken.None).then(ee=>this.fileService.writeFile(y.URI.file(ie),ee.stream)).then(Q?()=>(0,b.checksum)(ie,I.hash):()=>{}).then(()=>P.Promises.rename(ie,L)).then(()=>L)})).then(L=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},W&&I.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(I)):this.setState(c.State.Ready(I))})))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const R=h?I.message||I:void 0;this.setState(c.State.Idle(i(),R))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(h){const I=await this.cachePath;return g.join(I,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const I=h?z=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test(z):()=>!0,R=await this.cachePath,W=(await P.Promises.readdir(R)).filter(I).map(async z=>{try{await P.Promises.unlink(g.join(R,z))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(c.State.Updating(h));const I=await this.cachePath;this.availableUpdate.updateFilePath=g.join(I,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,W=await new Promise((z,Q)=>{V(["windows-mutex"],z,Q)});u(()=>W.isActive(L)).then(()=>this.setState(c.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([E.memoize],r.prototype,"cachePath",null),r=ue([te(0,d.ILifecycleMainService),te(1,S.IConfigurationService),te(2,f.ITelemetryService),te(3,w.IEnvironmentMainService),te(4,l.IRequestService),te(5,m.ILogService),te(6,t.IFileService),te(7,v.INativeHostMainService),te(8,k.IProductService)],r),e.Win32UpdateService=r}),define(Z[241],x([0,1,12,8,23,39,4,33,2,10,9,63,3,7,155,50,20,47,22,52,18,19,6,21,54,207,80,32,210,65,66,34,26,42]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c,o,u,s,i,r,a,h,I,R,L,W,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(ee){ee[ee.NONE=0]="NONE",ee[ee.NAVIGATING=1]="NAVIGATING",ee[ee.READY=2]="READY"})(Q||(Q={}));let ie=class extends g.Disposable{constructor(q,X,H,j,J,U,B,K,$,F,_,T,A,O,N){super();this.logService=X,this.environmentMainService=H,this.fileService=j,this.globalStorageMainService=J,this.configurationService=U,this.themeMainService=B,this.workspacesManagementMainService=K,this.backupMainService=$,this.telemetryService=F,this.dialogMainService=_,this.lifecycleMainService=T,this.productService=A,this.protocolMainService=O,this.windowsMainService=N,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[G,ne]=this.restoreWindowState(q.state);this.windowState=G,this.logService.trace("window#ctor: using window state",G);const ce=this.windowState.mode===0||this.windowState.mode===3,ae=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:R.WindowMinimumSize.WIDTH,minHeight:R.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,R.zoomLevelToZoomFactor)(ae?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};S.isLinux?re.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),S.isMacintosh&&(re.acceptFirstMouse=!0,ae?.clickThroughInactive===!1&&(re.acceptFirstMouse=!1));const le=S.isMacintosh&&ae?.nativeTabs===!0;le&&(re.tabbingIdentifier=this.productService.nameShort);const he=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(he&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,S.isMacintosh||(re.frame=!1)),(0,P.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(re),(0,P.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),S.isMacintosh&&he&&this._win.setSheetOffset(22),S.isMacintosh&&ne&&(!le||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(me=>typeof me=="number")){const me=this.windowState;this._win.setBounds({width:me.width,height:me.height,x:me.x,y:me.y})}ce&&((0,P.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(q){S.isMacintosh?this._win.setRepresentedFilename(q):this.representedFilename=q}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(q){S.isMacintosh&&this._win.setDocumentEdited(q),this.documentEdited=q}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(q){S.isMacintosh&&q?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(q=>{if(this.isReady)return q(this);this.whenReadyCallbacks.push(q)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(q=>{function X(){H.dispose(),j.dispose(),q()}const H=this.onDidClose(()=>X()),j=this.onWillLoad(()=>X())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(X,H)=>this.onWindowError(2,H)),this._win.webContents.on("did-fail-load",(X,H,j)=>this.onWindowError(3,{reason:j,exitCode:H})),this._win.webContents.on("will-prevent-unload",X=>{X.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",X,this._win)}),this._win.on("unmaximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",X,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(X=>this.onDidDeleteUntitledWorkspace(X)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(X,H)=>{const j=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(X.requestHeaders,j)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(q,X){switch(q){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:q,reason:X?.reason,code:X?.exitCode}),q){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(q===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const j=H.response===0;this.destroyWindow(j)}}else if(q===2){let H;X?H=(0,t.localize)(6,null,X.reason,X.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const J=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(J)}break}}destroyWindow(q){if(this._onDidDestroy.fire(),this._win?.destroy(),q&&this.config){let X,H;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?X={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?X={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[j]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}onDidDeleteUntitledWorkspace(q){this.openedWorkspace?.id===q.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const q=this.getMenuBarVisibility();q!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=q,this.setMenuBarVisibility(q));let X=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;X?.endsWith("/")&&(X=X.substr(0,X.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((X||"").indexOf("@")===-1&&(X!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=X,this.currentNoProxy=H;const j=X||"",J=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${J}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:J,pacScript:""})}}addTabbedWindow(q){S.isMacintosh&&q.win&&this._win.addTabbedWindow(q.win)}load(q,X=Object.create(null)){this.isDocumentEdited()&&(!X.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),X.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(q,X),this.readyState===0?this.currentConfig=q:this.pendingLoadConfig=q,this.readyState=1,this._win.loadURL(y.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:q.workspace,reason:X.isReload?3:H?2:1})}updateConfiguration(q,X){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const j=(0,l.isLaunchedFromCli)(H)&&!(0,l.isLaunchedFromCli)(q.userEnv),J=this.isExtensionDevelopmentHost;(j||J)&&(q.userEnv={...H,...q.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(q.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),X.disableExtensions!==void 0&&(q["disable-extensions"]=X.disableExtensions),q.fullscreen=this.isFullScreen,q.maximized=this._win.isMaximized(),q.partsSplash=this.themeMainService.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),q.perfMarks=(0,P.getMarks)(),this.configObjectUrl.update(q)}async reload(q){const X=Object.assign({},this.currentConfig);X.workspace=await this.validateWorkspaceBeforeReload(X),delete X.filesToOpenOrCreate,delete X.filesToDiff,delete X.filesToWait,this.isExtensionDevelopmentHost&&q&&(X.verbose=q.verbose,X.debugId=q.debugId,X.extensionEnvironment=q.extensionEnvironment,X["inspect-extensions"]=q["inspect-extensions"],X["inspect-brk-extensions"]=q["inspect-brk-extensions"],X["extensions-dir"]=q["extensions-dir"]),X.isInitialStartup=!1,this.load(X,{isReload:!0,disableExtensions:q?.["disable-extensions"]})}async validateWorkspaceBeforeReload(q){if((0,W.isWorkspaceIdentifier)(q.workspace)){const X=q.workspace.configPath;if(X.scheme===y.Schemas.file&&!await this.fileService.exists(X))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(q.workspace)){const X=q.workspace.uri;if(X.scheme===y.Schemas.file&&!await this.fileService.exists(X))return}return q.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let H;try{H=p.screen.getDisplayMatching(this.getBounds())}catch{}const j=(0,L.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||j.width,height:this.windowState.height||j.height,x:this.windowState.x||0,y:this.windowState.y||0}}const q=Object.create(null);let X;if(!S.isMacintosh&&this._win.isMaximized()?X=0:X=1,X===0?q.mode=0:q.mode=1,X===1||X===0){let H;X===1?H=this.getBounds():H=this._win.getNormalBounds(),q.x=H.x,q.y=H.y,q.width=H.width,q.height=H.height}return q}restoreWindowState(q){(0,P.mark)("code/willRestoreCodeWindowState");let X=!1;if(q)try{const H=p.screen.getAllDisplays();X=H.length>1,q=this.validateWindowState(q,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[q||(0,L.defaultWindowState)(),X]}validateWindowState(q,X){if(this.logService.trace(`window#validateWindowState: validating window state on ${X.length} display(s)`,q),typeof q.x!="number"||typeof q.y!="number"||typeof q.width!="number"||typeof q.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(q.width<=0||q.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(X.length===1){const J=this.getWorkingArea(X[0]);if(J){let U=function(){!q||typeof q.x!="number"||typeof q.y!="number"||!J||(q.x<J.x&&(q.x=J.x),q.y<J.y&&(q.y=J.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",J),U(),q.width>J.width&&(q.width=J.width),q.height>J.height&&(q.height=J.height),q.x>J.x+J.width-128&&(q.x=J.x+J.width-q.width),q.y>J.y+J.height-128&&(q.y=J.y+J.height-q.height),U()}return q}if(q.display&&q.mode===3){const J=X.find(U=>U.id===q.display);if(J&&typeof J.bounds?.x=="number"&&typeof J.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const U=(0,L.defaultWindowState)(3);return U.x=J.bounds.x,U.y=J.bounds.y,U}}let H,j;try{H=p.screen.getDisplayMatching({x:q.x,y:q.y,width:q.width,height:q.height}),j=this.getWorkingArea(H)}catch{}if(H&&j&&q.x+q.width>j.x&&q.y+q.height>j.y&&q.x<j.x+j.width&&q.y<j.y+j.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",j),q}getWorkingArea(q){if(q.workArea.width>0&&q.workArea.height>0)return q.workArea;if(q.bounds.width>0&&q.bounds.height>0)return q.bounds}getBounds(){const[q,X]=this._win.getPosition(),[H,j]=this._win.getSize();return{x:q,y:X,width:H,height:j}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(q){this.useNativeFullScreen()?this.setNativeFullScreen(q):this.setSimpleFullScreen(q),this.sendWhenReady(q?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(q){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(q)}setSimpleFullScreen(q){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(q),this._win.webContents.focus()}useNativeFullScreen(){const q=this.configurationService.getValue("window");return!q||typeof q.nativeFullScreen!="boolean"||q.nativeTabs?!0:q.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let q=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(q)<0&&(q="classic"),q}setMenuBarVisibility(q,X=!0){S.isMacintosh||(q==="toggle"&&X&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),q==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(q)}):this.doSetMenuBarVisibility(q))}doSetMenuBarVisibility(q){const X=this.isFullScreen;switch(q){case"classic":this._win.setMenuBarVisibility(!X),this._win.autoHideMenuBar=X;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(q,X,...H){this.isReady?this.send(q,...H):this.ready().then(()=>{X.isCancellationRequested||this.send(q,...H)})}send(q,...X){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${q}' for window that is destroyed`);return}try{this._win.webContents.send(q,...X)}catch(H){this.logService.warn(`Error sending IPC message to channel '${q}' of window ${this._id}: ${(0,C.toErrorMessage)(H)}`)}}}updateTouchBar(q){!S.isMacintosh||this.touchBarGroups.forEach((X,H)=>{const j=q[H];X.segments=this.createTouchBarGroupSegments(j)})}createTouchBar(){if(!!S.isMacintosh){for(let q=0;q<10;q++){const X=this.createTouchBarGroup();this.touchBarGroups.push(X)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(q=[]){const X=this.createTouchBarGroupSegments(q),H=new p.TouchBar.TouchBarSegmentedControl({segments:X,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:H.segments[j].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(q=[]){return q.map(H=>{let j;H.icon&&!h.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===y.Schemas.file&&(j=p.nativeImage.createFromPath(w.URI.revive(H.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let J;return typeof H.title=="string"?J=H.title:J=H.title.value,{id:H.id,label:j?void 0:J,icon:j}})}dispose(){super.dispose(),this._win=null}};ie=ue([te(1,o.ILogService),te(2,k.IEnvironmentMainService),te(3,f.IFileService),te(4,r.IGlobalStorageMainService),te(5,m.IConfigurationService),te(6,I.IThemeMainService),te(7,z.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,a.ITelemetryService),te(10,v.IDialogMainService),te(11,c.ILifecycleMainService),te(12,u.IProductService),te(13,s.IProtocolMainService),te(14,L.IWindowsMainService)],ie),e.CodeWindow=ie}),define(Z[67],x([0,1,12,30,8,4,33,2,10,3,16,7,24,158,5,19,6,38,80,26,42]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let c=class ze extends E.Disposable{constructor(u,s,i,r,a){super();this.stateMainService=u,this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.globalStorageMainService=a,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(u=>this.addRecentlyOpened([{workspace:u.workspace,remoteAuthority:u.window.remoteAuthority}])))}async addRecentlyOpened(u){const s=[],i=[];for(let r of u)if((0,l.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(s,r.workspace)===-1&&s.push(r);else if((0,l.isRecentFolder)(r))this.indexOfFolder(s,r.folderUri)===-1&&s.push(r);else{const a=this.indexOfFile(i,r.fileUri)>=0,h=r.fileUri.scheme===g.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,b.basename)(r.fileUri))>=0;!a&&!h&&(i.push(r),y.isWindows&&r.fileUri.scheme===g.Schemas.file&&p.app.addRecentDocument(r.fileUri.fsPath))}await this.addEntriesFromStorage(s,i),s.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(s.length=ze.MAX_TOTAL_RECENT_ENTRIES),i.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(i.length=ze.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:s,files:i}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(u){const s=h=>{const I=this.location(h);for(const R of u)if(b.extUriBiasedIgnorePathCase.isEqual(R,I))return!1;return!0},i=await this.getRecentlyOpened(),r=i.workspaces.filter(s),a=i.files.filter(s);(r.length!==i.workspaces.length||a.length!==i.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(u){const s=[],i=[];if(u){const a=u.config?.workspace;(0,l.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?s.push({workspace:a,remoteAuthority:u.remoteAuthority}):(0,l.isSingleFolderWorkspaceIdentifier)(a)&&s.push({folderUri:a.uri,remoteAuthority:u.remoteAuthority})}const r=u?.config?.filesToOpenOrCreate;if(r)for(let a of r){const h=a.fileUri;h&&this.indexOfFile(i,h)===-1&&i.push({fileUri:h})}return await this.addEntriesFromStorage(s,i),{workspaces:s,files:i}}async addEntriesFromStorage(u,s){let i=await this.getRecentlyOpenedFromStorage();for(let r of i.workspaces){let a=(0,l.isRecentFolder)(r)?this.indexOfFolder(u,r.folderUri):this.indexOfWorkspace(u,r.workspace);a>=0?u[a].label=u[a].label||r.label:u.push(r)}for(let r of i.files){let a=this.indexOfFile(s,r.fileUri);a>=0?s[a].label=s[a].label||r.label:s.push(r)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let u;const s=this.globalStorageMainService.get(ze.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof s=="string")try{u=JSON.parse(s)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}else u=this.stateMainService.getItem(ze.legacyRecentlyOpenedStorageKey),u&&(this.stateMainService.removeItem(ze.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(u),0,1));return(0,l.restoreRecentlyOpened)(u,this.logService)}async saveRecentlyOpened(u){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,l.toStoreData)(u)),0,1)}location(u){return(0,l.isRecentFolder)(u)?u.folderUri:(0,l.isRecentFile)(u)?u.fileUri:u.workspace.configPath}indexOfWorkspace(u,s){return u.findIndex(i=>(0,l.isRecentWorkspace)(i)&&i.workspace.id===s.id)}indexOfFolder(u,s){return u.findIndex(i=>(0,l.isRecentFolder)(i)&&b.extUriBiasedIgnorePathCase.isEqual(i.folderUri,s))}indexOfFile(u,s){return u.findIndex(i=>b.extUriBiasedIgnorePathCase.isEqual(i.fileUri,s))}async handleWindowsJumpList(){!y.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!y.isWindows)return;const u=[];if(u.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(0,null),description:(0,w.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let s=[];for(let a of p.app.getJumpListSettings().removedItems){const h=a.args;if(h){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);I&&s.push(P.URI.parse(I[2]))}}await this.removeRecentlyOpened(s);let i=!1;const r=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,ze.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const h=(0,l.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:I,description:R}=this.getWindowsJumpListLabel(h,a.label);let L;return P.URI.isUri(h)?L=`--folder-uri "${h.toString()}"`:(i=!0,L=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:R.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&u.push({type:"custom",name:i?(0,w.localize)(2,null):(0,w.localize)(3,null),items:r})}u.push({type:"recent"});try{p.app.setJumpList(u)}catch(s){this.logService.warn("updateWindowsJumpList#setJumpList",s)}}getWindowsJumpListLabel(u,s){if(s)return{title:(0,M.splitName)(s).name,description:s};if(P.URI.isUri(u))return{title:(0,b.basename)(u),description:this.renderJumpListPathDescription(u)};if(this.workspacesManagementMainService.isUntitledWorkspace(u))return{title:(0,w.localize)(4,null),description:""};let i=(0,b.basename)(u.configPath);return i.endsWith(l.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-l.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(5,null,i),description:this.renderJumpListPathDescription(u.configPath)}}renderJumpListPathDescription(u){return u.scheme==="file"?(0,M.normalizeDriveLetter)(u.fsPath):u.toString()}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;p.app.clearRecentDocuments();const u=await this.getRecentlyOpened(),s=[];let i=0;for(let a=0;a<u.workspaces.length&&i<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const h=this.location(u.workspaces[a]);if(h.scheme===g.Schemas.file){const I=(0,b.originalFSPath)(h);await S.Promises.exists(I)&&(s.push(I),i++)}}const r=[];for(let a=0;a<u.files.length&&i<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const h=this.location(u.files[a]);if(h.scheme===g.Schemas.file){const I=(0,b.originalFSPath)(h);if(ze.COMMON_FILES_FILTER.includes((0,b.basename)(h))||s.includes(I))continue;await S.Promises.exists(I)&&(r.push(I),i++)}}r.reverse().forEach(a=>p.app.addRecentDocument(a)),s.reverse().forEach(a=>p.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.legacyRecentlyOpenedStorageKey="openedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ue([te(0,v.IStateMainService),te(1,m.ILogService),te(2,f.IWorkspacesManagementMainService),te(3,d.ILifecycleMainService),te(4,k.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(Z[242],x([0,1,12,8,23,33,3,7,150,20,22,19,6,191,58,21,38,32,41,66,34,67]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let u=class Et{constructor(r,a,h,I,R,L,W,z,Q,ie,ee){this.updateService=r,this.configurationService=a,this.windowsMainService=h,this.environmentMainService=I,this.telemetryService=R,this.workspacesHistoryMainService=L,this.stateMainService=W,this.lifecycleMainService=z,this.logService=Q,this.nativeHostMainService=ie,this.productService=ee,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,l.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(Et.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,W,z)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,W,z)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,W,z)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,W,z)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const I=this.productService.licenseUrl;I&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=I.indexOf("?")>0?"&":"?";this.openUrl(`${I}${L}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(I,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&I&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,a){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(Et.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!M.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=p.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(M.isMacintosh?new p.Menu:null);return}const a=new p.Menu;let h;if(M.isMacintosh){const R=new p.Menu;h=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),a.append(h)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:R});this.setMenuById(R,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:R});this.setMenuById(R,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),a.append(L)}let I;if(this.shouldDrawMenu("Window")){const R=new p.Menu;I=new p.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(I&&a.append(I),this.shouldDrawMenu("Help")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),a.append(L)}a.items&&a.items.length>0?p.Menu.setApplicationMenu(a):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const a=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let I;if(this.shouldDrawMenu("Preferences")){const q=new p.Menu;this.setMenuById(q,"Preferences"),I=new p.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:q})}const R=new p.Menu,L=new p.MenuItem({label:g.localize(12,null),role:"services",submenu:R}),W=new p.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),z=new p.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new p.MenuItem({label:g.localize(15,null),role:"unhide"}),ie=new p.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:()=>{const q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),ee=[a];ee.push(...h),I&&ee.push(s(),I),ee.push(s(),L,s(),W,z,Q,s(),ie),ee.forEach(q=>r.append(q))}shouldDrawMenu(r){if(!M.isMacintosh&&(0,l.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,a){a.forEach(h=>{if((0,w.isMenubarMenuItemSeparator)(h))r.append(s());else if((0,w.isMenubarMenuItemSubmenu)(h)){const I=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(h.label),submenu:I});this.setMenu(I,h.submenu.items),r.append(R)}else(0,w.isMenubarMenuItemRecentAction)(h)?r.append(this.createOpenRecentMenuItem(h)):(0,w.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?r.append(new p.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):r.append(this.createMenuItem(h.label,h.id,!1,h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(r,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(r,this.menubarMenus[a].items)}insertCheckForUpdatesItems(r){const a=this.getUpdateMenuItems();a.length&&(a.forEach(h=>r.append(h)),r.append(s()))}createOpenRecentMenuItem(r){const a=E.URI.revive(r.uri),h=r.id,I=h==="openRecentFile"?{fileUri:a}:h==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new p.MenuItem(this.likeAction(h,{label:r.label,click:(R,L,W)=>{const z=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[I],forceNewWindow:z,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(r){return!!(r&&(!M.isMacintosh&&(r.ctrlKey||r.shiftKey)||M.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,a,h){const I={label:this.mnemonicLabel(r),role:h,enabled:!0};return new p.MenuItem(this.withKeybinding(a,I))}setMacWindowMenu(r){const a=new p.MenuItem({label:g.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new p.MenuItem({label:g.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),I=new p.MenuItem({label:g.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(g.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(s()),L.push(this.createMenuItem(g.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(g.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(g.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(g.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,h,s(),R,...L,s(),I].forEach(W=>r.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(g.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:g.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(g.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:g.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(g.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:g.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(g.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,a,h,I){const R=this.mnemonicLabel(r),L=typeof a=="function"?a:(ee,q,X)=>{const H=ee?ee.userSettingsLabel:null;let j=a;Array.isArray(a)&&(j=this.isOptionClick(X)?a[1]:a[0]),H&&X.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:j})},W=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,z=typeof I=="boolean"?I:!1,Q={label:R,click:L,enabled:W};z&&(Q.type="checkbox",Q.checked=z);let ie;return typeof a=="string"?ie=a:Array.isArray(a)&&(ie=a[0]),M.isMacintosh&&(ie==="editor.action.clipboardCutAction"?Q.role="cut":ie==="editor.action.clipboardCopyAction"?Q.role="copy":ie==="editor.action.clipboardPasteAction"&&(Q.role="paste"),ie==="undo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:ee=>ee.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ie==="redo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:ee=>ee.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ie==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(L,{inDevTools:ee=>ee.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ie,Q))}makeContextAwareClickHandler(r,a){return(h,I,R)=>{const L=p.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);r(h,I||L,R)}}runActionInRenderer(r){let a=p.BrowserWindow.getFocusedWindow();if(!a){const I=this.windowsMainService.getLastActiveWindow();I?.isMinimized()&&(a=I.win)}const h=a?this.windowsMainService.getWindowById(a.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",r),M.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const I={id:r.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",D.CancellationToken.None,I)}else{const I={userSettingsLabel:r.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,I)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,a){const h=typeof r=="string"?this.keybindings[r]:void 0;if(h?.label){if(h.isNative!==!1)a.accelerator=h.label,a.userSettingsLabel=h.userSettingsLabel;else if(typeof a.label=="string"){const I=a.label.indexOf("[");I>=0?a.label=`${a.label.substr(0,I)} [${h.label}]`:a.label=`${a.label} [${h.label}]`}}else a.accelerator=void 0;return a}likeAction(r,a,h=!a.accelerator){h&&(a=this.withKeybinding(r,a));const I=a.click;return a.click=(R,L,W)=>{this.reportMenuActionTelemetry(r),I&&I(R,L,W)},a}openUrl(r,a){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:o})}mnemonicLabel(r){return(0,C.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};u.lastKnownMenubarStorageKey="lastKnownMenubarData",u=ue([te(0,k.IUpdateService),te(1,y.IConfigurationService),te(2,f.IWindowsMainService),te(3,b.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,m.IStateMainService),te(7,P.ILifecycleMainService),te(8,S.ILogService),te(9,t.INativeHostMainService),te(10,d.IProductService)],u),e.Menubar=u;function s(){return new p.MenuItem({type:"separator"})}}),define(Z[243],x([0,1,5,19,6,242]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let M=class{constructor(g,y,b){this.instantiationService=g,this.lifecycleMainService=y,this.logService=b,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(g,y){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(y,g)}};M=ue([te(0,p.IInstantiationService),te(1,n.ILifecycleMainService),te(2,D.ILogService)],M),e.MenubarMainService=M}),define(Z[244],x([0,1,12,29,25,30,23,4,28,43,33,2,10,9,63,3,36,16,14,7,156,50,20,47,22,18,5,19,6,53,21,54,78,38,66,241,100,224,26,101,67,42]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c,o,u,s,i,r,a,h,I,R,L,W,z,Q,ie,ee,q,X,H,j,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U($){return(0,X.isWorkspaceIdentifier)($?.workspace)}function B($){return(0,X.isSingleFolderWorkspaceIdentifier)($?.workspace)}let K=class rt extends P.Disposable{constructor(F,_,T,A,O,N,G,ne,ce,ae,re,le,he,me,ke){super();this.machineId=F,this.initialUserEnv=_,this.logService=T,this.stateMainService=A,this.environmentMainService=O,this.lifecycleMainService=N,this.backupMainService=G,this.configurationService=ne,this.workspacesHistoryMainService=ce,this.workspacesManagementMainService=ae,this.instantiationService=re,this.dialogMainService=le,this.fileService=he,this.productService=me,this.protocolMainService=ke,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const _=new P.DisposableStore;if(_.add(E.Event.any(F.onDidClose,F.onDidDestroy)(()=>_.dispose())),F.config.extensionDevelopmentPath)for(const T of F.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(l.URI.file(T)));F.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(l.URI.file(F.config.extensionTestsPath)))}}))}openEmptyWindow(F,_){let T=this.environmentMainService.args;const A=_?.remoteAuthority||void 0,O=!0,N=_?.forceReuseWindow,G=!N;return this.open({...F,cli:T,forceEmpty:O,forceNewWindow:G,forceReuseWindow:N,remoteAuthority:A})}openExistingWindow(F,_){F.focus(),this.handleWaitMarkerFile(_,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const _=[],T=[],A=[],O=[],N=[];let G,ne=0;const ce=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ce);for(const he of ce)B(he)?F.addMode?_.push(he):T.push(he):U(he)?A.push(he):he.fileUri?(G||(G={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),G.filesToOpenOrCreate.push(he)):he.backupPath?N.push({backupFolder:(0,w.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):ne++;F.diffMode&&G&&G.filesToOpenOrCreate.length>=2&&(G.filesToDiff=G.filesToOpenOrCreate.slice(0,2),G.filesToOpenOrCreate=[]),G&&F.waitMarkerFileURI&&(G.filesToWait={paths:[...G.filesToDiff,...G.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...O),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:ae,filesOpenedInWindow:re}=this.doOpen(F,A,T,N,ne,G,_);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${T.length}, emptyToRestore: ${N.length}, emptyToOpen: ${ne})`),ae.length>1)if(re)re.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let me=!0,ke=!0;if(he){const Ce=ae.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),me=!1,ke=!1)}if(me)for(let Ce=ae.length-1;Ce>=0;Ce--){const Se=ae[Ce];if(!(Se.openedWorkspace&&O.some(pe=>Se.openedWorkspace&&pe.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&N.some(pe=>Se.backupPath&&pe.backupFolder===(0,w.basename)(Se.backupPath)))){Se.focus(),ke=!1;break}}ke&&ae[ae.length-1].focus()}const le=G&&G.filesToDiff.length>0;if(!ae.some(he=>he.isExtensionDevelopmentHost)&&!le&&!F.noRecentEntry){const he=[];for(const me of ce)U(me)&&!me.transient?he.push({label:me.label,workspace:me.workspace,remoteAuthority:me.remoteAuthority}):B(me)?he.push({label:me.label,folderUri:me.workspace.uri,remoteAuthority:me.remoteAuthority}):me.fileUri&&he.push({label:me.label,fileUri:me.fileUri,remoteAuthority:me.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(F,ae),ae}handleWaitMarkerFile(F,_){const T=F.waitMarkerFileURI;F.context===0&&T&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}doOpen(F,_,T,A,O,N,G){const ne=[];let ce;function ae(Se,pe){ne.push(Se),pe&&(ce=Se,N=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:le}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&G.length>0){const Se=G[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(Se);pe&&ae(this.doAddFoldersToExistingWindow(pe,G.map(be=>be.workspace.uri)))}const he=T.length+_.length+A.length;if(N&&he===0){const Se=N.filesToOpenOrCreate[0]||N.filesToDiff[0],pe=this.getWindows().filter(Re=>N&&(0,v.isEqualAuthority)(Re.remoteAuthority,N.remoteAuthority));let be;Se?.fileUri&&!le&&((F.context===4||F.context===0||F.context===1)&&(be=(0,ee.findWindowOnFile)(pe,Se.fileUri,Re=>Re.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),be||(be=this.doGetLastActiveWindow(pe))),be?(0,X.isWorkspaceIdentifier)(be.openedWorkspace)?_.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,X.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?T.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(F,be,N),!0):ae(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const me=(0,C.distinct)(_,Se=>Se.workspace.id);if(me.length>0){const Se=(0,C.coalesce)(me.map(pe=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(Se.length>0){const pe=Se[0],be=(0,v.isEqualAuthority)(N?.remoteAuthority,pe.remoteAuthority)?N:void 0;ae(this.doOpenFilesInExistingWindow(F,pe,be),!!be),re=!0}me.forEach(pe=>{if(Se.some(Ue=>Ue.openedWorkspace&&Ue.openedWorkspace.id===pe.workspace.id))return;const be=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(N?.remoteAuthority,be)?N:void 0;ae(this.doOpenFolderOrWorkspace(F,pe,re,Re),!!Re),re=!0})}const ke=(0,C.distinct)(T,Se=>v.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(ke.length>0){const Se=(0,C.coalesce)(ke.map(pe=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(Se.length>0){const pe=Se[0],be=(0,v.isEqualAuthority)(N?.remoteAuthority,pe.remoteAuthority)?N:void 0;ae(this.doOpenFilesInExistingWindow(F,pe,be),!!be),re=!0}ke.forEach(pe=>{if(Se.some(Ue=>(0,X.isSingleFolderWorkspaceIdentifier)(Ue.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Ue.openedWorkspace.uri,pe.workspace.uri)))return;const be=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(N?.remoteAuthority,be)?N:void 0;ae(this.doOpenFolderOrWorkspace(F,pe,re,Re),!!Re),re=!0})}const Ce=(0,C.distinct)(A,Se=>Se.backupFolder);if(Ce.length>0&&Ce.forEach(Se=>{const pe=Se.remoteAuthority,be=(0,v.isEqualAuthority)(N?.remoteAuthority,pe)?N:void 0;ae(this.doOpenEmpty(F,!0,pe,be,Se),!!be),re=!0}),ne.length===0||N){N&&!O&&O++;const Se=N?N.remoteAuthority:F.remoteAuthority;for(let pe=0;pe<O;pe++)ae(this.doOpenEmpty(F,re,Se,N),!!N),re=!0}return{windows:(0,C.distinct)(ne),filesOpenedInWindow:ce}}doOpenFilesInExistingWindow(F,_,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),_.focus();const A={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToWait:T?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",M.CancellationToken.None,A),_}doAddFoldersToExistingWindow(F,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:_}),F.focus();const T={foldersToAdd:_};return F.sendWhenReady("vscode:addFolders",M.CancellationToken.None,T),F}doOpenEmpty(F,_,T,A,O){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!O,remoteAuthority:T,filesToOpen:A,forceNewWindow:_});let N;return!_&&typeof F.contextWindowId=="number"&&(N=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:T,forceNewWindow:_,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:N,emptyWindowBackupInfo:O})}doOpenFolderOrWorkspace(F,_,T,A,O){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:_,filesToOpen:A}),!T&&!O&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:O})}getPathsToOpen(F){let _,T=!1,A=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(F),T=!0):F.forceEmpty?_=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(_=this.doExtractPathsFromCLI(F.cli),_.length===0&&_.push(Object.create(null)),T=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),A=!0),!F.addMode&&T){const O=_.filter(N=>B(N));if(O.length>1){const N=O[0].remoteAuthority;if(O.every(G=>(0,v.isEqualAuthority)(G.remoteAuthority,N))){const G=this.workspacesManagementMainService.createUntitledWorkspaceSync(O.map(ne=>({uri:ne.workspace.uri})));_.push({workspace:G,remoteAuthority:N}),_=_.filter(ne=>!B(ne))}}}return F.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(O=>U(O)||B(O)||O.backupPath)),_}doExtractPathsFromAPI(F){const _=[],T={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const A of(0,C.coalesce)(F.urisToOpen||[])){const O=this.resolveOpenable(A,T);if(O)O.label=A.label,_.push(O);else{const N=this.resourceFromOpenable(A),G={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:N.scheme===S.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:N.scheme===S.Schemas.file?(0,f.localize)(3,null,(0,b.getPathLabel)(N.fsPath,this.environmentMainService)):(0,f.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(G,(0,k.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return _}doExtractPathsFromCLI(F){const _=[],T={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},A=F["folder-uri"];if(A)for(const G of A){const ne=this.cliArgToUri(G);if(ne){const ce=this.resolveOpenable({folderUri:ne},T);ce&&_.push(ce)}}const O=F["file-uri"];if(O)for(const G of O){const ne=this.cliArgToUri(G);if(ne){const ce=this.resolveOpenable((0,X.hasWorkspaceFileExtension)(G)?{workspaceUri:ne}:{fileUri:ne},T);ce&&_.push(ce)}}const N=F._;for(const G of N){const ne=T.remoteAuthority?this.doResolvePathRemote(G,T):this.doResolveFilePath(G,T);ne&&_.push(ne)}return _}cliArgToUri(F){try{const _=l.URI.parse(F);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${F}, ${_.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const _=[];F!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const T=[];for(const A of _)if(A.workspace){const O=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});U(O)&&T.push(O)}else if(A.folderUri){const O=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});B(O)&&T.push(O)}else F!=="folders"&&A.backupPath&&T.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return T}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,_=Object.create(null)){let T=this.resourceFromOpenable(F);return T.scheme===S.Schemas.file?((0,Q.isFileToOpen)(F)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,_)):this.doResolveRemoteOpenable(F,_)}doResolveRemoteOpenable(F,_){let T=this.resourceFromOpenable(F);const A=(0,W.getRemoteAuthority)(T)||_.remoteAuthority;if(T=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(T)),(0,Q.isFileToOpen)(F)){if(_.gotoLineMode){const{path:O,line:N,column:G}=(0,g.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:O}),selection:N?{startLineNumber:N,startColumn:G||1}:void 0,remoteAuthority:A}}return{fileUri:T,remoteAuthority:A}}else if((0,Q.isWorkspaceToOpen)(F))return{workspace:(0,H.getWorkspaceIdentifier)(T),remoteAuthority:A};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:A}}resourceFromOpenable(F){return(0,Q.isWorkspaceToOpen)(F)?F.workspaceUri:(0,Q.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,_){let T,A;_.gotoLineMode&&({path:F,line:T,column:A}=(0,g.parseLineAndColumnAware)(F)),F=(0,g.sanitizeFilePath)((0,w.normalize)(F),(0,m.cwd)());try{const O=(0,n.statSync)(F);if(O.isFile()){if(!_.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.URI.file(F));if(N)return N.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:i.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:l.URI.file(F),type:i.FileType.File,exists:!0,selection:T?{startLineNumber:T,startColumn:A||1}:void 0}}else{if(O.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(l.URI.file(F),O),type:i.FileType.Directory,exists:!0};if(!d.isWindows&&F==="/dev/null")return{fileUri:l.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const N=l.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),_.ignoreFileNotFound)return{fileUri:N,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,_){const T=F.charCodeAt(0),A=_.remoteAuthority;let O,N;_.gotoLineMode&&({path:F,line:O,column:N}=(0,g.parseLineAndColumnAware)(F)),T!==47&&((0,g.isWindowsDriveLetter)(T)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,g.toSlashes)(F)),F=`/${F}`);const G=l.URI.from({scheme:S.Schemas.vscodeRemote,authority:A,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,X.hasWorkspaceFileExtension)(F))return _.forceOpenWorkspaceAsFile?{fileUri:G,selection:O?{startLineNumber:O,startColumn:N||1}:void 0,remoteAuthority:_.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(G),remoteAuthority:A};if(_.gotoLineMode||w.posix.basename(F).indexOf(".")!==-1)return{fileUri:G,selection:O?{startLineNumber:O,startColumn:N||1}:void 0,remoteAuthority:A}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(G),remoteAuthority:A}}shouldOpenNewWindow(F){const _=this.configurationService.getValue("window"),T=_?.openFoldersInNewWindow||"default",A=_?.openFilesInNewWindow||"off";let O=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(T==="on"||T==="off")&&(O=T==="on");let N=!1;return F.forceNewWindow||F.forceReuseWindow?N=!!F.forceNewWindow&&!F.forceReuseWindow:(d.isMacintosh?F.context===1&&(N=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!F.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(N=A==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(F,_){const T=(0,ee.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(T)return this.lifecycleMainService.reload(T,_.cli),T.focus(),[T];let A=_.cli["folder-uri"]||[],O=_.cli["file-uri"]||[],N=_.cli._;if(!N.length&&!A.length&&!O.length&&!_.cli.extensionTestsPath){const ae=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=ae&&(ae.workspace||ae.folderUri);re&&(l.URI.isUri(re)?re.scheme===S.Schemas.file?N=[re.fsPath]:A=[re.toString()]:re.configPath.scheme===S.Schemas.file?N=[(0,v.originalFSPath)(re.configPath)]:O=[re.configPath.toString()])}let G=_.remoteAuthority;for(const ae of F)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=l.URI.parse(ae),le=(0,W.getRemoteAuthority)(re);le&&(G?(0,v.isEqualAuthority)(le,G)||this.logService.error("more than one extension development path authority"):G=le)}N=N.filter(ae=>{const re=l.URI.file(ae);return(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),G)}),A=A.filter(ae=>{const re=this.cliArgToUri(ae);return re&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),G):!1}),O=O.filter(ae=>{const re=this.cliArgToUri(ae);return re&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),G):!1}),_.cli._=N,_.cli["folder-uri"]=A,_.cli["file-uri"]=O;const ne=!N.length&&!A.length&&!O.length,ce={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:G};return this.open(ce)}openInBrowserWindow(F){const _=this.configurationService.getValue("window"),T={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,w.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:I.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,autoDetectHighContrast:_?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let A;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(A=F.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const O=A.config;!T.extensionDevelopmentPath&&O&&!!O.extensionDevelopmentPath&&(T.extensionDevelopmentPath=O.extensionDevelopmentPath,T.verbose=O.verbose,T["inspect-brk-extensions"]=O["inspect-brk-extensions"],T.debugId=O.debugId,T.extensionEnvironment=O.extensionEnvironment,T["inspect-extensions"]=O["inspect-extensions"],T["extensions-dir"]=O["extensions-dir"])}else{const O=this.windowsStateHandler.getNewWindowState(T);(0,t.mark)("code/willCreateCodeWindow");const N=A=this.instantiationService.createInstance(ie.CodeWindow,{state:O,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const ne=this.getLastActiveWindow();ne&&ne.addTabbedWindow(N)}rt.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,y.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,y.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,y.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const G=(0,k.assertIsDefined)(N.win?.webContents);G.removeAllListeners("devtools-reload-page"),G.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return T.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(O=>{O||this.doOpenInBrowserWindow(A,T,F)}):this.doOpenInBrowserWindow(A,T,F),A}doOpenInBrowserWindow(F,_,T){if(!_.extensionDevelopmentPath)if((0,X.isWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:_.workspace,remoteAuthority:_.remoteAuthority});else if((0,X.isSingleFolderWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:_.workspace.uri,remoteAuthority:_.remoteAuthority});else{const A=T.emptyWindowBackupInfo&&T.emptyWindowBackupInfo.backupFolder;_.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,_.remoteAuthority)}F.load(_)}onWindowClosed(F){const _=rt.WINDOWS.indexOf(F);rt.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=p.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(_=>(0,v.isEqualAuthority)(_.remoteAuthority,F)))}doGetLastActiveWindow(F){const _=Math.max.apply(Math,F.map(T=>T.lastFocusTime));return F.find(T=>T.lastFocusTime===_)}sendToFocused(F,..._){const T=this.getFocusedWindow()||this.getLastActiveWindow();T&&T.sendWhenReady(F,M.CancellationToken.None,..._)}sendToAll(F,_,T){for(const A of this.getWindows())T&&T.indexOf(A.id)>=0||A.sendWhenReady(F,M.CancellationToken.None,_)}getWindows(){return rt.WINDOWS}getWindowCount(){return rt.WINDOWS.length}getWindowById(F){const _=this.getWindows().filter(T=>T.id===F);return(0,C.firstOrDefault)(_)}getWindowByWebContents(F){const _=p.BrowserWindow.fromWebContents(F);if(!!_)return this.getWindowById(_.id)}};K.WINDOWS=[],K=ue([te(2,h.ILogService),te(3,z.IStateMainService),te(4,s.IEnvironmentMainService),te(5,a.ILifecycleMainService),te(6,c.IBackupMainService),te(7,o.IConfigurationService),te(8,j.IWorkspacesHistoryMainService),te(9,J.IWorkspacesManagementMainService),te(10,r.IInstantiationService),te(11,u.IDialogMainService),te(12,i.IFileService),te(13,R.IProductService),te(14,L.IProtocolMainService)],K),e.WindowsMainService=K}),define(Z[245],x([0,1,50,34,67,42]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(g,y,b,P){this.workspacesManagementMainService=g,this.windowsMainService=y,this.workspacesHistoryMainService=b,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,y){const b=this.windowsMainService.getWindowById(g);if(b)return this.workspacesManagementMainService.enterWorkspace(b,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(g,y,b){return this.workspacesManagementMainService.createUntitledWorkspace(y,b)}deleteUntitledWorkspace(g,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(g,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(g))}addRecentlyOpened(g,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}removeRecentlyOpened(g,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ue([te(0,C.IWorkspacesManagementMainService),te(1,n.IWindowsMainService),te(2,D.IWorkspacesHistoryMainService),te(3,p.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Z[246],x([0,1,12,29,25,17,39,15,28,43,44,33,2,10,9,3,14,7,31,71,124,37,127,88,218,137,50,228,20,74,192,165,75,102,47,229,91,163,22,52,93,171,193,172,225,92,173,174,18,187,77,73,5,76,238,203,103,19,6,189,243,58,21,78,233,79,38,222,80,204,32,206,208,64,41,212,236,239,237,240,99,213,214,215,216,219,34,244,220,26,67,245,42]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c,o,u,s,i,r,a,h,I,R,L,W,z,Q,ie,ee,q,X,H,j,J,U,B,K,$,F,_,T,A,O,N,G,ne,ce,ae,re,le,he,me,ke,Ce,Se,pe,be,Re,Ue,xe,Te,Be,Ye,st,pt,ot,Qe,qe,Xe,Y,se,oe,fe,ye,Le,Oe,Ke,He,Ae,$e,Ve,Ge,it,Ct,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let vt=class extends S.Disposable{constructor(de,we,ve,ge,Pe,De,Me,Ee,Ie,We){super();this.mainProcessNodeIpcServer=de,this.userEnv=we,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ee,this.fileService=Ie,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const de=Ee=>Ee?.startsWith(`${w.Schemas.vscodeWebview}://`),we=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((Ee,Ie,We,Ne)=>de(Ne.requestingUrl)?We(we.has(Ie)):We(!1)),p.session.defaultSession.setPermissionCheckHandler((Ee,Ie,We,Ne)=>de(Ne.requestingUrl)?we.has(Ie):!1);const ve=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,"devtools"]),ge=Ee=>{for(let Ie=Ee;Ie;Ie=Ie.parent)if(Ie.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ee=>Ee.resourceType==="xhr"||ge(Ee.frame),De=Ee=>{const Ie=Ee.frame;if(!Ie||!this.windowsMainService)return!1;const We=p.BrowserWindow.getAllWindows();for(const Ne of We)if(Ie.processId===Ne.webContents.mainFrame.processId)return!0;return!1};p.session.defaultSession.webRequest.onBeforeRequest((Ee,Ie)=>{const We=v.URI.parse(Ee.url);return We.scheme===w.Schemas.vscodeFileResource&&!De(Ee)?(this.logService.error("Blocked vscode-file request",Ee.url),Ie({cancel:!0})):We.path.endsWith(".svg")&&!ve.has(We.scheme)?Ie({cancel:!Pe(Ee)}):Ie({cancel:!1})}),p.session.defaultSession.webRequest.onHeadersReceived((Ee,Ie)=>{const We=Ee.responseHeaders,Ne=We["content-type"]||We["Content-Type"];if(Ne&&Array.isArray(Ne)){const Je=v.URI.parse(Ee.url);if(Je.path.endsWith(".svg")&&ve.has(Je.scheme))return We["Content-Type"]=["image/svg+xml"],Ie({cancel:!1,responseHeaders:We});if(!Je.path.includes(w.Schemas.vscodeRemoteResource)&&Ne.some(tt=>tt.toLowerCase().includes("image/svg")))return Ie({cancel:!Pe(Ee)})}return Ie({cancel:!1})});const Me=p.session.defaultSession;typeof Me.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Me.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,E.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,E.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(ve,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),p.app.on("activate",(ve,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(ve,ge)=>{ge.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ge.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let de=[],we;p.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),we!==void 0&&(clearTimeout(we),we=void 0),we=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],we=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",ve=>{const ge=this.windowsMainService?.getWindowByWebContents(ve.sender);let Pe,De;return ge?.config?(Pe=ge.config,De={...process.env,...ge.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Pe)=>{const De=this.validateNlsPath([ge]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(Pe))}),p.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Pe=this.validateNlsPath(ge);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let we;for(const ve of de)typeof ve=="string"&&(typeof we!="string"?we=ve:we=(0,t.join)(we,ve));if(!(typeof we!="string"||!(0,t.isAbsolute)(we)||!(0,g.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(we)}onUnexpectedError(de){if(de){const we={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(we))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;d.isWindows&&de&&p.app.setAppUserModelId(de);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ie){this.logService.error(Ie)}const we=new o.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(ve),Me=await this.initServices(ve,ge,Pe);if(this.environmentMainService.driverHandle){const Ie=await(0,ie.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ie)}this._register(Me.createInstance(s.ProxyAuthHandler)),Me.invokeFunction(Ie=>this.initChannels(Ie,we,De));const Ee=Me.invokeFunction(Ie=>this.openFirstWindow(Ie,we));Me.invokeFunction(Ie=>this.afterWindowOpen(Ie,ge)),this.environmentMainService.args.trace&&Me.invokeFunction(Ie=>this.stopTracingEventually(Ie,Ee))}async resolveMachineId(){let de=this.stateMainService.getItem(Ye.machineIdKey);return(!de||d.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,l.getMachineId)(),this.stateMainService.setItem(Ye.machineIdKey,de)),de}setupSharedProcess(de){const we=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new u.Client(Pe,"main")})(),ge=(async()=>(await we.whenReady(),ve))();return{sharedProcess:we,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,we,ve){const ge=new ne.ServiceCollection;switch(process.platform){case"win32":ge.set(Qe.IUpdateService,new N.SyncDescriptor(oe.Win32UpdateService));break;case"linux":d.isLinuxSnap?ge.set(Qe.IUpdateService,new N.SyncDescriptor(se.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Qe.IUpdateService,new N.SyncDescriptor(Y.LinuxUpdateService));break;case"darwin":ge.set(Qe.IUpdateService,new N.SyncDescriptor(Xe.DarwinUpdateService));break}ge.set(Ae.IWindowsMainService,new N.SyncDescriptor($e.WindowsMainService,[de,this.userEnv])),ge.set(Q.IDialogMainService,new N.SyncDescriptor(Q.DialogMainService)),ge.set(re.ILaunchMainService,new N.SyncDescriptor(re.LaunchMainService)),ge.set(z.IDiagnosticsMainService,new N.SyncDescriptor(z.DiagnosticsMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(ce.IIssueMainService,new N.SyncDescriptor(ce.IssueMainService,[this.userEnv])),ge.set(ee.IEncryptionMainService,new N.SyncDescriptor(q.EncryptionMainService,[de])),ge.set(ae.IKeyboardLayoutMainService,new N.SyncDescriptor(ae.KeyboardLayoutMainService)),ge.set(Ce.INativeHostMainService,new N.SyncDescriptor(Ce.NativeHostMainService,[we])),ge.set(I.ICredentialsMainService,new N.SyncDescriptor(R.CredentialsMainService,[!1])),ge.set(Ke.IWebviewManagerService,new N.SyncDescriptor(He.WebviewMainService)),ge.set(Ge.IWorkspacesService,new N.SyncDescriptor(Ct.WorkspacesMainService)),ge.set(It.IWorkspacesManagementMainService,new N.SyncDescriptor(It.WorkspacesManagementMainService)),ge.set(it.IWorkspacesHistoryMainService,new N.SyncDescriptor(it.WorkspacesHistoryMainService)),ge.set(ke.IMenubarMainService,new N.SyncDescriptor(ke.MenubarMainService)),ge.set(J.IExtensionUrlTrustService,new N.SyncDescriptor(U.ExtensionUrlTrustService)),ge.set(B.IExtensionHostStarter,new N.SyncDescriptor(K.WorkerMainProcessExtensionHostStarter)),ge.set(Te.IStorageMainService,new N.SyncDescriptor(Te.StorageMainService)),ge.set(Te.IGlobalStorageMainService,new N.SyncDescriptor(Te.GlobalStorageMainService)),d.isWindows?ge.set($.IExternalTerminalMainService,new N.SyncDescriptor(F.WindowsExternalTerminalService)):d.isMacintosh?ge.set($.IExternalTerminalMainService,new N.SyncDescriptor(F.MacExternalTerminalService)):d.isLinux&&ge.set($.IExternalTerminalMainService,new N.SyncDescriptor(F.LinuxExternalTerminalService));const Pe=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(r.IBackupMainService,Pe),ge.set(fe.IURLService,new N.SyncDescriptor(Le.NativeURLService)),(0,ot.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(ve.then(Ne=>Ne.getChannel("telemetryAppender"))),Me=new st.TelemetryAppenderClient(De),Ee=(0,Be.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ie=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appenders:[Me],commonProperties:Ee,piiPaths:Ie,sendErrorTelemetry:!0};ge.set(Ye.ITelemetryService,new N.SyncDescriptor(pt.TelemetryService,[We]))}else ge.set(Ye.ITelemetryService,ot.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,we,ve){const ge=c.ProxyChannel.fromService(de.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Pe=c.ProxyChannel.fromService(de.get(z.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Pe);const De=this.fileService.getProvider(w.Schemas.file);(0,m.assertType)(De instanceof O.DiskFileSystemProvider);const Me=new A.DiskFileSystemProviderChannel(De,this.logService,this.environmentMainService);we.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me),ve.then(je=>je.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me));const Ee=new qe.UpdateChannel(de.get(Qe.IUpdateService));we.registerChannel("update",Ee);const Ie=c.ProxyChannel.fromService(de.get(ce.IIssueMainService));we.registerChannel("issue",Ie);const We=c.ProxyChannel.fromService(de.get(ee.IEncryptionMainService));we.registerChannel("encryption",We);const Ne=c.ProxyChannel.fromService(de.get(I.ICredentialsMainService));we.registerChannel("credentials",Ne);const Je=c.ProxyChannel.fromService(de.get(Re.ISignService));we.registerChannel("sign",Je);const tt=c.ProxyChannel.fromService(de.get(ae.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",tt),this.nativeHostMainService=de.get(Ce.INativeHostMainService);const dt=c.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",dt),ve.then(je=>je.registerChannel("nativeHost",dt));const _e=c.ProxyChannel.fromService(de.get(Ge.IWorkspacesService));we.registerChannel("workspaces",_e);const ft=c.ProxyChannel.fromService(de.get(ke.IMenubarMainService));we.registerChannel("menubar",ft);const at=c.ProxyChannel.fromService(de.get(fe.IURLService));we.registerChannel("url",at);const ct=c.ProxyChannel.fromService(de.get(J.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",ct);const gt=c.ProxyChannel.fromService(de.get(Ke.IWebviewManagerService));we.registerChannel("webview",gt);const lt=this._register(new xe.StorageDatabaseChannel(this.logService,de.get(Te.IStorageMainService)));we.registerChannel("storage",lt),ve.then(je=>je.registerChannel("storage",lt));const ut=c.ProxyChannel.fromService(de.get($.IExternalTerminalMainService));we.registerChannel("externalTerminal",ut);const nt=new me.LogLevelChannel(de.get(he.ILogService));we.registerChannel("logLevel",nt),ve.then(je=>je.registerChannel("logLevel",nt));const ht=new me.LoggerChannel(de.get(he.ILoggerService));we.registerChannel("logger",ht),ve.then(je=>je.registerChannel("logger",ht));const Fe=new L.ElectronExtensionHostDebugBroadcastChannel(de.get(Ae.IWindowsMainService));we.registerChannel("extensionhostdebugservice",Fe);const et=c.ProxyChannel.fromService(de.get(B.IExtensionHostStarter));we.registerChannel(B.ipcExtensionHostStarterChannelName,et)}openFirstWindow(de,we){const ve=this.windowsMainService=de.get(Ae.IWindowsMainService),ge=de.get(fe.IURLService),Pe=de.get(Ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Fe=>{try{return{uri:v.URI.parse(Fe),url:Fe}}catch{return}}).filter(Fe=>{if(!Fe||this.shouldBlockURI(Fe.uri))return!1;const et=this.getWindowOpenableFromProtocolLink(Fe.uri);return et?(De.push(et),!1):!0}),Ee=this,Ie=this.environmentMainService,We=this.productService;ge.registerHandler({async handleURL(Fe,et){if(Fe.scheme===We.urlProtocol&&Fe.path==="workspace"&&(Fe=Fe.with({authority:"file",path:v.URI.parse(Fe.query).path,query:""})),Ee.shouldBlockURI(Fe))return!0;const je=Ee.getWindowOpenableFromProtocolLink(Fe);if(je){const[yt]=ve.open({context:5,cli:{...Ie.args},urisToOpen:[je],gotoLineMode:!0});return yt.focus(),!0}if(d.isMacintosh&&ve.getWindowCount()===0){const[yt]=ve.open({context:5,cli:{...Ie.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Fe)});return await yt.ready(),ge.open(Fe,et)}return!1}});const Ne=this._register(new Ve.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Je=new c.StaticRouter(Fe=>Ne.getActiveClientId().then(et=>Fe===et)),tt=new ye.URLHandlerRouter(Je),dt=we.getChannel("urlHandler",tt);ge.registerHandler(new ye.URLHandlerChannelClient(dt)),this._register(new Oe.ElectronURLListener(Me,ge,ve,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,ft=global.macOpenFiles,at=(0,H.isLaunchedFromCli)(process.env)?0:4,ct=_e._.length,gt=!!_e["folder-uri"],lt=!!_e["file-uri"],ut=_e["skip-add-to-recently-opened"]===!0,nt=_e.wait&&_e.waitMarkerFilePath?v.URI.file(_e.waitMarkerFilePath):void 0,ht=_e.remote||void 0;return De.length>0?ve.open({context:at,cli:_e,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!ct&&!gt&&!lt?ve.open({context:at,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0,remoteAuthority:ht}):ft.length&&!ct&&!gt&&!lt?ve.open({context:1,cli:_e,urisToOpen:ft.map(Fe=>this.getWindowOpenableFromPathSync(Fe)),noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0}):ve.open({context:at,cli:_e,forceNewWindow:_e["new-window"]||!ct&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:ut,waitMarkerFileURI:nt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(de){return!!(de.authority===w.Schemas.file&&d.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,P.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===w.Schemas.file){const we=v.URI.file(de.fsPath);return(0,Ge.hasWorkspaceFileExtension)(we)?{workspaceUri:we}:{fileUri:we}}else if(de.authority===w.Schemas.vscodeRemote){const we=de.path.indexOf(t.posix.sep,1);if(we!==-1){const ve=de.path.substring(1,we),ge=de.path.substring(we),Pe=v.URI.from({scheme:w.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return(0,Ge.hasWorkspaceFileExtension)(ge)?{workspaceUri:Pe}:/:[\d]+$/.test(ge)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:v.URI.file(de)};if((0,Ge.hasWorkspaceFileExtension)(de))return{workspaceUri:v.URI.file(de)}}catch{}return{fileUri:v.URI.file(de)}}async afterWindowOpen(de,we){this.lifecycleMainService.phase=3;let ve=!1;(0,y.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const ge=de.get(Ye.ITelemetryService);this._register(we.onDidError(({type:Me,details:Ee})=>{let Ie;switch(Me){case 1:Ie="SharedProcess: detected unresponsive window";break;case 2:Ie=`SharedProcess: crashed (detail: ${Ee?.reason??"<unknown>"}, code: ${Ee?.exitCode??"<unknown>"})`;break;case 3:Ie=`SharedProcess: failed to load (detail: ${Ee?.reason??"<unknown>"}, code: ${Ee?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Ie)),ge.publicLog2("sharedprocesserror",{type:Me,reason:Ee?.reason,code:Ee?.exitCode,visible:we.isVisible(),shuttingdown:ve})}));const Pe=this.productService.win32MutexName;if(d.isWindows&&Pe)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Ee=new Me(Pe);(0,y.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Me,Ee)=>{Ee({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=de.get(Qe.IUpdateService);(De instanceof oe.Win32UpdateService||De instanceof Y.LinuxUpdateService||De instanceof Xe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ee=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,b.stripComments)(Ee))["enable-crash-reporter"]===void 0){const Ne=(0,ot.getTelemetryLevel)(this.configurationService)>=1,Je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ne},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,k.generateUuid)()}"`,"}"],tt=Ee.substring(0,Ee.length-2).concat(`,
`,Je.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(tt))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(de,we,ve){try{return await(0,j.getResolvedShellEnv)(this.logService,de,we)}catch(ge){const Pe=(0,M.toErrorMessage)(ge);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(de,we){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(Q.IDialogMainService);let ge=!1;const Pe=async Me=>{if(ge)return;ge=!0;const Ee=await p.contentTracing.stopRecording(`${(0,g.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ee}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ee),buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,m.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(we.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};vt=ue([te(2,G.IInstantiationService),te(3,he.ILogService),te(4,X.IEnvironmentMainService),te(5,le.ILifecycleMainService),te(6,h.IConfigurationService),te(7,Ue.IStateMainService),te(8,T.IFileService),te(9,Se.IProductService)],vt),e.CodeApplication=vt}),define(Z[253],x([0,1,12,29,30,8,39,15,28,43,33,10,9,63,3,36,27,24,37,57,246,11,20,197,205,22,52,168,18,185,77,73,179,76,19,95,6,190,96,53,21,54,194,98,235,56,232,79,202,38,234,64,65,211]),function(V,e,p,n,D,C,M,E,g,y,b,P,S,w,t,d,m,v,k,l,f,c,o,u,s,i,r,a,h,I,R,L,W,z,Q,ie,ee,q,X,H,j,J,U,B,K,$,F,_,T,A,O,N,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ne{main(){try{this.startup()}catch(re){console.error(re.message),p.app.exit(1)}}async startup(){(0,E.setUnexpectedErrorHandler)(pe=>console.error(pe));const[re,le,he,me,ke,Ce,Se]=this.createServices();try{try{await this.initServices(he,me,ke)}catch(pe){throw this.handleStartupDataDirError(he,Se.nameLong,pe),pe}await re.invokeFunction(async pe=>{const be=pe.get(ee.ILogService),Re=pe.get(Q.ILifecycleMainService),Ue=pe.get(h.IFileService),xe=await this.claimInstance(be,he,Re,re,Se,!0);return v.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Te=>{be.warn(`Error writing main lockfile: ${Te.stack}`)}),Ce.logger=new X.SpdLogLogger("main",(0,S.join)(he.logsPath,"main.log"),!0,!1,Ce.getLevel()),(0,y.once)(Re.onWillShutdown)(Te=>{Ue.dispose(),me.dispose(),Te.join(v.Promises.unlink(he.mainLockfile).catch(()=>{}))}),re.createInstance(f.CodeApplication,xe,le).startup()})}catch(pe){re.invokeFunction(this.quit,pe)}}createServices(){const re=new z.ServiceCollection,le={_serviceBrand:void 0,...H.default};re.set(j.IProductService,le);const he=new i.EnvironmentMainService(this.resolveArgs(),le),me=this.patchEnvironment(he);re.set(i.IEnvironmentMainService,he);const ke=new ie.BufferLogService,Ce=new ee.MultiplexLogService([new ee.ConsoleMainLogger((0,ee.getLogLevel)(he)),ke]);process.once("exit",()=>Ce.dispose()),re.set(ee.ILogService,Ce);const Se=new I.FileService(Ce);re.set(h.IFileService,Se);const pe=new R.DiskFileSystemProvider(Ce);Se.registerProvider(P.Schemas.file,pe),re.set(ee.ILoggerService,new q.LoggerService(Ce,Se));const be=new u.ConfigurationService(he.settingsResource,Se);re.set(o.IConfigurationService,be),re.set(Q.ILifecycleMainService,new L.SyncDescriptor(Q.LifecycleMainService));const Re=new O.StateMainService(he,Ce,Se);return re.set(A.IStateMainService,Re),re.set($.IRequestService,new L.SyncDescriptor(F.RequestMainService)),re.set(G.IThemeMainService,new L.SyncDescriptor(G.ThemeMainService)),re.set(_.ISignService,new L.SyncDescriptor(T.SignService)),re.set(B.ITunnelService,new L.SyncDescriptor(K.TunnelService)),re.set(J.IProtocolMainService,new L.SyncDescriptor(U.ProtocolMainService)),[new W.InstantiationService(re,!0),me,he,be,Re,ke,le]}patchEnvironment(re){const le={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const me=process.env[he];typeof me=="string"&&(le[he]=me)}),Object.assign(process.env,le),le}initServices(re,le,he){return C.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(me=>me?v.Promises.mkdir(me,{recursive:!0}):void 0)),le.initialize(),he.init()])}async claimInstance(re,le,he,me,ke,Ce){let Se;try{(0,w.mark)("code/willStartMainServer"),Se=await(0,l.serve)(le.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,y.once)(he.onWillShutdown)(()=>Se.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,ke.nameLong,pe),pe;let be;try{be=await(0,l.connect)(le.mainIPCHandle,"main")}catch(Te){if(!Ce||t.isWindows||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,ke.nameShort),(0,c.localize)(1,null),ke.nameLong),Te;try{(0,n.unlinkSync)(le.mainIPCHandle)}catch(Be){throw re.warn("Could not delete obsolete instance handle",Be),Be}return this.claimInstance(re,le,he,me,ke,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Te="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Te),be.dispose(),new Error(Te)}let Re;!le.args.wait&&!le.args.status&&(Re=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,ke.nameShort),(0,c.localize)(3,null),ke.nameLong)},1e4));const Ue=k.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0}),xe=k.ProxyChannel.toService(be.getChannel("diagnostics"),{disableMarshalling:!0});if(le.args.status)return me.invokeFunction(async()=>{const Te=new s.DiagnosticsService(N.NullTelemetryService,ke),Be=await Ue.getMainProcessInfo(),Ye=await xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),st=await Te.getDiagnostics(Be,Ye);throw console.log(st),new E.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ue,re),re.trace("Sending env to running instance..."),await Ue.start(le.args,process.env),be.dispose(),Re&&clearTimeout(Re),new E.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new E.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(re,le,he){if(he.code==="EACCES"||he.code==="EPERM"){const me=(0,D.coalesce)([re.userDataPath,re.extensionsPath,l.XDG_RUNTIME_DIR]).map(ke=>(0,b.getPathLabel)(ke,re));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,M.toErrorMessage)(he),me.join(`
`)),le)}}showStartupWarningDialog(re,le,he){p.dialog.showMessageBoxSync({title:he,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,c.localize)(6,null))],message:re,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,le){if(t.isWindows){const he=await re.getMainProcessId();le.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((me,ke)=>{V(["windows-foreground-love"],me,ke)})).allowSetForegroundWindow(he)}catch(me){le.error(me)}}}quit(re,le){const he=re.get(ee.ILogService),me=re.get(Q.ILifecycleMainService);let ke=0;le&&(le.isExpected?le.message&&he.trace(le.message):(ke=1,le.stack?he.error(le.stack):he.error(`Startup error: ${le.toString()}`))),me.kill(ke)}resolveArgs(){const re=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(re.wait&&!re.waitMarkerFilePath){const le=(0,a.createWaitMarkerFile)(re.verbose);le&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",le),re.waitMarkerFilePath=le)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const le=this.doValidatePaths(re._,re.goto);re._=le}return re}doValidatePaths(re,le){const he=(0,d.cwd)(),me=re.map(Se=>{let pe=String(Se),be;le&&(be=(0,g.parseLineAndColumnAware)(pe),pe=be.path),pe&&(pe=this.preparePath(he,pe));const Re=(0,g.sanitizeFilePath)(pe,he),Ue=(0,S.basename)(Re);return Ue&&!(0,g.isValidBasename)(Ue)?null:le&&be?(be.path=Re,this.toPath(be)):Re}),ke=t.isWindows||t.isMacintosh,Ce=(0,D.distinct)(me,Se=>Se&&ke?Se.toLowerCase():Se||"");return(0,D.coalesce)(Ce)}preparePath(re,le){return t.isWindows&&(le=(0,m.rtrim)(le,'"')),le=(0,m.trim)((0,m.trim)(le," "),"	"),t.isWindows&&(le=(0,S.resolve)(re,le),le=(0,m.rtrim)(le,".")),le}toPath(re){const le=[re.path];return typeof re.line=="number"&&le.push(String(re.line)),typeof re.column=="number"&&le.push(String(re.column)),le.join(":")}}new ne().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36c1f3bd16fce1c215b23e577a080f7f63755fcc/core/vs/code/electron-main/main.js.map
