/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languageFeatureRegistry","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],be=function(ee){for(var e=[],d=0,t=ee.length;d<t;d++)e[d]=ve[ee[d]];return e};define(ve[55],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=d}),define(ve[73],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function d(A){return A?A.replace(/\$\((.*?)\)/g,(k,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=d;class t{constructor(k,D,P){this.id=k,this.definition=D,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(A,k){const D=["codicon","codicon-"+A];return k&&D.push("codicon-modifier-"+k),D}e.getClassNamesArray=I;var C;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(y){if(y instanceof t)return["codicon","codicon-"+y.id];const l=k.exec(y.id);if(!l)return D(t.error);let[,b,g]=l;const v=["codicon","codicon-"+b];return g&&v.push("codicon-modifier-"+g.substr(1)),v}A.asClassNameArray=D;function P(y){return D(y).join(" ")}A.asClassName=P;function F(y){return"."+D(y).join(".")}A.asCSSSelector=F})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ve[74],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function t(F){const y=[];for(let l in F)d.call(F,l)&&y.push(F[l]);return y}e.values=t;function I(F,y){for(let l in F)if(d.call(F,l)&&y({key:l,value:F[l]},function(){delete F[l]})===!1)return}e.forEach=I;function C(F,y){const l=Object.create(null);for(const b of F){const g=y(b);let v=l[g];v||(v=l[g]=[]),v.push(b)}return l}e.groupBy=C;function A(F){const y=Object.create(null);return F&&F.forEach((l,b)=>{y[b]=l}),y}e.fromMap=A;function k(F,y){const l=[],b=[];for(let g of F)y.has(g)||l.push(g);for(let g of y)F.has(g)||b.push(g);return{removed:l,added:b}}e.diffSets=k;function D(F,y){const l=[],b=[];for(let[g,v]of F)y.has(g)||l.push(v);for(let[g,v]of y)F.has(g)||b.push(v);return{removed:l,added:b}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(y,l){let b=this.map.get(y);b||(b=new Set,this.map.set(y,b)),b.add(l)}delete(y,l){const b=this.map.get(y);!b||(b.delete(l),b.size===0&&this.map.delete(y))}forEach(y,l){const b=this.map.get(y);!b||b.forEach(l)}}e.SetMap=P}),define(ve[56],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(A){return(k,D,P)=>{let F=null,y=null;if(typeof P.value=="function"?(F="value",y=P.value):typeof P.get=="function"&&(F="get",y=P.get),!y)throw new Error("not supported");P[F]=A(y,D)}}e.createDecorator=d;function t(A,k,D){let P=null,F=null;if(typeof D.value=="function"?(P="value",F=D.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",F=D.get),!F)throw new Error("not supported");const y=`$memoize$${k}`;D[P]=function(...l){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,l)}),this[y]}}e.memoize=t;function I(A,k,D){return d((P,F)=>{const y=`$debounce$${F}`,l=`$debounce$result$${F}`;return function(...b){this[l]||(this[l]=D?D():void 0),clearTimeout(this[y]),k&&(this[l]=k(this[l],...b),b=[this[l]]),this[y]=setTimeout(()=>{P.apply(this,b),this[l]=D?D():void 0},A)}})}e.debounce=I;function C(A,k,D){return d((P,F)=>{const y=`$throttle$timer$${F}`,l=`$throttle$result$${F}`,b=`$throttle$lastRun$${F}`,g=`$throttle$pending$${F}`;return function(...v){if(this[l]||(this[l]=D?D():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...v)),this[g])return;const _=this[b]+A;_<=Date.now()?(this[b]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0):(this[g]=!0,this[y]=setTimeout(()=>{this[g]=!1,this[b]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0},_-Date.now()))}})}e.throttle=C}),define(ve[16],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class d{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(S=>{S(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=d,e.errorHandler=new d;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function I(u){D(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=I;function C(u){D(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=C;function A(u){if(u instanceof Error){let{name:r,message:S}=u;const a=u.stacktrace||u.stack;return{$isError:!0,name:r,message:S,stack:a}}return u}e.transformErrorForSerialization=A;const k="Canceled";function D(u){return u instanceof P?!0:u instanceof Error&&u.name===k&&u.message===k}e.isCancellationError=D;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function F(){const u=new Error(k);return u.name=u.message,u}e.canceled=F;function y(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=y;function l(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=l;function b(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function g(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=g;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=_;class R extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=R;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function h(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=h;function s(u,r=Object.create(null)){const S=new Error(u);return r.actions&&(S.actions=r.actions),S}e.createErrorWithActions=s}),define(ve[17],be([0,1,16]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(Z,Q=0){return Z[Z.length-(1+Q)]}e.tail=t;function I(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=I;function C(Z,Q,oe=(fe,pe)=>fe===pe){if(Z===Q)return!0;if(!Z||!Q||Z.length!==Q.length)return!1;for(let fe=0,pe=Z.length;fe<pe;fe++)if(!oe(Z[fe],Q[fe]))return!1;return!0}e.equals=C;function A(Z,Q,oe){let fe=0,pe=Z.length-1;for(;fe<=pe;){const Te=(fe+pe)/2|0,xe=oe(Z[Te],Q);if(xe<0)fe=Te+1;else if(xe>0)pe=Te-1;else return Te}return-(fe+1)}e.binarySearch=A;function k(Z,Q){let oe=0,fe=Z.length;if(fe===0)return 0;for(;oe<fe;){const pe=Math.floor((oe+fe)/2);Q(Z[pe])?fe=pe:oe=pe+1}return oe}e.findFirstInSorted=k;function D(Z,Q,oe){if(Z=Z|0,Z>=Q.length)throw new TypeError("invalid index");let fe=Q[Math.floor(Q.length*Math.random())],pe=[],Te=[],xe=[];for(let qe of Q){const Qe=oe(qe,fe);Qe<0?pe.push(qe):Qe>0?Te.push(qe):xe.push(qe)}return Z<pe.length?D(Z,pe,oe):Z<pe.length+xe.length?xe[0]:D(Z-(pe.length+xe.length),Te,oe)}e.quickSelect=D;function P(Z,Q){const oe=[];let fe;for(const pe of Z.slice(0).sort(Q))!fe||Q(fe[0],pe)!==0?(fe=[pe],oe.push(fe)):fe.push(pe);return oe}e.groupBy=P;function F(Z,Q,oe){const fe=[];function pe(qe,Qe,q){if(Qe===0&&q.length===0)return;const ie=fe[fe.length-1];ie&&ie.start+ie.deleteCount===qe?(ie.deleteCount+=Qe,ie.toInsert.push(...q)):fe.push({start:qe,deleteCount:Qe,toInsert:q})}let Te=0,xe=0;for(;;){if(Te===Z.length){pe(Te,0,Q.slice(xe));break}if(xe===Q.length){pe(Te,Z.length-Te,[]);break}const qe=Z[Te],Qe=Q[xe],q=oe(qe,Qe);q===0?(Te+=1,xe+=1):q<0?(pe(Te,1,[]),Te+=1):q>0&&(pe(Te,0,[Qe]),xe+=1)}return fe}e.sortedDiff=F;function y(Z,Q,oe){const fe=F(Z,Q,oe),pe=[],Te=[];for(const xe of fe)pe.push(...Z.slice(xe.start,xe.start+xe.deleteCount)),Te.push(...xe.toInsert);return{removed:pe,added:Te}}e.delta=y;function l(Z,Q,oe){if(oe===0)return[];const fe=Z.slice(0,oe).sort(Q);return g(Z,Q,fe,oe,Z.length),fe}e.top=l;function b(Z,Q,oe,fe,pe){return oe===0?Promise.resolve([]):new Promise((Te,xe)=>{(async()=>{const qe=Z.length,Qe=Z.slice(0,oe).sort(Q);for(let q=oe,ie=Math.min(oe+fe,qe);q<qe;q=ie,ie=Math.min(ie+fe,qe)){if(q>oe&&await new Promise(G=>setTimeout(G)),pe&&pe.isCancellationRequested)throw(0,d.canceled)();g(Z,Q,Qe,q,ie)}return Qe})().then(Te,xe)})}e.topAsync=b;function g(Z,Q,oe,fe,pe){for(const Te=oe.length;fe<pe;fe++){const xe=Z[fe];if(Q(xe,oe[Te-1])<0){oe.pop();const qe=k(oe,Qe=>Q(xe,Qe)<0);oe.splice(qe,0,xe)}}}function v(Z){return Z.filter(Q=>!!Q)}e.coalesce=v;function _(Z){let Q=0;for(let oe=0;oe<Z.length;oe++)Z[oe]&&(Z[Q]=Z[oe],Q+=1);Z.length=Q}e.coalesceInPlace=_;function R(Z,Q,oe){Z.splice(oe,0,Z.splice(Q,1)[0])}e.move=R;function p(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=p;function h(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=h;function s(Z,Q=oe=>oe){const oe=new Set;return Z.filter(fe=>{const pe=Q(fe);return oe.has(pe)?!1:(oe.add(pe),!0)})}e.distinct=s;function u(Z){const Q=new Set;return oe=>{const fe=Z(oe);return Q.has(fe)?!1:(Q.add(fe),!0)}}e.uniqueFilter=u;function r(Z,Q){const oe=S(Z,Q);if(oe!==-1)return Z[oe]}e.findLast=r;function S(Z,Q){for(let oe=Z.length-1;oe>=0;oe--){const fe=Z[oe];if(Q(fe))return oe}return-1}e.lastIndex=S;function a(Z,Q){return Z.length>0?Z[0]:Q}e.firstOrDefault=a;function i(Z,Q,oe=(fe,pe)=>fe===pe){let fe=0;for(let pe=0,Te=Math.min(Z.length,Q.length);pe<Te&&oe(Z[pe],Q[pe]);pe++)fe++;return fe}e.commonPrefixLength=i;function n(Z){return[].concat(...Z)}e.flatten=n;function o(Z,Q){let oe=typeof Q=="number"?Z:0;typeof Q=="number"?oe=Z:(oe=0,Q=Z);const fe=[];if(oe<=Q)for(let pe=oe;pe<Q;pe++)fe.push(pe);else for(let pe=oe;pe>Q;pe--)fe.push(pe);return fe}e.range=o;function c(Z,Q,oe){return Z.reduce((fe,pe)=>(fe[Q(pe)]=oe?oe(pe):pe,fe),Object.create(null))}e.index=c;function m(Z,Q){return Z.push(Q),()=>f(Z,Q)}e.insert=m;function f(Z,Q){const oe=Z.indexOf(Q);if(oe>-1)return Z.splice(oe,1),Q}e.remove=f;function w(Z,Q,oe){const fe=Z.slice(0,Q),pe=Z.slice(Q);return fe.concat(oe,pe)}e.arrayInsert=w;function T(Z,Q){let oe;if(typeof Q=="number"){let fe=Q;oe=()=>{const pe=Math.sin(fe++)*179426549;return pe-Math.floor(pe)}}else oe=Math.random;for(let fe=Z.length-1;fe>0;fe-=1){const pe=Math.floor(oe()*(fe+1)),Te=Z[fe];Z[fe]=Z[pe],Z[pe]=Te}}e.shuffle=T;function L(Z,Q){const oe=Z.indexOf(Q);oe>-1&&(Z.splice(oe,1),Z.unshift(Q))}e.pushToStart=L;function O(Z,Q){const oe=Z.indexOf(Q);oe>-1&&(Z.splice(oe,1),Z.push(Q))}e.pushToEnd=O;function E(Z,Q){return Array.isArray(Z)?Z.map(Q):Q(Z)}e.mapArrayOrNot=E;function M(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=M;function U(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=U;function V(Z,Q){for(const oe of Z){const fe=Q(oe);if(fe!==void 0)return fe}}e.mapFind=V;function z(Z,Q,oe){const fe=W(Z,Q),pe=Z.length,Te=oe.length;Z.length=pe+Te;for(let xe=pe-1;xe>=fe;xe--)Z[xe+Te]=Z[xe];for(let xe=0;xe<Te;xe++)Z[xe+fe]=oe[xe]}e.insertInto=z;function N(Z,Q,oe,fe){const pe=W(Z,Q),Te=Z.splice(pe,oe);return z(Z,pe,fe),Te}e.splice=N;function W(Z,Q){return Q<0?Math.max(Q+Z.length,0):Math.min(Q,Z.length)}function B(Z,Q){return(oe,fe)=>Q(Z(oe),Z(fe))}e.compareBy=B;const x=(Z,Q)=>Z-Q;e.numberComparator=x;function $(Z,Q){if(Z.length===0)return;let oe=Z[0];for(let fe=1;fe<Z.length;fe++){const pe=Z[fe];Q(pe,oe)>0&&(oe=pe)}return oe}e.findMaxBy=$;function J(Z,Q){if(Z.length===0)return;let oe=Z[0];for(let fe=1;fe<Z.length;fe++){const pe=Z[fe];Q(pe,oe)>=0&&(oe=pe)}return oe}e.findLastMaxBy=J;function ne(Z,Q){return $(Z,(oe,fe)=>-Q(oe,fe))}e.findMinBy=ne;class re{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let oe=this.firstIdx;for(;oe<this.items.length&&Q(this.items[oe]);)oe++;const fe=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,fe}takeFromEndWhile(Q){let oe=this.lastIdx;for(;oe>=0&&Q(this.items[oe]);)oe--;const fe=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,fe}peek(){return this.items[this.firstIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}takeCount(Q){const oe=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,oe}}e.ArrayQueue=re}),define(ve[75],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function d(t){const I=this;let C=!1,A;return function(){return C||(C=!0,A=t.apply(I,arguments)),A}}e.once=d}),define(ve[76],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(ve[77],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(t){function I(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=I;const C=Object.freeze([]);function A(){return C}t.empty=A;function*k(u){yield u}t.single=k;function D(u){return u||C}t.from=D;function P(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=P;function F(u){return u[Symbol.iterator]().next().value}t.first=F;function y(u,r){for(const S of u)if(r(S))return!0;return!1}t.some=y;function l(u,r){for(const S of u)if(r(S))return S}t.find=l;function*b(u,r){for(const S of u)r(S)&&(yield S)}t.filter=b;function*g(u,r){let S=0;for(const a of u)yield r(a,S++)}t.map=g;function*v(...u){for(const r of u)for(const S of r)yield S}t.concat=v;function*_(u){for(const r of u)for(const S of r)yield S}t.concatNested=_;function R(u,r,S){let a=S;for(const i of u)a=r(a,i);return a}t.reduce=R;function*p(u,r,S=u.length){for(r<0&&(r+=u.length),S<0?S+=u.length:S>u.length&&(S=u.length);r<S;r++)yield u[r]}t.slice=p;function h(u,r=Number.POSITIVE_INFINITY){const S=[];if(r===0)return[S,u];const a=u[Symbol.iterator]();for(let i=0;i<r;i++){const n=a.next();if(n.done)return[S,t.empty()];S.push(n.value)}return[S,{[Symbol.iterator](){return a}}]}t.consume=h;function s(u,r,S=(a,i)=>a===i){const a=u[Symbol.iterator](),i=r[Symbol.iterator]();for(;;){const n=a.next(),o=i.next();if(n.done!==o.done)return!1;if(n.done)return!0;if(!S(n.value,o.value))return!1}}t.equals=s})(d=e.Iterable||(e.Iterable={}))}),define(ve[57],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(r){r.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function A(r,S=!1){let a=0,i=r.length,n="",o=0,c=16,m=0;function f(U){let V=0,z=0;for(;V<U;){const N=r.charCodeAt(a);if(N>=48&&N<=57)z=z*16+N-48;else if(N>=65&&N<=70)z=z*16+N-65+10;else if(N>=97&&N<=102)z=z*16+N-97+10;else break;a++,V++}return V<U&&(z=-1),z}function w(U){a=U,n="",o=0,c=16,m=0}function T(){const U=a;if(r.charCodeAt(a)===48)a++;else for(a++;a<r.length&&P(r.charCodeAt(a));)a++;if(a<r.length&&r.charCodeAt(a)===46)if(a++,a<r.length&&P(r.charCodeAt(a)))for(a++;a<r.length&&P(r.charCodeAt(a));)a++;else return m=3,r.substring(U,a);let V=a;if(a<r.length&&(r.charCodeAt(a)===69||r.charCodeAt(a)===101))if(a++,(a<r.length&&r.charCodeAt(a)===43||r.charCodeAt(a)===45)&&a++,a<r.length&&P(r.charCodeAt(a))){for(a++;a<r.length&&P(r.charCodeAt(a));)a++;V=a}else m=3;return r.substring(U,V)}function L(){let U="",V=a;for(;;){if(a>=i){U+=r.substring(V,a),m=2;break}const z=r.charCodeAt(a);if(z===34){U+=r.substring(V,a),a++;break}if(z===92){if(U+=r.substring(V,a),a++,a>=i){m=2;break}switch(r.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const W=f(4);W>=0?U+=String.fromCharCode(W):m=4;break}default:m=5}V=a;continue}if(z>=0&&z<=31)if(D(z)){U+=r.substring(V,a),m=2;break}else m=6;a++}return U}function O(){if(n="",m=0,o=a,a>=i)return o=i,c=17;let U=r.charCodeAt(a);if(k(U)){do a++,n+=String.fromCharCode(U),U=r.charCodeAt(a);while(k(U));return c=15}if(D(U))return a++,n+=String.fromCharCode(U),U===13&&r.charCodeAt(a)===10&&(a++,n+=`
`),c=14;switch(U){case 123:return a++,c=1;case 125:return a++,c=2;case 91:return a++,c=3;case 93:return a++,c=4;case 58:return a++,c=6;case 44:return a++,c=5;case 34:return a++,n=L(),c=10;case 47:{const V=a-1;if(r.charCodeAt(a+1)===47){for(a+=2;a<i&&!D(r.charCodeAt(a));)a++;return n=r.substring(V,a),c=12}if(r.charCodeAt(a+1)===42){a+=2;const z=i-1;let N=!1;for(;a<z;){if(r.charCodeAt(a)===42&&r.charCodeAt(a+1)===47){a+=2,N=!0;break}a++}return N||(a++,m=1),n=r.substring(V,a),c=13}return n+=String.fromCharCode(U),a++,c=16}case 45:if(n+=String.fromCharCode(U),a++,a===i||!P(r.charCodeAt(a)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=T(),c=11;default:for(;a<i&&E(U);)a++,U=r.charCodeAt(a);if(o!==a){switch(n=r.substring(o,a),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(U),a++,c=16}}function E(U){if(k(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:w,getPosition:()=>a,scan:S?M:O,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>a-o,getTokenError:()=>m}}e.createScanner=A;function k(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function P(r){return r>=48&&r<=57}var F;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(F||(F={}));function y(r,S){const a=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(f,w,T,L){o.value=f,o.offset=w,o.length=T,o.type=L,o.colonOffset=void 0,n=o}try{h(r,{onObjectBegin:(f,w)=>{if(S<=f)throw i;n=void 0,c=S>f,a.push("")},onObjectProperty:(f,w,T)=>{if(S<w||(m(f,w,T,"property"),a[a.length-1]=f,S<=w+T))throw i},onObjectEnd:(f,w)=>{if(S<=f)throw i;n=void 0,a.pop()},onArrayBegin:(f,w)=>{if(S<=f)throw i;n=void 0,a.push(0)},onArrayEnd:(f,w)=>{if(S<=f)throw i;n=void 0,a.pop()},onLiteralValue:(f,w,T)=>{if(S<w||(m(f,w,T,u(f)),S<=w+T))throw i},onSeparator:(f,w,T)=>{if(S<=w)throw i;if(f===":"&&n&&n.type==="property")n.colonOffset=w,c=!1,n=void 0;else if(f===","){const L=a[a.length-1];typeof L=="number"?a[a.length-1]=L+1:(c=!0,a[a.length-1]=""),n=void 0}}})}catch(f){if(f!==i)throw f}return{path:a,previousNode:n,isAtPropertyKey:c,matches:f=>{let w=0;for(let T=0;w<f.length&&T<a.length;T++)if(f[w]===a[T]||f[w]==="*")w++;else if(f[w]!=="**")return!1;return w===f.length}}}e.getLocation=y;function l(r,S=[],a=C.DEFAULT){let i=null,n=[];const o=[];function c(f){Array.isArray(n)?n.push(f):i!==null&&(n[i]=f)}return h(r,{onObjectBegin:()=>{const f={};c(f),o.push(n),n=f,i=null},onObjectProperty:f=>{i=f},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const f=[];c(f),o.push(n),n=f,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:c,onError:(f,w,T)=>{S.push({error:f,offset:w,length:T})}},a),n[0]}e.parse=l;function b(r,S=[],a=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(f){i.type==="property"&&(i.length=f-i.offset,i=i.parent)}function o(f){return i.children.push(f),f}h(r,{onObjectBegin:f=>{i=o({type:"object",offset:f,length:-1,parent:i,children:[]})},onObjectProperty:(f,w,T)=>{i=o({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:f,offset:w,length:T,parent:i})},onObjectEnd:(f,w)=>{i.length=f+w-i.offset,i=i.parent,n(f+w)},onArrayBegin:(f,w)=>{i=o({type:"array",offset:f,length:-1,parent:i,children:[]})},onArrayEnd:(f,w)=>{i.length=f+w-i.offset,i=i.parent,n(f+w)},onLiteralValue:(f,w,T)=>{o({type:u(f),offset:w,length:T,parent:i,value:f}),n(w+T)},onSeparator:(f,w,T)=>{i.type==="property"&&(f===":"?i.colonOffset=w:f===","&&n(w))},onError:(f,w,T)=>{S.push({error:f,offset:w,length:T})}},a);const m=i.children[0];return m&&delete m.parent,m}e.parseTree=b;function g(r,S){if(!r)return;let a=r;for(let i of S)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let n=!1;for(const o of a.children)if(Array.isArray(o.children)&&o.children[0].value===i){a=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(a.type!=="array"||n<0||!Array.isArray(a.children)||n>=a.children.length)return;a=a.children[n]}return a}e.findNodeAtLocation=g;function v(r){if(!r.parent||!r.parent.children)return[];const S=v(r.parent);if(r.parent.type==="property"){const a=r.parent.children[0].value;S.push(a)}else if(r.parent.type==="array"){const a=r.parent.children.indexOf(r);a!==-1&&S.push(a)}return S}e.getNodePath=v;function _(r){switch(r.type){case"array":return r.children.map(_);case"object":{const S=Object.create(null);for(let a of r.children){const i=a.children[1];i&&(S[a.children[0].value]=_(i))}return S}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=_;function R(r,S,a=!1){return S>=r.offset&&S<r.offset+r.length||a&&S===r.offset+r.length}e.contains=R;function p(r,S,a=!1){if(R(r,S,a)){const i=r.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=S;n++){const o=p(i[n],S,a);if(o)return o}return r}}e.findNodeAtOffset=p;function h(r,S,a=C.DEFAULT){const i=A(r,!1);function n(re){return re?()=>re(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(re){return re?Z=>re(Z,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=n(S.onObjectBegin),m=o(S.onObjectProperty),f=n(S.onObjectEnd),w=n(S.onArrayBegin),T=n(S.onArrayEnd),L=o(S.onLiteralValue),O=o(S.onSeparator),E=n(S.onComment),M=o(S.onError),U=a&&a.disallowComments,V=a&&a.allowTrailingComma;function z(){for(;;){const re=i.scan();switch(i.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:U||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(re){case 12:case 13:U?N(10):E();break;case 16:N(1);break;case 15:case 14:break;default:return re}}}function N(re,Z=[],Q=[]){if(M(re),Z.length+Q.length>0){let oe=i.getToken();for(;oe!==17;){if(Z.indexOf(oe)!==-1){z();break}else if(Q.indexOf(oe)!==-1)break;oe=z()}}}function W(re){const Z=i.getTokenValue();return re?L(Z):m(Z),z(),!0}function B(){switch(i.getToken()){case 11:{let re=0;try{re=JSON.parse(i.getTokenValue()),typeof re!="number"&&(N(2),re=0)}catch{N(2)}L(re);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return z(),!0}function x(){return i.getToken()!==10?(N(3,[],[2,5]),!1):(W(!1),i.getToken()===6?(O(":"),z(),ne()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function $(){c(),z();let re=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(re||N(4,[],[]),O(","),z(),i.getToken()===2&&V)break}else re&&N(6,[],[]);x()||N(4,[],[2,5]),re=!0}return f(),i.getToken()!==2?N(7,[2],[]):z(),!0}function J(){w(),z();let re=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(re||N(4,[],[]),O(","),z(),i.getToken()===4&&V)break}else re&&N(6,[],[]);ne()||N(4,[],[4,5]),re=!0}return T(),i.getToken()!==4?N(8,[4],[]):z(),!0}function ne(){switch(i.getToken()){case 3:return J();case 1:return $();case 10:return W(!0);default:return B()}}return z(),i.getToken()===17?a.allowEmptyContent?!0:(N(4,[],[]),!1):ne()?(i.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=h;function s(r,S){let a=A(r),i=[],n,o=0,c;do switch(c=a.getPosition(),n=a.scan(),n){case 12:case 13:case 17:o!==c&&i.push(r.substring(o,c)),S!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,S)),o=a.getPosition();break}while(n!==17);return i.join("")}e.stripComments=s;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ve[140],be([0,1,57]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,F,y){let l,b,g,v,_;if(F){for(v=F.offset,_=v+F.length,g=v;g>0&&!D(P,g-1);)g--;let c=_;for(;c<P.length&&!D(P,c);)c++;b=P.substring(g,c),l=A(b,y)}else b=P,l=0,g=0,v=0,_=P.length;const R=k(y,P);let p=!1,h=0,s;y.insertSpaces?s=C(" ",y.tabSize||4):s="	";const u=(0,d.createScanner)(b,!1);let r=!1;function S(){return R+C(s,l+h)}function a(){let c=u.scan();for(p=!1;c===15||c===14;)p=p||c===14,c=u.scan();return r=c===16||u.getTokenError()!==0,c}const i=[];function n(c,m,f){!r&&m<_&&f>v&&P.substring(m,f)!==c&&i.push({offset:m,length:f-m,content:c})}let o=a();if(o!==17){const c=u.getTokenOffset()+g,m=C(s,l);n(m,g,c)}for(;o!==17;){let c=u.getTokenOffset()+u.getTokenLength()+g,m=a(),f="";for(;!p&&(m===12||m===13);){const T=u.getTokenOffset()+g;n(" ",c,T),c=u.getTokenOffset()+u.getTokenLength()+g,f=m===12?S():"",m=a()}if(m===2)o!==1&&(h--,f=S());else if(m===4)o!==3&&(h--,f=S());else{switch(o){case 3:case 1:h++,f=S();break;case 5:case 12:f=S();break;case 13:p?f=S():f=" ";break;case 6:f=" ";break;case 10:if(m===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?f=" ":m!==5&&m!==17&&(r=!0);break;case 16:r=!0;break}p&&(m===12||m===13)&&(f=S())}const w=u.getTokenOffset()+g;n(f,c,w),o=m}return i}e.format=t;function I(P,F){const y=JSON.stringify(P,void 0,F.insertSpaces?F.tabSize||4:"	");return F.eol!==void 0?y.replace(/\r\n|\r|\n/g,F.eol):y}e.toFormattedString=I;function C(P,F){let y="";for(let l=0;l<F;l++)y+=P;return y}function A(P,F){let y=0,l=0;const b=F.tabSize||4;for(;y<P.length;){const g=P.charAt(y);if(g===" ")l++;else if(g==="	")l+=b;else break;y++}return Math.floor(l/b)}function k(P,F){for(let y=0;y<F.length;y++){const l=F.charAt(y);if(l==="\r")return y+1<F.length&&F.charAt(y+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=k;function D(P,F){return`\r
`.indexOf(P.charAt(F))!==-1}e.isEOL=D}),define(ve[141],be([0,1,57,140]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(P,F,y){return C(P,F,void 0,y)}e.removeProperty=I;function C(P,F,y,l,b){const g=F.slice(),v=[],_=(0,d.parseTree)(P,v);let R,p;for(;g.length>0&&(p=g.pop(),R=(0,d.findNodeAtLocation)(_,g),R===void 0&&y!==void 0);)typeof p=="string"?y={[p]:y}:y=[y];if(R)if(R.type==="object"&&typeof p=="string"&&Array.isArray(R.children)){const h=(0,d.findNodeAtLocation)(R,[p]);if(h!==void 0)if(y===void 0){if(!h.parent)throw new Error("Malformed AST");const s=R.children.indexOf(h.parent);let u,r=h.parent.offset+h.parent.length;if(s>0){const S=R.children[s-1];u=S.offset+S.length}else u=R.offset+1,R.children.length>1&&(r=R.children[1].offset);return A(P,{offset:u,length:r-u,content:""},l)}else return A(P,{offset:h.offset,length:h.length,content:JSON.stringify(y)},l);else{if(y===void 0)return[];const s=`${JSON.stringify(p)}: ${JSON.stringify(y)}`,u=b?b(R.children.map(S=>S.children[0].value)):R.children.length;let r;if(u>0){const S=R.children[u-1];r={offset:S.offset+S.length,length:0,content:","+s}}else R.children.length===0?r={offset:R.offset+1,length:0,content:s}:r={offset:R.offset+1,length:0,content:s+","};return A(P,r,l)}}else if(R.type==="array"&&typeof p=="number"&&Array.isArray(R.children))if(y!==void 0){const h=`${JSON.stringify(y)}`;let s;if(R.children.length===0||p===0)s={offset:R.offset+1,length:0,content:R.children.length===0?h:h+","};else{const u=p===-1||p>R.children.length?R.children.length:p,r=R.children[u-1];s={offset:r.offset+r.length,length:0,content:","+h}}return A(P,s,l)}else{const h=p,s=R.children[h];let u;if(R.children.length===1)u={offset:R.offset+1,length:R.length-2,content:""};else if(R.children.length-1===h){const r=R.children[h-1],S=r.offset+r.length,a=R.offset+R.length;u={offset:S,length:a-2-S,content:""}}else u={offset:s.offset,length:R.children[h+1].offset-s.offset,content:""};return A(P,u,l)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${R.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(y)},l)}}e.setProperty=C;function A(P,F,y){let l=k(P,F),b=F.offset,g=F.offset+F.content.length;if(F.length===0||F.content.length===0){for(;b>0&&!(0,t.isEOL)(l,b-1);)b--;for(;g<l.length&&!(0,t.isEOL)(l,g);)g++}const v=(0,t.format)(l,{offset:b,length:g-b},y);for(let R=v.length-1;R>=0;R--){const p=v[R];l=k(l,p),b=Math.min(b,p.offset),g=Math.max(g,p.offset+p.length),g+=p.content.length-p.length}const _=P.length-(l.length-g)-b;return[{offset:b,length:_,content:l.substring(b,g)}]}e.withFormatting=A;function k(P,F){return P.substring(0,F.offset)+F.content+P.substring(F.offset+F.length)}e.applyEdit=k;function D(P,F){let y=F.slice(0).sort((b,g)=>{const v=b.offset-g.offset;return v===0?b.length-g.length:v}),l=P.length;for(let b=y.length-1;b>=0;b--){let g=y[b];if(g.offset+g.length<=l)P=k(P,g);else throw new Error("Overlapping edit");l=g.offset}return P}e.applyEdits=D}),define(ve[93],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new d(()=>I(this.getValue()))}}e.Lazy=d}),define(ve[6],be([0,1,75,77]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let C=null;function A(i){C=i}if(e.setDisposableTracker=A,I){const i="__is_disposable_tracked__";A(new class{trackDisposable(n){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[i]||console.log(o)},3e3)}setParent(n,o){if(n&&n!==p.None)try{n[i]=!0}catch{}}markAsDisposed(n){if(n&&n!==p.None)try{n[i]=!0}catch{}}markAsSingleton(n){}})}function k(i){return C?.trackDisposable(i),i}function D(i){C?.markAsDisposed(i)}function P(i,n){C?.setParent(i,n)}function F(i,n){if(!!C)for(const o of i)C.setParent(o,n)}function y(i){return C?.markAsSingleton(i),i}e.markAsSingleton=y;class l extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=l;function b(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=b;function g(i){if(t.Iterable.is(i)){let n=[];for(const o of i)if(o)try{o.dispose()}catch(c){n.push(c)}if(n.length===1)throw n[0];if(n.length>1)throw new l(n);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=g;function v(...i){const n=_(()=>g(i));return F(i,n),n}e.combinedDisposable=v;function _(i){const n=k({dispose:(0,d.once)(()=>{D(n),i()})});return n}e.toDisposable=_;class R{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return P(n,this),this._isDisposed?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=R,R.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new R,k(this),P(this._store,this)}dispose(){D(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&P(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&P(n,null),n}}e.MutableDisposable=h;class s{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class u{constructor(){this.references=new Map}acquire(n,...o){let c=this.references.get(n);c||(c={counter:0,object:this.createReferencedObject(n,...o)},this.references.set(n,c));const{object:m}=c,f=(0,d.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(n,c.object),this.references.delete(n))});return c.counter++,{object:m,dispose:f}}}e.ReferenceCollection=u;class r{constructor(n){this.referenceCollection=n}async acquire(n,...o){const c=this.referenceCollection.acquire(n,...o);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(m){throw c.dispose(),m}}}e.AsyncReferenceCollection=r;class S{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=S;function a(i){const n=new R;try{i(n)}finally{n.dispose()}}e.disposeOnReturn=a}),define(ve[94],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class d{constructor(C){this.element=C,this.next=d.Undefined,this.prev=d.Undefined}}d.Undefined=new d(void 0);class t{constructor(){this._first=d.Undefined,this._last=d.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===d.Undefined}clear(){let C=this._first;for(;C!==d.Undefined;){const A=C.next;C.prev=d.Undefined,C.next=d.Undefined,C=A}this._first=d.Undefined,this._last=d.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,A){const k=new d(C);if(this._first===d.Undefined)this._first=k,this._last=k;else if(A){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==d.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==d.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==d.Undefined&&C.next!==d.Undefined){const A=C.prev;A.next=C.next,C.next.prev=A}else C.prev===d.Undefined&&C.next===d.Undefined?(this._first=d.Undefined,this._last=d.Undefined):C.next===d.Undefined?(this._last=this._last.prev,this._last.next=d.Undefined):C.prev===d.Undefined&&(this._first=this._first.next,this._first.prev=d.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==d.Undefined;)yield C.element,C=C.next}}e.LinkedList=t}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Re,Ae){for(var Ce=0;Ce<Ae.length;Ce++){var ue=Ae[Ce];ue.enumerable=ue.enumerable||!1,ue.configurable=!0,"value"in ue&&(ue.writable=!0),Object.defineProperty(Re,ue.key,ue)}}function e(Re,Ae,Ce){return Ae&&ee(Re.prototype,Ae),Ce&&ee(Re,Ce),Re}function d(Re,Ae){if(!!Re){if(typeof Re=="string")return t(Re,Ae);var Ce=Object.prototype.toString.call(Re).slice(8,-1);if(Ce==="Object"&&Re.constructor&&(Ce=Re.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Re);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return t(Re,Ae)}}function t(Re,Ae){(Ae==null||Ae>Re.length)&&(Ae=Re.length);for(var Ce=0,ue=new Array(Ae);Ce<Ae;Ce++)ue[Ce]=Re[Ce];return ue}function I(Re,Ae){var Ce=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Ce)return(Ce=Ce.call(Re)).next.bind(Ce);if(Array.isArray(Re)||(Ce=d(Re))||Ae&&Re&&typeof Re.length=="number"){Ce&&(Re=Ce);var ue=0;return function(){return ue>=Re.length?{done:!0}:{done:!1,value:Re[ue++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){C.exports.defaults=Re}C.exports={defaults:A(),getDefaults:A,changeDefaults:k};var D=/[&<>"']/,P=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ae){return l[Ae]};function g(Re,Ae){if(Ae){if(D.test(Re))return Re.replace(P,b)}else if(F.test(Re))return Re.replace(y,b);return Re}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Re){return Re.replace(v,function(Ae,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var R=/(^|[^\[])\^/g;function p(Re,Ae){Re=Re.source||Re,Ae=Ae||"";var Ce={replace:function(de,Ee){return Ee=Ee.source||Ee,Ee=Ee.replace(R,"$1"),Re=Re.replace(de,Ee),Ce},getRegex:function(){return new RegExp(Re,Ae)}};return Ce}var h=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(Re,Ae,Ce){if(Re){var ue;try{ue=decodeURIComponent(_(Ce)).replace(h,"").toLowerCase()}catch{return null}if(ue.indexOf("javascript:")===0||ue.indexOf("vbscript:")===0||ue.indexOf("data:")===0)return null}Ae&&!s.test(Ce)&&(Ce=n(Ae,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var r={},S=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Re,Ae){r[" "+Re]||(S.test(Re)?r[" "+Re]=Re+"/":r[" "+Re]=f(Re,"/",!0)),Re=r[" "+Re];var Ce=Re.indexOf(":")===-1;return Ae.substring(0,2)==="//"?Ce?Ae:Re.replace(a,"$1")+Ae:Ae.charAt(0)==="/"?Ce?Ae:Re.replace(i,"$1")+Ae:Re+Ae}var o={exec:function(){}};function c(Re){for(var Ae=1,Ce,ue;Ae<arguments.length;Ae++){Ce=arguments[Ae];for(ue in Ce)Object.prototype.hasOwnProperty.call(Ce,ue)&&(Re[ue]=Ce[ue])}return Re}function m(Re,Ae){var Ce=Re.replace(/\|/g,function(Ee,ye,Oe){for(var Ge=!1,$e=ye;--$e>=0&&Oe[$e]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ue=Ce.split(/ \|/),de=0;if(ue[0].trim()||ue.shift(),ue[ue.length-1].trim()||ue.pop(),ue.length>Ae)ue.splice(Ae);else for(;ue.length<Ae;)ue.push("");for(;de<ue.length;de++)ue[de]=ue[de].trim().replace(/\\\|/g,"|");return ue}function f(Re,Ae,Ce){var ue=Re.length;if(ue===0)return"";for(var de=0;de<ue;){var Ee=Re.charAt(ue-de-1);if(Ee===Ae&&!Ce)de++;else if(Ee!==Ae&&Ce)de++;else break}return Re.substr(0,ue-de)}function w(Re,Ae){if(Re.indexOf(Ae[1])===-1)return-1;for(var Ce=Re.length,ue=0,de=0;de<Ce;de++)if(Re[de]==="\\")de++;else if(Re[de]===Ae[0])ue++;else if(Re[de]===Ae[1]&&(ue--,ue<0))return de;return-1}function T(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Re,Ae){if(Ae<1)return"";for(var Ce="";Ae>1;)Ae&1&&(Ce+=Re),Ae>>=1,Re+=Re;return Ce+Re}var O={escape:g,unescape:_,edit:p,cleanUrl:u,resolveUrl:n,noopTest:o,merge:c,splitCells:m,rtrim:f,findClosingBracket:w,checkSanitizeDeprecation:T,repeatString:L},E=C.exports.defaults,M=O.rtrim,U=O.splitCells,V=O.escape,z=O.findClosingBracket;function N(Re,Ae,Ce,ue){var de=Ae.href,Ee=Ae.title?V(Ae.title):null,ye=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){ue.state.inLink=!0;var Oe={type:"link",raw:Ce,href:de,title:Ee,text:ye,tokens:ue.inlineTokens(ye,[])};return ue.state.inLink=!1,Oe}else return{type:"image",raw:Ce,href:de,title:Ee,text:V(ye)}}function W(Re,Ae){var Ce=Re.match(/^(\s+)(?:```)/);if(Ce===null)return Ae;var ue=Ce[1];return Ae.split(`
`).map(function(de){var Ee=de.match(/^\s+/);if(Ee===null)return de;var ye=Ee[0];return ye.length>=ue.length?de.slice(ue.length):de}).join(`
`)}var B=function(){function Re(Ce){this.options=Ce||E}var Ae=Re.prototype;return Ae.space=function(ue){var de=this.rules.block.newline.exec(ue);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Ae.code=function(ue){var de=this.rules.block.code.exec(ue);if(de){var Ee=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?Ee:M(Ee,`
`)}}},Ae.fences=function(ue){var de=this.rules.block.fences.exec(ue);if(de){var Ee=de[0],ye=W(Ee,de[3]||"");return{type:"code",raw:Ee,lang:de[2]?de[2].trim():de[2],text:ye}}},Ae.heading=function(ue){var de=this.rules.block.heading.exec(ue);if(de){var Ee=de[2].trim();if(/#$/.test(Ee)){var ye=M(Ee,"#");(this.options.pedantic||!ye||/ $/.test(ye))&&(Ee=ye.trim())}var Oe={type:"heading",raw:de[0],depth:de[1].length,text:Ee,tokens:[]};return this.lexer.inline(Oe.text,Oe.tokens),Oe}},Ae.hr=function(ue){var de=this.rules.block.hr.exec(ue);if(de)return{type:"hr",raw:de[0]}},Ae.blockquote=function(ue){var de=this.rules.block.blockquote.exec(ue);if(de){var Ee=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(Ee,[]),text:Ee}}},Ae.list=function(ue){var de=this.rules.block.list.exec(ue);if(de){var Ee,ye,Oe,Ge,$e,Ye,at,ct,He,Se,_e=de[1].trim(),he=_e.length>1,Y={type:"list",raw:"",ordered:he,start:he?+_e.slice(0,-1):"",loose:!1,items:[]};_e=he?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=he?_e:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ue&&!(this.rules.block.hr.test(ue)||!(de=Ie.exec(ue)));){He=de[2].split(`
`),this.options.pedantic?(Ge=2,Se=He[0].trimLeft()):(Ge=de[2].search(/[^ ]/),Ge=de[1].length+(Ge>4?1:Ge),Se=He[0].slice(Ge-de[1].length)),Ye=!1,Ee=de[0],!He[0]&&/^ *$/.test(He[1])&&(Ee=de[1]+He.slice(0,2).join(`
`)+`
`,Y.loose=!0,He=[]);var Me=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<He.length;$e++){if(ct=He[$e],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Me.test(ct)){Ee=de[1]+He.slice(0,$e).join(`
`)+`
`;break}if(!Ye){ct.trim()||(Ye=!0),ct.search(/[^ ]/)>=Ge?Se+=`
`+ct.slice(Ge):Se+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Ge||!ct.trim()){Se+=`
`+ct.slice(Ge);continue}else{Ee=de[1]+He.slice(0,$e).join(`
`)+`
`;break}}Y.loose||(at?Y.loose=!0:/\n *\n *$/.test(Ee)&&(at=!0)),this.options.gfm&&(ye=/^\[[ xX]\] /.exec(Se),ye&&(Oe=ye[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Y.items.push({type:"list_item",raw:Ee,task:!!ye,checked:Oe,loose:!1,text:Se}),Y.raw+=Ee,ue=ue.slice(Ee.length)}Y.items[Y.items.length-1].raw=Ee.trimRight(),Y.items[Y.items.length-1].text=Se.trimRight(),Y.raw=Y.raw.trimRight();var Je=Y.items.length;for($e=0;$e<Je;$e++)this.lexer.state.top=!1,Y.items[$e].tokens=this.lexer.blockTokens(Y.items[$e].text,[]),Y.items[$e].tokens.some(function(Ke){return Ke.type==="space"})&&(Y.loose=!0,Y.items[$e].loose=!0);return Y}},Ae.html=function(ue){var de=this.rules.block.html.exec(ue);if(de){var Ee={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(Ee.type="paragraph",Ee.text=this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]),Ee.tokens=[],this.lexer.inline(Ee.text,Ee.tokens)),Ee}},Ae.def=function(ue){var de=this.rules.block.def.exec(ue);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var Ee=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Ee,raw:de[0],href:de[2],title:de[3]}}},Ae.table=function(ue){var de=this.rules.block.table.exec(ue);if(de){var Ee={type:"table",header:U(de[1]).map(function(at){return{text:at}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(Ee.header.length===Ee.align.length){Ee.raw=de[0];var ye=Ee.align.length,Oe,Ge,$e,Ye;for(Oe=0;Oe<ye;Oe++)/^ *-+: *$/.test(Ee.align[Oe])?Ee.align[Oe]="right":/^ *:-+: *$/.test(Ee.align[Oe])?Ee.align[Oe]="center":/^ *:-+ *$/.test(Ee.align[Oe])?Ee.align[Oe]="left":Ee.align[Oe]=null;for(ye=Ee.rows.length,Oe=0;Oe<ye;Oe++)Ee.rows[Oe]=U(Ee.rows[Oe],Ee.header.length).map(function(at){return{text:at}});for(ye=Ee.header.length,Ge=0;Ge<ye;Ge++)Ee.header[Ge].tokens=[],this.lexer.inlineTokens(Ee.header[Ge].text,Ee.header[Ge].tokens);for(ye=Ee.rows.length,Ge=0;Ge<ye;Ge++)for(Ye=Ee.rows[Ge],$e=0;$e<Ye.length;$e++)Ye[$e].tokens=[],this.lexer.inlineTokens(Ye[$e].text,Ye[$e].tokens);return Ee}}},Ae.lheading=function(ue){var de=this.rules.block.lheading.exec(ue);if(de){var Ee={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},Ae.paragraph=function(ue){var de=this.rules.block.paragraph.exec(ue);if(de){var Ee={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},Ae.text=function(ue){var de=this.rules.block.text.exec(ue);if(de){var Ee={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},Ae.escape=function(ue){var de=this.rules.inline.escape.exec(ue);if(de)return{type:"escape",raw:de[0],text:V(de[1])}},Ae.tag=function(ue){var de=this.rules.inline.tag.exec(ue);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]):de[0]}},Ae.link=function(ue){var de=this.rules.inline.link.exec(ue);if(de){var Ee=de[2].trim();if(!this.options.pedantic&&/^</.test(Ee)){if(!/>$/.test(Ee))return;var ye=M(Ee.slice(0,-1),"\\");if((Ee.length-ye.length)%2==0)return}else{var Oe=z(de[2],"()");if(Oe>-1){var Ge=de[0].indexOf("!")===0?5:4,$e=Ge+de[1].length+Oe;de[2]=de[2].substring(0,Oe),de[0]=de[0].substring(0,$e).trim(),de[3]=""}}var Ye=de[2],at="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);ct&&(Ye=ct[1],at=ct[3])}else at=de[3]?de[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(Ee)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),N(de,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:at&&at.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Ae.reflink=function(ue,de){var Ee;if((Ee=this.rules.inline.reflink.exec(ue))||(Ee=this.rules.inline.nolink.exec(ue))){var ye=(Ee[2]||Ee[1]).replace(/\s+/g," ");if(ye=de[ye.toLowerCase()],!ye||!ye.href){var Oe=Ee[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return N(Ee,ye,Ee[0],this.lexer)}},Ae.emStrong=function(ue,de,Ee){Ee===void 0&&(Ee="");var ye=this.rules.inline.emStrong.lDelim.exec(ue);if(!!ye&&!(ye[3]&&Ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=ye[1]||ye[2]||"";if(!Oe||Oe&&(Ee===""||this.rules.inline.punctuation.exec(Ee))){var Ge=ye[0].length-1,$e,Ye,at=Ge,ct=0,He=ye[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(He.lastIndex=0,de=de.slice(-1*ue.length+Ge);(ye=He.exec(de))!=null;)if($e=ye[1]||ye[2]||ye[3]||ye[4]||ye[5]||ye[6],!!$e){if(Ye=$e.length,ye[3]||ye[4]){at+=Ye;continue}else if((ye[5]||ye[6])&&Ge%3&&!((Ge+Ye)%3)){ct+=Ye;continue}if(at-=Ye,!(at>0)){if(Ye=Math.min(Ye,Ye+at+ct),Math.min(Ge,Ye)%2){var Se=ue.slice(1,Ge+ye.index+Ye);return{type:"em",raw:ue.slice(0,Ge+ye.index+Ye+1),text:Se,tokens:this.lexer.inlineTokens(Se,[])}}var _e=ue.slice(2,Ge+ye.index+Ye-1);return{type:"strong",raw:ue.slice(0,Ge+ye.index+Ye+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}}}}},Ae.codespan=function(ue){var de=this.rules.inline.code.exec(ue);if(de){var Ee=de[2].replace(/\n/g," "),ye=/[^ ]/.test(Ee),Oe=/^ /.test(Ee)&&/ $/.test(Ee);return ye&&Oe&&(Ee=Ee.substring(1,Ee.length-1)),Ee=V(Ee,!0),{type:"codespan",raw:de[0],text:Ee}}},Ae.br=function(ue){var de=this.rules.inline.br.exec(ue);if(de)return{type:"br",raw:de[0]}},Ae.del=function(ue){var de=this.rules.inline.del.exec(ue);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Ae.autolink=function(ue,de){var Ee=this.rules.inline.autolink.exec(ue);if(Ee){var ye,Oe;return Ee[2]==="@"?(ye=V(this.options.mangle?de(Ee[1]):Ee[1]),Oe="mailto:"+ye):(ye=V(Ee[1]),Oe=ye),{type:"link",raw:Ee[0],text:ye,href:Oe,tokens:[{type:"text",raw:ye,text:ye}]}}},Ae.url=function(ue,de){var Ee;if(Ee=this.rules.inline.url.exec(ue)){var ye,Oe;if(Ee[2]==="@")ye=V(this.options.mangle?de(Ee[0]):Ee[0]),Oe="mailto:"+ye;else{var Ge;do Ge=Ee[0],Ee[0]=this.rules.inline._backpedal.exec(Ee[0])[0];while(Ge!==Ee[0]);ye=V(Ee[0]),Ee[1]==="www."?Oe="http://"+ye:Oe=ye}return{type:"link",raw:Ee[0],text:ye,href:Oe,tokens:[{type:"text",raw:ye,text:ye}]}}},Ae.inlineText=function(ue,de){var Ee=this.rules.inline.text.exec(ue);if(Ee){var ye;return this.lexer.state.inRawBlock?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):V(Ee[0]):Ee[0]:ye=V(this.options.smartypants?de(Ee[0]):Ee[0]),{type:"text",raw:Ee[0],text:ye}}},Re}(),x=O.noopTest,$=O.edit,J=O.merge,ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=$(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=$(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=$(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=$(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=$(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=$(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=J({},ne),ne.gfm=J({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=$(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=J({},ne.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:$(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=$(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=$(ne._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=$(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=$(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=$(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=$(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=$(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=$(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=$(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=$(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=J({},re),re.pedantic=J({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=J({},re.normal,{escape:$(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=$(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=J({},re.gfm,{br:$(re.br).replace("{2,}","*").getRegex(),text:$(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Z={block:ne,inline:re},Q=B,oe=C.exports.defaults,fe=Z.block,pe=Z.inline,Te=O.repeatString;function xe(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Re){var Ae="",Ce,ue,de=Re.length;for(Ce=0;Ce<de;Ce++)ue=Re.charCodeAt(Ce),Math.random()>.5&&(ue="x"+ue.toString(16)),Ae+="&#"+ue+";";return Ae}var Qe=function(){function Re(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||oe,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ue={block:fe.normal,inline:pe.normal};this.options.pedantic?(ue.block=fe.pedantic,ue.inline=pe.pedantic):this.options.gfm&&(ue.block=fe.gfm,this.options.breaks?ue.inline=pe.breaks:ue.inline=pe.gfm),this.tokenizer.rules=ue}Re.lex=function(ue,de){var Ee=new Re(de);return Ee.lex(ue)},Re.lexInline=function(ue,de){var Ee=new Re(de);return Ee.inlineTokens(ue)};var Ae=Re.prototype;return Ae.lex=function(ue){ue=ue.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ue,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Ae.blockTokens=function(ue,de){var Ee=this;de===void 0&&(de=[]),this.options.pedantic&&(ue=ue.replace(/^ +$/gm,""));for(var ye,Oe,Ge,$e;ue;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(at){return(ye=at.call({lexer:Ee},ue,de))?(ue=ue.substring(ye.raw.length),de.push(ye),!0):!1}))){if(ye=this.tokenizer.space(ue)){ue=ue.substring(ye.raw.length),ye.type&&de.push(ye);continue}if(ye=this.tokenizer.code(ue)){ue=ue.substring(ye.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye);continue}if(ye=this.tokenizer.fences(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.heading(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.hr(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.blockquote(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.list(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.html(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.def(ue)){ue=ue.substring(ye.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[ye.tag]||(this.tokens.links[ye.tag]={href:ye.href,title:ye.title});continue}if(ye=this.tokenizer.table(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.lheading(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(Ge=ue,this.options.extensions&&this.options.extensions.startBlock&&function(){var at=1/0,ct=ue.slice(1),He=void 0;Ee.options.extensions.startBlock.forEach(function(Se){He=Se.call({lexer:this},ct),typeof He=="number"&&He>=0&&(at=Math.min(at,He))}),at<1/0&&at>=0&&(Ge=ue.substring(0,at+1))}(),this.state.top&&(ye=this.tokenizer.paragraph(Ge))){Oe=de[de.length-1],$e&&Oe.type==="paragraph"?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye),$e=Ge.length!==ue.length,ue=ue.substring(ye.raw.length);continue}if(ye=this.tokenizer.text(ue)){ue=ue.substring(ye.raw.length),Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye);continue}if(ue){var Ye="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,de},Ae.inline=function(ue,de){this.inlineQueue.push({src:ue,tokens:de})},Ae.inlineTokens=function(ue,de){var Ee=this;de===void 0&&(de=[]);var ye,Oe,Ge,$e=ue,Ye,at,ct;if(this.tokens.links){var He=Object.keys(this.tokens.links);if(He.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)He.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Ye.index)+"["+Te("a",Ye[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Ye.index)+"["+Te("a",Ye[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Ye.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ue;)if(at||(ct=""),at=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(ye=_e.call({lexer:Ee},ue,de))?(ue=ue.substring(ye.raw.length),de.push(ye),!0):!1}))){if(ye=this.tokenizer.escape(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.tag(ue)){ue=ue.substring(ye.raw.length),Oe=de[de.length-1],Oe&&ye.type==="text"&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ye=this.tokenizer.link(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.reflink(ue,this.tokens.links)){ue=ue.substring(ye.raw.length),Oe=de[de.length-1],Oe&&ye.type==="text"&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ye=this.tokenizer.emStrong(ue,$e,ct)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.codespan(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.br(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.del(ue)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.autolink(ue,qe)){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(ue,qe))){ue=ue.substring(ye.raw.length),de.push(ye);continue}if(Ge=ue,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=1/0,he=ue.slice(1),Y=void 0;Ee.options.extensions.startInline.forEach(function(Ie){Y=Ie.call({lexer:this},he),typeof Y=="number"&&Y>=0&&(_e=Math.min(_e,Y))}),_e<1/0&&_e>=0&&(Ge=ue.substring(0,_e+1))}(),ye=this.tokenizer.inlineText(Ge,xe)){ue=ue.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(ct=ye.raw.slice(-1)),at=!0,Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ue){var Se="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:fe,inline:pe}}}]),Re}(),q=C.exports.defaults,ie=O.cleanUrl,G=O.escape,X=function(){function Re(Ce){this.options=Ce||q}var Ae=Re.prototype;return Ae.code=function(ue,de,Ee){var ye=(de||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(ue,ye);Oe!=null&&Oe!==ue&&(Ee=!0,ue=Oe)}return ue=ue.replace(/\n$/,"")+`
`,ye?'<pre><code class="'+this.options.langPrefix+G(ye,!0)+'">'+(Ee?ue:G(ue,!0))+`</code></pre>
`:"<pre><code>"+(Ee?ue:G(ue,!0))+`</code></pre>
`},Ae.blockquote=function(ue){return`<blockquote>
`+ue+`</blockquote>
`},Ae.html=function(ue){return ue},Ae.heading=function(ue,de,Ee,ye){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+ye.slug(Ee)+'">'+ue+"</h"+de+`>
`:"<h"+de+">"+ue+"</h"+de+`>
`},Ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ae.list=function(ue,de,Ee){var ye=de?"ol":"ul",Oe=de&&Ee!==1?' start="'+Ee+'"':"";return"<"+ye+Oe+`>
`+ue+"</"+ye+`>
`},Ae.listitem=function(ue){return"<li>"+ue+`</li>
`},Ae.checkbox=function(ue){return"<input "+(ue?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ae.paragraph=function(ue){return"<p>"+ue+`</p>
`},Ae.table=function(ue,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ue+`</thead>
`+de+`</table>
`},Ae.tablerow=function(ue){return`<tr>
`+ue+`</tr>
`},Ae.tablecell=function(ue,de){var Ee=de.header?"th":"td",ye=de.align?"<"+Ee+' align="'+de.align+'">':"<"+Ee+">";return ye+ue+"</"+Ee+`>
`},Ae.strong=function(ue){return"<strong>"+ue+"</strong>"},Ae.em=function(ue){return"<em>"+ue+"</em>"},Ae.codespan=function(ue){return"<code>"+ue+"</code>"},Ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ae.del=function(ue){return"<del>"+ue+"</del>"},Ae.link=function(ue,de,Ee){if(ue=ie(this.options.sanitize,this.options.baseUrl,ue),ue===null)return Ee;var ye='<a href="'+G(ue)+'"';return de&&(ye+=' title="'+de+'"'),ye+=">"+Ee+"</a>",ye},Ae.image=function(ue,de,Ee){if(ue=ie(this.options.sanitize,this.options.baseUrl,ue),ue===null)return Ee;var ye='<img src="'+ue+'" alt="'+Ee+'"';return de&&(ye+=' title="'+de+'"'),ye+=this.options.xhtml?"/>":">",ye},Ae.text=function(ue){return ue},Re}(),ae=function(){function Re(){}var Ae=Re.prototype;return Ae.strong=function(ue){return ue},Ae.em=function(ue){return ue},Ae.codespan=function(ue){return ue},Ae.del=function(ue){return ue},Ae.html=function(ue){return ue},Ae.text=function(ue){return ue},Ae.link=function(ue,de,Ee){return""+Ee},Ae.image=function(ue,de,Ee){return""+Ee},Ae.br=function(){return""},Re}(),me=function(){function Re(){this.seen={}}var Ae=Re.prototype;return Ae.serialize=function(ue){return ue.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ae.getNextSafeSlug=function(ue,de){var Ee=ue,ye=0;if(this.seen.hasOwnProperty(Ee)){ye=this.seen[ue];do ye++,Ee=ue+"-"+ye;while(this.seen.hasOwnProperty(Ee))}return de||(this.seen[ue]=ye,this.seen[Ee]=0),Ee},Ae.slug=function(ue,de){de===void 0&&(de={});var Ee=this.serialize(ue);return this.getNextSafeSlug(Ee,de.dryrun)},Re}(),De=X,Be=ae,Xe=me,tt=C.exports.defaults,rt=O.unescape,st=function(){function Re(Ce){this.options=Ce||tt,this.options.renderer=this.options.renderer||new De,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Be,this.slugger=new Xe}Re.parse=function(ue,de){var Ee=new Re(de);return Ee.parse(ue)},Re.parseInline=function(ue,de){var Ee=new Re(de);return Ee.parseInline(ue)};var Ae=Re.prototype;return Ae.parse=function(ue,de){de===void 0&&(de=!0);var Ee="",ye,Oe,Ge,$e,Ye,at,ct,He,Se,_e,he,Y,Ie,Me,Je,Ke,mt,St,yt,dt=ue.length;for(ye=0;ye<dt;ye++){if(_e=ue[ye],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(yt=this.options.extensions.renderers[_e.type].call({parser:this},_e),yt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){Ee+=yt||"";continue}switch(_e.type){case"space":continue;case"hr":{Ee+=this.renderer.hr();continue}case"heading":{Ee+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,rt(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{Ee+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for(He="",ct="",$e=_e.header.length,Oe=0;Oe<$e;Oe++)ct+=this.renderer.tablecell(this.parseInline(_e.header[Oe].tokens),{header:!0,align:_e.align[Oe]});for(He+=this.renderer.tablerow(ct),Se="",$e=_e.rows.length,Oe=0;Oe<$e;Oe++){for(at=_e.rows[Oe],ct="",Ye=at.length,Ge=0;Ge<Ye;Ge++)ct+=this.renderer.tablecell(this.parseInline(at[Ge].tokens),{header:!1,align:_e.align[Ge]});Se+=this.renderer.tablerow(ct)}Ee+=this.renderer.table(He,Se);continue}case"blockquote":{Se=this.parse(_e.tokens),Ee+=this.renderer.blockquote(Se);continue}case"list":{for(he=_e.ordered,Y=_e.start,Ie=_e.loose,$e=_e.items.length,Se="",Oe=0;Oe<$e;Oe++)Je=_e.items[Oe],Ke=Je.checked,mt=Je.task,Me="",Je.task&&(St=this.renderer.checkbox(Ke),Ie?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=St+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=St+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:St}):Me+=St),Me+=this.parse(Je.tokens,Ie),Se+=this.renderer.listitem(Me,mt,Ke);Ee+=this.renderer.list(Se,he,Y);continue}case"html":{Ee+=this.renderer.html(_e.text);continue}case"paragraph":{Ee+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(Se=_e.tokens?this.parseInline(_e.tokens):_e.text;ye+1<dt&&ue[ye+1].type==="text";)_e=ue[++ye],Se+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);Ee+=de?this.renderer.paragraph(Se):Se;continue}default:{var vt='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return Ee},Ae.parseInline=function(ue,de){de=de||this.renderer;var Ee="",ye,Oe,Ge,$e=ue.length;for(ye=0;ye<$e;ye++){if(Oe=ue[ye],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(Ge=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){Ee+=Ge||"";continue}switch(Oe.type){case"escape":{Ee+=de.text(Oe.text);break}case"html":{Ee+=de.html(Oe.text);break}case"link":{Ee+=de.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,de));break}case"image":{Ee+=de.image(Oe.href,Oe.title,Oe.text);break}case"strong":{Ee+=de.strong(this.parseInline(Oe.tokens,de));break}case"em":{Ee+=de.em(this.parseInline(Oe.tokens,de));break}case"codespan":{Ee+=de.codespan(Oe.text);break}case"br":{Ee+=de.br();break}case"del":{Ee+=de.del(this.parseInline(Oe.tokens,de));break}case"text":{Ee+=de.text(Oe.text);break}default:{var Ye='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return Ee},Re}(),et=Qe,nt=st,gt=B,It=X,Ne=ae,Dt=me,te=O.merge,se=O.checkSanitizeDeprecation,K=O.escape,we=C.exports.getDefaults,ke=C.exports.changeDefaults,Ve=C.exports.defaults;function We(Re,Ae,Ce){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ae=="function"&&(Ce=Ae,Ae=null),Ae=te({},We.defaults,Ae||{}),se(Ae),Ce){var ue=Ae.highlight,de;try{de=et.lex(Re,Ae)}catch(Ge){return Ce(Ge)}var Ee=function($e){var Ye;if(!$e)try{Ae.walkTokens&&We.walkTokens(de,Ae.walkTokens),Ye=nt.parse(de,Ae)}catch(at){$e=at}return Ae.highlight=ue,$e?Ce($e):Ce(null,Ye)};if(!ue||ue.length<3||(delete Ae.highlight,!de.length))return Ee();var ye=0;We.walkTokens(de,function(Ge){Ge.type==="code"&&(ye++,setTimeout(function(){ue(Ge.text,Ge.lang,function($e,Ye){if($e)return Ee($e);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),ye--,ye===0&&Ee()})},0))}),ye===0&&Ee();return}try{var Oe=et.lex(Re,Ae);return Ae.walkTokens&&We.walkTokens(Oe,Ae.walkTokens),nt.parse(Oe,Ae)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+K(Ge.message+"",!0)+"</pre>";throw Ge}}We.options=We.setOptions=function(Re){return te(We.defaults,Re),ke(We.defaults),We},We.getDefaults=we,We.defaults=Ve,We.use=function(){for(var Re=this,Ae=arguments.length,Ce=new Array(Ae),ue=0;ue<Ae;ue++)Ce[ue]=arguments[ue];var de=te.apply(void 0,[{}].concat(Ce)),Ee=We.defaults.extensions||{renderers:{},childTokens:{}},ye;Ce.forEach(function(Oe){if(Oe.extensions&&(ye=!0,Oe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Ye=Ee.renderers?Ee.renderers[$e.name]:null;Ye?Ee.renderers[$e.name]=function(){for(var at=arguments.length,ct=new Array(at),He=0;He<at;He++)ct[He]=arguments[He];var Se=$e.renderer.apply(this,ct);return Se===!1&&(Se=Ye.apply(this,ct)),Se}:Ee.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Ee[$e.level]?Ee[$e.level].unshift($e.tokenizer):Ee[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?Ee.startBlock?Ee.startBlock.push($e.start):Ee.startBlock=[$e.start]:$e.level==="inline"&&(Ee.startInline?Ee.startInline.push($e.start):Ee.startInline=[$e.start]))}$e.childTokens&&(Ee.childTokens[$e.name]=$e.childTokens)})),Oe.renderer&&function(){var $e=We.defaults.renderer||new It,Ye=function(He){var Se=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var Ie=Oe.renderer[He].apply($e,he);return Ie===!1&&(Ie=Se.apply($e,he)),Ie}};for(var at in Oe.renderer)Ye(at);de.renderer=$e}(),Oe.tokenizer&&function(){var $e=We.defaults.tokenizer||new gt,Ye=function(He){var Se=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var Ie=Oe.tokenizer[He].apply($e,he);return Ie===!1&&(Ie=Se.apply($e,he)),Ie}};for(var at in Oe.tokenizer)Ye(at);de.tokenizer=$e}(),Oe.walkTokens){var Ge=We.defaults.walkTokens;de.walkTokens=function($e){Oe.walkTokens.call(Re,$e),Ge&&Ge($e)}}ye&&(de.extensions=Ee),We.setOptions(de)})},We.walkTokens=function(Re,Ae){for(var Ce=function(){var ye=de.value;switch(Ae(ye),ye.type){case"table":{for(var Oe=I(ye.header),Ge;!(Ge=Oe()).done;){var $e=Ge.value;We.walkTokens($e.tokens,Ae)}for(var Ye=I(ye.rows),at;!(at=Ye()).done;)for(var ct=at.value,He=I(ct),Se;!(Se=He()).done;){var _e=Se.value;We.walkTokens(_e.tokens,Ae)}break}case"list":{We.walkTokens(ye.items,Ae);break}default:We.defaults.extensions&&We.defaults.extensions.childTokens&&We.defaults.extensions.childTokens[ye.type]?We.defaults.extensions.childTokens[ye.type].forEach(function(he){We.walkTokens(ye[he],Ae)}):ye.tokens&&We.walkTokens(ye.tokens,Ae)}},ue=I(Re),de;!(de=ue()).done;)Ce()},We.parseInline=function(Re,Ae){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ae=te({},We.defaults,Ae||{}),se(Ae);try{var Ce=et.lexInline(Re,Ae);return Ae.walkTokens&&We.walkTokens(Ce,Ae.walkTokens),nt.parseInline(Ce,Ae)}catch(ue){if(ue.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+K(ue.message+"",!0)+"</pre>";throw ue}},We.Parser=nt,We.parser=nt.parse,We.Renderer=It,We.TextRenderer=Ne,We.Lexer=et,We.lexer=et.lex,We.Tokenizer=gt,We.Slugger=Dt,We.parse=We;var lt=We;return lt}),define(ve[95],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(k,D,P){return Math.min(Math.max(k,D),P)}e.clamp=d;function t(k,D){return(D+k%D)%D}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class C{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=C;class A{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const P=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function ee(I){const C=[];typeof I=="number"&&C.push("code/timeOrigin",I);function A(D){C.push(D,Date.now())}function k(){const D=[];for(let P=0;P<C.length;P+=2)D.push({name:C[P],startTime:C[P+1]});return D}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))C.push({name:A.name,startTime:Math.round(I+A.startTime)});return C}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function d(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=d(t))}(),define(ve[11],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const d="en";let t=!1,I=!1,C=!1,A=!1,k=!1,D=!1,P=!1,F=!1,y,l=d,b,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const _=typeof v?.versions?.electron=="string",R=_&&v?.type==="renderer";if(e.isElectronSandboxed=R&&v?.sandboxed,typeof navigator=="object"&&!R)g=navigator.userAgent,t=g.indexOf("Windows")>=0,I=g.indexOf("Macintosh")>=0,F=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=g.indexOf("Linux")>=0,D=!0,y=navigator.language,l=y;else if(typeof v=="object"){t=v.platform==="win32",I=v.platform==="darwin",C=v.platform==="linux",A=C&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,P=_,y=d,l=d;const n=v.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),c=o.availableLanguages["*"];y=o.locale,l=c||d,b=o._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var p;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function h(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let s=0;I?s=1:t?s=3:C&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=C,e.isLinuxSnap=A,e.isNative=k,e.isElectron=P,e.isWeb=D,e.isIOS=F,e.platform=s,e.userAgent=g,e.language=l;var u;(function(n){function o(){return e.language}n.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function m(){return e.language==="en"}n.isDefault=m})(u=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=b,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let m=0,f=n.length;m<f;m++){const w=n[m];if(w.id===c.data.vscodeScheduleAsyncWork){n.splice(m,1),w.callback();return}}});let o=0;return c=>{const m=++o;n.push({id:m,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:m},"*")}}return n=>setTimeout(n)})();var r;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||F?2:t?1:3;let S=!0,a=!1;function i(){if(!a){a=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,S=new Uint16Array(n.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[40],be([0,1,11]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof d.globals.vscode!="undefined"&&typeof d.globals.vscode.process!="undefined"){const I=d.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return d.isWindows?"win32":d.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[9],be([0,1,40]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,C=90,A=122,k=46,D=47,P=92,F=58,y=63;class l extends Error{constructor(s,u,r){let S;typeof u=="string"&&u.indexOf("not ")===0?(S="must not be",u=u.replace(/^not /,"")):S="must be";const a=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${a} ${S} of type ${u}`;i+=`. Received type ${typeof r}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function b(h,s){if(typeof h!="string")throw new l(s,"string",h)}function g(h){return h===D||h===P}function v(h){return h===D}function _(h){return h>=t&&h<=C||h>=I&&h<=A}function R(h,s,u,r){let S="",a=0,i=-1,n=0,o=0;for(let c=0;c<=h.length;++c){if(c<h.length)o=h.charCodeAt(c);else{if(r(o))break;o=D}if(r(o)){if(!(i===c-1||n===1))if(n===2){if(S.length<2||a!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const m=S.lastIndexOf(u);m===-1?(S="",a=0):(S=S.slice(0,m),a=S.length-1-S.lastIndexOf(u)),i=c,n=0;continue}else if(S.length!==0){S="",a=0,i=c,n=0;continue}}s&&(S+=S.length>0?`${u}..`:"..",a=2)}else S.length>0?S+=`${u}${h.slice(i+1,c)}`:S=h.slice(i+1,c),a=c-i-1;i=c,n=0}else o===k&&n!==-1?++n:n=-1}return S}function p(h,s){if(s===null||typeof s!="object")throw new l("pathObject","Object",s);const u=s.dir||s.root,r=s.base||`${s.name||""}${s.ext||""}`;return u?u===s.root?`${u}${r}`:`${u}${h}${r}`:r}e.win32={resolve(...h){let s="",u="",r=!1;for(let S=h.length-1;S>=-1;S--){let a;if(S>=0){if(a=h[S],b(a,"path"),a.length===0)continue}else s.length===0?a=d.cwd():(a=d.env[`=${s}`]||d.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===P)&&(a=`${s}\\`));const i=a.length;let n=0,o="",c=!1;const m=a.charCodeAt(0);if(i===1)g(m)&&(n=1,c=!0);else if(g(m))if(c=!0,g(a.charCodeAt(1))){let f=2,w=f;for(;f<i&&!g(a.charCodeAt(f));)f++;if(f<i&&f!==w){const T=a.slice(w,f);for(w=f;f<i&&g(a.charCodeAt(f));)f++;if(f<i&&f!==w){for(w=f;f<i&&!g(a.charCodeAt(f));)f++;(f===i||f!==w)&&(o=`\\\\${T}\\${a.slice(w,f)}`,n=f)}}}else n=1;else _(m)&&a.charCodeAt(1)===F&&(o=a.slice(0,2),n=2,i>2&&g(a.charCodeAt(2))&&(c=!0,n=3));if(o.length>0)if(s.length>0){if(o.toLowerCase()!==s.toLowerCase())continue}else s=o;if(r){if(s.length>0)break}else if(u=`${a.slice(n)}\\${u}`,r=c,c&&s.length>0)break}return u=R(u,!r,"\\",g),r?`${s}\\${u}`:`${s}${u}`||"."},normalize(h){b(h,"path");const s=h.length;if(s===0)return".";let u=0,r,S=!1;const a=h.charCodeAt(0);if(s===1)return v(a)?"\\":h;if(g(a))if(S=!0,g(h.charCodeAt(1))){let n=2,o=n;for(;n<s&&!g(h.charCodeAt(n));)n++;if(n<s&&n!==o){const c=h.slice(o,n);for(o=n;n<s&&g(h.charCodeAt(n));)n++;if(n<s&&n!==o){for(o=n;n<s&&!g(h.charCodeAt(n));)n++;if(n===s)return`\\\\${c}\\${h.slice(o)}\\`;n!==o&&(r=`\\\\${c}\\${h.slice(o,n)}`,u=n)}}}else u=1;else _(a)&&h.charCodeAt(1)===F&&(r=h.slice(0,2),u=2,s>2&&g(h.charCodeAt(2))&&(S=!0,u=3));let i=u<s?R(h.slice(u),!S,"\\",g):"";return i.length===0&&!S&&(i="."),i.length>0&&g(h.charCodeAt(s-1))&&(i+="\\"),r===void 0?S?`\\${i}`:i:S?`${r}\\${i}`:`${r}${i}`},isAbsolute(h){b(h,"path");const s=h.length;if(s===0)return!1;const u=h.charCodeAt(0);return g(u)||s>2&&_(u)&&h.charCodeAt(1)===F&&g(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let s,u;for(let a=0;a<h.length;++a){const i=h[a];b(i,"path"),i.length>0&&(s===void 0?s=u=i:s+=`\\${i}`)}if(s===void 0)return".";let r=!0,S=0;if(typeof u=="string"&&g(u.charCodeAt(0))){++S;const a=u.length;a>1&&g(u.charCodeAt(1))&&(++S,a>2&&(g(u.charCodeAt(2))?++S:r=!1))}if(r){for(;S<s.length&&g(s.charCodeAt(S));)S++;S>=2&&(s=`\\${s.slice(S)}`)}return e.win32.normalize(s)},relative(h,s){if(b(h,"from"),b(s,"to"),h===s)return"";const u=e.win32.resolve(h),r=e.win32.resolve(s);if(u===r||(h=u.toLowerCase(),s=r.toLowerCase(),h===s))return"";let S=0;for(;S<h.length&&h.charCodeAt(S)===P;)S++;let a=h.length;for(;a-1>S&&h.charCodeAt(a-1)===P;)a--;const i=a-S;let n=0;for(;n<s.length&&s.charCodeAt(n)===P;)n++;let o=s.length;for(;o-1>n&&s.charCodeAt(o-1)===P;)o--;const c=o-n,m=i<c?i:c;let f=-1,w=0;for(;w<m;w++){const L=h.charCodeAt(S+w);if(L!==s.charCodeAt(n+w))break;L===P&&(f=w)}if(w!==m){if(f===-1)return r}else{if(c>m){if(s.charCodeAt(n+w)===P)return r.slice(n+w+1);if(w===2)return r.slice(n+w)}i>m&&(h.charCodeAt(S+w)===P?f=w:w===2&&(f=3)),f===-1&&(f=0)}let T="";for(w=S+f+1;w<=a;++w)(w===a||h.charCodeAt(w)===P)&&(T+=T.length===0?"..":"\\..");return n+=f,T.length>0?`${T}${r.slice(n,o)}`:(r.charCodeAt(n)===P&&++n,r.slice(n,o))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const s=e.win32.resolve(h);if(s.length<=2)return h;if(s.charCodeAt(0)===P){if(s.charCodeAt(1)===P){const u=s.charCodeAt(2);if(u!==y&&u!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(_(s.charCodeAt(0))&&s.charCodeAt(1)===F&&s.charCodeAt(2)===P)return`\\\\?\\${s}`;return h},dirname(h){b(h,"path");const s=h.length;if(s===0)return".";let u=-1,r=0;const S=h.charCodeAt(0);if(s===1)return g(S)?h:".";if(g(S)){if(u=r=1,g(h.charCodeAt(1))){let n=2,o=n;for(;n<s&&!g(h.charCodeAt(n));)n++;if(n<s&&n!==o){for(o=n;n<s&&g(h.charCodeAt(n));)n++;if(n<s&&n!==o){for(o=n;n<s&&!g(h.charCodeAt(n));)n++;if(n===s)return h;n!==o&&(u=r=n+1)}}}}else _(S)&&h.charCodeAt(1)===F&&(u=s>2&&g(h.charCodeAt(2))?3:2,r=u);let a=-1,i=!0;for(let n=s-1;n>=r;--n)if(g(h.charCodeAt(n))){if(!i){a=n;break}}else i=!1;if(a===-1){if(u===-1)return".";a=u}return h.slice(0,a)},basename(h,s){s!==void 0&&b(s,"ext"),b(h,"path");let u=0,r=-1,S=!0,a;if(h.length>=2&&_(h.charCodeAt(0))&&h.charCodeAt(1)===F&&(u=2),s!==void 0&&s.length>0&&s.length<=h.length){if(s===h)return"";let i=s.length-1,n=-1;for(a=h.length-1;a>=u;--a){const o=h.charCodeAt(a);if(g(o)){if(!S){u=a+1;break}}else n===-1&&(S=!1,n=a+1),i>=0&&(o===s.charCodeAt(i)?--i==-1&&(r=a):(i=-1,r=n))}return u===r?r=n:r===-1&&(r=h.length),h.slice(u,r)}for(a=h.length-1;a>=u;--a)if(g(h.charCodeAt(a))){if(!S){u=a+1;break}}else r===-1&&(S=!1,r=a+1);return r===-1?"":h.slice(u,r)},extname(h){b(h,"path");let s=0,u=-1,r=0,S=-1,a=!0,i=0;h.length>=2&&h.charCodeAt(1)===F&&_(h.charCodeAt(0))&&(s=r=2);for(let n=h.length-1;n>=s;--n){const o=h.charCodeAt(n);if(g(o)){if(!a){r=n+1;break}continue}S===-1&&(a=!1,S=n+1),o===k?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||S===-1||i===0||i===1&&u===S-1&&u===r+1?"":h.slice(u,S)},format:p.bind(null,"\\"),parse(h){b(h,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return s;const u=h.length;let r=0,S=h.charCodeAt(0);if(u===1)return g(S)?(s.root=s.dir=h,s):(s.base=s.name=h,s);if(g(S)){if(r=1,g(h.charCodeAt(1))){let f=2,w=f;for(;f<u&&!g(h.charCodeAt(f));)f++;if(f<u&&f!==w){for(w=f;f<u&&g(h.charCodeAt(f));)f++;if(f<u&&f!==w){for(w=f;f<u&&!g(h.charCodeAt(f));)f++;f===u?r=f:f!==w&&(r=f+1)}}}}else if(_(S)&&h.charCodeAt(1)===F){if(u<=2)return s.root=s.dir=h,s;if(r=2,g(h.charCodeAt(2))){if(u===3)return s.root=s.dir=h,s;r=3}}r>0&&(s.root=h.slice(0,r));let a=-1,i=r,n=-1,o=!0,c=h.length-1,m=0;for(;c>=r;--c){if(S=h.charCodeAt(c),g(S)){if(!o){i=c+1;break}continue}n===-1&&(o=!1,n=c+1),S===k?a===-1?a=c:m!==1&&(m=1):a!==-1&&(m=-1)}return n!==-1&&(a===-1||m===0||m===1&&a===n-1&&a===i+1?s.base=s.name=h.slice(i,n):(s.name=h.slice(i,a),s.base=h.slice(i,n),s.ext=h.slice(a,n))),i>0&&i!==r?s.dir=h.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let s="",u=!1;for(let r=h.length-1;r>=-1&&!u;r--){const S=r>=0?h[r]:d.cwd();b(S,"path"),S.length!==0&&(s=`${S}/${s}`,u=S.charCodeAt(0)===D)}return s=R(s,!u,"/",v),u?`/${s}`:s.length>0?s:"."},normalize(h){if(b(h,"path"),h.length===0)return".";const s=h.charCodeAt(0)===D,u=h.charCodeAt(h.length-1)===D;return h=R(h,!s,"/",v),h.length===0?s?"/":u?"./":".":(u&&(h+="/"),s?`/${h}`:h)},isAbsolute(h){return b(h,"path"),h.length>0&&h.charCodeAt(0)===D},join(...h){if(h.length===0)return".";let s;for(let u=0;u<h.length;++u){const r=h[u];b(r,"path"),r.length>0&&(s===void 0?s=r:s+=`/${r}`)}return s===void 0?".":e.posix.normalize(s)},relative(h,s){if(b(h,"from"),b(s,"to"),h===s||(h=e.posix.resolve(h),s=e.posix.resolve(s),h===s))return"";const u=1,r=h.length,S=r-u,a=1,i=s.length-a,n=S<i?S:i;let o=-1,c=0;for(;c<n;c++){const f=h.charCodeAt(u+c);if(f!==s.charCodeAt(a+c))break;f===D&&(o=c)}if(c===n)if(i>n){if(s.charCodeAt(a+c)===D)return s.slice(a+c+1);if(c===0)return s.slice(a+c)}else S>n&&(h.charCodeAt(u+c)===D?o=c:c===0&&(o=0));let m="";for(c=u+o+1;c<=r;++c)(c===r||h.charCodeAt(c)===D)&&(m+=m.length===0?"..":"/..");return`${m}${s.slice(a+o)}`},toNamespacedPath(h){return h},dirname(h){if(b(h,"path"),h.length===0)return".";const s=h.charCodeAt(0)===D;let u=-1,r=!0;for(let S=h.length-1;S>=1;--S)if(h.charCodeAt(S)===D){if(!r){u=S;break}}else r=!1;return u===-1?s?"/":".":s&&u===1?"//":h.slice(0,u)},basename(h,s){s!==void 0&&b(s,"ext"),b(h,"path");let u=0,r=-1,S=!0,a;if(s!==void 0&&s.length>0&&s.length<=h.length){if(s===h)return"";let i=s.length-1,n=-1;for(a=h.length-1;a>=0;--a){const o=h.charCodeAt(a);if(o===D){if(!S){u=a+1;break}}else n===-1&&(S=!1,n=a+1),i>=0&&(o===s.charCodeAt(i)?--i==-1&&(r=a):(i=-1,r=n))}return u===r?r=n:r===-1&&(r=h.length),h.slice(u,r)}for(a=h.length-1;a>=0;--a)if(h.charCodeAt(a)===D){if(!S){u=a+1;break}}else r===-1&&(S=!1,r=a+1);return r===-1?"":h.slice(u,r)},extname(h){b(h,"path");let s=-1,u=0,r=-1,S=!0,a=0;for(let i=h.length-1;i>=0;--i){const n=h.charCodeAt(i);if(n===D){if(!S){u=i+1;break}continue}r===-1&&(S=!1,r=i+1),n===k?s===-1?s=i:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||r===-1||a===0||a===1&&s===r-1&&s===u+1?"":h.slice(s,r)},format:p.bind(null,"/"),parse(h){b(h,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return s;const u=h.charCodeAt(0)===D;let r;u?(s.root="/",r=1):r=0;let S=-1,a=0,i=-1,n=!0,o=h.length-1,c=0;for(;o>=r;--o){const m=h.charCodeAt(o);if(m===D){if(!n){a=o+1;break}continue}i===-1&&(n=!1,i=o+1),m===k?S===-1?S=o:c!==1&&(c=1):S!==-1&&(c=-1)}if(i!==-1){const m=a===0&&u?1:a;S===-1||c===0||c===1&&S===i-1&&S===a+1?s.base=s.name=h.slice(m,i):(s.name=h.slice(m,S),s.base=h.slice(m,i),s.ext=h.slice(S,i))}return a>0?s.dir=h.slice(0,a-1):u&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=d.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d.platform==="win32"?e.win32.join:e.posix.join,e.resolve=d.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=d.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=d.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=d.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=d.platform==="win32"?e.win32.extname:e.posix.extname,e.format=d.platform==="win32"?e.win32.format:e.posix.format,e.parse=d.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=d.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=d.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[96],be([0,1,9]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(y){y.text="text/plain",y.binary="application/octet-stream",y.unknown="application/unknown",y.markdown="text/markdown",y.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(y){const l=(0,d.extname)(y),b=I[l.toLowerCase()];return b!==void 0?b:k(y)}e.getMediaOrTextMime=A;function k(y){const l=(0,d.extname)(y);return C[l.toLowerCase()]}e.getMediaMime=k;function D(y){for(const l in C)if(C[l]===y)return l}e.getExtensionForMimeType=D;const P=/^(.+)\/(.+?)(;.+)?$/;function F(y,l){const b=P.exec(y);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:l?void 0:y}e.normalizeMimeType=F}),define(ve[97],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var d;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(d=e.Source||(e.Source={}));var t;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(C,...A){const k=A.reduce((F,y)=>(F[y]=!0,F),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(F=>!k[F]).forEach(F=>{for(let y=0;y<D.length;y++)if(F.search(D[y])!==-1){delete C[F];break}})}e.sanitizeProcessEnvironment=I}),define(ve[46],be([0,1,11]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=d.globals.performance&&typeof d.globals.performance.now=="function";class I{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new I(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?d.globals.performance.now():Date.now()}}e.StopWatch=I}),define(ve[3],be([0,1,16,75,6,94,46]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(s){s.None=()=>I.Disposable.None;function u(W){return(B,x=null,$)=>{let J=!1,ne;return ne=W(re=>{if(!J)return ne?ne.dispose():J=!0,B.call(x,re)},null,$),J&&ne.dispose(),ne}}s.once=u;function r(W,B){return c((x,$=null,J)=>W(ne=>x.call($,B(ne)),null,J))}s.map=r;function S(W,B){return c((x,$=null,J)=>W(ne=>{B(ne),x.call($,ne)},null,J))}s.forEach=S;function a(W,B){return c((x,$=null,J)=>W(ne=>B(ne)&&x.call($,ne),null,J))}s.filter=a;function i(W){return W}s.signal=i;function n(...W){return(B,x=null,$)=>(0,I.combinedDisposable)(...W.map(J=>J(ne=>B.call(x,ne),null,$)))}s.any=n;function o(W,B,x){let $=x;return r(W,J=>($=B($,J),$))}s.reduce=o;function c(W){let B;const x=new l({onFirstListenerAdd(){B=W(x.fire,x)},onLastListenerRemove(){B.dispose()}});return x.event}function m(W,B,x,$=100,J=!1){let ne,re,Z=0;return W(Q=>{Z++,ne=x(ne,Q),J&&!re&&(B(ne),ne=void 0),clearTimeout(re),re=setTimeout(()=>{const oe=ne;ne=void 0,re=void 0,(!J||Z>1)&&B(oe),Z=0},$)})}s.debouncedListener=m;function f(W,B,x=100,$=!1,J){let ne,re,Z,Q=0;const oe=new l({leakWarningThreshold:J,onFirstListenerAdd(){ne=W(fe=>{Q++,re=B(re,fe),$&&!Z&&(oe.fire(re),re=void 0),clearTimeout(Z),Z=setTimeout(()=>{const pe=re;re=void 0,Z=void 0,(!$||Q>1)&&oe.fire(pe),Q=0},x)})},onLastListenerRemove(){ne.dispose()}});return oe.event}s.debounce=f;function w(W,B=(x,$)=>x===$){let x=!0,$;return a(W,J=>{const ne=x||!B(J,$);return x=!1,$=J,ne})}s.latch=w;function T(W,B){return[s.filter(W,B),s.filter(W,x=>!B(x))]}s.split=T;function L(W,B=!1,x=[]){let $=x.slice(),J=W(Z=>{$?$.push(Z):re.fire(Z)});const ne=()=>{$&&$.forEach(Z=>re.fire(Z)),$=null},re=new l({onFirstListenerAdd(){J||(J=W(Z=>re.fire(Z)))},onFirstListenerDidAdd(){$&&(B?setTimeout(ne):ne())},onLastListenerRemove(){J&&J.dispose(),J=null}});return re.event}s.buffer=L;class O{constructor(B){this.event=B}map(B){return new O(r(this.event,B))}forEach(B){return new O(S(this.event,B))}filter(B){return new O(a(this.event,B))}reduce(B,x){return new O(o(this.event,B,x))}latch(){return new O(w(this.event))}debounce(B,x=100,$=!1,J){return new O(f(this.event,B,x,$,J))}on(B,x,$){return this.event(B,x,$)}once(B,x,$){return u(this.event)(B,x,$)}}function E(W){return new O(W)}s.chain=E;function M(W,B,x=$=>$){const $=(...Z)=>re.fire(x(...Z)),J=()=>W.on(B,$),ne=()=>W.removeListener(B,$),re=new l({onFirstListenerAdd:J,onLastListenerRemove:ne});return re.event}s.fromNodeEventEmitter=M;function U(W,B,x=$=>$){const $=(...Z)=>re.fire(x(...Z)),J=()=>W.addEventListener(B,$),ne=()=>W.removeEventListener(B,$),re=new l({onFirstListenerAdd:J,onLastListenerRemove:ne});return re.event}s.fromDOMEventEmitter=U;function V(W){return new Promise(B=>u(W)(B))}s.toPromise=V;function z(W,B){return B(void 0),W(x=>B(x))}s.runAndSubscribe=z;function N(W,B){let x=null;function $(ne){x?.dispose(),x=new I.DisposableStore,B(ne,x)}$(void 0);const J=W(ne=>$(ne));return(0,I.toDisposable)(()=>{J.dispose(),x?.dispose()})}s.runAndSubscribeWithStore=N})(k=e.Event||(e.Event={}));class D{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${D._idPool++}`}start(u){this._stopWatch=new A.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function F(s){const u=P;return P=s,{dispose(){P=u}}}e.setGlobalLeakWarningThreshold=F;class y{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=P;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(S)||0;if(this._stacks.set(S,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let i,n=0;for(const[o,c]of this._stacks)(!i||n<c)&&(i=o,n=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${n}):`),console.warn(i)}return()=>{const i=this._stacks.get(S)||0;this._stacks.set(S,i-1)}}}class l{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=P>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,S)=>{this._listeners||(this._listeners=new C.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(r?[u,r]:u);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const n=this._leakageMon?.check(this._listeners.size),o=(0,I.toDisposable)(()=>{n&&n(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof I.DisposableStore?S.add(o):Array.isArray(S)&&S.push(o),o}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,S]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,S):r[0].call(r[1],S)}catch(a){(0,d.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class b extends l{async fireAsync(u,r,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[a,i]=this._asyncDeliveryQueue.shift(),n=[],o={...i,token:r,waitUntil:c=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");S&&(c=S(c,typeof a=="function"?a:a[0])),n.push(c)}};try{typeof a=="function"?a.call(void 0,o):a[0].call(a[1],o)}catch(c){(0,d.onUnexpectedError)(c);continue}Object.freeze(n),await Promise.allSettled(n).then(c=>{for(const m of c)m.status==="rejected"&&(0,d.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=b;class g extends l{constructor(u){super(u);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=g;class v extends g{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=v;class _ extends l{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=_;class R{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const S=()=>{this.hasListeners&&this.unhook(r);const a=this.events.indexOf(r);this.events.splice(a,1)};return(0,I.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=R;class p{constructor(){this.buffers=[]}wrapEvent(u){return(r,S,a)=>u(i=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>r.call(S,i)):r.call(S,i)},void 0,a)}bufferEvents(u){const r=[];this.buffers.push(r);const S=u();return this.buffers.pop(),r.forEach(a=>a()),S}}e.EventBufferer=p;class h{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=I.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(ve[21],be([0,1,3]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,D){const P=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(P)}}});var I;(function(k){function D(P){return P===k.None||P===k.Cancelled||P instanceof C?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new d.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=A}),define(ve[142],be([0,1,21]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new d.CancellationTokenSource,k=this.task(A.token);return this.result={promise:k,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=t;class I{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const k=JSON.stringify(A);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=I}),define(ve[98],be([0,1,16,6]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(h){const s=h;return s?[s.on,s.pause,s.resume,s.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=I;function C(h){const s=h;return s?I(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(h,s){return new k(h,s)}e.newWriteableStream=A;class k{constructor(s,u){this.reducer=s,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(u=>u(s))}emitError(s){this.listeners.error.length===0?(0,d.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(u=>u(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,u){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(s,u){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const S=r.indexOf(u);S>=0&&r.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(h,s){const u=[];let r;for(;(r=h.read())!==null;)u.push(r);return s(u)}e.consumeReadable=D;function P(h,s,u){const r=[];let S;for(;(S=h.read())!==null&&r.length<u;)r.push(S);return S===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof S!="undefined"){const a=S;return S=void 0,a}return h.read()}}}e.peekReadable=P;function F(h,s){return new Promise((u,r)=>{const S=[];y(h,{onData:a=>{s&&S.push(a)},onError:a=>{s?r(a):u(void 0)},onEnd:()=>{u(s?s(S):void 0)}})})}e.consumeStream=F;function y(h,s){let u=!1;return h.on("error",r=>{u||s.onError(r)}),h.on("end",()=>{u||s.onEnd()}),h.on("data",r=>{u||s.onData(r)}),(0,t.toDisposable)(()=>u=!0)}e.listenStream=y;function l(h,s){return new Promise((u,r)=>{const S=new t.DisposableStore,a=[],i=c=>{if(a.push(c),a.length>s)return S.dispose(),h.pause(),u({stream:h,buffer:a,ended:!1})},n=c=>r(c),o=()=>u({stream:h,buffer:a,ended:!0});S.add((0,t.toDisposable)(()=>h.removeListener("error",n))),h.on("error",n),S.add((0,t.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),S.add((0,t.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=l;function b(h,s){const u=A(s);return u.end(h),u}e.toStream=b;function g(){const h=A(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=g;function v(h){let s=!1;return{read:()=>s?null:(s=!0,h)}}e.toReadable=v;function _(h,s,u){const r=A(u);return y(h,{onData:S=>r.write(s.data(S)),onError:S=>r.error(s.error?s.error(S):S),onEnd:()=>r.end()}),r}e.transform=_;function R(h,s,u){let r=!1;return{read:()=>{const S=s.read();return r?S:(r=!0,S!==null?u([h,S]):h)}}}e.prefixedReadable=R;function p(h,s,u){let r=!1;const S=A(u);return y(s,{onData:a=>r?S.write(a):(r=!0,S.write(u([h,a]))),onError:a=>S.error(a),onEnd:()=>{r||(r=!0,S.write(h)),S.end()}}),S}e.prefixedStream=p}),define(ve[22],be([0,1,98]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,C;class A{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return t?new A(Buffer.allocUnsafe(m)):new A(new Uint8Array(m))}static wrap(m){return t&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new A(m)}static fromString(m,f){return!(f?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(m)):(I||(I=new TextEncoder),new A(I.encode(m)))}static fromByteArray(m){const f=A.alloc(m.length);for(let w=0,T=m.length;w<T;w++)f.buffer[w]=m[w];return f}static concat(m,f){if(typeof f=="undefined"){f=0;for(let L=0,O=m.length;L<O;L++)f+=m[L].byteLength}const w=A.alloc(f);let T=0;for(let L=0,O=m.length;L<O;L++){const E=m[L];w.set(E,T),T+=E.byteLength}return w}clone(){const m=A.alloc(this.byteLength);return m.set(this),m}toString(){return t?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(m,f){return new A(this.buffer.subarray(m,f))}set(m,f){if(m instanceof A)this.buffer.set(m.buffer,f);else if(m instanceof Uint8Array)this.buffer.set(m,f);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),f);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),f);else throw new Error("Unkown argument 'array'")}readUInt32BE(m){return P(this.buffer,m)}writeUInt32BE(m,f){F(this.buffer,m,f)}readUInt32LE(m){return y(this.buffer,m)}writeUInt32LE(m,f){l(this.buffer,m,f)}readUInt8(m){return b(this.buffer,m)}writeUInt8(m,f){g(this.buffer,m,f)}}e.VSBuffer=A;function k(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0}e.readUInt16LE=k;function D(c,m,f){c[f+0]=m&255,m=m>>>8,c[f+1]=m&255}e.writeUInt16LE=D;function P(c,m){return c[m]*2**24+c[m+1]*2**16+c[m+2]*2**8+c[m+3]}e.readUInt32BE=P;function F(c,m,f){c[f+3]=m,m=m>>>8,c[f+2]=m,m=m>>>8,c[f+1]=m,m=m>>>8,c[f]=m}e.writeUInt32BE=F;function y(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0|c[m+2]<<16>>>0|c[m+3]<<24>>>0}e.readUInt32LE=y;function l(c,m,f){c[f+0]=m&255,m=m>>>8,c[f+1]=m&255,m=m>>>8,c[f+2]=m&255,m=m>>>8,c[f+3]=m&255}e.writeUInt32LE=l;function b(c,m){return c[m]}e.readUInt8=b;function g(c,m,f){c[f]=m}e.writeUInt8=g;function v(c){return d.consumeReadable(c,m=>A.concat(m))}e.readableToBuffer=v;function _(c){return d.toReadable(c)}e.bufferToReadable=_;function R(c){return d.consumeStream(c,m=>A.concat(m))}e.streamToBuffer=R;async function p(c){return c.ended?A.concat(c.buffer):A.concat([...c.buffer,await R(c.stream)])}e.bufferedStreamToBuffer=p;function h(c){return d.toStream(c,m=>A.concat(m))}e.bufferToStream=h;function s(c){return d.transform(c,{data:m=>typeof m=="string"?A.fromString(m):A.wrap(m)},m=>A.concat(m))}e.streamToBufferReadableStream=s;function u(c){return d.newWriteableStream(m=>A.concat(m),c)}e.newWriteableBufferStream=u;function r(c,m){return d.prefixedReadable(c,m,f=>A.concat(f))}e.prefixedBufferReadable=r;function S(c,m){return d.prefixedStream(c,m,f=>A.concat(f))}e.prefixedBufferStream=S;function a(c){let m=0,f=0,w=0;const T=new Uint8Array(Math.floor(c.length/4*3)),L=E=>{switch(f){case 3:T[w++]=m|E,f=0;break;case 2:T[w++]=m|E>>>2,m=E<<6,f=3;break;case 1:T[w++]=m|E>>>4,m=E<<4,f=2;break;default:m=E<<2,f=1}};for(let E=0;E<c.length;E++){const M=c.charCodeAt(E);if(M>=65&&M<=90)L(M-65);else if(M>=97&&M<=122)L(M-97+26);else if(M>=48&&M<=57)L(M-48+52);else if(M===43||M===45)L(62);else if(M===47||M===95)L(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${c[E]}`)}}const O=w;for(;f>0;)L(0);return A.wrap(T).slice(0,O)}e.decodeBase64=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},m=!0,f=!1){const w=f?n:i;let T="";const L=c.byteLength%3;let O=0;for(;O<c.byteLength-L;O+=3){const E=c[O+0],M=c[O+1],U=c[O+2];T+=w[E>>>2],T+=w[(E<<4|M>>>4)&63],T+=w[(M<<2|U>>>6)&63],T+=w[U&63]}if(L===1){const E=c[O+0];T+=w[E>>>2],T+=w[E<<4&63],m&&(T+="==")}else if(L===2){const E=c[O+0],M=c[O+1];T+=w[E>>>2],T+=w[(E<<4|M>>>4)&63],T+=w[M<<2&63],m&&(T+="=")}return T}e.encodeBase64=o}),define(ve[8],be([0,1,142,93]),function(ee,e,d,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=C;const A=/{(\d+)}/g;function k(K,...we){return we.length===0?K:K.replace(A,function(ke,Ve){const We=parseInt(Ve,10);return isNaN(We)||We<0||We>=we.length?ke:we[We]})}e.format=k;const D=/{([^}]+)}/g;function P(K,we){return K.replace(D,(ke,Ve)=>we[Ve]??ke)}e.format2=P;function F(K){return K.replace(/[<>&]/g,function(we){switch(we){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return we}})}e.escape=F;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function l(K,we){let ke=0;const Ve=we.charCodeAt(0);for(let We=K.length-1;We>=0;We--)K.charCodeAt(We)===Ve&&ke++;return ke}e.count=l;function b(K,we,ke="\u2026"){return K.length<=we?K:`${K.substr(0,we)}${ke}`}e.truncate=b;function g(K,we=" "){const ke=v(K,we);return _(ke,we)}e.trim=g;function v(K,we){if(!K||!we)return K;const ke=we.length;if(ke===0||K.length===0)return K;let Ve=0;for(;K.indexOf(we,Ve)===Ve;)Ve=Ve+ke;return K.substring(Ve)}e.ltrim=v;function _(K,we){if(!K||!we)return K;const ke=we.length,Ve=K.length;if(ke===0||Ve===0)return K;let We=Ve,lt=-1;for(;lt=K.lastIndexOf(we,We-1),!(lt===-1||lt+ke!==We);){if(lt===0)return"";We=lt}return K.substring(0,We)}e.rtrim=_;function R(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=R;function p(K){return K.replace(/\*/g,"")}e.stripWildcards=p;function h(K,we,ke={}){if(!K)throw new Error("Cannot create regex from empty string");we||(K=y(K)),ke.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ve="";return ke.global&&(Ve+="g"),ke.matchCase||(Ve+="i"),ke.multiline&&(Ve+="m"),ke.unicode&&(Ve+="u"),new RegExp(K,Ve)}e.createRegExp=h;function s(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function u(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=r;function S(K){return K.split(/\r\n|\r|\n/)}e.splitLines=S;function a(K){for(let we=0,ke=K.length;we<ke;we++){const Ve=K.charCodeAt(we);if(Ve!==32&&Ve!==9)return we}return-1}e.firstNonWhitespaceIndex=a;function i(K,we=0,ke=K.length){for(let Ve=we;Ve<ke;Ve++){const We=K.charCodeAt(Ve);if(We!==32&&We!==9)return K.substring(we,Ve)}return K.substring(we,ke)}e.getLeadingWhitespace=i;function n(K,we=K.length-1){for(let ke=we;ke>=0;ke--){const Ve=K.charCodeAt(ke);if(Ve!==32&&Ve!==9)return ke}return-1}e.lastNonWhitespaceIndex=n;function o(K,we){return K<we?-1:K>we?1:0}e.compare=o;function c(K,we,ke=0,Ve=K.length,We=0,lt=we.length){for(;ke<Ve&&We<lt;ke++,We++){let Ce=K.charCodeAt(ke),ue=we.charCodeAt(We);if(Ce<ue)return-1;if(Ce>ue)return 1}const Re=Ve-ke,Ae=lt-We;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=c;function m(K,we){return f(K,we,0,K.length,0,we.length)}e.compareIgnoreCase=m;function f(K,we,ke=0,Ve=K.length,We=0,lt=we.length){for(;ke<Ve&&We<lt;ke++,We++){let Ce=K.charCodeAt(ke),ue=we.charCodeAt(We);if(Ce===ue)continue;if(Ce>=128||ue>=128)return c(K.toLowerCase(),we.toLowerCase(),ke,Ve,We,lt);w(Ce)&&(Ce-=32),w(ue)&&(ue-=32);const de=Ce-ue;if(de!==0)return de}const Re=Ve-ke,Ae=lt-We;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=f;function w(K){return K>=97&&K<=122}e.isLowerAsciiLetter=w;function T(K){return K>=65&&K<=90}e.isUpperAsciiLetter=T;function L(K,we){return K.length===we.length&&f(K,we)===0}e.equalsIgnoreCase=L;function O(K,we){const ke=we.length;return we.length>K.length?!1:f(K,we,0,ke)===0}e.startsWithIgnoreCase=O;function E(K,we){let ke,Ve=Math.min(K.length,we.length);for(ke=0;ke<Ve;ke++)if(K.charCodeAt(ke)!==we.charCodeAt(ke))return ke;return Ve}e.commonPrefixLength=E;function M(K,we){let ke,Ve=Math.min(K.length,we.length);const We=K.length-1,lt=we.length-1;for(ke=0;ke<Ve;ke++)if(K.charCodeAt(We-ke)!==we.charCodeAt(lt-ke))return ke;return Ve}e.commonSuffixLength=M;function U(K){return 55296<=K&&K<=56319}e.isHighSurrogate=U;function V(K){return 56320<=K&&K<=57343}e.isLowSurrogate=V;function z(K,we){return(K-55296<<10)+(we-56320)+65536}e.computeCodePoint=z;function N(K,we,ke){const Ve=K.charCodeAt(ke);if(U(Ve)&&ke+1<we){const We=K.charCodeAt(ke+1);if(V(We))return z(Ve,We)}return Ve}e.getNextCodePoint=N;function W(K,we){const ke=K.charCodeAt(we-1);if(V(ke)&&we>1){const Ve=K.charCodeAt(we-2);if(U(Ve))return z(Ve,ke)}return ke}class B{constructor(we,ke=0){this._str=we,this._len=we.length,this._offset=ke}get offset(){return this._offset}setOffset(we){this._offset=we}prevCodePoint(){const we=W(this._str,this._offset);return this._offset-=we>=65536?2:1,we}nextCodePoint(){const we=N(this._str,this._len,this._offset);return this._offset+=we>=65536?2:1,we}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class x{constructor(we,ke=0){this._iterator=new B(we,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const we=et.getInstance(),ke=this._iterator,Ve=ke.offset;let We=we.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const lt=ke.offset,Re=we.getGraphemeBreakType(ke.nextCodePoint());if(rt(We,Re)){ke.setOffset(lt);break}We=Re}return ke.offset-Ve}prevGraphemeLength(){const we=et.getInstance(),ke=this._iterator,Ve=ke.offset;let We=we.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const lt=ke.offset,Re=we.getGraphemeBreakType(ke.prevCodePoint());if(rt(Re,We)){ke.setOffset(lt);break}We=Re}return Ve-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function $(K,we){return new x(K,we).nextGraphemeLength()}e.nextCharLength=$;function J(K,we){return new x(K,we).prevGraphemeLength()}e.prevCharLength=J;function ne(K,we){we>0&&V(K.charCodeAt(we))&&we--;const ke=we+$(K,we);return[ke-J(K,ke),ke]}e.getCharContainingOffset=ne;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(K){return re.test(K)}e.containsRTL=Z;const Q=/^[\t\n\r\x20-\x7E]*$/;function oe(K){return Q.test(K)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=fe;function pe(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=pe;function Te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=Te;function xe(K,we){if(K.length<we)return K;const ke=/\b/g;let Ve=0;for(;ke.test(K)&&!(K.length-ke.lastIndex<we);)Ve=ke.lastIndex,ke.lastIndex+=1;return K.substring(Ve).replace(/^\s/,"")}e.lcut=xe;const qe=/\x1B\x5B[12]?K/g,Qe=/\x1b\[\d+m/g,q=/\x1b\[0?m/g;function ie(K){return K&&(K=K.replace(qe,""),K=K.replace(Qe,""),K=K.replace(q,"")),K}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function X(K){return G(K)?K.substr(1):K}e.stripUTF8BOM=X;function ae(K,we){if(!K||!we||K.length<we.length)return!1;const ke=we.length,Ve=K.toLowerCase();let We=0,lt=-1;for(;We<ke;){const Re=Ve.indexOf(we[We],lt+1);if(Re<0)return!1;lt=Re,We++}return!0}e.fuzzyContains=ae;function me(K,we=!1){return K?(we&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=me;function De(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=De;function Be(K,we=1){if(we===0)return"";let ke=-1;do ke=K.indexOf(`
`,ke+1),we--;while(we>0&&ke>=0);return ke===-1?K:(K[ke-1]==="\r"&&ke--,K.substr(0,ke))}e.getNLines=Be;function Xe(K){const we=90-65+1;return K=K%(2*we),K<we?String.fromCharCode(97+K):String.fromCharCode(65+K-we)}e.singleLetterHash=Xe;function tt(K){return et.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=tt;function rt(K,we){return K===0?we!==5&&we!==7:K===2&&we===3?!1:K===4||K===2||K===3||we===4||we===2||we===3?!0:!(K===8&&(we===8||we===9||we===11||we===12)||(K===11||K===9)&&(we===9||we===10)||(K===12||K===10)&&we===10||we===5||we===13||we===7||K===1||K===13&&we===14||K===6&&we===6)}var st;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(st=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{constructor(){this._data=nt()}static getInstance(){return et._INSTANCE||(et._INSTANCE=new et),et._INSTANCE}getGraphemeBreakType(we){if(we<32)return we===10?3:we===13?2:4;if(we<127)return 0;const ke=this._data,Ve=ke.length/3;let We=1;for(;We<=Ve;)if(we<ke[3*We])We=2*We;else if(we>ke[3*We+1])We=2*We+1;else return ke[3*We+2];return 0}}et._INSTANCE=null;function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function gt(K,we){if(K===0)return 0;const ke=It(K,we);if(ke!==void 0)return ke;const Ve=new B(we,K);return Ve.prevCodePoint(),Ve.offset}e.getLeftDeleteOffset=gt;function It(K,we){const ke=new B(we,K);let Ve=ke.prevCodePoint();for(;Ne(Ve)||Ve===65039||Ve===8419;){if(ke.offset===0)return;Ve=ke.prevCodePoint()}if(!Te(Ve))return;let We=ke.offset;return We>0&&ke.prevCodePoint()===8205&&(We=ke.offset),We}function Ne(K){return 127995<=K&&K<=127999}var Dt;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Dt||(Dt={})),e.noBreakWhitespace="\xA0";class te{constructor(we){this.confusableDictionary=we}static getInstance(we){return te.cache.get(Array.from(we))}static getLocales(){return te._locales.getValue()}isAmbiguous(we){return this.confusableDictionary.has(we)}getPrimaryConfusable(we){return this.confusableDictionary.get(we)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=te,I=te,te.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),te.cache=new d.LRUCachedComputed(K=>{function we(ue){const de=new Map;for(let Ee=0;Ee<ue.length;Ee+=2)de.set(ue[Ee],ue[Ee+1]);return de}function ke(ue,de){const Ee=new Map(ue);for(const[ye,Oe]of de)Ee.set(ye,Oe);return Ee}function Ve(ue,de){if(!ue)return de;const Ee=new Map;for(const[ye,Oe]of ue)de.has(ye)&&Ee.set(ye,Oe);return Ee}const We=I.ambiguousCharacterData.getValue();let lt=K.filter(ue=>!ue.startsWith("_")&&ue in We);lt.length===0&&(lt=["_default"]);let Re;for(const ue of lt){const de=we(We[ue]);Re=Ve(Re,de)}const Ae=we(We._common),Ce=ke(Ae,Re);return new te(Ce)}),te._locales=new t.Lazy(()=>Object.keys(te.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(se.getRawData())),this._data}static isInvisibleCharacter(we){return se.getData().has(we)}static get codePoints(){return se.getData()}}e.InvisibleCharacters=se,se._data=void 0}),define(ve[58],be([0,1,8]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(R){return I(R,0)}e.hash=t;function I(R,p){switch(typeof R){case"object":return R===null?C(349,p):Array.isArray(R)?D(R,p):P(R,p);case"string":return k(R,p);case"boolean":return A(R,p);case"number":return C(R,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=I;function C(R,p){return(p<<5)-p+R|0}e.numberHash=C;function A(R,p){return C(R?433:863,p)}function k(R,p){p=C(149417,p);for(let h=0,s=R.length;h<s;h++)p=C(R.charCodeAt(h),p);return p}e.stringHash=k;function D(R,p){return p=C(104579,p),R.reduce((h,s)=>I(s,h),p)}function P(R,p){return p=C(181387,p),Object.keys(R).sort().reduce((h,s)=>(h=k(s,h),I(R[s],h)),p)}class F{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=I(p,this._value),this._value}}e.Hasher=F;var y;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function l(R,p,h=32){const s=h-p,u=~((1<<s)-1);return(R<<p|(u&R)>>>s)>>>0}function b(R,p=0,h=R.byteLength,s=0){for(let u=0;u<h;u++)R[p+u]=s}function g(R,p,h="0"){for(;R.length<p;)R=h+R;return R}function v(R,p=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(h=>h.toString(16).padStart(2,"0")).join(""):g((R>>>0).toString(16),p/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const h=p.length;if(h===0)return;const s=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,S,a;for(r!==0?(S=r,a=-1,r=0):(S=p.charCodeAt(0),a=0);;){let i=S;if(d.isHighSurrogate(S))if(a+1<h){const n=p.charCodeAt(a+1);d.isLowSurrogate(n)?(a++,i=d.computeCodePoint(S,n)):i=65533}else{r=S;break}else d.isLowSurrogate(S)&&(i=65533);if(u=this._push(s,u,i),a++,a<h)S=p.charCodeAt(a);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(p,h,s){return s<128?p[h++]=s:s<2048?(p[h++]=192|(s&1984)>>>6,p[h++]=128|(s&63)>>>0):s<65536?(p[h++]=224|(s&61440)>>>12,p[h++]=128|(s&4032)>>>6,p[h++]=128|(s&63)>>>0):(p[h++]=240|(s&1835008)>>>18,p[h++]=128|(s&258048)>>>12,p[h++]=128|(s&4032)>>>6,p[h++]=128|(s&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=_._bigBlock32,h=this._buffDV;for(let c=0;c<64;c+=4)p.setUint32(c,h.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)p.setUint32(c,l(p.getUint32(c-12,!1)^p.getUint32(c-32,!1)^p.getUint32(c-56,!1)^p.getUint32(c-64,!1),1),!1);let s=this._h0,u=this._h1,r=this._h2,S=this._h3,a=this._h4,i,n,o;for(let c=0;c<80;c++)c<20?(i=u&r|~u&S,n=1518500249):c<40?(i=u^r^S,n=1859775393):c<60?(i=u&r|u&S|r&S,n=2400959708):(i=u^r^S,n=3395469782),o=l(s,5)+i+a+n+p.getUint32(c*4,!1)&4294967295,a=S,S=r,r=l(u,30),u=s,s=o;this._h0=this._h0+s&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[24],be([0,1,17,8]),function(ee,e,d,t){"use strict";var I,C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(a,i,n){let o=a.get(i);return o===void 0&&(o=n,a.set(i,o)),o}e.getOrSet=k;function D(a){const i=[];return a.forEach((n,o)=>{i.push(`${o} => ${n}`)}),`Map(${a.size}) {${i.join(", ")}}`}e.mapToString=D;function P(a){const i=[];return a.forEach(n=>{i.push(n)}),`Set(${a.size}) {${i.join(", ")}}`}e.setToString=P;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return n-o}value(){return this._value[this._pos]}}e.StringIterator=F;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class l{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let n=i.length-1;n>=0;n--,this._valueLen--){const o=this._value.charCodeAt(n);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var b;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(b||(b={}));class g{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(_||(_={}));class R{constructor(i){this._iter=i}static forUris(i=()=>!1){return new R(new g(i))}static forPaths(i=!1){return new R(new l(void 0,!i))}static forStrings(){return new R(new F)}static forConfigKeys(){return new R(new y)}clear(){this._root=void 0}fill(i,n){if(n){const o=n.slice(0);(0,d.shuffle)(o);for(let c of o)this.set(c,i)}else{const o=i.slice(0);(0,d.shuffle)(o);for(let c of o)this.set(c[0],c[1])}}set(i,n){const o=this._iter.reset(i);let c;this._root||(this._root=new v,this._root.segment=o.value());const m=[];for(c=this._root;;){const w=o.cmp(c.segment);if(w>0)c.left||(c.left=new v,c.left.segment=o.value()),m.push([-1,c]),c=c.left;else if(w<0)c.right||(c.right=new v,c.right.segment=o.value()),m.push([1,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new v,c.mid.segment=o.value()),m.push([0,c]),c=c.mid;else break}const f=c.value;c.value=n,c.key=i;for(let w=m.length-1;w>=0;w--){const T=m[w][1];T.updateHeight();const L=T.balanceFactor();if(L<-1||L>1){const O=m[w][0],E=m[w+1][0];if(O===1&&E===1)m[w][1]=T.rotateLeft();else if(O===-1&&E===-1)m[w][1]=T.rotateRight();else if(O===1&&E===-1)T.right=m[w+1][1]=m[w+1][1].rotateRight(),m[w][1]=T.rotateLeft();else if(O===-1&&E===1)T.left=m[w+1][1]=m[w+1][1].rotateLeft(),m[w][1]=T.rotateRight();else throw new Error;if(w>0)switch(m[w-1][0]){case-1:m[w-1][1].left=m[w][1];break;case 1:m[w-1][1].right=m[w][1];break;case 0:m[w-1][1].mid=m[w][1];break}else this._root=m[0][1]}}return f}get(i){return this._getNode(i)?.value}_getNode(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const c=n.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(i){const n=this._getNode(i);return!(n?.value===void 0&&n?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const o=this._iter.reset(i),c=[];let m=this._root;for(;m;){const f=o.cmp(m.segment);if(f>0)c.push([-1,m]),m=m.left;else if(f<0)c.push([1,m]),m=m.right;else if(o.hasNext())o.next(),c.push([0,m]),m=m.mid;else break}if(!!m){if(n?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const f=this._min(m.right),{key:w,value:T,segment:L}=f;this._delete(f.key,!1),m.key=w,m.value=T,m.segment=L}else{const f=m.left??m.right;if(c.length>0){const[w,T]=c[c.length-1];switch(w){case-1:T.left=f;break;case 0:T.mid=f;break;case 1:T.right=f;break}}else this._root=f}for(let f=c.length-1;f>=0;f--){const w=c[f][1];w.updateHeight();const T=w.balanceFactor();if(T>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),c[f][1]=w.rotateLeft()):T<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),c[f][1]=w.rotateRight()),f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const n=this._iter.reset(i);let o=this._root,c;for(;o;){const m=n.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(n.hasNext())n.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const c=n.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[n,o]of this)i(o,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=n=>{if(!n)return!0;const o=n.balanceFactor();return o<-1||o>1?!1:i(n.left)&&i(n.right)};return i(this._root)}}e.TernarySearchTree=R;class p{constructor(i,n){this.uri=i,this.value=n}}class h{constructor(i,n){this[I]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=n??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),new p(i,n)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[o,c]of this.map)i(c.value,c.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=a=>a.toString();var s;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class u{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,n=0){const o=this._map.get(i);if(!!o)return n!==0&&this.touch(o,n),o.value}set(i,n,o=0){let c=this._map.get(i);if(c)c.value=n,o!==0&&this.touch(c,o);else{switch(c={key:i,value:n,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const o=this._state;let c=this._head;for(;c;){if(n?i.bind(n)(c.value,c.key,this):i(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,n=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.key,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return c}values(){const i=this,n=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.value,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return c}entries(){const i=this,n=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:[o.key,o.value],done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return c}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,o=this.size;for(;n&&o>i;)this._map.delete(n.key),n=n.next,o--;this._head=n,this._size=o,n&&(n.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,o=i.previous;if(!n||!o)throw new Error("Invalid list");n.previous=o,o.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const o=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const o=i.next,c=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,o)=>{i.push([o,n])}),i}fromJSON(i){this.clear();for(const[n,o]of i)this.set(n,o)}}e.LinkedMap=u;class r extends u{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class S{constructor(i){A.set(this,void 0),it(this,A,i,"f")}get size(){return Fe(this,A,"f").size}forEach(i,n){Fe(this,A,"f").forEach(i,n)}get(i){return Fe(this,A,"f").get(i)}has(i){return Fe(this,A,"f").has(i)}entries(){return Fe(this,A,"f").entries()}keys(){return Fe(this,A,"f").keys()}values(){return Fe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Fe(this,A,"f").entries()}}e.ReadonlyMapView=S}),define(ve[99],be([0,1,24,8]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...G){return function(X,ae){for(let me=0,De=G.length;me<De;me++){const Be=G[me](X,ae);if(Be)return Be}return null}}e.or=I,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(G,X,ae){if(!ae||ae.length<X.length)return null;let me;return G?me=t.startsWithIgnoreCase(ae,X):me=ae.indexOf(X)===0,me?X.length>0?[{start:0,end:X.length}]:[]:null}function A(G,X){const ae=X.toLowerCase().indexOf(G.toLowerCase());return ae===-1?null:[{start:ae,end:ae+G.length}]}e.matchesContiguousSubString=A;function k(G,X){return D(G.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=k;function D(G,X,ae,me){if(ae===G.length)return[];if(me===X.length)return null;if(G[ae]===X[me]){let De=null;return(De=D(G,X,ae+1,me+1))?R({start:me,end:me+1},De):null}return D(G,X,ae,me+1)}function P(G){return 97<=G&&G<=122}function F(G){return 65<=G&&G<=90}e.isUpper=F;function y(G){return 48<=G&&G<=57}function l(G){return G===32||G===9||G===10||G===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>b.add(G.charCodeAt(0)));function g(G){return l(G)||b.has(G)}function v(G,X){return G===X||g(G)&&g(X)}function _(G){return P(G)||F(G)||y(G)}function R(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function p(G,X){for(let ae=X;ae<G.length;ae++){const me=G.charCodeAt(ae);if(F(me)||y(me)||ae>0&&!_(G.charCodeAt(ae-1)))return ae}return G.length}function h(G,X,ae,me){if(ae===G.length)return[];if(me===X.length)return null;if(G[ae]!==X[me].toLowerCase())return null;{let De=null,Be=me+1;for(De=h(G,X,ae+1,me+1);!De&&(Be=p(X,Be))<X.length;)De=h(G,X,ae+1,Be),Be++;return De===null?null:R({start:me,end:me+1},De)}}function s(G){let X=0,ae=0,me=0,De=0,Be=0;for(let et=0;et<G.length;et++)Be=G.charCodeAt(et),F(Be)&&X++,P(Be)&&ae++,_(Be)&&me++,y(Be)&&De++;const Xe=X/G.length,tt=ae/G.length,rt=me/G.length,st=De/G.length;return{upperPercent:Xe,lowerPercent:tt,alphaPercent:rt,numericPercent:st}}function u(G){const{upperPercent:X,lowerPercent:ae}=G;return ae===0&&X>.6}function r(G){const{upperPercent:X,lowerPercent:ae,alphaPercent:me,numericPercent:De}=G;return ae>.2&&X<.8&&me>.6&&De<.2}function S(G){let X=0,ae=0,me=0,De=0;for(let Be=0;Be<G.length;Be++)me=G.charCodeAt(Be),F(me)&&X++,P(me)&&ae++,l(me)&&De++;return(X===0||ae===0)&&De===0?G.length<=30:X<=5}function a(G,X){if(!X||(X=X.trim(),X.length===0)||!S(G)||X.length>60)return null;const ae=s(X);if(!r(ae)){if(!u(ae))return null;X=X.toLowerCase()}let me=null,De=0;for(G=G.toLowerCase();De<X.length&&(me=h(G,X,0,De))===null;)De=p(X,De+1);return me}e.matchesCamelCase=a;function i(G,X,ae=!1){if(!X||X.length===0)return null;let me=null,De=0;for(G=G.toLowerCase(),X=X.toLowerCase();De<X.length&&(me=n(G,X,0,De,ae))===null;)De=o(X,De+1);return me}e.matchesWords=i;function n(G,X,ae,me,De){if(ae===G.length)return[];if(me===X.length)return null;if(v(G.charCodeAt(ae),X.charCodeAt(me))){let Be=null,Xe=me+1;if(Be=n(G,X,ae+1,me+1,De),!De)for(;!Be&&(Xe=o(X,Xe))<X.length;)Be=n(G,X,ae+1,Xe,De),Xe++;return Be===null?null:R({start:me,end:me+1},Be)}else return null}function o(G,X){for(let ae=X;ae<G.length;ae++)if(g(G.charCodeAt(ae))||ae>0&&g(G.charCodeAt(ae-1)))return ae;return G.length}const c=I(e.matchesPrefix,a,A),m=I(e.matchesPrefix,a,k),f=new d.LRUCache(1e4);function w(G,X,ae=!1){if(typeof G!="string"||typeof X!="string")return null;let me=f.get(G);me||(me=new RegExp(t.convertSimple2RegExpPattern(G),"i"),f.set(G,me));const De=me.exec(X);return De?[{start:De.index,end:De.index+De[0].length}]:ae?m(G,X):c(G,X)}e.matchesFuzzy=w;function T(G,X){const ae=pe(G,G.toLowerCase(),0,X,X.toLowerCase(),0,!0);return ae?O(ae):null}e.matchesFuzzy2=T;function L(G,X,ae,me,De,Be){const Xe=Math.min(13,G.length);for(;ae<Xe;ae++){const tt=pe(G,X,ae,me,De,Be,!1);if(tt)return tt}return[0,Be]}e.anyScore=L;function O(G){if(typeof G=="undefined")return[];const X=[],ae=G[1];for(let me=G.length-1;me>1;me--){const De=G[me]+ae,Be=X[X.length-1];Be&&Be.end===De?Be.end=De+1:X.push({start:De,end:De+1})}return X}e.createMatches=O;const E=128;function M(){const G=[],X=[];for(let ae=0;ae<=E;ae++)X[ae]=0;for(let ae=0;ae<=E;ae++)G.push(X.slice(0));return G}function U(G){const X=[];for(let ae=0;ae<=G;ae++)X[ae]=0;return X}const V=U(2*E),z=U(2*E),N=M(),W=M(),B=M(),x=!1;function $(G,X,ae,me,De){function Be(tt,rt,st=" "){for(;tt.length<rt;)tt=st+tt;return tt}let Xe=` |   |${me.split("").map(tt=>Be(tt,3)).join("|")}
`;for(let tt=0;tt<=ae;tt++)tt===0?Xe+=" |":Xe+=`${X[tt-1]}|`,Xe+=G[tt].slice(0,De+1).map(rt=>Be(rt.toString(),3)).join("|")+`
`;return Xe}function J(G,X,ae,me){G=G.substr(X),ae=ae.substr(me),console.log($(W,G,G.length,ae,ae.length)),console.log($(B,G,G.length,ae,ae.length)),console.log($(N,G,G.length,ae,ae.length))}function ne(G,X){if(X<0||X>=G.length)return!1;const ae=G.codePointAt(X);switch(ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(ae)}}function re(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function Z(G,X,ae){return X[G]!==ae[G]}function Q(G,X,ae,me,De,Be,Xe=!1){for(;X<ae&&De<Be;)G[X]===me[De]&&(Xe&&(V[X]=De),X+=1),De+=1;return X===ae}e.isPatternInWord=Q;var oe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var fe;(function(G){G.Default=[-100,0];function X(ae){return!ae||ae.length===2&&ae[0]===-100&&ae[1]===0}G.isDefault=X})(fe=e.FuzzyScore||(e.FuzzyScore={}));function pe(G,X,ae,me,De,Be,Xe){const tt=G.length>E?E:G.length,rt=me.length>E?E:me.length;if(ae>=tt||Be>=rt||tt-ae>rt-Be||!Q(X,ae,tt,De,Be,rt,!0))return;Te(tt,rt,ae,Be,X,De);let st=1,et=1,nt=ae,gt=Be;const It=[!1];for(st=1,nt=ae;nt<tt;st++,nt++){const K=V[nt],we=z[nt],ke=nt+1<tt?z[nt+1]:rt;for(et=K-Be+1,gt=K;gt<ke;et++,gt++){let Ve=Number.MIN_SAFE_INTEGER,We=!1;gt<=we&&(Ve=xe(G,X,nt,ae,me,De,gt,rt,Be,N[st-1][et-1]===0,It));let lt=0;Ve!==Number.MAX_SAFE_INTEGER&&(We=!0,lt=Ve+W[st-1][et-1]);const Re=gt>K,Ae=Re?W[st][et-1]+(N[st][et-1]>0?-5:0):0,Ce=gt>K+1&&N[st][et-1]>0,ue=Ce?W[st][et-2]+(N[st][et-2]>0?-5:0):0;if(Ce&&(!Re||ue>=Ae)&&(!We||ue>=lt))W[st][et]=ue,B[st][et]=3,N[st][et]=0;else if(Re&&(!We||Ae>=lt))W[st][et]=Ae,B[st][et]=2,N[st][et]=0;else if(We)W[st][et]=lt,B[st][et]=1,N[st][et]=N[st-1][et-1]+1;else throw new Error("not possible")}}if(x&&J(G,ae,me,Be),!It[0]&&!Xe)return;st--,et--;const Ne=[W[st][et],Be];let Dt=0,te=0;for(;st>=1;){let K=et;do{const we=B[st][K];if(we===3)K=K-2;else if(we===2)K=K-1;else break}while(K>=1);Dt>1&&X[ae+st-1]===De[Be+et-1]&&!Z(K+Be-1,me,De)&&Dt+1>N[st][K]&&(K=et),K===et?Dt++:Dt=1,te||(te=K),st--,et=K-1,Ne.push(et)}rt===tt&&(Ne[0]+=2);const se=te-tt;return Ne[0]-=se,Ne}e.fuzzyScore=pe;function Te(G,X,ae,me,De,Be){let Xe=G-1,tt=X-1;for(;Xe>=ae&&tt>=me;)De[Xe]===Be[tt]&&(z[Xe]=tt,Xe--),tt--}function xe(G,X,ae,me,De,Be,Xe,tt,rt,st,et){if(X[ae]!==Be[Xe])return Number.MIN_SAFE_INTEGER;let nt=1,gt=!1;return Xe===ae-me?nt=G[ae]===De[Xe]?7:5:Z(Xe,De,Be)&&(Xe===0||!Z(Xe-1,De,Be))?(nt=G[ae]===De[Xe]?7:5,gt=!0):ne(Be,Xe)&&(Xe===0||!ne(Be,Xe-1))?nt=5:(ne(Be,Xe-1)||re(Be,Xe-1))&&(nt=5,gt=!0),nt>1&&ae===me&&(et[0]=!0),gt||(gt=Z(Xe,De,Be)||ne(Be,Xe-1)||re(Be,Xe-1)),ae===me?Xe>rt&&(nt-=gt?3:5):st?nt+=gt?2:0:nt+=gt?0:1,Xe+1===tt&&(nt-=gt?3:5),nt}function qe(G,X,ae,me,De,Be,Xe){return q(G,X,ae,me,De,Be,!0,Xe)}e.fuzzyScoreGracefulAggressive=qe;function Qe(G,X,ae,me,De,Be,Xe){return q(G,X,ae,me,De,Be,!1,Xe)}e.fuzzyScoreGraceful=Qe;function q(G,X,ae,me,De,Be,Xe,tt){let rt=pe(G,X,ae,me,De,Be,tt);if(rt&&!Xe)return rt;if(G.length>=3){const st=Math.min(7,G.length-1);for(let et=ae+1;et<st;et++){const nt=ie(G,et);if(nt){const gt=pe(nt,nt.toLowerCase(),ae,me,De,Be,tt);gt&&(gt[0]-=3,(!rt||gt[0]>rt[0])&&(rt=gt))}}}return rt}function ie(G,X){if(X+1>=G.length)return;const ae=G[X],me=G[X+1];if(ae!==me)return G.slice(0,X)+me+ae+G.slice(X+2)}}),define(ve[143],be([0,1,73,99,8]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(d.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function D(_){return _.replace(k,(R,p)=>p?R:`\\${R}`)}e.escapeIcons=D;const P=new RegExp(`\\\\${C.source}`,"g");function F(_){return _.replace(P,R=>`\\${R}`)}e.markdownEscapeEscapedIcons=F;const y=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function l(_){return _.indexOf(e.iconStartMarker)===-1?_:_.replace(y,(R,p,h,s)=>h?R:p||s||"")}e.stripIcons=l;function b(_){const R=_.indexOf(e.iconStartMarker);return R===-1?{text:_}:g(_,R)}e.parseLabelWithIcons=b;function g(_,R){const p=[];let h="";function s(c){if(c){h+=c;for(const m of c)p.push(S)}}let u=-1,r="",S=0,a,i,n=R;const o=_.length;for(s(_.substr(0,R));n<o;)a=_[n],i=_[n+1],a===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(u=n,s(r),r=e.iconStartMarker,n++):a===")"&&u!==-1?(S+=n-u+1,u=-1,r=""):u!==-1?A.test(a)?r+=a:(s(r),u=-1,r=""):s(a),n++;return s(r),{text:h,iconOffsets:p}}function v(_,R,p=!1){const{text:h,iconOffsets:s}=R;if(!s||s.length===0)return(0,t.matchesFuzzy)(_,h,p);const u=(0,I.ltrim)(h," "),r=h.length-u.length,S=(0,t.matchesFuzzy)(_,u,p);if(S)for(const a of S){const i=s[a.start+r]+r;a.start+=i,a.end+=i}return S}e.matchesFuzzyIconAware=v}),define(ve[100],be([0,1,16,143]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(b="",g=!1){if(this.value=b,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(b,g=0){return this.value+=P(this.supportThemeIcons?(0,t.escapeIcons)(b):b).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,g){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}}e.MarkdownString=C;function A(l){return k(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function k(l){return l instanceof C?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function D(l,b){return l===b?!0:!l||!b?!1:l.value===b.value&&l.isTrusted===b.isTrusted&&l.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=D;function P(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function F(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function y(l){const b=[],g=l.split("|").map(_=>_.trim());l=g[0];const v=g[1];if(v){const _=/height=(\d+)/.exec(v),R=/width=(\d+)/.exec(v),p=_?_[1]:"",h=R?R[1]:"",s=isFinite(parseInt(h)),u=isFinite(parseInt(p));s&&b.push(`width="${h}"`),u&&b.push(`height="${p}"`)}return{href:l,dimensions:b}}e.parseHrefAndDimensions=y}),define(ve[78],be([0,1,24]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new d.LRUCache(1e4);function I(P){return D(P,"NFC",t)}e.normalizeNFC=I;const C=new d.LRUCache(1e4);function A(P){return D(P,"NFD",C)}e.normalizeNFD=A;const k=/[^\u0000-\u0080]/;function D(P,F,y){if(!P)return P;const l=y.get(P);if(l)return l;let b;return k.test(P)?b=P.normalize(F):b=P,y.set(P,b),b}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(F){return A(F).replace(P,"")}}()}),define(ve[47],be([0,1,8]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const C="error",A="warning",k="warn",D="info",P="ignore";function F(l){return l?d.equalsIgnoreCase(C,l)?I.Error:d.equalsIgnoreCase(A,l)||d.equalsIgnoreCase(k,l)?I.Warning:d.equalsIgnoreCase(D,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=F;function y(l){switch(l){case I.Error:return C;case I.Warning:return A;case I.Info:return D;default:return P}}I.toString=y}(t||(t={})),e.default=t}),define(ve[18],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function d(o){return Array.isArray(o)}e.isArray=d;function t(o){return typeof o=="string"}e.isString=t;function I(o){return Array.isArray(o)&&o.every(c=>t(c))}e.isStringArray=I;function C(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=C;function A(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=A;function k(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=k;function D(o){return o===!0||o===!1}e.isBoolean=D;function P(o){return typeof o=="undefined"}e.isUndefined=P;function F(o){return!y(o)}e.isDefined=F;function y(o){return P(o)||o===null}e.isUndefinedOrNull=y;function l(o,c){if(!o)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=l;function b(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=b;function g(...o){const c=[];for(let m=0;m<o.length;m++){const f=o[m];if(y(f))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);c.push(f)}return c}e.assertAllDefined=g;const v=Object.prototype.hasOwnProperty;function _(o){if(!C(o))return!1;for(let c in o)if(v.call(o,c))return!1;return!0}e.isEmptyObject=_;function R(o){return typeof o=="function"}e.isFunction=R;function p(...o){return o.length>0&&o.every(R)}e.areFunctions=p;function h(o,c){const m=Math.min(o.length,c.length);for(let f=0;f<m;f++)s(o[f],c[f])}e.validateConstraints=h;function s(o,c){if(t(c)){if(typeof o!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(R(c)){try{if(o instanceof c)return}catch{}if(!y(o)&&o.constructor===c||c.length===1&&c.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function u(o){let c=[],m=Object.getPrototypeOf(o);for(;Object.prototype!==m;)c=c.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return c}e.getAllPropertyNames=u;function r(o){const c=[];for(const m of u(o))typeof o[m]=="function"&&c.push(m);return c}e.getAllMethodNames=r;function S(o,c){const m=w=>function(){const T=Array.prototype.slice.call(arguments,0);return c(w,T)};let f={};for(const w of o)f[w]=m(w);return f}e.createProxyObject=S;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function i(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=i;function n(o,c="Unreachable"){throw new Error(c)}e.assertNever=n}),define(ve[28],be([0,1,9,11,8,18]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(n){return n===47||n===92}e.isPathSeparator=A;function k(n){return n.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=k;function D(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=D;function P(n,o=d.posix.sep){if(!n)return"";const c=n.length,m=n.charCodeAt(0);if(A(m)){if(A(n.charCodeAt(1))&&!A(n.charCodeAt(2))){let w=3;const T=w;for(;w<c&&!A(n.charCodeAt(w));w++);if(T!==w&&!A(n.charCodeAt(w+1))){for(w+=1;w<c;w++)if(A(n.charCodeAt(w)))return n.slice(0,w+1).replace(/[\\/]/g,o)}}return o}else if(R(m)&&n.charCodeAt(1)===58)return A(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let f=n.indexOf("://");if(f!==-1){for(f+=3;f<c;f++)if(A(n.charCodeAt(f)))return n.slice(0,f+1)}return""}e.getRoot=P;function F(n){if(!t.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let c=2;const m=c;for(;c<n.length&&(o=n.charCodeAt(c),o!==92);c++);return!(m===c||(o=n.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=F;const y=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,o=t.isWindows){const c=o?y:l;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||o&&b.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function v(n,o,c){const m=n===o;return!c||m?m:!n||!o?!1:(0,I.equalsIgnoreCase)(n,o)}e.isEqual=v;function _(n,o,c,m=d.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(c){if(!(0,I.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let w=o.length;return o.charAt(o.length-1)===m&&w--,n.charAt(w)===m}return o.charAt(o.length-1)!==m&&(o+=m),n.indexOf(o)===0}e.isEqualOrParent=_;function R(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=R;function p(n,o){return t.isWindows&&n.endsWith(":")&&(n+=d.sep),(0,d.isAbsolute)(n)||(n=(0,d.join)(o,n)),n=(0,d.normalize)(n),t.isWindows?(n=(0,I.rtrim)(n,d.sep),n.endsWith(":")&&(n+=d.sep)):(n=(0,I.rtrim)(n,d.sep),n||(n=d.sep)),n}e.sanitizeFilePath=p;function h(n){const o=(0,d.normalize)(n);return t.isWindows?n.length>3?!1:s(o)&&(n.length===2||o.charCodeAt(2)===92):o===d.posix.sep}e.isRootOrDriveLetter=h;function s(n,o){return(o!==void 0?o:t.isWindows)?R(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function u(n){return s(n)?n[0]:void 0}e.getDriveLetter=u;function r(n,o,c){return o.length>n.length?-1:n===o?0:(c&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=r;function S(n){const o=n.split(":");let c,m,f;for(const w of o){const T=Number(w);(0,C.isNumber)(T)?m===void 0?m=T:f===void 0&&(f=T):c=c?[c,w].join(":"):w}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(n,o,c=8){let m="";for(let w=0;w<c;w++)m+=a.charAt(Math.floor(Math.random()*a.length));let f;return o?f=`${o}-${m}`:f=m,n?(0,d.join)(n,f):f}e.randomPath=i}),define(ve[25],be([0,1,18]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(R=>{v[R]&&typeof v[R]=="object"?_[R]=t(v[R]):_[R]=v[R]}),_}e.deepClone=t;function I(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const R=_.shift();Object.freeze(R);for(const p in R)if(C.call(R,p)){const h=R[p];typeof h=="object"&&!Object.isFrozen(h)&&_.push(h)}}return v}e.deepFreeze=I;const C=Object.prototype.hasOwnProperty;function A(v,_){return k(v,_,new Set)}e.cloneAndChange=A;function k(v,_,R){if((0,d.isUndefinedOrNull)(v))return v;const p=_(v);if(typeof p!="undefined")return p;if((0,d.isArray)(v)){const h=[];for(const s of v)h.push(k(s,_,R));return h}if((0,d.isObject)(v)){if(R.has(v))throw new Error("Cannot clone recursive data-structure");R.add(v);const h={};for(let s in v)C.call(v,s)&&(h[s]=k(v[s],_,R));return R.delete(v),h}return v}function D(v,_,R=!0){return(0,d.isObject)(v)?((0,d.isObject)(_)&&Object.keys(_).forEach(p=>{p in v?R&&((0,d.isObject)(v[p])&&(0,d.isObject)(_[p])?D(v[p],_[p],R):v[p]=_[p]):v[p]=_[p]}),v):_}e.mixin=D;function P(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let R,p;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(R=0;R<v.length;R++)if(!P(v[R],_[R]))return!1}else{const h=[];for(p in v)h.push(p);h.sort();const s=[];for(p in _)s.push(p);if(s.sort(),!P(h,s))return!1;for(R=0;R<h.length;R++)if(!P(v[h[R]],_[h[R]]))return!1}return!0}e.equals=P;function F(v){const _=new Set;return JSON.stringify(v,(R,p)=>{if((0,d.isObject)(p)||Array.isArray(p)){if(_.has(p))return"[Circular]";_.add(p)}return p})}e.safeStringify=F;function y(v,_,R){const p=_(v);return typeof p=="undefined"?R:p}e.getOrDefault=y;function l(v,_){const R=Object.create(null);return!v||!_||Object.keys(_).forEach(h=>{const s=v[h],u=_[h];P(s,u)||(R[h]=u)}),R}e.distinct=l;function b(v,_){const R=_.toLowerCase(),p=Object.keys(v).find(h=>h.toLowerCase()===R);return p?v[p]:v[_]}e.getCaseInsensitive=b;function g(v,_){const R=Object.create(null);for(const[p,h]of Object.entries(v))_(p,h)&&(R[p]=h);return R}e.filter=g}),define(ve[101],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var d;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d=e.Constants||(e.Constants={}));function t(C){return C<0?0:C>255?255:C|0}e.toUint8=t;function I(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=I}),define(ve[2],be([0,1,9,11]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,C=/^\//,A=/^\/\//;function k(a,i){if(!a.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!I.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!C.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(a,i){return!a&&!i?"file":a}function P(a,i){switch(a){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const F="",y="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(i,n,o,c,m,f=!1){typeof i=="object"?(this.scheme=i.scheme||F,this.authority=i.authority||F,this.path=i.path||F,this.query=i.query||F,this.fragment=i.fragment||F):(this.scheme=D(i,f),this.authority=n||F,this.path=P(this.scheme,o||F),this.query=c||F,this.fragment=m||F,k(this,f))}static isUri(i){return i instanceof b?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return h(this,!1)}with(i){if(!i)return this;let{scheme:n,authority:o,path:c,query:m,fragment:f}=i;return n===void 0?n=this.scheme:n===null&&(n=F),o===void 0?o=this.authority:o===null&&(o=F),c===void 0?c=this.path:c===null&&(c=F),m===void 0?m=this.query:m===null&&(m=F),f===void 0?f=this.fragment:f===null&&(f=F),n===this.scheme&&o===this.authority&&c===this.path&&m===this.query&&f===this.fragment?this:new v(n,o,c,m,f)}static parse(i,n=!1){const o=l.exec(i);return o?new v(o[2]||F,S(o[4]||F),S(o[5]||F),S(o[7]||F),S(o[9]||F),n):new v(F,F,F,F,F)}static file(i){let n=F;if(t.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const o=i.indexOf(y,2);o===-1?(n=i.substring(2),i=y):(n=i.substring(2,o),i=i.substring(o)||y)}return new v("file",n,i,F,F)}static from(i){const n=new v(i.scheme,i.authority,i.path,i.query,i.fragment);return k(n,!0),n}static joinPath(i,...n){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&i.scheme==="file"?o=b.file(d.win32.join(h(i,!0),...n)).path:o=d.posix.join(i.path,...n),i.with({path:o})}toString(i=!1){return s(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof b)return i;{const n=new v(i);return n._formatted=i.external,n._fsPath=i._sep===g?i.fsPath:null,n}}else return i}}e.URI=b;const g=t.isWindows?1:void 0;class v extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(i=!1){return i?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=g),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function R(a,i){let n,o=-1;for(let c=0;c<a.length;c++){const m=a.charCodeAt(c);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||i&&m===47)o!==-1&&(n+=encodeURIComponent(a.substring(o,c)),o=-1),n!==void 0&&(n+=a.charAt(c));else{n===void 0&&(n=a.substr(0,c));const f=_[m];f!==void 0?(o!==-1&&(n+=encodeURIComponent(a.substring(o,c)),o=-1),n+=f):o===-1&&(o=c)}}return o!==-1&&(n+=encodeURIComponent(a.substring(o))),n!==void 0?n:a}function p(a){let i;for(let n=0;n<a.length;n++){const o=a.charCodeAt(n);o===35||o===63?(i===void 0&&(i=a.substr(0,n)),i+=_[o]):i!==void 0&&(i+=a[n])}return i!==void 0?i:a}function h(a,i){let n;return a.authority&&a.path.length>1&&a.scheme==="file"?n=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?i?n=a.path.substr(1):n=a.path[1].toLowerCase()+a.path.substr(2):n=a.path,t.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=h;function s(a,i){const n=i?p:R;let o="",{scheme:c,authority:m,path:f,query:w,fragment:T}=a;if(c&&(o+=c,o+=":"),(m||c==="file")&&(o+=y,o+=y),m){let L=m.indexOf("@");if(L!==-1){const O=m.substr(0,L);m=m.substr(L+1),L=O.indexOf(":"),L===-1?o+=n(O,!1):(o+=n(O.substr(0,L),!1),o+=":",o+=n(O.substr(L+1),!1)),o+="@"}m=m.toLowerCase(),L=m.indexOf(":"),L===-1?o+=n(m,!1):(o+=n(m.substr(0,L),!1),o+=m.substr(L))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const L=f.charCodeAt(1);L>=65&&L<=90&&(f=`/${String.fromCharCode(L+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const L=f.charCodeAt(0);L>=65&&L<=90&&(f=`${String.fromCharCode(L+32)}:${f.substr(2)}`)}o+=n(f,!0)}return w&&(o+="?",o+=n(w,!1)),T&&(o+="#",o+=i?T:R(T,!1)),o}function u(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+u(a.substr(3)):a}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(a){return a.match(r)?a.replace(r,i=>u(i)):a}}),define(ve[59],be([0,1,22,8,2]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(F){return JSON.stringify(F,D)}e.stringify=C;function A(F){let y=JSON.parse(F);return y=P(y),y}e.parse=A;var k;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext",F[F.Date=14]="Date"})(k=e.MarshalledId||(e.MarshalledId={}));function D(F,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function P(F,y=0){if(!F||y>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return I.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof d.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let l=0;l<F.length;++l)F[l]=P(F[l],y+1);else for(const l in F)Object.hasOwnProperty.call(F,l)&&(F[l]=P(F[l],y+1))}return F}e.revive=P}),define(ve[10],be([0,1,11,2]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,F){this._hosts[D]=P,this._ports[D]=F}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let F=this._hosts[P];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const y=this._ports[P],l=this._connectionTokens[P];let b=`path=${encodeURIComponent(D.path)}`;return typeof l=="string"&&(b+=`&tkn=${encodeURIComponent(l)}`),t.URI.from({scheme:d.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${F}:${y}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new C;class A{asBrowserUri(D,P){const F=this.toUri(D,P);return F.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===I.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${I.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?F.with({scheme:I.vscodeFileResource,authority:F.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(D,P){const F=this.toUri(D,P);return F.scheme===I.vscodeFileResource?F.with({scheme:I.file,authority:F.authority!==A.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(D,P){return t.URI.isUri(D)?D:t.URI.parse(P.toUrl(D))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ve[23],be([0,1,28,10,9,11,8,2]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(b){return(0,k.uriToFsPath)(b,!0)}e.originalFSPath=D;class P{constructor(g){this._ignorePathCasing=g}compare(g,v,_=!1){return g===v?0:(0,A.compare)(this.getComparisonKey(g,_),this.getComparisonKey(v,_))}isEqual(g,v,_=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,_)===this.getComparisonKey(v,_)}getComparisonKey(g,v=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,v,_=!1){if(g.scheme===v.scheme){if(g.scheme===t.Schemas.file)return d.isEqualOrParent(D(g),D(v),this._ignorePathCasing(g))&&g.query===v.query&&(_||g.fragment===v.fragment);if((0,e.isEqualAuthority)(g.authority,v.authority))return d.isEqualOrParent(g.path,v.path,this._ignorePathCasing(g),"/")&&g.query===v.query&&(_||g.fragment===v.fragment)}return!1}joinPath(g,...v){return k.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return I.posix.basename(g.path)}extname(g){return I.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===t.Schemas.file?v=k.URI.file(I.dirname(D(g))).path:(v=I.posix.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===t.Schemas.file?v=k.URI.file(I.normalize(D(g))).path:v=I.posix.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.isEqualAuthority)(g.authority,v.authority))return;if(g.scheme===t.Schemas.file){const p=I.relative(D(g),D(v));return C.isWindows?d.toSlashes(p):p}let _=g.path||"/",R=v.path||"/";if(this._ignorePathCasing(g)){let p=0;for(const h=Math.min(_.length,R.length);p<h&&!(_.charCodeAt(p)!==R.charCodeAt(p)&&_.charAt(p).toLowerCase()!==R.charAt(p).toLowerCase());p++);_=R.substr(0,p)+_.substr(p)}return I.posix.relative(_,R)}resolvePath(g,v){if(g.scheme===t.Schemas.file){const _=k.URI.file(I.resolve(D(g),v));return g.with({authority:_.authority,path:_.path})}return v=d.toPosixPath(v),g.with({path:I.posix.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||g!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(g,v)}hasTrailingPathSeparator(g,v=I.sep){if(g.scheme===t.Schemas.file){const _=D(g);return _.length>d.getRoot(_).length&&_[_.length-1]===v}else{const _=g.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=I.sep){return(0,e.hasTrailingPathSeparator)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=I.sep){let _=!1;if(g.scheme===t.Schemas.file){const R=D(g);_=R!==void 0&&R.length===d.getRoot(R).length&&R[R.length-1]===v}else{v="/";const R=g.path;_=R.length===1&&R.charCodeAt(R.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(g,v)?g.with({path:g.path+"/"}):g}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(b=>b.scheme===t.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(b,g){const v=[];for(let _=0;_<b.length;_++){const R=g(b[_]);b.some((p,h)=>h===_?!1:(0,e.isEqualOrParent)(R,g(p)))||v.push(b[_])}return v}e.distinctParents=F;var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function g(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(h=>{const[s,u]=h.split(":");s&&u&&_.set(s,u)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&_.set(b.META_DATA_MIME,p),_}b.parseMetaData=g})(y=e.DataUri||(e.DataUri={}));function l(b,g,v){if(g){let _=b.path;return _&&_[0]!==I.posix.sep&&(_=I.posix.sep+_),b.with({scheme:v,authority:g,path:_})}return b.with({scheme:v})}e.toLocalResource=l}),define(ve[13],be([0,1,21,16,3,6,23,11]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=D;function P(Z){const Q=new d.CancellationTokenSource,oe=Z(Q.token),fe=new Promise((pe,Te)=>{const xe=Q.token.onCancellationRequested(()=>{xe.dispose(),Q.dispose(),Te(new t.CancellationError)});Promise.resolve(oe).then(qe=>{xe.dispose(),Q.dispose(),pe(qe)},qe=>{xe.dispose(),Q.dispose(),Te(qe)})});return new class{cancel(){Q.cancel()}then(pe,Te){return fe.then(pe,Te)}catch(pe){return this.then(void 0,pe)}finally(pe){return fe.finally(pe)}}}e.createCancelablePromise=P;function F(Z,Q,oe){return new Promise((fe,pe)=>{const Te=Q.onCancellationRequested(()=>{Te.dispose(),fe(oe)});Z.then(fe,pe).finally(()=>Te.dispose())})}e.raceCancellation=F;function y(Z,Q){return new Promise((oe,fe)=>{const pe=Q.onCancellationRequested(()=>{pe.dispose(),fe(new t.CancellationError)});Z.then(oe,fe).finally(()=>pe.dispose())})}e.raceCancellationError=y;async function l(Z){let Q=-1;const oe=Z.map((pe,Te)=>pe.then(xe=>(Q=Te,xe))),fe=await Promise.race(oe);return Z.forEach((pe,Te)=>{Te!==Q&&pe.cancel()}),fe}e.raceCancellablePromises=l;function b(Z,Q,oe){let fe;const pe=setTimeout(()=>{fe?.(void 0),oe?.()},Q);return Promise.race([Z.finally(()=>clearTimeout(pe)),new Promise(Te=>fe=Te)])}e.raceTimeout=b;function g(Z){return new Promise((Q,oe)=>{const fe=Z();D(fe)?fe.then(Q,oe):Q(fe)})}e.asPromise=g;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const oe=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(oe,oe).then(fe)})}return new Promise((oe,fe)=>{this.queuedPromise.then(oe,fe)})}return this.activePromise=Q(),new Promise((oe,fe)=>{this.activePromise.then(pe=>{this.activePromise=null,oe(pe)},pe=>{this.activePromise=null,fe(pe)})})}}e.Throttler=v;class _{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=_;class R{constructor(){this.promiseMap=new Map}queue(Q,oe){const pe=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.promiseMap.get(Q)===pe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,pe),pe}}e.SequencerByKey=R;const p=(Z,Q)=>{let oe=!0;const fe=setTimeout(()=>{oe=!1,Q()},Z);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(fe),oe=!1}}},h=Z=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,Z())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,oe=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,Te)=>{this.doResolve=pe,this.doReject=Te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=oe===e.MicrotaskDelay?h(fe):p(oe,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class u{constructor(Q){this.delayer=new s(Q),this.throttler=new v}trigger(Q,oe){return this.delayer.trigger(()=>this.throttler.queue(Q),oe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class r{constructor(){this._isOpen=!1,this._promise=new Promise((Q,oe)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class S extends r{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function a(Z,Q){return Q?new Promise((oe,fe)=>{const pe=setTimeout(()=>{Te.dispose(),oe()},Z),Te=Q.onCancellationRequested(()=>{clearTimeout(pe),Te.dispose(),fe(new t.CancellationError)})}):P(oe=>a(Z,oe))}e.timeout=a;function i(Z,Q=0){const oe=setTimeout(Z,Q);return(0,C.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=i;function n(Z){const Q=[];let oe=0;const fe=Z.length;function pe(){return oe<fe?Z[oe++]():null}function Te(xe){xe!=null&&Q.push(xe);const qe=pe();return qe?qe.then(Te):Promise.resolve(Q)}return Promise.resolve(null).then(Te)}e.sequence=n;function o(Z,Q=fe=>!!fe,oe=null){let fe=0;const pe=Z.length,Te=()=>{if(fe>=pe)return Promise.resolve(oe);const xe=Z[fe++];return Promise.resolve(xe()).then(Qe=>Q(Qe)?Promise.resolve(Qe):Te())};return Te()}e.first=o;function c(Z,Q=fe=>!!fe,oe=null){if(Z.length===0)return Promise.resolve(oe);let fe=Z.length;const pe=()=>{fe=-1;for(const Te of Z)Te.cancel?.()};return new Promise((Te,xe)=>{for(const qe of Z)qe.then(Qe=>{--fe>=0&&Q(Qe)?(pe(),Te(Qe)):fe===0&&Te(oe)}).catch(Qe=>{--fe>=0&&(pe(),xe(Qe))})})}e.firstParallel=c;class m{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((oe,fe)=>{this.outstandingPromises.push({factory:Q,c:oe,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const oe=Q.factory();oe.then(Q.c,Q.e),oe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class f extends m{constructor(){super(1)}}e.Queue=f;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new B;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,oe=A.extUri){const fe=oe.getComparisonKey(Q);let pe=this.queues.get(fe);return pe||(pe=new f,I.Event.once(pe.onFinished)(()=>{pe?.dispose(),this.queues.delete(fe),this.onDidQueueFinish()}),this.queues.set(fe,pe)),pe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class T{constructor(Q,oe){this._token=-1,typeof Q=="function"&&typeof oe=="number"&&this.setIfNotSet(Q,oe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,oe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},oe)}setIfNotSet(Q,oe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},oe))}}e.TimeoutTimer=T;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,oe){this.cancel(),this._token=setInterval(()=>{Q()},oe)}}e.IntervalTimer=L;class O{constructor(Q,oe){this.timeoutToken=-1,this.runner=Q,this.timeout=oe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class E{constructor(Q,oe){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=oe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class M extends O{constructor(Q,oe){super(Q,oe);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class U extends C.Disposable{constructor(Q,oe){super();this.options=Q,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,k.setTimeout0)(()=>{if(Q)return;const oe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(Z,Q)=>{const oe=requestIdleCallback(Z,typeof Q=="number"?{timeout:Q}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(oe))}}}}();class V{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(oe){this._error=oe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function z(Z,Q,oe){let fe;for(let pe=0;pe<oe;pe++)try{return await Z()}catch(Te){fe=Te,await a(Q)}throw fe}e.retry=z;class N{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,oe,fe){return this._pending={taskId:Q,cancel:()=>fe?.(),promise:oe},oe.then(()=>this.donePending(Q),()=>this.donePending(Q)),oe}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let oe,fe;const pe=new Promise((Te,xe)=>{oe=Te,fe=xe});this._next={run:Q,promise:pe,promiseResolve:oe,promiseReject:fe}}return this._next.promise}}e.TaskSequentializer=N;class W{constructor(Q,oe=()=>Date.now()){this.interval=Q,this.nowFn=oe,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,oe)=>{this.completeCallback=Q,this.errorCallback=oe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(oe=>{this.completeCallback(Q),this.resolved=!0,oe()})}error(Q){return new Promise(oe=>{this.errorCallback(Q),this.rejected=!0,oe()})}cancel(){new Promise(Q=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=B;var x;(function(Z){async function Q(fe){let pe;const Te=await Promise.all(fe.map(xe=>xe.then(qe=>qe,qe=>{pe||(pe=qe)})));if(typeof pe!="undefined")throw pe;return Te}Z.settled=Q;function oe(fe){return new Promise(async(pe,Te)=>{try{await fe(pe,Te)}catch(xe){Te(xe)}})}Z.withAsyncBody=oe})(x=e.Promises||(e.Promises={}));var $;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})($||($={}));class J{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const oe={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(Q(oe)),this.resolve()}catch(fe){this.reject(fe)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}static fromArray(Q){return new J(oe=>{oe.emitMany(Q)})}static fromPromise(Q){return new J(async oe=>{oe.emitMany(await Q)})}static fromPromises(Q){return new J(async oe=>{await Promise.all(Q.map(async fe=>oe.emitOne(await fe)))})}static merge(Q){return new J(async oe=>{await Promise.all(Q.map(async fe=>{for await(const pe of fe)oe.emitOne(pe)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,oe){return new J(async fe=>{for await(const pe of Q)fe.emitOne(oe(pe))})}map(Q){return J.map(this,Q)}static filter(Q,oe){return new J(async fe=>{for await(const pe of Q)oe(pe)&&fe.emitOne(pe)})}filter(Q){return J.filter(this,Q)}static coalesce(Q){return J.filter(Q,oe=>!!oe)}coalesce(){return J.coalesce(this)}static async toPromise(Q){const oe=[];for await(const fe of Q)oe.push(fe);return oe}toPromise(){return J.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ne extends J{constructor(Q,oe){super(oe);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function re(Z){const Q=new d.CancellationTokenSource,oe=Z(Q.token);return new ne(Q,async fe=>{const pe=Q.token.onCancellationRequested(()=>{pe.dispose(),Q.dispose(),fe.reject(new t.CancellationError)});try{for await(const Te of oe){if(Q.token.isCancellationRequested)return;fe.emitOne(Te)}pe.dispose(),Q.dispose()}catch(Te){pe.dispose(),Q.dispose(),fe.reject(Te)}})}e.createCancelableAsyncIterable=re}),define(ve[102],be([0,1,13,9]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new d.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),C=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(f,w,T=!1){const L=f||"",O=w||"",E=I.value.collator.compare(L,O);return I.value.collatorIsNumeric&&E===0&&L!==O?L<O?-1:1:E}e.compareFileNames=k;function D(f,w){const T=C.value.collator;return f=f||"",w=w||"",u(T,f,w)}e.compareFileNamesDefault=D;function P(f,w){const T=C.value.collator;return f=f||"",w=w||"",i(f,w)||u(T,f,w)}e.compareFileNamesUpper=P;function F(f,w){const T=C.value.collator;return f=f||"",w=w||"",a(f,w)||u(T,f,w)}e.compareFileNamesLower=F;function y(f,w){return f=f||"",w=w||"",f===w?0:f<w?-1:1}e.compareFileNamesUnicode=y;function l(f,w,T=!1){T||(f=f&&f.toLowerCase(),w=w&&w.toLowerCase());const[L,O]=h(f),[E,M]=h(w);return L!==E?L<E?-1:1:O===M?0:O<M?-1:1}e.noIntlCompareFileNames=l;function b(f,w){const[T,L]=h(f),[O,E]=h(w);let M=I.value.collator.compare(L,E);if(M===0){if(I.value.collatorIsNumeric&&L!==E)return L<E?-1:1;if(M=I.value.collator.compare(T,O),I.value.collatorIsNumeric&&M===0&&T!==O)return T<O?-1:1}return M}e.compareFileExtensions=b;function g(f,w){f=f||"",w=w||"";const T=s(f),L=s(w),O=C.value.collator,E=A.value.collator;return u(E,T,L)||u(O,f,w)}e.compareFileExtensionsDefault=g;function v(f,w){f=f||"",w=w||"";const T=s(f),L=s(w),O=C.value.collator,E=A.value.collator;return u(E,T,L)||i(f,w)||u(O,f,w)}e.compareFileExtensionsUpper=v;function _(f,w){f=f||"",w=w||"";const T=s(f),L=s(w),O=C.value.collator,E=A.value.collator;return u(E,T,L)||a(f,w)||u(O,f,w)}e.compareFileExtensionsLower=_;function R(f,w){f=f||"",w=w||"";const T=s(f).toLowerCase(),L=s(w).toLowerCase();return T!==L?T<L?-1:1:f!==w?f<w?-1:1:0}e.compareFileExtensionsUnicode=R;const p=/^(.*?)(\.([^.]*))?$/;function h(f,w=!1){const T=f?p.exec(f):[];let L=[T&&T[1]||"",T&&T[3]||""];return w&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function s(f){const w=f?p.exec(f):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function u(f,w,T){let L=f.compare(w,T);return L!==0?L:w.length!==T.length?w.length<T.length?-1:1:0}function r(f){const w=f.charAt(0);return w.toLocaleUpperCase()!==w}function S(f){const w=f.charAt(0);return w.toLocaleLowerCase()!==w}function a(f,w){return r(f)&&S(w)?-1:S(f)&&r(w)?1:0}function i(f,w){return S(f)&&r(w)?-1:r(f)&&S(w)?1:0}function n(f,w,T=!1){return T||(f=f&&f.toLowerCase(),w=w&&w.toLowerCase()),f===w?0:f<w?-1:1}function o(f,w,T=!1){const L=f.split(t.sep),O=w.split(t.sep),E=L.length-1,M=O.length-1;let U,V;for(let z=0;;z++){if(U=E===z,V=M===z,U&&V)return k(L[z],O[z],T);if(U)return-1;if(V)return 1;const N=n(L[z],O[z],T);if(N!==0)return N}}e.comparePaths=o;function c(f,w,T){const L=f.toLowerCase(),O=w.toLowerCase(),E=m(f,w,T);if(E)return E;const M=L.endsWith(T),U=O.endsWith(T);if(M!==U)return M?-1:1;const V=k(L,O);return V!==0?V:L.localeCompare(O)}e.compareAnything=c;function m(f,w,T){const L=f.toLowerCase(),O=w.toLowerCase(),E=L.startsWith(T),M=O.startsWith(T);if(E!==M)return E?-1:1;if(E&&M){if(L.length<O.length)return-1;if(L.length>O.length)return 1}return 0}e.compareByPrefix=m}),define(ve[103],be([0,1,102,99,58,9,11,8]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,P=[D,[]];function F(N,W,B,x){if(!N||!W)return P;const $=N.length,J=W.length;if($<J)return P;const ne=N.toLowerCase();return y(W,B,J,N,ne,$,x)}e.scoreFuzzy=F;function y(N,W,B,x,$,J,ne){const re=[],Z=[];for(let pe=0;pe<B;pe++){const Te=pe*J,xe=Te-J,qe=pe>0,Qe=N[pe],q=W[pe];for(let ie=0;ie<J;ie++){const G=ie>0,X=Te+ie,ae=X-1,me=xe+ie-1,De=G?re[ae]:0,Be=qe&&G?re[me]:0,Xe=qe&&G?Z[me]:0;let tt;!Be&&qe?tt=0:tt=l(Qe,q,x,$,ie,Xe),tt&&Be+tt>=De&&(ne||qe||$.startsWith(W,ie))?(Z[X]=Xe+1,re[X]=Be+tt):(Z[X]=D,re[X]=De)}}const Q=[];let oe=B-1,fe=J-1;for(;oe>=0&&fe>=0;){const pe=oe*J+fe;Z[pe]===D||(Q.push(fe),oe--),fe--}return[re[B*J-1],Q.reverse()]}function l(N,W,B,x,$,J){let ne=0;if(!b(W,x[$]))return ne;if(ne+=1,J>0&&(ne+=J*5),N===B[$]&&(ne+=1),$===0)ne+=8;else{const re=g(B.charCodeAt($-1));re?ne+=re:(0,t.isUpper)(B.charCodeAt($))&&J===0&&(ne+=2)}return ne}function b(N,W){return N===W?!0:N==="/"||N==="\\"?W==="/"||W==="\\":!1}function g(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function _(N,W,B=0,x=0){const $=W;return $.values&&$.values.length>1?R(N,$.values,B,x):p(N,W,B,x)}e.scoreFuzzy2=_;function R(N,W,B,x){let $=0;const J=[];for(const ne of W){const[re,Z]=p(N,ne,B,x);if(typeof re!="number")return v;$+=re,J.push(...Z)}return[$,m(J)]}function p(N,W,B,x){const $=(0,t.fuzzyScore)(W.original,W.originalLowercase,B,N,N.toLowerCase(),x,!0);return $?[$[0],(0,t.createMatches)($)]:v}const h=Object.freeze({score:0}),s=1<<18,u=1<<17,r=1<<16;function S(N,W,B,x){const $=x.values?x.values:[x];return(0,I.hash)({[x.normalized]:{values:$.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:N,description:W,allowNonContiguousMatches:B}})}function a(N,W,B,x,$){if(!N||!W.normalized)return h;const J=x.getItemLabel(N);if(!J)return h;const ne=x.getItemDescription(N),re=S(J,ne,B,W),Z=$[re];if(Z)return Z;const Q=i(J,ne,x.getItemPath(N),W,B);return $[re]=Q,Q}e.scoreItemFuzzy=a;function i(N,W,B,x,$){const J=!B||!x.containsPathSeparator;return B&&(A.isLinux?x.pathNormalized===B:(0,k.equalsIgnoreCase)(x.pathNormalized,B))?{score:s,labelMatch:[{start:0,end:N.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:x.values&&x.values.length>1?n(N,W,B,x.values,J,$):o(N,W,B,x,J,$)}function n(N,W,B,x,$,J){let ne=0;const re=[],Z=[];for(const Q of x){const{score:oe,labelMatch:fe,descriptionMatch:pe}=o(N,W,B,Q,$,J);if(oe===D)return h;ne+=oe,fe&&re.push(...fe),pe&&Z.push(...pe)}return{score:ne,labelMatch:m(re),descriptionMatch:m(Z)}}function o(N,W,B,x,$,J){if($||!W){const[ne,re]=F(N,x.normalized,x.normalizedLowercase,J&&!x.expectContiguousMatch);if(ne){const Z=(0,t.matchesPrefix)(x.normalized,N);let Q;return Z?(Q=u,Q+=Math.round(x.normalized.length/N.length*100)):Q=r,{score:Q+ne,labelMatch:Z||c(re)}}}if(W){let ne=W;B&&(ne=`${W}${C.sep}`);const re=ne.length,Z=`${ne}${N}`,[Q,oe]=F(Z,x.normalized,x.normalizedLowercase,J&&!x.expectContiguousMatch);if(Q){const fe=c(oe),pe=[],Te=[];return fe.forEach(xe=>{xe.start<re&&xe.end>re?(pe.push({start:0,end:xe.end-re}),Te.push({start:xe.start,end:re})):xe.start>=re?pe.push({start:xe.start-re,end:xe.end-re}):Te.push(xe)}),{score:Q,labelMatch:pe,descriptionMatch:Te}}}return h}function c(N){const W=[];if(!N)return W;let B;for(const x of N)B&&B.end===x?B.end+=1:(B={start:x,end:x+1},W.push(B));return W}function m(N){const W=N.sort(($,J)=>$.start-J.start),B=[];let x;for(const $ of W)!x||!f(x,$)?(x=$,B.push($)):(x.start=Math.min(x.start,$.start),x.end=Math.max(x.end,$.end));return B}function f(N,W){return!(N.end<W.start||W.end<N.start)}function w(N,W,B,x,$,J){const ne=a(N,B,x,$,J),re=a(W,B,x,$,J),Z=ne.score,Q=re.score;if((Z===s||Q===s)&&Z!==Q)return Z===s?-1:1;if(Z>r||Q>r){if(Z!==Q)return Z>Q?-1:1;if(Z<u&&Q<u){const Qe=L(ne.labelMatch,re.labelMatch);if(Qe!==0)return Qe}const xe=$.getItemLabel(N)||"",qe=$.getItemLabel(W)||"";if(xe.length!==qe.length)return xe.length-qe.length}if(Z!==Q)return Z>Q?-1:1;const oe=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,fe=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(oe&&!fe)return-1;if(fe&&!oe)return 1;const pe=T(N,ne,$),Te=T(W,re,$);return pe&&Te&&pe!==Te?Te>pe?-1:1:O(N,W,B,$)}e.compareItemsByFuzzyScore=w;function T(N,W,B){let x=-1,$=-1;if(W.descriptionMatch&&W.descriptionMatch.length?x=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(x=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if($=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const J=B.getItemDescription(N);J&&($+=J.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&($=W.descriptionMatch[W.descriptionMatch.length-1].end);return $-x}function L(N,W){if(!N&&!W||(!N||!N.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!N||!N.length)return 1;const B=N[0].start,$=N[N.length-1].end-B,J=W[0].start,re=W[W.length-1].end-J;return $===re?0:re<$?1:-1}function O(N,W,B,x){const $=x.getItemLabel(N)||"",J=x.getItemLabel(W)||"",ne=x.getItemDescription(N),re=x.getItemDescription(W),Z=$.length+(ne?ne.length:0),Q=J.length+(re?re.length:0);if(Z!==Q)return Z-Q;const oe=x.getItemPath(N),fe=x.getItemPath(W);return oe&&fe&&oe.length!==fe.length?oe.length-fe.length:$!==J?(0,d.compareAnything)($,J,B.normalized):ne&&re&&ne!==re?(0,d.compareAnything)(ne,re,B.normalized):oe&&fe&&oe!==fe?(0,d.compareAnything)(oe,fe,B.normalized):0}function E(N){return N.startsWith('"')&&N.endsWith('"')}const M=" ";function U(N){typeof N!="string"&&(N="");const W=N.toLowerCase(),{pathNormalized:B,normalized:x,normalizedLowercase:$}=V(N),J=B.indexOf(C.sep)>=0,ne=E(N);let re;const Z=N.split(M);if(Z.length>1)for(const Q of Z){const oe=E(Q),{pathNormalized:fe,normalized:pe,normalizedLowercase:Te}=V(Q);pe&&(re||(re=[]),re.push({original:Q,originalLowercase:Q.toLowerCase(),pathNormalized:fe,normalized:pe,normalizedLowercase:Te,expectContiguousMatch:oe}))}return{original:N,originalLowercase:W,pathNormalized:B,normalized:x,normalizedLowercase:$,values:re,containsPathSeparator:J,expectContiguousMatch:ne}}e.prepareQuery=U;function V(N){let W;A.isWindows?W=N.replace(/\//g,C.sep):W=N.replace(/\\/g,C.sep);const B=(0,k.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:B,normalizedLowercase:B.toLowerCase()}}function z(N){return Array.isArray(N)?U(N.map(W=>W.original).join(M)):U(N.original)}e.pieceToQuery=z}),define(ve[32],be([0,1,13,28,24,9,11,8]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",F="[^/\\\\]",y=/\//g;function l(B){switch(B){case 0:return"";case 1:return`${F}*?`;default:return`(?:${P}|${F}+${P}|${P}${F}+)*?`}}function b(B,x){if(!B)return[];const $=[];let J=!1,ne=!1,re="";for(const Z of B){switch(Z){case x:if(!J&&!ne){$.push(re),re="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}re+=Z}return re&&$.push(re),$}e.splitGlobAware=b;function g(B){if(!B)return"";let x="";const $=b(B,e.GLOB_SPLIT);if($.every(J=>J===e.GLOBSTAR))x=".*";else{let J=!1;$.forEach((ne,re)=>{if(ne===e.GLOBSTAR){J||(x+=l(2),J=!0);return}let Z=!1,Q="",oe=!1,fe="";for(const pe of ne){if(pe!=="}"&&Z){Q+=pe;continue}if(oe&&(pe!=="]"||!fe)){let Te;pe==="-"?Te=pe:(pe==="^"||pe==="!")&&!fe?Te="^":pe===e.GLOB_SPLIT?Te="":Te=(0,k.escapeRegExpCharacters)(pe),fe+=Te;continue}switch(pe){case"{":Z=!0;continue;case"[":oe=!0;continue;case"}":{x+=`(?:${b(Q,",").map(qe=>g(qe)).join("|")})`,Z=!1,Q="";break}case"]":x+="["+fe+"]",oe=!1,fe="";break;case"?":x+=F;continue;case"*":x+=l(1);continue;default:x+=(0,k.escapeRegExpCharacters)(pe)}}re<$.length-1&&($[re+1]!==e.GLOBSTAR||re+2<$.length)&&(x+=P),J=!1})}return x}const v=/^\*\*\/\*\.[\w\.-]+$/,_=/^\*\*\/([\w\.-]+)\/?$/,R=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new I.LRUCache(1e4),r=function(){return!1},S=function(){return null};function a(B,x){if(!B)return S;let $;typeof B!="string"?$=B.pattern:$=B,$=$.trim();const J=`${$}_${!!x.trimForExclusions}`;let ne=u.get(J);if(ne)return i(ne,B);let re;if(v.test($)){const Z=$.substr(4);ne=function(Q,oe){return typeof Q=="string"&&Q.endsWith(Z)?$:null}}else(re=_.exec(n($,x)))?ne=o(re[1],$):(x.trimForExclusions?p:R).test($)?ne=c($,x):(re=h.exec(n($,x)))?ne=m(re[1].substr(1),$,!0):(re=s.exec(n($,x)))?ne=m(re[1],$,!1):ne=f($);return u.set(J,ne),i(ne,B)}function i(B,x){return typeof x=="string"?B:function($,J){return(0,t.isEqualOrParent)($,x.base,!A.isLinux)?B($.substr(x.base.length+1),J):null}}function n(B,x){return x.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function o(B,x){const $=`/${B}`,J=`\\${B}`,ne=function(Z,Q){return typeof Z!="string"?null:Q?Q===B?x:null:Z===B||Z.endsWith($)||Z.endsWith(J)?x:null},re=[B];return ne.basenames=re,ne.patterns=[x],ne.allBasenames=re,ne}function c(B,x){const $=W(B.slice(1,-1).split(",").map(Q=>a(Q,x)).filter(Q=>Q!==S),B),J=$.length;if(!J)return S;if(J===1)return $[0];const ne=function(Q,oe){for(let fe=0,pe=$.length;fe<pe;fe++)if($[fe](Q,oe))return B;return null},re=$.find(Q=>!!Q.allBasenames);re&&(ne.allBasenames=re.allBasenames);const Z=$.reduce((Q,oe)=>oe.allPaths?Q.concat(oe.allPaths):Q,[]);return Z.length&&(ne.allPaths=Z),ne}function m(B,x,$){const J=C.sep===C.posix.sep,ne=J?B:B.replace(y,C.sep),re=C.sep+ne,Z=C.posix.sep+B,Q=$?function(oe,fe){return typeof oe=="string"&&(oe===ne||oe.endsWith(re)||!J&&(oe===B||oe.endsWith(Z)))?x:null}:function(oe,fe){return typeof oe=="string"&&(oe===ne||!J&&oe===B)?x:null};return Q.allPaths=[($?"*/":"./")+B],Q}function f(B){try{const x=new RegExp(`^${g(B)}$`);return function($){return x.lastIndex=0,typeof $=="string"&&x.test($)?B:null}}catch{return S}}function w(B,x,$){return!B||typeof x!="string"?!1:T(B)(x,void 0,$)}e.match=w;function T(B,x={}){if(!B)return r;if(typeof B=="string"||M(B)){const $=a(B,x);if($===S)return r;const J=function(ne,re){return!!$(ne,re)};return $.allBasenames&&(J.allBasenames=$.allBasenames),$.allPaths&&(J.allPaths=$.allPaths),J}return z(B,x)}e.parse=T;function L(B){if(!B)return;let x;return $=>(x||(x=(B()||Promise.resolve([])).then(J=>J?E(J):{})),x.then(J=>!!J[$]))}e.hasSiblingPromiseFn=L;function O(B){if(!B)return;let x;return $=>{if(!x){const J=B();x=J?E(J):{}}return!!x[$]}}e.hasSiblingFn=O;function E(B){const x={};for(const $ of B)x[$]=!0;return x}function M(B){const x=B;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=M;function U(B){return B.allBasenames||[]}e.getBasenameTerms=U;function V(B){return B.allPaths||[]}e.getPathTerms=V;function z(B,x){const $=W(Object.getOwnPropertyNames(B).map(Q=>N(Q,B[Q],x)).filter(Q=>Q!==S)),J=$.length;if(!J)return S;if(!$.some(Q=>!!Q.requiresSiblings)){if(J===1)return $[0];const Q=function(pe,Te){for(let xe=0,qe=$.length;xe<qe;xe++){const Qe=$[xe](pe,Te);if(Qe)return Qe}return null},oe=$.find(pe=>!!pe.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const fe=$.reduce((pe,Te)=>Te.allPaths?pe.concat(Te.allPaths):pe,[]);return fe.length&&(Q.allPaths=fe),Q}const ne=function(Q,oe,fe){let pe;for(let Te=0,xe=$.length;Te<xe;Te++){const qe=$[Te];qe.requiresSiblings&&fe&&(oe||(oe=(0,C.basename)(Q)),pe||(pe=oe.substr(0,oe.length-(0,C.extname)(Q).length)));const Qe=qe(Q,oe,pe,fe);if(Qe)return Qe}return null},re=$.find(Q=>!!Q.allBasenames);re&&(ne.allBasenames=re.allBasenames);const Z=$.reduce((Q,oe)=>oe.allPaths?Q.concat(oe.allPaths):Q,[]);return Z.length&&(ne.allPaths=Z),ne}function N(B,x,$){if(x===!1)return S;const J=a(B,$);if(J===S)return S;if(typeof x=="boolean")return J;if(x){const ne=x.when;if(typeof ne=="string"){const re=(Z,Q,oe,fe)=>{if(!fe||!J(Z,Q))return null;const pe=ne.replace("$(basename)",oe),Te=fe(pe);return(0,d.isThenable)(Te)?Te.then(xe=>xe?B:null):Te?B:null};return re.requiresSiblings=!0,re}}return J}function W(B,x){const $=B.filter(Q=>!!Q.basenames);if($.length<2)return B;const J=$.reduce((Q,oe)=>{const fe=oe.basenames;return fe?Q.concat(fe):Q},[]);let ne;if(x){ne=[];for(let Q=0,oe=J.length;Q<oe;Q++)ne.push(x)}else ne=$.reduce((Q,oe)=>{const fe=oe.patterns;return fe?Q.concat(fe):Q},[]);const re=function(Q,oe){if(typeof Q!="string")return null;if(!oe){let pe;for(pe=Q.length;pe>0;pe--){const Te=Q.charCodeAt(pe-1);if(Te===47||Te===92)break}oe=Q.substr(pe)}const fe=J.indexOf(oe);return fe!==-1?ne[fe]:null};re.basenames=J,re.patterns=ne,re.allBasenames=J;const Z=B.filter(Q=>!Q.basenames);return Z.push(re),Z}}),define(ve[79],be([0,1,28,10,9,11,23,8,2]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,n,o){if(typeof i=="string"&&(i=D.URI.file(i)),o){const m=o.getWorkspaceFolder(i);if(m){const f=o.getWorkspace().folders.length>1;let w;if((0,A.isEqual)(m.uri,i)?w="":w=(0,A.relativePath)(m.uri,i),f){const T=m.name?m.name:(0,A.basename)(m.uri);w=w?T+" \u2022 "+w:T}return w}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(i.fsPath))return(0,I.normalize)(y(i.fsPath));let c=(0,I.normalize)(i.fsPath);return!C.isWindows&&n?.userHome&&(c=b(c,n.userHome.fsPath)),c}e.getPathLabel=P;function F(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const n=(0,A.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,d.isRootOrDriveLetter)(n)?y(n):n}e.getBaseLabel=F;function y(i,n){return(0,d.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let l=Object.create(null);function b(i,n){if(C.isWindows||!i||!n)return i;let o=l.original===n?l.normalized:void 0;return o||(o=`${(0,k.rtrim)(n,I.posix.sep)}${I.posix.sep}`,l={original:n,normalized:o}),(C.isLinux?i.startsWith(o):(0,k.startsWithIgnoreCase)(i,o))&&(i=`~/${i.substr(o.length)}`),i}e.tildify=b;function g(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=g;const v="\u2026",_="\\\\",R="~";function p(i,n=I.sep){const o=new Array(i.length);let c=!1;for(let m=0;m<i.length;m++){let f=i[m];if(f===""){o[m]=`.${n}`;continue}if(!f){o[m]=f;continue}c=!0;let w="";f.indexOf(_)===0?(w=f.substr(0,f.indexOf(_)+_.length),f=f.substr(f.indexOf(_)+_.length)):f.indexOf(n)===0?(w=f.substr(0,f.indexOf(n)+n.length),f=f.substr(f.indexOf(n)+n.length)):f.indexOf(R)===0&&(w=f.substr(0,f.indexOf(R)+R.length),f=f.substr(f.indexOf(R)+R.length));const T=f.split(n);for(let L=1;c&&L<=T.length;L++)for(let O=T.length-L;c&&O>=0;O--){c=!1;let E=T.slice(O,O+L).join(n);for(let M=0;!c&&M<i.length;M++)if(M!==m&&i[M]&&i[M].indexOf(E)>-1){const U=O+L===T.length,V=O>0&&i[M].indexOf(n)>-1?n+E:E,z=i[M].endsWith(V);c=!U||z}if(!c){let M="";(T[0].endsWith(":")||w!=="")&&(O===1&&(O=0,L++,E=T[0]+n+E),O>0&&(M=T[0]+n),M=w+M),O>0&&(M=M+v+n),M=M+E,O+L<T.length&&(M=M+n+v),o[m]=M}}c&&(o[m]=f)}return o}e.shorten=p;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function s(i,n=Object.create(null)){const o=[];let c=!1,m="";for(const f of i)if(f==="$"||c&&f==="{")m&&o.push({value:m,type:h.TEXT}),m="",c=!0;else if(f==="}"&&c){const w=n[m];if(typeof w=="string")w.length&&o.push({value:w,type:h.VARIABLE});else if(w){const T=o[o.length-1];(!T||T.type!==h.SEPARATOR)&&o.push({value:w.label,type:h.SEPARATOR})}m="",c=!1}else m+=f;return m&&!c&&o.push({value:m,type:h.TEXT}),o.filter((f,w)=>{if(f.type===h.SEPARATOR){const T=o[w-1],L=o[w+1];return[T,L].every(O=>O&&(O.type===h.VARIABLE||O.type===h.TEXT)&&O.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=s;function u(i,n){return C.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function r(i,n){return C.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function a(i){const n=i.indexOf("/")!==-1?I.posix:I.win32,o=n.basename(i),c=n.dirname(i);return o.length?{name:o,parentPath:c}:{name:c,parentPath:""}}e.splitName=a}),define(ve[104],be([0,1,2]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class I{constructor(y){this._uriTransformer=y}transformIncoming(y){const l=this._uriTransformer.transformIncoming(y);return l===y?y:t(d.URI.from(l))}transformOutgoing(y){const l=this._uriTransformer.transformOutgoing(y);return l===y?y:t(d.URI.from(l))}transformOutgoingURI(y){const l=this._uriTransformer.transformOutgoing(y);return l===y?y:d.URI.from(l)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function C(F,y,l){if(!F||l>200)return null;if(typeof F=="object"){if(F instanceof d.URI)return y.transformOutgoing(F);for(let b in F)if(Object.hasOwnProperty.call(F,b)){const g=C(F[b],y,l+1);g!==null&&(F[b]=g)}}return null}function A(F,y){const l=C(F,y,0);return l===null?F:l}e.transformOutgoingURIs=A;function k(F,y,l,b){if(!F||b>200)return null;if(typeof F=="object"){if(F.$mid===1)return l?d.URI.revive(y.transformIncoming(F)):y.transformIncoming(F);for(let g in F)if(Object.hasOwnProperty.call(F,g)){const v=k(F[g],y,l,b+1);v!==null&&(F[g]=v)}}return null}function D(F,y){const l=k(F,y,!1,0);return l===null?F:l}e.transformIncomingURIs=D;function P(F,y){const l=k(F,y,!0,0);return l===null?F:l}e.transformAndReviveIncomingURIs=P}),define(ve[33],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return d.test(D)}e.isUUID=t;const I=new Uint8Array(16),C=[];for(let D=0;D<256;D++)C.push(D.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){A(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,P="";return P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P}e.generateUuid=k}),define(ve[144],be([0,1,105]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(C="utf8"){this.stringDecoder=new d.StringDecoder(C),this.remaining=null}write(C){const A=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return A;let D=0,P,F=D;for(;F<k.length;)if(P=k.charCodeAt(F),P===13||P===10){if(A.push(k.substring(D,F)),F++,F<k.length){const y=P;P=k.charCodeAt(F),(y===13&&P===10||y===10&&P===13)&&F++}D=F}else F++;return this.remaining=D<k.length?k.substr(D):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(ve[29],be([0,1,60,80,292,13,28,78,9,11,23,2]),function(ee,e,d,t,I,C,A,k,D,P,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var l;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(l=e.RimRafMode||(e.RimRafMode={}));async function b(U,V=l.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return V===l.UNLINK?v(U):g(U)}async function g(U){try{const V=(0,A.randomPath)((0,t.tmpdir)());try{await d.promises.rename(U,V)}catch{return v(U)}v(V).catch(z=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function v(U){return(0,I.promisify)(d.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function _(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");d.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=_;async function R(U,V){return s(await(V?p(U):(0,I.promisify)(d.readdir)(U)))}async function p(U){try{return await(0,I.promisify)(d.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const V=[],z=await R(U);for(const N of z){let W=!1,B=!1,x=!1;try{const $=await e.Promises.lstat((0,D.join)(U,N));W=$.isFile(),B=$.isDirectory(),x=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}V.push({name:N,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>x})}return V}function h(U){return s(d.readdirSync(U))}e.readdirSync=h;function s(U){return U.map(V=>typeof V=="string"?P.isMacintosh?(0,k.normalizeNFC)(V):V:(V.name=P.isMacintosh?(0,k.normalizeNFC)(V.name):V.name,V))}async function u(U){const V=await R(U),z=[];for(const N of V)await S.existsDirectory((0,D.join)(U,N))&&z.push(N);return z}function r(U,V=1e3){return new Promise(z=>{let N=!1;const W=setInterval(()=>{N||(N=!0,d.access(U,B=>{N=!1,B&&(clearInterval(W),z(void 0))}))},V)})}e.whenDeleted=r;var S;(function(U){async function V(W){let B;try{if(B=await e.Promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(P.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw $}throw x}}U.stat=V;async function z(W){try{const{stat:B,symbolicLink:x}=await U.stat(W);return B.isFile()&&x?.dangling!==!0}catch{}return!1}U.existsFile=z;async function N(W){try{const{stat:B,symbolicLink:x}=await U.stat(W);return B.isDirectory()&&x?.dangling!==!0}catch{}return!1}U.existsDirectory=N})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new C.ResourceQueue;function i(U,V,z){return a.queueFor(y.URI.file(U),F.extUriBiasedIgnorePathCase).queue(()=>{const N=m(z);return new Promise((W,B)=>o(U,V,N,x=>x?B(x):W()))})}let n=!0;function o(U,V,z,N){if(!n)return d.writeFile(U,V,{mode:z.mode,flag:z.flag},N);d.open(U,z.flag,z.mode,(W,B)=>{if(W)return N(W);d.writeFile(B,V,x=>{if(x)return d.close(B,()=>N(x));d.fdatasync(B,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),n=!1),d.close(B,J=>N(J))))})})}function c(U,V,z){const N=m(z);if(!n)return d.writeFileSync(U,V,{mode:N.mode,flag:N.flag});const W=d.openSync(U,N.flag,N.mode);try{d.writeFileSync(W,V);try{d.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),n=!1}}finally{d.closeSync(W)}}e.writeFileSync=c;function m(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function f(U,V){if(U===V)return;async function z(N){try{const W=await e.Promises.lstat(N);if(W.isDirectory()||W.isSymbolicLink())return;await e.Promises.utimes(N,W.atime,new Date)}catch{}}try{await e.Promises.rename(U,V),await z(V)}catch(N){if(U.toLowerCase()!==V.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await w(U,V,{preserveSymlinks:!1}),await b(U,l.MOVE),await z(V);else throw N}}async function w(U,V,z){return L(U,V,{root:{source:U,target:V},options:z,handledSourcePaths:new Set})}const T=511;async function L(U,V,z){if(z.handledSourcePaths.has(U))return;z.handledSourcePaths.add(U);const{stat:N,symbolicLink:W}=await S.stat(U);if(W){if(z.options.preserveSymlinks)try{return await M(U,V,z)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(W.dangling)return}return N.isDirectory()?O(U,V,N.mode&T,z):E(U,V,N.mode&T)}async function O(U,V,z,N){await e.Promises.mkdir(V,{recursive:!0,mode:z});const W=await R(U);for(const B of W)await L((0,D.join)(U,B),(0,D.join)(V,B),N)}async function E(U,V,z){await e.Promises.copyFile(U,V),await e.Promises.chmod(V,z)}async function M(U,V,z){let N=await e.Promises.readlink(U);(0,A.isEqualOrParent)(N,z.root.source,!P.isLinux)&&(N=(0,D.join)(z.root.target,N.substr(z.root.source.length+1))),await e.Promises.symlink(N,V)}e.Promises=new class{get access(){return(0,I.promisify)(d.access)}get stat(){return(0,I.promisify)(d.stat)}get lstat(){return(0,I.promisify)(d.lstat)}get utimes(){return(0,I.promisify)(d.utimes)}get read(){return(U,V,z,N,W)=>new Promise((B,x)=>{d.read(U,V,z,N,W,($,J,ne)=>$?x($):B({bytesRead:J,buffer:ne}))})}get readFile(){return(0,I.promisify)(d.readFile)}get write(){return(U,V,z,N,W)=>new Promise((B,x)=>{d.write(U,V,z,N,W,($,J,ne)=>$?x($):B({bytesWritten:J,buffer:ne}))})}get appendFile(){return(0,I.promisify)(d.appendFile)}get fdatasync(){return(0,I.promisify)(d.fdatasync)}get truncate(){return(0,I.promisify)(d.truncate)}get rename(){return(0,I.promisify)(d.rename)}get copyFile(){return(0,I.promisify)(d.copyFile)}get open(){return(0,I.promisify)(d.open)}get close(){return(0,I.promisify)(d.close)}get symlink(){return(0,I.promisify)(d.symlink)}get readlink(){return(0,I.promisify)(d.readlink)}get chmod(){return(0,I.promisify)(d.chmod)}get mkdir(){return(0,I.promisify)(d.mkdir)}get unlink(){return(0,I.promisify)(d.unlink)}get rmdir(){return(0,I.promisify)(d.rmdir)}get realpath(){return(0,I.promisify)(d.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return R}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return b}get move(){return f}get copy(){return w}}}),define(ve[106],be([0,1,60,9,11,8,29]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(l){if(I.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const g=((0,t.basename)(l)||l).toLowerCase();try{const _=(0,A.readdirSync)(b).filter(R=>R.toLowerCase()===g);if(_.length===1){const R=k(b);if(R)return(0,t.join)(R,_[0])}else if(_.length>1){const R=_.indexOf(g);if(R>=0){const p=k(b);if(p)return(0,t.join)(p,_[R])}}}catch{}return null}e.realcaseSync=k;async function D(l){if(I.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const g=((0,t.basename)(l)||l).toLowerCase();try{const _=(await A.Promises.readdir(b)).filter(R=>R.toLowerCase()===g);if(_.length===1){const R=await D(b);if(R)return(0,t.join)(R,_[0])}else if(_.length>1){const R=_.indexOf(g);if(R>=0){const p=await D(b);if(p)return(0,t.join)(p,_[R])}}}catch{}return null}e.realcase=D;async function P(l){try{return await A.Promises.realpath(l)}catch{const g=y(l);return await A.Promises.access(g,d.constants.R_OK),g}}e.realpath=P;function F(l){try{return d.realpathSync(l)}catch{const g=y(l);return d.accessSync(g,d.constants.R_OK),g}}e.realpathSync=F;function y(l){return(0,C.rtrim)((0,t.normalize)(l),t.sep)}});var je=this&&this.__decorate||function(ee,e,d,t){var I=arguments.length,C=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,d):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(ee,e,d,t);else for(var k=ee.length-1;k>=0;k--)(A=ee[k])&&(C=(I<3?A(C):I>3?A(e,d,C):A(e,d))||C);return I>3&&C&&Object.defineProperty(e,d,C),C};define(ve[107],be([0,1,17,13,22,21,56,16,3,6,59,8,18]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function g(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(R||(R={}));class p{constructor(x){this.buffer=x,this.pos=0}read(x){const $=this.buffer.slice(this.pos,this.pos+x);return this.pos+=$.byteLength,$}}class h{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var s;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(s||(s={}));function u(B){const x=I.VSBuffer.alloc(4);return x.writeUInt32BE(B,0),x}function r(B){return B.read(4).readUInt32BE(0)}function S(B){const x=I.VSBuffer.alloc(1);return x.writeUInt8(B,0),x}const a={Undefined:S(s.Undefined),String:S(s.String),Buffer:S(s.Buffer),VSBuffer:S(s.VSBuffer),Array:S(s.Array),Object:S(s.Object)},i=typeof Buffer!="undefined";function n(B,x){if(typeof x=="undefined")B.write(a.Undefined);else if(typeof x=="string"){const $=I.VSBuffer.fromString(x);B.write(a.String),B.write(u($.byteLength)),B.write($)}else if(i&&Buffer.isBuffer(x)){const $=I.VSBuffer.wrap(x);B.write(a.Buffer),B.write(u($.byteLength)),B.write($)}else if(x instanceof I.VSBuffer)B.write(a.VSBuffer),B.write(u(x.byteLength)),B.write(x);else if(Array.isArray(x)){B.write(a.Array),B.write(u(x.length));for(const $ of x)n(B,$)}else{const $=I.VSBuffer.fromString(JSON.stringify(x));B.write(a.Object),B.write(u($.byteLength)),B.write($)}}function o(B){switch(B.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return B.read(r(B)).toString();case s.Buffer:return B.read(r(B)).buffer;case s.VSBuffer:return B.read(r(B));case s.Array:{const $=r(B),J=[];for(let ne=0;ne<$;ne++)J.push(o(B));return J}case s.Object:return JSON.parse(B.read(r(B)).toString())}}class c{constructor(x,$,J=null,ne=1e3){this.protocol=x,this.ctx=$,this.logger=J,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel(x,$){this.channels.set(x,$),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const $=this.send([x.type]);this.logger&&this.logger.logOutgoing($,0,1,_(x.type));return}case 201:case 202:case 204:case 203:{const $=this.send([x.type,x.id],x.data);this.logger&&this.logger.logOutgoing($,x.id,1,_(x.type),x.data);return}}}send(x,$=void 0){const J=new h;return n(J,x),n(J,$),this.sendBuffer(J.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const $=new p(x),J=o($),ne=o($),re=J[0];switch(re){case 100:return this.logger&&this.logger.logIncoming(x.byteLength,J[1],1,`${g(re)}: ${J[2]}.${J[3]}`,ne),this.onPromise({type:re,id:J[1],channelName:J[2],name:J[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(x.byteLength,J[1],1,`${g(re)}: ${J[2]}.${J[3]}`,ne),this.onEventListen({type:re,id:J[1],channelName:J[2],name:J[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(x.byteLength,J[1],1,`${g(re)}`),this.disposeActiveRequest({type:re,id:J[1]});case 103:return this.logger&&this.logger.logIncoming(x.byteLength,J[1],1,`${g(re)}`),this.disposeActiveRequest({type:re,id:J[1]})}}onPromise(x){const $=this.channels.get(x.channelName);if(!$){this.collectPendingRequest(x);return}const J=new C.CancellationTokenSource;let ne;try{ne=$.call(this.ctx,x.name,x.arg,J.token)}catch(Q){ne=Promise.reject(Q)}const re=x.id;ne.then(Q=>{this.sendResponse({id:re,data:Q,type:201}),this.activeRequests.delete(x.id)},Q=>{Q instanceof Error?this.sendResponse({id:re,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:re,data:Q,type:203}),this.activeRequests.delete(x.id)});const Z=(0,P.toDisposable)(()=>J.cancel());this.activeRequests.set(x.id,Z)}onEventListen(x){const $=this.channels.get(x.channelName);if(!$){this.collectPendingRequest(x);return}const J=x.id,re=$.listen(this.ctx,x.name,x.arg)(Z=>this.sendResponse({id:J,data:Z,type:204}));this.activeRequests.set(x.id,re)}disposeActiveRequest(x){const $=this.activeRequests.get(x.id);$&&($.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let $=this.pendingRequests.get(x.channelName);$||($=[],this.pendingRequests.set(x.channelName,$));const J=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:x,timeoutTimer:J})}flushPendingRequests(x){const $=this.pendingRequests.get(x);if($){for(const J of $)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var m;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(x,$=null){this.protocol=x,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=$}getChannel(x){const $=this;return{call(J,ne,re){return $.isDisposed?Promise.reject(k.canceled()):$.requestPromise(x,J,ne,re)},listen(J,ne){return $.isDisposed?Promise.reject(k.canceled()):$.requestEvent(x,J,ne)}}}requestPromise(x,$,J,ne=C.CancellationToken.None){const re=this.lastRequestId++,Q={id:re,type:100,channelName:x,name:$,arg:J};if(ne.isCancellationRequested)return Promise.reject(k.canceled());let oe;return new Promise((pe,Te)=>{if(ne.isCancellationRequested)return Te(k.canceled());const xe=()=>{const ie=G=>{switch(G.type){case 201:this.handlers.delete(re),pe(G.data);break;case 202:{this.handlers.delete(re);const X=new Error(G.data.message);X.stack=G.data.stack,X.name=G.data.name,Te(X);break}case 203:this.handlers.delete(re),Te(G.data);break}};this.handlers.set(re,ie),this.sendRequest(Q)};let qe=null;this.state===R.Idle?xe():(qe=(0,t.createCancelablePromise)(ie=>this.whenInitialized()),qe.then(()=>{qe=null,xe()}));const Qe=()=>{qe?(qe.cancel(),qe=null):this.sendRequest({id:re,type:101}),Te(k.canceled())},q=ne.onCancellationRequested(Qe);oe=(0,P.combinedDisposable)((0,P.toDisposable)(Qe),q),this.activeRequests.add(oe)}).finally(()=>{this.activeRequests.delete(oe)})}requestEvent(x,$,J){const ne=this.lastRequestId++,Z={id:ne,type:102,channelName:x,name:$,arg:J};let Q=null;const oe=new D.Emitter({onFirstListenerAdd:()=>{Q=(0,t.createCancelablePromise)(pe=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(oe),this.sendRequest(Z)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(oe),this.sendRequest({id:ne,type:103}))}}),fe=pe=>oe.fire(pe.data);return this.handlers.set(ne,fe),oe.event}sendRequest(x){switch(x.type){case 100:case 102:{const $=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing($,x.id,0,`${g(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const $=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing($,x.id,0,g(x.type));return}}}send(x,$=void 0){const J=new h;return n(J,x),n(J,$),this.sendBuffer(J.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const $=new p(x),J=o($),ne=o($),re=J[0];switch(re){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,_(re)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,J[1],0,_(re),ne),this.onResponse({type:J[0],id:J[1],data:ne})}}onResponse(x){if(x.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(x.id);$&&$(x)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}je([A.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class w{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:$,onDidClientDisconnect:J})=>{D.Event.once($.onMessage)(re=>{const Z=new p(re),Q=o(Z),oe=new c($,Q),fe=new f($);this.channels.forEach((Te,xe)=>oe.registerChannel(xe,Te));const pe={channelServer:oe,channelClient:fe,ctx:Q};this._connections.add(pe),this._onDidAddConnection.fire(pe),J(()=>{oe.dispose(),fe.dispose(),this._connections.delete(pe),this._onDidRemoveConnection.fire(pe)})})})}get connections(){const x=[];return this._connections.forEach($=>x.push($)),x}getChannel(x,$){const J=this;return{call(ne,re,Z){let Q;if((0,l.isFunction)($)){let fe=(0,d.getRandomElement)(J.connections.filter($));Q=fe?Promise.resolve(fe):D.Event.toPromise(D.Event.filter(J.onDidAddConnection,$))}else Q=$.routeCall(J,ne,re);const oe=Q.then(fe=>fe.channelClient.getChannel(x));return L(oe).call(ne,re,Z)},listen(ne,re){if((0,l.isFunction)($))return J.getMulticastEvent(x,$,ne,re);const Z=$.routeEvent(J,ne,re).then(Q=>Q.channelClient.getChannel(x));return L(Z).listen(ne,re)}}}getMulticastEvent(x,$,J,ne){const re=this;let Z=new P.DisposableStore;const Q=new D.Emitter({onFirstListenerAdd:()=>{Z=new P.DisposableStore;const oe=new D.EventMultiplexer,fe=new Map,pe=xe=>{const Qe=xe.channelClient.getChannel(x).listen(J,ne),q=oe.add(Qe);fe.set(xe,q)},Te=xe=>{const qe=fe.get(xe);!qe||(qe.dispose(),fe.delete(xe))};re.connections.filter($).forEach(pe),D.Event.filter(re.onDidAddConnection,$)(pe,void 0,Z),re.onDidRemoveConnection(Te,void 0,Z),oe.event(Q.fire,Q,Z),Z.add(oe)},onLastListenerRemove:()=>{Z.dispose()}});return Q.event}registerChannel(x,$){this.channels.set(x,$),this._connections.forEach(J=>{J.channelServer.registerChannel(x,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class T{constructor(x,$,J=null){const ne=new h;n(ne,$),x.send(ne.buffer),this.channelClient=new f(x,J),this.channelServer=new c(x,$,J)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,$){this.channelServer.registerChannel(x,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function L(B){return{call(x,$,J){return B.then(ne=>ne.call(x,$,J))},listen(x,$){const J=new D.Relay;return B.then(ne=>J.input=ne.listen(x,$)),J.event}}}e.getDelayedChannel=L;function O(B){let x=!1;return{call($,J,ne){return x?B.call($,J,ne):(0,t.timeout)(0).then(()=>x=!0).then(()=>B.call($,J,ne))},listen($,J){if(x)return B.listen($,J);const ne=new D.Relay;return(0,t.timeout)(0).then(()=>x=!0).then(()=>ne.input=B.listen($,J)),ne.event}}}e.getNextTickChannel=O;class E{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const $ of x.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await D.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=E;var M;(function(B){function x(re,Z){const Q=re,oe=Z&&Z.disableMarshalling,fe=new Map;for(const pe in Q)J(pe)&&fe.set(pe,D.Event.buffer(Q[pe],!0));return new class{listen(pe,Te,xe){const qe=fe.get(Te);if(qe)return qe;if(ne(Te)){const Qe=Q[Te];if(typeof Qe=="function")return Qe.call(Q,xe)}throw new Error(`Event not found: ${Te}`)}call(pe,Te,xe){const qe=Q[Te];if(typeof qe=="function"){if(!oe&&Array.isArray(xe))for(let Qe=0;Qe<xe.length;Qe++)xe[Qe]=(0,F.revive)(xe[Qe]);return qe.apply(Q,xe)}throw new Error(`Method not found: ${Te}`)}}}B.fromService=x;function $(re,Z){const Q=Z&&Z.disableMarshalling;return new Proxy({},{get(oe,fe){if(typeof fe=="string")return Z?.properties?.has(fe)?Z.properties.get(fe):ne(fe)?function(pe){return re.listen(fe,pe)}:J(fe)?re.listen(fe):async function(...pe){let Te;Z&&!(0,l.isUndefinedOrNull)(Z.context)?Te=[Z.context,...pe]:Te=pe;const xe=await re.call(fe,Te);return Q?xe:(0,F.revive)(xe)};throw new Error(`Property not found: ${String(fe)}`)}})}B.toService=$;function J(re){return re[0]==="o"&&re[1]==="n"&&y.isUpperAsciiLetter(re.charCodeAt(2))}function ne(re){return/^onDynamic/.test(re)&&y.isUpperAsciiLetter(re.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let x=B.toString();if(x!=="[object Object]")return x}return B}function z(B){return Array.isArray(B)?B.map(V):V(B)}function N(B,x,$,J,ne,re,Z){Z=z(Z);const Q=U[ne],oe=Q[J%Q.length];let fe=[`%c[${B}]%c[${String(x).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${oe}`];/\($/.test(re)?(fe=fe.concat(Z),fe.push(")")):fe.push(Z),console.log.apply(console,fe)}e.logWithColors=N;class W{constructor(x,$){this._outgoingPrefix=x,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,$,J,ne,re){this._totalOutgoing+=x,N(this._outgoingPrefix,this._totalOutgoing,x,$,J,ne,re)}logIncoming(x,$,J,ne,re){this._totalIncoming+=x,N(this._incomingPrefix,this._totalIncoming,x,$,J,ne,re)}}e.IPCLogger=W}),define(ve[108],be([0,1,22,3,6,107]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function c(f,w){if(!n.has(f)){const T=String(++o);n.set(f,T)}return n.get(f)}function m(f,w,T,L){if(!i.enableDiagnostics)return;const O=c(f,w);if(L instanceof d.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const E=d.VSBuffer.alloc(L.byteLength);E.set(L),i.records.push({timestamp:Date.now(),id:O,label:w,type:T,buff:E})}else i.records.push({timestamp:Date.now(),id:O,label:w,type:T,data:L})}i.traceSocketEvent=m})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function F(){return P||(P=d.VSBuffer.alloc(0)),P}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return F();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const w=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),w}if(this._chunks[0].byteLength>n){const w=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),w}let c=d.VSBuffer.alloc(n),m=0,f=0;for(;n>0;){const w=this._chunks[f];if(w.byteLength>n){const T=w.slice(0,n);c.set(T,m),m+=n,o&&(this._chunks[f]=w.slice(n),this._totalLength-=n),n-=n}else c.set(w,m),m+=w.byteLength,o?(this._chunks.shift(),this._totalLength-=w.byteLength):f++,n-=w.byteLength}return c}}e.ChunkStream=y;var l;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(l||(l={}));function b(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(n,o,c,m){this.type=n,this.id=o,this.ack=c,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class _ extends I.Disposable{constructor(n){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,m=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new v(c,m,f,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class R{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=d.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(o,n.data)}_bufferAdd(n,o){const c=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,c}_bufferTake(){const n=d.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class p extends I.Disposable{constructor(n){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new R(this._socket)),this._socketReader=this._register(new _(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new v(1,0,0,n))}}e.Protocol=p;class h extends C.IPCClient{constructor(n,o,c=null){super(n,o,c);this.protocol=n}static fromSocket(n,o){return new h(new p(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=h;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class u{constructor(n){this.data=n,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,c=this._first;for(;c;)n[o++]=c.data,c=c.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new u(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class S{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<S._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=S._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const n=Date.now(),o=(1+S._HISTORY_LENGTH)*1e3;let c=0;for(let m=0;m<S._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=o&&c++;return 1-c/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class a{constructor(n,o=null,c=S.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new _(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new v(5,0,0,F());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new v(7,0,0,F());this._socketWriter.write(n)}sendResume(){const n=new v(8,0,0,F());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new _(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,F());this._socketWriter.write(n);const o=this._outgoingUnackMsg.toArray();for(let c=0,m=o.length;c<m;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new v(6,0,0,F())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,m=o.length;c<m;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new v(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(n){const o=new v(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime,c=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const f=Math.max(2e4-o,2e4-c,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,F());this._socketWriter.write(n)}}e.PersistentProtocol=a}),define(ve[109],be([0,1,101]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const D=(0,d.toUint8)(k);this._defaultValue=D,this._asciiMap=t._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){const D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=k;return D}set(k,D){const P=(0,d.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(I||(I={}));class C{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(ve[48],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class d{constructor(I,C){this.lineNumber=I,this.column=C}with(I=this.lineNumber,C=this.column){return I===this.lineNumber&&C===this.column?this:new d(I,C)}delta(I=0,C=0){return this.with(this.lineNumber+I,this.column+C)}equals(I){return d.equals(this,I)}static equals(I,C){return!I&&!C?!0:!!I&&!!C&&I.lineNumber===C.lineNumber&&I.column===C.column}isBefore(I){return d.isBefore(this,I)}static isBefore(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<C.column}isBeforeOrEqual(I){return d.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<=C.column}static compare(I,C){const A=I.lineNumber|0,k=C.lineNumber|0;if(A===k){const D=I.column|0,P=C.column|0;return D-P}return A-k}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new d(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=d}),define(ve[41],be([0,1,48]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(C,A,k,D){C>k||C===k&&A>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=C,this.endColumn=A):(this.startLineNumber=C,this.startColumn=A,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return t.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return t.containsPosition(this,C)}static containsPosition(C,A){return!(A.lineNumber<C.startLineNumber||A.lineNumber>C.endLineNumber||A.lineNumber===C.startLineNumber&&A.column<C.startColumn||A.lineNumber===C.endLineNumber&&A.column>C.endColumn)}static strictContainsPosition(C,A){return!(A.lineNumber<C.startLineNumber||A.lineNumber>C.endLineNumber||A.lineNumber===C.startLineNumber&&A.column<=C.startColumn||A.lineNumber===C.endLineNumber&&A.column>=C.endColumn)}containsRange(C){return t.containsRange(this,C)}static containsRange(C,A){return!(A.startLineNumber<C.startLineNumber||A.endLineNumber<C.startLineNumber||A.startLineNumber>C.endLineNumber||A.endLineNumber>C.endLineNumber||A.startLineNumber===C.startLineNumber&&A.startColumn<C.startColumn||A.endLineNumber===C.endLineNumber&&A.endColumn>C.endColumn)}strictContainsRange(C){return t.strictContainsRange(this,C)}static strictContainsRange(C,A){return!(A.startLineNumber<C.startLineNumber||A.endLineNumber<C.startLineNumber||A.startLineNumber>C.endLineNumber||A.endLineNumber>C.endLineNumber||A.startLineNumber===C.startLineNumber&&A.startColumn<=C.startColumn||A.endLineNumber===C.endLineNumber&&A.endColumn>=C.endColumn)}plusRange(C){return t.plusRange(this,C)}static plusRange(C,A){let k,D,P,F;return A.startLineNumber<C.startLineNumber?(k=A.startLineNumber,D=A.startColumn):A.startLineNumber===C.startLineNumber?(k=A.startLineNumber,D=Math.min(A.startColumn,C.startColumn)):(k=C.startLineNumber,D=C.startColumn),A.endLineNumber>C.endLineNumber?(P=A.endLineNumber,F=A.endColumn):A.endLineNumber===C.endLineNumber?(P=A.endLineNumber,F=Math.max(A.endColumn,C.endColumn)):(P=C.endLineNumber,F=C.endColumn),new t(k,D,P,F)}intersectRanges(C){return t.intersectRanges(this,C)}static intersectRanges(C,A){let k=C.startLineNumber,D=C.startColumn,P=C.endLineNumber,F=C.endColumn,y=A.startLineNumber,l=A.startColumn,b=A.endLineNumber,g=A.endColumn;return k<y?(k=y,D=l):k===y&&(D=Math.max(D,l)),P>b?(P=b,F=g):P===b&&(F=Math.min(F,g)),k>P||k===P&&D>F?null:new t(k,D,P,F)}equalsRange(C){return t.equalsRange(this,C)}static equalsRange(C,A){return!!C&&!!A&&C.startLineNumber===A.startLineNumber&&C.startColumn===A.startColumn&&C.endLineNumber===A.endLineNumber&&C.endColumn===A.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(C){return new d.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(C){return new d.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,A){return new t(this.startLineNumber,this.startColumn,C,A)}setStartPosition(C,A){return new t(C,A,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(C){return new t(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,A=C){return new t(C.lineNumber,C.column,A.lineNumber,A.column)}static lift(C){return C?new t(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,A){return!(C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn||A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn)}static areIntersecting(C,A){return!(C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn||A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,A){if(C&&A){const P=C.startLineNumber|0,F=A.startLineNumber|0;if(P===F){const y=C.startColumn|0,l=A.startColumn|0;if(y===l){const b=C.endLineNumber|0,g=A.endLineNumber|0;if(b===g){const v=C.endColumn|0,_=A.endColumn|0;return v-_}return b-g}return y-l}return P-F}return(C?1:0)-(A?1:0)}static compareRangesUsingEnds(C,A){return C.endLineNumber===A.endLineNumber?C.endColumn===A.endColumn?C.startLineNumber===A.startLineNumber?C.startColumn-A.startColumn:C.startLineNumber-A.startLineNumber:C.endColumn-A.endColumn:C.endLineNumber-A.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=t}),define(ve[145],be([0,1,48,41]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class C extends t.Range{constructor(k,D,P,F){super(k,D,P,F);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,D):new C(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new d.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,D){return this.getDirection()===0?new C(k,D,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new C(k.lineNumber,k.column,D.lineNumber,D.column)}static fromRange(k,D){return D===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let P=0,F=k.length;P<F;P++)if(!this.selectionsEqual(k[P],D[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,P,F,y){return y===0?new C(k,D,P,F):new C(P,F,k,D)}}e.Selection=C}),define(ve[146],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(ve[147],be([0,1,109]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends d.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function C(A){const k={};return D=>(k.hasOwnProperty(D)||(k[D]=A(D)),k[D])}e.getMapForWordSeparators=C(A=>new I(A))}),define(ve[110],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function d(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=d();function t(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),D=new RegExp(k.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,D,P,F,y=I){if(P.length>y.maxLen){let _=k-y.maxLen/2;return _<0?_=0:F+=_,P=P.substring(_,k+y.maxLen/2),C(k,D,P,F,y)}const l=Date.now(),b=k-1-F;let g=-1,v=null;for(let _=1;!(Date.now()-l>=y.timeBudget);_++){const R=b-y.windowSize*_;D.lastIndex=Math.max(0,R);const p=A(D,P,b,g);if(!p&&v||(v=p,R<=0))break;g=R}if(v){const _={word:v[0],startColumn:F+1+v.index,endColumn:F+1+v.index+v[0].length};return D.lastIndex=0,_}return null}e.getWordAtText=C;function A(k,D,P,F){let y;for(;y=k.exec(D);){const l=y.index||0;if(l<=P&&k.lastIndex>=P)return y;if(F>0&&l>F)return null}return null}}),define(ve[81],be([0,1,32,9]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(C,A,k,D){if(Array.isArray(C)){let P=0;for(const F of C){const y=I(F,A,k,D);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof C=="string")return D?C==="*"?5:C===k?10:0:0;if(C){const{language:P,pattern:F,scheme:y,hasAccessToAllModels:l}=C;if(!D&&!l)return 0;let b=0;if(y)if(y===A.scheme)b=10;else if(y==="*")b=5;else return 0;if(P)if(P===k)b=10;else if(P==="*")b=Math.max(b,5);else return 0;if(F){let g;if(typeof F=="string"?g=F:g={...F,base:(0,t.normalize)(F.base)},g===A.fsPath||(0,d.match)(g,A.fsPath))b=10;else return 0}return b}else return 0}}e.score=I}),define(ve[148],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,D){if(k.getTokenCount()===0)return!0;const P=k.findTokenIndexAtOffset(D-2),F=k.getStandardTokenType(P);return this.isOK(F)}_findNeutralCharacterInRange(k,D){for(let P=k;P<=D;P++){const F=String.fromCharCode(P);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)C(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),C(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),C(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),C(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&C(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function C(A,k,D){A.has(k)?A.get(k).push(D):A.set(k,[D])}}),define(ve[149],be([0,1,109]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(g,v,_){const R=new Uint8Array(g*v);for(let p=0,h=g*v;p<h;p++)R[p]=_;this._data=R,this.rows=g,this.cols=v}get(g,v){return this._data[g*this.cols+v]}set(g,v,_){this._data[g*this.cols+v]=_}}e.Uint8Matrix=I;class C{constructor(g){let v=0,_=0;for(let p=0,h=g.length;p<h;p++){const[s,u,r]=g[p];u>v&&(v=u),s>_&&(_=s),r>_&&(_=r)}v++,_++;const R=new I(_,v,0);for(let p=0,h=g.length;p<h;p++){const[s,u,r]=g[p];R.set(s,u,r)}this._states=R,this._maxCharCode=v}nextState(g,v){return v<0||v>=this._maxCharCode?0:this._states.get(g,v)}}e.StateMachine=C;let A=null;function k(){return A===null&&(A=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var D;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function F(){if(P===null){P=new d.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<b.length;v++)P.set(b.charCodeAt(v),1);const g=".,;";for(let v=0;v<g.length;v++)P.set(g.charCodeAt(v),2)}return P}class y{static _createLink(g,v,_,R,p){let h=p-1;do{const s=v.charCodeAt(h);if(g.get(s)!==2)break;h--}while(h>R);if(R>0){const s=v.charCodeAt(R-1),u=v.charCodeAt(h);(s===40&&u===41||s===91&&u===93||s===123&&u===125)&&h--}return{range:{startLineNumber:_,startColumn:R+1,endLineNumber:_,endColumn:h+2},url:v.substring(R,h+1)}}static computeLinks(g,v=k()){const _=F(),R=[];for(let p=1,h=g.getLineCount();p<=h;p++){const s=g.getLineContent(p),u=s.length;let r=0,S=0,a=0,i=1,n=!1,o=!1,c=!1,m=!1;for(;r<u;){let f=!1;const w=s.charCodeAt(r);if(i===13){let T;switch(w){case 40:n=!0,T=0;break;case 41:T=n?0:1;break;case 91:c=!0,o=!0,T=0;break;case 93:c=!1,T=o?0:1;break;case 123:m=!0,T=0;break;case 125:T=m?0:1;break;case 39:T=a===34||a===96?0:1;break;case 34:T=a===39||a===96?0:1;break;case 96:T=a===39||a===34?0:1;break;case 42:T=a===42?1:0;break;case 124:T=a===124?1:0;break;case 32:T=c?0:1;break;default:T=_.get(w)}T===1&&(R.push(y._createLink(_,s,p,S,r)),f=!0)}else if(i===12){let T;w===91?(o=!0,T=0):T=_.get(w),T===1?f=!0:i=13}else i=v.nextState(i,w),i===0&&(f=!0);f&&(i=1,n=!1,o=!1,m=!1,S=r+1,a=w),r++}i===13&&R.push(y._createLink(_,s,p,S,u))}return R}}e.LinkComputer=y;function l(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:y.computeLinks(b)}e.computeLinks=l}),define(ve[82],be([0,1,25]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(C=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var A;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace),this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class F{constructor(h,s){this._findMatchBrand=void 0,this.range=h,this.matches=s}}e.FindMatch=F;var y;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var l;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(l=e.PositionAffinity||(e.PositionAffinity={}));var b;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=e.ModelConstants||(e.ModelConstants={}));class g{constructor(h,s,u,r,S,a){this.identifier=h,this.range=s,this.text=u,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=S,this._isTracked=a}}e.ValidAnnotatedEditOperation=g;class v{constructor(h,s,u){this.regex=h,this.wordSeparators=s,this.simpleSearch=u}}e.SearchData=v;class _{constructor(h,s,u){this.reverseEdits=h,this.changes=s,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=_;function R(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ve[150],be([0,1,3,6,82,81]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function A(D){return typeof D=="string"?!1:Array.isArray(D)?D.every(A):!!D.exclusive}class k{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(P,F){let y={selector:P,provider:F,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(y){const l=this._entries.indexOf(y);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(P){return this.all(P).length>0}all(P){if(!P)return[];this._updateScores(P);const F=[];for(let y of this._entries)y._score>0&&F.push(y.provider);return F}ordered(P){const F=[];return this._orderedForEach(P,y=>F.push(y.provider)),F}orderedGroups(P){const F=[];let y,l;return this._orderedForEach(P,b=>{y&&l===b._score?y.push(b.provider):(l=b._score,y=[b.provider],F.push(y))}),F}_orderedForEach(P,F){if(!!P){this._updateScores(P);for(const y of this._entries)y._score>0&&F(y)}}_updateScores(P){const F={uri:P.uri.toString(),language:P.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===F.language&&this._lastCandidate.uri===F.uri)){this._lastCandidate=F;for(let y of this._entries)if(y._score=(0,C.score)(y.selector,P.uri,P.getLanguageId(),(0,I.shouldSynchronizeModel)(P)),A(y.selector)&&y._score>0){for(let l of this._entries)l._score=0;y._score=1e3;break}this._entries.sort(k._compareByScoreAndTime)}}static _compareByScoreAndTime(P,F){return P._score<F._score?1:P._score>F._score?-1:P._time<F._time?1:P._time>F._time?-1:0}}e.LanguageFeatureRegistry=k}),define(ve[111],be([0,1,17,101]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,P){D=(0,t.toUint32)(D);const F=this.values,y=this.prefixSum,l=P.length;return l===0?!1:(this.values=new Uint32Array(F.length+l),this.values.set(F.subarray(0,D),0),this.values.set(F.subarray(D),D+l),this.values.set(P,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(D,P){return D=(0,t.toUint32)(D),P=(0,t.toUint32)(P),this.values[D]===P?!1:(this.values[D]=P,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,P){D=(0,t.toUint32)(D),P=(0,t.toUint32)(P);const F=this.values,y=this.prefixSum;if(D>=F.length)return!1;const l=F.length-D;return P>=l&&(P=l),P===0?!1:(this.values=new Uint32Array(F.length-P),this.values.set(F.subarray(0,D),0),this.values.set(F.subarray(D+P),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(D){return D<0?0:(D=(0,t.toUint32)(D),this._getPrefixSum(D))}_getPrefixSum(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),D>=this.values.length&&(D=this.values.length-1);for(let F=P;F<=D;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalSum();let P=0,F=this.values.length-1,y=0,l=0,b=0;for(;P<=F;)if(y=P+(F-P)/2|0,l=this.prefixSum[y],b=l-this.values[y],D<b)F=y-1;else if(D>=l)P=y+1;else break;return new A(y,D-b)}}e.PrefixSumComputer=I;class C{constructor(D){this._values=D,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(D){return this._ensureValid(),D===0?0:this._prefixSum[D-1]}getIndexOf(D){this._ensureValid();const P=this._indexBySum[D],F=P>0?this._prefixSum[P-1]:0;return new A(P,D-F)}removeValues(D,P){this._values.splice(D,P),this._invalidate(D)}insertValues(D,P){this._values=(0,d.arrayInsert)(this._values,D,P),this._invalidate(D)}_invalidate(D){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,D-1)}_ensureValid(){if(!this._isValid){for(let D=this._validEndIndex+1,P=this._values.length;D<P;D++){const F=this._values[D],y=D>0?this._prefixSum[D-1]:0;this._prefixSum[D]=y+F;for(let l=0;l<F;l++)this._indexBySum[y+l]=D}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(D,P){this._values[D]!==P&&(this._values[D]=P,this._invalidate(D))}}e.ConstantTimePrefixSumComputer=C;class A{constructor(D,P){this.index=D,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=D,this.remainder=P}}e.PrefixSumIndexOfResult=A}),define(ve[151],be([0,1,8,48,111]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,D,P,F){this._uri=k,this._lines=D,this._eol=P,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new t.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let F=0;F<D;F++)P[F]=this._lines[F].length+k;this._lineStarts=new I.PrefixSumComputer(P)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length===0)return;const P=(0,d.splitLines)(D);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);const F=new Uint32Array(P.length-1);for(let y=1;y<P.length;y++)this._lines.splice(k.lineNumber+y-1,0,P[y]),F[y-1]=P[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,F)}}e.MirrorTextModel=C}),define(ve[152],be([0,1,8,147,48,41,82]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(p,h,s,u){this.searchString=p,this.isRegex=h,this.matchCase=s,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=P(this.searchString):p=this.searchString.indexOf(`
`)>=0;let h=null;try{h=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!h)return null;let s=!this.isRegex&&!p;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new A.SearchData(h,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}e.SearchParams=D;function P(R){if(!R||R.length===0)return!1;for(let p=0,h=R.length;p<h;p++)if(R.charCodeAt(p)===92){if(p++,p>=h)break;const u=R.charCodeAt(p);if(u===110||u===114||u===87)return!0}return!1}e.isMultilineRegexSource=P;function F(R,p,h){if(!h)return new A.FindMatch(R,null);const s=[];for(let u=0,r=p.length;u<r;u++)s[u]=p[u];return new A.FindMatch(R,s)}e.createFindMatch=F;class y{constructor(p){const h=[];let s=0;for(let u=0,r=p.length;u<r;u++)p.charCodeAt(u)===10&&(h[s++]=u);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(p){const h=this._lineFeedsOffsets;let s=0,u=h.length-1;if(u===-1||p<=h[0])return 0;for(;s<u;){const r=s+((u-s)/2>>0);h[r]>=p?u=r-1:h[r+1]>=p?(s=r,u=r):s=r+1}return s+1}}class l{static findMatches(p,h,s,u,r){const S=h.parseSearchRequest();return S?S.regex.multiline?this._doFindMatchesMultiline(p,s,new _(S.wordSeparators,S.regex),u,r):this._doFindMatchesLineByLine(p,s,S,u,r):[]}static _getMultilineMatchRange(p,h,s,u,r,S){let a,i=0;u?(i=u.findLineFeedCountBeforeOffset(r),a=h+r+i):a=h+r;let n;if(u){const f=u.findLineFeedCountBeforeOffset(r+S.length)-i;n=a+S.length+f}else n=a+S.length;const o=p.getPositionAt(a),c=p.getPositionAt(n);return new C.Range(o.lineNumber,o.column,c.lineNumber,c.column)}static _doFindMatchesMultiline(p,h,s,u,r){const S=p.getOffsetAt(h.getStartPosition()),a=p.getValueInRange(h,1),i=p.getEOL()===`\r
`?new y(a):null,n=[];let o=0,c;for(s.reset(0);c=s.next(a);)if(n[o++]=F(this._getMultilineMatchRange(p,S,a,i,c.index,c[0]),c,u),o>=r)return n;return n}static _doFindMatchesLineByLine(p,h,s,u,r){const S=[];let a=0;if(h.startLineNumber===h.endLineNumber){const n=p.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return a=this._findMatchesInLine(s,n,h.startLineNumber,h.startColumn-1,a,S,u,r),S}const i=p.getLineContent(h.startLineNumber).substring(h.startColumn-1);a=this._findMatchesInLine(s,i,h.startLineNumber,h.startColumn-1,a,S,u,r);for(let n=h.startLineNumber+1;n<h.endLineNumber&&a<r;n++)a=this._findMatchesInLine(s,p.getLineContent(n),n,0,a,S,u,r);if(a<r){const n=p.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);a=this._findMatchesInLine(s,n,h.endLineNumber,0,a,S,u,r)}return S}static _findMatchesInLine(p,h,s,u,r,S,a,i){const n=p.wordSeparators;if(!a&&p.simpleSearch){const m=p.simpleSearch,f=m.length,w=h.length;let T=-f;for(;(T=h.indexOf(m,T+f))!==-1;)if((!n||v(n,h,w,T,f))&&(S[r++]=new A.FindMatch(new C.Range(s,T+1+u,s,T+1+f+u),null),r>=i))return r;return r}const o=new _(p.wordSeparators,p.regex);let c;o.reset(0);do if(c=o.next(h),c&&(S[r++]=F(new C.Range(s,c.index+1+u,s,c.index+1+c[0].length+u),c,a),r>=i))return r;while(c);return r}static findNextMatch(p,h,s,u){const r=h.parseSearchRequest();if(!r)return null;const S=new _(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(p,s,S,u):this._doFindNextMatchLineByLine(p,s,S,u)}static _doFindNextMatchMultiline(p,h,s,u){const r=new I.Position(h.lineNumber,1),S=p.getOffsetAt(r),a=p.getLineCount(),i=p.getValueInRange(new C.Range(r.lineNumber,r.column,a,p.getLineMaxColumn(a)),1),n=p.getEOL()===`\r
`?new y(i):null;s.reset(h.column-1);let o=s.next(i);return o?F(this._getMultilineMatchRange(p,S,i,n,o.index,o[0]),o,u):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(p,new I.Position(1,1),s,u):null}static _doFindNextMatchLineByLine(p,h,s,u){const r=p.getLineCount(),S=h.lineNumber,a=p.getLineContent(S),i=this._findFirstMatchInLine(s,a,S,h.column,u);if(i)return i;for(let n=1;n<=r;n++){const o=(S+n-1)%r,c=p.getLineContent(o+1),m=this._findFirstMatchInLine(s,c,o+1,1,u);if(m)return m}return null}static _findFirstMatchInLine(p,h,s,u,r){p.reset(u-1);const S=p.next(h);return S?F(new C.Range(s,S.index+1,s,S.index+1+S[0].length),S,r):null}static findPreviousMatch(p,h,s,u){const r=h.parseSearchRequest();if(!r)return null;const S=new _(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(p,s,S,u):this._doFindPreviousMatchLineByLine(p,s,S,u)}static _doFindPreviousMatchMultiline(p,h,s,u){const r=this._doFindMatchesMultiline(p,new C.Range(1,1,h.lineNumber,h.column),s,u,10*k);if(r.length>0)return r[r.length-1];const S=p.getLineCount();return h.lineNumber!==S||h.column!==p.getLineMaxColumn(S)?this._doFindPreviousMatchMultiline(p,new I.Position(S,p.getLineMaxColumn(S)),s,u):null}static _doFindPreviousMatchLineByLine(p,h,s,u){const r=p.getLineCount(),S=h.lineNumber,a=p.getLineContent(S).substring(0,h.column-1),i=this._findLastMatchInLine(s,a,S,u);if(i)return i;for(let n=1;n<=r;n++){const o=(r+S-n-1)%r,c=p.getLineContent(o+1),m=this._findLastMatchInLine(s,c,o+1,u);if(m)return m}return null}static _findLastMatchInLine(p,h,s,u){let r=null,S;for(p.reset(0);S=p.next(h);)r=F(new C.Range(s,S.index+1,s,S.index+1+S[0].length),S,u);return r}}e.TextModelSearch=l;function b(R,p,h,s,u){if(s===0)return!0;const r=p.charCodeAt(s-1);if(R.get(r)!==0||r===13||r===10)return!0;if(u>0){const S=p.charCodeAt(s);if(R.get(S)!==0)return!0}return!1}function g(R,p,h,s,u){if(s+u===h)return!0;const r=p.charCodeAt(s+u);if(R.get(r)!==0||r===13||r===10)return!0;if(u>0){const S=p.charCodeAt(s+u-1);if(R.get(S)!==0)return!0}return!1}function v(R,p,h,s,u){return b(R,p,h,s,u)&&g(R,p,h,s,u)}e.isValidMatch=v;class _{constructor(p,h){this._wordSeparators=p,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const h=p.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(s=this._searchRegex.exec(p),!s))return null;const u=s.index,r=s[0].length;if(u===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){d.getNextCodePoint(p,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=r,!this._wordSeparators||v(this._wordSeparators,p,h,u,r))return s}while(s);return null}}e.Searcher=_}),define(ve[112],be([0,1,22,11]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function C(y){for(let l=0,b=y.length;l<b;l+=4){const g=y[l+0],v=y[l+1],_=y[l+2],R=y[l+3];y[l+0]=R,y[l+1]=_,y[l+2]=v,y[l+3]=g}}function A(y){const l=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return t.isLittleEndian()||C(l),d.VSBuffer.wrap(l)}function k(y){const l=y.buffer;if(t.isLittleEndian()||C(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function D(y){const l=new Uint32Array(P(y));let b=0;if(l[b++]=y.id,y.type==="full")l[b++]=1,l[b++]=y.data.length,l.set(y.data,b),b+=y.data.length;else{l[b++]=2,l[b++]=y.deltas.length;for(const g of y.deltas)l[b++]=g.start,l[b++]=g.deleteCount,g.data?(l[b++]=g.data.length,l.set(g.data,b),b+=g.data.length):l[b++]=0}return A(l)}e.encodeSemanticTokensDto=D;function P(y){let l=0;if(l+=1+1,y.type==="full")l+=1+y.data.length;else{l+=1,l+=(1+1+1)*y.deltas.length;for(const b of y.deltas)b.data&&(l+=b.data.length)}return l}function F(y){const l=k(y);let b=0;const g=l[b++];if(l[b++]===1){const p=l[b++],h=l.subarray(b,b+p);return b+=p,{id:g,type:"full",data:h}}const _=l[b++],R=[];for(let p=0;p<_;p++){const h=l[b++],s=l[b++],u=l[b++];let r;u>0&&(r=l.subarray(b,b+u),b+=u),R[p]={start:h,deleteCount:s,data:r}}return{id:g,type:"delta",deltas:R}}e.decodeSemanticTokensDto=F}),define(ve[153],be([0,1,3,6]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,D){this._factories.get(k)?.dispose();const P=new C(this,k,D);return this._factories.set(k,P),(0,t.toDisposable)(()=>{const F=this._factories.get(k);!F||F!==P||(this._factories.delete(k),F.dispose())})}async getOrCreate(k){const D=this.get(k);if(D)return D;const P=this._factories.get(k);return!P||P.isResolved?null:(await P.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const P=this._factories.get(k);return!!(!P||P.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class C extends t.Disposable{constructor(k,D,P){super();this._registry=k,this._languageId=D,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(ve[83],be([0,1,2,41,150,153,73]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(E){E[E.Null=0]="Null",E[E.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var D;(function(E){E[E.NotSet=-1]="NotSet",E[E.None=0]="None",E[E.Italic=1]="Italic",E[E.Bold=2]="Bold",E[E.Underline=4]="Underline",E[E.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var P;(function(E){E[E.None=0]="None",E[E.DefaultForeground=1]="DefaultForeground",E[E.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var F;(function(E){E[E.Other=0]="Other",E[E.Comment=1]="Comment",E[E.String=2]="String",E[E.RegEx=3]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var y;(function(E){E[E.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",E[E.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",E[E.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",E[E.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",E[E.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",E[E.ITALIC_MASK=1024]="ITALIC_MASK",E[E.BOLD_MASK=2048]="BOLD_MASK",E[E.UNDERLINE_MASK=4096]="UNDERLINE_MASK",E[E.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",E[E.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",E[E.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",E[E.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",E[E.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",E[E.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",E[E.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",E[E.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",E[E.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",E[E.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",E[E.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",E[E.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(y=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(M){return(M&255)>>>0}static getTokenType(M){return(M&768)>>>8}static getFontStyle(M){return(M&15360)>>>10}static getForeground(M){return(M&8372224)>>>14}static getBackground(M){return(M&4286578688)>>>23}static getClassNameFromMetadata(M){const U=this.getForeground(M);let V="mtk"+U;const z=this.getFontStyle(M);return z&1&&(V+=" mtki"),z&2&&(V+=" mtkb"),z&4&&(V+=" mtku"),z&8&&(V+=" mtks"),V}static getInlineStyleFromMetadata(M,U){const V=this.getForeground(M),z=this.getFontStyle(M);let N=`color: ${U[V]};`;z&1&&(N+="font-style: italic;"),z&2&&(N+="font-weight: bold;");let W="";return z&4&&(W+=" underline"),z&8&&(W+=" line-through"),W&&(N+=`text-decoration:${W};`),N}static getPresentationFromMetadata(M){const U=this.getForeground(M),V=this.getFontStyle(M);return{foreground:U,italic:Boolean(V&1),bold:Boolean(V&2),underline:Boolean(V&4),strikethrough:Boolean(V&8)}}}e.TokenMetadata=l;class b{constructor(M,U,V){this._tokenBrand=void 0,this.offset=M,this.type=U,this.language=V}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=b;class g{constructor(M,U){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=U}}e.TokenizationResult=g;class v{constructor(M,U){this._encodedTokenizationResultBrand=void 0,this.tokens=M,this.endState=U}}e.EncodedTokenizationResult=v;var _;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(_=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(E){const M=new Map;M.set(0,A.Codicon.symbolMethod),M.set(1,A.Codicon.symbolFunction),M.set(2,A.Codicon.symbolConstructor),M.set(3,A.Codicon.symbolField),M.set(4,A.Codicon.symbolVariable),M.set(5,A.Codicon.symbolClass),M.set(6,A.Codicon.symbolStruct),M.set(7,A.Codicon.symbolInterface),M.set(8,A.Codicon.symbolModule),M.set(9,A.Codicon.symbolProperty),M.set(10,A.Codicon.symbolEvent),M.set(11,A.Codicon.symbolOperator),M.set(12,A.Codicon.symbolUnit),M.set(13,A.Codicon.symbolValue),M.set(15,A.Codicon.symbolEnum),M.set(14,A.Codicon.symbolConstant),M.set(15,A.Codicon.symbolEnum),M.set(16,A.Codicon.symbolEnumMember),M.set(17,A.Codicon.symbolKeyword),M.set(27,A.Codicon.symbolSnippet),M.set(18,A.Codicon.symbolText),M.set(19,A.Codicon.symbolColor),M.set(20,A.Codicon.symbolFile),M.set(21,A.Codicon.symbolReference),M.set(22,A.Codicon.symbolCustomColor),M.set(23,A.Codicon.symbolFolder),M.set(24,A.Codicon.symbolTypeParameter),M.set(25,A.Codicon.account),M.set(26,A.Codicon.issues);function U(N){let W=M.get(N);return W||(console.info("No codicon found for CompletionItemKind "+N),W=A.Codicon.symbolProperty),W}E.toIcon=U;const V=new Map;V.set("method",0),V.set("function",1),V.set("constructor",2),V.set("field",3),V.set("variable",4),V.set("class",5),V.set("struct",6),V.set("interface",7),V.set("module",8),V.set("property",9),V.set("event",10),V.set("operator",11),V.set("unit",12),V.set("value",13),V.set("constant",14),V.set("enum",15),V.set("enum-member",16),V.set("enumMember",16),V.set("keyword",17),V.set("snippet",27),V.set("text",18),V.set("color",19),V.set("file",20),V.set("reference",21),V.set("customcolor",22),V.set("folder",23),V.set("type-parameter",24),V.set("typeParameter",24),V.set("account",25),V.set("issue",26);function z(N,W){let B=V.get(N);return typeof B=="undefined"&&!W&&(B=9),B}E.fromString=z})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var p;(function(E){E[E.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var h;(function(E){E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(h=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var s;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(s=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var u;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(u=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var r;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(r=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var S;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(S=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(E){return E&&d.URI.isUri(E.uri)&&t.Range.isIRange(E.range)&&(t.Range.isIRange(E.originSelectionRange)||t.Range.isIRange(E.targetSelectionRange))}e.isLocationLink=i;var n;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var o;(function(E){E[E.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var c;(function(E){const M=new Map;M.set(0,A.Codicon.symbolFile),M.set(1,A.Codicon.symbolModule),M.set(2,A.Codicon.symbolNamespace),M.set(3,A.Codicon.symbolPackage),M.set(4,A.Codicon.symbolClass),M.set(5,A.Codicon.symbolMethod),M.set(6,A.Codicon.symbolProperty),M.set(7,A.Codicon.symbolField),M.set(8,A.Codicon.symbolConstructor),M.set(9,A.Codicon.symbolEnum),M.set(10,A.Codicon.symbolInterface),M.set(11,A.Codicon.symbolFunction),M.set(12,A.Codicon.symbolVariable),M.set(13,A.Codicon.symbolConstant),M.set(14,A.Codicon.symbolString),M.set(15,A.Codicon.symbolNumber),M.set(16,A.Codicon.symbolBoolean),M.set(17,A.Codicon.symbolArray),M.set(18,A.Codicon.symbolObject),M.set(19,A.Codicon.symbolKey),M.set(20,A.Codicon.symbolNull),M.set(21,A.Codicon.symbolEnumMember),M.set(22,A.Codicon.symbolStruct),M.set(23,A.Codicon.symbolEvent),M.set(24,A.Codicon.symbolOperator),M.set(25,A.Codicon.symbolTypeParameter);function U(V){let z=M.get(V);return z||(console.info("No codicon found for SymbolKind "+V),z=A.Codicon.symbolProperty),z}E.toIcon=U})(c=e.SymbolKinds||(e.SymbolKinds={}));class m{constructor(M){this.value=M}}e.FoldingRangeKind=m,m.Comment=new m("comment"),m.Imports=new m("imports"),m.Region=new m("region");var f;(function(E){function M(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}E.is=M})(f=e.Command||(e.Command={}));var w;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(w=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var T;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(T=e.CommentMode||(e.CommentMode={}));var L;(function(E){E[E.Other=0]="Other",E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(L=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistry;var O;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(O=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[154],be([19,20]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(ve[155],be([0,1,154]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,C=I*24,A=C*7,k=C*30,D=C*365;function P(y,l,b){typeof y!="number"&&(y=y.getTime());const g=Math.round((new Date().getTime()-y)/1e3);if(g<-30)return(0,d.localize)(0,null,P(new Date().getTime()+g*1e3,!1));if(g<30)return(0,d.localize)(1,null);let v;return g<t?(v=g,l?v===1?b?(0,d.localize)(2,null,v):(0,d.localize)(3,null,v):b?(0,d.localize)(4,null,v):(0,d.localize)(5,null,v):v===1?b?(0,d.localize)(6,null,v):(0,d.localize)(7,null,v):b?(0,d.localize)(8,null,v):(0,d.localize)(9,null,v)):g<I?(v=Math.floor(g/t),l?v===1?b?(0,d.localize)(10,null,v):(0,d.localize)(11,null,v):b?(0,d.localize)(12,null,v):(0,d.localize)(13,null,v):v===1?b?(0,d.localize)(14,null,v):(0,d.localize)(15,null,v):b?(0,d.localize)(16,null,v):(0,d.localize)(17,null,v)):g<C?(v=Math.floor(g/I),l?v===1?b?(0,d.localize)(18,null,v):(0,d.localize)(19,null,v):b?(0,d.localize)(20,null,v):(0,d.localize)(21,null,v):v===1?b?(0,d.localize)(22,null,v):(0,d.localize)(23,null,v):b?(0,d.localize)(24,null,v):(0,d.localize)(25,null,v)):g<A?(v=Math.floor(g/C),l?v===1?(0,d.localize)(26,null,v):(0,d.localize)(27,null,v):v===1?(0,d.localize)(28,null,v):(0,d.localize)(29,null,v)):g<k?(v=Math.floor(g/A),l?v===1?b?(0,d.localize)(30,null,v):(0,d.localize)(31,null,v):b?(0,d.localize)(32,null,v):(0,d.localize)(33,null,v):v===1?b?(0,d.localize)(34,null,v):(0,d.localize)(35,null,v):b?(0,d.localize)(36,null,v):(0,d.localize)(37,null,v)):g<D?(v=Math.floor(g/k),l?v===1?b?(0,d.localize)(38,null,v):(0,d.localize)(39,null,v):b?(0,d.localize)(40,null,v):(0,d.localize)(41,null,v):v===1?b?(0,d.localize)(42,null,v):(0,d.localize)(43,null,v):b?(0,d.localize)(44,null,v):(0,d.localize)(45,null,v)):(v=Math.floor(g/D),l?v===1?b?(0,d.localize)(46,null,v):(0,d.localize)(47,null,v):b?(0,d.localize)(48,null,v):(0,d.localize)(49,null,v):v===1?b?(0,d.localize)(50,null,v):(0,d.localize)(51,null,v):b?(0,d.localize)(52,null,v):(0,d.localize)(53,null,v))}e.fromNow=P;function F(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(ve[156],be([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(ve[49],be([0,1,17,18,156]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(P,F){return F&&(P.stack||P.stacktrace)?I.localize(0,null,k(P),A(P.stack)||A(P.stacktrace)):k(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function D(P=null,F=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const y=d.coalesce(P),l=D(y[0],F);return y.length>1?I.localize(4,null,l,y.length):l}if(t.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return C(y.error,F);if(y.exception)return C(y.exception,F)}return P.stack?C(P,F):P.message?P.message:I.localize(5,null)}e.toErrorMessage=D}),define(ve[157],be([19,20]),function(ee,e){return ee.create("vs/base/node/processes",e)}),define(ve[113],be([0,1,37,28,10,25,9,11,40,97,18,144,29,157]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function g(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(r,S){if(k.isWindows)try{const a={stdio:["pipe","pipe","ignore"]};S&&(a.cwd=S);const i=d.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],a);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,c)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(a){return Promise.resolve({success:!1,error:a,code:a.status?g(a.status):1})}else if(k.isLinux||k.isMacintosh)try{const a=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",ee).fsPath;return new Promise(i=>{d.execFile(a,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,o,c)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(a){return Promise.resolve({success:!1,error:a})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function _(r){!r||(delete r.DEBUG,k.isMacintosh&&delete r.DYLD_LIBRARY_PATH,k.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=_;function R(r=D.env){return r.comspec||"cmd.exe"}e.getWindowsShell=R;class p{constructor(S,a,i,n){if(a!==void 0&&i!==void 0&&n!==void 0)this.cmd=S,this.args=a,this.shell=i,this.options=n;else{const o=S;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(D.env).forEach(c=>{o[c]=D.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const a=S.lastIndexOf(A.sep);return a!==-1&&(S=S.substring(a+1)),p.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(D.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(a=>{let i,n;const o=new Promise((c,m)=>{i=c,n=m});if(a){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=d.exec(c,this.options,(m,f,w)=>{this.childProcess=null;const T=m;T&&T.killed?n({killed:this.terminateRequested,stdout:f.toString(),stderr:w.toString()}):this.handleExec(i,S,m,f,w)})}else{let c=null;const m=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,i,S,n);const w={terminated:this.terminateRequested};F.isNumber(f)&&(w.cmdCode=f),i(w)};if(this.shell&&k.isWindows){const f=C.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let w=!1,T=!1;const L=[];let O=this.ensureQuotes(this.cmd);L.push(O.value),w=O.quoted,this.args&&this.args.forEach(M=>{O=this.ensureQuotes(M),L.push(O.value),T=T&&O.quoted});const E=["/s","/c"];w?T?E.push('"'+L.join(" ")+'"'):L.length>1?E.push('"'+L[0]+'" '+L.slice(1).join(" ")):E.push('"'+L[0]+'"'):E.push(L.join(" ")),c=d.spawn(R(),E,f)}else this.cmd&&(c=d.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(F.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",f=>{this.childProcess=null,n({terminated:this.terminateRequested,error:f})}),c.pid&&(this.childProcess.on("close",m),this.handleSpawn(c,i,S,n,!0)))}return o})}handleClose(S,a,i,n){}ensureQuotes(S){return p.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,v(S,this.options.cwd).then(a=>(a.success&&(this.childProcess=null),a))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const a=d.spawn(R(),["/s","/c"]);a.on("error",i=>S(!0)),a.on("exit",i=>S(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class h extends p{constructor(S,a,i,n){super(S,a,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,a,i,n,o){[n,o].forEach((c,m)=>{const f=new y.LineDecoder;f.write(c).forEach(L=>{a({line:L,source:m===0?0:1})});const T=f.end();T&&a({line:T,source:m===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,a,i,n,o){const c=new y.LineDecoder,m=new y.LineDecoder;S.stdout.on("data",f=>{c.write(f).forEach(T=>i({line:T,source:0}))}),S.stderr.on("data",f=>{m.write(f).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=m}handleClose(S,a,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&i({line:c,source:1})}}e.LineProcess=h;function s(r){let S=[],a=!1;const i=function(n){if(a){S.push(n);return}(!r.send(n,c=>{if(c&&console.error(c),a=!1,S.length>0){const m=S.slice(0);S=[],m.forEach(f=>i(f))}})||k.isWindows)&&(a=!0)};return{send:i}}e.createQueuedSender=s;var u;(function(r){async function S(a,i,n){if(A.isAbsolute(a))return a;if(i===void 0&&(i=D.cwd()),A.dirname(a)!=="."||(n===void 0&&F.isString(D.env.PATH)&&(n=D.env.PATH.split(A.delimiter)),n===void 0||n.length===0))return A.join(i,a);async function c(m){if(await l.Promises.exists(m)){let f;try{f=await l.Promises.stat(m)}catch(w){w.message.startsWith("EACCES")&&(f=await l.Promises.lstat(m))}return f?!f.isDirectory():!1}return!1}for(let m of n){let f;if(A.isAbsolute(m)?f=A.join(m,a):f=A.join(i,m,a),await c(f))return f;let w=f+".com";if(await c(w)||(w=f+".exe",await c(w)))return w}return A.join(i,a)}r.findExecutable=S})(u=e.win32||(e.win32={}))}),define(ve[158],be([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(ve[114],be([0,1,158,11,110,17,25,146]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=P;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class y{constructor(se,K,we,ke){this.id=se,this.name=K,this.defaultValue=we,this.schema=ke}applyUpdate(se,K){return b(se,K)}compute(se,K,we){return we}}class l{constructor(se,K){this.newValue=se,this.didChange=K}}e.ApplyUpdateResult=l;function b(te,se){if(typeof te!="object"||typeof se!="object"||!te||!se)return new l(se,te!==se);if(Array.isArray(te)||Array.isArray(se)){const we=Array.isArray(te)&&Array.isArray(se)&&C.equals(te,se);return new l(se,we)}let K=!1;for(const we in se)if(se.hasOwnProperty(we)){const ke=b(te[we],se[we]);ke.didChange&&(te[we]=ke.newValue,K=!0)}return new l(te,K)}class g{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,K){return b(se,K)}validate(se){return this.defaultValue}}class v{constructor(se,K,we,ke){this.id=se,this.name=K,this.defaultValue=we,this.schema=ke}applyUpdate(se,K){return b(se,K)}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,K,we){return we}}function _(te,se){return typeof te=="undefined"?se:te==="false"?!1:Boolean(te)}e.boolean=_;class R extends v{constructor(se,K,we,ke=void 0){typeof ke!="undefined"&&(ke.type="boolean",ke.default=we);super(se,K,we,ke)}validate(se){return _(se,this.defaultValue)}}function p(te,se,K,we){if(typeof te=="undefined")return se;let ke=parseInt(te,10);return isNaN(ke)?se:(ke=Math.max(K,ke),ke=Math.min(we,ke),ke|0)}e.clampedInt=p;class h extends v{constructor(se,K,we,ke,Ve,We=void 0){typeof We!="undefined"&&(We.type="integer",We.default=we,We.minimum=ke,We.maximum=Ve);super(se,K,we,We);this.minimum=ke,this.maximum=Ve}static clampedInt(se,K,we,ke){return p(se,K,we,ke)}validate(se){return h.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class s extends v{constructor(se,K,we,ke,Ve){typeof Ve!="undefined"&&(Ve.type="number",Ve.default=we);super(se,K,we,Ve);this.validationFn=ke}static clamp(se,K,we){return se<K?K:se>we?we:se}static float(se,K){if(typeof se=="number")return se;if(typeof se=="undefined")return K;const we=parseFloat(se);return isNaN(we)?K:we}validate(se){return this.validationFn(s.float(se,this.defaultValue))}}class u extends v{static string(se,K){return typeof se!="string"?K:se}constructor(se,K,we,ke=void 0){typeof ke!="undefined"&&(ke.type="string",ke.default=we);super(se,K,we,ke)}validate(se){return u.string(se,this.defaultValue)}}function r(te,se,K){return typeof te!="string"||K.indexOf(te)===-1?se:te}e.stringSet=r;class S extends v{constructor(se,K,we,ke,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=ke,Ve.default=we);super(se,K,we,Ve);this._allowedValues=ke}validate(se){return r(se,this.defaultValue,this._allowedValues)}}class a extends y{constructor(se,K,we,ke,Ve,We,lt=void 0){typeof lt!="undefined"&&(lt.type="string",lt.enum=Ve,lt.default=ke);super(se,K,we,lt);this._allowedValues=Ve,this._convert=We}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function i(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,K,we){return we===0?se.accessibilitySupport:we}}class o extends y{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:d.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{insertSpace:_(K.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:_(K.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(te){switch(te){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function T(te){switch(te){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class L extends g{constructor(){super(128)}compute(se,K,we){const ke=["monaco-editor"];return K.get(33)&&ke.push(K.get(33)),se.extraEditorClassName&&ke.push(se.extraEditorClassName),K.get(66)==="default"?ke.push("mouse-default"):K.get(66)==="copy"&&ke.push("mouse-copy"),K.get(100)&&ke.push("showUnused"),K.get(126)&&ke.push("showDeprecated"),ke.join(" ")}}class O extends R{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(se,K,we){return we&&se.emptySelectionClipboard}}class E extends y{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:d.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:d.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{cursorMoveOnType:_(K.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":r(K.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":r(K.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:_(K.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:_(K.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:_(K.loop,this.defaultValue.loop)}}}class M extends y{constructor(){super(45,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.ON:se:Boolean(se)?M.ON:M.OFF}}e.EditorFontLigatures=M,M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on';class U extends g{constructor(){super(44)}compute(se,K,we){return se.fontInfo}}class V extends v{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(se){const K=s.float(se,this.defaultValue);return K===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(K,6,100)}compute(se,K,we){return se.fontInfo.fontSize}}class z extends y{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(h.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class N extends y{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},K={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},we=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...K},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...K},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...K},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...K},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...K},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:we,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:we,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:we,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:we,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:we,description:d.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{multiple:r(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:K.multipleDefinitions??r(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:K.multipleTypeDefinitions??r(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:K.multipleDeclarations??r(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:K.multipleImplementations??r(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:K.multipleReferences??r(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends y{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:d.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:d.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{enabled:_(K.enabled,this.defaultValue.enabled),delay:h.clampedInt(K.delay,this.defaultValue.delay,0,1e4),sticky:_(K.sticky,this.defaultValue.sticky),above:_(K.above,this.defaultValue.above)}}}var B;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class x extends g{constructor(){super(131)}compute(se,K,we){return x.computeLayout(K,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const K=se.height/se.lineHeight,we=se.scrollBeyondLastLine?K-1:0,ke=(se.viewLineCount+we)/(se.pixelRatio*se.height),Ve=Math.floor(se.viewLineCount/ke);return{typicalViewportLineCount:K,extraLinesBeyondLastLine:we,desiredRatio:ke,minimapLineCount:Ve}}static _computeMinimapLayout(se,K){const we=se.outerWidth,ke=se.outerHeight,Ve=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ke};const We=K.stableMinimapLayoutInput,lt=We&&se.outerHeight===We.outerHeight&&se.lineHeight===We.lineHeight&&se.typicalHalfwidthCharacterWidth===We.typicalHalfwidthCharacterWidth&&se.pixelRatio===We.pixelRatio&&se.scrollBeyondLastLine===We.scrollBeyondLastLine&&se.minimap.enabled===We.minimap.enabled&&se.minimap.side===We.minimap.side&&se.minimap.size===We.minimap.size&&se.minimap.showSlider===We.minimap.showSlider&&se.minimap.renderCharacters===We.minimap.renderCharacters&&se.minimap.maxColumn===We.minimap.maxColumn&&se.minimap.scale===We.minimap.scale&&se.verticalScrollbarWidth===We.verticalScrollbarWidth&&se.isViewportWrapping===We.isViewportWrapping,Re=se.lineHeight,Ae=se.typicalHalfwidthCharacterWidth,Ce=se.scrollBeyondLastLine,ue=se.minimap.renderCharacters;let de=Ve>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Ee=se.minimap.maxColumn,ye=se.minimap.size,Oe=se.minimap.side,Ge=se.verticalScrollbarWidth,$e=se.viewLineCount,Ye=se.remainingWidth,at=se.isViewportWrapping,ct=ue?2:3;let He=Math.floor(Ve*ke);const Se=He/Ve;let _e=!1,he=!1,Y=ct*de,Ie=de/Ve,Me=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:wt,desiredRatio:Bt,minimapLineCount:Tt}=x.computeContainedMinimapLineCount({viewLineCount:$e,scrollBeyondLastLine:Ce,height:ke,lineHeight:Re,pixelRatio:Ve});if($e/Tt>1)_e=!0,he=!0,de=1,Y=1,Ie=de/Ve;else{let kt=!1,Et=de+1;if(ye==="fit"){const Ot=Math.ceil(($e+wt)*Y);at&&lt&&Ye<=K.stableFitRemainingWidth?(kt=!0,Et=K.stableFitMaxMinimapScale):kt=Ot>He}if(ye==="fill"||kt){_e=!0;const Ot=de;Y=Math.min(Re*Ve,Math.max(1,Math.floor(1/Bt))),at&&lt&&Ye<=K.stableFitRemainingWidth&&(Et=K.stableFitMaxMinimapScale),de=Math.min(Et,Math.max(1,Math.floor(Y/ct))),de>Ot&&(Me=Math.min(2,de/Ot)),Ie=de/Ve/Me,He=Math.ceil(Math.max(vt,$e+wt)*Y),at?(K.stableMinimapLayoutInput=se,K.stableFitRemainingWidth=Ye,K.stableFitMaxMinimapScale=de):(K.stableMinimapLayoutInput=null,K.stableFitRemainingWidth=0)}}}const Je=Math.floor(Ee*Ie),Ke=Math.min(Je,Math.max(0,Math.floor((Ye-Ge-2)*Ie/(Ae+Ie)))+e.MINIMAP_GUTTER_WIDTH);let mt=Math.floor(Ve*Ke);const St=mt/Ve;mt=Math.floor(mt*Me);const yt=ue?1:2,dt=Oe==="left"?0:we-Ke-Ge;return{renderMinimap:yt,minimapLeft:dt,minimapWidth:Ke,minimapHeightIsEditorHeight:_e,minimapIsSampling:he,minimapScale:de,minimapLineHeight:Y,minimapCanvasInnerWidth:mt,minimapCanvasInnerHeight:He,minimapCanvasOuterWidth:St,minimapCanvasOuterHeight:Se}}static computeLayout(se,K){const we=K.outerWidth|0,ke=K.outerHeight|0,Ve=K.lineHeight|0,We=K.lineNumbersDigitCount|0,lt=K.typicalHalfwidthCharacterWidth,Re=K.maxDigitWidth,Ae=K.pixelRatio,Ce=K.viewLineCount,ue=se.get(123),de=ue==="inherit"?se.get(122):ue,Ee=de==="inherit"?se.get(118):de,ye=se.get(121),Oe=se.get(2),Ge=K.isDominatedByLongLines,$e=se.get(50),Ye=se.get(60).renderType!==0,at=se.get(61),ct=se.get(94),He=se.get(65),Se=se.get(92),_e=Se.verticalScrollbarSize,he=Se.verticalHasArrows,Y=Se.arrowSize,Ie=Se.horizontalScrollbarSize,Me=se.get(58),Je=se.get(37);let Ke;if(typeof Me=="string"&&/^\d+(\.\d+)?ch$/.test(Me)){const Wt=parseFloat(Me.substr(0,Me.length-2));Ke=h.clampedInt(Wt*lt,0,0,1e3)}else Ke=h.clampedInt(Me,0,0,1e3);Je&&(Ke+=16);let mt=0;if(Ye){const Wt=Math.max(We,at);mt=Math.round(Wt*Re)}let St=0;$e&&(St=Ve);let yt=0,dt=yt+St,vt=dt+mt,wt=vt+Ke;const Bt=we-St-mt-Ke;let Tt=!1,Mt=!1,kt=-1;Oe!==2&&(de==="inherit"&&Ge?(Tt=!0,Mt=!0):Ee==="on"||Ee==="bounded"?Mt=!0:Ee==="wordWrapColumn"&&(kt=ye));const Et=x._computeMinimapLayout({outerWidth:we,outerHeight:ke,lineHeight:Ve,typicalHalfwidthCharacterWidth:lt,pixelRatio:Ae,scrollBeyondLastLine:ct,minimap:He,verticalScrollbarWidth:_e,viewLineCount:Ce,remainingWidth:Bt,isViewportWrapping:Mt},K.memory||new F);Et.renderMinimap!==0&&Et.minimapLeft===0&&(yt+=Et.minimapWidth,dt+=Et.minimapWidth,vt+=Et.minimapWidth,wt+=Et.minimapWidth);const Ot=Bt-Et.minimapWidth,qt=Math.max(1,Math.floor((Ot-_e-2)/lt)),bt=he?Y:0;return Mt&&(kt=Math.max(1,qt),Ee==="bounded"&&(kt=Math.min(kt,ye))),{width:we,height:ke,glyphMarginLeft:yt,glyphMarginWidth:St,lineNumbersLeft:dt,lineNumbersWidth:mt,decorationsLeft:vt,decorationsWidth:Ke,contentLeft:wt,contentWidth:Ot,minimap:Et,viewportColumn:qt,isWordWrapMinified:Tt,isViewportWrapping:Mt,wrappingColumn:kt,verticalScrollbarWidth:_e,horizontalScrollbarHeight:Ie,overviewRuler:{top:bt,width:_e,height:ke-2*bt,right:0}}}}e.EditorLayoutInfoComputer=x;class $ extends y{constructor(){const se={enabled:!0};super(57,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:d.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:_(se.enabled,this.defaultValue.enabled)}}}class J extends y{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:d.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:d.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:d.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{enabled:_(K.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(K.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(K.fontFamily,this.defaultValue.fontFamily)}}}class ne extends s{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>s.clamp(se,0,150),{markdownDescription:d.localize(47,null)})}compute(se,K,we){return se.fontInfo.lineHeight}}class re extends y{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:d.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(49,null),d.localize(50,null),d.localize(51,null)],default:se.size,description:d.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:d.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:d.localize(54,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:d.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:d.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{enabled:_(K.enabled,this.defaultValue.enabled),size:r(K.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(K.side,this.defaultValue.side,["right","left"]),showSlider:r(K.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:_(K.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(K.scale,1,1,3),maxColumn:h.clampedInt(K.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Z(te){return te==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends y{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(59,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{top:h.clampedInt(K.top,0,0,1e3),bottom:h.clampedInt(K.bottom,0,0,1e3)}}}class oe extends y{constructor(){const se={enabled:!0,cycle:!1};super(76,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:d.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:d.localize(61,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{enabled:_(K.enabled,this.defaultValue.enabled),cycle:_(K.cycle,this.defaultValue.cycle)}}}class fe extends g{constructor(){super(129)}compute(se,K,we){return se.pixelRatio}}class pe extends y{constructor(){const se={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:d.localize(62,null)},comments:{type:"boolean",default:se.comments,description:d.localize(63,null)},other:{type:"boolean",default:se.other,description:d.localize(64,null)}}}],default:se,description:d.localize(65,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const K=se,we={other:_(K.other,this.defaultValue.other),comments:_(K.comments,this.defaultValue.comments),strings:_(K.strings,this.defaultValue.strings)};return we.other&&we.comments&&we.strings?!0:!we.other&&!we.comments&&!we.strings?!1:we}return this.defaultValue}}var Te;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends y{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null),d.localize(69,null)],default:"on",description:d.localize(70,null)})}validate(se){let K=this.defaultValue.renderType,we=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(K=4,we=se):se==="interval"?K=3:se==="relative"?K=2:se==="on"?K=1:K=0),{renderType:K,renderFn:we}}}function qe(te){const se=te.get(87);return se==="editable"?te.get(81):se!=="on"}e.filterValidationDecorations=qe;class Qe extends y{constructor(){const se=[],K={type:"number",description:d.localize(71,null)};super(91,"rulers",se,{type:"array",items:{anyOf:[K,{type:["object"],properties:{column:K,color:{type:"string",description:d.localize(72,null),format:"color-hex"}}}]},default:se,description:d.localize(73,null)})}validate(se){if(Array.isArray(se)){const K=[];for(let we of se)if(typeof we=="number")K.push({column:h.clampedInt(we,0,0,1e4),color:null});else if(we&&typeof we=="object"){const ke=we;K.push({column:h.clampedInt(ke.column,0,0,1e4),color:ke.color})}return K.sort((we,ke)=>we.column-ke.column),K}return this.defaultValue}}function q(te,se){if(typeof te!="string")return se;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class ie extends y{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(74,null),d.localize(75,null),d.localize(76,null)],default:"auto",description:d.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(78,null),d.localize(79,null),d.localize(80,null)],default:"auto",description:d.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:d.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:d.localize(84,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se,we=h.clampedInt(K.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ke=h.clampedInt(K.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(K.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:q(K.vertical,this.defaultValue.vertical),horizontal:q(K.horizontal,this.defaultValue.horizontal),useShadows:_(K.useShadows,this.defaultValue.useShadows),verticalHasArrows:_(K.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:_(K.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:_(K.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:_(K.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:we,horizontalSliderSize:h.clampedInt(K.horizontalSliderSize,we,0,1e3),verticalScrollbarSize:ke,verticalSliderSize:h.clampedInt(K.verticalSliderSize,ke,0,1e3),scrollByPage:_(K.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends y{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:d.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:d.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:d.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:d.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:d.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:d.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:d.localize(91,null)}})}applyUpdate(se,K){let we=!1;K.allowedCharacters&&(A.equals(se.allowedCharacters,K.allowedCharacters)||(se={...se,allowedCharacters:K.allowedCharacters},we=!0)),K.allowedLocales&&(A.equals(se.allowedLocales,K.allowedLocales)||(se={...se,allowedLocales:K.allowedLocales},we=!0));const ke=super.applyUpdate(se,K);return we?new l(ke.newValue,!0):ke}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{nonBasicASCII:De(K.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:_(K.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:_(K.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:De(K.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:De(K.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,K){if(typeof se!="object"||!se)return K;const we={};for(const[ke,Ve]of Object.entries(se))Ve===!0&&(we[ke]=!0);return we}}class X extends y{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:d.localize(92,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{enabled:_(K.enabled,this.defaultValue.enabled),mode:r(K.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ae extends y{constructor(){const se={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,description:d.localize(93,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:_(se.enabled,this.defaultValue.enabled)}}}class me extends y{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(94,null),d.localize(95,null),d.localize(96,null)],default:se.bracketPairs,description:d.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(98,null),d.localize(99,null),d.localize(100,null)],default:se.bracketPairsHorizontal,description:d.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:d.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:d.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:se.highlightActiveIndentation,description:d.localize(104,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{bracketPairs:De(K.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:De(K.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:_(K.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:_(K.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(K.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function De(te,se,K){const we=K.indexOf(te);return we===-1?se:K[we]}class Be extends y{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(105,null),d.localize(106,null)],default:se.insertMode,description:d.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:d.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:d.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:d.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:d.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:d.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:d.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:d.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:d.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(146,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const K=se;return{insertMode:r(K.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:_(K.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:_(K.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:_(K.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:_(K.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:_(K.showIcons,this.defaultValue.showIcons),showStatusBar:_(K.showStatusBar,this.defaultValue.showStatusBar),preview:_(K.preview,this.defaultValue.preview),previewMode:r(K.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:_(K.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:_(K.showMethods,this.defaultValue.showMethods),showFunctions:_(K.showFunctions,this.defaultValue.showFunctions),showConstructors:_(K.showConstructors,this.defaultValue.showConstructors),showDeprecated:_(K.showDeprecated,this.defaultValue.showDeprecated),showFields:_(K.showFields,this.defaultValue.showFields),showVariables:_(K.showVariables,this.defaultValue.showVariables),showClasses:_(K.showClasses,this.defaultValue.showClasses),showStructs:_(K.showStructs,this.defaultValue.showStructs),showInterfaces:_(K.showInterfaces,this.defaultValue.showInterfaces),showModules:_(K.showModules,this.defaultValue.showModules),showProperties:_(K.showProperties,this.defaultValue.showProperties),showEvents:_(K.showEvents,this.defaultValue.showEvents),showOperators:_(K.showOperators,this.defaultValue.showOperators),showUnits:_(K.showUnits,this.defaultValue.showUnits),showValues:_(K.showValues,this.defaultValue.showValues),showConstants:_(K.showConstants,this.defaultValue.showConstants),showEnums:_(K.showEnums,this.defaultValue.showEnums),showEnumMembers:_(K.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:_(K.showKeywords,this.defaultValue.showKeywords),showWords:_(K.showWords,this.defaultValue.showWords),showColors:_(K.showColors,this.defaultValue.showColors),showFiles:_(K.showFiles,this.defaultValue.showFiles),showReferences:_(K.showReferences,this.defaultValue.showReferences),showFolders:_(K.showFolders,this.defaultValue.showFolders),showTypeParameters:_(K.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:_(K.showSnippets,this.defaultValue.showSnippets),showUsers:_(K.showUsers,this.defaultValue.showUsers),showIssues:_(K.showIssues,this.defaultValue.showIssues)}}}class Xe extends y{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(147,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:_(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class tt extends g{constructor(){super(130)}compute(se,K,we){return K.get(81)?!0:se.tabFocusMode}}var rt;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(rt=e.WrappingIndent||(e.WrappingIndent={}));function st(te){switch(te){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class et extends g{constructor(){super(132)}compute(se,K,we){const ke=K.get(131);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:ke.isWordWrapMinified,isViewportWrapping:ke.isViewportWrapping,wrappingColumn:ke.wrappingColumn}}}const nt="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",It="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?gt:t.isLinux?It:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(te){return e.editorOptionsRegistry[te.id]=te,te}var Dt;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.autoClosingBrackets=5]="autoClosingBrackets",te[te.autoClosingDelete=6]="autoClosingDelete",te[te.autoClosingOvertype=7]="autoClosingOvertype",te[te.autoClosingQuotes=8]="autoClosingQuotes",te[te.autoIndent=9]="autoIndent",te[te.automaticLayout=10]="automaticLayout",te[te.autoSurround=11]="autoSurround",te[te.bracketPairColorization=12]="bracketPairColorization",te[te.guides=13]="guides",te[te.codeLens=14]="codeLens",te[te.codeLensFontFamily=15]="codeLensFontFamily",te[te.codeLensFontSize=16]="codeLensFontSize",te[te.colorDecorators=17]="colorDecorators",te[te.columnSelection=18]="columnSelection",te[te.comments=19]="comments",te[te.contextmenu=20]="contextmenu",te[te.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",te[te.cursorBlinking=22]="cursorBlinking",te[te.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",te[te.cursorStyle=24]="cursorStyle",te[te.cursorSurroundingLines=25]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",te[te.cursorWidth=27]="cursorWidth",te[te.disableLayerHinting=28]="disableLayerHinting",te[te.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",te[te.domReadOnly=30]="domReadOnly",te[te.dragAndDrop=31]="dragAndDrop",te[te.emptySelectionClipboard=32]="emptySelectionClipboard",te[te.extraEditorClassName=33]="extraEditorClassName",te[te.fastScrollSensitivity=34]="fastScrollSensitivity",te[te.find=35]="find",te[te.fixedOverflowWidgets=36]="fixedOverflowWidgets",te[te.folding=37]="folding",te[te.foldingStrategy=38]="foldingStrategy",te[te.foldingHighlight=39]="foldingHighlight",te[te.foldingImportsByDefault=40]="foldingImportsByDefault",te[te.foldingMaximumRegions=41]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=43]="fontFamily",te[te.fontInfo=44]="fontInfo",te[te.fontLigatures=45]="fontLigatures",te[te.fontSize=46]="fontSize",te[te.fontWeight=47]="fontWeight",te[te.formatOnPaste=48]="formatOnPaste",te[te.formatOnType=49]="formatOnType",te[te.glyphMargin=50]="glyphMargin",te[te.gotoLocation=51]="gotoLocation",te[te.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",te[te.hover=53]="hover",te[te.inDiffEditor=54]="inDiffEditor",te[te.inlineSuggest=55]="inlineSuggest",te[te.letterSpacing=56]="letterSpacing",te[te.lightbulb=57]="lightbulb",te[te.lineDecorationsWidth=58]="lineDecorationsWidth",te[te.lineHeight=59]="lineHeight",te[te.lineNumbers=60]="lineNumbers",te[te.lineNumbersMinChars=61]="lineNumbersMinChars",te[te.linkedEditing=62]="linkedEditing",te[te.links=63]="links",te[te.matchBrackets=64]="matchBrackets",te[te.minimap=65]="minimap",te[te.mouseStyle=66]="mouseStyle",te[te.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=68]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",te[te.multiCursorModifier=70]="multiCursorModifier",te[te.multiCursorPaste=71]="multiCursorPaste",te[te.occurrencesHighlight=72]="occurrencesHighlight",te[te.overviewRulerBorder=73]="overviewRulerBorder",te[te.overviewRulerLanes=74]="overviewRulerLanes",te[te.padding=75]="padding",te[te.parameterHints=76]="parameterHints",te[te.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",te[te.quickSuggestions=79]="quickSuggestions",te[te.quickSuggestionsDelay=80]="quickSuggestionsDelay",te[te.readOnly=81]="readOnly",te[te.renameOnType=82]="renameOnType",te[te.renderControlCharacters=83]="renderControlCharacters",te[te.renderFinalNewline=84]="renderFinalNewline",te[te.renderLineHighlight=85]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=87]="renderValidationDecorations",te[te.renderWhitespace=88]="renderWhitespace",te[te.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",te[te.roundedSelection=90]="roundedSelection",te[te.rulers=91]="rulers",te[te.scrollbar=92]="scrollbar",te[te.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=94]="scrollBeyondLastLine",te[te.scrollPredominantAxis=95]="scrollPredominantAxis",te[te.selectionClipboard=96]="selectionClipboard",te[te.selectionHighlight=97]="selectionHighlight",te[te.selectOnLineNumbers=98]="selectOnLineNumbers",te[te.showFoldingControls=99]="showFoldingControls",te[te.showUnused=100]="showUnused",te[te.snippetSuggestions=101]="snippetSuggestions",te[te.smartSelect=102]="smartSelect",te[te.smoothScrolling=103]="smoothScrolling",te[te.stickyTabStops=104]="stickyTabStops",te[te.stopRenderingLineAfter=105]="stopRenderingLineAfter",te[te.suggest=106]="suggest",te[te.suggestFontSize=107]="suggestFontSize",te[te.suggestLineHeight=108]="suggestLineHeight",te[te.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",te[te.suggestSelection=110]="suggestSelection",te[te.tabCompletion=111]="tabCompletion",te[te.tabIndex=112]="tabIndex",te[te.unicodeHighlighting=113]="unicodeHighlighting",te[te.unusualLineTerminators=114]="unusualLineTerminators",te[te.useShadowDOM=115]="useShadowDOM",te[te.useTabStops=116]="useTabStops",te[te.wordSeparators=117]="wordSeparators",te[te.wordWrap=118]="wordWrap",te[te.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=121]="wordWrapColumn",te[te.wordWrapOverride1=122]="wordWrapOverride1",te[te.wordWrapOverride2=123]="wordWrapOverride2",te[te.wrappingIndent=124]="wrappingIndent",te[te.wrappingStrategy=125]="wrappingStrategy",te[te.showDeprecated=126]="showDeprecated",te[te.inlayHints=127]="inlayHints",te[te.editorClassName=128]="editorClassName",te[te.pixelRatio=129]="pixelRatio",te[te.tabFocusMode=130]="tabFocusMode",te[te.layoutInfo=131]="layoutInfo",te[te.wrappingInfo=132]="wrappingInfo"})(Dt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new R(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(148,null)})),acceptSuggestionOnEnter:Ne(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(149,null),""],markdownDescription:d.localize(150,null)})),accessibilitySupport:Ne(new n),accessibilityPageSize:Ne(new h(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(151,null)})),ariaLabel:Ne(new u(4,"ariaLabel",d.localize(152,null))),autoClosingBrackets:Ne(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(153,null),d.localize(154,null),""],description:d.localize(155,null)})),autoClosingDelete:Ne(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(156,null),""],description:d.localize(157,null)})),autoClosingOvertype:Ne(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(158,null),""],description:d.localize(159,null)})),autoClosingQuotes:Ne(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(160,null),d.localize(161,null),""],description:d.localize(162,null)})),autoIndent:Ne(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[d.localize(163,null),d.localize(164,null),d.localize(165,null),d.localize(166,null),d.localize(167,null)],description:d.localize(168,null)})),automaticLayout:Ne(new R(10,"automaticLayout",!1)),autoSurround:Ne(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(169,null),d.localize(170,null),d.localize(171,null),""],description:d.localize(172,null)})),bracketPairColorization:Ne(new ae),bracketPairGuides:Ne(new me),stickyTabStops:Ne(new R(104,"stickyTabStops",!1,{description:d.localize(173,null)})),codeLens:Ne(new R(14,"codeLens",!0,{description:d.localize(174,null)})),codeLensFontFamily:Ne(new u(15,"codeLensFontFamily","",{description:d.localize(175,null)})),codeLensFontSize:Ne(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(176,null)})),colorDecorators:Ne(new R(17,"colorDecorators",!0,{description:d.localize(177,null)})),columnSelection:Ne(new R(18,"columnSelection",!1,{description:d.localize(178,null)})),comments:Ne(new o),contextmenu:Ne(new R(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new R(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(179,null)})),cursorBlinking:Ne(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:d.localize(180,null)})),cursorSmoothCaretAnimation:Ne(new R(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(181,null)})),cursorStyle:Ne(new a(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:d.localize(182,null)})),cursorSurroundingLines:Ne(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(183,null)})),cursorSurroundingLinesStyle:Ne(new S(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(184,null),d.localize(185,null)],description:d.localize(186,null)})),cursorWidth:Ne(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(187,null)})),disableLayerHinting:Ne(new R(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new R(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new R(30,"domReadOnly",!1)),dragAndDrop:Ne(new R(31,"dragAndDrop",!0,{description:d.localize(188,null)})),emptySelectionClipboard:Ne(new O),extraEditorClassName:Ne(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Ne(new s(34,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:d.localize(189,null)})),find:Ne(new E),fixedOverflowWidgets:Ne(new R(36,"fixedOverflowWidgets",!1)),folding:Ne(new R(37,"folding",!0,{description:d.localize(190,null)})),foldingStrategy:Ne(new S(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(191,null),d.localize(192,null)],description:d.localize(193,null)})),foldingHighlight:Ne(new R(39,"foldingHighlight",!0,{description:d.localize(194,null)})),foldingImportsByDefault:Ne(new R(40,"foldingImportsByDefault",!1,{description:d.localize(195,null)})),foldingMaximumRegions:Ne(new h(41,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(196,null)})),unfoldOnClickAfterEndOfLine:Ne(new R(42,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(197,null)})),fontFamily:Ne(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(198,null)})),fontInfo:Ne(new U),fontLigatures2:Ne(new M),fontSize:Ne(new V),fontWeight:Ne(new z),formatOnPaste:Ne(new R(48,"formatOnPaste",!1,{description:d.localize(199,null)})),formatOnType:Ne(new R(49,"formatOnType",!1,{description:d.localize(200,null)})),glyphMargin:Ne(new R(50,"glyphMargin",!0,{description:d.localize(201,null)})),gotoLocation:Ne(new N),hideCursorInOverviewRuler:Ne(new R(52,"hideCursorInOverviewRuler",!1,{description:d.localize(202,null)})),hover:Ne(new W),inDiffEditor:Ne(new R(54,"inDiffEditor",!1)),letterSpacing:Ne(new s(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>s.clamp(te,-5,20),{description:d.localize(203,null)})),lightbulb:Ne(new $),lineDecorationsWidth:Ne(new v(58,"lineDecorationsWidth",10)),lineHeight:Ne(new ne),lineNumbers:Ne(new xe),lineNumbersMinChars:Ne(new h(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new R(62,"linkedEditing",!1,{description:d.localize(204,null)})),links:Ne(new R(63,"links",!0,{description:d.localize(205,null)})),matchBrackets:Ne(new S(64,"matchBrackets","always",["always","near","never"],{description:d.localize(206,null)})),minimap:Ne(new re),mouseStyle:Ne(new S(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new s(67,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:d.localize(207,null)})),mouseWheelZoom:Ne(new R(68,"mouseWheelZoom",!1,{markdownDescription:d.localize(208,null)})),multiCursorMergeOverlapping:Ne(new R(69,"multiCursorMergeOverlapping",!0,{description:d.localize(209,null)})),multiCursorModifier:Ne(new a(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Z,{markdownEnumDescriptions:[d.localize(210,null),d.localize(211,null)],markdownDescription:d.localize(212,null)})),multiCursorPaste:Ne(new S(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(213,null),d.localize(214,null)],markdownDescription:d.localize(215,null)})),occurrencesHighlight:Ne(new R(72,"occurrencesHighlight",!0,{description:d.localize(216,null)})),overviewRulerBorder:Ne(new R(73,"overviewRulerBorder",!0,{description:d.localize(217,null)})),overviewRulerLanes:Ne(new h(74,"overviewRulerLanes",3,0,3)),padding:Ne(new Q),parameterHints:Ne(new oe),peekWidgetDefaultFocus:Ne(new S(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(218,null),d.localize(219,null)],description:d.localize(220,null)})),definitionLinkOpensInPeek:Ne(new R(78,"definitionLinkOpensInPeek",!1,{description:d.localize(221,null)})),quickSuggestions:Ne(new pe),quickSuggestionsDelay:Ne(new h(80,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(222,null)})),readOnly:Ne(new R(81,"readOnly",!1)),renameOnType:Ne(new R(82,"renameOnType",!1,{description:d.localize(223,null),markdownDeprecationMessage:d.localize(224,null)})),renderControlCharacters:Ne(new R(83,"renderControlCharacters",!0,{description:d.localize(225,null),restricted:!0})),renderFinalNewline:Ne(new R(84,"renderFinalNewline",!0,{description:d.localize(226,null)})),renderLineHighlight:Ne(new S(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(227,null)],description:d.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Ne(new R(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(229,null)})),renderValidationDecorations:Ne(new S(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new S(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(230,null),d.localize(231,null),d.localize(232,null),""],description:d.localize(233,null)})),revealHorizontalRightPadding:Ne(new h(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ne(new R(90,"roundedSelection",!0,{description:d.localize(234,null)})),rulers:Ne(new Qe),scrollbar:Ne(new ie),scrollBeyondLastColumn:Ne(new h(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(235,null)})),scrollBeyondLastLine:Ne(new R(94,"scrollBeyondLastLine",!0,{description:d.localize(236,null)})),scrollPredominantAxis:Ne(new R(95,"scrollPredominantAxis",!0,{description:d.localize(237,null)})),selectionClipboard:Ne(new R(96,"selectionClipboard",!0,{description:d.localize(238,null),included:t.isLinux})),selectionHighlight:Ne(new R(97,"selectionHighlight",!0,{description:d.localize(239,null)})),selectOnLineNumbers:Ne(new R(98,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new S(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(240,null),d.localize(241,null)],description:d.localize(242,null)})),showUnused:Ne(new R(100,"showUnused",!0,{description:d.localize(243,null)})),showDeprecated:Ne(new R(126,"showDeprecated",!0,{description:d.localize(244,null)})),inlayHints:Ne(new J),snippetSuggestions:Ne(new S(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(245,null),d.localize(246,null),d.localize(247,null),d.localize(248,null)],description:d.localize(249,null)})),smartSelect:Ne(new Xe),smoothScrolling:Ne(new R(103,"smoothScrolling",!1,{description:d.localize(250,null)})),stopRenderingLineAfter:Ne(new h(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new Be),inlineSuggest:Ne(new X),suggestFontSize:Ne(new h(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(251,null)})),suggestLineHeight:Ne(new h(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(252,null)})),suggestOnTriggerCharacters:Ne(new R(109,"suggestOnTriggerCharacters",!0,{description:d.localize(253,null)})),suggestSelection:Ne(new S(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(254,null),d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),tabCompletion:Ne(new S(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(258,null),d.localize(259,null),d.localize(260,null)],description:d.localize(261,null)})),tabIndex:Ne(new h(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new G),unusualLineTerminators:Ne(new S(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(262,null),d.localize(263,null),d.localize(264,null)],description:d.localize(265,null)})),useShadowDOM:Ne(new R(115,"useShadowDOM",!0)),useTabStops:Ne(new R(116,"useTabStops",!0,{description:d.localize(266,null)})),wordSeparators:Ne(new u(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:d.localize(267,null)})),wordWrap:Ne(new S(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(268,null),d.localize(269,null),d.localize(270,null),d.localize(271,null)],description:d.localize(272,null)})),wordWrapBreakAfterCharacters:Ne(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new h(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(273,null)})),wordWrapOverride1:Ne(new S(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new S(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new a(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[d.localize(274,null),d.localize(275,null),d.localize(276,null),d.localize(277,null)],description:d.localize(278,null)})),wrappingStrategy:Ne(new S(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(279,null),d.localize(280,null)],description:d.localize(281,null)})),editorClassName:Ne(new L),pixelRatio:Ne(new fe),tabFocusMode:Ne(new tt),layoutInfo:Ne(new x),wrappingInfo:Ne(new et)}}),define(ve[159],be([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[160],be([19,20]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[161],be([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[162],be([19,20]),function(ee,e){return ee.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[163],be([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(ve[164],be([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(ve[165],be([19,20]),function(ee,e){return ee.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[166],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[167],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[168],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[169],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[170],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[171],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[172],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[173],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[174],be([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[175],be([19,20]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(ve[176],be([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[177],be([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[178],be([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[179],be([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[180],be([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[181],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var t;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[182],be([0,1,161]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(l){return l=l.trim(),l==="*"||t.test(l)}e.isValidVersionStr=C;function A(l){if(!C(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=l.match(t);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=A;function k(l){if(!l)return null;let b=l.majorBase,g=l.majorMustEqual,v=l.minorBase,_=l.minorMustEqual,R=l.patchBase,p=l.patchMustEqual;l.hasCaret&&(b===0||(_=!1),p=!1);let h=0;if(l.preRelease){const s=I.exec(l.preRelease);if(s){const[,u,r,S]=s;h=Date.UTC(Number(u),Number(r)-1,Number(S))}}return{majorBase:b,majorMustEqual:g,minorBase:v,minorMustEqual:_,patchBase:R,patchMustEqual:p,isMinimum:l.hasGreaterEquals,notBefore:h}}e.normalizeVersion=k;function D(l,b,g){let v;typeof l=="string"?v=k(A(l)):v=l;let _;b instanceof Date?_=b.getTime():typeof b=="string"&&(_=new Date(b).getTime());let R;if(typeof g=="string"?R=k(A(g)):R=g,!v||!R)return!1;let p=v.majorBase,h=v.minorBase,s=v.patchBase,u=R.majorBase,r=R.minorBase,S=R.patchBase,a=R.notBefore,i=R.majorMustEqual,n=R.minorMustEqual,o=R.patchMustEqual;return R.isMinimum?p>u?!0:p<u?!1:h>r?!0:h<r||_&&_<a?!1:s>=S:(p===1&&u===0&&(!i||!n||!o)&&(u=1,r=0,S=0,i=!0,n=!1,o=!1),p<u?!1:p>u?!i:h<r?!1:h>r?!n:s<S?!1:s>S?!o:!(_&&_<a))}e.isValidVersion=D;function P(l,b,g,v){return g.isBuiltin||typeof g.main=="undefined"?!0:y(l,b,g.engines.vscode,v)}e.isValidExtensionVersion=P;function F(l,b,g){return l==="*"||y(b,g,l)}e.isEngineValid=F;function y(l,b,g,v=[]){let _=k(A(g));if(!_)return v.push(d.localize(0,null,g)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(d.localize(1,null,g)),!1}else if(!_.majorMustEqual)return v.push(d.localize(2,null,g)),!1;return D(l,b,_)?!0:(v.push(d.localize(3,null,l,g)),!1)}}),define(ve[115],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(I,C=[],A=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=d}),define(ve[61],be([0,1,115]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(A,k,D){k instanceof d.SyncDescriptor||(k=new d.SyncDescriptor(k,[],D)),t.push([A,k])}e.registerSingleton=I;function C(){return t}e.getSingletonServiceDescriptors=C}),define(ve[183],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=d;class t{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let A of this._nodes.values())A.outgoing.size===0&&C.push(A);return C}insertEdge(C,A){const k=this.lookupOrInsertNode(C),D=this.lookupOrInsertNode(A);k.outgoing.set(this._hashFn(A),D),D.incoming.set(this._hashFn(C),k)}removeNode(C){const A=this._hashFn(C);this._nodes.delete(A);for(let k of this._nodes.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(C){const A=this._hashFn(C);let k=this._nodes.get(A);return k||(k=new d(C),this._nodes.set(A,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[A,k]of this._nodes)C.push(`${A}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,A]of this._nodes){const k=new Set([C]),D=this._findCycle(A,k);if(D)return D}}_findCycle(C,A){for(let[k,D]of C.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const P=this._findCycle(D,A);if(P)return P;A.delete(k)}}}e.Graph=t}),define(ve[4],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function k(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=k})(d=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(A,k,D,P){k[d.DI_TARGET]===k?k[d.DI_DEPENDENCIES].push({id:A,index:D,optional:P}):(k[d.DI_DEPENDENCIES]=[{id:A,index:D,optional:P}],k[d.DI_TARGET]=k)}function I(A){if(d.serviceIds.has(A))return d.serviceIds.get(A);const k=function(D,P,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,D,F,!1)};return k.toString=()=>A,d.serviceIds.set(A,k),k}e.createDecorator=I;function C(A){return A}e.refineServiceDecorator=C}),define(ve[116],be([0,1,18,2,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function C(_){return _&&typeof _=="object"&&(!_.overrideIdentifier||typeof _.overrideIdentifier=="string")&&(!_.resource||_.resource instanceof t.URI)}e.isConfigurationOverrides=C;function A(_){return _&&typeof _=="object"&&(!_.overrideIdentifiers||d.isArray(_.overrideIdentifiers))&&!_.overrideIdentifier&&(!_.resource||_.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var k;(function(_){_[_.USER=1]="USER",_[_.USER_LOCAL=2]="USER_LOCAL",_[_.USER_REMOTE=3]="USER_REMOTE",_[_.WORKSPACE=4]="WORKSPACE",_[_.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",_[_.DEFAULT=6]="DEFAULT",_[_.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(_){switch(_){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function P(_,R){const p=Object.create(null);for(let h in _)F(p,h,_[h],R);return p}e.toValuesTree=P;function F(_,R,p,h){const s=R.split("."),u=s.pop();let r=_;for(let S=0;S<s.length;S++){let a=s[S],i=r[a];switch(typeof i){case"undefined":i=r[a]=Object.create(null);break;case"object":break;default:h(`Ignoring ${R} as ${s.slice(0,S+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[u]=p}catch{h(`Ignoring ${R} as ${s.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${R} as ${s.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=F;function y(_,R){const p=R.split(".");l(_,p)}e.removeFromValueTree=y;function l(_,R){const p=R.shift();if(R.length===0){delete _[p];return}if(Object.keys(_).indexOf(p)!==-1){const h=_[p];typeof h=="object"&&!Array.isArray(h)&&(l(h,R),Object.keys(h).length===0&&delete _[p])}}function b(_,R,p){function h(r,S){let a=r;for(const i of S){if(typeof a!="object"||a===null)return;a=a[i]}return a}const s=R.split("."),u=h(_,s);return typeof u=="undefined"?p:u}e.getConfigurationValue=b;function g(_,R,p){Object.keys(R).forEach(h=>{h!=="__proto__"&&(h in _?d.isObject(_[h])&&d.isObject(R[h])?g(_[h],R[h],p):p&&(_[h]=R[h]):_[h]=R[h])})}e.merge=g;function v(_,R,p){const h=_.inspect(R),s=_.inspect(p);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:h.defaultValue}e.getMigratedSettingValue=v}),define(ve[62],be([0,1,11,8,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",d.isMacintosh),C.set("isLinux",d.isLinux),C.set("isWindows",d.isWindows),C.set("isWeb",d.isWeb),C.set("isMacNative",d.isMacintosh&&!d.isWeb),C.set("isEdge",d.isEdge),C.set("isFirefox",d.isFirefox),C.set("isChrome",d.isChrome),C.set("isSafari",d.isSafari);const A=Object.prototype.hasOwnProperty;var k;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return y.INSTANCE}static true(){return l.INSTANCE}static has(E){return b.create(E)}static equals(E,M){return g.create(E,M)}static notEquals(E,M){return R.create(E,M)}static regex(E,M){return a.create(E,M)}static in(E,M){return v.create(E,M)}static not(E){return p.create(E)}static and(...E){return o.create(E,null)}static or(...E){return c.create(E,null,!0)}static greater(E,M){return s.create(E,M)}static greaterEquals(E,M){return u.create(E,M)}static smaller(E,M){return r.create(E,M)}static smallerEquals(E,M){return S.create(E,M)}static deserialize(E,M=!1){if(!!E)return this._deserializeOrExpression(E,M)}static _deserializeOrExpression(E,M){let U=E.split("||");return c.create(U.map(V=>this._deserializeAndExpression(V,M)),null,!0)}static _deserializeAndExpression(E,M){let U=E.split("&&");return o.create(U.map(V=>this._deserializeOne(V,M)),null)}static _deserializeOne(E,M){if(E=E.trim(),E.indexOf("!=")>=0){let U=E.split("!=");return R.create(U[0].trim(),this._deserializeValue(U[1],M))}if(E.indexOf("==")>=0){let U=E.split("==");return g.create(U[0].trim(),this._deserializeValue(U[1],M))}if(E.indexOf("=~")>=0){let U=E.split("=~");return a.create(U[0].trim(),this._deserializeRegexValue(U[1],M))}if(E.indexOf(" in ")>=0){let U=E.split(" in ");return v.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const U=E.split(">=");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const U=E.split(">");return s.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const U=E.split("<=");return S.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const U=E.split("<");return r.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(E)?p.create(E.substr(1).trim()):b.create(E)}static _deserializeValue(E,M){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let U=/^'([^']*)'$/.exec(E);return U?U[1].trim():E}static _deserializeRegexValue(E,M){if((0,t.isFalsyOrWhitespace)(E)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=E.indexOf("/"),V=E.lastIndexOf("/");if(U===V||U<0){if(M)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let z=E.slice(U+1,V),N=E[V+1]==="i"?"i":"";try{return new RegExp(z,N)}catch(W){if(M)throw new Error(`bad regexp-value '${E}', parse error: ${W}`);return console.warn(`bad regexp-value '${E}', parse error: ${W}`),null}}}e.ContextKeyExpr=D;function P(O,E){const M=O?O.substituteConstants():void 0,U=E?E.substituteConstants():void 0;return!M&&!U?!0:!M||!U?!1:M.equals(U)}e.expressionsAreEqualWithConstantSubstitution=P;function F(O,E){return O.cmp(E)}class y{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class l{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class b{constructor(E,M){this.key=E,this.negated=M,this.type=2}static create(E,M=null){const U=C.get(E);return typeof U=="boolean"?U?l.INSTANCE:y.INSTANCE:new b(E,M)}cmp(E){return E.type!==this.type?this.type-E.type:f(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=C.get(this.key);return typeof E=="boolean"?E?l.INSTANCE:y.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class g{constructor(E,M,U){this.key=E,this.value=M,this.negated=U,this.type=4}static create(E,M,U=null){if(typeof M=="boolean")return M?b.create(E,U):p.create(E,U);const V=C.get(E);return typeof V=="boolean"?M===(V?"true":"false")?l.INSTANCE:y.INSTANCE:new g(E,M,U)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=C.get(this.key);if(typeof E=="boolean"){const M=E?"true":"false";return this.value===M?l.INSTANCE:y.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class v{constructor(E,M){this.key=E,this.valueKey=M,this.type=10,this.negated=null}static create(E,M){return new v(E,M)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const M=E.getValue(this.valueKey),U=E.getValue(this.key);return Array.isArray(M)?M.indexOf(U)>=0:typeof U=="string"&&typeof M=="object"&&M!==null?A.call(M,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this)),this.negated}}e.ContextKeyInExpr=v;class _{constructor(E){this._actual=E,this.type=11}static create(E){return new _(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new _(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class R{constructor(E,M,U){this.key=E,this.value=M,this.negated=U,this.type=5}static create(E,M,U=null){if(typeof M=="boolean")return M?p.create(E,U):b.create(E,U);const V=C.get(E);return typeof V=="boolean"?M===(V?"true":"false")?y.INSTANCE:l.INSTANCE:new R(E,M,U)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=C.get(this.key);if(typeof E=="boolean"){const M=E?"true":"false";return this.value===M?y.INSTANCE:l.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=R;class p{constructor(E,M){this.key=E,this.negated=M,this.type=3}static create(E,M=null){const U=C.get(E);return typeof U=="boolean"?U?y.INSTANCE:l.INSTANCE:new p(E,M)}cmp(E){return E.type!==this.type?this.type-E.type:f(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=C.get(this.key);return typeof E=="boolean"?E?y.INSTANCE:l.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function h(O,E){if(typeof O=="string"){const M=parseFloat(O);isNaN(M)||(O=M)}return typeof O=="string"||typeof O=="number"?E(O):y.INSTANCE}class s{constructor(E,M,U){this.key=E,this.value=M,this.negated=U,this.type=12}static create(E,M,U=null){return h(M,V=>new s(E,V,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class u{constructor(E,M,U){this.key=E,this.value=M,this.negated=U,this.type=13}static create(E,M,U=null){return h(M,V=>new u(E,V,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class r{constructor(E,M,U){this.key=E,this.value=M,this.negated=U,this.type=14}static create(E,M,U=null){return h(M,V=>new r(E,V,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class S{constructor(E,M,U){this.key=E,this.value=M,this.negated=U,this.type=15}static create(E,M,U=null){return h(M,V=>new S(E,V,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=S;class a{constructor(E,M){this.key=E,this.regexp=M,this.type=7,this.negated=null}static create(E,M){return new a(E,M)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const M=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return M<U?-1:M>U?1:0}equals(E){if(E.type===this.type){const M=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return this.key===E.key&&M===U}return!1}substituteConstants(){return this}evaluate(E){let M=E.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class i{constructor(E){this._actual=E,this.type=8}static create(E){return new i(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new i(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function n(O){let E=null;for(let M=0,U=O.length;M<U;M++){const V=O[M].substituteConstants();if(O[M]!==V&&E===null){E=[];for(let z=0;z<M;z++)E[z]=O[z]}E!==null&&(E[M]=V)}return E===null?O:E}class o{constructor(E,M){this.expr=E,this.negated=M,this.type=6}static create(E,M){return o._normalizeArr(E,M)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const V=F(this.expr[M],E.expr[M]);if(V!==0)return V}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(E.expr[M]))return!1;return!0}return!1}substituteConstants(){const E=n(this.expr);return E===this.expr?this:o.create(E,this.negated)}evaluate(E){for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].evaluate(E))return!1;return!0}static _normalizeArr(E,M){const U=[];let V=!1;for(const z of E)if(!!z){if(z.type===1){V=!0;continue}if(z.type===0)return y.INSTANCE;if(z.type===6){U.push(...z.expr);continue}U.push(z)}if(U.length===0&&V)return l.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(F);for(let z=1;z<U.length;z++)U[z-1].equals(U[z])&&(U.splice(z,1),z--);if(U.length===1)return U[0];for(;U.length>1;){const z=U[U.length-1];if(z.type!==9)break;U.pop();const N=U.pop(),W=U.length===0,B=c.create(z.expr.map(x=>o.create([x,N],null)),null,W);B&&(U.push(B),U.sort(F))}return U.length===1?U[0]:new o(U,M)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let M of this.expr)E.push(...M.keys());return E}map(E){return new o(this.expr.map(M=>M.map(E)),null)}negate(){if(!this.negated){const E=[];for(let M of this.expr)E.push(M.negate());this.negated=c.create(E,this,!0)}return this.negated}}class c{constructor(E,M){this.expr=E,this.negated=M,this.type=9}static create(E,M,U){return c._normalizeArr(E,M,U)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const V=F(this.expr[M],E.expr[M]);if(V!==0)return V}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(E.expr[M]))return!1;return!0}return!1}substituteConstants(){const E=n(this.expr);return E===this.expr?this:c.create(E,this.negated,!1)}evaluate(E){for(let M=0,U=this.expr.length;M<U;M++)if(this.expr[M].evaluate(E))return!0;return!1}static _normalizeArr(E,M,U){let V=[],z=!1;if(E){for(let N=0,W=E.length;N<W;N++){const B=E[N];if(!!B){if(B.type===0){z=!0;continue}if(B.type===1)return l.INSTANCE;if(B.type===9){V=V.concat(B.expr);continue}V.push(B)}}if(V.length===0&&z)return y.INSTANCE;V.sort(F)}if(V.length!==0){if(V.length===1)return V[0];for(let N=1;N<V.length;N++)V[N-1].equals(V[N])&&(V.splice(N,1),N--);if(V.length===1)return V[0];if(U){for(let N=0;N<V.length;N++)for(let W=N+1;W<V.length;W++)T(V[N],V[W])&&(V.splice(W,1),W--);if(V.length===1)return V[0]}return new c(V,M)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let M of this.expr)E.push(...M.keys());return E}map(E){return new c(this.expr.map(M=>M.map(E)),null)}negate(){if(!this.negated){let E=[];for(let M of this.expr)E.push(M.negate());for(;E.length>1;){const M=E.shift(),U=E.shift(),V=[];for(const N of L(M))for(const W of L(U))V.push(o.create([N,W],null));const z=E.length===0;E.unshift(c.create(V,null,z))}this.negated=E[0]}return this.negated}}class m extends b{constructor(E,M,U){super(E,null);this._defaultValue=M,typeof U=="object"?m._info.push({...U,key:E}):U!==!0&&m._info.push({key:E,description:U,type:M!=null?typeof M:void 0})}static all(){return m._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return g.create(this.key,E)}notEqualsTo(E){return R.create(this.key,E)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(O,E){return O<E?-1:O>E?1:0}function w(O,E,M,U){return O<M?-1:O>M?1:E<U?-1:E>U?1:0}function T(O,E){if(E.type===6&&O.type!==9&&O.type!==6){for(const V of E.expr)if(O.equals(V))return!0}const M=O.negate(),U=L(M).concat(L(E));U.sort(F);for(let V=0;V<U.length;V++){const N=U[V].negate();for(let W=V+1;W<U.length;W++){const B=U[W];if(N.equals(B))return!0}}return!1}e.implies=T;function L(O){return O.type===9?O.expr:[O]}}),define(ve[184],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[185],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,d.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,d.createDecorator)("externalTerminal")}),define(ve[186],be([0,1,37,10,9,11,97,29,113,162,185]),function(ee,e,d,t,I,C,A,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=P.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends l{openTerminal(s,u){return this.spawnTerminal(d,s,D.getWindowsShell(),u)}spawnTerminal(s,u,r,S){const a=u.windowsExec||b.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=I.basename(a).toLowerCase();if(i==="cmder"||i==="cmder.exe")return s.spawn(a,S?[S]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return a.indexOf(" ")>=0&&n.push('""'),n.push(a),(i==="wt"||i==="wt.exe")&&n.push("-d ."),new Promise((o,c)=>{const m=_(process),f=s.spawn(r,n,{cwd:S,env:m});f.on("error",c),f.on("exit",()=>o())})}runInTerminal(s,u,r,S,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:b.getDefaultTerminalWindows();return new Promise((n,o)=>{const c=`"${u} - ${y}"`,m=`""${r.join('" "')}" & pause"`,f=["/c","start",c,"/wait",i,"/c",m],w=Object.assign({},_(process),S);Object.keys(w).filter(O=>w[O]===null).forEach(O=>delete w[O]);const T={cwd:u,env:w,windowsVerbatimArguments:!0};d.spawn(b.CMD,f,T).on("error",O=>{o(R(O))}),n(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class g extends l{openTerminal(s,u){return this.spawnTerminal(d,s,u)}runInTerminal(s,u,r,S,a){const i=a.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{if(i===F.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const c=i===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,ee).fsPath,"-t",s||y,"-w",u];for(let L of r)f.push("-a"),f.push(L);if(S){const L=Object.assign({},_(process),S);for(let O in L){const E=L[O];E===null?(f.push("-u"),f.push(O)):(f.push("-e"),f.push(`${O}=${E}`))}}let w="";const T=d.spawn(g.OSASCRIPT,f);T.on("error",L=>{o(R(L))}),T.stderr.on("data",L=>{w+=L.toString()}),T.on("exit",L=>{if(L===0)n(void 0);else if(w){const O=w.split(`
`,1);o(new Error(O[0]))}else o(new Error(P.localize(1,null,c,L)))})}else o(new Error(P.localize(2,null,i)))})}spawnTerminal(s,u,r){const S=u.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((a,i)=>{const n=["-a",S];r&&n.push(r);const o=_(process),c=s.spawn("/usr/bin/open",n,{cwd:r,env:o});c.on("error",i),c.on("exit",()=>a())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class v extends l{openTerminal(s,u){return this.spawnTerminal(d,s,u)}runInTerminal(s,u,r,S,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{let c=[];i.then(m=>{m.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const f=`${p(r)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;c.push(`''${f}''`);const w=Object.assign({},_(process),S);Object.keys(w).filter(E=>w[E]===null).forEach(E=>delete w[E]);const T={cwd:u,env:w};let L="";const O=d.spawn(m,c,T);O.on("error",E=>{o(R(E))}),O.stderr.on("data",E=>{L+=E.toString()}),O.on("exit",E=>{if(E===0)n(void 0);else if(L){const M=L.split(`
`,1);o(new Error(M[0]))}else o(new Error(P.localize(4,null,m,E)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await k.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{s?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,u,r){const S=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{S.then(n=>{const o=_(process),c=s.spawn(n,[],{cwd:r,env:o});c.on("error",i),c.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=P.localize(3,null);function _(h){const s={...h.env};return(0,A.sanitizeProcessEnvironment)(s),s}function R(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(P.localize(5,null,h.path)):h}function p(h){let s="";for(let u of h)u.indexOf(" ")>=0?s+='"'+u+'"':s+=u,s+=" ";return s}}),define(ve[42],be([0,1,24,9,8,18,2,163,4]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function P(z){return z.create===!0}e.isFileOpenForWriteOptions=P;var F;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var y;(function(z){z[z.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var l;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=b;function g(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=g;function v(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=_;function R(z){return b(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var p;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(N,W){super(N);this.code=W}}e.FileSystemProviderError=h;function s(z,N){const W=new h(z.toString(),N);return r(W,N),W}e.createFileSystemProviderError=s;function u(z){return z||s((0,k.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=u;function r(z,N){return z.name=N?`${N} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function S(z){if(!z)return p.Unknown;if(z instanceof h)return z.code;const N=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!N)return p.Unknown;switch(N[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=S;function a(z){if(z instanceof f)return z.fileOperationResult;switch(S(z)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(N,W,B){this.resource=N,this.operation=W,this.target=B}isOperation(N){return this.operation===N}}e.FileOperationEvent=n;var o;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(N,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const B=new Map;for(const x of N){const $=B.get(x.type);switch($?$.push([x.resource,x]):B.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,$]of B)switch(x){case 1:this.added=d.TernarySearchTree.forUris(()=>W),this.added.fill($);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>W),this.updated.fill($);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>W),this.deleted.fill($);break}}contains(N,...W){return this.doContains(N,{includeChildren:!1},...W)}affects(N,...W){return this.doContains(N,{includeChildren:!0},...W)}doContains(N,W,...B){if(!N)return!1;const x=B.length>0;return!!((!x||B.includes(1))&&(this.added?.get(N)||W.includeChildren&&this.added?.findSuperstr(N))||(!x||B.includes(0))&&(this.updated?.get(N)||W.includeChildren&&this.updated?.findSuperstr(N))||(!x||B.includes(2))&&(this.deleted?.findSubstr(N)||W.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function m(z,N,W){return!z||!N||z===N||N.length>z.length?!1:(N.charAt(N.length-1)!==t.sep&&(N+=t.sep),W?(0,I.startsWithIgnoreCase)(z,N):z.indexOf(N)===0)}e.isParent=m;class f extends Error{constructor(N,W,B){super(N);this.fileOperationResult=W,this.options=B}}e.FileOperationError=f;class w extends f{constructor(N,W,B){super(N,2,B);this.stat=W}}e.NotModifiedSinceFileOperationError=w;var T;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=O;async function E(z,N){if(!N.hasProvider(A.URI.from({scheme:z.scheme})))return new Promise(W=>{const B=N.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===z.scheme&&x.added&&(B.dispose(),W())})})}e.whenProviderRegistered=E,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(N){return(0,C.isNumber)(N)||(N=0),N<M.KB?(0,k.localize)(1,null,N.toFixed(0)):N<M.MB?(0,k.localize)(2,null,(N/M.KB).toFixed(2)):N<M.GB?(0,k.localize)(3,null,(N/M.MB).toFixed(2)):N<M.TB?(0,k.localize)(4,null,(N/M.GB).toFixed(2)):(0,k.localize)(5,null,(N/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var U;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function V(z){return{maxFileSize:z===0?300*M.MB:16*M.GB,maxHeapSize:z===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=V}),define(ve[84],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...I){this._entries=new Map;for(let[C,A]of I)this.set(C,A)}set(I,C){const A=this._entries.get(I);return this._entries.set(I,C),A}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=d}),define(ve[187],be([0,1,13,16,115,183,4,84]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class F{constructor(g=new k.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=g,this._strict=v,this._parent=_,this._services.set(A.IInstantiationService,this)}createChild(g){return new F(g,this._strict,this)}invokeFunction(g,...v){let _=l.traceInvocation(g),R=!1;try{return g({get:h=>{if(R)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,_);if(!s)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...v)}finally{R=!0,_.stop()}}createInstance(g,...v){let _,R;return g instanceof I.SyncDescriptor?(_=l.traceCreation(g.ctor),R=this._createInstance(g.ctor,g.staticArguments.concat(v),_)):(_=l.traceCreation(g),R=this._createInstance(g,v,_)),_.stop(),R}_createInstance(g,v=[],_){let R=A._util.getServiceDependencies(g).sort((s,u)=>s.index-u.index),p=[];for(const s of R){let u=this._getOrCreateServiceInstance(s.id,_);if(!u&&this._strict&&!s.optional)throw new Error(`[createInstance] ${g.name} depends on UNKNOWN service ${s.id}.`);p.push(u)}let h=R.length>0?R[0].index:v.length;if(v.length!==h){console.warn(`[createInstance] First service dependency of ${g.name} at position ${h+1} conflicts with ${v.length} static arguments`);let s=h-v.length;s>0?v=v.concat(new Array(s)):v=v.slice(0,h)}return new g(...[...v,...p])}_setServiceInstance(g,v){if(this._services.get(g)instanceof I.SyncDescriptor)this._services.set(g,v);else if(this._parent)this._parent._setServiceInstance(g,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let v=this._services.get(g);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):v}_getOrCreateServiceInstance(g,v){let _=this._getServiceInstanceOrDescriptor(g);return _ instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,_,v.branch(g,!0)):(v.branch(g,!1),_)}_safeCreateAndCacheServiceInstance(g,v,_){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,v,_)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,v,_){const R=new C.Graph(s=>s.id.toString());let p=0;const h=[{id:g,desc:v,_trace:_}];for(;h.length;){const s=h.pop();if(R.lookupOrInsertNode(s),p++>1e3)throw new P(R);for(let u of A._util.getServiceDependencies(s.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`),r instanceof I.SyncDescriptor){const S={id:u.id,desc:r,_trace:s._trace.branch(u.id,!0)};R.insertEdge(s,S),h.push(S)}}}for(;;){const s=R.roots();if(s.length===0){if(!R.isEmpty())throw new P(R);break}for(const{data:u}of s){if(this._getServiceInstanceOrDescriptor(u.id)instanceof I.SyncDescriptor){const S=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,S)}R.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,v,_=[],R,p){if(this._services.get(g)instanceof I.SyncDescriptor)return this._createServiceInstance(v,_,R,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,v,_,R,p);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(g,v=[],_,R){if(_){const p=new d.IdleValue(()=>this._createInstance(g,v,R));return new Proxy(Object.create(null),{get(h,s){if(s in h)return h[s];let u=p.value,r=u[s];return typeof r!="function"||(r=r.bind(u),h[s]=r),r},set(h,s,u){return p.value[s]=u,!0}})}else return this._createInstance(g,v,R)}}e.InstantiationService=F;var y;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(y||(y={}));class l{constructor(g,v){this.type=g,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return D?new l(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(g){return D?new l(0,g.name):l._None}branch(g,v){let _=new l(2,g.toString());return this._dep.push([g,v,_]),_}stop(){let g=Date.now()-this._start;l._totals+=g;let v=!1;function _(p,h){let s=[],u=new Array(p+1).join("	");for(const[r,S,a]of h._dep)if(S&&a){v=!0,s.push(`${u}CREATES -> ${r}`);let i=_(p+1,a);i&&s.push(i)}else s.push(`${u}uses -> ${r}`);return s.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(g>2||v)&&console.log(R.join(`
`))}}e.Trace=l,l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ve[12],be([0,1,49,3,6,11,4]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function P(S,a,i){switch(a){case D.Trace:S.trace(i);break;case D.Debug:S.debug(i);break;case D.Info:S.info(i);break;case D.Warning:S.warn(i);break;case D.Error:S.error(i);break;case D.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function F(S){let a="";for(let i=0;i<S.length;i++){let n=S[i];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}a+=(i>0?" ":"")+n}return a}e.format=F;class y extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class l extends y{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...i){this.checkLogLevel(D.Trace)&&this.log(D.Trace,F([a,...i]))}debug(a,...i){this.checkLogLevel(D.Debug)&&this.log(D.Debug,F([a,...i]))}info(a,...i){this.checkLogLevel(D.Info)&&this.log(D.Info,F([a,...i]))}warn(a,...i){this.checkLogLevel(D.Warning)&&this.log(D.Warning,F([a,...i]))}error(a,...i){if(this.checkLogLevel(D.Error))if(a instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=a.stack,this.log(D.Error,F(n))}else this.log(D.Error,F([a,...i]))}critical(a,...i){this.checkLogLevel(D.Critical)&&this.log(D.Critical,F([a,...i]))}flush(){}}e.AbstractMessageLogger=l;class b extends y{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!C.isWindows}trace(a,...i){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}debug(a,...i){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}info(a,...i){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}warn(a,...i){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,a,...i):console.warn(`[main ${k()}]`,a,...i))}error(a,...i){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,a,...i):console.error(`[main ${k()}]`,a,...i))}critical(a,...i){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,a,...i):console.error(`[main ${k()}]`,a,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class g extends y{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...i){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",a,...i)}debug(a,...i){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...i)}info(a,...i){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",a,...i)}warn(a,...i){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",a,...i)}error(a,...i){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",a,...i)}critical(a,...i){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class v extends y{constructor(a,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(i)}trace(a,...i){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(a),...i])}debug(a,...i){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(a),...i])}info(a,...i){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(a),...i])}warn(a,...i){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(a),...i])}error(a,...i){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(a),...i])}critical(a,...i){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(a),...i])}extractMessage(a){return typeof a=="string"?a:(0,d.toErrorMessage)(a,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class _ extends y{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const i of this.logServices)i.setLevel(a);super.setLevel(a)}trace(a,...i){for(const n of this.logServices)n.trace(a,...i)}debug(a,...i){for(const n of this.logServices)n.debug(a,...i)}info(a,...i){for(const n of this.logServices)n.info(a,...i)}warn(a,...i){for(const n of this.logServices)n.warn(a,...i)}error(a,...i){for(const n of this.logServices)n.error(a,...i)}critical(a,...i){for(const n of this.logServices)n.critical(a,...i)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=_;class R extends I.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...i){this.logger.trace(a,...i)}debug(a,...i){this.logger.debug(a,...i)}info(a,...i){this.logger.info(a,...i)}warn(a,...i){this.logger.warn(a,...i)}error(a,...i){this.logger.error(a,...i)}critical(a,...i){this.logger.critical(a,...i)}flush(){this.logger.flush()}}e.LogService=R;class p extends I.Disposable{constructor(a,i){super();this.logLevel=a,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}getLogger(a){return this.loggers.get(a.toString())}createLogger(a,i){let n=this.loggers.get(a.toString());return n||(n=this.doCreateLogger(a,i?.always?D.Trace:this.logLevel,i),this.loggers.set(a.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(a=>a.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return D.Info}trace(a,...i){}debug(a,...i){}info(a,...i){}warn(a,...i){}error(a,...i){}critical(a,...i){}dispose(){}flush(){}}e.NullLogService=h;function s(S){if(S.verbose)return D.Trace;if(typeof S.logLevel=="string"){const a=u(S.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function u(S){switch(S){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function r(S){switch(S){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=r}),define(ve[188],be([0,1,42,12]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,D,P,F,y){try{const l=await new Promise((g,v)=>{ee(["spdlog"],g,v)});l.setFlushOn(t.LogLevel.Trace);const b=await l.createAsyncRotatingLogger(k,D,P,F);return y&&b.clearFormatters(),b}catch(l){console.error(l)}return null}function C(k,D,P){switch(D){case t.LogLevel.Trace:k.trace(P);break;case t.LogLevel.Debug:k.debug(P);break;case t.LogLevel.Info:k.info(P);break;case t.LogLevel.Warning:k.warn(P);break;case t.LogLevel.Error:k.error(P);break;case t.LogLevel.Critical:k.critical(P);break;default:throw new Error("Invalid log level")}}class A extends t.AbstractMessageLogger{constructor(D,P,F,y,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(D,P,F,y),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(D,P,F,y){const l=F?6:1,b=30/l*d.ByteSize.MB,g=await I(D,P,b,l,y);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:v,message:_}of this.buffer)C(this._logger,v,_);this.buffer=[]}}log(D,P){this._logger?C(this._logger,D,P):this.getLevel()<=D&&this.buffer.push({level:D,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=A}),define(ve[117],be([0,1,47,164,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(g,v){return v-g}D.compare=P;const F=Object.create(null);F[D.Error]=(0,t.localize)(0,null),F[D.Warning]=(0,t.localize)(1,null),F[D.Info]=(0,t.localize)(2,null);function y(g){return F[g]||""}D.toString=y;function l(g){switch(g){case d.default.Error:return D.Error;case d.default.Warning:return D.Warning;case d.default.Info:return D.Info;case d.default.Ignore:return D.Hint}}D.fromSeverity=l;function b(g){switch(g){case D.Error:return d.default.Error;case D.Warning:return d.default.Warning;case D.Info:return d.default.Info;case D.Hint:return d.default.Ignore}}D.toSeverity=b}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function F(l){return y(l,!0)}D.makeKey=F;function y(l,b){let g=[P];return l.source?g.push(l.source.replace("\xA6","\\\xA6")):g.push(P),l.code?typeof l.code=="string"?g.push(l.code.replace("\xA6","\\\xA6")):g.push(l.code.value.replace("\xA6","\\\xA6")):g.push(P),l.severity!==void 0&&l.severity!==null?g.push(A.toString(l.severity)):g.push(P),l.message&&b?g.push(l.message.replace("\xA6","\\\xA6")):g.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?g.push(l.startLineNumber.toString()):g.push(P),l.startColumn!==void 0&&l.startColumn!==null?g.push(l.startColumn.toString()):g.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?g.push(l.endLineNumber.toString()):g.push(P),l.endColumn!==void 0&&l.endColumn!==null?g.push(l.endColumn.toString()):g.push(P),g.push(P),g.join("\xA6")}D.makeKeyOptionalMessage=y})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(ve[189],be([0,1,3,47,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var C;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=D}),define(ve[190],be([0,1,6,8,2,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function A(D,P){return I.URI.isUri(D)?(0,t.equalsIgnoreCase)(D.scheme,P):(0,t.startsWithIgnoreCase)(D,P+":")}e.matchesScheme=A;function k(D,...P){return P.some(F=>A(D,F))}e.matchesSomeScheme=k}),define(ve[191],be([0,1,10,11,40,23]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const k=t.globals.vscode.context.configuration();if(k)A=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ee?.__$__nodeRequire=="function"){const k=(0,C.dirname)(d.FileAccess.asFileUri("",ee));A=ee.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const D=ee.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:D.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var ze=this&&this.__param||function(ee,e){return function(d,t){e(d,t,ee)}};define(ve[118],be([0,1,13,21,6,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var A;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(y,l){super();this.deferred=new d.DeferredPromise,l.withProgress(y,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};D=je([ze(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends I.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(y){this.stop();const l=++this.currentOperationId,b=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:b.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ve[50],be([0,1,55,18]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(A,k){d.ok(t.isString(A)),d.ok(t.isObject(k)),d.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,k)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new I}),define(ve[192],be([0,1,3,50]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[I(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new C;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ve[119],be([0,1,17,3,18,159,192,50]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=k.Registry.as(A.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const S=this.doRegisterConfigurations(u,r);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(u){const r=this.doDeregisterConfigurations(u);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:u,remove:r}){const S=[];S.push(...this.doDeregisterConfigurations(r)),S.push(...this.doRegisterConfigurations(u,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,d.distinct)(S)})}registerDefaultConfigurations(u){const r=[],S=[];for(const{overrides:a,source:i}of u)for(const n in a)if(r.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const o={...this.configurationDefaultsOverrides.get(n)?.value||{},...a[n]};this.configurationDefaultsOverrides.set(n,{source:i,value:o});const c={type:"object",default:o,description:C.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:I.isString(i)?void 0:i};S.push(...g(n)),this.configurationProperties[n]=c,this.defaultLanguageConfigurationOverridesNode.properties[n]=c}else{this.configurationDefaultsOverrides.set(n,{value:a[n],source:i});const o=this.configurationProperties[n];o&&(this.updatePropertyDefaultValue(n,o),this.updateSchema(n,o))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const r=[];for(const{overrides:S,source:a}of u)for(const i in S){const n=this.configurationDefaultsOverrides.get(i),o=I.isString(a)?a:a?.id,c=I.isString(n?.source)?n?.source:n?.source?.id;if(o===c)if(r.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const m=this.configurationProperties[i];m&&(this.updatePropertyDefaultValue(i,m),this.updateSchema(i,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const r of u)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,r){const S=[];return u.forEach(a=>{S.push(...this.validateAndRegisterProperties(a,r,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),S}doDeregisterConfigurations(u){const r=[],S=a=>{if(a.properties)for(const i in a.properties)r.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,a.properties[i]);a.allOf&&a.allOf.forEach(i=>S(i))};for(const a of u){S(a);const i=this.configurationContributors.indexOf(a);i!==-1&&this.configurationContributors.splice(i,1)}return r}validateAndRegisterProperties(u,r=!0,S,a,i=3){i=I.isUndefinedOrNull(u.scope)?i:u.scope;let n=[],o=u.properties;if(o)for(let m in o){if(r&&p(m)){delete o[m];continue}const f=o[m];if(f.source=S,f.defaultDefaultValue=o[m].default,this.updatePropertyDefaultValue(m,f),e.OVERRIDE_PROPERTY_REGEX.test(m)?f.scope=void 0:(f.scope=I.isUndefinedOrNull(f.scope)?i:f.scope,f.restricted=I.isUndefinedOrNull(f.restricted)?!!a?.includes(m):f.restricted),o[m].hasOwnProperty("included")&&!o[m].included){this.excludedConfigurationProperties[m]=o[m],delete o[m];continue}else this.configurationProperties[m]=o[m];!o[m].deprecationMessage&&o[m].markdownDeprecationMessage&&(o[m].deprecationMessage=o[m].markdownDeprecationMessage),n.push(m)}let c=u.allOf;if(c)for(let m of c)n.push(...this.validateAndRegisterProperties(m,r,S,a,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const r=S=>{let a=S.properties;if(a)for(const n in a)this.updateSchema(n,a[n]);let i=S.allOf;i&&i.forEach(r)};r(u)}updateSchema(u,r){switch(e.allSettings.properties[u]=r,r.scope){case 1:e.applicationSettings.properties[u]=r;break;case 2:e.machineSettings.properties[u]=r;break;case 6:e.machineOverridableSettings.properties[u]=r;break;case 3:e.windowSettings.properties[u]=r;break;case 4:e.resourceSettings.properties[u]=r;break;case 5:e.resourceSettings.properties[u]=r,this.resourceLanguageSettingsSchema.properties[u]=r;break}}removeFromSchema(u,r){switch(delete e.allSettings.properties[u],r.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const r=`[${u}]`,S={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,S),e.allSettings.properties[r]=S,e.applicationSettings.properties[r]=S,e.machineSettings.properties[r]=S,e.machineOverridableSettings.properties[r]=S,e.windowSettings.properties[r]=S,e.resourceSettings.properties[r]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,r){const S=this.configurationDefaultsOverrides.get(u);let a=S?.value,i=S?.source;I.isUndefined(a)&&(a=r.defaultDefaultValue,i=void 0),I.isUndefined(a)&&(a=_(r.type)),r.default=a,r.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",b=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(s){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let r=b.exec(s);for(;r?.length;){const S=r[1].trim();S&&u.push(S),r=b.exec(s)}}return(0,d.distinct)(u)}e.overrideIdentifiersFromKey=g;function v(s){return s.reduce((u,r)=>`${u}[${r}]`,"")}e.keyFromOverrideIdentifiers=v;function _(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const R=new y;k.Registry.add(e.Extensions.Configuration,R);function p(s){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?C.localize(7,null,s):R.getConfigurationProperties()[s]!==void 0?C.localize(8,null,s):null:C.localize(6,null)}e.validateProperty=p;function h(){const s=[],u=R.getConfigurationProperties();for(const r of Object.keys(u))s.push([r,u[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=h}),define(ve[193],be([0,1,17,3,57,6,24,25,18,2,116,119,50]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(a={},i=[],n=[]){this._contents=a,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(a){return a?(0,F.getConfigurationValue)(this.contents,a):this.contents}getOverrideValue(a,i){const n=this.getContentsForOverrideIdentifer(i);return n?a?(0,F.getConfigurationValue)(n,a):n:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const n of this.overrides)n.identifiers.includes(a)&&i.push(...n.keys);return d.distinct(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return d.distinct(a)}override(a){let i=this.overrideConfigurations.get(a);return i||(i=this.createOverrideConfigurationModel(a),this.overrideConfigurations.set(a,i)),i}merge(...a){const i=k.deepClone(this.contents),n=k.deepClone(this.overrides),o=[...this.keys];for(const c of a){this.mergeContents(i,c.contents);for(const m of c.overrides){const[f]=n.filter(w=>d.equals(w.identifiers,m.identifiers));f?(this.mergeContents(f.contents,m.contents),f.keys.push(...m.keys),f.keys=d.distinct(f.keys)):n.push(k.deepClone(m))}for(const m of c.keys)o.indexOf(m)===-1&&o.push(m)}return new b(i,o,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(a){const i=this.getContentsForOverrideIdentifer(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of d.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o],m=i[o];m&&(typeof c=="object"&&typeof m=="object"?(c=k.deepClone(c),this.mergeContents(c,m)):c=m),n[o]=c}return new b(n,this.keys,this.overrides)}mergeContents(a,i){for(const n of Object.keys(i)){if(n in a&&D.isObject(a[n])&&D.isObject(i[n])){this.mergeContents(a[n],i[n]);continue}a[n]=k.deepClone(i[n])}}checkAndFreeze(a){return this.isFrozen&&!Object.isFrozen(a)?k.deepFreeze(a):a}getContentsForOverrideIdentifer(a){let i=null,n=null;const o=c=>{c&&(n?this.mergeContents(n,c):n=k.deepClone(c))};for(const c of this.overrides)d.equals(c.identifiers,[a])?i=c.contents:c.identifiers.includes(a)&&o(c.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(a,i){this.addKey(a),(0,F.addToValueTree)(this.contents,a,i,n=>{throw new Error(n)})}removeValue(a){this.removeKey(a)&&(0,F.removeFromValueTree)(this.contents,a)}addKey(a){let i=this.keys.length;for(let n=0;n<i;n++)a.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,a)}removeKey(a){let i=this.keys.indexOf(a);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class g extends b{constructor(a={}){const i=l.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(i),o=Object.create(null),c=[];for(const m in i){const f=a[m],w=f!==void 0?f:i[m].default;(0,F.addToValueTree)(o,m,w,T=>console.error(`Conflict in default settings: ${T}`))}for(const m of Object.keys(o))y.OVERRIDE_PROPERTY_REGEX.test(m)&&c.push({identifiers:(0,y.overrideIdentifiersFromKey)(m),keys:Object.keys(o[m]),contents:(0,F.toValuesTree)(o[m],f=>console.error(`Conflict in default settings file: ${f}`))});super(o,n,c)}}e.DefaultConfigurationModel=g;class v{constructor(a){this._name=a,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(a,i){if(!D.isUndefinedOrNull(a)){const n=this.doParseContent(a);this.parseRaw(n,i)}}reparse(a){this._raw&&this.parseRaw(this._raw,a)}parseRaw(a,i){this._raw=a;const{contents:n,keys:o,overrides:c,restricted:m}=this.doParseRaw(a,i);this._configurationModel=new b(n,o,c),this._restrictedConfigurations=m||[]}doParseContent(a){let i={},n=null,o=[],c=[],m=[];function f(T){Array.isArray(o)?o.push(T):n!==null&&(o[n]=T)}let w={onObjectBegin:()=>{let T={};f(T),c.push(o),o=T,n=null},onObjectProperty:T=>{n=T},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let T=[];f(T),c.push(o),o=T,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:f,onError:(T,L,O)=>{m.push({error:T,offset:L,length:O})}};if(a)try{I.visit(a,w),i=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(a,i){const n=l.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(a,n,!0,i);a=o.raw;const c=(0,F.toValuesTree)(a,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),m=Object.keys(a),f=this.toOverrides(a,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:c,keys:m,overrides:f,restricted:o.restricted}}filter(a,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:a,restricted:[]};const c={},m=[];for(let f in a)if(y.OVERRIDE_PROPERTY_REGEX.test(f)&&n){const w=this.filter(a[f],i,!1,o);c[f]=w.raw,m.push(...w.restricted)}else{const w=i[f],T=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&m.push(f),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&w?.restricted||(c[f]=a[f]))}return{raw:c,restricted:m}}toOverrides(a,i){const n=[];for(const o of Object.keys(a))if(y.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const m in a[o])c[m]=a[o][m];n.push({identifiers:(0,y.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,F.toValuesTree)(c,i)})}return n}}e.ConfigurationModelParser=v;class _ extends C.Disposable{constructor(a,i,n,o){super();this.userSettingsResource=a,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const a=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(a.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class R{constructor(a,i,n=new b,o=new b,c=new A.ResourceMap,m=new b,f=new A.ResourceMap,w=!0){this._defaultConfiguration=a,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=m,this._memoryConfigurationByResource=f,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(a,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(a)}updateValue(a,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new b,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(a):o.setValue(a,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(a,i,n){const o=this.getConsolidateConfigurationModel(i,n),c=this.getFolderConfigurationModelForResource(i.resource,n),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,f=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._defaultConfiguration.freeze().getValue(a),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.userConfiguration.freeze().getValue(a),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.localUserConfiguration.freeze().getValue(a),L=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.remoteUserConfiguration.freeze().getValue(a),O=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._workspaceConfiguration.freeze().getValue(a):void 0,E=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(a):c.freeze().getValue(a):void 0,M=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(a):m.getValue(a),U=o.getValue(a),V=d.distinct(d.flatten(o.overrides.map(z=>z.identifiers))).filter(z=>o.getOverrideValue(a,z)!==void 0);return{defaultValue:f,userValue:w,userLocalValue:T,userRemoteValue:L,workspaceValue:O,workspaceFolderValue:E,memoryValue:M,value:U,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspaceFolder:E!==void 0?{value:c?.freeze().getValue(a),override:i.overrideIdentifier?c?.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:m.getValue(a),override:i.overrideIdentifier?m.getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(a){const i=this.getFolderConfigurationModelForResource(void 0,a);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(a){this._defaultConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(a){this._localUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(a){this._remoteUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(a){this._workspaceConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(a,i){this._folderConfigurations.set(a,i),this._foldersConsolidatedConfigurations.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this._foldersConsolidatedConfigurations.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const n=[];if(!i){const{added:o,updated:c,removed:m}=u(this._defaultConfiguration,a);i=[...o,...c,...m]}for(const o of i)for(const c of(0,y.overrideIdentifiersFromKey)(o)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(c),f=a.getKeysForOverrideIdentifier(c),w=[...f.filter(T=>m.indexOf(T)===-1),...m.filter(T=>f.indexOf(T)===-1),...m.filter(T=>!k.equals(this._defaultConfiguration.override(c).getValue(T),a.override(c).getValue(T)))];n.push([c,w])}return this.updateDefaultConfiguration(a),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:n,removed:o,overrides:c}=u(this.localUserConfiguration,a),m=[...i,...n,...o];return m.length&&this.updateLocalUserConfiguration(a),{keys:m,overrides:c}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:n,removed:o,overrides:c}=u(this.remoteUserConfiguration,a);let m=[...i,...n,...o];return m.length&&this.updateRemoteUserConfiguration(a),{keys:m,overrides:c}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:n,removed:o,overrides:c}=u(this.workspaceConfiguration,a);let m=[...i,...n,...o];return m.length&&this.updateWorkspaceConfiguration(a),{keys:m,overrides:c}}compareAndUpdateFolderConfiguration(a,i){const n=this.folderConfigurations.get(a),{added:o,updated:c,removed:m,overrides:f}=u(n,i);let w=[...o,...c,...m];return(w.length||!n)&&this.updateFolderConfiguration(a,i),{keys:w,overrides:f}}compareAndDeleteFolderConfiguration(a){const i=this.folderConfigurations.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:n,updated:o,removed:c,overrides:m}=u(i,void 0);return{keys:[...n,...o,...c],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(a,i){let n=this.getConsolidatedConfigurationModelForResource(a,i);return a.overrideIdentifier?n.override(a.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:a},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&a){const o=i.getFolder(a);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const c=this._memoryConfigurationByResource.get(a);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(a){let i=this._foldersConsolidatedConfigurations.get(a);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(a);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(a,i)):i=n}return i}getFolderConfigurationModelForResource(a,i){if(i&&a){const n=i.getFolder(a);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((a,i)=>{const{contents:n,overrides:o,keys:c}=this._folderConfigurations.get(i);return a.push([i,{contents:n,overrides:o,keys:c}]),a},[])}}allKeys(){const a=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>a.add(i)),this.userConfiguration.freeze().keys.forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>a.add(n))),[...a.values()]}allOverrideIdentifiers(){const a=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n))),[...a.values()]}getAllKeysForOverrideIdentifier(a){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(a).forEach(o=>i.add(o))),[...i.values()]}static parse(a){const i=this.parseConfigurationModel(a.defaults),n=this.parseConfigurationModel(a.user),o=this.parseConfigurationModel(a.workspace),c=a.folders.reduce((m,f)=>(m.set(P.URI.revive(f[0]),this.parseConfigurationModel(f[1])),m),new A.ResourceMap);return new R(i,n,new b,o,c,new b,new A.ResourceMap,!1)}static parseConfigurationModel(a){return new b(a.contents,a.keys,a.overrides).freeze()}}e.Configuration=R;function p(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const a=new Set,i=new Map;for(const o of S)o.keys.forEach(c=>a.add(c)),o.overrides.forEach(([c,m])=>{const f=(0,A.getOrSet)(i,c,new Set);m.forEach(w=>f.add(w))});const n=[];return i.forEach((o,c)=>n.push([c,[...o.values()]])),{keys:[...a.values()],overrides:n}}e.mergeChanges=p;class h{constructor(a,i,n,o){this.change=a,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;a.keys.forEach(f=>c.add(f)),a.overrides.forEach(([,f])=>f.forEach(w=>c.add(w))),this.affectedKeys=[...c.values()];const m=new b;this.affectedKeys.forEach(f=>m.setValue(f,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(a,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,a)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(a,i,this.currentWorkspace);return!k.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(a,i){let n=(0,F.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(a=a[o],!a)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=h;class s extends h{constructor(a,i,n,o){super({keys:a.allKeys(),overrides:[]},void 0,a,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s;function u(S,a){const{added:i,removed:n,updated:o}=r(a,S),c=[],m=S?.getAllOverrideIdentifiers()||[],f=a?.getAllOverrideIdentifiers()||[];if(a){const w=f.filter(T=>!m.includes(T));for(const T of w)c.push([T,a.getKeysForOverrideIdentifier(T)])}if(S){const w=m.filter(T=>!f.includes(T));for(const T of w)c.push([T,S.getKeysForOverrideIdentifier(T)])}if(a&&S){for(const w of m)if(f.includes(w)){const T=r({contents:S.getOverrideValue(void 0,w)||{},keys:S.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});c.push([w,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:n,updated:o,overrides:c}}function r(S,a){const i=S?a?S.keys.filter(c=>a.keys.indexOf(c)===-1):[...S.keys]:[],n=a?S?a.keys.filter(c=>S.keys.indexOf(c)===-1):[...a.keys]:[],o=[];if(S&&a){for(const c of a.keys)if(S.keys.indexOf(c)!==-1){const m=(0,F.getConfigurationValue)(a.contents,c),f=(0,F.getConfigurationValue)(S.contents,c);k.equals(m,f)||o.push(c)}}return{added:i,removed:n,updated:o}}}),define(ve[120],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var t;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(A,k=t.Unknown,D){super(A);this._message=A,this._code=k,this._detail=D,this.isHandled=k===t.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(A){return A instanceof I&&A._code===t.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof I&&A._code===t.NoResolverFound}static isHandled(A){return A instanceof I&&A.isHandled}}e.RemoteAuthorityResolverError=I}),define(ve[85],be([0,1,10]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===d.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function I(C){if(!C)return;const A=C.indexOf("+");return A<0?C:C.substr(0,A)}e.getRemoteName=I}),define(ve[27],be([0,1,8,4,85]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=C;function A(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b=="undefined"||b===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){let v=typeof b=="string"?b:b.value,_=typeof g=="string"?g:g.value;return d.equalsIgnoreCase(v,_)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=D;function P(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function F(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function y(l,b){if(b){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(b)}`;return l.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[121],be([0,1,8,27]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(g,v){return g.uuid&&v.uuid?g.uuid===v.uuid:g.id===v.id?!0:(0,d.compareIgnoreCase)(g.id,v.id)===0}e.areSameExtensions=I;class C{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?I(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function A(g,v){return`${g}.${v}`}e.getExtensionId=A;function k(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(g,v){return k(A(g,v))}e.getGalleryExtensionId=D;function P(g,v){const _=[],R=p=>{for(const h of _)if(h.some(s=>I(v(s),v(p))))return h;return null};for(const p of g){const h=R(p);h?h.push(p):_.push([p])}return _}e.groupByExtension=P;function F(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function y(g){return{id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),...g.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function l(g){const v=new Set;if(g.malicious)for(const _ of g.malicious)v.add(_.id);return v}e.getMaliciousExtensionsSet=l;function b(g,v){const _=[],R=v.manifest.extensionDependencies?.slice(0)??[];for(;R.length;){const p=R.shift();if(p&&_.every(h=>!I(h.identifier,{id:p}))){const h=g.filter(s=>I(s.identifier,{id:p}));h.length===1&&(_.push(h[0]),R.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=b}),define(ve[194],be([0,1,10,160,121,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function k(r){const S=A.exec(r);return S&&S[1]?[(0,I.adoptToGalleryExtensionId)(S[1]),S[2]]:[(0,I.adoptToGalleryExtensionId)(r),void 0]}e.getIdAndVersion=k;var D;(function(r){r.WIN32_X64="win32-x64",r.WIN32_IA32="win32-ia32",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function P(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function F(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function y(r,S){switch(r){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function l(r,S){return S==="web"&&!r.includes("web")}e.isNotWebExtensionInWebTargetPlatform=l;function b(r,S,a){return l(S,a)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===a?!0:g(a).includes(r)}e.isTargetPlatformCompatible=b;function g(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function v(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=v;var _;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(_=e.SortBy||(e.SortBy={}));var R;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var p;(function(r){r.Install="install",r.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var h;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var s;(function(r){r.Unsupported="Unsupported",r.UnsupportedPreRelease="UnsupportedPreRelease",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatiblePreRelease="IncompatiblePreRelease",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Internal="Internal"})(s=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(S,a){super(S);this.code=a,this.name=a}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=d.FileAccess.asBrowserUri("./media/defaultIcon.png",ee).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(ve[195],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class d{constructor(){this.validators=new Map}vsda(){return new Promise((I,C)=>ee(["vsda"],I,C))}async createNewMessage(I){try{const C=await this.vsda(),A=new C.validator;if(A){const k=String(d._nextId++);return this.validators.set(k,A),{id:k,data:A.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,C){if(!I.id)return!0;const A=this.validators.get(I.id);if(!A)return!1;this.validators.delete(I.id);try{return A.validate(C)==="ok"}catch{return!1}}async sign(I){try{const C=await this.vsda(),A=new C.signer;if(A)return A.sign(I)}catch{}return I}}e.SignService=d,d._nextId=1}),define(ve[196],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,C,A=5){let k;return k=C(D=>{const P=typeof D=="string"?D:D.data;let F=this._terminalBufferMap.get(I);if(F){F.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(I),A);F={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,F)}),k}stopBuffering(I){const C=this._terminalBufferMap.get(I);C&&C.dispose()}flushBuffer(I){const C=this._terminalBufferMap.get(I);C&&(this._terminalBufferMap.delete(I),this._callback(I,C.data.join("")))}}e.TerminalDataBufferer=d}),define(ve[197],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(ve[86],be([0,1,73,3,6,4,50,197]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var D;(function(_){function R(p){return p&&typeof p=="object"&&typeof p.id=="string"}_.isThemeColor=R})(D=e.ThemeColor||(e.ThemeColor={}));function P(_){return{id:_}}e.themeColorFromId=P;var F;(function(_){function R(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||D.isThemeColor(i.color))}_.isThemeIcon=R;const p=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const n=p.exec(i);if(!n)return;let[,o]=n;return{id:o}}_.fromString=h;function s(i){return{id:i}}_.fromId=s;function u(i,n){let o=i.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),n&&(o=`${o}~${n}`),{id:o}}_.modify=u;function r(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}_.getModifier=r;function S(i,n){return i.id===n.id&&i.color?.id===n.color?.id}_.isEqual=S;function a(i,n){return{id:i.id,color:n?P(n):void 0}}_.asThemeIcon=a,_.asClassNameArray=d.CSSIcon.asClassNameArray,_.asClassName=d.CSSIcon.asClassName,_.asCSSSelector=d.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function y(_){switch(_){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(R){return this.themingParticipants.push(R),this.onThemingParticipantAddedEmitter.fire(R),(0,I.toDisposable)(()=>{const p=this.themingParticipants.indexOf(R);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new l;A.Registry.add(e.Extensions.ThemingContribution,b);function g(_){return b.onColorThemeChange(_)}e.registerThemingParticipant=g;class v extends I.Disposable{constructor(R){super();this.themeService=R,this.theme=R.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(R){this.theme=R,this.updateStyles()}updateStyles(){}getColor(R,p){let h=this.theme.getColor(R);return h&&p&&(h=p(h,this.theme)),h?h.toString():null}}e.Themable=v}),define(ve[122],be([0,1,3,11,4,12]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var A;(function(g){g.Http="http",g.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=y;function l(g,v){return v?v!==1&&g<1024:!t.isWindows&&g<1024}e.isPortPrivileged=l;let b=class{constructor(v){this.logService=v,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],_=Array.from(this._tunnels.values());for(let R of _){const p=Array.from(R.values());for(let h of p){const s=await h.value;s&&v.push(s)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:_}of v.values())await _.then(R=>R?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,_,R,p,h=!1,s=k.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${_}:${R} on local port ${p}.`),!v)return;_||(_="localhost");const r=this.retainOrCreateTunnel(v,_,R,p,h,s,u);return r?r.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(_,R);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(S);return(S.tunnelRemoteHost!==_||S.tunnelRemotePort!==R)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const _=this._tunnels.get(v.tunnelRemoteHost);if(_){const R=_.get(v.tunnelRemotePort);R&&(R.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,R))}}}}async tryDisposeTunnel(v,_,R){if(R.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${_}.`);const p=R.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(_),p}}async closeTunnel(v,_){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${_} `);const R=this._tunnels.get(v);if(R&&R.has(_)){const p=R.get(_);p.refcount=0,await this.tryDisposeTunnel(v,_,p)}}addTunnelToMap(v,_,R){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(_,{refcount:1,value:R})}async removeEmptyTunnelFromMap(v,_){const R=this._tunnels.get(v);R&&(await R.get(_)||R.delete(_),R.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,_){let R=[v];F(v)?(R.push(...e.LOCALHOST_ADDRESSES),R.push(...e.ALL_INTERFACES_ADDRESSES)):y(v)&&R.push(...e.ALL_INTERFACES_ADDRESSES);const p=R.map(h=>this._tunnels.get(h));for(const h of p){const s=h?.get(_);if(s)return s}}canTunnel(v){return!!P(v)}createWithProvider(v,_,R,p,h,s,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${_}:${R} on local port ${p}.`);const S={elevationRequired:h?l(p===void 0?R:p):!1},a={remoteAddress:{host:_,port:R},localAddressPort:p,privacy:s,public:s!==k.Private,protocol:u},i=v.forwardPort(a,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(_,R,i),i}};b=je([ze(0,C.ILogService)],b),e.AbstractTunnelService=b}),define(ve[198],be([0,1,10]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(k){return k.scheme!==d.Schemas.file&&k.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=t;function I(k){if(k.folders.length)return k.folders.every(D=>t(D.uri))?k.folders[0].uri:void 0;if(k.configuration&&t(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=I;function C(k){return I(k)?.scheme}e.getVirtualWorkspaceScheme=C;function A(k){return I(k)!==void 0}e.isVirtualWorkspace=A}),define(ve[43],be([0,1,24,23,2,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function k(l){const b=l;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=k;function D(l){const b=l;return!!(b&&typeof b=="object"&&I.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(b,g,v,_,R){this._id=b,this._transient=v,this._configuration=_,this._ignorePathCasing=R,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=g}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class F{constructor(b,g){this.raw=g,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,t.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function y(l){return new F({uri:l,index:0,name:(0,t.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=y}),define(ve[199],be([0,1,28,57,141,79,10,9,11,23,2,165,4,85,43]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(N){return(typeof N=="string"?(0,k.extname)(N):(0,P.extname)(N))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function R(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=R;function p(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=p;function h(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=h;function s(N){return N&&N.hasOwnProperty("folderUri")}e.isFolderBackupInfo=s;function u(N){return N&&N.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=u;function r(N){const W=N;return typeof W?.id=="string"&&F.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=r;function S(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=S;function a(N){const W=N;return typeof W?.id=="string"&&F.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=a;function i(N){const W=N;if(W?.uri)return{id:W.id,uri:F.URI.revive(W.uri)};const B=N;if(B?.configPath)return{id:B.id,configPath:F.URI.revive(B.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=i;function n(N,W){return P.extUriBiasedIgnorePathCase.isEqualOrParent(N,W.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function o(N){return c(N)||m(N)}e.isStoredWorkspaceFolder=o;function c(N){const W=N;return typeof W?.path=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=c;function m(N){const W=N;return typeof W?.uri=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=m;function f(N,W,B,x,$=!D.isWindows,J){if(N.scheme!==x.scheme)return{name:B,uri:N.toString(!0)};let ne=W?void 0:J.relativePath(x,N);if(ne!==void 0)ne.length===0?ne=".":D.isWindows&&N.scheme===A.Schemas.file&&!$&&(ne=ne.replace(/\//g,"\\"));else if(N.scheme===A.Schemas.file)ne=N.fsPath,D.isWindows&&(ne=(0,C.normalizeDriveLetter)(ne),$&&(ne=(0,d.toSlashes)(ne)));else{if(!J.isEqualAuthority(N.authority,x.authority))return{name:B,uri:N.toString(!0)};ne=N.path}return{name:B,path:ne}}e.getStoredWorkspaceFolder=f;function w(N,W,B){let x=[],$=new Set;const J=B.dirname(W);for(let ne of N){let re;if(c(ne))ne.path&&(re=B.resolvePath(J,ne.path));else if(m(ne))try{re=F.URI.parse(ne.uri),re.path[0]!=="/"&&(re=re.with({path:"/"+re.path}))}catch(Z){console.warn(Z)}if(re){let Z=B.getComparisonKey(re);if(!$.has(Z)){$.add(Z);const Q=ne.name||B.basenameOrAuthority(re);x.push(new g.WorkspaceFolder({uri:re,name:Q,index:x.length},ne))}}}return x}e.toWorkspaceFolders=w;function T(N,W,B,x,$){let J=L(W,N);const ne=$.dirname(W),re=$.dirname(x),Z=[],Q=O(J.folders);for(const Te of J.folders){const xe=c(Te)?$.resolvePath(ne,Te.path):F.URI.parse(Te.uri);let qe;B?qe=!1:qe=!c(Te)||(0,k.isAbsolute)(Te.path),Z.push(f(xe,qe,Te.name,re,Q,$))}const oe={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},fe=I.setProperty(N,["folders"],Z,oe);let pe=I.applyEdits(N,fe);return(0,P.isEqualAuthority)(J.remoteAuthority,(0,b.getRemoteAuthority)(x))&&(pe=I.applyEdits(pe,I.removeProperty(pe,["remoteAuthority"],oe))),pe}e.rewriteWorkspaceFileForNewLocation=T;function L(N,W){let B=t.parse(W);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter(x=>o(x));else throw new Error(`${N} looks like an invalid workspace file.`);return B}function O(N){return D.isWindows?N.some(W=>c(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function E(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function M(N){return typeof N.folderUri=="string"}function U(N){return typeof N.fileUri=="string"}function V(N,W){const B={workspaces:[],files:[]};if(N){const x=function(J,ne){for(let re=0;re<J.length;re++)try{ne(J[re],re)}catch(Z){W.warn(`Error restoring recent entry ${JSON.stringify(J[re])}: ${Z.toString()}. Skip entry.`)}},$=N;if(Array.isArray($.entries))x($.entries,J=>{const ne=J.label,re=J.remoteAuthority;E(J)?B.workspaces.push({label:ne,remoteAuthority:re,workspace:{id:J.workspace.id,configPath:F.URI.parse(J.workspace.configPath)}}):M(J)?B.workspaces.push({label:ne,remoteAuthority:re,folderUri:F.URI.parse(J.folderUri)}):U(J)&&B.files.push({label:ne,remoteAuthority:re,fileUri:F.URI.parse(J.fileUri)})});else{const J=N;Array.isArray(J.workspaces3)&&x(J.workspaces3,(ne,re)=>{const Z=Array.isArray(J.workspaceLabels)&&J.workspaceLabels[re]||void 0;typeof ne=="object"&&typeof ne.id=="string"&&typeof ne.configURIPath=="string"?B.workspaces.push({label:Z,workspace:{id:ne.id,configPath:F.URI.parse(ne.configURIPath)}}):typeof ne=="string"&&B.workspaces.push({label:Z,folderUri:F.URI.parse(ne)})}),Array.isArray(J.files2)&&x(J.files2,(ne,re)=>{const Z=Array.isArray(J.fileLabels)&&J.fileLabels[re]||void 0;typeof ne=="string"&&B.files.push({label:Z,fileUri:F.URI.parse(ne)})})}}return B}e.restoreRecentlyOpened=V;function z(N){const W={entries:[]};for(const B of N.workspaces)p(B)?W.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):W.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of N.files)W.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return W}e.toStoreData=z}),define(ve[87],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const C=this._idPool++;return this._data.set(C,I),this.logDebugInfo(),C}get(I,C){return this._data.has(I)?this._data.get(I)[C]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(ve[44],be([0,1,10,23,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const D=this._providerInfo.get(k.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(ve[200],be([0,1,13]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(A,k,D){this._deferredPromises=new Map,this._id=A,this._shared=k,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of P.values())F.complete()}catch(F){for(const y of P.values())y.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,k){let D=this._value[A];return typeof D=="undefined"&&(D=k),D}update(A,k){this._value[A]=k;let D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const P=new d.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(A,k){super(A.identifier.value,!0,k);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=I}),define(ve[201],be([0,1,3,2,12]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,D){this._logService=k,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,D,P){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(D.value,P)}$acceptDirtyStateChanged(k,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptDirty(D)}$acceptModelSaved(k){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(k,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,D);const P=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));P.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};C=je([ze(0,I.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(ve[14],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class t{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=t});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[202],be([0,1,27,3]),function(ee,e,d,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,D){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(k.identifier),it(this,I,D,"f"),Fe(this,I,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Fe(this,I,"f").get(this._id,k)}store(k,D){return Fe(this,I,"f").store(this._id,k,D)}delete(k){return Fe(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=C,I=new WeakMap}),define(ve[123],be([0,1,4,3]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(A){this._level=A}$onDidChangeTelemetryLevel(A){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=A,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(ve[63],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(p,h)=>{const s={controllerId:h};return t.set(p,s),s};e.createPrivateApiFor=I;const C=p=>t.get(p);e.getPrivateApiFor=C;const A=(p,h,s,u)=>{let r=s;return{enumerable:!0,configurable:!1,get(){return r},set(S){if(!u(r,S)){const a=r;r=S,p.listener?.({op:3,key:h,value:S,previous:a})}}}},k=(p,h)=>p===h,D={range:(p,h)=>p===h?!0:!p||!h?!1:p.isEqual(h),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(p,h)=>!(p.length!==h.length||p.some(s=>!h.find(u=>s.id===u.id)))},P=Object.keys(D),F=(p,h)=>({range:A(p,"range",void 0,D.range),label:A(p,"label",h,D.label),description:A(p,"description",void 0,D.description),canResolveChildren:A(p,"canResolveChildren",!1,D.canResolveChildren),busy:A(p,"busy",!1,D.busy),error:A(p,"error",void 0,D.error),tags:A(p,"tags",[],D.tags)}),y=(p,h)=>{const s=new Map;for(const u of P)D[u](p[u],h[u])||s.set(u,h[u]);return s};e.diffTestItems=y;class l extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.DuplicateTestItemError=l;class b extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class g extends Error{constructor(h,s,u){super(`TestItem with ID "${h}" is from controller "${s}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=g;const v=p=>{const h=(0,e.getPrivateApiFor)(p);let s=new Map;return{get size(){return s.size},forEach(u,r){for(const S of s.values())u.call(r,S,this)},replace(u){const r=new Map,S=new Set(s.keys()),a={op:4,ops:[]};for(const i of u){if(!(i instanceof _))throw new b(i.id);const n=(0,e.getPrivateApiFor)(i).controllerId;if(n!==h.controllerId)throw new g(i.id,n,h.controllerId);if(r.has(i.id))throw new l(i.id);r.set(i.id,i),S.delete(i.id),a.ops.push({op:0,item:i})}for(const i of S.keys())a.ops.push({op:1,id:i});h.listener?.(a),s=r},add(u){if(!(u instanceof _))throw new b(u.id);s.set(u.id,u),h.listener?.({op:0,item:u})},delete(u){s.delete(u)&&h.listener?.({op:1,id:u})},get(u){return s.get(u)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class _{constructor(h,s,u,r){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const S=(0,e.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof R?void 0:S.parent}},children:{value:v(this),enumerable:!0,writable:!1},...F(S,u)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class R extends _{constructor(h,s){super(h,h,s,void 0)}}e.TestItemRootImpl=R}),define(ve[51],be([0,1,4,122,3,14]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(D){function P(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:y.protocol}}D.fromApiTunnel=P;function F(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==t.TunnelPrivacyId.ConstantPrivate&&y.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}D.fromServiceTunnel=F})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,F){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,F){return{dispose:()=>{}}}async $providePortAttributes(P,F,y,l,b){return[]}async $forwardPort(P,F){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([ze(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[7],be([0,1,17,16,100,24,96,8,18,2,33,42,120]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";var b,g,v,_,R,p,h,s,u,r,S,a,i,n,o,c,m,f,w,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(j){function H(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(H,j),Object.setPrototypeOf(H.prototype,j.prototype),H}let O=R=class{constructor(H){b.set(this,void 0),it(this,b,H,"f")}static from(...H){let ce=H;return new R(function(){if(ce){for(const Pe of ce)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ce=void 0}})}dispose(){typeof Fe(this,b,"f")=="function"&&(Fe(this,b,"f").call(this),it(this,b,void 0,"f"))}};b=new WeakMap,O=R=je([L],O),e.Disposable=O;let E=p=class{constructor(H,ce){if(H<0)throw(0,t.illegalArgument)("line must be non-negative");if(ce<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=H,this._character=ce}static Min(...H){if(H.length===0)throw new TypeError;let ce=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ze=H[Pe];Ze.isBefore(ce)&&(ce=Ze)}return ce}static Max(...H){if(H.length===0)throw new TypeError;let ce=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ze=H[Pe];Ze.isAfter(ce)&&(ce=Ze)}return ce}static isPosition(H){if(!H)return!1;if(H instanceof p)return!0;let{line:ce,character:Pe}=H;return typeof ce=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,ce=0){if(H===null||ce===null)throw(0,t.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,ce=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&ce===0?this:new p(this.line+Pe,this.character+ce)}with(H,ce=this.character){if(H===null||ce===null)throw(0,t.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,ce=typeof H.character=="number"?H.character:this.character),Pe===this.line&&ce===this.character?this:new p(Pe,ce)}toJSON(){return{line:this.line,character:this.character}}};E=p=je([L],E),e.Position=E;let M=h=class{constructor(H,ce,Pe,Ze){let ot,ut;if(typeof H=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof Ze=="number"?(ot=new E(H,ce),ut=new E(Pe,Ze)):H instanceof E&&ce instanceof E&&(ot=H,ut=ce),!ot||!ut)throw new Error("Invalid arguments");ot.isBefore(ut)?(this._start=ot,this._end=ut):(this._start=ut,this._end=ot)}static isRange(H){return H instanceof h?!0:H?E.isPosition(H.start)&&E.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof h?this.contains(H._start)&&this.contains(H._end):H instanceof E?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const ce=E.Max(H.start,this._start),Pe=E.Min(H.end,this._end);if(!ce.isAfter(Pe))return new h(ce,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ce=E.Min(H.start,this._start),Pe=E.Max(H.end,this.end);return new h(ce,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,ce=this.end){if(H===null||ce===null)throw(0,t.illegalArgument)();let Pe;return H?E.isPosition(H)?Pe=H:(Pe=H.start||this.start,ce=H.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ce.isEqual(this.end)?this:new h(Pe,ce)}toJSON(){return[this.start,this.end]}};M=h=je([L],M),e.Range=M;let U=s=class extends M{constructor(H,ce,Pe,Ze){let ot,ut;if(typeof H=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof Ze=="number"?(ot=new E(H,ce),ut=new E(Pe,Ze)):H instanceof E&&ce instanceof E&&(ot=H,ut=ce),!ot||!ut)throw new Error("Invalid arguments");super(ot,ut);this._anchor=ot,this._active=ut}static isSelection(H){return H instanceof s?!0:H?M.isRange(H)&&E.isPosition(H.anchor)&&E.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=s=je([L],U),e.Selection=U;class V{constructor(H,ce,Pe){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(ce),this.connectionToken=Pe}}e.ResolvedAuthority=V;class z extends Error{constructor(H,ce=l.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H);this._message=H,this._code=ce,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(H,ce){return new z(H,l.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(H){return new z(H,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var N;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var W;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=u=class{constructor(H,ce){this._range=H,this._newText=ce}static isTextEdit(H){return H instanceof u?!0:H?M.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ce){return new u(H,ce)}static insert(H,ce){return u.replace(new M(H,H),ce)}static delete(H){return u.replace(H,"")}static setEndOfLine(H){const ce=new u(new M(new E(0,0),new E(0,0)),"");return ce.newEol=H,ce}get range(){return this._range}set range(H){if(H&&!M.isRange(H))throw(0,t.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,t.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,t.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=u=je([L],B),e.TextEdit=B;var x;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let $=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,ce,Pe,Ze){this._edits.push({_type:1,from:H,to:ce,options:Pe,metadata:Ze})}createFile(H,ce,Pe){this._edits.push({_type:1,from:void 0,to:H,options:ce,metadata:Pe})}deleteFile(H,ce,Pe){this._edits.push({_type:1,from:H,to:void 0,options:ce,metadata:Pe})}replaceNotebookMetadata(H,ce,Pe){this._edits.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(H,ce,Pe,Ze,ot){let ut,ft,Pt=[],Lt;if(xt.isNotebookRange(ce)&&$t.isNotebookCellDataArray(Pe)&&!$t.isNotebookCellDataArray(Ze)?(ut=ce.start,ft=ce.end,Pt=Pe,Lt=Ze):typeof ce=="number"&&typeof Pe=="number"&&$t.isNotebookCellDataArray(Ze)&&(ut=ce,ft=Pe,Pt=Ze,Lt=ot),ut===void 0||ft===void 0)throw new Error("Invalid arguments");(ut!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:H,index:ut,count:ft-ut,cells:Pt,metadata:Lt})}replaceNotebookCellMetadata(H,ce,Pe,Ze){this._edits.push({_type:3,metadata:Ze,uri:H,edit:{editType:8,index:ce,metadata:Pe}})}replace(H,ce,Pe,Ze){this._edits.push({_type:2,uri:H,edit:new B(ce,Pe),metadata:Ze})}insert(H,ce,Pe,Ze){this.replace(H,new M(ce,ce),Pe,Ze)}delete(H,ce,Pe){this.replace(H,ce,"",Pe)}has(H){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===H.toString())}set(H,ce){if(ce)for(const Pe of ce)Pe&&this._edits.push({_type:2,uri:H,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ze=this._edits[Pe];Ze._type===2&&Ze.uri.toString()===H.toString()&&(this._edits[Pe]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(H){const ce=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===H.toString()&&ce.push(Pe.edit);return ce}entries(){const H=new C.ResourceMap;for(let ce of this._edits)if(ce._type===2){let Pe=H.get(ce.uri);Pe||(Pe=[ce.uri,[]],H.set(ce.uri,Pe)),Pe[1].push(ce.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};$=je([L],$),e.WorkspaceEdit=$;let J=r=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof r?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=r._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ce=this._tabstop++){if(typeof H=="function"){const Pe=new r;Pe._tabstop=this._tabstop,H(Pe),this._tabstop=Pe._tabstop,H=Pe.value}else H=r._escape(H);return this.value+="${",this.value+=ce,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ce=this._tabstop++){const Pe=H.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,ce){if(typeof ce=="function"){const Pe=new r;Pe._tabstop=this._tabstop,ce(Pe),this._tabstop=Pe._tabstop,ce=Pe.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};J=r=je([L],J),e.SnippetString=J;var ne;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ne=e.DiagnosticTag||(e.DiagnosticTag={}));var re;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(re=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=S=class{constructor(H,ce){if(this.uri=H,ce)if(ce instanceof M)this.range=ce;else if(ce instanceof E)this.range=new M(ce,ce);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof S?!0:H?M.isRange(H.range)&&P.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=S=je([L],Z),e.Location=Z;let Q=class{constructor(H,ce){this.location=H,this.message=ce}static is(H){return H?typeof H.message=="string"&&H.location&&M.isRange(H.location.range)&&P.URI.isUri(H.location.uri):!1}static isEqual(H,ce){return H===ce?!0:!H||!ce?!1:H.message===ce.message&&H.location.range.isEqual(ce.location.range)&&H.location.uri.toString()===ce.location.uri.toString()}};Q=je([L],Q),e.DiagnosticRelatedInformation=Q;let oe=class{constructor(H,ce,Pe=re.Error){if(!M.isRange(H))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=H,this.message=ce,this.severity=Pe}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ce){return H===ce?!0:!H||!ce?!1:H.message===ce.message&&H.severity===ce.severity&&H.code===ce.code&&H.severity===ce.severity&&H.source===ce.source&&H.range.isEqual(ce.range)&&(0,d.equals)(H.tags,ce.tags)&&(0,d.equals)(H.relatedInformation,ce.relatedInformation,Q.isEqual)}};oe=je([L],oe),e.Diagnostic=oe;let fe=class{constructor(H,ce){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ce}};fe=je([L],fe),e.Hover=fe;var pe;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(H,ce=pe.Text){this.range=H,this.kind=ce}toJSON(){return{range:this.range,kind:pe[this.kind]}}};Te=je([L],Te),e.DocumentHighlight=Te;var xe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var qe;(function(j){j[j.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let Qe=a=class{constructor(H,ce,Pe,Ze,ot){this.name=H,this.kind=ce,this.containerName=ot,typeof Pe=="string"&&(this.containerName=Pe),Ze instanceof Z?this.location=Ze:Pe instanceof M&&(this.location=new Z(Ze,Pe)),a.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};Qe=a=je([L],Qe),e.SymbolInformation=Qe;let q=i=class{constructor(H,ce,Pe,Ze,ot){this.name=H,this.detail=ce,this.kind=Pe,this.range=Ze,this.selectionRange=ot,this.children=[],i.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(i.validate)}};q=i=je([L],q),e.DocumentSymbol=q;var ie;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(H,ce){this.title=H,this.kind=ce}};G=je([L],G),e.CodeAction=G;let X=n=class{constructor(H){this.value=H}append(H){return new n(this.value?this.value+n.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+n.sep)}};X.sep=".",X=n=je([L],X),e.CodeActionKind=X,X.Empty=new X(""),X.QuickFix=X.Empty.append("quickfix"),X.Refactor=X.Empty.append("refactor"),X.RefactorExtract=X.Refactor.append("extract"),X.RefactorInline=X.Refactor.append("inline"),X.RefactorRewrite=X.Refactor.append("rewrite"),X.Source=X.Empty.append("source"),X.SourceOrganizeImports=X.Source.append("organizeImports"),X.SourceFixAll=X.Source.append("fixAll");let ae=class{constructor(H,ce){if(this.range=H,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=je([L],ae),e.SelectionRange=ae;class me{constructor(H,ce,Pe,Ze,ot,ut){this.kind=H,this.name=ce,this.detail=Pe,this.uri=Ze,this.range=ot,this.selectionRange=ut}}e.CallHierarchyItem=me;class De{constructor(H,ce){this.fromRanges=ce,this.from=H}}e.CallHierarchyIncomingCall=De;class Be{constructor(H,ce){this.fromRanges=ce,this.to=H}}e.CallHierarchyOutgoingCall=Be;var Xe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(H,ce){this.range=H,this.command=ce}get isResolved(){return!!this.command}};tt=je([L],tt),e.CodeLens=tt;let rt=o=class{constructor(H,ce=!1){g.set(this,void 0),it(this,g,new I.MarkdownString(H,{supportThemeIcons:ce}),"f")}static isMarkdownString(H){return H instanceof o?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Fe(this,g,"f").value}set value(H){Fe(this,g,"f").value=H}get isTrusted(){return Fe(this,g,"f").isTrusted}set isTrusted(H){Fe(this,g,"f").isTrusted=H}get supportThemeIcons(){return Fe(this,g,"f").supportThemeIcons}set supportThemeIcons(H){Fe(this,g,"f").supportThemeIcons=H}get supportHtml(){return Fe(this,g,"f").supportHtml}set supportHtml(H){Fe(this,g,"f").supportHtml=H}appendText(H){return Fe(this,g,"f").appendText(H),this}appendMarkdown(H){return Fe(this,g,"f").appendMarkdown(H),this}appendCodeblock(H,ce){return Fe(this,g,"f").appendCodeblock(ce??"",H),this}};g=new WeakMap,rt=o=je([L],rt),e.MarkdownString=rt;let st=class{constructor(H,ce){this.label=H,this.documentation=ce}};st=je([L],st),e.ParameterInformation=st;let et=class{constructor(H,ce){this.label=H,this.documentation=ce,this.parameters=[]}};et=je([L],et),e.SignatureInformation=et;let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};nt=je([L],nt),e.SignatureHelp=nt;var gt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var It;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(It=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(H){this.label=H}};Ne=je([L],Ne),e.InlayHintLabelPart=Ne;let Dt=class{constructor(H,ce,Pe){this.label=H,this.position=ce,this.kind=Pe}};Dt=je([L],Dt),e.InlayHint=Dt;var te;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(se=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(j){j[j.Deprecated=1]="Deprecated"})(K=e.CompletionItemTag||(e.CompletionItemTag={}));let we=class{constructor(H,ce){this.label=H,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};we=je([L],we),e.CompletionItem=we;let ke=class{constructor(H=[],ce=!1){this.items=H,this.isIncomplete=ce}};ke=je([L],ke),e.CompletionList=ke;let Ve=class{constructor(H,ce,Pe){this.text=H,this.range=ce,this.command=Pe}};Ve=je([L],Ve),e.InlineSuggestion=Ve;let We=class{constructor(H){this.items=H}};We=je([L],We),e.InlineSuggestions=We;var lt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var Re;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ce;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ue;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ee;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ee=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ye;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(ye=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function H(ce){switch(ce){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=H}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor(H,ce){if(ce&&!P.URI.isUri(ce))throw(0,t.illegalArgument)("target");if(!M.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.target=ce}};Oe=je([L],Oe),e.DocumentLink=Oe;let Ge=class{constructor(H,ce,Pe,Ze){this.red=H,this.green=ce,this.blue=Pe,this.alpha=Ze}};Ge=je([L],Ge),e.Color=Ge;let $e=class{constructor(H,ce){if(ce&&!(ce instanceof Ge))throw(0,t.illegalArgument)("color");if(!M.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.color=ce}};$e=je([L],$e),e.ColorInformation=$e;let Ye=class{constructor(H){if(!H||typeof H!="string")throw(0,t.illegalArgument)("label");this.label=H}};Ye=je([L],Ye),e.ColorPresentation=Ye;var at;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var ct;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class He{constructor(H,ce,Pe){if(this.startIndex=H,this.length=ce,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,t.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=He;var Se;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Se=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(H){this.options=H,typeof H!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var he;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=c=class{constructor(H,ce){if(this.label=ce,typeof H!="string"||typeof ce!="string")throw(0,t.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Ie.Clean=new c("clean","Clean"),Ie.Build=new c("build","Build"),Ie.Rebuild=new c("rebuild","Rebuild"),Ie.Test=new c("test","Test"),Ie=c=je([L],Ie),e.TaskGroup=Ie;function Me(j){let H="";for(let ce=0;ce<j.length;ce++)H+=j[ce].replace(/,/g,",,")+",";return H}let Je=class{constructor(H,ce,Pe){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=H,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=Pe):this._options=ce)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let ce of this._args)H.push(ce);return Me(H)}};Je=je([L],Je),e.ProcessExecution=Je;let Ke=class{constructor(H,ce,Pe){if(this._args=[],Array.isArray(ce)){if(!H)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H,this._args=ce,this._options=Pe}else{if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ce of this._args)H.push(typeof ce=="string"?ce:ce.value);return Me(H)}};Ke=je([L],Ke),e.ShellExecution=Ke;var mt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class yt{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=yt;let dt=m=class{constructor(H,ce,Pe,Ze,ot,ut){this.__deprecated=!1,this._definition=this.definition=H;let ft;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=Pe,this.execution=Ze,ft=ot,this.__deprecated=!0):ce===St.Global||ce===St.Workspace?(this.target=ce,this._name=this.name=Pe,this._source=this.source=Ze,this.execution=ot,ft=ut):(this.target=ce,this._name=this.name=Pe,this._source=this.source=Ze,this.execution=ot,ft=ut),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Je?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ke?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const ce=this._definition.type;(m.EmptyType===ce||m.ProcessType===ce||m.ShellType===ce||m.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=m=je([L],dt),e.Task=dt;var vt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let wt=class{constructor(H,ce=Bt.None){this.collapsibleState=ce,P.URI.isUri(H)?this.resourceUri=H:this.label=H}};wt=je([L],wt),e.TreeItem=wt;var Bt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(H){this._value=H}async asString(){return JSON.stringify(this._value)}};Tt=je([L],Tt),e.TreeDataTransferItem=Tt;let Mt=class{constructor(){this._items=new Map}get(H){return this._items.get(H)}set(H,ce){this._items.set(H,ce)}forEach(H){this._items.forEach(H)}};Mt=je([L],Mt),e.TreeDataTransfer=Mt;let kt=class{constructor(H,ce){this.id=H,this.color=ce}};kt=je([L],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let Et=class{constructor(H){this.id=H}};Et=je([L],Et),e.ThemeColor=Et;var Ot;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ot=e.ConfigurationTarget||(e.ConfigurationTarget={}));let qt=class{constructor(H,ce){if(typeof H!="string"&&(!H||!P.URI.isUri(H)&&!P.URI.isUri(H.uri)))throw(0,t.illegalArgument)("base");if(typeof ce!="string")throw(0,t.illegalArgument)("pattern");typeof H=="string"?this.baseUri=P.URI.file(H):P.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ce}get base(){return this._base}set base(H){this._base=H,this._baseUri=P.URI.file(H)}get baseUri(){return this._baseUri}set baseUri(H){this._baseUri=H,this._base=H.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};qt=je([L],qt),e.RelativePattern=qt;let bt=class{constructor(H,ce,Pe,Ze){this.enabled=typeof H=="boolean"?H:!0,typeof ce=="string"&&(this.condition=ce),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};bt=je([L],bt),e.Breakpoint=bt;let Wt=class extends bt{constructor(H,ce,Pe,Ze,ot){super(ce,Pe,Ze,ot);if(H===null)throw(0,t.illegalArgument)("location");this.location=H}};Wt=je([L],Wt),e.SourceBreakpoint=Wt;let Kt=class extends bt{constructor(H,ce,Pe,Ze,ot){super(ce,Pe,Ze,ot);this.functionName=H}};Kt=je([L],Kt),e.FunctionBreakpoint=Kt;let Yt=class extends bt{constructor(H,ce,Pe,Ze,ot,ut,ft){super(Ze,ot,ut,ft);if(!ce)throw(0,t.illegalArgument)("dataId");this.label=H,this.dataId=ce,this.canPersist=Pe}};Yt=je([L],Yt),e.DataBreakpoint=Yt;let ai=class{constructor(H,ce,Pe){this.command=H,this.args=ce||[],this.options=Pe}};ai=je([L],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(H,ce){this.port=H,this.host=ce}};Rt=je([L],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(H){this.path=H}};Jt=je([L],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(H){this.implementation=H}};li=je([L],li),e.DebugAdapterInlineImplementation=li;let Gt=class{constructor(H,ce){this.range=H,this.expression=ce}};Gt=je([L],Gt),e.EvaluatableExpression=Gt;var Zt;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let pt=class{constructor(H,ce){this.range=H,this.text=ce}};pt=je([L],pt),e.InlineValueText=pt;let ci=class{constructor(H,ce,Pe=!0){this.range=H,this.variableName=ce,this.caseSensitiveLookup=Pe}};ci=je([L],ci),e.InlineValueVariableLookup=ci;let Nt=class{constructor(H,ce){this.range=H,this.expression=ce}};Nt=je([L],Nt),e.InlineValueEvaluatableExpression=Nt;let zt=class{constructor(H,ce){this.frameId=H,this.stoppedLocation=ce}};zt=je([L],zt),e.InlineValueContext=zt;var vi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=f=class extends Error{constructor(H,ce=y.FileSystemProviderErrorCode.Unknown,Pe){super(P.URI.isUri(H)?H.toString(!0):H);this.code=Pe?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(H){return new f(H,y.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(H){return new f(H,y.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(H){return new f(H,y.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(H){return new f(H,y.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(H){return new f(H,y.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(H){return new f(H,y.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};ui=f=je([L],ui),e.FileSystemError=ui;let ei=class{constructor(H,ce,Pe){this.start=H,this.end=ce,this.kind=Pe}};ei=je([L],ei),e.FoldingRange=ei;var Ci;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(H,ce=[]){this.tokenTypes=H,this.tokenModifiers=ce}}e.SemanticTokensLegend=Di;function di(j){return typeof j=="undefined"||(0,D.isStringArray)(j)}class Qt{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let ce=0,Pe=H.tokenTypes.length;ce<Pe;ce++)this._tokenTypeStrToInt.set(H.tokenTypes[ce],ce);for(let ce=0,Pe=H.tokenModifiers.length;ce<Pe;ce++)this._tokenModifierStrToInt.set(H.tokenModifiers[ce],ce)}}push(H,ce,Pe,Ze,ot){if(typeof H=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof Ze=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(H,ce,Pe,Ze,ot);if(M.isRange(H)&&typeof ce=="string"&&di(Pe))return this._push(H,ce,Pe);throw(0,t.illegalArgument)()}_push(H,ce,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Ze=H.start.line,ot=H.start.character,ut=H.end.character-H.start.character,ft=this._tokenTypeStrToInt.get(ce);let Pt=0;if(Pe)for(const Lt of Pe){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Ut=this._tokenModifierStrToInt.get(Lt);Pt|=1<<Ut>>>0}this._pushEncoded(Ze,ot,ut,ft,Pt)}_pushEncoded(H,ce,Pe,Ze,ot){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Lt=0,Ut=0;for(let Ht=0;Ht<Pt;Ht++){let Vt=this._data[5*Ht],gi=this._data[5*Ht+1];Vt===0?(Vt=Lt,gi+=Ut):Vt+=Lt,this._data[5*Ht]=Vt,this._data[5*Ht+1]=gi,Lt=Vt,Ut=gi}}let ut=H,ft=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=ot,this._prevLine=H,this._prevChar=ce}static _sortAndDeltaEncode(H){let ce=[];const Pe=H.length/5|0;for(let ft=0;ft<Pe;ft++)ce[ft]=ft;ce.sort((ft,Pt)=>{const Lt=H[5*ft],Ut=H[5*Pt];if(Lt===Ut){const Ht=H[5*ft+1],Vt=H[5*Pt+1];return Ht-Vt}return Lt-Ut});const Ze=new Uint32Array(H.length);let ot=0,ut=0;for(let ft=0;ft<Pe;ft++){const Pt=5*ce[ft],Lt=H[Pt+0],Ut=H[Pt+1],Ht=H[Pt+2],Vt=H[Pt+3],gi=H[Pt+4],xi=Lt-ot,Ji=xi===0?Ut-ut:Ut,pi=5*ft;Ze[pi+0]=xi,Ze[pi+1]=Ji,Ze[pi+2]=Ht,Ze[pi+3]=Vt,Ze[pi+4]=gi,ot=Lt,ut=Ut}return Ze}build(H){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),H):new hi(Qt._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=Qt;class hi{constructor(H,ce){this.resultId=ce,this.data=H}}e.SemanticTokens=hi;class ki{constructor(H,ce,Pe){this.start=H,this.deleteCount=ce,this.data=Pe}}e.SemanticTokensEdit=ki;class Xt{constructor(H,ce){this.resultId=ce,this.edits=H}}e.SemanticTokensEdits=Xt;var Ii;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new kt("arrow-left")},ii=je([L],ii),e.QuickInputButtons=ii;var Ai;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ai=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(H,ce,Pe){this.badge=H,this.tooltip=ce,this.color=Pe}static validate(H){if(H.badge){let ce=(0,k.nextCharLength)(H.badge,0);if(ce<H.badge.length&&(ce+=(0,k.nextCharLength)(H.badge,ce)),H.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(H){this.kind=H}};ni=je([L],ni),e.ColorTheme=ni;var Ue;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Ue=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(H,ce){if(H<0)throw(0,t.illegalArgument)("start must be positive");if(ce<0)throw(0,t.illegalArgument)("end must be positive");H<=ce?(this._start=H,this._end=ce):(this._start=ce,this._end=H)}static isNotebookRange(H){return H instanceof xt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let ce=this._start,Pe=this._end;return H.start!==void 0&&(ce=H.start),H.end!==void 0&&(Pe=H.end),ce===this._start&&Pe===this._end?this:new xt(ce,Pe)}}e.NotebookRange=xt;class $t{constructor(H,ce,Pe,Ze,ot,ut,ft){this.kind=H,this.value=ce,this.languageId=Pe,this.mime=Ze,this.outputs=ot??[],this.metadata=ut,this.executionSummary=ft,$t.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ce=>$t.isNotebookCellData(ce))}static isNotebookCellData(H){return!0}}e.NotebookCellData=$t;class _t{constructor(H){this.cells=H}}e.NotebookData=_t;class Ft{constructor(H,ce){this.data=H,this.mime=ce;const Pe=(0,A.normalizeMimeType)(ce,!0);if(!Pe)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(H){return H instanceof Ft?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ce={name:H.name,message:H.message,stack:H.stack};return Ft.json(ce,"application/vnd.code.notebook.error")}static stdout(H){return Ft.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Ft.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ce="application/octet-stream"){return new Ft(H,ce)}static text(H,ce=A.Mimes.text){const Pe=Fe(Ft,v,"f",_).encode(String(H));return new Ft(Pe,ce)}static json(H,ce="application/json"){const Pe=JSON.stringify(H,void 0,"	");return Ft.text(Pe,ce)}}e.NotebookCellOutputItem=Ft,v=Ft,_={value:new TextEncoder};class ri{constructor(H,ce,Pe){this.items=ri.ensureUniqueMimeTypes(H,!0),typeof ce=="string"?(this.id=ce,this.metadata=Pe):(this.id=(0,F.generateUuid)(),this.metadata=ce??Pe)}static isNotebookCellOutput(H){return H instanceof ri?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,D.isArray)(H.items)}static ensureUniqueMimeTypes(H,ce=!1){const Pe=new Set,Ze=new Set;for(let ot=0;ot<H.length;ot++){const ut=H[ot],ft=(0,A.normalizeMimeType)(ut.mime);if(!Pe.has(ft)){Pe.add(ft);continue}Ze.add(ot),ce&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ze.size===0?H:H.filter((ot,ut)=>!Ze.has(ut))}}e.NotebookCellOutput=ri;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ti=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Li{constructor(H,ce){this.text=H,this.alignment=ce}}e.NotebookCellStatusBarItem=Li;var Fi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Fi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(H,ce=[]){this.uri=H,this.provides=(0,d.asArray)(ce)}}e.NotebookRendererScript=_i;let mi=class{constructor(H,ce){this.label=H,this.timestamp=ce}};mi=je([L],mi),e.TimelineItem=mi;var Mi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Mi=e.ExtensionMode||(e.ExtensionMode={}));var Oi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(H,ce){this.ranges=H,this.wordPattern=ce}}e.LinkedEditingRanges=Ui;class le{constructor(H,ce){this._port=H,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=le;var ge;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ge=e.TestResultState||(e.TestResultState={}));var Le;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ht=class{constructor(H=void 0,ce=void 0,Pe=void 0){this.include=H,this.exclude=ce,this.profile=Pe}};ht=je([L],ht),e.TestRunRequest=ht;let Ct=w=class{constructor(H){this.message=H}static diff(H,ce,Pe){const Ze=new w(H);return Ze.expectedOutput=ce,Ze.actualOutput=Pe,Ze}};Ct=w=je([L],Ct),e.TestMessage=Ct;let At=class{constructor(H){this.id=H}};At=je([L],At),e.TestTag=At;let si=class{constructor(H,ce){this.covered=H,this.total=ce}};si=je([L],si),e.CoveredCount=si;let Bi=T=class{constructor(H,ce,Pe,Ze){this.uri=H,this.statementCoverage=ce,this.branchCoverage=Pe,this.functionCoverage=Ze}static fromDetails(H,ce){const Pe=new si(0,0),Ze=new si(0,0),ot=new si(0,0);for(const ft of ce)if("branches"in ft){Pe.total+=1,Pe.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Ze.total+=1,Ze.covered+=Pt.executionCount>0?1:0}else ot.total+=1,ot.covered+=ft.executionCount>0?1:0;const ut=new T(H,Pe,Ze.total>0?Ze:void 0,ot.total>0?ot:void 0);return ut.detailedCoverage=ce,ut}};Bi=T=je([L],Bi),e.FileCoverage=Bi;let Wi=class{constructor(H,ce,Pe=[]){this.executionCount=H,this.location=ce,this.branches=Pe}};Wi=je([L],Wi),e.StatementCoverage=Wi;let $i=class{constructor(H,ce){this.executionCount=H,this.location=ce}};$i=je([L],$i),e.BranchCoverage=$i;let Hi=class{constructor(H,ce){this.executionCount=H,this.location=ce}};Hi=je([L],Hi),e.FunctionCoverage=Hi;var Ki;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(H,ce,Pe,Ze,ot,ut){this.kind=H,this.name=ce,this.detail=Pe,this.uri=Ze,this.range=ot,this.selectionRange=ut}}e.TypeHierarchyItem=Yi}),define(ve[124],be([0,1,55,10,8,151,110,7,17]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function F(g,v){v?P.set(g,v):P.delete(g)}e.setWordDefinitionFor=F;function y(g){return P.get(g)}e.getWordDefinitionFor=y;class l extends C.MirrorTextModel{constructor(v,_,R,p,h,s,u,r){super(_,R,p,h);this._proxy=v,this._languageId=s,this._isDirty=u,this._notebook=r,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,D.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===t.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,R){return v._getWordRangeAtPosition(_,R)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,d.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,d.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const R=this._eol,p=_.start.line,h=_.end.line,s=[];s.push(this._lines[p].substring(_.start.character));for(let u=p+1;u<h;u++)s.push(this._lines[u]);return s.push(this._lines[h].substring(0,_.end.character)),s.join(R)}_lineAt(v){let _;if(v instanceof k.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new b(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),R=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,R))}_validateRange(v){if(!(v instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),R=this._validatePosition(v.end);return _===v.start&&R===v.end?v:new k.Range(_.line,_.character,R.line,R.character)}_validatePosition(v){if(!(v instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:R}=v,p=!1;if(_<0)_=0,R=0,p=!0;else if(_>=this._lines.length)_=this._lines.length-1,R=this._lines[_].length,p=!0;else{const h=this._lines[_].length;R<0?(R=0,p=!0):R>h&&(R=h,p=!0)}return p?new k.Position(_,R):v}_getWordRangeAtPosition(v,_){const R=this._validatePosition(v);if(!_)_=y(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const p=(0,A.getWordAtText)(R.character+1,(0,A.ensureValidWordDefinition)(_),this._lines[R.line],0);if(p)return new k.Range(R.line,p.startColumn-1,R.line,p.endColumn-1)}}e.ExtHostDocumentData=l;class b{constructor(v,_,R){this._line=v,this._text=_,this._isLastLine=R}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(ve[203],be([0,1,7,3,111,6,81,24,2,33]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(l,b,g,v){this._notebook=g,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(R=>{const p=this._cellUris.get(R.document.uri);p!==void 0&&(this._cellLengths.setValue(p,this._cells[p].document.getText().length+1),this._cellLines.setValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=R=>{R===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(R=>_(R.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const l=[],b=[];for(const g of this._notebook.getCells())g.kind===d.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,g.document.uri,g.document.languageId,!0))&&(this._cellUris.set(g.document.uri,this._cells.length),this._cells.push(g),l.push(g.document.getText().length+1),b.push(g.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(l){if(!l){let p="";for(const h of this._cells)p+=h.document.getText()+`
`;return p=p.slice(0,-1),p}if(l.isEmpty)return"";const b=this.locationAt(l.start),g=this.locationAt(l.end),v=this._cellUris.get(b.uri),_=this._cellUris.get(g.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new d.Range(b.range.start,g.range.end));const R=[this._cells[v].document.getText(new d.Range(b.range.start,new d.Position(this._cells[v].document.lineCount,0)))];for(let p=v+1;p<_;p++)R.push(this._cells[p].document.getText());return R.push(this._cells[_].document.getText(new d.Range(new d.Position(0,0),g.range.end))),R.join(`
`)}offsetAt(l){const b=this._cellLines.getIndexOf(l.line),g=this._cellLengths.getPrefixSum(b.index-1),v=this._cells[b.index].document.offsetAt(l.with(b.remainder));return g+v}positionAt(l){if(typeof l=="number"){const g=this._cellLengths.getIndexOf(l),v=this._cellLines.getPrefixSum(g.index-1);return this._cells[g.index].document.positionAt(g.remainder).translate(v)}const b=this._cellUris.get(l.uri);if(b!==void 0){const g=this._cellLines.getPrefixSum(b-1);return new d.Position(g+l.range.start.line,l.range.start.character)}return new d.Position(0,0)}locationAt(l){d.Range.isRange(l)||(l=new d.Range(l,l));const b=this._cellLines.getIndexOf(l.start.line);let g=b;l.isEmpty||(g=this._cellLines.getIndexOf(l.end.line));const v=new d.Position(b.remainder,l.start.character),_=new d.Position(g.remainder,l.end.character),R=new d.Range(v,_),p=this._cells[b.index];return new d.Location(p.document.uri,p.document.validateRange(R))}contains(l){return this._cellUris.has(l)}validateRange(l){const b=this.validatePosition(l.start),g=this.validatePosition(l.end);return l.with(b,g)}validatePosition(l){const b=this._cellLines.getIndexOf(l.line),g=new d.Position(b.remainder,l.character),v=this._cells[b.index].document.validatePosition(g),_=this._cellLines.getPrefixSum(b.index-1);return new d.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=F}),define(ve[204],be([0,1,7,14,3]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?d.ColorThemeKind.Light:k==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([ze(0,t.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(ve[64],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class t{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=t}),define(ve[205],be([0,1,22]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function I(k,D){if(D.serializeBuffersForPostMessage){const P=new t,F=(b,g)=>{if(g instanceof ArrayBuffer){const v=P.add(g);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(g)){const v=C(g);if(v){const _=P.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},y=JSON.stringify(k,F),l=P.buffers.map(b=>{const g=new Uint8Array(b);return d.VSBuffer.wrap(g)});return{message:y,buffers:l}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(k,D){const P=D.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),F=D.length?(l,b)=>{if(typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const g=b,{index:v}=g,_=P[v];if(g.view)switch(g.view.type){case 1:return new Int8Array(_,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return b}:void 0;return{message:JSON.parse(k,F),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(ve[206],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(t){function I(A){const k=new Map;return A.types.forEach((D,P)=>{k.set(D,{asString:async()=>A.items[P].asString})}),k}t.toITreeDataTransfer=I;async function C(A){const k={types:[],items:[]},D=Array.from(A.entries());for(const P of D)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}t.toTreeDataTransferDTO=C})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[88],be([0,1,10,2]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,D){return k.scheme===d.Schemas.http||k.scheme===d.Schemas.https?k:(D&&D.authority&&D.isRemote&&k.scheme===d.Schemas.file&&(k=t.URI.from({scheme:d.Schemas.vscodeRemote,authority:D.authority,path:k.path})),t.URI.from({scheme:d.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function C(k){return k.replace(/./g,D=>{const P=D.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?D:"-"+P.toString(16).padStart(4,"0")})}function A(k){return k.replace(/-([0-9a-f]{4})/g,(D,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=A}),define(ve[207],be([0,1,3,6,88]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,D,P){this._proxy=k,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const F=D.getVisibleTextEditors();for(const y of this._insets.values())F.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,P,F,y){let l;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===k){l=h;break}if(!l)throw new Error("not a visible editor");const b=this,g=this._handlePool++,v=new d.Emitter,_=new d.Emitter,R=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,I.asWebviewUri)(h,b._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(h){this._options=h,b._proxy.$setOptions(g,h)}get options(){return this._options}set html(h){this._html=h,b._proxy.$setHtml(g,h)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(h){return b._proxy.$postMessage(g,h)}},p=new class{constructor(){this.editor=k,this.line=D,this.height=P,this.webview=R,this.onDidDispose=_.event}dispose(){b._insets.has(g)&&(b._insets.delete(g),b._proxy.$disposeEditorInset(g),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(g,l.id,l.value.document.uri,D+1,P,F||{},y.identifier,y.extensionLocation),this._insets.set(g,{editor:k,inset:p,onDidReceiveMessage:v}),p}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=C}),define(ve[208],be([0,1,175,18,2,6,4,62,50,42,17,10]),function(ee,e,d,t,I,C,A,k,D,P,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.EditorTabsVisibleContext=new k.RawContextKey("editorTabsVisible",!0,(0,d.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(M,U,V){for(const z of V.visibleEditorPanes)if(z.group.id===U&&M.matches(z.input))return z.getViewState()}e.findViewStateForEditor=l;function b(M){if(u(M))return!1;const U=M;return I.URI.isUri(U?.resource)}e.isResourceEditorInput=b;function g(M){if(u(M))return!1;const U=M;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=g;function v(M){if(u(M)||g(M))return!1;const U=M;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function _(M){if(u(M))return!1;const U=M;return U?U.resource===void 0||U.resource.scheme===y.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var R;(function(M){M[M.SHORT=0]="SHORT",M[M.MEDIUM=1]="MEDIUM",M[M.LONG=2]="LONG"})(R=e.Verbosity||(e.Verbosity={}));var p;(function(M){M[M.EXPLICIT=1]="EXPLICIT",M[M.AUTO=2]="AUTO",M[M.FOCUS_CHANGE=3]="FOCUS_CHANGE",M[M.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var h;(function(M){M[M.None=0]="None",M[M.Readonly=2]="Readonly",M[M.Untitled=4]="Untitled",M[M.Singleton=8]="Singleton",M[M.RequiresTrust=16]="RequiresTrust",M[M.CanSplitInGroup=32]="CanSplitInGroup",M[M.ForceDescription=64]="ForceDescription"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends C.Disposable{}e.AbstractEditorInput=s;function u(M){return M instanceof s}e.isEditorInput=u;function r(M){const U=M;return I.URI.isUri(U?.preferredResource)}function S(M){const U=M;return u(U?.primary)&&u(U?.secondary)}e.isSideBySideEditorInput=S;function a(M){const U=M;return u(U?.modified)&&u(U?.original)}e.isDiffEditorInput=a;function i(M){return u(M?.editor)}e.isEditorInputWithOptions=i;function n(M){const U=M;return i(M)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function o(M){const U=M;return typeof U?.groupId=="number"&&u(U.editor)}e.isEditorIdentifier=o;var c;(function(M){M[M.UNKNOWN=0]="UNKNOWN",M[M.REPLACE=1]="REPLACE",M[M.MOVE=2]="MOVE",M[M.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(M){M[M.GROUP_ACTIVE=0]="GROUP_ACTIVE",M[M.GROUP_INDEX=1]="GROUP_INDEX",M[M.GROUP_LOCKED=2]="GROUP_LOCKED",M[M.EDITOR_OPEN=3]="EDITOR_OPEN",M[M.EDITOR_CLOSE=4]="EDITOR_CLOSE",M[M.EDITOR_MOVE=5]="EDITOR_MOVE",M[M.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",M[M.EDITOR_LABEL=7]="EDITOR_LABEL",M[M.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",M[M.EDITOR_PIN=9]="EDITOR_PIN",M[M.EDITOR_STICKY=10]="EDITOR_STICKY",M[M.EDITOR_DIRTY=11]="EDITOR_DIRTY",M[M.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(m=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(M){M[M.PRIMARY=1]="PRIMARY",M[M.SECONDARY=2]="SECONDARY",M[M.BOTH=3]="BOTH",M[M.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class w{getOriginalUri(U,V){if(!U)return;if(V?.supportSideBySide){const{primary:N,secondary:W}=this.getSideEditors(U);if(N&&W){if(V?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===f.ANY)return this.getOriginalUri(N,{filterByScheme:V.filterByScheme})??this.getOriginalUri(W,{filterByScheme:V.filterByScheme});U=V.supportSideBySide===f.PRIMARY?N:W}}if(g(U)||v(U))return;const z=r(U)?U.preferredResource:U.resource;return!z||!V||!V.filterByScheme?z:this.filterUri(z,V.filterByScheme)}getSideEditors(U){return S(U)||v(U)?{primary:U.primary,secondary:U.secondary}:a(U)||g(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,V){if(!U)return;if(V?.supportSideBySide){const{primary:N,secondary:W}=this.getSideEditors(U);if(N&&W){if(V?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===f.ANY)return this.getCanonicalUri(N,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:V.filterByScheme});U=V.supportSideBySide===f.PRIMARY?N:W}}if(g(U)||v(U))return;const z=U.resource;return!z||!V||!V.filterByScheme?z:this.filterUri(z,V.filterByScheme)}filterUri(U,V){if(Array.isArray(V)){if(V.some(z=>U.scheme===z))return U}else if(V===U.scheme)return U}}e.EditorResourceAccessor=new w;var T;(function(M){M[M.LEFT=0]="LEFT",M[M.RIGHT=1]="RIGHT"})(T=e.CloseDirection||(e.CloseDirection={}));class L{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const V=this.instantiationService=U.get(A.IInstantiationService);for(const[z,N]of this.editorSerializerConstructors)this.createEditorSerializer(z,N,V);this.editorSerializerConstructors.clear()}createEditorSerializer(U,V,z){const N=z.createInstance(V);this.editorSerializerInstances.set(U,N)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,V){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,V,this.instantiationService):this.editorSerializerConstructors.set(U,V),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new L);async function O(M,U){if(!M||!M.length)return[];const V=await Promise.all(M.map(async z=>{const N=I.URI.revive(z.fileUri);if(!N||!await U.canHandleResource(N))return;let B=z.exists,x=z.type;if(typeof B!="boolean"||typeof x!="number")try{x=(await U.resolve(N)).isDirectory?P.FileType.Directory:P.FileType.Unknown,B=!0}catch{B=!1}if(!B&&z.openOnlyIfExists||x===P.FileType.Directory)return;const $={selection:B?z.selection:void 0,pinned:!0,override:z.editorOverrideId};let J;return B?J={resource:N,options:$}:J={resource:N,options:$,forceUntitled:!0},J}));return(0,F.coalesce)(V)}e.pathsToEditors=O;var E;(function(M){M[M.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",M[M.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[125],be([0,1,3,13,176]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,F){const y={command:k};if(D&&Object.keys(D).length>0&&(y.arguments=D),this.internalSend("request",y),typeof F=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.pendingRequests.get(y.seq);if(b){this.pendingRequests.delete(y.seq);const g={type:"response",seq:0,request_seq:y.seq,success:!1,command:k,message:(0,I.localize)(0,null,F,k)};b(g)}},F)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,t.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(ve[209],be([0,1,8,2,9,25,10]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(a,i,n){return a.replace(k,function(o,c){return i&&c.length>0&&c[0]!=="_"?o:n&&n.hasOwnProperty(c)?n[c]:o})}e.formatPII=D;function P(a){const i={};for(const n of Object.keys(a))n.startsWith("!")||(i[n]=a[n]);return i}e.filterExceptionsFromTelemetry=P;function F(a){return a.configuration.request==="attach"&&!y(a)&&(!a.parentSession||F(a.parentSession))}e.isSessionAttach=F;function y(a){let i=a.configuration.type;if(!!i)return i==="vslsShare"&&(i=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(i,"extensionhost")||(0,d.equalsIgnoreCase)(i,"pwa-extensionhost")?a:a.parentSession?y(a.parentSession):void 0}e.getExtensionHostDebugSession=y;function l(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=l;function b(a,i,n){let o,c=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=m.exec(a);){const w=f.index+1,T=w+f[0].length;if(w<=i&&T>=n){o=f[0],c=w;break}}if(o){const w=/\w+/g;let T=null;for(;(T=w.exec(o))&&!(T.index+1+c+T[0].length>=n););T&&(o=o.substring(0,w.lastIndex))}return o?{start:c,end:c+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(a){return!!(a&&a.match(g))}e.isUri=v;function _(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(v(a.path))return t.URI.parse(a.path);if((0,I.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function R(a){if(typeof a.path=="object"){const i=t.URI.revive(a.path);if(i)return i.scheme===A.Schemas.file?i.fsPath:i.toString()}return a.path}function p(a,i){const n=i?_:R,o=(0,C.deepClone)(a);return s(o,(c,m)=>{c&&m&&(m.path=n(m))}),o}e.convertToDAPaths=p;function h(a,i){const n=i?_:R,o=(0,C.deepClone)(a);return s(o,(c,m)=>{!c&&m&&(m.path=n(m))}),o}e.convertToVSCPaths=h;function s(a,i){switch(a.type){case"event":{const n=a;switch(n.event){case"output":i(!1,n.body.source);break;case"loadedSource":i(!1,n.body.source);break;case"breakpoint":i(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=a;switch(n.command){case"setBreakpoints":i(!0,n.arguments.source);break;case"breakpointLocations":i(!0,n.arguments.source);break;case"source":i(!0,n.arguments.source);break;case"gotoTargets":i(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(o=>i(!1,o));break;default:break}break}case"response":{const n=a;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(o=>i(!1,o.source));break;case"loadedSources":n.body.sources.forEach(o=>i(!1,o));break;case"scopes":n.body.scopes.forEach(o=>i(!1,o.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(o=>i(!1,o.source));break;case"setBreakpoints":n.body.breakpoints.forEach(o=>i(!1,o.source));break;default:break}break}}}function u(a){return a.filter(i=>!i.presentation?.hidden).sort((i,n)=>i.presentation?n.presentation?i.presentation.group?n.presentation.group?i.presentation.group!==n.presentation.group?i.presentation.group.localeCompare(n.presentation.group):r(i.presentation.order,n.presentation.order):-1:n.presentation.group?1:r(i.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=u;function r(a,i){return typeof a!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:a-i}async function S(a,i){const n=a.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(n!=="none"&&(await i.saveAll(),n==="allEditorsInActiveGroup")){const o=i.activeEditorPane;o&&o.input.resource?.scheme===A.Schemas.untitled&&await i.save({editor:o.input,groupId:o.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(ve[210],be([0,1,29,37,177,126,9,8,25,11,194,125]),function(ee,e,d,t,I,C,A,k,D,P,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends y.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,h){this.outputStream=h,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",s=>this.handleData(s))}sendMessage(p){if(this.outputStream){const h=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${l.TWO_CRLF}${h}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const h=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+h))}continue}}else{const h=this.rawData.indexOf(l.TWO_CRLF);if(h!==-1){const u=this.rawData.toString("utf8",0,h).split(l.HEADER_LINESEPARATOR);for(const r of u){const S=r.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(h+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class b extends l{startSession(){return new Promise((p,h)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.socket.on("error",u=>{s?this._onError.fire(u):h(u)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class g extends b{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=g;class v extends b{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=v;class _ extends l{constructor(p,h,s){super();this.adapterExecutable=p,this.debugType=h,this.outputService=s}async startSession(){const p=this.adapterExecutable.command,h=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(p)if(A.isAbsolute(p)){if(!await d.Promises.exists(p))throw new Error(I.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let u=process.env;if(s.env&&Object.keys(s.env).length>0&&(u=D.mixin(D.deepClone(process.env),s.env)),p==="node")if(Array.isArray(h)&&h.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,a={env:u,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(a.cwd=s.cwd);const i=t.fork(h[0],h.slice(1),a);if(!i.pid)throw new Error(I.localize(2,null,h[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const S={env:u};s.cwd&&(S.cwd=s.cwd),this.serverProcess=t.spawn(p,h,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,a)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const r=this.outputService;if(r){const S=a=>a.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",a=>{const i=r.getChannel(F.ExtensionsChannelId);i&&i.append(S(a))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(u){this._onError.fire(u)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((p,h)=>{const s=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(u,r,S){if(u)return h(u)});s.on("exit",p),s.on("error",h)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,h){if(!p)return;const s=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?s.runtime=A.join(h,p.runtime):s.runtime=p.runtime),p.runtimeArgs&&(s.runtimeArgs=p.runtimeArgs),p.program&&(A.isAbsolute(p.program)?s.program=p.program:s.program=A.join(h,p.program)),p.args&&(s.args=p.args);const u=p;return u.win&&(s.win=_.extract(u.win,h)),u.winx86&&(s.winx86=_.extract(u.winx86,h)),u.windows&&(s.windows=_.extract(u.windows,h)),u.osx&&(s.osx=_.extract(u.osx,h)),u.linux&&(s.linux=_.extract(u.linux,h)),s}static platformAdapterExecutable(p,h){let s=Object.create(null);h=h.toLowerCase();for(const n of p)if(n.contributes){const o=n.contributes.debuggers;o&&o.length>0&&o.filter(c=>typeof c.type=="string"&&k.equalsIgnoreCase(c.type,h)).forEach(c=>{const m=_.extract(c,n.extensionLocation.fsPath);s=D.mixin(s,m,n.isBuiltin)})}let u;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=s.winx86||s.win||s.windows:P.isWindows?u=s.win||s.windows:P.isMacintosh?u=s.osx:P.isLinux&&(u=s.linux),u=u||s;const r=u.program||s.program,S=u.args||s.args,a=u.runtime||s.runtime,i=u.runtimeArgs||s.runtimeArgs;if(a)return{type:"executable",command:a,args:(i||[]).concat(typeof r=="string"?[r]:[]).concat(S||[])};if(r)return{type:"executable",command:r,args:S||[]}}}e.ExecutableDebugAdapter=_}),define(ve[211],be([0,1,37,11,28,186]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,b){return new Promise((g,v)=>{let _="";const R=d.spawn(l,b);R.pid&&R.stdout.on("data",p=>{_+=p.toString()}),R.on("error",p=>{v(p)}),R.on("close",p=>{g(_)})})}let k;function D(l,b){if(!k)if(t.isWindows)k=new C.WindowsExternalTerminalService;else if(t.isMacintosh)k=new C.MacExternalTerminalService;else if(t.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const g=b.getConfiguration("terminal");return k.runInTerminal(l.title,l.cwd,l.args,l.env||{},g.external||{})}e.runInExternalTerminal=D;async function P(l){if(l)if(t.isWindows){const b=await new Promise((g,v)=>{ee(["windows-process-tree"],g,v)});return new Promise(g=>{b.getProcessTree(l,v=>{g(v.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(l)]).then(b=>{const g=b.trim();return!(g.length===0||g.indexOf(" tmux")>=0)},b=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var F;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(F||(F={}));function y(l,b,g,v){l=l.trim().toLowerCase();let _;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?_=1:l.indexOf("cmd.exe")>=0?_=0:l.indexOf("bash")>=0?_=2:t.isWindows?_=0:_=2;let R,p=" ";switch(_){case 1:if(R=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),g){const h=(0,I.getDriveLetter)(g);h&&(p+=`${h}:; `),p+=`cd ${R(g)}; `}if(v)for(const h in v){const s=v[h];s===null?p+=`Remove-Item env:${h}; `:p+=`\${env:${h}}='${s}'; `}if(b.length>0){const h=R(b.shift());p+=h[0]==="'"?`& ${h} `:`${h} `;for(const s of b)p+=`${R(s)} `}break;case 0:if(R=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),g){const h=(0,I.getDriveLetter)(g);h&&(p+=`${h}: && `),p+=`cd ${R(g)} && `}if(v){p+='cmd /C "';for(const h in v){let s=v[h];s===null?p+=`set "${h}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,u=>`^${u}`),p+=`set "${h}=${s}" && `)}}for(const h of b)p+=`${R(h)} `;v&&(p+='"');break;case 2:{R=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const h=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(g&&(p+=`cd ${R(g)} ; `),v){p+="/usr/bin/env";for(const s in v){const u=v[s];u===null?p+=` -u ${h(s)}`:p+=` ${h(`${s}=${u}`)}`}p+=" "}for(const s of b)p+=`${R(s)} `;break}}return p}e.prepareCommand=y}),define(ve[127],be([0,1,32,77,96,10,9,11,62]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(w){w[w.Markup=1]="Markup",w[w.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(w){w[w.Running=1]="Running",w[w.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(w){w[w.Pending=2]="Pending",w[w.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(w){w[w.WithHardKernelDependency=0]="WithHardKernelDependency",w[w.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",w[w.Pure=2]="Pure",w[w.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(w){w.Always="always",w.Never="never",w.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(w){w[w.ModelChange=1]="ModelChange",w[w.Move=2]="Move",w[w.ChangeLanguage=5]="ChangeLanguage",w[w.Initialize=6]="Initialize",w[w.ChangeCellMetadata=7]="ChangeCellMetadata",w[w.Output=8]="Output",w[w.OutputItem=9]="OutputItem",w[w.ChangeCellContent=10]="ChangeCellContent",w[w.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",w[w.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",w[w.ChangeCellMime=13]="ChangeCellMime",w[w.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(w){w[w.Handle=0]="Handle",w[w.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(w){w[w.Replace=1]="Replace",w[w.Output=2]="Output",w[w.Metadata=3]="Metadata",w[w.CellLanguage=4]="CellLanguage",w[w.DocumentMetadata=5]="DocumentMetadata",w[w.Move=6]="Move",w[w.OutputItems=7]="OutputItems",w[w.PartialMetadata=8]="PartialMetadata",w[w.PartialInternalMetadata=9]="PartialInternalMetadata"})(_=e.CellEditType||(e.CellEditType={}));var R;(function(w){w.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function L(z,N){return z.with({scheme:w.scheme,fragment:`ch${N.toString().padStart(7,"0")}${z.scheme!==C.Schemas.file?z.scheme:""}`})}w.generate=L;function O(z){if(z.scheme!==w.scheme)return;const N=T.exec(z.fragment);return N?{handle:Number(N[1]),notebook:z.with({scheme:z.fragment.substring(N[0].length)||C.Schemas.file,fragment:null})}:void 0}w.parse=O;function E(z,N,W){return z.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${N.toString().padStart(7,"0")},${W??""},${z.scheme!==C.Schemas.file?z.scheme:""}`})}w.generateCellOutputUri=E;function M(z){if(z.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const N=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!N)return;const W=Number(N[1]),B=N[2]&&N[2]!==""?N[2]:void 0,x=N[3];return{handle:W,outputId:B,notebook:z.with({scheme:x||C.Schemas.file,fragment:null})}}w.parseCellOutputUri=M;function U(z,N,W){return z.with({scheme:W,fragment:`ch${N.toString().padStart(7,"0")}${z.scheme!==C.Schemas.file?z.scheme:""}`})}w.generateCellUri=U;function V(z,N){if(z.scheme!==N)return;const W=T.exec(z.fragment);return W?{handle:Number(W[1]),notebook:z.with({scheme:z.fragment.substring(W[0].length)||C.Schemas.file,fragment:null})}:void 0}w.parseCellUri=V})(R=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(w){return p.get(w)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=h;function s(w){return p.get(w)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function u(w){return p.get(w)?.mergeable??!1}e.mimeTypeIsMergeable=u;const r=w=>k.isWindows?w.replace(/\//g,"\\"):w;class S{constructor(T=[],L=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=L,this.order=[...new Set(T)].map(O=>({pattern:O,matches:d.parse(r(O))}))}sort(T){const L=new Map(t.Iterable.map(T,E=>[E,r(E)]));let O=[];for(const{matches:E}of this.order)for(const[M,U]of L)if(E(U)){O.push(M),L.delete(M);break}return L.size&&(O=O.concat([...L.keys()].sort((E,M)=>this.defaultOrder.indexOf(E)-this.defaultOrder.indexOf(M)))),O}prioritize(T,L){const O=this.findIndex(T);if(O===-1){this.order.unshift({pattern:T,matches:d.parse(r(T))});return}const E=new Set(L.map(U=>this.findIndex(U,O)));E.delete(-1);const M=Array.from(E).sort();this.order.splice(O+1,0,...M.map(U=>this.order[U]));for(let U=M.length-1;U>=0;U--)this.order.splice(M[U],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,L=this.order.length){const O=r(T);for(let E=0;E<L;E++)if(this.order[E].matches(O))return E;return-1}}e.MimeTypeDisplayOrder=S;function a(w,T,L,O=(E,M)=>E===M){const E=[];function M(z,N,W){if(N===0&&W.length===0)return;const B=E[E.length-1];B&&B.start+B.deleteCount===z?(B.deleteCount+=N,B.toInsert.push(...W)):E.push({start:z,deleteCount:N,toInsert:W})}let U=0,V=0;for(;;){if(U===w.length){M(U,0,T.slice(V));break}if(V===T.length){M(U,w.length-U,[]);break}const z=w[U],N=T[V];if(O(z,N)){U+=1,V+=1;continue}L(N)?(M(U,1,[]),U+=1):(M(U,0,[N]),V+=1)}return E}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(w){w.default="default",w.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(w){const T=w;return!!((typeof T.include=="string"||d.isRelativePattern(T.include))&&(typeof T.exclude=="string"||d.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=n;function o(w,T,L){if(Array.isArray(w.viewType)&&w.viewType.indexOf(T)>=0||w.viewType===T)return!0;if(w.filenamePattern){const O=n(w.filenamePattern)?w.filenamePattern.include:w.filenamePattern,E=n(w.filenamePattern)?w.filenamePattern.exclude:void 0;if(d.match(O,(0,A.basename)(L.fsPath).toLowerCase()))return!(E&&d.match(E,(0,A.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class c{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)T[L]=this.textModel.cells[L].getHashValue();return T}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var m;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(T){return`${f._prefix}${T}`}static parse(T){if(T.startsWith(f._prefix))return T.substring(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(ve[212],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(ve[213],be([0,1,4,62]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,d.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[214],be([0,1,179,4,62]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[215],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=d;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(ve[128],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var t;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var C;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(y,l)=>{l.expand!==void 0&&(y.expand=l.expand),l.item!==void 0&&(y.item=y.item?Object.assign(y.item,l.item):l.item)};e.applyTestItemUpdate=A;var k;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var D;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(l){}update(l){}remove(l,b){}complete(){}}e.IncrementalChangeCollector=P;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const b=this.createChangeCollector();for(const g of l)switch(g[0]){case 0:{const v=g[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const R=this.createItem(v,_);this.items.set(v.item.extId,R),b.add(R)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),b.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=g[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),b.update(_);break}case 2:{const v=this.items.get(g[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[g[1]]];for(;_.length;)for(const R of _.pop()){const p=this.items.get(R);p&&(_.push(p.children),this.items.delete(R),b.remove(p,p!==v),p.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(g[1]);break;case 3:this.updatePendingRoots(g[1]);break;case 5:this._tags.set(g[1].id,g[1]);break;case 6:this._tags.delete(g[1]);break}b.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=F}),define(ve[89],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(C){C.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(A,k=A.length){if(this.path=A,this.viewEnd=k,A.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,k,D=A.parent){if(A.id===k)return new I([k]);let P=[A.id];for(let F=D;F&&F.id!==k;F=F.parent)P.push(F.id);return P.push(k),new I(P.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const k=A.indexOf("\0");return k===-1?A:A.slice(0,k)}static fromString(A){return new I(A.split("\0"))}static join(A,k){return new I([...A.path,k])}static joinToString(A,k){return A.toString()+"\0"+k}static compare(A,k){return A===k?0:k.startsWith(A+"\0")?2:A.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let k=0;k<A.viewEnd&&k<this.viewEnd;k++)if(A.path[k]!==this.path[k])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=I}),define(ve[216],be([0,1,9,40,18,25,11,79,180]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,l,b){this._contributedVariables=new Map,this._context=y,this._labelService=l,b&&(this._envVariablesPromise=b.then(g=>this.prepareEnv(g)))}prepareEnv(y){if(A.isWindows){const l=Object.create(null);return Object.keys(y).forEach(b=>{l[b.toLowerCase()]=y[b]}),l}return y}resolveWithEnvironment(y,l,b){return this.recursiveResolve(this.prepareEnv(y),l?l.uri:void 0,b)}async resolveAsync(y,l){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,l)}async resolveAnyBase(y,l,b,g){const v=C.deepClone(l);return A.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):A.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):A.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,v,b,g)}async resolveAnyAsync(y,l,b){return this.resolveAnyBase(y,l,b)}async resolveAnyMap(y,l,b){const g=new Map;return{newConfig:await this.resolveAnyBase(y,l,b,g),resolvedVariables:g}}resolveWithInteractionReplace(y,l,b,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,l,b,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,l){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,l)}recursiveResolve(y,l,b,g,v){if(I.isString(b))return this.resolveString(y,l,b,g,v);if(I.isArray(b))return b.map(_=>this.recursiveResolve(y,l,_,g,v));if(I.isObject(b)){let _=Object.create(null);return Object.keys(b).forEach(R=>{const p=this.resolveString(y,l,R,g,v);_[p]=this.recursiveResolve(y,l,b[R],g,v)}),_}return b}resolveString(y,l,b,g,v){return b.replace(P.VARIABLE_REGEXP,(R,p)=>{if(p.includes(P.VARIABLE_LHS))return R;let h=this.evaluateSingleVariable(y,R,p,l,g);return v&&v.set(p,h),h!==R&&I.isString(h)&&h.match(P.VARIABLE_REGEXP)&&(h=this.resolveString(y,l,h,g,v)),h})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,l,b,g,v){let _;const R=b.split(":");R.length>1&&(b=R[0],_=R[1]);const p=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,D.localize)(0,null,l))},h=()=>{const u=p();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,D.localize)(1,null,l,d.basename(u)))},s=()=>{if(_){const u=this._context.getFolderUri(_);if(u)return u;throw new Error((0,D.localize)(2,null,l,_))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,l)):new Error((0,D.localize)(4,null,l))};switch(b){case"env":if(_){if(y){const u=y[A.isWindows?_.toLowerCase():_];if(I.isString(u))return u}return""}throw new Error((0,D.localize)(5,null,l));case"config":if(_){const u=this._context.getConfigurationValue(g,_);if(I.isUndefinedOrNull(u))throw new Error((0,D.localize)(6,null,l,_));if(I.isObject(u))throw new Error((0,D.localize)(7,null,l,_));return u}throw new Error((0,D.localize)(8,null,l));case"command":return this.resolveFromMap(l,_,v,"command");case"input":return this.resolveFromMap(l,_,v,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return g||_?(0,k.normalizeDriveLetter)(this.fsPath(s())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(s()));case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new Error((0,D.localize)(9,null,l))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new Error((0,D.localize)(10,null,l))}case"file":return p();case"fileWorkspaceFolder":return h();case"relativeFile":return g||_?d.relative(this.fsPath(s()),p()):p();case"relativeFileDirname":{const u=d.dirname(p());if(g||_){const r=d.relative(this.fsPath(s()),u);return r.length===0?".":r}return u}case"fileDirname":return d.dirname(p());case"fileExtname":return d.extname(p());case"fileBasename":return d.basename(p());case"fileBasenameNoExtension":{const u=d.basename(p());return u.slice(0,u.length-d.extname(u).length)}case"fileDirnameBasename":return d.basename(d.dirname(p()));case"execPath":{const u=this._context.getExecPath();return u||l}case"execInstallFolder":{const u=this._context.getAppRoot();return u||l}case"pathSeparator":return d.sep;default:try{const u=_?`${b}:${_}`:b;return this.resolveFromMap(l,u,v,void 0)}catch{return l}}}}resolveFromMap(y,l,b,g){if(l&&b){const v=g===void 0?b[l]:b[g+":"+l];if(typeof v=="string")return v;throw new Error((0,D.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[129],be([0,1,4,208]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var C;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var k;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function P(g){const v=g;return(0,t.isEditorInput)(v?.editor)&&(0,t.isEditorInput)(v?.replacement)}e.isEditorReplacement=P;var F;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function l(g){const v=g;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=l;function b(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ve[217],be([0,1,4,129]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(C){const A=C;return typeof C=="number"||(0,t.isEditorGroup)(A)}e.isPreferredGroup=I}),define(ve[15],be([0,1,17,22,100,293,59,25,18,2,41,83,181,117,63,127,89,217,7]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Se){function _e(Y){const{selectionStartLineNumber:Ie,selectionStartColumn:Me,positionLineNumber:Je,positionColumn:Ke}=Y,mt=new p.Position(Ie-1,Me-1),St=new p.Position(Je-1,Ke-1);return new p.Selection(mt,St)}Se.to=_e;function he(Y){const{anchor:Ie,active:Me}=Y;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}Se.from=he})(h=e.Selection||(e.Selection={}));var s;(function(Se){function _e(Y){if(!Y)return;const{start:Ie,end:Me}=Y;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}Se.from=_e;function he(Y){if(!Y)return;const{startLineNumber:Ie,startColumn:Me,endLineNumber:Je,endColumn:Ke}=Y;return new p.Range(Ie-1,Me-1,Je-1,Ke-1)}Se.to=he})(s=e.Range||(e.Range={}));var u;(function(Se){function _e(he){switch(he){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}Se.to=_e})(u=e.TokenType||(e.TokenType={}));var r;(function(Se){function _e(Y){return new p.Position(Y.lineNumber-1,Y.column-1)}Se.to=_e;function he(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Se.from=he})(r=e.Position||(e.Position={}));var S;(function(Se){function _e(Ie,Me){return(0,d.coalesce)((0,d.asArray)(Ie).map(Je=>he(Je,Me)))}Se.from=_e;function he(Ie,Me){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:Y(Ie.scheme,Me),pattern:se.from(Ie.pattern)??void 0,exclusive:Ie.exclusive}}function Y(Ie,Me){return Me&&typeof Ie=="string"?Me.transformOutgoingScheme(Ie):Ie}})(S=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function _e(Y){switch(Y){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}Se.from=_e;function he(Y){switch(Y){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}Se.to=he})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(Se){function _e(Y){let Ie;return Y.code&&((0,D.isString)(Y.code)||(0,D.isNumber)(Y.code)?Ie=String(Y.code):Ie={value:String(Y.code.value),target:Y.code.target}),{...s.from(Y.range),message:Y.message,source:Y.source,code:Ie,severity:o.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(n.from),tags:Array.isArray(Y.tags)?(0,d.coalesce)(Y.tags.map(a.from)):void 0}}Se.from=_e;function he(Y){const Ie=new p.Diagnostic(s.to(Y),Y.message,o.to(Y.severity));return Ie.source=Y.source,Ie.code=(0,D.isString)(Y.code)?Y.code:Y.code?.value,Ie.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(n.to),Ie.tags=Y.tags&&(0,d.coalesce)(Y.tags.map(a.to)),Ie}Se.to=he})(i=e.Diagnostic||(e.Diagnostic={}));var n;(function(Se){function _e(Y){return{...s.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Se.from=_e;function he(Y){return new p.DiagnosticRelatedInformation(new p.Location(Y.resource,s.to(Y)),Y.message)}Se.to=he})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(Se){function _e(Y){switch(Y){case p.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}Se.from=_e;function he(Y){switch(Y){case b.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}Se.to=he})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(Se){function _e(Y){return typeof Y=="number"&&Y>=p.ViewColumn.One?Y-1:Y===p.ViewColumn.Beside?R.SIDE_GROUP:R.ACTIVE_GROUP}Se.from=_e;function he(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=he})(c=e.ViewColumn||(e.ViewColumn={}));function m(Se){return typeof Se.range!="undefined"}function f(Se){return Se.length===0?!0:!!m(Se[0])}e.isDecorationOptionsArr=f;var w;(function(Se){function _e(Ke){return Ke.map(Se.from)}Se.fromMany=_e;function he(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let mt;if(he(Ke)){const{language:vt,value:wt}=Ke;mt={value:"```"+vt+`
`+wt+"\n```\n"}}else p.MarkdownString.isMarkdownString(Ke)?mt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml}:typeof Ke=="string"?mt={value:Ke}:mt={value:""};const St=Object.create(null);mt.uris=St;const yt=vt=>{try{let wt=P.URI.parse(vt,!0);wt=wt.with({query:Ie(wt.query,St)}),St[vt]=wt}catch{}return""},dt=new C.Renderer;return dt.link=yt,dt.image=vt=>yt(I.parseHrefAndDimensions(vt).href),C(mt.value,{renderer:dt}),mt}Se.from=Y;function Ie(Ke,mt){if(!Ke)return Ke;let St;try{St=(0,A.parse)(Ke)}catch{}if(!St)return Ke;let yt=!1;return St=(0,k.cloneAndChange)(St,dt=>{if(P.URI.isUri(dt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[vt]=dt,yt=!0,vt}else return}),yt?JSON.stringify(St):Ke}function Me(Ke){const mt=new p.MarkdownString(Ke.value,Ke.supportThemeIcons);return mt.isTrusted=Ke.isTrusted,mt.supportHtml=Ke.supportHtml,mt}Se.to=Me;function Je(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Se.from(Ke)}Se.fromStrict=Je})(w=e.MarkdownString||(e.MarkdownString={}));function T(Se){return f(Se)?Se.map(_e=>({range:s.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?w.fromMany(_e.hoverMessage):_e.hoverMessage?w.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):Se.map(_e=>({range:s.from(_e)}))}e.fromRangeOrRangeWithMessage=T;function L(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?P.URI.file(Se):Se}e.pathOrURIToURI=L;var O;(function(Se){function _e(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?L(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Se.from=_e})(O=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(Se){function _e(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?L(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}Se.from=_e})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(Se){function _e(he){if(typeof he=="undefined")return he;switch(he){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=_e})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(Se){function _e(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?M.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?E.from(he.light):void 0,dark:he.dark?E.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?L(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}Se.from=_e})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Se){function _e(Y){return{text:Y.newText,eol:Y.newEol&&gt.from(Y.newEol),range:s.from(Y.range)}}Se.from=_e;function he(Y){const Ie=new p.TextEdit(s.to(Y.range),Y.text);return Ie.newEol=typeof Y.eol=="undefined"?void 0:gt.to(Y.eol),Ie}Se.to=he})(V=e.TextEdit||(e.TextEdit={}));var z;(function(Se){function _e(Y,Ie,Me){const Je={edits:[]};if(Y instanceof p.WorkspaceEdit)for(let Ke of Y._allEntries())if(Ke._type===1)Je.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const mt=Ie?.getDocument(Ke.uri);Je.edits.push({_type:2,resource:Ke.uri,edit:V.from(Ke.edit),modelVersionId:mt?.version,metadata:Ke.metadata})}else Ke._type===3?Je.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Me?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&Je.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Me?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(lt.from)}});return Je}Se.from=_e;function he(Y){const Ie=new p.WorkspaceEdit;for(const Me of Y.edits)Me.edit?Ie.replace(P.URI.revive(Me.resource),s.to(Me.edit.range),Me.edit.text):Ie.renameFile(P.URI.revive(Me.oldUri),P.URI.revive(Me.newUri),Me.options);return Ie}Se.to=he})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(Se){const _e=Object.create(null);_e[p.SymbolKind.File]=0,_e[p.SymbolKind.Module]=1,_e[p.SymbolKind.Namespace]=2,_e[p.SymbolKind.Package]=3,_e[p.SymbolKind.Class]=4,_e[p.SymbolKind.Method]=5,_e[p.SymbolKind.Property]=6,_e[p.SymbolKind.Field]=7,_e[p.SymbolKind.Constructor]=8,_e[p.SymbolKind.Enum]=9,_e[p.SymbolKind.Interface]=10,_e[p.SymbolKind.Function]=11,_e[p.SymbolKind.Variable]=12,_e[p.SymbolKind.Constant]=13,_e[p.SymbolKind.String]=14,_e[p.SymbolKind.Number]=15,_e[p.SymbolKind.Boolean]=16,_e[p.SymbolKind.Array]=17,_e[p.SymbolKind.Object]=18,_e[p.SymbolKind.Key]=19,_e[p.SymbolKind.Null]=20,_e[p.SymbolKind.EnumMember]=21,_e[p.SymbolKind.Struct]=22,_e[p.SymbolKind.Event]=23,_e[p.SymbolKind.Operator]=24,_e[p.SymbolKind.TypeParameter]=25;function he(Ie){return typeof _e[Ie]=="number"?_e[Ie]:6}Se.from=he;function Y(Ie){for(const Me in _e)if(_e[Me]===Ie)return Number(Me);return p.SymbolKind.Property}Se.to=Y})(N=e.SymbolKind||(e.SymbolKind={}));var W;(function(Se){function _e(Y){switch(Y){case p.SymbolTag.Deprecated:return 1}}Se.from=_e;function he(Y){switch(Y){case 1:return p.SymbolTag.Deprecated}}Se.to=he})(W=e.SymbolTag||(e.SymbolTag={}));var B;(function(Se){function _e(Y){return{name:Y.name,kind:N.from(Y.kind),tags:Y.tags&&Y.tags.map(W.from),containerName:Y.containerName,location:re.from(Y.location)}}Se.from=_e;function he(Y){const Ie=new p.SymbolInformation(Y.name,N.to(Y.kind),Y.containerName,re.to(Y.location));return Ie.tags=Y.tags&&Y.tags.map(W.to),Ie}Se.to=he})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(Se){function _e(Y){const Ie={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),kind:N.from(Y.kind),tags:Y.tags?.map(W.from)??[]};return Y.children&&(Ie.children=Y.children.map(_e)),Ie}Se.from=_e;function he(Y){const Ie=new p.DocumentSymbol(Y.name,Y.detail,N.to(Y.kind),s.to(Y.range),s.to(Y.selectionRange));return(0,d.isNonEmptyArray)(Y.tags)&&(Ie.tags=Y.tags.map(W.to)),Y.children&&(Ie.children=Y.children.map(he)),Ie}Se.to=he})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var $;(function(Se){function _e(Y){const Ie=new p.CallHierarchyItem(N.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),s.to(Y.range),s.to(Y.selectionRange));return Ie._sessionId=Y._sessionId,Ie._itemId=Y._itemId,Ie}Se.to=_e;function he(Y,Ie,Me){if(Ie=Ie??Y._sessionId,Me=Me??Y._itemId,Ie===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Me,name:Y.name,detail:Y.detail,kind:N.from(Y.kind),uri:Y.uri,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),tags:Y.tags?.map(W.from)}}Se.from=he})($=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(Se){function _e(he){return new p.CallHierarchyIncomingCall($.to(he.from),he.fromRanges.map(Y=>s.to(Y)))}Se.to=_e})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Se){function _e(he){return new p.CallHierarchyOutgoingCall($.to(he.to),he.fromRanges.map(Y=>s.to(Y)))}Se.to=_e})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var re;(function(Se){function _e(Y){return{range:Y.range&&s.from(Y.range),uri:Y.uri}}Se.from=_e;function he(Y){return new p.Location(P.URI.revive(Y.uri),s.to(Y.range))}Se.to=he})(re=e.location||(e.location={}));var Z;(function(Se){function _e(Y){const Ie=Y,Me=Y;return{originSelectionRange:Ie.originSelectionRange?s.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Me.uri,range:s.from(Ie.targetRange?Ie.targetRange:Me.range),targetSelectionRange:Ie.targetSelectionRange?s.from(Ie.targetSelectionRange):void 0}}Se.from=_e;function he(Y){return{targetUri:P.URI.revive(Y.uri),targetRange:s.to(Y.range),targetSelectionRange:Y.targetSelectionRange?s.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?s.to(Y.originSelectionRange):void 0}}Se.to=he})(Z=e.DefinitionLink||(e.DefinitionLink={}));var Q;(function(Se){function _e(Y){return{range:s.from(Y.range),contents:w.fromMany(Y.contents)}}Se.from=_e;function he(Y){return new p.Hover(Y.contents.map(w.to),s.to(Y.range))}Se.to=he})(Q=e.Hover||(e.Hover={}));var oe;(function(Se){function _e(Y){return{range:s.from(Y.range),expression:Y.expression}}Se.from=_e;function he(Y){return new p.EvaluatableExpression(s.to(Y.range),Y.expression)}Se.to=he})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(Se){function _e(Y){if(Y instanceof p.InlineValueText)return{type:"text",range:s.from(Y.range),text:Y.text};if(Y instanceof p.InlineValueVariableLookup)return{type:"variable",range:s.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof p.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=_e;function he(Y){switch(Y.type){case"text":return{range:s.to(Y.range),text:Y.text};case"variable":return{range:s.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:s.to(Y.range),expression:Y.expression}}}Se.to=he})(fe=e.InlineValue||(e.InlineValue={}));var pe;(function(Se){function _e(Y){return{frameId:Y.frameId,stoppedLocation:s.from(Y.stoppedLocation)}}Se.from=_e;function he(Y){return new p.InlineValueContext(Y.frameId,s.to(Y.stoppedLocation))}Se.to=he})(pe=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(Se){function _e(Y){return{range:s.from(Y.range),kind:Y.kind}}Se.from=_e;function he(Y){return new p.DocumentHighlight(s.to(Y.range),Y.kind)}Se.to=he})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(Se){function _e(he){switch(he){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}Se.to=_e})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(Se){function _e(he){return{triggerKind:xe.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Se.to=_e})(qe=e.CompletionContext||(e.CompletionContext={}));var Qe;(function(Se){function _e(Y){switch(Y){case p.CompletionItemTag.Deprecated:return 1}}Se.from=_e;function he(Y){switch(Y){case 1:return p.CompletionItemTag.Deprecated}}Se.to=he})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(Se){const _e=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function he(Me){return _e.get(Me)??9}Se.from=he;const Y=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Ie(Me){return Y.get(Me)??p.CompletionItemKind.Property}Se.to=Ie})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Se){function _e(he,Y){const Ie=new p.CompletionItem(he.label);return Ie.insertText=he.insertText,Ie.kind=q.to(he.kind),Ie.tags=he.tags?.map(Qe.to),Ie.detail=he.detail,Ie.documentation=I.isMarkdownString(he.documentation)?w.to(he.documentation):he.documentation,Ie.sortText=he.sortText,Ie.filterText=he.filterText,Ie.preselect=he.preselect,Ie.commitCharacters=he.commitCharacters,F.Range.isIRange(he.range)?Ie.range=s.to(he.range):typeof he.range=="object"&&(Ie.range={inserting:s.to(he.range.insert),replacing:s.to(he.range.replace)}),Ie.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?Ie.insertText=new p.SnippetString(he.insertText):(Ie.insertText=he.insertText,Ie.textEdit=Ie.range instanceof p.Range?new p.TextEdit(Ie.range,Ie.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Ie.additionalTextEdits=he.additionalTextEdits.map(Me=>V.to(Me))),Ie.command=Y&&he.command?Y.fromInternal(he.command):void 0,Ie}Se.to=_e})(ie=e.CompletionItem||(e.CompletionItem={}));var G;(function(Se){function _e(Y){return{label:Y.label,documentation:Y.documentation?w.fromStrict(Y.documentation):void 0}}Se.from=_e;function he(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?w.to(Y.documentation):Y.documentation}}Se.to=he})(G=e.ParameterInformation||(e.ParameterInformation={}));var X;(function(Se){function _e(Y){return{label:Y.label,documentation:Y.documentation?w.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.from):[],activeParameter:Y.activeParameter}}Se.from=_e;function he(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?w.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.to):[],activeParameter:Y.activeParameter}}Se.to=he})(X=e.SignatureInformation||(e.SignatureInformation={}));var ae;(function(Se){function _e(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(X.from):[]}}Se.from=_e;function he(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(X.to):[]}}Se.to=he})(ae=e.SignatureHelp||(e.SignatureHelp={}));var me;(function(Se){function _e(he,Y){const Ie=new p.InlayHint(typeof Y.label=="string"?Y.label:Y.label.map(De.to.bind(void 0,he)),r.to(Y.position),Be.to(Y.kind));return Ie.tooltip=I.isMarkdownString(Y.tooltip)?w.to(Y.tooltip):Y.tooltip,Ie.paddingLeft=Y.paddingLeft,Ie.paddingRight=Y.paddingRight,Ie}Se.to=_e})(me=e.InlayHint||(e.InlayHint={}));var De;(function(Se){function _e(he,Y){const Ie=new p.InlayHintLabelPart(Y.label);return Ie.tooltip=I.isMarkdownString(Y.tooltip)?w.to(Y.tooltip):Y.tooltip,y.Command.is(Y.command)&&(Ie.command=he.fromInternal(Y.command)),Y.location&&(Ie.location=re.to(Y.location)),Ie}Se.to=_e})(De=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Be;(function(Se){function _e(Y){return Y}Se.from=_e;function he(Y){return Y}Se.to=he})(Be=e.InlayHintKind||(e.InlayHintKind={}));var Xe;(function(Se){function _e(Y){return{range:s.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Se.from=_e;function he(Y){let Ie;if(Y.url)try{Ie=typeof Y.url=="string"?P.URI.parse(Y.url,!0):P.URI.revive(Y.url)}catch{}return new p.DocumentLink(s.to(Y.range),Ie)}Se.to=he})(Xe=e.DocumentLink||(e.DocumentLink={}));var tt;(function(Se){function _e(Y){const Ie=new p.ColorPresentation(Y.label);return Y.textEdit&&(Ie.textEdit=V.to(Y.textEdit)),Y.additionalTextEdits&&(Ie.additionalTextEdits=Y.additionalTextEdits.map(Me=>V.to(Me))),Ie}Se.to=_e;function he(Y){return{label:Y.label,textEdit:Y.textEdit?V.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ie=>V.from(Ie)):void 0}}Se.from=he})(tt=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(Se){function _e(Y){return new p.Color(Y[0],Y[1],Y[2],Y[3])}Se.to=_e;function he(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Se.from=he})(rt=e.Color||(e.Color={}));var st;(function(Se){function _e(Y){return{range:s.from(Y.range)}}Se.from=_e;function he(Y){return new p.SelectionRange(s.to(Y.range))}Se.to=he})(st=e.SelectionRange||(e.SelectionRange={}));var et;(function(Se){function _e(he){switch(he){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}Se.to=_e})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Se){function _e(Y){switch(Y){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=_e;function he(Y){switch(Y){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 1:default:return p.TextEditorLineNumbersStyle.On}}Se.to=he})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(Se){function _e(Y){if(Y===p.EndOfLine.CRLF)return 1;if(Y===p.EndOfLine.LF)return 0}Se.from=_e;function he(Y){if(Y===1)return p.EndOfLine.CRLF;if(Y===0)return p.EndOfLine.LF}Se.to=he})(gt=e.EndOfLine||(e.EndOfLine={}));var It;(function(Se){function _e(he){if(typeof he=="object")return he.viewId;switch(he){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=_e})(It=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(Se){function _e(he){const Y={start:he.start+1,end:he.end+1};return he.kind&&(Y.kind=Dt.from(he.kind)),Y}Se.from=_e})(Ne=e.FoldingRange||(e.FoldingRange={}));var Dt;(function(Se){function _e(he){if(he)switch(he){case p.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}Se.from=_e})(Dt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var te;(function(Se){function _e(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?s.from(he.selection):void 0,override:typeof he.override=="boolean"?l.EditorResolution.DISABLED:void 0}}Se.from=_e})(te=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var se;(function(Se){function _e(Me){return Me instanceof p.RelativePattern?Me.toJSON():typeof Me=="string"?Me:he(Me)||Y(Me)?new p.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}Se.from=_e;function he(Me){const Je=Me;return Je?P.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function Y(Me){const Je=Me;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Ie(Me){return typeof Me=="string"?Me:new p.RelativePattern(P.URI.revive(Me.baseUri),Me.pattern)}Se.to=Ie})(se=e.GlobPattern||(e.GlobPattern={}));var K;(function(Se){function _e(he){if(he){if(Array.isArray(he))return he.map(_e);if(typeof he=="string")return he;{const Y=he;return{language:Y.language,scheme:Y.scheme,pattern:se.from(Y.pattern),exclusive:Y.exclusive}}}else return}Se.from=_e})(K=e.LanguageSelector||(e.LanguageSelector={}));var we;(function(Se){function _e(Y){return{start:Y.start,end:Y.end}}Se.from=_e;function he(Y){return new p.NotebookRange(Y.start,Y.end)}Se.to=he})(we=e.NotebookRange||(e.NotebookRange={}));var ke;(function(Se){function _e(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Se.to=_e;function he(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Se.from=he})(ke=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(Se){function _e(Y){switch(Y){case p.NotebookCellKind.Markup:return v.CellKind.Markup;case p.NotebookCellKind.Code:default:return v.CellKind.Code}}Se.from=_e;function he(Y){switch(Y){case v.CellKind.Markup:return p.NotebookCellKind.Markup;case v.CellKind.Code:default:return p.NotebookCellKind.Code}}Se.to=he})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var We;(function(Se){function _e(Y){const Ie={metadata:Y.metadata??Object.create(null),cells:[]};for(let Me of Y.cells)p.NotebookCellData.validate(Me),Ie.cells.push(lt.from(Me));return Ie}Se.from=_e;function he(Y){const Ie=new p.NotebookData(Y.cells.map(lt.to));return(0,D.isEmptyObject)(Y.metadata)||(Ie.metadata=Y.metadata),Ie}Se.to=he})(We=e.NotebookData||(e.NotebookData={}));var lt;(function(Se){function _e(Y){return{cellKind:Ve.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:ke.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Ae.from):[]}}Se.from=_e;function he(Y){return new p.NotebookCellData(Ve.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Ae.to):void 0,Y.metadata,Y.internalMetadata?ke.to(Y.internalMetadata):void 0)}Se.to=he})(lt=e.NotebookCellData||(e.NotebookCellData={}));var Re;(function(Se){function _e(Y){return{mime:Y.mime,valueBytes:t.VSBuffer.wrap(Y.data)}}Se.from=_e;function he(Y){return new p.NotebookCellOutputItem(Y.valueBytes.buffer,Y.mime)}Se.to=he})(Re=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(Se){function _e(Y){return{outputId:Y.id,items:Y.items.map(Re.from),metadata:Y.metadata}}Se.from=_e;function he(Y){const Ie=Y.items.map(Re.to);return new p.NotebookCellOutput(Ie,Y.outputId,Y.metadata)}Se.to=he})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(Se){function _e(Ie){return Y(Ie)?{include:(0,D.withNullAsUndefined)(se.from(Ie.include)),exclude:(0,D.withNullAsUndefined)(se.from(Ie.exclude))}:(0,D.withNullAsUndefined)(se.from(Ie))}Se.from=_e;function he(Ie){return Y(Ie)?{include:se.to(Ie.include),exclude:se.to(Ie.exclude)}:se.to(Ie)}Se.to=he;function Y(Ie){const Me=Ie;return Me?!!Me.include&&!!Me.exclude:!1}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ue;(function(Se){function _e(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?O.from(he.top):void 0}}Se.from=_e})(ue=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(Se){function _e(he,Y,Ie){const Me=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Me,Ie),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Se.from=_e})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ee;(function(Se){function _e(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}Se.from=_e})(Ee=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ye;(function(Se){function _e(Y){return{uri:Y.uri,provides:Y.provides}}Se.from=_e;function he(Y){return new p.NotebookRendererScript(P.URI.revive(Y.uri),Y.provides)}Se.to=he})(ye=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Oe;(function(Se){function _e(Y){return{message:w.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,location:Y.location?re.from(Y.location):void 0}}Se.from=_e;function he(Y){const Ie=new p.TestMessage(typeof Y.message=="string"?Y.message:w.to(Y.message));return Ie.actualOutput=Y.actual,Ie.expectedOutput=Y.expected,Ie.location=Y.location?re.to(Y.location):void 0,Ie}Se.to=he})(Oe=e.TestMessage||(e.TestMessage={}));var Ge;(function(Se){let _e;(function(he){he.Delimiter="\0"})(_e||(_e={})),Se.namespace=(he,Y)=>he+"\0"+Y,Se.denamespace=he=>{const Y=he.indexOf("\0");return{ctrlId:he.slice(0,Y),tagId:he.slice(Y+1)}}})(Ge=e.TestTag||(e.TestTag={}));var $e;(function(Se){function _e(Me){const Je=(0,g.getPrivateApiFor)(Me).controllerId;return{extId:_.TestId.fromExtHostTestItem(Me,Je).toString(),label:Me.label,uri:Me.uri,tags:Me.tags.map(Ke=>Ge.namespace(Je,Ke.id)),range:s.from(Me.range)||null,description:Me.description||null,error:Me.error&&w.fromStrict(Me.error)||null}}Se.from=_e;function he(Me){return{parent:void 0,error:void 0,id:_.TestId.fromString(Me.extId).localId,label:Me.label,uri:P.URI.revive(Me.uri),tags:(Me.tags||[]).map(Je=>{const{tagId:Ke}=Ge.denamespace(Je);return new p.TestTag(Ke)}),range:s.to(Me.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Me.description||void 0}}Se.toPlain=he;function Y(Me){const Je=_.TestId.fromString(Me.extId),Ke=new g.TestItemImpl(Je.controllerId,Je.localId,Me.label,P.URI.revive(Me.uri));return Ke.range=s.to(Me.range||void 0),Ke.description=Me.description||void 0,Ke}function Ie(Me){let Je;for(const Ke of Me.tests){const mt=Y(Ke.item);(0,g.getPrivateApiFor)(mt).parent=Je,Je=mt}return Je}Se.toItemFromContext=Ie})($e=e.TestItem||(e.TestItem={})),function(Se){function _e(Y){return{id:Y.id}}Se.from=_e;function he(Y){return new p.TestTag(Y.id)}Se.to=he}(Ge=e.TestTag||(e.TestTag={}));var Ye;(function(Se){const _e=(Y,Ie)=>{const Me={...$e.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ke=>Ke.type===0).map(Oe.to)})),children:Y.children.map(Je=>Ie.get(Je)).filter(D.isDefined).map(Je=>_e(Je,Ie))};for(const Je of Me.children)Je.parent=Me;return Me};function he(Y){const Ie=[],Me=new Map;for(const Je of Y.items)Me.set(Je.item.extId,Je),Y.request.targets.some(Ke=>Ke.controllerId===Je.controllerId&&Ke.testIds.includes(Je.item.extId))&&Ie.push(Je);return{completedAt:Y.completedAt,results:Ie.map(Je=>_e(Je,Me))}}Se.to=he})(Ye=e.TestResults||(e.TestResults={}));var at;(function(Se){function _e(Me){return{covered:Me.covered,total:Me.covered}}function he(Me){return"line"in Me?r.from(Me):s.from(Me)}function Y(Me){return"branches"in Me?{count:Me.executionCount,location:he(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Je=>({count:Je.executionCount,location:Je.location&&he(Je.location)})):void 0}:{type:0,count:Me.executionCount,location:he(Me.location)}}Se.fromDetailed=Y;function Ie(Me){return{uri:Me.uri,statement:_e(Me.statementCoverage),branch:Me.branchCoverage&&_e(Me.branchCoverage),function:Me.functionCoverage&&_e(Me.functionCoverage),details:Me.detailedCoverage?.map(Y)}}Se.fromFile=Ie})(at=e.TestCoverage||(e.TestCoverage={}));var ct;(function(Se){function _e(he){switch(he){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}Se.to=_e})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var He;(function(Se){function _e(Y){const Ie=new p.TypeHierarchyItem(N.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),s.to(Y.range),s.to(Y.selectionRange));return Ie._sessionId=Y._sessionId,Ie._itemId=Y._itemId,Ie}Se.to=_e;function he(Y,Ie,Me){if(Ie=Ie??Y._sessionId,Me=Me??Y._itemId,Ie===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Me,kind:N.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),tags:Y.tags?.map(W.from)}}Se.from=he})(He=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[218],be([0,1,2,16,7,15,94]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,F,y,l={timeout:1500,errors:3}){this._logService=P,this._documents=F,this._mainThreadBulkEdits=y,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(F,y,l)=>{const g={dispose:this._callbacks.push([F,y,P])};return Array.isArray(l)&&l.push(g),g}}async $participateInSave(P,F){const y=d.URI.revive(P);let l=!1;const b=setTimeout(()=>l=!0,this._thresholds.timeout),g=[];try{for(let v of[...this._callbacks]){if(l)break;const _=this._documents.getDocument(y),R=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:C.TextDocumentSaveReason.to(F)});g.push(R)}}finally{clearTimeout(b)}return g}_deliverEventAsyncAndBlameBadListeners([P,F,y],l){const b=this._badListeners.get(P);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,F,l).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const v=this._badListeners.get(P);this._badListeners.set(P,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,F,y,l){const b=[],g=Date.now(),{document:v,reason:_}=l,{version:R}=v,p=Object.freeze({document:v,reason:_,waitUntil(h){if(Object.isFrozen(b))throw(0,t.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(h))}});try{F.apply(y,[p])}catch(h){return Promise.reject(h)}return Object.freeze(b),new Promise((h,s)=>{const u=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(u),h(r)}).catch(r=>{clearTimeout(u),s(r)})}).then(h=>{const s={edits:[]};for(const u of h)if(Array.isArray(u)&&u.every(r=>r instanceof I.TextEdit))for(const{newText:r,newEol:S,range:a}of u)s.edits.push({_type:2,resource:v.uri,edit:{range:a&&C.Range.from(a),text:r,eol:S&&C.EndOfLine.from(S)}});if(s.edits.length!==0)return R===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ve[219],be([0,1,10,25,2,15,127]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(y,l,b,g){this.start=y,this.deletedCount=l,this.deletedItems=b,this.items=g}static asApiEvents(y){return y.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(b=>b.apiCell)}))}}class D{constructor(y,l,b){this.notebook=y,this._extHostDocument=l,this._cellData=b,this.handle=b.handle,this.uri=I.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(y,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return y._mime},set mime(b){y._mime=b},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}})}return this._apiCell}setOutputs(y){this._outputs=y.map(C.NotebookCellOutput.to)}setOutputItems(y,l,b){const g=b.map(C.NotebookCellOutputItem.to),v=this._outputs.find(_=>_.id===y);v&&(l||(v.items.length=0),v.items.push(...g))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=D;class P{constructor(y,l,b,g,v,_){this._proxy=y,this._textDocumentsAndEditors=l,this._textDocuments=b,this._emitter=g,this.uri=v,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=_.viewType,this._metadata=Object.freeze(_.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,_.cells]],!0),this._versionId=_.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this;this._notebook={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===d.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(l){return l=y._validateIndex(l),y._cells[l].apiCell},getCells(l){return(l?y._getCells(l):y._cells).map(g=>g.apiCell)},save(){return y._save()}}}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,l){this._versionId=y.versionId,this._isDirty=l;for(const b of y.rawEvents)b.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===A.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===A.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===A.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===A.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===A.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let l=y.start|0,b=y.end|0;return l<0&&(l=0),b>this._cells.length&&(b=this._cells.length),y.with({start:l,end:b})}_getCells(y){y=this._validateRange(y);const l=[];for(let b=y.start;b<y.end;b++)l.push(this._cells[b]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,l){if(this._disposed)return;const b=[],g=[],v=[];y.reverse().forEach(_=>{const p=_[2].map(u=>{const r=new D(this,this._textDocumentsAndEditors,u);return l||g.push(D.asModelAddData(this.apiNotebook,u)),r}),h=new k(_[0],_[1],[],p),s=this._cells.splice(_[0],_[1],...p);for(const u of s)v.push(u.uri),h.deletedItems.push(u.apiCell);b.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:v}),l||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(b)}))}_moveCell(y,l){const b=this._cells.splice(y,1);this._cells.splice(l,0,...b);const g=[new k(y,1,b.map(v=>v.apiCell),[]),new k(l,0,[],b)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(g)}))}_setCellOutputs(y,l){const b=this._cells[y];b.setOutputs(l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(y,l,b,g){const v=this._cells[y];v.setOutputItems(l,b,g),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(y,l){const b=this._cells[y];b.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(b.uri,l)}_changeCellMime(y,l){const b=this._cells[y];b.apiCell.mime=l}_changeCellMetadata(y,l){const b=this._cells[y],g=b.apiCell.metadata;b.setMetadata(l);const v=b.apiCell.metadata;(0,t.equals)(g,v)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(y,l){this._cells[y].setInternalMetadata(l)}getCellFromApiCell(y){return this._cells.find(l=>l.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(l=>l.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(ve[130],be([0,1,7,15,16]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:P})}replaceCells(D,P,F){this._throwIfFinalized(),!(D===P&&F.length===0)&&this._collectedEdits.push({editType:1,index:D,count:P-D,cells:F.map(t.NotebookCellData.from)})}}class A{constructor(D,P,F,y,l,b){this.id=D,this._proxy=P,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=y,this._viewColumn=b}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(P){if(!Array.isArray(P)||!P.every(d.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");D._selections=P,D._trySetSelections(P)},get visibleRanges(){return D._visibleRanges},revealRange(P,F){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(P),F??d.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(P){const F=new C(this.document.version);return P(F),D._applyEdit(F.finalize())},setDecorations(P,F){return D.setDecorations(P,F)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const P=[];let F=-1;for(let y=0;y<D.cellEdits.length;y++){if(F<0){P.push(D.cellEdits[y]),F++;continue}const b=P[F],g=D.cellEdits[y];if(b.editType===1&&g.editType===1&&b.index===g.index){b.cells.push(...D.cellEdits[y].cells),b.count+=D.cellEdits[y].count;continue}P.push(D.cellEdits[y]),F++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,P)}setDecorations(D,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return P.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(P),D.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(ve[220],be([0,1,15,118,168,21,56,16]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,b,g){const v=this._handles++,{title:_,location:R,cancellable:p}=b,h={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(v,{location:d.ProgressLocation.from(R),title:_,source:h,cancellable:p},l.isUnderDevelopment?void 0:l.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(v,g,!!p)}_withProgress(l,b,g){let v;g&&(v=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,v));const _=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),v&&v.dispose()};let R;try{R=b(new F(this._proxy,l),g&&v?v.token:C.CancellationToken.None)}catch(p){throw _(l),p}return R.then(p=>_(l),p=>_(l)),R}$acceptProgressCanceled(l){const b=this._mapHandleToCancellationSource.get(l);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=D;function P(y,l){return y.message=l.message,typeof l.increment=="number"&&(typeof y.increment=="number"?y.increment+=l.increment:y.increment=l.increment),y}class F extends t.Progress{constructor(l,b){super(g=>this.throttledReport(g));this._proxy=l,this._handle=b}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,A.throttle)(100,(y,l)=>P(y,l),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(ve[131],be([0,1,55,16,76,15,7]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(l,b,g){const v=k._Keys.nextId();l.$registerTextEditorDecorationType(b.identifier,v,C.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:v,dispose(){l.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(l,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,b){this._throwIfFinalized();let g=null;if(l instanceof A.Position)g=new A.Range(l,l);else if(l instanceof A.Range)g=l;else throw new Error("Unrecognized location");this._pushEdit(g,b,!1)}insert(l,b){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),b,!0)}delete(l){this._throwIfFinalized();let b=null;if(l instanceof A.Range)b=l;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(l,b,g){const v=this._document.validateRange(l);this._collectedEdits.push({range:v,text:b,forceMoveMarkers:g})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=D;class P{constructor(l,b,g,v){this._proxy=l,this._id=b,this._accept(g),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(R){_._setTabSize(R)},get insertSpaces(){return _._insertSpaces},set insertSpaces(R){_._setInsertSpaces(R)},get cursorStyle(){return _._cursorStyle},set cursorStyle(R){_._setCursorStyle(R)},get lineNumbers(){return _._lineNumbers},set lineNumbers(R){_._setLineNumbers(R)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(l){const b=this._validateTabSize(l);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const b=this._validateInsertSpaces(l);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let g=!1;if(typeof l.tabSize!="undefined"){const v=this._validateTabSize(l.tabSize);v==="auto"?(g=!0,b.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,g=!0,b.tabSize=v)}if(typeof l.insertSpaces!="undefined"){const v=this._validateInsertSpaces(l.insertSpaces);v==="auto"?(g=!0,b.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,g=!0,b.insertSpaces=v)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,g=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,g=!0,b.lineNumbers=C.TextEditorLineNumbersStyle.from(l.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(l,b){b.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=P;class F{constructor(l,b,g,v,_,R,p,h){this.id=l,this._proxy=b,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,R,g),this._visibleRanges=p,this._viewColumn=h;const s=this;this.value=Object.freeze({get document(){return v.getValue()},set document(u){throw(0,t.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(u){if(!(u instanceof A.Selection))throw(0,t.illegalArgument)("selection");s._selections=[u],s._trySetSelection()},get selections(){return s._selections},set selections(u){if(!Array.isArray(u)||u.some(r=>!(r instanceof A.Selection)))throw(0,t.illegalArgument)("selections");s._selections=u,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(u){throw(0,t.readonly)("visibleRanges")},get options(){return s._options.value},set options(u){s._disposed||s._options.assign(u)},get viewColumn(){return s._viewColumn},set viewColumn(u){throw(0,t.readonly)("viewColumn")},edit(u,r={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new D(v.getValue(),r);return u(S),s._applyEdit(S)},insertSnippet(u,r,S={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!r||Array.isArray(r)&&r.length===0)a=s._selections.map(i=>C.Range.from(i));else if(r instanceof A.Position){const{lineNumber:i,column:n}=C.Position.from(r);a=[{startLineNumber:i,startColumn:n,endLineNumber:i,endColumn:n}]}else if(r instanceof A.Range)a=[C.Range.from(r)];else{a=[];for(const i of r)if(i instanceof A.Range)a.push(C.Range.from(i));else{const{lineNumber:n,column:o}=C.Position.from(i);a.push({startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o})}}return b.$tryInsertSnippet(l,u.value,a,S)},setDecorations(u,r){const S=r.length===0;S&&!s._hasDecorationsForKey.has(u.key)||(S?s._hasDecorationsForKey.delete(u.key):s._hasDecorationsForKey.add(u.key),s._runOnProxy(()=>{if(C.isDecorationOptionsArr(r))return b.$trySetDecorations(l,u.key,C.fromRangeOrRangeWithMessage(r));{const a=new Array(4*r.length);for(let i=0,n=r.length;i<n;i++){const o=r[i];a[4*i]=o.start.line+1,a[4*i+1]=o.start.character+1,a[4*i+2]=o.end.line+1,a[4*i+3]=o.end.character+1}return b.$trySetDecorationsFast(l,u.key,a)}}))},revealRange(u,r){s._runOnProxy(()=>b.$tryRevealRange(l,C.Range.from(u),r||A.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(l,C.ViewColumn.from(u))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,d.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,d.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,d.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,d.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const g=b.edits.map(_=>_.range);g.sort((_,R)=>_.end.line===R.end.line?_.end.character===R.end.character?_.start.line===R.start.line?_.start.character-R.start.character:_.start.line-R.start.line:_.end.character-R.end.character:_.end.line-R.end.line);for(let _=0,R=g.length-1;_<R;_++){const p=g[_].end;if(g[_+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=b.edits.map(_=>({range:C.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,v,{setEndOfLine:typeof b.setEndOfLine=="number"?C.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=F}),define(ve[221],be([0,1,13,3,6,18,63,15,128,89]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends I.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const b=this.diff[this.diff.length-1];if(b&&l[0]===1){if(b[0]===1&&b[1].extId===l[1].extId){(0,D.applyTestItemUpdate)(b[1],l[1]);return}if(b[0]===0&&b[1].item.extId===l[1].extId){(0,D.applyTestItemUpdate)(b[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,b){const g=this.tree.get(l);if(!!g){if((g.expandLevels===void 0||b>g.expandLevels)&&(g.expandLevels=b),g.expand===1){const v=this.resolveChildren(g);return v.isOpen()?this.expandChildren(g,b-1):v.wait().then(()=>this.expandChildren(g,b-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.expandChildren(g,b-1)):this.expandChildren(g,b-1)}}dispose(){for(const l of this.tree.values())(0,A.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,b){switch(b.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(l.fullId,b.id));break;case 0:this.upsertItem(b.item,l);break;case 4:for(const g of b.ops)this.onTestItemEvent(l,g);break;case 3:{const{key:g,value:v,previous:_}=b,R=l.fullId.toString();switch(g){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(v,_,R);break;case"range":this.pushDiff([1,{extId:R,item:{range:k.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:R,item:{error:k.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:R,item:{[g]:v??null}}]);break}break}default:(0,C.assertNever)(b)}}upsertItem(l,b){if(!(l instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const g=P.TestId.fromExtHostTestItem(l,this.root.id,b?.actual),v=(0,A.getPrivateApiFor)(l);v.parent&&v.parent!==b?.actual&&v.parent.children.delete(l.id);let _=this.tree.get(g.toString());if(!_){_={fullId:g,actual:l,parent:b?g.parentId:null,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(l,b),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:k.TestItem.from(l)}]),this.connectItemAndChildren(l,_,b);return}if(_.actual===l){this.connectItem(l,_,b);return}const R=_.actual.children,p=_.actual,h=(0,A.diffTestItems)(p,l);(0,A.getPrivateApiFor)(p).listener=void 0,_.actual=l,_.expand=0;for(const[s,u]of h)this.onTestItemEvent(_,{op:3,key:s,value:u,previous:p[s]});this.connectItemAndChildren(l,_,b);for(const s of R)l.children.get(s.id)||this.removeItem(P.TestId.joinToString(g,s.id))}diffTagRefs(l,b,g){const v=new Set(b.map(_=>_.id));for(const _ of l)v.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:g,item:{tags:l.map(_=>k.TestTag.namespace(this.controllerId,_.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const b=this.tags.get(l.id);b?b.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const b=this.tags.get(l);b&&!--b.refCount&&(this.tags.delete(l),this.pushDiff([6,k.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,b){(0,A.getPrivateApiFor)(l).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(l,b,g){this.setItemParent(l,g);const v=(0,A.getPrivateApiFor)(l);v.parent=g?.actual,v.listener=_=>this.onTestItemEvent(b,_),this.updateExpandability(b)}connectItemAndChildren(l,b,g){this.connectItem(l,b,g);for(const v of l.children)this.upsertItem(v,b)}updateExpandability(l){let b;this._resolveHandler?l.resolveBarrier?b=l.resolveBarrier.isOpen()?3:2:b=l.actual.canResolveChildren?1:0:b=0,b!==l.expand&&(l.expand=b,this.pushDiff([1,{extId:l.fullId.toString(),expand:b}]),b===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,b){if(b<0)return;const g=[];for(const v of l.actual.children){const _=this.expand(P.TestId.joinToString(l.fullId,v.id),b);(0,d.isThenable)(_)&&g.push(_)}if(g.length)return Promise.all(g).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const _=new d.Barrier;return _.open(),_}l.expand=2,this.pushExpandStateUpdate(l);const b=l.resolveBarrier=new d.Barrier,g=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(_){g(_)}return(0,d.isThenable)(v)?v.catch(g).then(()=>{b.open(),this.updateExpandability(l)}):(b.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const b=this.tree.get(l);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const g=[b];for(;g.length;){const v=g.pop();if(!!v){(0,A.getPrivateApiFor)(v.actual).listener=void 0;for(const _ of v.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)g.push(this.tree.get(P.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=F}),define(ve[222],be([0,1,4,184]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(t.IEnvironmentService)}),define(ve[223],be([0,1,27,3,9]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=C;class A{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let y of F.activationEvents)y==="onUri"&&(y=`onUri:${d.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(F)}}keepOnly(F){const y=new Set;F.forEach(l=>y.add(d.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>y.has(d.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,y){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const l=A._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(l.map(b=>b.identifier)),y.length>0){const b=new Set;y.forEach(g=>b.add(d.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>!b.has(d.ExtensionIdentifier.toKey(g.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(l)}static _findLoopingExtensions(F){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,R){this.addNode(_),this.addNode(R),this._arcs.has(_)?this._arcs.get(_).push(R):this._arcs.set(_,[R])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,R){const p=y.getArcs(_);for(let h=0;h<p.length;h++)if(!R.has(p[h]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let _ of F){const R=d.ExtensionIdentifier.toKey(_.identifier);if(l.set(R,_),_.extensionDependencies)for(let p of _.extensionDependencies){const h=d.ExtensionIdentifier.toKey(p);y.addArc(R,h)}}let b=new Set;y.getNodes().filter(_=>y.getArcs(_).length===0).forEach(_=>b.add(_));let g=y.getNodes().filter(_=>!b.has(_)),v;do{v=!1;for(let _=0;_<g.length;_++){const R=g[_];y.hasOnlyGoodArcs(R,b)&&(g.splice(_,1),_--,b.add(R),v=!0)}}while(v);return g.map(_=>l.get(_))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const y=this._activationMap.get(F);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const y=this._extensionsMap.get(d.ExtensionIdentifier.toKey(F));return y||void 0}}e.ExtensionDescriptionRegistry=A;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,F){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(y!==l)return y-l;const b=I.posix.basename(P.extensionLocation.path),g=I.posix.basename(F.extensionLocation.path);return b<g?-1:b>g?1:0}}),define(ve[224],be([0,1,22]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function C(k){const D=d.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=C;function A(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=A}),define(ve[30],be([0,1,3,2,4,27,121]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class P{constructor(u){this.dependency=u}}e.MissingExtensionDependency=P;var F;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;function l(s,u){return s.enabledApiProposals?s.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=l;function b(s,u){if(!l(s,u))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=b;class g{constructor(u,r,S,a){this.codeLoadingTime=u,this.activateCallTime=r,this.activateResolvedTime=S,this.activationReason=a}}e.ActivationTimes=g;class v{constructor(u,r){this.description=u,this.value=r}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var _;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(_=e.ActivationKind||(e.ActivationKind={}));function R(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=R;function p(s,u){return{identifier:new C.ExtensionIdentifier((0,A.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!u,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=p;class h{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,r){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,r,S,a,i){}_onDidActivateExtensionError(u,r){}_onExtensionRuntimeError(u,r){}_onExtensionHostExit(u){}}e.NullExtensionService=h}),define(ve[225],be([0,1,16,27,30,12]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class k{constructor(v,_,R,p){this.startup=v,this.codeLoadingTime=_,this.activateCallTime=R,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,_){return v===-1||_===-1?-1:_-v}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class P{constructor(v,_,R,p,h,s){this.activationFailed=v,this.activationFailedError=_,this.activationTimes=R,this.module=p,this.exports=h,this.subscriptions=s}}e.ActivatedExtension=P;class F extends P{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class y extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class l extends P{constructor(v){super(!0,v,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let b=class{constructor(v,_,R,p,h){this._logService=h,this._isDisposed=!1,this._registry=v,this._resolvedExtensionsSet=new Set,_.forEach(s=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,R.forEach(s=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(s),s)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(v){const _=t.ExtensionIdentifier.toKey(v);return this._activatedExtensions.has(_)}getActivatedExtension(v){const _=t.ExtensionIdentifier.toKey(v),R=this._activatedExtensions.get(_);if(!R)throw new Error("Extension `"+v.value+"` is not known or not activated");return R}activateByEvent(v,_){if(this._alreadyActivatedEvents[v])return A;const R=this._registry.getExtensionDescriptionsForActivationEvent(v);return this._activateExtensions(R.map(p=>({id:p.identifier,reason:{startup:_,extensionId:p.identifier,activationEvent:v}}))).then(()=>{this._alreadyActivatedEvents[v]=!0})}activateById(v,_){const R=this._registry.getExtensionDescription(v);if(!R)throw new Error("Extension `"+v+"` is not known");return this._activateExtensions([{id:R.identifier,reason:_}])}_handleActivateRequest(v,_,R){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(v.id))){_[t.ExtensionIdentifier.toKey(v.id)]=v;return}const p=this._registry.getExtensionDescription(v.id);if(!p){const u=new Error(`Cannot activate unknown extension '${v.id.value}'`);this._host.onExtensionActivationError(v.id,u,new I.MissingExtensionDependency(v.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(v.id),new l(u));return}const h=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let s=!0;for(let u=0,r=h.length;u<r;u++){const S=h[u];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(S)))continue;const a=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(S));if(a&&!a.activationFailed)continue;if(a&&a.activationFailed){const c=p.displayName||p.identifier.value,m=this._registry.getExtensionDescription(S),f=m&&m.displayName||S,w=new Error(`Cannot activate the '${c}' extension because its dependency '${f}' failed to activate`);w.detail=a.activationFailedError,this._host.onExtensionActivationError(p.identifier,w,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(p.identifier),new l(w));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(S))){s=!1,_[t.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(S)),reason:v.reason};continue}const i=this._registry.getExtensionDescription(S);if(i){if(!i.main&&!i.browser)continue;s=!1,_[t.ExtensionIdentifier.toKey(S)]={id:i.identifier,reason:v.reason};continue}const n=p.displayName||p.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(p.identifier,o,new I.MissingExtensionDependency(S)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(p.identifier),new l(o));return}s?_[t.ExtensionIdentifier.toKey(p.identifier)]=v:R.push(v)}_activateExtensions(v){if(v.length===0||(v=v.filter(h=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(h.id))),v.length===0))return Promise.resolve(void 0);const _=Object.create(null),R=[];for(let h=0,s=v.length;h<s;h++)this._handleActivateRequest(v[h],_,R);for(let h=0,s=R.length;h<s;h++){const u=t.ExtensionIdentifier.toKey(R[h].id);_[u]&&delete _[u]}const p=Object.keys(_).map(h=>_[h]);return R.length===0?Promise.all(p.map(h=>this._activateExtension(h.id,h.reason))).then(h=>{}):this._activateExtensions(p).then(h=>this._activateExtensions(R))}_activateExtension(v,_){const R=t.ExtensionIdentifier.toKey(v);if(this._activatedExtensions.has(R))return Promise.resolve(void 0);const p=this._activatingExtensions.get(R);if(p)return p;const h=this._host.actualActivateExtension(v,_).then(void 0,s=>{const u=new Error;return s&&s.name&&(u.name=s.name),s&&s.message?u.message=`Activating extension '${v.value}' failed: ${s.message}.`:u.message=`Activating extension '${v.value}' failed: ${s}.`,s&&s.stack&&(u.stack=s.stack),this._isDisposed&&d.isCancellationError(s)?new l(s):(this._host.onExtensionActivationError(v,u,null),this._logService.error(`Activating extension ${v.value} failed due to an error:`),this._logService.error(s),new l(s))}).then(s=>{this._activatedExtensions.set(R,s),this._activatingExtensions.delete(R)});return this._activatingExtensions.set(R,h),h}};b=je([ze(4,C.ILogService)],b),e.ExtensionsActivator=b}),define(ve[226],be([0,1,12,26,30]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends d.LogService{constructor(k,D){super(k.createLogger(D.logFile,{name:I.ExtensionHostLogFileName}))}};C=je([ze(0,d.ILoggerService),ze(1,t.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ve[227],be([0,1,16]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,A)=>{this._actualOk=C,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,d.onUnexpectedError)(C))}then(C,A){return this._ensureActual().then(C,A)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=t}),define(ve[52],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const t=[];function I(k){const D=new d(k);return t[D.nid]=D,D}e.createProxyIdentifier=I;function C(k){return t[k].sid}e.getStringIdentifierForProxy=C;class A{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=A}),define(ve[5],be([0,1,59,2,52]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var A;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));class l{static mixin(h){return h._id=l._n++,h}}e.IdObject=l,l._n=0;var b;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.command="m",p.kindModifier="n"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(p){p[p.File=1]="File",p[p.Text=2]="Text",p[p.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(p){if(p&&p.edits)for(const h of p.edits)typeof h.resource=="object"?h.resource=t.URI.revive(h.resource):(h.newUri=t.URI.revive(h.newUri),h.oldUri=t.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,d.revive)(h.metadata));return p}e.reviveWorkspaceEditDto=_;var R;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(R=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[90],be([0,1,5,3,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(ve[65],be([0,1,4,12,5,14]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,P,F){const y=this.getUsageKey(D,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};A=je([ze(0,C.IExtHostRpcService),ze(1,t.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(ve[228],be([0,1,3,5,7,27]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,P,F,y={}){const l=C.ExtensionIdentifier.toKey(D.identifier),b=this._inFlightRequests.get(l)||[],g=[...F].sort().join(" ");let v=b.find(_=>_.scopes===g);if(v)return v.result;{const _=this._getSession(D,l,P,F,y);v={scopes:g,result:_},b.push(v),this._inFlightRequests.set(l,b);try{await _}finally{const R=b.findIndex(p=>p.scopes===g);R>-1&&(b.splice(R),this._inFlightRequests.set(l,b))}return _}}async _getSession(D,P,F,y,l={}){await this._proxy.$ensureProvider(F);const b=D.displayName||D.name;return this._proxy.$getSession(F,y,P,b,l)}async removeSession(D,P){const F=this._authenticationProviders.get(D);return F?F.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,F,y){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:F,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===D)||this._providers.push({id:D,label:P});const l=F.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(D,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,P,y?.supportsMultipleAccounts??!1),new I.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(D);const b=this._providers.findIndex(g=>g.id===D);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(ve[229],be([0,1,5,14,15]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=I.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};C=je([ze(0,t.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(ve[230],be([0,1,5]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(C){const A=C.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(k){return A.$writeText(k)}})}}e.ExtHostClipboard=t});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[38],be([0,1,18,7,15,25,5,17,12,59,41,48,2,6,4,14,63,22,52,49]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(o,c){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,it(this,s,o.getProxy(A.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new r(this,m=>{const f=this._apiCommands.get(m);return f?.result===a.Void?f:void 0},c),this._argumentProcessors=[{processArgument(m){return(0,P.revive)(m)}},{processArgument(m){return(0,C.cloneAndChange)(m,function(f){if(F.Range.isIRange(f))return I.Range.to(f);if(y.Position.isIPosition(f))return I.Position.to(f);if(F.Range.isIRange(f.range)&&l.URI.isUri(f.uri))return I.location.to(f);if(f instanceof R.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const c=this.registerCommand(!1,o.id,async(...m)=>{const f=o.args.map((T,L)=>{if(!T.validate(m[L]))throw new Error(`Invalid argument '${T.name}' when running '${o.id}', received: ${m[L]}`);return T.convert(m[L])}),w=await this.executeCommand(o.internalId,...f);return o.result.convert(w,m,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,c,m,f,w,T){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:m,thisArg:f,description:w,extension:T}),o&&Fe(this,s,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&o&&Fe(this,s,"f").$unregisterCommand(c)})}executeCommand(o,...c){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,c,!0)}async _doExecuteCommand(o,c,m){if(this._commands.has(o))return this._executeContributedCommand(o,c,!1);{let f=!1;const w=(0,C.cloneAndChange)(c,function(T){if(T instanceof t.Position)return I.Position.from(T);if(T instanceof t.Range)return I.Range.from(T);if(T instanceof t.Location)return I.location.from(T);if(t.NotebookRange.isNotebookRange(T))return I.NotebookRange.from(T);if(T instanceof ArrayBuffer)return f=!0,R.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return f=!0,R.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await Fe(this,s,"f").$executeCommand(o,f?new p.SerializableObjectWithBuffers(w):w,m);return(0,P.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(o,c,!1);throw T}}}async _executeContributedCommand(o,c,m){const f=this._commands.get(o);if(!f)throw new Error("Unknown command");let{callback:w,thisArg:T,description:L}=f;if(L)for(let O=0;O<L.args.length;O++)try{(0,d.validateConstraint)(c[O],L.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${L.args[O].name}' - ${L.args[O].description}`)}try{return await w.apply(T,c)}catch(O){if(o===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...c);E&&(o=E.command)}throw this._logService.error(O,o,f.extension?.identifier),m?new class extends Error{constructor(){super((0,h.toErrorMessage)(O));this.id=o,this.source=f.extension?.displayName??f.extension?.name}}:O}}$executeContributedCommand(o,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(c=c.map(m=>this._argumentProcessors.reduce((f,w)=>w.processArgument(f),m)),this._executeContributedCommand(o,c,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Fe(this,s,"f").$getCommands().then(c=>(o&&(c=c.filter(m=>m[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[c,m]of this._commands){let{description:f}=m;f&&(o[c]=f)}return Promise.resolve(o)}};s=new WeakMap,u=je([ze(0,v.IExtHostRpcService),ze(1,D.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class r{constructor(o,c,m){this._commands=o,this._lookupApiCommand=c,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,c){if(!o)return;const m={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return m;const f=this._lookupApiCommand(o.command);if(f)m.id=f.internalId,m.arguments=f.args.map((w,T)=>w.convert(o.arguments&&o.arguments[T]));else if((0,k.isNonEmptyArray)(o.arguments)){const w=++this._cachIdPool;this._cache.set(w,o),c.add((0,b.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),m.$ident=w,m.id=this.delegatingCommandId,m.arguments=[w],this._logService.trace("CommandsConverter#CREATE",o.command,w)}return m}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const c=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=r;class S{constructor(o,c,m,f){this.name=o,this.description=c,this.validate=m,this.convert=f}optional(){return new S(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,c){return new S(o??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",n=>l.URI.isUri(n),n=>n),S.Position=new S("position","A position in a text document",n=>t.Position.isPosition(n),I.Position.from),S.Range=new S("range","A range in a text document",n=>t.Range.isRange(n),I.Range.from),S.Selection=new S("selection","A selection in a text document",n=>t.Selection.isSelection(n),I.Selection.from),S.Number=new S("number","",n=>typeof n=="number",n=>n),S.String=new S("string","",n=>typeof n=="string",n=>n),S.CallHierarchyItem=new S("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",n=>n instanceof _.TestItemImpl,I.TestItem.from);class a{constructor(o,c){this.description=o,this.convert=c}}e.ApiCommandResult=a,a.Void=new a("no result",n=>n);class i{constructor(o,c,m,f,w){this.id=o,this.internalId=c,this.description=m,this.args=f,this.result=w}}e.ApiCommand=i}),define(ve[231],be([0,1,15,7,83,38,17,112]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(d.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,b)=>{if((0,A.isFalsyOrEmpty)(l))return;class g extends t.SymbolInformation{static to(_){const R=new g(_.name,d.SymbolKind.to(_.kind),_.containerName||"",new t.Location(b[0],d.Range.to(_.range)));return R.detail=_.detail,R.range=R.location.range,R.selectionRange=d.Range.to(_.selectionRange),R.children=_.children?_.children.map(g.to):[],R}}return l.map(g.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(d.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(d.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(d.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(d.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(d.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(b=>t.Position.isPosition(b)),l=>l.map(d.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(b=>{let g;for(const v of b.reverse())g=new t.SelectionRange(d.Range.to(v),g);return g}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(d.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(d.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(d.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(d.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:d.Range.to(l.range),placeholder:l.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return d.WorkspaceEdit.to(l)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(d.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,k.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,k.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,b,g)=>{if(!l)return new t.CompletionList([]);const v=l.suggestions.map(_=>d.CompletionItem.to(_,g));return new t.CompletionList(v,l.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return d.SignatureHelp.to(l)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,b,g)=>F(v=>new t.CodeLens(d.Range.to(v.range),v.command&&g.fromInternal(v.command)))(l))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>t.Range.isRange(l),l=>t.Selection.isSelection(l)?d.Selection.from(l):d.Range.from(l)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,b,g)=>F(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(v.command)}else{const _=new t.CodeAction(v.title,v.kind?new t.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=d.WorkspaceEdit.to(v.edit)),v.command&&(_.command=g.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(l))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(b=>new t.ColorInformation(d.Range.to(b.range),d.Color.to(b.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",l=>l instanceof t.Color,d.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:d.Range.from(l.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(d.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,b,g)=>l.map(d.InlayHint.to.bind(void 0,g)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(b=>d.NotebookExclusiveDocumentPattern.to(b))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(d.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[d.ViewColumn.from(l),void 0]:[d.ViewColumn.from(l.viewColumn),d.TextEditorOpenOptions.from(l)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[d.ViewColumn.from(l),void 0]:[d.ViewColumn.from(l.viewColumn),d.TextEditorOpenOptions.from(l)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[d.ViewColumn.from(l.viewColumn),d.TextEditorOpenOptions.from(l)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(d.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(d.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(d.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class P{static register(b){D.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=P;function F(l){return b=>{if(Array.isArray(b))return b.map(l)}}function y(l){if(!Array.isArray(l))return;const b=[];for(const g of l)I.isLocationLink(g)?b.push(d.DefinitionLink.to(g)):b.push(d.location.to(g));return b}}),define(ve[232],be([0,1,13,56,3,6,2,83,27,15,7,30,5]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(g,v,_){const R=g.getProxy(l.MainContext.MainThreadComments);class p{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,v.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const o=this._commentControllers.get(n.handle);return o||n}else if(n&&n.$mid===7){const o=this._commentControllers.get(n.commentControlHandle);if(!o)return n;const c=o.getCommentThread(n.commentThreadHandle);return c||n}else if(n&&n.$mid===8){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const c=o.getCommentThread(n.thread.commentThreadHandle);return c?{thread:c,text:n.text}:n}else if(n&&n.$mid===9){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const c=o.getCommentThread(n.thread.commentThreadHandle);if(!c)return n;let m=n.commentUniqueId,f=c.getCommentByUniqueId(m);return f||n}else if(n&&n.$mid===10){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const c=o.getCommentThread(n.thread.commentThreadHandle);if(!c)return n;let m=n.text,f=n.commentUniqueId,w=c.getCommentByUniqueId(f);return w?(w.body=m,w):n}return n}})}createCommentController(n,o,c){const m=p.handlePool++,f=new s(n,m,o,c);this._commentControllers.set(f.handle,f);const w=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(n.identifier))||[];return w.push(f),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(n.identifier),w),f.value}$createCommentThreadTemplate(n,o,c){const m=this._commentControllers.get(n);!m||m.$createCommentThreadTemplate(o,c)}async $updateCommentThreadTemplate(n,o,c){const m=this._commentControllers.get(n);!m||m.$updateCommentThreadTemplate(o,c)}$deleteCommentThread(n,o){const c=this._commentControllers.get(n);c&&c.$deleteCommentThread(o)}$provideCommentingRanges(n,o,c){const m=this._commentControllers.get(n);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const f=_.getDocument(A.URI.revive(o));return(0,d.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(f,c)).then(w=>w?w.map(T=>P.Range.from(T)):void 0)}$toggleReaction(n,o,c,m,f){const w=this._commentControllers.get(n);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const T=w.getCommentThread(o);if(T){const L=T.getCommentByUniqueId(m.uniqueIdInThread);if(w!==void 0&&L&&w.reactionHandler)return w.reactionHandler(L,S(f))}return Promise.resolve(void 0)})}dispose(){}}p.handlePool=0;class h{constructor(n,o,c,m,f,w,T){this._commentControllerHandle=o,this._id=c,this._uri=m,this._range=f,this._comments=w,this.extensionDescription=T,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),R.$createCommentThread(o,this.handle,this._id,this._uri,P.Range.from(this._range),T.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this._localDisposables.push({dispose:()=>{R.$deleteCommentThread(o,this.handle)}});const L=this;this.value={get uri(){return L.uri},get range(){return L.range},set range(O){L.range=O},get comments(){return L.comments},set comments(O){L.comments=O},get collapsibleState(){return L.collapsibleState},set collapsibleState(O){L.collapsibleState=O},get canReply(){return L.canReply},set canReply(O){L.canReply=O},get contextValue(){return L.contextValue},set contextValue(O){L.contextValue=O},get label(){return L.label},set label(O){L.label=O},dispose:()=>{L.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const n=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),o={};n("range")&&(o.range=P.Range.from(this._range)),n("label")&&(o.label=this.label),n("contextValue")&&(o.contextValue=this.contextValue??null),n("comments")&&(o.comments=this._comments.map(c=>u(this,c,this._commentsMap))),n("collapsibleState")&&(o.collapseState=a(this._collapseState)),n("canReply")&&(o.canReply=this.canReply),this.modifications={},R.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(n){for(let o of this._commentsMap){let c=o[0],m=o[1];if(n===m)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}h._handlePool=0,je([(0,t.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(n,o,c,m){this._extension=n,this._handle=o,this._id=c,this._label=m,this._threads=new Map,R.$registerCommentController(this.handle,c,m);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(w){f.options=w},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(w){f.commentingRangeProvider=w},get reactionHandler(){return f.reactionHandler},set reactionHandler(w){f.reactionHandler=w},createCommentThread(w,T,L){return f.createCommentThread(w,T,L).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{R.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,R.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,R.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,R.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,o,c,m){if(typeof n=="string"){const f=new h(this.id,this.handle,n,o,c,m,this._extension);return this._threads.set(f.handle,f),f}else{const f=new h(this.id,this.handle,void 0,n,o,c,this._extension);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(n,o){const c=new h(this.id,this.handle,void 0,A.URI.revive(n),P.Range.to(o),[],this._extension);return c.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(n,o){let c=this._threads.get(n);c&&(c.range=P.Range.to(o))}$deleteCommentThread(n){let o=this._threads.get(n);o&&o.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function u(i,n,o){let c=o.get(n);c||(c=++i.commentHandle,o.set(n,c));const m=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;n.timestamp&&(0,y.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let f;return n.timestamp&&(f={source:n.timestamp,$mid:14}),{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:c,body:typeof n.body=="string"?n.body:P.MarkdownString.from(n.body),userName:n.author.name,userIconPath:m,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>r(w)):void 0,timestamp:f}}function r(i){return{label:i.label,iconPath:i.iconPath?P.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function S(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?A.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function a(i){if(i!==void 0)switch(i){case F.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new p}e.createExtHostComments=b}),define(ve[132],be([0,1,2,5,7,4,14,12,17,8,9]),function(ee,e,d,t,I,C,A,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class yi{constructor(b,g){this._logService=g,this._provider=new Map,this._proxy=b.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,g){const v=yi._handlePool++;this._provider.set(v,{provider:b,extensionId:g}),this._proxy.$registerDecorationProvider(v,g.value);const _=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(R=>{if(!R){this._proxy.$onDidChange(v,null);return}let p=(0,D.asArray)(R);if(p.length<=yi._maxEventSize){this._proxy.$onDidChange(v,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,p.length);const h=p.map(r=>({uri:r,rank:(0,P.count)(r.path,"/")})),s=(0,D.groupBy)(h,(r,S)=>r.rank-S.rank||(0,P.compare)(r.uri.path,S.uri.path));let u=[];e:for(let r of s){let S;for(let a of r){let i=(0,F.dirname)(a.uri.path);if(S!==i&&(S=i,u.push(a.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(v,u)});return new I.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(b,g,v){if(!this._provider.has(b))return Object.create(null);const _=Object.create(null),{provider:R,extensionId:p}=this._provider.get(b);return await Promise.all(g.map(async h=>{try{const{uri:s,id:u}=h,r=await Promise.resolve(R.provideFileDecoration(d.URI.revive(s),v));if(!r)return;try{I.FileDecoration.validate(r),_[u]=[r.propagate,r.tooltip,r.badge,r.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${p.value}': ${S}`)}}catch(s){this._logService.error(s)}})),_}};y._handlePool=0,y._maxEventSize=250,y=je([ze(0,A.IExtHostRpcService),ze(1,k.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[233],be([0,1,166,117,2,5,7,15,3,12,24,44]),function(ee,e,d,t,I,C,A,k,D,P,F,y){"use strict";var l,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(p,h,s,u,r,S){this._name=p,this._owner=h,this._maxDiagnosticsPerFile=s,l.set(this,void 0),b.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,it(this,g,new F.ResourceMap(a=>u.getComparisonKey(a)),"f"),it(this,l,r,"f"),it(this,b,S,"f")}dispose(){this._isDisposed||(Fe(this,b,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,l,"f")&&Fe(this,l,"f").$clear(this._owner),Fe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,h){if(!p){this.clear();return}this._checkDisposed();let s=[];if(I.URI.isUri(p)){if(!h){this.delete(p);return}Fe(this,g,"f").set(p,h.slice()),s=[p]}else if(Array.isArray(p)){s=[];let r;p=[...p].sort(v._compareIndexedTuplesByUri);for(const S of p){const[a,i]=S;if((!r||a.toString()!==r.toString())&&(r&&Fe(this,g,"f").get(r).length===0&&Fe(this,g,"f").delete(r),r=a,s.push(a),Fe(this,g,"f").set(a,[])),i){const n=Fe(this,g,"f").get(a);n&&n.push(...i)}else{const n=Fe(this,g,"f").get(a);n&&(n.length=0)}}}if(Fe(this,b,"f").fire(s),!Fe(this,l,"f"))return;const u=[];for(let r of s){let S=[];const a=Fe(this,g,"f").get(r);if(a)if(a.length>this._maxDiagnosticsPerFile){S=[];const i=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let o of a)if(o.severity===i[n]&&S.push(k.Diagnostic.from(o))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,d.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=a.map(i=>k.Diagnostic.from(i));u.push([r,S])}Fe(this,l,"f").$changeMany(this._owner,u)}delete(p){this._checkDisposed(),Fe(this,b,"f").fire([p]),Fe(this,g,"f").delete(p),Fe(this,l,"f")&&Fe(this,l,"f").$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Fe(this,b,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,g,"f").clear(),Fe(this,l,"f")&&Fe(this,l,"f").$clear(this._owner)}forEach(p,h){this._checkDisposed();for(let s of Fe(this,g,"f").keys())p.apply(h,[s,this.get(s),this])}get(p){this._checkDisposed();const h=Fe(this,g,"f").get(p);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Fe(this,g,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,h){return p[0].toString()<h[0].toString()?-1:p[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=v,l=new WeakMap,b=new WeakMap,g=new WeakMap;let _=class oi{constructor(p,h,s){this._logService=h,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=p.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(p){const h=new F.ResourceMap;for(const s of p)h.set(s,s);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(p,h){const{_collections:s,_proxy:u,_onDidChangeDiagnostics:r,_logService:S,_fileSystemInfoService:a}=this,i=new class{$changeMany(c,m){u.$changeMany(c,m),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,c,m.length===0?"CLEARING":m)}$clear(c){u.$clear(c),S.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,c)}dispose(){u.dispose()}};let n;if(!h)h="_generated_diagnostic_collection_name_#"+oi._idPool++,n=h;else if(!s.has(h))n=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do n=h+oi._idPool++;while(s.has(n))}return new class extends v{constructor(){super(h,n,oi._maxDiagnosticsPerFile,a.extUri,i,r);s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const h=new Map,s=[];for(const u of this._collections.values())u.forEach((r,S)=>{let a=h.get(r.toString());typeof a=="undefined"&&(a=s.length,h.set(r.toString(),a),s.push([r,[]])),s[a][1]=s[a][1].concat(...S)});return s}}_getDiagnostics(p){let h=[];for(let s of this._collections.values())s.has(p)&&(h=h.concat(s.get(p)));return h}$acceptMarkersChange(p){if(!this._mirrorCollection){const h="_generated_mirror",s=new v(h,h,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,s),this._mirrorCollection=s}for(const[h,s]of p)this._mirrorCollection.set(I.URI.revive(h),s.map(k.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=je([ze(1,P.ILogService),ze(2,y.IExtHostFileSystemInfo)],_),e.ExtHostDiagnostics=_}),define(ve[234],be([0,1,2,5]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(A){this._proxy=A.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(k=>k?k.map(D=>d.URI.revive(D)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(k=>k?d.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(ve[235],be([0,1,16,2,7,5,10,21,8]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,l,b){this._documentsAndEditors=l,this._logService=b,this._documentContentProviders=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,l){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const b=P._handlePool++;this._documentContentProviders.set(b,l),this._proxy.$registerTextContentProvider(b,y);let g;return typeof l.onDidChange=="function"&&(g=l.onDidChange(v=>{if(v.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(b,v).then(_=>{if(!_&&typeof _!="string")return;const R=this._documentsAndEditors.getDocument(v);if(!R)return;const p=(0,D.splitLines)(_);if(!R.equalLines(p))return this._proxy.$onVirtualDocumentChange(v,_)},d.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(y,l){const b=this._documentContentProviders.get(y);return b?Promise.resolve(b.provideTextDocumentContent(t.URI.revive(l),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ve[236],be([0,1,3,6,2,5,124,15,18,25,7]),function(ee,e,d,t,I,C,A,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(b,g){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const g=this._documentsAndEditors.getDocument(b);if(g)return g}getDocument(b){const g=this.getDocumentData(b);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this._documentsAndEditors.getDocument(b);if(g)return Promise.resolve(g);let v=this._documentLoader.get(b.toString());return v||(v=this._proxy.$tryOpenDocument(b).then(_=>{this._documentLoader.delete(b.toString());const R=I.URI.revive(_);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(R))},_=>(this._documentLoader.delete(b.toString()),Promise.reject(_))),this._documentLoader.set(b.toString(),v)),v}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(g=>I.URI.revive(g))}$acceptModelLanguageChanged(b,g){const v=I.URI.revive(b),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(g),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(b){const g=I.URI.revive(b),v=this._documentsAndEditors.getDocument(g);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(b,g){const v=I.URI.revive(b),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(g),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,g,v){const _=I.URI.revive(b),R=this._documentsAndEditors.getDocument(_);if(!R)throw new Error("unknown document");R._acceptIsDirty(v),R.onEvents(g);let p;g.isUndoing?p=F.TextDocumentChangeReason.Undo:g.isRedoing&&(p=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:R.document,contentChanges:g.changes.map(h=>({range:k.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:p}))}setWordDefinitionFor(b,g){(0,A.setWordDefinitionFor)(b,g)}}e.ExtHostDocuments=y}),define(ve[45],be([0,1,55,3,6,2,4,5,124,14,131,15,12,24,10,77,93]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class R{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(s,u){this._extHostRpc=s,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const u=[],r=[],S=[];if(s.removedDocuments)for(const a of s.removedDocuments){const i=C.URI.revive(a),n=this._documents.get(i);n?.unref()&&(this._documents.delete(i),u.push(n.value))}if(s.addedDocuments)for(const a of s.addedDocuments){const i=C.URI.revive(a.uri);let n=this._documents.get(i);if(n&&i.scheme!==g.Schemas.vscodeNotebookCell&&i.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);n||(n=new R(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(i,n),r.push(n.value)),n.ref()}if(s.removedEditors)for(const a of s.removedEditors){const i=this._editors.get(a);this._editors.delete(a),i&&S.push(i)}if(s.addedEditors)for(const a of s.addedEditors){const i=C.URI.revive(a.documentUri);d.ok(this._documents.has(i),`document '${i}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const n=this._documents.get(i).value,o=new F.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>n.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(c=>y.Range.to(c)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,o)}s.newActiveEditor!==void 0&&(d.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,I.dispose)(u),(0,I.dispose)(S),s.removedDocuments&&this._onDidRemoveDocuments.fire(u),s.addedDocuments&&this._onDidAddDocuments.fire(r),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return s?u:u?.value}allEditors(){return[...this._editors.values()]}};p=je([ze(0,P.IExtHostRpcService),ze(1,l.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[53],be([0,1,15,5,2,3,4,14,13]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let P=class{constructor(y){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let l=-1;this._tabs=y.map((g,v)=>(g.isActive&&(l=v),Object.freeze({label:g.label,viewColumn:d.ViewColumn.to(g.viewColumn),index:v,resource:I.URI.revive(g.resource),additionalResourcesAndViewIds:g.additionalResourcesAndViewIds.map(({resource:_,viewId:R})=>({resource:I.URI.revive(_),viewId:R})),viewId:g.editorId,isActive:g.isActive,move:async(_,R)=>{this._proxy.$moveTab(g,_,d.ViewColumn.from(R)),await(0,D.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(g),await(0,D.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((g,v)=>g.viewColumn===v.viewColumn?g.index-v.index:g.viewColumn-v.viewColumn);const b=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==b&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=je([ze(0,k.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(ve[237],be([0,1,2,5,6,7,15,149,8,22,30]),function(ee,e,d,t,I,C,A,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const v=this._schemes.indexOf(g);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),v=[];let _,R,p=14,h=14;for(const s of g){let u=_?(0,D.commonPrefixLength)(_,s):0;for(u===0?R=1:R=h;u<s.length;u++)u+1===s.length?(p=h,h=9):h+=1,v.push([R,s.toUpperCase().charCodeAt(u),h]),v.push([R,s.toLowerCase().charCodeAt(u),h]),R=h;_=s,h=p}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new k.StateMachine(v)}}provideDocumentLinks(g){this._initStateMachine();const v=[],_=k.LinkComputer.computeLinks({getLineContent(R){return g.lineAt(R-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const R of _){const p=A.DocumentLink.to(R);p.target&&v.push(p)}return v}}class l{constructor(g,v){this._extHostLanguageFeatures=v,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,v,_,R={}){if(this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const p=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(p,_);let h=2;R.isCaseSensitive&&(h+=1024),R.isReadonly&&(h+=2048),typeof _.copy=="function"&&(h+=8),typeof _.open=="function"&&typeof _.close=="function"&&typeof _.read=="function"&&typeof _.write=="function"&&((0,F.checkProposedApiEnabled)(g,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(p,v,h).catch(u=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${v}`),console.error(u)});const s=_.onDidChangeFile(u=>{const r=[];for(const S of u){let{uri:a,type:i}=S;if(a.scheme!==v)continue;let n;switch(i){case C.FileChangeType.Changed:n=0;break;case C.FileChangeType.Created:n=1;break;case C.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:a,type:n})}this._proxy.$onFileSystemChange(p,r)});return(0,I.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(g){const{type:v,ctime:_,mtime:R,size:p,permissions:h}=g;return{type:v,ctime:_,mtime:R,size:p,permissions:h}}$stat(g,v){return Promise.resolve(this._getFsProvider(g).stat(d.URI.revive(v))).then(_=>l._asIStat(_))}$readdir(g,v){return Promise.resolve(this._getFsProvider(g).readDirectory(d.URI.revive(v)))}$readFile(g,v){return Promise.resolve(this._getFsProvider(g).readFile(d.URI.revive(v))).then(_=>P.VSBuffer.wrap(_))}$writeFile(g,v,_,R){return Promise.resolve(this._getFsProvider(g).writeFile(d.URI.revive(v),_.buffer,R))}$delete(g,v,_){return Promise.resolve(this._getFsProvider(g).delete(d.URI.revive(v),_))}$rename(g,v,_,R){return Promise.resolve(this._getFsProvider(g).rename(d.URI.revive(v),d.URI.revive(_),R))}$copy(g,v,_,R){const p=this._getFsProvider(g);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(d.URI.revive(v),d.URI.revive(_),R))}$mkdir(g,v){return Promise.resolve(this._getFsProvider(g).createDirectory(d.URI.revive(v)))}$watch(g,v,_,R){const p=this._getFsProvider(g).watch(d.URI.revive(_),R);this._watches.set(v,p)}$unwatch(g,v){const _=this._watches.get(v);_&&(_.dispose(),this._watches.delete(v))}$open(g,v,_){const R=this._getFsProvider(g);if(!R.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(R.open(d.URI.revive(v),_))}$close(g,v){const _=this._getFsProvider(g);if(!_.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(_.close(v))}$read(g,v,_,R){const p=this._getFsProvider(g);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const h=P.VSBuffer.alloc(R);return Promise.resolve(p.read(v,_,h.buffer,0,R)).then(s=>h.slice(0,s))}$write(g,v,_,R){const p=this._getFsProvider(g);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(v,_,R.buffer,0,R.byteLength))}_getFsProvider(g){const v=this._fsProvider.get(g);if(!v){const _=new Error;throw _.name="ENOPRO",_.message="no provider",_}return v}}e.ExtHostFileSystem=l}),define(ve[66],be([0,1,5,42,7,22,4,14,44,6]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class jt{constructor(l,b){this._fileSystemProvider=new Map,this._proxy=l.getProxy(d.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(v){try{const _=g._fileSystemProvider.get(v.scheme);if(!_)return await g._proxy.$stat(v);await g._proxy.$ensureActivation(v.scheme);const R=await _.stat(v);return{type:R.type,ctime:R.ctime,mtime:R.mtime,size:R.size,permissions:R.permissions}}catch(_){jt._handleError(_)}},async readDirectory(v){try{const _=g._fileSystemProvider.get(v.scheme);return _?(await g._proxy.$ensureActivation(v.scheme),(await _.readDirectory(v)).slice()):await g._proxy.$readdir(v)}catch(_){return jt._handleError(_)}},async createDirectory(v){try{return await g._proxy.$mkdir(v)}catch(_){return jt._handleError(_)}},async readFile(v){try{const _=g._fileSystemProvider.get(v.scheme);return _?(await g._proxy.$ensureActivation(v.scheme),(await _.readFile(v)).slice()):(await g._proxy.$readFile(v)).buffer}catch(_){return jt._handleError(_)}},async writeFile(v,_){try{return await g._proxy.$writeFile(v,C.VSBuffer.wrap(_))}catch(R){return jt._handleError(R)}},async delete(v,_){try{const R=g._fileSystemProvider.get(v.scheme);return R?(await g._proxy.$ensureActivation(v.scheme),await R.delete(v,{recursive:!1,..._})):await g._proxy.$delete(v,{recursive:!1,useTrash:!1,..._})}catch(R){return jt._handleError(R)}},async rename(v,_,R){try{return await g._proxy.$rename(v,_,{overwrite:!1,...R})}catch(p){return jt._handleError(p)}},async copy(v,_,R){try{return await g._proxy.$copy(v,_,{overwrite:!1,...R})}catch(p){return jt._handleError(p)}},isWritableFileSystem(v){const _=b.getCapabilities(v);if(typeof _=="number")return!(_&2048)}})}static _handleError(l){if(l instanceof I.FileSystemError)throw l;if(!(l instanceof Error))throw new I.FileSystemError(String(l));if(l.name==="ENOPRO")throw I.FileSystemError.Unavailable(l.message);switch(l.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(l.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(l.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(l.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(l.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(l.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(l.message);default:throw new I.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,b){return this._fileSystemProvider.set(l,b),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(l))}};F=je([ze(0,k.IExtHostRpcService),ze(1,D.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],be([0,1,3,32,2,5,15,7]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(y,l,b,g,v,_,R,p){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter;const h=this.ensureWatching(y,b,v);this._config=0,_&&(this._config+=1),R&&(this._config+=2),p&&(this._config+=4);const s=(0,t.parse)(v),u=typeof v=="string",r=g(S=>{if(!_)for(let a of S.created){const i=I.URI.revive(a);s(i.fsPath)&&(!u||l.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!R)for(let a of S.changed){const i=I.URI.revive(a);s(i.fsPath)&&(!u||l.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!p)for(let a of S.deleted){const i=I.URI.revive(a);s(i.fsPath)&&(!u||l.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(h,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(y,l,b){let g=k.Disposable.from();if(typeof b=="string")return g;const v=y.getProxy(C.MainContext.MainThreadFileSystem);let _=!1;(b.pattern.includes(t.GLOBSTAR)||b.pattern.includes(t.GLOB_SPLIT))&&(_=!0);const R=Math.random();return v.$watch(l.identifier.value,R,b.baseUri,{recursive:_,excludes:[]}),k.Disposable.from({dispose:()=>v.$unwatch(R)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(y,l,b){this._mainContext=y,this._logService=l,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,l,b,g,v,_){return new D(this._mainContext,y,l,this._onFileSystemEvent.event,A.GlobPattern.from(b),g,v,_)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,l){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(b=>I.URI.revive(b.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,l){return(b,g,v)=>{const _=function(p){b.call(g,p)};return _.extension=y,l.event(_,void 0,v)}}async $onWillRunFileOperation(y,l,b,g){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(v=>({oldUri:I.URI.revive(v.source),newUri:I.URI.revive(v.target)}))},b,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(v=>I.URI.revive(v.target))},b,g);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(v=>I.URI.revive(v.target))},b,g)}}async _fireWillEvent(y,l,b,g){const v=new Set,_=[];if(await y.fireAsync(l,g,async(p,h)=>{const s=Date.now(),u=await Promise.resolve(p);u instanceof k.WorkspaceEdit&&(_.push(u),v.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-s>b&&this._logService.warn("SLOW file-participant",h.extension.identifier)}),g.isCancellationRequested||_.length===0)return;const R={edits:[]};for(let p of _){let{edits:h}=A.WorkspaceEdit.from(p,this._extHostDocumentsAndEditors);R.edits=R.edits.concat(h)}return{edit:R,extensionNames:Array.from(v)}}}e.ExtHostFileSystemEventService=P}),define(ve[239],be([0,1,2,38]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(A,k,D,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=D,this._commands=P;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new t.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new t.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new t.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new t.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:d.URI.revive(y.notebookUri),inputUri:d.URI.revive(y.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:d.URI.revive(y.notebookUri),inputUri:d.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(A,k,D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=I}),define(ve[240],be([0,1,6,5]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(A){this._handlePool=0,this._proxy=A.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,A),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(ve[241],be([0,1,2,25,15,7,5,8,41,17,18,145,21,6,112,76,87,46,16,3,13]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(q,ie){this._documents=q,this._provider=ie}async provideDocumentSymbols(q,ie){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentSymbols(G,ie);if(!(0,P.isFalsyOrEmpty)(X))return X[0]instanceof C.DocumentSymbol?X.map(I.DocumentSymbol.from):u._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((X,ae)=>{let me=X.location.range.start.compareTo(ae.location.range.start);return me===0&&(me=ae.location.range.end.compareTo(X.location.range.end)),me});const ie=[],G=[];for(const X of q){const ae={name:X.name||"!!MISSING: name!!",kind:I.SymbolKind.from(X.kind),tags:X.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:I.Range.from(X.location.range),selectionRange:I.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(ae),ie.push(ae);break}const me=G[G.length-1];if(D.Range.containsRange(me.range,ae.range)&&!D.Range.equalsRange(me.range,ae.range)){me.children&&me.children.push(ae),G.push(ae);break}G.pop()}}return ie}}class r{constructor(q,ie,G){this._documents=q,this._commands=ie,this._provider=G,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,ie){const G=this._documents.getDocument(q),X=await this._provider.provideCodeLenses(G,ie);if(!X||ie.isCancellationRequested)return;const ae=this._cache.add(X),me=new b.DisposableStore;this._disposables.set(ae,me);const De={cacheId:ae,lenses:[]};for(let Be=0;Be<X.length;Be++)De.lenses.push({cacheId:[ae,Be],range:I.Range.from(X[Be].range),command:this._commands.toInternal(X[Be].command,me)});return De}async resolveCodeLens(q,ie){const G=q.cacheId&&this._cache.get(...q.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,ie),X||(X=G),ie.isCancellationRequested)return;const ae=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!ae)return q.command=this._commands.toInternal(X.command??r._badCmd,ae),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Qe){return Array.isArray(Qe)?Qe.map(I.DefinitionLink.from):Qe?[I.DefinitionLink.from(Qe)]:[]}class a{constructor(q,ie){this._documents=q,this._provider=ie}async provideDefinition(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideDefinition(X,ae,G);return S(me)}}class i{constructor(q,ie){this._documents=q,this._provider=ie}async provideDeclaration(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideDeclaration(X,ae,G);return S(me)}}class n{constructor(q,ie){this._documents=q,this._provider=ie}async provideImplementation(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideImplementation(X,ae,G);return S(me)}}class o{constructor(q,ie){this._documents=q,this._provider=ie}async provideTypeDefinition(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideTypeDefinition(X,ae,G);return S(me)}}class c{constructor(q,ie){this._documents=q,this._provider=ie}async provideHover(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideHover(X,ae,G);if(!(!me||(0,P.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=X.getWordRangeAtPosition(ae)),me.range||(me.range=new C.Range(ae,ae)),I.Hover.from(me)}}class m{constructor(q,ie){this._documents=q,this._provider=ie}async provideEvaluatableExpression(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideEvaluatableExpression(X,ae,G);if(me)return I.EvaluatableExpression.from(me)}}class f{constructor(q,ie){this._documents=q,this._provider=ie}async provideInlineValues(q,ie,G,X){const ae=this._documents.getDocument(q),me=await this._provider.provideInlineValues(ae,I.Range.to(ie),I.InlineValueContext.to(G),X);if(Array.isArray(me))return me.map(De=>I.InlineValue.from(De))}}class w{constructor(q,ie){this._documents=q,this._provider=ie}async provideDocumentHighlights(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideDocumentHighlights(X,ae,G);if(Array.isArray(me))return me.map(I.DocumentHighlight.from)}}class T{constructor(q,ie){this._documents=q,this._provider=ie}async provideLinkedEditingRanges(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.provideLinkedEditingRanges(X,ae,G);if(me&&Array.isArray(me.ranges))return{ranges:(0,P.coalesce)(me.ranges.map(I.Range.from)),wordPattern:me.wordPattern}}}class L{constructor(q,ie){this._documents=q,this._provider=ie}async provideReferences(q,ie,G,X){const ae=this._documents.getDocument(q),me=I.Position.to(ie),De=await this._provider.provideReferences(ae,me,G,X);if(Array.isArray(De))return De.map(I.location.from)}}class O{constructor(q,ie,G,X,ae,me,De){this._documents=q,this._commands=ie,this._diagnostics=G,this._provider=X,this._logService=ae,this._extension=me,this._apiDeprecation=De,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,ie,G,X){const ae=this._documents.getDocument(q),me=y.Selection.isISelection(ie)?I.Selection.to(ie):I.Range.to(ie),De=[];for(const et of this._diagnostics.getDiagnostics(q))if(me.intersection(et.range)&&De.push(et)>O._maxCodeActionsPerFile)break;const Be={diagnostics:De,only:G.only?new C.CodeActionKind(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},Xe=await this._provider.provideCodeActions(ae,me,Be,X);if(!(0,P.isNonEmptyArray)(Xe)||X.isCancellationRequested)return;const tt=this._cache.add(Xe),rt=new b.DisposableStore;this._disposables.set(tt,rt);const st=[];for(let et=0;et<Xe.length;et++){const nt=Xe[et];!nt||(O._isCommand(nt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:nt.title,command:this._commands.toInternal(nt,rt)})):(Be.only&&(nt.kind?Be.only.contains(nt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[tt,et],title:nt.title,command:nt.command&&this._commands.toInternal(nt.command,rt),diagnostics:nt.diagnostics&&nt.diagnostics.map(I.Diagnostic.from),edit:nt.edit&&I.WorkspaceEdit.from(nt.edit),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,disabled:nt.disabled?.reason})))}return{cacheId:tt,actions:st}}async resolveCodeAction(q,ie){const[G,X]=q,ae=this._cache.get(G,X);if(!ae||O._isCommand(ae)||!this._provider.resolveCodeAction)return;const me=await this._provider.resolveCodeAction(ae,ie)??ae;return me?.edit?I.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}O._maxCodeActionsPerFile=1e3;class E{constructor(q,ie){this._documents=q,this._provider=ie}async provideDocumentFormattingEdits(q,ie,G){const X=this._documents.getDocument(q),ae=await this._provider.provideDocumentFormattingEdits(X,ie,G);if(Array.isArray(ae))return ae.map(I.TextEdit.from)}}class M{constructor(q,ie){this._documents=q,this._provider=ie}async provideDocumentRangeFormattingEdits(q,ie,G,X){const ae=this._documents.getDocument(q),me=I.Range.to(ie),De=await this._provider.provideDocumentRangeFormattingEdits(ae,me,G,X);if(Array.isArray(De))return De.map(I.TextEdit.from)}}class U{constructor(q,ie){this._documents=q,this._provider=ie,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,ie,G,X,ae){const me=this._documents.getDocument(q),De=I.Position.to(ie),Be=await this._provider.provideOnTypeFormattingEdits(me,De,G,X,ae);if(Array.isArray(Be))return Be.map(I.TextEdit.from)}}class V{constructor(q,ie){this._provider=q,this._logService=ie,this._cache=new _.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(q,ie){const G=await this._provider.provideWorkspaceSymbols(q,ie);if(!(0,P.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),ae={cacheId:X,symbols:[]};for(let me=0;me<G.length;me++){const De=G[me];if(!De||!De.name){this._logService.warn("INVALID SymbolInformation",De);continue}ae.symbols.push({...I.WorkspaceSymbol.from(De),cacheId:[X,me]})}return ae}async resolveWorkspaceSymbol(q,ie){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const G=this._cache.get(...q.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,ie);return X&&(0,t.mixin)(q,I.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(q){this._cache.delete(q)}}class z{constructor(q,ie,G){this._documents=q,this._provider=ie,this._logService=G}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,ie,G,X){const ae=this._documents.getDocument(q),me=I.Position.to(ie);try{const De=await this._provider.provideRenameEdits(ae,me,G,X);return De?I.WorkspaceEdit.from(De):void 0}catch(De){const Be=z._asMessage(De);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(De)}}async resolveRenameLocation(q,ie,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(q),ae=I.Position.to(ie);try{const me=await this._provider.prepareRename(X,ae,G);let De,Be;if(C.Range.isRange(me)?(De=me,Be=X.getText(me)):(0,F.isObject)(me)&&(De=me.range,Be=me.placeholder),!De||!Be)return;if(De.start.line>ae.line||De.end.line<ae.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(De),text:Be}}catch(me){const De=z._asMessage(me);return De?{rejectReason:De,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class N{constructor(q,ie){this.resultId=q,this.tokens=ie}}class W{constructor(q,ie){this._documents=q,this._provider=ie,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,ie,G){const X=this._documents.getDocument(q),ae=ie!==0?this._previousResults.get(ie):null;let me=typeof ae?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,ae.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return ae&&this._previousResults.delete(ie),me?(me=W._fixProvidedSemanticTokens(me),this._send(W._convertToEdits(ae,me),me)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return W._isSemanticTokens(q)?W._isCorrectSemanticTokens(q)?q:new C.SemanticTokens(new Uint32Array(q.data),q.resultId):W._isSemanticTokensEdits(q)?W._isCorrectSemanticTokensEdits(q)?q:new C.SemanticTokensEdits(q.edits.map(ie=>new C.SemanticTokensEdit(ie.start,ie.deleteCount,ie.data?new Uint32Array(ie.data):ie.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const ie of q.edits)if(!(ie.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,ie){if(!W._isSemanticTokens(ie)||!q||!q.tokens)return ie;const G=q.tokens,X=G.length,ae=ie.data,me=ae.length;let De=0;const Be=Math.min(X,me);for(;De<Be&&G[De]===ae[De];)De++;if(De===X&&De===me)return new C.SemanticTokensEdits([],ie.resultId);let Xe=0;const tt=Be-De;for(;Xe<tt&&G[X-Xe-1]===ae[me-Xe-1];)Xe++;return new C.SemanticTokensEdits([{start:De,deleteCount:X-De-Xe,data:ae.subarray(De,me-Xe)}],ie.resultId)}_send(q,ie){if(W._isSemanticTokens(q)){const G=this._nextResultId++;return this._previousResults.set(G,new N(q.resultId,q.data)),(0,g.encodeSemanticTokensDto)({id:G,type:"full",data:q.data})}if(W._isSemanticTokensEdits(q)){const G=this._nextResultId++;return W._isSemanticTokens(ie)?this._previousResults.set(G,new N(ie.resultId,ie.data)):this._previousResults.set(G,new N(q.resultId)),(0,g.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(q.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class B{constructor(q,ie){this._documents=q,this._provider=ie}async provideDocumentRangeSemanticTokens(q,ie,G){const X=this._documents.getDocument(q),ae=await this._provider.provideDocumentRangeSemanticTokens(X,I.Range.to(ie),G);return ae?this._send(ae):null}_send(q){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=B;class x{constructor(q,ie,G,X,ae){this._documents=q,this._commands=ie,this._provider=G,this._apiDeprecation=X,this._extension=ae,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,ie,G,X){const ae=this._documents.getDocument(q),me=I.Position.to(ie),De=ae.getWordRangeAtPosition(me)||new C.Range(me,me),Be=De.with({end:me}),Xe=new R.StopWatch(!0),tt=await this._provider.provideCompletionItems(ae,me,X,I.CompletionContext.to(G));if(!tt||X.isCancellationRequested)return;const rt=Array.isArray(tt)?new C.CompletionList(tt):tt,st=x.supportsResolving(this._provider)?this._cache.add(rt.items):this._cache.add([]),et=new b.DisposableStore;this._disposables.set(st,et);const nt=[],gt={x:st,b:nt,a:{replace:I.Range.from(De),insert:I.Range.from(Be)},c:rt.isIncomplete||void 0,d:Xe.elapsed()};for(let It=0;It<rt.items.length;It++){const Ne=rt.items[It],Dt=this._convertCompletionItem(Ne,[st,It],Be,De);nt.push(Dt)}return gt}async resolveCompletionItem(q,ie){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveCompletionItem(G,ie);if(!!X)return this._convertCompletionItem(X,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,ie,G,X){const ae=this._disposables.get(ie[0]);if(!ae)throw Error("DisposableStore is missing...");const me={x:ie,a:q.label,b:q.kind!==void 0?I.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(I.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(q.command,ae)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=q.textEdit.newText):typeof q.insertText=="string"?me.h=q.insertText:q.insertText instanceof C.SnippetString&&(me.h=q.insertText.value,me.i|=4);let De;return q.textEdit?De=q.textEdit.range:q.range&&(De=q.range),C.Range.isRange(De)?me.j=I.Range.from(De):De&&(!G?.isEqual(De.inserting)||!X?.isEqual(De.replacing))&&(me.j={insert:I.Range.from(De.inserting),replace:I.Range.from(De.replacing)}),me}}class ${constructor(q,ie,G){this._documents=q,this._provider=ie,this._commands=G,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,ie,G,X){const ae=this._documents.getDocument(q),me=I.Position.to(ie),De=await this._provider.provideInlineCompletionItems(ae,me,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text,isSnippetText:G.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(G.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:G.triggerKind},X);if(!De||X.isCancellationRequested)return;const Be=(0,F.isArray)(De)?{items:De}:De,Xe=this._cache.add(Be.items);let tt;return{pid:Xe,items:Be.items.map((rt,st)=>{let et;return rt.command&&(tt||(tt=new b.DisposableStore,this._disposables.set(Xe,tt)),et=this._commands.toInternal(rt.command,tt)),{text:rt.text,range:rt.range?I.Range.from(rt.range):void 0,command:et,idx:st}})}}disposeCompletions(q){this._cache.delete(q);const ie=this._disposables.get(q);ie&&ie.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,ie){const G=this._cache.get(q,ie);G&&J.get(this._provider).fireOnDidShowCompletionItem({completionItem:G})}}class J{constructor(){this._onDidShowCompletionItemEmitter=new h.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let ie=J.map.get(q);return ie||(ie=new J,J.map.set(q,ie)),ie}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=J,J.map=new WeakMap;class ne{constructor(q,ie){this._documents=q,this._provider=ie,this._cache=new _.Cache("SignatureHelp")}async provideSignatureHelp(q,ie,G,X){const ae=this._documents.getDocument(q),me=I.Position.to(ie),De=this.reviveContext(G),Be=await this._provider.provideSignatureHelp(ae,me,X,De);if(Be){const Xe=this._cache.add([Be]);return{...I.SignatureHelp.from(Be),id:Xe}}}reviveContext(q){let ie;if(q.activeSignatureHelp){const G=I.SignatureHelp.to(q.activeSignatureHelp),X=this._cache.get(q.activeSignatureHelp.id,0);X?(ie=X,ie.activeSignature=G.activeSignature,ie.activeParameter=G.activeParameter):ie=G}return{...q,activeSignatureHelp:ie}}releaseSignatureHelp(q){this._cache.delete(q)}}class re{constructor(q,ie,G,X,ae){this._documents=q,this._commands=ie,this._provider=G,this._logService=X,this._extension=ae,this._cache=new _.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(q,ie,G){const X=this._documents.getDocument(q),ae=I.Range.to(ie),me=await this._provider.provideInlayHints(X,ae,G);if(!Array.isArray(me)||me.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${ie}`);return}if(G.isCancellationRequested)return;const De=this._cache.add(me);this._disposables.set(De,new b.DisposableStore);const Be={hints:[],cacheId:De};for(let Xe=0;Xe<me.length;Xe++)this._isValidInlayHint(me[Xe],ae)&&Be.hints.push(this._convertInlayHint(me[Xe],[De,Xe]));return this._logService.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this._extension.identifier.value}' for ${ie}`),Be}async resolveInlayHint(q,ie){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveInlayHint(G,ie);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,q)}releaseHints(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_isValidInlayHint(q,ie){return q.label.length===0||Array.isArray(q.label)&&q.label.every(G=>G.label.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(ie&&!ie.contains(q.position))}_convertInlayHint(q,ie){const G=this._disposables.get(ie[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:ie,tooltip:q.tooltip&&I.MarkdownString.from(q.tooltip),position:I.Position.from(q.position),kind:I.InlayHintKind.from(q.kind??C.InlayHintKind.Other),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};return typeof q.label=="string"?X.label=q.label:X.label=q.label.map(ae=>{let me={label:ae.label};return me.tooltip=ae.tooltip&&I.MarkdownString.from(ae.tooltip),C.Location.isLocation(ae.location)&&(me.location=I.location.from(ae.location)),ae.command&&(me.command=this._commands.toInternal(ae.command,G)),me}),X}}class Z{constructor(q,ie){this._documents=q,this._provider=ie,this._cache=new _.Cache("DocumentLink")}async provideLinks(q,ie){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentLinks(G,ie);if(!(!Array.isArray(X)||X.length===0)&&!ie.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(Z._validateLink).map(I.DocumentLink.from)};{const ae=this._cache.add(X),me={links:[],cacheId:ae};for(let De=0;De<X.length;De++){if(!Z._validateLink(X[De]))continue;const Be=I.DocumentLink.from(X[De]);Be.cacheId=[ae,De],me.links.push(Be)}return me}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,ie){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveDocumentLink(G,ie);if(!(!X||!Z._validateLink(X)))return I.DocumentLink.from(X)}releaseLinks(q){this._cache.delete(q)}}class Q{constructor(q,ie){this._documents=q,this._provider=ie}async provideColors(q,ie){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentColors(G,ie);return Array.isArray(X)?X.map(me=>({color:I.Color.from(me.color),range:I.Range.from(me.range)})):[]}async provideColorPresentations(q,ie,G){const X=this._documents.getDocument(q),ae=I.Range.to(ie.range),me=I.Color.to(ie.color),De=await this._provider.provideColorPresentations(me,{document:X,range:ae},G);if(!!Array.isArray(De))return De.map(I.ColorPresentation.from)}}class oe{constructor(q,ie){this._documents=q,this._provider=ie}async provideFoldingRanges(q,ie,G){const X=this._documents.getDocument(q),ae=await this._provider.provideFoldingRanges(X,ie,G);if(!!Array.isArray(ae))return ae.map(I.FoldingRange.from)}}class fe{constructor(q,ie,G){this._documents=q,this._provider=ie,this._logService=G}async provideSelectionRanges(q,ie,G){const X=this._documents.getDocument(q),ae=ie.map(I.Position.to),me=await this._provider.provideSelectionRanges(X,ae,G);if(!(0,P.isNonEmptyArray)(me))return[];if(me.length!==ae.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const De=[];for(let Be=0;Be<ae.length;Be++){const Xe=[];De.push(Xe);let tt=ae[Be],rt=me[Be];for(;;){if(!rt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(I.SelectionRange.from(rt)),!rt.parent)break;tt=rt.range,rt=rt.parent}}return De}}class pe{constructor(q,ie){this._documents=q,this._provider=ie,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.prepareCallHierarchy(X,ae,G);if(!me)return;const De=this._idPool.nextId();return this._cache.set(De,new Map),Array.isArray(me)?me.map(Be=>this._cacheAndConvertItem(De,Be)):[this._cacheAndConvertItem(De,me)]}async provideCallsTo(q,ie,G){const X=this._itemFromCache(q,ie);if(!X)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!ae)return ae.map(me=>({from:this._cacheAndConvertItem(q,me.from),fromRanges:me.fromRanges.map(De=>I.Range.from(De))}))}async provideCallsFrom(q,ie,G){const X=this._itemFromCache(q,ie);if(!X)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!ae)return ae.map(me=>({to:this._cacheAndConvertItem(q,me.to),fromRanges:me.fromRanges.map(De=>I.Range.from(De))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,ie){const G=this._cache.get(q),X=I.CallHierarchyItem.from(ie,q,G.size.toString(36));return G.set(X._itemId,ie),X}_itemFromCache(q,ie){return this._cache.get(q)?.get(ie)}}class Te{constructor(q,ie){this._documents=q,this._provider=ie,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(q,ie,G){const X=this._documents.getDocument(q),ae=I.Position.to(ie),me=await this._provider.prepareTypeHierarchy(X,ae,G);if(!me)return;const De=this._idPool.nextId();return this._cache.set(De,new Map),Array.isArray(me)?me.map(Be=>this._cacheAndConvertItem(De,Be)):[this._cacheAndConvertItem(De,me)]}async provideSupertypes(q,ie,G){const X=this._itemFromCache(q,ie);if(!X)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!ae)return ae.map(me=>this._cacheAndConvertItem(q,me))}async provideSubtypes(q,ie,G){const X=this._itemFromCache(q,ie);if(!X)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!ae)return ae.map(me=>this._cacheAndConvertItem(q,me))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,ie){const G=this._cache.get(q),X=I.TypeHierarchyItem.from(ie,q,G.size.toString(36));return G.set(X._itemId,ie),X}_itemFromCache(q,ie){return this._cache.get(q)?.get(ie)}}class xe{constructor(q,ie){this.adapter=q,this.extension=ie}}class qe{constructor(q,ie,G,X,ae,me,De){this._adapter=new Map,this._uriTransformer=ie,this._proxy=q.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=ae,this._logService=me,this._apiDeprecation=De}_transformDocumentSelector(q){return I.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new C.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return qe._handlePool++}async _withAdapter(q,ie,G,X,ae){const me=this._adapter.get(q);if(!me||!(me.adapter instanceof ie))return X;const De=Date.now();this._logService.trace(`[${me.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Be=G(me.adapter,me.extension);return Promise.resolve(Be).catch(Xe=>{(0,p.isCancellationError)(Xe)||(this._logService.error(`[${me.extension.identifier.value}] provider FAILED`),this._logService.error(Xe))}).finally(()=>{this._logService.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),l.CancellationToken.isCancellationToken(ae)?(0,s.raceCancellationError)(Be,ae):Be}_addNewAdapter(q,ie){const G=this._nextHandle();return this._adapter.set(G,new xe(q,ie)),G}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,ie,G,X){const ae=this._addNewAdapter(new u(this._documents,G),q),me=X&&X.label||qe._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(ae,this._transformDocumentSelector(ie),me),this._createDisposable(ae)}$provideDocumentSymbols(q,ie,G){return this._withAdapter(q,u,X=>X.provideDocumentSymbols(d.URI.revive(ie),G),void 0,G)}registerCodeLensProvider(q,ie,G){const X=this._nextHandle(),ae=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new xe(new r(this._documents,this._commands.converter,G),q)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(ie),ae);let me=this._createDisposable(X);if(ae!==void 0){const De=G.onDidChangeCodeLenses(Be=>this._proxy.$emitCodeLensEvent(ae));me=C.Disposable.from(me,De)}return me}$provideCodeLenses(q,ie,G){return this._withAdapter(q,r,X=>X.provideCodeLenses(d.URI.revive(ie),G),void 0,void 0)}$resolveCodeLens(q,ie,G){return this._withAdapter(q,r,X=>X.resolveCodeLens(ie,G),void 0,void 0)}$releaseCodeLenses(q,ie){this._withAdapter(q,r,G=>Promise.resolve(G.releaseCodeLenses(ie)),void 0,void 0)}registerDefinitionProvider(q,ie,G){const X=this._addNewAdapter(new a(this._documents,G),q);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideDefinition(q,ie,G,X){return this._withAdapter(q,a,ae=>ae.provideDefinition(d.URI.revive(ie),G,X),[],X)}registerDeclarationProvider(q,ie,G){const X=this._addNewAdapter(new i(this._documents,G),q);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideDeclaration(q,ie,G,X){return this._withAdapter(q,i,ae=>ae.provideDeclaration(d.URI.revive(ie),G,X),[],X)}registerImplementationProvider(q,ie,G){const X=this._addNewAdapter(new n(this._documents,G),q);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideImplementation(q,ie,G,X){return this._withAdapter(q,n,ae=>ae.provideImplementation(d.URI.revive(ie),G,X),[],X)}registerTypeDefinitionProvider(q,ie,G){const X=this._addNewAdapter(new o(this._documents,G),q);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideTypeDefinition(q,ie,G,X){return this._withAdapter(q,o,ae=>ae.provideTypeDefinition(d.URI.revive(ie),G,X),[],X)}registerHoverProvider(q,ie,G,X){const ae=this._addNewAdapter(new c(this._documents,G),q);return this._proxy.$registerHoverProvider(ae,this._transformDocumentSelector(ie)),this._createDisposable(ae)}$provideHover(q,ie,G,X){return this._withAdapter(q,c,ae=>ae.provideHover(d.URI.revive(ie),G,X),void 0,void 0)}registerEvaluatableExpressionProvider(q,ie,G,X){const ae=this._addNewAdapter(new m(this._documents,G),q);return this._proxy.$registerEvaluatableExpressionProvider(ae,this._transformDocumentSelector(ie)),this._createDisposable(ae)}$provideEvaluatableExpression(q,ie,G,X){return this._withAdapter(q,m,ae=>ae.provideEvaluatableExpression(d.URI.revive(ie),G,X),void 0,void 0)}registerInlineValuesProvider(q,ie,G,X){const ae=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new f(this._documents,G),q);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(ie),ae);let De=this._createDisposable(me);if(ae!==void 0){const Be=G.onDidChangeInlineValues(Xe=>this._proxy.$emitInlineValuesEvent(ae));De=C.Disposable.from(De,Be)}return De}$provideInlineValues(q,ie,G,X,ae){return this._withAdapter(q,f,me=>me.provideInlineValues(d.URI.revive(ie),G,X,ae),void 0,void 0)}registerDocumentHighlightProvider(q,ie,G){const X=this._addNewAdapter(new w(this._documents,G),q);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideDocumentHighlights(q,ie,G,X){return this._withAdapter(q,w,ae=>ae.provideDocumentHighlights(d.URI.revive(ie),G,X),void 0,void 0)}registerLinkedEditingRangeProvider(q,ie,G){const X=this._addNewAdapter(new T(this._documents,G),q);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideLinkedEditingRanges(q,ie,G,X){return this._withAdapter(q,T,async ae=>{const me=await ae.provideLinkedEditingRanges(d.URI.revive(ie),G,X);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?qe._serializeRegExp(me.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider(q,ie,G){const X=this._addNewAdapter(new L(this._documents,G),q);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideReferences(q,ie,G,X,ae){return this._withAdapter(q,L,me=>me.provideReferences(d.URI.revive(ie),G,X,ae),void 0,ae)}registerCodeActionProvider(q,ie,G,X){const ae=new b.DisposableStore,me=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,G,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(ie),{providedKinds:X?.providedCodeActionKinds?.map(De=>De.value),documentation:X?.documentation?.map(De=>({kind:De.kind.value,command:this._commands.converter.toInternal(De.command,ae)}))},qe._extLabel(q),Boolean(G.resolveCodeAction)),ae.add(this._createDisposable(me)),ae}$provideCodeActions(q,ie,G,X,ae){return this._withAdapter(q,O,me=>me.provideCodeActions(d.URI.revive(ie),G,X,ae),void 0,void 0)}$resolveCodeAction(q,ie,G){return this._withAdapter(q,O,X=>X.resolveCodeAction(ie,G),void 0,void 0)}$releaseCodeActions(q,ie){this._withAdapter(q,O,G=>Promise.resolve(G.releaseCodeActions(ie)),void 0,void 0)}registerDocumentFormattingEditProvider(q,ie,G){const X=this._addNewAdapter(new E(this._documents,G),q);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(ie),q.identifier,q.displayName||q.name),this._createDisposable(X)}$provideDocumentFormattingEdits(q,ie,G,X){return this._withAdapter(q,E,ae=>ae.provideDocumentFormattingEdits(d.URI.revive(ie),G,X),void 0,void 0)}registerDocumentRangeFormattingEditProvider(q,ie,G){const X=this._addNewAdapter(new M(this._documents,G),q);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(ie),q.identifier,q.displayName||q.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(q,ie,G,X,ae){return this._withAdapter(q,M,me=>me.provideDocumentRangeFormattingEdits(d.URI.revive(ie),G,X,ae),void 0,void 0)}registerOnTypeFormattingEditProvider(q,ie,G,X){const ae=this._addNewAdapter(new U(this._documents,G),q);return this._proxy.$registerOnTypeFormattingSupport(ae,this._transformDocumentSelector(ie),X,q.identifier),this._createDisposable(ae)}$provideOnTypeFormattingEdits(q,ie,G,X,ae,me){return this._withAdapter(q,U,De=>De.provideOnTypeFormattingEdits(d.URI.revive(ie),G,X,ae,me),void 0,void 0)}registerWorkspaceSymbolProvider(q,ie){const G=this._addNewAdapter(new V(ie,this._logService),q);return this._proxy.$registerNavigateTypeSupport(G,typeof ie.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(q,ie,G){return this._withAdapter(q,V,X=>X.provideWorkspaceSymbols(ie,G),{symbols:[]},G)}$resolveWorkspaceSymbol(q,ie,G){return this._withAdapter(q,V,X=>X.resolveWorkspaceSymbol(ie,G),void 0,void 0)}$releaseWorkspaceSymbols(q,ie){this._withAdapter(q,V,G=>G.releaseWorkspaceSymbols(ie),void 0,void 0)}registerRenameProvider(q,ie,G){const X=this._addNewAdapter(new z(this._documents,G,this._logService),q);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(ie),z.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(q,ie,G,X,ae){return this._withAdapter(q,z,me=>me.provideRenameEdits(d.URI.revive(ie),G,X,ae),void 0,void 0)}$resolveRenameLocation(q,ie,G,X){return this._withAdapter(q,z,ae=>ae.resolveRenameLocation(d.URI.revive(ie),G,X),void 0,void 0)}registerDocumentSemanticTokensProvider(q,ie,G,X){const ae=this._addNewAdapter(new W(this._documents,G),q),me=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ae,this._transformDocumentSelector(ie),X,me);let De=this._createDisposable(ae);if(me){const Be=G.onDidChangeSemanticTokens(Xe=>this._proxy.$emitDocumentSemanticTokensEvent(me));De=C.Disposable.from(De,Be)}return De}$provideDocumentSemanticTokens(q,ie,G,X){return this._withAdapter(q,W,ae=>ae.provideDocumentSemanticTokens(d.URI.revive(ie),G,X),null,void 0)}$releaseDocumentSemanticTokens(q,ie){this._withAdapter(q,W,G=>G.releaseDocumentSemanticColoring(ie),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,ie,G,X){const ae=this._addNewAdapter(new B(this._documents,G),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ae,this._transformDocumentSelector(ie),X),this._createDisposable(ae)}$provideDocumentRangeSemanticTokens(q,ie,G,X){return this._withAdapter(q,B,ae=>ae.provideDocumentRangeSemanticTokens(d.URI.revive(ie),G,X),null,void 0)}registerCompletionItemProvider(q,ie,G,X){const ae=this._addNewAdapter(new x(this._documents,this._commands.converter,G,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(ae,this._transformDocumentSelector(ie),X,x.supportsResolving(G),`${q.identifier.value}(${X.join("")})`),this._createDisposable(ae)}$provideCompletionItems(q,ie,G,X,ae){return this._withAdapter(q,x,me=>me.provideCompletionItems(d.URI.revive(ie),G,X,ae),void 0,ae)}$resolveCompletionItem(q,ie,G){return this._withAdapter(q,x,X=>X.resolveCompletionItem(ie,G),void 0,G)}$releaseCompletionItems(q,ie){this._withAdapter(q,x,G=>G.releaseCompletionItems(ie),void 0,void 0)}registerInlineCompletionsProvider(q,ie,G){const X=this._addNewAdapter(new $(this._documents,G,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideInlineCompletions(q,ie,G,X,ae){return this._withAdapter(q,$,me=>me.provideInlineCompletions(d.URI.revive(ie),G,X,ae),void 0,void 0)}$handleInlineCompletionDidShow(q,ie,G){this._withAdapter(q,$,async X=>{X.handleDidShowCompletionItem(ie,G)},void 0,void 0)}$freeInlineCompletionsList(q,ie){this._withAdapter(q,$,async G=>{G.disposeCompletions(ie)},void 0,void 0)}registerSignatureHelpProvider(q,ie,G,X){const ae=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,me=this._addNewAdapter(new ne(this._documents,G),q);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(ie),ae),this._createDisposable(me)}$provideSignatureHelp(q,ie,G,X,ae){return this._withAdapter(q,ne,me=>me.provideSignatureHelp(d.URI.revive(ie),G,X,ae),void 0,void 0)}$releaseSignatureHelp(q,ie){this._withAdapter(q,ne,G=>G.releaseSignatureHelp(ie),void 0,void 0)}registerInlayHintsProvider(q,ie,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new re(this._documents,this._commands.converter,G,this._logService,q),q);this._proxy.$registerInlayHintsProvider(ae,this._transformDocumentSelector(ie),typeof G.resolveInlayHint=="function",X);let me=this._createDisposable(ae);if(X!==void 0){const De=G.onDidChangeInlayHints(Be=>this._proxy.$emitInlayHintsEvent(X));me=C.Disposable.from(me,De)}return me}$provideInlayHints(q,ie,G,X){return this._withAdapter(q,re,ae=>ae.provideInlayHints(d.URI.revive(ie),G,X),void 0,X)}$resolveInlayHint(q,ie,G){return this._withAdapter(q,re,X=>X.resolveInlayHint(ie,G),void 0,G)}$releaseInlayHints(q,ie){this._withAdapter(q,re,G=>G.releaseHints(ie),void 0,void 0)}registerDocumentLinkProvider(q,ie,G){const X=this._addNewAdapter(new Z(this._documents,G),q);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(ie),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(q,ie,G){return this._withAdapter(q,Z,X=>X.provideLinks(d.URI.revive(ie),G),void 0,void 0)}$resolveDocumentLink(q,ie,G){return this._withAdapter(q,Z,X=>X.resolveLink(ie,G),void 0,void 0)}$releaseDocumentLinks(q,ie){this._withAdapter(q,Z,G=>G.releaseLinks(ie),void 0,void 0)}registerColorProvider(q,ie,G){const X=this._addNewAdapter(new Q(this._documents,G),q);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideDocumentColors(q,ie,G){return this._withAdapter(q,Q,X=>X.provideColors(d.URI.revive(ie),G),[],void 0)}$provideColorPresentations(q,ie,G,X){return this._withAdapter(q,Q,ae=>ae.provideColorPresentations(d.URI.revive(ie),G,X),void 0,void 0)}registerFoldingRangeProvider(q,ie,G){const X=this._nextHandle(),ae=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new xe(new oe(this._documents,G),q)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(ie),ae);let me=this._createDisposable(X);if(ae!==void 0){const De=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ae));me=C.Disposable.from(me,De)}return me}$provideFoldingRanges(q,ie,G,X){return this._withAdapter(q,oe,ae=>ae.provideFoldingRanges(d.URI.revive(ie),G,X),void 0,void 0)}registerSelectionRangeProvider(q,ie,G){const X=this._addNewAdapter(new fe(this._documents,G,this._logService),q);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$provideSelectionRanges(q,ie,G,X){return this._withAdapter(q,fe,ae=>ae.provideSelectionRanges(d.URI.revive(ie),G,X),[],X)}registerCallHierarchyProvider(q,ie,G){const X=this._addNewAdapter(new pe(this._documents,G),q);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$prepareCallHierarchy(q,ie,G,X){return this._withAdapter(q,pe,ae=>Promise.resolve(ae.prepareSession(d.URI.revive(ie),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(q,ie,G,X){return this._withAdapter(q,pe,ae=>ae.provideCallsTo(ie,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(q,ie,G,X){return this._withAdapter(q,pe,ae=>ae.provideCallsFrom(ie,G,X),void 0,X)}$releaseCallHierarchy(q,ie){this._withAdapter(q,pe,G=>Promise.resolve(G.releaseSession(ie)),void 0,void 0)}registerTypeHierarchyProvider(q,ie,G){const X=this._addNewAdapter(new Te(this._documents,G),q);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(ie)),this._createDisposable(X)}$prepareTypeHierarchy(q,ie,G,X){return this._withAdapter(q,Te,ae=>Promise.resolve(ae.prepareSession(d.URI.revive(ie),G,X)),void 0,X)}$provideTypeHierarchySupertypes(q,ie,G,X){return this._withAdapter(q,Te,ae=>ae.provideSupertypes(ie,G,X),void 0,X)}$provideTypeHierarchySubtypes(q,ie,G,X){return this._withAdapter(q,Te,ae=>ae.provideSubtypes(ie,G,X),void 0,X)}$releaseTypeHierarchy(q,ie){this._withAdapter(q,Te,G=>Promise.resolve(G.releaseSession(ie)),void 0,void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,k.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:qe._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?qe._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?qe._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:qe._serializeRegExp(q.beforeText),afterText:q.afterText?qe._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?qe._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(qe._serializeOnEnterRule)}setLanguageConfiguration(q,ie,G){let{wordPattern:X}=G;if(X&&(0,k.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(ie,X):this._documents.setWordDefinitionFor(ie,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const ae=this._nextHandle(),me={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?qe._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?qe._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?qe._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ae,ie,me),this._createDisposable(ae)}$setWordDefinitions(q){for(const ie of q)this._documents.setWordDefinitionFor(ie.languageId,new RegExp(ie.regexSource,ie.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(ve[242],be([0,1,5,15,7,47,13,6]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(F,y,l,b){this._documents=y,this._commands=l,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,y){await this._proxy.$changeLanguage(F,y);const l=this._documents.getDocumentData(F);if(!l)throw new Error(`document '${F.toString}' NOT found`);return l.document}async tokenAtPosition(F,y){const l=F.version,b=t.Position.from(y),g=await this._proxy.$tokensAtPosition(F.uri,b),v={type:I.StandardTokenType.Other,range:F.getWordRangeAtPosition(y)??new I.Range(y.line,y.character,y.line,y.character)};if(!g)return v;const _={range:t.Range.to(g.range),type:t.TokenType.to(g.type)};return!_.range.contains(y)||l!==F.version?v:_}createLanguageStatusItem(F,y,l){const b=this._handlePool++,g=this._proxy,v=this._ids,_=`${F.identifier.value}/${y}`;if(v.has(_))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);v.add(_);const R={selector:l,id:y,name:F.displayName??F.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p,h=new k.DisposableStore;const s=()=>{p?.dispose(),p=(0,A.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(b,{id:_,name:R.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(R.selector,this._uriTransformer),label:R.text,detail:R.detail??"",severity:R.severity===I.LanguageStatusSeverity.Error?C.default.Error:R.severity===I.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:R.command&&this._commands.toInternal(R.command,h),accessibilityInfo:R.accessibilityInformation,busy:R.busy})},0)},u={dispose(){h.dispose(),p?.dispose(),g.$removeLanguageStatus(b),v.delete(_)},get id(){return R.id},get name(){return R.name},set name(r){R.name=r,s()},get selector(){return R.selector},set selector(r){R.selector=r,s()},get text(){return R.text},set text(r){R.text=r,s()},get detail(){return R.detail},set detail(r){R.detail=r,s()},get severity(){return R.severity},set severity(r){R.severity=r,s()},get accessibilityInformation(){return R.accessibilityInformation},set accessibilityInformation(r){R.accessibilityInformation=r,s()},get command(){return R.command},set command(r){R.command=r,s()},get busy(){return R.busy},set busy(r){R.busy=r,s()}};return s(),u}}e.ExtHostLanguages=D}),define(ve[133],be([0,1,12,5,26,14,3]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends d.AbstractLoggerService{constructor(F,y){const l=new A.Emitter;super(y.logLevel,l.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,y,l){return new D(this._proxy,F,y,l)}};k=je([ze(0,C.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class D extends d.AbstractMessageLogger{constructor(F,y,l,b){super(b?.always);this.proxy=F,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(y,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,y){const l=[[F,y]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(F){this.proxy.$log(this.file,F)}}}),define(ve[243],be([0,1,5,12,30]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let A=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(d.MainContext.MainThreadMessageService)}showMessage(D,P,F,y,l){const b={source:{identifier:D.identifier,label:D.displayName||D.name}};let g;typeof y=="string"||C(y)?g=[y,...l]:(b.modal=y?.modal,b.useCustom=y?.useCustom,b.detail=y?.detail,g=l),b.useCustom&&(0,I.checkProposedApiEnabled)(D,"resolvers");const v=[];for(let _=0;_<g.length;_++){const R=g[_];if(typeof R=="string")v.push({title:R,handle:_,isCloseAffordance:!1});else if(typeof R=="object"){let{title:p,isCloseAffordance:h}=R;v.push({title:p,isCloseAffordance:!!h,handle:_})}else this._logService.warn("Invalid message item:",R)}return this._proxy.$showMessage(P,F,b,v).then(_=>{if(typeof _=="number")return g[_]})}};A=je([ze(1,t.ILogService)],A),e.ExtHostMessageService=A}),define(ve[244],be([0,1,22,3,58,6,24,8,18,2,87,5,15,7,52,219,130]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class R{constructor(h,s,u,r,S){this._textDocumentsAndEditors=u,this._textDocuments=r,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const i=a.notebookEditor?.notebookUri,n=a.cell.handle,c=this._documents.get(i)?.getCell(n);if(c)return c.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){const s=this._editors.get(h);if(!s)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(h){for(const[s,u]of this._editors)if(u.apiEditor===h)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,s){const u=this._documents.get(h);if(!u&&!s)throw new Error(`NO notebook document for '${h}'`);return u}_getProviderData(h){const s=this._notebookContentProviders.get(h);if(!s)throw new Error(`NO provider for '${h}'`);return s}registerNotebookContentProvider(h,s,u,r,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:h,provider:u});let a;return u.onDidChangeNotebookContentOptions&&(a=u.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(s,i)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},s,l.NotebookDocumentContentOptions.from(r),R._convertNotebookRegistrationData(h,S)),new b.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(h,s){if(!s)return;const u=s.filenamePattern.map(r=>l.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(s.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:s.displayName,filenamePattern:u,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,s,u){const r=R._notebookStatusBarItemProviderHandlePool++,S=typeof u.onDidChangeCellStatusBarItems=="function"?R._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,S,s);let a;return S!==void 0&&(a=u.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,S),a&&a.dispose()})}async createNotebookDocument(h){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&l.NotebookData.from(h.content)});return P.URI.revive(s)}async openNotebookDocument(h){const s=this._documents.get(h);if(s)return s.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(h),r=this._documents.get(P.URI.revive(u));return(0,D.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(h,s){P.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let u;typeof s=="object"?u={position:l.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(l.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:u={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,u),S=r&&this._editors.get(r)?.apiEditor;if(S)return S;throw r?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,s,u,r){const S=this._notebookStatusBarItemProviders.get(h),a=P.URI.revive(s),i=this._documents.get(a);if(!i||!S)return;const n=i.getCellFromIndex(u);if(!n)return;const o=await S.provideCellStatusBarItems(n.apiCell,r);if(!o)return;const c=new C.DisposableStore,m=this._statusBarCache.add([c]),w=(Array.isArray(o)?o:[o]).map(T=>l.NotebookStatusBarItem.from(T,this._commandsConverter,c));return{cacheId:m,items:w}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,s,u,r,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,u),this._notebookProxy.$registerNotebookSerializer(a,{id:h.identifier,location:h.extensionLocation},s,l.NotebookDocumentContentOptions.from(r),R._convertNotebookRegistrationData(h,S)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(h,s,u){const r=this._notebookSerializer.get(h);if(!r)throw new Error("NO serializer found");const S=await r.deserializeNotebook(s.buffer,u);return new g.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(h,s,u){const r=this._notebookSerializer.get(h);if(!r)throw new Error("NO serializer found");const S=await r.serializeNotebook(l.NotebookData.to(s.value),u);return d.VSBuffer.wrap(S)}async $openNotebook(h,s,u,r,S){const{provider:a}=this._getProviderData(h),i=await a.openNotebook(P.URI.revive(s),{backupId:u,untitledDocumentData:r?.buffer},S);return new g.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)})}async $saveNotebook(h,s,u){const r=this.getNotebookDocument(P.URI.revive(s)),{provider:S}=this._getProviderData(h);return await S.saveNotebook(r.apiNotebook,u),!0}async $saveNotebookAs(h,s,u,r){const S=this.getNotebookDocument(P.URI.revive(s)),{provider:a}=this._getProviderData(h);return await a.saveNotebookAs(P.URI.revive(u),S.apiNotebook,r),!0}async $backupNotebook(h,s,u){const r=this.getNotebookDocument(P.URI.revive(s)),S=this._getProviderData(h),a=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,I.hash)([r.uri.toString(),this._backupIdPool++])),n=P.URI.joinPath(a,i),o=await S.provider.backupNotebook(r.apiNotebook,{destination:n},u);return r.updateBackup(o),o.id}_createExtHostEditor(h,s,u){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const r=new _.ExtHostNotebookEditor(s,this._notebookEditorsProxy,h,u.visibleRanges.map(l.NotebookRange.to),u.selections.map(l.NotebookRange.to),typeof u.viewColumn=="number"?l.ViewColumn.to(u.viewColumn):void 0);this._editors.set(s,r)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const u of h.value.removedDocuments){const r=P.URI.revive(u),S=this._documents.get(r);S&&(S.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===r.toString()&&this._editors.delete(a.id)}if(h.value.addedDocuments){const u=[];for(const r of h.value.addedDocuments){const S=P.URI.revive(r.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const a=this,i=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){a._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){a._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){a._onDidChangeCellMetadata.fire(n)}},S,r);u.push(...r.cells.map(n=>v.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(h.value.addedEditors)for(const u of h.value.addedEditors){if(this._editors.has(u.id))return;const r=P.URI.revive(u.documentUri),S=this._documents.get(r);S&&this._createExtHostEditor(S,u.id,u)}const s=[];if(h.value.removedEditors)for(const u of h.value.removedEditors){const r=this._editors.get(u);r&&(this._editors.delete(u),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),s.push(r))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const u=new Set;this._visibleNotebookEditors.forEach(r=>u.add(r.id));for(const r of this._editors.values()){const S=u.has(r.id);r._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=R,R._notebookStatusBarItemProviderHandlePool=0}),define(ve[245],be([0,1,3,76,12,5,14,15]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(y,l){const b=D._Keys.nextId();y.$registerNotebookEditorDecorationType(b,k.NotebookDecorationRenderOptions.from(l)),this.value={key:b,dispose(){y.$removeNotebookEditorDecorationType(b)}}}}D._Keys=new t.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,l,b){this._logService=y,this._extHostRpc=l,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new D(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,l);const b=this._notebooksAndEditors.getEditorById(y);l.visibleRanges&&b._acceptVisibleRanges(l.visibleRanges.ranges.map(k.NotebookRange.to)),l.selections&&b._acceptSelections(l.selections.selections.map(k.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const l in y)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(k.ViewColumn.to(y[l]))}};P=je([ze(0,I.ILogService),ze(1,A.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(ve[246],be([0,1,17,13,21,3,6,24,2,27,12,5,38,15,7,88,212,30,52]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let h=class{constructor(i,n,o,c,m){this._initData=n,this._extHostNotebook=o,this._commands=c,this._logService=m,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new C.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(y.MainContext.MainThreadNotebookKernels);const f=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const T=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:T}}else if(w&&"notebookEditor"in w){const T=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:T}}return w})],l.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,n,o,c,m,f){for(const J of this._kernelData.values())if(J.controller.id===n&&P.ExtensionIdentifier.equals(i.identifier,J.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const w=this._handlePool++,T=this;this._logService.trace(`NotebookController[${w}], CREATED by ${i.identifier.value}, ${n}`);const L=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${i.identifier}'`);let O=!1;const E=new A.DisposableStore,M=new C.Emitter,U=new C.Emitter,V={id:S(i,n),notebookType:o,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:c||i.identifier.value,preloads:f?f.map(b.NotebookRendererScript.from):[]};let z=m??L,N;this._proxy.$addKernel(w,V).catch(J=>{console.log(J),O=!0});let W=0;const B=()=>{if(O)return;const J=++W;Promise.resolve().then(()=>{J===W&&this._proxy.$updateKernel(w,V)})},x=new k.ResourceMap,$={get id(){return n},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return V.label},set label(J){V.label=J??i.displayName??i.name,B()},get detail(){return V.detail??""},set detail(J){V.detail=J,B()},get description(){return V.description??""},set description(J){V.description=J,B()},get kind(){return(0,R.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind??""},set kind(J){(0,R.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind=J,B()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(J){V.supportedLanguages=J,B()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(J){V.supportsExecutionOrder=J,B()},get rendererScripts(){return V.preloads?V.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(J){z=J??L},get interruptHandler(){return N},set interruptHandler(J){N=J,V.supportsInterrupt=Boolean(J),B()},createNotebookCellExecution(J){if(O)throw new Error("notebook controller is DISPOSED");if(!x.has(J.notebook.uri))throw T._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return T._createNotebookCellExecution(J,S(i,this.id))},dispose:()=>{O||(this._logService.trace(`NotebookController[${w}], DISPOSED`),O=!0,this._kernelData.delete(w),E.dispose(),M.dispose(),U.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(J,ne){T._proxy.$updateNotebookPriority(w,J.uri,ne)},onDidReceiveMessage:U.event,postMessage(J,ne){return(0,R.checkProposedApiEnabled)(i,"notebookMessaging"),T._proxy.$postMessage(w,ne&&T._extHostNotebook.getIdByEditor(ne),J)},asWebviewUri(J){return(0,R.checkProposedApiEnabled)(i,"notebookMessaging"),(0,v.asWebviewUri)(J,T._initData.remote)}};return this._kernelData.set(w,{extensionId:i.identifier,controller:$,onDidReceiveMessage:U,onDidChangeSelection:M,associatedNotebooks:x}),$}$acceptNotebookAssociation(i,n,o){const c=this._kernelData.get(i);if(c){const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));o?c.associatedNotebooks.set(m.uri,!0):c.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,m.uri.toString(),o),c.onDidChangeSelection.fire({selected:o,notebook:m.apiNotebook})}}async $executeCells(i,n,o){const c=this._kernelData.get(i);if(!c)return;const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(n)),f=[];for(const w of o){const T=m.getCell(w);T&&f.push(T.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,m.uri.toString(),f.length),await c.controller.executeHandler.call(c.controller,f,m.apiNotebook,c.controller)}catch(w){this._logService.error(`NotebookController[${i}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(i,n,o){const c=this._kernelData.get(i);if(!c)return;const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,m.apiNotebook);else for(const f of o){const w=m.getCell(f);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,n,o){const c=this._kernelData.get(i);if(!c)return;const m=this._extHostNotebook.getEditorById(n);c.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:o}))}$cellExecutionChanged(i,n,o){const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(i)).getCell(n);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:o??g.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,n){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const m=new u(n,c,this._proxy);this._activeExecutions.set(c.uri,m);const f=m.onDidChangeState(()=>{m.state===s.Resolved&&(m.dispose(),f.dispose(),this._activeExecutions.delete(c.uri))});return m.asApiObject()}};h=je([ze(4,F.ILogService)],h),e.ExtHostNotebookKernels=h;var s;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(s||(s={}));class u extends A.Disposable{constructor(i,n,o){super();this._cell=n,this._proxy=o,this._handle=u.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new r(10,c=>this.update(c)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const n=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new p.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(n=>{const o=g.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return o===n.items?b.NotebookCellOutput.from(n):b.NotebookCellOutput.from({items:o,id:n.id,metadata:n.metadata})})}async updateOutputs(i,n,o){const c=this.validateAndConvertOutputs((0,d.asArray)(i));return this.updateSoon({editType:_.CellExecutionUpdateType.Output,append:o,outputs:c})}async updateOutputItems(i,n,o){return i=g.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(i),!0),this.updateSoon({editType:_.CellExecutionUpdateType.OutputItems,items:i.map(b.NotebookCellOutputItem.from),outputId:n.id,append:o})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(o){i._executionOrder=o,i.update([{editType:_.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(o){if(i._state===s.Resolved||i._state===s.Started)throw new Error("Cannot call start again");i._state=s.Started,i._onDidChangeState.fire(),i.update({editType:_.CellExecutionUpdateType.ExecutionState,runStartTime:o})},end(o,c){if(i._state===s.Resolved)throw new Error("Cannot call resolve twice");i._state=s.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new p.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:o}))},clearOutput(o){return i.verifyStateForOutput(),i.updateOutputs([],o,!1)},appendOutput(o,c){return i.verifyStateForOutput(),i.updateOutputs(o,c,!0)},replaceOutput(o,c){return i.verifyStateForOutput(),i.updateOutputs(o,c,!1)},appendOutputItems(o,c){return i.verifyStateForOutput(),i.updateOutputItems(o,c,!0)},replaceOutputItems(o,c){return i.verifyStateForOutput(),i.updateOutputItems(o,c,!1)}})}}u.HANDLE=0;class r{constructor(i,n){this.delay=i,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>i.complete())}}function S(a,i){return`${a.identifier.value}/${i}`}}),define(ve[247],be([0,1,3,5,130,30]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(D,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,P,F){const y=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(P)?.fire({editor:y.apiEditor,message:F})}createRendererMessaging(D,P){if(!D.contributes?.notebookRenderer?.some(b=>b.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const F=(0,C.isProposedApiEnabled)(D,"notebookEditor"),y=new WeakMap;return{onDidReceiveMessage:(b,g,v)=>{const _=F?b:R=>{const p={};y.set(p,R.editor),b({editor:p,message:R.message})};return this.getOrCreateEmitterFor(P).event(_,g,v)},postMessage:(b,g)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,g]=[g,b]);const v=F?g:y.get(g),_=v&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(v);return this.proxy.$postMessage(_?.id,P,b)}}}getOrCreateEmitterFor(D){let P=this._rendererMessageEmitters.get(D);return P||(P=new d.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,P),P)}}e.ExtHostNotebookRenderers=A}),define(ve[134],be([0,1,5,6,4,14,12,213,66,26,44,155,22]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends t.Disposable{constructor(_,R,p,h){super();this.id=_,this.name=R,this.logger=p,this.proxy=h,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(_){this.append(_+`
`)}append(_){this.write(_),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,_)}replace(_){const R=this.offset;this.write(_),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,R),this.visible&&this.logger.flush()}show(_,R){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:R))}hide(){this.proxy.$close(this.id)}write(_){this.offset+=l.VSBuffer.fromString(_).byteLength,this.logger.info(_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let g=class{constructor(_,R,p,h,s){this.extHostFileSystem=p,this.extHostFileSystemInfo=h,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(d.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(R.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[R,p]of this.channels)p.visible=R===this.visibleChannelId}createOutputChannel(_,R){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const p=this.doCreateOutputChannel(_,R);return p.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),this.createExtHostOutputChannel(_,p)}async doCreateOutputChannel(_,R){const p=await this.createOutputDirectory(),h=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(_,!1,h,R.identifier.value);return new b(u,_,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(_,R){let p=!1;const h=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return _},append(s){h(),R.then(u=>u.append(s))},appendLine(s){h(),R.then(u=>u.appendLine(s))},clear(){h(),R.then(s=>s.clear())},replace(s){h(),R.then(u=>u.replace(s))},show(s,u){h(),R.then(r=>r.show(s,u))},hide(){h(),R.then(s=>s.hide())},dispose(){p=!0,R.then(s=>s.dispose())}}}};g=je([ze(0,C.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,D.IExtHostConsumerFileSystem),ze(3,F.IExtHostFileSystemInfo),ze(4,A.ILoggerService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(ve[248],be([0,1,13,21,3,6,5,2,7,16,17,47,86]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(g,v,_){const R=g.getProxy(A.MainContext.MainThreadQuickOpen);class p{constructor(o,c){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=c}showQuickPick(o,c,m=t.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(o),w=++this._instances,T=R.$show(w,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},m),L={},O=T.then(()=>L);return Promise.race([O,f]).then(E=>{if(E!==L)return f.then(M=>{const U=[];for(let V=0;V<M.length;V++){const z=M[V];typeof z=="string"?U.push({label:z,handle:V}):z.kind===D.QuickPickItemKind.Separator?U.push({type:"separator",label:z.label}):U.push({label:z.label,description:z.description,detail:z.detail,picked:z.picked,alwaysShow:z.alwaysShow,handle:V})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{c.onDidSelectItem(M[V])}),R.$setItems(w,U),T.then(V=>{if(typeof V=="number")return M[V];if(Array.isArray(V))return V.map(z=>M[z])})})}).then(void 0,E=>{if(!(0,P.isCancellationError)(E))return R.$setError(w,E),Promise.reject(E)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,c=t.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,R.$input(o,typeof this._validateInput=="function",c).then(void 0,m=>{if(!(0,P.isCancellationError)(m))return Promise.reject(m)})}$validateInput(o){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,c=t.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!m)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(w=>w.uri.toString()===m.uri.toString())}createQuickPick(o){const c=new a(o,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(o){const c=new i(o,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(o,c){const m=this._sessions.get(o);m&&m._fireDidChangeValue(c)}$onDidAccept(o){const c=this._sessions.get(o);c&&c._fireDidAccept()}$onDidChangeActive(o,c){const m=this._sessions.get(o);m instanceof a&&m._fireDidChangeActive(c)}$onDidChangeSelection(o,c){const m=this._sessions.get(o);m instanceof a&&m._fireDidChangeSelection(c)}$onDidTriggerButton(o,c){const m=this._sessions.get(o);m&&m._fireDidTriggerButton(c)}$onDidTriggerItemButton(o,c,m){const f=this._sessions.get(o);f instanceof a&&f._fireDidTriggerItemButton(c,m)}$onDidHide(o){const c=this._sessions.get(o);c&&c._fireDidHide()}}class h{constructor(o,c){this._extensionId=o,this._onDidDispose=c,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((c,m)=>{const f=c===D.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(f,c)}),this.update({buttons:o.map((c,m)=>({...S(c),tooltip:c.tooltip,handle:c===D.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const c=this._handlesToButtons.get(o);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),R.$dispose(this._id))}update(o){if(!this._disposed){for(const c of Object.keys(o)){const m=o[c];this._pendingUpdate[c]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){R.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}h._nextId=1;function s(n){if(n instanceof D.ThemeIcon)return{id:n.id};const o=r(n),c=u(n);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof c=="string"?k.URI.file(c):c}}function u(n){return typeof n=="object"&&"light"in n?n.light:n}function r(n){return typeof n=="object"&&"dark"in n?n.dark:n}function S(n){const o=s(n.iconPath);let c,m;return"id"in o?m=l.ThemeIcon.asClassName(o):c=o,{iconPath:c,iconClass:m}}class a extends h{constructor(o,c){super(o.identifier,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((m,f)=>{this._handlesToItems.set(f,m),this._itemsToHandles.set(m,f)});const c=[];for(let m=0;m<o.length;m++){const f=o[m];f.kind===D.QuickPickItemKind.Separator?c.push({type:"separator",label:f.label}):c.push({handle:m,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons?.map((w,T)=>({...S(w),tooltip:w.tooltip,handle:T}))})}this.update({items:c})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(o){const c=(0,F.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(o){const c=(0,F.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(o,c){const m=this._handlesToItems.get(o);if(!m||!m.buttons||!m.buttons.length)return;const f=m.buttons[c];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:m})}}class i extends h{constructor(o,c){super(o,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?y.default.Error:y.default.Ignore})}}return new p(v,_)}e.createExtHostQuickOpen=b});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[249],be([0,1,2,3,56,6,13,5,17,102,12,27,86,15,30]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g){"use strict";var v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function R(m){if(m)return typeof m.iconPath=="string"?d.URI.file(m.iconPath):d.URI.isUri(m.iconPath)||l.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function p(m,f){if(!m.iconPath&&!f.iconPath)return 0;if(m.iconPath){if(!f.iconPath)return 1}else return-1;const w=typeof m.iconPath=="string"?m.iconPath:d.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,T=typeof f.iconPath=="string"?f.iconPath:d.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,P.comparePaths)(w,T)}function h(m,f){let w=0;if(m.strikeThrough!==f.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==f.faded)return m.faded?1:-1;if(m.tooltip!==f.tooltip)return(m.tooltip||"").localeCompare(f.tooltip||"");if(w=p(m,f),w!==0)return w;if(m.light&&f.light)w=p(m.light,f.light);else{if(m.light)return 1;if(f.light)return-1}if(w!==0)return w;if(m.dark&&f.dark)w=p(m.dark,f.dark);else{if(m.dark)return 1;if(f.dark)return-1}return w}function s(m,f){if(m.command!==f.command)return m.command<f.command?-1:1;if(m.title!==f.title)return m.title<f.title?-1:1;if(m.tooltip!==f.tooltip){if(m.tooltip!==void 0&&f.tooltip!==void 0)return m.tooltip<f.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(m.arguments===f.arguments)return 0;if(m.arguments)if(f.arguments){if(m.arguments.length!==f.arguments.length)return m.arguments.length-f.arguments.length}else return 1;else return-1;for(let w=0;w<m.arguments.length;w++){const T=m.arguments[w],L=f.arguments[w];if(T!==L)return T<L?-1:1}return 0}function u(m,f){let w=(0,P.comparePaths)(m.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(w!==0)return w;if(m.command&&f.command)w=s(m.command,f.command);else{if(m.command)return 1;if(f.command)return-1}if(w!==0)return w;if(m.decorations&&f.decorations)w=h(m.decorations,f.decorations);else{if(m.decorations)return 1;if(f.decorations)return-1}return w}function r(m,f){for(let w=0;w<m.length;w++)if(m[w]!==f[w])return!1;return!0}function S(m,f){return m.command===f.command&&m.title===f.title&&m.tooltip===f.tooltip&&(m.arguments&&f.arguments?r(m.arguments,f.arguments):m.arguments===f.arguments)}function a(m,f){return(0,D.equals)(m,f,S)}class i{constructor(f,w,T){this._extension=f,this._sourceControlHandle=T,v.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,it(this,v,w,"f")}get value(){return this._value}set value(f){f=f??"",Fe(this,v,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Fe(this,v,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Fe(this,v,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Fe(this,v,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,w){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Fe(this,v,"f").$showValidationMessage(this._sourceControlHandle,f,w)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=i,v=new WeakMap;class n{constructor(f,w,T,L,O){this._proxy=f,this._commands=w,this._sourceControlHandle=T,this._id=L,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,w){const T=this._resourceStatesCommandsMap.get(f);return T?(0,A.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(u),T=(0,D.sortedDiff)(this._resourceSnapshot,f,u).map(E=>{const M=E.toInsert.map(U=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,U);const z=U.resourceUri;let N;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const oe=new C.DisposableStore;N=this._commands.converter.toInternal(U.command,oe),this._resourceStatesDisposablesMap.set(V,oe)}else this._resourceStatesCommandsMap.set(V,U.command);const W=R(U.decorations),B=U.decorations&&R(U.decorations.light)||W,x=U.decorations&&R(U.decorations.dark)||W,$=[B,x],J=U.decorations&&U.decorations.tooltip||"",ne=U.decorations&&!!U.decorations.strikeThrough,re=U.decorations&&!!U.decorations.faded,Z=U.contextValue||"";return{rawResource:[V,z,$,J,ne,re,Z,N],handle:V}});return{start:E.start,deleteCount:E.deleteCount,toInsert:M}}),L=T.map(({start:E,deleteCount:M,toInsert:U})=>[E,M,U.map(V=>V.rawResource)]),O=T.reverse();for(const{start:E,deleteCount:M,toInsert:U}of O){const V=U.map(N=>N.handle),z=this._handlesSnapshot.splice(E,M,...V);for(const N of z)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=f,L}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class o{constructor(f,w,T,L,O,E){this._extension=f,this._commands=T,this._id=L,this._label=O,this._rootUri=E,_.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,it(this,_,w,"f"),this._inputBox=new i(f,Fe(this,_,"f"),this.handle),Fe(this,_,"f").$registerSourceControl(this.handle,L,O,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Fe(this,_,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Fe(this,_,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Fe(this,_,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=f;const w=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Fe(this,_,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=f;const w=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),description:f.description}:void 0;Fe(this,_,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&a(this._statusBarCommands,f))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=f;const w=(f||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));Fe(this,_,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(f,w){const T=new n(Fe(this,_,"f"),this._commands,this.handle,f,w),L=t.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,L),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const f=[],w=[];for(const[T,L]of this.createdResourceGroups){L.dispose();const O=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});t.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),O.dispose(),this._groups.delete(T.handle),Fe(this,_,"f").$unregisterGroup(this.handle,T.handle)}),f.push([T.handle,T.id,T.label,T.features]);const E=T._takeResourceStateSnapshot();E.length>0&&w.push([T.handle,E]),this._groups.set(T.handle,T)}Fe(this,_,"f").$registerGroups(this.handle,f,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(w=>{const T=w._takeResourceStateSnapshot();T.length!==0&&f.push([w.handle,T])}),f.length>0&&Fe(this,_,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Fe(this,_,"f").$unregisterSourceControl(this.handle)}}_=new WeakMap,o._handlePool=0,je([(0,I.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let c=class Vi{constructor(f,w,T){this._commands=w,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=f.getProxy(k.MainContext.MainThreadSCM),this._telemetry=f.getProxy(k.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const O=this._sourceControls.get(L.sourceControlHandle);if(!O)return L;const E=O.getResourceGroup(L.groupHandle);return E?E.getResourceState(L.handle):L}else if(L&&L.$mid===4){const O=this._sourceControls.get(L.sourceControlHandle);return O?O.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const O=this._sourceControls.get(L.handle);return O||L}return L}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,w,T,L){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,w,T,L),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const O=Vi._handlePool++,E=new o(f,this._proxy,this._commands,w,T,L);this._sourceControls.set(O,E);const M=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(f.identifier))||[];return M.push(E),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(f.identifier),M),E}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const w=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(f.identifier)),T=w&&w[w.length-1];return T&&T.inputBox}$provideOriginalResource(f,w,T){const L=d.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,L.toString());const O=this._sourceControls.get(f);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(L,T)).then(E=>E||null)}$onInputBoxValueChange(f,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const T=this._sourceControls.get(f);return T&&T.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(f,w,T,L){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,w,T);const O=this._sourceControls.get(f);if(!O)return Promise.resolve(void 0);const E=O.getResourceGroup(w);return E?E.$executeResourceCommand(T,L):Promise.resolve(void 0)}$validateInput(f,w,T){this.logService.trace("ExtHostSCM#$validateInput",f);const L=this._sourceControls.get(f);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>L.inputBox.validateInput(w,T)).then(O=>{if(!O)return Promise.resolve(void 0);const E=b.MarkdownString.fromStrict(O.message);return E?Promise.resolve([E,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};c._handlePool=0,c=je([ze(2,F.ILogService)],c),e.ExtHostSCM=c});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[250],be([0,1,7,5,169,6,15,18]),function(ee,e,d,t,I,C,A,k){"use strict";var D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(g,v,_,R,p=d.StatusBarAlignment.Left,h){D.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,it(this,D,g,"f"),it(this,P,v,"f"),this._entryId=F.ID_GEN++,this._extension=_,this._id=R,this._alignment=p,this._priority=this.validatePriority(h)}validatePriority(g){if(!!(0,k.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!F.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Fe(this,P,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Fe(this,P,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let v;this._name?v=this._name:v=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const R=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Fe(this,D,"f").$setEntry(this._entryId,g,v,this._text,R,this._command?.internal,_,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,D=new WeakMap,P=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const v={message:g};return this._messages.unshift(v),this._update(),new d.Disposable(()=>{const _=this._messages.indexOf(v);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(g,v){this._proxy=g.getProxy(t.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new y(this)}createStatusBarEntry(g,v,_,R){return new F(this._proxy,this._commands,g,v,_,R)}setStatusBarMessage(g,v){const _=this._statusMessage.setMessage(g);let R;return typeof v=="number"?R=setTimeout(()=>_.dispose(),v):typeof v!="undefined"&&v.then(()=>_.dispose(),()=>_.dispose()),new d.Disposable(()=>{_.dispose(),clearTimeout(R)})}}e.ExtHostStatusBar=l}),define(ve[91],be([0,1,5,3,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}initializeExtensionStorage(k,D,P){return this._proxy.$initializeExtensionStorage(k,D).then(F=>F||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(ve[67],be([0,1,4,26,12,66,2]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,F,y){this._logService=F,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(P){return A.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,F=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([ze(0,t.IExtHostInitDataService),ze(1,I.ILogService),ze(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ve[34],be([0,1,3,5,4,2,14,6,7,170,16,215,21,33,196,86,18,13]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class p{constructor(o,c,m,f){this._proxy=o,this._id=c,this._creationOptions=m,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(T,L=!0){w._checkDisposed(),w._proxy.$sendText(w._id,T,L)},show(T){w._checkDisposed(),w._proxy.$show(w._id,T)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(o,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,_.withNullAsUndefined)(o.shellPath),shellArgs:(0,_.withNullAsUndefined)(o.shellArgs),cwd:(0,_.withNullAsUndefined)(o.cwd),env:(0,_.withNullAsUndefined)(o.env),icon:(0,_.withNullAsUndefined)(a(o.iconPath)),color:v.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,_.withNullAsUndefined)(o.message),strictEnv:(0,_.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(o.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,_.withNullAsUndefined)(o.disablePersistence)})}async createExtensionTerminal(o,c,m,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:v.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(o,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,c){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,c){return o===this._cols&&c===this._rows||o===0||c===0?!1:(this._cols=o,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=p;class h{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new d.Emitter,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,c){this._pty.setDimensions?.({columns:o,rows:c})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=h;let s=1,u=class extends k.Disposable{constructor(o,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[m,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,c){const m=new p(this._proxy,(0,b.generateUuid)(),o,o.name),f=new h(o.pty);return m.createExtensionTerminal(o.location,this._serializeParentTerminal(o,c).resolvedExtHostIdentifier,a(o.iconPath),i(o.color)).then(w=>{const T=this._setupExtHostProcessListeners(w,f);this._terminalProcessDisposables[w]=T}),this._terminals.push(m),m.value}_serializeParentTerminal(o,c){if(c=c||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const m=o.location.parentTerminal;if(m){const f=this._terminals.find(w=>w.value===m);f&&(c.resolvedExtHostIdentifier=f._id)}}else o.location&&typeof o.location!="object"?c.location=o.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(o,c){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const f=new h(c),w=this._setupExtHostProcessListeners(o,f);this._terminalProcessDisposables[o]=w}async $acceptActiveTerminalChanged(o){const c=this._activeTerminal;if(o===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(o);m&&(this._activeTerminal=m,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,c){const m=this._getTerminalById(o);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(o,c,m){const f=this._getTerminalById(o);f&&f.setDimensions(c,m)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(o,c,m){this._terminalProcesses.get(o)?.resize(c,m)}async $acceptTerminalTitleChange(o,c){const m=this._getTerminalById(o);m&&(m.name=c)}async $acceptTerminalClosed(o,c){const m=this._getTerminalObjectIndexById(this._terminals,o);if(m!==null){const f=this._terminals.splice(m,1)[0];f.setExitCode(c),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(o,c,m,f){if(c){const L=this._getTerminalObjectIndexById(this._terminals,c);if(L!==null){this._terminals[L]._id=o,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const w={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:C.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},T=new p(this._proxy,o,w,m);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(o,c){const m=this._getTerminalById(o);m&&m._setProcessId(c)}async $startExtensionTerminal(o,c){const m=this._getTerminalById(o);if(!m)return{message:(0,P.localize)(0,null,o)};m.isOpen||await new Promise(w=>{const T=this.onDidOpenTerminal(async L=>{L===m.value&&(T.dispose(),w())})});const f=this._terminalProcesses.get(o);f?f.startSendingEvents(c):this._extensionTerminalAwaitingStart[o]={initialDimensions:c}}_setupExtHostProcessListeners(o,c){const m=new k.DisposableStore;m.add(c.onProcessReady(w=>this._proxy.$sendProcessReady(o,w.pid,w.cwd))),m.add(c.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(o,w))),this._bufferer.startBuffering(o,c.onProcessData),m.add(c.onProcessExit(w=>this._onProcessExit(o,w))),this._terminalProcesses.set(o,c);const f=this._extensionTerminalAwaitingStart[o];return f&&c instanceof h&&(c.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),m}$acceptProcessAckDataEvent(o,c){this._terminalProcesses.get(o)?.acknowledgeDataEvent(c)}$acceptProcessInput(o,c){this._terminalProcesses.get(o)?.input(c)}$acceptTerminalInteraction(o){const c=this._getTerminalById(o);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(o,c,m){try{this._terminalProcesses.get(o)?.resize(c,m)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(o,c){this._terminalProcesses.get(o)?.shutdown(c)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(c=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:c}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,c,m){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,m),this._proxy.$registerProfileProvider(c,o.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(o,c){const m=new l.CancellationTokenSource().token;let f=await this._profileProviders.get(o)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,c);return}this.createTerminalFromOptions(f.options,c)}}async $provideLinks(o,c){const m=this._getTerminalById(o);if(!m)return[];this._terminalLinkCache.delete(o);const f=this._terminalLinkCancellationSource.get(o);f&&f.dispose(!0);const w=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,w);const T=[],L={terminal:m.value,line:c},O=[];for(const U of this._linkProviders)O.push(R.Promises.withAsyncBody(async V=>{w.token.onCancellationRequested(()=>V({provider:U,links:[]}));const z=await U.provideTerminalLinks(L,w.token)||[];w.token.isCancellationRequested||V({provider:U,links:z})}));const E=await Promise.all(O);if(w.token.isCancellationRequested)return[];const M=new Map;for(const U of E)U&&U.links.length>0&&T.push(...U.links.map(V=>{const z={id:s++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return M.set(z.id,{provider:U.provider,link:V}),z}));return this._terminalLinkCache.set(o,M),T}$activateLink(o,c){const m=this._terminalLinkCache.get(o)?.get(c);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(o,c){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const m=this._terminalProcessDisposables[o];m&&(m.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,c)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,c){const m=this._getTerminalObjectIndexById(o,c);return m!==null?o[m]:null}_getTerminalObjectIndexById(o,c){let m=null;return o.some((f,w)=>f._id===c?(m=w,!0):!1),m}getEnvironmentVariableCollection(o){let c=this._environmentVariableCollections.get(o.identifier.value);return c||(c=new r,this._setEnvironmentVariableCollection(o.identifier.value,c)),c}_syncEnvironmentVariableCollection(o,c){const m=(0,y.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(o,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(o){o.forEach(c=>{const m=c[0],f=new r(c[1]);this._setEnvironmentVariableCollection(m,f)})}$acceptDefaultProfile(o,c){this._defaultProfile=o,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(o,c){this._environmentVariableCollections.set(o,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,c)})}};u=je([ze(1,A.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class r{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,c){this._setIfDiffers(o,{value:c,type:D.EnvironmentVariableMutatorType.Replace})}append(o,c){this._setIfDiffers(o,{value:c,type:D.EnvironmentVariableMutatorType.Append})}prepend(o,c){this._setIfDiffers(o,{value:c,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,c){const m=this.map.get(o);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(o,c),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,c){this.map.forEach((m,f)=>o.call(c,f,m,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let S=class extends u{constructor(o){super(!1,o)}createTerminal(o,c,m){throw new F.NotSupportedError}createTerminalFromOptions(o,c){throw new F.NotSupportedError}};S=je([ze(0,A.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function a(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function i(n){return v.ThemeColor.isThemeColor(n)?n:void 0}});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[251],be([0,1,17,22,21,3,75,58,6,25,18,33,5,14,63,15,7,221,128,89]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let u=class{constructor(L,O){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(l.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new S(this.proxy),O.registerArgumentProcessor({processArgument:E=>E?.$mid===13?v.TestItem.toItemFromContext(E):E})}createTestController(L,O,E){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const M=new D.DisposableStore,U=M.add(new R.SingleUseTestCollection(L));U.root.label=O;const V=new Map,z=this.proxy,N={items:U.root.children,get label(){return O},set label(B){O=B,U.root.label=B,z.$updateController(L,{label:O})},get refreshHandler(){return E},set refreshHandler(B){E=B,z.$updateController(L,{canRefresh:!!B})},get id(){return L},createRunProfile:(B,x,$,J,ne)=>{let re=(0,k.hash)(B);for(;V.has(re);)re++;const Z=new f(this.proxy,L,re,B,x,$,J,ne);return V.set(re,Z),Z},createTestItem(B,x,$){return new g.TestItemImpl(L,B,x,$)},createTestRun:(B,x,$=!0)=>this.runTracker.createTestRun(L,U,B,x,$),set resolveHandler(B){U.resolveHandler=B},get resolveHandler(){return U.resolveHandler},dispose:()=>{M.dispose()}};z.$registerTestController(L,O,!!E),M.add((0,D.toDisposable)(()=>z.$unregisterTestController(L)));const W={controller:N,collection:U,profiles:V};return this.controllers.set(L,W),M.add((0,D.toDisposable)(()=>this.controllers.delete(L))),M.add(U.onDidGenerateDiff(B=>z.$publishDiff(L,B))),N}createTestObserver(){return this.observer.checkout()}async runTests(L,O=I.CancellationToken.None){const E=a(L);if(!E)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(E.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(U=>U.id)??[M.collection.root.id],profileGroup:w[E.kind],profileId:E.profileId,controllerId:E.controllerId}],exclude:L.exclude?.map(U=>U.id)},O)}$provideFileCoverage(L,O,E){return(0,d.mapFind)(this.runTracker.trackers,U=>U.id===L?U.getCoverage(O):void 0)?.provideFileCoverage(E)??Promise.resolve([])}$resolveFileCoverage(L,O,E,M){return(0,d.mapFind)(this.runTracker.trackers,V=>V.id===L?V.getCoverage(O):void 0)?.resolveFileCoverage(E,M)??Promise.resolve([])}$configureRunProfile(L,O){this.controllers.get(L)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(L,O){await this.controllers.get(L)?.controller.refreshHandler?.(O)}$publishTestResults(L){this.results=Object.freeze(L.map(O=>(0,P.deepFreeze)(v.TestResults.to(O))).concat(this.results).sort((O,E)=>E.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,O){const E=this.controllers.get(h.TestId.fromString(L).controllerId)?.collection;E&&(await E.expand(L,O<0?1/0:O),E.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,O){const E=this.controllers.get(L.controllerId);if(!E)return;const{collection:M,profiles:U}=E,V=U.get(L.profileId);if(!V)return;const z=L.testIds.map(x=>M.tree.get(x)).filter(F.isDefined),N=L.excludeExtIds.map(x=>E.collection.tree.get(x)).filter(F.isDefined).filter(x=>z.some($=>$.fullId.compare(x.fullId)===2));if(!z.length)return;const W=new _.TestRunRequest(z.some(x=>x.actual instanceof g.TestItemRootImpl)?void 0:z.map(x=>x.actual),N.map(x=>x.actual),V),B=this.runTracker.prepareForMainThreadTestRun(W,i.fromInternal(L,E.collection),O);try{await V.runHandler(W,O)}finally{B.isRunning&&!O.isCancellationRequested&&await C.Event.toPromise(B.onEnd),B.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};u=je([ze(0,b.IExtHostRpcService)],u),e.ExtHostTesting=u;class r extends D.Disposable{constructor(L,O,E){super();this.dto=L,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(E)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const O=this.dto.id,E=this.dto.controllerId,M=(0,y.generateUuid)(),U=new n(this.proxy,O,M),V=B=>(x,...$)=>{if(N){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(x)||(this.ensureTestIsKnown(x),B(x,...$))},z=(B,x)=>{const $=x instanceof Array?x.map(v.TestMessage.from):[v.TestMessage.from(x)];if(B.uri&&B.range){const J={range:v.Range.from(B.range),uri:B.uri};for(const ne of $)ne.location=ne.location||J}this.proxy.$appendTestMessagesInRun(O,M,h.TestId.fromExtHostTestItem(B,E).toString(),$)};let N=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return U.coverageProvider},set coverageProvider(B){U.coverageProvider=B},enqueued:V(B=>{this.proxy.$updateTestStateInRun(O,M,h.TestId.fromExtHostTestItem(B,E).toString(),1)}),skipped:V(B=>{this.proxy.$updateTestStateInRun(O,M,h.TestId.fromExtHostTestItem(B,E).toString(),5)}),started:V(B=>{this.proxy.$updateTestStateInRun(O,M,h.TestId.fromExtHostTestItem(B,E).toString(),2)}),errored:V((B,x,$)=>{z(B,x),this.proxy.$updateTestStateInRun(O,M,h.TestId.fromExtHostTestItem(B,E).toString(),6,$)}),failed:V((B,x,$)=>{z(B,x),this.proxy.$updateTestStateInRun(O,M,h.TestId.fromExtHostTestItem(B,E).toString(),4,$)}),passed:V((B,x)=>{this.proxy.$updateTestStateInRun(O,M,h.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString(),3,x)}),appendOutput:(B,x,$)=>{N||($&&(this.dto.isIncluded($)?this.ensureTestIsKnown($):$=void 0),this.proxy.$appendOutputToRun(O,M,t.VSBuffer.fromString(B),x&&v.location.from(x),$&&h.TestId.fromExtHostTestItem($,E).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(O,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:W,coverage:U}),this.proxy.$startedTestRunTask(O,{id:M,name:L,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof g.TestItemImpl))throw new g.InvalidTestItemError(L.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const O=[],E=this.dto.colllection.root;for(;;){const M=v.TestItem.from(L);if(O.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),L===E))break;L=L.parent||E}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class S{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,O,E){return this.getTracker(L,O,E)}cancelRunById(L){for(const O of this.tracked.values())if(O.id===L){O.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,O,E,M,U){const V=this.tracked.get(E);if(V)return V.createRun(M);const z=i.fromPublic(L,O,E,U),N=a(E);this.proxy.$startedExtensionTestRun({controllerId:L,profile:N&&{group:w[N.kind],id:N.profileId},exclude:E.exclude?.map(B=>B.id)??[],id:z.id,include:E.include?.map(B=>B.id)??[O.root.id],persist:U});const W=this.getTracker(E,z);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),W.createRun(M)}getTracker(L,O,E){const M=new r(O,this.proxy,E);return this.tracked.set(L,M),M.onEnd(()=>this.tracked.delete(L)),M}}e.TestRunCoordinator=S;const a=T=>{if(!!T.profile){if(!(T.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class i{constructor(L,O,E,M,U,V){this.controllerId=L,this.id=O,this.isPersisted=U,this.colllection=V,this.includePrefix=E.map(z=>z+"\0"),this.excludePrefix=M.map(z=>z+"\0")}static fromPublic(L,O,E,M){return new i(L,(0,y.generateUuid)(),E.include?.map(U=>h.TestId.fromExtHostTestItem(U,L).toString())??[L],E.exclude?.map(U=>h.TestId.fromExtHostTestItem(U,L).toString())??[],M,O)}static fromInternal(L,O){return new i(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,O)}isIncluded(L){const O=h.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const E of this.excludePrefix)if(O===E||O.startsWith(E))return!1;for(const E of this.includePrefix)if(O===E||O.startsWith(E))return!0;return!1}}e.TestRunDto=i;class n{constructor(L,O,E){this.proxy=L,this.runId=O,this.taskId=E}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(L,O){const E=await this.fileCoverage;let M=E?.[L];return!this._coverageProvider||!E||!M?[]:(M.detailedCoverage||(M=E[L]=await this._coverageProvider.resolveFileCoverage?.(M,O)??M),M.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class o extends p.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,v.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:O,removed:E}=this;return{get added(){return[...L].map(M=>M.revived)},get updated(){return[...O].map(M=>M.revived)},get removed(){return[...E].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,O){return{...L,revived:v.TestItem.toPlain(L.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=c;class m{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(O=>O.revived)},dispose:(0,A.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class f{constructor(L,O,E,M,U,V,z=!1,N=void 0){this.controllerId=O,this.profileId=E,this._label=M,this.kind=U,this.runHandler=V,this._isDefault=z,this._tag=N,s.set(this,void 0),it(this,s,L,"f");const W=w[U];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Fe(this,s,"f").$publishTestRunProfile({profileId:E,controllerId:O,tag:N?v.TestTag.namespace(this.controllerId,N.id):null,label:M,group:W,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?v.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Fe(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,s=new WeakMap;const w={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(ve[252],be([0,1,3,17,5,131,15,7]),function(ee,e,d,t,I,C,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(F,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const y=this._extHostDocumentsAndEditors.allEditors();return F?y:y.map(l=>l.value)}async showTextDocument(F,y,l){let b;typeof y=="number"?b={position:A.ViewColumn.from(y),preserveFocus:l}:typeof y=="object"?b={position:A.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?A.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(F.uri,b),v=g&&this._extHostDocumentsAndEditors.getEditor(g);if(v)return v.value;throw g?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,y){return new C.TextEditorDecorationType(this._proxy,F,y).value}$acceptEditorPropertiesChanged(F,y){const l=this._extHostDocumentsAndEditors.getEditor(F);if(!l)throw new Error("unknown text editor");if(y.options&&l._acceptOptions(y.options),y.selections){const b=y.selections.selections.map(A.Selection.to);l._acceptSelections(b)}if(y.visibleRanges){const b=t.coalesce(y.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(b)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...y.options,lineNumbers:A.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const b=k.TextEditorSelectionChangeKind.fromValue(y.selections.source),g=y.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:g,kind:b})}if(y.visibleRanges){const b=t.coalesce(y.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(F){for(const y in F){const l=this._extHostDocumentsAndEditors.getEditor(y);if(!l)throw new Error("Unknown text editor");const b=A.ViewColumn.to(F[y]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=D}),define(ve[253],be([0,1,2,4,5,6,7]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(F,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(I.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const b=l.uri===void 0?void 0:d.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(D(b))?.get(l.handle)}return l}})}async $getTimeline(F,y,l,b,g){return this._providers.get(F)?.provideTimeline(d.URI.revive(y),l,b,g)}registerTimelineProvider(F,y,l,b){const g=new C.DisposableStore,v=this.convertTimelineItem(y.id,b,g).bind(this);let _;y.onDidChange&&(_=y.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:y.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:F,onDidChange:void 0,async provideTimeline(p,h,s,u){u?.resetCache&&(g.clear(),R.get(y.id)?.clear());const r=await y.provideTimeline(p,h,s);if(r==null)return;const S=v(p,u);return{...r,source:y.id,items:r.items.map(S)}},dispose(){for(const p of R.values())p.get(y.id)?.clear();_?.dispose(),g.dispose()}})}convertTimelineItem(F,y,l){return(b,g)=>{let v;if(g?.cacheResults){let _=this._itemsBySourceAndUriMap.get(F);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(F,_));const R=D(b);v=_.get(R),v===void 0&&(v=new Map,_.set(R,v))}return _=>{const{iconPath:R,...p}=_,h=`${F}|${_.id??_.timestamp}`;v?.set(h,_);let s,u,r;return _.iconPath&&(R instanceof A.ThemeIcon?r={id:R.id,color:R.color}:d.URI.isUri(R)?(s=R,u=R):{light:s,dark:u}=R),{...p,id:p.id??void 0,handle:h,source:F,command:_.command?y.toInternal(_.command,l):void 0,icon:s,iconDark:u,themeIcon:r,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,C.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=k;function D(P){return P?.toString()}}),define(ve[254],be([0,1,6,10,2,5]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,F,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=y.schemes.find(b=>!A.supportedSchemes.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,F),this._proxy.$registerUriOpener(P,y.schemes,D,y.label),(0,d.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,F){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener with id: ${D}`);const l=I.URI.revive(P);return y.canOpenExternalUri(l,F)}async $openUri(D,P,F){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener id: '${D}'`);return y.openExternalUri(I.URI.revive(P.resolvedUri),{sourceUri:I.URI.revive(P.sourceUri)},F)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ve[255],be([0,1,5,2,6,16,27]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(P,F){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=k.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(y,F),this._proxy.$registerUriHandler(y,P),(0,I.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,F){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(t.URI.revive(F))}catch(l){(0,C.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(P){return t.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[68],be([0,1,3,10,2,182,205,88,5]),function(ee,e,d,t,I,C,A,k,D){"use strict";var P,F,y,l,b,g,v,_,R,p,h,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(m,f,w,T,L,O,E){P.set(this,void 0),F.set(this,void 0),y.set(this,void 0),l.set(this,void 0),b.set(this,void 0),g.set(this,void 0),v.set(this,""),_.set(this,void 0),R.set(this,!1),p.set(this,!1),h.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new d.Emitter),this._onDidDispose=Fe(this,s,"f").event,it(this,P,m,"f"),it(this,F,f,"f"),it(this,_,w,"f"),it(this,l,T,"f"),it(this,b,L,"f"),it(this,g,O,"f"),it(this,h,r(O),"f"),it(this,y,E,"f")}dispose(){it(this,R,!0,"f"),Fe(this,s,"f").fire(),Fe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return it(this,p,!0,"f"),(0,k.asWebviewUri)(m,Fe(this,l,"f").remote)}get cspSource(){const m=Fe(this,g,"f").extensionLocation;if(m.scheme===t.Schemas.https||m.scheme===t.Schemas.http){let f=m.toString();return f.endsWith("/")||(f+="/"),f+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,v,"f")}set html(m){this.assertNotDisposed(),Fe(this,v,"f")!==m&&(it(this,v,m,"f"),!Fe(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(it(this,p,!0,"f"),Fe(this,y,"f").report("Webview vscode-resource: uris",Fe(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,F,"f").$setHtml(Fe(this,P,"f"),m))}get options(){return this.assertNotDisposed(),Fe(this,_,"f")}set options(m){this.assertNotDisposed(),Fe(this,F,"f").$setOptions(Fe(this,P,"f"),i(Fe(this,g,"f"),Fe(this,b,"f"),m)),it(this,_,m,"f")}async postMessage(m){if(Fe(this,R,"f"))return!1;const f=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Fe(this,h,"f")});return Fe(this,F,"f").$postMessage(Fe(this,P,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Fe(this,R,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,P=new WeakMap,F=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,g=new WeakMap,v=new WeakMap,_=new WeakMap,R=new WeakMap,p=new WeakMap,h=new WeakMap,s=new WeakMap;function r(c){try{const m=(0,C.normalizeVersion)((0,C.parseVersion)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class S{constructor(m,f,w,T,L){this.initData=f,this.workspace=w,this._logService=T,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=m.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(m,f,w){const T=this.getWebview(m);if(T){const{message:L}=(0,A.deserializeWebviewMessage)(f,w.value);T._onMessageEmitter.fire(L)}}$onMissingCsp(m,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,f,w){const T=new u(m,this._webviewProxy,n(f),this.initData,this.workspace,w,this._deprecationService);return this._webviews.set(m,T),T._onDidDispose(()=>{this._webviews.delete(m)}),T}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=S;function a(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=a;function i(c,m,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||o(c,m)}}e.serializeWebviewOptions=i;function n(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>I.URI.from(m))}}e.reviveOptions=n;function o(c,m){return[...(m?.getWorkspaceFolders()||[]).map(f=>f.uri),c.extensionLocation]}}),define(ve[256],be([0,1,21,58,6,10,23,2,15,68,87,5,7]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(r,S){this.document=r,this._storagePath=S,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,S){await this.getEdit(r).undo(),S||this.disposeBackup()}async redo(r,S){await this.getEdit(r).redo(),S||this.disposeBackup()}disposeEdits(r){for(const S of r)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=s(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const S=this._edits.get(r,0);if(!S)throw new Error("No edit found");return S}}class g{constructor(){this._documents=new Map}get(r,S){return this._documents.get(this.key(r,S))}add(r,S,a){const i=this.key(r,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${r} resource:${S.uri}`);const n=new b(S,a);return this._documents.set(i,n),n}delete(r,S){const a=this.key(r,S.uri);this._documents.delete(a)}key(r,S){return`${r}@@@${S}`}}var v;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(r,S,a){return this.add(0,r,S,a)}addCustomProvider(r,S,a){return this.add(1,r,S,a)}get(r){return this._providers.get(r)}add(r,S,a,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:r,extension:a,provider:i}),new l.Disposable(()=>this._providers.delete(S))}}class R{constructor(r,S,a,i,n){this._extHostDocuments=S,this._extensionStoragePaths=a,this._extHostWebview=i,this._extHostWebviewPanels=n,this._editorProviders=new _,this._documents=new g,this._proxy=r.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,S,a,i){const n=new I.DisposableStore;return p(a)?(n.add(this._editorProviders.addTextProvider(S,r,a)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(r),S,i.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(r))):(n.add(this._editorProviders.addCustomProvider(S,r,a)),this.supportEditing(a)&&n.add(a.onDidChangeCustomDocument(o=>{const c=this.getCustomDocumentEntry(S,o.document.uri);if(h(o)){const m=c.addEdit(o);this._proxy.$onDidEdit(o.document.uri,S,m,o.label)}else this._proxy.$onContentChange(o.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(r),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(r))),l.Disposable.from(n,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(r,S,a,i,n){const o=this._editorProviders.get(S);if(!o)throw new Error(`No provider found for '${S}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${S}'`);const c=k.URI.revive(r),m=await o.provider.openCustomDocument(c,{backupId:a,untitledDocumentData:i?.buffer},n);let f;return this.supportEditing(o.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(S,m,f),{editable:this.supportEditing(o.provider)}}async $disposeCustomDocument(r,S){const a=this._editorProviders.get(S);if(!a)throw new Error(`No provider found for '${S}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=k.URI.revive(r),{document:n}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,n),n.dispose()}async $resolveWebviewEditor(r,S,a,i,n,o){const c=this._editorProviders.get(a);if(!c)throw new Error(`No provider found for '${a}'`);const m=D.ViewColumn.to(n),f=this._extHostWebview.createNewWebview(S,i.webviewOptions,c.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(S,a,i.title,m,i.panelOptions,f),T=k.URI.revive(r);switch(c.type){case 1:{const{document:L}=this.getCustomDocumentEntry(a,T);return c.provider.resolveCustomEditor(L,w,o)}case 0:{const L=this._extHostDocuments.getDocument(T);return c.provider.resolveCustomTextEditor(L,w,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,S,a){this.getCustomDocumentEntry(S,r).disposeEdits(a)}async $onMoveCustomEditor(r,S,a){const i=this._editorProviders.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const n=this._extHostWebviewPanels.getWebviewPanel(r);if(!n)throw new Error("No webview found");const o=k.URI.revive(S),c=this._extHostDocuments.getDocument(o);await i.provider.moveCustomTextEditor(c,n,d.CancellationToken.None)}async $undo(r,S,a,i){return this.getCustomDocumentEntry(S,r).undo(a,i)}async $redo(r,S,a,i){return this.getCustomDocumentEntry(S,r).redo(a,i)}async $revert(r,S,a){const i=this.getCustomDocumentEntry(S,r);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,a),i.disposeBackup()}async $onSave(r,S,a){const i=this.getCustomDocumentEntry(S,r);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,a),i.disposeBackup()}async $onSaveAs(r,S,a,i){const n=this.getCustomDocumentEntry(S,r);return this.getCustomEditorProvider(S).saveCustomDocumentAs(n.document,k.URI.revive(a),i)}async $backup(r,S,a){const i=this.getCustomDocumentEntry(S,r),o=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},a);return i.updateBackup(o),o.id}getCustomDocumentEntry(r,S){const a=this._documents.get(r,k.URI.revive(S));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(r){const a=this._editorProviders.get(r)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=R;function p(u){return typeof u.resolveCustomTextEditor=="function"}function h(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function s(u){const r=u.scheme===C.Schemas.file||u.scheme===C.Schemas.untitled?u.fsPath:u.toString();return(0,t.hash)(r)+""}});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[257],be([0,1,3,6,2,33,15,68,5,7]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";var F,y,l,b,g,v,_,R,p,h,s,u,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(o,c,m,f,w,T,L){super();F.set(this,void 0),y.set(this,void 0),l.set(this,void 0),b.set(this,void 0),g.set(this,void 0),v.set(this,void 0),_.set(this,void 0),R.set(this,void 0),p.set(this,!0),h.set(this,!0),s.set(this,!1),u.set(this,this._register(new d.Emitter)),this.onDidDispose=Fe(this,u,"f").event,r.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Fe(this,r,"f").event,it(this,F,o,"f"),it(this,y,c,"f"),it(this,l,m,"f"),it(this,g,T,"f"),it(this,R,w,"f"),it(this,v,f,"f"),it(this,b,L,"f")}dispose(){Fe(this,s,"f")||(it(this,s,!0,"f"),Fe(this,u,"f").fire(),Fe(this,y,"f").$disposeWebview(Fe(this,F,"f")),Fe(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,b,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,l,"f")}get title(){return this.assertNotDisposed(),Fe(this,v,"f")}set title(o){this.assertNotDisposed(),Fe(this,v,"f")!==o&&(it(this,v,o,"f"),Fe(this,y,"f").$setTitle(Fe(this,F,"f"),o))}get iconPath(){return this.assertNotDisposed(),Fe(this,_,"f")}set iconPath(o){this.assertNotDisposed(),Fe(this,_,"f")!==o&&(it(this,_,o,"f"),Fe(this,y,"f").$setIconPath(Fe(this,F,"f"),I.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Fe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,R,"f")=="number"&&Fe(this,R,"f")<0))return Fe(this,R,"f")}get active(){return this.assertNotDisposed(),Fe(this,h,"f")}get visible(){return this.assertNotDisposed(),Fe(this,p,"f")}_updateViewState(o){Fe(this,s,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(it(this,h,o.active,"f"),it(this,p,o.visible,"f"),it(this,R,o.viewColumn,"f"),Fe(this,r,"f").fire({webviewPanel:this}))}reveal(o,c){this.assertNotDisposed(),Fe(this,y,"f").$reveal(Fe(this,F,"f"),{viewColumn:typeof o=="undefined"?void 0:A.ViewColumn.from(o),preserveFocus:!!c})}assertNotDisposed(){if(Fe(this,s,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,g=new WeakMap,v=new WeakMap,_=new WeakMap,R=new WeakMap,p=new WeakMap,h=new WeakMap,s=new WeakMap,u=new WeakMap,r=new WeakMap;class a{constructor(o,c,m){this.webviews=c,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(o,c,m,f,w={}){const T=typeof f=="object"?f.viewColumn:f,L={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof f=="object"&&!!f.preserveFocus},O=(0,k.shouldSerializeBuffersForPostMessage)(o),E=a.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(o),E,c,{title:m,panelOptions:i(w),webviewOptions:(0,k.serializeWebviewOptions)(o,this.workspace,w),serializeBuffersForPostMessage:O},L);const M=this.webviews.createNewWebview(E,w,o);return this.createNewWebviewPanel(E,c,m,T,w,M)}$onDidChangeWebviewPanelViewStates(o){const c=Object.keys(o);c.sort((m,f)=>{const w=o[m],T=o[f];return w.active?1:T.active?-1:+w.visible-+T.visible});for(const m of c){const f=this.getWebviewPanel(m);if(!f)continue;const w=o[m];f._updateViewState({active:w.active,visible:w.visible,viewColumn:A.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,c,m){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:m,extension:o}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(o)}),new P.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(o,c,m,f){const w=this._serializers.get(c);if(!w)throw new Error(`No serializer found for '${c}'`);const{serializer:T,extension:L}=w,O=this.webviews.createNewWebview(o,m.webviewOptions,L),E=this.createNewWebviewPanel(o,c,m.title,f,m.panelOptions,O);await T.deserializeWebviewPanel(E,m.state)}createNewWebviewPanel(o,c,m,f,w,T){const L=new S(o,this._proxy,c,m,f,w,T);return this._webviewPanels.set(o,L),L}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=a;function i(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[258],be([0,1,3,6,68,5,7]),function(ee,e,d,t,I,C,A){"use strict";var k,D,P,F,y,l,b,g,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class R extends t.Disposable{constructor(s,u,r,S,a,i){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),F.set(this,void 0),y.set(this,!1),l.set(this,void 0),b.set(this,void 0),g.set(this,void 0),v.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Fe(this,v,"f").event,_.set(this,this._register(new d.Emitter)),this.onDidDispose=Fe(this,_,"f").event,it(this,P,r,"f"),it(this,b,S,"f"),it(this,k,s,"f"),it(this,D,u,"f"),it(this,F,a,"f"),it(this,l,i,"f")}dispose(){Fe(this,y,"f")||(it(this,y,!0,"f"),Fe(this,_,"f").fire(),Fe(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,b,"f")}set title(s){this.assertNotDisposed(),Fe(this,b,"f")!==s&&(it(this,b,s,"f"),Fe(this,D,"f").$setWebviewViewTitle(Fe(this,k,"f"),s))}get description(){return this.assertNotDisposed(),Fe(this,g,"f")}set description(s){this.assertNotDisposed(),Fe(this,g,"f")!==s&&(it(this,g,s,"f"),Fe(this,D,"f").$setWebviewViewDescription(Fe(this,k,"f"),s))}get visible(){return Fe(this,l,"f")}get webview(){return Fe(this,F,"f")}get viewType(){return Fe(this,P,"f")}_setVisible(s){s===Fe(this,l,"f")||Fe(this,y,"f")||(it(this,l,s,"f"),Fe(this,v,"f").fire())}show(s){this.assertNotDisposed(),Fe(this,D,"f").$show(Fe(this,k,"f"),!!s)}assertNotDisposed(){if(Fe(this,y,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,F=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,g=new WeakMap,v=new WeakMap,_=new WeakMap;class p{constructor(s,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,u,r,S){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:r,extension:s}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(s),u,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(s,u,r,S,a){const i=this._viewProviders.get(u);if(!i)throw new Error(`No view provider found for '${u}'`);const{provider:n,extension:o}=i,c=this._extHostWebview.createNewWebview(s,{},o),m=new R(s,this._proxy,u,r,c,!0);this._webviewViews.set(s,m),await n.resolveWebviewView(m,{state:S},a)}async $onDidChangeWebviewViewVisibility(s,u){this.getWebviewView(s)._setVisible(u)}async $disposeWebviewView(s){const u=this.getWebviewView(s);this._webviewViews.delete(s),u.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const u=this._webviewViews.get(s);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=p}),define(ve[135],be([0,1,3,5,2,10,8,4,14]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class ji{constructor(y){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=y.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,l){let b;if(typeof y=="string"){b=y;try{y=I.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,b,l)}async asExternalUri(y,l){if((0,A.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(y,l);return I.URI.from(b)}};P.InitialState={focused:!0},P=je([ze(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ve[259],be([0,1,9,80,33,38,6,5,2,14]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends A.Disposable{constructor(l,b){super();const g=l.getProxy(k.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=D.URI.file((0,d.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await g.$download(v,_),_})}};F=je([ze(0,P.IExtHostRpcService),ze(1,C.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(ve[260],be([0,1,133,10,188,33]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class A extends d.ExtHostLoggerService{doCreateLogger(D,P,F){return D.scheme===t.Schemas.file?new I.SpdLogLogger(F?.name||(0,C.generateUuid)(),D.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,P):super.doCreateLogger(D,P,F)}}e.ExtHostLoggerService=A}),define(ve[261],be([0,1,60,9,2,67,6,10,13,29]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(r){const S=await super._getWorkspaceStorageURI(r);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const a=S.fsPath;let i=0;do{let n;i===0?n=a:n=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await y(n);const o=t.join(n,"vscode.lock"),c=await v(this._logService,o,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),I.URI.file(n);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function y(u){try{await P.Promises.stat(u);return}catch{}try{await P.Promises.mkdir(u,{recursive:!0})}catch{}}const l=1e3,b=10*60*1e3;class g extends A.Disposable{constructor(r,S){super();this.logService=r,this.filename=S,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const a=await _(r,S);(!a||a.pid!==process.pid)&&(r.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(S,new Date,new Date)}catch(i){r.error(i),r.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{d.unlinkSync(this.filename)}catch{}}async setWillRelease(r){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${r} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+r};await P.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function v(u,r,S){try{const i={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(r,JSON.stringify(i),{flag:"wx"})}catch(i){u.error(i)}const a=await _(u,r);return!a||a.pid!==process.pid?S?(u.info(`Lock '${r}': Could not acquire lock, giving up.`),null):(u.info(`Lock '${r}': Could not acquire lock, checking if the file is stale.`),h(u,r)):(u.info(`Lock '${r}': Lock acquired.`),new g(u,r))}async function _(u,r){let S;try{S=await P.Promises.readFile(r)}catch(a){return u.error(a),null}try{return JSON.parse(String(S))}catch(a){return u.error(a),null}}async function R(u,r){let S;try{S=await P.Promises.stat(r)}catch(a){return u.error(a),0}return S.mtime.getTime()}function p(u){try{return process.kill(u,0),!0}catch{return!1}}async function h(u,r){const S=await _(u,r);if(!S)return u.info(`Lock '${r}': Could not read pid of lock holder.`),s(u,r);if(S.willReleaseAt){let c=S.willReleaseAt-Date.now();if(c<5e3){for(c>0?u.info(`Lock '${r}': The lockfile is scheduled to be released in ${c} ms.`):u.info(`Lock '${r}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,D.timeout)(Math.min(100,c)),await R(u,r)===0)return s(u,r);c=S.willReleaseAt-Date.now()}return s(u,r)}}if(!p(S.pid))return u.info(`Lock '${r}': The pid ${S.pid} appears to be gone.`),s(u,r);const a=await R(u,r),i=Date.now()-a;if(i<=b)return u.info(`Lock '${r}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;u.info(`Lock '${r}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const n=await R(u,r),o=Date.now()-n;return o<=b?(u.info(`Lock '${r}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null):(u.info(`Lock '${r}': The lock looks stale even after waiting for 2s.`),s(u,r))}async function s(u,r){u.info(`Lock '${r}': Deleting a stale lock.`);try{await P.Promises.unlink(r)}catch{}return v(u,r,!0)}}),define(ve[262],be([0,1,33,14,34]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,D,P){return this.createTerminalFromOptions({name:k,shellPath:D,shellArgs:P})}createTerminalFromOptions(k,D){const P=new I.ExtHostTerminal(this._proxy,(0,d.generateUuid)(),k,k.name);return this._terminals.push(P),P.create(k,this._serializeParentTerminal(k,D)),P.value}};C=je([ze(0,t.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(ve[263],be([0,1,5,14,174,6,26,2,37,23,29,7,11,51,3,122,95,12]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(m,f,w){this.remoteAddress=m,this.localAddress=f,this._dispose=w,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function h(c){const m=c.trim().split(`
`),f=[];return m.forEach(T=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);L&&L.length>=3&&f.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),f.reduce((T,L)=>(T[L.socket]=L,T),{})}e.getSockets=h;function s(...c){const m=[].concat(...c.map(r));return[...new Map(m.filter(f=>f.st==="0A").map(f=>{const w=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:u(w[0]),port:parseInt(w[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=s;function u(c){let m="";if(c.length===8)for(let f=c.length-2;f>=0;f-=2)m+=parseInt(c.substr(f,2),16),f!==0&&(m+=".");else for(let f=c.length-4;f>=0;f-=4)m+=parseInt(c.substr(f,4),16).toString(16),f!==0&&(m+=":");return m}e.parseIpAddress=u;function r(c){const m=c.trim().split(`
`),f=m.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return m.map(T=>T.trim().split(/\s+/).reduce((L,O,E)=>(L[f[E]||E]=O,L),{}))}e.loadConnectionTable=r;function S(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function a(c){const m=c.trim().split(`
`),f=[];return m.forEach(w=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);T&&T.length>=4&&f.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),f}e.getRootProcesses=a;async function i(c,m,f){const w=f.reduce((L,O)=>(L[O.pid]=O,L),{}),T=[];return c.forEach(({socket:L,ip:O,port:E})=>{const M=m[L]?m[L].pid:void 0,U=M?w[M]?.cmd:void 0;M&&U&&!S(U)&&T.push({host:O,port:E,detail:U,pid:M})}),T}e.findPorts=i;function n(c,m,f){const w=new Map,T=a(m);for(const L of c){const O=f.get(L.port);if(O){w.set(L.port,O);continue}const E=T.find(M=>M.cmd.includes(`${L.port}`));if(E){let M=E,U;do U=T.find(V=>V.ppid===M.pid),U&&(M=U);while(U);w.set(L.port,{host:L.ip,port:L.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else w.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=n;let o=class extends C.Disposable{constructor(m,f,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(d.MainContext.MainThreadTunnelService),l.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(f,m.displayName);if(w){const T=new p(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,f){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:m,provider:f}),this._proxy.$registerPortsAttributesProvider(m,w),new y.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(m,f,w,T,L){const O=[];for(const M of m){const U=this._portAttributesProviders.get(M);if(!U)return[];O.push(...await Promise.all(f.map(async V=>U.provider.providePortAttributes(V,w,T,L))))}const E=O.filter(M=>!!M);return E.length>0?E.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let f=new _.MovingAverage,w;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),L=(await this.findCandidatePorts()).filter(E=>(0,v.isLocalhost)(E.host)||(0,v.isAllInterfaces)(E.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(E=>E.port).join(", ")}`);const O=new Date().getTime()-T;f.update(O),(!w||JSON.stringify(w)!==JSON.stringify(L))&&(w=L,await this._proxy.$onFoundNewCandidates(w)),await new Promise(E=>setTimeout(()=>E(),this.calculateDelay(f.value)))}}async setTunnelFactory(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let f=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const w=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:f}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,f){if(this._extensionTunnels.has(m.host)){const w=this._extensionTunnels.get(m.host);w.has(m.port)&&(f&&w.get(m.port).disposeListener.dispose(),await w.get(m.port).tunnel.dispose(),w.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(m,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const T=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const L=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:T,disposeListener:L}),b.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const f=await Promise.all(m.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),w=m.filter((T,L)=>f[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(T=>T.port).join(", ")} to ${w.map(T=>T.port).join(", ")}`),w}async findCandidatePorts(){let m="",f="";try{m=await F.Promises.readFile("/proc/net/tcp","utf8"),f=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=s(m,f),T=await new Promise(N=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,B,x)=>{N(B)})}),L=h(T),O=await F.Promises.readdir("/proc"),E=[];for(let N of O)try{const W=Number(N),B=P.joinPath(k.URI.file("/proc"),N);if((await F.Promises.stat(B.fsPath)).isDirectory()&&!isNaN(W)){const $=await F.Promises.readlink(P.joinPath(B,"cwd").fsPath),J=await F.Promises.readFile(P.joinPath(B,"cmdline").fsPath,"utf8");E.push({pid:W,cwd:$,cmd:J})}}catch{}const M=[],U=w.filter(N=>{const W=L[N.socket];return W||M.push(N),W}),V=i(U,L,E);let z;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const N=await new Promise(W=>{(0,D.exec)("ps -F -A -l | grep root",(B,x,$)=>{W(x)})});this._foundRootPorts=n(M,N,this._foundRootPorts),z=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return V.then(N=>z?N.concat(z):N)}};o=je([ze(0,t.IExtHostRpcService),ze(1,A.IExtHostInitDataService),ze(2,R.ILogService)],o),e.ExtHostTunnelService=o}),define(ve[264],be([0,1,13,22,21,16,3,6,104,227,52]),function(ee,e,d,t,I,C,A,k,D,P,F){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(w,T){try{return JSON.stringify(w,T)}catch{return"null"}}const b="$$ref$$",g={[b]:-1};class v{constructor(T,L){this.jsonString=T,this.referencedBuffers=L}}function _(w,T=null,L=!1){const O=[];return{jsonString:(L?l:JSON.stringify)(w,(M,U)=>{if(typeof U=="undefined")return g;if(typeof U=="object"){if(U instanceof t.VSBuffer){const V=O.push(U)-1;return{[b]:V}}if(T)return T(M,U)}return U}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=_;function R(w,T,L){return JSON.parse(w,(O,E)=>{if(E){const M=E[b];if(typeof M=="number")return T[M];if(L&&E.$mid===1)return L.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=R;function p(w,T){return JSON.stringify(w,T)}function h(w){return w?(T,L)=>L&&L.$mid===1?w.transformOutgoing(L):L:null}var s;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var u;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(u=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},S=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(T,L=null,O=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=L,this._uriTransformer=O,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,M=F.ProxyIdentifier.count;E<M;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,D.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:L,sid:O}=T;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,O)),this._proxies[L]}_createProxy(T,L){let O={get:(E,M)=>(typeof M=="string"&&!E[M]&&M.charCodeAt(0)===36&&(E[M]=(...U)=>this._remoteCall(T,M,U)),M===a?L:E[M])};return new Proxy(Object.create(null),O)}set(T,L){return this._locals[T.nid]=L,L}assertRegistered(T){for(let L=0,O=T.length;L<O;L++){const E=T[L];if(!this._locals[E.nid])throw new Error(`Missing proxy instance ${E.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const L=T.byteLength,O=n.read(T,0),E=O.readUInt8(),M=O.readUInt32();switch(E){case 1:case 2:{let{rpcId:U,method:V,args:z}=c.deserializeRequestJSONArgs(O);this._uriTransformer&&(z=(0,D.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(L,M,U,V,z,E===2);break}case 3:case 4:{let{rpcId:U,method:V,args:z}=c.deserializeRequestMixedArgs(O);this._uriTransformer&&(z=(0,D.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(L,M,U,V,z,E===4);break}case 5:{this._logger&&this._logger.logIncoming(L,M,0,"ack"),this._onDidReceiveAcknowledge(M);break}case 6:{this._receiveCancel(L,M);break}case 7:{this._receiveReply(L,M,void 0);break}case 9:{let U=c.deserializeReplyOKJSON(O);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(L,M,U);break}case 10:{const U=c.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(L,M,U);break}case 8:{let U=c.deserializeReplyOKVSBuffer(O);this._receiveReply(L,M,U);break}case 11:{let U=c.deserializeReplyErrError(O);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(L,M,U);break}case 12:{this._receiveReplyErr(L,M,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,L,O,E,M,U){this._logger&&this._logger.logIncoming(T,L,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(O)}.${E}(`,M);const V=String(L);let z,N;if(U){const B=new I.CancellationTokenSource;M.push(B.token),z=this._invokeHandler(O,E,M),N=()=>B.cancel()}else z=this._invokeHandler(O,E,M),N=r;this._cancelInvokedHandlers[V]=N;const W=c.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(W.byteLength,L,1,"ack"),this._protocol.send(W),z.then(B=>{delete this._cancelInvokedHandlers[V];const x=c.serializeReplyOK(L,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,L,1,"reply:",B),this._protocol.send(x)},B=>{delete this._cancelInvokedHandlers[V];const x=c.serializeReplyErr(L,B);this._logger&&this._logger.logOutgoing(x.byteLength,L,1,"replyErr:",B),this._protocol.send(x)})}_receiveCancel(T,L){this._logger&&this._logger.logIncoming(T,L,1,"receiveCancel");const O=String(L);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(T,L,O){this._logger&&this._logger.logIncoming(T,L,0,"receiveReply:",O);const E=String(L);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const M=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],M.resolveOk(O)}_receiveReplyErr(T,L,O){this._logger&&this._logger.logIncoming(T,L,0,"receiveReplyErr:",O);const E=String(L);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const M=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let U;O&&(O.$isError?(U=new Error,U.name=O.name,U.message=O.message,U.stack=O.stack):U=O),M.resolveErr(U)}_invokeHandler(T,L,O){try{return Promise.resolve(this._doInvokeHandler(T,L,O))}catch(E){return Promise.reject(E)}}_doInvokeHandler(T,L,O){const E=this._locals[T];if(!E)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(T));let M=E[L];if(typeof M!="function")throw new Error("Unknown method "+L+" on actor "+(0,F.getStringIdentifierForProxy)(T));return M.apply(E,O)}_remoteCall(T,L,O){if(this._isDisposed)return Promise.reject(C.canceled());let E=null;if(O.length>0&&I.CancellationToken.isCancellationToken(O[O.length-1])&&(E=O.pop()),E&&E.isCancellationRequested)return Promise.reject(C.canceled());const M=c.serializeRequestArguments(O,this._uriReplacer),U=++this._lastMessageId,V=String(U),z=new P.LazyPromise;E&&E.onCancellationRequested(()=>{const W=c.serializeCancel(U);this._logger&&this._logger.logOutgoing(W.byteLength,U,0,"cancel"),this._protocol.send(c.serializeCancel(U))}),this._pendingRPCReplies[V]=z,this._onWillSendRequest(U);const N=c.serializeRequest(U,T,L,M,!!E);return this._logger&&this._logger.logOutgoing(N.byteLength,U,0,`request: ${(0,F.getStringIdentifierForProxy)(T)}.${L}(`,O),this._protocol.send(N),z}}e.RPCProtocol=i,y=S,i.UNRESPONSIVE_TIME=3*1e3;class n{constructor(T,L){this._buff=T,this._offset=L}static alloc(T,L,O){let E=new n(t.VSBuffer.alloc(O+1+4),0);return E.writeUInt8(T),E.writeUInt32(L),E}static read(T,L){return new n(T,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,O}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,O}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,L}static sizeMixedArray(T){let L=0;L+=1;for(let O=0,E=T.length;O<E;O++){const M=T[O];switch(L+=1,M.type){case 1:L+=this.sizeLongString(M.value);break;case 2:L+=this.sizeVSBuffer(M.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(M.value);for(let U=0;U<M.buffers.length;++U)L+=this.sizeVSBuffer(M.buffers[U]);break;case 4:break}}return L}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let L=0,O=T.length;L<O;L++){const E=T[L];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let M=0;M<E.buffers.length;++M)this.writeBuffer(E.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(T);for(let O=0;O<T;O++)switch(this.readUInt8()){case 1:L[O]=this.readLongString();break;case 2:L[O]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),U=this.readLongString(),V=[];for(let z=0;z<M;++z)V.push(this.readVSBuffer());L[O]=new F.SerializableObjectWithBuffers(R(U,V,null));break}case 4:L[O]=void 0;break}return L}}n.sizeUInt32=4;var o;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(o||(o={}));class c{static _useMixedArgSerialization(T){for(let L=0,O=T.length;L<O;L++)if(T[L]instanceof t.VSBuffer||T[L]instanceof F.SerializableObjectWithBuffers||typeof T[L]=="undefined")return!0;return!1}static serializeRequestArguments(T,L){if(this._useMixedArgSerialization(T)){const O=[];for(let E=0,M=T.length;E<M;E++){const U=T[E];if(U instanceof t.VSBuffer)O[E]={type:2,value:U};else if(typeof U=="undefined")O[E]={type:4};else if(U instanceof F.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:z}=_(U.value,L);O[E]={type:3,value:t.VSBuffer.fromString(V),buffers:z}}else O[E]={type:1,value:t.VSBuffer.fromString(p(U,L))}}return{type:1,args:O}}return{type:0,args:p(T,L)}}static serializeRequest(T,L,O,E,M){switch(E.type){case 0:return this._requestJSONArgs(T,L,O,E.args,M);case 1:return this._requestMixedArgs(T,L,O,E.args,M)}}static _requestJSONArgs(T,L,O,E,M){const U=t.VSBuffer.fromString(O),V=t.VSBuffer.fromString(E);let z=0;z+=n.sizeUInt8(),z+=n.sizeShortString(U),z+=n.sizeLongString(V);let N=n.alloc(M?2:1,T,z);return N.writeUInt8(L),N.writeShortString(U),N.writeLongString(V),N.buffer}static deserializeRequestJSONArgs(T){const L=T.readUInt8(),O=T.readShortString(),E=T.readLongString();return{rpcId:L,method:O,args:JSON.parse(E)}}static _requestMixedArgs(T,L,O,E,M){const U=t.VSBuffer.fromString(O);let V=0;V+=n.sizeUInt8(),V+=n.sizeShortString(U),V+=n.sizeMixedArray(E);let z=n.alloc(M?4:3,T,V);return z.writeUInt8(L),z.writeShortString(U),z.writeMixedArray(E),z.buffer}static deserializeRequestMixedArgs(T){const L=T.readUInt8(),O=T.readShortString(),E=T.readMixedArray(),M=new Array(E.length);for(let U=0,V=E.length;U<V;U++){const z=E[U];typeof z=="string"?M[U]=JSON.parse(z):M[U]=z}return{rpcId:L,method:O,args:M}}static serializeAcknowledged(T){return n.alloc(5,T,0).buffer}static serializeCancel(T){return n.alloc(6,T,0).buffer}static serializeReplyOK(T,L,O){if(typeof L=="undefined")return this._serializeReplyOKEmpty(T);if(L instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(T,L);if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:M}=_(L.value,O,!0);return this._serializeReplyOKJSONWithBuffers(T,E,M)}else return this._serializeReplyOKJSON(T,l(L,O))}static _serializeReplyOKEmpty(T){return n.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,L){let O=0;O+=n.sizeVSBuffer(L);let E=n.alloc(8,T,O);return E.writeVSBuffer(L),E.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,L){const O=t.VSBuffer.fromString(L);let E=0;E+=n.sizeLongString(O);let M=n.alloc(9,T,E);return M.writeLongString(O),M.buffer}static _serializeReplyOKJSONWithBuffers(T,L,O){const E=t.VSBuffer.fromString(L);let M=0;M+=n.sizeUInt32,M+=n.sizeLongString(E);for(const V of O)M+=n.sizeVSBuffer(V);let U=n.alloc(10,T,M);U.writeUInt32(O.length),U.writeLongString(E);for(const V of O)U.writeBuffer(V);return U.buffer}static deserializeReplyOKJSON(T){const L=T.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(T,L){const O=T.readUInt32(),E=T.readLongString(),M=[];for(let U=0;U<O;++U)M.push(T.readVSBuffer());return new F.SerializableObjectWithBuffers(R(E,M,L))}static serializeReplyErr(T,L){return L?this._serializeReplyErrEror(T,L):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,L){const O=t.VSBuffer.fromString(l(C.transformErrorForSerialization(L),null));let E=0;E+=n.sizeLongString(O);let M=n.alloc(11,T,E);return M.writeLongString(O),M.buffer}static deserializeReplyErrError(T){const L=T.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(T){return n.alloc(12,T,0).buffer}}var m;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var f;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(f||(f={}))}),define(ve[265],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(ve[266],be([0,1,28,10,9,11,23,2,4,198,43,222,265]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let b=class qi{constructor(v,_,R,p){this.localUserHome=v,this.remoteAgentService=_,this.environmentService=R,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=h?.userHome||v})()}hasValidBasename(v,_,R){return typeof _=="string"||typeof _=="undefined"?this.resolveOS.then(p=>this.doHasValidBasename(v,p,_)):this.doHasValidBasename(v,_,R)}doHasValidBasename(v,_,R){return v.scheme===t.Schemas.file||v.scheme===t.Schemas.vscodeRemote?(0,d.isValidBasename)(R??(0,A.basename)(v),_===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(v,_){if(v.remoteAuthority)return t.Schemas.vscodeRemote;const R=(0,P.getVirtualWorkspaceScheme)(_.getWorkspace());if(R)return R;const p=_.getWorkspace().folders[0];if(p)return p.uri.scheme;const h=_.getWorkspace().configuration;return h?h.scheme:t.Schemas.file}async userHome(v){return v?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(v=>v===1?I.win32:I.posix)}async fileURI(v){let _="";if(await this.resolveOS===1&&(v=v.replace(/\\/g,"/")),v[0]==="/"&&v[1]==="/"){const p=v.indexOf("/",2);p===-1?(_=v.substring(2),v="/"):(_=v.substring(2,p),v=v.substring(p)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:_,path:v,query:"",fragment:""})}};b=je([ze(1,l.IRemoteAgentService),ze(2,y.IWorkbenchEnvironmentService),ze(3,F.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(ve[69],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(A,k){this.line=A,this.character=k}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,k){return new d(0,0)}with(A){return new d(0,0)}}e.Position=d;class t{constructor(A,k,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(A,k),this.end=new d(D,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new t(0,0,0,0)}with(A){return new t(0,0,0,0)}}e.Range=t;var I;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],be([0,1,17,32,25,28,8,4,9,16,69,13]),function(ee,e,d,t,I,C,A,k,D,P,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",g=(l.length+b.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var v;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var _;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function R(W){return!!W.preview}e.resultIsMatch=R;function p(W){return!!W.resource}e.isFileMatch=p;function h(W){return!!W.message}e.isProgressMessage=h;var s;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=u;class r{constructor(B,x,$){this.ranges=x;const J=Array.isArray(x)?x:[x];if($&&$.matchLines===1&&S(J)){B=(0,A.getNLines)(B,$.matchLines);let ne="",re=0,Z=0;const Q=Math.floor($.charsPerLine/5),oe=[];for(const fe of J){const pe=Math.max(fe.startColumn-Q,0),Te=fe.startColumn+$.charsPerLine;if(pe>Z+Q+g){const xe=l+(pe-Z)+b;ne+=xe+B.slice(pe,Te),re+=pe-(Z+xe.length)}else ne+=B.slice(Z,Te);oe.push(new i(0,fe.startColumn-re,fe.endColumn-re)),Z=Te}this.preview={text:ne,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const ne=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:B,matches:(0,d.mapArrayOrNot)(x,re=>new a(re.startLineNumber-ne,re.startColumn,re.endLineNumber-ne,re.endColumn))}}}}e.TextSearchMatch=r;function S(W){const B=W[0].startLineNumber;for(const x of W)if(x.startLineNumber!==B||x.endLineNumber!==B)return!1;return!0}class a{constructor(B,x,$,J){this.startLineNumber=B,this.startColumn=x,this.endLineNumber=$,this.endColumn=J}}e.SearchRange=a;class i extends a{constructor(B,x,$){super(B,x,B,$)}}e.OneLineRange=i;var n;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function o(W,B=!0){const x=W&&W.files&&W.files.exclude,$=B&&W&&W.search&&W.search.exclude;if(!x&&!$)return;if(!x||!$)return x||$;let J=Object.create(null);return J=I.mixin(J,I.deepClone(x)),J=I.mixin(J,I.deepClone($),!0),J}e.getExcludes=o;function c(W,B){return W.excludePattern&&t.match(W.excludePattern,B)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&t.match(W.includePattern,B)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(x=>{const $=x.folder.fsPath;if(C.isEqualOrParent(B,$)){const J=D.relative($,B);return!x.includePattern||!!t.match(x.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var m;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(B,x){super(B);this.code=x}}e.SearchError=f;function w(W){const B=W.message;if((0,P.isCancellationError)(W))return new f(B,m.canceled);try{const x=JSON.parse(B);return new f(x.message,x.code)}catch{return new f(B,m.other)}}e.deserializeSearchError=w;function T(W){const B={message:W.message,code:W.code};return new Error(JSON.stringify(B))}e.serializeSearchError=T;function L(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=L;function O(W){return W.type==="success"}e.isSerializedSearchSuccess=O;function E(W){return!!W.path}e.isSerializedFileMatch=E;function M(W,B){const x=W.searchPath?W.searchPath:W.relativePath;return(0,A.fuzzyContains)(x,B)}e.isFilePatternMatch=M;class U{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function V(W,B){const x={...W||{},...B||{}};return Object.keys(x).filter($=>{const J=x[$];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=V;class z{constructor(B,x){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...x.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let $=B.includePattern;x.includePattern&&($?$={...$,...x.includePattern}:$=x.includePattern),$&&(this._parsedIncludeExpression=t.parse($))}matchesExcludesSync(B,x,$){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,x,$))}includedInQuerySync(B,x,$){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,x,$)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,x,$))}includedInQuery(B,x,$){const J=this._parsedExcludeExpression(B,x,$),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,x,$):!0;return(0,y.isThenable)(J)?J.then(re=>re?!1:ne()):ne()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=z;function N(W){for(const B in W)if(typeof W[B]!="boolean")return!0;return!1}}),define(ve[35],be([0,1,17,13,21,3,24,10,95,23,8,18,2,172,4,12,189,43,44,26,14,15,7,31,5]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h,s,u,r,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(L,O,E){return new P.ExtUri(M=>m(M,E)).isEqual(L,O)}function n(L,O,E){return i(L.uri,O.uri,E)?0:(0,F.compare)(L.uri.toString(),O.uri.toString())}function o(L,O,E){return L.index!==O.index?L.index<O.index?-1:1:i(L.uri,O.uri,E)?(0,F.compare)(L.name,O.name):(0,F.compare)(L.uri.toString(),O.uri.toString())}function c(L,O,E,M){const U=L.slice(0).sort((z,N)=>E(z,N,M)),V=O.slice(0).sort((z,N)=>E(z,N,M));return(0,d.delta)(U,V,(z,N)=>E(z,N,M))}function m(L,O){const E=O.getCapabilities(L.scheme);return!(E&&E&1024)}class f extends R.Workspace{constructor(O,E,M,U,V,z,N){super(O,M.map(W=>new R.WorkspaceFolder(W)),U,V,N);this._name=E,this._isUntitled=z,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(N),M.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(O,E,M,U){if(!O)return{workspace:null,added:[],removed:[]};const{id:V,name:z,folders:N,configuration:W,transient:B,isUntitled:x}=O,$=[],J=E;E?N.forEach((Q,oe)=>{const fe=l.URI.revive(Q.uri),pe=f._findFolder(M||E,fe,U);pe?(pe.name=Q.name,pe.index=Q.index,$.push(pe)):$.push({uri:fe,name:Q.name,index:oe})}):$.push(...N.map(({uri:Q,name:oe,index:fe})=>({uri:l.URI.revive(Q),name:oe,index:fe}))),$.sort((Q,oe)=>Q.index<oe.index?-1:1);const ne=new f(V,z,$,!!B,W?l.URI.revive(W):null,!!x,Q=>m(Q,U)),{added:re,removed:Z}=c(J?J.workspaceFolders:[],ne.workspaceFolders,n,U);return{workspace:ne,added:re,removed:Z}}static _findFolder(O,E,M){for(let U=0;U<O.folders.length;U++){const V=O.workspaceFolders[U];if(i(V.uri,E,M))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,E){return E&&this._structure.get(O)&&(O=(0,P.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let w=class{constructor(O,E,M,U){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=U,this._extHostFileSystemInfo=M,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=O.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(a.MainContext.MainThreadMessageService);const V=E.workspace;this._confirmedWorkspace=V?new f(V.id,V.name,[],!!V.transient,V.configuration?l.URI.revive(V.configuration):null,!!V.isUntitled,z=>m(z,M)):void 0}$initializeWorkspace(O,E){this._trusted=E,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,E,M,...U){const V=[];if(Array.isArray(U)&&U.forEach(x=>{l.URI.isUri(x.uri)&&!V.some($=>i($.uri,x.uri,this._extHostFileSystemInfo))&&V.push({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[E,M].some(x=>typeof x!="number"||x<0)||M===0&&V.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(E+M>z.length)return!1;const N=z.slice(0);N.splice(E,M,...V.map(x=>({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<N.length;x++){const $=N[x];if(N.some((J,ne)=>ne!==x&&i($.uri,J.uri,this._extHostFileSystemInfo)))return!1}N.forEach((x,$)=>x.index=$);const{added:W,removed:B}=c(z,N,o,this._extHostFileSystemInfo);if(W.length===0&&B.length===0)return!1;if(this._proxy){const x=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(x,E,M,V).then(void 0,$=>{this._unconfirmedWorkspace=void 0;const J={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(_.Severity.Error,(0,b.localize)(0,null,x,$.toString()),J,[])})}return this.trySetWorkspaceFolders(N),!0}getWorkspaceFolder(O,E){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,E)}async getWorkspaceFolder2(O,E){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,E)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,E){let M,U="";if(typeof O=="string"?(M=l.URI.file(O),U=O):typeof O!="undefined"&&(M=O,U=O.fsPath),!M)return U;const V=this.getWorkspaceFolder(M,!0);if(!V)return U;typeof E=="undefined"&&this._actualWorkspace&&(E=this._actualWorkspace.folders.length>1);let z=(0,P.relativePath)(V.uri,M);return E&&V.name&&(z=`${V.name}/${z}`),z}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:E,added:M,removed:U}=f.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=E||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:M,removed:U}))}findFiles(O,E,M,U,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let z;if(E===null?z=!1:E&&(typeof E=="string"?z=E:z=E.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:N,folder:W}=T(u.GlobPattern.from(O));return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(N),(0,y.withUndefinedAsNull)(W),(0,y.withUndefinedAsNull)(z),(0,y.withUndefinedAsNull)(M),V).then(B=>Array.isArray(B)?B.map(x=>l.URI.revive(x)):[])}async findTextInFiles(O,E,M,U,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),N=typeof E.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:E.previewOptions,{includePattern:W,folder:B}=T(u.GlobPattern.from(E.include)),x=typeof E.exclude=="string"?E.exclude:E.exclude?E.exclude.pattern:void 0,$={ignoreSymlinks:typeof E.followSymlinks=="boolean"?!E.followSymlinks:void 0,disregardIgnoreFiles:typeof E.useIgnoreFiles=="boolean"?!E.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof E.useGlobalIgnoreFiles=="boolean"?!E.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof E.useParentIgnoreFiles=="boolean"?!E.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof E.useDefaultExcludes=="boolean"?!E.useDefaultExcludes:!0,fileEncoding:E.encoding,maxResults:E.maxResults,previewOptions:N,afterContext:E.afterContext,beforeContext:E.beforeContext,includePattern:W,excludePattern:x},J=!1;if(this._activeSearchCallbacks[z]=ne=>{if(J)return;const re=l.URI.revive(ne.resource);ne.results.forEach(Z=>{(0,S.resultIsMatch)(Z)?M({uri:re,preview:{text:Z.preview.text,matches:(0,d.mapArrayOrNot)(Z.preview.matches,Q=>new r.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))},ranges:(0,d.mapArrayOrNot)(Z.ranges,Q=>new r.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))}):M({uri:re,text:Z.text,lineNumber:Z.lineNumber})})},V.isCancellationRequested)return{};try{const ne=await this._proxy.$startTextSearch(O,(0,y.withUndefinedAsNull)(B),$,z,V);return delete this._activeSearchCallbacks[z],ne||{}}catch(ne){throw delete this._activeSearchCallbacks[z],ne}}$handleTextSearchResult(O,E){this._activeSearchCallbacks[E]&&this._activeSearchCallbacks[E](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=je([ze(0,s.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,p.IExtHostFileSystemInfo),ze(3,v.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function T(L){let O,E;return L&&(typeof L=="string"?O=L:(O=L.pattern,E=l.URI.revive(L.baseUri))),{includePattern:O,folder:E}}}),define(ve[36],be([0,1,25,3,35,5,7,193,119,18,13,4,14,12,2]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(S,a){if(a){const i=a.split(".");let n=S;for(let o=0;n&&o<i.length;o++)n=n[i[o]];return n}}function _(S){return S instanceof g.URI}function R(S){return S&&S.uri instanceof g.URI&&S.languageId&&typeof S.languageId=="string"}function p(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function h(S){return S&&S.uri instanceof g.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function s(S){if(_(S))return{resource:S};if(R(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(p(S))return{overrideIdentifier:S.languageId};if(h(S))return{resource:S.uri};if(S===null)return{resource:null}}let u=class{constructor(a,i,n){this._proxy=a.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=n,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new r(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(a,i))}};u=je([ze(0,l.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,b.ILogService)],u),e.ExtHostConfiguration=u;class r{constructor(a,i,n,o){this._onDidChangeConfiguration=new t.Emitter,this._proxy=a,this._logService=o,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,i){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,n))}getConfiguration(a,i,n){const o=s(i)||{},c=this._toReadonlyValue(a?v(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,o,n?.identifier);function m(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(w){return typeof v(c,w)!="undefined"},get:(w,T)=>{this._validateConfigurationAccess(a?`${a}.${w}`:w,o,n?.identifier);let L=v(c,w);if(typeof L=="undefined")L=T;else{let O;const E=(M,U)=>{let V;const z=()=>{O=O||(0,d.deepClone)(c),V=V||v(O,U)};return(0,P.isObject)(M)?new Proxy(M,{get:(N,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return z(),()=>V;if(O)return V=V||v(O,U),V[W];const B=N[W];return typeof W=="string"?E(B,`${U}.${W}`):B},set:(N,W,B)=>(z(),V&&(V[W]=B),!0),deleteProperty:(N,W)=>(z(),V&&delete V[W],!0),defineProperty:(N,W,B)=>(z(),V&&Object.defineProperty(V,W,B),!0)}):M};L=E(L,w)}return L},update:(w,T,L,O)=>{w=a?`${a}.${w}`:w;const E=m(L);return T!==void 0?this._proxy.$updateConfigurationOption(E,w,T,o,O):this._proxy.$removeConfigurationOption(E,w,o,O)},inspect:w=>{w=a?`${a}.${w}`:w;const T=(0,d.deepClone)(this._configuration.inspect(w,o,this._extHostWorkspace.workspace));if(T)return{key:w,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof c=="object"&&(0,d.mixin)(f,c,!1),Object.freeze(f)}_toReadonlyValue(a){const i=n=>(0,P.isObject)(n)?new Proxy(n,{get:(o,c)=>i(o[c]),set:(o,c,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(o,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(o,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return i(a)}_validateConfigurationAccess(a,i,n){const o=D.OVERRIDE_PROPERTY_REGEX.test(a)?4:this._configurationScopes.get(a),c=n?`[${n.value}] `:"";if(o===4){typeof i?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){i?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,i){const n=new k.ConfigurationChangeEvent(a,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,c)=>n.affectsConfiguration(o,s(c))})}_toMap(a){return a.reduce((i,n)=>(i.set(n[0],n[1]),i),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[70],be([0,1,2,13,3,5,7,35,45,36,21,34,14,26,4,10,11,12,65,214,16]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h,s){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(U){function V(N){if(N!=null)return N}U.from=V;function z(N){if(N!=null)return N}U.to=z})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(U){function V(N){if(N!=null)return N}U.from=V;function z(N){if(N!=null)return N}U.to=z})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(U){function V(N){if(N!=null)return N}U.from=V;function z(N){if(N!=null)return N}U.to=z})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(U){function V(W){if(W){const B=W;return B&&!!B.process}else return!1}U.is=V;function z(W){if(W==null)return;const B={process:W.process,args:W.args};return W.options&&(B.options=a.from(W.options)),B}U.from=z;function N(W){if(W!=null)return new A.ProcessExecution(W.process,W.args,W.options)}U.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(U){function V(N){if(N!=null)return N}U.from=V;function z(N){if(N!=null)return N}U.to=z})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(U){function V(W){if(W){const B=W;return B&&(!!B.commandLine||!!B.command)}else return!1}U.is=V;function z(W){if(W==null)return;const B={};return W.commandLine!==void 0?B.commandLine=W.commandLine:(B.command=W.command,B.args=W.args),W.options&&(B.options=n.from(W.options)),B}U.from=z;function N(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new A.ShellExecution(W.commandLine,W.options):new A.ShellExecution(W.command,W.args?W.args:[],W.options)}U.to=N})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(U){function V(W){if(W){let B=W;return B&&B.customExecution==="customExecution"}else return!1}U.is=V;function z(W){return{customExecution:"customExecution"}}U.from=z;function N(W,B){return B.get(W)}U.to=N})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(U){function V(z,N){let W;return z.scope!==void 0&&typeof z.scope!="number"?W=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?W=N.workspaceFile:W=h.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:W}}U.from=V})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(U){function V(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}U.from=V})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(U){function V(W,B){if(W==null)return[];const x=[];for(let $ of W){const J=z($,B);J&&x.push(J)}return x}U.fromMany=V;function z(W,B){if(W==null)return;let x;W.execution instanceof A.ProcessExecution?x=i.from(W.execution):W.execution instanceof A.ShellExecution?x=o.from(W.execution):W.execution&&W.execution instanceof A.CustomExecution&&(x=c.from(W.execution));const $=r.from(W.definition);let J;return W.scope?typeof W.scope=="number"?J=W.scope:J=W.scope.uri:J=A.TaskScope.Workspace,!$||!J?void 0:{_id:W._id,definition:$,name:W.name,source:{extensionId:B.identifier.value,label:W.source,scope:J},execution:x,isBackground:W.isBackground,group:f.from(W.group),presentationOptions:S.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}U.from=z;async function N(W,B,x){if(W==null)return;let $;i.is(W.execution)?$=i.to(W.execution):o.is(W.execution)?$=o.to(W.execution):c.is(W.execution)&&($=c.to(W._id,x));const J=r.to(W.definition);let ne;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?ne=W.source.scope:ne=await B.resolveWorkspaceFolder(d.URI.revive(W.source.scope)):ne=A.TaskScope.Workspace),!J||!ne)return;const re=new A.Task(J,ne,W.name,W.source.label,$,W.problemMatchers);return W.isBackground!==void 0&&(re.isBackground=W.isBackground),W.group!==void 0&&(re.group=A.TaskGroup.from(W.group._id),re.group&&W.group.isDefault&&(re.group=new A.TaskGroup(re.group.id,re.group.label),W.group.isDefault&&(re.group.isDefault=W.group.isDefault))),W.presentationOptions&&(re.presentationOptions=S.to(W.presentationOptions)),W._id&&(re._id=W._id),W.detail&&(re.detail=W.detail),re}U.to=N})(w=e.TaskDTO||(e.TaskDTO={}));var T;(function(U){function V(N){return N}U.from=V;function z(N){if(!!N)return Object.assign(Object.create(null),N)}U.to=z})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(V,z,N){this._id=z,this._task=N,u.set(this,void 0),it(this,u,V,"f")}get task(){return this._task}terminate(){Fe(this,u,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}u=new WeakMap;var O;(function(U){function V(z){return{id:z._id,task:void 0}}U.from=V})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor(V,z,N,W,B,x,$,J){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=V.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=W,this._configurationService=B,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,z,N){if(!N)return new A.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:z,provider:N,extension:V}),this._proxy.$registerTaskProvider(W,z),new A.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(V,z){this._proxy.$registerTaskSystem(V,z)}fetchTasks(V){return this._proxy.$fetchTasks(T.from(V)).then(async z=>{const N=[];for(let W of z){const B=await w.to(W,this._workspaceProvider,this._providedCustomExecutions2);B&&N.push(B)}return N})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(z=>V.push(z)),V}terminateTask(V){if(!(V instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,z,N){const W=this._providedCustomExecutions2.get(V.id);W&&(this._activeCustomExecutions2.set(V.id,W),this._terminalService.attachPtyToTerminal(z,await W.callback(N))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const z=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const z=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:z,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const z=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:V.exitCode})}$provideTasks(V,z){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));const W=[],B=(0,t.asPromise)(()=>N.provider.provideTasks(F.CancellationToken.None)).then(x=>this.provideTasksInternal(z,W,N,x));return new Promise(x=>{B.then($=>{Promise.all(W).then(()=>{x($)})})})}async $resolveTask(V,z){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const W=await w.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const B=await N.provider.resolveTask(W,F.CancellationToken.None);if(!B)return;this.checkDeprecation(B,N);const x=w.from(B,N.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(x.execution)&&await this.addCustomExecution(x,B,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,z,N){const W=await this._proxy.$createTaskId(V);!N&&!this._providedCustomExecutions2.has(W)&&(this._notProvidedCustomExecutions.add(W),this._activeCustomExecutions2.set(W,z.execution)),this._providedCustomExecutions2.set(W,z.execution)}async getTaskExecution(V,z){if(typeof V=="string"){const B=this._taskExecutionPromises.get(V);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let N=this._taskExecutionPromises.get(V.id);if(N)return N;const W=new Promise((B,x)=>{function $(J,ne,re){re?B(new L(J,ne.id,re)):x("Unexpected: Task does not exist.")}z?$(this,V,z):w.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>$(this,V,J))});return this._taskExecutionPromises.set(V.id,W),W.then(B=>(this._taskExecutions.set(V.id,B),B),B=>Promise.reject(B))}checkDeprecation(V,z){V._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let N=this._notProvidedCustomExecutions.values(),W=N.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=N.next()}};E=je([ze(0,l.IExtHostRpcService),ze(1,b.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,R.ILogService),ze(7,p.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let M=class extends E{constructor(V,z,N,W,B,x,$,J){super(V,z,N,W,B,x,$,J);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(V,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=w.from(z,V);if(N===void 0)throw new Error("Task is not valid");if(c.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new s.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(B=>{throw new Error(B)}),W}provideTasksInternal(V,z,N,W){const B=[];if(W)for(let x of W){this.checkDeprecation(x,N),(!x.definition||!V[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const $=w.from(x,N.extension);$&&c.is($.execution)?(B.push($),z.push(this.addCustomExecution($,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:N.extension}}async resolveTaskInternal(V){if(c.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,z,N){}};M=je([ze(0,l.IExtHostRpcService),ze(1,b.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,R.ILogService),ze(7,p.IExtHostApiDeprecationService)],M),e.WorkerExtHostTask=M,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(ve[267],be([0,1,17,74,32,79,24,10,9,23,8,18,2,152,178,116,43,129,266,31]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(m,f,w,T){this.configurationService=m,this.workspaceContextService=f,this.editorGroupsService=w,this.pathService=T}text(m,f,w={}){m=this.getContentPattern(m,w);const T=this.configurationService.getValue(),L=f&&f.some(E=>!this.configurationService.getValue({resource:E}).search.useRipgrep);return{...this.commonQuery(f?.map(_.toWorkspaceFolder),w),type:2,contentPattern:m,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:T.search.usePCRE2||L||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}getContentPattern(m,f){const w=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const T={...m,wordSeparators:w.editor.wordSeparators};return this.isCaseSensitive(m,f)&&(T.isCaseSensitive=!0),this.isMultiline(m)&&(T.isMultiline=!0),T}file(m,f={}){return{...this.commonQuery(m,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(m,f){return m?(m=Array.isArray(m)?m.map(i):i(m),f?this.parseSearchPaths(m):{pattern:r(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],f={}){const w=this.handleIncludeExclude(f.includePattern,f.expandPatterns),T=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),L=m.length>1,O=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,f,T)):m.map(U=>this.getFolderQueryForRoot(U,f,T,L))).filter(U=>!!U),E={_reason:f._reason,folderQueries:O,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:T.pattern,includePattern:w.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const V=d.coalesce(d.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(W=>W.resource)))).filter(N=>(0,h.pathIncludedInQuery)(E,N.fsPath)),z=this.commonQueryFromFileList(V);return{...E,...z}}const M=f.extraFileResources&&f.extraFileResources.filter(U=>(0,h.pathIncludedInQuery)(E,U.fsPath));return E.extraFileResources=M&&M.length?M:void 0,E}commonQueryFromFileList(m){const f=[],w=new A.ResourceMap,T={};let L=!1;return m.forEach(O=>{if(O.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(O)){const M=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:D.dirname(O.fsPath)});let U=w.get(M);U||(L=!0,U={folder:M,includePattern:{}},f.push(U),w.set(M,U));const V=D.relative(M.fsPath,O.fsPath);(0,y.assertIsDefined)(U.includePattern)[V.replace(/\\/g,"/")]=!0}else O.fsPath&&(L=!0,T[O.fsPath]=!0)}),{folderQueries:f,includePattern:T,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(m,f){if(f.isSmartCase){if(m.isRegExp){if(F.containsUppercaseCharacter(m.pattern,!0))return!0}else if(F.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,b.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const f=z=>D.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),T=(Array.isArray(m)?m:S(m)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,C.untildify)(z,N.scheme===k.Schemas.file?N.fsPath:N.path):z}),L=t.groupBy(T,z=>f(z)?"searchPaths":"exprSegments"),O=(L.exprSegments||[]).map(z=>F.rtrim(z,"/")).map(z=>F.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),a(z))),E={},M=this.expandSearchPathPatterns(L.searchPaths||[]);M&&M.length&&(E.searchPaths=M);const U=d.flatten(O),V=r(...U);return V&&(E.pattern=V),E}getExcludesForFolder(m,f){return f.disregardExcludeSettings?void 0:(0,h.getExcludes)(m,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const f=d.flatten(m.map(T=>{let{pathPortion:L,globPortion:O}=u(T);O&&(O=n(O));const E=this.expandOneSearchPath(L);return d.flatten(E.map(M=>this.resolveOneSearchPathPattern(M,O)))})),w=new Map;return f.forEach(T=>{const L=T.searchPath.toString(),O=w.get(L);O?T.pattern&&(O.pattern=O.pattern||{},O.pattern[T.pattern]=!0):w.set(L,{searchPath:T.searchPath,pattern:T.pattern?r(T.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(m){if(D.isAbsolute(m)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==k.Schemas.file?[{searchPath:f[0].uri.with({path:m})}]:[{searchPath:l.URI.file(D.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=i(m),m.startsWith("../")||m===".."){const T=D.posix.resolve(f.path,m);return[{searchPath:f.with({path:T})}]}const w=n(m);return[{searchPath:f,pattern:w}]}else{if(m==="./"||m===".\\")return[];{const f=m.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(L=>{const O=f.match(new RegExp(`^${F.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return O?{match:O,folder:L}:null}).filter(y.isDefined);if(T.length)return T.map(L=>{const O=L.match[1];return{searchPath:L.folder.uri,pattern:O&&n(O)}});{const L=m.match(/\.[\/\\](.+)[\/\\]?/),O=L?L[1]:m,E=g.localize(0,null,O);throw new Error(E)}}}}resolveOneSearchPathPattern(m,f){const w=m.pattern&&f?`${m.pattern}/${f}`:m.pattern||f,T=[{searchPath:m.searchPath,pattern:w}];return w&&!w.endsWith("**")&&T.push({searchPath:m.searchPath,pattern:w+"/**"}),T}getFolderQueryForSearchPath(m,f,w){const T=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(m.searchPath),f,w,!1);return T?{...T,includePattern:m.pattern}:null}getFolderQueryForRoot(m,f,w,T){let L;const O=l.URI.isUri(m)?m:m.uri;if(w.searchPaths){const z=w.searchPaths.filter(N=>(0,P.isEqual)(N.searchPath,O))[0];if(z&&!z.pattern)return null;z&&(L=z.pattern)}const E=this.configurationService.getValue({resource:O}),U={...this.getExcludesForFolder(E,f)||{},...L||{}},V=l.URI.isUri(m)?(0,P.basename)(m):m.name;return{folder:O,folderName:T?V:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:E.files&&E.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!E.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!E.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!E.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!E.search.followSymlinks}}};s=je([ze(0,v.IConfigurationService),ze(1,_.IWorkspaceContextService),ze(2,R.IEditorGroupsService),ze(3,p.IPathService)],s),e.QueryBuilder=s;function u(c){const m=c.match(/[\*\{\}\(\)\[\]\?]/);if(m){const f=m.index,w=c.substr(0,f).match(/[/|\\][^/\\]*$/);if(w){let T=c.substr(0,w.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:c.substr((w.index||0)+1)}}}return{pathPortion:c}}function r(...c){return c.length?c.reduce((m,f)=>(m[f]=!0,m),Object.create(null)):void 0}function S(c){return I.splitGlobAware(c,",").map(m=>m.trim()).filter(m=>!!m.length)}function a(c){return[`**/${c}/**`,`**/${c}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function i(c){return c.replace(/\\/g,"/")}function n(c){return i(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(c,m){c=d.distinct(c,T=>T.toString());const f=[],w=m.getWorkspace();return c&&c.forEach(T=>{let L;if(m.getWorkbenchState()===2)L=(0,P.relativePath)(w.folders[0].uri,T),L&&L!=="."&&(L="./"+L);else{const O=m.getWorkspaceFolder(T);if(O){const E=O.name;if(w.folders.filter(U=>U.name===E).length===1){const U=(0,P.relativePath)(O.uri,T);U===""?L=`./${O.name}`:L=`./${O.name}/${U}`}else L=T.fsPath}}L&&f.push(L)}),f}e.resolveResourcesForSearchIncludes=o}),define(ve[268],be([0,1,23,2,21,16,4,267,31,43]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function y(v,_){const R=_.activationEvents;if(!R)return Promise.resolve(void 0);const p=[],h=[];for(const i of R)if(/^workspaceContains:/.test(i)){const n=i.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||v.forceUsingSearch?h.push(n):p.push(n)}if(p.length===0&&h.length===0)return Promise.resolve(void 0);let s;const u=new Promise((i,n)=>{s=i}),r=i=>s({activationEvent:i}),S=Promise.all(p.map(i=>l(v,i,r))).then(()=>{}),a=b(v,_.identifier,h,r);return Promise.all([S,a]).then(()=>{s(void 0)}),u}e.checkActivateWorkspaceContainsExtension=y;async function l(v,_,R){for(const p of v.folders)if(await v.exists(d.joinPath(t.URI.revive(p),_))){R(`workspaceContains:${_}`);return}}async function b(v,_,R,p){if(R.length===0)return Promise.resolve(void 0);const h=new I.CancellationTokenSource,s=v.checkExists(v.folders,R,h.token),u=setTimeout(async()=>{h.cancel(),v.logService.info(`Not activating extension '${_.value}': Timed out while searching for 'workspaceContains' pattern ${R.join(",")}`)},F);let r=!1;try{r=await s}catch(S){C.isCancellationError(S)||C.onUnexpectedError(S)}h.dispose(),clearTimeout(u),r&&p(`workspaceContains:${R.join(",")}`)}function g(v,_,R,p){const h=v.get(A.IInstantiationService),s=v.get(D.ISearchService),r=h.createInstance(k.QueryBuilder).file(_.map(S=>(0,P.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:R,exists:!0});return s.fileSearch(r,p).then(S=>!!S.limitHit,S=>C.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=g});var it=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Fe=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(ve[39],be([0,1,167,9,71,23,13,6,24,2,12,5,36,225,91,35,30,223,16,27,22,200,7,120,4,26,67,14,84,51,34,3,268,90,202,10]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h,s,u,r,S,a,i,n,o,c,m,f,w,T,L,O,E){"use strict";var M,U,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Gi extends k.Disposable{constructor($,J,ne,re,Z,Q,oe,fe,pe,Te){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=J,this._extHostContext=ne,this._initData=oe,this._extHostWorkspace=re,this._extHostConfiguration=Z,this._logService=Q,this._extHostTunnelService=pe,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new R.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=fe,this._instaService=$.createChild(new c.ServiceCollection([g.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(qe=>xe.add(h.ExtensionIdentifier.toKey(qe))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,Qe,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,p.transformErrorForSerialization(Qe),q)},actualActivateExtension:async(qe,Qe)=>{if(xe.has(h.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,Qe),new b.HostExtension;const q=this._registry.getExtensionDescription(qe);return this._activateExtension(q,Qe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){p.onUnexpectedError($)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let $=[];try{$=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all($)}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}_activateByEvent($,J){return this._activator.activateByEvent($,J)}_activateById($,J){return this._activator.activateById($,J)}activateByIdWithErrors($,J){return this._activateById($,J).then(()=>{const ne=this._activator.getActivatedExtension($);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._registry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}async _realPathExtensionUri($){if($.scheme!==E.Schemas.file)return $;const J=await this._hostUtils.realpath($.fsPath);return P.URI.file(J)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const $=D.TernarySearchTree.forUris(J=>C.extUriBiasedIgnorePathCase.ignorePathCasing(J));for(const J of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(J)){const ne=await this._realPathExtensionUri(J.extensionLocation);$.set(ne,J)}return $})()),this._extensionPathIndex}_deactivate($){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return J;const ne=this._activator.getActivatedExtension($);if(!ne)return J;try{typeof ne.module.deactivate=="function"&&(J=Promise.resolve(ne.module.deactivate()).then(void 0,re=>(this._logService.error(re),Promise.resolve(void 0))))}catch(re){this._logService.error(`An error occurred when deactivating the extension '${$.value}':`),this._logService.error(re)}try{(0,k.dispose)(ne.subscriptions)}catch(re){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${$.value}':`),this._logService.error(re)}return J}async _activateExtension($,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,J).then(ne=>{const re=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,J),this._logExtensionActivationTimes($,J,"success",re),ne},ne=>{throw this._logExtensionActivationTimes($,J,"failure"),ne})}_logExtensionActivationTimes($,J,ne,re){const Z=N($,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...re||{},outcome:ne})}_doActivateExtension($,J){const ne=N($,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const re=this._getEntryPoint($);if(!re)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${$.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const Z=new b.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule($.identifier,(0,C.joinPath)($.extensionLocation,re),Z),this._loadExtensionContext($)]).then(Q=>(I.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),Gi._callActivate(this._logService,$.identifier,Q[0],Q[1],Z))).then(Q=>(I.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),Q))}_loadExtensionContext($){const J=new u.ExtensionGlobalMemento($,this._storage),ne=new u.ExtensionMemento($.identifier.value,!1,this._storage),re=new O.ExtensionSecrets($,this._secretState),Z=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Q=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([J.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const oe=this;let fe,pe;const Te=(0,_.isProposedApiEnabled)($,"ipc")?this._initData.messagePorts?.get(h.ExtensionIdentifier.toKey($.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:ne,secrets:re,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(xe){return t.join($.extensionLocation.fsPath,xe)},get storagePath(){return oe._storagePath.workspaceValue($)?.fsPath},get globalStoragePath(){return oe._storagePath.globalValue($).fsPath},get logPath(){return t.join(oe._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return P.URI.joinPath(oe._initData.logsLocation,$.identifier.value)},get storageUri(){return oe._storagePath.workspaceValue($)},get globalStorageUri(){return oe._storagePath.globalValue($)},get extensionMode(){return Z},get extension(){return fe===void 0&&(fe=new W(oe,$.identifier,$,Q)),fe},get extensionRuntime(){return(0,_.checkProposedApiEnabled)($,"extensionRuntime"),oe.extensionRuntime},get environmentVariableCollection(){return oe._extHostTerminalService.getEnvironmentVariableCollection($)},get messagePassingProtocol(){if(!pe){if(!Te)return;const xe=w.Event.buffer(w.Event.fromDOMEventEmitter(Te,"message",qe=>qe.data));Te.start(),pe={onDidReceiveMessage:xe,postMessage:Te.postMessage.bind(Te)}}return pe}})})}static _callActivate($,J,ne,re,Z){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional($,J,ne,re,Z).then(Q=>new b.ActivatedExtension(!1,null,Z.build(),ne,Q,re.subscriptions))}static _callActivateOptional($,J,ne,re,Z){if(typeof ne.activate=="function")try{Z.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Q=typeof global=="object"?global:self,oe=ne.activate.apply(Q,[re]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(oe).then(fe=>(Z.activateResolveStop(),fe))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(ne)}_activateOneStartupFinished($,J){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:J}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const $ of this._registry.getAllExtensionDescriptions())if($.activationEvents)for(const J of $.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished($,J)}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(J),re=Promise.all([$,ne]).then(()=>{});return Promise.race([re,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension($,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,J){if(this.isActivated(J.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={logService:this._logService,folders:$.map(Q=>Q.uri),forceUsingSearch:ne,exists:Q=>this._hostUtils.exists(Q.fsPath),checkExists:(Q,oe,fe)=>this._mainThreadWorkspaceProxy.$checkExists(Q,oe,fe)},Z=await(0,T.checkActivateWorkspaceContainsExtension)(re,J);if(!!Z)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:Z.activationEvent}).then(void 0,Q=>this._logService.error(Q))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:J}=this._initData.environment;if(!$||!J)throw new Error(d.localize(0,null));const ne=await this._loadCommonJSModule(null,J,new b.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(d.localize(1,null,J.toString()));return new Promise((re,Z)=>{const Q=(pe,Te)=>{pe?Z(pe):re(typeof Te=="number"&&Te>0?1:0)},oe=(0,C.originalFSPath)(J),fe=ne.run(oe,Q);fe&&fe.then&&fe.then(()=>{re(0)}).catch(pe=>{Z(pe instanceof Error&&pe.stack?pe.stack:String(pe))})})}async $extensionTestsExit($){this._logService.info(`Extension host terminating: test runner requested exit with code ${$}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${$}`),this._logService.flush(),this._hostUtils.exit($)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver($,J){return this._resolvers[$]=J,(0,k.toDisposable)(()=>{delete this._resolvers[$]})}async _activateAndGetResolver($){const J=$.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const ne=$.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority($,J){this._logService.info(`$resolveAuthority invoked for authority (${B($)})`);const{authorityPrefix:ne,resolver:re}=await this._activateAndGetResolver($);if(!re)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(re)),I.mark(`code/extHost/willResolveAuthority/${ne}`);const Z=await re.resolve($,{resolveAttempt:J});I.mark(`code/extHost/didResolveAuthorityOK/${ne}`);const Q={authority:$,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},oe={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted,authenticationSession:Z.authenticationSessionForInitializingExtensions?{id:Z.authenticationSessionForInitializingExtensions.id,providerId:Z.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Q,options:oe,tunnelInformation:{environmentTunnels:Z.environmentTunnels,features:Z.tunnelFeatures}}}}catch(Z){if(I.mark(`code/extHost/didResolveAuthorityError/${ne}`),Z instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI($,J){this._logService.info(`$getCanonicalURI invoked for authority (${B($)})`);const{authorityPrefix:ne,resolver:re}=await this._activateAndGetResolver($);if(!re)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ne}`);const Z=P.URI.revive(J);if(typeof re.getCanonicalURI=="undefined")return Z;const Q=await(0,A.asPromise)(()=>re.getCanonicalURI(Z));return Q||Z}$startExtensionHost($){return this._registry.keepOnly($),this._startExtensionHost()}$activateByEvent($,J){return J===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent($,!1))}async $activate($,J){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription($)?(await this._activateById($,J),!0):!1}async $deltaExtensions($,J){$.forEach(re=>re.extensionLocation=P.URI.revive(re.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(J.map(async re=>{const Z=this._registry.getExtensionDescription(re);Z&&ne.delete(await this._realPathExtensionUri(Z.extensionLocation))})),await Promise.all($.map(async re=>{const Z=await this._realPathExtensionUri(re.extensionLocation);ne.set(Z,re)})),this._registry.deltaExtensions($,J),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){let J=s.VSBuffer.alloc($),ne=Math.random()%256;for(let re=0;re<$;re++)J.writeUInt8(ne,re);return J}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};z=je([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,o.IExtHostRpcService),ze(3,v.IExtHostWorkspace),ze(4,l.IExtHostConfiguration),ze(5,F.ILogService),ze(6,i.IExtHostInitDataService),ze(7,n.IExtensionStoragePaths),ze(8,m.IExtHostTunnelService),ze(9,f.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function N(x,$){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor($,J,ne,re){M.set(this,void 0),U.set(this,void 0),V.set(this,void 0),it(this,M,$,"f"),it(this,U,J,"f"),it(this,V,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=t.normalize((0,C.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=re}get isActive(){return Fe(this,M,"f").isActivated(Fe(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Fe(this,M,"f").getExtensionExports(Fe(this,V,"f"))}activate(){return Fe(this,M,"f").activateByIdWithErrors(Fe(this,V,"f"),{startup:!1,extensionId:Fe(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,M=new WeakMap,U=new WeakMap,V=new WeakMap;function B(x){const $=x.indexOf("+");return $===-1?x:x.substring(0,$)}}),define(ve[54],be([0,1,9,2,3,13,5,7,125,35,39,45,216,36,209,14,4,18,40,53]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let s=class{constructor(c,m,f,w,T,L){this._workspaceService=m,this._extensionService=f,this._editorsService=w,this._configurationService=T,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=c.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(E=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,m){const f=c;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let w=`debug:${encodeURIComponent(f.path||"")}`,T="?";return m&&(w+=`${T}session=${encodeURIComponent(m.id)}`,T="&"),w+=`${T}ref=${f.sourceReference}`,t.URI.parse(w)}else{if(f.path)return t.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const m=[];for(const f of c.getAllExtensionDescriptions())if(f.contributes){const w=f.contributes.debuggers;if(w&&w.length>0)for(const T of w)(0,g.isDebuggerMainContribution)(T)&&m.push(T.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(m=>c.push(m)),c}addBreakpoints(c){this.startBreakpoints();const m=c.filter(T=>{const L=T.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,T),!0)});this.fireBreakpointChanges(m,[],[]);const f=[],w=new Map;for(const T of m)if(T instanceof k.SourceBreakpoint){let L=w.get(T.location.uri.toString());L||(L={type:"sourceMulti",uri:T.location.uri,lines:[]},w.set(T.location.uri.toString(),L),f.push(L)),L.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof k.FunctionBreakpoint&&f.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(c){this.startBreakpoints();const m=c.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],m,[]);const f=m.filter(L=>L instanceof k.SourceBreakpoint).map(L=>L.id),w=m.filter(L=>L instanceof k.FunctionBreakpoint).map(L=>L.id),T=m.filter(L=>L instanceof k.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(f,w,T)}startDebugging(c,m,f){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,m,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,m,f){if(!m)return new k.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:w,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,f,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,w),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(c,m,f){if(!f)return new k.Disposable(()=>{});if(!this.definesDebugType(c,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:w,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,w),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(c,m){if(!m)return new k.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:f,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==m)})}async $runInTerminal(c,m){return Promise.resolve(void 0)}async $substituteVariables(c,m){if(!this._variableResolver){const[T,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,L)}let f;const w=await this.getFolder(c);return w&&(f={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,m)}createDebugAdapter(c,m){if(c.type==="implementation")return new i(c.implementation)}createSignService(){}async $startDASession(c,m){const f=this,w=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const L=this.convertToDto(T),O=this.createDebugAdapter(L,w);if(!O)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const E=O;return this._debugAdapters.set(c,E),this.getDebugAdapterTrackers(w).then(M=>(M&&this._debugAdaptersTrackers.set(c,M),E.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const V=U,z={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(V.arguments.value);z.body={signature:N},E.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,E.sendResponse(z)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(U),U=(0,g.convertToVSCPaths)(U,!0),f._debugServiceProxy.$acceptDAMessage(c,U)}),E.onError(U=>{M&&M.onError&&M.onError(U),this._debugServiceProxy.$acceptDAError(c,U.name,U.message,U.stack)}),E.onExit(U=>{M&&M.onExit&&M.onExit((0,R.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,R.withNullAsUndefined)(U),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),E.startSession()))})}$sendDAMessage(c,m){m=(0,g.convertToDAPaths)(m,!1);const f=this._debugAdaptersTrackers.get(c);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(m);const w=this._debugAdapters.get(c);w&&w.sendMessage(m)}$stopDASession(c){const m=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),m&&m.onWillStopSession&&m.onWillStopSession();const f=this._debugAdapters.get(c);return this._debugAdapters.delete(c),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const m=[],f=[],w=[];if(c.added)for(const T of c.added){const L=T.id;if(L&&!this._breakpoints.has(L)){let O;if(T.type==="function")O=new k.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")O=new k.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const E=t.URI.revive(T.uri);O=new k.SourceBreakpoint(new k.Location(E,new k.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}O._id=L,this._breakpoints.set(L,O),m.push(O)}}if(c.removed)for(const T of c.removed){const L=this._breakpoints.get(T);L&&(this._breakpoints.delete(T),f.push(L))}if(c.changed){for(const T of c.changed)if(T.id){const L=this._breakpoints.get(T.id);if(L){if(L instanceof k.FunctionBreakpoint&&T.type==="function"){const O=L;O.enabled=T.enabled,O.condition=T.condition,O.hitCondition=T.hitCondition,O.logMessage=T.logMessage,O.functionName=T.functionName}else if(L instanceof k.SourceBreakpoint&&T.type==="source"){const O=L;O.enabled=T.enabled,O.condition=T.condition,O.hitCondition=T.hitCondition,O.logMessage=T.logMessage,O.location=new k.Location(t.URI.revive(T.uri),new k.Position(T.line,T.character))}w.push(L)}}}this.fireBreakpointChanges(m,f,w)}$provideDebugConfigurations(c,m,f){return(0,C.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(m);return w.provideDebugConfigurations(T,f)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(c,m,f,w){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(m);return T.resolveDebugConfiguration(L,f,w)})}$resolveDebugConfigurationWithSubstitutedVariables(c,m,f,w){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(m);return T.resolveDebugConfigurationWithSubstitutedVariables(L,f,w)})}async $provideDebugAdapter(c,m){const f=this.getAdapterDescriptorFactoryByHandle(c);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(m);return this.getAdapterDescriptor(f,w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(c){const m=await this.getSession(c);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(c){const m=await this.getSession(c);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,m){const f=await this.getSession(c);f&&f._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(c,m){const w={session:await this.getSession(c),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(c){if(c instanceof k.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof k.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const m=this._adapterFactories.filter(f=>f.type===c);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(c){const m=this._adapterFactories.filter(f=>f.handle===c);if(m.length>0)return m[0].factory}getConfigProviderByHandle(c){const m=this._configProviders.filter(f=>f.handle===c);if(m.length>0)return m[0].provider}definesDebugType(c,m){if(c.contributes){const f=c.contributes.debuggers;if(f&&f.length>0){for(const w of f)if(w.label&&w.type&&w.type===m)return!0}}return!1}getDebugAdapterTrackers(c){const f=c.configuration.type,w=this._trackerFactories.filter(T=>T.type===f||T.type==="*").map(T=>(0,C.asPromise)(()=>T.factory.createDebugAdapterTracker(c)).then(L=>L,L=>null));return Promise.race([Promise.all(w).then(T=>{const L=T.filter(O=>!!O);if(L.length>0)return new a(L)}),new Promise((T,L)=>{const O=setTimeout(()=>{clearTimeout(O),L(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(c,m){const f=m.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.DebugAdapterServer(f));if(c){const T=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>c.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,T))).then(L=>{if(L)return L})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,w))}daExecutableFromPackage(c,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,m,f){(c.length>0||m.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:m,changed:f}))}async getSession(c){if(c)if(typeof c=="string"){const m=this._debugSessions.get(c);if(m)return m}else{let m=this._debugSessions.get(c.id);if(!m){const f=await this.getFolder(c.folderUri),w=c.parent?this._debugSessions.get(c.parent):void 0;m=new u(this._debugServiceProxy,c.id,c.type,c.name,f,c.configuration,w),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(c){if(c){const m=t.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};s=je([ze(0,v.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,F.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,b.IExtHostConfiguration),ze(5,h.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class u{constructor(c,m,f,w,T,L,O){this._debugServiceProxy=c,this._id=m,this._type=f,this._name=w,this._workspaceFolder=T,this._configuration=L,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,m)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=u;class r{constructor(c){this.value=Object.freeze({append(m){c.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=r;class S extends l.AbstractVariableResolverService{constructor(c,m,f,w,T){function L(){if(m){const O=m.activeEditor();if(O)return O.document.uri;const E=w.tabs.filter(M=>M.isActive);if(E.length>0){const M=E[0].resource;return M&&(M.primary||M.secondary)?M.primary??M.secondary:E[0].resource}}}super({getFolderUri:O=>{const E=c.filter(M=>M.name===O);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(O,E)=>f.getConfiguration(void 0,O).get(E),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=L();if(O)return d.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const O=L();if(O){const E=T.getWorkspaceFolder(O);if(E)return d.normalize(E.uri.fsPath)}}},getSelectedText:()=>{if(m){const O=m.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(m){const O=m.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=S;class a{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(m=>m.onError?m.onError(c):void 0)}onExit(c,m){this.trackers.forEach(f=>f.onExit?f.onExit(c,m):void 0)}}class i extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends s{constructor(c,m,f,w,T,L){super(c,m,f,w,T,L)}createVariableResolver(c,m,f){return new S(c,m,f,this._editorTabs)}};n=je([ze(0,v.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,F.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,b.IExtHostConfiguration),ze(5,h.IExtHostEditorTabs)],n),e.WorkerExtHostDebugService=n}),define(ve[269],be([0,1,71,2,5,36,30,27,14,26,4,39,40,12,8]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let v=class{constructor(u,r,S,a,i,n,o){this._apiFactory=u,this._extensionRegistry=r,this._instaService=S,this._extHostConfiguration=a,this._extHostExtensionService=i,this._initData=n,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new R(this._apiFactory,r,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(p,r)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,r,this._initData.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(let r of u.nodeModuleName)this._factories.set(r,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(r=>u.alternativeModuleName(r))}};v=je([ze(2,F.IInstantiationService),ze(3,C.IExtHostConfiguration),ze(4,y.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,b.ILogService)],v),e.RequireInterceptor=v;let _=class zi{constructor(u){if(u.environment.appRoot&&zi.aliased.size){const r=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(u.environment.appRoot.fsPath)),S="[a-z0-9_.-]",a=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${i}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(u){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(u));if(!r)return;const[,S,a,i]=r,n=zi.aliased.get(a);if(n!==void 0)return console.warn(`${a} as been renamed to ${n}, please update your imports`),S+n+i}forceForwardSlashes(u){return u.replace(/\\/g,"/")}};_.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),_=je([ze(0,P.IExtHostInitDataService)],_);class R{constructor(u,r,S,a,i){this._apiFactory=u,this._extensionPaths=r,this._extensionRegistry=S,this._configProvider=a,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,r){const S=this._extensionPaths.findSubstr(r);if(S){let a=this._extApiImpl.get(k.ExtensionIdentifier.toKey(S.identifier));return a||(a=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(S.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((i,n)=>a+=`	${n} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(u,r,S){this._extensionPaths=u,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(I.MainContext.MainThreadTelemetry);const{environment:a}=S,i=r.getProxy(I.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;l.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,o)=>i.$getPassword(n,o),setPassword:(n,o,c)=>i.$setPassword(n,o,c),deletePassword:(n,o)=>i.$deletePassword(n,o),findPassword:n=>i.$findPassword(n),findCredentials(n){return i.$findCredentials(n)}}}load(u,r){const S=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(u){const r=u.length;if(r<=7||!this.alternativeNames)return;const S=r-7;if((u.charAt(S)==="/"||u.charAt(S)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};p=je([ze(1,D.IExtHostRpcService),ze(2,P.IExtHostInitDataService)],p);let h=class{constructor(u,r,S){this._extensionPaths=u,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(I.MainContext.MainThreadTelemetry);const a=S.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,n)=>{const o=t.URI.parse(i);return n?this.callOriginal(i,n):o.scheme==="http"||o.scheme==="https"?a.$openUri(o,i,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?a.$openUri(o,i,{}):this.callOriginal(i,n)}}load(u,r,S){const a=this._extensionPaths.findSubstr(r);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=S(u),this._impl}callOriginal(u,r){return this.sendNoForwardTelemetry(),this._original(u,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=je([ze(2,D.IExtHostRpcService)],h)}),define(ve[270],be([0,1,173,11,7,210,35,39,45,36,34,14,54,195,13,211,53]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let R=class extends l.ExtHostDebugServiceBase{constructor(s,u,r,S,a,i,n){super(s,u,r,S,a,n);this._terminalService=i,this._integratedTerminalInstances=new p}createDebugAdapter(s,u){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,u.type)}return super.createDebugAdapter(s,u)}daExecutableFromPackage(s,u){const r=C.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),s.type);if(r)return new I.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new b.SignService}async $runInTerminal(s,u){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const r=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),a=this._terminalService.getDefaultShellArgs(!0),i=s.title||d.localize(0,null),n=JSON.stringify({shell:S,shellArgs:a});let o=await this._integratedTerminalInstances.checkout(n,i),c,m=!1;if(o)c=s.cwd;else{const L={shellPath:S,shellArgs:a,cwd:s.cwd,name:i,iconPath:new I.ThemeIcon("debug")};m=!0,o=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,n)}o.show(!0);const f=await o.processId;m?await new Promise(L=>setTimeout(L,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?o.sendText("cls"):S.indexOf("bash")>=0?o.sendText("clear"):t.isWindows?o.sendText("cls"):o.sendText("clear"));const w=(0,v.prepareCommand)(S,s.args,c,s.env);o.sendText(w);const T=this.onDidTerminateDebugSession(L=>{L.id===u&&(this._integratedTerminalInstances.free(o),T.dispose())});return f}else if(s.kind==="external")return(0,v.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,u)}createVariableResolver(s,u,r){return new l.ExtHostVariableResolverService(s,u,r,this._editorTabs,this._workspaceService)}};R=je([ze(0,y.IExtHostRpcService),ze(1,A.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,F.IExtHostTerminalService),ze(6,_.IExtHostEditorTabs)],R),e.ExtHostDebugService=R;class p{constructor(){this._terminalInstances=new Map}async checkout(s,u){const S=[...this._terminalInstances.entries()].map(([a,i])=>(0,g.createCancelablePromise)(async n=>{if(a.name!==u||i.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await a.processId))return null;const o=Date.now();return i.lastUsedAt+p.minUseDelay>o||n.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=o,a)}));return await(0,g.firstParallel)(S,a=>!!a)}insert(s,u){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:u})}free(s){const u=this._terminalInstances.get(s);u&&(u.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}p.minUseDelay=1e3}),define(ve[271],be([0,1,9,2,113,35,54,45,36,43,34,14,26,70,10,12,65,53,23,80]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends b.ExtHostTaskBase{constructor(r,S,a,i,n,o,c,m,f){super(r,S,a,i,n,o,c,m);this.workspaceService=a,this.editorTabs=f,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(r,S){const a=S;if(!S.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const i=b.TaskHandleDTO.from(a,this.workspaceService),n=await this._proxy.$getTaskExecution(i);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(n,S);return this._proxy.$executeTask(i).catch(()=>{}),o}else{const i=b.TaskDTO.from(S,r);if(i===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),n}}provideTasksInternal(r,S,a,i){const n=[];if(i)for(let o of i){this.checkDeprecation(o,a),(!o.definition||!r[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const c=b.TaskDTO.from(o,a.extension);c&&(n.push(c),b.CustomExecutionDTO.is(c.execution)&&S.push(this.addCustomExecution(c,o,!0)))}return{tasks:n,extension:a.extension}}async resolveTaskInternal(r){return r}async getVariableResolver(r){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(r,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(r){let S=r&&r.length>0?r[0]:void 0;if(!S){const a=t.URI.file((0,h.homedir)());S=new P.WorkspaceFolder({uri:a,name:p.basename(a),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(r,S){const a=t.URI.revive(r),i={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(a),o=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(o),m=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(let f of S.variables)i.variables[f]=await c.resolveAsync(m,f);if(S.process!==void 0){let f;if(S.process.path!==void 0){f=S.process.path.split(d.delimiter);for(let w=0;w<f.length;w++)f[w]=await c.resolveAsync(m,f[w])}i.process=await I.win32.findExecutable(await c.resolveAsync(m,S.process.name),S.process.cwd!==void 0?await c.resolveAsync(m,S.process.cwd):void 0,f)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(r,S,a){return I.win32.findExecutable(r,S,a)}};s=je([ze(0,y.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,k.IExtHostDocumentsAndEditors),ze(4,D.IExtHostConfiguration),ze(5,F.IExtHostTerminalService),ze(6,v.ILogService),ze(7,_.IExtHostApiDeprecationService),ze(8,R.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(ve[272],be([0,1,13,16,71,6,2,5,264,12,61,84,26,187,14,64,39,34]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(s,u,r,S,a){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=r,this._rpcProtocol=new D.RPCProtocol(s,null,S),u=p._transform(u,this._rpcProtocol);const i=new y.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...u,messagePorts:a}),i.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),i.set(v.IURITransformerService,new v.URITransformerService(S)),i.set(_.IHostUtils,r);const n=new b.InstantiationService(i,!0);this._disposables.add(n.invokeFunction(f=>f.get(R.IExtHostTerminalService))),this._disposables.add(n.invokeFunction(f=>f.get(_.IExtHostExtensionService))),this._logService=n.invokeFunction(f=>f.get(P.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",u),this._extensionService=n.invokeFunction(f=>f.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(w,T)=>{let L="",O,E;for(const M of T)L+=`
	at ${M.toString()}`,E=M.getFileName(),!O&&E&&(O=f.findSubstr(A.URI.file(E)));return o.set(w,O),`${w.name||"Error"}: ${w.message||""}${L}`}});const c=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(f=>{const w=t.transformErrorForSerialization(f),T=o.get(f);T?c.$onExtensionRuntimeError(T.identifier,w):m.$onUnexpectedError(w)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(r=>{this._logService.error(r)}),this._rpcProtocol.dispose();const u=this._extensionService.deactivateAll();Promise.race([(0,d.timeout)(5e3),u]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,u){s.extensions.forEach(S=>S.extensionLocation=A.URI.revive(u.transformIncomingURIs(S.extensionLocation))),s.environment.appRoot=A.URI.revive(u.transformIncomingURIs(s.environment.appRoot));const r=s.environment.extensionDevelopmentLocationURI;return r&&(s.environment.extensionDevelopmentLocationURI=r.map(S=>A.URI.revive(u.transformIncomingURIs(S)))),s.environment.extensionTestsLocationURI=A.URI.revive(u.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=A.URI.revive(u.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=A.URI.revive(u.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=A.URI.revive(u.transformIncomingURIs(s.logsLocation)),s.logFile=A.URI.revive(u.transformIncomingURIs(s.logFile)),s.workspace=u.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=p}),define(ve[273],be([0,1,9,21,49,32,23,46,31]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,b,g){this.config=l,this.provider=b,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&C.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&C.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const b=this.config.folderQueries||[];return new Promise((g,v)=>{const _=R=>{this.resultCount++,l(R)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(R=>{const p=R.toString(),h=d.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,h)||this.matchFile(_,{base:R,basename:h})}),Promise.all(b.map(R=>this.searchInFolder(R,_))).then(R=>{g({limitHit:this.isLimitHit,stats:R[0]||void 0})},R=>{v(new Error((0,I.toErrorMessage)(R)))})})}async searchInFolder(l,b){const g=new t.CancellationTokenSource,v=this.getSearchOptionsForFolder(l),_=this.initDirectoryTree(),R=new D.QueryGlobTester(this.config,l),p=!R.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(g),h=k.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,g.token),u=h.elapsed(),r=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(S=>{const a=d.posix.relative(l.folder.path,S.path);if(p){const i=d.basename(S.path);this.matchFile(b,{base:l.folder,relativePath:a,basename:i});return}this.addDirectoryEntries(_,l.folder,a,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,R,b),{providerTime:u,postProcessTime:r.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(l){const b=(0,D.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),g=(0,D.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:g,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},b,g,v){if(g===this.filePattern){const R=d.basename(this.filePattern);this.matchFile(v,{base:b,relativePath:this.filePattern,basename:R})}function _(R){const p=d.basename(R),h=d.dirname(R);let s=l[h];s||(s=l[h]=[],_(h)),s.push({base:b,relativePath:R,basename:p})}_(g)}matchDirectoryTree({rootEntries:l,pathToEntries:b},g,v){const _=this,R=this.filePattern;function p(h){const s=C.hasSiblingFn(()=>h.map(u=>u.basename));for(let u=0,r=h.length;u<r;u++){const S=h[u],{relativePath:a,basename:i}=S;if(g.matchesExcludesSync(a,i,R!==i?s:void 0))continue;const n=b[a];if(n)p(n);else{if(a===R)continue;_.matchFile(v,S)}if(_.isLimitHit)break}}p(l)}matchFile(l,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(b))}}class F{constructor(){this.sessions=new Map}fileSearch(l,b,g,v){const _=this.getSessionTokenSource(l.cacheKey),R=new P(l,b,_&&_.token);let p=0;const h=s=>{p+=s.length,g(s.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(R,F.BATCH_SIZE,h,v).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:s.stats}}))}clearCache(l){const b=this.getSessionTokenSource(l);b&&b.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new t.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,b,g,v){v.onCancellationRequested(()=>{l.cancel()});const _=p=>{p&&(R.push(p),b>0&&R.length>=b&&(g(R),R=[]))};let R=[];return l.search(_).then(p=>(R.length&&g(R),p),p=>(R.length&&g(R),Promise.reject(p)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(ve[136],be([0,1,17,13,21,49,32,10,9,23,18,2,31]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(s,u,r,S){this.query=s,this.provider=u,this.fileUtils=r,this.processType=S,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,u){const r=this.query.folderQueries||[],S=new I.CancellationTokenSource;return u.onCancellationRequested(()=>S.cancel()),new Promise((a,i)=>{this.collector=new v(s);let n=!1;const o=(c,m)=>{if(!n&&!this.isLimitHit){const f=this.resultSize(c);R(c)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,n=!0,S.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const w=this.resultSize(c);this.resultCount+=w,(w>0||!R(c))&&this.collector.add(c,m)}};Promise.all(r.map((c,m)=>this.searchInFolder(c,f=>o(f,m),S.token))).then(c=>{S.dispose(),this.collector.flush();const m=c.some(f=>!!f&&!!f.limitHit);a({limitHit:this.isLimitHit||m,messages:(0,d.flatten)(c.map(f=>f?.message?(0,F.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},c=>{S.dispose();const m=(0,C.toErrorMessage)(c);i(new Error(m))})})}resultSize(s){return R(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,u){const r=Array.isArray(s.ranges)?s.ranges:[s.ranges],S=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:r.slice(0,u),preview:{matches:S.slice(0,u),text:s.preview.text},uri:s.uri}}async searchInFolder(s,u,r){const S=new l.QueryGlobTester(this.query,s),a=[],i={report:c=>{if(!this.validateProviderResult(c))return;const m=s.folder.scheme===k.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(P.dirname(c.uri))):void 0,f=P.relativePath(s.folder,c.uri);if(f){const w=S.includedInQuery(f,D.basename(f),m);(0,t.isThenable)(w)?a.push(w.then(T=>{T&&u(c)})):w&&u(c)}}},n=this.getSearchOptionsForFolder(s),o=await this.provider.provideTextSearchResults(g(this.query.contentPattern),n,i,r);return a.length&&await Promise.all(a),o}validateProviderResult(s){if(R(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const u=(0,l.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),r=(0,l.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),S={folder:y.URI.from(s.folder),excludes:r,includes:u,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return S.usePCRE2=this.query.usePCRE2,S}}e.TextSearchManager=b;function g(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class v{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,u=>this.sendItems(u))}add(s,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!P.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(_(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=v;function _(h){return R(h)?{preview:{matches:(0,d.mapArrayOrNot)(h.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:h.preview.text},ranges:(0,d.mapArrayOrNot)(h.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function R(h){return!!h.preview}e.extensionResultIsMatch=R;class p{constructor(s,u){this.maxBatchSize=s,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,u){!s||this.addItemToBatch(s,u)}addItems(s,u){!s||this.addItemsToBatch(s,u)}addItemToBatch(s,u){this.batch.push(s),this.batchSize+=u,this.onUpdate()}addItemsToBatch(s,u){this.batch=this.batch.concat(s),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(ve[72],be([0,1,6,5,4,273,14,64,12,2,136]),function(ee,e,d,t,I,C,A,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let y=class{constructor(v,_,R){this.extHostRpc=v,this._uriTransformer=_,this._logService=R,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const R=this._handlePool++;return this._textSearchProvider.set(R,_),this._proxy.$registerTextSearchProvider(R,this._transformScheme(v)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const R=this._handlePool++;return this._fileSearchProvider.set(R,_),this._proxy.$registerFileSearchProvider(R,this._transformScheme(v)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}$provideFileSearchResults(v,_,R,p){const h=l(R),s=this._fileSearchProvider.get(v);if(s)return this._fileSearchManager.fileSearch(h,s,u=>{this._proxy.$handleFileMatch(v,_,u.map(r=>r.resource))},p);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,R,p){const h=this._textSearchProvider.get(v);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const s=l(R);return this.createTextSearchManager(s,h).search(r=>this._proxy.$handleTextMatch(v,_,r),p)}$enableExtensionHostSearch(){}createTextSearchManager(v,_){return new F.TextSearchManager(v,_,{readdir:R=>Promise.resolve([]),toCanonicalName:R=>R},"textSearchProvider")}};y=je([ze(0,A.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,D.ILogService)],y),e.ExtHostSearch=y;function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(v=>P.URI.revive(v))}}e.reviveQuery=l;function b(g){return{...g,folder:P.URI.revive(g.folder)}}}),define(ve[274],be([0,1,61,134,35,132,36,38,45,34,70,54,72,91,51,65,135,66,44,90,123,53,133,12,226]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h,s,u,r,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(S.ILoggerService,r.ExtHostLoggerService),(0,d.registerSingleton)(S.ILogService,a.ExtHostLogService),(0,d.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,d.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,d.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,d.registerSingleton)(R.IExtHostConsumerFileSystem,R.ExtHostConsumerFileSystem),(0,d.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,d.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,d.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,d.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,d.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,d.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,d.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,d.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,d.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService),(0,d.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,d.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,d.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,d.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,d.registerSingleton)(u.IExtHostEditorTabs,u.ExtHostEditorTabs)}),define(ve[92],be([0,1,17,12,31,69]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}e.anchorGlob=A;function k(y,l,b,g){const v=(0,d.mapArrayOrNot)(b,D),_=new I.TextSearchMatch(l,v,g),R=_.preview.matches;return{ranges:(0,d.mapArrayOrNot)(v,P),uri:y,preview:{text:_.preview.text,matches:(0,d.mapArrayOrNot)(R,P)}}}e.createTextSearchResult=k;function D(y){return new I.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function P(y){return new C.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let F=class{constructor(l,b){this.prefix=l,this.logService=b}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};F=je([ze(1,t.ILogService)],F),e.OutputChannel=F}),define(ve[275],be([0,1,37,9,78,28,11,8,92,276]),function(ee,e,d,t,I,C,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(h,s,u,r){const S=l(h,s,u,r),a=s.folder.fsPath;return{cmd:d.spawn(F,S.args,{cwd:a}),rgDiskPath:F,siblingClauses:S.siblingClauses,rgArgs:S,cwd:a}}e.spawnRipgrepCmd=y;function l(h,s,u,r){const S=["--files","--hidden","--case-sensitive"];g([s],u,!1).forEach(i=>{const n=(0,D.anchorGlob)(i);if(S.push("-g",n),A.isMacintosh){const o=(0,I.normalizeNFD)(n);o!==n&&S.push("-g",o)}});const a=b([s],r,void 0,!1);return a.globArgs.forEach(i=>{const n=`!${(0,D.anchorGlob)(i)}`;if(S.push("-g",n),A.isMacintosh){const o=(0,I.normalizeNFD)(n);o!==n&&S.push("-g",o)}}),s.disregardIgnoreFiles!==!1?S.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),s.ignoreSymlinks||S.push("--follow"),h.exists&&S.push("--quiet"),S.push("--no-config"),s.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:a.siblingClauses}}function b(h,s,u,r=!0){const S=[];let a={};return h.forEach(i=>{const n=Object.assign({},i.excludePattern||{},s||{}),o=v(n,r?i.folder.fsPath:void 0,u);S.push(...o.globArgs),o.siblingClauses&&(a=Object.assign(a,o.siblingClauses))}),{globArgs:S,siblingClauses:a}}e.foldersToRgExcludeGlobs=b;function g(h,s,u=!0){const r=[];return h.forEach(S=>{const a=Object.assign({},s||{},S.includePattern||{}),i=v(a,u?S.folder.fsPath:void 0);r.push(...i.globArgs)}),r}e.foldersToIncludeGlobs=g;function v(h,s,u){const r=[],S={};return Object.keys(h).forEach(a=>{if(u&&u.has(a)||!a)return;const i=h[a];a=R(s?_(s,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),r.push(p(a))):i&&i.when&&(S[a]=i)}),{globArgs:r,siblingClauses:S}}function _(h,s){return t.isAbsolute(s)?s:t.join(h,s)}e.getAbsoluteGlob=_;function R(h){return h=k.rtrim(h,"\\"),k.rtrim(h,"/")}function p(h){return C.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=p}),define(ve[277],be([0,1,37,60,9,105,17,49,32,78,28,11,46,8,18,29,31,275,103]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(a=>a())});class s{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(n=>{const o=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),c=n.folder.fsPath;i.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==c).forEach(m=>{(0,F.isEqualOrParent)(m,c)&&(o[I.relative(c,m)]=!0)}),this.folderExcludePatterns.set(c,new r(o,c))})}cancel(){this.isCanceled=!0,h.forEach(i=>i())}walk(i,n,o,c,m){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);n.forEach(f=>{const w=I.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,w)||this.matchFile(o,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(i,(f,w)=>{this.call(this.cmdTraversal,this,f,o,c,T=>{if(T){const L=(0,k.toErrorMessage)(T);console.error(L),this.errors.push(L),w(T,void 0)}else w(null,void 0)})},(f,w)=>{this.fileWalkSW.stop();const T=f?A.coalesce(f)[0]:null;m(T,this.isLimitHit)})}parallel(i,n,o){const c=new Array(i.length),m=new Array(i.length);let f=!1,w=0;if(i.length===0)return o(null,[]);i.forEach((T,L)=>{n(T,(O,E)=>{if(O?(f=!0,c[L]=null,m[L]=O):(c[L]=E,m[L]=null),++w===i.length)return o(f?m:null,c)})})}call(i,n,...o){try{i.apply(n,o)}catch(c){o[o.length-1](c)}}cmdTraversal(i,n,o,c){const m=i.folder.fsPath,f=y.isMacintosh;let w;const T=()=>w&&w.kill();h.add(T);let L=N=>{h.delete(T),L=()=>{},c(N)},O="";const E=this.initDirectoryTree();let M;const U=(0,R.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=U.cmd,M=!Object.keys(U.siblingClauses).length;const V=U.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let z=`${U.rgDiskPath} ${V}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),o({message:z}),this.cmdResultCount=0,this.collectStdout(w,"utf8",o,(N,W,B)=>{if(N){L(N);return}if(this.isLimitHit){L();return}const $=(O+(f?P.normalizeNFC(W||""):W)).split(`
`);if(B){const J=$.length;$[J-1]=$[J-1].trim(),$[J-1]||$.pop()}else O=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,M){for(const J of $)if(this.matchFile(n,{base:m,relativePath:J,searchPath:this.getSearchPath(i,J)}),this.isLimitHit){T();break}(B||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,E,m,$,n),B&&(this.matchDirectoryTree(E,m,n),L())})}spawnFindCmd(i){const n=this.folderExcludePatterns.get(i.folder.fsPath),o=n.getBasenameTerms(),c=n.getPathTerms(),m=["-L","."];if(o.length||c.length){m.push("-not","(","(");for(const f of o)m.push("-name",f),m.push("-o");for(const f of c)m.push("-path",f),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),d.spawn("find",m,{cwd:i.folder.fsPath})}readStdout(i,n,o){let c="";this.collectStdout(i,n,()=>{},(m,f,w)=>{if(m){o(m);return}c+=f,w&&o(null,c)})}collectStdout(i,n,o,c){let m=(T,L,O)=>{(T||O)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),c(T,L,O)},f=!1;i.stdout?(this.forwardData(i.stdout,n,m),i.stdout.once("data",()=>f=!0)):o({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):o({message:"stderr is null"}),i.on("error",T=>{m(T)}),i.on("close",T=>{let L;!f&&(L=this.decodeData(w,n))&&S(L)?m(new Error(`command failed with error code ${T}: ${this.decodeData(w,n)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(i,n,o){const c=new C.StringDecoder(n);return i.on("data",m=>{o(null,c.write(m))}),c}collectData(i){const n=[];return i.on("data",o=>{n.push(o)}),n}decodeData(i,n){const o=new C.StringDecoder(n);return i.map(c=>o.write(c)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:n},o,c,m){c.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:o,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const f=w=>{const T=I.basename(w),L=I.dirname(w);let O=n[L];O||(O=n[L]=[],f(L)),O.push({base:o,relativePath:w,basename:T,searchPath:this.getSearchPath(i,w)})};c.forEach(f)}matchDirectoryTree({rootEntries:i,pathToEntries:n},o,c){const m=this,f=this.folderExcludePatterns.get(o),w=this.filePattern;function T(L){m.directoriesWalked++;const O=D.hasSiblingFn(()=>L.map(E=>E.basename));for(let E=0,M=L.length;E<M;E++){const U=L[E],{relativePath:V,basename:z}=U;if(f.test(V,z,w!==z?O:void 0))continue;const N=n[V];if(N)T(N);else{if(m.filesWalked++,V===w)continue;m.matchFile(c,U)}if(m.isLimitHit)break}}T(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,n,o,c,m){const f=i.folder,w=D.hasSiblingFn(()=>o);this.parallel(o,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const O=n?[n,T].join(I.sep):T;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,T,this.config.filePattern!==T?w:void 0))return L(null);const E=[f.fsPath,O].join(I.sep);t.lstat(E,(M,U)=>{if(M||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(E,U,(V,z)=>V||this.isCanceled||this.isLimitHit?L(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(E,U,(N,W)=>N||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?L(null):(this.walkedPaths[W]=!0,v.Promises.readdir(E).then(B=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(i,O,B,c,x=>L(x||null))},B=>{L(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&g.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(c,{base:f.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),L(null,void 0)))})},T=>{const L=T&&A.coalesce(T);return m(L&&L.length>0?L[0]:void 0)})}matchFile(i,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,I.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(n))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,n,o){return n.isSymbolicLink()?t.stat(i,o):o(null,n)}realPathIfNeeded(i,n,o){return n.isSymbolicLink()?t.realpath(i,(c,m)=>c?o(c):o(null,m)):o(null,i)}getSearchPath(i,n){return i.folderName?I.join(i.folderName,n):n}}e.FileWalker=s;class u{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new s(i)}search(i,n,o){this.walker.walk(this.folderQueries,this.extraFiles,i,n,(c,m)=>{o(c,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=u;class r{constructor(i,n){this.expression=i,this.root=n,this.init(i)}init(i){let n,o;Object.keys(i).filter(c=>i[c]).forEach(c=>{I.isAbsolute(c)?(n=n||D.getEmptyExpression(),n[c]=i[c]):(o=o||D.getEmptyExpression(),o[c]=i[c])}),this.absoluteParsedExpr=n&&D.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=o&&D.parse(o,{trimForExclusions:!0})}test(i,n,o){return this.relativeParsedExpr&&this.relativeParsedExpr(i,n,o)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),n,o)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function S(a){const i=a.trim().split(`
`),n=i[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return b.uppercaseFirstLetter(i[i.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=S}),define(ve[278],be([0,1,98,22]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===a)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,A=512,k=512*8,D=512*128;var P;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(i,n){super(i);this.decodeStreamErrorKind=n}}e.DecodeStreamError=F;class y{constructor(i){this.iconvLiteDecoder=i}static async create(i){let n;if(i!==e.UTF8)n=(await new Promise((c,m)=>{ee(["@vscode/iconv-lite-umd"],c,m)})).getDecoder(v(i));else{const o=new TextDecoder;n={write(c){return o.decode(c,{stream:!0})},end(){return o.decode()}}}return new y(n)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function l(a,i){const n=i.minBytesRequiredForDetection??i.guessEncoding?k:A;return new Promise((o,c)=>{const m=(0,d.newWriteableStream)(E=>E.join("")),f=[];let w=0,T,L;const O=async()=>{try{const E=await S({buffer:t.VSBuffer.concat(f),bytesRead:w},i.guessEncoding);if(E.seemsBinary&&i.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);E.encoding=await i.overwriteEncoding(E.encoding),T=await y.create(E.encoding);const M=T.write(t.VSBuffer.concat(f).buffer);m.write(M),f.length=0,w=0,o({stream:m,detected:E})}catch(E){L?.dispose(),m.destroy(),c(E)}};L=(0,d.listenStream)(a,{onData:async E=>{T?m.write(T.write(E.buffer)):(f.push(E),w+=E.byteLength,w>=n&&(a.pause(),await O(),setTimeout(()=>a.resume())))},onError:E=>m.error(E),onEnd:async()=>{T||await O(),m.end(T?.end())}})})}e.toDecodeStream=l;async function b(a,i,n){const c=(await new Promise((w,T)=>{ee(["@vscode/iconv-lite-umd"],w,T)})).getEncoder(v(i),n);let m=!1,f=!1;return{read(){if(f)return null;const w=a.read();if(typeof w!="string"){if(f=!0,!m&&n?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const T=c.end();return T&&T.length>0?(m=!0,t.VSBuffer.wrap(T)):null}return m=!0,t.VSBuffer.wrap(c.write(w))}}}e.toEncodeReadable=b;async function g(a){return(await new Promise((n,o)=>{ee(["@vscode/iconv-lite-umd"],n,o)})).encodingExists(v(a))}e.encodingExists=g;function v(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=v;function _(a,i){if(!a||i<e.UTF16be_BOM.length)return null;const n=a.readUInt8(0),o=a.readUInt8(1);if(n===e.UTF16be_BOM[0]&&o===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&o===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const c=a.readUInt8(2);return n===e.UTF8_BOM[0]&&o===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=_;const R=["ascii","utf-16","utf-32"];async function p(a){const i=await new Promise((f,w)=>{ee(["jschardet"],f,w)}),n=a.slice(0,D),o=u(n.buffer),c=i.detect(o);if(!c||!c.encoding)return null;const m=c.encoding.toLowerCase();return 0<=R.indexOf(m)?null:s(c.encoding)}const h={ibm866:"cp866",big5:"cp950"};function s(a){const i=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[i]||i}function u(a){let i="";for(let n=0;n<a.length;n++)i+=String.fromCharCode(a[n]);return i}function r(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=a.match(/windows(\d+)/);return i?"windows-"+i[1]:a}}}e.toCanonicalName=r;function S({buffer:a,bytesRead:i},n){let o=_(a,i),c=!1;if(o!==e.UTF16be&&o!==e.UTF16le&&a){let m=!0,f=!0,w=!1;for(let T=0;T<i&&T<C;T++){const L=T%2==1,O=a.readUInt8(T)===0;if(O&&(w=!0),m&&(L&&!O||!L&&O)&&(m=!1),f&&(L&&O||!L&&!O)&&(f=!1),O&&!m&&!f)break}w&&(m?o=e.UTF16le:f?o=e.UTF16be:c=!0)}return n&&!c&&!o&&a?p(a.slice(0,i)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:c,encoding:o}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[137],be([0,1,278,29,136]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends I.TextSearchManager{constructor(k,D,P=t,F="searchProcess"){super(k,D,{readdir:y=>P.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,d.toCanonicalName)(y)},F)}}e.NativeTextSearchManager=C}),define(ve[279],be([0,1,61,4]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const k=this._dragOperations.get(A);return this._dragOperations.delete(A),k}}addDragOperationTransfer(A,k){this._dragOperations.set(A,k)}}e.TreeViewsDragAndDropService=I,(0,d.registerSingleton)(e.ITreeViewsDragAndDropService,I)}),define(ve[280],be([0,1,171,23,2,3,6,13,7,18,17,15,21,206,279]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(p,h){if((0,P.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let s;return Array.isArray(p.highlights)&&(s=p.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),s=s.length?s:void 0),{label:p.label,highlights:s}}}class _{constructor(h,s,u){this._proxy=h,this.commands=s,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeViewsDragAndDropService;function r(S){return S&&S.$treeViewId&&S.$treeItemHandle}s.registerArgumentProcessor({processArgument:S=>r(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(a=>r(a)?this.convertArgument(a):a):S})}registerTreeDataProvider(h,s,u){const r=this.createTreeView(h,{treeDataProvider:s},u);return{dispose:()=>r.dispose()}}createTreeView(h,s,u){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=s.dragAndDropController?.supportedMimeTypes,S=!!s.dragAndDropController?.handleDrag,a=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:r,hasHandleDrag:S}),i=this.createExtHostTreeView(h,s,u);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(n){i.message=n},get title(){return i.title},set title(n){i.title=n},get description(){return i.description},set description(n){i.description=n},reveal:(n,o)=>i.reveal(n,o),dispose:async()=>{await a,this.treeViews.delete(h),i.dispose()}}}$getChildren(h,s){const u=this.treeViews.get(h);return u?u.getChildren(s):Promise.reject(new Error((0,d.localize)(0,null,h)))}async $handleDrop(h,s,u,r,S,a){const i=this.treeViews.get(h);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,h)));const n=b.TreeDataTransferConverter.toITreeDataTransfer(s);return S===h&&a&&await this.addAdditionalTransferItems(n,i,a,r),i.onDrop(n,u)}async addAdditionalTransferItems(h,s,u,r){const S=this.treeDragAndDropService.removeDragOperationTransfer(r);if(S)(await S)?.forEach((a,i)=>{a&&h.set(i,a)});else if(r&&s.handleDrag){const a=s.handleDrag(u,h);this.treeDragAndDropService.addDragOperationTransfer(r,a),await a}return h}async $handleDrag(h,s,u){const r=this.treeViews.get(h);if(!r)return Promise.reject(new Error((0,d.localize)(2,null,h)));const S=await this.addAdditionalTransferItems(new Map,r,s,u);if(!!S)return b.TreeDataTransferConverter.toTreeDataTransferDTO(S)}async $hasResolve(h){const s=this.treeViews.get(h);if(!s)throw new Error((0,d.localize)(3,null,h));return s.hasResolve}$resolve(h,s,u){const r=this.treeViews.get(h);if(!r)throw new Error((0,d.localize)(4,null,h));return r.resolveTreeItem(s,u)}$setExpanded(h,s,u){const r=this.treeViews.get(h);if(!r)throw new Error((0,d.localize)(5,null,h));r.setExpanded(s,u)}$setSelection(h,s){const u=this.treeViews.get(h);if(!u)throw new Error((0,d.localize)(6,null,h));u.setSelection(s)}$setVisible(h,s){const u=this.treeViews.get(h);if(!u)throw new Error((0,d.localize)(7,null,h));u.setVisible(s)}createExtHostTreeView(h,s,u){const r=new R(h,s,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(h,r),r}convertArgument(h){const s=this.treeViews.get(h.$treeViewId);return s?s.getExtensionElement(h.$treeItemHandle):null}}e.ExtHostTreeViews=_;class R extends A.Disposable{constructor(h,s,u,r,S,a){super();if(this.viewId=h,this.proxy=u,this.commands=r,this.logService=S,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,a.contributes&&a.contributes.views)for(const o in a.contributes.views)for(const c of a.contributes.views[o])c.id===h&&(this._title=c.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let i,n;this._register(C.Event.debounce(this._onDidChangeData.event,(o,c)=>(o||(o={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(m=>n=m),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(c.element)?o.elements.push(...c.element):o.elements.push(c.element)),c.message&&(o.message=!0),o),200,!0)(({message:o,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=n;return i=null,this.refresh(c).then(()=>m())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,P.isUndefinedOrNull)(h))}async getChildren(h){const s=h?this.getExtensionElement(h):void 0;if(h&&!s)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(h);return u||(u=await this.fetchChildrenNodes(s)),u?u.map(r=>r.item):void 0}getExtensionElement(h){return this.elements.get(h)}reveal(h,s){s=s||{select:!0,focus:!1};const u=(0,P.isUndefinedOrNull)(s.select)?!0:s.select,r=(0,P.isUndefinedOrNull)(s.focus)?!1:s.focus,S=(0,P.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(a=>this.resolveTreeNode(h,a[a.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:a.map(n=>n.item)},{select:u,focus:r,expand:S})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:r,expand:S})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}setExpanded(h,s){const u=this.getExtensionElement(h);u&&(s?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(h){(0,F.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(h,s){const u=[];for(const r of h){const S=this.getExtensionElement(r);S&&u.push(S)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,s),s}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(h,s){const u=this.getExtensionElement(s);if(!!u)return(0,k.asPromise)(()=>this.dndController?.handleDrop(h,u))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,s){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(h);if(u){const r=this.nodes.get(u);if(r){const S=await this.dataProvider.resolveTreeItem(r.extensionItem,u,s)??r.extensionItem;return r.item.tooltip=this.getTooltip(S.tooltip),r.item.command=this.getCommand(r.disposableStore,S.command),r.item}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(s=>s?this.resolveUnknownParentChain(s).then(u=>this.resolveTreeNode(s,u[u.length-1]).then(r=>(u.push(r),u))):Promise.resolve([]))}resolveParent(h){const s=this.nodes.get(h);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,s){const u=this.nodes.get(h);return u?Promise.resolve(u):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(r=>this.createHandle(h,r,s,!0)).then(r=>this.getChildren(s?s.item.handle:void 0).then(()=>{const S=this.getExtensionElement(r);if(S){const a=this.nodes.get(S);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(h){if(h){let s;if(typeof h=="string"){const u=this.getExtensionElement(h);s=u?this.nodes.get(u):void 0}else s=h;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const s=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=h?this.nodes.get(h):void 0,r=await this.dataProvider.getChildren(h);if(s.token.isCancellationRequested)return;const S=await Promise.all((0,F.coalesce)(r||[]).map(async a=>{const i=await this.dataProvider.getTreeItem(a);return i&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(a,i,u):null}));return s.token.isCancellationRequested?void 0:(0,F.coalesce)(S)}finally{s.dispose()}}refresh(h){if(h.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(h);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const s=new Set,u=h.map(S=>this.nodes.get(S));for(const S of u)if(S&&!s.has(S.item.handle)){let a=S;for(;a&&a.parent&&u.findIndex(i=>a&&a.parent&&i&&i.item.handle===a.parent.item.handle)===-1;){const i=this.elements.get(a.parent.item.handle);a=i?this.nodes.get(i):void 0}a&&!a.parent&&s.add(S.item.handle)}const r=[];return s.forEach(S=>{const a=this.elements.get(S);if(a){const i=this.nodes.get(a);i&&(!i.parent||!s.has(i.parent.item.handle))&&r.push(S)}}),r}refreshHandles(h){const s={};return Promise.all(h.map(u=>this.refreshNode(u).then(r=>{r&&(s[u]=r.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(h){const s=this.getExtensionElement(h);if(s){const u=this.nodes.get(s);if(u)return this.clearChildren(s),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(r=>{if(r){const S=this.createTreeNode(s,r,u.parent);return this.updateNodeCache(s,S,u,u.parent),u.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,s,u){const r=this.createTreeNode(h,s,u);if(s.id&&this.elements.has(r.item.handle))throw new Error((0,d.localize)(8,null,s.id));return this.addNodeToCache(h,r),this.addNodeToParentCache(r,u),r}getTooltip(h){return D.MarkdownString.isMarkdownString(h)?y.MarkdownString.from(h):h}getCommand(h,s){return s?this.commands.toInternal(s,h):void 0}createTreeNode(h,s,u){const r=new A.DisposableStore,S=this.createHandle(h,s,u),a=this.getLightIconPath(s);return{item:{handle:S,parentHandle:u?u.item.handle:void 0,label:v(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(r,s.command),contextValue:s.contextValue,icon:a,iconDark:this.getDarkIconPath(s)||a,themeIcon:this.getThemeIcon(s),collapsibleState:(0,P.isUndefinedOrNull)(s.collapsibleState)?D.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:u,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(h){return h.iconPath instanceof D.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:s,label:u,resourceUri:r},S,a){if(s)return`${R.ID_HANDLE_PREFIX}/${s}`;const i=v(u,this.extension),n=S?S.item.handle:R.LABEL_HANDLE_PREFIX;let o=i?i.label:r?(0,t.basename)(r):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const c=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,m=this.getChildrenNodes(S)||[];let f,w=0;do{if(f=`${n}/${w}:${o}`,a||!this.elements.has(f)||c===f)break;w++}while(w<=m.length);return f}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof D.ThemeIcon))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof D.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return I.URI.isUri(h)?h:I.URI.file(h)}addNodeToCache(h,s){this.elements.set(s.item.handle,h),this.nodes.set(h,s)}updateNodeCache(h,s,u,r){this.elements.delete(s.item.handle),this.nodes.delete(h),s.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(h,s);const S=this.getChildrenNodes(r)||[],a=S.filter(i=>i.item.handle===u.item.handle)[0];a&&S.splice(S.indexOf(a),1,s)}addNodeToParentCache(h,s){s?(s.children||(s.children=[]),s.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const s=this.nodes.get(h);if(s){if(s.children)for(const u of s.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}s.children=void 0}}else this.clearAll()}clear(h){const s=this.nodes.get(h);if(s){if(s.children)for(const u of s.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}this.nodes.delete(h),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}R.LABEL_HANDLE_PREFIX="0",R.ID_HANDLE_PREFIX="1"}),define(ve[281],be([0,1,21,16,3,47,2,114,82,148,81,42,5,231,230,38,232,36,233,234,235,218,236,45,39,237,238,241,242,243,134,220,248,249,250,91,34,252,280,15,7,255,68,135,35,74,207,240,85,132,70,54,72,12,64,14,26,244,204,51,65,228,253,203,67,66,258,256,257,229,44,251,254,90,53,123,246,69,247,10,190,245,201,239,6,30]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p,h,s,u,r,S,a,i,n,o,c,m,f,w,T,L,O,E,M,U,V,z,N,W,B,x,$,J,ne,re,Z,Q,oe,fe,pe,Te,xe,qe,Qe,q,ie,G,X,ae,me,De,Be,Xe,tt,rt,st,et,nt,gt,It,Ne,Dt,te,se,K,we,ke,Ve,We,lt,Re,Ae,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ue(de){const Ee=de.get(Qe.IExtHostInitDataService),ye=de.get(nt.IExtHostFileSystemInfo),Oe=de.get(Xe.IExtHostConsumerFileSystem),Ge=de.get(a.IExtHostExtensionService),$e=de.get($.IExtHostWorkspace),Ye=de.get(te.IExtHostTelemetry),at=de.get(R.IExtHostConfiguration),ct=de.get(xe.IURITransformerService),He=de.get(qe.IExtHostRpcService),Se=de.get(E.IExtHostStorage),_e=de.get(Be.IExtensionStoragePaths),he=de.get(Te.ILoggerService),Y=de.get(Te.ILogService),Ie=de.get(G.IExtHostTunnelService),Me=de.get(X.IExtHostApiDeprecationService),Je=de.get(x.IExtHostWindow),Ke=de.get(Ne.IExtHostSecretState),mt=de.get(Dt.IExtHostEditorTabs);He.set(l.ExtHostContext.ExtHostFileSystemInfo,ye),He.set(l.ExtHostContext.ExtHostLogLevelServiceShape,he),He.set(l.ExtHostContext.ExtHostWorkspace,$e),He.set(l.ExtHostContext.ExtHostConfiguration,at),He.set(l.ExtHostContext.ExtHostExtensionService,Ge),He.set(l.ExtHostContext.ExtHostStorage,Se),He.set(l.ExtHostContext.ExtHostTunnelService,Ie),He.set(l.ExtHostContext.ExtHostWindow,Je),He.set(l.ExtHostContext.ExtHostSecretState,Ke),He.set(l.ExtHostContext.ExtHostTelemetry,Ye),He.set(l.ExtHostContext.ExtHostEditorTabs,mt);const St=He.set(l.ExtHostContext.ExtHostDecorations,de.get(Q.IExtHostDecorations)),yt=He.set(l.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),dt=He.set(l.ExtHostContext.ExtHostCommands,de.get(v.IExtHostCommands)),vt=He.set(l.ExtHostContext.ExtHostTerminalService,de.get(M.IExtHostTerminalService)),wt=He.set(l.ExtHostContext.ExtHostDebugService,de.get(fe.IExtHostDebugService)),Bt=He.set(l.ExtHostContext.ExtHostSearch,de.get(pe.IExtHostSearch)),Tt=He.set(l.ExtHostContext.ExtHostTask,de.get(oe.IExtHostTask)),Mt=He.set(l.ExtHostContext.ExtHostOutputService,de.get(f.IExtHostOutputService)),kt=He.set(l.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(He)),Et=He.set(l.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(He,yt)),Ot=He.set(l.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(He,yt,Y)),qt=He.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new u.ExtHostDocumentSaveParticipant(Y,Et,He.getProxy(l.MainContext.MainThreadBulkEdits))),bt=He.set(l.ExtHostContext.ExtHostNotebook,new q.ExtHostNotebookController(He,dt,yt,Et,_e)),Wt=He.set(l.ExtHostContext.ExtHostNotebookDocuments,new lt.ExtHostNotebookDocuments(Y,bt)),Kt=He.set(l.ExtHostContext.ExtHostNotebookEditors,new We.ExtHostNotebookEditors(Y,He,bt)),Yt=He.set(l.ExtHostContext.ExtHostNotebookKernels,new se.ExtHostNotebookKernels(He,Ee,bt,dt,Y)),ai=He.set(l.ExtHostContext.ExtHostNotebookRenderers,new we.ExtHostNotebookRenderers(He,bt)),Rt=He.set(l.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(He,yt)),Jt=He.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(He.getProxy(l.MainContext.MainThreadTreeViews),dt,Y)),li=He.set(l.ExtHostContext.ExtHostEditorInsets,new ne.ExtHostEditorInsets(He.getProxy(l.MainContext.MainThreadEditorInsets),Rt,Ee)),Gt=He.set(l.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(He,Y,ye)),Zt=He.set(l.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(He,Et,dt.converter,ct)),pt=He.set(l.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(He,ct,Et,dt,Gt,Y,Me)),ci=He.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(He,pt)),Nt=He.set(l.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(He,Y,yt)),zt=He.set(l.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(He,$e,dt)),vi=He.set(l.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(He,dt,Y)),ui=He.set(l.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(He,dt,Et)),ei=He.set(l.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(He.getProxy(l.MainContext.MainThreadProgress))),Ci=He.set(l.ExtHostContext.ExtHosLabelService,new re.ExtHostLabelService(He)),wi=He.set(l.ExtHostContext.ExtHostTheming,new ie.ExtHostTheming(He)),ti=He.set(l.ExtHostContext.ExtHostAuthentication,new ae.ExtHostAuthentication(He)),Di=He.set(l.ExtHostContext.ExtHostTimeline,new me.ExtHostTimeline(He,dt)),di=He.set(l.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(He,{remote:Ee.remote},$e,Y,Me)),Qt=He.set(l.ExtHostContext.ExtHostWebviewPanels,new st.ExtHostWebviewPanels(He,di,$e)),hi=He.set(l.ExtHostContext.ExtHostCustomEditors,new rt.ExtHostCustomEditors(He,Et,_e,di,Qt)),ki=He.set(l.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(He,di)),Xt=He.set(l.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(He,dt)),Ii=He.set(l.ExtHostContext.ExtHostUriOpeners,new It.ExtHostUriOpeners(He));He.set(l.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(He,bt,yt,dt));const Pi=(0,J.values)(l.ExtHostContext);He.assertRegistered(Pi);const ii=new et.ExtHostBulkEdits(He,yt),Ai=new g.ExtHostClipboard(He),fi=new m.ExtHostMessageService(He,Y),bi=new h.ExtHostDialogs(He),ni=new O.ExtHostStatusBar(He,dt.converter);return b.ExtHostApiCommands.register(dt),function(Ue,xt,$t){const _t=function(){let le=!Ue.isUnderDevelopment;function ge(){le||(Y.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function Le(ht){if(Array.isArray(ht))ht.forEach(Le);else if(typeof ht=="string")ge();else{const Ct=ht;typeof Ct.scheme=="undefined"&&ge(),typeof Ct.exclusive=="boolean"&&(0,Ce.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return ht}}(),Ft={getSession(le,ge,Le){return ti.getSession(Ue,le,ge,Le)},async hasSession(le,ge){return(0,Ce.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,le,ge,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(le,ge,Le,ht){return ti.registerAuthenticationProvider(le,ge,Le,ht)}},ri={registerCommand(le,ge,Le){return dt.registerCommand(!0,le,ge,Le,void 0,Ue)},registerTextEditorCommand(le,ge,Le){return dt.registerCommand(!0,le,(...ht)=>{const Ct=Rt.getActiveTextEditor();if(!Ct){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}return Ct.edit(At=>{ge.apply(Le,[Ct,At,...ht])}).then(At=>{At||Y.warn("Edits from command "+le+" were not applied.")},At=>{Y.warn("An error occurred while running command "+le,At)})},void 0,void 0,Ue)},registerDiffInformationCommand:(le,ge,Le)=>((0,Ce.checkProposedApiEnabled)(Ue,"diffCommand"),dt.registerCommand(!0,le,async(...ht)=>{const Ct=yt.activeEditor(!0);if(!Ct){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}const At=await Rt.getDiffInformation(Ct.id);ge.apply(Le,[At,...ht])},void 0,void 0,Ue)),executeCommand(le,...ge){return dt.executeCommand(le,...ge)},getCommands(le=!1){return dt.getCommands(le)}},Ei={get machineId(){return Ee.telemetryInfo.machineId},get sessionId(){return Ee.telemetryInfo.sessionId},get language(){return Ee.environment.appLanguage},get appName(){return Ee.environment.appName},get appRoot(){return Ee.environment.appRoot?.fsPath??""},get appHost(){return Ee.environment.appHost},get uriScheme(){return Ee.environment.appUriScheme},get clipboard(){return Ai.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ye.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ye.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ce.checkProposedApiEnabled)(Ue,"telemetry"),Ye.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ce.checkProposedApiEnabled)(Ue,"telemetry"),Ye.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const le=Date.now()-new Date(Ee.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,ge){return Je.openUri(le,{allowTunneling:!!Ee.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===Ee.environment.appUriScheme)return kt.createAppUri(le);try{return await Je.asExternalUri(le,{allowTunneling:!!Ee.remote.authority})}catch(ge){if((0,Ve.matchesScheme)(le,ke.Schemas.http)||(0,Ve.matchesScheme)(le,ke.Schemas.https))return le;throw ge}},get remoteName(){return(0,Z.getRemoteName)(Ee.remote.authority)},get remoteAuthority(){return(0,Ce.checkProposedApiEnabled)(Ue,"resolvers"),Ee.remote.authority},get uiKind(){return Ee.uiKind}};Ee.environment.extensionTestsLocationURI||Object.freeze(Ei);const Si=Ee.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Ti={createTestController(le,ge,Le){return Le&&(0,Ce.checkProposedApiEnabled)(Ue,"testRefresh"),Xt.createTestController(le,ge,Le)},createTestObserver(){return(0,Ce.checkProposedApiEnabled)(Ue,"testObserver"),Xt.createTestObserver()},runTests(le){return(0,Ce.checkProposedApiEnabled)(Ue,"testObserver"),Xt.runTests(le)},get onDidChangeTestResults(){return(0,Ce.checkProposedApiEnabled)(Ue,"testObserver"),Xt.onResultsChanged},get testResults(){return(0,Ce.checkProposedApiEnabled)(Ue,"testObserver"),Xt.results}},Ri={getExtension(le){const ge=xt.getExtensionDescription(le);if(ge)return new a.Extension(Ge,Ue.identifier,ge,Si)},get all(){return xt.getAllExtensionDescriptions().map(le=>new a.Extension(Ge,Ue.identifier,le,Si))},get onDidChange(){return xt.onDidChange}},Li={createDiagnosticCollection(le){return Gt.createDiagnosticCollection(Ue.identifier,le)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:le=>Gt.getDiagnostics(le),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(le,ge){return Zt.changeLanguage(le.uri,ge)},match(le,ge){return(0,F.score)(z.LanguageSelector.from(le),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(le,ge,Le){return pt.registerCodeActionProvider(Ue,_t(le),ge,Le)},registerCodeLensProvider(le,ge){return pt.registerCodeLensProvider(Ue,_t(le),ge)},registerDefinitionProvider(le,ge){return pt.registerDefinitionProvider(Ue,_t(le),ge)},registerDeclarationProvider(le,ge){return pt.registerDeclarationProvider(Ue,_t(le),ge)},registerImplementationProvider(le,ge){return pt.registerImplementationProvider(Ue,_t(le),ge)},registerTypeDefinitionProvider(le,ge){return pt.registerTypeDefinitionProvider(Ue,_t(le),ge)},registerHoverProvider(le,ge){return pt.registerHoverProvider(Ue,_t(le),ge,Ue.identifier)},registerEvaluatableExpressionProvider(le,ge){return pt.registerEvaluatableExpressionProvider(Ue,_t(le),ge,Ue.identifier)},registerInlineValuesProvider(le,ge){return pt.registerInlineValuesProvider(Ue,_t(le),ge,Ue.identifier)},registerDocumentHighlightProvider(le,ge){return pt.registerDocumentHighlightProvider(Ue,_t(le),ge)},registerLinkedEditingRangeProvider(le,ge){return pt.registerLinkedEditingRangeProvider(Ue,_t(le),ge)},registerReferenceProvider(le,ge){return pt.registerReferenceProvider(Ue,_t(le),ge)},registerRenameProvider(le,ge){return pt.registerRenameProvider(Ue,_t(le),ge)},registerDocumentSymbolProvider(le,ge,Le){return pt.registerDocumentSymbolProvider(Ue,_t(le),ge,Le)},registerWorkspaceSymbolProvider(le){return pt.registerWorkspaceSymbolProvider(Ue,le)},registerDocumentFormattingEditProvider(le,ge){return pt.registerDocumentFormattingEditProvider(Ue,_t(le),ge)},registerDocumentRangeFormattingEditProvider(le,ge){return pt.registerDocumentRangeFormattingEditProvider(Ue,_t(le),ge)},registerOnTypeFormattingEditProvider(le,ge,Le,...ht){return pt.registerOnTypeFormattingEditProvider(Ue,_t(le),ge,[Le].concat(ht))},registerDocumentSemanticTokensProvider(le,ge,Le){return pt.registerDocumentSemanticTokensProvider(Ue,_t(le),ge,Le)},registerDocumentRangeSemanticTokensProvider(le,ge,Le){return pt.registerDocumentRangeSemanticTokensProvider(Ue,_t(le),ge,Le)},registerSignatureHelpProvider(le,ge,Le,...ht){return typeof Le=="object"?pt.registerSignatureHelpProvider(Ue,_t(le),ge,Le):pt.registerSignatureHelpProvider(Ue,_t(le),ge,typeof Le=="undefined"?[]:[Le,...ht])},registerCompletionItemProvider(le,ge,...Le){return pt.registerCompletionItemProvider(Ue,_t(le),ge,Le)},registerInlineCompletionItemProvider(le,ge){return(0,Ce.checkProposedApiEnabled)(Ue,"inlineCompletions"),pt.registerInlineCompletionsProvider(Ue,_t(le),ge)},registerDocumentLinkProvider(le,ge){return pt.registerDocumentLinkProvider(Ue,_t(le),ge)},registerColorProvider(le,ge){return pt.registerColorProvider(Ue,_t(le),ge)},registerFoldingRangeProvider(le,ge){return pt.registerFoldingRangeProvider(Ue,_t(le),ge)},registerSelectionRangeProvider(le,ge){return pt.registerSelectionRangeProvider(Ue,le,ge)},registerCallHierarchyProvider(le,ge){return pt.registerCallHierarchyProvider(Ue,le,ge)},registerTypeHierarchyProvider(le,ge){return pt.registerTypeHierarchyProvider(Ue,le,ge)},setLanguageConfiguration:(le,ge)=>pt.setLanguageConfiguration(Ue,le,ge),getTokenInformationAtPosition(le,ge){return(0,Ce.checkProposedApiEnabled)(Ue,"tokenInformation"),Zt.tokenAtPosition(le,ge)},registerInlayHintsProvider(le,ge){return(0,Ce.checkProposedApiEnabled)(Ue,"inlayHints"),pt.registerInlayHintsProvider(Ue,le,ge)},createLanguageStatusItem(le,ge){return(0,Ce.checkProposedApiEnabled)(Ue,"languageStatus"),Zt.createLanguageStatusItem(Ue,le,ge)}},Fi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(le,ge,Le){const ht=await(A.URI.isUri(le)?Promise.resolve(_i.openTextDocument(le)):Promise.resolve(le));return Rt.showTextDocument(ht,ge,Le)},createTextEditorDecorationType(le){return Rt.createTextEditorDecorationType(Ue,le)},onDidChangeActiveTextEditor(le,ge,Le){return Rt.onDidChangeActiveTextEditor(le,ge,Le)},onDidChangeVisibleTextEditors(le,ge,Le){return Rt.onDidChangeVisibleTextEditors(le,ge,Le)},onDidChangeTextEditorSelection(le,ge,Le){return Rt.onDidChangeTextEditorSelection(le,ge,Le)},onDidChangeTextEditorOptions(le,ge,Le){return Rt.onDidChangeTextEditorOptions(le,ge,Le)},onDidChangeTextEditorVisibleRanges(le,ge,Le){return Rt.onDidChangeTextEditorVisibleRanges(le,ge,Le)},onDidChangeTextEditorViewColumn(le,ge,Le){return Rt.onDidChangeTextEditorViewColumn(le,ge,Le)},onDidCloseTerminal(le,ge,Le){return vt.onDidCloseTerminal(le,ge,Le)},onDidOpenTerminal(le,ge,Le){return vt.onDidOpenTerminal(le,ge,Le)},onDidChangeActiveTerminal(le,ge,Le){return vt.onDidChangeActiveTerminal(le,ge,Le)},onDidChangeTerminalDimensions(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"terminalDimensions"),vt.onDidChangeTerminalDimensions(le,ge,Le)},onDidChangeTerminalState(le,ge,Le){return vt.onDidChangeTerminalState(le,ge,Le)},onDidWriteTerminalData(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(le,ge,Le)},get state(){return Je.state},onDidChangeWindowState(le,ge,Le){return Je.onDidChangeWindowState(le,ge,Le)},showInformationMessage(le,...ge){return fi.showMessage(Ue,C.default.Info,le,ge[0],ge.slice(1))},showWarningMessage(le,...ge){return fi.showMessage(Ue,C.default.Warning,le,ge[0],ge.slice(1))},showErrorMessage(le,...ge){return fi.showMessage(Ue,C.default.Error,le,ge[0],ge.slice(1))},showQuickPick(le,ge,Le){return zt.showQuickPick(le,ge,Le)},showWorkspaceFolderPick(le){return zt.showWorkspaceFolderPick(le)},showInputBox(le,ge){return zt.showInput(le,ge)},showOpenDialog(le){return bi.showOpenDialog(le)},showSaveDialog(le){return bi.showSaveDialog(le)},createStatusBarItem(le,ge,Le){let ht,Ct,At;return typeof le=="string"?(ht=le,Ct=ge,At=Le):(Ct=le,At=ge),ni.createStatusBarEntry(Ue,ht,Ct,At)},setStatusBarMessage(le,ge){return ni.setStatusBarMessage(le,ge)},withScmProgress(le){return Me.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ei.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(ge,Le)=>le({report(ht){}}))},withProgress(le,ge){return ei.withProgress(Ue,le,ge)},createOutputChannel(le){return Mt.createOutputChannel(le,Ue)},createWebviewPanel(le,ge,Le,ht){return Qt.createWebviewPanel(Ue,le,ge,Le,ht)},createWebviewTextEditorInset(le,ge,Le,ht){return(0,Ce.checkProposedApiEnabled)(Ue,"editorInsets"),li.createWebviewEditorInset(le,ge,Le,ht,Ue)},createTerminal(le,ge,Le){return typeof le=="object"?"pty"in le?vt.createExtensionTerminal(le):vt.createTerminalFromOptions(le):vt.createTerminal(le,ge,Le)},registerTerminalLinkProvider(le){return vt.registerLinkProvider(le)},registerTerminalProfileProvider(le,ge){return vt.registerProfileProvider(Ue,le,ge)},registerTreeDataProvider(le,ge){return Jt.registerTreeDataProvider(le,ge,Ue)},createTreeView(le,ge){return Jt.createTreeView(le,ge,Ue)},registerWebviewPanelSerializer:(le,ge)=>Qt.registerWebviewPanelSerializer(Ue,le,ge),registerCustomEditorProvider:(le,ge,Le={})=>hi.registerCustomEditorProvider(Ue,le,ge,Le),registerFileDecorationProvider(le){return St.registerFileDecorationProvider(le,Ue.identifier)},registerUriHandler(le){return kt.registerUriHandler(Ue.identifier,le)},createQuickPick(){return zt.createQuickPick(Ue)},createInputBox(){return zt.createInputBox(Ue.identifier)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(le,ge,Le){return wi.onDidChangeActiveColorTheme(le,ge,Le)},registerWebviewViewProvider(le,ge,Le){return ki.registerWebviewViewProvider(Ue,le,ge,Le?.webviewOptions)},get activeNotebookEditor(){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(le,ge,Le)},get visibleNotebookEditors(){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),Kt.onDidChangeNotebookEditorSelection(le,ge,Le)},onDidChangeNotebookEditorVisibleRanges(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),Kt.onDidChangeNotebookEditorVisibleRanges(le,ge,Le)},showNotebookDocument(le,ge){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.showNotebookDocument(le,ge)},registerExternalUriOpener(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ii.registerExternalUriOpener(Ue.identifier,le,ge,Le)},get tabs(){return(0,Ce.checkProposedApiEnabled)(Ue,"tabs"),mt.tabs},get activeTab(){return(0,Ce.checkProposedApiEnabled)(Ue,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,Ce.checkProposedApiEnabled)(Ue,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Ce.checkProposedApiEnabled)(Ue,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,Ce.checkProposedApiEnabled)(Ue,"inlineCompletions"),o.InlineCompletionController.get(le)}},_i={get rootPath(){return Me.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return $e.getWorkspaceFolder(le)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(le){throw t.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,ge,...Le)=>$e.updateWorkspaceFolders(Ue,le,ge||0,...Le),onDidChangeWorkspaceFolders:function(le,ge,Le){return $e.onDidChangeWorkspace(le,ge,Le)},asRelativePath:(le,ge)=>$e.getRelativePath(le,ge),findFiles:(le,ge,Le,ht)=>$e.findFiles(le,ge,Le,Ue.identifier,ht),findTextInFiles:(le,ge,Le,ht)=>{(0,Ce.checkProposedApiEnabled)(Ue,"findTextInFiles");let Ct,At;return typeof ge=="object"?(Ct=ge,At=Le):(Ct={},At=ge,ht=Le),$e.findTextInFiles(le,Ct||{},At,Ue.identifier,ht)},saveAll:le=>$e.saveAll(le),applyEdit(le){return ii.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,ge,Le,ht)=>Nt.createFileSystemWatcher($e,Ue,le,ge,Le,ht),get textDocuments(){return Et.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let ge;const Le=le;if(typeof le=="string")ge=Promise.resolve(A.URI.file(le));else if(A.URI.isUri(le))ge=Promise.resolve(le);else if(!Le||typeof Le=="object")ge=Et.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ht=>Et.ensureDocumentData(ht).then(Ct=>Ct.document))},onDidOpenTextDocument:(le,ge,Le)=>Et.onDidAddDocument(le,ge,Le),onDidCloseTextDocument:(le,ge,Le)=>Et.onDidRemoveDocument(le,ge,Le),onDidChangeTextDocument:(le,ge,Le)=>Et.onDidChangeDocument(le,ge,Le),onDidSaveTextDocument:(le,ge,Le)=>Et.onDidSaveDocument(le,ge,Le),onWillSaveTextDocument:(le,ge,Le)=>qt.getOnWillSaveTextDocumentEvent(Ue)(le,ge,Le),get notebookDocuments(){return bt.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,ge){let Le;if(A.URI.isUri(le))Le=le,await bt.openNotebookDocument(le);else if(typeof le=="string")Le=A.URI.revive(await bt.createNotebookDocument({viewType:le,content:ge}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Le).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(le,ge,Le,ht){return bt.registerNotebookSerializer(Ue,le,ge,Le,(0,Ce.isProposedApiEnabled)(Ue,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(le,ge,Le,ht)=>((0,Ce.checkProposedApiEnabled)(Ue,"notebookContentProvider"),bt.registerNotebookContentProvider(Ue,le,ge,Le,(0,Ce.isProposedApiEnabled)(Ue,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(le,ge,Le)=>$t.onDidChangeConfiguration(le,ge,Le),getConfiguration(le,ge){return ge=arguments.length===1?void 0:ge,$t.getConfiguration(le,ge,Ue)},registerTextDocumentContentProvider(le,ge){return Ot.registerTextDocumentContentProvider(le,ge)},registerTaskProvider:(le,ge)=>(Me.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Tt.registerTaskProvider(Ue,le,ge)),registerFileSystemProvider(le,ge,Le){return(0,Ae.combinedDisposable)(ci.registerFileSystemProvider(Ue,le,ge,Le),Oe.addFileSystemProvider(le,ge))},get fs(){return Oe.value},registerFileSearchProvider:(le,ge)=>((0,Ce.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Bt.registerFileSearchProvider(le,ge)),registerTextSearchProvider:(le,ge)=>((0,Ce.checkProposedApiEnabled)(Ue,"textSearchProvider"),Bt.registerTextSearchProvider(le,ge)),registerRemoteAuthorityResolver:(le,ge)=>((0,Ce.checkProposedApiEnabled)(Ue,"resolvers"),Ge.registerRemoteAuthorityResolver(le,ge)),registerResourceLabelFormatter:le=>((0,Ce.checkProposedApiEnabled)(Ue,"resolvers"),Ci.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,ge,Le)=>Nt.onDidCreateFile(le,ge,Le),onDidDeleteFiles:(le,ge,Le)=>Nt.onDidDeleteFile(le,ge,Le),onDidRenameFiles:(le,ge,Le)=>Nt.onDidRenameFile(le,ge,Le),onWillCreateFiles:(le,ge,Le)=>Nt.getOnWillCreateFileEvent(Ue)(le,ge,Le),onWillDeleteFiles:(le,ge,Le)=>Nt.getOnWillDeleteFileEvent(Ue)(le,ge,Le),onWillRenameFiles:(le,ge,Le)=>Nt.getOnWillRenameFileEvent(Ue)(le,ge,Le),openTunnel:le=>((0,Ce.checkProposedApiEnabled)(Ue,"resolvers"),Ie.openTunnel(Ue,le).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ce.checkProposedApiEnabled)(Ue,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(le,ge,Le)=>((0,Ce.checkProposedApiEnabled)(Ue,"resolvers"),Ie.onDidChangeTunnels(le,ge,Le)),registerPortAttributesProvider:(le,ge)=>((0,Ce.checkProposedApiEnabled)(Ue,"portsAttributes"),Ie.registerPortsAttributesProvider(le,ge)),registerTimelineProvider:(le,ge)=>((0,Ce.checkProposedApiEnabled)(Ue,"timeline"),Di.registerTimelineProvider(le,ge,Ue.identifier,dt.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:le=>((0,Ce.checkProposedApiEnabled)(Ue,"workspaceTrust"),$e.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,ge,Le)=>$e.onDidGrantWorkspaceTrust(le,ge,Le)},mi={get inputBox(){return Me.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ue)},createSourceControl(le,ge,Le){return vi.createSourceControl(Ue,le,ge,Le)}},Mi={createCommentController(le,ge){return ui.createCommentController(Ue,le,ge)}},Oi={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},onDidStartDebugSession(le,ge,Le){return wt.onDidStartDebugSession(le,ge,Le)},onDidTerminateDebugSession(le,ge,Le){return wt.onDidTerminateDebugSession(le,ge,Le)},onDidChangeActiveDebugSession(le,ge,Le){return wt.onDidChangeActiveDebugSession(le,ge,Le)},onDidReceiveDebugSessionCustomEvent(le,ge,Le){return wt.onDidReceiveDebugSessionCustomEvent(le,ge,Le)},onDidChangeBreakpoints(le,ge,Le){return wt.onDidChangeBreakpoints(le,ge,Le)},registerDebugConfigurationProvider(le,ge,Le){return wt.registerDebugConfigurationProvider(le,ge,Le||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,ge){return wt.registerDebugAdapterDescriptorFactory(Ue,le,ge)},registerDebugAdapterTrackerFactory(le,ge){return wt.registerDebugAdapterTrackerFactory(le,ge)},startDebugging(le,ge,Le){return!Le||typeof Le=="object"&&"configuration"in Le?wt.startDebugging(le,ge,{parentSession:Le}):wt.startDebugging(le,ge,Le||{})},stopDebugging(le){return wt.stopDebugging(le)},addBreakpoints(le){return wt.addBreakpoints(le)},removeBreakpoints(le){return wt.removeBreakpoints(le)},asDebugSourceUri(le,ge){return wt.asDebugSourceUri(le,ge)}},Ni={registerTaskProvider:(le,ge)=>Tt.registerTaskProvider(Ue,le,ge),fetchTasks:le=>Tt.fetchTasks(le),executeTask:le=>Tt.executeTask(Ue,le),get taskExecutions(){return Tt.taskExecutions},onDidStartTask:(le,ge,Le)=>Tt.onDidStartTask(le,ge,Le),onDidEndTask:(le,ge,Le)=>Tt.onDidEndTask(le,ge,Le),onDidStartTaskProcess:(le,ge,Le)=>Tt.onDidStartTaskProcess(le,ge,Le),onDidEndTaskProcess:(le,ge,Le)=>Tt.onDidEndTaskProcess(le,ge,Le)},Ui={createNotebookController(le,ge,Le,ht,Ct){return Yt.createNotebookController(Ue,le,ge,Le,ht,(0,Ce.isProposedApiEnabled)(Ue,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(le,ge)=>bt.registerNotebookCellStatusBarItemProvider(Ue,le,ge),get onDidSaveNotebookDocument(){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditorDecorationType"),Kt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Ue,le)},onDidChangeNotebookDocumentMetadata(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(le,ge,Le)},onDidChangeNotebookCells(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.onDidChangeNotebookCells(le,ge,Le)},onDidChangeNotebookCellExecutionState(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(le,ge,Le)},onDidChangeCellOutputs(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.onDidChangeCellOutputs(le,ge,Le)},onDidChangeCellMetadata(le,ge,Le){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookEditor"),bt.onDidChangeCellMetadata(le,ge,Le)},createConcatTextDocument(le,ge){return(0,Ce.checkProposedApiEnabled)(Ue,"notebookConcatTextDocument"),new De.ExtHostNotebookConcatDocument(bt,Et,le,ge)}};return{version:Ee.version,authentication:Ft,commands:ri,comments:Mi,debug:Oi,env:Ei,extensions:Ri,languages:Li,notebooks:Ui,scm:mi,tasks:Ni,tests:Ti,window:Fi,workspace:_i,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:P.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:l.UIKind,Uri:A.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:K.TextSearchCompleteMessageType,TreeDataTransfer:N.TreeDataTransfer,TreeDataTransferItem:N.TreeDataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ue}),define(ve[282],be([0,1,283,294,295,2,296]),function(ee,e,d,t,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(y,l,b,g,v,_){const R=_.environment.useHostProxy,p=typeof R=="boolean"?R:!_.remote.isRemote,h=(0,A.createProxyResolver)({resolveProxy:u=>y.resolveProxy(u),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(u,r,...S)=>{switch(u){case A.LogLevel.Trace:g.trace(r,...S);break;case A.LogLevel.Debug:g.debug(r,...S);break;case A.LogLevel.Info:g.info(r,...S);break;case A.LogLevel.Warning:g.warn(r,...S);break;case A.LogLevel.Error:g.error(r,...S);break;case A.LogLevel.Critical:g.critical(r,...S);break;case A.LogLevel.Off:break;default:a(u,r,S);break}function a(i,n,...o){g.error("Unknown log level",i),g.error(n,...o)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:u=>{v.$publicLog2("resolveProxy",u)},useHostProxy:p,env:process.env}),s=D(l,h);return F(b,s)}e.connectProxyResolver=k;function D(y,l){const b={config:y.getConfiguration("http").get("proxySupport")||"off"};y.onDidChangeConfiguration(v=>{b.config=y.getConfiguration("http").get("proxySupport")||"off"});const g={config:!!y.getConfiguration("http").get("systemCertificates")};return y.onDidChangeConfiguration(v=>{g.config=!!y.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},d,(0,A.createHttpPatch)(d,l,{config:"off"},g,!0)),on:Object.assign({},d,(0,A.createHttpPatch)(d,l,{config:"on"},g,!0)),override:Object.assign({},d,(0,A.createHttpPatch)(d,l,{config:"override"},g,!0)),onRequest:Object.assign({},d,(0,A.createHttpPatch)(d,l,b,g,!0)),default:Object.assign(d,(0,A.createHttpPatch)(d,l,b,g,!1))},https:{off:Object.assign({},t,(0,A.createHttpPatch)(t,l,{config:"off"},g,!0)),on:Object.assign({},t,(0,A.createHttpPatch)(t,l,{config:"on"},g,!0)),override:Object.assign({},t,(0,A.createHttpPatch)(t,l,{config:"override"},g,!0)),onRequest:Object.assign({},t,(0,A.createHttpPatch)(t,l,b,g,!0)),default:Object.assign(t,(0,A.createHttpPatch)(t,l,b,g,!1))},tls:Object.assign(I,(0,A.createTlsPatch)(I))}}const P=new Map;function F(y,l){return y.getExtensionPathIndex().then(b=>{const g=ee.__$__nodeRequire("module"),v=g._load;g._load=function(R,p,h){if(R==="tls")return l.tls;if(R!=="http"&&R!=="https")return v.apply(this,arguments);const s=l[R],u=b.findSubstr(C.URI.file(p.filename));let r=P.get(u);if(r||P.set(u,r={}),!r[R]){let S=s.default;r[R]={...S}}return r[R]}})}}),define(ve[138],be([0,1,37,297,105,17,74,32,9,8,2,31,69,298,276,92]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class R{constructor(f){this.outputChannel=f}provideTextSearchResults(f,w,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((O,E)=>{L.onCancellationRequested(()=>x());const M=S(f,w),U=w.folder.fsPath,V=M.map(Z=>Z.match(/^-/)?Z:`'${Z}'`).join(" ");this.outputChannel.appendLine(`${_} ${V}
 - cwd: ${U}`);let z=d.spawn(_,M,{cwd:U});z.on("error",Z=>{console.error(Z),this.outputChannel.appendLine("Error: "+(Z&&Z.message)),E((0,y.serializeSearchError)(new y.SearchError(Z&&Z.message,y.SearchErrorCode.rgProcessError)))});let N=!1;const W=new s(w.maxResults,U,w.previewOptions);W.on("result",Z=>{N=!0,J="",T.report(Z)});let B=!1;const x=()=>{B=!0,z&&z.kill(),W&&W.cancel()};let $=!1;W.on("hitLimit",()=>{$=!0,x()});let J="";z.stdout.on("data",Z=>{W.handleData(Z),N||(J+=Z)});let ne=!1;z.stdout.once("data",()=>ne=!0);let re="";z.stderr.on("data",Z=>{const Q=Z.toString();this.outputChannel.appendLine(Q),re+=Q}),z.on("close",()=>{if(this.outputChannel.appendLine(ne?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),J&&this.outputChannel.appendLine(`Got data without result: ${J}`),this.outputChannel.appendLine(""),B)O({limitHit:$});else{W.flush(),z=null;let Z;re&&!ne&&(Z=p(re))?E((0,y.serializeSearchError)(new y.SearchError(Z.message,Z.code))):O({limitHit:$})}})})}}e.RipgrepTextSearchEngine=R;function p(m){const f=m.split(`
`),w=f[0].trim();if(f.some(L=>L.startsWith("regex parse error")))return new y.SearchError(h(f),y.SearchErrorCode.regexParseError);const T=w.match(/grep config error: unknown encoding: (.*)/);if(T)return new y.SearchError(`Unknown encoding: ${T[1]}`,y.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new y.SearchError(w.charAt(0).toUpperCase()+w.substr(1),y.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new y.SearchError(w.charAt(0).toUpperCase()+w.substr(1),y.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new y.SearchError(w,y.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function h(m){const f=["Regex parse error"],w=m.filter(T=>T.startsWith("PCRE2:"));if(w.length>=1){const T=w[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];f.push(":"+L)}}return f.join("")}e.buildRegexParseError=h;class s extends t.EventEmitter{constructor(f,w,T){super();this.maxResults=f,this.rootFolder=w,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,w){return super.on(f,w),this}handleData(f){if(this.isDone)return;const w=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(w)}handleDecodedData(f){let w=f.indexOf(`
`);const T=this.remainder+f;if(w>=0)w+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;w>=0;)this.handleLine(T.substring(L,w).trim()),L=w+1,w=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(f){if(this.isDone||!f)return;let w;try{w=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(w.type==="match"){const T=u(w.data.path),L=F.URI.file(D.join(this.rootFolder,T)),O=this.createTextSearchMatch(w.data,L);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const T=u(w.data.path),L=F.URI.file(D.join(this.rootFolder,T));this.createTextSearchContext(w.data,L).forEach(E=>this.onResult(E))}}createTextSearchMatch(f,w){const T=f.line_number-1,L=u(f.lines),O=Buffer.from(L);let E=0,M=0,U=T;f.submatches.length===0&&f.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const V=(0,C.coalesce)(f.submatches.map((z,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const W=u(z.match),B=O.slice(E,z.start).toString().length,x=M+B,$=r(W),J=U,ne=$.numLines+J,re=$.numLines>0?$.lastLineLength:$.lastLineLength+x;return E=z.end,M=re,U=ne,new l.Range(J,x,ne,re)}));return(0,v.createTextSearchResult)(w,L,V,this.previewOptions)}createTextSearchContext(f,w){const T=u(f.lines),L=f.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((O,E)=>({text:O,uri:w,lineNumber:L+E}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=s;function u(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function r(m){const f=/\n/g;let w=0,T=-1,L;for(;L=f.exec(m);)w++,T=L.index;const O=T>=0?m.length-T-1:m.length;return{numLines:w,lastLineLength:O}}function S(m,f){const w=["--hidden"];w.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=(0,A.groupBy)(f.includes,E=>E.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const E=new Set;L.forEach(M=>{E.add(M)}),w.push("-g","!*"),E.forEach(M=>{a(M).map(v.anchorGlob).forEach(U=>{w.push("-g",U)})})}T&&T.length&&T.forEach(E=>{w.push("-g",E)}),f.excludes.map(v.anchorGlob).forEach(E=>w.push("-g",`!${E}`)),f.maxFileSize&&w.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),f.followSymlinks&&w.push("--follow"),f.encoding&&f.encoding!=="utf8"&&w.push("--encoding",f.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,P.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),f.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),m.isRegExp&&(m.pattern=i(m.pattern),w.push("--engine","auto"));let O;if(m.isWordMatch){const M=(0,P.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",M)}else if(m.isRegExp){let E=o(m.pattern);E=c(E),w.push("--regexp",E)}else O=m.pattern,w.push("--fixed-strings");return w.push("--no-config"),f.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),m.isMultiline&&w.push("--multiline"),f.beforeContext&&w.push("--before-context",f.beforeContext+""),f.afterContext&&w.push("--after-context",f.afterContext+""),w.push("--"),O&&w.push(O),w.push("."),w}function a(m){const f=(0,k.splitGlobAware)(m,"/");return f.map((w,T)=>f.slice(0,T+1).join("/"))}e.spreadGlobComponents=a;function i(m){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(f);)m=m.replace(f,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(w);)m=m.replace(w,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=i;const n=m=>m.type==="Assertion"&&m.kind==="lookbehind";function o(m){let f;try{f=new b.RegExpParser().parsePattern(m)}catch{return m}let w="",T=0;const L=(M,U,V)=>{w+=m.slice(T,M)+V,T=U},O=[];return new b.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const U=O[0];if(!U)L(M.start,M.end,"\\r?\\n");else if(!O.some(n))if(U.type==="CharacterClass")if(U.negate){const V=m.slice(U.start+2,M.start)+m.slice(M.end,U.end-1);if(U.parent?.type==="Quantifier"){const z=U.parent;L(z.start,z.end,(V?`[^${V}]`:".")+(z.greedy?"+":"*"))}else L(U.start,U.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=m.slice(U.start+1,M.start)+m.slice(M.end,U.end-1);L(U.start,U.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else U.type==="Quantifier"&&L(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){O.unshift(M)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(M){O.unshift(M)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(M){O.unshift(M)},onCharacterClassLeave(){O.shift()},onAssertionEnter(M){n(M)&&O.push(M)},onAssertionLeave(M){O[0]===M&&O.shift()}}).visit(f),w+=m.slice(T),w}e.fixRegexNewline=o;function c(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(ve[284],be([0,1,21,138,118,10]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,F,y,l){const b=new t.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===C.Schemas.userData){const g={...F,folder:F.folder.with({scheme:C.Schemas.file})},v=new I.Progress(_=>y.report({..._,uri:_.uri.with({scheme:F.folder.scheme})}));return this.withToken(l,_=>b.provideTextSearchResults(P,g,v,_))}else return this.withToken(l,g=>b.provideTextSearchResults(P,F,y,g))}async withToken(P,F){const y=k(P);this.inProgress.add(y);const l=await F(y.token);return this.inProgress.delete(y),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=A;function k(D){const P=new d.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(ve[285],be([0,1,29,138,137]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(D){this.query=D}search(D,P,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const y={appendLine(b){F({message:b})}},l=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(y),d);return new Promise((b,g)=>l.search(v=>{P(v.map(A))},D).then(v=>b({limitHit:v.limitHit,type:"success",stats:v.stats}),g))}}e.TextSearchEngineAdapter=C;function A(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,P)=>{if(P.ranges){const F=P;return D+(Array.isArray(F.ranges)?F.ranges.length:1)}else return D+1},0)}}}),define(ve[286],be([0,1,17,13,16,3,103,9,46,2,42,31,277,285]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class g{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let u;const r=R(s),S=new C.Emitter({onFirstListenerDidAdd:()=>{u=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(l.Engine,r,i=>S.fire(i),a)),u.then(a=>S.fire(a),a=>S.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return S.event}textSearch(s){let u;const r=R(s),S=new C.Emitter({onFirstListenerDidAdd:()=>{u=(0,t.createCancelablePromise)(a=>this.ripgrepTextSearch(r,i=>S.fire(i),a)),u.then(a=>S.fire(a),a=>S.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return S.event}ripgrepTextSearch(s,u,r){return s.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(s).search(r,u,u)}doFileSearch(s,u,r){return this.doFileSearchWithEngine(l.Engine,s,u,r)}doFileSearchWithEngine(s,u,r,S,a=g.BATCH_SIZE){let i=0;const n=c=>{Array.isArray(c)?(i+=c.length,r(c.map(m=>this.rawMatchToSearchItem(m)))):c.relativePath?(i++,r(this.rawMatchToSearchItem(c))):r(c)};if(u.sortByScore){let c=this.trySortedSearchFromCache(u,n,S);if(!c){const m=u.maxResults?Object.assign({},u,{maxResults:null}):u,f=new s(m);c=this.doSortedSearch(f,u,r,n,S)}return new Promise((m,f)=>{c.then(([w,T])=>{const L=T.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(L,r,a),m(w)},f)})}const o=new s(u);return this.doSearch(o,n,a,S).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,k.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,u,r,S,a){const i=new C.Emitter;let n=(0,t.createCancelablePromise)(c=>{let m=[];const f=w=>{Array.isArray(w)?m=w:(S(w),i.fire(w))};return this.doSearch(s,f,-1,c).then(w=>[w,m])}),o;if(u.cacheKey){o=this.getOrCreateCache(u.cacheKey);const c={promise:n,event:i.event,resolved:!1};o.resultsToSearchCache[u.filePattern||""]=c,n.then(()=>{c.resolved=!0},m=>{delete o.resultsToSearchCache[u.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([c,m])=>{const f=o?o.scorerCache:Object.create(null),w=(typeof u.maxResults!="number"||u.maxResults>0)&&D.StopWatch.create(!1);return this.sortResults(u,m,f,a).then(T=>{const L=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:L,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:T.length},messages:c.messages,limitHit:c.limitHit||typeof u.maxResults=="number"&&m.length>u.maxResults},T]})})}getOrCreateCache(s){const u=this.caches[s];return u||(this.caches[s]=new v)}trySortedSearchFromCache(s,u,r){const S=s.cacheKey&&this.caches[s.cacheKey];if(!S)return;const a=this.getResultsFromCache(S,s.filePattern||"",u,r);if(a)return a.then(([i,n,o])=>{const c=D.StopWatch.create(!1);return this.sortResults(s,n,S.scorerCache,r).then(m=>{const f=c.elapsed(),w={fromCache:!0,detailStats:o,type:this.processType,resultCount:n.length,sortingTime:f};return[{type:"success",limitHit:i.limitHit||typeof s.maxResults=="number"&&n.length>s.maxResults,stats:w},m]})})}sortResults(s,u,r,S){const a=(0,A.prepareQuery)(s.filePattern||""),i=(o,c)=>(0,A.compareItemsByFuzzyScore)(o,c,a,!0,_,r),n=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return d.topAsync(u,i,n,1e4,S)}sendProgress(s,u,r){if(r&&r>0)for(let S=0;S<s.length;S+=r)u(s.slice(S,S+r));else u(s)}getResultsFromCache(s,u,r,S){const a=D.StopWatch.create(!1),i=u.indexOf(k.sep)>=0;let n;for(const f in s.resultsToSearchCache)if(u.startsWith(f)){if(i&&f.indexOf(k.sep)<0&&f!=="")continue;const w=s.resultsToSearchCache[f];n={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!n)return null;const o=a.elapsed(),c=D.StopWatch.create(!1),m=n.event(r);return S&&S.onCancellationRequested(()=>{m.dispose()}),n.promise.then(([f,w])=>{if(S&&S.isCancellationRequested)throw(0,I.canceled)();const T=[],L=(0,A.prepareQuery)(u).normalizedLowercase;for(const O of w)!(0,y.isFilePatternMatch)(O,L)||T.push(O);return[f,T,{cacheWasResolved:n.resolved,cacheLookupTime:o,cacheFilterTime:c.elapsed(),cacheEntryCount:w.length}]})}doSearch(s,u,r,S){return new Promise((a,i)=>{let n=[];S&&S.onCancellationRequested(()=>s.cancel()),s.search(o=>{o&&(r?(n.push(o),r>0&&n.length>=r&&(u(n),n=[])):u(o))},o=>{u(o)},(o,c)=>{n.length&&u(n),o?i(o):a(c)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,r){return s.then(u,r)}catch(u){return this.then(void 0,u)}finally(u){return s.finally(u)}}}}e.SearchService=g,g.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(h){return(0,k.basename)(h.relativePath)}getItemDescription(h){return(0,k.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function R(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(p),extraFileResources:h.extraFileResources&&h.extraFileResources.map(s=>P.URI.revive(s))}}function p(h){return{...h,folder:P.URI.revive(h.folder)}}}),define(ve[287],be([0,1,6,10,2,29,12,26,14,72,64,31,286,284,92,137]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends P.ExtHostSearch{constructor(p,h,s,u){super(p,s,u);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const r=new g.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new b.RipgrepSearchProvider(r)),h.remote.isRemote&&h.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new g.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new b.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(t.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,h){const s=this._handlePool++;return this._internalFileSearchProvider=h,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(p)),(0,d.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(p,h,s,u){const r=(0,P.reviveQuery)(s);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,h,r,u):super.$provideFileSearchResults(p,h,s,u)}doInternalFileSearch(p,h,s,u){const r=S=>{if((0,y.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(p,h,S.map(a=>I.URI.file(a.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,r,u)}$clearCache(p){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,h){return new v.NativeTextSearchManager(p,h,void 0,"textSearchProvider")}};_=je([ze(0,D.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,F.IURITransformerService),ze(3,A.ILogService)],_),e.NativeExtHostSearch=_}),define(ve[139],be([0,1,299,126,80,22,16,3,6,9,11,33,107,108,300]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(w,T=""){this.debugLabel=T,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,A.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,T){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const T=L=>{this.traceSocketEvent("read",L),w(C.VSBuffer.wrap(L))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(w){const T=L=>{this.traceSocketEvent("close",{hadError:L}),w({type:0,hadError:L,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(w){const T=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,A.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,A.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=v;var _;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var R;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(R||(R={}));class p extends D.Disposable{constructor(w,T,L,O){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new h(this,T,L,O,this._onData,(E,M)=>this._write(E,M))),this._register(this._flowManager.onError(E=>{console.error(E),(0,A.onUnexpectedError)(E),this._onClose.fire({type:0,hadError:!0,error:E})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(E=>this._acceptChunk(E))),this._register(this.socket.onClose(E=>this._onClose.fire(E)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,T){this.socket.traceSocketEvent(w,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let L=2;w.byteLength<126?L+=0:w.byteLength<2**16?L+=2:L+=8;const O=C.VSBuffer.alloc(L);if(T?O.writeUInt8(194,0):O.writeUInt8(130,0),w.byteLength<126)O.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){O.writeUInt8(126,1);let E=1;O.writeUInt8(w.byteLength>>>8&255,++E),O.writeUInt8(w.byteLength>>>0&255,++E)}else{O.writeUInt8(127,1);let E=1;O.writeUInt8(0,++E),O.writeUInt8(0,++E),O.writeUInt8(0,++E),O.writeUInt8(0,++E),O.writeUInt8(w.byteLength>>>24&255,++E),O.writeUInt8(w.byteLength>>>16&255,++E),O.writeUInt8(w.byteLength>>>8&255,++E),O.writeUInt8(w.byteLength>>>0&255,++E)}this.socket.write(C.VSBuffer.concat([O,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),L=T.readUInt8(0),O=(L&128)>>>7,E=(L&64)>>>6,M=T.readUInt8(1),U=(M&128)>>>7,V=M&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(E)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),L=T.readUInt8(1),O=(L&128)>>>7;let E=L&127,M=1;E===126?E=T.readUInt8(++M)*2**8+T.readUInt8(++M):E===127&&(E=T.readUInt8(++M)*0+T.readUInt8(++M)*0+T.readUInt8(++M)*0+T.readUInt8(++M)*0+T.readUInt8(++M)*2**24+T.readUInt8(++M)*2**16+T.readUInt8(++M)*2**8+T.readUInt8(++M));let U=0;O&&(U=T.readUInt8(++M)*2**24+T.readUInt8(++M)*2**16+T.readUInt8(++M)*2**8+T.readUInt8(++M)),this._state.state=3,this._state.readLen=E,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),r(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class h extends D.Disposable{constructor(w,T,L,O,E,M){super();this._tracer=w,this._onData=E,this._writeFn=M,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new s(this._tracer,O,L,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(T,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,T){return new Promise((L,O)=>{w.write(T),w.flush(E=>L(E))})}acceptFrame(w,T,L){this._readQueue.push({data:w,isCompressed:T,isLastFrameOfMessage:L}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,T,L){return new Promise((O,E)=>{w.write(T),L&&w.write(C.VSBuffer.fromByteArray([0,0,255,255])),w.flush(M=>O(M))})}}class s extends D.Disposable{constructor(w,T,L,O){super();this._tracer=w,this._recordInflateBytes=T,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(O),this._zlibInflate.on("error",E=>{this._tracer.traceSocketEvent("zlibInflateError",{message:E?.message,code:E?.code}),this._onError.fire(E)}),this._zlibInflate.on("data",E=>{this._tracer.traceSocketEvent("zlibInflateData",E),this._pendingInflateData.push(C.VSBuffer.wrap(E))}),L&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(T)})}}class u extends D.Disposable{constructor(w,T){super();this._tracer=w,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibDeflate.on("data",L=>{this._tracer.traceSocketEvent("zlibDeflateData",L),this._pendingDeflateData.push(C.VSBuffer.wrap(L))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),w(T)})}}function r(f,w){if(w===0)return;let T=f.byteLength>>>2;for(let V=0;V<T;V++){const z=f.readUInt32BE(V*4);f.writeUInt32BE(z^w,V*4)}let L=T*4,O=f.byteLength-L;const E=w>>>24&255,M=w>>>16&255,U=w>>>8&255;O>=1&&f.writeUInt8(f.readUInt8(L)^E,L),O>=2&&f.writeUInt8(f.readUInt8(L+1)^M,L+1),O>=3&&f.writeUInt8(f.readUInt8(L+2)^U,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function a(){const f=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):w=(0,P.join)((0,I.tmpdir)(),`vscode-ipc-${f}.sock`),n(w),w}e.createRandomIPCHandle=a;function i(f,w,T){const L=(0,d.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${T}-${w}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${T}-${w}.sock`):O=(0,P.join)(f,`${T}-${w}.sock`),n(O),O}e.createStaticIPCHandle=i;function n(f){const w=S[F.platform];typeof w=="number"&&f.length>=w&&console.warn(`WARNING: IPC handle "${f}" is longer than ${w} chars, try a shorter --user-data-dir`)}class o extends l.IPCServer{constructor(w){super(o.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const T=k.Event.fromNodeEventEmitter(w,"connection");return k.Event.map(T,L=>({protocol:new b.Protocol(new v(L,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(f){return new Promise((w,T)=>{const L=(0,t.createServer)();L.on("error",T),L.listen(f,()=>{L.removeListener("error",T),w(new o(L))})})}e.serve=c;function m(f,w){return new Promise((T,L)=>{const O=(0,t.createConnection)(f,()=>{O.removeListener("error",L),T(b.Client.fromSocket(new v(O,`ipc-client${w}`),w))});O.once("error",L)})}e.connect=m}),define(ve[288],be([0,1,139,283,60,38,2,199,12]),function(ee,e,d,t,I,C,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,b,g){this._commands=l,this.logService=b,this._ipcHandlePath=g,this._server=t.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(b.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,b){const g=[];l.setEncoding("utf8"),l.on("data",v=>g.push(v)),l.on("end",()=>{const v=JSON.parse(g.join(""));switch(v.type){case"open":this.open(v,b);break;case"openExternal":this.openExternal(v,b);break;case"status":this.getStatus(v,b);break;case"extensionManagement":this.manageExtensions(v,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),b.end();break}})}open(l,b){const{fileURIs:g,folderURIs:v,forceNewWindow:_,diffMode:R,addMode:p,forceReuseWindow:h,gotoLineMode:s,waitMarkerFilePath:u,remoteAuthority:r}=l,S=[];if(Array.isArray(v))for(const o of v)try{S.push({folderUri:A.URI.parse(o)})}catch{}if(Array.isArray(g))for(const o of g)try{(0,k.hasWorkspaceFileExtension)(o)?S.push({workspaceUri:A.URI.parse(o)}):S.push({fileUri:A.URI.parse(o)})}catch{}const a=u?A.URI.file(u):void 0,n={forceNewWindow:_,diffMode:R,addMode:p,gotoLineMode:s,forceReuseWindow:h,preferNewWindow:!h&&!a&&!p,waitMarkerFileURI:a,remoteAuthority:r};this._commands.executeCommand("_remoteCLI.windowOpen",S,n),b.writeHead(200),b.end()}async openExternal(l,b){for(const g of l.uris){const v=A.URI.parse(g),_=v.scheme==="file"?v:g;await this._commands.executeCommand("_remoteCLI.openExternal",_)}b.writeHead(200),b.end()}async manageExtensions(l,b){try{const g=R=>R?.map(p=>/\.vsix$/i.test(p)?A.URI.parse(p):p),v={list:l.list,install:g(l.install),uninstall:g(l.uninstall),force:l.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);b.writeHead(200),b.write(_)}catch(g){b.writeHead(500),b.write(String(g),v=>{v&&this.logService.error(v)})}b.end()}async getStatus(l,b){try{const g=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(g),b.end()}catch(g){b.writeHead(500),b.write(String(g),v=>{v&&this.logService.error(v)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let F=class extends P{constructor(l,b){super(l,b,(0,d.createRandomIPCHandle)())}};F=je([ze(0,C.IExtHostCommands),ze(1,D.ILogService)],F),e.CLIServer=F}),define(ve[289],be([0,1,71,281,269,5,282,39,259,2,10,7,288,106]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class g extends I.RequireInterceptor{_installInterceptor(){const R=this,p=ee.__$__nodeRequire("module"),h=p._load;p._load=function(S,a,i){return S=u(S),R._factories.has(S)?R._factories.get(S).load(S,P.URI.file((0,b.realpathSync)(a.filename)),n=>h.apply(this,[n,a,i])):h.apply(this,arguments)};const s=p._resolveLookupPaths;p._resolveLookupPaths=(r,S)=>s.call(this,u(r),S);const u=r=>{for(let S of R._alternatives){let a=S(r);if(a){r=a;break}}return r}}}class v extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const R=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const r=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}await this._instaService.createInstance(g,R,this._registry).install(),d.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),d.mark("code/extHost/didInitProxyResolver");const s=process.send,u=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...r)=>r.length===0||!r[0]||r[0].type!=="__$console"?s.apply(process,r):(u.$logExtensionHostMessage(r[0]),!1)}_getEntryPoint(R){return R.main}_loadCommonJSModule(R,p,h){if(p.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let s=null;h.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{R&&d.mark(`code/extHost/willLoadExtensionCode/${R.value}`),s=ee.__$__nodeRequire(p.fsPath)}catch(u){return Promise.reject(u)}finally{R&&d.mark(`code/extHost/didLoadExtensionCode/${R.value}`),h.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(R){if(!!this._initData.remote.isRemote)for(const p in R){const h=R[p];h===null?delete process.env[p]:process.env[p]=h}}}e.ExtHostExtensionService=v}),define(ve[290],be([0,1,61,262,271,270,287,289,263,54,39,72,70,34,51,67,261,260,12]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(F.IExtHostExtensionService,k.ExtHostExtensionService),(0,d.registerSingleton)(p.ILoggerService,R.ExtHostLoggerService),(0,d.registerSingleton)(v.IExtensionStoragePaths,_.ExtensionStoragePaths),(0,d.registerSingleton)(P.IExtHostDebugService,C.ExtHostDebugService),(0,d.registerSingleton)(y.IExtHostSearch,A.NativeExtHostSearch),(0,d.registerSingleton)(l.IExtHostTask,I.ExtHostTask),(0,d.registerSingleton)(b.IExtHostTerminalService,t.ExtHostTerminalService),(0,d.registerSingleton)(g.IExtHostTunnelService,D.ExtHostTunnelService)}),define(ve[291],be([0,1,126,301,71,16,108,139,191,224,272,22,104,29,106,13,114,274,290]),function(ee,e,d,t,I,C,A,k,D,P,F,y,l,b,g,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const R=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=ee.__$__nodeRequire("module"),n=i._load;i._load=function(o){if(o==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const p=process.exit.bind(process);function h(i){process.exit=function(n){if(i)p(n);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let s=function(i){p()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,n)=>{let o=null,c=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,f=3e5,w=new v.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),m),T=new v.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),f);process.on("message",(O,E)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){E.setNoDelay(!0);const M=y.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let U;if(O.skipWebSocketFrames)U=new k.NodeSocket(E,"extHost-socket");else{const V=y.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));U=new k.WebSocketNodeSocket(new k.NodeSocket(E,"extHost-socket"),O.permessageDeflate,V,!1)}o?(w.cancel(),T.cancel(),o.beginAcceptReconnection(U,M),o.endAcceptReconnection(),o.sendResume()):(clearTimeout(c),o=new A.PersistentProtocol(U,M),o.sendResume(),o.onDidDispose(()=>s("renderer disconnected")),i(o),o.onSocketClose(()=>{w.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;w.isScheduled()&&T.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,o)=>{const c=d.createConnection(i,()=>{c.removeListener("error",o),n(new A.PersistentProtocol(new k.NodeSocket(c,"extHost-renderer")))});c.once("error",o),c.on("close",()=>{s("renderer closed the socket")})})}}async function r(){const i=await u();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(n=>{(0,P.isMessageOfType)(n,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||i.send(n)}drain(){return i.drain()}}}function S(i){return new Promise(n=>{const o=i.onMessage(c=>{o.dispose();const m=JSON.parse(c.toString()),f=m.commit,w=D.default.commit;f&&w&&f!==w&&p(55);let T=0;setInterval(function(){try{process.kill(m.parentPid,0),T=0}catch(O){O&&O.code==="EPERM"?(T++,T>=3&&s(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):s(`parent process ${m.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let L;try{L=ee.__$__nodeRequire("native-watchdog"),L.start(m.parentPid)}catch(O){(0,C.onUnexpectedError)(O)}i.send((0,P.createMessageOfType)(0)),n({protocol:i,initData:m})});i.send((0,P.createMessageOfType)(1))})}async function a(){const i=[];process.on("unhandledRejection",(T,L)=>{i.push(L),setTimeout(()=>{const O=i.indexOf(L);O>=0&&L.catch(E=>{i.splice(O,1),(0,C.isCancellationError)(E)||(console.warn(`rejected promise not handled within 1 second: ${E}`),E&&E.stack&&console.warn(`stack trace: ${E.stack}`),T&&(0,C.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const L=i.indexOf(T);L>=0&&i.splice(L,1)}),process.on("uncaughtException",function(T){(0,C.onUnexpectedError)(T)}),I.mark("code/extHost/willConnectToRenderer");const n=await r();I.mark("code/extHost/didConnectToRenderer");const o=await S(n);I.mark("code/extHost/didWaitForInitData");const{initData:c}=o;h(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=!!R.useHostProxy,c.environment.skipWorkspaceStorageLock=(0,_.boolean)(R.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(L){p(L)}exists(L){return b.Promises.exists(L)}realpath(L){return(0,g.realpath)(L)}};let f=null;if(c.remote.authority&&R.uriTransformerPath)try{const L=ee.__$__nodeRequire(R.uriTransformerPath)(c.remote.authority);f=new l.URITransformer(L)}catch(T){console.error(T)}const w=new F.ExtensionHostMain(o.protocol,c,m,f);s=T=>w.terminate(T)}e.startExtensionHostProcess=a}),define(ve[302],be([0,1,291]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.startExtensionHostProcess)().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36c1f3bd16fce1c215b23e577a080f7f63755fcc/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
