/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/async","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/platform/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/glob","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/extpath","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/core/range","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/editor/common/languageSelector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(Z){for(var e=[],i=0,A=Z.length;i<A;i++)e[i]=be[Z[i]];return e};define(be[41],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function i(A,_){if(!A)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=i}),define(be[67],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const i=Object.prototype.hasOwnProperty;function A(O){const m=[];for(let t in O)i.call(O,t)&&m.push(O[t]);return m}e.values=A;function _(O,m){for(let t in O)if(i.call(O,t)&&m({key:t,value:O[t]},function(){delete O[t]})===!1)return}e.forEach=_;function D(O,m){const t=Object.create(null);for(const u of O){const s=m(u);let a=t[s];a||(a=t[s]=[]),a.push(u)}return t}e.groupBy=D;function M(O){const m=Object.create(null);return O&&O.forEach((t,u)=>{m[u]=t}),m}e.fromMap=M;function T(O,m){const t=[],u=[];for(let s of O)m.has(s)||t.push(s);for(let s of m)O.has(s)||u.push(s);return{removed:t,added:u}}e.diffSets=T;function y(O,m){const t=[],u=[];for(let[s,a]of O)m.has(s)||t.push(a);for(let[s,a]of m)O.has(s)||u.push(a);return{removed:t,added:u}}e.diffMaps=y;class F{constructor(){this.map=new Map}add(m,t){let u=this.map.get(m);u||(u=new Set,this.map.set(m,u)),u.add(t)}delete(m,t){const u=this.map.get(m);!u||(u.delete(t),u.size===0&&this.map.delete(m))}forEach(m,t){const u=this.map.get(m);!u||u.forEach(t)}}e.SetMap=F}),define(be[51],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function i(M){return(T,y,F)=>{let O=null,m=null;if(typeof F.value=="function"?(O="value",m=F.value):typeof F.get=="function"&&(O="get",m=F.get),!m)throw new Error("not supported");F[O]=M(m,y)}}e.createDecorator=i;function A(M,T,y){let F=null,O=null;if(typeof y.value=="function"?(F="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(F="get",O=y.get),!O)throw new Error("not supported");const m=`$memoize$${T}`;y[F]=function(...t){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,t)}),this[m]}}e.memoize=A;function _(M,T,y){return i((F,O)=>{const m=`$debounce$${O}`,t=`$debounce$result$${O}`;return function(...u){this[t]||(this[t]=y?y():void 0),clearTimeout(this[m]),T&&(this[t]=T(this[t],...u),u=[this[t]]),this[m]=setTimeout(()=>{F.apply(this,u),this[t]=y?y():void 0},M)}})}e.debounce=_;function D(M,T,y){return i((F,O)=>{const m=`$throttle$timer$${O}`,t=`$throttle$result$${O}`,u=`$throttle$lastRun$${O}`,s=`$throttle$pending$${O}`;return function(...a){if(this[t]||(this[t]=y?y():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),T&&(this[t]=T(this[t],...a)),this[s])return;const l=this[u]+M;l<=Date.now()?(this[u]=Date.now(),F.apply(this,[this[t]]),this[t]=y?y():void 0):(this[s]=!0,this[m]=setTimeout(()=>{this[s]=!1,this[u]=Date.now(),F.apply(this,[this[t]]),this[t]=y?y():void 0},l-Date.now()))}})}e.throttle=D}),define(be[52],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(be[97],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var A;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(n){n.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function M(n,P=!1){let r=0,c=n.length,w="",h=0,d=16,g=0;function f(x){let j=0,H=0;for(;j<x;){const z=n.charCodeAt(r);if(z>=48&&z<=57)H=H*16+z-48;else if(z>=65&&z<=70)H=H*16+z-65+10;else if(z>=97&&z<=102)H=H*16+z-97+10;else break;r++,j++}return j<x&&(H=-1),H}function E(x){r=x,w="",h=0,d=16,g=0}function C(){const x=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&F(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&F(n.charCodeAt(r)))for(r++;r<n.length&&F(n.charCodeAt(r));)r++;else return g=3,n.substring(x,r);let j=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&F(n.charCodeAt(r))){for(r++;r<n.length&&F(n.charCodeAt(r));)r++;j=r}else g=3;return n.substring(x,j)}function I(){let x="",j=r;for(;;){if(r>=c){x+=n.substring(j,r),g=2;break}const H=n.charCodeAt(r);if(H===34){x+=n.substring(j,r),r++;break}if(H===92){if(x+=n.substring(j,r),r++,r>=c){g=2;break}switch(n.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const K=f(4);K>=0?x+=String.fromCharCode(K):g=4;break}default:g=5}j=r;continue}if(H>=0&&H<=31)if(y(H)){x+=n.substring(j,r),g=2;break}else g=6;r++}return x}function N(){if(w="",g=0,h=r,r>=c)return h=c,d=17;let x=n.charCodeAt(r);if(T(x)){do r++,w+=String.fromCharCode(x),x=n.charCodeAt(r);while(T(x));return d=15}if(y(x))return r++,w+=String.fromCharCode(x),x===13&&n.charCodeAt(r)===10&&(r++,w+=`
`),d=14;switch(x){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,w=I(),d=10;case 47:{const j=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<c&&!y(n.charCodeAt(r));)r++;return w=n.substring(j,r),d=12}if(n.charCodeAt(r+1)===42){r+=2;const H=c-1;let z=!1;for(;r<H;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,z=!0;break}r++}return z||(r++,g=1),w=n.substring(j,r),d=13}return w+=String.fromCharCode(x),r++,d=16}case 45:if(w+=String.fromCharCode(x),r++,r===c||!F(n.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=C(),d=11;default:for(;r<c&&p(x);)r++,x=n.charCodeAt(r);if(h!==r){switch(w=n.substring(h,r),w){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return w+=String.fromCharCode(x),r++,d=16}}function p(x){if(T(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let x;do x=N();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:P?R:N,getToken:()=>d,getTokenValue:()=>w,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>g}}e.createScanner=M;function T(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function F(n){return n>=48&&n<=57}var O;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(O||(O={}));function m(n,P){const r=[],c=new Object;let w;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function g(f,E,C,I){h.value=f,h.offset=E,h.length=C,h.type=I,h.colonOffset=void 0,w=h}try{b(n,{onObjectBegin:(f,E)=>{if(P<=f)throw c;w=void 0,d=P>f,r.push("")},onObjectProperty:(f,E,C)=>{if(P<E||(g(f,E,C,"property"),r[r.length-1]=f,P<=E+C))throw c},onObjectEnd:(f,E)=>{if(P<=f)throw c;w=void 0,r.pop()},onArrayBegin:(f,E)=>{if(P<=f)throw c;w=void 0,r.push(0)},onArrayEnd:(f,E)=>{if(P<=f)throw c;w=void 0,r.pop()},onLiteralValue:(f,E,C)=>{if(P<E||(g(f,E,C,S(f)),P<=E+C))throw c},onSeparator:(f,E,C)=>{if(P<=E)throw c;if(f===":"&&w&&w.type==="property")w.colonOffset=E,d=!1,w=void 0;else if(f===","){const I=r[r.length-1];typeof I=="number"?r[r.length-1]=I+1:(d=!0,r[r.length-1]=""),w=void 0}}})}catch(f){if(f!==c)throw f}return{path:r,previousNode:w,isAtPropertyKey:d,matches:f=>{let E=0;for(let C=0;E<f.length&&C<r.length;C++)if(f[E]===r[C]||f[E]==="*")E++;else if(f[E]!=="**")return!1;return E===f.length}}}e.getLocation=m;function t(n,P=[],r=D.DEFAULT){let c=null,w=[];const h=[];function d(f){Array.isArray(w)?w.push(f):c!==null&&(w[c]=f)}return b(n,{onObjectBegin:()=>{const f={};d(f),h.push(w),w=f,c=null},onObjectProperty:f=>{c=f},onObjectEnd:()=>{w=h.pop()},onArrayBegin:()=>{const f=[];d(f),h.push(w),w=f,c=null},onArrayEnd:()=>{w=h.pop()},onLiteralValue:d,onError:(f,E,C)=>{P.push({error:f,offset:E,length:C})}},r),w[0]}e.parse=t;function u(n,P=[],r=D.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(f){c.type==="property"&&(c.length=f-c.offset,c=c.parent)}function h(f){return c.children.push(f),f}b(n,{onObjectBegin:f=>{c=h({type:"object",offset:f,length:-1,parent:c,children:[]})},onObjectProperty:(f,E,C)=>{c=h({type:"property",offset:E,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:f,offset:E,length:C,parent:c})},onObjectEnd:(f,E)=>{c.length=f+E-c.offset,c=c.parent,w(f+E)},onArrayBegin:(f,E)=>{c=h({type:"array",offset:f,length:-1,parent:c,children:[]})},onArrayEnd:(f,E)=>{c.length=f+E-c.offset,c=c.parent,w(f+E)},onLiteralValue:(f,E,C)=>{h({type:S(f),offset:E,length:C,parent:c,value:f}),w(E+C)},onSeparator:(f,E,C)=>{c.type==="property"&&(f===":"?c.colonOffset=E:f===","&&w(E))},onError:(f,E,C)=>{P.push({error:f,offset:E,length:C})}},r);const g=c.children[0];return g&&delete g.parent,g}e.parseTree=u;function s(n,P){if(!n)return;let r=n;for(let c of P)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let w=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===c){r=h.children[1],w=!0;break}if(!w)return}else{const w=c;if(r.type!=="array"||w<0||!Array.isArray(r.children)||w>=r.children.length)return;r=r.children[w]}return r}e.findNodeAtLocation=s;function a(n){if(!n.parent||!n.parent.children)return[];const P=a(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;P.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&P.push(r)}return P}e.getNodePath=a;function l(n){switch(n.type){case"array":return n.children.map(l);case"object":{const P=Object.create(null);for(let r of n.children){const c=r.children[1];c&&(P[r.children[0].value]=l(c))}return P}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=l;function k(n,P,r=!1){return P>=n.offset&&P<n.offset+n.length||r&&P===n.offset+n.length}e.contains=k;function v(n,P,r=!1){if(k(n,P,r)){const c=n.children;if(Array.isArray(c))for(let w=0;w<c.length&&c[w].offset<=P;w++){const h=v(c[w],P,r);if(h)return h}return n}}e.findNodeAtOffset=v;function b(n,P,r=D.DEFAULT){const c=M(n,!1);function w(ve){return ve?()=>ve(c.getTokenOffset(),c.getTokenLength()):()=>!0}function h(ve){return ve?Me=>ve(Me,c.getTokenOffset(),c.getTokenLength()):()=>!0}const d=w(P.onObjectBegin),g=h(P.onObjectProperty),f=w(P.onObjectEnd),E=w(P.onArrayBegin),C=w(P.onArrayEnd),I=h(P.onLiteralValue),N=h(P.onSeparator),p=w(P.onComment),R=h(P.onError),x=r&&r.disallowComments,j=r&&r.allowTrailingComma;function H(){for(;;){const ve=c.scan();switch(c.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:x||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ve){case 12:case 13:x?z(10):p();break;case 16:z(1);break;case 15:case 14:break;default:return ve}}}function z(ve,Me=[],je=[]){if(R(ve),Me.length+je.length>0){let et=c.getToken();for(;et!==17;){if(Me.indexOf(et)!==-1){H();break}else if(je.indexOf(et)!==-1)break;et=H()}}}function K(ve){const Me=c.getTokenValue();return ve?I(Me):g(Me),H(),!0}function ce(){switch(c.getToken()){case 11:{let ve=0;try{ve=JSON.parse(c.getTokenValue()),typeof ve!="number"&&(z(2),ve=0)}catch{z(2)}I(ve);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return H(),!0}function fe(){return c.getToken()!==10?(z(3,[],[2,5]),!1):(K(!1),c.getToken()===6?(N(":"),H(),ye()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function re(){d(),H();let ve=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(ve||z(4,[],[]),N(","),H(),c.getToken()===2&&j)break}else ve&&z(6,[],[]);fe()||z(4,[],[2,5]),ve=!0}return f(),c.getToken()!==2?z(7,[2],[]):H(),!0}function ge(){E(),H();let ve=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(ve||z(4,[],[]),N(","),H(),c.getToken()===4&&j)break}else ve&&z(6,[],[]);ye()||z(4,[],[4,5]),ve=!0}return C(),c.getToken()!==4?z(8,[4],[]):H(),!0}function ye(){switch(c.getToken()){case 3:return ge();case 1:return re();case 10:return K(!0);default:return ce()}}return H(),c.getToken()===17?r.allowEmptyContent?!0:(z(4,[],[]),!1):ye()?(c.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function o(n,P){let r=M(n),c=[],w,h=0,d;do switch(d=r.getPosition(),w=r.scan(),w){case 12:case 13:case 17:h!==d&&c.push(n.substring(h,d)),P!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,P)),h=r.getPosition();break}while(w!==17);return c.join("")}e.stripComments=o;function S(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ie,Se){for(var he=0;he<Se.length;he++){var ee=Se[he];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Ie,ee.key,ee)}}function e(Ie,Se,he){return Se&&Z(Ie.prototype,Se),he&&Z(Ie,he),Ie}function i(Ie,Se){if(!!Ie){if(typeof Ie=="string")return A(Ie,Se);var he=Object.prototype.toString.call(Ie).slice(8,-1);if(he==="Object"&&Ie.constructor&&(he=Ie.constructor.name),he==="Map"||he==="Set")return Array.from(Ie);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return A(Ie,Se)}}function A(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var he=0,ee=new Array(Se);he<Se;he++)ee[he]=Ie[he];return ee}function _(Ie,Se){var he=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(he)return(he=he.call(Ie)).next.bind(he);if(Array.isArray(Ie)||(he=i(Ie))||Se&&Ie&&typeof Ie.length=="number"){he&&(Ie=he);var ee=0;return function(){return ee>=Ie.length?{done:!0}:{done:!1,value:Ie[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var D={exports:{}};function M(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(Ie){D.exports.defaults=Ie}D.exports={defaults:M(),getDefaults:M,changeDefaults:T};var y=/[&<>"']/,F=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,m=/[<>"']|&(?!#?\w+;)/g,t={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(Se){return t[Se]};function s(Ie,Se){if(Se){if(y.test(Ie))return Ie.replace(F,u)}else if(O.test(Ie))return Ie.replace(m,u);return Ie}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(Ie){return Ie.replace(a,function(Se,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var k=/(^|[^\[])\^/g;function v(Ie,Se){Ie=Ie.source||Ie,Se=Se||"";var he={replace:function(te,ue){return ue=ue.source||ue,ue=ue.replace(k,"$1"),Ie=Ie.replace(te,ue),he},getRegex:function(){return new RegExp(Ie,Se)}};return he}var b=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Ie,Se,he){if(Ie){var ee;try{ee=decodeURIComponent(l(he)).replace(b,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}Se&&!o.test(he)&&(he=w(Se,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var n={},P=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Ie,Se){n[" "+Ie]||(P.test(Ie)?n[" "+Ie]=Ie+"/":n[" "+Ie]=f(Ie,"/",!0)),Ie=n[" "+Ie];var he=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?he?Se:Ie.replace(r,"$1")+Se:Se.charAt(0)==="/"?he?Se:Ie.replace(c,"$1")+Se:Ie+Se}var h={exec:function(){}};function d(Ie){for(var Se=1,he,ee;Se<arguments.length;Se++){he=arguments[Se];for(ee in he)Object.prototype.hasOwnProperty.call(he,ee)&&(Ie[ee]=he[ee])}return Ie}function g(Ie,Se){var he=Ie.replace(/\|/g,function(ue,de,ke){for(var xe=!1,Ae=de;--Ae>=0&&ke[Ae]==="\\";)xe=!xe;return xe?"|":" |"}),ee=he.split(/ \|/),te=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>Se)ee.splice(Se);else for(;ee.length<Se;)ee.push("");for(;te<ee.length;te++)ee[te]=ee[te].trim().replace(/\\\|/g,"|");return ee}function f(Ie,Se,he){var ee=Ie.length;if(ee===0)return"";for(var te=0;te<ee;){var ue=Ie.charAt(ee-te-1);if(ue===Se&&!he)te++;else if(ue!==Se&&he)te++;else break}return Ie.substr(0,ee-te)}function E(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var he=Ie.length,ee=0,te=0;te<he;te++)if(Ie[te]==="\\")te++;else if(Ie[te]===Se[0])ee++;else if(Ie[te]===Se[1]&&(ee--,ee<0))return te;return-1}function C(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Ie,Se){if(Se<1)return"";for(var he="";Se>1;)Se&1&&(he+=Ie),Se>>=1,Ie+=Ie;return he+Ie}var N={escape:s,unescape:l,edit:v,cleanUrl:S,resolveUrl:w,noopTest:h,merge:d,splitCells:g,rtrim:f,findClosingBracket:E,checkSanitizeDeprecation:C,repeatString:I},p=D.exports.defaults,R=N.rtrim,x=N.splitCells,j=N.escape,H=N.findClosingBracket;function z(Ie,Se,he,ee){var te=Se.href,ue=Se.title?j(Se.title):null,de=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){ee.state.inLink=!0;var ke={type:"link",raw:he,href:te,title:ue,text:de,tokens:ee.inlineTokens(de,[])};return ee.state.inLink=!1,ke}else return{type:"image",raw:he,href:te,title:ue,text:j(de)}}function K(Ie,Se){var he=Ie.match(/^(\s+)(?:```)/);if(he===null)return Se;var ee=he[1];return Se.split(`
`).map(function(te){var ue=te.match(/^\s+/);if(ue===null)return te;var de=ue[0];return de.length>=ee.length?te.slice(ee.length):te}).join(`
`)}var ce=function(){function Ie(he){this.options=he||p}var Se=Ie.prototype;return Se.space=function(ee){var te=this.rules.block.newline.exec(ee);if(te)return te[0].length>1?{type:"space",raw:te[0]}:{raw:`
`}},Se.code=function(ee){var te=this.rules.block.code.exec(ee);if(te){var ue=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:R(ue,`
`)}}},Se.fences=function(ee){var te=this.rules.block.fences.exec(ee);if(te){var ue=te[0],de=K(ue,te[3]||"");return{type:"code",raw:ue,lang:te[2]?te[2].trim():te[2],text:de}}},Se.heading=function(ee){var te=this.rules.block.heading.exec(ee);if(te){var ue=te[2].trim();if(/#$/.test(ue)){var de=R(ue,"#");(this.options.pedantic||!de||/ $/.test(de))&&(ue=de.trim())}var ke={type:"heading",raw:te[0],depth:te[1].length,text:ue,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},Se.hr=function(ee){var te=this.rules.block.hr.exec(ee);if(te)return{type:"hr",raw:te[0]}},Se.blockquote=function(ee){var te=this.rules.block.blockquote.exec(ee);if(te){var ue=te[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},Se.list=function(ee){var te=this.rules.block.list.exec(ee);if(te){var ue,de,ke,xe,Ae,Be,Xe,nt,Re,ae,le=te[1].trim(),ie=le.length>1,W={type:"list",raw:"",ordered:ie,start:ie?+le.slice(0,-1):"",loose:!1,items:[]};le=ie?"\\d{1,9}\\"+le.slice(-1):"\\"+le,this.options.pedantic&&(le=ie?le:"[*+-]");for(var pe=new RegExp("^( {0,3}"+le+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(te=pe.exec(ee)));){Re=te[2].split(`
`),this.options.pedantic?(xe=2,ae=Re[0].trimLeft()):(xe=te[2].search(/[^ ]/),xe=te[1].length+(xe>4?1:xe),ae=Re[0].slice(xe-te[1].length)),Be=!1,ue=te[0],!Re[0]&&/^ *$/.test(Re[1])&&(ue=te[1]+Re.slice(0,2).join(`
`)+`
`,W.loose=!0,Re=[]);var Ce=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ae=1;Ae<Re.length;Ae++){if(nt=Re[Ae],this.options.pedantic&&(nt=nt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ce.test(nt)){ue=te[1]+Re.slice(0,Ae).join(`
`)+`
`;break}if(!Be){nt.trim()||(Be=!0),nt.search(/[^ ]/)>=xe?ae+=`
`+nt.slice(xe):ae+=`
`+nt;continue}if(nt.search(/[^ ]/)>=xe||!nt.trim()){ae+=`
`+nt.slice(xe);continue}else{ue=te[1]+Re.slice(0,Ae).join(`
`)+`
`;break}}W.loose||(Xe?W.loose=!0:/\n *\n *$/.test(ue)&&(Xe=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(ae),de&&(ke=de[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),W.items.push({type:"list_item",raw:ue,task:!!de,checked:ke,loose:!1,text:ae}),W.raw+=ue,ee=ee.slice(ue.length)}W.items[W.items.length-1].raw=ue.trimRight(),W.items[W.items.length-1].text=ae.trimRight(),W.raw=W.raw.trimRight();var ze=W.items.length;for(Ae=0;Ae<ze;Ae++)this.lexer.state.top=!1,W.items[Ae].tokens=this.lexer.blockTokens(W.items[Ae].text,[]),W.items[Ae].tokens.some(function(Ue){return Ue.type==="space"})&&(W.loose=!0,W.items[Ae].loose=!0);return W}},Se.html=function(ee){var te=this.rules.block.html.exec(ee);if(te){var ue={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};return this.options.sanitize&&(ue.type="paragraph",ue.text=this.options.sanitizer?this.options.sanitizer(te[0]):j(te[0]),ue.tokens=[],this.lexer.inline(ue.text,ue.tokens)),ue}},Se.def=function(ee){var te=this.rules.block.def.exec(ee);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var ue=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:te[0],href:te[2],title:te[3]}}},Se.table=function(ee){var te=this.rules.block.table.exec(ee);if(te){var ue={type:"table",header:x(te[1]).map(function(Xe){return{text:Xe}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]?te[3].replace(/\n$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=te[0];var de=ue.align.length,ke,xe,Ae,Be;for(ke=0;ke<de;ke++)/^ *-+: *$/.test(ue.align[ke])?ue.align[ke]="right":/^ *:-+: *$/.test(ue.align[ke])?ue.align[ke]="center":/^ *:-+ *$/.test(ue.align[ke])?ue.align[ke]="left":ue.align[ke]=null;for(de=ue.rows.length,ke=0;ke<de;ke++)ue.rows[ke]=x(ue.rows[ke],ue.header.length).map(function(Xe){return{text:Xe}});for(de=ue.header.length,xe=0;xe<de;xe++)ue.header[xe].tokens=[],this.lexer.inlineTokens(ue.header[xe].text,ue.header[xe].tokens);for(de=ue.rows.length,xe=0;xe<de;xe++)for(Be=ue.rows[xe],Ae=0;Ae<Be.length;Ae++)Be[Ae].tokens=[],this.lexer.inlineTokens(Be[Ae].text,Be[Ae].tokens);return ue}}},Se.lheading=function(ee){var te=this.rules.block.lheading.exec(ee);if(te){var ue={type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},Se.paragraph=function(ee){var te=this.rules.block.paragraph.exec(ee);if(te){var ue={type:"paragraph",raw:te[0],text:te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},Se.text=function(ee){var te=this.rules.block.text.exec(ee);if(te){var ue={type:"text",raw:te[0],text:te[0],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},Se.escape=function(ee){var te=this.rules.inline.escape.exec(ee);if(te)return{type:"escape",raw:te[0],text:j(te[1])}},Se.tag=function(ee){var te=this.rules.inline.tag.exec(ee);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):j(te[0]):te[0]}},Se.link=function(ee){var te=this.rules.inline.link.exec(ee);if(te){var ue=te[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var de=R(ue.slice(0,-1),"\\");if((ue.length-de.length)%2==0)return}else{var ke=H(te[2],"()");if(ke>-1){var xe=te[0].indexOf("!")===0?5:4,Ae=xe+te[1].length+ke;te[2]=te[2].substring(0,ke),te[0]=te[0].substring(0,Ae).trim(),te[3]=""}}var Be=te[2],Xe="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Be);nt&&(Be=nt[1],Xe=nt[3])}else Xe=te[3]?te[3].slice(1,-1):"";return Be=Be.trim(),/^</.test(Be)&&(this.options.pedantic&&!/>$/.test(ue)?Be=Be.slice(1):Be=Be.slice(1,-1)),z(te,{href:Be&&Be.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},Se.reflink=function(ee,te){var ue;if((ue=this.rules.inline.reflink.exec(ee))||(ue=this.rules.inline.nolink.exec(ee))){var de=(ue[2]||ue[1]).replace(/\s+/g," ");if(de=te[de.toLowerCase()],!de||!de.href){var ke=ue[0].charAt(0);return{type:"text",raw:ke,text:ke}}return z(ue,de,ue[0],this.lexer)}},Se.emStrong=function(ee,te,ue){ue===void 0&&(ue="");var de=this.rules.inline.emStrong.lDelim.exec(ee);if(!!de&&!(de[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=de[1]||de[2]||"";if(!ke||ke&&(ue===""||this.rules.inline.punctuation.exec(ue))){var xe=de[0].length-1,Ae,Be,Xe=xe,nt=0,Re=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Re.lastIndex=0,te=te.slice(-1*ee.length+xe);(de=Re.exec(te))!=null;)if(Ae=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ae){if(Be=Ae.length,de[3]||de[4]){Xe+=Be;continue}else if((de[5]||de[6])&&xe%3&&!((xe+Be)%3)){nt+=Be;continue}if(Xe-=Be,!(Xe>0)){if(Be=Math.min(Be,Be+Xe+nt),Math.min(xe,Be)%2){var ae=ee.slice(1,xe+de.index+Be);return{type:"em",raw:ee.slice(0,xe+de.index+Be+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}var le=ee.slice(2,xe+de.index+Be-1);return{type:"strong",raw:ee.slice(0,xe+de.index+Be+1),text:le,tokens:this.lexer.inlineTokens(le,[])}}}}}},Se.codespan=function(ee){var te=this.rules.inline.code.exec(ee);if(te){var ue=te[2].replace(/\n/g," "),de=/[^ ]/.test(ue),ke=/^ /.test(ue)&&/ $/.test(ue);return de&&ke&&(ue=ue.substring(1,ue.length-1)),ue=j(ue,!0),{type:"codespan",raw:te[0],text:ue}}},Se.br=function(ee){var te=this.rules.inline.br.exec(ee);if(te)return{type:"br",raw:te[0]}},Se.del=function(ee){var te=this.rules.inline.del.exec(ee);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2],[])}},Se.autolink=function(ee,te){var ue=this.rules.inline.autolink.exec(ee);if(ue){var de,ke;return ue[2]==="@"?(de=j(this.options.mangle?te(ue[1]):ue[1]),ke="mailto:"+de):(de=j(ue[1]),ke=de),{type:"link",raw:ue[0],text:de,href:ke,tokens:[{type:"text",raw:de,text:de}]}}},Se.url=function(ee,te){var ue;if(ue=this.rules.inline.url.exec(ee)){var de,ke;if(ue[2]==="@")de=j(this.options.mangle?te(ue[0]):ue[0]),ke="mailto:"+de;else{var xe;do xe=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(xe!==ue[0]);de=j(ue[0]),ue[1]==="www."?ke="http://"+de:ke=de}return{type:"link",raw:ue[0],text:de,href:ke,tokens:[{type:"text",raw:de,text:de}]}}},Se.inlineText=function(ee,te){var ue=this.rules.inline.text.exec(ee);if(ue){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):j(ue[0]):ue[0]:de=j(this.options.smartypants?te(ue[0]):ue[0]),{type:"text",raw:ue[0],text:de}}},Ie}(),fe=N.noopTest,re=N.edit,ge=N.merge,ye={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:fe,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ye._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ye._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ye.def=re(ye.def).replace("label",ye._label).replace("title",ye._title).getRegex(),ye.bullet=/(?:[*+-]|\d{1,9}[.)])/,ye.listItemStart=re(/^( *)(bull) */).replace("bull",ye.bullet).getRegex(),ye.list=re(ye.list).replace(/bull/g,ye.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ye.def.source+")").getRegex(),ye._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ye._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ye.html=re(ye.html,"i").replace("comment",ye._comment).replace("tag",ye._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ye.paragraph=re(ye._paragraph).replace("hr",ye.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ye._tag).getRegex(),ye.blockquote=re(ye.blockquote).replace("paragraph",ye.paragraph).getRegex(),ye.normal=ge({},ye),ye.gfm=ge({},ye.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ye.gfm.table=re(ye.gfm.table).replace("hr",ye.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ye._tag).getRegex(),ye.pedantic=ge({},ye.normal,{html:re(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ye._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:fe,paragraph:re(ye.normal._paragraph).replace("hr",ye.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ye.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ve={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:fe,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:fe,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ve._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ve.punctuation=re(ve.punctuation).replace(/punctuation/g,ve._punctuation).getRegex(),ve.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ve.escapedEmSt=/\\\*|\\_/g,ve._comment=re(ye._comment).replace("(?:-->|$)","-->").getRegex(),ve.emStrong.lDelim=re(ve.emStrong.lDelim).replace(/punct/g,ve._punctuation).getRegex(),ve.emStrong.rDelimAst=re(ve.emStrong.rDelimAst,"g").replace(/punct/g,ve._punctuation).getRegex(),ve.emStrong.rDelimUnd=re(ve.emStrong.rDelimUnd,"g").replace(/punct/g,ve._punctuation).getRegex(),ve._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ve._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ve._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ve.autolink=re(ve.autolink).replace("scheme",ve._scheme).replace("email",ve._email).getRegex(),ve._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ve.tag=re(ve.tag).replace("comment",ve._comment).replace("attribute",ve._attribute).getRegex(),ve._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ve._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ve._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ve.link=re(ve.link).replace("label",ve._label).replace("href",ve._href).replace("title",ve._title).getRegex(),ve.reflink=re(ve.reflink).replace("label",ve._label).getRegex(),ve.reflinkSearch=re(ve.reflinkSearch,"g").replace("reflink",ve.reflink).replace("nolink",ve.nolink).getRegex(),ve.normal=ge({},ve),ve.pedantic=ge({},ve.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:re(/^!?\[(label)\]\((.*?)\)/).replace("label",ve._label).getRegex(),reflink:re(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ve._label).getRegex()}),ve.gfm=ge({},ve.normal,{escape:re(ve.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ve.gfm.url=re(ve.gfm.url,"i").replace("email",ve.gfm._extended_email).getRegex(),ve.breaks=ge({},ve.gfm,{br:re(ve.br).replace("{2,}","*").getRegex(),text:re(ve.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Me={block:ye,inline:ve},je=ce,et=D.exports.defaults,lt=Me.block,it=Me.inline,ft=N.repeatString;function _t(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ut(Ie){var Se="",he,ee,te=Ie.length;for(he=0;he<te;he++)ee=Ie.charCodeAt(he),Math.random()>.5&&(ee="x"+ee.toString(16)),Se+="&#"+ee+";";return Se}var rt=function(){function Ie(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||et,this.options.tokenizer=this.options.tokenizer||new je,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:lt.normal,inline:it.normal};this.options.pedantic?(ee.block=lt.pedantic,ee.inline=it.pedantic):this.options.gfm&&(ee.block=lt.gfm,this.options.breaks?ee.inline=it.breaks:ee.inline=it.gfm),this.tokenizer.rules=ee}Ie.lex=function(ee,te){var ue=new Ie(te);return ue.lex(ee)},Ie.lexInline=function(ee,te){var ue=new Ie(te);return ue.inlineTokens(ee)};var Se=Ie.prototype;return Se.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},Se.blockTokens=function(ee,te){var ue=this;te===void 0&&(te=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var de,ke,xe,Ae;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Xe){return(de=Xe.call({lexer:ue},ee,te))?(ee=ee.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.space(ee)){ee=ee.substring(de.raw.length),de.type&&te.push(de);continue}if(de=this.tokenizer.code(ee)){ee=ee.substring(de.raw.length),ke=te[te.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):te.push(de);continue}if(de=this.tokenizer.fences(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.heading(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.hr(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.blockquote(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.list(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.html(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.def(ee)){ee=ee.substring(de.raw.length),ke=te[te.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.lheading(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(xe=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var Xe=1/0,nt=ee.slice(1),Re=void 0;ue.options.extensions.startBlock.forEach(function(ae){Re=ae.call({lexer:this},nt),typeof Re=="number"&&Re>=0&&(Xe=Math.min(Xe,Re))}),Xe<1/0&&Xe>=0&&(xe=ee.substring(0,Xe+1))}(),this.state.top&&(de=this.tokenizer.paragraph(xe))){ke=te[te.length-1],Ae&&ke.type==="paragraph"?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):te.push(de),Ae=xe.length!==ee.length,ee=ee.substring(de.raw.length);continue}if(de=this.tokenizer.text(ee)){ee=ee.substring(de.raw.length),ke=te[te.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):te.push(de);continue}if(ee){var Be="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Be);break}else throw new Error(Be)}}return this.state.top=!0,te},Se.inline=function(ee,te){this.inlineQueue.push({src:ee,tokens:te})},Se.inlineTokens=function(ee,te){var ue=this;te===void 0&&(te=[]);var de,ke,xe,Ae=ee,Be,Xe,nt;if(this.tokens.links){var Re=Object.keys(this.tokens.links);if(Re.length>0)for(;(Be=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)Re.includes(Be[0].slice(Be[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Be.index)+"["+ft("a",Be[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Be=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Be.index)+"["+ft("a",Be[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Be=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Be.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(Xe||(nt=""),Xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(de=le.call({lexer:ue},ee,te))?(ee=ee.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.escape(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.tag(ee)){ee=ee.substring(de.raw.length),ke=te[te.length-1],ke&&de.type==="text"&&ke.type==="text"?(ke.raw+=de.raw,ke.text+=de.text):te.push(de);continue}if(de=this.tokenizer.link(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(de.raw.length),ke=te[te.length-1],ke&&de.type==="text"&&ke.type==="text"?(ke.raw+=de.raw,ke.text+=de.text):te.push(de);continue}if(de=this.tokenizer.emStrong(ee,Ae,nt)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.codespan(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.br(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.del(ee)){ee=ee.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.autolink(ee,ut)){ee=ee.substring(de.raw.length),te.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(ee,ut))){ee=ee.substring(de.raw.length),te.push(de);continue}if(xe=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,ie=ee.slice(1),W=void 0;ue.options.extensions.startInline.forEach(function(pe){W=pe.call({lexer:this},ie),typeof W=="number"&&W>=0&&(le=Math.min(le,W))}),le<1/0&&le>=0&&(xe=ee.substring(0,le+1))}(),de=this.tokenizer.inlineText(xe,_t)){ee=ee.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(nt=de.raw.slice(-1)),Xe=!0,ke=te[te.length-1],ke&&ke.type==="text"?(ke.raw+=de.raw,ke.text+=de.text):te.push(de);continue}if(ee){var ae="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return te},e(Ie,null,[{key:"rules",get:function(){return{block:lt,inline:it}}}]),Ie}(),B=D.exports.defaults,G=N.cleanUrl,$=N.escape,V=function(){function Ie(he){this.options=he||B}var Se=Ie.prototype;return Se.code=function(ee,te,ue){var de=(te||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(ee,de);ke!=null&&ke!==ee&&(ue=!0,ee=ke)}return ee=ee.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+$(de,!0)+'">'+(ue?ee:$(ee,!0))+`</code></pre>
`:"<pre><code>"+(ue?ee:$(ee,!0))+`</code></pre>
`},Se.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},Se.html=function(ee){return ee},Se.heading=function(ee,te,ue,de){return this.options.headerIds?"<h"+te+' id="'+this.options.headerPrefix+de.slug(ue)+'">'+ee+"</h"+te+`>
`:"<h"+te+">"+ee+"</h"+te+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ee,te,ue){var de=te?"ol":"ul",ke=te&&ue!==1?' start="'+ue+'"':"";return"<"+de+ke+`>
`+ee+"</"+de+`>
`},Se.listitem=function(ee){return"<li>"+ee+`</li>
`},Se.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ee){return"<p>"+ee+`</p>
`},Se.table=function(ee,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+te+`</table>
`},Se.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},Se.tablecell=function(ee,te){var ue=te.header?"th":"td",de=te.align?"<"+ue+' align="'+te.align+'">':"<"+ue+">";return de+ee+"</"+ue+`>
`},Se.strong=function(ee){return"<strong>"+ee+"</strong>"},Se.em=function(ee){return"<em>"+ee+"</em>"},Se.codespan=function(ee){return"<code>"+ee+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ee){return"<del>"+ee+"</del>"},Se.link=function(ee,te,ue){if(ee=G(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ue;var de='<a href="'+$(ee)+'"';return te&&(de+=' title="'+te+'"'),de+=">"+ue+"</a>",de},Se.image=function(ee,te,ue){if(ee=G(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ue;var de='<img src="'+ee+'" alt="'+ue+'"';return te&&(de+=' title="'+te+'"'),de+=this.options.xhtml?"/>":">",de},Se.text=function(ee){return ee},Ie}(),Y=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(ee){return ee},Se.em=function(ee){return ee},Se.codespan=function(ee){return ee},Se.del=function(ee){return ee},Se.html=function(ee){return ee},Se.text=function(ee){return ee},Se.link=function(ee,te,ue){return""+ue},Se.image=function(ee,te,ue){return""+ue},Se.br=function(){return""},Ie}(),ne=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ee,te){var ue=ee,de=0;if(this.seen.hasOwnProperty(ue)){de=this.seen[ee];do de++,ue=ee+"-"+de;while(this.seen.hasOwnProperty(ue))}return te||(this.seen[ee]=de,this.seen[ue]=0),ue},Se.slug=function(ee,te){te===void 0&&(te={});var ue=this.serialize(ee);return this.getNextSafeSlug(ue,te.dryrun)},Ie}(),me=V,Fe=Y,$e=ne,qe=D.exports.defaults,Je=N.unescape,Ze=function(){function Ie(he){this.options=he||qe,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Fe,this.slugger=new $e}Ie.parse=function(ee,te){var ue=new Ie(te);return ue.parse(ee)},Ie.parseInline=function(ee,te){var ue=new Ie(te);return ue.parseInline(ee)};var Se=Ie.prototype;return Se.parse=function(ee,te){te===void 0&&(te=!0);var ue="",de,ke,xe,Ae,Be,Xe,nt,Re,ae,le,ie,W,pe,Ce,ze,Ue,dt,bt,yt,st=ee.length;for(de=0;de<st;de++){if(le=ee[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(yt=this.options.extensions.renderers[le.type].call({parser:this},le),yt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){ue+=yt||"";continue}switch(le.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(le.tokens),le.depth,Je(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(Re="",nt="",Ae=le.header.length,ke=0;ke<Ae;ke++)nt+=this.renderer.tablecell(this.parseInline(le.header[ke].tokens),{header:!0,align:le.align[ke]});for(Re+=this.renderer.tablerow(nt),ae="",Ae=le.rows.length,ke=0;ke<Ae;ke++){for(Xe=le.rows[ke],nt="",Be=Xe.length,xe=0;xe<Be;xe++)nt+=this.renderer.tablecell(this.parseInline(Xe[xe].tokens),{header:!1,align:le.align[xe]});ae+=this.renderer.tablerow(nt)}ue+=this.renderer.table(Re,ae);continue}case"blockquote":{ae=this.parse(le.tokens),ue+=this.renderer.blockquote(ae);continue}case"list":{for(ie=le.ordered,W=le.start,pe=le.loose,Ae=le.items.length,ae="",ke=0;ke<Ae;ke++)ze=le.items[ke],Ue=ze.checked,dt=ze.task,Ce="",ze.task&&(bt=this.renderer.checkbox(Ue),pe?ze.tokens.length>0&&ze.tokens[0].type==="paragraph"?(ze.tokens[0].text=bt+" "+ze.tokens[0].text,ze.tokens[0].tokens&&ze.tokens[0].tokens.length>0&&ze.tokens[0].tokens[0].type==="text"&&(ze.tokens[0].tokens[0].text=bt+" "+ze.tokens[0].tokens[0].text)):ze.tokens.unshift({type:"text",text:bt}):Ce+=bt),Ce+=this.parse(ze.tokens,pe),ae+=this.renderer.listitem(Ce,dt,Ue);ue+=this.renderer.list(ae,ie,W);continue}case"html":{ue+=this.renderer.html(le.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(ae=le.tokens?this.parseInline(le.tokens):le.text;de+1<st&&ee[de+1].type==="text";)le=ee[++de],ae+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);ue+=te?this.renderer.paragraph(ae):ae;continue}default:{var gt='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return ue},Se.parseInline=function(ee,te){te=te||this.renderer;var ue="",de,ke,xe,Ae=ee.length;for(de=0;de<Ae;de++){if(ke=ee[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(xe=this.options.extensions.renderers[ke.type].call({parser:this},ke),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){ue+=xe||"";continue}switch(ke.type){case"escape":{ue+=te.text(ke.text);break}case"html":{ue+=te.html(ke.text);break}case"link":{ue+=te.link(ke.href,ke.title,this.parseInline(ke.tokens,te));break}case"image":{ue+=te.image(ke.href,ke.title,ke.text);break}case"strong":{ue+=te.strong(this.parseInline(ke.tokens,te));break}case"em":{ue+=te.em(this.parseInline(ke.tokens,te));break}case"codespan":{ue+=te.codespan(ke.text);break}case"br":{ue+=te.br();break}case"del":{ue+=te.del(this.parseInline(ke.tokens,te));break}case"text":{ue+=te.text(ke.text);break}default:{var Be='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return ue},Ie}(),Ke=rt,Qe=Ze,mt=ce,Tt=V,Te=Y,kt=ne,q=N.merge,Q=N.checkSanitizeDeprecation,se=N.escape,Oe=D.exports.getDefaults,He=D.exports.changeDefaults,tt=D.exports.defaults;function Ve(Ie,Se,he){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(he=Se,Se=null),Se=q({},Ve.defaults,Se||{}),Q(Se),he){var ee=Se.highlight,te;try{te=Ke.lex(Ie,Se)}catch(xe){return he(xe)}var ue=function(Ae){var Be;if(!Ae)try{Se.walkTokens&&Ve.walkTokens(te,Se.walkTokens),Be=Qe.parse(te,Se)}catch(Xe){Ae=Xe}return Se.highlight=ee,Ae?he(Ae):he(null,Be)};if(!ee||ee.length<3||(delete Se.highlight,!te.length))return ue();var de=0;Ve.walkTokens(te,function(xe){xe.type==="code"&&(de++,setTimeout(function(){ee(xe.text,xe.lang,function(Ae,Be){if(Ae)return ue(Ae);Be!=null&&Be!==xe.text&&(xe.text=Be,xe.escaped=!0),de--,de===0&&ue()})},0))}),de===0&&ue();return}try{var ke=Ke.lex(Ie,Se);return Se.walkTokens&&Ve.walkTokens(ke,Se.walkTokens),Qe.parse(ke,Se)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+se(xe.message+"",!0)+"</pre>";throw xe}}Ve.options=Ve.setOptions=function(Ie){return q(Ve.defaults,Ie),He(Ve.defaults),Ve},Ve.getDefaults=Oe,Ve.defaults=tt,Ve.use=function(){for(var Ie=this,Se=arguments.length,he=new Array(Se),ee=0;ee<Se;ee++)he[ee]=arguments[ee];var te=q.apply(void 0,[{}].concat(he)),ue=Ve.defaults.extensions||{renderers:{},childTokens:{}},de;he.forEach(function(ke){if(ke.extensions&&(de=!0,ke.extensions.forEach(function(Ae){if(!Ae.name)throw new Error("extension name required");if(Ae.renderer){var Be=ue.renderers?ue.renderers[Ae.name]:null;Be?ue.renderers[Ae.name]=function(){for(var Xe=arguments.length,nt=new Array(Xe),Re=0;Re<Xe;Re++)nt[Re]=arguments[Re];var ae=Ae.renderer.apply(this,nt);return ae===!1&&(ae=Be.apply(this,nt)),ae}:ue.renderers[Ae.name]=Ae.renderer}if(Ae.tokenizer){if(!Ae.level||Ae.level!=="block"&&Ae.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[Ae.level]?ue[Ae.level].unshift(Ae.tokenizer):ue[Ae.level]=[Ae.tokenizer],Ae.start&&(Ae.level==="block"?ue.startBlock?ue.startBlock.push(Ae.start):ue.startBlock=[Ae.start]:Ae.level==="inline"&&(ue.startInline?ue.startInline.push(Ae.start):ue.startInline=[Ae.start]))}Ae.childTokens&&(ue.childTokens[Ae.name]=Ae.childTokens)})),ke.renderer&&function(){var Ae=Ve.defaults.renderer||new Tt,Be=function(Re){var ae=Ae[Re];Ae[Re]=function(){for(var le=arguments.length,ie=new Array(le),W=0;W<le;W++)ie[W]=arguments[W];var pe=ke.renderer[Re].apply(Ae,ie);return pe===!1&&(pe=ae.apply(Ae,ie)),pe}};for(var Xe in ke.renderer)Be(Xe);te.renderer=Ae}(),ke.tokenizer&&function(){var Ae=Ve.defaults.tokenizer||new mt,Be=function(Re){var ae=Ae[Re];Ae[Re]=function(){for(var le=arguments.length,ie=new Array(le),W=0;W<le;W++)ie[W]=arguments[W];var pe=ke.tokenizer[Re].apply(Ae,ie);return pe===!1&&(pe=ae.apply(Ae,ie)),pe}};for(var Xe in ke.tokenizer)Be(Xe);te.tokenizer=Ae}(),ke.walkTokens){var xe=Ve.defaults.walkTokens;te.walkTokens=function(Ae){ke.walkTokens.call(Ie,Ae),xe&&xe(Ae)}}de&&(te.extensions=ue),Ve.setOptions(te)})},Ve.walkTokens=function(Ie,Se){for(var he=function(){var de=te.value;switch(Se(de),de.type){case"table":{for(var ke=_(de.header),xe;!(xe=ke()).done;){var Ae=xe.value;Ve.walkTokens(Ae.tokens,Se)}for(var Be=_(de.rows),Xe;!(Xe=Be()).done;)for(var nt=Xe.value,Re=_(nt),ae;!(ae=Re()).done;){var le=ae.value;Ve.walkTokens(le.tokens,Se)}break}case"list":{Ve.walkTokens(de.items,Se);break}default:Ve.defaults.extensions&&Ve.defaults.extensions.childTokens&&Ve.defaults.extensions.childTokens[de.type]?Ve.defaults.extensions.childTokens[de.type].forEach(function(ie){Ve.walkTokens(de[ie],Se)}):de.tokens&&Ve.walkTokens(de.tokens,Se)}},ee=_(Ie),te;!(te=ee()).done;)he()},Ve.parseInline=function(Ie,Se){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=q({},Ve.defaults,Se||{}),Q(Se);try{var he=Ke.lexInline(Ie,Se);return Se.walkTokens&&Ve.walkTokens(he,Se.walkTokens),Qe.parseInline(he,Se)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+se(ee.message+"",!0)+"</pre>";throw ee}},Ve.Parser=Qe,Ve.parser=Qe.parse,Ve.Renderer=Tt,Ve.TextRenderer=Te,Ve.Lexer=Ke,Ve.lexer=Ke.lex,Ve.Tokenizer=mt,Ve.Slugger=kt,Ve.parse=Ve;var wt=Ve;return wt}),define(be[98],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(T,y,F){return Math.min(Math.max(T,y),F)}e.clamp=i;function A(T,y){return(y+T%y)%y}e.rot=A;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class D{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=D;class M{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const F=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=F,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=M}),function(){function Z(_){const D=[];typeof _=="number"&&D.push("code/timeOrigin",_);function M(y){D.push(y,Date.now())}function T(){const y=[];for(let F=0;F<D.length;F+=2)y.push({name:D[F],startTime:D[F+1]});return y}return{mark:M,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const M of performance.getEntriesByType("mark"))D.push({name:M.name,startTime:Math.round(_+M.startTime)});return D}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function i(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=i(A))}(),define(be[68],we([0,1,19]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var A;(function(m){m.text="text/plain",m.binary="application/octet-stream",m.unknown="application/unknown",m.markdown="text/markdown",m.latex="text/latex"})(A=e.Mimes||(e.Mimes={}));const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(m){const t=(0,i.extname)(m),u=_[t.toLowerCase()];return u!==void 0?u:T(m)}e.getMediaOrTextMime=M;function T(m){const t=(0,i.extname)(m);return D[t.toLowerCase()]}e.getMediaMime=T;function y(m){for(const t in D)if(D[t]===m)return t}e.getExtensionForMimeType=y;const F=/^(.+)\/(.+?)(;.+)?$/;function O(m,t){const u=F.exec(m);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:t?void 0:m}e.normalizeMimeType=O}),define(be[99],we([0,1,15,7]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(b){const o=b;return o?[o.on,o.pause,o.resume,o.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=_;function D(b){const o=b;return o?_(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=D;function M(b,o){return new T(b,o)}e.newWriteableStream=M;class T{constructor(o,S){this.reducer=o,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(S=>S(o))}emitError(o){this.listeners.error.length===0?(0,i.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(S=>S(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,S){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(o,S){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const P=n.indexOf(S);P>=0&&n.splice(P,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(b,o){const S=[];let n;for(;(n=b.read())!==null;)S.push(n);return o(S)}e.consumeReadable=y;function F(b,o,S){const n=[];let P;for(;(P=b.read())!==null&&n.length<S;)n.push(P);return P===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof P!="undefined"){const r=P;return P=void 0,r}return b.read()}}}e.peekReadable=F;function O(b,o){return new Promise((S,n)=>{const P=[];m(b,{onData:r=>{o&&P.push(r)},onError:r=>{o?n(r):S(void 0)},onEnd:()=>{S(o?o(P):void 0)}})})}e.consumeStream=O;function m(b,o){let S=!1;return b.on("error",n=>{S||o.onError(n)}),b.on("end",()=>{S||o.onEnd()}),b.on("data",n=>{S||o.onData(n)}),(0,A.toDisposable)(()=>S=!0)}e.listenStream=m;function t(b,o){return new Promise((S,n)=>{const P=new A.DisposableStore,r=[],c=d=>{if(r.push(d),r.length>o)return P.dispose(),b.pause(),S({stream:b,buffer:r,ended:!1})},w=d=>n(d),h=()=>S({stream:b,buffer:r,ended:!0});P.add((0,A.toDisposable)(()=>b.removeListener("error",w))),b.on("error",w),P.add((0,A.toDisposable)(()=>b.removeListener("end",h))),b.on("end",h),P.add((0,A.toDisposable)(()=>b.removeListener("data",c))),b.on("data",c)})}e.peekStream=t;function u(b,o){const S=M(o);return S.end(b),S}e.toStream=u;function s(){const b=M(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=s;function a(b){let o=!1;return{read:()=>o?null:(o=!0,b)}}e.toReadable=a;function l(b,o,S){const n=M(S);return m(b,{onData:P=>n.write(o.data(P)),onError:P=>n.error(o.error?o.error(P):P),onEnd:()=>n.end()}),n}e.transform=l;function k(b,o,S){let n=!1;return{read:()=>{const P=o.read();return n?P:(n=!0,P!==null?S([b,P]):b)}}}e.prefixedReadable=k;function v(b,o,S){let n=!1;const P=M(S);return m(o,{onData:r=>n?P.write(r):(n=!0,P.write(S([b,r]))),onError:r=>P.error(r),onEnd:()=>{n||(n=!0,P.write(b)),P.end()}}),P}e.prefixedStream=v}),define(be[21],we([0,1,99]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined";let _,D;class M{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return A?new M(Buffer.allocUnsafe(g)):new M(new Uint8Array(g))}static wrap(g){return A&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new M(g)}static fromString(g,f){return!(f?.dontUseNodeBuffer||!1)&&A?new M(Buffer.from(g)):(_||(_=new TextEncoder),new M(_.encode(g)))}static fromByteArray(g){const f=M.alloc(g.length);for(let E=0,C=g.length;E<C;E++)f.buffer[E]=g[E];return f}static concat(g,f){if(typeof f=="undefined"){f=0;for(let I=0,N=g.length;I<N;I++)f+=g[I].byteLength}const E=M.alloc(f);let C=0;for(let I=0,N=g.length;I<N;I++){const p=g[I];E.set(p,C),C+=p.byteLength}return E}clone(){const g=M.alloc(this.byteLength);return g.set(this),g}toString(){return A?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(g,f){return new M(this.buffer.subarray(g,f))}set(g,f){if(g instanceof M)this.buffer.set(g.buffer,f);else if(g instanceof Uint8Array)this.buffer.set(g,f);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),f);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),f);else throw new Error("Unkown argument 'array'")}readUInt32BE(g){return F(this.buffer,g)}writeUInt32BE(g,f){O(this.buffer,g,f)}readUInt32LE(g){return m(this.buffer,g)}writeUInt32LE(g,f){t(this.buffer,g,f)}readUInt8(g){return u(this.buffer,g)}writeUInt8(g,f){s(this.buffer,g,f)}}e.VSBuffer=M;function T(d,g){return d[g+0]<<0>>>0|d[g+1]<<8>>>0}e.readUInt16LE=T;function y(d,g,f){d[f+0]=g&255,g=g>>>8,d[f+1]=g&255}e.writeUInt16LE=y;function F(d,g){return d[g]*2**24+d[g+1]*2**16+d[g+2]*2**8+d[g+3]}e.readUInt32BE=F;function O(d,g,f){d[f+3]=g,g=g>>>8,d[f+2]=g,g=g>>>8,d[f+1]=g,g=g>>>8,d[f]=g}e.writeUInt32BE=O;function m(d,g){return d[g+0]<<0>>>0|d[g+1]<<8>>>0|d[g+2]<<16>>>0|d[g+3]<<24>>>0}e.readUInt32LE=m;function t(d,g,f){d[f+0]=g&255,g=g>>>8,d[f+1]=g&255,g=g>>>8,d[f+2]=g&255,g=g>>>8,d[f+3]=g&255}e.writeUInt32LE=t;function u(d,g){return d[g]}e.readUInt8=u;function s(d,g,f){d[f]=g}e.writeUInt8=s;function a(d){return i.consumeReadable(d,g=>M.concat(g))}e.readableToBuffer=a;function l(d){return i.toReadable(d)}e.bufferToReadable=l;function k(d){return i.consumeStream(d,g=>M.concat(g))}e.streamToBuffer=k;async function v(d){return d.ended?M.concat(d.buffer):M.concat([...d.buffer,await k(d.stream)])}e.bufferedStreamToBuffer=v;function b(d){return i.toStream(d,g=>M.concat(g))}e.bufferToStream=b;function o(d){return i.transform(d,{data:g=>typeof g=="string"?M.fromString(g):M.wrap(g)},g=>M.concat(g))}e.streamToBufferReadableStream=o;function S(d){return i.newWriteableStream(g=>M.concat(g),d)}e.newWriteableBufferStream=S;function n(d,g){return i.prefixedReadable(d,g,f=>M.concat(f))}e.prefixedBufferReadable=n;function P(d,g){return i.prefixedStream(d,g,f=>M.concat(f))}e.prefixedBufferStream=P;function r(d){let g=0,f=0,E=0;const C=new Uint8Array(Math.floor(d.length/4*3)),I=p=>{switch(f){case 3:C[E++]=g|p,f=0;break;case 2:C[E++]=g|p>>>2,g=p<<6,f=3;break;case 1:C[E++]=g|p>>>4,g=p<<4,f=2;break;default:g=p<<2,f=1}};for(let p=0;p<d.length;p++){const R=d.charCodeAt(p);if(R>=65&&R<=90)I(R-65);else if(R>=97&&R<=122)I(R-97+26);else if(R>=48&&R<=57)I(R-48+52);else if(R===43||R===45)I(62);else if(R===47||R===95)I(63);else{if(R===61)break;throw new SyntaxError(`Unexpected base64 character ${d[p]}`)}}const N=E;for(;f>0;)I(0);return M.wrap(C).slice(0,N)}e.decodeBase64=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:d},g=!0,f=!1){const E=f?w:c;let C="";const I=d.byteLength%3;let N=0;for(;N<d.byteLength-I;N+=3){const p=d[N+0],R=d[N+1],x=d[N+2];C+=E[p>>>2],C+=E[(p<<4|R>>>4)&63],C+=E[(R<<2|x>>>6)&63],C+=E[x&63]}if(I===1){const p=d[N+0];C+=E[p>>>2],C+=E[p<<4&63],g&&(C+="==")}else if(I===2){const p=d[N+0],R=d[N+1];C+=E[p>>>2],C+=E[(p<<4|R>>>4)&63],C+=E[R<<2&63],g&&(C+="=")}return C}e.encodeBase64=h}),define(be[100],we([0,1,22,14]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...$){return function(V,Y){for(let ne=0,me=$.length;ne<me;ne++){const Fe=$[ne](V,Y);if(Fe)return Fe}return null}}e.or=_,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D($,V,Y){if(!Y||Y.length<V.length)return null;let ne;return $?ne=A.startsWithIgnoreCase(Y,V):ne=Y.indexOf(V)===0,ne?V.length>0?[{start:0,end:V.length}]:[]:null}function M($,V){const Y=V.toLowerCase().indexOf($.toLowerCase());return Y===-1?null:[{start:Y,end:Y+$.length}]}e.matchesContiguousSubString=M;function T($,V){return y($.toLowerCase(),V.toLowerCase(),0,0)}e.matchesSubString=T;function y($,V,Y,ne){if(Y===$.length)return[];if(ne===V.length)return null;if($[Y]===V[ne]){let me=null;return(me=y($,V,Y+1,ne+1))?k({start:ne,end:ne+1},me):null}return y($,V,Y,ne+1)}function F($){return 97<=$&&$<=122}function O($){return 65<=$&&$<=90}e.isUpper=O;function m($){return 48<=$&&$<=57}function t($){return $===32||$===9||$===10||$===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach($=>u.add($.charCodeAt(0)));function s($){return t($)||u.has($)}function a($,V){return $===V||s($)&&s(V)}function l($){return F($)||O($)||m($)}function k($,V){return V.length===0?V=[$]:$.end===V[0].start?V[0].start=$.start:V.unshift($),V}function v($,V){for(let Y=V;Y<$.length;Y++){const ne=$.charCodeAt(Y);if(O(ne)||m(ne)||Y>0&&!l($.charCodeAt(Y-1)))return Y}return $.length}function b($,V,Y,ne){if(Y===$.length)return[];if(ne===V.length)return null;if($[Y]!==V[ne].toLowerCase())return null;{let me=null,Fe=ne+1;for(me=b($,V,Y+1,ne+1);!me&&(Fe=v(V,Fe))<V.length;)me=b($,V,Y+1,Fe),Fe++;return me===null?null:k({start:ne,end:ne+1},me)}}function o($){let V=0,Y=0,ne=0,me=0,Fe=0;for(let Ke=0;Ke<$.length;Ke++)Fe=$.charCodeAt(Ke),O(Fe)&&V++,F(Fe)&&Y++,l(Fe)&&ne++,m(Fe)&&me++;const $e=V/$.length,qe=Y/$.length,Je=ne/$.length,Ze=me/$.length;return{upperPercent:$e,lowerPercent:qe,alphaPercent:Je,numericPercent:Ze}}function S($){const{upperPercent:V,lowerPercent:Y}=$;return Y===0&&V>.6}function n($){const{upperPercent:V,lowerPercent:Y,alphaPercent:ne,numericPercent:me}=$;return Y>.2&&V<.8&&ne>.6&&me<.2}function P($){let V=0,Y=0,ne=0,me=0;for(let Fe=0;Fe<$.length;Fe++)ne=$.charCodeAt(Fe),O(ne)&&V++,F(ne)&&Y++,t(ne)&&me++;return(V===0||Y===0)&&me===0?$.length<=30:V<=5}function r($,V){if(!V||(V=V.trim(),V.length===0)||!P($)||V.length>60)return null;const Y=o(V);if(!n(Y)){if(!S(Y))return null;V=V.toLowerCase()}let ne=null,me=0;for($=$.toLowerCase();me<V.length&&(ne=b($,V,0,me))===null;)me=v(V,me+1);return ne}e.matchesCamelCase=r;function c($,V,Y=!1){if(!V||V.length===0)return null;let ne=null,me=0;for($=$.toLowerCase(),V=V.toLowerCase();me<V.length&&(ne=w($,V,0,me,Y))===null;)me=h(V,me+1);return ne}e.matchesWords=c;function w($,V,Y,ne,me){if(Y===$.length)return[];if(ne===V.length)return null;if(a($.charCodeAt(Y),V.charCodeAt(ne))){let Fe=null,$e=ne+1;if(Fe=w($,V,Y+1,ne+1,me),!me)for(;!Fe&&($e=h(V,$e))<V.length;)Fe=w($,V,Y+1,$e,me),$e++;return Fe===null?null:k({start:ne,end:ne+1},Fe)}else return null}function h($,V){for(let Y=V;Y<$.length;Y++)if(s($.charCodeAt(Y))||Y>0&&s($.charCodeAt(Y-1)))return Y;return $.length}const d=_(e.matchesPrefix,r,M),g=_(e.matchesPrefix,r,T),f=new i.LRUCache(1e4);function E($,V,Y=!1){if(typeof $!="string"||typeof V!="string")return null;let ne=f.get($);ne||(ne=new RegExp(A.convertSimple2RegExpPattern($),"i"),f.set($,ne));const me=ne.exec(V);return me?[{start:me.index,end:me.index+me[0].length}]:Y?g($,V):d($,V)}e.matchesFuzzy=E;function C($,V){const Y=it($,$.toLowerCase(),0,V,V.toLowerCase(),0,!0);return Y?N(Y):null}e.matchesFuzzy2=C;function I($,V,Y,ne,me,Fe){const $e=Math.min(13,$.length);for(;Y<$e;Y++){const qe=it($,V,Y,ne,me,Fe,!1);if(qe)return qe}return[0,Fe]}e.anyScore=I;function N($){if(typeof $=="undefined")return[];const V=[],Y=$[1];for(let ne=$.length-1;ne>1;ne--){const me=$[ne]+Y,Fe=V[V.length-1];Fe&&Fe.end===me?Fe.end=me+1:V.push({start:me,end:me+1})}return V}e.createMatches=N;const p=128;function R(){const $=[],V=[];for(let Y=0;Y<=p;Y++)V[Y]=0;for(let Y=0;Y<=p;Y++)$.push(V.slice(0));return $}function x($){const V=[];for(let Y=0;Y<=$;Y++)V[Y]=0;return V}const j=x(2*p),H=x(2*p),z=R(),K=R(),ce=R(),fe=!1;function re($,V,Y,ne,me){function Fe(qe,Je,Ze=" "){for(;qe.length<Je;)qe=Ze+qe;return qe}let $e=` |   |${ne.split("").map(qe=>Fe(qe,3)).join("|")}
`;for(let qe=0;qe<=Y;qe++)qe===0?$e+=" |":$e+=`${V[qe-1]}|`,$e+=$[qe].slice(0,me+1).map(Je=>Fe(Je.toString(),3)).join("|")+`
`;return $e}function ge($,V,Y,ne){$=$.substr(V),Y=Y.substr(ne),console.log(re(K,$,$.length,Y,Y.length)),console.log(re(ce,$,$.length,Y,Y.length)),console.log(re(z,$,$.length,Y,Y.length))}function ye($,V){if(V<0||V>=$.length)return!1;const Y=$.codePointAt(V);switch(Y){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(Y)}}function ve($,V){if(V<0||V>=$.length)return!1;switch($.charCodeAt(V)){case 32:case 9:return!0;default:return!1}}function Me($,V,Y){return V[$]!==Y[$]}function je($,V,Y,ne,me,Fe,$e=!1){for(;V<Y&&me<Fe;)$[V]===ne[me]&&($e&&(j[V]=me),V+=1),me+=1;return V===Y}e.isPatternInWord=je;var et;(function($){$[$.Diag=1]="Diag",$[$.Left=2]="Left",$[$.LeftLeft=3]="LeftLeft"})(et||(et={}));var lt;(function($){$.Default=[-100,0];function V(Y){return!Y||Y.length===2&&Y[0]===-100&&Y[1]===0}$.isDefault=V})(lt=e.FuzzyScore||(e.FuzzyScore={}));function it($,V,Y,ne,me,Fe,$e){const qe=$.length>p?p:$.length,Je=ne.length>p?p:ne.length;if(Y>=qe||Fe>=Je||qe-Y>Je-Fe||!je(V,Y,qe,me,Fe,Je,!0))return;ft(qe,Je,Y,Fe,V,me);let Ze=1,Ke=1,Qe=Y,mt=Fe;const Tt=[!1];for(Ze=1,Qe=Y;Qe<qe;Ze++,Qe++){const se=j[Qe],Oe=H[Qe],He=Qe+1<qe?H[Qe+1]:Je;for(Ke=se-Fe+1,mt=se;mt<He;Ke++,mt++){let tt=Number.MIN_SAFE_INTEGER,Ve=!1;mt<=Oe&&(tt=_t($,V,Qe,Y,ne,me,mt,Je,Fe,z[Ze-1][Ke-1]===0,Tt));let wt=0;tt!==Number.MAX_SAFE_INTEGER&&(Ve=!0,wt=tt+K[Ze-1][Ke-1]);const Ie=mt>se,Se=Ie?K[Ze][Ke-1]+(z[Ze][Ke-1]>0?-5:0):0,he=mt>se+1&&z[Ze][Ke-1]>0,ee=he?K[Ze][Ke-2]+(z[Ze][Ke-2]>0?-5:0):0;if(he&&(!Ie||ee>=Se)&&(!Ve||ee>=wt))K[Ze][Ke]=ee,ce[Ze][Ke]=3,z[Ze][Ke]=0;else if(Ie&&(!Ve||Se>=wt))K[Ze][Ke]=Se,ce[Ze][Ke]=2,z[Ze][Ke]=0;else if(Ve)K[Ze][Ke]=wt,ce[Ze][Ke]=1,z[Ze][Ke]=z[Ze-1][Ke-1]+1;else throw new Error("not possible")}}if(fe&&ge($,Y,ne,Fe),!Tt[0]&&!$e)return;Ze--,Ke--;const Te=[K[Ze][Ke],Fe];let kt=0,q=0;for(;Ze>=1;){let se=Ke;do{const Oe=ce[Ze][se];if(Oe===3)se=se-2;else if(Oe===2)se=se-1;else break}while(se>=1);kt>1&&V[Y+Ze-1]===me[Fe+Ke-1]&&!Me(se+Fe-1,ne,me)&&kt+1>z[Ze][se]&&(se=Ke),se===Ke?kt++:kt=1,q||(q=se),Ze--,Ke=se-1,Te.push(Ke)}Je===qe&&(Te[0]+=2);const Q=q-qe;return Te[0]-=Q,Te}e.fuzzyScore=it;function ft($,V,Y,ne,me,Fe){let $e=$-1,qe=V-1;for(;$e>=Y&&qe>=ne;)me[$e]===Fe[qe]&&(H[$e]=qe,$e--),qe--}function _t($,V,Y,ne,me,Fe,$e,qe,Je,Ze,Ke){if(V[Y]!==Fe[$e])return Number.MIN_SAFE_INTEGER;let Qe=1,mt=!1;return $e===Y-ne?Qe=$[Y]===me[$e]?7:5:Me($e,me,Fe)&&($e===0||!Me($e-1,me,Fe))?(Qe=$[Y]===me[$e]?7:5,mt=!0):ye(Fe,$e)&&($e===0||!ye(Fe,$e-1))?Qe=5:(ye(Fe,$e-1)||ve(Fe,$e-1))&&(Qe=5,mt=!0),Qe>1&&Y===ne&&(Ke[0]=!0),mt||(mt=Me($e,me,Fe)||ye(Fe,$e-1)||ve(Fe,$e-1)),Y===ne?$e>Je&&(Qe-=mt?3:5):Ze?Qe+=mt?2:0:Qe+=mt?0:1,$e+1===qe&&(Qe-=mt?3:5),Qe}function ut($,V,Y,ne,me,Fe,$e){return B($,V,Y,ne,me,Fe,!0,$e)}e.fuzzyScoreGracefulAggressive=ut;function rt($,V,Y,ne,me,Fe,$e){return B($,V,Y,ne,me,Fe,!1,$e)}e.fuzzyScoreGraceful=rt;function B($,V,Y,ne,me,Fe,$e,qe){let Je=it($,V,Y,ne,me,Fe,qe);if(Je&&!$e)return Je;if($.length>=3){const Ze=Math.min(7,$.length-1);for(let Ke=Y+1;Ke<Ze;Ke++){const Qe=G($,Ke);if(Qe){const mt=it(Qe,Qe.toLowerCase(),Y,ne,me,Fe,qe);mt&&(mt[0]-=3,(!Je||mt[0]>Je[0])&&(Je=mt))}}}return Je}function G($,V){if(V+1>=$.length)return;const Y=$[V],ne=$[V+1];if(Y!==ne)return $.slice(0,V)+ne+Y+$.slice(V+2)}}),define(be[101],we([0,1,102,100,14]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),M=new RegExp(i.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${D.source}`,"g");function y(l){return l.replace(T,(k,v)=>v?k:`\\${k}`)}e.escapeIcons=y;const F=new RegExp(`\\\\${D.source}`,"g");function O(l){return l.replace(F,k=>`\\${k}`)}e.markdownEscapeEscapedIcons=O;const m=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function t(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(m,(k,v,b,o)=>b?k:v||o||"")}e.stripIcons=t;function u(l){const k=l.indexOf(e.iconStartMarker);return k===-1?{text:l}:s(l,k)}e.parseLabelWithIcons=u;function s(l,k){const v=[];let b="";function o(d){if(d){b+=d;for(const g of d)v.push(P)}}let S=-1,n="",P=0,r,c,w=k;const h=l.length;for(o(l.substr(0,k));w<h;)r=l[w],c=l[w+1],r===e.iconStartMarker[0]&&c===e.iconStartMarker[1]?(S=w,o(n),n=e.iconStartMarker,w++):r===")"&&S!==-1?(P+=w-S+1,S=-1,n=""):S!==-1?M.test(r)?n+=r:(o(n),S=-1,n=""):o(r),w++;return o(n),{text:b,iconOffsets:v}}function a(l,k,v=!1){const{text:b,iconOffsets:o}=k;if(!o||o.length===0)return(0,A.matchesFuzzy)(l,b,v);const S=(0,_.ltrim)(b," "),n=b.length-S.length,P=(0,A.matchesFuzzy)(l,S,v);if(P)for(const r of P){const c=o[r.start+n]+n;r.start+=c,r.end+=c}return P}e.matchesFuzzyIconAware=a}),define(be[69],we([0,1,15,101]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(u="",s=!1){if(this.value=u,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(u,s=0){return this.value+=F(this.supportThemeIcons?(0,A.escapeIcons)(u):u).replace(/([ \t]+)/g,(a,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,s){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=D;function M(t){return T(t)?!t.value:Array.isArray(t)?t.every(M):!0}e.isEmptyMarkdownString=M;function T(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function y(t,u){return t===u?!0:!t||!u?!1:t.value===u.value&&t.isTrusted===u.isTrusted&&t.supportThemeIcons===u.supportThemeIcons}e.markdownStringEqual=y;function F(t){return t.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=F;function O(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=O;function m(t){const u=[],s=t.split("|").map(l=>l.trim());t=s[0];const a=s[1];if(a){const l=/height=(\d+)/.exec(a),k=/width=(\d+)/.exec(a),v=l?l[1]:"",b=k?k[1]:"",o=isFinite(parseInt(b)),S=isFinite(parseInt(v));o&&u.push(`width="${b}"`),S&&u.push(`height="${v}"`)}return{href:t,dimensions:u}}e.parseHrefAndDimensions=m}),define(be[33],we([0,1,14]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(A||(A={})),function(_){const D="error",M="warning",T="warn",y="info",F="ignore";function O(t){return t?i.equalsIgnoreCase(D,t)?_.Error:i.equalsIgnoreCase(M,t)||i.equalsIgnoreCase(T,t)?_.Warning:i.equalsIgnoreCase(y,t)?_.Info:_.Ignore:_.Ignore}_.fromValue=O;function m(t){switch(t){case _.Error:return D;case _.Warning:return M;case _.Info:return y;default:return F}}_.toString=m}(A||(A={})),e.default=A}),define(be[53],we([0,1,21,14,2]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(O){return JSON.stringify(O,y)}e.stringify=D;function M(O){let m=JSON.parse(O);return m=F(m),m}e.parse=M;var T;(function(O){O[O.Uri=1]="Uri",O[O.Regexp=2]="Regexp",O[O.ScmResource=3]="ScmResource",O[O.ScmResourceGroup=4]="ScmResourceGroup",O[O.ScmProvider=5]="ScmProvider",O[O.CommentController=6]="CommentController",O[O.CommentThread=7]="CommentThread",O[O.CommentThreadReply=8]="CommentThreadReply",O[O.CommentNode=9]="CommentNode",O[O.CommentThreadNode=10]="CommentThreadNode",O[O.TimelineActionContext=11]="TimelineActionContext",O[O.NotebookCellActionContext=12]="NotebookCellActionContext",O[O.TestItemContext=13]="TestItemContext",O[O.Date=14]="Date"})(T=e.MarshalledId||(e.MarshalledId={}));function y(O,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,A.regExpFlags)(m)}:m}function F(O,m=0){if(!O||m>200)return O;if(typeof O=="object"){switch(O.$mid){case 1:return _.URI.revive(O);case 2:return new RegExp(O.source,O.flags);case 14:return new Date(O.source)}if(O instanceof i.VSBuffer||O instanceof Uint8Array)return O;if(Array.isArray(O))for(let t=0;t<O.length;++t)O[t]=F(O[t],m+1);else for(const t in O)Object.hasOwnProperty.call(O,t)&&(O[t]=F(O[t],m+1))}return O}e.revive=F}),define(be[103],we([0,1,10,19]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new i.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),D=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(f,E,C=!1){const I=f||"",N=E||"",p=_.value.collator.compare(I,N);return _.value.collatorIsNumeric&&p===0&&I!==N?I<N?-1:1:p}e.compareFileNames=T;function y(f,E){const C=D.value.collator;return f=f||"",E=E||"",S(C,f,E)}e.compareFileNamesDefault=y;function F(f,E){const C=D.value.collator;return f=f||"",E=E||"",c(f,E)||S(C,f,E)}e.compareFileNamesUpper=F;function O(f,E){const C=D.value.collator;return f=f||"",E=E||"",r(f,E)||S(C,f,E)}e.compareFileNamesLower=O;function m(f,E){return f=f||"",E=E||"",f===E?0:f<E?-1:1}e.compareFileNamesUnicode=m;function t(f,E,C=!1){C||(f=f&&f.toLowerCase(),E=E&&E.toLowerCase());const[I,N]=b(f),[p,R]=b(E);return I!==p?I<p?-1:1:N===R?0:N<R?-1:1}e.noIntlCompareFileNames=t;function u(f,E){const[C,I]=b(f),[N,p]=b(E);let R=_.value.collator.compare(I,p);if(R===0){if(_.value.collatorIsNumeric&&I!==p)return I<p?-1:1;if(R=_.value.collator.compare(C,N),_.value.collatorIsNumeric&&R===0&&C!==N)return C<N?-1:1}return R}e.compareFileExtensions=u;function s(f,E){f=f||"",E=E||"";const C=o(f),I=o(E),N=D.value.collator,p=M.value.collator;return S(p,C,I)||S(N,f,E)}e.compareFileExtensionsDefault=s;function a(f,E){f=f||"",E=E||"";const C=o(f),I=o(E),N=D.value.collator,p=M.value.collator;return S(p,C,I)||c(f,E)||S(N,f,E)}e.compareFileExtensionsUpper=a;function l(f,E){f=f||"",E=E||"";const C=o(f),I=o(E),N=D.value.collator,p=M.value.collator;return S(p,C,I)||r(f,E)||S(N,f,E)}e.compareFileExtensionsLower=l;function k(f,E){f=f||"",E=E||"";const C=o(f).toLowerCase(),I=o(E).toLowerCase();return C!==I?C<I?-1:1:f!==E?f<E?-1:1:0}e.compareFileExtensionsUnicode=k;const v=/^(.*?)(\.([^.]*))?$/;function b(f,E=!1){const C=f?v.exec(f):[];let I=[C&&C[1]||"",C&&C[3]||""];return E&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function o(f){const E=f?v.exec(f):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function S(f,E,C){let I=f.compare(E,C);return I!==0?I:E.length!==C.length?E.length<C.length?-1:1:0}function n(f){const E=f.charAt(0);return E.toLocaleUpperCase()!==E}function P(f){const E=f.charAt(0);return E.toLocaleLowerCase()!==E}function r(f,E){return n(f)&&P(E)?-1:P(f)&&n(E)?1:0}function c(f,E){return P(f)&&n(E)?-1:n(f)&&P(E)?1:0}function w(f,E,C=!1){return C||(f=f&&f.toLowerCase(),E=E&&E.toLowerCase()),f===E?0:f<E?-1:1}function h(f,E,C=!1){const I=f.split(A.sep),N=E.split(A.sep),p=I.length-1,R=N.length-1;let x,j;for(let H=0;;H++){if(x=p===H,j=R===H,x&&j)return T(I[H],N[H],C);if(x)return-1;if(j)return 1;const z=w(I[H],N[H],C);if(z!==0)return z}}e.comparePaths=h;function d(f,E,C){const I=f.toLowerCase(),N=E.toLowerCase(),p=g(f,E,C);if(p)return p;const R=I.endsWith(C),x=N.endsWith(C);if(R!==x)return R?-1:1;const j=T(I,N);return j!==0?j:I.localeCompare(N)}e.compareAnything=d;function g(f,E,C){const I=f.toLowerCase(),N=E.toLowerCase(),p=I.startsWith(C),R=N.startsWith(C);if(p!==R)return p?-1:1;if(p&&R){if(I.length<N.length)return-1;if(I.length>N.length)return 1}return 0}e.compareByPrefix=g}),define(be[70],we([0,1,71,11,19,28,24,14,2]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function F(c,w,h){if(typeof c=="string"&&(c=y.URI.file(c)),h){const g=h.getWorkspaceFolder(c);if(g){const f=h.getWorkspace().folders.length>1;let E;if((0,M.isEqual)(g.uri,c)?E="":E=(0,M.relativePath)(g.uri,c),f){const C=g.name?g.name:(0,M.basename)(g.uri);E=E?C+" \u2022 "+E:C}return E}}if(c.scheme!==A.Schemas.file&&c.scheme!==A.Schemas.untitled)return c.with({query:null,fragment:null}).toString(!0);if((0,i.hasDriveLetter)(c.fsPath))return(0,_.normalize)(m(c.fsPath));let d=(0,_.normalize)(c.fsPath);return!D.isWindows&&w?.userHome&&(d=u(d,w.userHome.fsPath)),d}e.getPathLabel=F;function O(c){if(!c)return;typeof c=="string"&&(c=y.URI.file(c));const w=(0,M.basename)(c)||(c.scheme===A.Schemas.file?c.fsPath:c.path);return D.isWindows&&(0,i.isRootOrDriveLetter)(w)?m(w):w}e.getBaseLabel=O;function m(c,w){return(0,i.hasDriveLetter)(c,w)?c.charAt(0).toUpperCase()+c.slice(1):c}e.normalizeDriveLetter=m;let t=Object.create(null);function u(c,w){if(D.isWindows||!c||!w)return c;let h=t.original===w?t.normalized:void 0;return h||(h=`${(0,T.rtrim)(w,_.posix.sep)}${_.posix.sep}`,t={original:w,normalized:h}),(D.isLinux?c.startsWith(h):(0,T.startsWithIgnoreCase)(c,h))&&(c=`~/${c.substr(h.length)}`),c}e.tildify=u;function s(c,w){return c.replace(/^~($|\/|\\)/,`${w}$1`)}e.untildify=s;const a="\u2026",l="\\\\",k="~";function v(c,w=_.sep){const h=new Array(c.length);let d=!1;for(let g=0;g<c.length;g++){let f=c[g];if(f===""){h[g]=`.${w}`;continue}if(!f){h[g]=f;continue}d=!0;let E="";f.indexOf(l)===0?(E=f.substr(0,f.indexOf(l)+l.length),f=f.substr(f.indexOf(l)+l.length)):f.indexOf(w)===0?(E=f.substr(0,f.indexOf(w)+w.length),f=f.substr(f.indexOf(w)+w.length)):f.indexOf(k)===0&&(E=f.substr(0,f.indexOf(k)+k.length),f=f.substr(f.indexOf(k)+k.length));const C=f.split(w);for(let I=1;d&&I<=C.length;I++)for(let N=C.length-I;d&&N>=0;N--){d=!1;let p=C.slice(N,N+I).join(w);for(let R=0;!d&&R<c.length;R++)if(R!==g&&c[R]&&c[R].indexOf(p)>-1){const x=N+I===C.length,j=N>0&&c[R].indexOf(w)>-1?w+p:p,H=c[R].endsWith(j);d=!x||H}if(!d){let R="";(C[0].endsWith(":")||E!=="")&&(N===1&&(N=0,I++,p=C[0]+w+p),N>0&&(R=C[0]+w),R=E+R),N>0&&(R=R+a+w),R=R+p,N+I<C.length&&(R=R+w+a),h[g]=R}}d&&(h[g]=f)}return h}e.shorten=v;var b;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function o(c,w=Object.create(null)){const h=[];let d=!1,g="";for(const f of c)if(f==="$"||d&&f==="{")g&&h.push({value:g,type:b.TEXT}),g="",d=!0;else if(f==="}"&&d){const E=w[g];if(typeof E=="string")E.length&&h.push({value:E,type:b.VARIABLE});else if(E){const C=h[h.length-1];(!C||C.type!==b.SEPARATOR)&&h.push({value:E.label,type:b.SEPARATOR})}g="",d=!1}else g+=f;return g&&!d&&h.push({value:g,type:b.TEXT}),h.filter((f,E)=>{if(f.type===b.SEPARATOR){const C=h[E-1],I=h[E+1];return[C,I].every(N=>N&&(N.type===b.VARIABLE||N.type===b.TEXT)&&N.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=o;function S(c,w){return D.isMacintosh||w?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):c.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function n(c,w){return D.isMacintosh||w?c.replace(/\(&&\w\)|&&/g,""):D.isWindows?c.replace(/&&|&/g,h=>h==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function P(c){return c.replace(/&/g,"&&")}e.unmnemonicLabel=P;function r(c){const w=c.indexOf("/")!==-1?_.posix:_.win32,h=w.basename(c),d=w.dirname(c);return h.length?{name:h,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(be[104],we([0,1,2]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(O){return O.toJSON()}class _{constructor(m){this._uriTransformer=m}transformIncoming(m){const t=this._uriTransformer.transformIncoming(m);return t===m?m:A(i.URI.from(t))}transformOutgoing(m){const t=this._uriTransformer.transformOutgoing(m);return t===m?m:A(i.URI.from(t))}transformOutgoingURI(m){const t=this._uriTransformer.transformOutgoing(m);return t===m?m:i.URI.from(t)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function D(O,m,t){if(!O||t>200)return null;if(typeof O=="object"){if(O instanceof i.URI)return m.transformOutgoing(O);for(let u in O)if(Object.hasOwnProperty.call(O,u)){const s=D(O[u],m,t+1);s!==null&&(O[u]=s)}}return null}function M(O,m){const t=D(O,m,0);return t===null?O:t}e.transformOutgoingURIs=M;function T(O,m,t,u){if(!O||u>200)return null;if(typeof O=="object"){if(O.$mid===1)return t?i.URI.revive(m.transformIncoming(O)):m.transformIncoming(O);for(let s in O)if(Object.hasOwnProperty.call(O,s)){const a=T(O[s],m,t,u+1);a!==null&&(O[s]=a)}}return null}function y(O,m){const t=T(O,m,!1,0);return t===null?O:t}e.transformIncomingURIs=y;function F(O,m){const t=T(O,m,!0,0);return t===null?O:t}e.transformAndReviveIncomingURIs=F}),define(be[34],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(y){return i.test(y)}e.isUUID=A;const _=new Uint8Array(16),D=[];for(let y=0;y<256;y++)D.push(y.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(y){for(let F=0;F<y.length;F++)y[F]=Math.floor(Math.random()*256);return y};function T(){M(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let y=0,F="";return F+=D[_[y++]],F+=D[_[y++]],F+=D[_[y++]],F+=D[_[y++]],F+="-",F+=D[_[y++]],F+=D[_[y++]],F+="-",F+=D[_[y++]],F+=D[_[y++]],F+="-",F+=D[_[y++]],F+=D[_[y++]],F+="-",F+=D[_[y++]],F+=D[_[y++]],F+=D[_[y++]],F+=D[_[y++]],F+=D[_[y++]],F+=D[_[y++]],F}e.generateUuid=T}),define(be[105],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(be[106],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class A{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let y=0,F=T.notIn.length;y<F;y++)switch(T.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,y){if(T.getTokenCount()===0)return!0;const F=T.findTokenIndexAtOffset(y-2),O=T.getStandardTokenType(F);return this.isOK(O)}_findNeutralCharacterInRange(T,y){for(let F=T;F<=y;F++){const O=String.fromCharCode(F);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=A;class _{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of T)D(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),D(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),D(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),D(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&D(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=_;function D(M,T,y){M.has(T)?M.get(T).push(y):M.set(T,[y])}}),define(be[72],we([0,1,21,28]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(m){m[m.Full=1]="Full",m[m.Delta=2]="Delta"})(_||(_={}));function D(m){for(let t=0,u=m.length;t<u;t+=4){const s=m[t+0],a=m[t+1],l=m[t+2],k=m[t+3];m[t+0]=k,m[t+1]=l,m[t+2]=a,m[t+3]=s}}function M(m){const t=new Uint8Array(m.buffer,m.byteOffset,m.length*4);return A.isLittleEndian()||D(t),i.VSBuffer.wrap(t)}function T(m){const t=m.buffer;if(A.isLittleEndian()||D(t),t.byteOffset%4==0)return new Uint32Array(t.buffer,t.byteOffset,t.length/4);{const u=new Uint8Array(t.byteLength);return u.set(t),new Uint32Array(u.buffer,u.byteOffset,u.length/4)}}function y(m){const t=new Uint32Array(F(m));let u=0;if(t[u++]=m.id,m.type==="full")t[u++]=1,t[u++]=m.data.length,t.set(m.data,u),u+=m.data.length;else{t[u++]=2,t[u++]=m.deltas.length;for(const s of m.deltas)t[u++]=s.start,t[u++]=s.deleteCount,s.data?(t[u++]=s.data.length,t.set(s.data,u),u+=s.data.length):t[u++]=0}return M(t)}e.encodeSemanticTokensDto=y;function F(m){let t=0;if(t+=1+1,m.type==="full")t+=1+m.data.length;else{t+=1,t+=(1+1+1)*m.deltas.length;for(const u of m.deltas)u.data&&(t+=u.data.length)}return t}function O(m){const t=T(m);let u=0;const s=t[u++];if(t[u++]===1){const v=t[u++],b=t.subarray(u,u+v);return u+=v,{id:s,type:"full",data:b}}const l=t[u++],k=[];for(let v=0;v<l;v++){const b=t[u++],o=t[u++],S=t[u++];let n;S>0&&(n=t.subarray(u,u+S),u+=S),k[v]={start:b,deleteCount:o,data:n}}return{id:s,type:"delta",deltas:k}}e.decodeSemanticTokensDto=O}),define(be[107],we([17,18]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(be[108],we([0,1,107]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,_=A*60,D=_*24,M=D*7,T=D*30,y=D*365;function F(m,t,u){typeof m!="number"&&(m=m.getTime());const s=Math.round((new Date().getTime()-m)/1e3);if(s<-30)return(0,i.localize)(0,null,F(new Date().getTime()+s*1e3,!1));if(s<30)return(0,i.localize)(1,null);let a;return s<A?(a=s,t?a===1?u?(0,i.localize)(2,null,a):(0,i.localize)(3,null,a):u?(0,i.localize)(4,null,a):(0,i.localize)(5,null,a):a===1?u?(0,i.localize)(6,null,a):(0,i.localize)(7,null,a):u?(0,i.localize)(8,null,a):(0,i.localize)(9,null,a)):s<_?(a=Math.floor(s/A),t?a===1?u?(0,i.localize)(10,null,a):(0,i.localize)(11,null,a):u?(0,i.localize)(12,null,a):(0,i.localize)(13,null,a):a===1?u?(0,i.localize)(14,null,a):(0,i.localize)(15,null,a):u?(0,i.localize)(16,null,a):(0,i.localize)(17,null,a)):s<D?(a=Math.floor(s/_),t?a===1?u?(0,i.localize)(18,null,a):(0,i.localize)(19,null,a):u?(0,i.localize)(20,null,a):(0,i.localize)(21,null,a):a===1?u?(0,i.localize)(22,null,a):(0,i.localize)(23,null,a):u?(0,i.localize)(24,null,a):(0,i.localize)(25,null,a)):s<M?(a=Math.floor(s/D),t?a===1?(0,i.localize)(26,null,a):(0,i.localize)(27,null,a):a===1?(0,i.localize)(28,null,a):(0,i.localize)(29,null,a)):s<T?(a=Math.floor(s/M),t?a===1?u?(0,i.localize)(30,null,a):(0,i.localize)(31,null,a):u?(0,i.localize)(32,null,a):(0,i.localize)(33,null,a):a===1?u?(0,i.localize)(34,null,a):(0,i.localize)(35,null,a):u?(0,i.localize)(36,null,a):(0,i.localize)(37,null,a)):s<y?(a=Math.floor(s/T),t?a===1?u?(0,i.localize)(38,null,a):(0,i.localize)(39,null,a):u?(0,i.localize)(40,null,a):(0,i.localize)(41,null,a):a===1?u?(0,i.localize)(42,null,a):(0,i.localize)(43,null,a):u?(0,i.localize)(44,null,a):(0,i.localize)(45,null,a)):(a=Math.floor(s/y),t?a===1?u?(0,i.localize)(46,null,a):(0,i.localize)(47,null,a):u?(0,i.localize)(48,null,a):(0,i.localize)(49,null,a):a===1?u?(0,i.localize)(50,null,a):(0,i.localize)(51,null,a):u?(0,i.localize)(52,null,a):(0,i.localize)(53,null,a))}e.fromNow=F;function O(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(be[109],we([17,18]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(be[42],we([0,1,16,13,109]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(F,O){return O&&(F.stack||F.stacktrace)?_.localize(0,null,T(F),M(F.stack)||M(F.stacktrace)):T(F)}function M(F){return Array.isArray(F)?F.join(`
`):F}function T(F){return typeof F.code=="string"&&typeof F.errno=="number"&&typeof F.syscall=="string"?_.localize(1,null,F.message):F.message||_.localize(2,null)}function y(F=null,O=!1){if(!F)return _.localize(3,null);if(Array.isArray(F)){const m=i.coalesce(F),t=y(m[0],O);return m.length>1?_.localize(4,null,t,m.length):t}if(A.isString(F))return F;if(F.detail){const m=F.detail;if(m.error)return D(m.error,O);if(m.exception)return D(m.exception,O)}return F.stack?D(F,O):F.message?F.message:_.localize(5,null)}e.toErrorMessage=y}),define(be[110],we([17,18]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(be[111],we([0,1,110,28,112,16,25,105]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=F;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class m{constructor(Q,se,Oe,He){this.id=Q,this.name=se,this.defaultValue=Oe,this.schema=He}applyUpdate(Q,se){return u(Q,se)}compute(Q,se,Oe){return Oe}}class t{constructor(Q,se){this.newValue=Q,this.didChange=se}}e.ApplyUpdateResult=t;function u(q,Q){if(typeof q!="object"||typeof Q!="object"||!q||!Q)return new t(Q,q!==Q);if(Array.isArray(q)||Array.isArray(Q)){const Oe=Array.isArray(q)&&Array.isArray(Q)&&D.equals(q,Q);return new t(Q,Oe)}let se=!1;for(const Oe in Q)if(Q.hasOwnProperty(Oe)){const He=u(q[Oe],Q[Oe]);He.didChange&&(q[Oe]=He.newValue,se=!0)}return new t(q,se)}class s{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,se){return u(Q,se)}validate(Q){return this.defaultValue}}class a{constructor(Q,se,Oe,He){this.id=Q,this.name=se,this.defaultValue=Oe,this.schema=He}applyUpdate(Q,se){return u(Q,se)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,se,Oe){return Oe}}function l(q,Q){return typeof q=="undefined"?Q:q==="false"?!1:Boolean(q)}e.boolean=l;class k extends a{constructor(Q,se,Oe,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Oe);super(Q,se,Oe,He)}validate(Q){return l(Q,this.defaultValue)}}function v(q,Q,se,Oe){if(typeof q=="undefined")return Q;let He=parseInt(q,10);return isNaN(He)?Q:(He=Math.max(se,He),He=Math.min(Oe,He),He|0)}e.clampedInt=v;class b extends a{constructor(Q,se,Oe,He,tt,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="integer",Ve.default=Oe,Ve.minimum=He,Ve.maximum=tt);super(Q,se,Oe,Ve);this.minimum=He,this.maximum=tt}static clampedInt(Q,se,Oe,He){return v(Q,se,Oe,He)}validate(Q){return b.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class o extends a{constructor(Q,se,Oe,He,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Oe);super(Q,se,Oe,tt);this.validationFn=He}static clamp(Q,se,Oe){return Q<se?se:Q>Oe?Oe:Q}static float(Q,se){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return se;const Oe=parseFloat(Q);return isNaN(Oe)?se:Oe}validate(Q){return this.validationFn(o.float(Q,this.defaultValue))}}class S extends a{static string(Q,se){return typeof Q!="string"?se:Q}constructor(Q,se,Oe,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Oe);super(Q,se,Oe,He)}validate(Q){return S.string(Q,this.defaultValue)}}function n(q,Q,se){return typeof q!="string"||se.indexOf(q)===-1?Q:q}e.stringSet=n;class P extends a{constructor(Q,se,Oe,He,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=He,tt.default=Oe);super(Q,se,Oe,tt);this._allowedValues=He}validate(Q){return n(Q,this.defaultValue,this._allowedValues)}}class r extends m{constructor(Q,se,Oe,He,tt,Ve,wt=void 0){typeof wt!="undefined"&&(wt.type="string",wt.enum=tt,wt.default=He);super(Q,se,Oe,wt);this._allowedValues=tt,this._convert=Ve}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function c(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends m{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",description:i.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,se,Oe){return Oe===0?Q.accessibilitySupport:Oe}}class h extends m{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{insertSpace:l(se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var d;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(d=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function g(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(q){switch(q){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function C(q){switch(q){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class I extends s{constructor(){super(128)}compute(Q,se,Oe){const He=["monaco-editor"];return se.get(33)&&He.push(se.get(33)),Q.extraEditorClassName&&He.push(Q.extraEditorClassName),se.get(66)==="default"?He.push("mouse-default"):se.get(66)==="copy"&&He.push("mouse-copy"),se.get(100)&&He.push("showUnused"),se.get(126)&&He.push("showDeprecated"),He.join(" ")}}class N extends k{constructor(){super(32,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Q,se,Oe){return Oe&&Q.emptySelectionClipboard}}class p extends m{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:i.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:i.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{cursorMoveOnType:l(se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":n(se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":n(se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(se.loop,this.defaultValue.loop)}}}class R extends m{constructor(){super(45,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?R.OFF:Q==="true"?R.ON:Q:Boolean(Q)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class x extends s{constructor(){super(44)}compute(Q,se,Oe){return Q.fontInfo}}class j extends a{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(22,null)})}validate(Q){const se=o.float(Q,this.defaultValue);return se===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(se,6,100)}compute(Q,se,Oe){return Q.fontInfo.fontSize}}class H extends m{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:i.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(b.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class z extends m{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},se={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[i.localize(25,null),i.localize(26,null),i.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(29,null),...se},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(30,null),...se},"editor.gotoLocation.multipleDeclarations":{description:i.localize(31,null),...se},"editor.gotoLocation.multipleImplementations":{description:i.localize(32,null),...se},"editor.gotoLocation.multipleReferences":{description:i.localize(33,null),...se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Oe,description:i.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Oe,description:i.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Oe,description:i.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Oe,description:i.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Oe,description:i.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{multiple:n(se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:se.multipleDefinitions??n(se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:se.multipleTypeDefinitions??n(se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:se.multipleDeclarations??n(se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:se.multipleImplementations??n(se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:se.multipleReferences??n(se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends m{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:i.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:i.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:i.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:i.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{enabled:l(se.enabled,this.defaultValue.enabled),delay:b.clampedInt(se.delay,this.defaultValue.delay,0,1e4),sticky:l(se.sticky,this.defaultValue.sticky),above:l(se.above,this.defaultValue.above)}}}var ce;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(ce=e.RenderMinimap||(e.RenderMinimap={}));class fe extends s{constructor(){super(131)}compute(Q,se,Oe){return fe.computeLayout(se,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const se=Q.height/Q.lineHeight,Oe=Q.scrollBeyondLastLine?se-1:0,He=(Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),tt=Math.floor(Q.viewLineCount/He);return{typicalViewportLineCount:se,extraLinesBeyondLastLine:Oe,desiredRatio:He,minimapLineCount:tt}}static _computeMinimapLayout(Q,se){const Oe=Q.outerWidth,He=Q.outerHeight,tt=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ve=se.stableMinimapLayoutInput,wt=Ve&&Q.outerHeight===Ve.outerHeight&&Q.lineHeight===Ve.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ve.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ve.pixelRatio&&Q.scrollBeyondLastLine===Ve.scrollBeyondLastLine&&Q.minimap.enabled===Ve.minimap.enabled&&Q.minimap.side===Ve.minimap.side&&Q.minimap.size===Ve.minimap.size&&Q.minimap.showSlider===Ve.minimap.showSlider&&Q.minimap.renderCharacters===Ve.minimap.renderCharacters&&Q.minimap.maxColumn===Ve.minimap.maxColumn&&Q.minimap.scale===Ve.minimap.scale&&Q.verticalScrollbarWidth===Ve.verticalScrollbarWidth&&Q.isViewportWrapping===Ve.isViewportWrapping,Ie=Q.lineHeight,Se=Q.typicalHalfwidthCharacterWidth,he=Q.scrollBeyondLastLine,ee=Q.minimap.renderCharacters;let te=tt>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ue=Q.minimap.maxColumn,de=Q.minimap.size,ke=Q.minimap.side,xe=Q.verticalScrollbarWidth,Ae=Q.viewLineCount,Be=Q.remainingWidth,Xe=Q.isViewportWrapping,nt=ee?2:3;let Re=Math.floor(tt*He);const ae=Re/tt;let le=!1,ie=!1,W=nt*te,pe=te/tt,Ce=1;if(de==="fill"||de==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:pt,desiredRatio:Ut,minimapLineCount:At}=fe.computeContainedMinimapLineCount({viewLineCount:Ae,scrollBeyondLastLine:he,height:He,lineHeight:Ie,pixelRatio:tt});if(Ae/At>1)le=!0,ie=!0,te=1,W=1,pe=te/tt;else{let Ct=!1,Et=te+1;if(de==="fit"){const Lt=Math.ceil((Ae+pt)*W);Xe&&wt&&Be<=se.stableFitRemainingWidth?(Ct=!0,Et=se.stableFitMaxMinimapScale):Ct=Lt>Re}if(de==="fill"||Ct){le=!0;const Lt=te;W=Math.min(Ie*tt,Math.max(1,Math.floor(1/Ut))),Xe&&wt&&Be<=se.stableFitRemainingWidth&&(Et=se.stableFitMaxMinimapScale),te=Math.min(Et,Math.max(1,Math.floor(W/nt))),te>Lt&&(Ce=Math.min(2,te/Lt)),pe=te/tt/Ce,Re=Math.ceil(Math.max(gt,Ae+pt)*W),Xe?(se.stableMinimapLayoutInput=Q,se.stableFitRemainingWidth=Be,se.stableFitMaxMinimapScale=te):(se.stableMinimapLayoutInput=null,se.stableFitRemainingWidth=0)}}}const ze=Math.floor(ue*pe),Ue=Math.min(ze,Math.max(0,Math.floor((Be-xe-2)*pe/(Se+pe)))+e.MINIMAP_GUTTER_WIDTH);let dt=Math.floor(tt*Ue);const bt=dt/tt;dt=Math.floor(dt*Ce);const yt=ee?1:2,st=ke==="left"?0:Oe-Ue-xe;return{renderMinimap:yt,minimapLeft:st,minimapWidth:Ue,minimapHeightIsEditorHeight:le,minimapIsSampling:ie,minimapScale:te,minimapLineHeight:W,minimapCanvasInnerWidth:dt,minimapCanvasInnerHeight:Re,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:ae}}static computeLayout(Q,se){const Oe=se.outerWidth|0,He=se.outerHeight|0,tt=se.lineHeight|0,Ve=se.lineNumbersDigitCount|0,wt=se.typicalHalfwidthCharacterWidth,Ie=se.maxDigitWidth,Se=se.pixelRatio,he=se.viewLineCount,ee=Q.get(123),te=ee==="inherit"?Q.get(122):ee,ue=te==="inherit"?Q.get(118):te,de=Q.get(121),ke=Q.get(2),xe=se.isDominatedByLongLines,Ae=Q.get(50),Be=Q.get(60).renderType!==0,Xe=Q.get(61),nt=Q.get(94),Re=Q.get(65),ae=Q.get(92),le=ae.verticalScrollbarSize,ie=ae.verticalHasArrows,W=ae.arrowSize,pe=ae.horizontalScrollbarSize,Ce=Q.get(58),ze=Q.get(37);let Ue;if(typeof Ce=="string"&&/^\d+(\.\d+)?ch$/.test(Ce)){const Bt=parseFloat(Ce.substr(0,Ce.length-2));Ue=b.clampedInt(Bt*wt,0,0,1e3)}else Ue=b.clampedInt(Ce,0,0,1e3);ze&&(Ue+=16);let dt=0;if(Be){const Bt=Math.max(Ve,Xe);dt=Math.round(Bt*Ie)}let bt=0;Ae&&(bt=tt);let yt=0,st=yt+bt,gt=st+dt,pt=gt+Ue;const Ut=Oe-bt-dt-Ue;let At=!1,Ot=!1,Ct=-1;ke!==2&&(te==="inherit"&&xe?(At=!0,Ot=!0):ue==="on"||ue==="bounded"?Ot=!0:ue==="wordWrapColumn"&&(Ct=de));const Et=fe._computeMinimapLayout({outerWidth:Oe,outerHeight:He,lineHeight:tt,typicalHalfwidthCharacterWidth:wt,pixelRatio:Se,scrollBeyondLastLine:nt,minimap:Re,verticalScrollbarWidth:le,viewLineCount:he,remainingWidth:Ut,isViewportWrapping:Ot},se.memory||new O);Et.renderMinimap!==0&&Et.minimapLeft===0&&(yt+=Et.minimapWidth,st+=Et.minimapWidth,gt+=Et.minimapWidth,pt+=Et.minimapWidth);const Lt=Ut-Et.minimapWidth,qt=Math.max(1,Math.floor((Lt-le-2)/wt)),vt=ie?W:0;return Ot&&(Ct=Math.max(1,qt),ue==="bounded"&&(Ct=Math.min(Ct,de))),{width:Oe,height:He,glyphMarginLeft:yt,glyphMarginWidth:bt,lineNumbersLeft:st,lineNumbersWidth:dt,decorationsLeft:gt,decorationsWidth:Ue,contentLeft:pt,contentWidth:Lt,minimap:Et,viewportColumn:qt,isWordWrapMinified:At,isViewportWrapping:Ot,wrappingColumn:Ct,verticalScrollbarWidth:le,horizontalScrollbarHeight:pe,overviewRuler:{top:vt,width:le,height:He-2*vt,right:0}}}}e.EditorLayoutInfoComputer=fe;class re extends m{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:i.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:l(Q.enabled,this.defaultValue.enabled)}}}class ge extends m{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:i.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:i.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{enabled:l(se.enabled,this.defaultValue.enabled),fontSize:b.clampedInt(se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(se.fontFamily,this.defaultValue.fontFamily)}}}class ye extends o{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>o.clamp(Q,0,150),{markdownDescription:i.localize(47,null)})}compute(Q,se,Oe){return Q.fontInfo.lineHeight}}class ve extends m{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:i.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(49,null),i.localize(50,null),i.localize(51,null)],default:Q.size,description:i.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:i.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:i.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:i.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:i.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{enabled:l(se.enabled,this.defaultValue.enabled),size:n(se.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(se.side,this.defaultValue.side,["right","left"]),showSlider:n(se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(se.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(se.scale,1,1,3),maxColumn:b.clampedInt(se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(q){return q==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class je extends m{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{top:b.clampedInt(se.top,0,0,1e3),bottom:b.clampedInt(se.bottom,0,0,1e3)}}}class et extends m{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:i.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{enabled:l(se.enabled,this.defaultValue.enabled),cycle:l(se.cycle,this.defaultValue.cycle)}}}class lt extends s{constructor(){super(129)}compute(Q,se,Oe){return Q.pixelRatio}}class it extends m{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:i.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:i.localize(63,null)},other:{type:"boolean",default:Q.other,description:i.localize(64,null)}}}],default:Q,description:i.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const se=Q,Oe={other:l(se.other,this.defaultValue.other),comments:l(se.comments,this.defaultValue.comments),strings:l(se.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var ft;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(ft=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class _t extends m{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null),i.localize(69,null)],default:"on",description:i.localize(70,null)})}validate(Q){let se=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(se=4,Oe=Q):Q==="interval"?se=3:Q==="relative"?se=2:Q==="on"?se=1:se=0),{renderType:se,renderFn:Oe}}}function ut(q){const Q=q.get(87);return Q==="editable"?q.get(81):Q!=="on"}e.filterValidationDecorations=ut;class rt extends m{constructor(){const Q=[],se={type:"number",description:i.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[se,{type:["object"],properties:{column:se,color:{type:"string",description:i.localize(72,null),format:"color-hex"}}}]},default:Q,description:i.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const se=[];for(let Oe of Q)if(typeof Oe=="number")se.push({column:b.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const He=Oe;se.push({column:b.clampedInt(He.column,0,0,1e4),color:He.color})}return se.sort((Oe,He)=>Oe.column-He.column),se}return this.defaultValue}}function B(q,Q){if(typeof q!="string")return Q;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends m{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(74,null),i.localize(75,null),i.localize(76,null)],default:"auto",description:i.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(78,null),i.localize(79,null),i.localize(80,null)],default:"auto",description:i.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:i.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:i.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:i.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q,Oe=b.clampedInt(se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=b.clampedInt(se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(se.vertical,this.defaultValue.vertical),horizontal:B(se.horizontal,this.defaultValue.horizontal),useShadows:l(se.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:b.clampedInt(se.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:He,verticalSliderSize:b.clampedInt(se.verticalSliderSize,He,0,1e3),scrollByPage:l(se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class $ extends m{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:i.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:i.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:i.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:i.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:i.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:i.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:i.localize(91,null)}})}applyUpdate(Q,se){let Oe=!1;se.allowedCharacters&&(M.equals(Q.allowedCharacters,se.allowedCharacters)||(Q={...Q,allowedCharacters:se.allowedCharacters},Oe=!0)),se.allowedLocales&&(M.equals(Q.allowedLocales,se.allowedLocales)||(Q={...Q,allowedLocales:se.allowedLocales},Oe=!0));const He=super.applyUpdate(Q,se);return Oe?new t(He.newValue,!0):He}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{nonBasicASCII:me(se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,se){if(typeof Q!="object"||!Q)return se;const Oe={};for(const[He,tt]of Object.entries(Q))tt===!0&&(Oe[He]=!0);return Oe}}class V extends m{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:i.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{enabled:l(se.enabled,this.defaultValue.enabled),mode:n(se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Y extends m{constructor(){const Q={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:i.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:l(Q.enabled,this.defaultValue.enabled)}}}class ne extends m{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(94,null),i.localize(95,null),i.localize(96,null)],default:Q.bracketPairs,description:i.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(98,null),i.localize(99,null),i.localize(100,null)],default:Q.bracketPairsHorizontal,description:i.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:i.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:i.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:i.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{bracketPairs:me(se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(se.indentation,this.defaultValue.indentation),highlightActiveIndentation:l(se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function me(q,Q,se){const Oe=se.indexOf(q);return Oe===-1?Q:se[Oe]}class Fe extends m{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(105,null),i.localize(106,null)],default:Q.insertMode,description:i.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:i.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:i.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:i.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:i.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:i.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:i.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:i.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:i.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const se=Q;return{insertMode:n(se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(se.showIcons,this.defaultValue.showIcons),showStatusBar:l(se.showStatusBar,this.defaultValue.showStatusBar),preview:l(se.preview,this.defaultValue.preview),previewMode:n(se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(se.showMethods,this.defaultValue.showMethods),showFunctions:l(se.showFunctions,this.defaultValue.showFunctions),showConstructors:l(se.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(se.showDeprecated,this.defaultValue.showDeprecated),showFields:l(se.showFields,this.defaultValue.showFields),showVariables:l(se.showVariables,this.defaultValue.showVariables),showClasses:l(se.showClasses,this.defaultValue.showClasses),showStructs:l(se.showStructs,this.defaultValue.showStructs),showInterfaces:l(se.showInterfaces,this.defaultValue.showInterfaces),showModules:l(se.showModules,this.defaultValue.showModules),showProperties:l(se.showProperties,this.defaultValue.showProperties),showEvents:l(se.showEvents,this.defaultValue.showEvents),showOperators:l(se.showOperators,this.defaultValue.showOperators),showUnits:l(se.showUnits,this.defaultValue.showUnits),showValues:l(se.showValues,this.defaultValue.showValues),showConstants:l(se.showConstants,this.defaultValue.showConstants),showEnums:l(se.showEnums,this.defaultValue.showEnums),showEnumMembers:l(se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(se.showKeywords,this.defaultValue.showKeywords),showWords:l(se.showWords,this.defaultValue.showWords),showColors:l(se.showColors,this.defaultValue.showColors),showFiles:l(se.showFiles,this.defaultValue.showFiles),showReferences:l(se.showReferences,this.defaultValue.showReferences),showFolders:l(se.showFolders,this.defaultValue.showFolders),showTypeParameters:l(se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(se.showSnippets,this.defaultValue.showSnippets),showUsers:l(se.showUsers,this.defaultValue.showUsers),showIssues:l(se.showIssues,this.defaultValue.showIssues)}}}class $e extends m{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class qe extends s{constructor(){super(130)}compute(Q,se,Oe){return se.get(81)?!0:Q.tabFocusMode}}var Je;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Je=e.WrappingIndent||(e.WrappingIndent={}));function Ze(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends s{constructor(){super(132)}compute(Q,se,Oe){const He=se.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Qe="Consolas, 'Courier New', monospace",mt="Menlo, Monaco, 'Courier New', monospace",Tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?mt:A.isLinux?Tt:Qe,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(q){return e.editorOptionsRegistry[q.id]=q,q}var kt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.foldingMaximumRegions=41]="foldingMaximumRegions",q[q.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=43]="fontFamily",q[q.fontInfo=44]="fontInfo",q[q.fontLigatures=45]="fontLigatures",q[q.fontSize=46]="fontSize",q[q.fontWeight=47]="fontWeight",q[q.formatOnPaste=48]="formatOnPaste",q[q.formatOnType=49]="formatOnType",q[q.glyphMargin=50]="glyphMargin",q[q.gotoLocation=51]="gotoLocation",q[q.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",q[q.hover=53]="hover",q[q.inDiffEditor=54]="inDiffEditor",q[q.inlineSuggest=55]="inlineSuggest",q[q.letterSpacing=56]="letterSpacing",q[q.lightbulb=57]="lightbulb",q[q.lineDecorationsWidth=58]="lineDecorationsWidth",q[q.lineHeight=59]="lineHeight",q[q.lineNumbers=60]="lineNumbers",q[q.lineNumbersMinChars=61]="lineNumbersMinChars",q[q.linkedEditing=62]="linkedEditing",q[q.links=63]="links",q[q.matchBrackets=64]="matchBrackets",q[q.minimap=65]="minimap",q[q.mouseStyle=66]="mouseStyle",q[q.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=68]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",q[q.multiCursorModifier=70]="multiCursorModifier",q[q.multiCursorPaste=71]="multiCursorPaste",q[q.occurrencesHighlight=72]="occurrencesHighlight",q[q.overviewRulerBorder=73]="overviewRulerBorder",q[q.overviewRulerLanes=74]="overviewRulerLanes",q[q.padding=75]="padding",q[q.parameterHints=76]="parameterHints",q[q.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",q[q.quickSuggestions=79]="quickSuggestions",q[q.quickSuggestionsDelay=80]="quickSuggestionsDelay",q[q.readOnly=81]="readOnly",q[q.renameOnType=82]="renameOnType",q[q.renderControlCharacters=83]="renderControlCharacters",q[q.renderFinalNewline=84]="renderFinalNewline",q[q.renderLineHighlight=85]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=87]="renderValidationDecorations",q[q.renderWhitespace=88]="renderWhitespace",q[q.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",q[q.roundedSelection=90]="roundedSelection",q[q.rulers=91]="rulers",q[q.scrollbar=92]="scrollbar",q[q.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=94]="scrollBeyondLastLine",q[q.scrollPredominantAxis=95]="scrollPredominantAxis",q[q.selectionClipboard=96]="selectionClipboard",q[q.selectionHighlight=97]="selectionHighlight",q[q.selectOnLineNumbers=98]="selectOnLineNumbers",q[q.showFoldingControls=99]="showFoldingControls",q[q.showUnused=100]="showUnused",q[q.snippetSuggestions=101]="snippetSuggestions",q[q.smartSelect=102]="smartSelect",q[q.smoothScrolling=103]="smoothScrolling",q[q.stickyTabStops=104]="stickyTabStops",q[q.stopRenderingLineAfter=105]="stopRenderingLineAfter",q[q.suggest=106]="suggest",q[q.suggestFontSize=107]="suggestFontSize",q[q.suggestLineHeight=108]="suggestLineHeight",q[q.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",q[q.suggestSelection=110]="suggestSelection",q[q.tabCompletion=111]="tabCompletion",q[q.tabIndex=112]="tabIndex",q[q.unicodeHighlighting=113]="unicodeHighlighting",q[q.unusualLineTerminators=114]="unusualLineTerminators",q[q.useShadowDOM=115]="useShadowDOM",q[q.useTabStops=116]="useTabStops",q[q.wordSeparators=117]="wordSeparators",q[q.wordWrap=118]="wordWrap",q[q.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=121]="wordWrapColumn",q[q.wordWrapOverride1=122]="wordWrapOverride1",q[q.wordWrapOverride2=123]="wordWrapOverride2",q[q.wrappingIndent=124]="wrappingIndent",q[q.wrappingStrategy=125]="wrappingStrategy",q[q.showDeprecated=126]="showDeprecated",q[q.inlayHints=127]="inlayHints",q[q.editorClassName=128]="editorClassName",q[q.pixelRatio=129]="pixelRatio",q[q.tabFocusMode=130]="tabFocusMode",q[q.layoutInfo=131]="layoutInfo",q[q.wrappingInfo=132]="wrappingInfo"})(kt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new k(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(148,null)})),acceptSuggestionOnEnter:Te(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(149,null),""],markdownDescription:i.localize(150,null)})),accessibilitySupport:Te(new w),accessibilityPageSize:Te(new b(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(151,null)})),ariaLabel:Te(new S(4,"ariaLabel",i.localize(152,null))),autoClosingBrackets:Te(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(153,null),i.localize(154,null),""],description:i.localize(155,null)})),autoClosingDelete:Te(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(156,null),""],description:i.localize(157,null)})),autoClosingOvertype:Te(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(158,null),""],description:i.localize(159,null)})),autoClosingQuotes:Te(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(160,null),i.localize(161,null),""],description:i.localize(162,null)})),autoIndent:Te(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[i.localize(163,null),i.localize(164,null),i.localize(165,null),i.localize(166,null),i.localize(167,null)],description:i.localize(168,null)})),automaticLayout:Te(new k(10,"automaticLayout",!1)),autoSurround:Te(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(169,null),i.localize(170,null),i.localize(171,null),""],description:i.localize(172,null)})),bracketPairColorization:Te(new Y),bracketPairGuides:Te(new ne),stickyTabStops:Te(new k(104,"stickyTabStops",!1,{description:i.localize(173,null)})),codeLens:Te(new k(14,"codeLens",!0,{description:i.localize(174,null)})),codeLensFontFamily:Te(new S(15,"codeLensFontFamily","",{description:i.localize(175,null)})),codeLensFontSize:Te(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(176,null)})),colorDecorators:Te(new k(17,"colorDecorators",!0,{description:i.localize(177,null)})),columnSelection:Te(new k(18,"columnSelection",!1,{description:i.localize(178,null)})),comments:Te(new h),contextmenu:Te(new k(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new k(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(179,null)})),cursorBlinking:Te(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:i.localize(180,null)})),cursorSmoothCaretAnimation:Te(new k(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(181,null)})),cursorStyle:Te(new r(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:i.localize(182,null)})),cursorSurroundingLines:Te(new b(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(183,null)})),cursorSurroundingLinesStyle:Te(new P(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(184,null),i.localize(185,null)],description:i.localize(186,null)})),cursorWidth:Te(new b(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(187,null)})),disableLayerHinting:Te(new k(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new k(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new k(30,"domReadOnly",!1)),dragAndDrop:Te(new k(31,"dragAndDrop",!0,{description:i.localize(188,null)})),emptySelectionClipboard:Te(new N),extraEditorClassName:Te(new S(33,"extraEditorClassName","")),fastScrollSensitivity:Te(new o(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:i.localize(189,null)})),find:Te(new p),fixedOverflowWidgets:Te(new k(36,"fixedOverflowWidgets",!1)),folding:Te(new k(37,"folding",!0,{description:i.localize(190,null)})),foldingStrategy:Te(new P(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(191,null),i.localize(192,null)],description:i.localize(193,null)})),foldingHighlight:Te(new k(39,"foldingHighlight",!0,{description:i.localize(194,null)})),foldingImportsByDefault:Te(new k(40,"foldingImportsByDefault",!1,{description:i.localize(195,null)})),foldingMaximumRegions:Te(new b(41,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(196,null)})),unfoldOnClickAfterEndOfLine:Te(new k(42,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(197,null)})),fontFamily:Te(new S(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(198,null)})),fontInfo:Te(new x),fontLigatures2:Te(new R),fontSize:Te(new j),fontWeight:Te(new H),formatOnPaste:Te(new k(48,"formatOnPaste",!1,{description:i.localize(199,null)})),formatOnType:Te(new k(49,"formatOnType",!1,{description:i.localize(200,null)})),glyphMargin:Te(new k(50,"glyphMargin",!0,{description:i.localize(201,null)})),gotoLocation:Te(new z),hideCursorInOverviewRuler:Te(new k(52,"hideCursorInOverviewRuler",!1,{description:i.localize(202,null)})),hover:Te(new K),inDiffEditor:Te(new k(54,"inDiffEditor",!1)),letterSpacing:Te(new o(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>o.clamp(q,-5,20),{description:i.localize(203,null)})),lightbulb:Te(new re),lineDecorationsWidth:Te(new a(58,"lineDecorationsWidth",10)),lineHeight:Te(new ye),lineNumbers:Te(new _t),lineNumbersMinChars:Te(new b(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new k(62,"linkedEditing",!1,{description:i.localize(204,null)})),links:Te(new k(63,"links",!0,{description:i.localize(205,null)})),matchBrackets:Te(new P(64,"matchBrackets","always",["always","near","never"],{description:i.localize(206,null)})),minimap:Te(new ve),mouseStyle:Te(new P(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new o(67,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:i.localize(207,null)})),mouseWheelZoom:Te(new k(68,"mouseWheelZoom",!1,{markdownDescription:i.localize(208,null)})),multiCursorMergeOverlapping:Te(new k(69,"multiCursorMergeOverlapping",!0,{description:i.localize(209,null)})),multiCursorModifier:Te(new r(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[i.localize(210,null),i.localize(211,null)],markdownDescription:i.localize(212,null)})),multiCursorPaste:Te(new P(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(213,null),i.localize(214,null)],markdownDescription:i.localize(215,null)})),occurrencesHighlight:Te(new k(72,"occurrencesHighlight",!0,{description:i.localize(216,null)})),overviewRulerBorder:Te(new k(73,"overviewRulerBorder",!0,{description:i.localize(217,null)})),overviewRulerLanes:Te(new b(74,"overviewRulerLanes",3,0,3)),padding:Te(new je),parameterHints:Te(new et),peekWidgetDefaultFocus:Te(new P(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(218,null),i.localize(219,null)],description:i.localize(220,null)})),definitionLinkOpensInPeek:Te(new k(78,"definitionLinkOpensInPeek",!1,{description:i.localize(221,null)})),quickSuggestions:Te(new it),quickSuggestionsDelay:Te(new b(80,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(222,null)})),readOnly:Te(new k(81,"readOnly",!1)),renameOnType:Te(new k(82,"renameOnType",!1,{description:i.localize(223,null),markdownDeprecationMessage:i.localize(224,null)})),renderControlCharacters:Te(new k(83,"renderControlCharacters",!0,{description:i.localize(225,null),restricted:!0})),renderFinalNewline:Te(new k(84,"renderFinalNewline",!0,{description:i.localize(226,null)})),renderLineHighlight:Te(new P(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(227,null)],description:i.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Te(new k(86,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(229,null)})),renderValidationDecorations:Te(new P(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new P(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(230,null),i.localize(231,null),i.localize(232,null),""],description:i.localize(233,null)})),revealHorizontalRightPadding:Te(new b(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new k(90,"roundedSelection",!0,{description:i.localize(234,null)})),rulers:Te(new rt),scrollbar:Te(new G),scrollBeyondLastColumn:Te(new b(93,"scrollBeyondLastColumn",5,0,1073741824,{description:i.localize(235,null)})),scrollBeyondLastLine:Te(new k(94,"scrollBeyondLastLine",!0,{description:i.localize(236,null)})),scrollPredominantAxis:Te(new k(95,"scrollPredominantAxis",!0,{description:i.localize(237,null)})),selectionClipboard:Te(new k(96,"selectionClipboard",!0,{description:i.localize(238,null),included:A.isLinux})),selectionHighlight:Te(new k(97,"selectionHighlight",!0,{description:i.localize(239,null)})),selectOnLineNumbers:Te(new k(98,"selectOnLineNumbers",!0)),showFoldingControls:Te(new P(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[i.localize(240,null),i.localize(241,null)],description:i.localize(242,null)})),showUnused:Te(new k(100,"showUnused",!0,{description:i.localize(243,null)})),showDeprecated:Te(new k(126,"showDeprecated",!0,{description:i.localize(244,null)})),inlayHints:Te(new ge),snippetSuggestions:Te(new P(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(245,null),i.localize(246,null),i.localize(247,null),i.localize(248,null)],description:i.localize(249,null)})),smartSelect:Te(new $e),smoothScrolling:Te(new k(103,"smoothScrolling",!1,{description:i.localize(250,null)})),stopRenderingLineAfter:Te(new b(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new Fe),inlineSuggest:Te(new V),suggestFontSize:Te(new b(107,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(251,null)})),suggestLineHeight:Te(new b(108,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(252,null)})),suggestOnTriggerCharacters:Te(new k(109,"suggestOnTriggerCharacters",!0,{description:i.localize(253,null)})),suggestSelection:Te(new P(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(254,null),i.localize(255,null),i.localize(256,null)],description:i.localize(257,null)})),tabCompletion:Te(new P(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(258,null),i.localize(259,null),i.localize(260,null)],description:i.localize(261,null)})),tabIndex:Te(new b(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new $),unusualLineTerminators:Te(new P(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(262,null),i.localize(263,null),i.localize(264,null)],description:i.localize(265,null)})),useShadowDOM:Te(new k(115,"useShadowDOM",!0)),useTabStops:Te(new k(116,"useTabStops",!0,{description:i.localize(266,null)})),wordSeparators:Te(new S(117,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:i.localize(267,null)})),wordWrap:Te(new P(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(268,null),i.localize(269,null),i.localize(270,null),i.localize(271,null)],description:i.localize(272,null)})),wordWrapBreakAfterCharacters:Te(new S(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new S(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new b(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(273,null)})),wordWrapOverride1:Te(new P(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new P(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new r(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ze,{enumDescriptions:[i.localize(274,null),i.localize(275,null),i.localize(276,null),i.localize(277,null)],description:i.localize(278,null)})),wrappingStrategy:Te(new P(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[i.localize(279,null),i.localize(280,null)],description:i.localize(281,null)})),editorClassName:Te(new I),pixelRatio:Te(new lt),tabFocusMode:Te(new qe),layoutInfo:Te(new fe),wrappingInfo:Te(new Ke)}}),define(be[113],we([17,18]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[114],we([17,18]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[115],we([17,18]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(be[116],we([17,18]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(be[117],we([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[118],we([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[119],we([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(be[120],we([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[121],we([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[122],we([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[123],we([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[124],we([17,18]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(be[125],we([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[126],we([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[127],we([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[128],we([17,18]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[129],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var i;(function(M){M[M.ACTIVATE=1]="ACTIVATE",M[M.RESTORE=2]="RESTORE",M[M.PRESERVE=3]="PRESERVE"})(i=e.EditorActivation||(e.EditorActivation={}));var A;(function(M){M[M.PICK=0]="PICK",M[M.DISABLED=1]="DISABLED",M[M.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(A=e.EditorResolution||(e.EditorResolution={}));var _;(function(M){M[M.API=0]="API",M[M.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(M){M[M.Center=0]="Center",M[M.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",M[M.NearTop=2]="NearTop",M[M.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[130],we([0,1,114]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function D(t){return t=t.trim(),t==="*"||A.test(t)}e.isValidVersionStr=D;function M(t){if(!D(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let u=t.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=M;function T(t){if(!t)return null;let u=t.majorBase,s=t.majorMustEqual,a=t.minorBase,l=t.minorMustEqual,k=t.patchBase,v=t.patchMustEqual;t.hasCaret&&(u===0||(l=!1),v=!1);let b=0;if(t.preRelease){const o=_.exec(t.preRelease);if(o){const[,S,n,P]=o;b=Date.UTC(Number(S),Number(n)-1,Number(P))}}return{majorBase:u,majorMustEqual:s,minorBase:a,minorMustEqual:l,patchBase:k,patchMustEqual:v,isMinimum:t.hasGreaterEquals,notBefore:b}}e.normalizeVersion=T;function y(t,u,s){let a;typeof t=="string"?a=T(M(t)):a=t;let l;u instanceof Date?l=u.getTime():typeof u=="string"&&(l=new Date(u).getTime());let k;if(typeof s=="string"?k=T(M(s)):k=s,!a||!k)return!1;let v=a.majorBase,b=a.minorBase,o=a.patchBase,S=k.majorBase,n=k.minorBase,P=k.patchBase,r=k.notBefore,c=k.majorMustEqual,w=k.minorMustEqual,h=k.patchMustEqual;return k.isMinimum?v>S?!0:v<S?!1:b>n?!0:b<n||l&&l<r?!1:o>=P:(v===1&&S===0&&(!c||!w||!h)&&(S=1,n=0,P=0,c=!0,w=!1,h=!1),v<S?!1:v>S?!c:b<n?!1:b>n?!w:o<P?!1:o>P?!h:!(l&&l<r))}e.isValidVersion=y;function F(t,u,s,a){return s.isBuiltin||typeof s.main=="undefined"?!0:m(t,u,s.engines.vscode,a)}e.isValidExtensionVersion=F;function O(t,u,s){return t==="*"||m(u,s,t)}e.isEngineValid=O;function m(t,u,s,a=[]){let l=T(M(s));if(!l)return a.push(i.localize(0,null,s)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return a.push(i.localize(1,null,s)),!1}else if(!l.majorMustEqual)return a.push(i.localize(2,null,s)),!1;return y(t,u,l)?!0:(a.push(i.localize(3,null,t,s)),!1)}}),define(be[73],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(_,D=[],M=!1){this.ctor=_,this.staticArguments=D,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=i}),define(be[43],we([0,1,73]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const A=[];function _(M,T,y){T instanceof i.SyncDescriptor||(T=new i.SyncDescriptor(T,[],y)),A.push([M,T])}e.registerSingleton=_;function D(){return A}e.getSingletonServiceDescriptors=D}),define(be[131],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=i;class A{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let M of this._nodes.values())M.outgoing.size===0&&D.push(M);return D}insertEdge(D,M){const T=this.lookupOrInsertNode(D),y=this.lookupOrInsertNode(M);T.outgoing.set(this._hashFn(M),y),y.incoming.set(this._hashFn(D),T)}removeNode(D){const M=this._hashFn(D);this._nodes.delete(M);for(let T of this._nodes.values())T.outgoing.delete(M),T.incoming.delete(M)}lookupOrInsertNode(D){const M=this._hashFn(D);let T=this._nodes.get(M);return T||(T=new i(D),this._nodes.set(M,T)),T}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[M,T]of this._nodes)D.push(`${M}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,M]of this._nodes){const T=new Set([D]),y=this._findCycle(M,T);if(y)return y}}_findCycle(D,M){for(let[T,y]of D.outgoing){if(M.has(T))return[...M,T].join(" -> ");M.add(T);const F=this._findCycle(y,M);if(F)return F;M.delete(T)}}}e.Graph=A}),define(be[3],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function T(y){return y[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=T})(i=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function A(M,T,y,F){T[i.DI_TARGET]===T?T[i.DI_DEPENDENCIES].push({id:M,index:y,optional:F}):(T[i.DI_DEPENDENCIES]=[{id:M,index:y,optional:F}],T[i.DI_TARGET]=T)}function _(M){if(i.serviceIds.has(M))return i.serviceIds.get(M);const T=function(y,F,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(T,y,O,!1)};return T.toString=()=>M,i.serviceIds.set(M,T),T}e.createDecorator=_;function D(M){return M}e.refineServiceDecorator=D}),define(be[74],we([0,1,13,2,3]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function D(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof A.URI)}e.isConfigurationOverrides=D;function M(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||i.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=M;var T;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function F(l,k){const v=Object.create(null);for(let b in l)O(v,b,l[b],k);return v}e.toValuesTree=F;function O(l,k,v,b){const o=k.split("."),S=o.pop();let n=l;for(let P=0;P<o.length;P++){let r=o[P],c=n[r];switch(typeof c){case"undefined":c=n[r]=Object.create(null);break;case"object":break;default:b(`Ignoring ${k} as ${o.slice(0,P+1).join(".")} is ${JSON.stringify(c)}`);return}n=c}if(typeof n=="object"&&n!==null)try{n[S]=v}catch{b(`Ignoring ${k} as ${o.join(".")} is ${JSON.stringify(n)}`)}else b(`Ignoring ${k} as ${o.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=O;function m(l,k){const v=k.split(".");t(l,v)}e.removeFromValueTree=m;function t(l,k){const v=k.shift();if(k.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const b=l[v];typeof b=="object"&&!Array.isArray(b)&&(t(b,k),Object.keys(b).length===0&&delete l[v])}}function u(l,k,v){function b(n,P){let r=n;for(const c of P){if(typeof r!="object"||r===null)return;r=r[c]}return r}const o=k.split("."),S=b(l,o);return typeof S=="undefined"?v:S}e.getConfigurationValue=u;function s(l,k,v){Object.keys(k).forEach(b=>{b!=="__proto__"&&(b in l?i.isObject(l[b])&&i.isObject(k[b])?s(l[b],k[b],v):v&&(l[b]=k[b]):l[b]=k[b])})}e.merge=s;function a(l,k,v){const b=l.inspect(k),o=l.inspect(v);return typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:b.defaultValue}e.getMigratedSettingValue=a}),define(be[44],we([0,1,28,14,3]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",i.isMacintosh),D.set("isLinux",i.isLinux),D.set("isWindows",i.isWindows),D.set("isWeb",i.isWeb),D.set("isMacNative",i.isMacintosh&&!i.isWeb),D.set("isEdge",i.isEdge),D.set("isFirefox",i.isFirefox),D.set("isChrome",i.isChrome),D.set("isSafari",i.isSafari);const M=Object.prototype.hasOwnProperty;var T;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return m.INSTANCE}static true(){return t.INSTANCE}static has(p){return u.create(p)}static equals(p,R){return s.create(p,R)}static notEquals(p,R){return k.create(p,R)}static regex(p,R){return r.create(p,R)}static in(p,R){return a.create(p,R)}static not(p){return v.create(p)}static and(...p){return h.create(p,null)}static or(...p){return d.create(p,null,!0)}static greater(p,R){return o.create(p,R)}static greaterEquals(p,R){return S.create(p,R)}static smaller(p,R){return n.create(p,R)}static smallerEquals(p,R){return P.create(p,R)}static deserialize(p,R=!1){if(!!p)return this._deserializeOrExpression(p,R)}static _deserializeOrExpression(p,R){let x=p.split("||");return d.create(x.map(j=>this._deserializeAndExpression(j,R)),null,!0)}static _deserializeAndExpression(p,R){let x=p.split("&&");return h.create(x.map(j=>this._deserializeOne(j,R)),null)}static _deserializeOne(p,R){if(p=p.trim(),p.indexOf("!=")>=0){let x=p.split("!=");return k.create(x[0].trim(),this._deserializeValue(x[1],R))}if(p.indexOf("==")>=0){let x=p.split("==");return s.create(x[0].trim(),this._deserializeValue(x[1],R))}if(p.indexOf("=~")>=0){let x=p.split("=~");return r.create(x[0].trim(),this._deserializeRegexValue(x[1],R))}if(p.indexOf(" in ")>=0){let x=p.split(" in ");return a.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const x=p.split(">=");return S.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const x=p.split(">");return o.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const x=p.split("<=");return P.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const x=p.split("<");return n.create(x[0].trim(),x[1].trim())}return/^\!\s*/.test(p)?v.create(p.substr(1).trim()):u.create(p)}static _deserializeValue(p,R){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let x=/^'([^']*)'$/.exec(p);return x?x[1].trim():p}static _deserializeRegexValue(p,R){if((0,A.isFalsyOrWhitespace)(p)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let x=p.indexOf("/"),j=p.lastIndexOf("/");if(x===j||x<0){if(R)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let H=p.slice(x+1,j),z=p[j+1]==="i"?"i":"";try{return new RegExp(H,z)}catch(K){if(R)throw new Error(`bad regexp-value '${p}', parse error: ${K}`);return console.warn(`bad regexp-value '${p}', parse error: ${K}`),null}}}e.ContextKeyExpr=y;function F(N,p){const R=N?N.substituteConstants():void 0,x=p?p.substituteConstants():void 0;return!R&&!x?!0:!R||!x?!1:R.equals(x)}e.expressionsAreEqualWithConstantSubstitution=F;function O(N,p){return N.cmp(p)}class m{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return t.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class t{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=t,t.INSTANCE=new t;class u{constructor(p,R){this.key=p,this.negated=R,this.type=2}static create(p,R=null){const x=D.get(p);return typeof x=="boolean"?x?t.INSTANCE:m.INSTANCE:new u(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:f(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=D.get(this.key);return typeof p=="boolean"?p?t.INSTANCE:m.INSTANCE:this}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class s{constructor(p,R,x){this.key=p,this.value=R,this.negated=x,this.type=4}static create(p,R,x=null){if(typeof R=="boolean")return R?u.create(p,x):v.create(p,x);const j=D.get(p);return typeof j=="boolean"?R===(j?"true":"false")?t.INSTANCE:m.INSTANCE:new s(p,R,x)}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=D.get(this.key);if(typeof p=="boolean"){const R=p?"true":"false";return this.value===R?t.INSTANCE:m.INSTANCE}return this}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class a{constructor(p,R){this.key=p,this.valueKey=R,this.type=10,this.negated=null}static create(p,R){return new a(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}substituteConstants(){return this}evaluate(p){const R=p.getValue(this.valueKey),x=p.getValue(this.key);return Array.isArray(R)?R.indexOf(x)>=0:typeof x=="string"&&typeof R=="object"&&R!==null?M.call(R,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyInExpr=a;class l{constructor(p){this._actual=p,this.type=11}static create(p){return new l(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new l(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=l;class k{constructor(p,R,x){this.key=p,this.value=R,this.negated=x,this.type=5}static create(p,R,x=null){if(typeof R=="boolean")return R?v.create(p,x):u.create(p,x);const j=D.get(p);return typeof j=="boolean"?R===(j?"true":"false")?m.INSTANCE:t.INSTANCE:new k(p,R,x)}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=D.get(this.key);if(typeof p=="boolean"){const R=p?"true":"false";return this.value===R?m.INSTANCE:t.INSTANCE}return this}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class v{constructor(p,R){this.key=p,this.negated=R,this.type=3}static create(p,R=null){const x=D.get(p);return typeof x=="boolean"?x?m.INSTANCE:t.INSTANCE:new v(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:f(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=D.get(this.key);return typeof p=="boolean"?p?m.INSTANCE:t.INSTANCE:this}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function b(N,p){if(typeof N=="string"){const R=parseFloat(N);isNaN(R)||(N=R)}return typeof N=="string"||typeof N=="number"?p(N):m.INSTANCE}class o{constructor(p,R,x){this.key=p,this.value=R,this.negated=x,this.type=12}static create(p,R,x=null){return b(R,j=>new o(p,j,x))}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class S{constructor(p,R,x){this.key=p,this.value=R,this.negated=x,this.type=13}static create(p,R,x=null){return b(R,j=>new S(p,j,x))}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=S;class n{constructor(p,R,x){this.key=p,this.value=R,this.negated=x,this.type=14}static create(p,R,x=null){return b(R,j=>new n(p,j,x))}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class P{constructor(p,R,x){this.key=p,this.value=R,this.negated=x,this.type=15}static create(p,R,x=null){return b(R,j=>new P(p,j,x))}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=P;class r{constructor(p,R){this.key=p,this.regexp=R,this.type=7,this.negated=null}static create(p,R){return new r(p,R)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const R=this.regexp?this.regexp.source:"",x=p.regexp?p.regexp.source:"";return R<x?-1:R>x?1:0}equals(p){if(p.type===this.type){const R=this.regexp?this.regexp.source:"",x=p.regexp?p.regexp.source:"";return this.key===p.key&&R===x}return!1}substituteConstants(){return this}evaluate(p){let R=p.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=c.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class c{constructor(p){this._actual=p,this.type=8}static create(p){return new c(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new c(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=c;function w(N){let p=null;for(let R=0,x=N.length;R<x;R++){const j=N[R].substituteConstants();if(N[R]!==j&&p===null){p=[];for(let H=0;H<R;H++)p[H]=N[H]}p!==null&&(p[R]=j)}return p===null?N:p}class h{constructor(p,R){this.expr=p,this.negated=R,this.type=6}static create(p,R){return h._normalizeArr(p,R)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let R=0,x=this.expr.length;R<x;R++){const j=O(this.expr[R],p.expr[R]);if(j!==0)return j}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let R=0,x=this.expr.length;R<x;R++)if(!this.expr[R].equals(p.expr[R]))return!1;return!0}return!1}substituteConstants(){const p=w(this.expr);return p===this.expr?this:h.create(p,this.negated)}evaluate(p){for(let R=0,x=this.expr.length;R<x;R++)if(!this.expr[R].evaluate(p))return!1;return!0}static _normalizeArr(p,R){const x=[];let j=!1;for(const H of p)if(!!H){if(H.type===1){j=!0;continue}if(H.type===0)return m.INSTANCE;if(H.type===6){x.push(...H.expr);continue}x.push(H)}if(x.length===0&&j)return t.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(O);for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];for(;x.length>1;){const H=x[x.length-1];if(H.type!==9)break;x.pop();const z=x.pop(),K=x.length===0,ce=d.create(H.expr.map(fe=>h.create([fe,z],null)),null,K);ce&&(x.push(ce),x.sort(O))}return x.length===1?x[0]:new h(x,R)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let R of this.expr)p.push(...R.keys());return p}map(p){return new h(this.expr.map(R=>R.map(p)),null)}negate(){if(!this.negated){const p=[];for(let R of this.expr)p.push(R.negate());this.negated=d.create(p,this,!0)}return this.negated}}class d{constructor(p,R){this.expr=p,this.negated=R,this.type=9}static create(p,R,x){return d._normalizeArr(p,R,x)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let R=0,x=this.expr.length;R<x;R++){const j=O(this.expr[R],p.expr[R]);if(j!==0)return j}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let R=0,x=this.expr.length;R<x;R++)if(!this.expr[R].equals(p.expr[R]))return!1;return!0}return!1}substituteConstants(){const p=w(this.expr);return p===this.expr?this:d.create(p,this.negated,!1)}evaluate(p){for(let R=0,x=this.expr.length;R<x;R++)if(this.expr[R].evaluate(p))return!0;return!1}static _normalizeArr(p,R,x){let j=[],H=!1;if(p){for(let z=0,K=p.length;z<K;z++){const ce=p[z];if(!!ce){if(ce.type===0){H=!0;continue}if(ce.type===1)return t.INSTANCE;if(ce.type===9){j=j.concat(ce.expr);continue}j.push(ce)}}if(j.length===0&&H)return m.INSTANCE;j.sort(O)}if(j.length!==0){if(j.length===1)return j[0];for(let z=1;z<j.length;z++)j[z-1].equals(j[z])&&(j.splice(z,1),z--);if(j.length===1)return j[0];if(x){for(let z=0;z<j.length;z++)for(let K=z+1;K<j.length;K++)C(j[z],j[K])&&(j.splice(K,1),K--);if(j.length===1)return j[0]}return new d(j,R)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let R of this.expr)p.push(...R.keys());return p}map(p){return new d(this.expr.map(R=>R.map(p)),null)}negate(){if(!this.negated){let p=[];for(let R of this.expr)p.push(R.negate());for(;p.length>1;){const R=p.shift(),x=p.shift(),j=[];for(const z of I(R))for(const K of I(x))j.push(h.create([z,K],null));const H=p.length===0;p.unshift(d.create(j,null,H))}this.negated=p[0]}return this.negated}}class g extends u{constructor(p,R,x){super(p,null);this._defaultValue=R,typeof x=="object"?g._info.push({...x,key:p}):x!==!0&&g._info.push({key:p,description:x,type:R!=null?typeof R:void 0})}static all(){return g._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return s.create(this.key,p)}notEqualsTo(p){return k.create(this.key,p)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(N,p){return N<p?-1:N>p?1:0}function E(N,p,R,x){return N<R?-1:N>R?1:p<x?-1:p>x?1:0}function C(N,p){if(p.type===6&&N.type!==9&&N.type!==6){for(const j of p.expr)if(N.equals(j))return!0}const R=N.negate(),x=I(R).concat(I(p));x.sort(O);for(let j=0;j<x.length;j++){const z=x[j].negate();for(let K=j+1;K<x.length;K++){const ce=x[K];if(z.equals(ce))return!0}}return!1}e.implies=C;function I(N){return N.type===9?N.expr:[N]}}),define(be[132],we([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(be[45],we([0,1,22,19,14,13,2,115,3]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function F(H){return H.create===!0}e.isFileOpenForWriteOptions=F;var O;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var m;(function(H){H[H.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var t;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(t=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=u;function s(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=s;function a(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function l(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=l;function k(H){return u(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var v;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,K){super(z);this.code=K}}e.FileSystemProviderError=b;function o(H,z){const K=new b(H.toString(),z);return n(K,z),K}e.createFileSystemProviderError=o;function S(H){return H||o((0,T.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=S;function n(H,z){return H.name=z?`${z} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=n;function P(H){if(!H)return v.Unknown;if(H instanceof b)return H.code;const z=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!z)return v.Unknown;switch(z[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=P;function r(H){if(H instanceof f)return H.fileOperationResult;switch(P(H)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var c;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(c=e.FileOperation||(e.FileOperation={}));class w{constructor(z,K,ce){this.resource=z,this.operation=K,this.target=ce}isOperation(z){return this.operation===z}}e.FileOperationEvent=w;var h;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class d{constructor(z,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const ce=new Map;for(const fe of z){const re=ce.get(fe.type);switch(re?re.push([fe.resource,fe]):ce.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,re]of ce)switch(fe){case 1:this.added=i.TernarySearchTree.forUris(()=>K),this.added.fill(re);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>K),this.updated.fill(re);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>K),this.deleted.fill(re);break}}contains(z,...K){return this.doContains(z,{includeChildren:!1},...K)}affects(z,...K){return this.doContains(z,{includeChildren:!0},...K)}doContains(z,K,...ce){if(!z)return!1;const fe=ce.length>0;return!!((!fe||ce.includes(1))&&(this.added?.get(z)||K.includeChildren&&this.added?.findSuperstr(z))||(!fe||ce.includes(0))&&(this.updated?.get(z)||K.includeChildren&&this.updated?.findSuperstr(z))||(!fe||ce.includes(2))&&(this.deleted?.findSubstr(z)||K.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function g(H,z,K){return!H||!z||H===z||z.length>H.length?!1:(z.charAt(z.length-1)!==A.sep&&(z+=A.sep),K?(0,_.startsWithIgnoreCase)(H,z):H.indexOf(z)===0)}e.isParent=g;class f extends Error{constructor(z,K,ce){super(z);this.fileOperationResult=K,this.options=ce}}e.FileOperationError=f;class E extends f{constructor(z,K,ce){super(z,2,ce);this.stat=K}}e.NotModifiedSinceFileOperationError=E;var C;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=N;async function p(H,z){if(!z.hasProvider(M.URI.from({scheme:H.scheme})))return new Promise(K=>{const ce=z.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===H.scheme&&fe.added&&(ce.dispose(),K())})})}e.whenProviderRegistered=p,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(z){return(0,D.isNumber)(z)||(z=0),z<R.KB?(0,T.localize)(1,null,z.toFixed(0)):z<R.MB?(0,T.localize)(2,null,(z/R.KB).toFixed(2)):z<R.GB?(0,T.localize)(3,null,(z/R.MB).toFixed(2)):z<R.TB?(0,T.localize)(4,null,(z/R.GB).toFixed(2)):(0,T.localize)(5,null,(z/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB;var x;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function j(H){return{maxFileSize:H===0?300*R.MB:16*R.GB,maxHeapSize:H===0?700*R.MB:2*700*R.MB}}e.getPlatformLimits=j}),define(be[54],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(..._){this._entries=new Map;for(let[D,M]of _)this.set(D,M)}set(_,D){const M=this._entries.get(_);return this._entries.set(_,D),M}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=i}),define(be[133],we([0,1,10,15,73,131,3,54]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class F extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class O{constructor(s=new T.ServiceCollection,a=!1,l){this._activeInstantiations=new Set,this._services=s,this._strict=a,this._parent=l,this._services.set(M.IInstantiationService,this)}createChild(s){return new O(s,this._strict,this)}invokeFunction(s,...a){let l=t.traceInvocation(s),k=!1;try{return s({get:b=>{if(k)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(b,l);if(!o)throw new Error(`[invokeFunction] unknown service '${b}'`);return o}},...a)}finally{k=!0,l.stop()}}createInstance(s,...a){let l,k;return s instanceof _.SyncDescriptor?(l=t.traceCreation(s.ctor),k=this._createInstance(s.ctor,s.staticArguments.concat(a),l)):(l=t.traceCreation(s),k=this._createInstance(s,a,l)),l.stop(),k}_createInstance(s,a=[],l){let k=M._util.getServiceDependencies(s).sort((o,S)=>o.index-S.index),v=[];for(const o of k){let S=this._getOrCreateServiceInstance(o.id,l);if(!S&&this._strict&&!o.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${o.id}.`);v.push(S)}let b=k.length>0?k[0].index:a.length;if(a.length!==b){console.warn(`[createInstance] First service dependency of ${s.name} at position ${b+1} conflicts with ${a.length} static arguments`);let o=b-a.length;o>0?a=a.concat(new Array(o)):a=a.slice(0,b)}return new s(...[...a,...v])}_setServiceInstance(s,a){if(this._services.get(s)instanceof _.SyncDescriptor)this._services.set(s,a);else if(this._parent)this._parent._setServiceInstance(s,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let a=this._services.get(s);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):a}_getOrCreateServiceInstance(s,a){let l=this._getServiceInstanceOrDescriptor(s);return l instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,l,a.branch(s,!0)):(a.branch(s,!1),l)}_safeCreateAndCacheServiceInstance(s,a,l){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,a,l)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,a,l){const k=new D.Graph(o=>o.id.toString());let v=0;const b=[{id:s,desc:a,_trace:l}];for(;b.length;){const o=b.pop();if(k.lookupOrInsertNode(o),v++>1e3)throw new F(k);for(let S of M._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(S.id);if(!n&&!S.optional&&console.warn(`[createInstance] ${s} depends on ${S.id} which is NOT registered.`),n instanceof _.SyncDescriptor){const P={id:S.id,desc:n,_trace:o._trace.branch(S.id,!0)};k.insertEdge(o,P),b.push(P)}}}for(;;){const o=k.roots();if(o.length===0){if(!k.isEmpty())throw new F(k);break}for(const{data:S}of o){if(this._getServiceInstanceOrDescriptor(S.id)instanceof _.SyncDescriptor){const P=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,P)}k.removeNode(S)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,a,l=[],k,v){if(this._services.get(s)instanceof _.SyncDescriptor)return this._createServiceInstance(a,l,k,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,a,l,k,v);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(s,a=[],l,k){if(l){const v=new i.IdleValue(()=>this._createInstance(s,a,k));return new Proxy(Object.create(null),{get(b,o){if(o in b)return b[o];let S=v.value,n=S[o];return typeof n!="function"||(n=n.bind(S),b[o]=n),n},set(b,o,S){return v.value[o]=S,!0}})}else return this._createInstance(s,a,k)}}e.InstantiationService=O;var m;(function(u){u[u.Creation=0]="Creation",u[u.Invocation=1]="Invocation",u[u.Branch=2]="Branch"})(m||(m={}));class t{constructor(s,a){this.type=s,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return y?new t(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):t._None}static traceCreation(s){return y?new t(0,s.name):t._None}branch(s,a){let l=new t(2,s.toString());return this._dep.push([s,a,l]),l}stop(){let s=Date.now()-this._start;t._totals+=s;let a=!1;function l(v,b){let o=[],S=new Array(v+1).join("	");for(const[n,P,r]of b._dep)if(P&&r){a=!0,o.push(`${S}CREATES -> ${n}`);let c=l(v+1,r);c&&o.push(c)}else o.push(`${S}uses -> ${n}`);return o.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${t._totals.toFixed(2)}ms)`];(s>2||a)&&console.log(k.join(`
`))}}e.Trace=t,t._None=new class extends t{constructor(){super(-1,null)}stop(){}branch(){return this}},t._totals=0}),define(be[9],we([0,1,42,5,7,28,3]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function T(){return new Date().toISOString()}var y;(function(P){P[P.Trace=0]="Trace",P[P.Debug=1]="Debug",P[P.Info=2]="Info",P[P.Warning=3]="Warning",P[P.Error=4]="Error",P[P.Critical=5]="Critical",P[P.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function F(P,r,c){switch(r){case y.Trace:P.trace(c);break;case y.Debug:P.debug(c);break;case y.Info:P.info(c);break;case y.Warning:P.warn(c);break;case y.Error:P.error(c);break;case y.Critical:P.critical(c);break;default:throw new Error("Invalid log level")}}e.log=F;function O(P){let r="";for(let c=0;c<P.length;c++){let w=P[c];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}r+=(c>0?" ":"")+w}return r}e.format=O;class m extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class t extends m{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...c){this.checkLogLevel(y.Trace)&&this.log(y.Trace,O([r,...c]))}debug(r,...c){this.checkLogLevel(y.Debug)&&this.log(y.Debug,O([r,...c]))}info(r,...c){this.checkLogLevel(y.Info)&&this.log(y.Info,O([r,...c]))}warn(r,...c){this.checkLogLevel(y.Warning)&&this.log(y.Warning,O([r,...c]))}error(r,...c){if(this.checkLogLevel(y.Error))if(r instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=r.stack,this.log(y.Error,O(w))}else this.log(y.Error,O([r,...c]))}critical(r,...c){this.checkLogLevel(y.Critical)&&this.log(y.Critical,O([r,...c]))}flush(){}}e.AbstractMessageLogger=t;class u extends m{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!D.isWindows}trace(r,...c){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...c):console.log(`[main ${T()}]`,r,...c))}debug(r,...c){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...c):console.log(`[main ${T()}]`,r,...c))}info(r,...c){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...c):console.log(`[main ${T()}]`,r,...c))}warn(r,...c){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,r,...c):console.warn(`[main ${T()}]`,r,...c))}error(r,...c){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,r,...c):console.error(`[main ${T()}]`,r,...c))}critical(r,...c){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,r,...c):console.error(`[main ${T()}]`,r,...c))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class s extends m{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...c){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",r,...c)}debug(r,...c){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...c)}info(r,...c){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",r,...c)}warn(r,...c){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",r,...c)}error(r,...c){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",r,...c)}critical(r,...c){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...c)}dispose(){}flush(){}}e.ConsoleLogger=s;class a extends m{constructor(r,c=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(c)}trace(r,...c){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(r),...c])}debug(r,...c){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(r),...c])}info(r,...c){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(r),...c])}warn(r,...c){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(r),...c])}error(r,...c){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(r),...c])}critical(r,...c){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(r),...c])}extractMessage(r){return typeof r=="string"?r:(0,i.toErrorMessage)(r,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class l extends m{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const c of this.logServices)c.setLevel(r);super.setLevel(r)}trace(r,...c){for(const w of this.logServices)w.trace(r,...c)}debug(r,...c){for(const w of this.logServices)w.debug(r,...c)}info(r,...c){for(const w of this.logServices)w.info(r,...c)}warn(r,...c){for(const w of this.logServices)w.warn(r,...c)}error(r,...c){for(const w of this.logServices)w.error(r,...c)}critical(r,...c){for(const w of this.logServices)w.critical(r,...c)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=l;class k extends _.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...c){this.logger.trace(r,...c)}debug(r,...c){this.logger.debug(r,...c)}info(r,...c){this.logger.info(r,...c)}warn(r,...c){this.logger.warn(r,...c)}error(r,...c){this.logger.error(r,...c)}critical(r,...c){this.logger.critical(r,...c)}flush(){this.logger.flush()}}e.LogService=k;class v extends _.Disposable{constructor(r,c){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(c(w=>{this.logLevel=w,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(w))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,c){let w=this.loggers.get(r.toString());return w||(w=this.doCreateLogger(r,c?.always?y.Trace:this.logLevel,c),this.loggers.set(r.toString(),w),c?.always||this.logLevelChangeableLoggers.push(w)),w}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class b{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(r){}getLevel(){return y.Info}trace(r,...c){}debug(r,...c){}info(r,...c){}warn(r,...c){}error(r,...c){}critical(r,...c){}dispose(){}flush(){}}e.NullLogService=b;function o(P){if(P.verbose)return y.Trace;if(typeof P.logLevel=="string"){const r=S(P.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function S(P){switch(P){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=S;function n(P){switch(P){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=n}),define(be[75],we([0,1,33,116,3]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var M;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(M=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function F(s,a){return a-s}y.compare=F;const O=Object.create(null);O[y.Error]=(0,A.localize)(0,null),O[y.Warning]=(0,A.localize)(1,null),O[y.Info]=(0,A.localize)(2,null);function m(s){return O[s]||""}y.toString=m;function t(s){switch(s){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=t;function u(s){switch(s){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=u}(M=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(y){const F="";function O(t){return m(t,!0)}y.makeKey=O;function m(t,u){let s=[F];return t.source?s.push(t.source.replace("\xA6","\\\xA6")):s.push(F),t.code?typeof t.code=="string"?s.push(t.code.replace("\xA6","\\\xA6")):s.push(t.code.value.replace("\xA6","\\\xA6")):s.push(F),t.severity!==void 0&&t.severity!==null?s.push(M.toString(t.severity)):s.push(F),t.message&&u?s.push(t.message.replace("\xA6","\\\xA6")):s.push(F),t.startLineNumber!==void 0&&t.startLineNumber!==null?s.push(t.startLineNumber.toString()):s.push(F),t.startColumn!==void 0&&t.startColumn!==null?s.push(t.startColumn.toString()):s.push(F),t.endLineNumber!==void 0&&t.endLineNumber!==null?s.push(t.endLineNumber.toString()):s.push(F),t.endColumn!==void 0&&t.endColumn!==null?s.push(t.endColumn.toString()):s.push(F),s.push(F),s.join("\xA6")}y.makeKeyOptionalMessage=m})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(be[134],we([0,1,5,33,3]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,_.createDecorator)("notificationService");var D;(function(F){F[F.WORKSPACE=0]="WORKSPACE",F[F.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var M;(function(F){F[F.OFF=0]="OFF",F[F.SILENT=1]="SILENT",F[F.ERROR=2]="ERROR"})(M=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=T;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(be[135],we([0,1,7,14,2,3]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return i.Disposable.None},registerValidator(){return i.Disposable.None},registerExternalUriResolver(){return i.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return i.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function M(y,F){return _.URI.isUri(y)?(0,A.equalsIgnoreCase)(y.scheme,F):(0,A.startsWithIgnoreCase)(y,F+":")}e.matchesScheme=M;function T(y,...F){return F.some(O=>M(y,O))}e.matchesSomeScheme=T});var Le=this&&this.__decorate||function(Z,e,i,A){var _=arguments.length,D=_<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,i):A,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Z,e,i,A);else for(var T=Z.length-1;T>=0;T--)(M=Z[T])&&(D=(_<3?M(D):_>3?M(e,i,D):M(e,i))||D);return _>3&&D&&Object.defineProperty(e,i,D),D},Ne=this&&this.__param||function(Z,e){return function(i,A){e(i,A,Z)}};define(be[136],we([0,1,10,20,7,3]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,D.createDecorator)("progressService");var M;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(M=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(m){this.callback=m}get value(){return this._value}report(m){this._value=m,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let y=class extends _.Disposable{constructor(m,t){super();this.deferred=new i.DeferredPromise,t.withProgress(m,u=>(this.reporter=u,this.lastStep&&u.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(m){this.reporter?this.reporter.report(m):this.lastStep=m}};y=Le([Ne(1,e.IProgressService)],y),e.UnmanagedProgress=y;class F extends _.Disposable{constructor(m){super();this.progressIndicator=m,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(m){this.stop();const t=++this.currentOperationId,u=new A.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{t===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},m),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>u.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:t,token:u.token,stop:()=>this.doStop(t),isCurrent:()=>this.currentOperationId===t}}stop(){this.doStop(this.currentOperationId)}doStop(m){this.currentOperationId===m&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=F,e.IEditorProgressService=(0,D.createDecorator)("editorProgressService")}),define(be[35],we([0,1,41,13]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(M,T){i.ok(A.isString(M)),i.ok(A.isObject(T)),i.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,T)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new _}),define(be[137],we([0,1,5,35]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class D{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,F){this.schemasById[_(y)]=F,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new D;A.Registry.add(e.Extensions.JSONContribution,M)}),define(be[76],we([0,1,16,5,13,113,137,35]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var F;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const O=T.Registry.as(M.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(S,n=!0){this.registerConfigurations([S],n)}registerConfigurations(S,n=!0){const P=this.doRegisterConfigurations(S,n);O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:P})}deregisterConfigurations(S){const n=this.doDeregisterConfigurations(S);O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:S,remove:n}){const P=[];P.push(...this.doDeregisterConfigurations(n)),P.push(...this.doRegisterConfigurations(S,!1)),O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,i.distinct)(P)})}registerDefaultConfigurations(S){const n=[],P=[];for(const{overrides:r,source:c}of S)for(const w in r)if(n.push(w),e.OVERRIDE_PROPERTY_REGEX.test(w)){const h={...this.configurationDefaultsOverrides.get(w)?.value||{},...r[w]};this.configurationDefaultsOverrides.set(w,{source:c,value:h});const d={type:"object",default:h,description:D.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:_.isString(c)?void 0:c};P.push(...s(w)),this.configurationProperties[w]=d,this.defaultLanguageConfigurationOverridesNode.properties[w]=d}else{this.configurationDefaultsOverrides.set(w,{value:r[w],source:c});const h=this.configurationProperties[w];h&&(this.updatePropertyDefaultValue(w,h),this.updateSchema(w,h))}this.registerOverrideIdentifiers(P),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(S){const n=[];for(const{overrides:P,source:r}of S)for(const c in P){const w=this.configurationDefaultsOverrides.get(c),h=_.isString(r)?r:r?.id,d=_.isString(w?.source)?w?.source:w?.source?.id;if(h===d)if(n.push(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const g=this.configurationProperties[c];g&&(this.updatePropertyDefaultValue(c,g),this.updateSchema(c,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const n of S)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(S,n){const P=[];return S.forEach(r=>{P.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),P}doDeregisterConfigurations(S){const n=[],P=r=>{if(r.properties)for(const c in r.properties)n.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,r.properties[c]);r.allOf&&r.allOf.forEach(c=>P(c))};for(const r of S){P(r);const c=this.configurationContributors.indexOf(r);c!==-1&&this.configurationContributors.splice(c,1)}return n}validateAndRegisterProperties(S,n=!0,P,r,c=3){c=_.isUndefinedOrNull(S.scope)?c:S.scope;let w=[],h=S.properties;if(h)for(let g in h){if(n&&v(g)){delete h[g];continue}const f=h[g];if(f.source=P,f.defaultDefaultValue=h[g].default,this.updatePropertyDefaultValue(g,f),e.OVERRIDE_PROPERTY_REGEX.test(g)?f.scope=void 0:(f.scope=_.isUndefinedOrNull(f.scope)?c:f.scope,f.restricted=_.isUndefinedOrNull(f.restricted)?!!r?.includes(g):f.restricted),h[g].hasOwnProperty("included")&&!h[g].included){this.excludedConfigurationProperties[g]=h[g],delete h[g];continue}else this.configurationProperties[g]=h[g];!h[g].deprecationMessage&&h[g].markdownDeprecationMessage&&(h[g].deprecationMessage=h[g].markdownDeprecationMessage),w.push(g)}let d=S.allOf;if(d)for(let g of d)w.push(...this.validateAndRegisterProperties(g,n,P,r,c));return w}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(S){const n=P=>{let r=P.properties;if(r)for(const w in r)this.updateSchema(w,r[w]);let c=P.allOf;c&&c.forEach(n)};n(S)}updateSchema(S,n){switch(e.allSettings.properties[S]=n,n.scope){case 1:e.applicationSettings.properties[S]=n;break;case 2:e.machineSettings.properties[S]=n;break;case 6:e.machineOverridableSettings.properties[S]=n;break;case 3:e.windowSettings.properties[S]=n;break;case 4:e.resourceSettings.properties[S]=n;break;case 5:e.resourceSettings.properties[S]=n,this.resourceLanguageSettingsSchema.properties[S]=n;break}}removeFromSchema(S,n){switch(delete e.allSettings.properties[S],n.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S],delete this.resourceLanguageSettingsSchema.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const n=`[${S}]`,P={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,P),e.allSettings.properties[n]=P,e.applicationSettings.properties[n]=P,e.machineSettings.properties[n]=P,e.machineOverridableSettings.properties[n]=P,e.windowSettings.properties[n]=P,e.resourceSettings.properties[n]=P}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const S={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,n){const P=this.configurationDefaultsOverrides.get(S);let r=P?.value,c=P?.source;_.isUndefined(r)&&(r=n.defaultDefaultValue,c=void 0),_.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=c}}const t="\\[([^\\]]+)\\]",u=new RegExp(t,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${t})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(o){const S=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let n=u.exec(o);for(;n?.length;){const P=n[1].trim();P&&S.push(P),n=u.exec(o)}}return(0,i.distinct)(S)}e.overrideIdentifiersFromKey=s;function a(o){return o.reduce((S,n)=>`${S}[${n}]`,"")}e.keyFromOverrideIdentifiers=a;function l(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const k=new m;T.Registry.add(e.Extensions.Configuration,k);function v(o){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?D.localize(7,null,o):k.getConfigurationProperties()[o]!==void 0?D.localize(8,null,o):null:D.localize(6,null)}e.validateProperty=v;function b(){const o=[],S=k.getConfigurationProperties();for(const n of Object.keys(S))o.push([n,S[n].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.getScopes=b}),define(be[138],we([0,1,16,5,97,7,22,25,13,2,74,76,35]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class u{constructor(r={},c=[],w=[]){this._contents=r,this._keys=c,this._overrides=w,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,c){const w=this.getContentsForOverrideIdentifer(c);return w?r?(0,O.getConfigurationValue)(w,r):w:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const w of this.overrides)w.identifiers.includes(r)&&c.push(...w.keys);return i.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return i.distinct(r)}override(r){let c=this.overrideConfigurations.get(r);return c||(c=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,c)),c}merge(...r){const c=T.deepClone(this.contents),w=T.deepClone(this.overrides),h=[...this.keys];for(const d of r){this.mergeContents(c,d.contents);for(const g of d.overrides){const[f]=w.filter(E=>i.equals(E.identifiers,g.identifiers));f?(this.mergeContents(f.contents,g.contents),f.keys.push(...g.keys),f.keys=i.distinct(f.keys)):w.push(T.deepClone(g))}for(const g of d.keys)h.indexOf(g)===-1&&h.push(g)}return new u(c,h,w)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const c=this.getContentsForOverrideIdentifer(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;let w={};for(const h of i.distinct([...Object.keys(this.contents),...Object.keys(c)])){let d=this.contents[h],g=c[h];g&&(typeof d=="object"&&typeof g=="object"?(d=T.deepClone(d),this.mergeContents(d,g)):d=g),w[h]=d}return new u(w,this.keys,this.overrides)}mergeContents(r,c){for(const w of Object.keys(c)){if(w in r&&y.isObject(r[w])&&y.isObject(c[w])){this.mergeContents(r[w],c[w]);continue}r[w]=T.deepClone(c[w])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?T.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let c=null,w=null;const h=d=>{d&&(w?this.mergeContents(w,d):w=T.deepClone(d))};for(const d of this.overrides)i.equals(d.identifiers,[r])?c=d.contents:d.identifiers.includes(r)&&h(d.contents);return h(c),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,c){this.addKey(r),(0,O.addToValueTree)(this.contents,r,c,w=>{throw new Error(w)})}removeValue(r){this.removeKey(r)&&(0,O.removeFromValueTree)(this.contents,r)}addKey(r){let c=this.keys.length;for(let w=0;w<c;w++)r.indexOf(this.keys[w])===0&&(c=w);this.keys.splice(c,1,r)}removeKey(r){let c=this.keys.indexOf(r);return c!==-1?(this.keys.splice(c,1),!0):!1}}e.ConfigurationModel=u;class s extends u{constructor(r={}){const c=t.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),w=Object.keys(c),h=Object.create(null),d=[];for(const g in c){const f=r[g],E=f!==void 0?f:c[g].default;(0,O.addToValueTree)(h,g,E,C=>console.error(`Conflict in default settings: ${C}`))}for(const g of Object.keys(h))m.OVERRIDE_PROPERTY_REGEX.test(g)&&d.push({identifiers:(0,m.overrideIdentifiersFromKey)(g),keys:Object.keys(h[g]),contents:(0,O.toValuesTree)(h[g],f=>console.error(`Conflict in default settings file: ${f}`))});super(h,w,d)}}e.DefaultConfigurationModel=s;class a{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,c){if(!y.isUndefinedOrNull(r)){const w=this.doParseContent(r);this.parseRaw(w,c)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,c){this._raw=r;const{contents:w,keys:h,overrides:d,restricted:g}=this.doParseRaw(r,c);this._configurationModel=new u(w,h,d),this._restrictedConfigurations=g||[]}doParseContent(r){let c={},w=null,h=[],d=[],g=[];function f(C){Array.isArray(h)?h.push(C):w!==null&&(h[w]=C)}let E={onObjectBegin:()=>{let C={};f(C),d.push(h),h=C,w=null},onObjectProperty:C=>{w=C},onObjectEnd:()=>{h=d.pop()},onArrayBegin:()=>{let C=[];f(C),d.push(h),h=C,w=null},onArrayEnd:()=>{h=d.pop()},onLiteralValue:f,onError:(C,I,N)=>{g.push({error:C,offset:I,length:N})}};if(r)try{_.visit(r,E),c=h[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return c}doParseRaw(r,c){const w=t.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,w,!0,c);r=h.raw;const d=(0,O.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),g=Object.keys(r),f=this.toOverrides(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:d,keys:g,overrides:f,restricted:h.restricted}}filter(r,c,w,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:r,restricted:[]};const d={},g=[];for(let f in r)if(m.OVERRIDE_PROPERTY_REGEX.test(f)&&w){const E=this.filter(r[f],c,!1,h);d[f]=E.raw,g.push(...E.restricted)}else{const E=c[f],C=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&g.push(f),(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&(h.skipRestricted&&E?.restricted||(d[f]=r[f]))}return{raw:d,restricted:g}}toOverrides(r,c){const w=[];for(const h of Object.keys(r))if(m.OVERRIDE_PROPERTY_REGEX.test(h)){const d={};for(const g in r[h])d[g]=r[h][g];w.push({identifiers:(0,m.overrideIdentifiersFromKey)(h),keys:Object.keys(d),contents:(0,O.toValuesTree)(d,c)})}return w}}e.ConfigurationModelParser=a;class l extends D.Disposable{constructor(r,c,w,h){super();this.userSettingsResource=r,this.scopes=c,this.fileService=h,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(w.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new u}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=l;class k{constructor(r,c,w=new u,h=new u,d=new M.ResourceMap,g=new u,f=new M.ResourceMap,E=!0){this._defaultConfiguration=r,this._localUserConfiguration=c,this._remoteUserConfiguration=w,this._workspaceConfiguration=h,this._folderConfigurations=d,this._memoryConfiguration=g,this._memoryConfigurationByResource=f,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(r,c,w){return this.getConsolidateConfigurationModel(c,w).getValue(r)}updateValue(r,c,w={}){let h;w.resource?(h=this._memoryConfigurationByResource.get(w.resource),h||(h=new u,this._memoryConfigurationByResource.set(w.resource,h))):h=this._memoryConfiguration,c===void 0?h.removeValue(r):h.setValue(r,c),w.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,c,w){const h=this.getConsolidateConfigurationModel(c,w),d=this.getFolderConfigurationModelForResource(c.resource,w),g=c.resource?this._memoryConfigurationByResource.get(c.resource)||this._memoryConfiguration:this._memoryConfiguration,f=c.overrideIdentifier?this._defaultConfiguration.freeze().override(c.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),E=c.overrideIdentifier?this.userConfiguration.freeze().override(c.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),C=c.overrideIdentifier?this.localUserConfiguration.freeze().override(c.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),I=c.overrideIdentifier?this.remoteUserConfiguration.freeze().override(c.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=w?c.overrideIdentifier?this._workspaceConfiguration.freeze().override(c.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,p=d?c.overrideIdentifier?d.freeze().override(c.overrideIdentifier).getValue(r):d.freeze().getValue(r):void 0,R=c.overrideIdentifier?g.override(c.overrideIdentifier).getValue(r):g.getValue(r),x=h.getValue(r),j=i.distinct(i.flatten(h.overrides.map(H=>H.identifiers))).filter(H=>h.getOverrideValue(r,H)!==void 0);return{defaultValue:f,userValue:E,userLocalValue:C,userRemoteValue:I,workspaceValue:N,workspaceFolderValue:p,memoryValue:R,value:x,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:c.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,c.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:c.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,c.overrideIdentifier):void 0}:void 0,userLocal:C!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:c.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,c.overrideIdentifier):void 0}:void 0,userRemote:I!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:c.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,c.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:c.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,c.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:d?.freeze().getValue(r),override:c.overrideIdentifier?d?.freeze().getOverrideValue(r,c.overrideIdentifier):void 0}:void 0,memory:R!==void 0?{value:g.getValue(r),override:c.overrideIdentifier?g.getOverrideValue(r,c.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(r){const c=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:c?c.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,c){this._folderConfigurations.set(r,c),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const w=[];if(!c){const{added:h,updated:d,removed:g}=S(this._defaultConfiguration,r);c=[...h,...d,...g]}for(const h of c)for(const d of(0,m.overrideIdentifiersFromKey)(h)){const g=this._defaultConfiguration.getKeysForOverrideIdentifier(d),f=r.getKeysForOverrideIdentifier(d),E=[...f.filter(C=>g.indexOf(C)===-1),...g.filter(C=>f.indexOf(C)===-1),...g.filter(C=>!T.equals(this._defaultConfiguration.override(d).getValue(C),r.override(d).getValue(C)))];w.push([d,E])}return this.updateDefaultConfiguration(r),{keys:c,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:w,removed:h,overrides:d}=S(this.localUserConfiguration,r),g=[...c,...w,...h];return g.length&&this.updateLocalUserConfiguration(r),{keys:g,overrides:d}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:w,removed:h,overrides:d}=S(this.remoteUserConfiguration,r);let g=[...c,...w,...h];return g.length&&this.updateRemoteUserConfiguration(r),{keys:g,overrides:d}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:w,removed:h,overrides:d}=S(this.workspaceConfiguration,r);let g=[...c,...w,...h];return g.length&&this.updateWorkspaceConfiguration(r),{keys:g,overrides:d}}compareAndUpdateFolderConfiguration(r,c){const w=this.folderConfigurations.get(r),{added:h,updated:d,removed:g,overrides:f}=S(w,c);let E=[...h,...d,...g];return(E.length||!w)&&this.updateFolderConfiguration(r,c),{keys:E,overrides:f}}compareAndDeleteFolderConfiguration(r){const c=this.folderConfigurations.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:w,updated:h,removed:d,overrides:g}=S(c,void 0);return{keys:[...w,...h,...d],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,c){let w=this.getConsolidatedConfigurationModelForResource(r,c);return r.overrideIdentifier?w.override(r.overrideIdentifier):w}getConsolidatedConfigurationModelForResource({resource:r},c){let w=this.getWorkspaceConsolidatedConfiguration();if(c&&r){const h=c.getFolder(r);h&&(w=this.getFolderConsolidatedConfiguration(h.uri)||w);const d=this._memoryConfigurationByResource.get(r);d&&(w=w.merge(d))}return w}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let c=this._foldersConsolidatedConfigurations.get(r);if(!c){const w=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(c=w.merge(h),this._freeze&&(c=c.freeze()),this._foldersConsolidatedConfigurations.set(r,c)):c=w}return c}getFolderConfigurationModelForResource(r,c){if(c&&r){const w=c.getFolder(r);if(w)return this._folderConfigurations.get(w.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,c)=>{const{contents:w,overrides:h,keys:d}=this._folderConfigurations.get(c);return r.push([c,{contents:w,overrides:h,keys:d}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(c=>r.add(c)),this.userConfiguration.freeze().keys.forEach(c=>r.add(c)),this._workspaceConfiguration.freeze().keys.forEach(c=>r.add(c)),this._folderConfigurations.forEach(c=>c.freeze().keys.forEach(w=>r.add(w))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c)),this._folderConfigurations.forEach(c=>c.freeze().getAllOverrideIdentifiers().forEach(w=>r.add(w))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const c=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(w=>c.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(w=>c.add(w)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(w=>c.add(w)),this._folderConfigurations.forEach(w=>w.getKeysForOverrideIdentifier(r).forEach(h=>c.add(h))),[...c.values()]}static parse(r){const c=this.parseConfigurationModel(r.defaults),w=this.parseConfigurationModel(r.user),h=this.parseConfigurationModel(r.workspace),d=r.folders.reduce((g,f)=>(g.set(F.URI.revive(f[0]),this.parseConfigurationModel(f[1])),g),new M.ResourceMap);return new k(c,w,new u,h,d,new u,new M.ResourceMap,!1)}static parseConfigurationModel(r){return new u(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=k;function v(...P){if(P.length===0)return{keys:[],overrides:[]};if(P.length===1)return P[0];const r=new Set,c=new Map;for(const h of P)h.keys.forEach(d=>r.add(d)),h.overrides.forEach(([d,g])=>{const f=(0,M.getOrSet)(c,d,new Set);g.forEach(E=>f.add(E))});const w=[];return c.forEach((h,d)=>w.push([d,[...h.values()]])),{keys:[...r.values()],overrides:w}}e.mergeChanges=v;class b{constructor(r,c,w,h){this.change=r,this.previous=c,this.currentConfiguraiton=w,this.currentWorkspace=h,this._previousConfiguration=void 0;const d=new Set;r.keys.forEach(f=>d.add(f)),r.overrides.forEach(([,f])=>f.forEach(E=>d.add(E))),this.affectedKeys=[...d.values()];const g=new u;this.affectedKeys.forEach(f=>g.setValue(f,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,c){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(c){const w=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,c,this.currentWorkspace);return!T.equals(w,h)}return!0}return!1}doesAffectedKeysTreeContains(r,c){let w=(0,O.toValuesTree)({[c]:!0},()=>{}),h;for(;typeof w=="object"&&(h=Object.keys(w)[0]);){if(r=r[h],!r)return!1;w=w[h]}return!0}}e.ConfigurationChangeEvent=b;class o extends b{constructor(r,c,w,h){super({keys:r.allKeys(),overrides:[]},void 0,r,c);this.source=w,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=o;function S(P,r){const{added:c,removed:w,updated:h}=n(r,P),d=[],g=P?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const E=f.filter(C=>!g.includes(C));for(const C of E)d.push([C,r.getKeysForOverrideIdentifier(C)])}if(P){const E=g.filter(C=>!f.includes(C));for(const C of E)d.push([C,P.getKeysForOverrideIdentifier(C)])}if(r&&P){for(const E of g)if(f.includes(E)){const C=n({contents:P.getOverrideValue(void 0,E)||{},keys:P.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});d.push([E,[...C.added,...C.removed,...C.updated]])}}return{added:c,removed:w,updated:h,overrides:d}}function n(P,r){const c=P?r?P.keys.filter(d=>r.keys.indexOf(d)===-1):[...P.keys]:[],w=r?P?r.keys.filter(d=>P.keys.indexOf(d)===-1):[...r.keys]:[],h=[];if(P&&r){for(const d of r.keys)if(P.keys.indexOf(d)!==-1){const g=(0,O.getConfigurationValue)(r.contents,d),f=(0,O.getConfigurationValue)(P.contents,d);T.equals(g,f)||h.push(d)}}return{added:c,removed:w,updated:h}}}),define(be[77],we([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var A;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(M,T=A.Unknown,y){super(M);this._message=M,this._code=T,this._detail=y,this.isHandled=T===A.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(M){return M instanceof _&&M._code===A.TemporarilyNotAvailable}static isNoResolverFound(M){return M instanceof _&&M._code===A.NoResolverFound}static isHandled(M){return M instanceof _&&M.isHandled}}e.RemoteAuthorityResolverError=_}),define(be[78],we([0,1,11]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function A(D){return D.scheme===i.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=A;function _(D){if(!D)return;const M=D.indexOf("+");return M<0?D:D.substr(0,M)}e.getRemoteName=_}),define(be[23],we([0,1,14,3,78]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=D;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,s){if(typeof u=="undefined"||u===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof u=="string"||typeof s=="string"){let a=typeof u=="string"?u:u.value,l=typeof s=="string"?s:s.value;return i.equalsIgnoreCase(a,l)}return u._lower===s._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=y;function F(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=F;function O(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=O;function m(t,u){if(u){const s=`onResolveRemoteAuthority:${(0,_.getRemoteName)(u)}`;return t.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[139],we([0,1,14,23]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(s,a){return s.uuid&&a.uuid?s.uuid===a.uuid:s.id===a.id?!0:(0,i.compareIgnoreCase)(s.id,a.id)===0}e.areSameExtensions=_;class D{constructor(a,l){this.version=l,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof D?_(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=D;function M(s,a){return`${s}.${a}`}e.getExtensionId=M;function T(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function y(s,a){return T(M(s,a))}e.getGalleryExtensionId=y;function F(s,a){const l=[],k=v=>{for(const b of l)if(b.some(o=>_(a(o),a(v))))return b;return null};for(const v of s){const b=k(v);b?b.push(v):l.push([v])}return l}e.groupByExtension=F;function O(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=O;function m(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function t(s){const a=new Set;if(s.malicious)for(const l of s.malicious)a.add(l.id);return a}e.getMaliciousExtensionsSet=t;function u(s,a){const l=[],k=a.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const v=k.shift();if(v&&l.every(b=>!_(b.identifier,{id:v}))){const b=s.filter(o=>_(o.identifier,{id:v}));b.length===1&&(l.push(b[0]),k.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=u}),define(be[140],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,D,M=5){let T;return T=D(y=>{const F=typeof y=="string"?y:y.data;let O=this._terminalBufferMap.get(_);if(O){O.data.push(F);return}const m=setTimeout(()=>this.flushBuffer(_),M);O={data:[F],timeoutId:m,dispose:()=>{clearTimeout(m),this.flushBuffer(_),T.dispose()}},this._terminalBufferMap.set(_,O)}),T}stopBuffering(_){const D=this._terminalBufferMap.get(_);D&&D.dispose()}flushBuffer(_){const D=this._terminalBufferMap.get(_);D&&(this._terminalBufferMap.delete(_),this._callback(_,D.data.join("")))}}e.TerminalDataBufferer=i}),define(be[141],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var i;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(i=e.ColorScheme||(e.ColorScheme={}))}),define(be[55],we([0,1,102,5,7,3,35,141]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var y;(function(l){function k(v){return v&&typeof v=="object"&&typeof v.id=="string"}l.isThemeColor=k})(y=e.ThemeColor||(e.ThemeColor={}));function F(l){return{id:l}}e.themeColorFromId=F;var O;(function(l){function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color=="undefined"||y.isThemeColor(c.color))}l.isThemeIcon=k;const v=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function b(c){const w=v.exec(c);if(!w)return;let[,h]=w;return{id:h}}l.fromString=b;function o(c){return{id:c}}l.fromId=o;function S(c,w){let h=c.id;const d=h.lastIndexOf("~");return d!==-1&&(h=h.substring(0,d)),w&&(h=`${h}~${w}`),{id:h}}l.modify=S;function n(c){const w=c.id.lastIndexOf("~");if(w!==-1)return c.id.substring(w+1)}l.getModifier=n;function P(c,w){return c.id===w.id&&c.color?.id===w.color?.id}l.isEqual=P;function r(c,w){return{id:c.id,color:w?F(w):void 0}}l.asThemeIcon=r,l.asClassNameArray=i.CSSIcon.asClassNameArray,l.asClassName=i.CSSIcon.asClassName,l.asCSSSelector=i.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function m(l){switch(l){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=m,e.Extensions={ThemingContribution:"base.contributions.theming"};class t{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,_.toDisposable)(()=>{const v=this.themingParticipants.indexOf(k);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let u=new t;M.Registry.add(e.Extensions.ThemingContribution,u);function s(l){return u.onColorThemeChange(l)}e.registerThemingParticipant=s;class a extends _.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,v){let b=this.theme.getColor(k);return b&&v&&(b=v(b,this.theme)),b?b.toString():null}}e.Themable=a}),define(be[142],we([0,1,5,28,3,9]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var M;(function(s){s.Http="http",s.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function F(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=F,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=m;function t(s,a){return a?a!==1&&s<1024:!A.isWindows&&s<1024}e.isPortPrivileged=t;let u=class{constructor(a){this.logService=a,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(a){return this._tunnelProvider=a,a?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this._canElevate=a.elevation,this._privacyOptions=a.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const a=[],l=Array.from(this._tunnels.values());for(let k of l){const v=Array.from(k.values());for(let b of v){const o=await b.value;o&&a.push(o)}}return a}async dispose(){for(const a of this._tunnels.values()){for(const{value:l}of a.values())await l.then(k=>k?.dispose());a.clear()}this._tunnels.clear()}openTunnel(a,l,k,v,b=!1,o=T.Private,S){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${k} on local port ${v}.`),!a)return;l||(l="localhost");const n=this.retainOrCreateTunnel(a,l,k,v,b,o,S);return n?n.then(P=>{if(!P){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(l,k);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(P);return(P.tunnelRemoteHost!==l||P.tunnelRemotePort!==k)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const l=this._tunnels.get(a.tunnelRemoteHost);if(l){const k=l.get(a.tunnelRemotePort);k&&(k.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,k))}}}}async tryDisposeTunnel(a,l,k){if(k.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${l}.`);const v=k.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(l),v}}async closeTunnel(a,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${l} `);const k=this._tunnels.get(a);if(k&&k.has(l)){const v=k.get(l);v.refcount=0,await this.tryDisposeTunnel(a,l,v)}}addTunnelToMap(a,l,k){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(l,{refcount:1,value:k})}async removeEmptyTunnelFromMap(a,l){const k=this._tunnels.get(a);k&&(await k.get(l)||k.delete(l),k.size===0&&this._tunnels.delete(a))}getTunnelFromMap(a,l){let k=[a];O(a)?(k.push(...e.LOCALHOST_ADDRESSES),k.push(...e.ALL_INTERFACES_ADDRESSES)):m(a)&&k.push(...e.ALL_INTERFACES_ADDRESSES);const v=k.map(b=>this._tunnels.get(b));for(const b of v){const o=b?.get(l);if(o)return o}}canTunnel(a){return!!F(a)}createWithProvider(a,l,k,v,b,o,S){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${k} on local port ${v}.`);const P={elevationRequired:b?t(v===void 0?k:v):!1},r={remoteAddress:{host:l,port:k},localAddressPort:v,privacy:o,public:o!==T.Private,protocol:S},c=a.forwardPort(r,P);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),c&&this.addTunnelToMap(l,k,c),c}};u=Le([Ne(0,D.ILogService)],u),e.AbstractTunnelService=u}),define(be[143],we([0,1,11]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(T){return T.scheme!==i.Schemas.file&&T.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=A;function _(T){if(T.folders.length)return T.folders.every(y=>A(y.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=_;function D(T){return _(T)?.scheme}e.getVirtualWorkspaceScheme=D;function M(T){return _(T)!==void 0}e.isVirtualWorkspace=M}),define(be[46],we([0,1,22,24,2,3]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var M;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function T(t){const u=t;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=T;function y(t){const u=t;return!!(u&&typeof u=="object"&&_.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=y;class F{constructor(u,s,a,l,k){this._id=u,this._transient=a,this._configuration=l,this._ignorePathCasing=k,this._foldersMap=i.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(u){this._id=u.id,this._configuration=u.configuration,this._transient=u.transient,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u.with({scheme:u.scheme,authority:u.authority,path:u.path}))||null}updateFoldersMap(){this._foldersMap=i.TernarySearchTree.forUris(this._ignorePathCasing);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=F;class O{constructor(u,s){this.raw=s,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,A.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=O;function m(t){return new O({uri:t,index:0,name:(0,A.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=m}),define(be[56],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const D=this._idPool++;return this._data.set(D,_),this.logDebugInfo(),D}get(_,D){return this._data.has(_)?this._data.get(_)[D]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!i.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=i,i.enableDebugLogging=!1}),define(be[29],we([0,1,11,24,3]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(i.Schemas)),this._providerInfo=new Map,this.extUri=new A.ExtUri(T=>{const y=this._providerInfo.get(T.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(T,y){y===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,y)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(be[144],we([0,1,10]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(M,T,y){this._deferredPromises=new Map,this._id=M,this._shared=T,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(F=>(this._value=F,this)),this._storageListener=this._storage.onDidChangeStorage(F=>{F.shared===this._shared&&F.key===this._id&&(this._value=F.value)}),this._scheduler=new i.RunOnceScheduler(()=>{const F=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of F.values())O.complete()}catch(O){for(const m of F.values())m.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this._init}get(M,T){let y=this._value[M];return typeof y=="undefined"&&(y=T),y}update(M,T){this._value[M]=T;let y=this._deferredPromises.get(M);if(y!==void 0)return y.p;const F=new i.DeferredPromise;return this._deferredPromises.set(M,F),this._scheduler.isScheduled()||this._scheduler.schedule(),F.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=A;class _ extends A{constructor(M,T){super(M.identifier.value,!0,T);this._extension=M}setKeysForSync(M){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},M)}}e.ExtensionGlobalMemento=_}),define(be[145],we([0,1,5,2,9]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let D=class{constructor(T,y){this._logService=T,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new i.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new i.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,y,F){this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T)).acceptModelChanged(y.value,F)}$acceptDirtyStateChanged(T,y){this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T)).acceptDirty(y)}$acceptModelSaved(T){const y=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(T,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,y);const F=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T));F.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:F.apiNotebook})}};D=Le([Ne(0,_.ILogService)],D),e.ExtHostNotebookDocuments=D}),define(be[12],we([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class A{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=A});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[146],we([0,1,23,5]),function(Z,e,i,A){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class D{constructor(T,y){_.set(this,void 0),this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._id=i.ExtensionIdentifier.toKey(T.identifier),Ge(this,_,y,"f"),De(this,_,"f").onDidChangePassword(F=>{F.extensionId===this._id&&this._onDidChange.fire({key:F.key})})}get(T){return De(this,_,"f").get(this._id,T)}store(T,y){return De(this,_,"f").store(this._id,T,y)}delete(T){return De(this,_,"f").delete(this._id,T)}}e.ExtensionSecrets=D,_=new WeakMap}),define(be[79],we([0,1,3,5]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new A.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new A.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(M){this._level=M}$onDidChangeTelemetryLevel(M){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=M,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(be[47],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var i;(function(v){v[v.Upsert=0]="Upsert",v[v.RemoveChild=1]="RemoveChild",v[v.Invalidated=2]="Invalidated",v[v.SetProp=3]="SetProp",v[v.Bulk=4]="Bulk"})(i=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const A=new WeakMap,_=(v,b)=>{const o={controllerId:b};return A.set(v,o),o};e.createPrivateApiFor=_;const D=v=>A.get(v);e.getPrivateApiFor=D;const M=(v,b,o,S)=>{let n=o;return{enumerable:!0,configurable:!1,get(){return n},set(P){if(!S(n,P)){const r=n;n=P,v.listener?.({op:3,key:b,value:P,previous:r})}}}},T=(v,b)=>v===b,y={range:(v,b)=>v===b?!0:!v||!b?!1:v.isEqual(b),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(v,b)=>!(v.length!==b.length||v.some(o=>!b.find(S=>o.id===S.id)))},F=Object.keys(y),O=(v,b)=>({range:M(v,"range",void 0,y.range),label:M(v,"label",b,y.label),description:M(v,"description",void 0,y.description),canResolveChildren:M(v,"canResolveChildren",!1,y.canResolveChildren),busy:M(v,"busy",!1,y.busy),error:M(v,"error",void 0,y.error),tags:M(v,"tags",[],y.tags)}),m=(v,b)=>{const o=new Map;for(const S of F)y[S](v[S],b[S])||o.set(S,b[S]);return o};e.diffTestItems=m;class t extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=t;class u extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=u;class s extends Error{constructor(b,o,S){super(`TestItem with ID "${b}" is from controller "${o}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=s;const a=v=>{const b=(0,e.getPrivateApiFor)(v);let o=new Map;return{get size(){return o.size},forEach(S,n){for(const P of o.values())S.call(n,P,this)},replace(S){const n=new Map,P=new Set(o.keys()),r={op:4,ops:[]};for(const c of S){if(!(c instanceof l))throw new u(c.id);const w=(0,e.getPrivateApiFor)(c).controllerId;if(w!==b.controllerId)throw new s(c.id,w,b.controllerId);if(n.has(c.id))throw new t(c.id);n.set(c.id,c),P.delete(c.id),r.ops.push({op:0,item:c})}for(const c of P.keys())r.ops.push({op:1,id:c});b.listener?.(r),o=n},add(S){if(!(S instanceof l))throw new u(S.id);o.set(S.id,S),b.listener?.({op:0,item:S})},delete(S){o.delete(S)&&b.listener?.({op:1,id:S})},get(S){return o.get(S)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class l{constructor(b,o,S,n){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const P=(0,e.createPrivateApiFor)(this,b);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return P.parent instanceof k?void 0:P.parent}},children:{value:a(this),enumerable:!0,writable:!1},...O(P,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=l;class k extends l{constructor(b,o){super(b,b,o,void 0)}}e.TestItemRootImpl=k}),define(be[57],we([0,1,3,142,5,12]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var M;(function(y){function F(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:m.protocol}}y.fromApiTunnel=F;function O(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==A.TunnelPrivacyId.ConstantPrivate&&m.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}y.fromServiceTunnel=O})(M=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let T=class{constructor(F){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(F){return F}async openTunnel(F,O){}async getTunnels(){return[]}async setTunnelFactory(F){return{dispose:()=>{}}}registerPortsAttributesProvider(F,O){return{dispose:()=>{}}}async $providePortAttributes(F,O,m,t,u){return[]}async $forwardPort(F,O){}async $closeTunnel(F){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Le([Ne(0,D.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[6],we([0,1,16,15,69,22,68,14,13,2,34,45,77]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";var u,s,a,l,k,v,b,o,S,n,P,r,c,w,h,d,g,f,E,C;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let N=k=class{constructor(L){u.set(this,void 0),Ge(this,u,L,"f")}static from(...L){let J=L;return new k(function(){if(J){for(const Ee of J)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();J=void 0}})}dispose(){typeof De(this,u,"f")=="function"&&(De(this,u,"f").call(this),Ge(this,u,void 0,"f"))}};u=new WeakMap,N=k=Le([I],N),e.Disposable=N;let p=v=class{constructor(L,J){if(L<0)throw(0,A.illegalArgument)("line must be non-negative");if(J<0)throw(0,A.illegalArgument)("character must be non-negative");this._line=L,this._character=J}static Min(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let Ee=1;Ee<L.length;Ee++){const We=L[Ee];We.isBefore(J)&&(J=We)}return J}static Max(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let Ee=1;Ee<L.length;Ee++){const We=L[Ee];We.isAfter(J)&&(J=We)}return J}static isPosition(L){if(!L)return!1;if(L instanceof v)return!0;let{line:J,character:Ee}=L;return typeof J=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,J=0){if(L===null||J===null)throw(0,A.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,J=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&J===0?this:new v(this.line+Ee,this.character+J)}with(L,J=this.character){if(L===null||J===null)throw(0,A.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,J=typeof L.character=="number"?L.character:this.character),Ee===this.line&&J===this.character?this:new v(Ee,J)}toJSON(){return{line:this.line,character:this.character}}};p=v=Le([I],p),e.Position=p;let R=b=class{constructor(L,J,Ee,We){let Ye,ot;if(typeof L=="number"&&typeof J=="number"&&typeof Ee=="number"&&typeof We=="number"?(Ye=new p(L,J),ot=new p(Ee,We)):L instanceof p&&J instanceof p&&(Ye=L,ot=J),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this._start=Ye,this._end=ot):(this._start=ot,this._end=Ye)}static isRange(L){return L instanceof b?!0:L?p.isPosition(L.start)&&p.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof b?this.contains(L._start)&&this.contains(L._end):L instanceof p?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const J=p.Max(L.start,this._start),Ee=p.Min(L.end,this._end);if(!J.isAfter(Ee))return new b(J,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const J=p.Min(L.start,this._start),Ee=p.Max(L.end,this.end);return new b(J,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,J=this.end){if(L===null||J===null)throw(0,A.illegalArgument)();let Ee;return L?p.isPosition(L)?Ee=L:(Ee=L.start||this.start,J=L.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&J.isEqual(this.end)?this:new b(Ee,J)}toJSON(){return[this.start,this.end]}};R=b=Le([I],R),e.Range=R;let x=o=class extends R{constructor(L,J,Ee,We){let Ye,ot;if(typeof L=="number"&&typeof J=="number"&&typeof Ee=="number"&&typeof We=="number"?(Ye=new p(L,J),ot=new p(Ee,We)):L instanceof p&&J instanceof p&&(Ye=L,ot=J),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot);this._anchor=Ye,this._active=ot}static isSelection(L){return L instanceof o?!0:L?R.isRange(L)&&p.isPosition(L.anchor)&&p.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=o=Le([I],x),e.Selection=x;class j{constructor(L,J,Ee){if(typeof L!="string"||L.length===0)throw(0,A.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,A.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,A.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(J),this.connectionToken=Ee}}e.ResolvedAuthority=j;class H extends Error{constructor(L,J=t.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L);this._message=L,this._code=J,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(L,J){return new H(L,t.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(L){return new H(L,t.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var z;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var K;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(K=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ce=S=class{constructor(L,J){this._range=L,this._newText=J}static isTextEdit(L){return L instanceof S?!0:L?R.isRange(L)&&typeof L.newText=="string":!1}static replace(L,J){return new S(L,J)}static insert(L,J){return S.replace(new R(L,L),J)}static delete(L){return S.replace(L,"")}static setEndOfLine(L){const J=new S(new R(new p(0,0),new p(0,0)),"");return J.newEol=L,J}get range(){return this._range}set range(L){if(L&&!R.isRange(L))throw(0,A.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,A.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,A.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ce=S=Le([I],ce),e.TextEdit=ce;var fe;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(fe=e.FileEditType||(e.FileEditType={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,J,Ee,We){this._edits.push({_type:1,from:L,to:J,options:Ee,metadata:We})}createFile(L,J,Ee){this._edits.push({_type:1,from:void 0,to:L,options:J,metadata:Ee})}deleteFile(L,J,Ee){this._edits.push({_type:1,from:L,to:void 0,options:J,metadata:Ee})}replaceNotebookMetadata(L,J,Ee){this._edits.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(L,J,Ee,We,Ye){let ot,ct,It=[],Ft;if(Wt.isNotebookRange(J)&&$t.isNotebookCellDataArray(Ee)&&!$t.isNotebookCellDataArray(We)?(ot=J.start,ct=J.end,It=Ee,Ft=We):typeof J=="number"&&typeof Ee=="number"&&$t.isNotebookCellDataArray(We)&&(ot=J,ct=Ee,It=We,Ft=Ye),ot===void 0||ct===void 0)throw new Error("Invalid arguments");(ot!==ct||It.length>0)&&this._edits.push({_type:5,uri:L,index:ot,count:ct-ot,cells:It,metadata:Ft})}replaceNotebookCellMetadata(L,J,Ee,We){this._edits.push({_type:3,metadata:We,uri:L,edit:{editType:8,index:J,metadata:Ee}})}replace(L,J,Ee,We){this._edits.push({_type:2,uri:L,edit:new ce(J,Ee),metadata:We})}insert(L,J,Ee,We){this.replace(L,new R(J,J),Ee,We)}delete(L,J,Ee){this.replace(L,J,"",Ee)}has(L){return this._edits.some(J=>J._type===2&&J.uri.toString()===L.toString())}set(L,J){if(J)for(const Ee of J)Ee&&this._edits.push({_type:2,uri:L,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const We=this._edits[Ee];We._type===2&&We.uri.toString()===L.toString()&&(this._edits[Ee]=void 0)}(0,i.coalesceInPlace)(this._edits)}}get(L){const J=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===L.toString()&&J.push(Ee.edit);return J}entries(){const L=new D.ResourceMap;for(let J of this._edits)if(J._type===2){let Ee=L.get(J.uri);Ee||(Ee=[J.uri,[]],L.set(J.uri,Ee)),Ee[1].push(J.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};re=Le([I],re),e.WorkspaceEdit=re;let ge=n=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof n?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=n._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,J=this._tabstop++){if(typeof L=="function"){const Ee=new n;Ee._tabstop=this._tabstop,L(Ee),this._tabstop=Ee._tabstop,L=Ee.value}else L=n._escape(L);return this.value+="${",this.value+=J,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,J=this._tabstop++){const Ee=L.map(We=>We.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,J){if(typeof J=="function"){const Ee=new n;Ee._tabstop=this._tabstop,J(Ee),this._tabstop=Ee._tabstop,J=Ee.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,J&&(this.value+=":",this.value+=J),this.value+="}",this}};ge=n=Le([I],ge),e.SnippetString=ge;var ye;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ye=e.DiagnosticTag||(e.DiagnosticTag={}));var ve;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ve=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Me=P=class{constructor(L,J){if(this.uri=L,J)if(J instanceof R)this.range=J;else if(J instanceof p)this.range=new R(J,J);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof P?!0:L?R.isRange(L.range)&&F.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Me=P=Le([I],Me),e.Location=Me;let je=class{constructor(L,J){this.location=L,this.message=J}static is(L){return L?typeof L.message=="string"&&L.location&&R.isRange(L.location.range)&&F.URI.isUri(L.location.uri):!1}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.location.range.isEqual(J.location.range)&&L.location.uri.toString()===J.location.uri.toString()}};je=Le([I],je),e.DiagnosticRelatedInformation=je;let et=class{constructor(L,J,Ee=ve.Error){if(!R.isRange(L))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=L,this.message=J,this.severity=Ee}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.severity===J.severity&&L.code===J.code&&L.severity===J.severity&&L.source===J.source&&L.range.isEqual(J.range)&&(0,i.equals)(L.tags,J.tags)&&(0,i.equals)(L.relatedInformation,J.relatedInformation,je.isEqual)}};et=Le([I],et),e.Diagnostic=et;let lt=class{constructor(L,J){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=J}};lt=Le([I],lt),e.Hover=lt;var it;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(it=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ft=class{constructor(L,J=it.Text){this.range=L,this.kind=J}toJSON(){return{range:this.range,kind:it[this.kind]}}};ft=Le([I],ft),e.DocumentHighlight=ft;var _t;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(_t=e.SymbolKind||(e.SymbolKind={}));var ut;(function(U){U[U.Deprecated=1]="Deprecated"})(ut=e.SymbolTag||(e.SymbolTag={}));let rt=r=class{constructor(L,J,Ee,We,Ye){this.name=L,this.kind=J,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),We instanceof Me?this.location=We:Ee instanceof R&&(this.location=new Me(We,Ee)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:_t[this.kind],location:this.location,containerName:this.containerName}}};rt=r=Le([I],rt),e.SymbolInformation=rt;let B=c=class{constructor(L,J,Ee,We,Ye){this.name=L,this.detail=J,this.kind=Ee,this.range=We,this.selectionRange=Ye,this.children=[],c.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(c.validate)}};B=c=Le([I],B),e.DocumentSymbol=B;var G;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let $=class{constructor(L,J){this.title=L,this.kind=J}};$=Le([I],$),e.CodeAction=$;let V=w=class{constructor(L){this.value=L}append(L){return new w(this.value?this.value+w.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+w.sep)}};V.sep=".",V=w=Le([I],V),e.CodeActionKind=V,V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll");let Y=class{constructor(L,J){if(this.range=L,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Le([I],Y),e.SelectionRange=Y;class ne{constructor(L,J,Ee,We,Ye,ot){this.kind=L,this.name=J,this.detail=Ee,this.uri=We,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=ne;class me{constructor(L,J){this.fromRanges=J,this.from=L}}e.CallHierarchyIncomingCall=me;class Fe{constructor(L,J){this.fromRanges=J,this.to=L}}e.CallHierarchyOutgoingCall=Fe;var $e;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let qe=class{constructor(L,J){this.range=L,this.command=J}get isResolved(){return!!this.command}};qe=Le([I],qe),e.CodeLens=qe;let Je=h=class{constructor(L,J=!1){s.set(this,void 0),Ge(this,s,new _.MarkdownString(L,{supportThemeIcons:J}),"f")}static isMarkdownString(L){return L instanceof h?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return De(this,s,"f").value}set value(L){De(this,s,"f").value=L}get isTrusted(){return De(this,s,"f").isTrusted}set isTrusted(L){De(this,s,"f").isTrusted=L}get supportThemeIcons(){return De(this,s,"f").supportThemeIcons}set supportThemeIcons(L){De(this,s,"f").supportThemeIcons=L}get supportHtml(){return De(this,s,"f").supportHtml}set supportHtml(L){De(this,s,"f").supportHtml=L}appendText(L){return De(this,s,"f").appendText(L),this}appendMarkdown(L){return De(this,s,"f").appendMarkdown(L),this}appendCodeblock(L,J){return De(this,s,"f").appendCodeblock(J??"",L),this}};s=new WeakMap,Je=h=Le([I],Je),e.MarkdownString=Je;let Ze=class{constructor(L,J){this.label=L,this.documentation=J}};Ze=Le([I],Ze),e.ParameterInformation=Ze;let Ke=class{constructor(L,J){this.label=L,this.documentation=J,this.parameters=[]}};Ke=Le([I],Ke),e.SignatureInformation=Ke;let Qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Qe=Le([I],Qe),e.SignatureHelp=Qe;var mt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(mt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Tt;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Tt=e.InlayHintKind||(e.InlayHintKind={}));let Te=class{constructor(L){this.label=L}};Te=Le([I],Te),e.InlayHintLabelPart=Te;let kt=class{constructor(L,J,Ee){this.label=L,this.position=J,this.kind=Ee}};kt=Le([I],kt),e.InlayHint=kt;var q;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(U){U[U.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(L,J){this.label=L,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=Le([I],Oe),e.CompletionItem=Oe;let He=class{constructor(L=[],J=!1){this.items=L,this.isIncomplete=J}};He=Le([I],He),e.CompletionList=He;let tt=class{constructor(L,J,Ee){this.text=L,this.range=J,this.command=Ee}};tt=Le([I],tt),e.InlineSuggestion=tt;let Ve=class{constructor(L){this.items=L}};Ve=Le([I],Ve),e.InlineSuggestions=Ve;var wt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(wt=e.ViewColumn||(e.ViewColumn={}));var Ie;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ie=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Se;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Se=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(he=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ee;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ee=e.TextEditorRevealType||(e.TextEditorRevealType={}));var te;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(J){switch(J){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ke=class{constructor(L,J){if(J&&!F.URI.isUri(J))throw(0,A.illegalArgument)("target");if(!R.isRange(L)||L.isEmpty)throw(0,A.illegalArgument)("range");this.range=L,this.target=J}};ke=Le([I],ke),e.DocumentLink=ke;let xe=class{constructor(L,J,Ee,We){this.red=L,this.green=J,this.blue=Ee,this.alpha=We}};xe=Le([I],xe),e.Color=xe;let Ae=class{constructor(L,J){if(J&&!(J instanceof xe))throw(0,A.illegalArgument)("color");if(!R.isRange(L)||L.isEmpty)throw(0,A.illegalArgument)("range");this.range=L,this.color=J}};Ae=Le([I],Ae),e.ColorInformation=Ae;let Be=class{constructor(L){if(!L||typeof L!="string")throw(0,A.illegalArgument)("label");this.label=L}};Be=Le([I],Be),e.ColorPresentation=Be;var Xe;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var nt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(nt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Re{constructor(L,J,Ee){if(this.startIndex=L,this.length=J,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,A.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,A.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Re;var ae;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ae=e.TerminalLocation||(e.TerminalLocation={}));class le{constructor(L){this.options=L,typeof L!="object"&&(0,A.illegalArgument)("options")}}e.TerminalProfile=le;var ie;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ie=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let pe=d=class{constructor(L,J){if(this.label=J,typeof L!="string"||typeof J!="string")throw(0,A.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};pe.Clean=new d("clean","Clean"),pe.Build=new d("build","Build"),pe.Rebuild=new d("rebuild","Rebuild"),pe.Test=new d("test","Test"),pe=d=Le([I],pe),e.TaskGroup=pe;function Ce(U){let L="";for(let J=0;J<U.length;J++)L+=U[J].replace(/,/g,",,")+",";return L}let ze=class{constructor(L,J,Ee){if(typeof L!="string")throw(0,A.illegalArgument)("process");this._args=[],this._process=L,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=Ee):this._options=J)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,A.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let J of this._args)L.push(J);return Ce(L)}};ze=Le([I],ze),e.ProcessExecution=ze;let Ue=class{constructor(L,J,Ee){if(this._args=[],Array.isArray(J)){if(!L)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,A.illegalArgument)("command");this._command=L,this._args=J,this._options=Ee}else{if(typeof L!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=L,this._options=J}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,A.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let J of this._args)L.push(typeof J=="string"?J:J.value);return Ce(L)}};Ue=Le([I],Ue),e.ShellExecution=Ue;var dt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class yt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=yt;let st=g=class{constructor(L,J,Ee,We,Ye,ot){this.__deprecated=!1,this._definition=this.definition=L;let ct;typeof J=="string"?(this._name=this.name=J,this._source=this.source=Ee,this.execution=We,ct=Ye,this.__deprecated=!0):J===bt.Global||J===bt.Workspace?(this.target=J,this._name=this.name=Ee,this._source=this.source=We,this.execution=Ye,ct=ot):(this.target=J,this._name=this.name=Ee,this._source=this.source=We,this.execution=Ye,ct=ot),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ze?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ue?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,A.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const J=this._definition.type;(g.EmptyType===J||g.ProcessType===J||g.ShellType===J||g.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};st.ExtensionCallbackType="customExecution",st.ProcessType="process",st.ShellType="shell",st.EmptyType="$empty",st=g=Le([I],st),e.Task=st;var gt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(L,J=Ut.None){this.collapsibleState=J,F.URI.isUri(L)?this.resourceUri=L:this.label=L}};pt=Le([I],pt),e.TreeItem=pt;var Ut;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let At=class{constructor(L){this._value=L}async asString(){return JSON.stringify(this._value)}};At=Le([I],At),e.TreeDataTransferItem=At;let Ot=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,J){this._items.set(L,J)}forEach(L){this._items.forEach(L)}};Ot=Le([I],Ot),e.TreeDataTransfer=Ot;let Ct=class{constructor(L,J){this.id=L,this.color=J}};Ct=Le([I],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Et=class{constructor(L){this.id=L}};Et=Le([I],Et),e.ThemeColor=Et;var Lt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Lt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let qt=class{constructor(L,J){if(typeof L!="string"&&(!L||!F.URI.isUri(L)&&!F.URI.isUri(L.uri)))throw(0,A.illegalArgument)("base");if(typeof J!="string")throw(0,A.illegalArgument)("pattern");typeof L=="string"?this.baseUri=F.URI.file(L):F.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=J}get base(){return this._base}set base(L){this._base=L,this._baseUri=F.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};qt=Le([I],qt),e.RelativePattern=qt;let vt=class{constructor(L,J,Ee,We){this.enabled=typeof L=="boolean"?L:!0,typeof J=="string"&&(this.condition=J),typeof Ee=="string"&&(this.hitCondition=Ee),typeof We=="string"&&(this.logMessage=We)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};vt=Le([I],vt),e.Breakpoint=vt;let Bt=class extends vt{constructor(L,J,Ee,We,Ye){super(J,Ee,We,Ye);if(L===null)throw(0,A.illegalArgument)("location");this.location=L}};Bt=Le([I],Bt),e.SourceBreakpoint=Bt;let Gt=class extends vt{constructor(L,J,Ee,We,Ye){super(J,Ee,We,Ye);this.functionName=L}};Gt=Le([I],Gt),e.FunctionBreakpoint=Gt;let Xt=class extends vt{constructor(L,J,Ee,We,Ye,ot,ct){super(We,Ye,ot,ct);if(!J)throw(0,A.illegalArgument)("dataId");this.label=L,this.dataId=J,this.canPersist=Ee}};Xt=Le([I],Xt),e.DataBreakpoint=Xt;let ai=class{constructor(L,J,Ee){this.command=L,this.args=J||[],this.options=Ee}};ai=Le([I],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(L,J){this.port=L,this.host=J}};Rt=Le([I],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(L){this.path=L}};Jt=Le([I],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(L){this.implementation=L}};li=Le([I],li),e.DebugAdapterInlineImplementation=li;let Kt=class{constructor(L,J){this.range=L,this.expression=J}};Kt=Le([I],Kt),e.EvaluatableExpression=Kt;var Zt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ht=class{constructor(L,J){this.range=L,this.text=J}};ht=Le([I],ht),e.InlineValueText=ht;let ci=class{constructor(L,J,Ee=!0){this.range=L,this.variableName=J,this.caseSensitiveLookup=Ee}};ci=Le([I],ci),e.InlineValueVariableLookup=ci;let Nt=class{constructor(L,J){this.range=L,this.expression=J}};Nt=Le([I],Nt),e.InlineValueEvaluatableExpression=Nt;let zt=class{constructor(L,J){this.frameId=L,this.stoppedLocation=J}};zt=Le([I],zt),e.InlineValueContext=zt;var vi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=f=class extends Error{constructor(L,J=m.FileSystemProviderErrorCode.Unknown,Ee){super(F.URI.isUri(L)?L.toString(!0):L);this.code=Ee?.name??"Unknown",(0,m.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(L){return new f(L,m.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(L){return new f(L,m.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(L){return new f(L,m.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(L){return new f(L,m.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(L){return new f(L,m.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(L){return new f(L,m.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};ui=f=Le([I],ui),e.FileSystemError=ui;let ei=class{constructor(L,J,Ee){this.start=L,this.end=J,this.kind=Ee}};ei=Le([I],ei),e.FoldingRange=ei;var Di;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Di=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Ci{constructor(L,J=[]){this.tokenTypes=L,this.tokenModifiers=J}}e.SemanticTokensLegend=Ci;function di(U){return typeof U=="undefined"||(0,y.isStringArray)(U)}class Qt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let J=0,Ee=L.tokenTypes.length;J<Ee;J++)this._tokenTypeStrToInt.set(L.tokenTypes[J],J);for(let J=0,Ee=L.tokenModifiers.length;J<Ee;J++)this._tokenModifierStrToInt.set(L.tokenModifiers[J],J)}}push(L,J,Ee,We,Ye){if(typeof L=="number"&&typeof J=="number"&&typeof Ee=="number"&&typeof We=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(L,J,Ee,We,Ye);if(R.isRange(L)&&typeof J=="string"&&di(Ee))return this._push(L,J,Ee);throw(0,A.illegalArgument)()}_push(L,J,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const We=L.start.line,Ye=L.start.character,ot=L.end.character-L.start.character,ct=this._tokenTypeStrToInt.get(J);let It=0;if(Ee)for(const Ft of Ee){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Ft);It|=1<<xt>>>0}this._pushEncoded(We,Ye,ot,ct,It)}_pushEncoded(L,J,Ee,We,Ye){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let Ft=0,xt=0;for(let Ht=0;Ht<It;Ht++){let Vt=this._data[5*Ht],gi=this._data[5*Ht+1];Vt===0?(Vt=Ft,gi+=xt):Vt+=Ft,this._data[5*Ht]=Vt,this._data[5*Ht+1]=gi,Ft=Vt,xt=gi}}let ot=L,ct=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=We,this._data[this._dataLen++]=Ye,this._prevLine=L,this._prevChar=J}static _sortAndDeltaEncode(L){let J=[];const Ee=L.length/5|0;for(let ct=0;ct<Ee;ct++)J[ct]=ct;J.sort((ct,It)=>{const Ft=L[5*ct],xt=L[5*It];if(Ft===xt){const Ht=L[5*ct+1],Vt=L[5*It+1];return Ht-Vt}return Ft-xt});const We=new Uint32Array(L.length);let Ye=0,ot=0;for(let ct=0;ct<Ee;ct++){const It=5*J[ct],Ft=L[It+0],xt=L[It+1],Ht=L[It+2],Vt=L[It+3],gi=L[It+4],Wi=Ft-Ye,Ji=Wi===0?xt-ot:xt,pi=5*ct;We[pi+0]=Wi,We[pi+1]=Ji,We[pi+2]=Ht,We[pi+3]=Vt,We[pi+4]=gi,Ye=Ft,ot=xt}return We}build(L){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),L):new hi(Qt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Qt;class hi{constructor(L,J){this.resultId=J,this.data=L}}e.SemanticTokens=hi;class Ii{constructor(L,J,Ee){this.start=L,this.deleteCount=J,this.data=Ee}}e.SemanticTokensEdit=Ii;class Yt{constructor(L,J){this.resultId=J,this.edits=L}}e.SemanticTokensEdits=Yt;var ki;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new Ct("arrow-left")},ii=Le([I],ii),e.QuickInputButtons=ii;var Ti;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Ti=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(L,J,Ee){this.badge=L,this.tooltip=J,this.color=Ee}static validate(L){if(L.badge){let J=(0,T.nextCharLength)(L.badge,0);if(J<L.badge.length&&(J+=(0,T.nextCharLength)(L.badge,J)),L.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(L){this.kind=L}};ni=Le([I],ni),e.ColorTheme=ni;var Pe;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(Pe=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(L,J){if(L<0)throw(0,A.illegalArgument)("start must be positive");if(J<0)throw(0,A.illegalArgument)("end must be positive");L<=J?(this._start=L,this._end=J):(this._start=J,this._end=L)}static isNotebookRange(L){return L instanceof Wt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let J=this._start,Ee=this._end;return L.start!==void 0&&(J=L.start),L.end!==void 0&&(Ee=L.end),J===this._start&&Ee===this._end?this:new Wt(J,Ee)}}e.NotebookRange=Wt;class $t{constructor(L,J,Ee,We,Ye,ot,ct){this.kind=L,this.value=J,this.languageId=Ee,this.mime=We,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ct,$t.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(J=>$t.isNotebookCellData(J))}static isNotebookCellData(L){return!0}}e.NotebookCellData=$t;class St{constructor(L){this.cells=L}}e.NotebookData=St;class Mt{constructor(L,J){this.data=L,this.mime=J;const Ee=(0,M.normalizeMimeType)(J,!0);if(!Ee)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(L){return L instanceof Mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const J={name:L.name,message:L.message,stack:L.stack};return Mt.json(J,"application/vnd.code.notebook.error")}static stdout(L){return Mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,J="application/octet-stream"){return new Mt(L,J)}static text(L,J=M.Mimes.text){const Ee=De(Mt,a,"f",l).encode(String(L));return new Mt(Ee,J)}static json(L,J="application/json"){const Ee=JSON.stringify(L,void 0,"	");return Mt.text(Ee,J)}}e.NotebookCellOutputItem=Mt,a=Mt,l={value:new TextEncoder};class ri{constructor(L,J,Ee){this.items=ri.ensureUniqueMimeTypes(L,!0),typeof J=="string"?(this.id=J,this.metadata=Ee):(this.id=(0,O.generateUuid)(),this.metadata=J??Ee)}static isNotebookCellOutput(L){return L instanceof ri?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,y.isArray)(L.items)}static ensureUniqueMimeTypes(L,J=!1){const Ee=new Set,We=new Set;for(let Ye=0;Ye<L.length;Ye++){const ot=L[Ye],ct=(0,M.normalizeMimeType)(ot.mime);if(!Ee.has(ct)){Ee.add(ct);continue}We.add(Ye),J&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return We.size===0?L:L.filter((Ye,ot)=>!We.has(ot))}}e.NotebookCellOutput=ri;var wi;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(wi=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fi{constructor(L,J){this.text=L,this.alignment=J}}e.NotebookCellStatusBarItem=Fi;var Mi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Mi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(L,J=[]){this.uri=L,this.provides=(0,i.asArray)(J)}}e.NotebookRendererScript=_i;let mi=class{constructor(L,J){this.label=L,this.timestamp=J}};mi=Le([I],mi),e.TimelineItem=mi;var Oi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var Li;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Li=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class xi{constructor(L,J){this.ranges=L,this.wordPattern=J}}e.LinkedEditingRanges=xi;class X{constructor(L,J){this._port=L,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=X;var oe;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(oe=e.TestResultState||(e.TestResultState={}));var _e;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(_e=e.TestRunProfileKind||(e.TestRunProfileKind={}));let at=class{constructor(L=void 0,J=void 0,Ee=void 0){this.include=L,this.exclude=J,this.profile=Ee}};at=Le([I],at),e.TestRunRequest=at;let Dt=E=class{constructor(L){this.message=L}static diff(L,J,Ee){const We=new E(L);return We.expectedOutput=J,We.actualOutput=Ee,We}};Dt=E=Le([I],Dt),e.TestMessage=Dt;let Pt=class{constructor(L){this.id=L}};Pt=Le([I],Pt),e.TestTag=Pt;let oi=class{constructor(L,J){this.covered=L,this.total=J}};oi=Le([I],oi),e.CoveredCount=oi;let Ui=C=class{constructor(L,J,Ee,We){this.uri=L,this.statementCoverage=J,this.branchCoverage=Ee,this.functionCoverage=We}static fromDetails(L,J){const Ee=new oi(0,0),We=new oi(0,0),Ye=new oi(0,0);for(const ct of J)if("branches"in ct){Ee.total+=1,Ee.covered+=ct.executionCount>0?1:0;for(const It of ct.branches)We.total+=1,We.covered+=It.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ct.executionCount>0?1:0;const ot=new C(L,Ee,We.total>0?We:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=J,ot}};Ui=C=Le([I],Ui),e.FileCoverage=Ui;let Bi=class{constructor(L,J,Ee=[]){this.executionCount=L,this.location=J,this.branches=Ee}};Bi=Le([I],Bi),e.StatementCoverage=Bi;let $i=class{constructor(L,J){this.executionCount=L,this.location=J}};$i=Le([I],$i),e.BranchCoverage=$i;let Hi=class{constructor(L,J){this.executionCount=L,this.location=J}};Hi=Le([I],Hi),e.FunctionCoverage=Hi;var Gi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xi{constructor(L,J,Ee,We,Ye,ot){this.kind=L,this.name=J,this.detail=Ee,this.uri=We,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=Xi}),define(be[80],we([0,1,41,11,14,222,112,6,16]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const F=new Map;function O(s,a){a?F.set(s,a):F.delete(s)}e.setWordDefinitionFor=O;function m(s){return F.get(s)}e.getWordDefinitionFor=m;class t extends D.MirrorTextModel{constructor(a,l,k,v,b,o,S,n){super(l,k,v,b);this._proxy=a,this._languageId=o,this._isDirty=S,this._notebook=n,this._isDisposed=!1}dispose(){(0,i.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,y.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===A.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(l){return l?a._getTextInRange(l):a.getText()},get eol(){return a._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(l){return a._lineAt(l)},offsetAt(l){return a._offsetAt(l)},positionAt(l){return a._positionAt(l)},validateRange(l){return a._validateRange(l)},validatePosition(l){return a._validatePosition(l)},getWordRangeAtPosition(l,k){return a._getWordRangeAtPosition(l,k)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,i.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,i.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const l=this._validateRange(a);if(l.isEmpty)return"";if(l.isSingleLine)return this._lines[l.start.line].substring(l.start.character,l.end.character);const k=this._eol,v=l.start.line,b=l.end.line,o=[];o.push(this._lines[v].substring(l.start.character));for(let S=v+1;S<b;S++)o.push(this._lines[S]);return o.push(this._lines[b].substring(0,l.end.character)),o.join(k)}_lineAt(a){let l;if(a instanceof T.Position?l=a.line:typeof a=="number"&&(l=a),typeof l!="number"||l<0||l>=this._lines.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new u(l,this._lines[l],l===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(a),k=this._lines[l.index].length;return new T.Position(l.index,Math.min(l.remainder,k))}_validateRange(a){if(!(a instanceof T.Range))throw new Error("Invalid argument");const l=this._validatePosition(a.start),k=this._validatePosition(a.end);return l===a.start&&k===a.end?a:new T.Range(l.line,l.character,k.line,k.character)}_validatePosition(a){if(!(a instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:l,character:k}=a,v=!1;if(l<0)l=0,k=0,v=!0;else if(l>=this._lines.length)l=this._lines.length-1,k=this._lines[l].length,v=!0;else{const b=this._lines[l].length;k<0?(k=0,v=!0):k>b&&(k=b,v=!0)}return v?new T.Position(l,k):a}_getWordRangeAtPosition(a,l){const k=this._validatePosition(a);if(!l)l=m(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const v=(0,M.getWordAtText)(k.character+1,(0,M.ensureValidWordDefinition)(l),this._lines[k.line],0);if(v)return new T.Range(k.line,v.startColumn-1,k.line,v.endColumn-1)}}e.ExtHostDocumentData=t;class u{constructor(a,l,k){this._line=a,this._text=l,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=u}),define(be[147],we([0,1,6,5,223,7,148,22,2,34]),function(Z,e,i,A,_,D,M,T,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class O{constructor(t,u,s,a){this._notebook=s,this._selector=a,this._disposables=new D.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,F.generateUuid)()}),this._init(),this._disposables.add(u.onDidChangeDocument(k=>{const v=this._cellUris.get(k.document.uri);v!==void 0&&(this._cellLengths.setValue(v,this._cells[v].document.getText().length+1),this._cellLines.setValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const l=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(t.onDidChangeNotebookCells(k=>l(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const t=[],u=[];for(const s of this._notebook.getCells())s.kind===i.NotebookCellKind.Code&&(!this._selector||(0,M.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),t.push(s.document.getText().length+1),u.push(s.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(t)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(u))}get version(){return this._versionId}getText(t){if(!t){let v="";for(const b of this._cells)v+=b.document.getText()+`
`;return v=v.slice(0,-1),v}if(t.isEmpty)return"";const u=this.locationAt(t.start),s=this.locationAt(t.end),a=this._cellUris.get(u.uri),l=this._cellUris.get(s.uri);if(a===void 0||l===void 0)return"";if(a===l)return this._cells[a].document.getText(new i.Range(u.range.start,s.range.end));const k=[this._cells[a].document.getText(new i.Range(u.range.start,new i.Position(this._cells[a].document.lineCount,0)))];for(let v=a+1;v<l;v++)k.push(this._cells[v].document.getText());return k.push(this._cells[l].document.getText(new i.Range(new i.Position(0,0),s.range.end))),k.join(`
`)}offsetAt(t){const u=this._cellLines.getIndexOf(t.line),s=this._cellLengths.getPrefixSum(u.index-1),a=this._cells[u.index].document.offsetAt(t.with(u.remainder));return s+a}positionAt(t){if(typeof t=="number"){const s=this._cellLengths.getIndexOf(t),a=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(a)}const u=this._cellUris.get(t.uri);if(u!==void 0){const s=this._cellLines.getPrefixSum(u-1);return new i.Position(s+t.range.start.line,t.range.start.character)}return new i.Position(0,0)}locationAt(t){i.Range.isRange(t)||(t=new i.Range(t,t));const u=this._cellLines.getIndexOf(t.start.line);let s=u;t.isEmpty||(s=this._cellLines.getIndexOf(t.end.line));const a=new i.Position(u.remainder,t.start.character),l=new i.Position(s.remainder,t.end.character),k=new i.Range(a,l),v=this._cells[u.index];return new i.Location(v.document.uri,v.document.validateRange(k))}contains(t){return this._cellUris.has(t)}validateRange(t){const u=this.validatePosition(t.start),s=this.validatePosition(t.end);return t.with(u,s)}validatePosition(t){const u=this._cellLines.getIndexOf(t.line),s=new i.Position(u.remainder,t.character),a=this._cells[u.index].document.validatePosition(s),l=this._cellLines.getPrefixSum(u.index-1);return new i.Position(l+a.line,a.character)}}e.ExtHostNotebookConcatDocument=O}),define(be[149],we([0,1,6,12,5]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let D=class{constructor(T){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let y=T==="light"?i.ColorThemeKind.Light:T==="dark"?i.ColorThemeKind.Dark:i.ColorThemeKind.HighContrast;this._actual=new i.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};D=Le([Ne(0,A.IExtHostRpcService)],D),e.ExtHostTheming=D}),define(be[58],we([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class A{constructor(D){D?(this.transformIncoming=D.transformIncoming.bind(D),this.transformOutgoing=D.transformOutgoing.bind(D),this.transformOutgoingURI=D.transformOutgoingURI.bind(D),this.transformOutgoingScheme=D.transformOutgoingScheme.bind(D)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.URITransformerService=A}),define(be[150],we([0,1,21]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(y){let F=this.buffers.indexOf(y);return F<0&&(F=this.buffers.length,this.buffers.push(y)),F}}function _(T,y){if(y.serializeBuffersForPostMessage){const F=new A,O=(u,s)=>{if(s instanceof ArrayBuffer){const a=F.add(s);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(s)){const a=D(s);if(a){const l=F.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:l,view:{type:a,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},m=JSON.stringify(T,O),t=F.buffers.map(u=>{const s=new Uint8Array(u);return i.VSBuffer.wrap(s)});return{message:m,buffers:t}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=_;function D(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(T,y){const F=y.map(t=>{const u=new ArrayBuffer(t.byteLength);return new Uint8Array(u).set(t.buffer),u}),O=y.length?(t,u)=>{if(typeof u=="object"&&u.$$vscode_array_buffer_reference$$){const s=u,{index:a}=s,l=F[a];if(s.view)switch(s.view.type){case 1:return new Int8Array(l,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return u}:void 0;return{message:JSON.parse(T,O),arrayBuffers:F}}e.deserializeWebviewMessage=M}),define(be[151],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var i;(function(A){function _(M){const T=new Map;return M.types.forEach((y,F)=>{T.set(y,{asString:async()=>M.items[F].asString})}),T}A.toITreeDataTransfer=_;async function D(M){const T={types:[],items:[]},y=Array.from(M.entries());for(const F of y)T.types.push(F[0]),T.items.push({asString:await F[1].asString()});return T}A.toTreeDataTransferDTO=D})(i=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[59],we([0,1,11,2]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(T,y){return T.scheme===i.Schemas.http||T.scheme===i.Schemas.https?T:(y&&y.authority&&y.isRemote&&T.scheme===i.Schemas.file&&(T=A.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:T.path})),A.URI.from({scheme:i.Schemas.https,authority:`${T.scheme}+${D(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=_;function D(T){return T.replace(/./g,y=>{const F=y.charCodeAt(0);return F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57?y:"-"+F.toString(16).padStart(4,"0")})}function M(T){return T.replace(/-([0-9a-f]{4})/g,(y,F)=>String.fromCharCode(parseInt(F,16)))}e.decodeAuthority=M}),define(be[152],we([0,1,5,7,59]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(T,y,F){this._proxy=T,this._editors=y,this._initData=F,this._handlePool=0,this._disposables=new A.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const m of this._insets.values())O.indexOf(m.editor)<0&&m.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,y,F,O,m){let t;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===T){t=b;break}if(!t)throw new Error("not a visible editor");const u=this,s=this._handlePool++,a=new i.Emitter,l=new i.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,_.asWebviewUri)(b,u._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(b){this._options=b,u._proxy.$setOptions(s,b)}get options(){return this._options}set html(b){this._html=b,u._proxy.$setHtml(s,b)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(b){return u._proxy.$postMessage(s,b)}},v=new class{constructor(){this.editor=T,this.line=y,this.height=F,this.webview=k,this.onDidDispose=l.event}dispose(){u._insets.has(s)&&(u._insets.delete(s),u._proxy.$disposeEditorInset(s),l.fire(),l.dispose(),a.dispose())}};return this._proxy.$createEditorInset(s,t.id,t.value.document.uri,y+1,F,O||{},m.identifier,m.extensionLocation),this._insets.set(s,{editor:T,inset:v,onDidReceiveMessage:a}),v}$onDidDispose(T){const y=this._insets.get(T);y&&y.inset.dispose()}$onDidReceiveMessage(T,y){const F=this._insets.get(T);F&&F.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=D}),define(be[153],we([0,1,124,13,2,7,3,44,35,45,16,11]),function(Z,e,i,A,_,D,M,T,y,F,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,i.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,i.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,i.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,i.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,i.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,i.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,i.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,i.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,i.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,i.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,i.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,i.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,i.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,i.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,i.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,i.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,i.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,i.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,i.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,i.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,i.localize)(22,null)),e.EditorTabsVisibleContext=new T.RawContextKey("editorTabsVisible",!0,(0,i.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function t(R,x,j){for(const H of j.visibleEditorPanes)if(H.group.id===x&&R.matches(H.input))return H.getViewState()}e.findViewStateForEditor=t;function u(R){if(S(R))return!1;const x=R;return _.URI.isUri(x?.resource)}e.isResourceEditorInput=u;function s(R){if(S(R))return!1;const x=R;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=s;function a(R){if(S(R)||s(R))return!1;const x=R;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=a;function l(R){if(S(R))return!1;const x=R;return x?x.resource===void 0||x.resource.scheme===m.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var k;(function(R){R[R.SHORT=0]="SHORT",R[R.MEDIUM=1]="MEDIUM",R[R.LONG=2]="LONG"})(k=e.Verbosity||(e.Verbosity={}));var v;(function(R){R[R.EXPLICIT=1]="EXPLICIT",R[R.AUTO=2]="AUTO",R[R.FOCUS_CHANGE=3]="FOCUS_CHANGE",R[R.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var b;(function(R){R[R.None=0]="None",R[R.Readonly=2]="Readonly",R[R.Untitled=4]="Untitled",R[R.Singleton=8]="Singleton",R[R.RequiresTrust=16]="RequiresTrust",R[R.CanSplitInGroup=32]="CanSplitInGroup",R[R.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends D.Disposable{}e.AbstractEditorInput=o;function S(R){return R instanceof o}e.isEditorInput=S;function n(R){const x=R;return _.URI.isUri(x?.preferredResource)}function P(R){const x=R;return S(x?.primary)&&S(x?.secondary)}e.isSideBySideEditorInput=P;function r(R){const x=R;return S(x?.modified)&&S(x?.original)}e.isDiffEditorInput=r;function c(R){return S(R?.editor)}e.isEditorInputWithOptions=c;function w(R){const x=R;return c(R)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=w;function h(R){const x=R;return typeof x?.groupId=="number"&&S(x.editor)}e.isEditorIdentifier=h;var d;(function(R){R[R.UNKNOWN=0]="UNKNOWN",R[R.REPLACE=1]="REPLACE",R[R.MOVE=2]="MOVE",R[R.UNPIN=3]="UNPIN"})(d=e.EditorCloseContext||(e.EditorCloseContext={}));var g;(function(R){R[R.GROUP_ACTIVE=0]="GROUP_ACTIVE",R[R.GROUP_INDEX=1]="GROUP_INDEX",R[R.GROUP_LOCKED=2]="GROUP_LOCKED",R[R.EDITOR_OPEN=3]="EDITOR_OPEN",R[R.EDITOR_CLOSE=4]="EDITOR_CLOSE",R[R.EDITOR_MOVE=5]="EDITOR_MOVE",R[R.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",R[R.EDITOR_LABEL=7]="EDITOR_LABEL",R[R.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",R[R.EDITOR_PIN=9]="EDITOR_PIN",R[R.EDITOR_STICKY=10]="EDITOR_STICKY",R[R.EDITOR_DIRTY=11]="EDITOR_DIRTY",R[R.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(g=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(R){R[R.PRIMARY=1]="PRIMARY",R[R.SECONDARY=2]="SECONDARY",R[R.BOTH=3]="BOTH",R[R.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class E{getOriginalUri(x,j){if(!x)return;if(j?.supportSideBySide){const{primary:z,secondary:K}=this.getSideEditors(x);if(z&&K){if(j?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===f.ANY)return this.getOriginalUri(z,{filterByScheme:j.filterByScheme})??this.getOriginalUri(K,{filterByScheme:j.filterByScheme});x=j.supportSideBySide===f.PRIMARY?z:K}}if(s(x)||a(x))return;const H=n(x)?x.preferredResource:x.resource;return!H||!j||!j.filterByScheme?H:this.filterUri(H,j.filterByScheme)}getSideEditors(x){return P(x)||a(x)?{primary:x.primary,secondary:x.secondary}:r(x)||s(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,j){if(!x)return;if(j?.supportSideBySide){const{primary:z,secondary:K}=this.getSideEditors(x);if(z&&K){if(j?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===f.ANY)return this.getCanonicalUri(z,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:j.filterByScheme});x=j.supportSideBySide===f.PRIMARY?z:K}}if(s(x)||a(x))return;const H=x.resource;return!H||!j||!j.filterByScheme?H:this.filterUri(H,j.filterByScheme)}filterUri(x,j){if(Array.isArray(j)){if(j.some(H=>x.scheme===H))return x}else if(j===x.scheme)return x}}e.EditorResourceAccessor=new E;var C;(function(R){R[R.LEFT=0]="LEFT",R[R.RIGHT=1]="RIGHT"})(C=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const j=this.instantiationService=x.get(M.IInstantiationService);for(const[H,z]of this.editorSerializerConstructors)this.createEditorSerializer(H,z,j);this.editorSerializerConstructors.clear()}createEditorSerializer(x,j,H){const z=H.createInstance(j);this.editorSerializerInstances.set(x,z)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,A.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,j){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,j,this.instantiationService):this.editorSerializerConstructors.set(x,j),(0,D.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new I);async function N(R,x){if(!R||!R.length)return[];const j=await Promise.all(R.map(async H=>{const z=_.URI.revive(H.fileUri);if(!z||!await x.canHandleResource(z))return;let ce=H.exists,fe=H.type;if(typeof ce!="boolean"||typeof fe!="number")try{fe=(await x.resolve(z)).isDirectory?F.FileType.Directory:F.FileType.Unknown,ce=!0}catch{ce=!1}if(!ce&&H.openOnlyIfExists||fe===F.FileType.Directory)return;const re={selection:ce?H.selection:void 0,pinned:!0,override:H.editorOverrideId};let ge;return ce?ge={resource:z,options:re}:ge={resource:z,options:re,forceUntitled:!0},ge}));return(0,O.coalesce)(j)}e.pathsToEditors=N;var p;(function(R){R[R.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",R[R.SEQUENTIAL=1]="SEQUENTIAL"})(p=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[154],we([0,1,5,10,125]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class D{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,y,F,O){const m={command:T};if(y&&Object.keys(y).length>0&&(m.arguments=y),this.internalSend("request",m),typeof O=="number"){const t=setTimeout(()=>{clearTimeout(t);const u=this.pendingRequests.get(m.seq);if(u){this.pendingRequests.delete(m.seq);const s={type:"response",seq:0,request_seq:m.seq,success:!1,command:T,message:(0,_.localize)(0,null,O,T)};u(s)}},O)}return F&&this.pendingRequests.set(m.seq,F),m.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,y){return T.type!=="event"||y.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,A.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":{const y=T,F=this.pendingRequests.get(y.request_seq);F&&(this.pendingRequests.delete(y.request_seq),F(y));break}}}}internalSend(T,y){y.type=T,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((y,F)=>T.set(F,y)),await(0,A.timeout)(500),T.forEach((y,F)=>{y({type:"response",seq:0,request_seq:F,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(F)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=D}),define(be[155],we([0,1,14,2,19,25,11]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function y(r,c,w){return r.replace(T,function(h,d){return c&&d.length>0&&d[0]!=="_"?h:w&&w.hasOwnProperty(d)?w[d]:h})}e.formatPII=y;function F(r){const c={};for(const w of Object.keys(r))w.startsWith("!")||(c[w]=r[w]);return c}e.filterExceptionsFromTelemetry=F;function O(r){return r.configuration.request==="attach"&&!m(r)&&(!r.parentSession||O(r.parentSession))}e.isSessionAttach=O;function m(r){let c=r.configuration.type;if(!!c)return c==="vslsShare"&&(c=r.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(c,"extensionhost")||(0,i.equalsIgnoreCase)(c,"pwa-extensionhost")?r:r.parentSession?m(r.parentSession):void 0}e.getExtensionHostDebugSession=m;function t(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=t;function u(r,c,w){let h,d=0;const g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=g.exec(r);){const E=f.index+1,C=E+f[0].length;if(E<=c&&C>=w){h=f[0],d=E;break}}if(h){const E=/\w+/g;let C=null;for(;(C=E.exec(h))&&!(C.index+1+d+C[0].length>=w););C&&(h=h.substring(0,E.lastIndex))}return h?{start:d,end:d+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=u;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(r){return!!(r&&r.match(s))}e.isUri=a;function l(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(a(r.path))return A.URI.parse(r.path);if((0,_.isAbsolute)(r.path))return A.URI.file(r.path)}return r.path}function k(r){if(typeof r.path=="object"){const c=A.URI.revive(r.path);if(c)return c.scheme===M.Schemas.file?c.fsPath:c.toString()}return r.path}function v(r,c){const w=c?l:k,h=(0,D.deepClone)(r);return o(h,(d,g)=>{d&&g&&(g.path=w(g))}),h}e.convertToDAPaths=v;function b(r,c){const w=c?l:k,h=(0,D.deepClone)(r);return o(h,(d,g)=>{!d&&g&&(g.path=w(g))}),h}e.convertToVSCPaths=b;function o(r,c){switch(r.type){case"event":{const w=r;switch(w.event){case"output":c(!1,w.body.source);break;case"loadedSource":c(!1,w.body.source);break;case"breakpoint":c(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=r;switch(w.command){case"setBreakpoints":c(!0,w.arguments.source);break;case"breakpointLocations":c(!0,w.arguments.source);break;case"source":c(!0,w.arguments.source);break;case"gotoTargets":c(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(h=>c(!1,h));break;default:break}break}case"response":{const w=r;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(h=>c(!1,h.source));break;case"loadedSources":w.body.sources.forEach(h=>c(!1,h));break;case"scopes":w.body.scopes.forEach(h=>c(!1,h.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(h=>c(!1,h.source));break;case"setBreakpoints":w.body.breakpoints.forEach(h=>c(!1,h.source));break;default:break}break}}}function S(r){return r.filter(c=>!c.presentation?.hidden).sort((c,w)=>c.presentation?w.presentation?c.presentation.group?w.presentation.group?c.presentation.group!==w.presentation.group?c.presentation.group.localeCompare(w.presentation.group):n(c.presentation.order,w.presentation.order):-1:w.presentation.group?1:n(c.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.getVisibleAndSorted=S;function n(r,c){return typeof r!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:r-c}async function P(r,c){const w=r.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(w!=="none"&&(await c.saveAll(),w==="allEditorsInActiveGroup")){const h=c.activeEditorPane;h&&h.input.resource?.scheme===M.Schemas.untitled&&await c.save({editor:h.input,groupId:h.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=P}),define(be[81],we([0,1,36,156,68,11,19,28,44]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var F;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(F=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var O;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(O=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var t;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(t=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var k;(function(E){E.scheme=D.Schemas.vscodeNotebookCell;const C=/^ch(\d{7,})/;function I(H,z){return H.with({scheme:E.scheme,fragment:`ch${z.toString().padStart(7,"0")}${H.scheme!==D.Schemas.file?H.scheme:""}`})}E.generate=I;function N(H){if(H.scheme!==E.scheme)return;const z=C.exec(H.fragment);return z?{handle:Number(z[1]),notebook:H.with({scheme:H.fragment.substring(z[0].length)||D.Schemas.file,fragment:null})}:void 0}E.parse=N;function p(H,z,K){return H.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`ch${z.toString().padStart(7,"0")},${K??""},${H.scheme!==D.Schemas.file?H.scheme:""}`})}E.generateCellOutputUri=p;function R(H){if(H.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const z=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!z)return;const K=Number(z[1]),ce=z[2]&&z[2]!==""?z[2]:void 0,fe=z[3];return{handle:K,outputId:ce,notebook:H.with({scheme:fe||D.Schemas.file,fragment:null})}}E.parseCellOutputUri=R;function x(H,z,K){return H.with({scheme:K,fragment:`ch${z.toString().padStart(7,"0")}${H.scheme!==D.Schemas.file?H.scheme:""}`})}E.generateCellUri=x;function j(H,z){if(H.scheme!==z)return;const K=C.exec(H.fragment);return K?{handle:Number(K[1]),notebook:H.with({scheme:H.fragment.substring(K[0].length)||D.Schemas.file,fragment:null})}:void 0}E.parseCellUri=j})(k=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(E){return v.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function o(E){return v.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function S(E){return v.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=S;const n=E=>T.isWindows?E.replace(/\//g,"\\"):E;class P{constructor(C=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(C)].map(N=>({pattern:N,matches:i.parse(n(N))}))}sort(C){const I=new Map(A.Iterable.map(C,p=>[p,n(p)]));let N=[];for(const{matches:p}of this.order)for(const[R,x]of I)if(p(x)){N.push(R),I.delete(R);break}return I.size&&(N=N.concat([...I.keys()].sort((p,R)=>this.defaultOrder.indexOf(p)-this.defaultOrder.indexOf(R)))),N}prioritize(C,I){const N=this.findIndex(C);if(N===-1){this.order.unshift({pattern:C,matches:i.parse(n(C))});return}const p=new Set(I.map(x=>this.findIndex(x,N)));p.delete(-1);const R=Array.from(p).sort();this.order.splice(N+1,0,...R.map(x=>this.order[x]));for(let x=R.length-1;x>=0;x--)this.order.splice(R[x],1)}toArray(){return this.order.map(C=>C.pattern)}findIndex(C,I=this.order.length){const N=n(C);for(let p=0;p<I;p++)if(this.order[p].matches(N))return p;return-1}}e.MimeTypeDisplayOrder=P;function r(E,C,I,N=(p,R)=>p===R){const p=[];function R(H,z,K){if(z===0&&K.length===0)return;const ce=p[p.length-1];ce&&ce.start+ce.deleteCount===H?(ce.deleteCount+=z,ce.toInsert.push(...K)):p.push({start:H,deleteCount:z,toInsert:K})}let x=0,j=0;for(;;){if(x===E.length){R(x,0,C.slice(j));break}if(j===C.length){R(x,E.length-x,[]);break}const H=E[x],z=C[j];if(N(H,z)){x+=1,j+=1;continue}I(z)?(R(x,1,[]),x+=1):(R(x,0,[z]),j+=1)}return p}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(E){E.default="default",E.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function w(E){const C=E;return!!((typeof C.include=="string"||i.isRelativePattern(C.include))&&(typeof C.exclude=="string"||i.isRelativePattern(C.exclude)))}e.isDocumentExcludePattern=w;function h(E,C,I){if(Array.isArray(E.viewType)&&E.viewType.indexOf(C)>=0||E.viewType===C)return!0;if(E.filenamePattern){const N=w(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,p=w(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(i.match(N,(0,M.basename)(I.fsPath).toLowerCase()))return!(p&&i.match(p,(0,M.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class d{constructor(C){this.textModel=C}getElements(){const C=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)C[I]=this.textModel.cells[I].getHashValue();return C}}e.CellSequence=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var g;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(g=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(C){return`${f._prefix}${C}`}static parse(C){if(C.startsWith(f._prefix))return C.substring(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(be[157],we([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(be[158],we([0,1,3,44]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new A.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new A.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new A.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,i.createDecorator)(e.OUTPUT_SERVICE_ID);var _;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(_=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(be[159],we([0,1,127,3,44]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,i.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,i.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,i.localize(2,null)),e.ITaskService=(0,A.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[160],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=i;function A(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=A}),define(be[82],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var i;(function(m){m[m.Unset=0]="Unset",m[m.Queued=1]="Queued",m[m.Running=2]="Running",m[m.Passed=3]="Passed",m[m.Failed=4]="Failed",m[m.Skipped=5]="Skipped",m[m.Errored=6]="Errored"})(i=e.TestResultState||(e.TestResultState={}));var A;(function(m){m[m.Run=2]="Run",m[m.Debug=4]="Debug",m[m.Coverage=8]="Coverage",m[m.HasNonDefaultProfile=16]="HasNonDefaultProfile",m[m.HasConfigurable=32]="HasConfigurable"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(m){m[m.Error=0]="Error",m[m.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var D;(function(m){m[m.NotExpandable=0]="NotExpandable",m[m.Expandable=1]="Expandable",m[m.BusyExpanding=2]="BusyExpanding",m[m.Expanded=3]="Expanded"})(D=e.TestItemExpandState||(e.TestItemExpandState={}));const M=(m,t)=>{t.expand!==void 0&&(m.expand=t.expand),t.item!==void 0&&(m.item=m.item?Object.assign(m.item,t.item):t.item)};e.applyTestItemUpdate=M;var T;(function(m){m[m.Function=0]="Function",m[m.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var y;(function(m){m[m.Add=0]="Add",m[m.Update=1]="Update",m[m.Remove=2]="Remove",m[m.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",m[m.Retire=4]="Retire",m[m.AddTag=5]="AddTag",m[m.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class F{add(t){}update(t){}remove(t,u){}complete(){}}e.IncrementalChangeCollector=F;class O{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const u=this.createChangeCollector();for(const s of t)switch(s[0]){case 0:{const a=s[1];if(a.parent){if(this.items.has(a.parent)){const l=this.items.get(a.parent);l.children.add(a.item.extId);const k=this.createItem(a,l);this.items.set(a.item.extId,k),u.add(k)}}else{const l=this.createItem(a);this.roots.add(l),this.items.set(a.item.extId,l),u.add(l)}a.expand===2&&this.busyControllerCount++;break}case 1:{const a=s[1],l=this.items.get(a.extId);if(!l)break;a.expand!==void 0&&(l.expand===2&&this.busyControllerCount--,a.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(l,a),u.update(l);break}case 2:{const a=this.items.get(s[1]);if(!a)break;a.parent?this.items.get(a.parent).children.delete(a.item.extId):this.roots.delete(a);const l=[[s[1]]];for(;l.length;)for(const k of l.pop()){const v=this.items.get(k);v&&(l.push(v.children),this.items.delete(k),u.remove(v,v!==a),v.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}u.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new F}}e.AbstractIncrementalTestCollection=O}),define(be[60],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(D){D.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class _{constructor(M,T=M.length){if(this.path=M,this.viewEnd=T,M.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(M,T,y=M.parent){if(M.id===T)return new _([T]);let F=[M.id];for(let O=y;O&&O.id!==T;O=O.parent)F.push(O.id);return F.push(T),new _(F.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const T=M.indexOf("\0");return T===-1?M:M.slice(0,T)}static fromString(M){return new _(M.split("\0"))}static join(M,T){return new _([...M.path,T])}static joinToString(M,T){return M.toString()+"\0"+T}static compare(M,T){return M===T?0:T.startsWith(M+"\0")?2:M.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let M=1;M<=this.viewEnd;M++)yield new _(this.path,M)}compare(M){if(typeof M=="string")return _.compare(this.toString(),M);for(let T=0;T<M.viewEnd&&T<this.viewEnd;T++)if(M.path[T]!==this.path[T])return 1;return M.viewEnd>this.viewEnd?2:M.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let M=1;M<this.viewEnd;M++)this.stringifed+="\0",this.stringifed+=this.path[M]}return this.stringifed}}e.TestId=_}),define(be[161],we([0,1,19,83,13,25,28,70,128]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class F{constructor(m,t,u){this._contributedVariables=new Map,this._context=m,this._labelService=t,u&&(this._envVariablesPromise=u.then(s=>this.prepareEnv(s)))}prepareEnv(m){if(M.isWindows){const t=Object.create(null);return Object.keys(m).forEach(u=>{t[u.toLowerCase()]=m[u]}),t}return m}resolveWithEnvironment(m,t,u){return this.recursiveResolve(this.prepareEnv(m),t?t.uri:void 0,u)}async resolveAsync(m,t){return this.recursiveResolve(await this._envVariablesPromise,m?m.uri:void 0,t)}async resolveAnyBase(m,t,u,s){const a=D.deepClone(t);return M.isWindows&&a.windows?Object.keys(a.windows).forEach(l=>a[l]=a.windows[l]):M.isMacintosh&&a.osx?Object.keys(a.osx).forEach(l=>a[l]=a.osx[l]):M.isLinux&&a.linux&&Object.keys(a.linux).forEach(l=>a[l]=a.linux[l]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,m?m.uri:void 0,a,u,s)}async resolveAnyAsync(m,t,u){return this.resolveAnyBase(m,t,u)}async resolveAnyMap(m,t,u){const s=new Map;return{newConfig:await this.resolveAnyBase(m,t,u,s),resolvedVariables:s}}resolveWithInteractionReplace(m,t,u,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,t,u,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,t){if(this._contributedVariables.has(m))throw new Error("Variable "+m+" is contributed twice.");this._contributedVariables.set(m,t)}recursiveResolve(m,t,u,s,a){if(_.isString(u))return this.resolveString(m,t,u,s,a);if(_.isArray(u))return u.map(l=>this.recursiveResolve(m,t,l,s,a));if(_.isObject(u)){let l=Object.create(null);return Object.keys(u).forEach(k=>{const v=this.resolveString(m,t,k,s,a);l[v]=this.recursiveResolve(m,t,u[k],s,a)}),l}return u}resolveString(m,t,u,s,a){return u.replace(F.VARIABLE_REGEXP,(k,v)=>{if(v.includes(F.VARIABLE_LHS))return k;let b=this.evaluateSingleVariable(m,k,v,t,s);return a&&a.set(v,b),b!==k&&_.isString(b)&&b.match(F.VARIABLE_REGEXP)&&(b=this.resolveString(m,t,b,s,a)),b})}fsPath(m){return this._labelService?this._labelService.getUriLabel(m,{noPrefix:!0}):m.fsPath}evaluateSingleVariable(m,t,u,s,a){let l;const k=u.split(":");k.length>1&&(u=k[0],l=k[1]);const v=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,y.localize)(0,null,t))},b=()=>{const S=v();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,y.localize)(1,null,t,i.basename(S)))},o=()=>{if(l){const S=this._context.getFolderUri(l);if(S)return S;throw new Error((0,y.localize)(2,null,t,l))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,t)):new Error((0,y.localize)(4,null,t))};switch(u){case"env":if(l){if(m){const S=m[M.isWindows?l.toLowerCase():l];if(_.isString(S))return S}return""}throw new Error((0,y.localize)(5,null,t));case"config":if(l){const S=this._context.getConfigurationValue(s,l);if(_.isUndefinedOrNull(S))throw new Error((0,y.localize)(6,null,t,l));if(_.isObject(S))throw new Error((0,y.localize)(7,null,t,l));return S}throw new Error((0,y.localize)(8,null,t));case"command":return this.resolveFromMap(t,l,a,"command");case"input":return this.resolveFromMap(t,l,a,"input");default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return s||l?(0,T.normalizeDriveLetter)(this.fsPath(o())):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(this.fsPath(o()));case"lineNumber":{const S=this._context.getLineNumber();if(S)return S;throw new Error((0,y.localize)(9,null,t))}case"selectedText":{const S=this._context.getSelectedText();if(S)return S;throw new Error((0,y.localize)(10,null,t))}case"file":return v();case"fileWorkspaceFolder":return b();case"relativeFile":return s||l?i.relative(this.fsPath(o()),v()):v();case"relativeFileDirname":{const S=i.dirname(v());if(s||l){const n=i.relative(this.fsPath(o()),S);return n.length===0?".":n}return S}case"fileDirname":return i.dirname(v());case"fileExtname":return i.extname(v());case"fileBasename":return i.basename(v());case"fileBasenameNoExtension":{const S=i.basename(v());return S.slice(0,S.length-i.extname(S).length)}case"fileDirnameBasename":return i.basename(i.dirname(v()));case"execPath":{const S=this._context.getExecPath();return S||t}case"execInstallFolder":{const S=this._context.getAppRoot();return S||t}case"pathSeparator":return i.sep;default:try{const S=l?`${u}:${l}`:u;return this.resolveFromMap(t,S,a,void 0)}catch{return t}}}}resolveFromMap(m,t,u,s){if(t&&u){const a=s===void 0?u[t]:u[s+":"+t];if(typeof a=="string")return a;throw new Error((0,y.localize)(11,null,m))}return m}}e.AbstractVariableResolverService=F,F.VARIABLE_LHS="${",F.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[84],we([0,1,3,153]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var _;(function(s){s[s.UP=0]="UP",s[s.DOWN=1]="DOWN",s[s.LEFT=2]="LEFT",s[s.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var D;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var M;(function(s){s[s.FIRST=0]="FIRST",s[s.LAST=1]="LAST",s[s.NEXT=2]="NEXT",s[s.PREVIOUS=3]="PREVIOUS"})(M=e.GroupLocation||(e.GroupLocation={}));var T;(function(s){s[s.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",s[s.EVEN=1]="EVEN",s[s.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(s){s[s.COPY_EDITORS=0]="COPY_EDITORS",s[s.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function F(s){const a=s;return(0,A.isEditorInput)(a?.editor)&&(0,A.isEditorInput)(a?.replacement)}e.isEditorReplacement=F;var O;(function(s){s[s.CREATION_TIME=0]="CREATION_TIME",s[s.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",s[s.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var m;(function(s){s[s.NEW_EDITOR=1]="NEW_EDITOR",s[s.MOVE_EDITOR=2]="MOVE_EDITOR",s[s.COPY_EDITOR=3]="COPY_EDITOR"})(m=e.OpenEditorContext||(e.OpenEditorContext={}));function t(s){const a=s;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=t;function u(s){return s.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(be[162],we([0,1,3,84]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(D){const M=D;return typeof D=="number"||(0,A.isEditorGroup)(M)}e.isPreferredGroup=_}),define(be[8],we([0,1,16,21,69,224,53,25,13,2,85,86,129,75,47,81,60,162,6]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var b;(function(ae){function le(W){const{selectionStartLineNumber:pe,selectionStartColumn:Ce,positionLineNumber:ze,positionColumn:Ue}=W,dt=new v.Position(pe-1,Ce-1),bt=new v.Position(ze-1,Ue-1);return new v.Selection(dt,bt)}ae.to=le;function ie(W){const{anchor:pe,active:Ce}=W;return{selectionStartLineNumber:pe.line+1,selectionStartColumn:pe.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}ae.from=ie})(b=e.Selection||(e.Selection={}));var o;(function(ae){function le(W){if(!W)return;const{start:pe,end:Ce}=W;return{startLineNumber:pe.line+1,startColumn:pe.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}ae.from=le;function ie(W){if(!W)return;const{startLineNumber:pe,startColumn:Ce,endLineNumber:ze,endColumn:Ue}=W;return new v.Range(pe-1,Ce-1,ze-1,Ue-1)}ae.to=ie})(o=e.Range||(e.Range={}));var S;(function(ae){function le(ie){switch(ie){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 3:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}ae.to=le})(S=e.TokenType||(e.TokenType={}));var n;(function(ae){function le(W){return new v.Position(W.lineNumber-1,W.column-1)}ae.to=le;function ie(W){return{lineNumber:W.line+1,column:W.character+1}}ae.from=ie})(n=e.Position||(e.Position={}));var P;(function(ae){function le(pe,Ce){return(0,i.coalesce)((0,i.asArray)(pe).map(ze=>ie(ze,Ce)))}ae.from=le;function ie(pe,Ce){if(typeof pe=="string")return{$serialized:!0,language:pe};if(pe)return{$serialized:!0,language:pe.language,scheme:W(pe.scheme,Ce),pattern:Q.from(pe.pattern)??void 0,exclusive:pe.exclusive}}function W(pe,Ce){return Ce&&typeof pe=="string"?Ce.transformOutgoingScheme(pe):pe}})(P=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ae){function le(W){switch(W){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}ae.from=le;function ie(W){switch(W){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}ae.to=ie})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(ae){function le(W){let pe;return W.code&&((0,y.isString)(W.code)||(0,y.isNumber)(W.code)?pe=String(W.code):pe={value:String(W.code.value),target:W.code.target}),{...o.from(W.range),message:W.message,source:W.source,code:pe,severity:h.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(w.from),tags:Array.isArray(W.tags)?(0,i.coalesce)(W.tags.map(r.from)):void 0}}ae.from=le;function ie(W){const pe=new v.Diagnostic(o.to(W),W.message,h.to(W.severity));return pe.source=W.source,pe.code=(0,y.isString)(W.code)?W.code:W.code?.value,pe.relatedInformation=W.relatedInformation&&W.relatedInformation.map(w.to),pe.tags=W.tags&&(0,i.coalesce)(W.tags.map(r.to)),pe}ae.to=ie})(c=e.Diagnostic||(e.Diagnostic={}));var w;(function(ae){function le(W){return{...o.from(W.location.range),message:W.message,resource:W.location.uri}}ae.from=le;function ie(W){return new v.DiagnosticRelatedInformation(new v.Location(W.resource,o.to(W)),W.message)}ae.to=ie})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(ae){function le(W){switch(W){case v.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}ae.from=le;function ie(W){switch(W){case u.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}ae.to=ie})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(ae){function le(W){return typeof W=="number"&&W>=v.ViewColumn.One?W-1:W===v.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}ae.from=le;function ie(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=ie})(d=e.ViewColumn||(e.ViewColumn={}));function g(ae){return typeof ae.range!="undefined"}function f(ae){return ae.length===0?!0:!!g(ae[0])}e.isDecorationOptionsArr=f;var E;(function(ae){function le(Ue){return Ue.map(ae.from)}ae.fromMany=le;function ie(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function W(Ue){let dt;if(ie(Ue)){const{language:gt,value:pt}=Ue;dt={value:"```"+gt+`
`+pt+"\n```\n"}}else v.MarkdownString.isMarkdownString(Ue)?dt={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?dt={value:Ue}:dt={value:""};const bt=Object.create(null);dt.uris=bt;const yt=gt=>{try{let pt=F.URI.parse(gt,!0);pt=pt.with({query:pe(pt.query,bt)}),bt[gt]=pt}catch{}return""},st=new D.Renderer;return st.link=yt,st.image=gt=>yt(_.parseHrefAndDimensions(gt).href),D(dt.value,{renderer:st}),dt}ae.from=W;function pe(Ue,dt){if(!Ue)return Ue;let bt;try{bt=(0,M.parse)(Ue)}catch{}if(!bt)return Ue;let yt=!1;return bt=(0,T.cloneAndChange)(bt,st=>{if(F.URI.isUri(st)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[gt]=st,yt=!0,gt}else return}),yt?JSON.stringify(bt):Ue}function Ce(Ue){const dt=new v.MarkdownString(Ue.value,Ue.supportThemeIcons);return dt.isTrusted=Ue.isTrusted,dt.supportHtml=Ue.supportHtml,dt}ae.to=Ce;function ze(Ue){if(!!Ue)return typeof Ue=="string"?Ue:ae.from(Ue)}ae.fromStrict=ze})(E=e.MarkdownString||(e.MarkdownString={}));function C(ae){return f(ae)?ae.map(le=>({range:o.from(le.range),hoverMessage:Array.isArray(le.hoverMessage)?E.fromMany(le.hoverMessage):le.hoverMessage?E.from(le.hoverMessage):void 0,renderOptions:le.renderOptions})):ae.map(le=>({range:o.from(le)}))}e.fromRangeOrRangeWithMessage=C;function I(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?F.URI.file(ae):ae}e.pathOrURIToURI=I;var N;(function(ae){function le(ie){return typeof ie=="undefined"?ie:{contentText:ie.contentText,contentIconPath:ie.contentIconPath?I(ie.contentIconPath):void 0,border:ie.border,borderColor:ie.borderColor,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,color:ie.color,backgroundColor:ie.backgroundColor,margin:ie.margin,width:ie.width,height:ie.height}}ae.from=le})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var p;(function(ae){function le(ie){return typeof ie=="undefined"?ie:{backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?I(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?N.from(ie.before):void 0,after:ie.after?N.from(ie.after):void 0}}ae.from=le})(p=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ae){function le(ie){if(typeof ie=="undefined")return ie;switch(ie){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=le})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ae){function le(ie){return{isWholeLine:ie.isWholeLine,rangeBehavior:ie.rangeBehavior?R.from(ie.rangeBehavior):void 0,overviewRulerLane:ie.overviewRulerLane,light:ie.light?p.from(ie.light):void 0,dark:ie.dark?p.from(ie.dark):void 0,backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?I(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?N.from(ie.before):void 0,after:ie.after?N.from(ie.after):void 0}}ae.from=le})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(ae){function le(W){return{text:W.newText,eol:W.newEol&&mt.from(W.newEol),range:o.from(W.range)}}ae.from=le;function ie(W){const pe=new v.TextEdit(o.to(W.range),W.text);return pe.newEol=typeof W.eol=="undefined"?void 0:mt.to(W.eol),pe}ae.to=ie})(j=e.TextEdit||(e.TextEdit={}));var H;(function(ae){function le(W,pe,Ce){const ze={edits:[]};if(W instanceof v.WorkspaceEdit)for(let Ue of W._allEntries())if(Ue._type===1)ze.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const dt=pe?.getDocument(Ue.uri);ze.edits.push({_type:2,resource:Ue.uri,edit:j.from(Ue.edit),modelVersionId:dt?.version,metadata:Ue.metadata})}else Ue._type===3?ze.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ce?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&ze.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ce?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(wt.from)}});return ze}ae.from=le;function ie(W){const pe=new v.WorkspaceEdit;for(const Ce of W.edits)Ce.edit?pe.replace(F.URI.revive(Ce.resource),o.to(Ce.edit.range),Ce.edit.text):pe.renameFile(F.URI.revive(Ce.oldUri),F.URI.revive(Ce.newUri),Ce.options);return pe}ae.to=ie})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ae){const le=Object.create(null);le[v.SymbolKind.File]=0,le[v.SymbolKind.Module]=1,le[v.SymbolKind.Namespace]=2,le[v.SymbolKind.Package]=3,le[v.SymbolKind.Class]=4,le[v.SymbolKind.Method]=5,le[v.SymbolKind.Property]=6,le[v.SymbolKind.Field]=7,le[v.SymbolKind.Constructor]=8,le[v.SymbolKind.Enum]=9,le[v.SymbolKind.Interface]=10,le[v.SymbolKind.Function]=11,le[v.SymbolKind.Variable]=12,le[v.SymbolKind.Constant]=13,le[v.SymbolKind.String]=14,le[v.SymbolKind.Number]=15,le[v.SymbolKind.Boolean]=16,le[v.SymbolKind.Array]=17,le[v.SymbolKind.Object]=18,le[v.SymbolKind.Key]=19,le[v.SymbolKind.Null]=20,le[v.SymbolKind.EnumMember]=21,le[v.SymbolKind.Struct]=22,le[v.SymbolKind.Event]=23,le[v.SymbolKind.Operator]=24,le[v.SymbolKind.TypeParameter]=25;function ie(pe){return typeof le[pe]=="number"?le[pe]:6}ae.from=ie;function W(pe){for(const Ce in le)if(le[Ce]===pe)return Number(Ce);return v.SymbolKind.Property}ae.to=W})(z=e.SymbolKind||(e.SymbolKind={}));var K;(function(ae){function le(W){switch(W){case v.SymbolTag.Deprecated:return 1}}ae.from=le;function ie(W){switch(W){case 1:return v.SymbolTag.Deprecated}}ae.to=ie})(K=e.SymbolTag||(e.SymbolTag={}));var ce;(function(ae){function le(W){return{name:W.name,kind:z.from(W.kind),tags:W.tags&&W.tags.map(K.from),containerName:W.containerName,location:ve.from(W.location)}}ae.from=le;function ie(W){const pe=new v.SymbolInformation(W.name,z.to(W.kind),W.containerName,ve.to(W.location));return pe.tags=W.tags&&W.tags.map(K.to),pe}ae.to=ie})(ce=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(ae){function le(W){const pe={name:W.name||"!!MISSING: name!!",detail:W.detail,range:o.from(W.range),selectionRange:o.from(W.selectionRange),kind:z.from(W.kind),tags:W.tags?.map(K.from)??[]};return W.children&&(pe.children=W.children.map(le)),pe}ae.from=le;function ie(W){const pe=new v.DocumentSymbol(W.name,W.detail,z.to(W.kind),o.to(W.range),o.to(W.selectionRange));return(0,i.isNonEmptyArray)(W.tags)&&(pe.tags=W.tags.map(K.to)),W.children&&(pe.children=W.children.map(ie)),pe}ae.to=ie})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(ae){function le(W){const pe=new v.CallHierarchyItem(z.to(W.kind),W.name,W.detail||"",F.URI.revive(W.uri),o.to(W.range),o.to(W.selectionRange));return pe._sessionId=W._sessionId,pe._itemId=W._itemId,pe}ae.to=le;function ie(W,pe,Ce){if(pe=pe??W._sessionId,Ce=Ce??W._itemId,pe===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:pe,_itemId:Ce,name:W.name,detail:W.detail,kind:z.from(W.kind),uri:W.uri,range:o.from(W.range),selectionRange:o.from(W.selectionRange),tags:W.tags?.map(K.from)}}ae.from=ie})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(ae){function le(ie){return new v.CallHierarchyIncomingCall(re.to(ie.from),ie.fromRanges.map(W=>o.to(W)))}ae.to=le})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ye;(function(ae){function le(ie){return new v.CallHierarchyOutgoingCall(re.to(ie.to),ie.fromRanges.map(W=>o.to(W)))}ae.to=le})(ye=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(ae){function le(W){return{range:W.range&&o.from(W.range),uri:W.uri}}ae.from=le;function ie(W){return new v.Location(F.URI.revive(W.uri),o.to(W.range))}ae.to=ie})(ve=e.location||(e.location={}));var Me;(function(ae){function le(W){const pe=W,Ce=W;return{originSelectionRange:pe.originSelectionRange?o.from(pe.originSelectionRange):void 0,uri:pe.targetUri?pe.targetUri:Ce.uri,range:o.from(pe.targetRange?pe.targetRange:Ce.range),targetSelectionRange:pe.targetSelectionRange?o.from(pe.targetSelectionRange):void 0}}ae.from=le;function ie(W){return{targetUri:F.URI.revive(W.uri),targetRange:o.to(W.range),targetSelectionRange:W.targetSelectionRange?o.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?o.to(W.originSelectionRange):void 0}}ae.to=ie})(Me=e.DefinitionLink||(e.DefinitionLink={}));var je;(function(ae){function le(W){return{range:o.from(W.range),contents:E.fromMany(W.contents)}}ae.from=le;function ie(W){return new v.Hover(W.contents.map(E.to),o.to(W.range))}ae.to=ie})(je=e.Hover||(e.Hover={}));var et;(function(ae){function le(W){return{range:o.from(W.range),expression:W.expression}}ae.from=le;function ie(W){return new v.EvaluatableExpression(o.to(W.range),W.expression)}ae.to=ie})(et=e.EvaluatableExpression||(e.EvaluatableExpression={}));var lt;(function(ae){function le(W){if(W instanceof v.InlineValueText)return{type:"text",range:o.from(W.range),text:W.text};if(W instanceof v.InlineValueVariableLookup)return{type:"variable",range:o.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=le;function ie(W){switch(W.type){case"text":return{range:o.to(W.range),text:W.text};case"variable":return{range:o.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:o.to(W.range),expression:W.expression}}}ae.to=ie})(lt=e.InlineValue||(e.InlineValue={}));var it;(function(ae){function le(W){return{frameId:W.frameId,stoppedLocation:o.from(W.stoppedLocation)}}ae.from=le;function ie(W){return new v.InlineValueContext(W.frameId,o.to(W.stoppedLocation))}ae.to=ie})(it=e.InlineValueContext||(e.InlineValueContext={}));var ft;(function(ae){function le(W){return{range:o.from(W.range),kind:W.kind}}ae.from=le;function ie(W){return new v.DocumentHighlight(o.to(W.range),W.kind)}ae.to=ie})(ft=e.DocumentHighlight||(e.DocumentHighlight={}));var _t;(function(ae){function le(ie){switch(ie){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}ae.to=le})(_t=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ut;(function(ae){function le(ie){return{triggerKind:_t.to(ie.triggerKind),triggerCharacter:ie.triggerCharacter}}ae.to=le})(ut=e.CompletionContext||(e.CompletionContext={}));var rt;(function(ae){function le(W){switch(W){case v.CompletionItemTag.Deprecated:return 1}}ae.from=le;function ie(W){switch(W){case 1:return v.CompletionItemTag.Deprecated}}ae.to=ie})(rt=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(ae){const le=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ie(Ce){return le.get(Ce)??9}ae.from=ie;const W=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function pe(Ce){return W.get(Ce)??v.CompletionItemKind.Property}ae.to=pe})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(ae){function le(ie,W){const pe=new v.CompletionItem(ie.label);return pe.insertText=ie.insertText,pe.kind=B.to(ie.kind),pe.tags=ie.tags?.map(rt.to),pe.detail=ie.detail,pe.documentation=_.isMarkdownString(ie.documentation)?E.to(ie.documentation):ie.documentation,pe.sortText=ie.sortText,pe.filterText=ie.filterText,pe.preselect=ie.preselect,pe.commitCharacters=ie.commitCharacters,O.Range.isIRange(ie.range)?pe.range=o.to(ie.range):typeof ie.range=="object"&&(pe.range={inserting:o.to(ie.range.insert),replacing:o.to(ie.range.replace)}),pe.keepWhitespace=typeof ie.insertTextRules=="undefined"?!1:Boolean(ie.insertTextRules&1),typeof ie.insertTextRules!="undefined"&&ie.insertTextRules&4?pe.insertText=new v.SnippetString(ie.insertText):(pe.insertText=ie.insertText,pe.textEdit=pe.range instanceof v.Range?new v.TextEdit(pe.range,pe.insertText):void 0),ie.additionalTextEdits&&ie.additionalTextEdits.length>0&&(pe.additionalTextEdits=ie.additionalTextEdits.map(Ce=>j.to(Ce))),pe.command=W&&ie.command?W.fromInternal(ie.command):void 0,pe}ae.to=le})(G=e.CompletionItem||(e.CompletionItem={}));var $;(function(ae){function le(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0}}ae.from=le;function ie(W){return{label:W.label,documentation:_.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation}}ae.to=ie})($=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(ae){function le(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map($.from):[],activeParameter:W.activeParameter}}ae.from=le;function ie(W){return{label:W.label,documentation:_.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map($.to):[],activeParameter:W.activeParameter}}ae.to=ie})(V=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(ae){function le(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(V.from):[]}}ae.from=le;function ie(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(V.to):[]}}ae.to=ie})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ne;(function(ae){function le(ie,W){const pe=new v.InlayHint(typeof W.label=="string"?W.label:W.label.map(me.to.bind(void 0,ie)),n.to(W.position),Fe.to(W.kind));return pe.tooltip=_.isMarkdownString(W.tooltip)?E.to(W.tooltip):W.tooltip,pe.paddingLeft=W.paddingLeft,pe.paddingRight=W.paddingRight,pe}ae.to=le})(ne=e.InlayHint||(e.InlayHint={}));var me;(function(ae){function le(ie,W){const pe=new v.InlayHintLabelPart(W.label);return pe.tooltip=_.isMarkdownString(W.tooltip)?E.to(W.tooltip):W.tooltip,m.Command.is(W.command)&&(pe.command=ie.fromInternal(W.command)),W.location&&(pe.location=ve.to(W.location)),pe}ae.to=le})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Fe;(function(ae){function le(W){return W}ae.from=le;function ie(W){return W}ae.to=ie})(Fe=e.InlayHintKind||(e.InlayHintKind={}));var $e;(function(ae){function le(W){return{range:o.from(W.range),url:W.target,tooltip:W.tooltip}}ae.from=le;function ie(W){let pe;if(W.url)try{pe=typeof W.url=="string"?F.URI.parse(W.url,!0):F.URI.revive(W.url)}catch{}return new v.DocumentLink(o.to(W.range),pe)}ae.to=ie})($e=e.DocumentLink||(e.DocumentLink={}));var qe;(function(ae){function le(W){const pe=new v.ColorPresentation(W.label);return W.textEdit&&(pe.textEdit=j.to(W.textEdit)),W.additionalTextEdits&&(pe.additionalTextEdits=W.additionalTextEdits.map(Ce=>j.to(Ce))),pe}ae.to=le;function ie(W){return{label:W.label,textEdit:W.textEdit?j.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(pe=>j.from(pe)):void 0}}ae.from=ie})(qe=e.ColorPresentation||(e.ColorPresentation={}));var Je;(function(ae){function le(W){return new v.Color(W[0],W[1],W[2],W[3])}ae.to=le;function ie(W){return[W.red,W.green,W.blue,W.alpha]}ae.from=ie})(Je=e.Color||(e.Color={}));var Ze;(function(ae){function le(W){return{range:o.from(W.range)}}ae.from=le;function ie(W){return new v.SelectionRange(o.to(W.range))}ae.to=ie})(Ze=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ae){function le(ie){switch(ie){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}ae.to=le})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(ae){function le(W){switch(W){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=le;function ie(W){switch(W){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}ae.to=ie})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var mt;(function(ae){function le(W){if(W===v.EndOfLine.CRLF)return 1;if(W===v.EndOfLine.LF)return 0}ae.from=le;function ie(W){if(W===1)return v.EndOfLine.CRLF;if(W===0)return v.EndOfLine.LF}ae.to=ie})(mt=e.EndOfLine||(e.EndOfLine={}));var Tt;(function(ae){function le(ie){if(typeof ie=="object")return ie.viewId;switch(ie){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=le})(Tt=e.ProgressLocation||(e.ProgressLocation={}));var Te;(function(ae){function le(ie){const W={start:ie.start+1,end:ie.end+1};return ie.kind&&(W.kind=kt.from(ie.kind)),W}ae.from=le})(Te=e.FoldingRange||(e.FoldingRange={}));var kt;(function(ae){function le(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}ae.from=le})(kt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var q;(function(ae){function le(ie){if(ie)return{pinned:typeof ie.preview=="boolean"?!ie.preview:void 0,inactive:ie.background,preserveFocus:ie.preserveFocus,selection:typeof ie.selection=="object"?o.from(ie.selection):void 0,override:typeof ie.override=="boolean"?t.EditorResolution.DISABLED:void 0}}ae.from=le})(q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(ae){function le(Ce){return Ce instanceof v.RelativePattern?Ce.toJSON():typeof Ce=="string"?Ce:ie(Ce)||W(Ce)?new v.RelativePattern(Ce.baseUri??Ce.base,Ce.pattern).toJSON():Ce}ae.from=le;function ie(Ce){const ze=Ce;return ze?F.URI.isUri(ze.baseUri)&&typeof ze.pattern=="string":!1}function W(Ce){const ze=Ce;return ze?typeof ze.base=="string"&&typeof ze.pattern=="string":!1}function pe(Ce){return typeof Ce=="string"?Ce:new v.RelativePattern(F.URI.revive(Ce.baseUri),Ce.pattern)}ae.to=pe})(Q=e.GlobPattern||(e.GlobPattern={}));var se;(function(ae){function le(ie){if(ie){if(Array.isArray(ie))return ie.map(le);if(typeof ie=="string")return ie;{const W=ie;return{language:W.language,scheme:W.scheme,pattern:Q.from(W.pattern),exclusive:W.exclusive}}}else return}ae.from=le})(se=e.LanguageSelector||(e.LanguageSelector={}));var Oe;(function(ae){function le(W){return{start:W.start,end:W.end}}ae.from=le;function ie(W){return new v.NotebookRange(W.start,W.end)}ae.to=ie})(Oe=e.NotebookRange||(e.NotebookRange={}));var He;(function(ae){function le(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ae.to=le;function ie(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ae.from=ie})(He=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var tt;(function(ae){function le(W){switch(W){case v.NotebookCellKind.Markup:return a.CellKind.Markup;case v.NotebookCellKind.Code:default:return a.CellKind.Code}}ae.from=le;function ie(W){switch(W){case a.CellKind.Markup:return v.NotebookCellKind.Markup;case a.CellKind.Code:default:return v.NotebookCellKind.Code}}ae.to=ie})(tt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(ae){function le(W){const pe={metadata:W.metadata??Object.create(null),cells:[]};for(let Ce of W.cells)v.NotebookCellData.validate(Ce),pe.cells.push(wt.from(Ce));return pe}ae.from=le;function ie(W){const pe=new v.NotebookData(W.cells.map(wt.to));return(0,y.isEmptyObject)(W.metadata)||(pe.metadata=W.metadata),pe}ae.to=ie})(Ve=e.NotebookData||(e.NotebookData={}));var wt;(function(ae){function le(W){return{cellKind:tt.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:He.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Se.from):[]}}ae.from=le;function ie(W){return new v.NotebookCellData(tt.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Se.to):void 0,W.metadata,W.internalMetadata?He.to(W.internalMetadata):void 0)}ae.to=ie})(wt=e.NotebookCellData||(e.NotebookCellData={}));var Ie;(function(ae){function le(W){return{mime:W.mime,valueBytes:A.VSBuffer.wrap(W.data)}}ae.from=le;function ie(W){return new v.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ae.to=ie})(Ie=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Se;(function(ae){function le(W){return{outputId:W.id,items:W.items.map(Ie.from),metadata:W.metadata}}ae.from=le;function ie(W){const pe=W.items.map(Ie.to);return new v.NotebookCellOutput(pe,W.outputId,W.metadata)}ae.to=ie})(Se=e.NotebookCellOutput||(e.NotebookCellOutput={}));var he;(function(ae){function le(pe){return W(pe)?{include:(0,y.withNullAsUndefined)(Q.from(pe.include)),exclude:(0,y.withNullAsUndefined)(Q.from(pe.exclude))}:(0,y.withNullAsUndefined)(Q.from(pe))}ae.from=le;function ie(pe){return W(pe)?{include:Q.to(pe.include),exclude:Q.to(pe.exclude)}:Q.to(pe)}ae.to=ie;function W(pe){const Ce=pe;return Ce?!!Ce.include&&!!Ce.exclude:!1}})(he=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ee;(function(ae){function le(ie){return{backgroundColor:ie.backgroundColor,borderColor:ie.borderColor,top:ie.top?N.from(ie.top):void 0}}ae.from=le})(ee=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var te;(function(ae){function le(ie,W,pe){const Ce=typeof ie.command=="string"?{title:"",command:ie.command}:ie.command;return{alignment:ie.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Ce,pe),text:ie.text,tooltip:ie.tooltip,accessibilityInformation:ie.accessibilityInformation,priority:ie.priority}}ae.from=le})(te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ae){function le(ie){return{transientOutputs:ie?.transientOutputs??!1,transientCellMetadata:ie?.transientCellMetadata??{},transientDocumentMetadata:ie?.transientDocumentMetadata??{}}}ae.from=le})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(ae){function le(W){return{uri:W.uri,provides:W.provides}}ae.from=le;function ie(W){return new v.NotebookRendererScript(F.URI.revive(W.uri),W.provides)}ae.to=ie})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ke;(function(ae){function le(W){return{message:E.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ve.from(W.location):void 0}}ae.from=le;function ie(W){const pe=new v.TestMessage(typeof W.message=="string"?W.message:E.to(W.message));return pe.actualOutput=W.actual,pe.expectedOutput=W.expected,pe.location=W.location?ve.to(W.location):void 0,pe}ae.to=ie})(ke=e.TestMessage||(e.TestMessage={}));var xe;(function(ae){let le;(function(ie){ie.Delimiter="\0"})(le||(le={})),ae.namespace=(ie,W)=>ie+"\0"+W,ae.denamespace=ie=>{const W=ie.indexOf("\0");return{ctrlId:ie.slice(0,W),tagId:ie.slice(W+1)}}})(xe=e.TestTag||(e.TestTag={}));var Ae;(function(ae){function le(Ce){const ze=(0,s.getPrivateApiFor)(Ce).controllerId;return{extId:l.TestId.fromExtHostTestItem(Ce,ze).toString(),label:Ce.label,uri:Ce.uri,tags:Ce.tags.map(Ue=>xe.namespace(ze,Ue.id)),range:o.from(Ce.range)||null,description:Ce.description||null,error:Ce.error&&E.fromStrict(Ce.error)||null}}ae.from=le;function ie(Ce){return{parent:void 0,error:void 0,id:l.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:F.URI.revive(Ce.uri),tags:(Ce.tags||[]).map(ze=>{const{tagId:Ue}=xe.denamespace(ze);return new v.TestTag(Ue)}),range:o.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0}}ae.toPlain=ie;function W(Ce){const ze=l.TestId.fromString(Ce.extId),Ue=new s.TestItemImpl(ze.controllerId,ze.localId,Ce.label,F.URI.revive(Ce.uri));return Ue.range=o.to(Ce.range||void 0),Ue.description=Ce.description||void 0,Ue}function pe(Ce){let ze;for(const Ue of Ce.tests){const dt=W(Ue.item);(0,s.getPrivateApiFor)(dt).parent=ze,ze=dt}return ze}ae.toItemFromContext=pe})(Ae=e.TestItem||(e.TestItem={})),function(ae){function le(W){return{id:W.id}}ae.from=le;function ie(W){return new v.TestTag(W.id)}ae.to=ie}(xe=e.TestTag||(e.TestTag={}));var Be;(function(ae){const le=(W,pe)=>{const Ce={...Ae.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ue=>Ue.type===0).map(ke.to)})),children:W.children.map(ze=>pe.get(ze)).filter(y.isDefined).map(ze=>le(ze,pe))};for(const ze of Ce.children)ze.parent=Ce;return Ce};function ie(W){const pe=[],Ce=new Map;for(const ze of W.items)Ce.set(ze.item.extId,ze),W.request.targets.some(Ue=>Ue.controllerId===ze.controllerId&&Ue.testIds.includes(ze.item.extId))&&pe.push(ze);return{completedAt:W.completedAt,results:pe.map(ze=>le(ze,Ce))}}ae.to=ie})(Be=e.TestResults||(e.TestResults={}));var Xe;(function(ae){function le(Ce){return{covered:Ce.covered,total:Ce.covered}}function ie(Ce){return"line"in Ce?n.from(Ce):o.from(Ce)}function W(Ce){return"branches"in Ce?{count:Ce.executionCount,location:ie(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(ze=>({count:ze.executionCount,location:ze.location&&ie(ze.location)})):void 0}:{type:0,count:Ce.executionCount,location:ie(Ce.location)}}ae.fromDetailed=W;function pe(Ce){return{uri:Ce.uri,statement:le(Ce.statementCoverage),branch:Ce.branchCoverage&&le(Ce.branchCoverage),function:Ce.functionCoverage&&le(Ce.functionCoverage),details:Ce.detailedCoverage?.map(W)}}ae.fromFile=pe})(Xe=e.TestCoverage||(e.TestCoverage={}));var nt;(function(ae){function le(ie){switch(ie){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}ae.to=le})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Re;(function(ae){function le(W){const pe=new v.TypeHierarchyItem(z.to(W.kind),W.name,W.detail||"",F.URI.revive(W.uri),o.to(W.range),o.to(W.selectionRange));return pe._sessionId=W._sessionId,pe._itemId=W._itemId,pe}ae.to=le;function ie(W,pe,Ce){if(pe=pe??W._sessionId,Ce=Ce??W._itemId,pe===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:pe,_itemId:Ce,kind:z.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:o.from(W.range),selectionRange:o.from(W.selectionRange),tags:W.tags?.map(K.from)}}ae.from=ie})(Re=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[163],we([0,1,2,15,6,8,225]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(F,O,m,t={timeout:1500,errors:3}){this._logService=F,this._documents=O,this._mainThreadBulkEdits=m,this._thresholds=t,this._callbacks=new M.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(F){return(O,m,t)=>{const s={dispose:this._callbacks.push([O,m,F])};return Array.isArray(t)&&t.push(s),s}}async $participateInSave(F,O){const m=i.URI.revive(F);let t=!1;const u=setTimeout(()=>t=!0,this._thresholds.timeout),s=[];try{for(let a of[...this._callbacks]){if(t)break;const l=this._documents.getDocument(m),k=await this._deliverEventAsyncAndBlameBadListeners(a,{document:l,reason:D.TextDocumentSaveReason.to(O)});s.push(k)}}finally{clearTimeout(u)}return s}_deliverEventAsyncAndBlameBadListeners([F,O,m],t){const u=this._badListeners.get(F);return typeof u=="number"&&u>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(m,F,O,t).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const a=this._badListeners.get(F);this._badListeners.set(F,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(F,O,m,t){const u=[],s=Date.now(),{document:a,reason:l}=t,{version:k}=a,v=Object.freeze({document:a,reason:l,waitUntil(b){if(Object.isFrozen(u))throw(0,A.illegalState)("waitUntil can not be called async");u.push(Promise.resolve(b))}});try{O.apply(m,[v])}catch(b){return Promise.reject(b)}return Object.freeze(u),new Promise((b,o)=>{const S=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(u).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${F.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(S),b(n)}).catch(n=>{clearTimeout(S),o(n)})}).then(b=>{const o={edits:[]};for(const S of b)if(Array.isArray(S)&&S.every(n=>n instanceof _.TextEdit))for(const{newText:n,newEol:P,range:r}of S)o.edits.push({_type:2,resource:a.uri,edit:{range:r&&D.Range.from(r),text:n,eol:P&&D.EndOfLine.from(P)}});if(o.edits.length!==0)return k===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(be[164],we([0,1,11,25,2,8,81]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(m,t,u,s){this.start=m,this.deletedCount=t,this.deletedItems=u,this.items=s}static asApiEvents(m){return m.map(t=>({start:t.start,deletedCount:t.deletedCount,deletedItems:t.deletedItems,items:t.items.map(u=>u.apiCell)}))}}class y{constructor(m,t,u){this.notebook=m,this._extHostDocument=t,this._cellData=u,this.handle=u.handle,this.uri=_.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(m,t){return{EOL:t.eol,lines:t.source,languageId:t.language,uri:t.uri,isDirty:!1,versionId:1,notebook:m}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const m=this,t=this._extHostDocument.getDocument(this.uri);if(!t)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return m.notebook.getCellIndex(m)},notebook:m.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:t.document,get mime(){return m._mime},set mime(u){m._mime=u},get outputs(){return m._outputs.slice(0)},get metadata(){return m._metadata},get executionSummary(){return m._previousResult}})}return this._apiCell}setOutputs(m){this._outputs=m.map(D.NotebookCellOutput.to)}setOutputItems(m,t,u){const s=u.map(D.NotebookCellOutputItem.to),a=this._outputs.find(l=>l.id===m);a&&(t||(a.items.length=0),a.items.push(...s))}setMetadata(m){this._metadata=Object.freeze(m)}setInternalMetadata(m){this._internalMetadata=m,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(m))}setMime(m){}}e.ExtHostCell=y;class F{constructor(m,t,u,s,a,l){this._proxy=m,this._textDocumentsAndEditors=t,this._textDocuments=u,this._emitter=s,this.uri=a,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0),this._versionId=l.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const m=this;this._notebook={get uri(){return m.uri},get version(){return m._versionId},get notebookType(){return m._notebookType},get isDirty(){return m._isDirty},get isUntitled(){return m.uri.scheme===i.Schemas.untitled},get isClosed(){return m._disposed},get metadata(){return m._metadata},get cellCount(){return m._cells.length},cellAt(t){return t=m._validateIndex(t),m._cells[t].apiCell},getCells(t){return(t?m._getCells(t):m._cells).map(s=>s.apiCell)},save(){return m._save()}}}return this._notebook}updateBackup(m){this._backup?.delete(),this._backup=m}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(m){m.metadata&&(this._metadata=Object.freeze({...this._metadata,...m.metadata}))}acceptDirty(m){this._isDirty=m}acceptModelChanged(m,t){this._versionId=m.versionId,this._isDirty=t;for(const u of m.rawEvents)u.kind===M.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===M.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===M.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===M.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===M.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===M.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===M.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(m){return m=m|0,m<0?0:m>=this._cells.length?this._cells.length-1:m}_validateRange(m){let t=m.start|0,u=m.end|0;return t<0&&(t=0),u>this._cells.length&&(u=this._cells.length),m.with({start:t,end:u})}_getCells(m){m=this._validateRange(m);const t=[];for(let u=m.start;u<m.end;u++)t.push(this._cells[u]);return t}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(m,t){if(this._disposed)return;const u=[],s=[],a=[];m.reverse().forEach(l=>{const v=l[2].map(S=>{const n=new y(this,this._textDocumentsAndEditors,S);return t||s.push(y.asModelAddData(this.apiNotebook,S)),n}),b=new T(l[0],l[1],[],v),o=this._cells.splice(l[0],l[1],...v);for(const S of o)a.push(S.uri),b.deletedItems.push(S.apiCell);u.push(b)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),t||this._emitter.emitModelChange((0,A.deepFreeze)({document:this.apiNotebook,changes:T.asApiEvents(u)}))}_moveCell(m,t){const u=this._cells.splice(m,1);this._cells.splice(t,0,...u);const s=[new T(m,1,u.map(a=>a.apiCell),[]),new T(t,0,[],u)];this._emitter.emitModelChange((0,A.deepFreeze)({document:this.apiNotebook,changes:T.asApiEvents(s)}))}_setCellOutputs(m,t){const u=this._cells[m];u.setOutputs(t),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(m,t,u,s){const a=this._cells[m];a.setOutputItems(t,u,s),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_changeCellLanguage(m,t){const u=this._cells[m];u.apiCell.document.languageId!==t&&this._textDocuments.$acceptModelLanguageChanged(u.uri,t)}_changeCellMime(m,t){const u=this._cells[m];u.apiCell.mime=t}_changeCellMetadata(m,t){const u=this._cells[m],s=u.apiCell.metadata;u.setMetadata(t);const a=u.apiCell.metadata;(0,A.equals)(s,a)||this._emitter.emitCellMetadataChange((0,A.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(m,t){this._cells[m].setInternalMetadata(t)}getCellFromApiCell(m){return this._cells.find(t=>t.apiCell===m)}getCellFromIndex(m){return this._cells[m]}getCell(m){return this._cells.find(t=>t.handle===m)}getCellIndex(m){return this._cells.indexOf(m)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(be[87],we([0,1,6,8,15]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,F){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:F})}replaceCells(y,F,O){this._throwIfFinalized(),!(y===F&&O.length===0)&&this._collectedEdits.push({editType:1,index:y,count:F-y,cells:O.map(A.NotebookCellData.from)})}}class M{constructor(y,F,O,m,t,u){this.id=y,this._proxy=F,this.notebookData=O,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._visibleRanges=m,this._viewColumn=u}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(F){if(!Array.isArray(F)||!F.every(i.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");y._selections=F,y._trySetSelections(F)},get visibleRanges(){return y._visibleRanges},revealRange(F,O){y._proxy.$tryRevealRange(y.id,A.NotebookRange.from(F),O??i.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(F){const O=new D(this.document.version);return F(O),y._applyEdit(O.finalize())},setDecorations(F,O){return y.setDecorations(F,O)}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(A.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const F=[];let O=-1;for(let m=0;m<y.cellEdits.length;m++){if(O<0){F.push(y.cellEdits[m]),O++;continue}const u=F[O],s=y.cellEdits[m];if(u.editType===1&&s.editType===1&&u.index===s.index){u.cells.push(...y.cellEdits[m].cells),u.count+=y.cellEdits[m].count;continue}F.push(y.cellEdits[m]),O++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,F)}setDecorations(y,F){if(!(F.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return F.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,A.NotebookRange.from(F),y.key)}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(be[165],we([0,1,8,136,119,20,51,15]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(t){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=t}async withProgress(t,u,s){const a=this._handles++,{title:l,location:k,cancellable:v}=u,b={label:(0,_.localize)(0,null,t.displayName||t.name),id:t.identifier.value};return this._proxy.$startProgress(a,{location:i.ProgressLocation.from(k),title:l,source:b,cancellable:v},t.isUnderDevelopment?void 0:t.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(a,s,!!v)}_withProgress(t,u,s){let a;s&&(a=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(t,a));const l=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a&&a.dispose()};let k;try{k=u(new O(this._proxy,t),s&&a?a.token:D.CancellationToken.None)}catch(v){throw l(t),v}return k.then(v=>l(t),v=>l(t)),k}$acceptProgressCanceled(t){const u=this._mapHandleToCancellationSource.get(t);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(t))}}e.ExtHostProgress=y;function F(m,t){return m.message=t.message,typeof t.increment=="number"&&(typeof m.increment=="number"?m.increment+=t.increment:m.increment=t.increment),m}class O extends A.Progress{constructor(t,u){super(s=>this.throttledReport(s));this._proxy=t,this._handle=u}throttledReport(t){this._proxy.$progressReport(this._handle,t)}}Le([(0,M.throttle)(100,(m,t)=>F(m,t),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(be[88],we([0,1,41,15,52,8,6]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(t,u,s){const a=T._Keys.nextId();t.$registerTextEditorDecorationType(u.identifier,a,D.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:a,dispose(){t.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=T,T._Keys=new _.IdGenerator("TextEditorDecorationType");class y{constructor(t,u){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=t,this._documentVersionId=t.version,this._undoStopBefore=u.undoStopBefore,this._undoStopAfter=u.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(t,u){this._throwIfFinalized();let s=null;if(t instanceof M.Position)s=new M.Range(t,t);else if(t instanceof M.Range)s=t;else throw new Error("Unrecognized location");this._pushEdit(s,u,!1)}insert(t,u){this._throwIfFinalized(),this._pushEdit(new M.Range(t,t),u,!0)}delete(t){this._throwIfFinalized();let u=null;if(t instanceof M.Range)u=t;else throw new Error("Unrecognized location");this._pushEdit(u,null,!0)}_pushEdit(t,u,s){const a=this._document.validateRange(t);this._collectedEdits.push({range:a,text:u,forceMoveMarkers:s})}setEndOfLine(t){if(this._throwIfFinalized(),t!==M.EndOfLine.LF&&t!==M.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this._setEndOfLine=t}}e.TextEditorEdit=y;class F{constructor(t,u,s,a){this._proxy=t,this._id=u,this._accept(s),this._logService=a;const l=this;this.value={get tabSize(){return l._tabSize},set tabSize(k){l._setTabSize(k)},get insertSpaces(){return l._insertSpaces},set insertSpaces(k){l._setInsertSpaces(k)},get cursorStyle(){return l._cursorStyle},set cursorStyle(k){l._setCursorStyle(k)},get lineNumbers(){return l._lineNumbers},set lineNumbers(k){l._setLineNumbers(k)}}}_accept(t){this._tabSize=t.tabSize,this._insertSpaces=t.insertSpaces,this._cursorStyle=t.cursorStyle,this._lineNumbers=D.TextEditorLineNumbersStyle.to(t.lineNumbers)}_validateTabSize(t){if(t==="auto")return"auto";if(typeof t=="number"){const u=Math.floor(t);return u>0?u:null}if(typeof t=="string"){const u=parseInt(t,10);return isNaN(u)?null:u>0?u:null}return null}_setTabSize(t){const u=this._validateTabSize(t);if(u!==null){if(typeof u=="number"){if(this._tabSize===u)return;this._tabSize=u}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:u}))}}_validateInsertSpaces(t){return t==="auto"?"auto":t==="false"?!1:Boolean(t)}_setInsertSpaces(t){const u=this._validateInsertSpaces(t);if(typeof u=="boolean"){if(this._insertSpaces===u)return;this._insertSpaces=u}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:u}))}_setCursorStyle(t){this._cursorStyle!==t&&(this._cursorStyle=t,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:t})))}_setLineNumbers(t){this._lineNumbers!==t&&(this._lineNumbers=t,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:D.TextEditorLineNumbersStyle.from(t)})))}assign(t){const u={};let s=!1;if(typeof t.tabSize!="undefined"){const a=this._validateTabSize(t.tabSize);a==="auto"?(s=!0,u.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,s=!0,u.tabSize=a)}if(typeof t.insertSpaces!="undefined"){const a=this._validateInsertSpaces(t.insertSpaces);a==="auto"?(s=!0,u.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,s=!0,u.insertSpaces=a)}typeof t.cursorStyle!="undefined"&&this._cursorStyle!==t.cursorStyle&&(this._cursorStyle=t.cursorStyle,s=!0,u.cursorStyle=t.cursorStyle),typeof t.lineNumbers!="undefined"&&this._lineNumbers!==t.lineNumbers&&(this._lineNumbers=t.lineNumbers,s=!0,u.lineNumbers=D.TextEditorLineNumbersStyle.from(t.lineNumbers)),s&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,u))}_warnOnError(t,u){u.catch(s=>{this._logService.warn(`ExtHostTextEditorOptions '${t}' failed:'`),this._logService.warn(s)})}}e.ExtHostTextEditorOptions=F;class O{constructor(t,u,s,a,l,k,v,b){this.id=t,this._proxy=u,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._options=new F(this._proxy,this.id,k,s),this._visibleRanges=v,this._viewColumn=b;const o=this;this.value=Object.freeze({get document(){return a.getValue()},set document(S){throw(0,A.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(S){if(!(S instanceof M.Selection))throw(0,A.illegalArgument)("selection");o._selections=[S],o._trySetSelection()},get selections(){return o._selections},set selections(S){if(!Array.isArray(S)||S.some(n=>!(n instanceof M.Selection)))throw(0,A.illegalArgument)("selections");o._selections=S,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(S){throw(0,A.readonly)("visibleRanges")},get options(){return o._options.value},set options(S){o._disposed||o._options.assign(S)},get viewColumn(){return o._viewColumn},set viewColumn(S){throw(0,A.readonly)("viewColumn")},edit(S,n={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const P=new y(a.getValue(),n);return S(P),o._applyEdit(P)},insertSnippet(S,n,P={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=o._selections.map(c=>D.Range.from(c));else if(n instanceof M.Position){const{lineNumber:c,column:w}=D.Position.from(n);r=[{startLineNumber:c,startColumn:w,endLineNumber:c,endColumn:w}]}else if(n instanceof M.Range)r=[D.Range.from(n)];else{r=[];for(const c of n)if(c instanceof M.Range)r.push(D.Range.from(c));else{const{lineNumber:w,column:h}=D.Position.from(c);r.push({startLineNumber:w,startColumn:h,endLineNumber:w,endColumn:h})}}return u.$tryInsertSnippet(t,S.value,r,P)},setDecorations(S,n){const P=n.length===0;P&&!o._hasDecorationsForKey.has(S.key)||(P?o._hasDecorationsForKey.delete(S.key):o._hasDecorationsForKey.add(S.key),o._runOnProxy(()=>{if(D.isDecorationOptionsArr(n))return u.$trySetDecorations(t,S.key,D.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let c=0,w=n.length;c<w;c++){const h=n[c];r[4*c]=h.start.line+1,r[4*c+1]=h.start.character+1,r[4*c+2]=h.end.line+1,r[4*c+3]=h.end.character+1}return u.$trySetDecorationsFast(t,S.key,r)}}))},revealRange(S,n){o._runOnProxy(()=>u.$tryRevealRange(t,D.Range.from(S),n||M.TextEditorRevealType.Default))},show(S){u.$tryShowEditor(t,D.ViewColumn.from(S))},hide(){u.$tryHideEditor(t)}})}dispose(){(0,i.ok)(!this._disposed),this._disposed=!0}_acceptOptions(t){(0,i.ok)(!this._disposed),this._options._accept(t)}_acceptVisibleRanges(t){(0,i.ok)(!this._disposed),this._visibleRanges=t}_acceptViewColumn(t){(0,i.ok)(!this._disposed),this._viewColumn=t}_acceptSelections(t){(0,i.ok)(!this._disposed),this._selections=t}async _trySetSelection(){const t=this._selections.map(D.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,t)),this.value}_applyEdit(t){const u=t.finalize();if(u.edits.length===0&&!u.setEndOfLine)return Promise.resolve(!0);const s=u.edits.map(l=>l.range);s.sort((l,k)=>l.end.line===k.end.line?l.end.character===k.end.character?l.start.line===k.start.line?l.start.character-k.start.character:l.start.line-k.start.line:l.end.character-k.end.character:l.end.line-k.end.line);for(let l=0,k=s.length-1;l<k;l++){const v=s[l].end;if(s[l+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=u.edits.map(l=>({range:D.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,u.documentVersionId,a,{setEndOfLine:typeof u.setEndOfLine=="number"?D.EndOfLine.from(u.setEndOfLine):void 0,undoStopBefore:u.undoStopBefore,undoStopAfter:u.undoStopAfter})}_runOnProxy(t){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):t().then(()=>this,u=>(u instanceof Error&&u.name==="DISPOSED"||this._logService.warn(u),null))}}e.ExtHostTextEditor=O}),define(be[166],we([0,1,10,5,7,13,47,8,82,60]),function(Z,e,i,A,_,D,M,T,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class O extends _.Disposable{constructor(t){super();this.controllerId=t,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new A.Emitter),this.root=new M.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(t){this._resolveHandler=t;for(const u of this.tree.values())this.updateExpandability(u)}collectDiff(){const t=this.diff;return this.diff=[],t}pushDiff(t){const u=this.diff[this.diff.length-1];if(u&&t[0]===1){if(u[0]===1&&u[1].extId===t[1].extId){(0,y.applyTestItemUpdate)(u[1],t[1]);return}if(u[0]===0&&u[1].item.extId===t[1].extId){(0,y.applyTestItemUpdate)(u[1],t[1]);return}}this.diff.push(t),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(t,u){const s=this.tree.get(t);if(!!s){if((s.expandLevels===void 0||u>s.expandLevels)&&(s.expandLevels=u),s.expand===1){const a=this.resolveChildren(s);return a.isOpen()?this.expandChildren(s,u-1):a.wait().then(()=>this.expandChildren(s,u-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,u-1)):this.expandChildren(s,u-1)}}dispose(){for(const t of this.tree.values())(0,M.getPrivateApiFor)(t.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(t,u){switch(u.op){case 2:this.pushDiff([4,t.fullId.toString()]);break;case 1:this.removeItem(F.TestId.joinToString(t.fullId,u.id));break;case 0:this.upsertItem(u.item,t);break;case 4:for(const s of u.ops)this.onTestItemEvent(t,s);break;case 3:{const{key:s,value:a,previous:l}=u,k=t.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(t);break;case"tags":this.diffTagRefs(a,l,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:T.Range.from(a)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:T.MarkdownString.fromStrict(a)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[s]:a??null}}]);break}break}default:(0,D.assertNever)(u)}}upsertItem(t,u){if(!(t instanceof M.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${t.id} did not`);const s=F.TestId.fromExtHostTestItem(t,this.root.id,u?.actual),a=(0,M.getPrivateApiFor)(t);a.parent&&a.parent!==u?.actual&&a.parent.children.delete(t.id);let l=this.tree.get(s.toString());if(!l){l={fullId:s,actual:t,parent:u?s.parentId:null,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},t.tags.forEach(this.incrementTagRefs,this),this.tree.set(l.fullId.toString(),l),this.setItemParent(t,u),this.pushDiff([0,{parent:l.parent&&l.parent.toString(),controllerId:this.controllerId,expand:l.expand,item:T.TestItem.from(t)}]),this.connectItemAndChildren(t,l,u);return}if(l.actual===t){this.connectItem(t,l,u);return}const k=l.actual.children,v=l.actual,b=(0,M.diffTestItems)(v,t);(0,M.getPrivateApiFor)(v).listener=void 0,l.actual=t,l.expand=0;for(const[o,S]of b)this.onTestItemEvent(l,{op:3,key:o,value:S,previous:v[o]});this.connectItemAndChildren(t,l,u);for(const o of k)t.children.get(o.id)||this.removeItem(F.TestId.joinToString(s,o.id))}diffTagRefs(t,u,s){const a=new Set(u.map(l=>l.id));for(const l of t)a.delete(l.id)||this.incrementTagRefs(l);this.pushDiff([1,{extId:s,item:{tags:t.map(l=>T.TestTag.namespace(this.controllerId,l.id))}}]),a.forEach(this.decrementTagRefs,this)}incrementTagRefs(t){const u=this.tags.get(t.id);u?u.refCount++:(this.tags.set(t.id,{refCount:1}),this.pushDiff([5,{id:T.TestTag.namespace(this.controllerId,t.id),ctrlLabel:this.root.label}]))}decrementTagRefs(t){const u=this.tags.get(t);u&&!--u.refCount&&(this.tags.delete(t),this.pushDiff([6,T.TestTag.namespace(this.controllerId,t)]))}setItemParent(t,u){(0,M.getPrivateApiFor)(t).parent=u&&u.actual!==this.root?u.actual:void 0}connectItem(t,u,s){this.setItemParent(t,s);const a=(0,M.getPrivateApiFor)(t);a.parent=s?.actual,a.listener=l=>this.onTestItemEvent(u,l),this.updateExpandability(u)}connectItemAndChildren(t,u,s){this.connectItem(t,u,s);for(const a of t.children)this.upsertItem(a,u)}updateExpandability(t){let u;this._resolveHandler?t.resolveBarrier?u=t.resolveBarrier.isOpen()?3:2:u=t.actual.canResolveChildren?1:0:u=0,u!==t.expand&&(t.expand=u,this.pushDiff([1,{extId:t.fullId.toString(),expand:u}]),u===1&&t.expandLevels!==void 0&&this.resolveChildren(t))}expandChildren(t,u){if(u<0)return;const s=[];for(const a of t.actual.children){const l=this.expand(F.TestId.joinToString(t.fullId,a.id),u);(0,i.isThenable)(l)&&s.push(l)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this._resolveHandler){const l=new i.Barrier;return l.open(),l}t.expand=2,this.pushExpandStateUpdate(t);const u=t.resolveBarrier=new i.Barrier,s=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),t.actual!==this.root&&(t.actual.error=l.stack||l.message||String(l))};let a;try{a=this._resolveHandler(t.actual===this.root?void 0:t.actual)}catch(l){s(l)}return(0,i.isThenable)(a)?a.catch(s).then(()=>{u.open(),this.updateExpandability(t)}):(u.open(),this.updateExpandability(t)),t.resolveBarrier}pushExpandStateUpdate(t){this.pushDiff([1,{extId:t.fullId.toString(),expand:t.expand}])}removeItem(t){const u=this.tree.get(t);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff([2,t]);const s=[u];for(;s.length;){const a=s.pop();if(!!a){(0,M.getPrivateApiFor)(a.actual).listener=void 0;for(const l of a.actual.tags)this.decrementTagRefs(l.id);this.tree.delete(a.fullId.toString());for(const l of a.actual.children)s.push(this.tree.get(F.TestId.joinToString(a.fullId,l.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.diffOpEmitter.fire(t)}}e.SingleUseTestCollection=O}),define(be[167],we([0,1,3,132]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(A.IEnvironmentService)}),define(be[168],we([0,1,23,5,19]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class D{constructor(O){this.removedDueToLooping=O}}e.DeltaExtensionsResult=D;class M{constructor(O){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=O,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const O of this._extensionDescriptions){if(this._extensionsMap.has(i.ExtensionIdentifier.toKey(O.identifier))){console.error("Extension `"+O.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(i.ExtensionIdentifier.toKey(O.identifier),O),this._extensionsArr.push(O),Array.isArray(O.activationEvents))for(let m of O.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(O.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(O)}}keepOnly(O){const m=new Set;O.forEach(t=>m.add(i.ExtensionIdentifier.toKey(t))),this._extensionDescriptions=this._extensionDescriptions.filter(t=>m.has(i.ExtensionIdentifier.toKey(t.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(O,m){O.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(O));const t=M._findLoopingExtensions(this._extensionDescriptions);if(m=m.concat(t.map(u=>u.identifier)),m.length>0){const u=new Set;m.forEach(s=>u.add(i.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!u.has(i.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new D(t)}static _findLoopingExtensions(O){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(l){this._nodesSet.has(l)||(this._nodesSet.add(l),this._nodesArr.push(l))}addArc(l,k){this.addNode(l),this.addNode(k),this._arcs.has(l)?this._arcs.get(l).push(k):this._arcs.set(l,[k])}getArcs(l){return this._arcs.has(l)?this._arcs.get(l):[]}hasOnlyGoodArcs(l,k){const v=m.getArcs(l);for(let b=0;b<v.length;b++)if(!k.has(v[b]))return!1;return!0}getNodes(){return this._nodesArr}};let t=new Map;for(let l of O){const k=i.ExtensionIdentifier.toKey(l.identifier);if(t.set(k,l),l.extensionDependencies)for(let v of l.extensionDependencies){const b=i.ExtensionIdentifier.toKey(v);m.addArc(k,b)}}let u=new Set;m.getNodes().filter(l=>m.getArcs(l).length===0).forEach(l=>u.add(l));let s=m.getNodes().filter(l=>!u.has(l)),a;do{a=!1;for(let l=0;l<s.length;l++){const k=s[l];m.hasOnlyGoodArcs(k,u)&&(s.splice(l,1),l--,u.add(k),a=!0)}}while(a);return s.map(l=>t.get(l))}containsActivationEvent(O){return this._activationMap.has(O)}containsExtension(O){return this._extensionsMap.has(i.ExtensionIdentifier.toKey(O))}getExtensionDescriptionsForActivationEvent(O){const m=this._activationMap.get(O);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(O){const m=this._extensionsMap.get(i.ExtensionIdentifier.toKey(O));return m||void 0}}e.ExtensionDescriptionRegistry=M;var T;(function(F){F[F.Builtin=0]="Builtin",F[F.User=1]="User",F[F.Dev=2]="Dev"})(T||(T={}));function y(F,O){const m=F.isBuiltin?0:F.isUnderDevelopment?2:1,t=O.isBuiltin?0:O.isUnderDevelopment?2:1;if(m!==t)return m-t;const u=_.posix.basename(F.extensionLocation.path),s=_.posix.basename(O.extensionLocation.path);return u<s?-1:u>s?1:0}}),define(be[169],we([0,1,21]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var A;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(A=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function D(T){const y=i.VSBuffer.alloc(1);switch(T){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=D;function M(T,y){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=M}),define(be[26],we([0,1,5,2,3,23,139]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new D.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var T;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class F{constructor(S){this.dependency=S}}e.MissingExtensionDependency=F;var O;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(O=e.ExtensionHostKind||(e.ExtensionHostKind={}));function m(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=m;function t(o,S){return o.enabledApiProposals?o.enabledApiProposals.includes(S):!1}e.isProposedApiEnabled=t;function u(o,S){if(!t(o,S))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${S}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${S}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=u;class s{constructor(S,n,P,r){this.codeLoadingTime=S,this.activateCallTime=n,this.activateResolvedTime=P,this.activationReason=r}}e.ActivationTimes=s;class a{constructor(S,n){this.description=S,this.value=n}}e.ExtensionPointContribution=a,e.ExtensionHostLogFileName="exthost";var l;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(l=e.ActivationKind||(e.ActivationKind={}));function k(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,M.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=k;function v(o,S){return{identifier:new D.ExtensionIdentifier((0,M.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!S,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=v;class b{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,n){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,n,P,r,c){}_onDidActivateExtensionError(S,n){}_onExtensionRuntimeError(S,n){}_onExtensionHostExit(S){}}e.NullExtensionService=b}),define(be[170],we([0,1,15,23,26,9]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const M=Promise.resolve(void 0);class T{constructor(a,l,k,v){this.startup=a,this.codeLoadingTime=l,this.activateCallTime=k,this.activateResolvedTime=v}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class y{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,l){return a===-1||l===-1?-1:l-a}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class F{constructor(a,l,k,v,b,o){this.activationFailed=a,this.activationFailedError=l,this.activationTimes=k,this.module=v,this.exports=b,this.subscriptions=o}}e.ActivatedExtension=F;class O extends F{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class m extends F{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class t extends F{constructor(a){super(!0,a,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=t;let u=class{constructor(a,l,k,v,b){this._logService=b,this._isDisposed=!1,this._registry=a,this._resolvedExtensionsSet=new Set,l.forEach(o=>this._resolvedExtensionsSet.add(A.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,k.forEach(o=>this._hostExtensionsMap.set(A.ExtensionIdentifier.toKey(o),o)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(a){const l=A.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(l)}getActivatedExtension(a){const l=A.ExtensionIdentifier.toKey(a),k=this._activatedExtensions.get(l);if(!k)throw new Error("Extension `"+a.value+"` is not known or not activated");return k}activateByEvent(a,l){if(this._alreadyActivatedEvents[a])return M;const k=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(k.map(v=>({id:v.identifier,reason:{startup:l,extensionId:v.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,l){const k=this._registry.getExtensionDescription(a);if(!k)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:k.identifier,reason:l}])}_handleActivateRequest(a,l,k){if(this._hostExtensionsMap.has(A.ExtensionIdentifier.toKey(a.id))){l[A.ExtensionIdentifier.toKey(a.id)]=a;return}const v=this._registry.getExtensionDescription(a.id);if(!v){const S=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,S,new _.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(A.ExtensionIdentifier.toKey(a.id),new t(S));return}const b=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let o=!0;for(let S=0,n=b.length;S<n;S++){const P=b[S];if(this._resolvedExtensionsSet.has(A.ExtensionIdentifier.toKey(P)))continue;const r=this._activatedExtensions.get(A.ExtensionIdentifier.toKey(P));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const d=v.displayName||v.identifier.value,g=this._registry.getExtensionDescription(P),f=g&&g.displayName||P,E=new Error(`Cannot activate the '${d}' extension because its dependency '${f}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(v.identifier,E,null),this._activatedExtensions.set(A.ExtensionIdentifier.toKey(v.identifier),new t(E));return}if(this._hostExtensionsMap.has(A.ExtensionIdentifier.toKey(P))){o=!1,l[A.ExtensionIdentifier.toKey(P)]={id:this._hostExtensionsMap.get(A.ExtensionIdentifier.toKey(P)),reason:a.reason};continue}const c=this._registry.getExtensionDescription(P);if(c){if(!c.main&&!c.browser)continue;o=!1,l[A.ExtensionIdentifier.toKey(P)]={id:c.identifier,reason:a.reason};continue}const w=v.displayName||v.identifier.value,h=new Error(`Cannot activate the '${w}' extension because it depends on unknown extension '${P}'`);this._host.onExtensionActivationError(v.identifier,h,new _.MissingExtensionDependency(P)),this._activatedExtensions.set(A.ExtensionIdentifier.toKey(v.identifier),new t(h));return}o?l[A.ExtensionIdentifier.toKey(v.identifier)]=a:k.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(b=>!this._activatedExtensions.has(A.ExtensionIdentifier.toKey(b.id))),a.length===0))return Promise.resolve(void 0);const l=Object.create(null),k=[];for(let b=0,o=a.length;b<o;b++)this._handleActivateRequest(a[b],l,k);for(let b=0,o=k.length;b<o;b++){const S=A.ExtensionIdentifier.toKey(k[b].id);l[S]&&delete l[S]}const v=Object.keys(l).map(b=>l[b]);return k.length===0?Promise.all(v.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(v).then(b=>this._activateExtensions(k))}_activateExtension(a,l){const k=A.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(k))return Promise.resolve(void 0);const v=this._activatingExtensions.get(k);if(v)return v;const b=this._host.actualActivateExtension(a,l).then(void 0,o=>{const S=new Error;return o&&o.name&&(S.name=o.name),o&&o.message?S.message=`Activating extension '${a.value}' failed: ${o.message}.`:S.message=`Activating extension '${a.value}' failed: ${o}.`,o&&o.stack&&(S.stack=o.stack),this._isDisposed&&i.isCancellationError(o)?new t(o):(this._host.onExtensionActivationError(a,S,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(o),new t(o))}).then(o=>{this._activatedExtensions.set(k,o),this._activatingExtensions.delete(k)});return this._activatingExtensions.set(k,b),b}};u=Le([Ne(4,D.ILogService)],u),e.ExtensionsActivator=u}),define(be[171],we([0,1,9,27,26]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends i.LogService{constructor(T,y){super(T.createLogger(y.logFile,{name:_.ExtensionHostLogFileName}))}};D=Le([Ne(0,i.ILoggerService),Ne(1,A.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(be[172],we([0,1,15]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class A{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,M)=>{this._actualOk=D,this._actualErr=M,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,i.onUnexpectedError)(D))}then(D,M){return this._ensureActual().then(D,M)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=A}),define(be[37],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const A=[];function _(T){const y=new i(T);return A[y.nid]=y,y}e.createProxyIdentifier=_;function D(T){return A[T].sid}e.getStringIdentifierForProxy=D;class M{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=M}),define(be[4],we([0,1,53,2,37]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var M;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(M=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var F;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(F=e.CellOutputKind||(e.CellOutputKind={}));var O;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(O=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var m;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(m=e.CandidatePortSource||(e.CandidatePortSource={}));class t{static mixin(b){return b._id=t._n++,b}}e.IdObject=t,t._n=0;var u;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.command="m",v.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var a;(function(v){v[v.File=1]="File",v[v.Text=2]="Text",v[v.Cell=3]="Cell"})(a=e.WorkspaceEditType||(e.WorkspaceEditType={}));function l(v){if(v&&v.edits)for(const b of v.edits)typeof b.resource=="object"?b.resource=A.URI.revive(b.resource):(b.newUri=A.URI.revive(b.newUri),b.oldUri=A.URI.revive(b.oldUri)),b.metadata&&b.metadata.iconPath&&(b.metadata=(0,i.revive)(b.metadata));return v}e.reviveWorkspaceEditDto=l;var k;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(k=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createProxyIdentifier)("ExtHostTelemetry")}}),define(be[61],we([0,1,4,5,3]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class D{constructor(T){this._onDidChangePassword=new A.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,y){return this._proxy.$getPassword(T,y)}store(T,y,F){return this._proxy.$setPassword(T,y,F)}delete(T,y){return this._proxy.$deletePassword(T,y)}}e.ExtHostSecretState=D,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(be[62],we([0,1,3,9,4,12]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let M=class{constructor(y,F){this._extHostLogService=F,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(_.MainContext.MainThreadTelemetry)}report(y,F,O){const m=this.getUsageKey(y,F);this._reportedUsages.has(m)||(this._reportedUsages.add(m),F.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:F.identifier.value,apiId:y}))}getUsageKey(y,F){return`${y}-${F.identifier.value}`}};M=Le([Ne(0,D.IExtHostRpcService),Ne(1,A.ILogService)],M),e.ExtHostApiDeprecationService=M,e.NullApiDeprecationService=Object.freeze(new class{report(T,y,F){}})}),define(be[173],we([0,1,5,4,6,23]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class M{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,F,O,m={}){const t=D.ExtensionIdentifier.toKey(y.identifier),u=this._inFlightRequests.get(t)||[],s=[...O].sort().join(" ");let a=u.find(l=>l.scopes===s);if(a)return a.result;{const l=this._getSession(y,t,F,O,m);a={scopes:s,result:l},u.push(a),this._inFlightRequests.set(t,u);try{await l}finally{const k=u.findIndex(v=>v.scopes===s);k>-1&&(u.splice(k),this._inFlightRequests.set(t,u))}return l}}async _getSession(y,F,O,m,t={}){await this._proxy.$ensureProvider(O);const u=y.displayName||y.name;return this._proxy.$getSession(O,m,F,u,t)}async removeSession(y,F){const O=this._authenticationProviders.get(y);return O?O.provider.removeSession(F):this._proxy.$removeSession(y,F)}registerAuthenticationProvider(y,F,O,m){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:F,provider:O,options:m??{supportsMultipleAccounts:!1}}),this._providers.find(u=>u.id===y)||this._providers.push({id:y,label:F});const t=O.onDidChangeSessions(u=>{this._proxy.$sendDidChangeSessions(y,{added:u.added??[],changed:u.changed??[],removed:u.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,F,m?.supportsMultipleAccounts??!1),new _.Disposable(()=>{t.dispose(),this._authenticationProviders.delete(y);const u=this._providers.findIndex(s=>s.id===y);u>-1&&this._providers.splice(u),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,F){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.createSession(F));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,F){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.removeSession(F));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,F){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.getSessions(F));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,F){return this._onDidChangeSessions.fire({provider:{id:y,label:F}}),Promise.resolve()}}e.ExtHostAuthentication=M}),define(be[174],we([0,1,4,12,8]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(T,y){this._extHostDocumentsAndEditors=y,this._proxy=T.getProxy(i.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(T){const y=_.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};D=Le([Ne(0,A.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(be[175],we([0,1,4]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(D){const M=D.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(T){return M.$writeText(T)}})}}e.ExtHostClipboard=A});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[38],we([0,1,13,6,8,25,4,16,9,53,85,226,2,7,3,12,47,21,37,42]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(h,d){o.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ge(this,o,h.getProxy(M.MainContext.MainThreadCommands),"f"),this._logService=d,this.converter=new n(this,g=>{const f=this._apiCommands.get(g);return f?.result===r.Void?f:void 0},d),this._argumentProcessors=[{processArgument(g){return(0,F.revive)(g)}},{processArgument(g){return(0,D.cloneAndChange)(g,function(f){if(O.Range.isIRange(f))return _.Range.to(f);if(m.Position.isIPosition(f))return _.Position.to(f);if(O.Range.isIRange(f.range)&&t.URI.isUri(f.uri))return _.location.to(f);if(f instanceof k.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(h){this._argumentProcessors.push(h)}registerApiCommand(h){const d=this.registerCommand(!1,h.id,async(...g)=>{const f=h.args.map((C,I)=>{if(!C.validate(g[I]))throw new Error(`Invalid argument '${C.name}' when running '${h.id}', received: ${g[I]}`);return C.convert(g[I])}),E=await this.executeCommand(h.internalId,...f);return h.result.convert(E,g,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this._apiCommands.set(h.id,h),new A.Disposable(()=>{d.dispose(),this._apiCommands.delete(h.id)})}registerCommand(h,d,g,f,E,C){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:g,thisArg:f,description:E,extension:C}),h&&De(this,o,"f").$registerCommand(d),new A.Disposable(()=>{this._commands.delete(d)&&h&&De(this,o,"f").$unregisterCommand(d)})}executeCommand(h,...d){return this._logService.trace("ExtHostCommands#executeCommand",h),this._doExecuteCommand(h,d,!0)}async _doExecuteCommand(h,d,g){if(this._commands.has(h))return this._executeContributedCommand(h,d,!1);{let f=!1;const E=(0,D.cloneAndChange)(d,function(C){if(C instanceof A.Position)return _.Position.from(C);if(C instanceof A.Range)return _.Range.from(C);if(C instanceof A.Location)return _.location.from(C);if(A.NotebookRange.isNotebookRange(C))return _.NotebookRange.from(C);if(C instanceof ArrayBuffer)return f=!0,k.VSBuffer.wrap(new Uint8Array(C));if(C instanceof Uint8Array)return f=!0,k.VSBuffer.wrap(C);if(!Array.isArray(C))return C});try{const C=await De(this,o,"f").$executeCommand(h,f?new v.SerializableObjectWithBuffers(E):E,g);return(0,F.revive)(C)}catch(C){if(C instanceof Error&&C.message==="$executeCommand:retry")return this._doExecuteCommand(h,d,!1);throw C}}}async _executeContributedCommand(h,d,g){const f=this._commands.get(h);if(!f)throw new Error("Unknown command");let{callback:E,thisArg:C,description:I}=f;if(I)for(let N=0;N<I.args.length;N++)try{(0,i.validateConstraint)(d[N],I.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${I.args[N].name}' - ${I.args[N].description}`)}try{return await E.apply(C,d)}catch(N){if(h===this.converter.delegatingCommandId){const p=this.converter.getActualCommand(...d);p&&(h=p.command)}throw this._logService.error(N,h,f.extension?.identifier),g?new class extends Error{constructor(){super((0,b.toErrorMessage)(N));this.id=h,this.source=f.extension?.displayName??f.extension?.name}}:N}}$executeContributedCommand(h,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",h),this._commands.has(h)?(d=d.map(g=>this._argumentProcessors.reduce((f,E)=>E.processArgument(f),g)),this._executeContributedCommand(h,d,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this._logService.trace("ExtHostCommands#getCommands",h),De(this,o,"f").$getCommands().then(d=>(h&&(d=d.filter(g=>g[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const h=Object.create(null);for(let[d,g]of this._commands){let{description:f}=g;f&&(h[d]=f)}return Promise.resolve(h)}};o=new WeakMap,S=Le([Ne(0,a.IExtHostRpcService),Ne(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class n{constructor(h,d,g){this._commands=h,this._lookupApiCommand=d,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(h,d){if(!h)return;const g={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return g;const f=this._lookupApiCommand(h.command);if(f)g.id=f.internalId,g.arguments=f.args.map((E,C)=>E.convert(h.arguments&&h.arguments[C]));else if((0,T.isNonEmptyArray)(h.arguments)){const E=++this._cachIdPool;this._cache.set(E,h),d.add((0,u.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),g.$ident=E,g.id=this.delegatingCommandId,g.arguments=[E],this._logService.trace("CommandsConverter#CREATE",h.command,E)}return g}fromInternal(h){return typeof h.$ident=="number"?this._cache.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this._cache.get(h[0])}_executeConvertedCommand(...h){const d=this.getActualCommand(...h);return this._logService.trace("CommandsConverter#EXECUTE",h[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=n;class P{constructor(h,d,g,f){this.name=h,this.description=d,this.validate=g,this.convert=f}optional(){return new P(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,d){return new P(h??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",w=>t.URI.isUri(w),w=>w),P.Position=new P("position","A position in a text document",w=>A.Position.isPosition(w),_.Position.from),P.Range=new P("range","A range in a text document",w=>A.Range.isRange(w),_.Range.from),P.Selection=new P("selection","A selection in a text document",w=>A.Selection.isSelection(w),_.Selection.from),P.Number=new P("number","",w=>typeof w=="number",w=>w),P.String=new P("string","",w=>typeof w=="string",w=>w),P.CallHierarchyItem=new P("item","A call hierarchy item",w=>w instanceof A.CallHierarchyItem,_.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",w=>w instanceof A.TypeHierarchyItem,_.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",w=>w instanceof l.TestItemImpl,_.TestItem.from);class r{constructor(h,d){this.description=h,this.convert=d}}e.ApiCommandResult=r,r.Void=new r("no result",w=>w);class c{constructor(h,d,g,f,E){this.id=h,this.internalId=d,this.description=g,this.args=f,this.result=E}}e.ApiCommand=c}),define(be[176],we([0,1,8,6,86,38,16,72]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",O(i.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,u)=>{if((0,M.isFalsyOrEmpty)(t))return;class s extends A.SymbolInformation{static to(l){const k=new s(l.name,i.SymbolKind.to(l.kind),l.containerName||"",new A.Location(u[0],i.Range.to(l.range)));return k.detail=l.detail,k.range=k.location.range,k.selectionRange=i.Range.to(l.selectionRange),k.children=l.children?l.children.map(s.to):[],k}}return t.map(s.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",O(i.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",O(i.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",O(i.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",O(i.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",O(i.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(u=>A.Position.isPosition(u)),t=>t.map(i.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(u=>{let s;for(const a of u.reverse())s=new A.SelectionRange(i.Range.to(a),s);return s}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(i.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(i.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(i.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(i.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:i.Range.to(t.range),placeholder:t.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return i.WorkspaceEdit.to(t)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(i.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new A.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const u=(0,T.decodeSemanticTokensDto)(t);if(u.type==="full")return new A.SemanticTokens(u.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new A.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const u=(0,T.decodeSemanticTokensDto)(t);if(u.type==="full")return new A.SemanticTokens(u.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,u,s)=>{if(!t)return new A.CompletionList([]);const a=t.suggestions.map(l=>i.CompletionItem.to(l,s));return new A.CompletionList(a,t.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return i.SignatureHelp.to(t)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,u,s)=>O(a=>new A.CodeLens(i.Range.to(a.range),a.command&&s.fromInternal(a.command)))(t))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>A.Range.isRange(t),t=>A.Selection.isSelection(t)?i.Selection.from(t):i.Range.from(t)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,u,s)=>O(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(a.command)}else{const l=new A.CodeAction(a.title,a.kind?new A.CodeActionKind(a.kind):void 0);return a.edit&&(l.edit=i.WorkspaceEdit.to(a.edit)),a.command&&(l.command=s.fromInternal(a.command)),l.isPreferred=a.isPreferred,l}})(t))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(u=>new A.ColorInformation(i.Range.to(u.range),i.Color.to(u.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",t=>t instanceof A.Color,i.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:i.Range.from(t.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(i.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,u,s)=>t.map(i.InlayHint.to.bind(void 0,s)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",O(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(u=>i.NotebookExclusiveDocumentPattern.to(u))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(i.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[i.ViewColumn.from(t),void 0]:[i.ViewColumn.from(t.viewColumn),i.TextEditorOpenOptions.from(t)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[i.ViewColumn.from(t),void 0]:[i.ViewColumn.from(t.viewColumn),i.TextEditorOpenOptions.from(t)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[i.ViewColumn.from(t.viewColumn),i.TextEditorOpenOptions.from(t)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(i.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(i.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(i.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class F{static register(u){y.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=F;function O(t){return u=>{if(Array.isArray(u))return u.map(t)}}function m(t){if(!Array.isArray(t))return;const u=[];for(const s of t)_.isLocationLink(s)?u.push(i.DefinitionLink.to(s)):u.push(i.location.to(s));return u}}),define(be[177],we([0,1,10,51,5,7,2,86,23,8,6,26,4]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(s,a,l){const k=s.getProxy(t.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const h=this._commentControllers.get(w.handle);return h||w}else if(w&&w.$mid===7){const h=this._commentControllers.get(w.commentControlHandle);if(!h)return w;const d=h.getCommentThread(w.commentThreadHandle);return d||w}else if(w&&w.$mid===8){const h=this._commentControllers.get(w.thread.commentControlHandle);if(!h)return w;const d=h.getCommentThread(w.thread.commentThreadHandle);return d?{thread:d,text:w.text}:w}else if(w&&w.$mid===9){const h=this._commentControllers.get(w.thread.commentControlHandle);if(!h)return w;const d=h.getCommentThread(w.thread.commentThreadHandle);if(!d)return w;let g=w.commentUniqueId,f=d.getCommentByUniqueId(g);return f||w}else if(w&&w.$mid===10){const h=this._commentControllers.get(w.thread.commentControlHandle);if(!h)return w;const d=h.getCommentThread(w.thread.commentThreadHandle);if(!d)return w;let g=w.text,f=w.commentUniqueId,E=d.getCommentByUniqueId(f);return E?(E.body=g,E):w}return w}})}createCommentController(w,h,d){const g=v.handlePool++,f=new o(w,g,h,d);this._commentControllers.set(f.handle,f);const E=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(w.identifier))||[];return E.push(f),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(w.identifier),E),f.value}$createCommentThreadTemplate(w,h,d){const g=this._commentControllers.get(w);!g||g.$createCommentThreadTemplate(h,d)}async $updateCommentThreadTemplate(w,h,d){const g=this._commentControllers.get(w);!g||g.$updateCommentThreadTemplate(h,d)}$deleteCommentThread(w,h){const d=this._commentControllers.get(w);d&&d.$deleteCommentThread(h)}$provideCommentingRanges(w,h,d){const g=this._commentControllers.get(w);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const f=l.getDocument(M.URI.revive(h));return(0,i.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(f,d)).then(E=>E?E.map(C=>F.Range.from(C)):void 0)}$toggleReaction(w,h,d,g,f){const E=this._commentControllers.get(w);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const C=E.getCommentThread(h);if(C){const I=C.getCommentByUniqueId(g.uniqueIdInThread);if(E!==void 0&&I&&E.reactionHandler)return E.reactionHandler(I,P(f))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class b{constructor(w,h,d,g,f,E,C){this._commentControllerHandle=h,this._id=d,this._uri=g,this._range=f,this._comments=E,this.extensionDescription=C,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputDisposables.value=new D.DisposableStore,this._id===void 0&&(this._id=`${w}.${this.handle}`),k.$createCommentThread(h,this.handle,this._id,this._uri,F.Range.from(this._range),C.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{k.$deleteCommentThread(h,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(N){I.range=N},get comments(){return I.comments},set comments(N){I.comments=N},get collapsibleState(){return I.collapsibleState},set collapsibleState(N){I.collapsibleState=N},get canReply(){return I.canReply},set canReply(N){I.canReply=N},get contextValue(){return I.contextValue},set contextValue(N){I.contextValue=N},get label(){return I.label},set label(N){I.label=N},dispose:()=>{I.dispose()}}}set threadId(w){this._id=w}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(w){w.isEqual(this._range)||(this._range=w,this.modifications.range=w,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(w){this._canReply!==w&&(this._canReply=w,this.modifications.canReply=w,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(w){this._label=w,this.modifications.label=w,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(w){this._contextValue=w,this.modifications.contextValue=w,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(w){this._comments=w,this.modifications.comments=w,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(w){this._collapseState=w,this.modifications.collapsibleState=w,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new D.DisposableStore);const w=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),h={};w("range")&&(h.range=F.Range.from(this._range)),w("label")&&(h.label=this.label),w("contextValue")&&(h.contextValue=this.contextValue??null),w("comments")&&(h.comments=this._comments.map(d=>S(this,d,this._commentsMap))),w("collapsibleState")&&(h.collapseState=r(this._collapseState)),w("canReply")&&(h.canReply=this.canReply),this.modifications={},k.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,h)}getCommentByUniqueId(w){for(let h of this._commentsMap){let d=h[0],g=h[1];if(w===g)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(w=>w.dispose())}}b._handlePool=0,Le([(0,A.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(w,h,d,g){this._extension=w,this._handle=h,this._id=d,this._label=g,this._threads=new Map,k.$registerCommentController(this.handle,d,g);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(E){f.options=E},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(E){f.commentingRangeProvider=E},get reactionHandler(){return f.reactionHandler},set reactionHandler(E){f.reactionHandler=E},createCommentThread(E,C,I){return f.createCommentThread(E,C,I).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{k.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(w){this._commentingRangeProvider=w,k.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(w){this._reactionHandler=w,k.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this._options}set options(w){this._options=w,k.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(w,h,d,g){if(typeof w=="string"){const f=new b(this.id,this.handle,w,h,d,g,this._extension);return this._threads.set(f.handle,f),f}else{const f=new b(this.id,this.handle,void 0,w,h,d,this._extension);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(w,h){const d=new b(this.id,this.handle,void 0,M.URI.revive(w),F.Range.to(h),[],this._extension);return d.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(w,h){let d=this._threads.get(w);d&&(d.range=F.Range.to(h))}$deleteCommentThread(w){let h=this._threads.get(w);h&&h.dispose(),this._threads.delete(w)}getCommentThread(w){return this._threads.get(w)}dispose(){this._threads.forEach(w=>{w.dispose()}),this._localDisposables.forEach(w=>w.dispose())}}function S(c,w,h){let d=h.get(w);d||(d=++c.commentHandle,h.set(w,d));const g=w.author&&w.author.iconPath?w.author.iconPath.toString():void 0;w.timestamp&&(0,m.checkProposedApiEnabled)(c.extensionDescription,"commentTimestamp");let f;return w.timestamp&&(f={source:w.timestamp,$mid:14}),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:d,body:typeof w.body=="string"?w.body:F.MarkdownString.from(w.body),userName:w.author.name,userIconPath:g,label:w.label,commentReactions:w.reactions?w.reactions.map(E=>n(E)):void 0,timestamp:f}}function n(c){return{label:c.label,iconPath:c.iconPath?F.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function P(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?M.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function r(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new v}e.createExtHostComments=u}),define(be[89],we([0,1,2,4,6,3,12,9,16,14,19]),function(Z,e,i,A,_,D,M,T,y,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class yi{constructor(u,s){this._logService=s,this._provider=new Map,this._proxy=u.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(u,s){const a=yi._handlePool++;this._provider.set(a,{provider:u,extensionId:s}),this._proxy.$registerDecorationProvider(a,s.value);const l=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(a,null);return}let v=(0,y.asArray)(k);if(v.length<=yi._maxEventSize){this._proxy.$onDidChange(a,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,v.length);const b=v.map(n=>({uri:n,rank:(0,F.count)(n.path,"/")})),o=(0,y.groupBy)(b,(n,P)=>n.rank-P.rank||(0,F.compare)(n.uri.path,P.uri.path));let S=[];e:for(let n of o){let P;for(let r of n){let c=(0,O.dirname)(r.uri.path);if(P!==c&&(P=c,S.push(r.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(a,S)});return new _.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(u,s,a){if(!this._provider.has(u))return Object.create(null);const l=Object.create(null),{provider:k,extensionId:v}=this._provider.get(u);return await Promise.all(s.map(async b=>{try{const{uri:o,id:S}=b,n=await Promise.resolve(k.provideFileDecoration(i.URI.revive(o),a));if(!n)return;try{_.FileDecoration.validate(n),l[S]=[n.propagate,n.tooltip,n.badge,n.color]}catch(P){this._logService.warn(`INVALID decoration from extension '${v.value}': ${P}`)}}catch(o){this._logService.error(o)}})),l}};m._handlePool=0,m._maxEventSize=250,m=Le([Ne(0,M.IExtHostRpcService),Ne(1,T.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,D.createDecorator)("IExtHostDecorations")});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[178],we([0,1,117,75,2,4,6,8,5,9,22,29]),function(Z,e,i,A,_,D,M,T,y,F,O,m){"use strict";var t,u,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(v,b,o,S,n,P){this._name=v,this._owner=b,this._maxDiagnosticsPerFile=o,t.set(this,void 0),u.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Ge(this,s,new O.ResourceMap(r=>S.getComparisonKey(r)),"f"),Ge(this,t,n,"f"),Ge(this,u,P,"f")}dispose(){this._isDisposed||(De(this,u,"f").fire([...De(this,s,"f").keys()]),De(this,t,"f")&&De(this,t,"f").$clear(this._owner),De(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,b){if(!v){this.clear();return}this._checkDisposed();let o=[];if(_.URI.isUri(v)){if(!b){this.delete(v);return}De(this,s,"f").set(v,b.slice()),o=[v]}else if(Array.isArray(v)){o=[];let n;v=[...v].sort(a._compareIndexedTuplesByUri);for(const P of v){const[r,c]=P;if((!n||r.toString()!==n.toString())&&(n&&De(this,s,"f").get(n).length===0&&De(this,s,"f").delete(n),n=r,o.push(r),De(this,s,"f").set(r,[])),c){const w=De(this,s,"f").get(r);w&&w.push(...c)}else{const w=De(this,s,"f").get(r);w&&(w.length=0)}}}if(De(this,u,"f").fire(o),!De(this,t,"f"))return;const S=[];for(let n of o){let P=[];const r=De(this,s,"f").get(n);if(r)if(r.length>this._maxDiagnosticsPerFile){P=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let w=0;w<4;w++)for(let h of r)if(h.severity===c[w]&&P.push(T.Diagnostic.from(h))===this._maxDiagnosticsPerFile)break e;P.push({severity:A.MarkerSeverity.Info,message:(0,i.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:P[P.length-1].startLineNumber,startColumn:P[P.length-1].startColumn,endLineNumber:P[P.length-1].endLineNumber,endColumn:P[P.length-1].endColumn})}else P=r.map(c=>T.Diagnostic.from(c));S.push([n,P])}De(this,t,"f").$changeMany(this._owner,S)}delete(v){this._checkDisposed(),De(this,u,"f").fire([v]),De(this,s,"f").delete(v),De(this,t,"f")&&De(this,t,"f").$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),De(this,u,"f").fire([...De(this,s,"f").keys()]),De(this,s,"f").clear(),De(this,t,"f")&&De(this,t,"f").$clear(this._owner)}forEach(v,b){this._checkDisposed();for(let o of De(this,s,"f").keys())v.apply(b,[o,this.get(o),this])}get(v){this._checkDisposed();const b=De(this,s,"f").get(v);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(De(this,s,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,b){return v[0].toString()<b[0].toString()?-1:v[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=a,t=new WeakMap,u=new WeakMap,s=new WeakMap;let l=class si{constructor(v,b,o){this._logService=b,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=v.getProxy(D.MainContext.MainThreadDiagnostics)}static _mapper(v){const b=new O.ResourceMap;for(const o of v)b.set(o,o);return{uris:Object.freeze(Array.from(b.values()))}}createDiagnosticCollection(v,b){const{_collections:o,_proxy:S,_onDidChangeDiagnostics:n,_logService:P,_fileSystemInfoService:r}=this,c=new class{$changeMany(d,g){S.$changeMany(d,g),P.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,d,g.length===0?"CLEARING":g)}$clear(d){S.$clear(d),P.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,d)}dispose(){S.dispose()}};let w;if(!b)b="_generated_diagnostic_collection_name_#"+si._idPool++,w=b;else if(!o.has(b))w=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do w=b+si._idPool++;while(o.has(w))}return new class extends a{constructor(){super(b,w,si._maxDiagnosticsPerFile,r.extUri,c,n);o.set(w,this)}dispose(){super.dispose(),o.delete(w)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const b=new Map,o=[];for(const S of this._collections.values())S.forEach((n,P)=>{let r=b.get(n.toString());typeof r=="undefined"&&(r=o.length,b.set(n.toString(),r),o.push([n,[]])),o[r][1]=o[r][1].concat(...P)});return o}}_getDiagnostics(v){let b=[];for(let o of this._collections.values())o.has(v)&&(b=b.concat(o.get(v)));return b}$acceptMarkersChange(v){if(!this._mirrorCollection){const b="_generated_mirror",o=new a(b,b,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,o),this._mirrorCollection=o}for(const[b,o]of v)this._mirrorCollection.set(_.URI.revive(b),o.map(T.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Le([Ne(1,F.ILogService),Ne(2,m.IExtHostFileSystemInfo)],l),e.ExtHostDiagnostics=l}),define(be[179],we([0,1,2,4]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(M){this._proxy=M.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(M){return this._proxy.$showOpenDialog(M).then(T=>T?T.map(y=>i.URI.revive(y)):void 0)}showSaveDialog(M){return this._proxy.$showSaveDialog(M).then(T=>T?i.URI.revive(T):void 0)}}e.ExtHostDialogs=_}),define(be[180],we([0,1,15,2,6,4,11,20,14]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class F{constructor(m,t,u){this._documentsAndEditors=t,this._logService=u,this._documentContentProviders=new Map,this._proxy=m.getProxy(D.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(m,t){if(Object.keys(M.Schemas).indexOf(m)>=0)throw new Error(`scheme '${m}' already registered`);const u=F._handlePool++;this._documentContentProviders.set(u,t),this._proxy.$registerTextContentProvider(u,m);let s;return typeof t.onDidChange=="function"&&(s=t.onDidChange(a=>{if(a.scheme!==m){this._logService.warn(`Provider for scheme '${m}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(u,a).then(l=>{if(!l&&typeof l!="string")return;const k=this._documentsAndEditors.getDocument(a);if(!k)return;const v=(0,y.splitLines)(l);if(!k.equalLines(v))return this._proxy.$onVirtualDocumentChange(a,l)},i.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(u)&&this._proxy.$unregisterTextContentProvider(u),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(m,t){const u=this._documentContentProviders.get(m);return u?Promise.resolve(u.provideTextDocumentContent(A.URI.revive(t),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${t.scheme}`))}}e.ExtHostDocumentContentProvider=F,F._handlePool=0}),define(be[181],we([0,1,5,7,2,4,80,8,13,25,6]),function(Z,e,i,A,_,D,M,T,y,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class m{constructor(u,s){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new A.DisposableStore,this._documentLoader=new Map,this._proxy=u.getProxy(D.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const l of a)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const l of a)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(u){if(!u)return;const s=this._documentsAndEditors.getDocument(u);if(s)return s}getDocument(u){const s=this.getDocumentData(u);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${u}'`);return s.document}ensureDocumentData(u){const s=this._documentsAndEditors.getDocument(u);if(s)return Promise.resolve(s);let a=this._documentLoader.get(u.toString());return a||(a=this._proxy.$tryOpenDocument(u).then(l=>{this._documentLoader.delete(u.toString());const k=_.URI.revive(l);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(k))},l=>(this._documentLoader.delete(u.toString()),Promise.reject(l))),this._documentLoader.set(u.toString(),a)),a}createDocumentData(u){return this._proxy.$tryCreateDocument(u).then(s=>_.URI.revive(s))}$acceptModelLanguageChanged(u,s){const a=_.URI.revive(u),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(s),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(u){const s=_.URI.revive(u),a=this._documentsAndEditors.getDocument(s);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(u,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(u,s){const a=_.URI.revive(u),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");l._acceptIsDirty(s),this._onDidChangeDocument.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(u,s,a){const l=_.URI.revive(u),k=this._documentsAndEditors.getDocument(l);if(!k)throw new Error("unknown document");k._acceptIsDirty(a),k.onEvents(s);let v;s.isUndoing?v=O.TextDocumentChangeReason.Undo:s.isRedoing&&(v=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,F.deepFreeze)({document:k.document,contentChanges:s.changes.map(b=>({range:T.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:v}))}setWordDefinitionFor(u,s){(0,M.setWordDefinitionFor)(u,s)}}e.ExtHostDocuments=m}),define(be[48],we([0,1,41,5,7,2,3,4,80,12,88,8,9,22,11,156,227]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(o,S){this._extHostRpc=o,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new u.ResourceMap,this._onDidAddDocuments=new A.Emitter,this._onDidRemoveDocuments=new A.Emitter,this._onDidChangeVisibleTextEditors=new A.Emitter,this._onDidChangeActiveTextEditor=new A.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const S=[],n=[],P=[];if(o.removedDocuments)for(const r of o.removedDocuments){const c=D.URI.revive(r),w=this._documents.get(c);w?.unref()&&(this._documents.delete(c),S.push(w.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const c=D.URI.revive(r.uri);let w=this._documents.get(c);if(w&&c.scheme!==s.Schemas.vscodeNotebookCell&&c.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);w||(w=new k(new y.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(c,w),n.push(w.value)),w.ref()}if(o.removedEditors)for(const r of o.removedEditors){const c=this._editors.get(r);this._editors.delete(r),c&&P.push(c)}if(o.addedEditors)for(const r of o.addedEditors){const c=D.URI.revive(r.documentUri);i.ok(this._documents.has(c),`document '${c}' does not exist`),i.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const w=this._documents.get(c).value,h=new O.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new l.Lazy(()=>w.document),r.selections.map(m.Selection.to),r.options,r.visibleRanges.map(d=>m.Range.to(d)),typeof r.editorPosition=="number"?m.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,h)}o.newActiveEditor!==void 0&&(i.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,_.dispose)(S),(0,_.dispose)(P),o.removedDocuments&&this._onDidRemoveDocuments.fire(S),o.addedDocuments&&this._onDidAddDocuments.fire(n),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return o?S:S?.value}allEditors(){return[...this._editors.values()]}};v=Le([Ne(0,F.IExtHostRpcService),Ne(1,t.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,M.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[63],we([0,1,8,4,2,5,3,12,10]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,M.createDecorator)("IExtHostEditorTabs");let F=class{constructor(m){this._onDidChangeTabs=new D.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new D.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=m.getProxy(A.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(m){let t=-1;this._tabs=m.map((s,a)=>(s.isActive&&(t=a),Object.freeze({label:s.label,viewColumn:i.ViewColumn.to(s.viewColumn),index:a,resource:_.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:l,viewId:k})=>({resource:_.URI.revive(l),viewId:k})),viewId:s.editorId,isActive:s.isActive,move:async(l,k)=>{this._proxy.$moveTab(s,l,i.ViewColumn.from(k)),await(0,y.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,y.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,a)=>s.viewColumn===a.viewColumn?s.index-a.index:s.viewColumn-a.viewColumn);const u=this._activeTab;this._activeTab=t===-1?void 0:this._tabs[t],this._activeTab!==u&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};F=Le([Ne(0,T.IExtHostRpcService)],F),e.ExtHostEditorTabs=F}),define(be[182],we([0,1,2,4,7,6,8,228,14,21,26]),function(Z,e,i,A,_,D,M,T,y,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class m{constructor(){this._schemes=[]}add(s){this._stateMachine=void 0,this._schemes.push(s)}delete(s){const a=this._schemes.indexOf(s);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const s=this._schemes.sort(),a=[];let l,k,v=14,b=14;for(const o of s){let S=l?(0,y.commonPrefixLength)(l,o):0;for(S===0?k=1:k=b;S<o.length;S++)S+1===o.length?(v=b,b=9):b+=1,a.push([k,o.toUpperCase().charCodeAt(S),b]),a.push([k,o.toLowerCase().charCodeAt(S),b]),k=b;l=o,b=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new T.StateMachine(a)}}provideDocumentLinks(s){this._initStateMachine();const a=[],l=T.LinkComputer.computeLinks({getLineContent(k){return s.lineAt(k-1).text},getLineCount(){return s.lineCount}},this._stateMachine);for(const k of l){const v=M.DocumentLink.to(k);v.target&&a.push(v)}return a}}class t{constructor(s,a){this._extHostLanguageFeatures=a,this._linkProvider=new m,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=s.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(s,a,l,k={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(s,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(v,l);let b=2;k.isCaseSensitive&&(b+=1024),k.isReadonly&&(b+=2048),typeof l.copy=="function"&&(b+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&((0,O.checkProposedApiEnabled)(s,"fsChunks"),b+=4),this._proxy.$registerFileSystemProvider(v,a,b).catch(S=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(S)});const o=l.onDidChangeFile(S=>{const n=[];for(const P of S){let{uri:r,type:c}=P;if(r.scheme!==a)continue;let w;switch(c){case D.FileChangeType.Changed:w=0;break;case D.FileChangeType.Created:w=1;break;case D.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:r,type:w})}this._proxy.$onFileSystemChange(v,n)});return(0,_.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(s){const{type:a,ctime:l,mtime:k,size:v,permissions:b}=s;return{type:a,ctime:l,mtime:k,size:v,permissions:b}}$stat(s,a){return Promise.resolve(this._getFsProvider(s).stat(i.URI.revive(a))).then(l=>t._asIStat(l))}$readdir(s,a){return Promise.resolve(this._getFsProvider(s).readDirectory(i.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this._getFsProvider(s).readFile(i.URI.revive(a))).then(l=>F.VSBuffer.wrap(l))}$writeFile(s,a,l,k){return Promise.resolve(this._getFsProvider(s).writeFile(i.URI.revive(a),l.buffer,k))}$delete(s,a,l){return Promise.resolve(this._getFsProvider(s).delete(i.URI.revive(a),l))}$rename(s,a,l,k){return Promise.resolve(this._getFsProvider(s).rename(i.URI.revive(a),i.URI.revive(l),k))}$copy(s,a,l,k){const v=this._getFsProvider(s);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(i.URI.revive(a),i.URI.revive(l),k))}$mkdir(s,a){return Promise.resolve(this._getFsProvider(s).createDirectory(i.URI.revive(a)))}$watch(s,a,l,k){const v=this._getFsProvider(s).watch(i.URI.revive(l),k);this._watches.set(a,v)}$unwatch(s,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(s,a,l){const k=this._getFsProvider(s);if(!k.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(k.open(i.URI.revive(a),l))}$close(s,a){const l=this._getFsProvider(s);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(s,a,l,k){const v=this._getFsProvider(s);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const b=F.VSBuffer.alloc(k);return Promise.resolve(v.read(a,l,b.buffer,0,k)).then(o=>b.slice(0,o))}$write(s,a,l,k){const v=this._getFsProvider(s);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,l,k.buffer,0,k.byteLength))}_getFsProvider(s){const a=this._fsProvider.get(s);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=t}),define(be[49],we([0,1,4,45,6,21,3,12,29,7]),function(Z,e,i,A,_,D,M,T,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class jt{constructor(t,u){this._fileSystemProvider=new Map,this._proxy=t.getProxy(i.MainContext.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(a){try{const l=s._fileSystemProvider.get(a.scheme);if(!l)return await s._proxy.$stat(a);await s._proxy.$ensureActivation(a.scheme);const k=await l.stat(a);return{type:k.type,ctime:k.ctime,mtime:k.mtime,size:k.size,permissions:k.permissions}}catch(l){jt._handleError(l)}},async readDirectory(a){try{const l=s._fileSystemProvider.get(a.scheme);return l?(await s._proxy.$ensureActivation(a.scheme),(await l.readDirectory(a)).slice()):await s._proxy.$readdir(a)}catch(l){return jt._handleError(l)}},async createDirectory(a){try{return await s._proxy.$mkdir(a)}catch(l){return jt._handleError(l)}},async readFile(a){try{const l=s._fileSystemProvider.get(a.scheme);return l?(await s._proxy.$ensureActivation(a.scheme),(await l.readFile(a)).slice()):(await s._proxy.$readFile(a)).buffer}catch(l){return jt._handleError(l)}},async writeFile(a,l){try{return await s._proxy.$writeFile(a,D.VSBuffer.wrap(l))}catch(k){return jt._handleError(k)}},async delete(a,l){try{const k=s._fileSystemProvider.get(a.scheme);return k?(await s._proxy.$ensureActivation(a.scheme),await k.delete(a,{recursive:!1,...l})):await s._proxy.$delete(a,{recursive:!1,useTrash:!1,...l})}catch(k){return jt._handleError(k)}},async rename(a,l,k){try{return await s._proxy.$rename(a,l,{overwrite:!1,...k})}catch(v){return jt._handleError(v)}},async copy(a,l,k){try{return await s._proxy.$copy(a,l,{overwrite:!1,...k})}catch(v){return jt._handleError(v)}},isWritableFileSystem(a){const l=u.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(t){if(t instanceof _.FileSystemError)throw t;if(!(t instanceof Error))throw new _.FileSystemError(String(t));if(t.name==="ENOPRO")throw _.FileSystemError.Unavailable(t.message);switch(t.name){case A.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(t.message);case A.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(t.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(t.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(t.message);case A.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(t.message);case A.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(t.message);default:throw new _.FileSystemError(t.message,t.name)}}addFileSystemProvider(t,u){return this._fileSystemProvider.set(t,u),(0,F.toDisposable)(()=>this._fileSystemProvider.delete(t))}};O=Le([Ne(0,T.IExtHostRpcService),Ne(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,M.createDecorator)("IExtHostConsumerFileSystem")}),define(be[183],we([0,1,5,36,2,4,8,6]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(m,t,u,s,a,l,k,v){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter;const b=this.ensureWatching(m,u,a);this._config=0,l&&(this._config+=1),k&&(this._config+=2),v&&(this._config+=4);const o=(0,A.parse)(a),S=typeof a=="string",n=s(P=>{if(!l)for(let r of P.created){const c=_.URI.revive(r);o(c.fsPath)&&(!S||t.getWorkspaceFolder(c))&&this._onDidCreate.fire(c)}if(!k)for(let r of P.changed){const c=_.URI.revive(r);o(c.fsPath)&&(!S||t.getWorkspaceFolder(c))&&this._onDidChange.fire(c)}if(!v)for(let r of P.deleted){const c=_.URI.revive(r);o(c.fsPath)&&(!S||t.getWorkspaceFolder(c))&&this._onDidDelete.fire(c)}});this._disposable=T.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,t,u){let s=T.Disposable.from();if(typeof u=="string")return s;const a=m.getProxy(D.MainContext.MainThreadFileSystem);let l=!1;(u.pattern.includes(A.GLOBSTAR)||u.pattern.includes(A.GLOB_SPLIT))&&(l=!0);const k=Math.random();return a.$watch(t.identifier.value,k,u.baseUri,{recursive:l,excludes:[]}),T.Disposable.from({dispose:()=>a.$unwatch(k)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class F{constructor(m,t,u){this._mainContext=m,this._logService=t,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,t,u,s,a,l){return new y(this._mainContext,m,t,this._onFileSystemEvent.event,M.GlobPattern.from(u),s,a,l)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,t){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:t.map(u=>({oldUri:_.URI.revive(u.source),newUri:_.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:t.map(u=>_.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:t.map(u=>_.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,t){return(u,s,a)=>{const l=function(v){u.call(s,v)};return l.extension=m,t.event(l,void 0,a)}}async $onWillRunFileOperation(m,t,u,s){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:t.map(a=>({oldUri:_.URI.revive(a.source),newUri:_.URI.revive(a.target)}))},u,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:t.map(a=>_.URI.revive(a.target))},u,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:t.map(a=>_.URI.revive(a.target))},u,s)}}async _fireWillEvent(m,t,u,s){const a=new Set,l=[];if(await m.fireAsync(t,s,async(v,b)=>{const o=Date.now(),S=await Promise.resolve(v);S instanceof T.WorkspaceEdit&&(l.push(S),a.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-o>u&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),s.isCancellationRequested||l.length===0)return;const k={edits:[]};for(let v of l){let{edits:b}=M.WorkspaceEdit.from(v,this._extHostDocumentsAndEditors);k.edits=k.edits.concat(b)}return{edit:k,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=F}),define(be[184],we([0,1,2,38]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(M,T,y,F){this._extHostNotebooks=T,this._textDocumentsAndEditors=y,this._commands=F;const O=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new A.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new A.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new A.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new A.ApiCommandResult("Notebook and input URI",m=>{if(m.notebookEditorId!==void 0){const t=this._extHostNotebooks.getEditorById(m.notebookEditorId);return{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:t.apiEditor}}return{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(O)}$willAddInteractiveDocument(M,T,y,F){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:y,uri:M,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(i.URI.revive(F))?.apiNotebook}]})}$willRemoveInteractiveDocument(M,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.ExtHostInteractive=_}),define(be[185],we([0,1,7,4]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(M){this._handlePool=0,this._proxy=M.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(M){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,M),(0,i.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=_}),define(be[186],we([0,1,2,25,8,6,4,14,85,16,13,229,20,7,72,52,56,187,15,5,10]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class S{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentSymbols(B,G){const $=this._documents.getDocument(B),V=await this._provider.provideDocumentSymbols($,G);if(!(0,F.isFalsyOrEmpty)(V))return V[0]instanceof D.DocumentSymbol?V.map(_.DocumentSymbol.from):S._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((V,Y)=>{let ne=V.location.range.start.compareTo(Y.location.range.start);return ne===0&&(ne=Y.location.range.end.compareTo(V.location.range.end)),ne});const G=[],$=[];for(const V of B){const Y={name:V.name||"!!MISSING: name!!",kind:_.SymbolKind.from(V.kind),tags:V.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:_.Range.from(V.location.range),selectionRange:_.Range.from(V.location.range),children:[]};for(;;){if($.length===0){$.push(Y),G.push(Y);break}const ne=$[$.length-1];if(y.Range.containsRange(ne.range,Y.range)&&!y.Range.equalsRange(ne.range,Y.range)){ne.children&&ne.children.push(Y),$.push(Y);break}$.pop()}}return G}}class n{constructor(B,G,$){this._documents=B,this._commands=G,this._provider=$,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,G){const $=this._documents.getDocument(B),V=await this._provider.provideCodeLenses($,G);if(!V||G.isCancellationRequested)return;const Y=this._cache.add(V),ne=new u.DisposableStore;this._disposables.set(Y,ne);const me={cacheId:Y,lenses:[]};for(let Fe=0;Fe<V.length;Fe++)me.lenses.push({cacheId:[Y,Fe],range:_.Range.from(V[Fe].range),command:this._commands.toInternal(V[Fe].command,ne)});return me}async resolveCodeLens(B,G){const $=B.cacheId&&this._cache.get(...B.cacheId);if(!$)return;let V;if(typeof this._provider.resolveCodeLens!="function"||$.isResolved?V=$:V=await this._provider.resolveCodeLens($,G),V||(V=$),G.isCancellationRequested)return;const Y=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!Y)return B.command=this._commands.toInternal(V.command??n._badCmd,Y),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}n._badCmd={command:"missing",title:"!!MISSING: command!!"};function P(rt){return Array.isArray(rt)?rt.map(_.DefinitionLink.from):rt?[_.DefinitionLink.from(rt)]:[]}class r{constructor(B,G){this._documents=B,this._provider=G}async provideDefinition(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideDefinition(V,Y,$);return P(ne)}}class c{constructor(B,G){this._documents=B,this._provider=G}async provideDeclaration(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideDeclaration(V,Y,$);return P(ne)}}class w{constructor(B,G){this._documents=B,this._provider=G}async provideImplementation(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideImplementation(V,Y,$);return P(ne)}}class h{constructor(B,G){this._documents=B,this._provider=G}async provideTypeDefinition(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideTypeDefinition(V,Y,$);return P(ne)}}class d{constructor(B,G){this._documents=B,this._provider=G}async provideHover(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideHover(V,Y,$);if(!(!ne||(0,F.isFalsyOrEmpty)(ne.contents)))return ne.range||(ne.range=V.getWordRangeAtPosition(Y)),ne.range||(ne.range=new D.Range(Y,Y)),_.Hover.from(ne)}}class g{constructor(B,G){this._documents=B,this._provider=G}async provideEvaluatableExpression(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideEvaluatableExpression(V,Y,$);if(ne)return _.EvaluatableExpression.from(ne)}}class f{constructor(B,G){this._documents=B,this._provider=G}async provideInlineValues(B,G,$,V){const Y=this._documents.getDocument(B),ne=await this._provider.provideInlineValues(Y,_.Range.to(G),_.InlineValueContext.to($),V);if(Array.isArray(ne))return ne.map(me=>_.InlineValue.from(me))}}class E{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentHighlights(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideDocumentHighlights(V,Y,$);if(Array.isArray(ne))return ne.map(_.DocumentHighlight.from)}}class C{constructor(B,G){this._documents=B,this._provider=G}async provideLinkedEditingRanges(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.provideLinkedEditingRanges(V,Y,$);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,F.coalesce)(ne.ranges.map(_.Range.from)),wordPattern:ne.wordPattern}}}class I{constructor(B,G){this._documents=B,this._provider=G}async provideReferences(B,G,$,V){const Y=this._documents.getDocument(B),ne=_.Position.to(G),me=await this._provider.provideReferences(Y,ne,$,V);if(Array.isArray(me))return me.map(_.location.from)}}class N{constructor(B,G,$,V,Y,ne,me){this._documents=B,this._commands=G,this._diagnostics=$,this._provider=V,this._logService=Y,this._extension=ne,this._apiDeprecation=me,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,G,$,V){const Y=this._documents.getDocument(B),ne=m.Selection.isISelection(G)?_.Selection.to(G):_.Range.to(G),me=[];for(const Ke of this._diagnostics.getDiagnostics(B))if(ne.intersection(Ke.range)&&me.push(Ke)>N._maxCodeActionsPerFile)break;const Fe={diagnostics:me,only:$.only?new D.CodeActionKind($.only):void 0,triggerKind:_.CodeActionTriggerKind.to($.trigger)},$e=await this._provider.provideCodeActions(Y,ne,Fe,V);if(!(0,F.isNonEmptyArray)($e)||V.isCancellationRequested)return;const qe=this._cache.add($e),Je=new u.DisposableStore;this._disposables.set(qe,Je);const Ze=[];for(let Ke=0;Ke<$e.length;Ke++){const Qe=$e[Ke];!Qe||(N._isCommand(Qe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Qe.title,command:this._commands.toInternal(Qe,Je)})):(Fe.only&&(Qe.kind?Fe.only.contains(Qe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[qe,Ke],title:Qe.title,command:Qe.command&&this._commands.toInternal(Qe.command,Je),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(_.Diagnostic.from),edit:Qe.edit&&_.WorkspaceEdit.from(Qe.edit),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:qe,actions:Ze}}async resolveCodeAction(B,G){const[$,V]=B,Y=this._cache.get($,V);if(!Y||N._isCommand(Y)||!this._provider.resolveCodeAction)return;const ne=await this._provider.resolveCodeAction(Y,G)??Y;return ne?.edit?_.WorkspaceEdit.from(ne.edit):void 0}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}N._maxCodeActionsPerFile=1e3;class p{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentFormattingEdits(B,G,$){const V=this._documents.getDocument(B),Y=await this._provider.provideDocumentFormattingEdits(V,G,$);if(Array.isArray(Y))return Y.map(_.TextEdit.from)}}class R{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentRangeFormattingEdits(B,G,$,V){const Y=this._documents.getDocument(B),ne=_.Range.to(G),me=await this._provider.provideDocumentRangeFormattingEdits(Y,ne,$,V);if(Array.isArray(me))return me.map(_.TextEdit.from)}}class x{constructor(B,G){this._documents=B,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,G,$,V,Y){const ne=this._documents.getDocument(B),me=_.Position.to(G),Fe=await this._provider.provideOnTypeFormattingEdits(ne,me,$,V,Y);if(Array.isArray(Fe))return Fe.map(_.TextEdit.from)}}class j{constructor(B,G){this._provider=B,this._logService=G,this._cache=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,G){const $=await this._provider.provideWorkspaceSymbols(B,G);if(!(0,F.isNonEmptyArray)($))return{symbols:[]};const V=this._cache.add($),Y={cacheId:V,symbols:[]};for(let ne=0;ne<$.length;ne++){const me=$[ne];if(!me||!me.name){this._logService.warn("INVALID SymbolInformation",me);continue}Y.symbols.push({..._.WorkspaceSymbol.from(me),cacheId:[V,ne]})}return Y}async resolveWorkspaceSymbol(B,G){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const $=this._cache.get(...B.cacheId);if($){const V=await this._provider.resolveWorkspaceSymbol($,G);return V&&(0,A.mixin)(B,_.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class H{constructor(B,G,$){this._documents=B,this._provider=G,this._logService=$}static supportsResolving(B){return typeof B.prepareRename=="function"}async provideRenameEdits(B,G,$,V){const Y=this._documents.getDocument(B),ne=_.Position.to(G);try{const me=await this._provider.provideRenameEdits(Y,ne,$,V);return me?_.WorkspaceEdit.from(me):void 0}catch(me){const Fe=H._asMessage(me);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(me)}}async resolveRenameLocation(B,G,$){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(B),Y=_.Position.to(G);try{const ne=await this._provider.prepareRename(V,Y,$);let me,Fe;if(D.Range.isRange(ne)?(me=ne,Fe=V.getText(ne)):(0,O.isObject)(ne)&&(me=ne.range,Fe=ne.placeholder),!me||!Fe)return;if(me.start.line>Y.line||me.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(me),text:Fe}}catch(ne){const me=H._asMessage(ne);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(ne)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class z{constructor(B,G){this.resultId=B,this.tokens=G}}class K{constructor(B,G){this._documents=B,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,G,$){const V=this._documents.getDocument(B),Y=G!==0?this._previousResults.get(G):null;let ne=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,Y.resultId,$):await this._provider.provideDocumentSemanticTokens(V,$);return Y&&this._previousResults.delete(G),ne?(ne=K._fixProvidedSemanticTokens(ne),this._send(K._convertToEdits(Y,ne),ne)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return K._isSemanticTokens(B)?K._isCorrectSemanticTokens(B)?B:new D.SemanticTokens(new Uint32Array(B.data),B.resultId):K._isSemanticTokensEdits(B)?K._isCorrectSemanticTokensEdits(B)?B:new D.SemanticTokensEdits(B.edits.map(G=>new D.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const G of B.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,G){if(!K._isSemanticTokens(G)||!B||!B.tokens)return G;const $=B.tokens,V=$.length,Y=G.data,ne=Y.length;let me=0;const Fe=Math.min(V,ne);for(;me<Fe&&$[me]===Y[me];)me++;if(me===V&&me===ne)return new D.SemanticTokensEdits([],G.resultId);let $e=0;const qe=Fe-me;for(;$e<qe&&$[V-$e-1]===Y[ne-$e-1];)$e++;return new D.SemanticTokensEdits([{start:me,deleteCount:V-me-$e,data:Y.subarray(me,ne-$e)}],G.resultId)}_send(B,G){if(K._isSemanticTokens(B)){const $=this._nextResultId++;return this._previousResults.set($,new z(B.resultId,B.data)),(0,s.encodeSemanticTokensDto)({id:$,type:"full",data:B.data})}if(K._isSemanticTokensEdits(B)){const $=this._nextResultId++;return K._isSemanticTokens(G)?this._previousResults.set($,new z(G.resultId,G.data)):this._previousResults.set($,new z(B.resultId)),(0,s.encodeSemanticTokensDto)({id:$,type:"delta",deltas:(B.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class ce{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentRangeSemanticTokens(B,G,$){const V=this._documents.getDocument(B),Y=await this._provider.provideDocumentRangeSemanticTokens(V,_.Range.to(G),$);return Y?this._send(Y):null}_send(B){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=ce;class fe{constructor(B,G,$,V,Y){this._documents=B,this._commands=G,this._provider=$,this._apiDeprecation=V,this._extension=Y,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,G,$,V){const Y=this._documents.getDocument(B),ne=_.Position.to(G),me=Y.getWordRangeAtPosition(ne)||new D.Range(ne,ne),Fe=me.with({end:ne}),$e=new k.StopWatch(!0),qe=await this._provider.provideCompletionItems(Y,ne,V,_.CompletionContext.to($));if(!qe||V.isCancellationRequested)return;const Je=Array.isArray(qe)?new D.CompletionList(qe):qe,Ze=fe.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),Ke=new u.DisposableStore;this._disposables.set(Ze,Ke);const Qe=[],mt={x:Ze,b:Qe,a:{replace:_.Range.from(me),insert:_.Range.from(Fe)},c:Je.isIncomplete||void 0,d:$e.elapsed()};for(let Tt=0;Tt<Je.items.length;Tt++){const Te=Je.items[Tt],kt=this._convertCompletionItem(Te,[Ze,Tt],Fe,me);Qe.push(kt)}return mt}async resolveCompletionItem(B,G){if(typeof this._provider.resolveCompletionItem!="function")return;const $=this._cache.get(...B);if(!$)return;const V=await this._provider.resolveCompletionItem($,G);if(!!V)return this._convertCompletionItem(V,B)}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,G,$,V){const Y=this._disposables.get(G[0]);if(!Y)throw Error("DisposableStore is missing...");const ne={x:G,a:B.label,b:B.kind!==void 0?_.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(_.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(B.command,Y)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ne.h=B.textEdit.newText):typeof B.insertText=="string"?ne.h=B.insertText:B.insertText instanceof D.SnippetString&&(ne.h=B.insertText.value,ne.i|=4);let me;return B.textEdit?me=B.textEdit.range:B.range&&(me=B.range),D.Range.isRange(me)?ne.j=_.Range.from(me):me&&(!$?.isEqual(me.inserting)||!V?.isEqual(me.replacing))&&(ne.j={insert:_.Range.from(me.inserting),replace:_.Range.from(me.replacing)}),ne}}class re{constructor(B,G,$){this._documents=B,this._provider=G,this._commands=$,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(B,G,$,V){const Y=this._documents.getDocument(B),ne=_.Position.to(G),me=await this._provider.provideInlineCompletionItems(Y,ne,{selectedCompletionInfo:$.selectedSuggestionInfo?{range:_.Range.to($.selectedSuggestionInfo.range),text:$.selectedSuggestionInfo.text,isSnippetText:$.selectedSuggestionInfo.isSnippetText,completionKind:_.CompletionItemKind.to($.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:$.triggerKind},V);if(!me||V.isCancellationRequested)return;const Fe=(0,O.isArray)(me)?{items:me}:me,$e=this._cache.add(Fe.items);let qe;return{pid:$e,items:Fe.items.map((Je,Ze)=>{let Ke;return Je.command&&(qe||(qe=new u.DisposableStore,this._disposables.set($e,qe)),Ke=this._commands.toInternal(Je.command,qe)),{text:Je.text,range:Je.range?_.Range.from(Je.range):void 0,command:Ke,idx:Ze}})}}disposeCompletions(B){this._cache.delete(B);const G=this._disposables.get(B);G&&G.clear(),this._disposables.delete(B)}handleDidShowCompletionItem(B,G){const $=this._cache.get(B,G);$&&ge.get(this._provider).fireOnDidShowCompletionItem({completionItem:$})}}class ge{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(B){let G=ge.map.get(B);return G||(G=new ge,ge.map.set(B,G)),G}fireOnDidShowCompletionItem(B){this._onDidShowCompletionItemEmitter.fire(B)}}e.InlineCompletionController=ge,ge.map=new WeakMap;class ye{constructor(B,G){this._documents=B,this._provider=G,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(B,G,$,V){const Y=this._documents.getDocument(B),ne=_.Position.to(G),me=this.reviveContext($),Fe=await this._provider.provideSignatureHelp(Y,ne,V,me);if(Fe){const $e=this._cache.add([Fe]);return{..._.SignatureHelp.from(Fe),id:$e}}}reviveContext(B){let G;if(B.activeSignatureHelp){const $=_.SignatureHelp.to(B.activeSignatureHelp),V=this._cache.get(B.activeSignatureHelp.id,0);V?(G=V,G.activeSignature=$.activeSignature,G.activeParameter=$.activeParameter):G=$}return{...B,activeSignatureHelp:G}}releaseSignatureHelp(B){this._cache.delete(B)}}class ve{constructor(B,G,$,V,Y){this._documents=B,this._commands=G,this._provider=$,this._logService=V,this._extension=Y,this._cache=new l.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,G,$){const V=this._documents.getDocument(B),Y=_.Range.to(G),ne=await this._provider.provideInlayHints(V,Y,$);if(!Array.isArray(ne)||ne.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${G}`);return}if($.isCancellationRequested)return;const me=this._cache.add(ne);this._disposables.set(me,new u.DisposableStore);const Fe={hints:[],cacheId:me};for(let $e=0;$e<ne.length;$e++)this._isValidInlayHint(ne[$e],Y)&&Fe.hints.push(this._convertInlayHint(ne[$e],[me,$e]));return this._logService.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${G}`),Fe}async resolveInlayHint(B,G){if(typeof this._provider.resolveInlayHint!="function")return;const $=this._cache.get(...B);if(!$)return;const V=await this._provider.resolveInlayHint($,G);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,G){return B.label.length===0||Array.isArray(B.label)&&B.label.every($=>$.label.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(G&&!G.contains(B.position))}_convertInlayHint(B,G){const $=this._disposables.get(G[0]);if(!$)throw Error("DisposableStore is missing...");const V={label:"",cacheId:G,tooltip:B.tooltip&&_.MarkdownString.from(B.tooltip),position:_.Position.from(B.position),kind:_.InlayHintKind.from(B.kind??D.InlayHintKind.Other),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?V.label=B.label:V.label=B.label.map(Y=>{let ne={label:Y.label};return ne.tooltip=Y.tooltip&&_.MarkdownString.from(Y.tooltip),D.Location.isLocation(Y.location)&&(ne.location=_.location.from(Y.location)),Y.command&&(ne.command=this._commands.toInternal(Y.command,$)),ne}),V}}class Me{constructor(B,G){this._documents=B,this._provider=G,this._cache=new l.Cache("DocumentLink")}async provideLinks(B,G){const $=this._documents.getDocument(B),V=await this._provider.provideDocumentLinks($,G);if(!(!Array.isArray(V)||V.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(Me._validateLink).map(_.DocumentLink.from)};{const Y=this._cache.add(V),ne={links:[],cacheId:Y};for(let me=0;me<V.length;me++){if(!Me._validateLink(V[me]))continue;const Fe=_.DocumentLink.from(V[me]);Fe.cacheId=[Y,me],ne.links.push(Fe)}return ne}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,G){if(typeof this._provider.resolveDocumentLink!="function")return;const $=this._cache.get(...B);if(!$)return;const V=await this._provider.resolveDocumentLink($,G);if(!(!V||!Me._validateLink(V)))return _.DocumentLink.from(V)}releaseLinks(B){this._cache.delete(B)}}class je{constructor(B,G){this._documents=B,this._provider=G}async provideColors(B,G){const $=this._documents.getDocument(B),V=await this._provider.provideDocumentColors($,G);return Array.isArray(V)?V.map(ne=>({color:_.Color.from(ne.color),range:_.Range.from(ne.range)})):[]}async provideColorPresentations(B,G,$){const V=this._documents.getDocument(B),Y=_.Range.to(G.range),ne=_.Color.to(G.color),me=await this._provider.provideColorPresentations(ne,{document:V,range:Y},$);if(!!Array.isArray(me))return me.map(_.ColorPresentation.from)}}class et{constructor(B,G){this._documents=B,this._provider=G}async provideFoldingRanges(B,G,$){const V=this._documents.getDocument(B),Y=await this._provider.provideFoldingRanges(V,G,$);if(!!Array.isArray(Y))return Y.map(_.FoldingRange.from)}}class lt{constructor(B,G,$){this._documents=B,this._provider=G,this._logService=$}async provideSelectionRanges(B,G,$){const V=this._documents.getDocument(B),Y=G.map(_.Position.to),ne=await this._provider.provideSelectionRanges(V,Y,$);if(!(0,F.isNonEmptyArray)(ne))return[];if(ne.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Fe=0;Fe<Y.length;Fe++){const $e=[];me.push($e);let qe=Y[Fe],Je=ne[Fe];for(;;){if(!Je.range.contains(qe))throw new Error("INVALID selection range, must contain the previous range");if($e.push(_.SelectionRange.from(Je)),!Je.parent)break;qe=Je.range,Je=Je.parent}}return me}}class it{constructor(B,G){this._documents=B,this._provider=G,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.prepareCallHierarchy(V,Y,$);if(!ne)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ne)?ne.map(Fe=>this._cacheAndConvertItem(me,Fe)):[this._cacheAndConvertItem(me,ne)]}async provideCallsTo(B,G,$){const V=this._itemFromCache(B,G);if(!V)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(V,$);if(!!Y)return Y.map(ne=>({from:this._cacheAndConvertItem(B,ne.from),fromRanges:ne.fromRanges.map(me=>_.Range.from(me))}))}async provideCallsFrom(B,G,$){const V=this._itemFromCache(B,G);if(!V)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(V,$);if(!!Y)return Y.map(ne=>({to:this._cacheAndConvertItem(B,ne.to),fromRanges:ne.fromRanges.map(me=>_.Range.from(me))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,G){const $=this._cache.get(B),V=_.CallHierarchyItem.from(G,B,$.size.toString(36));return $.set(V._itemId,G),V}_itemFromCache(B,G){return this._cache.get(B)?.get(G)}}class ft{constructor(B,G){this._documents=B,this._provider=G,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(B,G,$){const V=this._documents.getDocument(B),Y=_.Position.to(G),ne=await this._provider.prepareTypeHierarchy(V,Y,$);if(!ne)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ne)?ne.map(Fe=>this._cacheAndConvertItem(me,Fe)):[this._cacheAndConvertItem(me,ne)]}async provideSupertypes(B,G,$){const V=this._itemFromCache(B,G);if(!V)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(V,$);if(!!Y)return Y.map(ne=>this._cacheAndConvertItem(B,ne))}async provideSubtypes(B,G,$){const V=this._itemFromCache(B,G);if(!V)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(V,$);if(!!Y)return Y.map(ne=>this._cacheAndConvertItem(B,ne))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,G){const $=this._cache.get(B),V=_.TypeHierarchyItem.from(G,B,$.size.toString(36));return $.set(V._itemId,G),V}_itemFromCache(B,G){return this._cache.get(B)?.get(G)}}class _t{constructor(B,G){this.adapter=B,this.extension=G}}class ut{constructor(B,G,$,V,Y,ne,me){this._adapter=new Map,this._uriTransformer=G,this._proxy=B.getProxy(M.MainContext.MainThreadLanguageFeatures),this._documents=$,this._commands=V,this._diagnostics=Y,this._logService=ne,this._apiDeprecation=me}_transformDocumentSelector(B){return _.DocumentSelector.from(B,this._uriTransformer)}_createDisposable(B){return new D.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return ut._handlePool++}async _withAdapter(B,G,$,V,Y){const ne=this._adapter.get(B);if(!ne||!(ne.adapter instanceof G))return V;const me=Date.now();this._logService.trace(`[${ne.extension.identifier.value}] INVOKE provider '${$.toString().replace(/[\r\n]/g,"")}'`);const Fe=$(ne.adapter,ne.extension);return Promise.resolve(Fe).catch($e=>{(0,v.isCancellationError)($e)||(this._logService.error(`[${ne.extension.identifier.value}] provider FAILED`),this._logService.error($e))}).finally(()=>{this._logService.trace(`[${ne.extension.identifier.value}] provider DONE after ${Date.now()-me}ms`)}),t.CancellationToken.isCancellationToken(Y)?(0,o.raceCancellationError)(Fe,Y):Fe}_addNewAdapter(B,G){const $=this._nextHandle();return this._adapter.set($,new _t(B,G)),$}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,G,$,V){const Y=this._addNewAdapter(new S(this._documents,$),B),ne=V&&V.label||ut._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(G),ne),this._createDisposable(Y)}$provideDocumentSymbols(B,G,$){return this._withAdapter(B,S,V=>V.provideDocumentSymbols(i.URI.revive(G),$),void 0,$)}registerCodeLensProvider(B,G,$){const V=this._nextHandle(),Y=typeof $.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new _t(new n(this._documents,this._commands.converter,$),B)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(G),Y);let ne=this._createDisposable(V);if(Y!==void 0){const me=$.onDidChangeCodeLenses(Fe=>this._proxy.$emitCodeLensEvent(Y));ne=D.Disposable.from(ne,me)}return ne}$provideCodeLenses(B,G,$){return this._withAdapter(B,n,V=>V.provideCodeLenses(i.URI.revive(G),$),void 0,void 0)}$resolveCodeLens(B,G,$){return this._withAdapter(B,n,V=>V.resolveCodeLens(G,$),void 0,void 0)}$releaseCodeLenses(B,G){this._withAdapter(B,n,$=>Promise.resolve($.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(B,G,$){const V=this._addNewAdapter(new r(this._documents,$),B);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideDefinition(B,G,$,V){return this._withAdapter(B,r,Y=>Y.provideDefinition(i.URI.revive(G),$,V),[],V)}registerDeclarationProvider(B,G,$){const V=this._addNewAdapter(new c(this._documents,$),B);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideDeclaration(B,G,$,V){return this._withAdapter(B,c,Y=>Y.provideDeclaration(i.URI.revive(G),$,V),[],V)}registerImplementationProvider(B,G,$){const V=this._addNewAdapter(new w(this._documents,$),B);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideImplementation(B,G,$,V){return this._withAdapter(B,w,Y=>Y.provideImplementation(i.URI.revive(G),$,V),[],V)}registerTypeDefinitionProvider(B,G,$){const V=this._addNewAdapter(new h(this._documents,$),B);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideTypeDefinition(B,G,$,V){return this._withAdapter(B,h,Y=>Y.provideTypeDefinition(i.URI.revive(G),$,V),[],V)}registerHoverProvider(B,G,$,V){const Y=this._addNewAdapter(new d(this._documents,$),B);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(G)),this._createDisposable(Y)}$provideHover(B,G,$,V){return this._withAdapter(B,d,Y=>Y.provideHover(i.URI.revive(G),$,V),void 0,void 0)}registerEvaluatableExpressionProvider(B,G,$,V){const Y=this._addNewAdapter(new g(this._documents,$),B);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(G)),this._createDisposable(Y)}$provideEvaluatableExpression(B,G,$,V){return this._withAdapter(B,g,Y=>Y.provideEvaluatableExpression(i.URI.revive(G),$,V),void 0,void 0)}registerInlineValuesProvider(B,G,$,V){const Y=typeof $.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new f(this._documents,$),B);this._proxy.$registerInlineValuesProvider(ne,this._transformDocumentSelector(G),Y);let me=this._createDisposable(ne);if(Y!==void 0){const Fe=$.onDidChangeInlineValues($e=>this._proxy.$emitInlineValuesEvent(Y));me=D.Disposable.from(me,Fe)}return me}$provideInlineValues(B,G,$,V,Y){return this._withAdapter(B,f,ne=>ne.provideInlineValues(i.URI.revive(G),$,V,Y),void 0,void 0)}registerDocumentHighlightProvider(B,G,$){const V=this._addNewAdapter(new E(this._documents,$),B);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideDocumentHighlights(B,G,$,V){return this._withAdapter(B,E,Y=>Y.provideDocumentHighlights(i.URI.revive(G),$,V),void 0,void 0)}registerLinkedEditingRangeProvider(B,G,$){const V=this._addNewAdapter(new C(this._documents,$),B);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideLinkedEditingRanges(B,G,$,V){return this._withAdapter(B,C,async Y=>{const ne=await Y.provideLinkedEditingRanges(i.URI.revive(G),$,V);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?ut._serializeRegExp(ne.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider(B,G,$){const V=this._addNewAdapter(new I(this._documents,$),B);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideReferences(B,G,$,V,Y){return this._withAdapter(B,I,ne=>ne.provideReferences(i.URI.revive(G),$,V,Y),void 0,Y)}registerCodeActionProvider(B,G,$,V){const Y=new u.DisposableStore,ne=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,$,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(ne,this._transformDocumentSelector(G),{providedKinds:V?.providedCodeActionKinds?.map(me=>me.value),documentation:V?.documentation?.map(me=>({kind:me.kind.value,command:this._commands.converter.toInternal(me.command,Y)}))},ut._extLabel(B),Boolean($.resolveCodeAction)),Y.add(this._createDisposable(ne)),Y}$provideCodeActions(B,G,$,V,Y){return this._withAdapter(B,N,ne=>ne.provideCodeActions(i.URI.revive(G),$,V,Y),void 0,void 0)}$resolveCodeAction(B,G,$){return this._withAdapter(B,N,V=>V.resolveCodeAction(G,$),void 0,void 0)}$releaseCodeActions(B,G){this._withAdapter(B,N,$=>Promise.resolve($.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(B,G,$){const V=this._addNewAdapter(new p(this._documents,$),B);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(G),B.identifier,B.displayName||B.name),this._createDisposable(V)}$provideDocumentFormattingEdits(B,G,$,V){return this._withAdapter(B,p,Y=>Y.provideDocumentFormattingEdits(i.URI.revive(G),$,V),void 0,void 0)}registerDocumentRangeFormattingEditProvider(B,G,$){const V=this._addNewAdapter(new R(this._documents,$),B);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(G),B.identifier,B.displayName||B.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(B,G,$,V,Y){return this._withAdapter(B,R,ne=>ne.provideDocumentRangeFormattingEdits(i.URI.revive(G),$,V,Y),void 0,void 0)}registerOnTypeFormattingEditProvider(B,G,$,V){const Y=this._addNewAdapter(new x(this._documents,$),B);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(G),V,B.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(B,G,$,V,Y,ne){return this._withAdapter(B,x,me=>me.provideOnTypeFormattingEdits(i.URI.revive(G),$,V,Y,ne),void 0,void 0)}registerWorkspaceSymbolProvider(B,G){const $=this._addNewAdapter(new j(G,this._logService),B);return this._proxy.$registerNavigateTypeSupport($,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable($)}$provideWorkspaceSymbols(B,G,$){return this._withAdapter(B,j,V=>V.provideWorkspaceSymbols(G,$),{symbols:[]},$)}$resolveWorkspaceSymbol(B,G,$){return this._withAdapter(B,j,V=>V.resolveWorkspaceSymbol(G,$),void 0,void 0)}$releaseWorkspaceSymbols(B,G){this._withAdapter(B,j,$=>$.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(B,G,$){const V=this._addNewAdapter(new H(this._documents,$,this._logService),B);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(G),H.supportsResolving($)),this._createDisposable(V)}$provideRenameEdits(B,G,$,V,Y){return this._withAdapter(B,H,ne=>ne.provideRenameEdits(i.URI.revive(G),$,V,Y),void 0,void 0)}$resolveRenameLocation(B,G,$,V){return this._withAdapter(B,H,Y=>Y.resolveRenameLocation(i.URI.revive(G),$,V),void 0,void 0)}registerDocumentSemanticTokensProvider(B,G,$,V){const Y=this._addNewAdapter(new K(this._documents,$),B),ne=typeof $.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(G),V,ne);let me=this._createDisposable(Y);if(ne){const Fe=$.onDidChangeSemanticTokens($e=>this._proxy.$emitDocumentSemanticTokensEvent(ne));me=D.Disposable.from(me,Fe)}return me}$provideDocumentSemanticTokens(B,G,$,V){return this._withAdapter(B,K,Y=>Y.provideDocumentSemanticTokens(i.URI.revive(G),$,V),null,void 0)}$releaseDocumentSemanticTokens(B,G){this._withAdapter(B,K,$=>$.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,G,$,V){const Y=this._addNewAdapter(new ce(this._documents,$),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(G),V),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(B,G,$,V){return this._withAdapter(B,ce,Y=>Y.provideDocumentRangeSemanticTokens(i.URI.revive(G),$,V),null,void 0)}registerCompletionItemProvider(B,G,$,V){const Y=this._addNewAdapter(new fe(this._documents,this._commands.converter,$,this._apiDeprecation,B),B);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(G),V,fe.supportsResolving($),`${B.identifier.value}(${V.join("")})`),this._createDisposable(Y)}$provideCompletionItems(B,G,$,V,Y){return this._withAdapter(B,fe,ne=>ne.provideCompletionItems(i.URI.revive(G),$,V,Y),void 0,Y)}$resolveCompletionItem(B,G,$){return this._withAdapter(B,fe,V=>V.resolveCompletionItem(G,$),void 0,$)}$releaseCompletionItems(B,G){this._withAdapter(B,fe,$=>$.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(B,G,$){const V=this._addNewAdapter(new re(this._documents,$,this._commands.converter),B);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideInlineCompletions(B,G,$,V,Y){return this._withAdapter(B,re,ne=>ne.provideInlineCompletions(i.URI.revive(G),$,V,Y),void 0,void 0)}$handleInlineCompletionDidShow(B,G,$){this._withAdapter(B,re,async V=>{V.handleDidShowCompletionItem(G,$)},void 0,void 0)}$freeInlineCompletionsList(B,G){this._withAdapter(B,re,async $=>{$.disposeCompletions(G)},void 0,void 0)}registerSignatureHelpProvider(B,G,$,V){const Y=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ne=this._addNewAdapter(new ye(this._documents,$),B);return this._proxy.$registerSignatureHelpProvider(ne,this._transformDocumentSelector(G),Y),this._createDisposable(ne)}$provideSignatureHelp(B,G,$,V,Y){return this._withAdapter(B,ye,ne=>ne.provideSignatureHelp(i.URI.revive(G),$,V,Y),void 0,void 0)}$releaseSignatureHelp(B,G){this._withAdapter(B,ye,$=>$.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(B,G,$){const V=typeof $.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new ve(this._documents,this._commands.converter,$,this._logService,B),B);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(G),typeof $.resolveInlayHint=="function",V);let ne=this._createDisposable(Y);if(V!==void 0){const me=$.onDidChangeInlayHints(Fe=>this._proxy.$emitInlayHintsEvent(V));ne=D.Disposable.from(ne,me)}return ne}$provideInlayHints(B,G,$,V){return this._withAdapter(B,ve,Y=>Y.provideInlayHints(i.URI.revive(G),$,V),void 0,V)}$resolveInlayHint(B,G,$){return this._withAdapter(B,ve,V=>V.resolveInlayHint(G,$),void 0,$)}$releaseInlayHints(B,G){this._withAdapter(B,ve,$=>$.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(B,G,$){const V=this._addNewAdapter(new Me(this._documents,$),B);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(G),typeof $.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(B,G,$){return this._withAdapter(B,Me,V=>V.provideLinks(i.URI.revive(G),$),void 0,void 0)}$resolveDocumentLink(B,G,$){return this._withAdapter(B,Me,V=>V.resolveLink(G,$),void 0,void 0)}$releaseDocumentLinks(B,G){this._withAdapter(B,Me,$=>$.releaseLinks(G),void 0,void 0)}registerColorProvider(B,G,$){const V=this._addNewAdapter(new je(this._documents,$),B);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideDocumentColors(B,G,$){return this._withAdapter(B,je,V=>V.provideColors(i.URI.revive(G),$),[],void 0)}$provideColorPresentations(B,G,$,V){return this._withAdapter(B,je,Y=>Y.provideColorPresentations(i.URI.revive(G),$,V),void 0,void 0)}registerFoldingRangeProvider(B,G,$){const V=this._nextHandle(),Y=typeof $.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new _t(new et(this._documents,$),B)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(G),Y);let ne=this._createDisposable(V);if(Y!==void 0){const me=$.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ne=D.Disposable.from(ne,me)}return ne}$provideFoldingRanges(B,G,$,V){return this._withAdapter(B,et,Y=>Y.provideFoldingRanges(i.URI.revive(G),$,V),void 0,void 0)}registerSelectionRangeProvider(B,G,$){const V=this._addNewAdapter(new lt(this._documents,$,this._logService),B);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$provideSelectionRanges(B,G,$,V){return this._withAdapter(B,lt,Y=>Y.provideSelectionRanges(i.URI.revive(G),$,V),[],V)}registerCallHierarchyProvider(B,G,$){const V=this._addNewAdapter(new it(this._documents,$),B);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$prepareCallHierarchy(B,G,$,V){return this._withAdapter(B,it,Y=>Promise.resolve(Y.prepareSession(i.URI.revive(G),$,V)),void 0,V)}$provideCallHierarchyIncomingCalls(B,G,$,V){return this._withAdapter(B,it,Y=>Y.provideCallsTo(G,$,V),void 0,V)}$provideCallHierarchyOutgoingCalls(B,G,$,V){return this._withAdapter(B,it,Y=>Y.provideCallsFrom(G,$,V),void 0,V)}$releaseCallHierarchy(B,G){this._withAdapter(B,it,$=>Promise.resolve($.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(B,G,$){const V=this._addNewAdapter(new ft(this._documents,$),B);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(G)),this._createDisposable(V)}$prepareTypeHierarchy(B,G,$,V){return this._withAdapter(B,ft,Y=>Promise.resolve(Y.prepareSession(i.URI.revive(G),$,V)),void 0,V)}$provideTypeHierarchySupertypes(B,G,$,V){return this._withAdapter(B,ft,Y=>Y.provideSupertypes(G,$,V),void 0,V)}$provideTypeHierarchySubtypes(B,G,$,V){return this._withAdapter(B,ft,Y=>Y.provideSubtypes(G,$,V),void 0,V)}$releaseTypeHierarchy(B,G){this._withAdapter(B,ft,$=>Promise.resolve($.releaseSession(G)),void 0,void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:(0,T.regExpFlags)(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:ut._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:ut._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ut._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ut._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:ut._serializeRegExp(B.beforeText),afterText:B.afterText?ut._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?ut._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(ut._serializeOnEnterRule)}setLanguageConfiguration(B,G,$){let{wordPattern:V}=$;if(V&&(0,T.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(G,V):this._documents.setWordDefinitionFor(G,void 0),$.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),$.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Y=this._nextHandle(),ne={comments:$.comments,brackets:$.brackets,wordPattern:$.wordPattern?ut._serializeRegExp($.wordPattern):void 0,indentationRules:$.indentationRules?ut._serializeIndentationRule($.indentationRules):void 0,onEnterRules:$.onEnterRules?ut._serializeOnEnterRules($.onEnterRules):void 0,__electricCharacterSupport:$.__electricCharacterSupport,__characterPairSupport:$.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,G,ne),this._createDisposable(Y)}$setWordDefinitions(B){for(const G of B)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=ut,ut._handlePool=0}),define(be[188],we([0,1,4,8,6,33,10,7]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,m,t,u){this._documents=m,this._commands=t,this._uriTransformer=u,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,m){await this._proxy.$changeLanguage(O,m);const t=this._documents.getDocumentData(O);if(!t)throw new Error(`document '${O.toString}' NOT found`);return t.document}async tokenAtPosition(O,m){const t=O.version,u=A.Position.from(m),s=await this._proxy.$tokensAtPosition(O.uri,u),a={type:_.StandardTokenType.Other,range:O.getWordRangeAtPosition(m)??new _.Range(m.line,m.character,m.line,m.character)};if(!s)return a;const l={range:A.Range.to(s.range),type:A.TokenType.to(s.type)};return!l.range.contains(m)||t!==O.version?a:l}createLanguageStatusItem(O,m,t){const u=this._handlePool++,s=this._proxy,a=this._ids,l=`${O.identifier.value}/${m}`;if(a.has(l))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);a.add(l);const k={selector:t,id:m,name:O.displayName??O.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v,b=new T.DisposableStore;const o=()=>{v?.dispose(),v=(0,M.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(u,{id:l,name:k.name??O.displayName??O.name,source:O.displayName??O.name,selector:A.DocumentSelector.from(k.selector,this._uriTransformer),label:k.text,detail:k.detail??"",severity:k.severity===_.LanguageStatusSeverity.Error?D.default.Error:k.severity===_.LanguageStatusSeverity.Warning?D.default.Warning:D.default.Info,command:k.command&&this._commands.toInternal(k.command,b),accessibilityInfo:k.accessibilityInformation,busy:k.busy})},0)},S={dispose(){b.dispose(),v?.dispose(),s.$removeLanguageStatus(u),a.delete(l)},get id(){return k.id},get name(){return k.name},set name(n){k.name=n,o()},get selector(){return k.selector},set selector(n){k.selector=n,o()},get text(){return k.text},set text(n){k.text=n,o()},get detail(){return k.detail},set detail(n){k.detail=n,o()},get severity(){return k.severity},set severity(n){k.severity=n,o()},get accessibilityInformation(){return k.accessibilityInformation},set accessibilityInformation(n){k.accessibilityInformation=n,o()},get command(){return k.command},set command(n){k.command=n,o()},get busy(){return k.busy},set busy(n){k.busy=n,o()}};return o(),S}}e.ExtHostLanguages=y}),define(be[189],we([0,1,9,4,27,12,5]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends i.AbstractLoggerService{constructor(O,m){const t=new M.Emitter;super(m.logLevel,t.event);this._proxy=O.getProxy(A.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(t)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,m,t){return new y(this._proxy,O,m,t)}};T=Le([Ne(0,D.IExtHostRpcService),Ne(1,_.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class y extends i.AbstractMessageLogger{constructor(O,m,t,u){super(u?.always);this.proxy=O,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.proxy.$createLogger(m,u).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,m){const t=[[O,m]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(O){this.proxy.$log(this.file,O)}}}),define(be[190],we([0,1,4,9,26]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function D(T){return T&&T.title}let M=class{constructor(y,F){this._logService=F,this._proxy=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,F,O,m,t){const u={source:{identifier:y.identifier,label:y.displayName||y.name}};let s;typeof m=="string"||D(m)?s=[m,...t]:(u.modal=m?.modal,u.useCustom=m?.useCustom,u.detail=m?.detail,s=t),u.useCustom&&(0,_.checkProposedApiEnabled)(y,"resolvers");const a=[];for(let l=0;l<s.length;l++){const k=s[l];if(typeof k=="string")a.push({title:k,handle:l,isCloseAffordance:!1});else if(typeof k=="object"){let{title:v,isCloseAffordance:b}=k;a.push({title:v,isCloseAffordance:!!b,handle:l})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(F,O,u,a).then(l=>{if(typeof l=="number")return s[l]})}};M=Le([Ne(1,A.ILogService)],M),e.ExtHostMessageService=M}),define(be[191],we([0,1,21,5,90,7,22,14,13,2,56,4,8,6,37,164,87]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(b,o,S,n,P){this._textDocumentsAndEditors=S,this._textDocuments=n,this._extensionStoragePaths=P,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new A.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new A.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new A.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new A.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new A.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new A.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(m.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(m.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(m.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const c=r.notebookEditor?.notebookUri,w=r.cell.handle,d=this._documents.get(c)?.getCell(w);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const o=this._editors.get(b);if(!o)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(b){for(const[o,S]of this._editors)if(S.apiEditor===b)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,o){const S=this._documents.get(b);if(!S&&!o)throw new Error(`NO notebook document for '${b}'`);return S}_getProviderData(b){const o=this._notebookContentProviders.get(b);if(!o)throw new Error(`NO provider for '${b}'`);return o}registerNotebookContentProvider(b,o,S,n,P){if((0,T.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:b,provider:S});let r;return S.onDidChangeNotebookContentOptions&&(r=S.onDidChangeNotebookContentOptions(()=>{const c=t.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(o,c)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},o,t.NotebookDocumentContentOptions.from(n),k._convertNotebookRegistrationData(b,P)),new u.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(b,o){if(!o)return;const S=o.filenamePattern.map(n=>t.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(o.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:o.displayName,filenamePattern:S,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,o,S){const n=k._notebookStatusBarItemProviderHandlePool++,P=typeof S.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,P,o);let r;return P!==void 0&&(r=S.onDidChangeCellStatusBarItems(c=>this._notebookProxy.$emitCellStatusBarEvent(P))),new u.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,P),r&&r.dispose()})}async createNotebookDocument(b){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&t.NotebookData.from(b.content)});return F.URI.revive(o)}async openNotebookDocument(b){const o=this._documents.get(b);if(o)return o.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(b),n=this._documents.get(F.URI.revive(S));return(0,y.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(b,o){F.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let S;typeof o=="object"?S={position:t.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(t.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:S={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,S),P=n&&this._editors.get(n)?.apiEditor;if(P)return P;throw n?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,o,S,n){const P=this._notebookStatusBarItemProviders.get(b),r=F.URI.revive(o),c=this._documents.get(r);if(!c||!P)return;const w=c.getCellFromIndex(S);if(!w)return;const h=await P.provideCellStatusBarItems(w.apiCell,n);if(!h)return;const d=new D.DisposableStore,g=this._statusBarCache.add([d]),E=(Array.isArray(h)?h:[h]).map(C=>t.NotebookStatusBarItem.from(C,this._commandsConverter,d));return{cacheId:g,items:E}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,o,S,n,P){if((0,T.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,S),this._notebookProxy.$registerNotebookSerializer(r,{id:b.identifier,location:b.extensionLocation},o,t.NotebookDocumentContentOptions.from(n),k._convertNotebookRegistrationData(b,P)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(b,o,S){const n=this._notebookSerializer.get(b);if(!n)throw new Error("NO serializer found");const P=await n.deserializeNotebook(o.buffer,S);return new s.SerializableObjectWithBuffers(t.NotebookData.from(P))}async $notebookToData(b,o,S){const n=this._notebookSerializer.get(b);if(!n)throw new Error("NO serializer found");const P=await n.serializeNotebook(t.NotebookData.to(o.value),S);return i.VSBuffer.wrap(P)}async $openNotebook(b,o,S,n,P){const{provider:r}=this._getProviderData(b),c=await r.openNotebook(F.URI.revive(o),{backupId:S,untitledDocumentData:n?.buffer},P);return new s.SerializableObjectWithBuffers({metadata:c.metadata??Object.create(null),cells:c.cells.map(t.NotebookCellData.from)})}async $saveNotebook(b,o,S){const n=this.getNotebookDocument(F.URI.revive(o)),{provider:P}=this._getProviderData(b);return await P.saveNotebook(n.apiNotebook,S),!0}async $saveNotebookAs(b,o,S,n){const P=this.getNotebookDocument(F.URI.revive(o)),{provider:r}=this._getProviderData(b);return await r.saveNotebookAs(F.URI.revive(S),P.apiNotebook,n),!0}async $backupNotebook(b,o,S){const n=this.getNotebookDocument(F.URI.revive(o)),P=this._getProviderData(b),r=this._extensionStoragePaths.workspaceValue(P.extension)??this._extensionStoragePaths.globalValue(P.extension),c=String((0,_.hash)([n.uri.toString(),this._backupIdPool++])),w=F.URI.joinPath(r,c),h=await P.provider.backupNotebook(n.apiNotebook,{destination:w},S);return n.updateBackup(h),h.id}_createExtHostEditor(b,o,S){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const n=new l.ExtHostNotebookEditor(o,this._notebookEditorsProxy,b,S.visibleRanges.map(t.NotebookRange.to),S.selections.map(t.NotebookRange.to),typeof S.viewColumn=="number"?t.ViewColumn.to(S.viewColumn):void 0);this._editors.set(o,n)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const S of b.value.removedDocuments){const n=F.URI.revive(S),P=this._documents.get(n);P&&(P.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:P.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(P.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===n.toString()&&this._editors.delete(r.id)}if(b.value.addedDocuments){const S=[];for(const n of b.value.addedDocuments){const P=F.URI.revive(n.uri);if(this._documents.has(P))throw new Error(`adding EXISTING notebook ${P} `);const r=this,c=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(w){r._onDidChangeNotebookCells.fire(w)},emitCellOutputsChange(w){r._onDidChangeCellOutputs.fire(w)},emitCellMetadataChange(w){r._onDidChangeCellMetadata.fire(w)}},P,n);S.push(...n.cells.map(w=>a.ExtHostCell.asModelAddData(c.apiNotebook,w))),this._documents.get(P)?.dispose(),this._documents.set(P,c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(c.apiNotebook)}}if(b.value.addedEditors)for(const S of b.value.addedEditors){if(this._editors.has(S.id))return;const n=F.URI.revive(S.documentUri),P=this._documents.get(n);P&&this._createExtHostEditor(P,S.id,S)}const o=[];if(b.value.removedEditors)for(const S of b.value.removedEditors){const n=this._editors.get(S);n&&(this._editors.delete(S),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),o.push(n))}if(b.value.visibleEditors){this._visibleNotebookEditors=b.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const S=new Set;this._visibleNotebookEditors.forEach(n=>S.add(n.id));for(const n of this._editors.values()){const P=S.has(n.id);n._acceptVisibility(P)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this._activeNotebookEditor=void 0:b.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(be[192],we([0,1,5,52,9,4,12,8]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(m,t){const u=y._Keys.nextId();m.$registerNotebookEditorDecorationType(u,T.NotebookDecorationRenderOptions.from(t)),this.value={key:u,dispose(){m.$removeNotebookEditorDecorationType(u)}}}}y._Keys=new A.IdGenerator("NotebookEditorDecorationType");let F=class{constructor(m,t,u){this._logService=m,this._extHostRpc=t,this._notebooksAndEditors=u,this._onDidChangeNotebookEditorSelection=new i.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new i.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(m){return new y(this._extHostRpc.getProxy(D.MainContext.MainThreadNotebookEditors),m).value}$acceptEditorPropertiesChanged(m,t){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,t);const u=this._notebooksAndEditors.getEditorById(m);t.visibleRanges&&u._acceptVisibleRanges(t.visibleRanges.ranges.map(T.NotebookRange.to)),t.selections&&u._acceptSelections(t.selections.selections.map(T.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:u.apiEditor,visibleRanges:u.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:u.apiEditor,selections:u.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const t in m)this._notebooksAndEditors.getEditorById(t)._acceptViewColumn(T.ViewColumn.to(m[t]))}};F=Le([Ne(0,_.ILogService),Ne(1,M.IExtHostRpcService)],F),e.ExtHostNotebookEditors=F}),define(be[193],we([0,1,16,10,20,5,7,22,2,23,9,4,38,8,6,59,157,26,37]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(c,w,h,d,g){this._initData=w,this._extHostNotebook=h,this._commands=d,this._logService=g,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new D.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=c.getProxy(m.MainContext.MainThreadNotebookKernels);const f=new t.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new t.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const C=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:C}}else if(E&&"notebookEditor"in E){const C=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(C===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:C}}return E})],t.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(c,w,h,d,g,f){for(const ge of this._kernelData.values())if(ge.controller.id===w&&F.ExtensionIdentifier.equals(c.identifier,ge.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const E=this._handlePool++,C=this;this._logService.trace(`NotebookController[${E}], CREATED by ${c.identifier.value}, ${w}`);const I=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${c.identifier}'`);let N=!1;const p=new M.DisposableStore,R=new D.Emitter,x=new D.Emitter,j={id:P(c,w),notebookType:h,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:d||c.identifier.value,preloads:f?f.map(u.NotebookRendererScript.from):[]};let H=g??I,z;this._proxy.$addKernel(E,j).catch(ge=>{console.log(ge),N=!0});let K=0;const ce=()=>{if(N)return;const ge=++K;Promise.resolve().then(()=>{ge===K&&this._proxy.$updateKernel(E,j)})},fe=new T.ResourceMap,re={get id(){return w},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return j.label},set label(ge){j.label=ge??c.displayName??c.name,ce()},get detail(){return j.detail??""},set detail(ge){j.detail=ge,ce()},get description(){return j.description??""},set description(ge){j.description=ge,ce()},get kind(){return(0,k.checkProposedApiEnabled)(c,"notebookControllerKind"),j.kind??""},set kind(ge){(0,k.checkProposedApiEnabled)(c,"notebookControllerKind"),j.kind=ge,ce()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(ge){j.supportedLanguages=ge,ce()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){j.supportsExecutionOrder=ge,ce()},get rendererScripts(){return j.preloads?j.preloads.map(u.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(ge){H=ge??I},get interruptHandler(){return z},set interruptHandler(ge){z=ge,j.supportsInterrupt=Boolean(ge),ce()},createNotebookCellExecution(ge){if(N)throw new Error("notebook controller is DISPOSED");if(!fe.has(ge.notebook.uri))throw C._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(fe.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return C._createNotebookCellExecution(ge,P(c,this.id))},dispose:()=>{N||(this._logService.trace(`NotebookController[${E}], DISPOSED`),N=!0,this._kernelData.delete(E),p.dispose(),R.dispose(),x.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(ge,ye){C._proxy.$updateNotebookPriority(E,ge.uri,ye)},onDidReceiveMessage:x.event,postMessage(ge,ye){return(0,k.checkProposedApiEnabled)(c,"notebookMessaging"),C._proxy.$postMessage(E,ye&&C._extHostNotebook.getIdByEditor(ye),ge)},asWebviewUri(ge){return(0,k.checkProposedApiEnabled)(c,"notebookMessaging"),(0,a.asWebviewUri)(ge,C._initData.remote)}};return this._kernelData.set(E,{extensionId:c.identifier,controller:re,onDidReceiveMessage:x,onDidChangeSelection:R,associatedNotebooks:fe}),re}$acceptNotebookAssociation(c,w,h){const d=this._kernelData.get(c);if(d){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(w));h?d.associatedNotebooks.set(g.uri,!0):d.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,g.uri.toString(),h),d.onDidChangeSelection.fire({selected:h,notebook:g.apiNotebook})}}async $executeCells(c,w,h){const d=this._kernelData.get(c);if(!d)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(w)),f=[];for(const E of h){const C=g.getCell(E);C&&f.push(C.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,g.uri.toString(),f.length),await d.controller.executeHandler.call(d.controller,f,g.apiNotebook,d.controller)}catch(E){this._logService.error(`NotebookController[${c}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(c,w,h){const d=this._kernelData.get(c);if(!d)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(w));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,g.apiNotebook);else for(const f of h){const E=g.getCell(f);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,w,h){const d=this._kernelData.get(c);if(!d)return;const g=this._extHostNotebook.getEditorById(w);d.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:h}))}$cellExecutionChanged(c,w,h){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)).getCell(w);g&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:h??s.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(c,w){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!d)throw new Error("invalid cell");if(this._activeExecutions.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const g=new S(w,d,this._proxy);this._activeExecutions.set(d.uri,g);const f=g.onDidChangeState(()=>{g.state===o.Resolved&&(g.dispose(),f.dispose(),this._activeExecutions.delete(d.uri))});return g.asApiObject()}};b=Le([Ne(4,O.ILogService)],b),e.ExtHostNotebookKernels=b;var o;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(o||(o={}));class S extends M.Disposable{constructor(c,w,h){super();this._cell=w,this._proxy=h,this._handle=S.HANDLE++,this._onDidChangeState=new D.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new n(10,d=>this.update(d)),this._executionOrder=w.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,c,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(c){await this._collector.addItem(c)}async update(c){const w=Array.isArray(c)?c:[c];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(w))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(c){return c.map(w=>{const h=s.NotebookCellOutput.ensureUniqueMimeTypes(w.items,!0);return h===w.items?u.NotebookCellOutput.from(w):u.NotebookCellOutput.from({items:h,id:w.id,metadata:w.metadata})})}async updateOutputs(c,w,h){const d=this.validateAndConvertOutputs((0,i.asArray)(c));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,append:h,outputs:d})}async updateOutputItems(c,w,h){return c=s.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(c),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,items:c.map(u.NotebookCellOutputItem.from),outputId:w.id,append:h})}asApiObject(){const c=this;return Object.freeze({get token(){return c._tokenSource.token},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(h){c._executionOrder=h,c.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:c._executionOrder}])},start(h){if(c._state===o.Resolved||c._state===o.Started)throw new Error("Cannot call start again");c._state=o.Started,c._onDidChangeState.fire(),c.update({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,d){if(c._state===o.Resolved)throw new Error("Cannot call resolve twice");c._state=o.Resolved,c._onDidChangeState.fire(),c._collector.flush(),c._proxy.$completeExecution(c._handle,new v.SerializableObjectWithBuffers({runEndTime:d,lastRunSuccess:h}))},clearOutput(h){return c.verifyStateForOutput(),c.updateOutputs([],h,!1)},appendOutput(h,d){return c.verifyStateForOutput(),c.updateOutputs(h,d,!0)},replaceOutput(h,d){return c.verifyStateForOutput(),c.updateOutputs(h,d,!1)},appendOutputItems(h,d){return c.verifyStateForOutput(),c.updateOutputItems(h,d,!0)},replaceOutputItems(h,d){return c.verifyStateForOutput(),c.updateOutputItems(h,d,!1)}})}}S.HANDLE=0;class n{constructor(c,w){this.delay=c,this.callback=w,this.batch=[],this.startedTimer=Date.now()}addItem(c){return this.batch.push(c),this.currentDeferred||(this.currentDeferred=new A.DeferredPromise,this.startedTimer=Date.now(),(0,A.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const c=this.currentDeferred;this.currentDeferred=void 0;const w=this.batch;return this.batch=[],this.callback(w).finally(()=>c.complete())}}function P(r,c){return`${r.identifier.value}/${c}`}}),define(be[194],we([0,1,5,4,87,26]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(y,F){this._extHostNotebook=F,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,F,O){const m=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(F)?.fire({editor:m.apiEditor,message:O})}createRendererMessaging(y,F){if(!y.contributes?.notebookRenderer?.some(u=>u.id===F))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${F})`);const O=(0,D.isProposedApiEnabled)(y,"notebookEditor"),m=new WeakMap;return{onDidReceiveMessage:(u,s,a)=>{const l=O?u:k=>{const v={};m.set(v,k.editor),u({editor:v,message:k.message})};return this.getOrCreateEmitterFor(F).event(l,s,a)},postMessage:(u,s)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,s]=[s,u]);const a=O?s:m.get(s),l=a&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(a);return this.proxy.$postMessage(l?.id,F,u)}}}getOrCreateEmitterFor(y){let F=this._rendererMessageEmitters.get(y);return F||(F=new i.Emitter({onLastListenerRemove:()=>{F?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,F),F)}}e.ExtHostNotebookRenderers=M}),define(be[91],we([0,1,4,7,3,12,9,158,49,27,29,108,21]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class u extends A.Disposable{constructor(l,k,v,b){super();this.id=l,this.name=k,this.logger=v,this.proxy=b,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(l){this.append(l+`
`)}append(l){this.write(l),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const l=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,l)}replace(l){const k=this.offset;this.write(l),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,k),this.visible&&this.logger.flush()}show(l,k){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof l=="boolean"?l:k))}hide(){this.proxy.$close(this.id)}write(l){this.offset+=t.VSBuffer.fromString(l).byteLength,this.logger.info(l)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=u;let s=class{constructor(l,k,v,b,o){this.extHostFileSystem=v,this.extHostFileSystemInfo=b,this.loggerService=o,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=l.getProxy(i.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(k.logsLocation,`output_logging_${(0,m.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.visibleChannelId=l;for(const[k,v]of this.channels)v.visible=k===this.visibleChannelId}createOutputChannel(l,k){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const v=this.doCreateOutputChannel(l,k);return v.then(b=>{this.channels.set(b.id,b),b.visible=b.id===this.visibleChannelId}),this.createExtHostOutputChannel(l,v)}async doCreateOutputChannel(l,k){const v=await this.createOutputDirectory(),b=this.extHostFileSystemInfo.extUri.joinPath(v,`${this.namePool++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(b,{always:!0,donotRotate:!0,donotUseFormatters:!0}),S=await this.proxy.$register(l,!1,b,k.identifier.value);return new u(S,l,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(l,k){let v=!1;const b=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return l},append(o){b(),k.then(S=>S.append(o))},appendLine(o){b(),k.then(S=>S.appendLine(o))},clear(){b(),k.then(o=>o.clear())},replace(o){b(),k.then(S=>S.replace(o))},show(o,S){b(),k.then(n=>n.show(o,S))},hide(){b(),k.then(o=>o.hide())},dispose(){v=!0,k.then(o=>o.dispose())}}}};s=Le([Ne(0,D.IExtHostRpcService),Ne(1,F.IExtHostInitDataService),Ne(2,y.IExtHostConsumerFileSystem),Ne(3,O.IExtHostFileSystemInfo),Ne(4,M.ILoggerService)],s),e.ExtHostOutputService=s,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(be[195],we([0,1,10,20,5,7,4,2,6,15,16,33,55]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function u(s,a,l){const k=s.getProxy(M.MainContext.MainThreadQuickOpen);class v{constructor(h,d){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=d}showQuickPick(h,d,g=A.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(h),E=++this._instances,C=k.$show(E,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},g),I={},N=C.then(()=>I);return Promise.race([N,f]).then(p=>{if(p!==I)return f.then(R=>{const x=[];for(let j=0;j<R.length;j++){const H=R[j];typeof H=="string"?x.push({label:H,handle:j}):H.kind===y.QuickPickItemKind.Separator?x.push({type:"separator",label:H.label}):x.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:j})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{d.onDidSelectItem(R[j])}),k.$setItems(E,x),C.then(j=>{if(typeof j=="number")return R[j];if(Array.isArray(j))return j.map(H=>R[H])})})}).then(void 0,p=>{if(!(0,F.isCancellationError)(p))return k.$setError(E,p),Promise.reject(p)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,d=A.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,k.$input(h,typeof this._validateInput=="function",d).then(void 0,g=>{if(!(0,F.isCancellationError)(g))return Promise.reject(g)})}$validateInput(h){return this._validateInput?(0,i.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,d=A.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!g)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(E=>E.uri.toString()===g.uri.toString())}createQuickPick(h){const d=new r(h,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(h){const d=new c(h,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(h,d){const g=this._sessions.get(h);g&&g._fireDidChangeValue(d)}$onDidAccept(h){const d=this._sessions.get(h);d&&d._fireDidAccept()}$onDidChangeActive(h,d){const g=this._sessions.get(h);g instanceof r&&g._fireDidChangeActive(d)}$onDidChangeSelection(h,d){const g=this._sessions.get(h);g instanceof r&&g._fireDidChangeSelection(d)}$onDidTriggerButton(h,d){const g=this._sessions.get(h);g&&g._fireDidTriggerButton(d)}$onDidTriggerItemButton(h,d,g){const f=this._sessions.get(h);f instanceof r&&f._fireDidTriggerItemButton(d,g)}$onDidHide(h){const d=this._sessions.get(h);d&&d._fireDidHide()}}class b{constructor(h,d){this._extensionId=h,this._onDidDispose=d,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((d,g)=>{const f=d===y.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(f,d)}),this.update({buttons:h.map((d,g)=>({...P(d),tooltip:d.tooltip,handle:d===y.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const d=this._handlesToButtons.get(h);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),k.$dispose(this._id))}update(h){if(!this._disposed){for(const d of Object.keys(h)){const g=h[d];this._pendingUpdate[d]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){k.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function o(w){if(w instanceof y.ThemeIcon)return{id:w.id};const h=n(w),d=S(w);return{dark:typeof h=="string"?T.URI.file(h):h,light:typeof d=="string"?T.URI.file(d):d}}function S(w){return typeof w=="object"&&"light"in w?w.light:w}function n(w){return typeof w=="object"&&"dark"in w?w.dark:w}function P(w){const h=o(w.iconPath);let d,g;return"id"in h?g=t.ThemeIcon.asClassName(h):d=h,{iconPath:d,iconClass:g}}class r extends b{constructor(h,d){super(h.identifier,d);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((g,f)=>{this._handlesToItems.set(f,g),this._itemsToHandles.set(g,f)});const d=[];for(let g=0;g<h.length;g++){const f=h[g];f.kind===y.QuickPickItemKind.Separator?d.push({type:"separator",label:f.label}):d.push({handle:g,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons?.map((E,C)=>({...P(E),tooltip:E.tooltip,handle:C}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(h){const d=(0,O.coalesce)(h.map(g=>this._handlesToItems.get(g)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(h){const d=(0,O.coalesce)(h.map(g=>this._handlesToItems.get(g)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(h,d){const g=this._handlesToItems.get(h);if(!g||!g.buttons||!g.buttons.length)return;const f=g.buttons[d];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:g})}}class c extends b{constructor(h,d){super(h,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?m.default.Error:m.default.Ignore})}}return new v(a,l)}e.createExtHostQuickOpen=u});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[196],we([0,1,2,5,51,7,10,4,16,103,9,23,55,8,26]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s){"use strict";var a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function k(g){if(g)return typeof g.iconPath=="string"?i.URI.file(g.iconPath):i.URI.isUri(g.iconPath)||t.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function v(g,f){if(!g.iconPath&&!f.iconPath)return 0;if(g.iconPath){if(!f.iconPath)return 1}else return-1;const E=typeof g.iconPath=="string"?g.iconPath:i.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,C=typeof f.iconPath=="string"?f.iconPath:i.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,F.comparePaths)(E,C)}function b(g,f){let E=0;if(g.strikeThrough!==f.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==f.faded)return g.faded?1:-1;if(g.tooltip!==f.tooltip)return(g.tooltip||"").localeCompare(f.tooltip||"");if(E=v(g,f),E!==0)return E;if(g.light&&f.light)E=v(g.light,f.light);else{if(g.light)return 1;if(f.light)return-1}if(E!==0)return E;if(g.dark&&f.dark)E=v(g.dark,f.dark);else{if(g.dark)return 1;if(f.dark)return-1}return E}function o(g,f){if(g.command!==f.command)return g.command<f.command?-1:1;if(g.title!==f.title)return g.title<f.title?-1:1;if(g.tooltip!==f.tooltip){if(g.tooltip!==void 0&&f.tooltip!==void 0)return g.tooltip<f.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(g.arguments===f.arguments)return 0;if(g.arguments)if(f.arguments){if(g.arguments.length!==f.arguments.length)return g.arguments.length-f.arguments.length}else return 1;else return-1;for(let E=0;E<g.arguments.length;E++){const C=g.arguments[E],I=f.arguments[E];if(C!==I)return C<I?-1:1}return 0}function S(g,f){let E=(0,F.comparePaths)(g.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(E!==0)return E;if(g.command&&f.command)E=o(g.command,f.command);else{if(g.command)return 1;if(f.command)return-1}if(E!==0)return E;if(g.decorations&&f.decorations)E=b(g.decorations,f.decorations);else{if(g.decorations)return 1;if(f.decorations)return-1}return E}function n(g,f){for(let E=0;E<g.length;E++)if(g[E]!==f[E])return!1;return!0}function P(g,f){return g.command===f.command&&g.title===f.title&&g.tooltip===f.tooltip&&(g.arguments&&f.arguments?n(g.arguments,f.arguments):g.arguments===f.arguments)}function r(g,f){return(0,y.equals)(g,f,P)}class c{constructor(f,E,C){this._extension=f,this._sourceControlHandle=C,a.set(this,void 0),this._value="",this._onDidChange=new A.Emitter,this._placeholder="",this._visible=!0,Ge(this,a,E,"f")}get value(){return this._value}set value(f){f=f??"",De(this,a,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){De(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,De(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,De(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,E){(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),De(this,a,"f").$showValidationMessage(this._sourceControlHandle,f,E)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=c,a=new WeakMap;class w{constructor(f,E,C,I,N){this._proxy=f,this._commands=E,this._sourceControlHandle=C,this._id=I,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new A.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=w._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,E){const C=this._resourceStatesCommandsMap.get(f);return C?(0,M.asPromise)(()=>this._commands.executeCommand(C.command,...C.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(S),C=(0,y.sortedDiff)(this._resourceSnapshot,f,S).map(p=>{const R=p.toInsert.map(x=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,x);const H=x.resourceUri;let z;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const et=new D.DisposableStore;z=this._commands.converter.toInternal(x.command,et),this._resourceStatesDisposablesMap.set(j,et)}else this._resourceStatesCommandsMap.set(j,x.command);const K=k(x.decorations),ce=x.decorations&&k(x.decorations.light)||K,fe=x.decorations&&k(x.decorations.dark)||K,re=[ce,fe],ge=x.decorations&&x.decorations.tooltip||"",ye=x.decorations&&!!x.decorations.strikeThrough,ve=x.decorations&&!!x.decorations.faded,Me=x.contextValue||"";return{rawResource:[j,H,re,ge,ye,ve,Me,z],handle:j}});return{start:p.start,deleteCount:p.deleteCount,toInsert:R}}),I=C.map(({start:p,deleteCount:R,toInsert:x})=>[p,R,x.map(j=>j.rawResource)]),N=C.reverse();for(const{start:p,deleteCount:R,toInsert:x}of N){const j=x.map(z=>z.handle),H=this._handlesSnapshot.splice(p,R,...j);for(const z of H)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=f,I}dispose(){this._disposed=!0,this._onDidDispose.fire()}}w._handlePool=0;class h{constructor(f,E,C,I,N,p){this._extension=f,this._commands=C,this._id=I,this._label=N,this._rootUri=p,l.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new D.MutableDisposable,this._statusBarDisposables=new D.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new A.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=h._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ge(this,l,E,"f"),this._inputBox=new c(f,De(this,l,"f"),this.handle),De(this,l,"f").$registerSourceControl(this.handle,I,N,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,De(this,l,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,De(this,l,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,De(this,l,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new D.DisposableStore,this._acceptInputCommand=f;const E=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);De(this,l,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new D.DisposableStore,this._actionButton=f;const E=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),description:f.description}:void 0;De(this,l,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&r(this._statusBarCommands,f))return;this._statusBarDisposables.value=new D.DisposableStore,this._statusBarCommands=f;const E=(f||[]).map(C=>this._commands.converter.toInternal(C,this._statusBarDisposables.value));De(this,l,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(f,E){const C=new w(De(this,l,"f"),this._commands,this.handle,f,E),I=A.Event.once(C.onDidDispose)(()=>this.createdResourceGroups.delete(C));return this.createdResourceGroups.set(C,I),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const f=[],E=[];for(const[C,I]of this.createdResourceGroups){I.dispose();const N=C.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(C),this.eventuallyUpdateResourceStates()});A.Event.once(C.onDidDispose)(()=>{this.updatedResourceGroups.delete(C),N.dispose(),this._groups.delete(C.handle),De(this,l,"f").$unregisterGroup(this.handle,C.handle)}),f.push([C.handle,C.id,C.label,C.features]);const p=C._takeResourceStateSnapshot();p.length>0&&E.push([C.handle,p]),this._groups.set(C.handle,C)}De(this,l,"f").$registerGroups(this.handle,f,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(E=>{const C=E._takeResourceStateSnapshot();C.length!==0&&f.push([E.handle,C])}),f.length>0&&De(this,l,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),De(this,l,"f").$unregisterSourceControl(this.handle)}}l=new WeakMap,h._handlePool=0,Le([(0,_.debounce)(100)],h.prototype,"eventuallyAddResourceGroups",null),Le([(0,_.debounce)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let d=class Vi{constructor(f,E,C){this._commands=E,this.logService=C,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new A.Emitter,this._proxy=f.getProxy(T.MainContext.MainThreadSCM),this._telemetry=f.getProxy(T.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const N=this._sourceControls.get(I.sourceControlHandle);if(!N)return I;const p=N.getResourceGroup(I.groupHandle);return p?p.getResourceState(I.handle):I}else if(I&&I.$mid===4){const N=this._sourceControls.get(I.sourceControlHandle);return N?N.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const N=this._sourceControls.get(I.handle);return N||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,E,C,I){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,E,C,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const N=Vi._handlePool++,p=new h(f,this._proxy,this._commands,E,C,I);this._sourceControls.set(N,p);const R=this._sourceControlsByExtension.get(m.ExtensionIdentifier.toKey(f.identifier))||[];return R.push(p),this._sourceControlsByExtension.set(m.ExtensionIdentifier.toKey(f.identifier),R),p}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const E=this._sourceControlsByExtension.get(m.ExtensionIdentifier.toKey(f.identifier)),C=E&&E[E.length-1];return C&&C.inputBox}$provideOriginalResource(f,E,C){const I=i.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,I.toString());const N=this._sourceControls.get(f);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(I,C)).then(p=>p||null)}$onInputBoxValueChange(f,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const C=this._sourceControls.get(f);return C&&C.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(f,E,C,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,E,C);const N=this._sourceControls.get(f);if(!N)return Promise.resolve(void 0);const p=N.getResourceGroup(E);return p?p.$executeResourceCommand(C,I):Promise.resolve(void 0)}$validateInput(f,E,C){this.logService.trace("ExtHostSCM#$validateInput",f);const I=this._sourceControls.get(f);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,M.asPromise)(()=>I.inputBox.validateInput(E,C)).then(N=>{if(!N)return Promise.resolve(void 0);const p=u.MarkdownString.fromStrict(N.message);return p?Promise.resolve([p,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};d._handlePool=0,d=Le([Ne(2,O.ILogService)],d),e.ExtHostSCM=d});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[197],we([0,1,6,4,120,7,8,13]),function(Z,e,i,A,_,D,M,T){"use strict";var y,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(s,a,l,k,v=i.StatusBarAlignment.Left,b){y.set(this,void 0),F.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new D.DisposableStore,Ge(this,y,s,"f"),Ge(this,F,a,"f"),this._entryId=O.ID_GEN++,this._extension=l,this._id=k,this._alignment=v,this._priority=this.validatePriority(b)}validatePriority(s){if(!!(0,T.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!O.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:De(this,F,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:De(this,F,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,De(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let a;this._name?a=this._name:a=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const k=this._tooltip?M.MarkdownString.fromStrict(this._tooltip):void 0;De(this,y,"f").$setEntry(this._entryId,s,a,this._text,k,this._command?.internal,l,this._backgroundColor,this._alignment===i.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,F=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class m{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const a={message:s};return this._messages.unshift(a),this._update(),new i.Disposable(()=>{const l=this._messages.indexOf(a);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class t{constructor(s,a){this._proxy=s.getProxy(A.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new m(this)}createStatusBarEntry(s,a,l,k){return new O(this._proxy,this._commands,s,a,l,k)}setStatusBarMessage(s,a){const l=this._statusMessage.setMessage(s);let k;return typeof a=="number"?k=setTimeout(()=>l.dispose(),a):typeof a!="undefined"&&a.then(()=>l.dispose(),()=>l.dispose()),new i.Disposable(()=>{l.dispose(),clearTimeout(k)})}}e.ExtHostStatusBar=t}),define(be[64],we([0,1,4,5,3]),function(Z,e,i,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class D{constructor(T){this._onDidChangeStorage=new A.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,y){this._proxy.$registerExtensionStorageKeysToSync(T,y)}initializeExtensionStorage(T,y,F){return this._proxy.$initializeExtensionStorage(T,y).then(O=>O||F)}setValue(T,y,F){return this._proxy.$setValue(T,y,F)}$acceptValue(T,y,F){this._onDidChangeStorage.fire({shared:T,key:y,value:F})}}e.ExtHostStorage=D,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(be[65],we([0,1,3,27,9,49,2]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let T=class{constructor(F,O,m){this._logService=O,this._extHostFileSystem=m,this._workspace=F.workspace??void 0,this._environment=F.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(t=>this._value=t)}async _getWorkspaceStorageURI(F){return M.URI.joinPath(this._environment.workspaceStorageHome,F)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const F=this._workspace.id,O=await this._getWorkspaceStorageURI(F);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(M.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:M.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(m){this._logService.error("[ExtHostStorage]",m);return}}workspaceValue(F){if(this._value)return M.URI.joinPath(this._value,F.identifier.value)}globalValue(F){return M.URI.joinPath(this._environment.globalStorageHome,F.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Le([Ne(0,A.IExtHostInitDataService),Ne(1,_.ILogService),Ne(2,D.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(be[39],we([0,1,5,4,3,2,12,7,6,121,15,160,20,34,140,55,13,10]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class v{constructor(h,d,g,f){this._proxy=h,this._id=d,this._creationOptions=g,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(C=>this._pidPromiseComplete=C);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(C,I=!0){E._checkDisposed(),E._proxy.$sendText(E._id,C,I)},show(C){E._checkDisposed(),E._proxy.$show(E._id,C)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(h,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:h.name,shellPath:(0,l.withNullAsUndefined)(h.shellPath),shellArgs:(0,l.withNullAsUndefined)(h.shellArgs),cwd:(0,l.withNullAsUndefined)(h.cwd),env:(0,l.withNullAsUndefined)(h.env),icon:(0,l.withNullAsUndefined)(r(h.iconPath)),color:a.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:(0,l.withNullAsUndefined)(h.message),strictEnv:(0,l.withNullAsUndefined)(h.strictEnv),hideFromUser:(0,l.withNullAsUndefined)(h.hideFromUser),isFeatureTerminal:(0,l.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,l.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(h.location,d?.resolvedExtHostIdentifier),disablePersistence:(0,l.withNullAsUndefined)(h.disablePersistence)})}async createExtensionTerminal(h,d,g,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:a.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(h,d),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(h,d){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in h?{viewColumn:h.viewColumn,preserveFocus:h.preserveFocus}:void 0:h}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(h){this._name=h}setExitCode(h){this._exitStatus=Object.freeze({code:h})}setDimensions(h,d){return h===this._cols&&d===this._rows||h===0||d===0?!1:(this._cols=h,this._rows=d,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(h){this._pidPromiseComplete?(this._pidPromiseComplete(h),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==h&&(this._pidPromise=Promise.resolve(h))})}}e.ExtHostTerminal=v;class b{constructor(h){this._pty=h,this.id=0,this.shouldPersist=!1,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new i.Emitter,this._onDidChangeProperty=new i.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${d}`)}async start(){}shutdown(){this._pty.close()}input(h){this._pty.handleInput?.(h)}resize(h,d){this._pty.setDimensions?.({columns:h,rows:d})}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(h){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose?.((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions?.(d=>{d&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this._pty.onDidChangeName?.(d=>{this._onDidChangeProperty.fire({type:"title",value:d})}),this._pty.open(h||void 0),h&&this._pty.setDimensions?.(h),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let o=1,S=class extends T.Disposable{constructor(h,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new i.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new i.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new i.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new i.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new i.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(A.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(h),this._register({dispose:()=>{for(const[g,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(h=>h.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(h,d){const g=new v(this._proxy,(0,u.generateUuid)(),h,h.name),f=new b(h.pty);return g.createExtensionTerminal(h.location,this._serializeParentTerminal(h,d).resolvedExtHostIdentifier,r(h.iconPath),c(h.color)).then(E=>{const C=this._setupExtHostProcessListeners(E,f);this._terminalProcessDisposables[E]=C}),this._terminals.push(g),g.value}_serializeParentTerminal(h,d){if(d=d||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const g=h.location.parentTerminal;if(g){const f=this._terminals.find(E=>E.value===g);f&&(d.resolvedExtHostIdentifier=f._id)}}else h.location&&typeof h.location!="object"?d.location=h.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(h,d){if(!this._getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const f=new b(d),E=this._setupExtHostProcessListeners(h,f);this._terminalProcessDisposables[h]=E}async $acceptActiveTerminalChanged(h){const d=this._activeTerminal;if(h===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(h);g&&(this._activeTerminal=g,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(h,d){const g=this._getTerminalById(h);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:d})}async $acceptTerminalDimensions(h,d,g){const f=this._getTerminalById(h);f&&f.setDimensions(d,g)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(h,d,g){this._terminalProcesses.get(h)?.resize(d,g)}async $acceptTerminalTitleChange(h,d){const g=this._getTerminalById(h);g&&(g.name=d)}async $acceptTerminalClosed(h,d){const g=this._getTerminalObjectIndexById(this._terminals,h);if(g!==null){const f=this._terminals.splice(g,1)[0];f.setExitCode(d),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(h,d,g,f){if(d){const I=this._getTerminalObjectIndexById(this._terminals,d);if(I!==null){this._terminals[I]._id=h,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const E={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:D.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},C=new v(this._proxy,h,E,g);this._terminals.push(C),this._onDidOpenTerminal.fire(C.value),C.isOpen=!0}async $acceptTerminalProcessId(h,d){const g=this._getTerminalById(h);g&&g._setProcessId(d)}async $startExtensionTerminal(h,d){const g=this._getTerminalById(h);if(!g)return{message:(0,F.localize)(0,null,h)};g.isOpen||await new Promise(E=>{const C=this.onDidOpenTerminal(async I=>{I===g.value&&(C.dispose(),E())})});const f=this._terminalProcesses.get(h);f?f.startSendingEvents(d):this._extensionTerminalAwaitingStart[h]={initialDimensions:d}}_setupExtHostProcessListeners(h,d){const g=new T.DisposableStore;g.add(d.onProcessReady(E=>this._proxy.$sendProcessReady(h,E.pid,E.cwd))),g.add(d.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(h,E))),this._bufferer.startBuffering(h,d.onProcessData),g.add(d.onProcessExit(E=>this._onProcessExit(h,E))),this._terminalProcesses.set(h,d);const f=this._extensionTerminalAwaitingStart[h];return f&&d instanceof b&&(d.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[h]),g}$acceptProcessAckDataEvent(h,d){this._terminalProcesses.get(h)?.acknowledgeDataEvent(d)}$acceptProcessInput(h,d){this._terminalProcesses.get(h)?.input(d)}$acceptTerminalInteraction(h){const d=this._getTerminalById(h);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(h,d,g){try{this._terminalProcesses.get(h)?.resize(d,g)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(h,d){this._terminalProcesses.get(h)?.shutdown(d)}$acceptProcessRequestInitialCwd(h){this._terminalProcesses.get(h)?.getInitialCwd().then(d=>this._proxy.$sendProcessProperty(h,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(h){this._terminalProcesses.get(h)?.getCwd().then(d=>this._proxy.$sendProcessProperty(h,{type:"cwd",value:d}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this._linkProviders.add(h),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(h),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(h,d,g){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,g),this._proxy.$registerProfileProvider(d,h.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(h,d){const g=new t.CancellationTokenSource().token;let f=await this._profileProviders.get(h)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,d);return}this.createTerminalFromOptions(f.options,d)}}async $provideLinks(h,d){const g=this._getTerminalById(h);if(!g)return[];this._terminalLinkCache.delete(h);const f=this._terminalLinkCancellationSource.get(h);f&&f.dispose(!0);const E=new t.CancellationTokenSource;this._terminalLinkCancellationSource.set(h,E);const C=[],I={terminal:g.value,line:d},N=[];for(const x of this._linkProviders)N.push(k.Promises.withAsyncBody(async j=>{E.token.onCancellationRequested(()=>j({provider:x,links:[]}));const H=await x.provideTerminalLinks(I,E.token)||[];E.token.isCancellationRequested||j({provider:x,links:H})}));const p=await Promise.all(N);if(E.token.isCancellationRequested)return[];const R=new Map;for(const x of p)x&&x.links.length>0&&C.push(...x.links.map(j=>{const H={id:o++,startIndex:j.startIndex,length:j.length,label:j.tooltip};return R.set(H.id,{provider:x.provider,link:j}),H}));return this._terminalLinkCache.set(h,R),C}$activateLink(h,d){const g=this._terminalLinkCache.get(h)?.get(d);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(h,d){this._bufferer.stopBuffering(h),this._terminalProcesses.delete(h),delete this._extensionTerminalAwaitingStart[h];const g=this._terminalProcessDisposables[h];g&&(g.dispose(),delete this._terminalProcessDisposables[h]),this._proxy.$sendProcessExit(h,d)}_getTerminalById(h){return this._getTerminalObjectById(this._terminals,h)}_getTerminalObjectById(h,d){const g=this._getTerminalObjectIndexById(h,d);return g!==null?h[g]:null}_getTerminalObjectIndexById(h,d){let g=null;return h.some((f,E)=>f._id===d?(g=E,!0):!1),g}getEnvironmentVariableCollection(h){let d=this._environmentVariableCollections.get(h.identifier.value);return d||(d=new n,this._setEnvironmentVariableCollection(h.identifier.value,d)),d}_syncEnvironmentVariableCollection(h,d){const g=(0,m.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(h,d.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(h){h.forEach(d=>{const g=d[0],f=new n(d[1]);this._setEnvironmentVariableCollection(g,f)})}$acceptDefaultProfile(h,d){this._defaultProfile=h,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(h,d){this._environmentVariableCollections.set(h,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(h,d)})}};S=Le([Ne(1,M.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class n{constructor(h){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,this.map=new Map(h)}get persistent(){return this._persistent}set persistent(h){this._persistent=h,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(h,d){this._setIfDiffers(h,{value:d,type:y.EnvironmentVariableMutatorType.Replace})}append(h,d){this._setIfDiffers(h,{value:d,type:y.EnvironmentVariableMutatorType.Append})}prepend(h,d){this._setIfDiffers(h,{value:d,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(h,d){const g=this.map.get(h);(!g||g.value!==d.value||g.type!==d.type)&&(this.map.set(h,d),this._onDidChangeCollection.fire())}get(h){return this.map.get(h)}forEach(h,d){this.map.forEach((g,f)=>h.call(d,f,g,this))}delete(h){this.map.delete(h),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let P=class extends S{constructor(h){super(!1,h)}createTerminal(h,d,g){throw new O.NotSupportedError}createTerminalFromOptions(h,d){throw new O.NotSupportedError}};P=Le([Ne(0,M.IExtHostRpcService)],P),e.WorkerExtHostTerminalService=P;function r(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function c(w){return a.ThemeColor.isThemeColor(w)?w:void 0}});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[198],we([0,1,16,21,20,5,230,90,7,25,13,34,4,12,47,8,6,166,82,60]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(I,N){this.resultsChangedEmitter=new D.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(t.MainContext.MainThreadTesting),this.observer=new g(this.proxy),this.runTracker=new P(this.proxy),N.registerArgumentProcessor({processArgument:p=>p?.$mid===13?a.TestItem.toItemFromContext(p):p})}createTestController(I,N,p){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const R=new y.DisposableStore,x=R.add(new k.SingleUseTestCollection(I));x.root.label=N;const j=new Map,H=this.proxy,z={items:x.root.children,get label(){return N},set label(ce){N=ce,x.root.label=ce,H.$updateController(I,{label:N})},get refreshHandler(){return p},set refreshHandler(ce){p=ce,H.$updateController(I,{canRefresh:!!ce})},get id(){return I},createRunProfile:(ce,fe,re,ge,ye)=>{let ve=(0,T.hash)(ce);for(;j.has(ve);)ve++;const Me=new f(this.proxy,I,ve,ce,fe,re,ge,ye);return j.set(ve,Me),Me},createTestItem(ce,fe,re){return new s.TestItemImpl(I,ce,fe,re)},createTestRun:(ce,fe,re=!0)=>this.runTracker.createTestRun(I,x,ce,fe,re),set resolveHandler(ce){x.resolveHandler=ce},get resolveHandler(){return x.resolveHandler},dispose:()=>{R.dispose()}};H.$registerTestController(I,N,!!p),R.add((0,y.toDisposable)(()=>H.$unregisterTestController(I)));const K={controller:z,collection:x,profiles:j};return this.controllers.set(I,K),R.add((0,y.toDisposable)(()=>this.controllers.delete(I))),R.add(x.onDidGenerateDiff(ce=>H.$publishDiff(I,ce))),z}createTestObserver(){return this.observer.checkout()}async runTests(I,N=_.CancellationToken.None){const p=r(I);if(!p)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const R=this.controllers.get(p.controllerId);if(!R)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(x=>x.id)??[R.collection.root.id],profileGroup:E[p.kind],profileId:p.profileId,controllerId:p.controllerId}],exclude:I.exclude?.map(x=>x.id)},N)}$provideFileCoverage(I,N,p){return(0,i.mapFind)(this.runTracker.trackers,x=>x.id===I?x.getCoverage(N):void 0)?.provideFileCoverage(p)??Promise.resolve([])}$resolveFileCoverage(I,N,p,R){return(0,i.mapFind)(this.runTracker.trackers,j=>j.id===I?j.getCoverage(N):void 0)?.resolveFileCoverage(p,R)??Promise.resolve([])}$configureRunProfile(I,N){this.controllers.get(I)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(I,N){await this.controllers.get(I)?.controller.refreshHandler?.(N)}$publishTestResults(I){this.results=Object.freeze(I.map(N=>(0,F.deepFreeze)(a.TestResults.to(N))).concat(this.results).sort((N,p)=>p.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,N){const p=this.controllers.get(b.TestId.fromString(I).controllerId)?.collection;p&&(await p.expand(I,N<0?1/0:N),p.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,N){const p=this.controllers.get(I.controllerId);if(!p)return;const{collection:R,profiles:x}=p,j=x.get(I.profileId);if(!j)return;const H=I.testIds.map(fe=>R.tree.get(fe)).filter(O.isDefined),z=I.excludeExtIds.map(fe=>p.collection.tree.get(fe)).filter(O.isDefined).filter(fe=>H.some(re=>re.fullId.compare(fe.fullId)===2));if(!H.length)return;const K=new l.TestRunRequest(H.some(fe=>fe.actual instanceof s.TestItemRootImpl)?void 0:H.map(fe=>fe.actual),z.map(fe=>fe.actual),j),ce=this.runTracker.prepareForMainThreadTestRun(K,c.fromInternal(I,p.collection),N);try{await j.runHandler(K,N)}finally{ce.isRunning&&!N.isCancellationRequested&&await D.Event.toPromise(ce.onEnd),ce.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};S=Le([Ne(0,u.IExtHostRpcService)],S),e.ExtHostTesting=S;class n extends y.Disposable{constructor(I,N,p){super();this.dto=I,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new D.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(p)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:R}of this.tasks.values())R.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const N=this.dto.id,p=this.dto.controllerId,R=(0,m.generateUuid)(),x=new w(this.proxy,N,R),j=ce=>(fe,...re)=>{if(z){console.warn(`Setting the state of test "${fe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(fe)||(this.ensureTestIsKnown(fe),ce(fe,...re))},H=(ce,fe)=>{const re=fe instanceof Array?fe.map(a.TestMessage.from):[a.TestMessage.from(fe)];if(ce.uri&&ce.range){const ge={range:a.Range.from(ce.range),uri:ce.uri};for(const ye of re)ye.location=ye.location||ge}this.proxy.$appendTestMessagesInRun(N,R,b.TestId.fromExtHostTestItem(ce,p).toString(),re)};let z=!1;const K={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return x.coverageProvider},set coverageProvider(ce){x.coverageProvider=ce},enqueued:j(ce=>{this.proxy.$updateTestStateInRun(N,R,b.TestId.fromExtHostTestItem(ce,p).toString(),1)}),skipped:j(ce=>{this.proxy.$updateTestStateInRun(N,R,b.TestId.fromExtHostTestItem(ce,p).toString(),5)}),started:j(ce=>{this.proxy.$updateTestStateInRun(N,R,b.TestId.fromExtHostTestItem(ce,p).toString(),2)}),errored:j((ce,fe,re)=>{H(ce,fe),this.proxy.$updateTestStateInRun(N,R,b.TestId.fromExtHostTestItem(ce,p).toString(),6,re)}),failed:j((ce,fe,re)=>{H(ce,fe),this.proxy.$updateTestStateInRun(N,R,b.TestId.fromExtHostTestItem(ce,p).toString(),4,re)}),passed:j((ce,fe)=>{this.proxy.$updateTestStateInRun(N,R,b.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,fe)}),appendOutput:(ce,fe,re)=>{z||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(N,R,A.VSBuffer.fromString(ce),fe&&a.location.from(fe),re&&b.TestId.fromExtHostTestItem(re,p).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(N,R),this.tasks.delete(R),this.isRunning||this.dispose())}};return this.tasks.set(R,{run:K,coverage:x}),this.proxy.$startedTestRunTask(N,{id:R,name:I,running:!0}),K}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof s.TestItemImpl))throw new s.InvalidTestItemError(I.id);if(this.sharedTestIds.has(b.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const N=[],p=this.dto.colllection.root;for(;;){const R=a.TestItem.from(I);if(N.unshift(R),this.sharedTestIds.has(R.extId)||(this.sharedTestIds.add(R.extId),I===p))break;I=I.parent||p}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class P{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,N,p){return this.getTracker(I,N,p)}cancelRunById(I){for(const N of this.tracked.values())if(N.id===I){N.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,N,p,R,x){const j=this.tracked.get(p);if(j)return j.createRun(R);const H=c.fromPublic(I,N,p,x),z=r(p);this.proxy.$startedExtensionTestRun({controllerId:I,profile:z&&{group:E[z.kind],id:z.profileId},exclude:p.exclude?.map(ce=>ce.id)??[],id:H.id,include:p.include?.map(ce=>ce.id)??[N.root.id],persist:x});const K=this.getTracker(p,H);return K.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),K.createRun(R)}getTracker(I,N,p){const R=new n(N,this.proxy,p);return this.tracked.set(I,R),R.onEnd(()=>this.tracked.delete(I)),R}}e.TestRunCoordinator=P;const r=C=>{if(!!C.profile){if(!(C.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class c{constructor(I,N,p,R,x,j){this.controllerId=I,this.id=N,this.isPersisted=x,this.colllection=j,this.includePrefix=p.map(H=>H+"\0"),this.excludePrefix=R.map(H=>H+"\0")}static fromPublic(I,N,p,R){return new c(I,(0,m.generateUuid)(),p.include?.map(x=>b.TestId.fromExtHostTestItem(x,I).toString())??[I],p.exclude?.map(x=>b.TestId.fromExtHostTestItem(x,I).toString())??[],R,N)}static fromInternal(I,N){return new c(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,N)}isIncluded(I){const N=b.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const p of this.excludePrefix)if(N===p||N.startsWith(p))return!1;for(const p of this.includePrefix)if(N===p||N.startsWith(p))return!0;return!1}}e.TestRunDto=c;class w{constructor(I,N,p){this.proxy=I,this.runId=N,this.taskId=p}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(I,N){const p=await this.fileCoverage;let R=p?.[I];return!this._coverageProvider||!p||!R?[]:(R.detailedCoverage||(R=p[I]=await this._coverageProvider.resolveFileCoverage?.(R,N)??R),R.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class h extends v.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,a.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:N,removed:p}=this;return{get added(){return[...I].map(R=>R.revived)},get updated(){return[...N].map(R=>R.revived)},get removed(){return[...p].map(R=>R.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,N){return{...I,revived:a.TestItem.toPlain(I.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=d;class g{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(N=>N.revived)},dispose:(0,M.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class f{constructor(I,N,p,R,x,j,H=!1,z=void 0){this.controllerId=N,this.profileId=p,this._label=R,this.kind=x,this.runHandler=j,this._isDefault=H,this._tag=z,o.set(this,void 0),Ge(this,o,I,"f");const K=E[x];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);De(this,o,"f").$publishTestRunProfile({profileId:p,controllerId:N,tag:z?a.TestTag.namespace(this.controllerId,z.id):null,label:R,group:K,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,De(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,De(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,De(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?a.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,De(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){De(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,o=new WeakMap;const E={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(be[199],we([0,1,5,16,4,88,8,6]),function(Z,e,i,A,_,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,m){this._extHostDocumentsAndEditors=m,this._onDidChangeTextEditorSelection=new i.Emitter,this._onDidChangeTextEditorOptions=new i.Emitter,this._onDidChangeTextEditorVisibleRanges=new i.Emitter,this._onDidChangeTextEditorViewColumn=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(t=>this._onDidChangeVisibleTextEditors.fire(t)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(t=>this._onDidChangeActiveTextEditor.fire(t))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const m=this._extHostDocumentsAndEditors.allEditors();return O?m:m.map(t=>t.value)}async showTextDocument(O,m,t){let u;typeof m=="number"?u={position:M.ViewColumn.from(m),preserveFocus:t}:typeof m=="object"?u={position:M.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selection:typeof m.selection=="object"?M.Range.from(m.selection):void 0,pinned:typeof m.preview=="boolean"?!m.preview:void 0}:u={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(O.uri,u),a=s&&this._extHostDocumentsAndEditors.getEditor(s);if(a)return a.value;throw s?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,m){return new D.TextEditorDecorationType(this._proxy,O,m).value}$acceptEditorPropertiesChanged(O,m){const t=this._extHostDocumentsAndEditors.getEditor(O);if(!t)throw new Error("unknown text editor");if(m.options&&t._acceptOptions(m.options),m.selections){const u=m.selections.selections.map(M.Selection.to);t._acceptSelections(u)}if(m.visibleRanges){const u=A.coalesce(m.visibleRanges.map(M.Range.to));t._acceptVisibleRanges(u)}if(m.options&&this._onDidChangeTextEditorOptions.fire({textEditor:t.value,options:{...m.options,lineNumbers:M.TextEditorLineNumbersStyle.to(m.options.lineNumbers)}}),m.selections){const u=T.TextEditorSelectionChangeKind.fromValue(m.selections.source),s=m.selections.selections.map(M.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:t.value,selections:s,kind:u})}if(m.visibleRanges){const u=A.coalesce(m.visibleRanges.map(M.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:t.value,visibleRanges:u})}}$acceptEditorPositionData(O){for(const m in O){const t=this._extHostDocumentsAndEditors.getEditor(m);if(!t)throw new Error("Unknown text editor");const u=M.ViewColumn.to(O[m]);t.value.viewColumn!==u&&(t._acceptViewColumn(u),this._onDidChangeTextEditorViewColumn.fire({textEditor:t.value,viewColumn:u}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(be[200],we([0,1,2,3,4,7,6]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class T{constructor(O,m){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=O.getProxy(_.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===11){const u=t.uri===void 0?void 0:i.URI.revive(t.uri);return this._itemsBySourceAndUriMap.get(t.source)?.get(y(u))?.get(t.handle)}return t}})}async $getTimeline(O,m,t,u,s){return this._providers.get(O)?.provideTimeline(i.URI.revive(m),t,u,s)}registerTimelineProvider(O,m,t,u){const s=new D.DisposableStore,a=this.convertTimelineItem(m.id,u,s).bind(this);let l;m.onDidChange&&(l=m.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:m.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...m,scheme:O,onDidChange:void 0,async provideTimeline(v,b,o,S){S?.resetCache&&(s.clear(),k.get(m.id)?.clear());const n=await m.provideTimeline(v,b,o);if(n==null)return;const P=a(v,S);return{...n,source:m.id,items:n.items.map(P)}},dispose(){for(const v of k.values())v.get(m.id)?.clear();l?.dispose(),s.dispose()}})}convertTimelineItem(O,m,t){return(u,s)=>{let a;if(s?.cacheResults){let l=this._itemsBySourceAndUriMap.get(O);l===void 0&&(l=new Map,this._itemsBySourceAndUriMap.set(O,l));const k=y(u);a=l.get(k),a===void 0&&(a=new Map,l.set(k,a))}return l=>{const{iconPath:k,...v}=l,b=`${O}|${l.id??l.timestamp}`;a?.set(b,l);let o,S,n;return l.iconPath&&(k instanceof M.ThemeIcon?n={id:k.id,color:k.color}:i.URI.isUri(k)?(o=k,S=k):{light:o,dark:S}=k),{...v,id:v.id??void 0,handle:b,source:O,command:l.command?m.toInternal(l.command,t):void 0,icon:o,iconDark:S,themeIcon:n,accessibilityInformation:l.accessibilityInformation}}}}registerTimelineProviderCore(O){if(this._providers.get(O.id))throw new Error(`Timeline Provider ${O.id} already exists.`);return this._proxy.$registerTimelineProvider({id:O.id,label:O.label,scheme:O.scheme}),this._providers.set(O.id,O),(0,D.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(O.id)?.clear();this._providers.delete(O.id),this._proxy.$unregisterTimelineProvider(O.id),O.dispose()})}}e.ExtHostTimeline=T;function y(F){return F?.toString()}}),define(be[201],we([0,1,7,11,2,4]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class M{constructor(y){this._openers=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,F,O,m){if(this._openers.has(F))throw new Error(`Opener with id '${F}' already registered`);const t=m.schemes.find(u=>!M.supportedSchemes.has(u));if(t)throw new Error(`Scheme '${t}' is not supported. Only http and https are currently supported.`);return this._openers.set(F,O),this._proxy.$registerUriOpener(F,m.schemes,y,m.label),(0,i.toDisposable)(()=>{this._openers.delete(F),this._proxy.$unregisterUriOpener(F)})}async $canOpenUri(y,F,O){const m=this._openers.get(y);if(!m)throw new Error(`Unknown opener with id: ${y}`);const t=_.URI.revive(F);return m.canOpenExternalUri(t,O)}async $openUri(y,F,O){const m=this._openers.get(y);if(!m)throw new Error(`Unknown opener id: '${y}'`);return m.openExternalUri(_.URI.revive(F.resolvedUri),{sourceUri:_.URI.revive(F.sourceUri)},O)}}e.ExtHostUriOpeners=M,M.supportedSchemes=new Set([A.Schemas.http,A.Schemas.https])}),define(be[202],we([0,1,4,2,7,15,23]),function(Z,e,i,A,_,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(F){this.handles=new Set,this.handlers=new Map,this._proxy=F.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(F,O){if(this.handles.has(M.ExtensionIdentifier.toKey(F)))throw new Error(`Protocol handler already registered for extension ${F}`);const m=T.HandlePool++;return this.handles.add(M.ExtensionIdentifier.toKey(F)),this.handlers.set(m,O),this._proxy.$registerUriHandler(m,F),(0,_.toDisposable)(()=>{this.handles.delete(M.ExtensionIdentifier.toKey(F)),this.handlers.delete(m),this._proxy.$unregisterUriHandler(m)})}$handleExternalUri(F,O){const m=this.handlers.get(F);if(!m)return Promise.resolve(void 0);try{m.handleUri(A.URI.revive(O))}catch(t){(0,D.onUnexpectedError)(t)}return Promise.resolve(void 0)}async createAppUri(F){return A.URI.revive(await this._proxy.$createAppUri(F))}}e.ExtHostUrls=T,T.HandlePool=0});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[50],we([0,1,5,11,2,130,150,59,4]),function(Z,e,i,A,_,D,M,T,y){"use strict";var F,O,m,t,u,s,a,l,k,v,b,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class S{constructor(g,f,E,C,I,N,p){F.set(this,void 0),O.set(this,void 0),m.set(this,void 0),t.set(this,void 0),u.set(this,void 0),s.set(this,void 0),a.set(this,""),l.set(this,void 0),k.set(this,!1),v.set(this,!1),b.set(this,!1),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new i.Emitter),this._onDidDispose=De(this,o,"f").event,Ge(this,F,g,"f"),Ge(this,O,f,"f"),Ge(this,l,E,"f"),Ge(this,t,C,"f"),Ge(this,u,I,"f"),Ge(this,s,N,"f"),Ge(this,b,n(N),"f"),Ge(this,m,p,"f")}dispose(){Ge(this,k,!0,"f"),De(this,o,"f").fire(),De(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Ge(this,v,!0,"f"),(0,T.asWebviewUri)(g,De(this,t,"f").remote)}get cspSource(){const g=De(this,s,"f").extensionLocation;if(g.scheme===A.Schemas.https||g.scheme===A.Schemas.http){let f=g.toString();return f.endsWith("/")||(f+="/"),f+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),De(this,a,"f")}set html(g){this.assertNotDisposed(),De(this,a,"f")!==g&&(Ge(this,a,g,"f"),!De(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Ge(this,v,!0,"f"),De(this,m,"f").report("Webview vscode-resource: uris",De(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),De(this,O,"f").$setHtml(De(this,F,"f"),g))}get options(){return this.assertNotDisposed(),De(this,l,"f")}set options(g){this.assertNotDisposed(),De(this,O,"f").$setOptions(De(this,F,"f"),c(De(this,s,"f"),De(this,u,"f"),g)),Ge(this,l,g,"f")}async postMessage(g){if(De(this,k,"f"))return!1;const f=(0,M.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:De(this,b,"f")});return De(this,O,"f").$postMessage(De(this,F,"f"),f.message,...f.buffers)}assertNotDisposed(){if(De(this,k,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=S,F=new WeakMap,O=new WeakMap,m=new WeakMap,t=new WeakMap,u=new WeakMap,s=new WeakMap,a=new WeakMap,l=new WeakMap,k=new WeakMap,v=new WeakMap,b=new WeakMap,o=new WeakMap;function n(d){try{const g=(0,D.normalizeVersion)((0,D.parseVersion)(d.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class P{constructor(g,f,E,C,I){this.initData=f,this.workspace=E,this._logService=C,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=g.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(g,f,E){const C=this.getWebview(g);if(C){const{message:I}=(0,M.deserializeWebviewMessage)(f,E.value);C._onMessageEmitter.fire(I)}}$onMissingCsp(g,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,f,E){const C=new S(g,this._webviewProxy,w(f),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(g,C),C._onDidDispose(()=>{this._webviews.delete(g)}),C}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=P;function r(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=r;function c(d,g,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||h(d,g)}}e.serializeWebviewOptions=c;function w(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(g=>_.URI.from(g))}}e.reviveOptions=w;function h(d,g){return[...(g?.getWorkspaceFolders()||[]).map(f=>f.uri),d.extensionLocation]}}),define(be[203],we([0,1,20,90,7,11,24,2,8,50,56,4,6]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class u{constructor(n,P){this.document=n,this._storagePath=P,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,P){await this.getEdit(n).undo(),P||this.disposeBackup()}async redo(n,P){await this.getEdit(n).redo(),P||this.disposeBackup()}disposeEdits(n){for(const P of n)this._edits.delete(P)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=o(this.document.uri)+this._backupCounter++;return(0,M.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const P=this._edits.get(n,0);if(!P)throw new Error("No edit found");return P}}class s{constructor(){this._documents=new Map}get(n,P){return this._documents.get(this.key(n,P))}add(n,P,r){const c=this.key(n,P.uri);if(this._documents.has(c))throw new Error(`Document already exists for viewType:${n} resource:${P.uri}`);const w=new u(P,r);return this._documents.set(c,w),w}delete(n,P){const r=this.key(n,P.uri);this._documents.delete(r)}key(n,P){return`${n}@@@${P}`}}var a;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(a||(a={}));class l{constructor(){this._providers=new Map}addTextProvider(n,P,r){return this.add(0,n,P,r)}addCustomProvider(n,P,r){return this.add(1,n,P,r)}get(n){return this._providers.get(n)}add(n,P,r,c){if(this._providers.has(P))throw new Error(`Provider for viewType:${P} already registered`);return this._providers.set(P,{type:n,extension:r,provider:c}),new t.Disposable(()=>this._providers.delete(P))}}class k{constructor(n,P,r,c,w){this._extHostDocuments=P,this._extensionStoragePaths=r,this._extHostWebview=c,this._extHostWebviewPanels=w,this._editorProviders=new l,this._documents=new s,this._proxy=n.getProxy(m.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,P,r,c){const w=new _.DisposableStore;return v(r)?(w.add(this._editorProviders.addTextProvider(P,n,r)),this._proxy.$registerTextEditorProvider((0,F.toExtensionData)(n),P,c.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,F.shouldSerializeBuffersForPostMessage)(n))):(w.add(this._editorProviders.addCustomProvider(P,n,r)),this.supportEditing(r)&&w.add(r.onDidChangeCustomDocument(h=>{const d=this.getCustomDocumentEntry(P,h.document.uri);if(b(h)){const g=d.addEdit(h);this._proxy.$onDidEdit(h.document.uri,P,g,h.label)}else this._proxy.$onContentChange(h.document.uri,P)})),this._proxy.$registerCustomEditorProvider((0,F.toExtensionData)(n),P,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,F.shouldSerializeBuffersForPostMessage)(n))),t.Disposable.from(w,new t.Disposable(()=>{this._proxy.$unregisterEditorProvider(P)}))}async $createCustomDocument(n,P,r,c,w){const h=this._editorProviders.get(P);if(!h)throw new Error(`No provider found for '${P}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${P}'`);const d=T.URI.revive(n),g=await h.provider.openCustomDocument(d,{backupId:r,untitledDocumentData:c?.buffer},w);let f;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(P,g,f),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(n,P){const r=this._editorProviders.get(P);if(!r)throw new Error(`No provider found for '${P}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${P}'`);const c=T.URI.revive(n),{document:w}=this.getCustomDocumentEntry(P,c);this._documents.delete(P,w),w.dispose()}async $resolveWebviewEditor(n,P,r,c,w,h){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);const g=y.ViewColumn.to(w),f=this._extHostWebview.createNewWebview(P,c.webviewOptions,d.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(P,r,c.title,g,c.panelOptions,f),C=T.URI.revive(n);switch(d.type){case 1:{const{document:I}=this.getCustomDocumentEntry(r,C);return d.provider.resolveCustomEditor(I,E,h)}case 0:{const I=this._extHostDocuments.getDocument(C);return d.provider.resolveCustomTextEditor(I,E,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,P,r){this.getCustomDocumentEntry(P,n).disposeEdits(r)}async $onMoveCustomEditor(n,P,r){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const w=this._extHostWebviewPanels.getWebviewPanel(n);if(!w)throw new Error("No webview found");const h=T.URI.revive(P),d=this._extHostDocuments.getDocument(h);await c.provider.moveCustomTextEditor(d,w,i.CancellationToken.None)}async $undo(n,P,r,c){return this.getCustomDocumentEntry(P,n).undo(r,c)}async $redo(n,P,r,c){return this.getCustomDocumentEntry(P,n).redo(r,c)}async $revert(n,P,r){const c=this.getCustomDocumentEntry(P,n);await this.getCustomEditorProvider(P).revertCustomDocument(c.document,r),c.disposeBackup()}async $onSave(n,P,r){const c=this.getCustomDocumentEntry(P,n);await this.getCustomEditorProvider(P).saveCustomDocument(c.document,r),c.disposeBackup()}async $onSaveAs(n,P,r,c){const w=this.getCustomDocumentEntry(P,n);return this.getCustomEditorProvider(P).saveCustomDocumentAs(w.document,T.URI.revive(r),c)}async $backup(n,P,r){const c=this.getCustomDocumentEntry(P,n),h=await this.getCustomEditorProvider(P).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},r);return c.updateBackup(h),h.id}getCustomDocumentEntry(n,P){const r=this._documents.get(n,T.URI.revive(P));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(n){const r=this._editorProviders.get(n)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function v(S){return typeof S.resolveCustomTextEditor=="function"}function b(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function o(S){const n=S.scheme===D.Schemas.file||S.scheme===D.Schemas.untitled?S.fsPath:S.toString();return(0,A.hash)(n)+""}});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[204],we([0,1,5,7,2,34,8,50,4,6]),function(Z,e,i,A,_,D,M,T,y,F){"use strict";var O,m,t,u,s,a,l,k,v,b,o,S,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends A.Disposable{constructor(h,d,g,f,E,C,I){super();O.set(this,void 0),m.set(this,void 0),t.set(this,void 0),u.set(this,void 0),s.set(this,void 0),a.set(this,void 0),l.set(this,void 0),k.set(this,void 0),v.set(this,!0),b.set(this,!0),o.set(this,!1),S.set(this,this._register(new i.Emitter)),this.onDidDispose=De(this,S,"f").event,n.set(this,this._register(new i.Emitter)),this.onDidChangeViewState=De(this,n,"f").event,Ge(this,O,h,"f"),Ge(this,m,d,"f"),Ge(this,t,g,"f"),Ge(this,s,C,"f"),Ge(this,k,E,"f"),Ge(this,a,f,"f"),Ge(this,u,I,"f")}dispose(){De(this,o,"f")||(Ge(this,o,!0,"f"),De(this,S,"f").fire(),De(this,m,"f").$disposeWebview(De(this,O,"f")),De(this,u,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),De(this,u,"f")}get viewType(){return this.assertNotDisposed(),De(this,t,"f")}get title(){return this.assertNotDisposed(),De(this,a,"f")}set title(h){this.assertNotDisposed(),De(this,a,"f")!==h&&(Ge(this,a,h,"f"),De(this,m,"f").$setTitle(De(this,O,"f"),h))}get iconPath(){return this.assertNotDisposed(),De(this,l,"f")}set iconPath(h){this.assertNotDisposed(),De(this,l,"f")!==h&&(Ge(this,l,h,"f"),De(this,m,"f").$setIconPath(De(this,O,"f"),_.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return De(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof De(this,k,"f")=="number"&&De(this,k,"f")<0))return De(this,k,"f")}get active(){return this.assertNotDisposed(),De(this,b,"f")}get visible(){return this.assertNotDisposed(),De(this,v,"f")}_updateViewState(h){De(this,o,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Ge(this,b,h.active,"f"),Ge(this,v,h.visible,"f"),Ge(this,k,h.viewColumn,"f"),De(this,n,"f").fire({webviewPanel:this}))}reveal(h,d){this.assertNotDisposed(),De(this,m,"f").$reveal(De(this,O,"f"),{viewColumn:typeof h=="undefined"?void 0:M.ViewColumn.from(h),preserveFocus:!!d})}assertNotDisposed(){if(De(this,o,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,m=new WeakMap,t=new WeakMap,u=new WeakMap,s=new WeakMap,a=new WeakMap,l=new WeakMap,k=new WeakMap,v=new WeakMap,b=new WeakMap,o=new WeakMap,S=new WeakMap,n=new WeakMap;class r{constructor(h,d,g){this.webviews=d,this.workspace=g,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,D.generateUuid)()}createWebviewPanel(h,d,g,f,E={}){const C=typeof f=="object"?f.viewColumn:f,I={viewColumn:M.ViewColumn.from(C),preserveFocus:typeof f=="object"&&!!f.preserveFocus},N=(0,T.shouldSerializeBuffersForPostMessage)(h),p=r.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(h),p,d,{title:g,panelOptions:c(E),webviewOptions:(0,T.serializeWebviewOptions)(h,this.workspace,E),serializeBuffersForPostMessage:N},I);const R=this.webviews.createNewWebview(p,E,h);return this.createNewWebviewPanel(p,d,g,C,E,R)}$onDidChangeWebviewPanelViewStates(h){const d=Object.keys(h);d.sort((g,f)=>{const E=h[g],C=h[f];return E.active?1:C.active?-1:+E.visible-+C.visible});for(const g of d){const f=this.getWebviewPanel(g);if(!f)continue;const E=h[g];f._updateViewState({active:E.active,visible:E.visible,viewColumn:M.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,d,g){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:g,extension:h}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(h)}),new F.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(h,d,g,f){const E=this._serializers.get(d);if(!E)throw new Error(`No serializer found for '${d}'`);const{serializer:C,extension:I}=E,N=this.webviews.createNewWebview(h,g.webviewOptions,I),p=this.createNewWebviewPanel(h,d,g.title,f,g.panelOptions,N);await C.deserializeWebviewPanel(p,g.state)}createNewWebviewPanel(h,d,g,f,E,C){const I=new P(h,this._proxy,d,g,f,E,C);return this._webviewPanels.set(h,I),I}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=r;function c(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[205],we([0,1,5,7,50,4,6]),function(Z,e,i,A,_,D,M){"use strict";var T,y,F,O,m,t,u,s,a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends A.Disposable{constructor(o,S,n,P,r,c){super();T.set(this,void 0),y.set(this,void 0),F.set(this,void 0),O.set(this,void 0),m.set(this,!1),t.set(this,void 0),u.set(this,void 0),s.set(this,void 0),a.set(this,this._register(new i.Emitter)),this.onDidChangeVisibility=De(this,a,"f").event,l.set(this,this._register(new i.Emitter)),this.onDidDispose=De(this,l,"f").event,Ge(this,F,n,"f"),Ge(this,u,P,"f"),Ge(this,T,o,"f"),Ge(this,y,S,"f"),Ge(this,O,r,"f"),Ge(this,t,c,"f")}dispose(){De(this,m,"f")||(Ge(this,m,!0,"f"),De(this,l,"f").fire(),De(this,O,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),De(this,u,"f")}set title(o){this.assertNotDisposed(),De(this,u,"f")!==o&&(Ge(this,u,o,"f"),De(this,y,"f").$setWebviewViewTitle(De(this,T,"f"),o))}get description(){return this.assertNotDisposed(),De(this,s,"f")}set description(o){this.assertNotDisposed(),De(this,s,"f")!==o&&(Ge(this,s,o,"f"),De(this,y,"f").$setWebviewViewDescription(De(this,T,"f"),o))}get visible(){return De(this,t,"f")}get webview(){return De(this,O,"f")}get viewType(){return De(this,F,"f")}_setVisible(o){o===De(this,t,"f")||De(this,m,"f")||(Ge(this,t,o,"f"),De(this,a,"f").fire())}show(o){this.assertNotDisposed(),De(this,y,"f").$show(De(this,T,"f"),!!o)}assertNotDisposed(){if(De(this,m,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,y=new WeakMap,F=new WeakMap,O=new WeakMap,m=new WeakMap,t=new WeakMap,u=new WeakMap,s=new WeakMap,a=new WeakMap,l=new WeakMap;class v{constructor(o,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,S,n,P){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:n,extension:o}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(o),S,{retainContextWhenHidden:P?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new M.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(o,S,n,P,r){const c=this._viewProviders.get(S);if(!c)throw new Error(`No view provider found for '${S}'`);const{provider:w,extension:h}=c,d=this._extHostWebview.createNewWebview(o,{},h),g=new k(o,this._proxy,S,n,d,!0);this._webviewViews.set(o,g),await w.resolveWebviewView(g,{state:P},r)}async $onDidChangeWebviewViewVisibility(o,S){this.getWebviewView(o)._setVisible(S)}async $disposeWebviewView(o){const S=this.getWebviewView(o);this._webviewViews.delete(o),S.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const S=this._webviewViews.get(o);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=v}),define(be[92],we([0,1,5,4,2,11,14,3,12]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let F=class ji{constructor(m){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=m.getProxy(A.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(t=>this.$onDidChangeWindowFocus(t))}get state(){return this._state}$onDidChangeWindowFocus(m){m!==this._state.focused&&(this._state={...this._state,focused:m},this._onDidChangeWindowState.fire(this._state))}openUri(m,t){let u;if(typeof m=="string"){u=m;try{m=_.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,M.isFalsyOrWhitespace)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this._proxy.$openUri(m,u,t)}async asExternalUri(m,t){if((0,M.isFalsyOrWhitespace)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this._proxy.$asExternalUri(m,t);return _.URI.from(u)}};F.InitialState={focused:!0},F=Le([Ne(0,y.IExtHostRpcService)],F),e.ExtHostWindow=F,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(be[206],we([0,1,10,21,20,15,5,7,104,172,37]),function(Z,e,i,A,_,D,M,T,y,F,O){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function t(E,C){try{return JSON.stringify(E,C)}catch{return"null"}}const u="$$ref$$",s={[u]:-1};class a{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function l(E,C=null,I=!1){const N=[];return{jsonString:(I?t:JSON.stringify)(E,(R,x)=>{if(typeof x=="undefined")return s;if(typeof x=="object"){if(x instanceof A.VSBuffer){const j=N.push(x)-1;return{[u]:j}}if(C)return C(R,x)}return x}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=l;function k(E,C,I){return JSON.parse(E,(N,p)=>{if(p){const R=p[u];if(typeof R=="number")return C[R];if(I&&p.$mid===1)return I.transformIncoming(p)}return p})}e.parseJsonAndRestoreBufferRefs=k;function v(E,C){return JSON.stringify(E,C)}function b(E){return E?(C,I)=>I&&I.$mid===1?E.transformOutgoing(I):I:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},P=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends T.Disposable{constructor(C,I=null,N=null){super();this[m]=!0,this._onDidChangeResponsiveState=this._register(new M.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=C,this._logger=I,this._uriTransformer=N,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let p=0,R=O.ProxyIdentifier.count;p<R;p++)this._locals[p]=null,this._proxies[p]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(p=>this._receiveOneMessage(p))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(C=>{this._pendingRPCReplies[C].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(C){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(C){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(C){this._responsiveState!==C&&(this._responsiveState=C,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(C){return this._uriTransformer?(0,y.transformIncomingURIs)(C,this._uriTransformer):C}getProxy(C){const{nid:I,sid:N}=C;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,N)),this._proxies[I]}_createProxy(C,I){let N={get:(p,R)=>(typeof R=="string"&&!p[R]&&R.charCodeAt(0)===36&&(p[R]=(...x)=>this._remoteCall(C,R,x)),R===r?I:p[R])};return new Proxy(Object.create(null),N)}set(C,I){return this._locals[C.nid]=I,I}assertRegistered(C){for(let I=0,N=C.length;I<N;I++){const p=C[I];if(!this._locals[p.nid])throw new Error(`Missing proxy instance ${p.sid}`)}}_receiveOneMessage(C){if(this._isDisposed)return;const I=C.byteLength,N=w.read(C,0),p=N.readUInt8(),R=N.readUInt32();switch(p){case 1:case 2:{let{rpcId:x,method:j,args:H}=d.deserializeRequestJSONArgs(N);this._uriTransformer&&(H=(0,y.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(I,R,x,j,H,p===2);break}case 3:case 4:{let{rpcId:x,method:j,args:H}=d.deserializeRequestMixedArgs(N);this._uriTransformer&&(H=(0,y.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(I,R,x,j,H,p===4);break}case 5:{this._logger&&this._logger.logIncoming(I,R,0,"ack"),this._onDidReceiveAcknowledge(R);break}case 6:{this._receiveCancel(I,R);break}case 7:{this._receiveReply(I,R,void 0);break}case 9:{let x=d.deserializeReplyOKJSON(N);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(I,R,x);break}case 10:{const x=d.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(I,R,x);break}case 8:{let x=d.deserializeReplyOKVSBuffer(N);this._receiveReply(I,R,x);break}case 11:{let x=d.deserializeReplyErrError(N);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(I,R,x);break}case 12:{this._receiveReplyErr(I,R,void 0);break}default:console.error("received unexpected message"),console.error(C)}}_receiveRequest(C,I,N,p,R,x){this._logger&&this._logger.logIncoming(C,I,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(N)}.${p}(`,R);const j=String(I);let H,z;if(x){const ce=new _.CancellationTokenSource;R.push(ce.token),H=this._invokeHandler(N,p,R),z=()=>ce.cancel()}else H=this._invokeHandler(N,p,R),z=n;this._cancelInvokedHandlers[j]=z;const K=d.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing(K.byteLength,I,1,"ack"),this._protocol.send(K),H.then(ce=>{delete this._cancelInvokedHandlers[j];const fe=d.serializeReplyOK(I,ce,this._uriReplacer);this._logger&&this._logger.logOutgoing(fe.byteLength,I,1,"reply:",ce),this._protocol.send(fe)},ce=>{delete this._cancelInvokedHandlers[j];const fe=d.serializeReplyErr(I,ce);this._logger&&this._logger.logOutgoing(fe.byteLength,I,1,"replyErr:",ce),this._protocol.send(fe)})}_receiveCancel(C,I){this._logger&&this._logger.logIncoming(C,I,1,"receiveCancel");const N=String(I);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(C,I,N){this._logger&&this._logger.logIncoming(C,I,0,"receiveReply:",N);const p=String(I);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const R=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p],R.resolveOk(N)}_receiveReplyErr(C,I,N){this._logger&&this._logger.logIncoming(C,I,0,"receiveReplyErr:",N);const p=String(I);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const R=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p];let x;N&&(N.$isError?(x=new Error,x.name=N.name,x.message=N.message,x.stack=N.stack):x=N),R.resolveErr(x)}_invokeHandler(C,I,N){try{return Promise.resolve(this._doInvokeHandler(C,I,N))}catch(p){return Promise.reject(p)}}_doInvokeHandler(C,I,N){const p=this._locals[C];if(!p)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(C));let R=p[I];if(typeof R!="function")throw new Error("Unknown method "+I+" on actor "+(0,O.getStringIdentifierForProxy)(C));return R.apply(p,N)}_remoteCall(C,I,N){if(this._isDisposed)return Promise.reject(D.canceled());let p=null;if(N.length>0&&_.CancellationToken.isCancellationToken(N[N.length-1])&&(p=N.pop()),p&&p.isCancellationRequested)return Promise.reject(D.canceled());const R=d.serializeRequestArguments(N,this._uriReplacer),x=++this._lastMessageId,j=String(x),H=new F.LazyPromise;p&&p.onCancellationRequested(()=>{const K=d.serializeCancel(x);this._logger&&this._logger.logOutgoing(K.byteLength,x,0,"cancel"),this._protocol.send(d.serializeCancel(x))}),this._pendingRPCReplies[j]=H,this._onWillSendRequest(x);const z=d.serializeRequest(x,C,I,R,!!p);return this._logger&&this._logger.logOutgoing(z.byteLength,x,0,`request: ${(0,O.getStringIdentifierForProxy)(C)}.${I}(`,N),this._protocol.send(z),H}}e.RPCProtocol=c,m=P,c.UNRESPONSIVE_TIME=3*1e3;class w{constructor(C,I){this._buff=C,this._offset=I}static alloc(C,I,N){let p=new w(A.VSBuffer.alloc(N+1+4),0);return p.writeUInt8(C),p.writeUInt32(I),p}static read(C,I){return new w(C,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(C){this._buff.writeUInt8(C,this._offset),this._offset+=1}readUInt8(){const C=this._buff.readUInt8(this._offset);return this._offset+=1,C}writeUInt32(C){this._buff.writeUInt32BE(C,this._offset),this._offset+=4}readUInt32(){const C=this._buff.readUInt32BE(this._offset);return this._offset+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this._buff.writeUInt8(C.byteLength,this._offset),this._offset+=1,this._buff.set(C,this._offset),this._offset+=C.byteLength}readShortString(){const C=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+C).toString();return this._offset+=C,N}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}readLongString(){const C=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+C).toString();return this._offset+=C,N}writeBuffer(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}readVSBuffer(){const C=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+C);return this._offset+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let N=0,p=C.length;N<p;N++){const R=C[N];switch(I+=1,R.type){case 1:I+=this.sizeLongString(R.value);break;case 2:I+=this.sizeVSBuffer(R.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(R.value);for(let x=0;x<R.buffers.length;++x)I+=this.sizeVSBuffer(R.buffers[x]);break;case 4:break}}return I}writeMixedArray(C){this._buff.writeUInt8(C.length,this._offset),this._offset+=1;for(let I=0,N=C.length;I<N;I++){const p=C[I];switch(p.type){case 1:this.writeUInt8(1),this.writeLongString(p.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p.value);break;case 3:this.writeUInt8(3),this.writeUInt32(p.buffers.length),this.writeLongString(p.value);for(let R=0;R<p.buffers.length;++R)this.writeBuffer(p.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(C);for(let N=0;N<C;N++)switch(this.readUInt8()){case 1:I[N]=this.readLongString();break;case 2:I[N]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),x=this.readLongString(),j=[];for(let H=0;H<R;++H)j.push(this.readVSBuffer());I[N]=new O.SerializableObjectWithBuffers(k(x,j,null));break}case 4:I[N]=void 0;break}return I}}w.sizeUInt32=4;var h;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(h||(h={}));class d{static _useMixedArgSerialization(C){for(let I=0,N=C.length;I<N;I++)if(C[I]instanceof A.VSBuffer||C[I]instanceof O.SerializableObjectWithBuffers||typeof C[I]=="undefined")return!0;return!1}static serializeRequestArguments(C,I){if(this._useMixedArgSerialization(C)){const N=[];for(let p=0,R=C.length;p<R;p++){const x=C[p];if(x instanceof A.VSBuffer)N[p]={type:2,value:x};else if(typeof x=="undefined")N[p]={type:4};else if(x instanceof O.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:H}=l(x.value,I);N[p]={type:3,value:A.VSBuffer.fromString(j),buffers:H}}else N[p]={type:1,value:A.VSBuffer.fromString(v(x,I))}}return{type:1,args:N}}return{type:0,args:v(C,I)}}static serializeRequest(C,I,N,p,R){switch(p.type){case 0:return this._requestJSONArgs(C,I,N,p.args,R);case 1:return this._requestMixedArgs(C,I,N,p.args,R)}}static _requestJSONArgs(C,I,N,p,R){const x=A.VSBuffer.fromString(N),j=A.VSBuffer.fromString(p);let H=0;H+=w.sizeUInt8(),H+=w.sizeShortString(x),H+=w.sizeLongString(j);let z=w.alloc(R?2:1,C,H);return z.writeUInt8(I),z.writeShortString(x),z.writeLongString(j),z.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),N=C.readShortString(),p=C.readLongString();return{rpcId:I,method:N,args:JSON.parse(p)}}static _requestMixedArgs(C,I,N,p,R){const x=A.VSBuffer.fromString(N);let j=0;j+=w.sizeUInt8(),j+=w.sizeShortString(x),j+=w.sizeMixedArray(p);let H=w.alloc(R?4:3,C,j);return H.writeUInt8(I),H.writeShortString(x),H.writeMixedArray(p),H.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),N=C.readShortString(),p=C.readMixedArray(),R=new Array(p.length);for(let x=0,j=p.length;x<j;x++){const H=p[x];typeof H=="string"?R[x]=JSON.parse(H):R[x]=H}return{rpcId:I,method:N,args:R}}static serializeAcknowledged(C){return w.alloc(5,C,0).buffer}static serializeCancel(C){return w.alloc(6,C,0).buffer}static serializeReplyOK(C,I,N){if(typeof I=="undefined")return this._serializeReplyOKEmpty(C);if(I instanceof A.VSBuffer)return this._serializeReplyOKVSBuffer(C,I);if(I instanceof O.SerializableObjectWithBuffers){const{jsonString:p,referencedBuffers:R}=l(I.value,N,!0);return this._serializeReplyOKJSONWithBuffers(C,p,R)}else return this._serializeReplyOKJSON(C,t(I,N))}static _serializeReplyOKEmpty(C){return w.alloc(7,C,0).buffer}static _serializeReplyOKVSBuffer(C,I){let N=0;N+=w.sizeVSBuffer(I);let p=w.alloc(8,C,N);return p.writeVSBuffer(I),p.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static _serializeReplyOKJSON(C,I){const N=A.VSBuffer.fromString(I);let p=0;p+=w.sizeLongString(N);let R=w.alloc(9,C,p);return R.writeLongString(N),R.buffer}static _serializeReplyOKJSONWithBuffers(C,I,N){const p=A.VSBuffer.fromString(I);let R=0;R+=w.sizeUInt32,R+=w.sizeLongString(p);for(const j of N)R+=w.sizeVSBuffer(j);let x=w.alloc(10,C,R);x.writeUInt32(N.length),x.writeLongString(p);for(const j of N)x.writeBuffer(j);return x.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const N=C.readUInt32(),p=C.readLongString(),R=[];for(let x=0;x<N;++x)R.push(C.readVSBuffer());return new O.SerializableObjectWithBuffers(k(p,R,I))}static serializeReplyErr(C,I){return I?this._serializeReplyErrEror(C,I):this._serializeReplyErrEmpty(C)}static _serializeReplyErrEror(C,I){const N=A.VSBuffer.fromString(t(D.transformErrorForSerialization(I),null));let p=0;p+=w.sizeLongString(N);let R=w.alloc(11,C,p);return R.writeLongString(N),R.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(C){return w.alloc(12,C,0).buffer}}var g;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var f;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(f||(f={}))}),define(be[207],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(D){const M=T=>{self.removeEventListener("message",M);const y=T.data;Object.defineProperties(self,{postMessage:{value(F,O){y.postMessage(F,O)}},onmessage:{get(){return y.onmessage},set(F){y.onmessage=F}}}),y.addEventListener("message",F=>{self.dispatchEvent(new MessageEvent("message",{data:F.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(D)};self.addEventListener("message",M)}.toString();class A extends EventTarget{constructor(D,M,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${M}'))`,F=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(F),m=new MessageChannel,t=O,u={type:"_newWorker",id:t,port:m.port2,url:O,options:T};D(u,[m.port2]),this.postMessage=m.port1.postMessage.bind(m.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:t};m.port1.postMessage(s),URL.revokeObjectURL(O),m.port1.close(),m.port2.close()},Object.defineProperties(this,{onmessage:{get(){return m.port1.onmessage},set(s){m.port1.onmessage=s}},onmessageerror:{get(){return m.port1.onmessageerror},set(s){m.port1.onmessageerror=s}}}),m.port1.addEventListener("messageerror",s=>{const a=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(a)}),m.port1.addEventListener("message",s=>{const a=new MessageEvent("message",{data:s.data});this.dispatchEvent(a)}),m.port1.start()}}e.NestedWorker=A}),define(be[208],we([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(be[209],we([0,1,71,11,19,28,24,2,3,143,46,167,208]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let u=class qi{constructor(a,l,k,v){this.localUserHome=a,this.remoteAgentService=l,this.environmentService=k,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||a})()}hasValidBasename(a,l,k){return typeof l=="string"||typeof l=="undefined"?this.resolveOS.then(v=>this.doHasValidBasename(a,v,l)):this.doHasValidBasename(a,l,k)}doHasValidBasename(a,l,k){return a.scheme===A.Schemas.file||a.scheme===A.Schemas.vscodeRemote?(0,i.isValidBasename)(k??(0,M.basename)(a),l===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,l){if(a.remoteAuthority)return A.Schemas.vscodeRemote;const k=(0,F.getVirtualWorkspaceScheme)(l.getWorkspace());if(k)return k;const v=l.getWorkspace().folders[0];if(v)return v.uri.scheme;const b=l.getWorkspace().configuration;return b?b.scheme:A.Schemas.file}async userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?_.win32:_.posix)}async fileURI(a){let l="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const v=a.indexOf("/",2);v===-1?(l=a.substring(2),a="/"):(l=a.substring(2,v),a=a.substring(v)||"/")}return T.URI.from({scheme:A.Schemas.file,authority:l,path:a,query:"",fragment:""})}};u=Le([Ne(1,t.IRemoteAgentService),Ne(2,m.IWorkbenchEnvironmentService),Ne(3,O.IWorkspaceContextService)],u),e.AbstractPathService=u}),define(be[93],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(M,T){this.line=M,this.character=T}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,T){return new i(0,0)}with(M){return new i(0,0)}}e.Position=i;class A{constructor(M,T,y,F){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(M,T),this.end=new i(y,F)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new A(0,0,0,0)}with(M){return new A(0,0,0,0)}}e.Range=A;var _;(function(D){D[D.Information=1]="Information",D[D.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[40],we([0,1,16,36,25,71,14,3,19,15,93,10]),function(Z,e,i,A,_,D,M,T,y,F,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const t="\u27EA ",u=" characters skipped \u27EB",s=(t.length+u.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var a;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function k(K){return!!K.preview}e.resultIsMatch=k;function v(K){return!!K.resource}e.isFileMatch=v;function b(K){return!!K.message}e.isProgressMessage=b;var o;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=S;class n{constructor(ce,fe,re){this.ranges=fe;const ge=Array.isArray(fe)?fe:[fe];if(re&&re.matchLines===1&&P(ge)){ce=(0,M.getNLines)(ce,re.matchLines);let ye="",ve=0,Me=0;const je=Math.floor(re.charsPerLine/5),et=[];for(const lt of ge){const it=Math.max(lt.startColumn-je,0),ft=lt.startColumn+re.charsPerLine;if(it>Me+je+s){const _t=t+(it-Me)+u;ye+=_t+ce.slice(it,ft),ve+=it-(Me+_t.length)}else ye+=ce.slice(Me,ft);et.push(new c(0,lt.startColumn-ve,lt.endColumn-ve)),Me=ft}this.preview={text:ye,matches:Array.isArray(this.ranges)?et:et[0]}}else{const ye=Array.isArray(fe)?fe[0].startLineNumber:fe.startLineNumber;this.preview={text:ce,matches:(0,i.mapArrayOrNot)(fe,ve=>new r(ve.startLineNumber-ye,ve.startColumn,ve.endLineNumber-ye,ve.endColumn))}}}}e.TextSearchMatch=n;function P(K){const ce=K[0].startLineNumber;for(const fe of K)if(fe.startLineNumber!==ce||fe.endLineNumber!==ce)return!1;return!0}class r{constructor(ce,fe,re,ge){this.startLineNumber=ce,this.startColumn=fe,this.endLineNumber=re,this.endColumn=ge}}e.SearchRange=r;class c extends r{constructor(ce,fe,re){super(ce,fe,ce,re)}}e.OneLineRange=c;var w;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(w=e.SearchSortOrder||(e.SearchSortOrder={}));function h(K,ce=!0){const fe=K&&K.files&&K.files.exclude,re=ce&&K&&K.search&&K.search.exclude;if(!fe&&!re)return;if(!fe||!re)return fe||re;let ge=Object.create(null);return ge=_.mixin(ge,_.deepClone(fe)),ge=_.mixin(ge,_.deepClone(re),!0),ge}e.getExcludes=h;function d(K,ce){return K.excludePattern&&A.match(K.excludePattern,ce)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&A.match(K.includePattern,ce)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(fe=>{const re=fe.folder.fsPath;if(D.isEqualOrParent(ce,re)){const ge=y.relative(re,ce);return!fe.includePattern||!!A.match(fe.includePattern,ge)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var g;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(ce,fe){super(ce);this.code=fe}}e.SearchError=f;function E(K){const ce=K.message;if((0,F.isCancellationError)(K))return new f(ce,g.canceled);try{const fe=JSON.parse(ce);return new f(fe.message,fe.code)}catch{return new f(ce,g.other)}}e.deserializeSearchError=E;function C(K){const ce={message:K.message,code:K.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=C;function I(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=I;function N(K){return K.type==="success"}e.isSerializedSearchSuccess=N;function p(K){return!!K.path}e.isSerializedFileMatch=p;function R(K,ce){const fe=K.searchPath?K.searchPath:K.relativePath;return(0,M.fuzzyContains)(fe,ce)}e.isFilePatternMatch=R;class x{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function j(K,ce){const fe={...K||{},...ce||{}};return Object.keys(fe).filter(re=>{const ge=fe[re];return typeof ge=="boolean"&&ge})}e.resolvePatternsForProvider=j;class H{constructor(ce,fe){this._parsedIncludeExpression=null,this._excludeExpression={...ce.excludePattern||{},...fe.excludePattern||{}},this._parsedExcludeExpression=A.parse(this._excludeExpression);let re=ce.includePattern;fe.includePattern&&(re?re={...re,...fe.includePattern}:re=fe.includePattern),re&&(this._parsedIncludeExpression=A.parse(re))}matchesExcludesSync(ce,fe,re){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,fe,re))}includedInQuerySync(ce,fe,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,fe,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ce,fe,re))}includedInQuery(ce,fe,re){const ge=this._parsedExcludeExpression(ce,fe,re),ye=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ce,fe,re):!0;return(0,m.isThenable)(ge)?ge.then(ve=>ve?!1:ye()):ye()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=H;function z(K){for(const ce in K)if(typeof K[ce]!="boolean")return!0;return!1}}),define(be[30],we([0,1,16,10,20,5,22,11,98,24,14,13,2,123,3,9,134,46,29,27,12,8,6,40,4]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b,o,S,n,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(I,N,p){return new F.ExtUri(R=>g(R,p)).isEqual(I,N)}function w(I,N,p){return c(I.uri,N.uri,p)?0:(0,O.compare)(I.uri.toString(),N.uri.toString())}function h(I,N,p){return I.index!==N.index?I.index<N.index?-1:1:c(I.uri,N.uri,p)?(0,O.compare)(I.name,N.name):(0,O.compare)(I.uri.toString(),N.uri.toString())}function d(I,N,p,R){const x=I.slice(0).sort((H,z)=>p(H,z,R)),j=N.slice(0).sort((H,z)=>p(H,z,R));return(0,i.delta)(x,j,(H,z)=>p(H,z,R))}function g(I,N){const p=N.getCapabilities(I.scheme);return!(p&&p&1024)}class f extends k.Workspace{constructor(N,p,R,x,j,H,z){super(N,R.map(K=>new k.WorkspaceFolder(K)),x,j,z);this._name=p,this._isUntitled=H,this._workspaceFolders=[],this._structure=M.TernarySearchTree.forUris(z),R.forEach(K=>{this._workspaceFolders.push(K),this._structure.set(K.uri,K)})}static toExtHostWorkspace(N,p,R,x){if(!N)return{workspace:null,added:[],removed:[]};const{id:j,name:H,folders:z,configuration:K,transient:ce,isUntitled:fe}=N,re=[],ge=p;p?z.forEach((je,et)=>{const lt=t.URI.revive(je.uri),it=f._findFolder(R||p,lt,x);it?(it.name=je.name,it.index=je.index,re.push(it)):re.push({uri:lt,name:je.name,index:et})}):re.push(...z.map(({uri:je,name:et,index:lt})=>({uri:t.URI.revive(je),name:et,index:lt}))),re.sort((je,et)=>je.index<et.index?-1:1);const ye=new f(j,H,re,!!ce,K?t.URI.revive(K):null,!!fe,je=>g(je,x)),{added:ve,removed:Me}=d(ge?ge.workspaceFolders:[],ye.workspaceFolders,w,x);return{workspace:ye,added:ve,removed:Me}}static _findFolder(N,p,R){for(let x=0;x<N.folders.length;x++){const j=N.workspaceFolders[x];if(c(j.uri,p,R))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,p){return p&&this._structure.get(N)&&(N=(0,F.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let E=class{constructor(N,p,R,x){this._onDidChangeWorkspace=new D.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new D.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=x,this._extHostFileSystemInfo=R,this._requestIdProvider=new y.Counter,this._barrier=new A.Barrier,this._proxy=N.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(r.MainContext.MainThreadMessageService);const j=p.workspace;this._confirmedWorkspace=j?new f(j.id,j.name,[],!!j.transient,j.configuration?t.URI.revive(j.configuration):null,!!j.isUntitled,H=>g(H,R)):void 0}$initializeWorkspace(N,p){this._trusted=p,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?t.URI.from({scheme:T.Schemas.untitled,path:(0,F.basename)((0,F.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,p,R,...x){const j=[];if(Array.isArray(x)&&x.forEach(fe=>{t.URI.isUri(fe.uri)&&!j.some(re=>c(re.uri,fe.uri,this._extHostFileSystemInfo))&&j.push({uri:fe.uri,name:fe.name||(0,F.basenameOrAuthority)(fe.uri)})}),this._unconfirmedWorkspace||[p,R].some(fe=>typeof fe!="number"||fe<0)||R===0&&j.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(p+R>H.length)return!1;const z=H.slice(0);z.splice(p,R,...j.map(fe=>({uri:fe.uri,name:fe.name||(0,F.basenameOrAuthority)(fe.uri),index:void 0})));for(let fe=0;fe<z.length;fe++){const re=z[fe];if(z.some((ge,ye)=>ye!==fe&&c(re.uri,ge.uri,this._extHostFileSystemInfo)))return!1}z.forEach((fe,re)=>fe.index=re);const{added:K,removed:ce}=d(H,z,h,this._extHostFileSystemInfo);if(K.length===0&&ce.length===0)return!1;if(this._proxy){const fe=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(fe,p,R,j).then(void 0,re=>{this._unconfirmedWorkspace=void 0;const ge={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(l.Severity.Error,(0,u.localize)(0,null,fe,re.toString()),ge,[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(N,p){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,p)}async getWorkspaceFolder2(N,p){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,p)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,p){let R,x="";if(typeof N=="string"?(R=t.URI.file(N),x=N):typeof N!="undefined"&&(R=N,x=N.fsPath),!R)return x;const j=this.getWorkspaceFolder(R,!0);if(!j)return x;typeof p=="undefined"&&this._actualWorkspace&&(p=this._actualWorkspace.folders.length>1);let H=(0,F.relativePath)(j.uri,R);return p&&j.name&&(H=`${j.name}/${H}`),H}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:p,added:R,removed:x}=f.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=p||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:x}))}findFiles(N,p,R,x,j=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let H;if(p===null?H=!1:p&&(typeof p=="string"?H=p:H=p.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:K}=C(S.GlobPattern.from(N));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(z),(0,m.withUndefinedAsNull)(K),(0,m.withUndefinedAsNull)(H),(0,m.withUndefinedAsNull)(R),j).then(ce=>Array.isArray(ce)?ce.map(fe=>t.URI.revive(fe)):[])}async findTextInFiles(N,p,R,x,j=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),z=typeof p.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:p.previewOptions,{includePattern:K,folder:ce}=C(S.GlobPattern.from(p.include)),fe=typeof p.exclude=="string"?p.exclude:p.exclude?p.exclude.pattern:void 0,re={ignoreSymlinks:typeof p.followSymlinks=="boolean"?!p.followSymlinks:void 0,disregardIgnoreFiles:typeof p.useIgnoreFiles=="boolean"?!p.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof p.useGlobalIgnoreFiles=="boolean"?!p.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof p.useParentIgnoreFiles=="boolean"?!p.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof p.useDefaultExcludes=="boolean"?!p.useDefaultExcludes:!0,fileEncoding:p.encoding,maxResults:p.maxResults,previewOptions:z,afterContext:p.afterContext,beforeContext:p.beforeContext,includePattern:K,excludePattern:fe},ge=!1;if(this._activeSearchCallbacks[H]=ye=>{if(ge)return;const ve=t.URI.revive(ye.resource);ye.results.forEach(Me=>{(0,P.resultIsMatch)(Me)?R({uri:ve,preview:{text:Me.preview.text,matches:(0,i.mapArrayOrNot)(Me.preview.matches,je=>new n.Range(je.startLineNumber,je.startColumn,je.endLineNumber,je.endColumn))},ranges:(0,i.mapArrayOrNot)(Me.ranges,je=>new n.Range(je.startLineNumber,je.startColumn,je.endLineNumber,je.endColumn))}):R({uri:ve,text:Me.text,lineNumber:Me.lineNumber})})},j.isCancellationRequested)return{};try{const ye=await this._proxy.$startTextSearch(N,(0,m.withUndefinedAsNull)(ce),re,H,j);return delete this._activeSearchCallbacks[H],ye||{}}catch(ye){throw delete this._activeSearchCallbacks[H],ye}}$handleTextSearchResult(N,p){this._activeSearchCallbacks[p]&&this._activeSearchCallbacks[p](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Le([Ne(0,o.IExtHostRpcService),Ne(1,b.IExtHostInitDataService),Ne(2,v.IExtHostFileSystemInfo),Ne(3,a.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function C(I){let N,p;return I&&(typeof I=="string"?N=I:(N=I.pattern,p=t.URI.revive(I.baseUri))),{includePattern:N,folder:p}}}),define(be[31],we([0,1,25,5,30,4,6,138,76,13,10,3,12,9,2]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(P,r){if(r){const c=r.split(".");let w=P;for(let h=0;w&&h<c.length;h++)w=w[c[h]];return w}}function l(P){return P instanceof s.URI}function k(P){return P&&P.uri instanceof s.URI&&P.languageId&&typeof P.languageId=="string"}function v(P){return P&&!P.uri&&P.languageId&&typeof P.languageId=="string"}function b(P){return P&&P.uri instanceof s.URI&&(!P.name||typeof P.name=="string")&&(!P.index||typeof P.index=="number")}function o(P){if(l(P))return{resource:P};if(k(P))return{resource:P.uri,overrideIdentifier:P.languageId};if(v(P))return{overrideIdentifier:P.languageId};if(b(P))return{resource:P.uri};if(P===null)return{resource:null}}let S=class{constructor(r,c,w){this._proxy=r.getProxy(D.MainContext.MainThreadConfiguration),this._extHostWorkspace=c,this._logService=w,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(r,c))}};S=Le([Ne(0,t.IExtHostRpcService),Ne(1,_.IExtHostWorkspace),Ne(2,u.ILogService)],S),e.ExtHostConfiguration=S;class n{constructor(r,c,w,h){this._onDidChangeConfiguration=new A.Emitter,this._proxy=r,this._logService=h,this._extHostWorkspace=c,this._configuration=T.Configuration.parse(w),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,c){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(c,w))}getConfiguration(r,c,w){const h=o(c)||{},d=this._toReadonlyValue(r?a(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,h,w?.identifier);function g(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case M.ConfigurationTarget.Global:return 1;case M.ConfigurationTarget.Workspace:return 4;case M.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(E){return typeof a(d,E)!="undefined"},get:(E,C)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,h,w?.identifier);let I=a(d,E);if(typeof I=="undefined")I=C;else{let N;const p=(R,x)=>{let j;const H=()=>{N=N||(0,i.deepClone)(d),j=j||a(N,x)};return(0,F.isObject)(R)?new Proxy(R,{get:(z,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return H(),()=>j;if(N)return j=j||a(N,x),j[K];const ce=z[K];return typeof K=="string"?p(ce,`${x}.${K}`):ce},set:(z,K,ce)=>(H(),j&&(j[K]=ce),!0),deleteProperty:(z,K)=>(H(),j&&delete j[K],!0),defineProperty:(z,K,ce)=>(H(),j&&Object.defineProperty(j,K,ce),!0)}):R};I=p(I,E)}return I},update:(E,C,I,N)=>{E=r?`${r}.${E}`:E;const p=g(I);return C!==void 0?this._proxy.$updateConfigurationOption(p,E,C,h,N):this._proxy.$removeConfigurationOption(p,E,h,N)},inspect:E=>{E=r?`${r}.${E}`:E;const C=(0,i.deepClone)(this._configuration.inspect(E,h,this._extHostWorkspace.workspace));if(C)return{key:E,defaultValue:C.default?.value,globalValue:C.user?.value,workspaceValue:C.workspace?.value,workspaceFolderValue:C.workspaceFolder?.value,defaultLanguageValue:C.default?.override,globalLanguageValue:C.user?.override,workspaceLanguageValue:C.workspace?.override,workspaceFolderLanguageValue:C.workspaceFolder?.override,languageIds:C.overrideIdentifiers}}};return typeof d=="object"&&(0,i.mixin)(f,d,!1),Object.freeze(f)}_toReadonlyValue(r){const c=w=>(0,F.isObject)(w)?new Proxy(w,{get:(h,d)=>c(h[d]),set:(h,d,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(h,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(h,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return c(r)}_validateConfigurationAccess(r,c,w){const h=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),d=w?`[${w.value}] `:"";if(h===4){typeof c?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){c?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,c){const w=new T.ConfigurationChangeEvent(r,c,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,d)=>w.affectsConfiguration(h,o(d))})}_toMap(r){return r.reduce((c,w)=>(c.set(w[0],w[1]),c),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,m.createDecorator)("IExtHostConfiguration")});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[94],we([0,1,2,10,5,4,6,30,48,31,20,39,12,27,3,11,28,9,62,159,15]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b,o){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(x){function j(z){if(z!=null)return z}x.from=j;function H(z){if(z!=null)return z}x.to=H})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var P;(function(x){function j(z){if(z!=null)return z}x.from=j;function H(z){if(z!=null)return z}x.to=H})(P=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(x){function j(z){if(z!=null)return z}x.from=j;function H(z){if(z!=null)return z}x.to=H})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var c;(function(x){function j(K){if(K){const ce=K;return ce&&!!ce.process}else return!1}x.is=j;function H(K){if(K==null)return;const ce={process:K.process,args:K.args};return K.options&&(ce.options=r.from(K.options)),ce}x.from=H;function z(K){if(K!=null)return new M.ProcessExecution(K.process,K.args,K.options)}x.to=z})(c=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var w;(function(x){function j(z){if(z!=null)return z}x.from=j;function H(z){if(z!=null)return z}x.to=H})(w=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(x){function j(K){if(K){const ce=K;return ce&&(!!ce.commandLine||!!ce.command)}else return!1}x.is=j;function H(K){if(K==null)return;const ce={};return K.commandLine!==void 0?ce.commandLine=K.commandLine:(ce.command=K.command,ce.args=K.args),K.options&&(ce.options=w.from(K.options)),ce}x.from=H;function z(K){if(!(K==null||K.command===void 0&&K.commandLine===void 0))return K.commandLine?new M.ShellExecution(K.commandLine,K.options):new M.ShellExecution(K.command,K.args?K.args:[],K.options)}x.to=z})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(x){function j(K){if(K){let ce=K;return ce&&ce.customExecution==="customExecution"}else return!1}x.is=j;function H(K){return{customExecution:"customExecution"}}x.from=H;function z(K,ce){return ce.get(K)}x.to=z})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var g;(function(x){function j(H,z){let K;return H.scope!==void 0&&typeof H.scope!="number"?K=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===M.TaskScope.Workspace&&z&&z.workspaceFile?K=z.workspaceFile:K=b.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:K}}x.from=j})(g=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(x){function j(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}x.from=j})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function j(K,ce){if(K==null)return[];const fe=[];for(let re of K){const ge=H(re,ce);ge&&fe.push(ge)}return fe}x.fromMany=j;function H(K,ce){if(K==null)return;let fe;K.execution instanceof M.ProcessExecution?fe=c.from(K.execution):K.execution instanceof M.ShellExecution?fe=h.from(K.execution):K.execution&&K.execution instanceof M.CustomExecution&&(fe=d.from(K.execution));const re=n.from(K.definition);let ge;return K.scope?typeof K.scope=="number"?ge=K.scope:ge=K.scope.uri:ge=M.TaskScope.Workspace,!re||!ge?void 0:{_id:K._id,definition:re,name:K.name,source:{extensionId:ce.identifier.value,label:K.source,scope:ge},execution:fe,isBackground:K.isBackground,group:f.from(K.group),presentationOptions:P.from(K.presentationOptions),problemMatchers:K.problemMatchers,hasDefinedMatchers:K.hasDefinedMatchers,runOptions:K.runOptions?K.runOptions:{reevaluateOnRerun:!0},detail:K.detail}}x.from=H;async function z(K,ce,fe){if(K==null)return;let re;c.is(K.execution)?re=c.to(K.execution):h.is(K.execution)?re=h.to(K.execution):d.is(K.execution)&&(re=d.to(K._id,fe));const ge=n.to(K.definition);let ye;if(K.source&&(K.source.scope!==void 0?typeof K.source.scope=="number"?ye=K.source.scope:ye=await ce.resolveWorkspaceFolder(i.URI.revive(K.source.scope)):ye=M.TaskScope.Workspace),!ge||!ye)return;const ve=new M.Task(ge,ye,K.name,K.source.label,re,K.problemMatchers);return K.isBackground!==void 0&&(ve.isBackground=K.isBackground),K.group!==void 0&&(ve.group=M.TaskGroup.from(K.group._id),ve.group&&K.group.isDefault&&(ve.group=new M.TaskGroup(ve.group.id,ve.group.label),K.group.isDefault&&(ve.group.isDefault=K.group.isDefault))),K.presentationOptions&&(ve.presentationOptions=P.to(K.presentationOptions)),K._id&&(ve._id=K._id),K.detail&&(ve.detail=K.detail),ve}x.to=z})(E=e.TaskDTO||(e.TaskDTO={}));var C;(function(x){function j(z){return z}x.from=j;function H(z){if(!!z)return Object.assign(Object.create(null),z)}x.to=H})(C=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(j,H,z){this._id=H,this._task=z,S.set(this,void 0),Ge(this,S,j,"f")}get task(){return this._task}terminate(){De(this,S,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}S=new WeakMap;var N;(function(x){function j(H){return{id:H._id,task:void 0}}x.from=j})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let p=class{constructor(j,H,z,K,ce,fe,re,ge){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=j.getProxy(D.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=K,this._configurationService=ce,this._terminalService=fe,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=ge,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,H,z){if(!z)return new M.Disposable(()=>{});const K=this.nextHandle();return this._handlers.set(K,{type:H,provider:z,extension:j}),this._proxy.$registerTaskProvider(K,H),new M.Disposable(()=>{this._handlers.delete(K),this._proxy.$unregisterTaskProvider(K)})}registerTaskSystem(j,H){this._proxy.$registerTaskSystem(j,H)}fetchTasks(j){return this._proxy.$fetchTasks(C.from(j)).then(async H=>{const z=[];for(let K of H){const ce=await E.to(K,this._workspaceProvider,this._providedCustomExecutions2);ce&&z.push(ce)}return z})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(H=>j.push(H)),j}terminateTask(j){if(!(j instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,H,z){const K=this._providedCustomExecutions2.get(j.id);K&&(this._activeCustomExecutions2.set(j.id,K),this._terminalService.attachPtyToTerminal(H,await K.callback(z))),this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const H=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const H=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:H,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const H=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:j.exitCode})}$provideTasks(j,H){const z=this._handlers.get(j);if(!z)return Promise.reject(new Error("no handler found"));const K=[],ce=(0,A.asPromise)(()=>z.provider.provideTasks(O.CancellationToken.None)).then(fe=>this.provideTasksInternal(H,K,z,fe));return new Promise(fe=>{ce.then(re=>{Promise.all(K).then(()=>{fe(re)})})})}async $resolveTask(j,H){const z=this._handlers.get(j);if(!z)return Promise.reject(new Error("no handler found"));if(H.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${z.type}].`);const K=await E.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!K)throw new Error("Unexpected: Task cannot be resolved.");const ce=await z.provider.resolveTask(K,O.CancellationToken.None);if(!ce)return;this.checkDeprecation(ce,z);const fe=E.from(ce,z.extension);if(!fe)throw new Error("Unexpected: Task cannot be resolved.");if(ce.definition!==K.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(fe.execution)&&await this.addCustomExecution(fe,ce,!0),await this.resolveTaskInternal(fe)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,H,z){const K=await this._proxy.$createTaskId(j);!z&&!this._providedCustomExecutions2.has(K)&&(this._notProvidedCustomExecutions.add(K),this._activeCustomExecutions2.set(K,H.execution)),this._providedCustomExecutions2.set(K,H.execution)}async getTaskExecution(j,H){if(typeof j=="string"){const ce=this._taskExecutionPromises.get(j);if(!ce)throw new Error("Unexpected: The specified task is missing an execution");return ce}let z=this._taskExecutionPromises.get(j.id);if(z)return z;const K=new Promise((ce,fe)=>{function re(ge,ye,ve){ve?ce(new I(ge,ye.id,ve)):fe("Unexpected: Task does not exist.")}H?re(this,j,H):E.to(j.task,this._workspaceProvider,this._providedCustomExecutions2).then(ge=>re(this,j,ge))});return this._taskExecutionPromises.set(j.id,K),K.then(ce=>(this._taskExecutions.set(j.id,ce),ce),ce=>Promise.reject(ce))}checkDeprecation(j,H){j._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let z=this._notProvidedCustomExecutions.values(),K=z.next();for(;!K.done;)!this._activeCustomExecutions2.has(K.value)&&this._lastStartedTask!==K.value&&(this._providedCustomExecutions2.delete(K.value),this._notProvidedCustomExecutions.delete(K.value)),K=z.next()}};p=Le([Ne(0,t.IExtHostRpcService),Ne(1,u.IExtHostInitDataService),Ne(2,T.IExtHostWorkspace),Ne(3,y.IExtHostDocumentsAndEditors),Ne(4,F.IExtHostConfiguration),Ne(5,m.IExtHostTerminalService),Ne(6,k.ILogService),Ne(7,v.IExtHostApiDeprecationService)],p),e.ExtHostTaskBase=p;let R=class extends p{constructor(j,H,z,K,ce,fe,re,ge){super(j,H,z,K,ce,fe,re,ge);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:l.PlatformToString(0)})}async executeTask(j,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const z=E.from(H,j);if(z===void 0)throw new Error("Task is not valid");if(d.is(z.execution))await this.addCustomExecution(z,H,!1);else throw new o.NotSupportedError;const K=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),H);return this._proxy.$executeTask(z).catch(ce=>{throw new Error(ce)}),K}provideTasksInternal(j,H,z,K){const ce=[];if(K)for(let fe of K){this.checkDeprecation(fe,z),(!fe.definition||!j[fe.definition.type])&&this._logService.warn(`The task [${fe.source}, ${fe.name}] uses an undefined task type. The task will be ignored in the future.`);const re=E.from(fe,z.extension);re&&d.is(re.execution)?(ce.push(re),H.push(this.addCustomExecution(re,fe,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ce,extension:z.extension}}async resolveTaskInternal(j){if(d.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,H,z){}};R=Le([Ne(0,t.IExtHostRpcService),Ne(1,u.IExtHostInitDataService),Ne(2,T.IExtHostWorkspace),Ne(3,y.IExtHostDocumentsAndEditors),Ne(4,F.IExtHostConfiguration),Ne(5,m.IExtHostTerminalService),Ne(6,k.ILogService),Ne(7,v.IExtHostApiDeprecationService)],R),e.WorkerExtHostTask=R,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(be[210],we([0,1,16,67,36,70,22,11,19,24,14,13,2,231,126,74,46,84,209,40]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(g,f,E,C){this.configurationService=g,this.workspaceContextService=f,this.editorGroupsService=E,this.pathService=C}text(g,f,E={}){g=this.getContentPattern(g,E);const C=this.configurationService.getValue(),I=f&&f.some(p=>!this.configurationService.getValue({resource:p}).search.useRipgrep);return{...this.commonQuery(f?.map(l.toWorkspaceFolder),E),type:2,contentPattern:g,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:C.search.usePCRE2||I||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(g,f){const E=this.configurationService.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const C={...g,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(g,f)&&(C.isCaseSensitive=!0),this.isMultiline(g)&&(C.isMultiline=!0),C}file(g,f={}){return{...this.commonQuery(g,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(g,f){return g?(g=Array.isArray(g)?g.map(c):c(g),f?this.parseSearchPaths(g):{pattern:n(...Array.isArray(g)?g:[g])}):{}}commonQuery(g=[],f={}){const E=this.handleIncludeExclude(f.includePattern,f.expandPatterns),C=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),I=g.length>1,N=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,f,C)):g.map(x=>this.getFolderQueryForRoot(x,f,C,I))).filter(x=>!!x),p={_reason:f._reason,folderQueries:N,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:C.pattern,includePattern:E.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const j=i.coalesce(i.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(K=>K.resource)))).filter(z=>(0,b.pathIncludedInQuery)(p,z.fsPath)),H=this.commonQueryFromFileList(j);return{...p,...H}}const R=f.extraFileResources&&f.extraFileResources.filter(x=>(0,b.pathIncludedInQuery)(p,x.fsPath));return p.extraFileResources=R&&R.length?R:void 0,p}commonQueryFromFileList(g){const f=[],E=new M.ResourceMap,C={};let I=!1;return g.forEach(N=>{if(N.scheme===T.Schemas.walkThrough)return;if((0,F.isAbsolutePath)(N)){const R=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:y.dirname(N.fsPath)});let x=E.get(R);x||(I=!0,x={folder:R,includePattern:{}},f.push(x),E.set(R,x));const j=y.relative(R.fsPath,N.fsPath);(0,m.assertIsDefined)(x.includePattern)[j.replace(/\\/g,"/")]=!0}else N.fsPath&&(I=!0,C[N.fsPath]=!0)}),{folderQueries:f,includePattern:C,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(g,f){if(f.isSmartCase){if(g.isRegExp){if(O.containsUppercaseCharacter(g.pattern,!0))return!0}else if(O.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}isMultiline(g){return g.isMultiline||g.isRegExp&&(0,u.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const f=H=>y.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),C=(Array.isArray(g)?g:P(g)).map(H=>{const z=this.pathService.resolvedUserHome;return z?(0,D.untildify)(H,z.scheme===T.Schemas.file?z.fsPath:z.path):H}),I=A.groupBy(C,H=>f(H)?"searchPaths":"exprSegments"),N=(I.exprSegments||[]).map(H=>O.rtrim(H,"/")).map(H=>O.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),r(H))),p={},R=this.expandSearchPathPatterns(I.searchPaths||[]);R&&R.length&&(p.searchPaths=R);const x=i.flatten(N),j=n(...x);return j&&(p.pattern=j),p}getExcludesForFolder(g,f){return f.disregardExcludeSettings?void 0:(0,b.getExcludes)(g,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(g){if(!g||!g.length)return[];const f=i.flatten(g.map(C=>{let{pathPortion:I,globPortion:N}=S(C);N&&(N=w(N));const p=this.expandOneSearchPath(I);return i.flatten(p.map(R=>this.resolveOneSearchPathPattern(R,N)))})),E=new Map;return f.forEach(C=>{const I=C.searchPath.toString(),N=E.get(I);N?C.pattern&&(N.pattern=N.pattern||{},N.pattern[C.pattern]=!0):E.set(I,{searchPath:C.searchPath,pattern:C.pattern?n(C.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(g){if(y.isAbsolute(g)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==T.Schemas.file?[{searchPath:f[0].uri.with({path:g})}]:[{searchPath:t.URI.file(y.normalize(g))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(g=c(g),g.startsWith("../")||g===".."){const C=y.posix.resolve(f.path,g);return[{searchPath:f.with({path:C})}]}const E=w(g);return[{searchPath:f,pattern:E}]}else{if(g==="./"||g===".\\")return[];{const f=g.replace(/^\.[\/\\]/,""),C=this.workspaceContextService.getWorkspace().folders.map(I=>{const N=f.match(new RegExp(`^${O.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return N?{match:N,folder:I}:null}).filter(m.isDefined);if(C.length)return C.map(I=>{const N=I.match[1];return{searchPath:I.folder.uri,pattern:N&&w(N)}});{const I=g.match(/\.[\/\\](.+)[\/\\]?/),N=I?I[1]:g,p=s.localize(0,null,N);throw new Error(p)}}}}resolveOneSearchPathPattern(g,f){const E=g.pattern&&f?`${g.pattern}/${f}`:g.pattern||f,C=[{searchPath:g.searchPath,pattern:E}];return E&&!E.endsWith("**")&&C.push({searchPath:g.searchPath,pattern:E+"/**"}),C}getFolderQueryForSearchPath(g,f,E){const C=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(g.searchPath),f,E,!1);return C?{...C,includePattern:g.pattern}:null}getFolderQueryForRoot(g,f,E,C){let I;const N=t.URI.isUri(g)?g:g.uri;if(E.searchPaths){const H=E.searchPaths.filter(z=>(0,F.isEqual)(z.searchPath,N))[0];if(H&&!H.pattern)return null;H&&(I=H.pattern)}const p=this.configurationService.getValue({resource:N}),x={...this.getExcludesForFolder(p,f)||{},...I||{}},j=t.URI.isUri(g)?(0,F.basename)(g):g.name;return{folder:N,folderName:C?j:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:p.files&&p.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!p.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!p.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!p.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!p.search.followSymlinks}}};o=Le([Ne(0,a.IConfigurationService),Ne(1,l.IWorkspaceContextService),Ne(2,k.IEditorGroupsService),Ne(3,v.IPathService)],o),e.QueryBuilder=o;function S(d){const g=d.match(/[\*\{\}\(\)\[\]\?]/);if(g){const f=g.index,E=d.substr(0,f).match(/[/|\\][^/\\]*$/);if(E){let C=d.substr(0,E.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:d.substr((E.index||0)+1)}}}return{pathPortion:d}}function n(...d){return d.length?d.reduce((g,f)=>(g[f]=!0,g),Object.create(null)):void 0}function P(d){return _.splitGlobAware(d,",").map(g=>g.trim()).filter(g=>!!g.length)}function r(d){return[`**/${d}/**`,`**/${d}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function c(d){return d.replace(/\\/g,"/")}function w(d){return c(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(d,g){d=i.distinct(d,C=>C.toString());const f=[],E=g.getWorkspace();return d&&d.forEach(C=>{let I;if(g.getWorkbenchState()===2)I=(0,F.relativePath)(E.folders[0].uri,C),I&&I!=="."&&(I="./"+I);else{const N=g.getWorkspaceFolder(C);if(N){const p=N.name;if(E.folders.filter(x=>x.name===p).length===1){const x=(0,F.relativePath)(N.uri,C);x===""?I=`./${N.name}`:I=`./${N.name}/${x}`}else I=C.fsPath}}I&&f.push(I)}),f}e.resolveResourcesForSearchIncludes=h}),define(be[211],we([0,1,24,2,20,15,3,210,40,46]),function(Z,e,i,A,_,D,M,T,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function m(a,l){const k=l.activationEvents;if(!k)return Promise.resolve(void 0);const v=[],b=[];for(const c of k)if(/^workspaceContains:/.test(c)){const w=c.substr("workspaceContains:".length);w.indexOf("*")>=0||w.indexOf("?")>=0||a.forceUsingSearch?b.push(w):v.push(w)}if(v.length===0&&b.length===0)return Promise.resolve(void 0);let o;const S=new Promise((c,w)=>{o=c}),n=c=>o({activationEvent:c}),P=Promise.all(v.map(c=>t(a,c,n))).then(()=>{}),r=u(a,l.identifier,b,n);return Promise.all([P,r]).then(()=>{o(void 0)}),S}e.checkActivateWorkspaceContainsExtension=m;async function t(a,l,k){for(const v of a.folders)if(await a.exists(i.joinPath(A.URI.revive(v),l))){k(`workspaceContains:${l}`);return}}async function u(a,l,k,v){if(k.length===0)return Promise.resolve(void 0);const b=new _.CancellationTokenSource,o=a.checkExists(a.folders,k,b.token),S=setTimeout(async()=>{b.cancel(),a.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${k.join(",")}`)},O);let n=!1;try{n=await o}catch(P){D.isCancellationError(P)||D.onUnexpectedError(P)}b.dispose(),clearTimeout(S),n&&v(`workspaceContains:${k.join(",")}`)}function s(a,l,k,v){const b=a.get(M.IInstantiationService),o=a.get(y.ISearchService),n=b.createInstance(T.QueryBuilder).file(l.map(P=>(0,F.toWorkspaceFolder)(A.URI.revive(P))),{_reason:"checkExists",includePattern:k,exists:!0});return o.fileSearch(n,v).then(P=>!!P.limitHit,P=>D.isCancellationError(P)?!1:Promise.reject(P))}e.checkGlobFileExists=s});var Ge=this&&this.__classPrivateFieldSet||function(Z,e,i,A,_){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?_.call(Z,i):_?_.value=i:e.set(Z,i),i},De=this&&this.__classPrivateFieldGet||function(Z,e,i,A){if(i==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!A:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?A:i==="a"?A.call(Z):A?A.value:e.get(Z)};define(be[32],we([0,1,118,19,66,24,10,7,22,2,9,4,31,170,64,30,26,168,15,23,21,144,6,77,3,27,65,12,54,57,39,5,211,61,146,11]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b,o,S,n,P,r,c,w,h,d,g,f,E,C,I,N,p){"use strict";var R,x,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let H=class Ki extends T.Disposable{constructor(re,ge,ye,ve,Me,je,et,lt,it,ft){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ge,this._extHostContext=ye,this._initData=et,this._extHostWorkspace=ve,this._extHostConfiguration=Me,this._logService=je,this._extHostTunnelService=it,this._extHostTerminalService=ft,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(m.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(m.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(m.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new M.Barrier,this._readyToStartExtensionHost=new M.Barrier,this._readyToRunExtensions=new M.Barrier,this._eagerExtensionsActivated=new M.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=lt,this._instaService=re.createChild(new d.ServiceCollection([s.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const _t=new Set;this._initData.hostExtensions.forEach(ut=>_t.add(b.ExtensionIdentifier.toKey(ut))),this._activator=this._register(new u.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ut,rt,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ut,v.transformErrorForSerialization(rt),B)},actualActivateExtension:async(ut,rt)=>{if(_t.has(b.ExtensionIdentifier.toKey(ut)))return await this._mainThreadExtensionsProxy.$activateExtension(ut,rt),new u.HostExtension;const B=this._registry.getExtensionDescription(ut);return this._activateExtension(B,rt)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(re){v.onUnexpectedError(re)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let re=[];try{re=this._registry.getAllExtensionDescriptions().map(Me=>Me.identifier).filter(Me=>this.isActivated(Me)).map(Me=>this._deactivate(Me))}catch{}await Promise.all(re)}isActivated(re){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(re):!1}_activateByEvent(re,ge){return this._activator.activateByEvent(re,ge)}_activateById(re,ge){return this._activator.activateById(re,ge)}activateByIdWithErrors(re,ge){return this._activateById(re,ge).then(()=>{const ye=this._activator.getActivatedExtension(re);if(ye.activationFailed)return Promise.reject(ye.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(re=>this._registry)}getExtensionExports(re){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(re).exports:null}async _realPathExtensionUri(re){if(re.scheme!==p.Schemas.file)return re;const ge=await this._hostUtils.realpath(re.fsPath);return F.URI.file(ge)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const re=y.TernarySearchTree.forUris(ge=>D.extUriBiasedIgnorePathCase.ignorePathCasing(ge));for(const ge of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ge)){const ye=await this._realPathExtensionUri(ge.extensionLocation);re.set(ye,ge)}return re})()),this._extensionPathIndex}_deactivate(re){let ge=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(re))return ge;const ye=this._activator.getActivatedExtension(re);if(!ye)return ge;try{typeof ye.module.deactivate=="function"&&(ge=Promise.resolve(ye.module.deactivate()).then(void 0,ve=>(this._logService.error(ve),Promise.resolve(void 0))))}catch(ve){this._logService.error(`An error occurred when deactivating the extension '${re.value}':`),this._logService.error(ve)}try{(0,T.dispose)(ye.subscriptions)}catch(ve){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this._logService.error(ve)}return ge}async _activateExtension(re,ge){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier),this._doActivateExtension(re,ge).then(ye=>{const ve=ye.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(re.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,ge),this._logExtensionActivationTimes(re,ge,"success",ve),ye},ye=>{throw this._logExtensionActivationTimes(re,ge,"failure"),ye})}_logExtensionActivationTimes(re,ge,ye,ve){const Me=z(re,ge);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Me,...ve||{},outcome:ye})}_doActivateExtension(re,ge){const ye=z(re,ge);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ye);const ve=this._getEntryPoint(re);if(!ve)return Promise.resolve(new u.EmptyExtension(u.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${ge.startup}, activationEvent: '${ge.activationEvent}'${re.identifier.value!==ge.extensionId.value?`, root cause: ${ge.extensionId.value}`:""}`),this._logService.flush();const Me=new u.ExtensionActivationTimesBuilder(ge.startup);return Promise.all([this._loadCommonJSModule(re.identifier,(0,D.joinPath)(re.extensionLocation,ve),Me),this._loadExtensionContext(re)]).then(je=>(_.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Ki._callActivate(this._logService,re.identifier,je[0],je[1],Me))).then(je=>(_.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),je))}_loadExtensionContext(re){const ge=new S.ExtensionGlobalMemento(re,this._storage),ye=new S.ExtensionMemento(re.identifier.value,!1,this._storage),ve=new N.ExtensionSecrets(re,this._secretState),Me=re.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,je=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([ge.whenReady,ye.whenReady,this._storagePath.whenReady]).then(()=>{const et=this;let lt,it;const ft=(0,l.isProposedApiEnabled)(re,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:ge,workspaceState:ye,secrets:ve,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(_t){return A.join(re.extensionLocation.fsPath,_t)},get storagePath(){return et._storagePath.workspaceValue(re)?.fsPath},get globalStoragePath(){return et._storagePath.globalValue(re).fsPath},get logPath(){return A.join(et._initData.logsLocation.fsPath,re.identifier.value)},get logUri(){return F.URI.joinPath(et._initData.logsLocation,re.identifier.value)},get storageUri(){return et._storagePath.workspaceValue(re)},get globalStorageUri(){return et._storagePath.globalValue(re)},get extensionMode(){return Me},get extension(){return lt===void 0&&(lt=new K(et,re.identifier,re,je)),lt},get extensionRuntime(){return(0,l.checkProposedApiEnabled)(re,"extensionRuntime"),et.extensionRuntime},get environmentVariableCollection(){return et._extHostTerminalService.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!it){if(!ft)return;const _t=E.Event.buffer(E.Event.fromDOMEventEmitter(ft,"message",ut=>ut.data));ft.start(),it={onDidReceiveMessage:_t,postMessage:ft.postMessage.bind(ft)}}return it}})})}static _callActivate(re,ge,ye,ve,Me){return ye=ye||{activate:void 0,deactivate:void 0},this._callActivateOptional(re,ge,ye,ve,Me).then(je=>new u.ActivatedExtension(!1,null,Me.build(),ye,je,ve.subscriptions))}static _callActivateOptional(re,ge,ye,ve,Me){if(typeof ye.activate=="function")try{Me.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${ge.value}`);const je=typeof global=="object"?global:self,et=ye.activate.apply(je,[ve]);return Me.activateCallStop(),Me.activateResolveStart(),Promise.resolve(et).then(lt=>(Me.activateResolveStop(),lt))}catch(je){return Promise.reject(je)}else return Promise.resolve(ye)}_activateOneStartupFinished(re,ge){this._activateById(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:ge}).then(void 0,ye=>{this._logService.error(ye)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const re of this._registry.getAllExtensionDescriptions())if(re.activationEvents)for(const ge of re.activationEvents)ge==="onStartupFinished"&&this._activateOneStartupFinished(re,ge)}_handleEagerExtensions(){const re=this._activateByEvent("*",!0).then(void 0,Me=>{this._logService.error(Me)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Me=>this._handleWorkspaceContainsEagerExtensions(Me.added)));const ge=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ye=this._handleWorkspaceContainsEagerExtensions(ge),ve=Promise.all([re,ye]).then(()=>{});return Promise.race([ve,(0,M.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(re){return re.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ge=>this._handleWorkspaceContainsEagerExtension(re,ge))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(re,ge){if(this.isActivated(ge.identifier))return;const ye=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ve={logService:this._logService,folders:re.map(je=>je.uri),forceUsingSearch:ye,exists:je=>this._hostUtils.exists(je.fsPath),checkExists:(je,et,lt)=>this._mainThreadWorkspaceProxy.$checkExists(je,et,lt)},Me=await(0,C.checkActivateWorkspaceContainsExtension)(ve,ge);if(!!Me)return this._activateById(ge.identifier,{startup:!0,extensionId:ge.identifier,activationEvent:Me.activationEvent}).then(void 0,je=>this._logService.error(je))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(re){throw console.error(re),re}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:ge}=this._initData.environment;if(!re||!ge)throw new Error(i.localize(0,null));const ye=await this._loadCommonJSModule(null,ge,new u.ExtensionActivationTimesBuilder(!1));if(!ye||typeof ye.run!="function")throw new Error(i.localize(1,null,ge.toString()));return new Promise((ve,Me)=>{const je=(it,ft)=>{it?Me(it):ve(typeof ft=="number"&&ft>0?1:0)},et=(0,D.originalFSPath)(ge),lt=ye.run(et,je);lt&&lt.then&&lt.then(()=>{ve(0)}).catch(it=>{Me(it instanceof Error&&it.stack?it.stack:String(it))})})}async $extensionTestsExit(re){this._logService.info(`Extension host terminating: test runner requested exit with code ${re}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${re}`),this._logService.flush(),this._hostUtils.exit(re)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,ge){return this._resolvers[re]=ge,(0,T.toDisposable)(()=>{delete this._resolvers[re]})}async _activateAndGetResolver(re){const ge=re.indexOf("+");if(ge===-1)throw new Error("Not an authority that can be resolved!");const ye=re.substr(0,ge);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ye}`,!1),{authorityPrefix:ye,resolver:this._resolvers[ye]}}async $resolveAuthority(re,ge){this._logService.info(`$resolveAuthority invoked for authority (${ce(re)})`);const{authorityPrefix:ye,resolver:ve}=await this._activateAndGetResolver(re);if(!ve)return{type:"error",error:{code:P.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ye}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ve)),_.mark(`code/extHost/willResolveAuthority/${ye}`);const Me=await ve.resolve(re,{resolveAttempt:ge});_.mark(`code/extHost/didResolveAuthorityOK/${ye}`);const je={authority:re,host:Me.host,port:Me.port,connectionToken:Me.connectionToken},et={extensionHostEnv:Me.extensionHostEnv,isTrusted:Me.isTrusted,authenticationSession:Me.authenticationSessionForInitializingExtensions?{id:Me.authenticationSessionForInitializingExtensions.id,providerId:Me.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:je,options:et,tunnelInformation:{environmentTunnels:Me.environmentTunnels,features:Me.tunnelFeatures}}}}catch(Me){if(_.mark(`code/extHost/didResolveAuthorityError/${ye}`),Me instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Me._code,message:Me._message,detail:Me._detail}};throw Me}}async $getCanonicalURI(re,ge){this._logService.info(`$getCanonicalURI invoked for authority (${ce(re)})`);const{authorityPrefix:ye,resolver:ve}=await this._activateAndGetResolver(re);if(!ve)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ye}`);const Me=F.URI.revive(ge);if(typeof ve.getCanonicalURI=="undefined")return Me;const je=await(0,M.asPromise)(()=>ve.getCanonicalURI(Me));return je||Me}$startExtensionHost(re){return this._registry.keepOnly(re),this._startExtensionHost()}$activateByEvent(re,ge){return ge===1?this._activateByEvent(re,!1):this._readyToRunExtensions.wait().then(ye=>this._activateByEvent(re,!1))}async $activate(re,ge){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(re)?(await this._activateById(re,ge),!0):!1}async $deltaExtensions(re,ge){re.forEach(ve=>ve.extensionLocation=F.URI.revive(ve.extensionLocation));const ye=await this.getExtensionPathIndex();return await Promise.all(ge.map(async ve=>{const Me=this._registry.getExtensionDescription(ve);Me&&ye.delete(await this._realPathExtensionUri(Me.extensionLocation))})),await Promise.all(re.map(async ve=>{const Me=await this._realPathExtensionUri(ve.extensionLocation);ye.set(Me,ve)})),this._registry.deltaExtensions(re,ge),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){let ge=o.VSBuffer.alloc(re),ye=Math.random()%256;for(let ve=0;ve<re;ve++)ge.writeUInt8(ye,ve);return ge}async $updateRemoteConnectionData(re){this._remoteConnectionData=re,this._onDidChangeRemoteConnectionData.fire()}};H=Le([Ne(0,r.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,h.IExtHostRpcService),Ne(3,a.IExtHostWorkspace),Ne(4,t.IExtHostConfiguration),Ne(5,O.ILogService),Ne(6,c.IExtHostInitDataService),Ne(7,w.IExtensionStoragePaths),Ne(8,g.IExtHostTunnelService),Ne(9,f.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function z(fe,re){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class K{constructor(re,ge,ye,ve){R.set(this,void 0),x.set(this,void 0),j.set(this,void 0),Ge(this,R,re,"f"),Ge(this,x,ge,"f"),Ge(this,j,ye.identifier,"f"),this.id=ye.identifier.value,this.extensionUri=ye.extensionLocation,this.extensionPath=A.normalize((0,D.originalFSPath)(ye.extensionLocation)),this.packageJSON=ye,this.extensionKind=ve}get isActive(){return De(this,R,"f").isActivated(De(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return De(this,R,"f").getExtensionExports(De(this,j,"f"))}activate(){return De(this,R,"f").activateByIdWithErrors(De(this,j,"f"),{startup:!1,extensionId:De(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=K,R=new WeakMap,x=new WeakMap,j=new WeakMap;function ce(fe){const re=fe.indexOf("+");return re===-1?fe:fe.substring(0,re)}}),define(be[95],we([0,1,19,2,5,10,4,6,154,30,32,48,161,31,155,12,3,13,83,63]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,l.createDecorator)("IExtHostDebugService");let o=class{constructor(d,g,f,E,C,I){this._workspaceService=g,this._extensionService=f,this._editorsService=E,this._configurationService=C,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=d.getProxy(M.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(p=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,g){const f=d;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let E=`debug:${encodeURIComponent(f.path||"")}`,C="?";return g&&(E+=`${C}session=${encodeURIComponent(g.id)}`,C="&"),E+=`${C}ref=${f.sourceReference}`,A.URI.parse(E)}else{if(f.path)return A.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const g=[];for(const f of d.getAllExtensionDescriptions())if(f.contributes){const E=f.contributes.debuggers;if(E&&E.length>0)for(const C of E)(0,s.isDebuggerMainContribution)(C)&&g.push(C.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(g=>d.push(g)),d}addBreakpoints(d){this.startBreakpoints();const g=d.filter(C=>{const I=C.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,C),!0)});this.fireBreakpointChanges(g,[],[]);const f=[],E=new Map;for(const C of g)if(C instanceof T.SourceBreakpoint){let I=E.get(C.location.uri.toString());I||(I={type:"sourceMulti",uri:C.location.uri,lines:[]},E.set(C.location.uri.toString(),I),f.push(I)),I.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character})}else C instanceof T.FunctionBreakpoint&&f.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(d){this.startBreakpoints();const g=d.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],g,[]);const f=g.filter(I=>I instanceof T.SourceBreakpoint).map(I=>I.id),E=g.filter(I=>I instanceof T.FunctionBreakpoint).map(I=>I.id),C=g.filter(I=>I instanceof T.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(f,E,C)}startDebugging(d,g,f){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,g,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,g,f){if(!g)return new T.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:E,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,f,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,E),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(C=>C.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(d,g,f){if(!f)return new T.Disposable(()=>{});if(!this.definesDebugType(d,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:E,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,E),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(C=>C.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(d,g){if(!g)return new T.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:f,factory:g}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==g)})}async $runInTerminal(d,g){return Promise.resolve(void 0)}async $substituteVariables(d,g){if(!this._variableResolver){const[C,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(C||[],this._editorsService,I)}let f;const E=await this.getFolder(d);return E&&(f={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,g)}createDebugAdapter(d,g){if(d.type==="implementation")return new c(d.implementation)}createSignService(){}async $startDASession(d,g){const f=this,E=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const I=this.convertToDto(C),N=this.createDebugAdapter(I,E);if(!N)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const p=N;return this._debugAdapters.set(d,p),this.getDebugAdapterTrackers(E).then(R=>(R&&this._debugAdaptersTrackers.set(d,R),p.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const j=x,H={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(j.arguments.value);H.body={signature:z},p.sendResponse(H)}else throw new Error("no signer")}catch(z){H.success=!1,H.message=z.message,p.sendResponse(H)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(x),x=(0,s.convertToVSCPaths)(x,!0),f._debugServiceProxy.$acceptDAMessage(d,x)}),p.onError(x=>{R&&R.onError&&R.onError(x),this._debugServiceProxy.$acceptDAError(d,x.name,x.message,x.stack)}),p.onExit(x=>{R&&R.onExit&&R.onExit((0,k.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,k.withNullAsUndefined)(x),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),p.startSession()))})}$sendDAMessage(d,g){g=(0,s.convertToDAPaths)(g,!1);const f=this._debugAdaptersTrackers.get(d);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(g);const E=this._debugAdapters.get(d);E&&E.sendMessage(g)}$stopDASession(d){const g=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),g&&g.onWillStopSession&&g.onWillStopSession();const f=this._debugAdapters.get(d);return this._debugAdapters.delete(d),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const g=[],f=[],E=[];if(d.added)for(const C of d.added){const I=C.id;if(I&&!this._breakpoints.has(I)){let N;if(C.type==="function")N=new T.FunctionBreakpoint(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage);else if(C.type==="data")N=new T.DataBreakpoint(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage);else{const p=A.URI.revive(C.uri);N=new T.SourceBreakpoint(new T.Location(p,new T.Position(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage)}N._id=I,this._breakpoints.set(I,N),g.push(N)}}if(d.removed)for(const C of d.removed){const I=this._breakpoints.get(C);I&&(this._breakpoints.delete(C),f.push(I))}if(d.changed){for(const C of d.changed)if(C.id){const I=this._breakpoints.get(C.id);if(I){if(I instanceof T.FunctionBreakpoint&&C.type==="function"){const N=I;N.enabled=C.enabled,N.condition=C.condition,N.hitCondition=C.hitCondition,N.logMessage=C.logMessage,N.functionName=C.functionName}else if(I instanceof T.SourceBreakpoint&&C.type==="source"){const N=I;N.enabled=C.enabled,N.condition=C.condition,N.hitCondition=C.hitCondition,N.logMessage=C.logMessage,N.location=new T.Location(A.URI.revive(C.uri),new T.Position(C.line,C.character))}E.push(I)}}}this.fireBreakpointChanges(g,f,E)}$provideDebugConfigurations(d,g,f){return(0,D.asPromise)(async()=>{const E=this.getConfigProviderByHandle(d);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.getFolder(g);return E.provideDebugConfigurations(C,f)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(d,g,f,E){return(0,D.asPromise)(async()=>{const C=this.getConfigProviderByHandle(d);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(g);return C.resolveDebugConfiguration(I,f,E)})}$resolveDebugConfigurationWithSubstitutedVariables(d,g,f,E){return(0,D.asPromise)(async()=>{const C=this.getConfigProviderByHandle(d);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(g);return C.resolveDebugConfigurationWithSubstitutedVariables(I,f,E)})}async $provideDebugAdapter(d,g){const f=this.getAdapterDescriptorFactoryByHandle(d);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(g);return this.getAdapterDescriptor(f,E).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(C)})}async $acceptDebugSessionStarted(d){const g=await this.getSession(d);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(d){const g=await this.getSession(d);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,g){const f=await this.getSession(d);f&&f._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(d,g){const E={session:await this.getSession(d),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(d){if(d instanceof T.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof T.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const g=this._adapterFactories.filter(f=>f.type===d);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(d){const g=this._adapterFactories.filter(f=>f.handle===d);if(g.length>0)return g[0].factory}getConfigProviderByHandle(d){const g=this._configProviders.filter(f=>f.handle===d);if(g.length>0)return g[0].provider}definesDebugType(d,g){if(d.contributes){const f=d.contributes.debuggers;if(f&&f.length>0){for(const E of f)if(E.label&&E.type&&E.type===g)return!0}}return!1}getDebugAdapterTrackers(d){const f=d.configuration.type,E=this._trackerFactories.filter(C=>C.type===f||C.type==="*").map(C=>(0,D.asPromise)(()=>C.factory.createDebugAdapterTracker(d)).then(I=>I,I=>null));return Promise.race([Promise.all(E).then(C=>{const I=C.filter(N=>!!N);if(I.length>0)return new r(I)}),new Promise((C,I)=>{const N=setTimeout(()=>{clearTimeout(N),I(new Error("timeout"))},1e3)})]).catch(C=>{})}async getAdapterDescriptor(d,g){const f=g.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new T.DebugAdapterServer(f));if(d){const C=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>d.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,C))).then(I=>{if(I)return I})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,E))}daExecutableFromPackage(d,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,g,f){(d.length>0||g.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:g,changed:f}))}async getSession(d){if(d)if(typeof d=="string"){const g=this._debugSessions.get(d);if(g)return g}else{let g=this._debugSessions.get(d.id);if(!g){const f=await this.getFolder(d.folderUri),E=d.parent?this._debugSessions.get(d.parent):void 0;g=new S(this._debugServiceProxy,d.id,d.type,d.name,f,d.configuration,E),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(d){if(d){const g=A.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};o=Le([Ne(0,a.IExtHostRpcService),Ne(1,F.IExtHostWorkspace),Ne(2,O.IExtHostExtensionService),Ne(3,m.IExtHostDocumentsAndEditors),Ne(4,u.IExtHostConfiguration),Ne(5,b.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class S{constructor(d,g,f,E,C,I,N){this._debugServiceProxy=d,this._id=g,this._type=f,this._name=E,this._workspaceFolder=C,this._configuration=I,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,g)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=S;class n{constructor(d){this.value=Object.freeze({append(g){d.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.ExtHostDebugConsole=n;class P extends t.AbstractVariableResolverService{constructor(d,g,f,E,C){function I(){if(g){const N=g.activeEditor();if(N)return N.document.uri;const p=E.tabs.filter(R=>R.isActive);if(p.length>0){const R=p[0].resource;return R&&(R.primary||R.secondary)?R.primary??R.secondary:p[0].resource}}}super({getFolderUri:N=>{const p=d.filter(R=>R.name===N);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(N,p)=>f.getConfiguration(void 0,N).get(p),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=I();if(N)return i.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(C){const N=I();if(N){const p=C.getWorkspaceFolder(N);if(p)return i.normalize(p.uri.fsPath)}}},getSelectedText:()=>{if(g){const N=g.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(g){const N=g.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=P;class r{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(g=>g.onError?g.onError(d):void 0)}onExit(d,g){this.trackers.forEach(f=>f.onExit?f.onExit(d,g):void 0)}}class c extends y.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let w=class extends o{constructor(d,g,f,E,C,I){super(d,g,f,E,C,I)}createVariableResolver(d,g,f){return new P(d,g,f,this._editorTabs)}};w=Le([Ne(0,a.IExtHostRpcService),Ne(1,F.IExtHostWorkspace),Ne(2,O.IExtHostExtensionService),Ne(3,m.IExtHostDocumentsAndEditors),Ne(4,u.IExtHostConfiguration),Ne(5,b.IExtHostEditorTabs)],w),e.WorkerExtHostDebugService=w}),define(be[212],we([0,1,66,2,4,31,26,23,12,27,3,32,83,9,14]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(S,n,P,r,c,w,h){this._apiFactory=S,this._extensionRegistry=n,this._instaService=P,this._extHostConfiguration=r,this._extHostExtensionService=c,this._initData=w,this._logService=h,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),i.mark("code/extHost/willWaitForConfig");const S=await this._extHostConfiguration.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new k(this._apiFactory,n,this._extensionRegistry,S,this._logService)),this.register(this._instaService.createInstance(v,n)),this.register(this._instaService.createInstance(l)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,n,this._initData.environment.appUriScheme))}register(S){if("nodeModuleName"in S)if(Array.isArray(S.nodeModuleName))for(let n of S.nodeModuleName)this._factories.set(n,S);else this._factories.set(S.nodeModuleName,S);typeof S.alternativeModuleName=="function"&&this._alternatives.push(n=>S.alternativeModuleName(n))}};a=Le([Ne(2,O.IInstantiationService),Ne(3,D.IExtHostConfiguration),Ne(4,m.IExtHostExtensionService),Ne(5,F.IExtHostInitDataService),Ne(6,u.ILogService)],a),e.RequireInterceptor=a;let l=class zi{constructor(S){if(S.environment.appRoot&&zi.aliased.size){const n=(0,s.escapeRegExpCharacters)(this.forceForwardSlashes(S.environment.appRoot.fsPath)),P="[a-z0-9_.-]",r=`@${P}+\\/${P}+|${P}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(S){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(S));if(!n)return;const[,P,r,c]=n,w=zi.aliased.get(r);if(w!==void 0)return console.warn(`${r} as been renamed to ${w}, please update your imports`),P+w+c}forceForwardSlashes(S){return S.replace(/\\/g,"/")}};l.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),l=Le([Ne(0,F.IExtHostInitDataService)],l);class k{constructor(S,n,P,r,c){this._apiFactory=S,this._extensionPaths=n,this._extensionRegistry=P,this._configProvider=r,this._logService=c,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(S,n){const P=this._extensionPaths.findSubstr(n);if(P){let r=this._extApiImpl.get(T.ExtensionIdentifier.toKey(P.identifier));return r||(r=this._apiFactory(P,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(P.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((c,w)=>r+=`	${w} -> ${c.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(M.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(S,n,P){this._extensionPaths=S,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(_.MainContext.MainThreadTelemetry);const{environment:r}=P,c=n.getProxy(_.MainContext.MainThreadKeytar);if(r.appRoot){let w=r.appRoot.fsPath;t.platform==="win32"&&(w=w.replace(/\\/g,"/")),w[w.length-1]==="/"&&(w=w.substr(0,w.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${w}/node_modules.asar/keytar`),this.alternativeNames.add(`${w}/node_modules/keytar`)}this._impl={getPassword:(w,h)=>c.$getPassword(w,h),setPassword:(w,h,d)=>c.$setPassword(w,h,d),deletePassword:(w,h)=>c.$deletePassword(w,h),findPassword:w=>c.$findPassword(w),findCredentials(w){return c.$findCredentials(w)}}}load(S,n){const P=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:P?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(S){const n=S.length;if(n<=7||!this.alternativeNames)return;const P=n-7;if((S.charAt(P)==="/"||S.charAt(P)==="\\")&&S.endsWith("keytar")&&(S=S.replace(/\\/g,"/"),this.alternativeNames.has(S)))return"keytar"}};v=Le([Ne(1,y.IExtHostRpcService),Ne(2,F.IExtHostInitDataService)],v);let b=class{constructor(S,n,P){this._extensionPaths=S,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=P.getProxy(_.MainContext.MainThreadTelemetry);const r=P.getProxy(_.MainContext.MainThreadWindow);this._impl=(c,w)=>{const h=A.URI.parse(c);return w?this.callOriginal(c,w):h.scheme==="http"||h.scheme==="https"?r.$openUri(h,c,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this._appUriScheme?r.$openUri(h,c,{}):this.callOriginal(c,w)}}load(S,n,P){const r=this._extensionPaths.findSubstr(n);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=P(S),this._impl}callOriginal(S,n){return this.sendNoForwardTelemetry(),this._original(S,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Le([Ne(2,y.IExtHostRpcService)],b)}),define(be[213],we([0,1,10,15,66,7,2,4,206,9,43,54,27,133,12,58,32,39]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(o,S,n,P,r){this._disposables=new D.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new y.RPCProtocol(o,null,P),S=v._transform(S,this._rpcProtocol);const c=new m.ServiceCollection(...(0,O.getSingletonServiceDescriptors)());c.set(t.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:r}),c.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),c.set(a.IURITransformerService,new a.URITransformerService(P)),c.set(l.IHostUtils,n);const w=new u.InstantiationService(c,!0);this._disposables.add(w.invokeFunction(f=>f.get(k.IExtHostTerminalService))),this._disposables.add(w.invokeFunction(f=>f.get(l.IExtHostExtensionService))),this._logService=w.invokeFunction(f=>f.get(F.ILogService)),_.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=w.invokeFunction(f=>f.get(l.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(E,C)=>{let I="",N,p;for(const R of C)I+=`
	at ${R.toString()}`,p=R.getFileName(),!N&&p&&(N=f.findSubstr(M.URI.file(p)));return h.set(E,N),`${E.name||"Error"}: ${E.message||""}${I}`}});const d=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),g=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);A.setUnexpectedErrorHandler(f=>{const E=A.transformErrorForSerialization(f),C=h.get(f);C?d.$onExtensionRuntimeError(C.identifier,E):g.$onUnexpectedError(E)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),A.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();Promise.race([(0,i.timeout)(5e3),S]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(o,S){o.extensions.forEach(P=>P.extensionLocation=M.URI.revive(S.transformIncomingURIs(P.extensionLocation))),o.environment.appRoot=M.URI.revive(S.transformIncomingURIs(o.environment.appRoot));const n=o.environment.extensionDevelopmentLocationURI;return n&&(o.environment.extensionDevelopmentLocationURI=n.map(P=>M.URI.revive(S.transformIncomingURIs(P)))),o.environment.extensionTestsLocationURI=M.URI.revive(S.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=M.URI.revive(S.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=M.URI.revive(S.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=M.URI.revive(S.transformIncomingURIs(o.logsLocation)),o.logFile=M.URI.revive(S.transformIncomingURIs(o.logFile)),o.workspace=S.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=v}),define(be[214],we([0,1,19,20,42,36,24,187,40]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class F{constructor(t,u,s){this.config=t,this.provider=u,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=t.filePattern,this.includePattern=t.includePattern&&D.parse(t.includePattern),this.maxResults=t.maxResults||void 0,this.exists=t.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=t.excludePattern&&D.parse(t.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(t=>t.cancel()),this.activeCancellationTokens=new Set}search(t){const u=this.config.folderQueries||[];return new Promise((s,a)=>{const l=k=>{this.resultCount++,t(k)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const v=k.toString(),b=i.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,b)||this.matchFile(l,{base:k,basename:b})}),Promise.all(u.map(k=>this.searchInFolder(k,l))).then(k=>{s({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{a(new Error((0,_.toErrorMessage)(k)))})})}async searchInFolder(t,u){const s=new A.CancellationTokenSource,a=this.getSearchOptionsForFolder(t),l=this.initDirectoryTree(),k=new y.QueryGlobTester(this.config,t),v=!k.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(s),b=T.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,s.token),S=b.elapsed(),n=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(P=>{const r=i.posix.relative(t.folder.path,P.path);if(v){const c=i.basename(P.path);this.matchFile(u,{base:t.folder,relativePath:r,basename:c});return}this.addDirectoryEntries(l,t.folder,r,u)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(l,k,u),{providerTime:S,postProcessTime:n.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(t){const u=(0,y.resolvePatternsForProvider)(this.config.includePattern,t.includePattern),s=(0,y.resolvePatternsForProvider)(this.config.excludePattern,t.excludePattern);return{folder:t.folder,excludes:s,includes:u,useIgnoreFiles:!t.disregardIgnoreFiles,useGlobalIgnoreFiles:!t.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!t.disregardParentIgnoreFiles,followSymlinks:!t.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries({pathToEntries:t},u,s,a){if(s===this.filePattern){const k=i.basename(this.filePattern);this.matchFile(a,{base:u,relativePath:this.filePattern,basename:k})}function l(k){const v=i.basename(k),b=i.dirname(k);let o=t[b];o||(o=t[b]=[],l(b)),o.push({base:u,relativePath:k,basename:v})}l(s)}matchDirectoryTree({rootEntries:t,pathToEntries:u},s,a){const l=this,k=this.filePattern;function v(b){const o=D.hasSiblingFn(()=>b.map(S=>S.basename));for(let S=0,n=b.length;S<n;S++){const P=b[S],{relativePath:r,basename:c}=P;if(s.matchesExcludesSync(r,c,k!==c?o:void 0))continue;const w=u[r];if(w)v(w);else{if(r===k)continue;l.matchFile(a,P)}if(l.isLimitHit)break}}v(t)}matchFile(t,u){(!this.includePattern||u.relativePath&&this.includePattern(u.relativePath,u.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||t(u))}}class O{constructor(){this.sessions=new Map}fileSearch(t,u,s,a){const l=this.getSessionTokenSource(t.cacheKey),k=new F(t,u,l&&l.token);let v=0;const b=o=>{v+=o.length,s(o.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(k,O.BATCH_SIZE,b,a).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:o.stats}}))}clearCache(t){const u=this.getSessionTokenSource(t);u&&u.cancel()}getSessionTokenSource(t){if(!!t)return this.sessions.has(t)||this.sessions.set(t,new A.CancellationTokenSource),this.sessions.get(t)}rawMatchToSearchItem(t){return t.relativePath?{resource:M.joinPath(t.base,t.relativePath)}:{resource:t.base}}doSearch(t,u,s,a){a.onCancellationRequested(()=>{t.cancel()});const l=v=>{v&&(k.push(v),u>0&&k.length>=u&&(s(k),k=[]))};let k=[];return t.search(l).then(v=>(k.length&&s(k),v),v=>(k.length&&s(k),Promise.reject(v)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(be[215],we([0,1,16,10,20,42,36,11,19,24,13,2,40]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(o,S,n,P){this.query=o,this.provider=S,this.fileUtils=n,this.processType=P,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,S){const n=this.query.folderQueries||[],P=new _.CancellationTokenSource;return S.onCancellationRequested(()=>P.cancel()),new Promise((r,c)=>{this.collector=new a(o);let w=!1;const h=(d,g)=>{if(!w&&!this.isLimitHit){const f=this.resultSize(d);k(d)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,w=!0,P.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const E=this.resultSize(d);this.resultCount+=E,(E>0||!k(d))&&this.collector.add(d,g)}};Promise.all(n.map((d,g)=>this.searchInFolder(d,f=>h(f,g),P.token))).then(d=>{P.dispose(),this.collector.flush();const g=d.some(f=>!!f&&!!f.limitHit);r({limitHit:this.isLimitHit||g,messages:(0,i.flatten)(d.map(f=>f?.message?(0,O.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},d=>{P.dispose();const g=(0,D.toErrorMessage)(d);c(new Error(g))})})}resultSize(o){return k(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,S){const n=Array.isArray(o.ranges)?o.ranges:[o.ranges],P=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:n.slice(0,S),preview:{matches:P.slice(0,S),text:o.preview.text},uri:o.uri}}async searchInFolder(o,S,n){const P=new t.QueryGlobTester(this.query,o),r=[],c={report:d=>{if(!this.validateProviderResult(d))return;const g=o.folder.scheme===T.Schemas.file?M.hasSiblingPromiseFn(()=>this.fileUtils.readdir(F.dirname(d.uri))):void 0,f=F.relativePath(o.folder,d.uri);if(f){const E=P.includedInQuery(f,y.basename(f),g);(0,A.isThenable)(E)?r.push(E.then(C=>{C&&S(d)})):E&&S(d)}}},w=this.getSearchOptionsForFolder(o),h=await this.provider.provideTextSearchResults(s(this.query.contentPattern),w,c,n);return r.length&&await Promise.all(r),h}validateProviderResult(o){if(k(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const S=(0,t.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),n=(0,t.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),P={folder:m.URI.from(o.folder),excludes:n,includes:S,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return P.usePCRE2=this.query.usePCRE2,P}}e.TextSearchManager=u;function s(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class a{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,S=>this.sendItems(S))}add(o,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!F.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(l(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=a;function l(b){return k(b)?{preview:{matches:(0,i.mapArrayOrNot)(b.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:b.preview.text},ranges:(0,i.mapArrayOrNot)(b.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function k(b){return!!b.preview}e.extensionResultIsMatch=k;class v{constructor(o,S){this.maxBatchSize=o,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,S){!o||this.addItemToBatch(o,S)}addItems(o,S){!o||this.addItemsToBatch(o,S)}addItemToBatch(o,S){this.batch.push(o),this.batchSize+=S,this.onUpdate()}addItemsToBatch(o,S){this.batch=this.batch.concat(o),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(be[96],we([0,1,7,4,3,214,12,58,9,2,215]),function(Z,e,i,A,_,D,M,T,y,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let m=class{constructor(a,l,k){this.extHostRpc=a,this._uriTransformer=l,this._logService=k,this._proxy=this.extHostRpc.getProxy(A.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new D.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,l){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const k=this._handlePool++;return this._textSearchProvider.set(k,l),this._proxy.$registerTextSearchProvider(k,this._transformScheme(a)),(0,i.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(a,l){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const k=this._handlePool++;return this._fileSearchProvider.set(k,l),this._proxy.$registerFileSearchProvider(k,this._transformScheme(a)),(0,i.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(a,l,k,v){const b=t(k),o=this._fileSearchProvider.get(a);if(o)return this._fileSearchManager.fileSearch(b,o,S=>{this._proxy.$handleFileMatch(a,l,S.map(n=>n.resource))},v);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,l,k,v){const b=this._textSearchProvider.get(a);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const o=t(k);return this.createTextSearchManager(o,b).search(n=>this._proxy.$handleTextMatch(a,l,n),v)}$enableExtensionHostSearch(){}createTextSearchManager(a,l){return new O.TextSearchManager(a,l,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};m=Le([Ne(0,M.IExtHostRpcService),Ne(1,T.IURITransformerService),Ne(2,y.ILogService)],m),e.ExtHostSearch=m;function t(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(u),extraFileResources:s.extraFileResources&&s.extraFileResources.map(a=>F.URI.revive(a))}}e.reviveQuery=t;function u(s){return{...s,folder:F.URI.revive(s.folder)}}}),define(be[216],we([0,1,43,91,30,89,31,38,48,39,94,95,96,64,57,62,92,49,29,61,79,63,189,9,171]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b,o,S,n,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(P.ILoggerService,n.ExtHostLoggerService),(0,i.registerSingleton)(P.ILogService,r.ExtHostLogService),(0,i.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService),(0,i.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,i.registerSingleton)(M.IExtHostConfiguration,M.ExtHostConfiguration),(0,i.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,i.registerSingleton)(m.IExtHostDebugService,m.WorkerExtHostDebugService),(0,i.registerSingleton)(D.IExtHostDecorations,D.ExtHostDecorations),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,i.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,i.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService),(0,i.registerSingleton)(t.IExtHostSearch,t.ExtHostSearch),(0,i.registerSingleton)(u.IExtHostStorage,u.ExtHostStorage),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask),(0,i.registerSingleton)(F.IExtHostTerminalService,F.WorkerExtHostTerminalService),(0,i.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,i.registerSingleton)(l.IExtHostWindow,l.ExtHostWindow),(0,i.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,i.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState),(0,i.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,i.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(be[217],we([0,1,43,3]),function(Z,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,A.createDecorator)("treeViewsDragAndDropService");class _{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(M){if(M&&this._dragOperations.has(M)){const T=this._dragOperations.get(M);return this._dragOperations.delete(M),T}}addDragOperationTransfer(M,T){this._dragOperations.set(M,T)}}e.TreeViewsDragAndDropService=_,(0,i.registerSingleton)(e.ITreeViewsDragAndDropService,_)}),define(be[218],we([0,1,122,24,2,5,7,10,6,13,16,8,20,151,217]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(v,b){if((0,F.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let o;return Array.isArray(v.highlights)&&(o=v.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),o=o.length?o:void 0),{label:v.label,highlights:o}}}class l{constructor(b,o,S){this._proxy=b,this.commands=o,this.logService=S,this.treeViews=new Map,this.treeDragAndDropService=new s.TreeViewsDragAndDropService;function n(P){return P&&P.$treeViewId&&P.$treeItemHandle}o.registerArgumentProcessor({processArgument:P=>n(P)?this.convertArgument(P):Array.isArray(P)&&P.length>0?P.map(r=>n(r)?this.convertArgument(r):r):P})}registerTreeDataProvider(b,o,S){const n=this.createTreeView(b,{treeDataProvider:o},S);return{dispose:()=>n.dispose()}}createTreeView(b,o,S){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=o.dragAndDropController?.supportedMimeTypes,P=!!o.dragAndDropController?.handleDrag,r=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dragAndDropMimeTypes:n,hasHandleDrag:P}),c=this.createExtHostTreeView(b,o,S);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(w){c.message=w},get title(){return c.title},set title(w){c.title=w},get description(){return c.description},set description(w){c.description=w},reveal:(w,h)=>c.reveal(w,h),dispose:async()=>{await r,this.treeViews.delete(b),c.dispose()}}}$getChildren(b,o){const S=this.treeViews.get(b);return S?S.getChildren(o):Promise.reject(new Error((0,i.localize)(0,null,b)))}async $handleDrop(b,o,S,n,P,r){const c=this.treeViews.get(b);if(!c)return Promise.reject(new Error((0,i.localize)(1,null,b)));const w=u.TreeDataTransferConverter.toITreeDataTransfer(o);return P===b&&r&&await this.addAdditionalTransferItems(w,c,r,n),c.onDrop(w,S)}async addAdditionalTransferItems(b,o,S,n){const P=this.treeDragAndDropService.removeDragOperationTransfer(n);if(P)(await P)?.forEach((r,c)=>{r&&b.set(c,r)});else if(n&&o.handleDrag){const r=o.handleDrag(S,b);this.treeDragAndDropService.addDragOperationTransfer(n,r),await r}return b}async $handleDrag(b,o,S){const n=this.treeViews.get(b);if(!n)return Promise.reject(new Error((0,i.localize)(2,null,b)));const P=await this.addAdditionalTransferItems(new Map,n,o,S);if(!!P)return u.TreeDataTransferConverter.toTreeDataTransferDTO(P)}async $hasResolve(b){const o=this.treeViews.get(b);if(!o)throw new Error((0,i.localize)(3,null,b));return o.hasResolve}$resolve(b,o,S){const n=this.treeViews.get(b);if(!n)throw new Error((0,i.localize)(4,null,b));return n.resolveTreeItem(o,S)}$setExpanded(b,o,S){const n=this.treeViews.get(b);if(!n)throw new Error((0,i.localize)(5,null,b));n.setExpanded(o,S)}$setSelection(b,o){const S=this.treeViews.get(b);if(!S)throw new Error((0,i.localize)(6,null,b));S.setSelection(o)}$setVisible(b,o){const S=this.treeViews.get(b);if(!S)throw new Error((0,i.localize)(7,null,b));S.setVisible(o)}createExtHostTreeView(b,o,S){const n=new k(b,o,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(b,n),n}convertArgument(b){const o=this.treeViews.get(b.$treeViewId);return o?o.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=l;class k extends M.Disposable{constructor(b,o,S,n,P,r){super();if(this.viewId=b,this.proxy=S,this.commands=n,this.logService=P,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new t.CancellationTokenSource,r.contributes&&r.contributes.views)for(const h in r.contributes.views)for(const d of r.contributes.views[h])d.id===b&&(this._title=d.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let c,w;this._register(D.Event.debounce(this._onDidChangeData.event,(h,d)=>(h||(h={message:!1,elements:[]}),d.element!==!1&&(c||(c=new Promise(g=>w=g),this.refreshPromise=this.refreshPromise.then(()=>c)),Array.isArray(d.element)?h.elements.push(...d.element):h.elements.push(d.element)),d.message&&(h.message=!0),h),200,!0)(({message:h,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=w;return c=null,this.refresh(d).then(()=>g())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,F.isUndefinedOrNull)(b))}async getChildren(b){const o=b?this.getExtensionElement(b):void 0;if(b&&!o)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(b);return S||(S=await this.fetchChildrenNodes(o)),S?S.map(n=>n.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,o){o=o||{select:!0,focus:!1};const S=(0,F.isUndefinedOrNull)(o.select)?!0:o.select,n=(0,F.isUndefinedOrNull)(o.focus)?!1:o.focus,P=(0,F.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(r=>this.resolveTreeNode(b,r[r.length-1]).then(c=>this.proxy.$reveal(this.viewId,{item:c.item,parentChain:r.map(w=>w.item)},{select:S,focus:n,expand:P})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:n,expand:P})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,o){const S=this.getExtensionElement(b);S&&(o?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(b){(0,O.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(b,o){const S=[];for(const n of b){const P=this.getExtensionElement(n);P&&S.push(P)}if(!(!this.dndController?.handleDrag||S.length===0))return await this.dndController.handleDrag(S,o),o}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(b,o){const S=this.getExtensionElement(o);if(!!S)return(0,T.asPromise)(()=>this.dndController?.handleDrop(b,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,o){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(b);if(S){const n=this.nodes.get(S);if(n){const P=await this.dataProvider.resolveTreeItem(n.extensionItem,S,o)??n.extensionItem;return n.item.tooltip=this.getTooltip(P.tooltip),n.item.command=this.getCommand(n.disposableStore,P.command),n.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(o=>o?this.resolveUnknownParentChain(o).then(S=>this.resolveTreeNode(o,S[S.length-1]).then(n=>(S.push(n),S))):Promise.resolve([]))}resolveParent(b){const o=this.nodes.get(b);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,T.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,o){const S=this.nodes.get(b);return S?Promise.resolve(S):(0,T.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(n=>this.createHandle(b,n,o,!0)).then(n=>this.getChildren(o?o.item.handle:void 0).then(()=>{const P=this.getExtensionElement(n);if(P){const r=this.nodes.get(P);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(b){if(b){let o;if(typeof b=="string"){const S=this.getExtensionElement(b);o=S?this.nodes.get(S):void 0}else o=b;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const o=new t.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=b?this.nodes.get(b):void 0,n=await this.dataProvider.getChildren(b);if(o.token.isCancellationRequested)return;const P=await Promise.all((0,O.coalesce)(n||[]).map(async r=>{const c=await this.dataProvider.getTreeItem(r);return c&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(r,c,S):null}));return o.token.isCancellationRequested?void 0:(0,O.coalesce)(P)}finally{o.dispose()}}refresh(b){if(b.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new t.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(b);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const o=new Set,S=b.map(P=>this.nodes.get(P));for(const P of S)if(P&&!o.has(P.item.handle)){let r=P;for(;r&&r.parent&&S.findIndex(c=>r&&r.parent&&c&&c.item.handle===r.parent.item.handle)===-1;){const c=this.elements.get(r.parent.item.handle);r=c?this.nodes.get(c):void 0}r&&!r.parent&&o.add(P.item.handle)}const n=[];return o.forEach(P=>{const r=this.elements.get(P);if(r){const c=this.nodes.get(r);c&&(!c.parent||!o.has(c.parent.item.handle))&&n.push(P)}}),n}refreshHandles(b){const o={};return Promise.all(b.map(S=>this.refreshNode(S).then(n=>{n&&(o[S]=n.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(b){const o=this.getExtensionElement(b);if(o){const S=this.nodes.get(o);if(S)return this.clearChildren(o),(0,T.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(n=>{if(n){const P=this.createTreeNode(o,n,S.parent);return this.updateNodeCache(o,P,S,S.parent),S.dispose(),P}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,o,S){const n=this.createTreeNode(b,o,S);if(o.id&&this.elements.has(n.item.handle))throw new Error((0,i.localize)(8,null,o.id));return this.addNodeToCache(b,n),this.addNodeToParentCache(n,S),n}getTooltip(b){return y.MarkdownString.isMarkdownString(b)?m.MarkdownString.from(b):b}getCommand(b,o){return o?this.commands.toInternal(o,b):void 0}createTreeNode(b,o,S){const n=new M.DisposableStore,P=this.createHandle(b,o,S),r=this.getLightIconPath(o);return{item:{handle:P,parentHandle:S?S.item.handle:void 0,label:a(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(n,o.command),contextValue:o.contextValue,icon:r,iconDark:this.getDarkIconPath(o)||r,themeIcon:this.getThemeIcon(o),collapsibleState:(0,F.isUndefinedOrNull)(o.collapsibleState)?y.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:S,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(b){return b.iconPath instanceof y.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:o,label:S,resourceUri:n},P,r){if(o)return`${k.ID_HANDLE_PREFIX}/${o}`;const c=a(S,this.extension),w=P?P.item.handle:k.LABEL_HANDLE_PREFIX;let h=c?c.label:n?(0,A.basename)(n):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const d=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,g=this.getChildrenNodes(P)||[];let f,E=0;do{if(f=`${w}/${E}:${h}`,r||!this.elements.has(f)||d===f)break;E++}while(E<=g.length);return f}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof y.ThemeIcon))return typeof b.iconPath=="string"||_.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof y.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return _.URI.isUri(b)?b:_.URI.file(b)}addNodeToCache(b,o){this.elements.set(o.item.handle,b),this.nodes.set(b,o)}updateNodeCache(b,o,S,n){this.elements.delete(o.item.handle),this.nodes.delete(b),o.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(b,o);const P=this.getChildrenNodes(n)||[],r=P.filter(c=>c.item.handle===S.item.handle)[0];r&&P.splice(P.indexOf(r),1,o)}addNodeToParentCache(b,o){o?(o.children||(o.children=[]),o.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const o=this.nodes.get(b);if(o){if(o.children)for(const S of o.children){const n=this.elements.get(S.item.handle);n&&this.clear(n)}o.children=void 0}}else this.clearAll()}clear(b){const o=this.nodes.get(b);if(o){if(o.children)for(const S of o.children){const n=this.elements.get(S.item.handle);n&&this.clear(n)}this.nodes.delete(b),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(be[219],we([0,1,20,15,5,33,2,111,232,106,148,45,4,176,175,38,177,31,178,179,180,163,181,48,32,182,183,186,188,190,91,165,195,196,197,64,39,199,218,8,6,202,50,92,30,67,152,185,78,89,94,95,96,9,58,12,27,191,149,57,62,173,200,147,65,49,205,203,204,174,29,198,201,61,63,79,193,93,194,11,135,192,145,184,7,26]),function(Z,e,i,A,_,D,M,T,y,F,O,m,t,u,s,a,l,k,v,b,o,S,n,P,r,c,w,h,d,g,f,E,C,I,N,p,R,x,j,H,z,K,ce,fe,re,ge,ye,ve,Me,je,et,lt,it,ft,_t,ut,rt,B,G,$,V,Y,ne,me,Fe,$e,qe,Je,Ze,Ke,Qe,mt,Tt,Te,kt,q,Q,se,Oe,He,tt,Ve,wt,Ie,Se,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ee(te){const ue=te.get(rt.IExtHostInitDataService),de=te.get(Qe.IExtHostFileSystemInfo),ke=te.get($e.IExtHostConsumerFileSystem),xe=te.get(r.IExtHostExtensionService),Ae=te.get(re.IExtHostWorkspace),Be=te.get(q.IExtHostTelemetry),Xe=te.get(k.IExtHostConfiguration),nt=te.get(_t.IURITransformerService),Re=te.get(ut.IExtHostRpcService),ae=te.get(p.IExtHostStorage),le=te.get(Fe.IExtensionStoragePaths),ie=te.get(ft.ILoggerService),W=te.get(ft.ILogService),pe=te.get($.IExtHostTunnelService),Ce=te.get(V.IExtHostApiDeprecationService),ze=te.get(fe.IExtHostWindow),Ue=te.get(Te.IExtHostSecretState),dt=te.get(kt.IExtHostEditorTabs);Re.set(t.ExtHostContext.ExtHostFileSystemInfo,de),Re.set(t.ExtHostContext.ExtHostLogLevelServiceShape,ie),Re.set(t.ExtHostContext.ExtHostWorkspace,Ae),Re.set(t.ExtHostContext.ExtHostConfiguration,Xe),Re.set(t.ExtHostContext.ExtHostExtensionService,xe),Re.set(t.ExtHostContext.ExtHostStorage,ae),Re.set(t.ExtHostContext.ExtHostTunnelService,pe),Re.set(t.ExtHostContext.ExtHostWindow,ze),Re.set(t.ExtHostContext.ExtHostSecretState,Ue),Re.set(t.ExtHostContext.ExtHostTelemetry,Be),Re.set(t.ExtHostContext.ExtHostEditorTabs,dt);const bt=Re.set(t.ExtHostContext.ExtHostDecorations,te.get(je.IExtHostDecorations)),yt=Re.set(t.ExtHostContext.ExtHostDocumentsAndEditors,te.get(P.IExtHostDocumentsAndEditors)),st=Re.set(t.ExtHostContext.ExtHostCommands,te.get(a.IExtHostCommands)),gt=Re.set(t.ExtHostContext.ExtHostTerminalService,te.get(R.IExtHostTerminalService)),pt=Re.set(t.ExtHostContext.ExtHostDebugService,te.get(lt.IExtHostDebugService)),Ut=Re.set(t.ExtHostContext.ExtHostSearch,te.get(it.IExtHostSearch)),At=Re.set(t.ExtHostContext.ExtHostTask,te.get(et.IExtHostTask)),Ot=Re.set(t.ExtHostContext.ExtHostOutputService,te.get(f.IExtHostOutputService)),Ct=Re.set(t.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(Re)),Et=Re.set(t.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(Re,yt)),Lt=Re.set(t.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(Re,yt,W)),qt=Re.set(t.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(W,Et,Re.getProxy(t.MainContext.MainThreadBulkEdits))),vt=Re.set(t.ExtHostContext.ExtHostNotebook,new B.ExtHostNotebookController(Re,st,yt,Et,le)),Bt=Re.set(t.ExtHostContext.ExtHostNotebookDocuments,new wt.ExtHostNotebookDocuments(W,vt)),Gt=Re.set(t.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(W,Re,vt)),Xt=Re.set(t.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(Re,ue,vt,st,W)),ai=Re.set(t.ExtHostContext.ExtHostNotebookRenderers,new Oe.ExtHostNotebookRenderers(Re,vt)),Rt=Re.set(t.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Re,yt)),Jt=Re.set(t.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(Re.getProxy(t.MainContext.MainThreadTreeViews),st,W)),li=Re.set(t.ExtHostContext.ExtHostEditorInsets,new ye.ExtHostEditorInsets(Re.getProxy(t.MainContext.MainThreadEditorInsets),Rt,ue)),Kt=Re.set(t.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Re,W,de)),Zt=Re.set(t.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(Re,Et,st.converter,nt)),ht=Re.set(t.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(Re,nt,Et,st,Kt,W,Ce)),ci=Re.set(t.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Re,ht)),Nt=Re.set(t.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(Re,W,yt)),zt=Re.set(t.ExtHostContext.ExtHostQuickOpen,(0,C.createExtHostQuickOpen)(Re,Ae,st)),vi=Re.set(t.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(Re,st,W)),ui=Re.set(t.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Re,st,Et)),ei=Re.set(t.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Re.getProxy(t.MainContext.MainThreadProgress))),Di=Re.set(t.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Re)),Ei=Re.set(t.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(Re)),ti=Re.set(t.ExtHostContext.ExtHostAuthentication,new Y.ExtHostAuthentication(Re)),Ci=Re.set(t.ExtHostContext.ExtHostTimeline,new ne.ExtHostTimeline(Re,st)),di=Re.set(t.ExtHostContext.ExtHostWebviews,new ce.ExtHostWebviews(Re,{remote:ue.remote},Ae,W,Ce)),Qt=Re.set(t.ExtHostContext.ExtHostWebviewPanels,new Ze.ExtHostWebviewPanels(Re,di,Ae)),hi=Re.set(t.ExtHostContext.ExtHostCustomEditors,new Je.ExtHostCustomEditors(Re,Et,le,di,Qt)),Ii=Re.set(t.ExtHostContext.ExtHostWebviewViews,new qe.ExtHostWebviewViews(Re,di)),Yt=Re.set(t.ExtHostContext.ExtHostTesting,new mt.ExtHostTesting(Re,st)),ki=Re.set(t.ExtHostContext.ExtHostUriOpeners,new Tt.ExtHostUriOpeners(Re));Re.set(t.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Re,vt,yt,st));const Pi=(0,ge.values)(t.ExtHostContext);Re.assertRegistered(Pi);const ii=new Ke.ExtHostBulkEdits(Re,yt),Ti=new s.ExtHostClipboard(Re),fi=new g.ExtHostMessageService(Re,W),bi=new b.ExtHostDialogs(Re),ni=new N.ExtHostStatusBar(Re,st.converter);return u.ExtHostApiCommands.register(st),function(Pe,Wt,$t){const St=function(){let X=!Pe.isUnderDevelopment;function oe(){X||(W.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function _e(at){if(Array.isArray(at))at.forEach(_e);else if(typeof at=="string")oe();else{const Dt=at;typeof Dt.scheme=="undefined"&&oe(),typeof Dt.exclusive=="boolean"&&(0,he.checkProposedApiEnabled)(Pe,"documentFiltersExclusive")}return at}}(),Mt={getSession(X,oe,_e){return ti.getSession(Pe,X,oe,_e)},async hasSession(X,oe){return(0,he.checkProposedApiEnabled)(Pe,"authSession"),!!await ti.getSession(Pe,X,oe,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(X,oe,_e,at){return ti.registerAuthenticationProvider(X,oe,_e,at)}},ri={registerCommand(X,oe,_e){return st.registerCommand(!0,X,oe,_e,void 0,Pe)},registerTextEditorCommand(X,oe,_e){return st.registerCommand(!0,X,(...at)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){W.warn("Cannot execute "+X+" because there is no active text editor.");return}return Dt.edit(Pt=>{oe.apply(_e,[Dt,Pt,...at])}).then(Pt=>{Pt||W.warn("Edits from command "+X+" were not applied.")},Pt=>{W.warn("An error occurred while running command "+X,Pt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(X,oe,_e)=>((0,he.checkProposedApiEnabled)(Pe,"diffCommand"),st.registerCommand(!0,X,async(...at)=>{const Dt=yt.activeEditor(!0);if(!Dt){W.warn("Cannot execute "+X+" because there is no active text editor.");return}const Pt=await Rt.getDiffInformation(Dt.id);oe.apply(_e,[Pt,...at])},void 0,void 0,Pe)),executeCommand(X,...oe){return st.executeCommand(X,...oe)},getCommands(X=!1){return st.getCommands(X)}},wi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Be.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Be.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,he.checkProposedApiEnabled)(Pe,"telemetry"),Be.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,he.checkProposedApiEnabled)(Pe,"telemetry"),Be.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const X=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,oe){return ze.openUri(X,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===ue.environment.appUriScheme)return Ct.createAppUri(X);try{return await ze.asExternalUri(X,{allowTunneling:!!ue.remote.authority})}catch(oe){if((0,tt.matchesScheme)(X,He.Schemas.http)||(0,tt.matchesScheme)(X,He.Schemas.https))return X;throw oe}},get remoteName(){return(0,Me.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,he.checkProposedApiEnabled)(Pe,"resolvers"),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(wi);const Si=ue.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ai={createTestController(X,oe,_e){return _e&&(0,he.checkProposedApiEnabled)(Pe,"testRefresh"),Yt.createTestController(X,oe,_e)},createTestObserver(){return(0,he.checkProposedApiEnabled)(Pe,"testObserver"),Yt.createTestObserver()},runTests(X){return(0,he.checkProposedApiEnabled)(Pe,"testObserver"),Yt.runTests(X)},get onDidChangeTestResults(){return(0,he.checkProposedApiEnabled)(Pe,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,he.checkProposedApiEnabled)(Pe,"testObserver"),Yt.results}},Ri={getExtension(X){const oe=Wt.getExtensionDescription(X);if(oe)return new r.Extension(xe,Pe.identifier,oe,Si)},get all(){return Wt.getAllExtensionDescriptions().map(X=>new r.Extension(xe,Pe.identifier,X,Si))},get onDidChange(){return Wt.onDidChange}},Fi={createDiagnosticCollection(X){return Kt.createDiagnosticCollection(Pe.identifier,X)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:X=>Kt.getDiagnostics(X),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(X,oe){return Zt.changeLanguage(X.uri,oe)},match(X,oe){return(0,O.score)(H.LanguageSelector.from(X),oe.uri,oe.languageId,!0)},registerCodeActionsProvider(X,oe,_e){return ht.registerCodeActionProvider(Pe,St(X),oe,_e)},registerCodeLensProvider(X,oe){return ht.registerCodeLensProvider(Pe,St(X),oe)},registerDefinitionProvider(X,oe){return ht.registerDefinitionProvider(Pe,St(X),oe)},registerDeclarationProvider(X,oe){return ht.registerDeclarationProvider(Pe,St(X),oe)},registerImplementationProvider(X,oe){return ht.registerImplementationProvider(Pe,St(X),oe)},registerTypeDefinitionProvider(X,oe){return ht.registerTypeDefinitionProvider(Pe,St(X),oe)},registerHoverProvider(X,oe){return ht.registerHoverProvider(Pe,St(X),oe,Pe.identifier)},registerEvaluatableExpressionProvider(X,oe){return ht.registerEvaluatableExpressionProvider(Pe,St(X),oe,Pe.identifier)},registerInlineValuesProvider(X,oe){return ht.registerInlineValuesProvider(Pe,St(X),oe,Pe.identifier)},registerDocumentHighlightProvider(X,oe){return ht.registerDocumentHighlightProvider(Pe,St(X),oe)},registerLinkedEditingRangeProvider(X,oe){return ht.registerLinkedEditingRangeProvider(Pe,St(X),oe)},registerReferenceProvider(X,oe){return ht.registerReferenceProvider(Pe,St(X),oe)},registerRenameProvider(X,oe){return ht.registerRenameProvider(Pe,St(X),oe)},registerDocumentSymbolProvider(X,oe,_e){return ht.registerDocumentSymbolProvider(Pe,St(X),oe,_e)},registerWorkspaceSymbolProvider(X){return ht.registerWorkspaceSymbolProvider(Pe,X)},registerDocumentFormattingEditProvider(X,oe){return ht.registerDocumentFormattingEditProvider(Pe,St(X),oe)},registerDocumentRangeFormattingEditProvider(X,oe){return ht.registerDocumentRangeFormattingEditProvider(Pe,St(X),oe)},registerOnTypeFormattingEditProvider(X,oe,_e,...at){return ht.registerOnTypeFormattingEditProvider(Pe,St(X),oe,[_e].concat(at))},registerDocumentSemanticTokensProvider(X,oe,_e){return ht.registerDocumentSemanticTokensProvider(Pe,St(X),oe,_e)},registerDocumentRangeSemanticTokensProvider(X,oe,_e){return ht.registerDocumentRangeSemanticTokensProvider(Pe,St(X),oe,_e)},registerSignatureHelpProvider(X,oe,_e,...at){return typeof _e=="object"?ht.registerSignatureHelpProvider(Pe,St(X),oe,_e):ht.registerSignatureHelpProvider(Pe,St(X),oe,typeof _e=="undefined"?[]:[_e,...at])},registerCompletionItemProvider(X,oe,..._e){return ht.registerCompletionItemProvider(Pe,St(X),oe,_e)},registerInlineCompletionItemProvider(X,oe){return(0,he.checkProposedApiEnabled)(Pe,"inlineCompletions"),ht.registerInlineCompletionsProvider(Pe,St(X),oe)},registerDocumentLinkProvider(X,oe){return ht.registerDocumentLinkProvider(Pe,St(X),oe)},registerColorProvider(X,oe){return ht.registerColorProvider(Pe,St(X),oe)},registerFoldingRangeProvider(X,oe){return ht.registerFoldingRangeProvider(Pe,St(X),oe)},registerSelectionRangeProvider(X,oe){return ht.registerSelectionRangeProvider(Pe,X,oe)},registerCallHierarchyProvider(X,oe){return ht.registerCallHierarchyProvider(Pe,X,oe)},registerTypeHierarchyProvider(X,oe){return ht.registerTypeHierarchyProvider(Pe,X,oe)},setLanguageConfiguration:(X,oe)=>ht.setLanguageConfiguration(Pe,X,oe),getTokenInformationAtPosition(X,oe){return(0,he.checkProposedApiEnabled)(Pe,"tokenInformation"),Zt.tokenAtPosition(X,oe)},registerInlayHintsProvider(X,oe){return(0,he.checkProposedApiEnabled)(Pe,"inlayHints"),ht.registerInlayHintsProvider(Pe,X,oe)},createLanguageStatusItem(X,oe){return(0,he.checkProposedApiEnabled)(Pe,"languageStatus"),Zt.createLanguageStatusItem(Pe,X,oe)}},Mi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(X,oe,_e){const at=await(M.URI.isUri(X)?Promise.resolve(_i.openTextDocument(X)):Promise.resolve(X));return Rt.showTextDocument(at,oe,_e)},createTextEditorDecorationType(X){return Rt.createTextEditorDecorationType(Pe,X)},onDidChangeActiveTextEditor(X,oe,_e){return Rt.onDidChangeActiveTextEditor(X,oe,_e)},onDidChangeVisibleTextEditors(X,oe,_e){return Rt.onDidChangeVisibleTextEditors(X,oe,_e)},onDidChangeTextEditorSelection(X,oe,_e){return Rt.onDidChangeTextEditorSelection(X,oe,_e)},onDidChangeTextEditorOptions(X,oe,_e){return Rt.onDidChangeTextEditorOptions(X,oe,_e)},onDidChangeTextEditorVisibleRanges(X,oe,_e){return Rt.onDidChangeTextEditorVisibleRanges(X,oe,_e)},onDidChangeTextEditorViewColumn(X,oe,_e){return Rt.onDidChangeTextEditorViewColumn(X,oe,_e)},onDidCloseTerminal(X,oe,_e){return gt.onDidCloseTerminal(X,oe,_e)},onDidOpenTerminal(X,oe,_e){return gt.onDidOpenTerminal(X,oe,_e)},onDidChangeActiveTerminal(X,oe,_e){return gt.onDidChangeActiveTerminal(X,oe,_e)},onDidChangeTerminalDimensions(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"terminalDimensions"),gt.onDidChangeTerminalDimensions(X,oe,_e)},onDidChangeTerminalState(X,oe,_e){return gt.onDidChangeTerminalState(X,oe,_e)},onDidWriteTerminalData(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(X,oe,_e)},get state(){return ze.state},onDidChangeWindowState(X,oe,_e){return ze.onDidChangeWindowState(X,oe,_e)},showInformationMessage(X,...oe){return fi.showMessage(Pe,D.default.Info,X,oe[0],oe.slice(1))},showWarningMessage(X,...oe){return fi.showMessage(Pe,D.default.Warning,X,oe[0],oe.slice(1))},showErrorMessage(X,...oe){return fi.showMessage(Pe,D.default.Error,X,oe[0],oe.slice(1))},showQuickPick(X,oe,_e){return zt.showQuickPick(X,oe,_e)},showWorkspaceFolderPick(X){return zt.showWorkspaceFolderPick(X)},showInputBox(X,oe){return zt.showInput(X,oe)},showOpenDialog(X){return bi.showOpenDialog(X)},showSaveDialog(X){return bi.showSaveDialog(X)},createStatusBarItem(X,oe,_e){let at,Dt,Pt;return typeof X=="string"?(at=X,Dt=oe,Pt=_e):(Dt=X,Pt=oe),ni.createStatusBarEntry(Pe,at,Dt,Pt)},setStatusBarMessage(X,oe){return ni.setStatusBarMessage(X,oe)},withScmProgress(X){return Ce.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),ei.withProgress(Pe,{location:z.ProgressLocation.SourceControl},(oe,_e)=>X({report(at){}}))},withProgress(X,oe){return ei.withProgress(Pe,X,oe)},createOutputChannel(X){return Ot.createOutputChannel(X,Pe)},createWebviewPanel(X,oe,_e,at){return Qt.createWebviewPanel(Pe,X,oe,_e,at)},createWebviewTextEditorInset(X,oe,_e,at){return(0,he.checkProposedApiEnabled)(Pe,"editorInsets"),li.createWebviewEditorInset(X,oe,_e,at,Pe)},createTerminal(X,oe,_e){return typeof X=="object"?"pty"in X?gt.createExtensionTerminal(X):gt.createTerminalFromOptions(X):gt.createTerminal(X,oe,_e)},registerTerminalLinkProvider(X){return gt.registerLinkProvider(X)},registerTerminalProfileProvider(X,oe){return gt.registerProfileProvider(Pe,X,oe)},registerTreeDataProvider(X,oe){return Jt.registerTreeDataProvider(X,oe,Pe)},createTreeView(X,oe){return Jt.createTreeView(X,oe,Pe)},registerWebviewPanelSerializer:(X,oe)=>Qt.registerWebviewPanelSerializer(Pe,X,oe),registerCustomEditorProvider:(X,oe,_e={})=>hi.registerCustomEditorProvider(Pe,X,oe,_e),registerFileDecorationProvider(X){return bt.registerFileDecorationProvider(X,Pe.identifier)},registerUriHandler(X){return Ct.registerUriHandler(Pe.identifier,X)},createQuickPick(){return zt.createQuickPick(Pe)},createInputBox(){return zt.createInputBox(Pe.identifier)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(X,oe,_e){return Ei.onDidChangeActiveColorTheme(X,oe,_e)},registerWebviewViewProvider(X,oe,_e){return Ii.registerWebviewViewProvider(Pe,X,oe,_e?.webviewOptions)},get activeNotebookEditor(){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.onDidChangeActiveNotebookEditor(X,oe,_e)},get visibleNotebookEditors(){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),Gt.onDidChangeNotebookEditorSelection(X,oe,_e)},onDidChangeNotebookEditorVisibleRanges(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),Gt.onDidChangeNotebookEditorVisibleRanges(X,oe,_e)},showNotebookDocument(X,oe){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.showNotebookDocument(X,oe)},registerExternalUriOpener(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"externalUriOpener"),ki.registerExternalUriOpener(Pe.identifier,X,oe,_e)},get tabs(){return(0,he.checkProposedApiEnabled)(Pe,"tabs"),dt.tabs},get activeTab(){return(0,he.checkProposedApiEnabled)(Pe,"tabs"),dt.activeTab},get onDidChangeTabs(){return(0,he.checkProposedApiEnabled)(Pe,"tabs"),dt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,he.checkProposedApiEnabled)(Pe,"tabs"),dt.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,he.checkProposedApiEnabled)(Pe,"inlineCompletions"),h.InlineCompletionController.get(X)}},_i={get rootPath(){return Ce.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ae.getPath()},set rootPath(X){throw A.readonly()},getWorkspaceFolder(X){return Ae.getWorkspaceFolder(X)},get workspaceFolders(){return Ae.getWorkspaceFolders()},get name(){return Ae.name},set name(X){throw A.readonly()},get workspaceFile(){return Ae.workspaceFile},set workspaceFile(X){throw A.readonly()},updateWorkspaceFolders:(X,oe,..._e)=>Ae.updateWorkspaceFolders(Pe,X,oe||0,..._e),onDidChangeWorkspaceFolders:function(X,oe,_e){return Ae.onDidChangeWorkspace(X,oe,_e)},asRelativePath:(X,oe)=>Ae.getRelativePath(X,oe),findFiles:(X,oe,_e,at)=>Ae.findFiles(X,oe,_e,Pe.identifier,at),findTextInFiles:(X,oe,_e,at)=>{(0,he.checkProposedApiEnabled)(Pe,"findTextInFiles");let Dt,Pt;return typeof oe=="object"?(Dt=oe,Pt=_e):(Dt={},Pt=oe,at=_e),Ae.findTextInFiles(X,Dt||{},Pt,Pe.identifier,at)},saveAll:X=>Ae.saveAll(X),applyEdit(X){return ii.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,oe,_e,at)=>Nt.createFileSystemWatcher(Ae,Pe,X,oe,_e,at),get textDocuments(){return Et.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw A.readonly()},openTextDocument(X){let oe;const _e=X;if(typeof X=="string")oe=Promise.resolve(M.URI.file(X));else if(M.URI.isUri(X))oe=Promise.resolve(X);else if(!_e||typeof _e=="object")oe=Et.createDocumentData(_e);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(at=>Et.ensureDocumentData(at).then(Dt=>Dt.document))},onDidOpenTextDocument:(X,oe,_e)=>Et.onDidAddDocument(X,oe,_e),onDidCloseTextDocument:(X,oe,_e)=>Et.onDidRemoveDocument(X,oe,_e),onDidChangeTextDocument:(X,oe,_e)=>Et.onDidChangeDocument(X,oe,_e),onDidSaveTextDocument:(X,oe,_e)=>Et.onDidSaveDocument(X,oe,_e),onWillSaveTextDocument:(X,oe,_e)=>qt.getOnWillSaveTextDocumentEvent(Pe)(X,oe,_e),get notebookDocuments(){return vt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,oe){let _e;if(M.URI.isUri(X))_e=X,await vt.openNotebookDocument(X);else if(typeof X=="string")_e=M.URI.revive(await vt.createNotebookDocument({viewType:X,content:oe}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(_e).apiNotebook},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(X,oe,_e,at){return vt.registerNotebookSerializer(Pe,X,oe,_e,(0,he.isProposedApiEnabled)(Pe,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(X,oe,_e,at)=>((0,he.checkProposedApiEnabled)(Pe,"notebookContentProvider"),vt.registerNotebookContentProvider(Pe,X,oe,_e,(0,he.isProposedApiEnabled)(Pe,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(X,oe,_e)=>$t.onDidChangeConfiguration(X,oe,_e),getConfiguration(X,oe){return oe=arguments.length===1?void 0:oe,$t.getConfiguration(X,oe,Pe)},registerTextDocumentContentProvider(X,oe){return Lt.registerTextDocumentContentProvider(X,oe)},registerTaskProvider:(X,oe)=>(Ce.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),At.registerTaskProvider(Pe,X,oe)),registerFileSystemProvider(X,oe,_e){return(0,Se.combinedDisposable)(ci.registerFileSystemProvider(Pe,X,oe,_e),ke.addFileSystemProvider(X,oe))},get fs(){return ke.value},registerFileSearchProvider:(X,oe)=>((0,he.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Ut.registerFileSearchProvider(X,oe)),registerTextSearchProvider:(X,oe)=>((0,he.checkProposedApiEnabled)(Pe,"textSearchProvider"),Ut.registerTextSearchProvider(X,oe)),registerRemoteAuthorityResolver:(X,oe)=>((0,he.checkProposedApiEnabled)(Pe,"resolvers"),xe.registerRemoteAuthorityResolver(X,oe)),registerResourceLabelFormatter:X=>((0,he.checkProposedApiEnabled)(Pe,"resolvers"),Di.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,oe,_e)=>Nt.onDidCreateFile(X,oe,_e),onDidDeleteFiles:(X,oe,_e)=>Nt.onDidDeleteFile(X,oe,_e),onDidRenameFiles:(X,oe,_e)=>Nt.onDidRenameFile(X,oe,_e),onWillCreateFiles:(X,oe,_e)=>Nt.getOnWillCreateFileEvent(Pe)(X,oe,_e),onWillDeleteFiles:(X,oe,_e)=>Nt.getOnWillDeleteFileEvent(Pe)(X,oe,_e),onWillRenameFiles:(X,oe,_e)=>Nt.getOnWillRenameFileEvent(Pe)(X,oe,_e),openTunnel:X=>((0,he.checkProposedApiEnabled)(Pe,"resolvers"),pe.openTunnel(Pe,X).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,he.checkProposedApiEnabled)(Pe,"resolvers"),pe.getTunnels()},onDidChangeTunnels:(X,oe,_e)=>((0,he.checkProposedApiEnabled)(Pe,"resolvers"),pe.onDidChangeTunnels(X,oe,_e)),registerPortAttributesProvider:(X,oe)=>((0,he.checkProposedApiEnabled)(Pe,"portsAttributes"),pe.registerPortsAttributesProvider(X,oe)),registerTimelineProvider:(X,oe)=>((0,he.checkProposedApiEnabled)(Pe,"timeline"),Ci.registerTimelineProvider(X,oe,Pe.identifier,st.converter)),get isTrusted(){return Ae.trusted},requestWorkspaceTrust:X=>((0,he.checkProposedApiEnabled)(Pe,"workspaceTrust"),Ae.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,oe,_e)=>Ae.onDidGrantWorkspaceTrust(X,oe,_e)},mi={get inputBox(){return Ce.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Pe)},createSourceControl(X,oe,_e){return vi.createSourceControl(Pe,X,oe,_e)}},Oi={createCommentController(X,oe){return ui.createCommentController(Pe,X,oe)}},Li={get activeDebugSession(){return pt.activeDebugSession},get activeDebugConsole(){return pt.activeDebugConsole},get breakpoints(){return pt.breakpoints},onDidStartDebugSession(X,oe,_e){return pt.onDidStartDebugSession(X,oe,_e)},onDidTerminateDebugSession(X,oe,_e){return pt.onDidTerminateDebugSession(X,oe,_e)},onDidChangeActiveDebugSession(X,oe,_e){return pt.onDidChangeActiveDebugSession(X,oe,_e)},onDidReceiveDebugSessionCustomEvent(X,oe,_e){return pt.onDidReceiveDebugSessionCustomEvent(X,oe,_e)},onDidChangeBreakpoints(X,oe,_e){return pt.onDidChangeBreakpoints(X,oe,_e)},registerDebugConfigurationProvider(X,oe,_e){return pt.registerDebugConfigurationProvider(X,oe,_e||z.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,oe){return pt.registerDebugAdapterDescriptorFactory(Pe,X,oe)},registerDebugAdapterTrackerFactory(X,oe){return pt.registerDebugAdapterTrackerFactory(X,oe)},startDebugging(X,oe,_e){return!_e||typeof _e=="object"&&"configuration"in _e?pt.startDebugging(X,oe,{parentSession:_e}):pt.startDebugging(X,oe,_e||{})},stopDebugging(X){return pt.stopDebugging(X)},addBreakpoints(X){return pt.addBreakpoints(X)},removeBreakpoints(X){return pt.removeBreakpoints(X)},asDebugSourceUri(X,oe){return pt.asDebugSourceUri(X,oe)}},Ni={registerTaskProvider:(X,oe)=>At.registerTaskProvider(Pe,X,oe),fetchTasks:X=>At.fetchTasks(X),executeTask:X=>At.executeTask(Pe,X),get taskExecutions(){return At.taskExecutions},onDidStartTask:(X,oe,_e)=>At.onDidStartTask(X,oe,_e),onDidEndTask:(X,oe,_e)=>At.onDidEndTask(X,oe,_e),onDidStartTaskProcess:(X,oe,_e)=>At.onDidStartTaskProcess(X,oe,_e),onDidEndTaskProcess:(X,oe,_e)=>At.onDidEndTaskProcess(X,oe,_e)},xi={createNotebookController(X,oe,_e,at,Dt){return Xt.createNotebookController(Pe,X,oe,_e,at,(0,he.isProposedApiEnabled)(Pe,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(X,oe)=>vt.registerNotebookCellStatusBarItemProvider(Pe,X,oe),get onDidSaveNotebookDocument(){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),Bt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Gt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ai.createRendererMessaging(Pe,X)},onDidChangeNotebookDocumentMetadata(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),Bt.onDidChangeNotebookDocumentMetadata(X,oe,_e)},onDidChangeNotebookCells(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.onDidChangeNotebookCells(X,oe,_e)},onDidChangeNotebookCellExecutionState(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(X,oe,_e)},onDidChangeCellOutputs(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.onDidChangeCellOutputs(X,oe,_e)},onDidChangeCellMetadata(X,oe,_e){return(0,he.checkProposedApiEnabled)(Pe,"notebookEditor"),vt.onDidChangeCellMetadata(X,oe,_e)},createConcatTextDocument(X,oe){return(0,he.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new me.ExtHostNotebookConcatDocument(vt,Et,X,oe)}};return{version:ue.version,authentication:Mt,commands:ri,comments:Oi,debug:Li,env:wi,extensions:Ri,languages:Fi,notebooks:xi,scm:mi,tasks:Ni,tests:Ai,window:Mi,workspace:_i,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:t.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:z.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestions,Hover:z.Hover,IndentAction:F.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:t.UIKind,Uri:M.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:se.TextSearchCompleteMessageType,TreeDataTransfer:z.TreeDataTransfer,TreeDataTransferItem:z.TreeDataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ee}),define(be[220],we([0,1,219,32,212,6,10,4,11]),function(Z,e,i,A,_,D,M,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class F extends _.RequireInterceptor{_installInterceptor(){}getModule(s,a){for(let l of this._alternatives){let k=l(s);if(k){s=k;break}}if(this._factories.has(s))return this._factories.get(s).load(s,a,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends A.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);t(s,this._initData.environment.isExtensionDevelopmentDebug);const a=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,a,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,a,l){a=a.with({path:m(a.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const k=await fetch(y.FileAccess.asBrowserUri(a).toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),k.status!==200)throw new Error(k.statusText);const v=await k.text(),b=`${a.toString(!0)}#vscode-extension`,o=`${v}
//# sourceURL=${b}`;let S;try{S=new Function("module","exports","require",o)}catch(c){throw console.error(s?`Loading code for extension ${s.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${a.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const n={},P={exports:n},r=c=>{const w=this._fakeModules.getModule(c,a);if(w===void 0)throw new Error(`Cannot load module '${c}'`);return w};try{return l.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),S(P,n,r),P.exports!==n?P.exports:n}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),l.codeLoadingStop()}}async $setRemoteEnvironment(s){}async _waitForDebuggerAttachment(s=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const a=Date.now()+s;for(;Date.now()<a&&!("__jsDebugIsReady"in globalThis);)await(0,M.timeout)(10)}}e.ExtHostExtensionService=O;function m(u,s){return u.endsWith(s)?u:u+s}function t(u,s){a("info","log"),a("log","log"),a("warn","warn"),a("error","error");function a(v,b){const o=console[v];console[v]=function(){u.$logExtensionHostMessage({type:"__$console",severity:b,arguments:k(arguments)}),s&&o.apply(console,arguments)}}const l=1e5;function k(v){const b=[],o=[];if(v.length)for(let S=0;S<v.length;S++){if(typeof v[S]=="undefined")v[S]="undefined";else if(v[S]instanceof Error){const n=v[S];n.stack?v[S]=n.stack:v[S]=n.toString()}o.push(v[S])}try{const S=JSON.stringify(o,function(n,P){if(P&&typeof P=="object"){if(b.indexOf(P)!==-1)return"[Circular]";b.push(P)}return P});return S.length>l?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}}),define(be[221],we([0,1,43,32,65,220]),function(Z,e,i,A,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(A.IExtHostExtensionService,D.ExtHostExtensionService),(0,i.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(be[233],we([0,1,21,5,169,213,207,19,66,11,2,216,221]),function(Z,e,i,A,_,D,M,T,y,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const m=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const t=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const u=fetch.bind(self);if(self.fetch=function(b,o){return b instanceof Request||/^file:/i.test(String(b))&&(b=F.FileAccess.asBrowserUri(O.URI.parse(String(b))).toString(!0)),u(b,o)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,o,S,n,P){return/^file:/i.test(o.toString())&&(o=F.FileAccess.asBrowserUri(O.URI.parse(o.toString())).toString(!0)),super.open(b,o,S??!0,n,P)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=self.Worker;Worker=function(o,S){/^file:/i.test(o.toString())&&(o=F.FileAccess.asBrowserUri(O.URI.parse(o.toString())).toString(!0));const P=`(${function(h){function d(E){return typeof E=="string"||E instanceof URL?String(E).replace(/^file:\/\//i,"vscode-file://vscode-app"):E}const g=fetch.bind(self);self.fetch=function(E,C){return E instanceof Request?g(E,C):g(d(E),C)},self.XMLHttpRequest=class extends XMLHttpRequest{open(E,C,I,N,p){return super.open(E,d(C),I??!0,N,p)}};const f=importScripts.bind(self);self.importScripts=(...E)=>{f(...E.map(d))},f(h)}.toString()}('${o}'))`;S=S||{},S.name=S.name||T.basename(o.toString());const r=new Blob([P],{type:"application/javascript"}),c=URL.createObjectURL(r);return new b(c,S)}}else self.Worker=class extends M.NestedWorker{constructor(b,o){super(t,b,{name:T.basename(b.toString()),...o})}};const s=new class{constructor(){this.pid=void 0}exit(b){m()}async exists(b){return!0}async realpath(b){return b}};class a{constructor(){const o=new MessageChannel,S=new A.Emitter;let n=!1;t(o.port2,[o.port2]),o.port1.onmessage=P=>{const{data:r}=P;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const c=i.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,_.isMessageOfType)(c,2)){n=!0,k("received terminate message from renderer");return}S.fire(c)},this.protocol={onMessage:S.event,send:P=>{if(!n){const r=P.buffer.buffer.slice(P.buffer.byteOffset,P.buffer.byteOffset+P.buffer.byteLength);o.port1.postMessage(r,[r])}}}}}function l(b){return new Promise(o=>{const S=b.onMessage(n=>{S.dispose();const P=JSON.parse(n.toString());b.send((0,_.createMessageOfType)(0)),o({protocol:b,initData:P})});b.send((0,_.createMessageOfType)(1))})}let k=b=>m();function v(){y.mark("code/extHost/willConnectToRenderer");const b=new a;return{onmessage(o){l(b.protocol).then(S=>{y.mark("code/extHost/didWaitForInitData");const n=new D.ExtensionHostMain(S.protocol,S.initData,s,null,o);k=P=>n.terminate(P)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36c1f3bd16fce1c215b23e577a080f7f63755fcc/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
